#!/bin/ksh
#
#
cat <<EOF > header_file.txt
1.00 1.00 15 0 4 BL text
EOF
#
avhrr_l1b_calib_plot()
{
gmtset HEADER_FONT_SIZE 20
gmtset LABEL_FONT_SIZE 20
#gmtset PAPER_MEDIA AAPP_WEB
gmtset PAPER_MEDIA A4
gmtset X_ORIGIN 1.3c
gmtset Y_ORIGIN 5.0c
gmtset DEGREE_FORMAT 1
gmtset PAGE_COLOR 230/230/180
#
PROJECTION='JM'
pstext header_file.txt -R$1/$2/$3/$4  -${PROJECTION}12c -P -K  >$7
makecpt -Crainbow -T$5/$6/1. -Z >avhrr1c.cpt
pscoast -R -${PROJECTION} -P -B10g10:."${title}": -G180/120/60 -S0/0/100 -K -O -U >>$7
psxy -R -${PROJECTION} -P -K -O satellite_data.txt -Cavhrr1c.cpt -Sc0.025  >>$7
psscale -Cavhrr1c.cpt -D13.5c/5c/10c/0.5c -O -V -B10.:"${scale}":/:K: >>$7
}

rm satellite_data.txt avhrr_l1b_calib_plot.ps

# input1:  AAPP AVHRR l1b file full pathname
# input2:  AVHRR channel number
# input3:  subsampling factor
# input4:  number of first navigation block to be plotted
# input5:  number of last navigation block to be plotted

export title="Metop-A  28/01/2010  10\07242"
export scale="AVHRR CH5"

cat << EOF | avhrr_l1b_calib_plot.exe
hrpt_M02_20100128_1042_17002.l1b
5
5
1
500
EOF

if [ -s satellite_data.txt ]; then
#   minmax -C -I1 satellite_data.txt | read W E S N MIN MAX
   minmax -C -I1 satellite_data.txt >tmp.txt
   read W E S N MIN MAX <tmp.txt
   print 'MIN' $MIN 'MAX' $MAX   
   avhrr_l1b_calib_plot $W $E $S $N $MIN $MAX avhrr_l1b_calib_plot.ps
else
   print '!!! satellite_data.txt is empty !!!'
fi
\rm -f .gmtcommands
