!$Id: l1d_plot.f,v 1.2 2005/04/15 13:39:47 frna Exp $

      program l1d_plot

! Purpose: read AAPP TOVS/ATOVS level 1d file to display the results with GMT
!          Data are written into formatted file, which will be read by the GMT 
!           script

!-------------------------------------------------------------------------------------
! Author: K. Dieter Klaes January 2000
! updated: Rainer Schraidt July 2001      
! updated: N Atkinson Nov 2004, modify includes assuming in-situ compilation
! updated: N Atkinson Nov 2006, use #include (required for AAPP v6)
! updated: N Atkinson Jul 2014, use wmosatid to check for TOVS/ATOVS
!
!-------------------------------------------------------------------------------------

C******************************************************************************
C*****Parameters you may want to modify****************************************

! Includes

#include "ppparms.h"
#include "hrs1d.h"
#include "reclopt.h"
	
c******************************************************************************	
c******************************************************************************


! Declarations

      character*80 L1d_file

      character*2 instrument
      integer*4 channel_number,n_scnlin
      integer*4 s_hour,s_min,s_sec,e_hour,e_min,e_sec
      
      

! Code starts here

      print*,'Enter (A)TOVS Level 1d filename....:'
      read(*,111) L1d_file
 111  format(a80)
      write(*,111) L1d_file
      print*,'Enter instrument to be considered:'
      print*,'HIRS on original grid....= HO'
      print*,'MSU on HIRS grid..   ....= MH'
      print*,'AMSU-A on HIRS grid......= AH'
      print*,'AMSU-B on HIRS grid......= BH'
      print*,'AVHRR on HIRS grid.......= AV'
      print*,'auxiliary data...........= ax'
      read(*,112) instrument
 112  format(a2) 
      write(*,112) instrument
      print*,'Enter channel/parameter number:'
      read*,channel_number
      print*,channel_number
      if(instrument.eq.'HO'.and.
     & (channel_number.lt.0.or.channel_number.gt.20)) goto 888
      if(instrument.eq.'MH'.and.
     & (channel_number.lt.0.or.channel_number.gt. 4)) goto 888
      if(instrument.eq.'AH'.and.
     & (channel_number.lt.0.or.channel_number.gt.15)) goto 888
      if(instrument.eq.'BH'.and.
     & (channel_number.lt.0.or.channel_number.gt. 5)) goto 888
      if(instrument.eq.'AV'.and.
     & (channel_number.lt.0.or.channel_number.gt. 5)) goto 888
      if(instrument.eq.'ax'.and.
     & (channel_number.lt.0.or.channel_number.gt. 2)) goto 888
      
! Read Header Information

      open(unit=10,
     1     file=L1d_file,
     2     form='unformatted',
     3     access='direct',
     4     recl=hrs_1drecl/rldiv,
     5     status='old')
      read(10,rec=1,err=999) hrs1d_hd
      close(unit=10)

	s_hour=hrs1d_h_startdatatime/1.e3/60./60.
	s_min=(hrs1d_h_startdatatime/1.e3-s_hour*60*60)/60
	s_sec=(hrs1d_h_startdatatime/1.e3-s_hour*60*60-s_min*60)

	e_hour=hrs1d_h_enddatatime/1.e3/60./60.
	e_min=(hrs1d_h_enddatatime/1.e3-e_hour*60*60)/60
	e_sec=(hrs1d_h_enddatatime/1.e3-e_hour*60*60-e_min*60)

        print*,'NOAA',hrs1d_h_satid,' ',
     $   hrs1d_h_startdatayr,hrs1d_h_startdatady,
     $   s_hour,s_min,s_sec,e_hour,e_min,e_sec 

! Plot satellite data: TOVS or ATOVS

      n_scnlin=hrs1d_h_scnlin
!      if(hrs1d_h_satid .lt. 15) then
      if(hrs1d_h_wmosatid .le. 205 .and. hrs1d_h_wmosatid .gt. 5) then
        call l1d_plot_tovs(L1d_file,instrument,channel_number,n_scnlin)
      else
        call l1d_plot_atovs(L1d_file,instrument,channel_number,n_scnlin)
      endif
      
      stop
      
            
 888  print*,channel_number,
     & ' is invalid channel_number for plot request ',instrument
      stop
      !!!!
      
 999  print*,'An error occurred during reading the header !'
      close(unit=10)
      stop
      end
