#!/bin/ksh
#
#
cat <<EOF > header_file.txt
1.00 1.00 15 0 4 BL text
EOF
#
l1d_plot()
{
gmtset HEADER_FONT_SIZE 20
gmtset LABEL_FONT_SIZE 20
#gmtset PAPER_MEDIA AAPP_WEB
gmtset PAPER_MEDIA A4
gmtset X_ORIGIN 1.3c
gmtset Y_ORIGIN 5.0c
gmtset DEGREE_FORMAT 1
gmtset PAGE_COLOR 230/230/180
#
PROJECTION='JM'
pstext header_file.txt -R$1/$2/$3/$4  -${PROJECTION}12c -P -K  >$7
makecpt -Crainbow -T$5/$6/1. -Z >atovs1d.cpt
pscoast -R -${PROJECTION} -Dl -P -B10g10:."${title}": -G180/120/60 -S0/0/100 -K -O >>$7
psxy -R -${PROJECTION} -O -P -K satellite_data.txt -Catovs1d.cpt -Sc0.13  >>$7
psscale -Catovs1d.cpt -D13.5c/5c/10c/0.5c -O -V -B10:"$scale":/:K: >>$7
}

rm -f satellite_data.txt l1d_plot.ps

# prepare the data from the (A)TOVS HIRS-Level1d file
# input1:  AAPP l1d file full pathname
# input2:  data type (instrument or auxiliary)
#          see l1d_plot.f for details
# input3:  data subtype (channel number or subtype)
#

export title="Metop-A  28/01/2010  10\07242"
export scale="AMSU 1 on HIRS"

cat <<EOF | l1d_plot.exe
hirsl1d_M02_20100128_1042_17002.l1d
AH
1
EOF

if [ -s satellite_data.txt ]; then
#   minmax -C -I1 satellite_data.txt | read W E S N MIN MAX
   minmax -C -I1 satellite_data.txt >tmp.txt
   read W E S N MIN MAX <tmp.txt    #read doesn't work with "|" on some systems
   print 'MIN' $MIN 'MAX' $MAX
   l1d_plot $W $E $S $N $MIN $MAX l1d_plot.ps
else
   print '!!! satellite_data.txt is empty !!!'
fi
\rm -f .gmtcommands
