/* this code has been extracted from OPS-LRS V7 and adapted for stand alone execution*/
#ifndef NUEES_H
#define NUEES_H
#define FALSE 0
#define TRUE 1

static const int CMN__NON = 0;
static const int CMN__OUI = 1;

// typedef de retour d'etat
typedef int t_CMN__Statut;
// define des etats generaux

static const int CMN__STATUT_OK = 0;
static const int CMN__STATUT_NOK = -1;
typedef union { struct { double _re, _im; } _data; double _align; } dcmplx;
//--------------------------------------------------------------------*/
//* Macros permettant d'acceder aux elements d'un tableau en utilisant */
//* un mode de rangement de type fortran ( indices commencant a 1 et
//* variants de la gauche vers le droite */
//--------------------------------------------------------------------*/
#define IND1(i) (i-1)
#define IND2(i,j,dimi) ((j-1)*(dimi)+(i-1))
#define IND3(i,j,k,dimi,dimj) ((k-1)*(dimi)*(dimj)+(j-1)*(dimi)+(i-1))
#define IND4(i,j,k,l,dimi,dimj,dimk) ((l-1)*(dimi)*(dimj)*(dimk)+(k-1)*(dimi)*(dimj)+(j-1)*(dimi)+(i-1))
#define IND5(i,j,k,l,m,dimi,dimj,dimk,diml) ((m-1)*(dimi)*(dimj)*(dimk)*(diml)+(l-1)*(dimi)*(dimj)*(dimk)+(k-1)*(dimi)*(dimj)+(j-1)*(dimi) + (i-1))
#define IND6(i,j,k,l,m,n,dimi,dimj,dimk,diml,dimm) ((n-1)*(dimi)*(dimj)*(dimk)*(diml)*(dimm)+(m-1)*(dimi)*(dimj)*(dimk)*(diml)+(l-1)*(dimi)*(dimj)*(dimk)+(k-1)*(dimi)*(dimj) + (j-1)*(dimi) + (i-1))

//--------------------------------------------------------------------*/
/* Macro permettant l'appel a malloc avec gestion d'erreur */
/* La macro a ete modifiee afin d'initialiser avec des octets = 0 la zone allouee */
//--------------------------------------------------------------------*/

#define SD_BAS_MacMALLOC(p,T,n)   ( (p = (T*)calloc((size_t)n,(size_t)(sizeof(T))))? \
                 TRUE : FALSE)
#define SD_BAS_MacFREE(p) { if (p) {free((void *)(p)); p = NULL;} }

#define RE( x ) ( x )._data._re

#define MAX(a,b) ((a>b)?(a):(b))
#define MIN(a,b) ((a<b)?(a):(b))
#define SD_BAS_TEST_ERR_INT(errinterne, set, num, fct, lig, msg)\
{\
  if (errinterne.nb < SD_BAS_NB_MAX_MSG) \
    { \
      CreerMessage (SD_SET, 1, &(ctx->cr.msgJDB));\
      StockerParametreMessage ("$LIBELLE", msg, &(ctx->cr.msgJDB));\
      strncpy(errinterne.nomfonction[errinterne.nb], fct,SD_BAS_LGNOMPROCEDURE);\
      errinterne.nomfonction[errinterne.nb][SD_BAS_LGNOMPROCEDURE - 1] = '\0';\
      errinterne.numligne[errinterne.nb] = lig;\
      strncpy(errinterne.libelle[errinterne.nb], msg,SD_BAS_LGLIBERR);\
      errinterne.libelle[errinterne.nb][SD_BAS_LGLIBERR -1 ] = '\0';\
      errinterne.nb++;\
      fprintf(stderr,\
              "**fonction %s ligne %d \n \tAnomalie : %s\n", \
              fct, lig, msg);\
    } \
}
#define SD_SET 1 // type enumere
// metop AVHRR/IASI
#define SD_BAS_NPI_IMAGER 2048 // number of pixel in one band AVHRR
#define SD_BAS_NLI_MAX_UTIL_IMAGER 160 // number of lines in one strip AVHRR for one line IASI
#define SD_BAS_NBK 16// number max of channel (16 VIIRS channels)
#define SD_BAS_NCL_MAX 20         // number of class for FOV MAX sounder Analysis
#define SD_BAS_NCL 7              // number of class for FOV sounder Analysis

// algo 
#define SD_ALG_MAX_ITER 9



// for error messages
static char *SD_BAS_MSG_ALLOC   = (char *)"ALLOCATION ERROR";
static char *SD_ALG_MSG_ERR_NUL_DISTANCE="Nul prototype distance";
static char *SD_BAS_MSG_ERR_NUL_EIG_VAL="Nul Eigen value";
static char *SD_BAS_MSG_ERR_EIG_VAL_PROCESSING="Eigen value processing";
static char *ERREUR_CONVERGENCE = "Erreur de convergence";

#define SD_BAS_NB_MAX_MSG     20      /* Nbre max de messages stockes dans une liste de msg JDB*/
#define SD_BAS_LGLIBERR 255     /* longueur des libelles erreur */
#define SD_BAS_LGNOMPROCEDURE 60      /* longueur max des noms de fonctions */
#define ERR_BASE_AVHRR                          1340 /*SD_ALG_ERR_BASE_AVHRR */
#define SD_ALG_AVHRR_ERR_ALLOCATION             (ERR_BASE_AVHRR+1)
#define SD_ALG_AVHRR_ERR_NUL_DISTANCE           (ERR_BASE_AVHRR+7)
#define SD_ALG_AVHRR_ERR_NUL_EIG_VAL            (ERR_BASE_AVHRR+9)
#define SD_BAS_ERR_SET_AVHRR                   1
#define SD_ALG_AVHRR_ERR_EIG_VAL_PROCESSING     (ERR_BASE_AVHRR+11)
static const int SD_BAS_ERR_BASE_ESSL            = 1240;
#define SD_BAS_ERR_SET_ESSL                 1
#define ERR_BASE_ESSL 1240
#define SD_BAS_LibESSL_ERR_ALLOCATION       (ERR_BASE_ESSL+5)
#define SD_BAS_LibESSL_ERR_CONVERG          (ERR_BASE_ESSL+2)

typedef char  t_SD_BAS_MetopMSG[256];

//--------------------------------------------------------------------*/
// type definissant les informations utiles pour les messages  d'erreur
// algo a utiliser dans les modules de haut niveau
//--------------------------------------------------------------------*/
typedef struct
{
  int nb; /* nombre d'elements ecrits dans numligne et nomfonction */
  char libelle[SD_BAS_NB_MAX_MSG][SD_BAS_LGLIBERR]; /* libelle de l'erreur de bas niveau */
  int numligne[SD_BAS_NB_MAX_MSG]; /* numero de la ligne du fichier ou l'erreur est emise */
  char nomfonction[SD_BAS_NB_MAX_MSG][SD_BAS_LGNOMPROCEDURE]; /* nom de la fonction ou l'erreur est emise */
} t_SD_BAS_ERREUR;
#define JDB_NB_MAX_PARAM                20

// Type definissant un parametre d'un message JDB. Chaque parametre
// comporte un nom et une valeur
typedef struct {
    char * nom;          // Nom d'un parametre 
    char * valeur;       // Valeur d'un parametre 
} t_JDB_Param;
    
// Type definissant une liste de parametres d'un message JDB
typedef struct {
    int       nb;
    t_JDB_Param         tab[JDB_NB_MAX_PARAM];
} t_JDB_ListeParam;
    
// Type definissant un pointeur sur une liste de parametres d'un
// message JDB
typedef t_JDB_ListeParam *t_JDB_pt_ListeParam;
//--------------------------------------------------------------------*/
// Type definissant un message JDB par son set, son numero dans le set
// et la liste de ses parametres
//--------------------------------------------------------------------*/
typedef struct {
    int               set;
    int               num;
    t_JDB_ListeParam  param;
} t_SD_BAS_ParamMessage;

//--------------------------------------------------------------------*/
// Type definissant la liste des messages JDB
//--------------------------------------------------------------------*/
typedef struct {
    int      	                nb;
    t_SD_BAS_ParamMessage 	msg [SD_BAS_NB_MAX_MSG];
} t_SD_BAS_ListeMessage;

//--------------------------------------------------------------------*/
// type definissant un compte rendu
//--------------------------------------------------------------------*/
typedef struct
    {
    t_SD_BAS_ERREUR       errinterne;    // numero de l'erreur interne a emettre
    t_SD_BAS_ListeMessage msgJDB;        // Liste des messages a emettre
    } t_SD_BAS_CompteRendu;
//--------------------------------------------------------------------*/
// type definissant les informations sur la donnee traitee
//--------------------------------------------------------------------*/
typedef struct
    {
    int LN; // numero de la ligne ( depuis le debut du granule )
    int SN; // numero du step number ( 0 si non utilise )
    int PN; // numero du pixel ( 0 si non utilise )
    int CCD;// numero diraction du coin de cube ( 0 si non utilise )
    int SB; // numero de la bande ( 0 si non utilise )
    int Thread; // numero du thread dans lequel le calcul est effectue
    } t_SD_BAS_ORIGINE;

/*****************************************************************************/
/* Structure t_SD_BAS_DataThreadProduit :                                    */
/*                                                                           */
/*****************************************************************************/

typedef struct
{ 
	
  // 41_CCS ; SD_ALG_InitRad
  int           *IdPix;                 // int( SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER)

  // SD_ALG_NueesDynamiques
  float         *RadNW;                 // float( (SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER) * SD_BAS_NBK)

  // SD_ALG_NueesDynamiques ; SD_ALG_IterNuDyn ; SD_ALG_GestionProto
  double        *Dist;                  // double( SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER * SD_BAS_NCL)
 
  // SD_ALG_InitRad
  float         *RadN;                  // float( (SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER) * SD_BAS_NBK)

  // SD_ALG_InitProto
  unsigned int  *UsedPixTest;           // unsigned int(SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER)
  double        *DistZero;              // double( SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER)
  double        *Dist1;                 // double( SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER)

  // SD_ALG_GestionProto ; SD_ALG_GestionProtoPost
  int           *IdPixAglo;             // int( SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER)

  // SD_ALG_StatClas
  float         *ImgIJ;                 // float( SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER)

} t_SD_BAS_DataThreadProduit;


typedef struct
    {
    t_SD_BAS_ORIGINE ctxtrt; // contexte du traitement ( SN,PN ...);
    t_SD_BAS_CompteRendu cr;
    t_SD_BAS_MetopMSG  * ptmsg;
    } t_SD_BAS_DataThread;

/*********************************************************************/
/*  functions declaration                                            */
/*********************************************************************/

static t_CMN__Statut SD_ALG_EigenAnalysis(
  // Entrees
  t_SD_BAS_DataThread *Contexte_courant,   // t_SD_BAS_DataThread*
  int                  Taille,             // int(1) Nombre de points
  double              *Covar,              // double( Taille * Taille),
  unsigned int         Transpose,          // unsigned int(1)
  // Sorties
/* bma complexes->reels */
  double              *EigVal,             // double( Taille)
  double              *EigVect             // double( Taille * Taille)
/* fin bma */
);
// ===============================================================================

static t_CMN__Statut SD_ALG_InitProto(
  // Entrees
  t_SD_BAS_DataThread* Contexte_courant,      // t_SD_BAS_DataThread*
  t_SD_BAS_DataThreadProduit  *ProduitCourant,     // t_SD_BAS_DataThreadProduit*
  float                *RadN,               // float( (SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER) * SD_BAS_NBK)
  int                   Nch,                // int(1)
  int                   NbPixAv,            // int(1)
  double               *ProtoZero,          // double( SD_BAS_NBK)
  int                   NbClusMax,          // int(1)
  double                DistMax,            // double(1)
  int                   SortingChannel,     // int(1)
  // Sorties
  int                  *NbPro,              // int(1)
  double               *Proto,              // double( SD_BAS_NBK * SD_BAS_NCL_MAX)
  double               *Covar,              // double( SD_BAS_NBK * SD_BAS_NBK * SD_BAS_NCL_MAX)
  double               *Dist,               // double( (SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER) * SD_BAS_NCL_MAX)
  int                  *IdPix,              // int( SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER)
  int                  *NbPixClas,          // int( SD_BAS_NCL_MAX)
  double               *SumDistClas         // double( SD_BAS_NCL_MAX)
);

static t_CMN__Statut SD_ALG_InitRad(
  // Entrees
  t_SD_BAS_DataThreadProduit  *ProduitCourant,     // t_SD_BAS_DataThreadProduit*
  t_SD_BAS_DataThread  *Contexte_courant,   // t_SD_BAS_DataThread*
  float                *RadAv,              // float( (SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER) * SD_BAS_NBK)
  int                   NbPixAv,            // int(1)
  int                   Nch,                // int(1)
  double               *ChannelNoise,       // int( SD_BAS_NBK)
  int                  *ChannelWgt,         // int( SD_BAS_NBK)
  // Sorties
  double                *RadMean,            // float( SD_BAS_NBK)
  double                *RadStd,             // float( SD_BAS_NBK)
  float                *RadNW,              // float( (SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER) * SD_BAS_NBK)
  double               *ProtoZero,          // double( SD_BAS_NBK)
/* bma complexes->reels */
  double               *EigVal,             // double( SD_BAS_NBK)
  double               *EigVect             // double( SD_BAS_NBK * SD_BAS_NBK)
/* fin bma */
);

t_CMN__Statut SD_ALG_NueesDynamiques(
  // Entrees
  t_SD_BAS_DataThreadProduit  *ProduitCourant,     // t_SD_BAS_DataThreadProduit*
  t_SD_BAS_DataThread  *Contexte_courant,   // t_SD_BAS_DataThread*
  float        *RadAv,               // float( (SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER) * SD_BAS_NBK)
                                     // Considere comme NBK vecteurs de NPI_AVHRR * NLI_MAX_UTIL_AVHRR valeurs
  int           NbPixAv,             // int(1)
  int           Nch,                 // int(1)
  int           SortingChannel,      // int(1)
  double       *ChannelNoise,        // double( SD_BAS_NBK)
  int          *ChannelWgt,          // int( SD_BAS_NBK)
  int           NbClusMax,           // int(1)
  int           NbIterMax,           // int(1)
  double        IterConvCutoff,      // double(1)
  double        SplitCutoff,         // double(1)
  double        GlueCutoff,          // double(1)
  double        EigValCutoff,        // double(1)
  double        DistAgloInit,        // double(1)
  int           MinIterNCCutOff,     // int(1)
  int           NbNonClassifMax,     // int(1)
  double        DistMax,             // double(1)
  // Sorties
  int          *IdPix,               // int( SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER)
  unsigned int *NoExt,               // unsigned int( SD_BAS_NCL_MAX)
  int          *NbClass,             // int(1)
  unsigned int *FlagPostProcessing,  // unsigned int(1)
  double       *NonClassifRate,      // double(1)
  double       *VarianceRate         // double(1)
);

static t_CMN__Statut SD_ALG_IterNuDyn(
  // Entree
   t_SD_BAS_DataThread*           Contexte_courant,      // t_SD_BAS_DataThread*
  t_SD_BAS_DataThreadProduit  *ProduitCourant,     // t_SD_BAS_DataThreadProduit*
  float                *RadN,                  // float( (SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER) * SD_BAS_NBK)
  int                   NbPixAv,               // int(1)
  int                   Nch,                   // int(1)
  int                   NbPro,                 // int(1)
  int                   NbClusMax,             // int(1)
  int                   NbIterMax,             // int(1)
  double               *EigVal,                // double( SD_BAS_NBK)
  double               *EigVect,               // double( SD_BAS_NBK * SD_BAS_NBK)
  double                DistAgloInit,          // double(1)
  double                SplitCutoff,           // double(1)
  double                GlueCutoff,            // double(1)
  double                EigValCutoff,          // double(1)
  int                   MinIterNCCutoff,       // int(1)
  int                   NbNonClassifMax,       // int(1)
  int                   SortingChannel,        // int(1)
  double                DistMax,               // double(1)
  double                IterConvCutoff,        // double(1)
  // Entrees/Sortie
  double               *Proto,                 // double( SD_BAS_NBK * SD_BAS_NCL_MAX)
  int                  *IdPix,                 // int( SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER)
  int                  *NbPixClas,             // int( SD_BAS_NCL_MAX)
  double               *SumDistClas,           // double( SD_BAS_NCL_MAX)
  // Sortie
  int                  *NbClass,               // int(1)
  unsigned int         *NoExt,                 // unsigned int( SD_BAS_NCL_MAX)
  int                  *Iter                   // int(1)
);

static t_CMN__Statut SD_ALG_IterNuDynPost(
  // Entree
  t_SD_BAS_DataThreadProduit  *ProduitCourant,  // t_SD_BAS_DataThreadProduit*
  int                          IterLast,        // int(1)
  int                          NbPixAv,         // int(1)
  int                          Nch,             // int(1)
  int                          NbClusMax,       // int(1)
/* bma complexes->reels */
  double                      *EigVal,          // double( SD_BAS_NBK)
  double                      *EigVect,         // double( SD_BAS_NBK * SD_BAS_NBK)
/* fin bma */
  double                       DistAgloInit,    // double(1)
  double                       EigValCutoff,    // double(1)
  int                          SortingChannel,  // int(1)
  // Entrees / Sortie
  double                      *Proto,           // double( SD_BAS_NBK * SD_BAS_NCL_MAX)
  int                         *IdPix,           // int( SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER)
  int                         *NbPixClas,       // int( SD_BAS_NCL_MAX)
  double                      *SumDistClas,     // double( SD_BAS_NCL_MAX)
  unsigned int                *NoExt,           // unsigned int( SD_BAS_NCL_MAX)
  // Sortie
  int                         *NbClass,         // int(1)
  int                         *Iter             // int(1)
);

static t_CMN__Statut SD_ALG_TestQual(
  // Entrees
  int     NbPixAv,          // int(1)
  int     Nch,              // int(1)
  int     NbClass,          // int(1)
/* bma complexes->reels */
  double *EigVal,           // double( SD_BAS_NBK)
/* fin bma */
  double  EigValCutoff,     // double(1)
  int    *NbPixClas,        // int( SD_BAS_NCL_MAX)
  double *SumDistClas,      // double( SD_BAS_NCL_MAX)
  // Sorties
  double *NonClassifRate,   // double(1)
  double *NormVarRate       // double(1)
);

static t_CMN__Statut SD_ALG_StatClas(
  // Entrees
  t_SD_BAS_DataThreadProduit  *ProduitCourant,     // t_SD_BAS_DataThreadProduit*
  float                *ImgAv,              // float( (SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER) * SD_BAS_NBK)
  int                  *IdPix,              // int( SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER)
  int                   NbChannel,          // int(1)
  int                   NbPixAv,            // int(1)
  int                   IdPro,              // int(1)
  // Sorties
  double               *Proto,              // double( SD_BAS_NBK)
  double               *Covar               // double( SD_BAS_NBK * SD_BAS_NBK)
);

static t_CMN__Statut SD_ALG_LinkPixProto(
  // Entrees
  double *Dist,         // double( (SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER) * SD_BAS_NCL_MAX)
  double  DistMax,      // double(1)
  int     NbPixAv,      // int(1)
  int     NbPro,        // int(1)
  // Sorties
  int    *IdPix,        // int( SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER)
  int    *NbPixClas,    // int( SD_BAS_NCL_MAX)
  double *SumDistClas,  // double( SD_BAS_NCL_MAX)
  double *SumDistTot    // double(1)
);

static t_CMN__Statut SD_ALG_SortClas(
  // Entrees
  int     SortingChannel,  // int(1)
  int     NbChannel,       // int(1)
  int     NbPixAv,         // int(1)
  int     NbPro,           // int(1)
  // Entrees / Sorties
  double *Proto,           // double( SD_BAS_NBK * SD_BAS_NCL_MAX)
  int    *IdPix,           // int( SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER)
  int    *NbPixClas,       // int( SD_BAS_NCL_MAX)
  double *SumDistClas      // double( SD_BAS_NCL_MAX)
);


static double SD_ALG_Moyenne(
  // Entrees
  float   *ImgAv,     // float( NbPixAv)
  int      NbPixAv,   // int(1)
  int     *IdPix,     // int( NbPixAv)
  int      IdPro      // int(1)
);

static t_CMN__Statut SD_ALG_Tri_ascendant(
  // Entrees
  t_SD_BAS_DataThread* ctx,      // t_SD_BAS_DataThread*
  double   *Vecteur,        // double( NbElem)
  int       NbElem,         // int(1)
  // Sorties
  int      *IndicesClasses  // int( NbElem)
);

static int SD_ALG_sort_paire_i_val( const void *a, const void *b);

static int SD_ALG_sort_eigen_val( const void *a, const void *b);

static t_CMN__Statut SD_ALG_GestionProto(
  // Entrees
  t_SD_BAS_DataThread* Contexte_courant,      // t_SD_BAS_DataThread*
  t_SD_BAS_DataThreadProduit  *ProduitCourant,     // t_SD_BAS_DataThreadProduit*
  float                       *RadN,               // float( (SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER) * SD_BAS_NBK)
  int                          NbPixAv,            // int(1)
  int                          Nch,                // int(1)
  unsigned int                 Aglo,               // unsigned int(1)
  unsigned int                 Separ,              // unsigned int(1)
/* bma complexes->reels */
  double                      *EigVal,             // double( SD_BAS_NBK)
  double                      *EigVect,            // double( SD_BAS_NBK * SD_BAS_NBK)
/* fin bma */
  double                       SplitCutoff,        // double(1)
  double                       DistAgloInit,       // double(1)
  double                       GlueCutoff,         // double(1)
  double                       EigValCutoff,       // double(1)
  // Entrees / Sortie
  double                      *Proto,              // double( SD_BAS_NBK * SD_BAS_NCL_MAX)
  int                         *NbPro,              // int(1)
  int                         *IdPix,              // int( SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER)
  int                         *NbPixClas,          // int( SD_BAS_NCL_MAX)
  double                      *SumDistClas,        // double( SD_BAS_NCL_MAX)
  // Sorties
  unsigned int                *NoExt               // unsigned int( SD_BAS_NCL_MAX)
);
static t_CMN__Statut SD_ALG_GestionProtoPost(
  // Entrees
  t_SD_BAS_DataThreadProduit  *ProduitCourant,     // t_SD_BAS_DataThreadProduit*
  int                          Nch,                // int(1)
/* bma ajout du nombre de pixels AVHRR dans la signature de la fonction GestionProtoPost*/
  int                          NbPixAv,            // int(1)
/* fin bma */
/* bma complexes->reels */
  double                      *EigVal,             // double( SD_BAS_NBK)
  double                      *EigVect,            // double( SD_BAS_NBK * SD_BAS_NBK)
/* fin bma */
  double                       DistAgloInit,       // double(1)
  double                       EigValCutoff,       // double(1)
  // Entrees / Sortie
  double                      *Proto,              // double( SD_BAS_NBK * SD_BAS_NCL_MAX)
  int                         *NbPro,              // int(1)
  int                         *IdPix,              // int( SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER)
  int                         *NbPixClas,          // int( SD_BAS_NCL_MAX)
  double                      *SumDistClas,        // double( SD_BAS_NCL_MAX)
  unsigned int                *NoExt               // unsigned int( SD_BAS_NCL_MAX)
);


static t_CMN__Statut SD_ALG_DistPixProto(
  // Entrees
  float  *ImgAv,      // float( (SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER) * SD_BAS_NBK)
  int     NbChannel,  // int(1)
  int     NbPixAv,    // int(1)
  double *Proto,      // double( SD_BAS_NBK)
  // Sorties
  double *Dist        // double( (SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER) * SD_BAS_NCL_MAX)
);


t_CMN__Statut SD_ALG_DistPixProtoClas(
  // Entrees
  float  *ImgAv,      // float( (SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER) * SD_BAS_NBK)
  int     NbChannel,  // int(1)
  int     NbPixAv,    // int(1)
  int    *IdPix,      // int( SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER)
  int     IdPro,      // int(1)
  double *Proto,      // double( SD_BAS_NBK)
  // Sorties
  double *DistClas    // double( (SD_BAS_NPI_IMAGER * SD_BAS_NLI_MAX_UTIL_IMAGER) * SD_BAS_NCL_MAX)
);


static t_CMN__Statut SD_ALG_MinDistAgloLoc(
  // Entrees
  double *DistAglo,    // double( SD_BAS_NCL_MAX * SD_BAS_NCL_MAX)
  int     NbPro,       // int(1)
  // Sorties
  double *DistMin,     // double(1)
  int    *Ind1,        // int(1)
  int    *Ind2         // int(1)
);

//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_ValVectPropre
//@
//@ Description : calcul des valeurs propres et des vecteurs propres
//@ d'une matrice carree
//@
//@
//@ Parameters :
//@         (ENTREE)  nbpts : nombre de pts
//@         (ENTREE)  a : matrice
//@         (SORTIE)  auxv : tableau temporaire
//@         (SORTIE) valpropre : valeurs propres
//@         (SORTIE) vecpropre : vecteurs propres
//@
//@ Return Status :
//@         t_CMN__Statut
//@         CMN__STATUT_OK si la fonction a reussi
//@         CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_ValVectPropre(
        t_SD_BAS_DataThread * ctx,
        int   nbpts,
        double * a,
        double * auxv,
        dcmplx * valpropre,
        dcmplx * vecpropre
        );
#endif
