#ifndef AAPP_HDF5_H
#define AAPP_HDF5_H

/* declare interface to functions defined in libaapphdf5 */

extern int ama1c_read(char *filename);
extern int ama1c_to_hdf5_write(char *filename, int clevel);
extern int ama1d_read(char *filename);
extern int ama1d_to_hdf5_write(char *filename, int clevel);
extern int ama1c_from_hdf5_read(char *filename); 
extern int ama1c_write(char *filename);

extern int amb1c_read(char *filename);
extern int amb1c_to_hdf5_write(char *filename, int clevel);
extern int amb1d_read(char *filename);
extern int amb1d_to_hdf5_write(char *filename, int clevel);
extern int amb1c_from_hdf5_read(char *filename); 
extern int amb1c_write(char *filename);

extern int atms1c_read(char *filename);
extern int atms1c_to_hdf5_write(char *filename, int clevel);
extern int atms_sdr_read(char *filename, char geo_char);
extern int atms_geo_read(char *filename);
extern int atms_tdr_read(char *filename);
extern int atms_sdr_intf(void);

extern int avh1b_to_hdf5_intf(int argc, char* argv[]);
extern int avh1c_read(char *filename);
extern int avh1c_to_hdf5_write(char *filename, int clevel, int fullresgeo, double lat0, double lon0, int nx, int ny);

extern int cris1c_read(char *filename);
extern int cris1c_to_hdf5_write(char *filename, int clevel);
extern int cris_sdr_read(char *filename, char geo_char);
extern int cris_geo_read(char *filename);
extern int cris_sdr_intf(void);

extern int hiras_sdr_read(char *filename);
extern int hiras_sdr_intf(void);

extern int hrp1b_read(char *filename);
extern int hrp1b_to_hdf5_write(char *filename, int clevel, int fullresgeo);

extern int hrs1c_read(char *filename);
extern int hrs1c_to_hdf5_write(char *filename, int clevel);
extern int hrs1d_read(char *filename);
extern int hrs1d_to_hdf5_write(char *filename, int clevel);
extern int hrs1c_from_hdf5_read(char *filename); 
extern int hrs1c_write(char *filename);

extern int iasi1c_read(char *filename);
extern int iasi1c_to_hdf5_write(char *filename, int clevel);
extern int iasi1d_read(char *filename);
extern int iasi1d_to_hdf5_write(char *filename, int clevel);
extern int iasi1c_from_hdf5_read(char *filename); 
extern int iasi1c_write(char *filename);

extern int iasipc_read(char *filename);
extern int iasipc_to_hdf5_write(char *filename, int clevel);
extern int iasipc_from_hdf5_read(char *filename); 
extern int iasipc_write(char *filename);

extern int iras1c_read(char *filename);
extern int iras1c_to_hdf5_write(char *filename, int clevel);
extern int iras_sdr_read(char *filename);
extern int iras_sdr_intf(void);
extern int iras1c_from_hdf5_read(char *filename); 
extern int iras1c_write(char *filename);

extern int mwhs_sdr_read(char *filename);
extern int mwhs_sdr_intf(void);
extern int mwhs21c_read(char *filename);
extern int mwhs21c_to_hdf5_write(char *filename, int clevel);
extern int mwhs2_sdr_read(char *filename);
extern int mwhs2_sdr_intf(void);
extern int mwhs21c_from_hdf5_read(char *filename); 
extern int mwhs21c_write(char *filename);

extern int mwri1c_read(char *filename);
extern int mwri1c_to_hdf5_write(char *filename, int clevel);
extern int mwri_sdr_read(char *filename);
extern int mwri_sdr_intf(void);
extern int mwri2_sdr_read(char *filename);
extern int mwri2_sdr_intf(void);

extern int mwts_sdr_read(char *filename);
extern int mwts_sdr_intf(void);
extern int mwts21c_read(char *filename);
extern int mwts21c_to_hdf5_write(char *filename, int clevel);
extern int mwts2_sdr_read(char *filename);
extern int mwts2_sdr_intf(void);
extern int mwts21c_from_hdf5_read(char *filename); 
extern int mwts21c_write(char *filename);

#endif  /* AAPP_HDF5_H */
