!$Id: ama1b.h,v 1.2 2005/04/15 13:39:47 frna Exp $
!###########################################################################
!
!               AMSU-A Level 1B Data Set
!
!    Updated 24 June 1996
!    Modified on July 10 M. Derrien 
! changed       integer*2  ama_navstat   by integer*4
!    July 17 1996 Revert to I*2 on ama1_sync,ama1_id,ama1_dhk and ama2_*
!    Dec 31 1996 Modified to conform to NOAA release dated Dec 31 1996
!    Mar 6 1998  Modified to conform to NOAA release dated May 28 1997
!    Nov 5 2004  Modified to conform to NOAA release dated Sept 27 2004. NCA
!
!###########################################################################
!                                                                          !
!                      AMSU-A  PARAMETERS                                  !
!                                                                          !
!###########################################################################

       integer reclama         !length in byte of one AMSU-A record
       parameter(reclama=2560)
       integer cama_size       !length in integer*2 of one AMSU-A record
       parameter(cama_size=1280)

!###########################################################################
!
!              AMSU-A HEADER RECORD
!
!##############################################################################
C!
C!..AMSU-A header words----------------------------------------------------
C!
C!.. General information
C!
       character*3  ama_h_siteid        !Data set creation site ID
       character*1  ama_h_blank         !ASCII blank
       integer*2    ama_h_l1bversnb     !level 1b format version number
       integer*2    ama_h_l1bversyr     !level 1b format version year
       integer*2    ama_h_l1bversdy     !level 1b format version day of year
       integer*2    ama_h_reclg         ! logical record length
       integer*2    ama_h_blksz         ! blocksize
       integer*2    ama_h_hdrcnt        !count of header records in data set
       integer*2    ama_h_filler1(3)
       character*42 ama_h_dataname      !data set name
       character*8  ama_h_prblkid       !processing block identification
       integer*2    ama_h_satid         !NOAA spacecraft identification code
       integer*2    ama_h_instid        !AMSU-A instrument identification
C!                  (Bits 15-8:AMSU-A2 ID - 2=EM, 6=PFM, 10=F1, 14=F2)
C!                  (Bits 7-0: AMSU-A1 ID - 1=EM, 5=PFM,  9=F1, 13=F2)
       integer*2    ama_h_datatyp       !data type code
C!                  (1 = LAC; 2 = GAC; 3 = HRPT; 4 = TIP; 5 = HIRS; 6 = MSU;
C!                   7 = SSU; 8 = DCS; 9 = SEM; 10 = AMSU-A; 11 = AMSU-B)
       integer*2    ama_h_tipsrc        !TIP source code
C!                  (0 = N/A; 1 = embedded; 2 = stored; 3 = third CDA)
       integer*4    ama_h_startdatajd   !start of data set julian day
C!                                       (count from 00h 1 Jan 1950)
       integer*2    ama_h_startdatayr   !start of data set year
       integer*2    ama_h_startdatady   !start of data set day of year
       integer*4    ama_h_startdatatime !start of data set UTC time of day in
C!                                       milliseconds
       integer*4    ama_h_enddatajd     !end of data set julian day
C!                                       (count from 00h 1 Jan 1950)
       integer*2    ama_h_enddatayr     !end of data set year
       integer*2    ama_h_enddatady     !end of data set day of year
       integer*4    ama_h_enddatatime   !end of data set UTC time of day in
C!                                       milliseconds
       integer*2    ama_h_cpidsupdyr    ! year of last CPIDS update
       integer*2    ama_h_cpidsupddy    ! day of year of last cpids update
       INTEGER*2    ama_h_fov1offset    !time offset for FOV 1 (ms)
C!       CHARACTER*2  ama_h_calparid     !Redundant, but retain for compatibility
       integer*2    ama_h_filler2(5)   !filler
C!
C!              DATA SET QUALITY INDICATORS
C!
       integer*4   ama2_h_inststat1     !AMSU-A2 instrument status
C!                 Bit 31-15:<zero fill> 
C!                     14=Cold Cal pos msb, 13=Cold cal pos lsb, 
C!                       (0=6.667, 1=8.333, 2=9.999, 3=13.332 degrees) 
C!                     12=park nadir, 11=park cold, 10=park warm, 9=full scan,
C!                     8-5=<zero fill>
C!                     4=survival heater on, 3=module power, 2=comp motor
C!                     1=scanner A2 power, 0=<zero fill>
       integer*2   ama_h_filler3         !filler
       integer*2   ama2_h_statchrecnb    !record number of status change
C!                 ( if 0, none occurred)
       integer*4   ama2_h_inststat2      !AMSU-A2 second instrument status
C!                 ( if previous word is 0, no change)
C!
       integer*4   ama1_h_inststat1     !AMSU-A1 instrument status
C!                 Bit 31-15:<zero fill> 
C!                     14=Cold Cal pos msb, 13=Cold cal pos lsb, 
C!                       (0=6.667, 1=8.333, 2=9.999, 3=13.332 degrees) 
C!                     12=park nadir, 11=park cold, 10=park warm, 9=full scan, 
C!                       (if all zero, instrument is parked in warm cal)
C!                     8-6=<zero fill>
C!                     5=module power connect, 4=survival heater on, 
C!                     3=phase lock loop (0=redundant, 1=primary), 
C!                     2=scanner A1-2 power
C!                     1=scanner A1-1 power, 0=<zero fill>
       integer*2   ama_h_filler4         !filler
       integer*2   ama1_h_statchrecnb    !record number of status change
C!                 ( if 0, none occurred)
       integer*4   ama1_h_inststat2      !AMSU-A1 second instrument status
C!                 ( if previous word is 0, no change)
C!
       integer*2   ama_h_scnlin         !count of scan lines in this data set
       integer*2   ama_h_callocsclin    !count of calibrated, earth located
C!                                       scan lines in this data set
       integer*2   ama_h_misscnlin      !count of missing scan lines
       integer*2   ama_h_datagaps       !count of data gaps in this data set
       integer*2   ama_h_okdatafr       !count of data frames without frame
C!                                       sync word errors
       integer*2   ama_h_pacsparityerr  !count of PACS detected TIP parity
C!                                       errors
       integer*2   ama_h_auxsyncerrsum  !sum of all auxiliary sync errors
C!                                       detected in the input data
       integer*2   ama_h_timeseqerr     !time sequence error
C!               (0 =none; otherwise the record number of the first occurrence)
       integer*2   ama_h_timeseqerrcode !time sequence error code
C!               (taken from Scan Line Quality Flags, at the time of first
C!                occurrence)
       integer*2   ama_h_socclockupind  !socc clock update indicator
C!               ( 0 = none during this orbit;
C!                   otherwise the record number of the first occurrence)
       integer*2   ama_h_locerrind      !earth location error indicator
C!               ( 0 = none during this orbit;
C!                   otherwise the record number of the first occurrence)
       integer*2   ama_h_locerrcode     !earth location error code
C!               (taken from Scan Line Quality Flags, at the time of first
C!                occurrence)
       integer*2   ama_h_pacsstatfield
       integer*2   ama_h_pacsdatasrc   !0=unused, 1=Gilmore, 2=Wallops, 3=SOCC
       integer*4   ama_h_filler5a
       character*8 ama_h_spare2         ! reserved for ingester
       character*8 ama_h_spare3         ! reserved for decommutation
       integer*4   ama_h_filler5(4)
C!
C! Calibration parameters
C!
      INTEGER*2 ama_h_plloid
      INTEGER*2 ama_h_tsensid(3)    ! Instrument temperature sensor ID
C!              A1-1, A1-2 and A2; 0=RF shelf, 1=RF Mux
      INTEGER*2 ama_h_reftemp(12)   ! Instrument reference temps, RF Shelf
C!              3 temperatures for A1-1, A1-2, A2 and A1-1 PLLO#2
      INTEGER*2 ama_h_muxtemp(12) ! Instrument reference temps, RF Mux
C!              3 temperatures for A1-1, A1-2, A2 and A1-1 PLLO#2
      INTEGER*2 ama_h_bias(78)     ! Calibration bias corrections
C!              Warm target bias at 3 temps and cold bias for 15 channels,
C!              then Warm target bias at 3 temps for Channels 9-14 PLLO#2.
      INTEGER*4 ama_h_nonlin(63)   ! Nonlinearity corrections
C!              At 3 temps for Ch 1-15 and Ch 9-14 PLLO#2.
      INTEGER*4 ama_h_filler6(4)
C!
C! temp to radiance conversion factors
C!
      INTEGER*4 ama_h_temrad(45)
C!         10^6*(Central wavenumber, Const1, Const2 (slope)) for 15 channels
      INTEGER*4 ama_h_filler7(3)
C!
C! Navigation
C!
      character*8 ama_h_modelid
      integer*2   ama_h_nadloctol  !10 x (nadir earth location tolerance in km)
      integer*2   ama_h_locbit     !earth location bit field
C!                 bits 15-3: <zero fill>
C!          bit 0 : constant attitude error correction (0 = not performed)
C!          bit 1 : reasonableness test (0 = inactive, 1=active)
C!          bit 2 : dynamic attitude error correction (0 = not performed)
      integer*2   ama_h_filler8
      integer*2   ama_h_rollerr    !10^3 x (constant roll attitude error, deg)
      integer*2   ama_h_pitcherr   !10^3 x (constant pitch attitude error, deg)
      integer*2   ama_h_yawerr     !10^3 x (constant yaw attitude error in deg)
      integer*2   ama_h_epoyr      !epoch year for orbit vector
      integer*2   ama_h_epody      !day of epoch year for orbit vector
      integer*4   ama_h_epotime    !epoch UTC time of day in milliseconds for
C!                                   orbit vector
      integer*4   ama_h_smaxis     !10^6 x (semi-major axis in kilometers)
      integer*4   ama_h_eccen      !10^8 x (eccentricity)
      integer*4   ama_h_incli      !10^5 x (inclination in degrees)
      integer*4   ama_h_argper     !10^5 x (argument of perigee in degrees)
      integer*4   ama_h_rascnod    !10^5 x (right ascension of the ascending
C!                                           node in degrees)
      integer*4   ama_h_manom      !10^5 x (mean anomaly in degrees)
      integer*4   ama_h_xpos       !10^6 x (position vector x component in
C!                                           kilometers)
      integer*4   ama_h_ypos       !10^6 x (position vector y component in
C!                                           kilometers)
      integer*4   ama_h_zpos       !10^6 x (position vector z component in
C!                                           kilometers)
      integer*4   ama_h_xvel       !10^8 x (velocity vector x-dot component
C!                                           in kilometers/second)
      integer*4   ama_h_yvel       !10^8 x (velocity vector y-dot component
C!                                           in kilometers/second)
      integer*4   ama_h_zvel       !10^8 x (velocity vector z-dot component
C!                                           in kilometers/second)
      integer*4   ama_h_earthsun   !10^6 x (earth/sun distance ratio)
      INTEGER*4   ama_h_filler9(4)
C!
C! digital A and analogue telemetry conversion coeffs
C!
      INTEGER*4 ama1_h_digacoef(180)
C!              4 coefficients for: Scan motor A1-1; Scan motor A1-2; Horn A1-1;
C!              Horn A1-2; RF Mux A1-1; RF Mux A1-2; LO Chan 3-8 and 15;
C!              PLLO#2; PLLO#1; PLLO (Ref Osc); Mixer Chan 3-9 and 15; 
C!              IF Amp Ch 11/14, 9, 10, 11; DC/DC convertor; IF Amp Ch 13, 14,
C!              12; RF Shelf A1-1 and A1-2; Det/Pre-amp; A1-1 warm load 1-4 
C!              and centre; A1-2 warm load 1-4 and centre.
      INTEGER*4 ama_h_filler10
      INTEGER*4 ama1_h_analcoef(54)
C!              Intercept and slope for 27 parameters
      INTEGER*4 ama_h_filler11
      INTEGER*4 ama2_h_digacoef(76)
C!              4 coefficients for: Scan motor A2; Horn A2;
C!              RF Mux A2; Mixer/IF Amp Chan 1-2; LO Chan 1-2;
C!              Compensation motor, Subreflector, DC/DC convertor; 
C!              RF Shelf; Det/Pre-amp; A2 warm load centre and 1-6.
      INTEGER*4 ama_h_filler12
      INTEGER*4 ama2_h_analcoef(30)
C!              Intercept and slope for 15 parameters
      INTEGER*4 ama_h_filler13(2)
C!
C! lunar contamination correction (NESDIS)
C!
      INTEGER*2 ama_h_moonscnlin     !count of scans with Moon in space view
                                     ! (-1 = detection algorithm turned off)
      INTEGER*2 ama_h_moondist       !100*average dist to Moon in Earth radii
      INTEGER*2 ama_h_moonsunang     !100*angle between Moon and Sun in degrees
      INTEGER*2 ama_h_filler14
C!
C! METOP manoeuvres identification (zero fill for NOAA)
C!
      INTEGER*2 ama_h_startmanyr        !4 digit year
      INTEGER*2 ama_h_startmandy        !Day of year
      INTEGER*4 ama_h_startmantime      !Time of day in milliseconds
      INTEGER*2 ama_h_endmanyr
      INTEGER*2 ama_h_endmandy
      INTEGER*4 ama_h_endmantime
      INTEGER*4 ama_h_deltav(3)         !Change in velocity
      INTEGER*4 ama_h_mass(2)           !Spacecraft mass before and after
C!      
C! Spare words
C!
      integer*4 ama_h_filler15(40)
C!
      INTEGER*2 ama_hd(cama_size)
      EQUIVALENCE(ama_hd(1),ama_h_siteid)
C!
      COMMON/AMA1BHD/ama_h_siteid,ama_h_blank,ama_h_l1bversnb,
     &       ama_h_l1bversyr,ama_h_l1bversdy,ama_h_reclg,ama_h_blksz,
     &       ama_h_hdrcnt,ama_h_filler1,ama_h_dataname,ama_h_prblkid,
     &       ama_h_satid,ama_h_instid,ama_h_datatyp,ama_h_tipsrc,
     &       ama_h_startdatajd,ama_h_startdatayr,ama_h_startdatady,
     &       ama_h_startdatatime,ama_h_enddatajd,ama_h_enddatayr,
     &       ama_h_enddatady,ama_h_enddatatime,ama_h_cpidsupdyr,
     &       ama_h_cpidsupddy,ama_h_fov1offset,ama_h_filler2,
     &       ama2_h_inststat1,ama_h_filler3,
     &       ama2_h_statchrecnb,ama2_h_inststat2,
     &       ama1_h_inststat1,ama_h_filler4,ama1_h_statchrecnb,
     &       ama1_h_inststat2,ama_h_scnlin,ama_h_callocsclin,
     &       ama_h_misscnlin,ama_h_datagaps,ama_h_okdatafr,
     &       ama_h_pacsparityerr,ama_h_auxsyncerrsum,ama_h_timeseqerr,
     &       ama_h_timeseqerrcode,ama_h_socclockupind,ama_h_locerrind,
     &       ama_h_locerrcode,ama_h_pacsstatfield,ama_h_pacsdatasrc,
     &       ama_h_filler5a,ama_h_spare2,ama_h_spare3,ama_h_filler5,
     &       ama_h_plloid,ama_h_tsensid,
     &       ama_h_reftemp,ama_h_muxtemp,
     &       ama_h_bias,ama_h_nonlin,ama_h_filler6,
     &       ama_h_temrad,ama_h_filler7,ama_h_modelid,
     &       ama_h_nadloctol,ama_h_locbit,ama_h_filler8,
     &       ama_h_rollerr,ama_h_pitcherr,ama_h_yawerr,ama_h_epoyr,
     &       ama_h_epody,ama_h_epotime,ama_h_smaxis,
     &       ama_h_eccen,ama_h_incli,ama_h_argper,ama_h_rascnod,
     &       ama_h_manom,ama_h_xpos, ama_h_ypos,ama_h_zpos,
     &       ama_h_xvel,ama_h_yvel,ama_h_zvel,ama_h_earthsun,
     &       ama_h_filler9,
     &       ama1_h_digacoef,ama_h_filler10,ama1_h_analcoef,
     &       ama_h_filler11,ama2_h_digacoef,ama_h_filler12,
     &       ama2_h_analcoef,ama_h_filler13,
     &       ama_h_moonscnlin,ama_h_moondist,ama_h_moonsunang,
     &       ama_h_filler14,ama_h_startmanyr,ama_h_startmandy,
     &       ama_h_startmantime,ama_h_endmanyr,ama_h_endmandy,
     &       ama_h_endmantime,ama_h_deltav,ama_h_mass,ama_h_filler15

!##############################################################################
!
!            SINGLE AMSU-A 1B  DATA RECORD
!
!##############################################################################
C!
C!......scan line information
C!
      INTEGER*2 ama_scnlin
      INTEGER*2 ama_scnlinyr,ama_scnlindy,ama_clockdrift
      INTEGER*4 ama_scnlintime             ! UTC time of day in milliseconds
      INTEGER*2 ama_scnlinbit              ! scan line bit field
C!                          Bit 15: 0=northbound, 1=southbound
C!                          Bit 14: 1=scan time corrected for clock drift
C!                          Bit 13-0: <zero fill>
      Integer*2 ama_tipmf                  ! Major frame count
      INTEGER*4 ama_filler1(2)
      INTEGER*4 ama_qualind                ! quality indicator bit field
      INTEGER*4 ama_linqualflgs            ! scan line quality
      INTEGER*2 ama_chqualflg(16)          ! Calibration quality flags 
C!                                     for each channel (last word zero fill)
      INTEGER*4 ama_filler2(4)
C!
C!......calibration coeffs
C!
      INTEGER*4 ama_pmcal(45),ama_sdcal(45) ! Primary & secondary cal coeffs
C!              Second, first and zeroth order coefficients for 15 channels
      INTEGER*4 ama_filler3
C!
C!.......navigation
C!
      INTEGER*2  ama_yawsteering(3) !computed yaw steering angles for METOP
                                    !Yaw, pitch, roll (degrees)
      INTEGER*2  ama_totattcorr(3)  !Total applied attitude correction for METOP
                                    !1000* Yaw, pitch, roll (degrees)
      integer*4  ama_navstat    !navigation status bit field
!         bits31-17: zero fill
!         bit 16:    1=earth location corrected for TIP Euler angles
!         bits15-12: earth location indicator
!                    0=earth location available
!                    1=user ephemerics files greater than 24hours old
!                    2=no earth location available
!         bits11-08: spacecraft attitude control
!                    0=operating in YGC or nominal mode
!                    1=operating in another mode
!                    2=attitude exceeds nominal tolerance
!                    3=both 1 and 2
!         bits07-04: attitude SMODE
!                    0=nominal mode
!                    1=rate nulling mode
!                    2=YGC mode
!                    3=search mode
!                    4=coast mode
!         bits03-00: attitude PWT1$AC
!                    0=nominal mode/no test
!                    1=yaw axis test in progress
!                    2=roll axis test in progress
!                    3=pitch axis test in progress
      integer*4  ama_attangtime   !time associated with TIP Euler angles (secs)
      integer*2  ama_rollang        !10^3*Roll angle in degrees
      integer*2  ama_pitchang       !10^3*Pitch angle in degrees
      integer*2  ama_yawang         !10^3*Yaw angle in degrees
      integer*2  ama_scalti         !10*spacecraft altitude (MSL) in km
      integer*2  ama_ang(90) !scan angles in degrees
!                     word1: 100*solar zenith angle, point 1
!                     word2: 100*satellite zenith angle, point 1
!                     word3: 100*local azimuth angle, point 1
!                     word4: 100*solar zenith angle, point 2
!                     word5: 100*satellite zenith angle, point 2
!                     word6: 100*local azimuth angle, point 2
!                     ......
!                     word88: 100*solar zenith angle, point 30
!                     word89: 100*satellite zenith angle, point 30
!                     word90: 100*local azimuth angle, point 30
      integer*4  ama_pos(60) !Earth location
!                     (north latitude and east longitude are positive)
!                     word1: 10^4*latitude in degrees, point 1
!                     word2: 10^4*longitude in degrees, point 1
!                     word3: 10^4*latitude in degrees, point 2
!                     word4: 10^4*longitude in degrees, point 2
!                     ......
!                     word60: 10^4*longitude in degrees, point 30
      integer*4  ama_filler4  ! <zero fill>
C!
C!.......A1 telemetry
C!
!      character*3 ama1_sync
!      character*1 ama1_id
!      character*4 ama1_dhk
      integer*2 ama1_sync
      integer*2 ama1_id      !n.b. includes 3rd sync character
      integer*2 ama1_dhk(2)
      INTEGER*2 ama1_earth_data(17,30)
C!              4 position + 13 channels (3-15) at each antenna position
      INTEGER*2 ama1_coldcal(30)
C!              4 position + 13 channels(3-15) + 13 channels repeat, cold view
      INTEGER*2 ama1_temps(46)         !46 temperatures
      INTEGER*2 ama1_warmcal(30)
C!              4 position + 13 channels(3-15) + 13 channels repeat, warm view
      INTEGER*4 ama_filler5
C!
C!.......A1 digital B telemetry
C!
      INTEGER*2 ama1_digbval  !Indicates validity of ama1_digb bits (0=valid)
      INTEGER*2 ama1_digb
      INTEGER*4 ama_filler6
C!
C!.......A1 Analog housekeeping data (TIP)
C!
      INTEGER*4 ama1_ahkval   !Each bit indicates validity of ama1_ahk word
C!                             (0 = valid, 1=invalid)
      character*1 ama1_ahk(28)  !27 analogue words (word 28 is zero-fill)
      INTEGER*4 ama_filler7
C!
C!.......A2 telemetry
C!
!      character*3 ama2_sync
!      character*1 ama2_id
!      character*4 ama2_dhk
      integer*2 ama2_sync
      integer*2 ama2_id      !n.b. includes 3rd sync character
      integer*2 ama2_dhk(2)
      INTEGER*2 ama2_earth_data(4,30)
C!              2 position + 2 channels (1-2) at each antenna position
      INTEGER*2 ama2_coldcal(6)
C!              2 position + 2 channels(1-2) + 2 channels repeat, cold view
      INTEGER*2 ama2_temps(20)         !20 temperatures
      INTEGER*2 ama2_warmcal(6)
C!              2 position + 2 channels(1-2) + 2 channels repeat, warm view
      INTEGER*4 ama_filler8
C!
C!.......A2 digital B telemetry
C!
      INTEGER*2 ama2_digbval  !Indicates validity of ama2_digb (0=valid)
      INTEGER*2 ama2_digb
      INTEGER*4 ama_filler9
C!
C!.......A2 Analog housekeeping data (TIP)
C!
      INTEGER*4 ama2_ahkval     !Each bit indicates validity of ama2_ahk word
C!                             (0 = valid, 1=invalid)
      character*1 ama2_ahk(16)   !15 analogue words (word 16 is zero-fill)
C!
C!.......Lunar contamination correction (NESDIS method using antenna patterns)
C!
      CHARACTER*1 ama_mooncountcor(15)    !Raw count minus corrected (0 to 255)
      CHARACTER*1 ama_filler10
      INTEGER*2 ama_moonazimuth(3)   !100*azimuth in deg for A1-1, A1-2, A2
      INTEGER*2 ama_moonelev(3)      !100*elevation in deg for A1-1, A1-2, A2

      INTEGER*4 ama_filler11

      INTEGER*2 ama_dt(cama_size)
      EQUIVALENCE(ama_dt(1),ama_scnlin)
      COMMON/AMA1BDT/ama_scnlin,ama_scnlinyr,ama_scnlindy,
     &        ama_clockdrift,ama_scnlintime,ama_scnlinbit,
     &        ama_tipmf,ama_filler1,ama_qualind,
     &        ama_linqualflgs,ama_chqualflg,ama_filler2,
     &        ama_pmcal,ama_sdcal,ama_filler3,
     &        ama_yawsteering,ama_totattcorr,ama_navstat,
     &        ama_attangtime,ama_rollang,ama_pitchang,ama_yawang,
     &        ama_scalti,ama_ang,ama_pos,ama_filler4,
     &        ama1_sync,ama1_id,ama1_dhk,ama1_earth_data,
     &        ama1_coldcal,ama1_temps,ama1_warmcal,ama_filler5,
     &        ama1_digbval,ama1_digb,
     &        ama_filler6,ama1_ahkval,ama1_ahk,ama_filler7,
     &        ama2_sync,ama2_id,ama2_dhk,ama2_earth_data,
     &        ama2_coldcal,ama2_temps,ama2_warmcal,ama_filler8,
     &        ama2_digbval,ama2_digb,ama_filler9,
     &        ama2_ahkval,ama2_ahk,ama_mooncountcor,ama_filler10,
     &        ama_moonazimuth,ama_moonelev,ama_filler11
!-------------------------------------------------------------------------------
!                         -- CVS MODIFICATION HISTORY --
!-------------------------------------------------------------------------------
!$Log: ama1b.h,v $
!Revision 1.2  2005/04/15 13:39:47  frna
!Merge AAPP5Dev with main trunk
!
!Revision 1.1.1.1.4.2  2004/11/26 11:40:34  frna
!Correct typo
!
!Revision 1.1.1.1.4.1  2004/11/10 09:43:49  frna
!Conform to NOAA 1b release dated Sept 27 2004

