!-----------------------------------------------------------------------------
! ama_cinit.h
      integer nscan
      parameter (nscan=7)         ! number of scans to avg cal samples over
!      parameter (nscan=3)         ! number of scans to avg cal samples over
      real c,plck(2)              ! speed of light and Planck constants
      real tspace                 ! br temp of space at AMSU frequencies
!
      integer modid               ! instrument id
      real freq(15)               ! centre frequencies in wavenumbers
      real a(15),b(15)            ! band correction factors
      integer nscan2              ! half no. of scans to avg cal samples over
      integer spview_a1,spview_a2 ! preferred view (A1 antennae both use same 
!                                   view)
! prt counts to temp conversion coefs
      real prtcnttmp_a11(4,5),prtcnttmp_a12(4,5),prtcnttmp_a2(4,7)
! individual PRT weights
      real prtwght_a11(5),prtwght_a12(5),prtwght_a2(7) 
      real  prtcnttmpi_a11(4)      ! instrument temp prt coeffs
      real  prtcnttmpi_a12(4)      ! instrument temp prt coeffs
      real  prtcnttmpi_a2(4)       ! instrument temp prt coeffs
      real intcorr(21,3)           ! internal target corrn degK
      real spcorr(21,4)            ! space view corrn degK
      integer intcntmin(21),intcntmax(21) ! internal target max/min counts
      integer spcntmin(21),spcntmax(21) ! space view max/min counts
      integer dcount(21)       ! max change in counts
! conv coef for antenna position
      real ant_coef_a11,ant_coef_a12,ant_coef_a2
      real ant_off_a11,ant_off_a12,ant_off_a2
!  max posn error for cal & earth views
      real pos_errc_a11,pos_errc_a12,pos_errc_a2,
     &     pos_erre_a11,pos_erre_a12,pos_erre_a2  
! min,max & max change in PRT values allowed
      real prtmin_a11,prtmin_a12,prtmin_a2,
     &     prtmax_a11,prtmax_a12,prtmax_a2,
     &     prtdt_a11,prtdt_a12,prtdt_a2 
! min number of PRTs to define target temp
      integer nprtmin_a11,nprtmin_a12,nprtmin_a2          
! no. of scan lines to fill in PRT data
      integer nprtgap_a11,nprtgap_a12,nprtgap_a2          
! no. of scan lines to use for consistency checks in cal views
      integer ncalgap_a11,ncalgap_a12,ncalgap_a2      

      real reftemp(4,3)          ! min, nominal and max instrument temps
                                 !for A1-1, A1-2, A2 and A1-PLLO2
      real nonlin(21,3)         ! non-linearity correction factors
      real u0(15,3),u1(15,3),u2(15,3) ! default calib coefs for min,norm & max T
      real scanpos(2,4)    ! nominal calib viewing angles, space and internal

      real digacoef_a1(4,45),digacoef_a2(4,19)  !Digital A telemetry coeffs
      real analcoef_a1(2,27),analcoef_a2(2,15)  !Analogue telemetry coeffs
! modified by M. Derrien May 98
      integer tsensid_a11,tsensid_a12,tsensid_a2
      real muxtemp(4,3),shelftemp(4,3)
!
      common/amb_clcoef/c,plck,tspace,modid,freq,a,b,nscan2,
     & spview_a1,spview_a2,prtcnttmp_a11,prtcnttmp_a12,
     & prtcnttmp_a2,prtwght_a11,prtwght_a12,prtwght_a2,prtcnttmpi_a11,
     & prtcnttmpi_a12,prtcnttmpi_a2,intcorr,spcorr,
     & intcntmin,intcntmax,spcntmin,spcntmax,dcount,reftemp,
     & ant_coef_a11,ant_coef_a12,ant_coef_a2,
     & ant_off_a11,ant_off_a12,ant_off_a2,pos_errc_a11,pos_errc_a12,
     & pos_errc_a2,pos_erre_a11,pos_erre_a12,pos_erre_a2,
     & prtmin_a11,prtmin_a12,prtmin_a2,prtmax_a11,prtmax_a12,prtmax_a2,
     & prtdt_a11,prtdt_a12,prtdt_a2,nprtmin_a11,nprtmin_a12,nprtmin_a2,
     & nprtgap_a11,nprtgap_a12,nprtgap_a2,nonlin,scanpos,
     & ncalgap_a11,ncalgap_a12,ncalgap_a2,digacoef_a1,digacoef_a2,
     & analcoef_a1,analcoef_a2,tsensid_a11,tsensid_a12,tsensid_a2,
     & muxtemp,shelftemp
      common/amb_tstcf/u0,u1,u2
