!---------------------------------------------------------------------------
!amascn.h
! Created June 96 (N. Atkinson)
! modified pos array name by earthloc name ( M. Derrien July 96)
! a1_dhk and a2_dhk included (N. Atkinson July 96)
! modified integer*2 to integer*4 for navstat & earthl ( M.Derrien May 1998)
!
! March 04  full orbit parametrisation P. Brunel
!###########################################################################
!                                                                          !
!                      AMSU-A  PARAMETERS                                    !
!                                                                          !
!###########################################################################
       integer mxpix       !maximum spot number
       parameter(mxpix=30)
       integer mxlin       !maximum AMSU-A lines number
       parameter(mxlin=1000)

!###########################################################################
!
!               AMSU-A Level 1B Scan line
!    Last updated 10 June 1996
!
!##############################################################################
!
!            AMSU-A DATA RECORDS
!
!##############################################################################
C!......scan line information
      INTEGER*2 scnlin(mxlin),scnlinyr(mxlin),scnlindy(mxlin)
      INTEGER*2 clockdrift(mxlin),scnlinbit(mxlin)
      INTEGER*4 scnlintime(mxlin),qualind(mxlin),linqualflgs(mxlin)
      INTEGER*2 chqualflg(15,mxlin),tipmf(mxlin)
C! cal coeffs
      INTEGER*4 pmcal(45,mxlin),sdcal(45,mxlin)
C!....navigation
      integer*4  attangtime(mxlin)    !time associated angles (seconds)
      integer*2  rollang(mxlin)       !Roll angle in degrees
      integer*2  pitchang(mxlin)      !Pitch angle in degrees
      integer*2  yawang(mxlin)        !Yaw angle in degrees
      integer*4  navstat(mxlin)    !navigation status bit field
!         bits15-12: earth location indicator
!                    0=earth location available
!                    1=user ephemerics files greater than 24 hours old
!                    2=no earth location available
!         bits11-08: spacecraft attitude control
!                    0=operating in YGC or nominal mode
!                    1=operating in another mode
!                    2=attitude exceeds nominal tolerance
!                    3=both 1 and 2
!         bits07-04: attitude SMODE
!                    0=nominal mode
!                    1=rate nulling mode
!                    2=YGC mode
!                    3=search mode
!                    4=coast mode
!         bits03-00: attitude PWT1$AC
!                    0=nominal mode/no test
!                    1=yaw axis test in progress
!                    2=roll axis test in progress
!                    3=pitch axis test in progress
      integer*2  scalti(mxlin)       !10*spacecraft altitude (MSL) in km
      integer*2  ang(mxpix*3,mxlin) !scan angles in degrees
!                     word1: 100*solar zenith angle, point 1
!                     word2: 100*satellite zenith angle, point 1
!                     word3: 100*local azimuth angle, point 1
!                     word4: 100*solar zenith angle, point 2
!                     word5: 100*satellite zenith angle, point 2
!                     word6: 100*local azimuth angle, point 2
!                     ......
!                     word88: 100*solar zenith angle, point 30
!                     word89: 100*satellite zenith angle, point 30
!                     word90: 100*local azimuth angle, point 30
      integer*4  earthl(mxpix*2,mxlin) !Earth location
!                     (north latitude and east longitude are positive)
!                     word1: 100*latitude in degrees, point 1
!                     word2: 100*longitude in degrees, point 1
!                     word3: 100*latitude in degrees, point 2
!                     word4: 100*longitude in degrees, point 2
!                     ......
!                     word60: 100*longitude in degrees, point 30
C!
C!.......AMSU-A1 telemetry
      INTEGER*4 a1_dhk(mxlin)
      INTEGER*4 a1_earth_data(17,30,mxlin)
      INTEGER*4 a1_coldcal(30,mxlin),a1_warmcal(30,mxlin)
      INTEGER*4 a1_temps(46,mxlin),a1_digb(mxlin)
C!.......AMSU-A2 telemetry
      INTEGER*4 a2_dhk(mxlin)
      INTEGER*4 a2_earth_data(4,30,mxlin)
      INTEGER*4 a2_coldcal(6,mxlin),a2_warmcal(6,mxlin)
      INTEGER*4 a2_temps(20,mxlin),a2_digb(mxlin)
C!
      COMMON/scan/scnlin,scnlinyr,scnlindy,clockdrift,scnlintime,
     &        scnlinbit,qualind,linqualflgs,
     &        chqualflg,tipmf,pmcal,sdcal,
     &        attangtime,rollang,pitchang,yawang,
     &        navstat,scalti,ang,earthl,a1_dhk,a2_dhk,
     &        a1_earth_data,a1_coldcal,a1_warmcal,a1_temps,a1_digb,
     &        a2_earth_data,a2_coldcal,a2_warmcal,a2_temps,a2_digb
