#define AMB_SPOTS 90
#define AMB_CHANS 5
#define AMA_CHANS 15
#define AMSU_CHANS 20

char h_site[4];       /* dataset creation site ID (terminated by null) */
char h_1bsite[4];     /* creation site for original 1B data */
int  h_versnb;        /* level 1c format version number */
int  h_satid;         /* satellite id (e.g. 14 for NOAA-14) */
int  h_grid;          /* code for instrument grid (5=HIRS; 6=MSU; 10=AMSU-A; 11=AMSU-B) */
int  h_satht;         /* nominal satellite altitude, km*10 */
int  h_period;        /* nominal orbit period (seconds) */
int  h_startorbit;    /* orbit number (at start of file) */
int  h_startdatayr;   /* start of data set year */
int  h_startdatady;   /* start of data set day of the year */
int  h_startdatatime; /* start of data set UTC time of day (ms) */
int  h_endorbit;      /* orbit number (at end of file) */
int  h_enddatayr;     /* end of data set year */
int  h_enddatady;     /* end of data set day of the year */
int  h_enddatatime;   /* end of data set UTC time of day (ms) */
int  h_scnlin;        /* count of scan lines in this data set */
int  h_misscnlin;     /* count of missing scan lines */
int  h_atovppvn;      /* ATOVPP version number */
int  h_instruments;   /* instruments present (bit0=HIRS, bit1=MSU, bit3=AMSU-A, bit4=AMSU-B, bit5=AVHRR) */
int  h_Bantenna;      /* vn no, AMSU-B antenna corrections (from ATOVIN) */
int  h_wmosatid;      /* WMO satellite id (e.g. 3 for METOP-1) */
int  h_amsPlanck[AMSU_CHANS][3];   /* Wavenumber, const1, const2 for AMSU */
int  h_Bcorrvn;       /* vn no AMSU-B limb/emiss correction (=0 if data not corrected) */
int  h_Bpcpvn;        /* vn no AMSU-B precip/scatter detection (=0 if not done) */

int *scnlin;     /* scan line number */
int *scnlinyr;   /* scan line year */
int *scnlindy;   /* scan line day of year */
int *scnlintime; /* scan line UTC time of day in milliseconds */
int *qualind;    /* quality indicator bit field */
int *scanqual;   /* scan line quality flags */
int *instrtemp;  /* AMSU-B/MHS temperature */
int *latitude;   /* latitude, deg*10000 */
int *longitude;  /* longitude, deg*10000 */
int *surfheight; /* surface height, metres */
int *surftype;   /* 0=sea, 1=mixed, 2=land */
int *satzen;     /* local zenith angle, deg*100 */
int *satazi;     /* local azimuth angle, deg*100 */
int *solzen;     /* solar zenith angle, deg*100 */
int *solazi;     /* solar azimuth angle, deg*100 */
int *scalti;     /* sat altitude above reference ellipsoid, km*10 */
int *btemps;     /* brightness temperatures, K*100 */
int *prepro;     /* values from pre-processing */
