!
!###########################################################################
!                                                                          !
!                      AMSU-B CALIBRATION PARAMETERS                       !
!                                                                          !
! Updated July 2003 to include moon parameters. N C Atkinson               !
!                                                                          !
!###########################################################################
!
! amb_cinit.h
      integer nscan 
      parameter (nscan=7)         ! number of scans to avg cal samples over
      real c,plck(2)              ! speed of light and Planck constants
      real tspace                 ! br temp of space at AMSU frequencies
!--------------------------------------------------------------------------      
      integer modid               ! instrument id
      real freq(5)                ! centre frequencies in wavenumbers
      real a(5),b(5)              ! band correction factors
      integer nscan2              ! half no. of scans to avg cal samples over
      integer nview,spview        ! no. of space views and preferred view
      real prtcnttmp(4,7)         !prt counts to temp conversion coefs
      real prtwght(7)             ! individual PRT weights
      real  prtcnttmpi(4)         ! mixer prt coeffs
      real intcorr(5,3)           ! internal target corrn degK
      real spcorr(5,4)            ! space view corrn degK
      integer intcntmin(5),intcntmax(5) ! internal target max/min counts
      integer spcntmin(5),spcntmax(5) ! space view max/min counts
      integer dcount(5)       ! max change in counts
      integer ngap            ! max no. of lines before resetting last value
      real ant_coef           ! conv coef for antenna position
      real pos_errc,pos_erre  !  max posn error for cal & earth views
      real prtmin,prtmax,prtdt ! min,max & max change in PRT values allowed
      integer nprtmin          ! min number of PRTs to define target temp
      integer nprtgap          ! no. of scan lines to fill in PRT data
      real reftemp(3)          ! min, nominal and max instrument temps
      real nonlin(5,3)         ! non-linearity correction factors
      real scanpos(8,4)        ! nominal calib viewing angles
      real diga_coef(4,24)     ! digital A telemetry coeffs
      real anal_coef(4,18)     ! analogue telemetry coeffs
      real moonthresh          ! Angular threshold for moon contamination
      real moon_azcorr         ! Correction (deg) for optimising moon algorithm
      real moon_elevcorr       ! Correction (deg)
      
!---------------------------------------------------------------------------      
      real u0(5,3),u1(5,3),u2(5,3) ! default calib coefs for min,norm & max T
!
      common/amb_clcoef/c,plck,tspace,modid,freq,a,b,nscan2,nview,
     & spview,prtcnttmp,prtwght,reftemp,prtcnttmpi,intcorr,spcorr,
     & intcntmin,intcntmax,
     & spcntmin,spcntmax,dcount,ngap,ant_coef,pos_errc,pos_erre,
     & prtmin,prtmax,prtdt,nprtmin,nprtgap,nonlin,scanpos,
     & diga_coef,anal_coef,moonthresh,moon_azcorr,moon_elevcorr
      common/amb_tstcf/u0,u1,u2
