!###########################################################################
!
!               AMSU-B Level 1B Scan line 
!    Last updated 22 November 1995
!
!###########################################################################
!                                                                          !
!                      AMSU-B  PARAMETERS                                  !
!                                                                          !
!###########################################################################


       integer mxpix       !maximum number of FOVS
       parameter(mxpix=90)
       integer mxlin       !maximum AMSU-B lines number
!!       parameter(mxlin=450) ! 1 orbit~2270 
       parameter(mxlin=2600) ! 1 orbit~2270  ?? 
!                             local HRPT area ~ 350
!##############################################################################
!
!            AMSU-B DATA RECORDS 
!
!##############################################################################
C!......scan line information
      INTEGER*2 scnlinyr(mxlin),scnlindy(mxlin)
      INTEGER*2 clockdrift(mxlin),scnlin(mxlin),scnlinbit(mxlin)
      INTEGER*4 scnlintime(mxlin),qualind(mxlin),linqualflgs(mxlin)
      INTEGER*2 chqualflg(5,mxlin),tipmf(mxlin)
C! cal coeffs
      INTEGER*4 pmcal(15,mxlin),sdcal(15,mxlin)
C!....navigation
      integer    attangtime(mxlin)    !time associated angles (seconds)
      integer*2  rollang(mxlin)       !Roll angle in degrees
      integer*2  pitchang(mxlin)      !Pitch angle in degrees
      integer*2  yawang(mxlin)        !Yaw angle in degrees
      integer*4  navstat(mxlin)    !navigation status bit field
!         bits15-12: earth location indicator
!                    0=earth location available
!                    1=user ephemerics files greater than 24hours old
!                    2=no earth location available
!         bits11-08: spacecraft attitude control 
!                    0=operating in YGC or nominal mode
!                    1=operating in another mode
!                    2=attitude exceeds nominal tolerance
!                    3=both 1 and 2
!         bits07-04: attitude SMODE 
!                    0=nominal mode
!                    1=rate nulling mode
!                    2=YGC mode
!                    3=search mode
!                    4=coast mode
!         bits03-00: attitude PWT1$AC
!                    0=nominal mode/no test
!                    1=yaw axis test in progress
!                    2=roll axis test in progress
!                    3=pitch axis test in progress
      integer*2  scalti(mxlin)       !10*spacecraft altitude (MSL) in km 
      integer*2  ang(mxpix*3,mxlin) !scan angles in degrees
!                     word1: 100*solar zenith angle, point 1
!                     word2: 100*satellite zenith angle, point 1
!                     word3: 100*local azimuth angle, point 1
!                     word4: 100*solar zenith angle, point 2
!                     word5: 100*satellite zenith angle, point 2
!                     word6: 100*local azimuth angle, point 2
!                     ......
!                     word268: 100*solar zenith angle, point 90
!                     word269: 100*satellite zenith angle, point 90
!                     word270: 100*local azimuth angle, point 90
      integer*4  earthl(mxpix*2,mxlin) !Earth location
!                     (north latitude and east longitude are positive)
!                     word1: 100*latitude in degrees, point 1
!                     word2: 100*longitude in degrees, point 1
!                     word3: 100*latitude in degrees, point 2
!                     word4: 100*longitude in degrees, point 2
!                     ......
!                     word180: 100*longitude in degrees, point 90
      integer*2  moonang(4,mxlin)
C!
C!.......AMSU-B telemetry
      INTEGER*4 earth_data(540,mxlin)
      INTEGER*4 coldcal(24,mxlin),warmcal(24,mxlin)
      INTEGER*4 diga(mxlin),stat(mxlin)
      INTEGER*4 ahk(18,mxlin),temps(24,mxlin)
C!
      COMMON/scan/scnlin,scnlinyr,scnlindy,clockdrift,scnlintime,
     &        scnlinbit,qualind,linqualflgs,
     &        chqualflg,tipmf,pmcal,sdcal,
     &        attangtime,rollang,pitchang,yawang,
     &        navstat,
     &        scalti,ang,earthl,moonang,earth_data,coldcal,warmcal,
     &        stat,diga,temps,ahk
