#define ATMS_SPOTS 96
#define ATMS_CHANS 22

char h_site[4];          /* dataset creation site ID (terminated by null) */
char h_1bsite[4];        /* creation site for original 1B data */
int  h_versnb;           /* level 1c format version number */
int  h_satid;            /* satellite id (e.g. 14 for NOAA-14) */
int  h_instrument;       /* instrument code (5=HIRS; 6=MSU; 10=AMSU-A; 11=AMSU-B) */
int  h_satht;            /* nominal satellite altitude, km*10 */
int  h_period;           /* nominal orbit period (seconds) */
int  h_startorbit;       /* orbit number (at start of file) */
int  h_startdatayr;      /* start of data set year */
int  h_startdatady;      /* start of data set day of the year */
int  h_startdatatime;    /* start of data set UTC time of day (ms) */
int  h_endorbit;         /* orbit number (at end of file) */
int  h_enddatayr;        /* end of data set year */
int  h_enddatady;        /* end of data set day of the year */
int  h_enddatatime;      /* end of data set UTC time of day (ms) */
int  h_scnlin;           /* count of scan lines in this data set */
int  h_misscnlin;        /* count of missing scan lines */
int  h_vnantennacorr;      /* version number, antenna corrections */
int  h_tempradcnv[ATMS_CHANS][3]; /* wavenumber, const1, const2 */
int  h_bandwidth[ATMS_CHANS];     /* bandwidth */
int  h_nchan;                     /* number of channels */
int  h_nfov;                      /* number of FOVs */
int  h_nchanused;                 /* number of channels used */
int  h_wmosatid;                  /* WMO satellite id (224 for NPP) */
int  h_centre;                    /* WMO id of centre */
int  h_subcentre;                 /* WMO id of subcentre */
int  h_beamversion;               /* User defined (see atms_beamwidth.dat) */
int  h_beamwidth[ATMS_CHANS];     /* deg*1E3 */
int  h_cutoff[ATMS_CHANS];        /* fraction*1E3 */
int  h_nxaverage[ATMS_CHANS];     /* number of samples averaged along-scan */
int  h_nyaverage[ATMS_CHANS];     /* number of samples averaged along-track */


int *scnlin;             /* scan line number */
int *scnlinyr;           /* scan line year */
int *scnlindy;           /* scan line day of year */
int *scnlintime;         /* scan line UTC time of day in milliseconds */
int *orbit;              /* orbit number */
int *granulequal;        /* granule quality flags */
int *scanqual;           /* scan line quality flags */
int *geolocqual;         /* geolocation quality */
int *chanqual;           /* channel quality */
int *latitude;           /* latitude, deg*10000 */
int *longitude;          /* longitude, deg*10000 */
int *satzen;             /* local zenith angle, deg*100 */
int *satazi;             /* local azimuth angle, deg*100 */
int *solzen;             /* solar zenith angle, deg*100 */
int *solazi;             /* solar azimuth angle, deg*100 */
int *scalti;             /* sat altitude above reference ellipsoid, km*10 */
int *nedtcold;           /* Cold view NEDT K*1E4 */
int *nedtwarm;           /* Warm view NEDT K*1E4 */
int *anttemps;           /* Antenna temps *100 */
int *btemps;             /* BT *100 */
