/* Variables to hold the ATMS SDR together with geolocation data */

/* ATMS_GRANULES is the max number of granules that we need to accommodate -
   also defined in atms_sdr_out.F */

#define ATMS_GRANULES 30
#define ATMS_SCANS_PER_GRANULE 12
#define ATMS_SPOTS 96
#define ATMS_CHANS 22
#define ATMS_SCANS ATMS_SCANS_PER_GRANULE*ATMS_GRANULES
#define RMDI -9999.99
#define MDI -999999

/* SDR */

long long int      BeamTime[ATMS_SCANS][ATMS_SPOTS];
unsigned short int BrightnessTemperature[ATMS_SCANS][ATMS_SPOTS][ATMS_CHANS];
float              BrightnessTemperatureFactors[ATMS_GRANULES*2];
float              NEdTCold[ATMS_SCANS][ATMS_CHANS];
float              NEdTWarm[ATMS_SCANS][ATMS_CHANS];
char               AggregateBeginningDate[9];
unsigned long long AggregateBeginningOrbitNumber;
unsigned long long N_Beginning_Orbit_Number;
char               AggregateBeginningTime[15];
char               AggregateEndingDate[9];
unsigned long long AggregateEndingOrbitNumber;
char               AggregateEndingTime[15];
long               AggregateNumberGranules;
char               Mission_Name[4];
char               N_GEO_Ref[79];
char               N_Software_Version[16];
unsigned char      QF1_GRAN_HEALTHSTATUS[ATMS_SCANS/3];
unsigned char      QF2_GRAN_HEALTHSTATUS[ATMS_SCANS/3];
unsigned char      QF3_GRAN_HEALTHSTATUS[ATMS_SCANS/3];
unsigned char      QF4_GRAN_HEALTHSTATUS[ATMS_SCANS/3];
unsigned char      QF5_GRAN_HEALTHSTATUS[ATMS_SCANS/3];
unsigned char      QF6_GRAN_HEALTHSTATUS[ATMS_SCANS/3];
unsigned char      QF7_GRAN_HEALTHSTATUS[ATMS_SCANS/3];
unsigned char      QF8_GRAN_HEALTHSTATUS[ATMS_SCANS/3];
unsigned char      QF9_GRAN_HEALTHSTATUS[ATMS_SCANS/3];
unsigned char      QF11_GRAN_QUADRATICCORRECTION[ATMS_GRANULES];
unsigned char      QF12_SCAN_KAVPRTCONVERR[ATMS_SCANS];
unsigned char      QF13_SCAN_WGPRTCONVERR[ATMS_SCANS];
unsigned char      QF14_SCAN_SHELFPRTCONVERR[ATMS_SCANS];
unsigned char      QF15_SCAN_KAVPRTTEMPLIMIT[ATMS_SCANS];
unsigned char      QF16_SCAN_WGPRTTEMPLIMIT[ATMS_SCANS];
unsigned char      QF17_SCAN_KAVPRTTEMPCONSISTENCY[ATMS_SCANS];
unsigned char      QF18_SCAN_WGPRTTEMPCONSISTENCY[ATMS_SCANS];
unsigned char      QF19_SCAN_ATMSSDR[ATMS_SCANS];
unsigned char      QF20_ATMSSDR[ATMS_SCANS][ATMS_CHANS];
unsigned char      QF21_ATMSSDR[ATMS_SCANS][ATMS_CHANS];
unsigned char      QF22_ATMSSDR[ATMS_SCANS][ATMS_CHANS];

/* TDR */

unsigned short int AntennaTemperature[ATMS_SCANS][ATMS_SPOTS][ATMS_CHANS];
float              AntennaTemperatureFactors[ATMS_GRANULES*2];

/* Geolocation */

float              Latitude[ATMS_SCANS][ATMS_SPOTS];
float              Longitude[ATMS_SCANS][ATMS_SPOTS];
float              SatelliteAzimuthAngle[ATMS_SCANS][ATMS_SPOTS];
float              SatelliteZenithAngle[ATMS_SCANS][ATMS_SPOTS];
float              SolarAzimuthAngle[ATMS_SCANS][ATMS_SPOTS];
float              SolarZenithAngle[ATMS_SCANS][ATMS_SPOTS];
float              SCPosition[ATMS_SCANS][3];
unsigned char      QF1_ATMSSDRGEO[ATMS_SCANS];

/* Derived (4-byte integers) */

float              BT_real[ATMS_SCANS][ATMS_SPOTS][ATMS_CHANS];
float              AT_real[ATMS_SCANS][ATMS_SPOTS][ATMS_CHANS];
int                BeamTime_millisec[ATMS_SCANS][ATMS_SPOTS];
int                StartOrbit;
int                EndOrbit;
int                NScan;
int                granulequal[ATMS_SCANS];
int                scanqual[ATMS_SCANS];
int                chanqual[ATMS_SCANS][ATMS_CHANS];
int                geolocqual[ATMS_SCANS];
int                orbit_numbers[ATMS_SCANS];
