#define AVH_SPOTS 2048
#define AVH_SPOTS_GAC 409
#define AVH_TIE 51
#define AVH_IRCHN 3
#define AVH_VISCHN 3
#define AVH_CHANS 5
#define AVH_VISCOEFS 5   /* slope1, intercept1, slope2, intercept2, intersection */
#define AVH_VISSETS 3    /* operational, test, prelaunch */
#define AVH_IRCOEFS 3
#define AVH_IRSETS 2     /* operational, test */

char   h_siteid[4];      /* Data set creation site ID (terminated by null) */
short  h_l1bversnb;      /* level 1b format version number */
short  h_l1bversyr;      /* level 1b format version year */
short  h_l1bversdy;      /* level 1b format version day of year */
char   h_dataname[43];   /* data set name */
char   h_prblkid[9];     /* processing block identification */
short  h_satid;          /* NOAA spacecraft identification code */
short  h_instid;         /* instrument identification */
short  h_datatyp;        /* data type code */
short  h_tipsrc;         /* TIP source code */
int    h_startdatajd;    /* start of data set day count  */
short  h_startdatayr;    /* start of data set year */
short  h_startdatady;    /* start of data set day of year */
int    h_startdatatime;  /* start of data set UTC time of day in milliseconds */
int    h_enddatajd;      /* end of data set day count from 00h,1 Jan 1950 */
short  h_enddatayr;      /* end of data set year */
short  h_enddatady;      /* end of data set day of year */
int    h_enddatatime;    /* end of data set UTC time of day in milliseconds */
short  h_cpidsyr;        /* year of Last CPIDS Update */
short  h_cpidsdy;        /* Day of Year of Last CPIDS Update */
int    h_inststat1;      /* first instrument status */
unsigned short  h_statchrecnb;    /* record number of status change  */
int    h_inststat2;      /* second instrument status  */
unsigned short  h_scnlin;         /* count of scan lines in this data set */
unsigned short  h_callocscnlin;   /* count of calibrated, earth located */
unsigned short  h_misscnlin;      /* count of missing scan lines */
unsigned short  h_datagaps;       /* count of data gaps in this data set */
unsigned short  h_okdatafr;       /* count of data frames without frame  */
unsigned short  h_pacsparityerr;  /* count of PACS detected TIP parity */
unsigned short  h_auxsyncerrsum;  /* sum of all auxiliary sync errors   */
unsigned short  h_timeseqerr;     /* time sequence error */
unsigned short  h_timeseqerrcode; /* time sequence error code  */
unsigned short  h_socclockupind;  /* socc clock update indicator */
unsigned short  h_locerrind  ;    /* earth location error indicator */
unsigned short  h_locerrcode;     /* earth location error code */
unsigned short  h_pacsstatfield;  /* PACS status bit field */
unsigned short  h_pacsdatasrc;    /* PACS data source  */
unsigned short  h_racalind;       /* ramp/auto calibration indicators bit field */
unsigned short  h_solarcalyr;     /* year of most recent solar channel  calibration */
unsigned short  h_solarcaldy;     /* day of year of most recent solar channel  calibration */
unsigned short  h_pcalalgind;     /* primary calibration algorithm  identification  */
unsigned short  h_pcalalgopt;     /* primary calibration algorithm option  selected  */
unsigned short  h_scalalgind;     /* secundary calibration algorithm  identification  */
unsigned short  h_scalalgopt;     /* secundary calibration algorithm option  selected  */
short  h_irttcoef[4][6]; /*  IR Target Temperature Conversion Coefficients (4 PRTs, 6 coefs) */
int    h_albcnv[AVH_VISCHN][2];    /* albedo conversion */
int    h_radtempcnv[AVH_IRCHN][3]; /* radiance to temperature conversion */
char   h_modelid[9];
short  h_nadloctol;      /* 10 x (nadir earth location tolerance in kilometers) */
short  h_locbit;         /* earth location bit field */
short  h_rollerr;        /* 10^3 x (constant roll attitude error in degrees) */
short  h_pitcherr;       /* 10^3 x (constant pitch attitude error in degrees) */
short  h_yawerr;         /* 10^3 x (constant yaw attitude error in degrees) */
short  h_epoyr;          /* epoch year for orbit vector */
short  h_epody;          /* day of epoch year for orbit vector */
int    h_epotime;        /* Epoch UTC Time of day in milliseconds for Orbit Vector */
int    h_smaxis;         /* 10^5 x (semi-major axis in kilometers) */
int    h_eccen ;         /* 10^8 x (eccentricity) */
int    h_incli;          /* 10^5 x (inclination in degrees) */
int    h_argper;         /* 10^5 x (argument of perigee in degrees) */
int    h_rascnod;        /* 10^5 x (right ascension of the ascending  */
int    h_manom;          /* 10^5 x (mean anomaly in degrees) */
int    h_xpos;           /* 10^5 x (position vector x component in */
int    h_ypos;           /* 10^5 x (position vector y component in */
int    h_zpos;           /* 10^5 x (position vector z component in */
int    h_xvel;           /* 10^8 x (velocity vector x-dot component  */
int    h_yvel;           /* 10^8 x (velocity vector y-dot component */
int    h_zvel;           /* 10^8 x (velocity vector z-dot component  */
int    h_earthsun;       /* 10^6 x (earth/sun distance ratio in AU) */
short  h_pchtemp[5];     /* patch temperature coef */
short  h_pchtempext[5];  /* patch temperature extended coef */
short  h_pchpow[5];      /* patch power coef */
short  h_rdtemp[5];      /* radiator temperature coef */
short  h_bbtemp1[5];     /* black body temperature 1 coef */
short  h_bbtemp2[5];     /* black body temperature 2 coef */   
short  h_bbtemp3[5];     /* black body temperature 3 coef */ 
short  h_bbtemp4[5];     /* black body temperature 4 coef */
short  h_eleccur[5];     /* electronics current  coef */
short  h_motorcur[5];    /* motor current  coef */
short  h_earthpos[5];    /* earth shield position coef */
short  h_electemp[5];    /* electronics temperature  coef */
short  h_chtemp[5];      /* cooler housing  temperature coef */ 
short  h_bptemp[5];      /* baseplate temperature coef */
short  h_mhtemp[5];      /* motor housing temperature  coef */
short  h_adcontemp[5];   /* A/D converter temperature  coef */
short  h_d4bvolt[5];     /* detector #4 bias voltage  coef */
short  h_d5bvolt[5];     /* detector #5 bias voltage  coef */
short  h_bbtempchn3B[5]; /* black body temperature channel 3B coef */
short  h_bbtempchn4[5];  /* black body temperature channel 4  coef */
short  h_bbtempchn5[5];  /* black body temperature channel 5 coef */
short  h_refvolt[5];     /* reference voltage coef */

unsigned short  *scnlin;      /* scan line number */
short  *scnlinyr;    /* scan line year */
short  *scnlindy;    /* scan line day of year */
short  *clockdrift;  /* satellite clock drift delta in milliseconds */
int    *scnlintime ; /* scan line UTC time of day in milliseconds */
short  *scnlinbit;   /* scan line bit field */
int    *qualind;     /* quality indicator bit field */
int    *scnlinqual;  /* scan line quality flags  */ 
short  *calqual;     /* calibration quality flags  */
short  *cbiterr;     /* count of bit errors in frame sync */
int    *calvis;      /* Vis calibration */
int    *calir;       /* IR calibration */
int    *navstat;     /*  Navigation Status Bit Field */
int    *attangtime;  /* Time associated with TIP Euler angles(seconds) */
short  *rollang;     /* 10^3xRoll Angle in Degrees */
short  *pitchang;    /* 10^3xPitch Angle in Degrees */
short  *yawang;      /* 10^3xYaw Angle in Degrees */
short  *scalti;      /*  10 x Spacecraft Altitude (MSL) in km */  
int    *latitude;    /* latitude, deg*10000, point 25 to point 2025 every 40 points */
int    *longitude;   /* longitude, deg*10000, point 25 to point 2025 every 40 points */
short  *satzen;      /* local zenith angle, deg*100 */
short  *solzen;      /* solar zenith angle, deg*100 */
short  *relazi;      /* relative azimuth angle, deg*100 */
short  *telem;       /* telemetry data (HRPT minor frame format) */
short  *hrpt;        /* AVHRR channel counts */
short  *tipmfhd;     /* TIP minor frame header */
short  *icputel;     /* CPU-A telemetry (words TIP 46-51) and CPU-B telemetry (words TIP 96-101) */
short  *nedt;        /* NEdT for IR channels, 8 bits */
short  irscale[3];   /* a2, a1, a0 scale factor (from avh_filler2) */
