#define AVH_SPOTS 2048
#define AVH_TIE 51
#define AVH_IRCHN 3
#define AVH_VISCHN 3
#define AVH_CHANS 5

char h_site[4];       /* dataset creation site ID (terminated by null) */
char h_1bsite[4];     /* creation site for original 1B data */
int  h_versnb;        /* level 1c format version number */
int  h_satid;         /* satellite id (e.g. 14 for NOAA-14) */
int  h_instrument;    /* instrument code (1=AVHRR; 5=HIRS; 6=MSU; 10=AMSU-A; 11=AMSU-B) */
int  h_satht;         /* nominal satellite altitude, km*10 */
int  h_period;        /* nominal orbit period (seconds) */
int  h_startorbit;    /* orbit number (at start of file) */
int  h_startdatayr;   /* start of data set year */
int  h_startdatady;   /* start of data set day of the year */
int  h_startdatatime; /* start of data set UTC time of day (ms) */
int  h_endorbit;      /* orbit number (at end of file) */
int  h_enddatayr;     /* end of data set year */
int  h_enddatady;     /* end of data set day of the year */
int  h_enddatatime;   /* end of data set UTC time of day (ms) */
int  h_scnlin;        /* count of scan lines in this data set */
int  h_misscnlin;     /* count of missing scan lines */
int  h_callocscnlin;  /* count of calibrated, earth located scans */
int  h_datagaps;      /* count of data gaps */
int  h_datatyp;       /* (1 = LAC; 2 = GAC; 3 = HRPT; 4=FRAC) */
char h_infilename[69];/* input file name (allow pfs name) */
int  h_wmosatid;      /* WMO satellite id (3 for METOP-1) */
int  h_cpidsyr;       /* year of Last CPIDS Update */
int  h_cpidsdy;       /* day of Last CPIDS Update */
int  h_rollerr;       /* 10^3 x constant roll attitude error (deg) */
int  h_pitcherr;      /* 10^3 x constant pitch attitude error (deg) */
int  h_yawerr;        /* 10^3 x constant yaw attitude error (deg) */
int  h_albcnv[AVH_VISCHN][2];    /* albedo conversion */
int  h_radtempcnv[AVH_IRCHN][3]; /* radiance to temperature conversion */

int *scnlin;     /* scan line number */
int *scnlinyr;   /* scan line year */
int *scnlindy;   /* scan line day of year */
int *scnlintime; /* scan line UTC time of day in milliseconds */
int *clockdrift; /* satellite clock drift delta in milliseconds */
int *scnlinbit;  /* scan line bit field */
int *qualind;    /* quality indicator bit field */
int *scnlinqual; /* scan line quality flags */
int *calqual;    /* calibration quality flags */
int *nedt;	 /* nedt  */
int *scalti;     /* sat altitude above reference ellipsoid, km*10 */
int *latitude;   /* latitude, deg*10000, point 25 to point 2025 every 40 points */
int *longitude;  /* longitude, deg*10000, point 25 to point 2025 every 40 points */
int *satzen;     /* local zenith angle, deg*100 */
int *solzen;     /* solar zenith angle, deg*100 */
int *relazi;     /* relative azimuth angle, deg*100 */
short *btemps;   /* albedo %*100 or brightness temperatures, K*100 */
int *maskind;    /* cloud mask done =1 */
short *mask;     /* cloud mask */
short *tsurf;    /* retrieved temperature in C*100 */
