!       c_1bnav.h
!
! common for NOAA level 1b 
!
        double precision pi
        parameter ( pi = 3.14159265358979311600d0)
        double precision crd
        parameter (crd=180.d0/pi)

        integer nbpm                    ! maximum number of pixels
        parameter (nbpm=90)

        double precision yaw            ! estimated yaw error           (rad)
        double precision roll           ! estimated roll error          (rad)
        double precision pitch          ! estimated pitch error         (rad)
        double precision att(3,3)       ! attitude error

        integer first_pnav              ! first point to locate
        integer first_lnav              ! first line to locate
        integer step_pnav               ! step between two located points
        integer step_lnav               ! step between two located lines
        integer nb_pnav                 ! number of located points for the scan

        real lines(nbpm)                ! line numbers of viewed points
        real pixels(nbpm)               ! pixels numbers of viewed points
        double precision time(nbpm)     ! times of viewed points 
        double precision scnang(nbpm)   ! scanning angles of viewed points (rad)
        double precision pos(3)         ! satellite position vector     (km)
        double precision vel(3)         ! satellite inertial velocity vec (km/s)
!                                 pos and vel are in Greenwich reference frame
        double precision lat(nbpm)      ! latitudes of viewed points    (rad)
        double precision lon(nbpm)      ! longitudes of viewed points   (rad)
        double precision satzen(nbpm)   ! satellite zenith angles (rad)
        double precision satazi(nbpm)   ! satellite azimut angles (rad)
        double precision sunzen(nbpm)   ! sun zenith angles       (rad)
        double precision sunazi(nbpm)   ! sun azimut angles      (rad)

        real errclock                   ! error clock (sec)

! single precision common
        common/h1_1bnav/
     &  first_pnav, first_lnav, step_pnav, step_lnav, nb_pnav,
     &  lines,pixels,errclock

! double precision common
        common/h_1bnav/
     &  yaw,roll,pitch,att,
     &  time,scnang,pos,vel,lat,lon,satzen,satazi,sunzen,sunazi

