!       c_satpos.h
!
! common for SATPOS header
        real sp_nbdays                  ! number of days
        integer sp_bulsear              ! bulletin search criteria
        character*16  sp_satnam         ! name of the satellite
        character*80  sp_grsnam         ! Ground station name
        character*8   sp_bultyp         ! type of orbital bulletin (TBUS, ARGOS)
        character*256 sp_bulfilna       ! name of the orbital bulletin file used

        double precision sp_fstart      ! SATPOS start julian instant
        double precision sp_dt          ! time step  (sec)

       double precision sp_epoch        ! epoch time (julian days)

       double precision sp_eccent       ! eccentricity
       double precision sp_argper       ! argument of perigee   (rd)
       double precision sp_rigasc       ! right ascension       (rd)
       double precision sp_inclin       ! inclination           (rd)
       double precision sp_meanano      ! mean anomaly          (rd)
       double precision sp_semaxis      ! semi major axis       (km)

       double precision sp_x            ! x component of the position (km)
       double precision sp_y            ! y component of the position (km)
       double precision sp_z            ! z component of the position (km)
       double precision sp_vx           ! x component of the velocity (km/s)
       double precision sp_vy           ! y component of the velocity (km/s)
       double precision sp_vz           ! z component of the velocity (km/s)

       double precision sp_latstat      ! ground station geogr. latitude (rad)
       double precision sp_lonstat      ! ground station longitude       (rad)
       double precision sp_altstat      ! ground station altitude        (km)
       double precision sp_sitestat     ! ground station minimum site    (rad)

        common/h1_satpos/
     >   sp_satnam, sp_grsnam, sp_bultyp, sp_bulfilna,
     >   sp_nbdays, sp_bulsear

        common/h_satpos/
     >   sp_fstart, sp_dt, 
     >   sp_epoch, sp_eccent, sp_argper, sp_rigasc, 
     >   sp_inclin, sp_meanano, sp_semaxis,
     >   sp_x, sp_y, sp_z, sp_vx, sp_vy, sp_vz,
     >   sp_latstat, sp_lonstat, sp_altstat, sp_sitestat

! common for SATPOS data

        integer nspmax                  ! max number of data lines in SATPOS
        parameter ( nspmax = 10001)

        double precision sp_pos(3,nspmax)! Greenwich satellite position (km)
        double precision sp_vel(3,nspmax)! Greenwich satellite velocity (km)
        integer sp_orbnum(nspmax)        ! orbit number
        integer sp_satlight(nspmax)      ! satellite in daylight or nighttime
!                                          0=daylight 1=nighttime 2=penombra
        integer sp_satvis(nspmax)        ! satellite seen from the station 
!                                          0=yes  1=no

        common/d_satpos/
     >    sp_pos, sp_vel, sp_orbnum, sp_satlight, sp_satvis


! common for SATPOS data used in each position and velocity interpolation

        double precision sp_jstart      ! SAPTPOS start in julian instant
        double precision sp_dt2, sp_dt3 ! time step **2 and **3
        integer sp_nbli                 ! number of data line present in SATPOS

        common/u_satpos/
     >   sp_jstart, sp_dt2, sp_dt3, sp_nbli

