! common TBUS part IV
!
       integer tbus_orbnum              ! orbit number at epoch
       double precision tbus_tan        ! time of ascending node (day of year)
       double precision tbus_gha        ! greenwich hour angle  (rd)
       double precision tbus_anoper     ! anomalistic period    (days)
       double precision tbus_nodper     ! nodal period          (days)

       double precision tbus_epoch      ! epoch time    (julian days)

       double precision tbus_eccent     ! eccentricity
       double precision tbus_argper     ! argument of perigee   (rd)
       double precision tbus_rigasc     ! right ascension       (rd)
       double precision tbus_inclin     ! inclination           (rd)
       double precision tbus_meanano    ! mean anomaly          (rd)
       double precision tbus_semaxis    ! semi major axis       (km)

       double precision tbus_x          ! x component of the position (km)
       double precision tbus_y          ! y component of the position (km)
       double precision tbus_z          ! z component of the position (km)
       double precision tbus_vx         ! x component of the velocity (km/s)
       double precision tbus_vy         ! y component of the velocity (km/s)
       double precision tbus_vz         ! z component of the velocity (km/s)

       double precision tbus_balcoef    ! balistic coefficient  (m2/kg)
       integer tbus_dsolflux            ! daily solar flux      (10-7w/m2)
       integer tbus_msolflux            ! 90-day running mean sol flux(10-7w/m2)
       integer tbus_magind              ! planetary magnetic index (2x10-5gauss)
       double precision tbus_dragcoef   ! drag modulation coefficient
       double precision tbus_radpres    ! radiation pressure coefficient
       double precision tbus_permot     ! perigee motion                (rd/day)
       double precision tbus_rascmot    ! right ascension motion        (rd/day)
       double precision tbus_manomot    ! mean anomaly motion           (rd/day)
       
       
!       common TBUS Part IV
        common/c_tbus4/
     >   tbus_tan, tbus_gha, tbus_anoper, tbus_nodper, tbus_epoch,
     >   tbus_eccent, tbus_argper, tbus_rigasc, 
     >   tbus_inclin, tbus_meanano, tbus_semaxis,
     >   tbus_x, tbus_y, tbus_z, tbus_vx, tbus_vy, tbus_vz,
     >   tbus_balcoef, tbus_dragcoef, tbus_radpres,
     >   tbus_permot, tbus_rascmot, tbus_manomot,
     >   tbus_orbnum, tbus_dsolflux, tbus_msolflux, tbus_magind
!
