!       c_tle.h
!
       integer tle_orbnum               ! orbit number at epoch

       integer tle_satnumber            ! satellite number (TLE)
       character*1 tle_satclas          ! satellite classification
       character*8 tle_intdes           ! International designator (3 parts)


       double precision tle_epoch       ! epoch time    (julian days)
       double precision tle_epoch_tlf   ! epoch time    (TLE format)

       double precision tle_inclin      ! inclination           (rd)
       double precision tle_rigasc      ! right ascension       (rd)
       double precision tle_eccent      ! eccentricity
       double precision tle_argper      ! argument of perigee   (rd)
       double precision tle_meanano     ! mean anomaly          (rd)
       double precision tle_meanmotion  ! mean motion           (rd/mn)

       
       double precision tle_ftdmm         ! first time derivative of the mean motion (rd/mn2)
       double precision tle_stdmm       ! second time derivative of the mean motion(rd/mn3)
       double precision tle_bstar       ! BSTAR drag term

       integer tle_ephtype              ! ephemeris type
       integer tle_elemnum              ! element number
       integer tle_chksum1              ! check sum line 1
       integer tle_chksum2              ! check sum line 2

       logical tle_deep                 ! true if deep space satellite

!      common TLE orbital elements
       common/c_tle/tle_orbnum,  
     &    tle_satnumber, tle_ephtype, tle_elemnum, 
     &    tle_chksum1, tle_chksum2, tle_deep, tle_satclas, tle_intdes
!
       common/c_tle_dbl/ tle_epoch, tle_epoch_tlf, 
     &     tle_inclin, tle_rigasc, tle_eccent, tle_argper, 
     &     tle_meanano, tle_meanmotion, tle_ftdmm, 
     &     tle_stdmm, tle_bstar
