!NAME
! cavh_mem1b.h
!
!DESCRIPTION 
!   include file for avhrcl  1b data into memory
!
!    FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER  
! Marcel Derrien
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
!  1.0     09/95     initial            Marcel Derrien
!  2.0     27/11/95  new release from NOAA available 30/10/95
!  3.0     19/05/98  new release from NOAA 1B documents available May 98
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
!###########################################################################
!
!
       integer*2 scnlin(avh_mxscn)   !scan line number
       integer*2 scnlinyr(avh_mxscn) !scan line year
       integer*2 scnlindy(avh_mxscn) !scan line day of year
       integer*2 clockdrift(avh_mxscn) !satellite clock drift delta in msec.
       integer scnlintime(avh_mxscn) !scan line UTC time of day in milliseconds
       integer*2 scnlinbit(avh_mxscn)      !scan line bit field
       integer qualind(avh_mxscn)          !quality indicator bit field
       integer scnlinqual(avh_mxscn)    !scan line quality flags 
       integer*2 calqual(avh_mxirchn,avh_mxscn) !calibration quality flags 
       integer*2 cbiterr(avh_mxscn)     !count of bit errors in frame sync
       integer*4 navstat(avh_mxscn)   ! Navigation Status Bit Field
       integer*4 attangtime(avh_mxscn)
       integer*2 rollang(avh_mxscn)   !Roll Angle in Degrees
       integer*2 pitchang(avh_mxscn)  !Pitch Angle in Degrees
       integer*2 yawang(avh_mxscn)   !Yaw Angle in Degrees
       integer*2 scalti(avh_mxscn)    ! Spacecraft Altitude (MSL) in km     
       integer*2 frsync(6,avh_mxscn)
       integer*2 idavh(2,avh_mxscn)
       integer*2 timecode(4,avh_mxscn)
       integer*2 rampcal(5,avh_mxscn)
       integer*2 thcnt(3,avh_mxscn)
       integer*2 patchcnt(avh_mxscn)
       integer*2 sp1(avh_mxscn)
       integer*2 iwtcnt(3,10,avh_mxscn)
       integer*2 ispcnt(5,10,avh_mxscn)
       common/cavhmem1B/ scnlin , scnlinyr , scnlindy , 
     & scnlintime , clockdrift ,scnlinbit ,
     & qualind , scnlinqual , calqual ,
     & cbiterr  , navstat ,
     & attangtime , rollang , pitchang , yawang ,
     & scalti ,  frsync , idavh , timecode , rampcal , thcnt ,
     & patchcnt , sp1, iwtcnt , ispcnt 
       real calir(3,3,avh_mxscn) 
       common/calir1b/calir
