!NAME
! cinit.h
!
!DESCRIPTION 
!
!    FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER  
!    Tiphaine Labrot
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
!  1.0     June 95       no             T. Labrot
!  2.0     FEB 05     Updated because calcoef.dat file has been modified
!                     because NOAA18 has 5 PRTs and 6 coefs for each. T. Labrot(MF) 
!  2.1     March 05   Double precision variables first in common block. NCA.
!

      integer prtnb            !number of PRTs =4 for HIRS2 or 3, =5 for HIRS4
      integer prtwght(5)       !weight coefficients for each PRT
      integer spcntlm(19,2)    !output counts limits of space view scan
      integer iwtcntlm(19,2)   !output counts limits of iwt
      integer prtminmax(5)     !maximum value of the difference between the
!                               maximum and minimum values of PRT output counts
      double precision prtcnttmp(5,6) 
!                              !IWT PRT count to temp. conversion coefficients
      double precision cwave(19)       
!                              !19 central waves
      double precision bdcorr(19,2) 
!                              !19*2 band-correction coefficients
      double precision plck(2) !Planck constants
      double precision visibcoef(2)
!                              !calib coefficients for the visible channel



      integer sp1fv           !the first field of view in the space scan that
!                              is not contaminated.
      integer minvw           !the minimum number of space or iwt data  
!                              to compute an average
      integer stdevcf         !coefficient xx for the test +/- xx*standard
!                              deviation to eliminate some extreme output counts
      integer prtminnb        !the minimum of PRT output values to compute an 
!                              average
      integer prtbfore        !specified number of scan lines before the IWT
!                              (internal warm target) scan line
      integer prtafter        !specified number of scan lines after the IWT
!                              (internal warm target) scan line                              
      integer nbslval         !minimum number of successive scan lines with 
!                              agreed line counters 
 
      common/hrs_clcf/prtcnttmp,cwave,bdcorr,plck,visibcoef,
     &                prtwght,spcntlm,iwtcntlm,prtminmax,prtnb
      common/hrs_tstcf/sp1fv,minvw,stdevcf,prtminnb,prtbfore,
     &                 prtafter,nbslval
