#define CRIS_SPOTS 270
#define CRIS_FOR 30
#define CRIS_FOV 9
#define CRIS_CHANS 2211
/* FSR version */

char h_site[4];          /* dataset creation site ID (terminated by null) */
char h_1bsite[4];        /* creation site for original 1B data */
int  h_versnb;           /* level 1c format version number */
int  h_satid;            /* satellite id (e.g. 14 for NOAA-14) */
int  h_instrument;       /* instrument code (5=HIRS; 6=MSU; 10=AMSU-A; 11=AMSU-B) */
int  h_satht;            /* nominal satellite altitude, km*10 */
int  h_period;           /* nominal orbit period (seconds) */
int  h_startorbit;       /* orbit number (at start of file) */
int  h_startdatayr;      /* start of data set year */
int  h_startdatady;      /* start of data set day of the year */
int  h_startdatatime;    /* start of data set UTC time of day (ms) */
int  h_endorbit;         /* orbit number (at end of file) */
int  h_enddatayr;        /* end of data set year */
int  h_enddatady;        /* end of data set day of the year */
int  h_enddatatime;      /* end of data set UTC time of day (ms) */
int  h_scnlin;           /* count of scan lines in this data set */
int  h_misscnlin;        /* count of missing scan lines */
int  h_wmosatid;         /* WMO satellite id (224 for NPP) */
int  h_centre;           /* WMO id of centre */
int  h_subcentre;        /* WMO id of subcentre */
int  h_nfov;             /* Number of FOVs */
int  h_nfor;             /* Number of FORs */
int  h_nband;            /* Number of bands */
int  h_startw[3];        /* First wavenumber *1E2 */
int  h_endw[3];          /* Last wavenumber *1E2 */
int  h_startchan[3];     /* First channel in band */
int  h_endchan[3];       /* Last channel in band */
int  h_eigvn;            /* Version number of eigenvectors */
int  h_npc;              /* Number of PCs in format */
int  h_npcused;          /* Number of PCs used */
int  h_chanvn;           /* Version number of channel selection */
int  h_nchan;            /* Number of channels in format */
int  h_nchanused;        /* Number of channels used */
int  h_channels[CRIS_CHANS];   /* List of CrIS channels range */

int *scnlin;             /* scan line number */
int *scnlinyr;           /* scan line year */
int *scnlindy;           /* scan line day of year */
int *scnlintime;         /* scan line UTC time of day in milliseconds */
int *latitude;           /* latitude, deg*10000 */
int *longitude;          /* longitude, deg*10000 */
int *satzen;             /* local zenith angle, deg*100 */
int *satazi;             /* local azimuth angle, deg*100 */
int *solzen;             /* solar zenith angle, deg*100 */
int *solazi;             /* solar azimuth angle, deg*100 */
int *satxyz;             /* x,y,z of satellite at mid-scan */
int *ascdesc;            /* ascending / descending orbit qualifier */
int *orbit;              /* orbit number */
int *scalti;             /* sat altitude above reference ellipsoid, km*10 */
int *surfht;             /* surface height */
int *landfrac;           /* land fraction */
int *landsea;            /* land/sea qualifier */
int *cloudcover;         /* cloud cover (percent) */
int *cloudtopht;         /* height of top of cloud (m) */
int *radianceflgs;       /* radiance flags */
int *scanqualflgs;       /* scan quality flags */
int *calqualflgs;        /* calibration quality */
int *fovqualflgs;        /* FOV quality */
int *geolocqual;         /* Geolocation quality */
int *quality;            /* Quality information */
int *scores;             /* PC scores */
int *logfit;             /* Log Reconstruction Scores */
int *radiance;           /* radiance*1E7 */
