/* Variables to hold the CRIS SDR together with geolocation data */

/* CRIS_GRANULES is the max number of granules that we need to accommodate - 
   also defined in cris_sdr_out.F */
   
/* 16/05/2016: Enlarge the ES_Real arrays and make them single dimension,
               to accommodate FSR data */

#define CRIS_GRANULES 30
#define CRIS_SCANS_PER_GRANULE 4
#define CRIS_FORS 30
#define CRIS_FOVS 9
#define CRIS_BANDS 3
#define CRIS_CHANS_LW_MAX 717
#define CRIS_CHANS_MW_MAX 869
#define CRIS_CHANS_SW_MAX 637
#define CRIS_SCANS CRIS_SCANS_PER_GRANULE*CRIS_GRANULES
#define RMDI -9999.99
#define MDI -999999

/* SDR */

int                cris_chans_lw;
int                cris_chans_mw;
int                cris_chans_sw;
float              ES_RealLW[CRIS_SCANS*CRIS_FORS*CRIS_FOVS*CRIS_CHANS_LW_MAX];
float              ES_RealMW[CRIS_SCANS*CRIS_FORS*CRIS_FOVS*CRIS_CHANS_MW_MAX];
float              ES_RealSW[CRIS_SCANS*CRIS_FORS*CRIS_FOVS*CRIS_CHANS_SW_MAX];
long               AggregateNumberGranules;
char               Mission_Name[4];
char               N_GEO_Ref[79];
char               N_Software_Version[16];
unsigned char      QF1_SCAN_CRISSDR[CRIS_SCANS];
unsigned char      QF2_CRISSDR[CRIS_SCANS][CRIS_FORS][CRIS_BANDS];
unsigned char      QF3_CRISSDR[CRIS_SCANS][CRIS_FORS][CRIS_FOVS][CRIS_BANDS];
unsigned char      QF4_CRISSDR[CRIS_SCANS][CRIS_FORS][CRIS_FOVS][CRIS_BANDS];
unsigned long long N_Beginning_Orbit_Number;

/* Geolocation */

long long int      FORTime[CRIS_SCANS][CRIS_FORS];
float              Latitude[CRIS_SCANS][CRIS_FORS][CRIS_FOVS];
float              Longitude[CRIS_SCANS][CRIS_FORS][CRIS_FOVS];
float              SatelliteAzimuthAngle[CRIS_SCANS][CRIS_FORS][CRIS_FOVS];
float              SatelliteZenithAngle[CRIS_SCANS][CRIS_FORS][CRIS_FOVS];
float              SolarAzimuthAngle[CRIS_SCANS][CRIS_FORS][CRIS_FOVS];
float              SolarZenithAngle[CRIS_SCANS][CRIS_FORS][CRIS_FOVS];
float              SCPosition[CRIS_SCANS][3];
float              SCVelocity[CRIS_SCANS][3];
float              Height[CRIS_SCANS][CRIS_FORS][CRIS_FOVS];
unsigned char      QF1_CRISSDRGEO[CRIS_SCANS];
char               AggregateBeginningDate[9];
char               AggregateBeginningTime[15];
unsigned long long AggregateBeginningOrbitNumber;
char               AggregateEndingDate[9];
char               AggregateEndingTime[15];
unsigned long long AggregateEndingOrbitNumber;

/* Derived (4-byte integers) */

int                FORTime_millisec[CRIS_SCANS][CRIS_FORS];
int                StartOrbit;
int                EndOrbit;
int                NScan;
int                geolocqual[CRIS_SCANS];
int                scanqual[CRIS_SCANS];
int                calqual[CRIS_SCANS][CRIS_FOVS][CRIS_BANDS];
int                fovqual[CRIS_SCANS][CRIS_FORS][CRIS_FOVS][CRIS_BANDS];
int                orbit_numbers[CRIS_SCANS];
char               CApod[20];
