!------------------------------------------------------------------------------
!NAME
!  hcaliblineinfo_algoV4.h
!
!  Include to process with program hirscl_algoV4
!
!HISTORY (CHANGES) 
!(version   date         comment           <author>)
! 1.0     January 05     creation          T. Labrot (MF)
!
!CURRENT CODE OWNER: SAF NWP
!
!COPYRIGHT
!    This software was developed within the context of
!    the EUMETSAT Satellite Application Facility on
!    Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 25 November 1998, between
!    EUMETSAT and the Met Office, UK, by one or more partners
!    within the NWP SAF. The partners in the NWP SAF are
!    the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2005, EUMETSAT, All Rights Reserved.
!
!------------------------------------------------------------------------------
      INTEGER lin0            ! first scan line with usable data
      INTEGER lin1            ! last scan line with usable data
                              ! (computed in h_instrtest_algoV4.F)
                              
      INTEGER linequality(10,hrs_mxlin) 
                              ! quality array for each scan line to update
                              ! quality flags in the HIRS level 1b
                              ! 1: scan line no usable because the instrument
                              !    status is OFF
                              ! 2: scan line no usable because the bit 31 (do not
                              !    use scan for product generation) is ON
                              ! 3: insufficient data for calibration
                              ! 4: scan was not calibrated
                              ! 5: scan contains marginal calibration in some 
                              !    of the IR channels
                              ! 6: PRT quality test failed
                              ! 7: PRT data marginal, some readings were rejected
                              ! 8: scan contains some uncalibrated channels
                              ! 9: scan indicates that the normal HIRS calibration 
                              !    sequence is disabled 
                              ! 10: space view scan is lunar contaminated
       INTEGER linechquality(6,hrs_mxchn,hrs_mxlin)                       
                              ! 1: calibration failed
                              ! 2: calibration marginal
                              ! 3: calibration slope came from the HCF
                              ! 4: BB views failed NEDC test
                              ! 5: space views failed NEDC test
                              ! 6: some QC (quality control) tests could not be 
                              !    applied                

      COMMON/lines/lin0,lin1
      COMMON/lquality/linequality,linechquality
