!------------------------------------------------------------------------------
!NAME
!  hclin_algoV4.h
!  
!  Include to process with program hirscl_algoV4
!
!HISTORY (CHANGES) 
!(version   date         comment           <author>)
! 1.0     January 05     creation          T. Labrot (MF)
!
!CURRENT CODE OWNER: SAF NWP
!
!COPYRIGHT
!    This software was developed within the context of
!    the EUMETSAT Satellite Application Facility on
!    Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 25 November 1998, between
!    EUMETSAT and the Met Office, UK, by one or more partners
!    within the NWP SAF. The partners in the NWP SAF are
!    the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2005, EUMETSAT, All Rights Reserved.
!
!------------------------------------------------------------------------------

      INTEGER hrs_lflg     !Switch=1 for HIRS navigation localisation (0 if not for)
      INTEGER hrs_cflg     !Switch=1 for HIRS calibration (0 if not for)
      INTEGER hrs_ttflg    !Switch=1 for HIRS calibration with a correction 
!                          !of the intercept using the telescope temperature    
      INTEGER hrs_coefu    !logical unit for HIRS calibration coefficients file
      INTEGER hrs_tstcoefu 
!                   logical unit for HIRS calibration/test coefficients file      
      INTEGER hrs_b1aslopu !logical unit for the b1/average slope file 
      INTEGER hrs_cllgu    !logical unit for HIRS log/debug file
      INTEGER hrs_histou   !logical unit for calib historic file
      INTEGER hrs_l1bu     !logical unit HIRS level1b file
      INTEGER satposu      !logical unit for SATPOS file
      INTEGER ckdriftu     !logical unit for the clock drift data file

      INTEGER iprint    !print option in the log.file
!                         = 0, nothing is printed
!                        >= 1, statements indicating entering and exiting 
!                              routines and few informations are printed
!                        >= 2, computed values  and few values read from files
!                              that would help in debugging are printed

      COMMON/hrs_unit/hrs_coefu,hrs_tstcoefu,hrs_b1aslopu,hrs_cllgu,
     &                hrs_histou,hrs_l1bu,satposu,ckdriftu  
 
      COMMON/hrs_flags/hrs_lflg,hrs_cflg,hrs_ttflg

      COMMON/hrs_print/iprint
