/* Variables to hold the HIRAS SDR together with geolocation data */

/* HIRAS_GRANULES is the max number of granules that we need to accommodate - 
   also defined in hiras_sdr_out.F. Assume 5-minute granules, 10s scan period */
   
#define HIRAS_GRANULES 4
#define HIRAS_SCANS_PER_GRANULE 30
#define HIRAS_FORS 29
#define HIRAS_FOVS 4
#define HIRAS_BANDS 3
#define HIRAS_TOTAL_STEPS 40
#define HIRAS_CHANS_LW_MAX 781
#define HIRAS_CHANS_MW1_MAX 869
#define HIRAS_CHANS_MW2_MAX 637
#define HIRAS_SCANS HIRAS_SCANS_PER_GRANULE*HIRAS_GRANULES
#define RMDI -9999.99
#define MDI -999999

/* Variables */

int          Count_scnlines;
int          Orbit_Number;
int          Orbit_Period;      /* minutes */

int          hiras_chans_lw;
int          hiras_chans_mw1;
int          hiras_chans_mw2;
float        ES_RealLW[HIRAS_SCANS*HIRAS_FORS*HIRAS_FOVS*HIRAS_CHANS_LW_MAX];
float        ES_RealMW1[HIRAS_SCANS*HIRAS_FORS*HIRAS_FOVS*HIRAS_CHANS_MW1_MAX];
float        ES_RealMW2[HIRAS_SCANS*HIRAS_FORS*HIRAS_FOVS*HIRAS_CHANS_MW2_MAX];

short int    Daycnt[HIRAS_SCANS][HIRAS_TOTAL_STEPS];
int          Mscnt[HIRAS_SCANS][HIRAS_TOTAL_STEPS];
float        Latitude[HIRAS_SCANS][HIRAS_FORS][HIRAS_FOVS];
float        Longitude[HIRAS_SCANS][HIRAS_FORS][HIRAS_FOVS];
short int    SensorAzimuth[HIRAS_SCANS][HIRAS_FORS][HIRAS_FOVS];
short int    SensorZenith[HIRAS_SCANS][HIRAS_FORS][HIRAS_FOVS];
short int    SolarAzimuth[HIRAS_SCANS][HIRAS_FORS][HIRAS_FOVS];
short int    SolarZenith[HIRAS_SCANS][HIRAS_FORS][HIRAS_FOVS];
short int    LandSeaMask[HIRAS_SCANS][HIRAS_FORS][HIRAS_FOVS];
short int    Land_Cover[HIRAS_SCANS][HIRAS_FORS][HIRAS_FOVS];
short int    Height[HIRAS_SCANS][HIRAS_FORS][HIRAS_FOVS];    /* Earth Topography */

short int    QA_Score[HIRAS_SCANS];
short int    QA_flag_Process[HIRAS_SCANS];
int          QA_flag_Scnline[HIRAS_SCANS][HIRAS_TOTAL_STEPS];

char         Beginning_Date[11];     /* e.g. "2010-11-30" */
char         Beginning_Time[13];     /* e.g. "04:00:28.000" */
char         Ending_Date[11];
char         Ending_Time[13];
char         Satellite_Name[6];      /* e.g. "FY-3C" */

char         CApod[20];
