#define HIRS_SPOTS 56
#define HIRS_CHANS 20

char h_site[4];       /* dataset creation site ID (terminated by null) */
char h_1bsite[4];     /* creation site for original 1B data */
int  h_versnb;        /* level 1c format version number */
int  h_satid;         /* satellite id (e.g. 14 for NOAA-14) */
int  h_instrument;    /* instrument code (5=HIRS; 6=MSU; 10=AMSU-A; 11=AMSU-B) */
int  h_satht;         /* nominal satellite altitude, km*10 */
int  h_period;        /* nominal orbit period (seconds) */
int  h_startorbit;    /* orbit number (at start of file) */
int  h_startdatayr;   /* start of data set year */
int  h_startdatady;   /* start of data set day of the year */
int  h_startdatatime; /* start of data set UTC time of day (ms) */
int  h_endorbit;      /* orbit number (at end of file) */
int  h_enddatayr;     /* end of data set year */
int  h_enddatady;     /* end of data set day of the year */
int  h_enddatatime;   /* end of data set UTC time of day (ms) */
int  h_scnlin;        /* count of scan lines in this data set */
int  h_misscnlin;     /* count of missing scan lines */
int  h_tempradcnv[HIRS_CHANS-1][3]; /* Wavenumber, const1, const2 for IR channels */
int  h_20solfiltirrad; /* ch20 solar filtered irradiance, W/m2 */
int  h_20equifiltwidth; /* ch20 equivalent filter width cm^-1 */
int  h_wmosatid;     /* WMO satellite id (3 for METOP-1) */
int  h_coldnedt[HIRS_CHANS];     /* Cold NEDT in mK at reference temp */
int  h_warmnedt[HIRS_CHANS];     /* Warm NEDT in mK at reference temp */

int *scnlin;     /* scan line number */
int *scnlinyr;   /* scan line year */
int *scnlindy;   /* scan line day of year */
int *scnlintime; /* scan line UTC time of day in milliseconds */
int *mjfrcnt;    /* major frame count */
int *qualind;    /* quality indicator bit field */
int *scanqual;   /* scan line quality flags */
int *chanqual;   /* quality flag for each channel */
int *instrtemp;  /* HIRS baseplate temperature */
int *latitude;   /* latitude, deg*10000 */
int *longitude;  /* longitude, deg*10000 */
int *satzen;     /* local zenith angle, deg*100 */
int *satazi;     /* local azimuth angle, deg*100 */
int *solzen;     /* solar zenith angle, deg*100 */
int *solazi;     /* solar azimuth angle, deg*100 */
int *scalti;     /* sat altitude above reference ellipsoid, km*10 */
int *btemps;     /* brightness temperatures, K*100 */
int *dataqual;   /* quality control word for the data in each field of view */
int *coldnedt;   /* Cold NEDT (mK) */
int *warmnedt;   /* Warm NEDT (mK) */
