!NAME
! hstatist.h
!
!DESCRIPTION 
!    include file for statistics of HIRS calibration
!
!    FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER  
!    Tiphaine Labrot
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
!  1.0     dec.95       no             T. Labrot
!  1.1     may 96     prtejecstat now is defined in real and not in integer (TL)
!  1.2     March 04  full orbit parametrisation P. Brunel
!  1.3     April 05  use dimension hrs_mxprtnb instead of "4". N.Atkinson
!

      integer calib

      double precision calibcoefmn(20,3),calibcoefstd(20,3)
!                       array of intercept,slope,third coef means 
!                       array of intercept,slope,third coef standard deviations 

      integer prtgoodsum(hrs_mxprtnb)
      integer prtejecsum(hrs_mxprtnb)
      integer prtstatcnt(hrs_mxprtnb)
      real prtejecstat(hrs_mxprtnb)
      double precision prtmnsum(hrs_mxprtnb)
      double precision prtstdsum(hrs_mxprtnb)
      double precision prtmnstat(hrs_mxprtnb)
      double precision prtstdstat(hrs_mxprtnb)

      integer spgoodcnt(19,hrs_mxcalib)
      integer spinfcnt(19,hrs_mxcalib)
      integer spsupcnt(19,hrs_mxcalib)
      integer spmisscnt(19,hrs_mxcalib)
      integer spejeccnt(19,hrs_mxcalib)   
      double precision spcntmn(19,hrs_mxcalib)  
      double precision spcntstd(19,hrs_mxcalib) 

      real spmisstat(19)
      real spinfstat(19)
      real spsupstat(19)
      real spejecstat(19)
      double precision spmnstat(19)
      double precision spstdstat(19)

      integer iwtgoodcnt(19,hrs_mxcalib)
      integer iwtinfcnt(19,hrs_mxcalib)
      integer iwtsupcnt(19,hrs_mxcalib)
      integer iwtmisscnt(19,hrs_mxcalib)
      integer iwtejeccnt(19,hrs_mxcalib)   
      double precision iwtcntmn(19,hrs_mxcalib)  
      double precision iwtcntstd(19,hrs_mxcalib)

      real iwtmisstat(19)
      real iwtinfstat(19)
      real iwtsupstat(19)
      real iwtejecstat(19)
      double precision iwtmnstat(19)
      double precision iwtstdstat(19)


      common/calibnb/calib 

      common/calibcoefstat/calibcoefmn,calibcoefstd

      common/prtstat/prtmnsum,prtstdsum,prtgoodsum,prtejecsum,prtstatcnt

      common/prtfinstat/prtmnstat,prtstdstat,prtejecstat


      common/spstat/spcntmn,spcntstd,spgoodcnt,spinfcnt,
     &              spsupcnt,spmisscnt,spejeccnt

      common/spfinstat/spmnstat,spstdstat,spmisstat,spinfstat,
     &                 spsupstat,spejecstat


      common/iwtstat/iwtcntmn,iwtcntstd,iwtgoodcnt,iwtinfcnt,
     &               iwtsupcnt,iwtmisscnt,iwtejeccnt

      common/iwtfinstat/iwtmnstat,iwtstdstat,iwtmisstat,iwtinfstat,
     &                 iwtsupstat,iwtejecstat
