#define IASI_SPOTS 120
#define IASI_FOR 30
#define IASI_FOV 4
#define IASI_CHANS 8461
#define AVHRR_CHANS 6
#define AVHRR_CLASS 7

char h_site[4];          /* dataset creation site ID (terminated by null) */
char h_1bsite[4];        /* creation site for original 1B data */
int  h_versnb;           /* level 1c format version number */
int  h_satid;            /* satellite id (e.g. 14 for NOAA-14) */
int  h_instrument;       /* instrument code (5=HIRS; 6=MSU; 10=AMSU-A; 11=AMSU-B) */
int  h_satht;            /* nominal satellite altitude, km*10 */
int  h_period;           /* nominal orbit period (seconds) */
int  h_startorbit;       /* orbit number (at start of file) */
int  h_startdatayr;      /* start of data set year */
int  h_startdatady;      /* start of data set day of the year */
int  h_startdatatime;    /* start of data set UTC time of day (ms) */
int  h_endorbit;         /* orbit number (at end of file) */
int  h_enddatayr;        /* end of data set year */
int  h_enddatady;        /* end of data set day of the year */
int  h_enddatatime;      /* end of data set UTC time of day (ms) */
int  h_scnlin;           /* count of scan lines in this data set */
int  h_misscnlin;        /* count of missing scan lines */
int  h_wmosatid;         /* WMO satellite id (3 for METOP-1) */
int  h_startchan[10];    /* Start channel */
int  h_endchan[10];      /* End channel */
int  h_scalefactor[10];  /* Scale factor: radiance = scalrad*10^(-scalefactor) */

int *scnlin;             /* scan line number */
int *granule;            /* granule number */
int *scnlinyr;           /* scan line year */
int *scnlindy;           /* scan line day of year */
int *scnlintime;         /* scan line UTC time of day in milliseconds */
int *GQisFlagQual;       /* combines GQisFlagQual and GQisFlagQualDetailed */
int *GQisQualIndex;      /* NEDT estimated/expected */
int *GQisQualIndexLoc;   /* IIS/AVHRR co-registration uncertainty */
int *GQisQualIndexRad;   /* NEDT estimated/expected radiometric */
int *GQisQualIndexSpect; /* NEDT estimated/expected spectral */
int *GQisSysTecSondQual; /* System - TEC quality index for sounder */
int *latitude;           /* latitude, deg*10000 */
int *longitude;          /* longitude, deg*10000 */
int *satzen;             /* local zenith angle, deg*100 */
int *satazi;             /* local azimuth angle, deg*100 */
int *solzen;             /* solar zenith angle, deg*100 */
int *solazi;             /* solar azimuth angle, deg*100 */
int *scalti;             /* sat altitude above reference ellipsoid, km*10 */
short *scalrad;          /* scaled radiance (16 bit) */
int *avhcombination;     /* AVHRR channel combination */
int *avhrrmean;          /* Mean radiance for 6 channels, 7 classes */
short *avhmeanscalefactor; /* Scale factor */
int *avhrrsdev;          /* Std dev radiance for 6 channels, 7 classes */
short *avhsdevscalefactor; /* Scale factor */
int *avhrrfrac;          /* 10^6 x Fraction in each class */
int *avhrrCGy;           /* 10^6 x Z angular position of centre of gravity */
int *avhrrCGz;           /* 10^6 x Y angular position of centre of gravity */
int *GIacVarImagIIS;     /* 10^6 x Variance of IIS image W/(m^2 sr m^-1) */
int *GIacAvgImagIIS;     /* 10^6 x Average of IIS image W/(m^2 sr m^-1) */
int *GEUMAvhrr1BCldFrac; /* Cloud fraction */
int *GEUMAvhrr1BLandFrac;/* Land fraction */
int *GEUMAvhrr1BQual;    /* Bits 0-6: % snow/ice, or number of bad AVHRR pixels, Bit 7: 0 if AVHRR is OK */
