#define IASI_FOR 30
#define IASI_CHANS 8461
#define MAP_CHANS 20
#define AVHRR_CHANS 6
#define AVHRR_CLASS 7

char h_site[4];          /* dataset creation site ID (terminated by null) */
char h_1bsite[4];        /* creation site for original 1B data */
int  h_versnb;           /* level 1c format version number */
int  h_satid;            /* satellite id (e.g. 14 for NOAA-14) */
int  h_grid;             /* grid code (5=HIRS; 6=MSU; 10=AMSU-A; 11=AMSU-B; 12=MHS; 13=IASI) */
int  h_satht;            /* nominal satellite altitude, km*10 */
int  h_period;           /* nominal orbit period (seconds) */
int  h_startorbit;       /* orbit number (at start of file) */
int  h_startdatayr;      /* start of data set year */
int  h_startdatady;      /* start of data set day of the year */
int  h_startdatatime;    /* start of data set UTC time of day (ms) */
int  h_endorbit;         /* orbit number (at end of file) */
int  h_enddatayr;        /* end of data set year */
int  h_enddatady;        /* end of data set day of the year */
int  h_enddatatime;      /* end of data set UTC time of day (ms) */
int  h_scnlin;           /* count of scan lines in this data set */
int  h_misscnlin;        /* count of missing scan lines */
int  h_atovppvn;         /* atovpp version number */
int  h_instruments;      /* instruments (bit0=HIRS, bit1=MSU, bit3=AMSU-A, bit4=AMSU-B, bit5=AVHRR, bit 6=IASI) */
int  h_wmosatid;         /* WMO satellite id (3 for METOP-1) */
int  h_startchan[10];    /* Start channel */
int  h_endchan[10];      /* End channel */
int  h_scalefactor[10];  /* Scale factor: radiance = scalrad*10^(-scalefactor) */
int  h_eigvn;            /* Version number of eigenvectors */
int  h_npc;              /* Number of PCs in 1d format */
int  h_npcused;          /* Number of PCs used */
int  h_chanvn;           /* Version number of channel selection */
int  h_nchan;            /* Number of channels in 1d format */
int  h_nchanused;        /* Number of channels used */
int  h_channels[IASI_CHANS];       /* List of IASI channels */
int  h_amsPlanck[MAP_CHANS][3];    /* Wavenumber, const1, const2 for AMSU */
int  h_dT;               /* size of data batches processed within ATOVPP (seconds) */
int  h_mapBTmode;        /* 1=nearest neighbour, 2=bilinear interpolation, 3=spatial averaging */
int  h_Acorrvn;          /* vn no AMSU-A limb/emiss correction */
int  h_Apcpvn;           /* vn no AMSU-A precip/scatter detection */
int  h_Aantenna;         /* vn no, AMSU-A antenna corrections */
int  h_Bcorrvn;          /* vn no MHS limb/emiss correction */
int  h_Bpcpvn;           /* vn no MHS precip/scatter detection */
int  h_Bantenna;         /* vn no, MHS antenna corrections */
int  h_Ascat;            /* threshold value for AMSU-A scattering index */
int  h_ACrosby;          /* threshold value for AMSU-A logistic precip */
int  h_AB89;             /* threshold value for AMSU-A/B 89GHz differences */
int  h_cloudtests;       /* Cloud tests used (0 if none) */
int  h_recperscan;       /* Records per scan: 1 or 4 */
int  h_fovmode;          /* 0 = full resolution; 1 to 4 = fixed detector; 5+ = other methods */

int *scnlin;             /* scan line number */
int *scnlinyr;           /* scan line year */
int *scnlindy;           /* scan line day of year */
int *scnlintime;         /* scan line UTC time of day in milliseconds */
int *instrtempa1;        /* instrument temperature AMSU-A1 */
int *instrtempa2;        /* instrument temperature AMSU-A2 */
int *instrtempb;         /* instrument temperature MHS */
int *latitude;           /* latitude, deg*10000 */
int *longitude;          /* longitude, deg*10000 */
int *surfheight;         /* surface height, metres */
int *surftype;           /* 0=sea, 1=mixed, 2=land */
int *satzen;             /* local zenith angle, deg*100 */
int *satazi;             /* local azimuth angle, deg*100 */
int *solzen;             /* solar zenith angle, deg*100 */
int *solazi;             /* solar azimuth angle, deg*100 */
int *scalti;             /* sat altitude above reference ellipsoid, km*10 */
int *btemps;             /* AMSU+MHS BTs */
int *iasiqual;           /* quality flag for each spot */
int *prepro;             /* values from pre-processing */
int *emiss;              /* 13 emissivity parameters */
int *GQisFlagQual;       /* combines GQisFlagQual and GQisFlagQualDetailed */
int *GQisQualIndex;      /* NEDT estimated/expected */
int *GQisQualIndexLoc;   /* IIS/AVHRR co-registration uncertainty */
int *GQisQualIndexRad;   /* NEDT estimated/expected radiometric */
int *GQisQualIndexSpect; /* NEDT estimated/expected spectral */
int *GQisSysTecSondQual; /* System - TEC quality index for sounder */
short *scalrad;          /* scaled radiance (16 bit) */
int *scores;             /* PC scores */
int *logfit;             /* Reconstruction Scores for 3 bands */
int *FOV;                /* 30 values in range 1 to 120 */
int *avhcombination;     /* AVHRR channel combination */
int *avhrrmean;          /* Mean radiance for 6 channels, 7 classes */
short *avhmeanscalefactor; /* Scale factor */
int *avhrrsdev;          /* Std dev radiance for 6 channels, 7 classes */
short *avhsdevscalefactor; /* Scale factor */
int *avhrrfrac;          /* 10^6 x Fraction in each class */
int *avhrrCGy;           /* 10^6 x Z angular position of centre of gravity */
int *avhrrCGz;           /* 10^6 x Y angular position of centre of gravity */
int *cloudflag;          /* Cloud flag */
