!+ MSU Data Variables for processing within ATOVIN
!
! Name:  inmstore.h
!
! Purpose:
!   'INCLUDE' file for COMMON / inmstore /
!   containing MSU data for use within ATOVIN code.
!
! Current Code Owner: R.J.Renshaw
!
! History:
! Version    Date     Comment
!
!  1.0     19/3/96  Original code. (R.J.Renshaw)
!
! Code Description:
!   FORTRAN 77, following AAPP standards
!#########################################################################
! COPYRIGHT        THE CONTENTS OF THIS FILE ARE CROWN COPYRIGHT. THE
!                  SOFTWARE, DATA AND OTHER PROPRIETARY INFORMATION
!                  CONTAINED THEREIN IS SUPPLIED FOR BONAFIDE RESEARCH
!                  PURPOSES. COMMERCIAL OR BUSINESS USE IS NOT PERMITTED
!                  WITHOUT THE WRITTEN AUTHORITY OF THE U.K. MET. OFFICE.
!#########################################################################
!
! Declarations:
!
      REAL          Mcalib(2,3,Mnchan)     ! calibration coefficients:
                                           !   primary & secondary,
                                           !   2nd,1st,0th coefficients,
                                           !   for each channel.
      REAL          Mnonlin(3,Mnchan)      ! non-linearity coefficients:
                                           !   2nd,1st,0th coefficients,
                                           !   for counts in each channel.
      INTEGER       Mcounts(Mnchan,Mnfovs) ! instrument counts for each chan,
                                           ! for each field of view
      REAL          MPlanck(4,Mnchan)      ! 'inverse Planck function'
!                   temperature-radiance conversion
!                   order of channels = 1,2,3,4,...,18,19
!                   for channels 1 to 19 :
!                      (1,*) First radiation constant * (central wavenumber)^3
!                      (2,*) Second radiation constant * central wavenumber
!                      (3,*) bandwidth correction coefficient 'a'
!                      (4,*) bandwidth correction coefficient 'b'
!                            such that T* = a + bT  where radiance=B(T)

      COMMON / inmstore / Mcalib, Mnonlin, Mcounts, MPlanck
