#define IRAS_SPOTS 56
#define IRAS_CHANS 26
#define IRAS_MAPCHANS 28

char h_site[4];       /* dataset creation site ID (terminated by null) */
char h_1bsite[4];     /* creation site for original 1B data */
int  h_versnb;        /* level 1c format version number */
int  h_satid;         /* satellite id (e.g. 14 for NOAA-14) */
int  h_instrument;    /* instrument code (18=MWTS2, 19=MWHS2) */
int  h_satht;         /* nominal satellite altitude, km*10 */
int  h_period;        /* nominal orbit period (seconds) */
int  h_startorbit;    /* orbit number (at start of file) */
int  h_startdatayr;   /* start of data set year */
int  h_startdatady;   /* start of data set day of the year */
int  h_startdatatime; /* start of data set UTC time of day (ms) */
int  h_endorbit;      /* orbit number (at end of file) */
int  h_enddatayr;     /* end of data set year */
int  h_enddatady;     /* end of data set day of the year */
int  h_enddatatime;   /* end of data set UTC time of day (ms) */
int  h_scnlin;        /* count of scan lines in this data set */
int  h_misscnlin;     /* count of missing scan lines */
int  h_tempradcnv[IRAS_CHANS][3]; /* Wavenumber, const1, const2 */
int  h_wmosatid;      /* WMO satellite id (522=FY-3C) */
int  h_bandwidth[IRAS_CHANS]; /* GHz*1E6 */
int  h_nchan;         /* number of MWHS channels in format */
int  h_nmapchan;      /* number of mapped channels in format */
int  h_nmapchanused_mwts;  /* number of MWTS channels used */
int  h_nmapchanused_mwhs;  /* number of MWHS channels used */

int *scnlin;     /* scan line number */
int *scnlinyr;   /* scan line year */
int *scnlindy;   /* scan line day of year */
int *scnlintime; /* scan line UTC time of day in milliseconds */
int *geo_qc;     /* quality indicators */
int *scnlin_qc;
int *cal_qc;
int *pixel_qc;
int *instrtemp;  /* instrument temperatures, K*100 */
int *latitude;   /* latitude, deg*10000 */
int *longitude;  /* longitude, deg*10000 */
int *satzen;     /* local zenith angle, deg*100 */
int *satazi;     /* local azimuth angle, deg*100 */
int *solzen;     /* solar zenith angle, deg*100 */
int *solazi;     /* solar azimuth angle, deg*100 */
int *scalti;     /* sat altitude above reference ellipsoid, km*10 */
int *satposition;/* x,y,z in metres */
int *satvelocity;/* vx,vy,vz in m/s */
int *orbitangle; /* angle round orbit relative to solar plane, in deg*100 */
int *btemps;     /* brightness temperatures, K*100 */
int *btmap;      /* mapped brightness temperatures, K*100 */
int *dataqual;   /* quality control word for the data in each field of view */
