/* Variables to hold the IRAS SDR */

/* IRAS_SCANS is the max number of scans that we need to accommodate (1 orbit) */

#define IRAS_SPOTS 56
#define IRAS_CHANS 26
#define IRAS_SCANS 1300
#define RMDI -9999.99
#define MDI -999999

/* Variables */

int          Count_scnlines;
int          Orbit_Number;
int          Orbit_Period;      /* minutes */

float        Earth_Obs_BT[IRAS_CHANS*IRAS_SCANS*IRAS_SPOTS];
float        Latitude[IRAS_SCANS][IRAS_SPOTS];
float        Longitude[IRAS_SCANS][IRAS_SPOTS];
short int    SensorZenith[IRAS_SCANS][IRAS_SPOTS];     /* deg *100 */
short int    SensorAzimuth[IRAS_SCANS][IRAS_SPOTS];
short int    SolarZenith[IRAS_SCANS][IRAS_SPOTS];
short int    SolarAzimuth[IRAS_SCANS][IRAS_SPOTS];
short int    Height[IRAS_SCANS][IRAS_SPOTS];           /* metres */
short int    LandSeaMask[IRAS_SCANS][IRAS_SPOTS];
short int    geo_qc[IRAS_SCANS];
int          scnlin_qc[IRAS_SCANS];
int          cal_qc[IRAS_SCANS];
int          pixel_qc[IRAS_SCANS][IRAS_SPOTS];
int          Scan_Time[IRAS_SCANS];       /* milliseconds */
int          Scan_Day[IRAS_SCANS];        /* days since 01/01/2000, 12:00 */
float        EVS_orb_pos[IRAS_SCANS][3];               /* metres */

float        Ave_Instr_Temp[9];
float        Central_Wn[IRAS_CHANS];

char         Beginning_Date[11];     /* e.g. "2010-11-30" */
char         Beginning_Time[13];     /* e.g. "04:00:28.000" */
char         Ending_Date[11];
char         Ending_Time[13];
char         Satellite_Name[6];      /* e.g. "FY-3A" */
char         Orbit_string[6];
