!
!###########################################################################
!                                                                          !
!                      MHS CALIBRATION PARAMETERS                          !
!                                                                          !
!###########################################################################
!
! mhs_cinit.h
      integer nscan 
      parameter (nscan=7)         ! number of scans to avg cal samples over
      real c,plck(2)              ! speed of light and Planck constants
      real tspace                 ! br temp of space at AMSU frequencies
!--------------------------------------------------------------------------      
      integer modid               ! instrument id
      real freq(5)                ! centre frequencies in wavenumbers
      real a(5),b(5)              ! band correction factors
      integer nscan2              ! half no. of scans to avg cal samples over
      integer nview,spview        ! no. of space views and preferred view
      real refres(6)              ! reference resistance values (3 per PIE)
      real prtrestmp(4,10)        ! prt resistance to temp conversion coefs
      real prtwght(10)            ! individual PRT weights
      real thermcnttmp(5)         ! thermistor coefs, counts to temperature
      real intcorr(5,3)           ! internal target corrn degK
      real spcorr(5,4)            ! space view corrn degK
      integer intcntmin(5),intcntmax(5) ! internal target max/min counts
      integer spcntmin(5),spcntmax(5) ! space view max/min counts
      integer dcount(5)       ! max change in counts
      integer ngap            ! max no. of lines before resetting last value
      real ant_coef           ! conv coef for antenna position
      real pos_errc,pos_erre  !  max posn error for cal & earth views
      real prtmin,prtmax,prtdt ! min,max & max change in PRT values allowed
      integer nprtmin          ! min number of PRTs to define target temp
      integer nprtgap          ! no. of scan lines to fill in PRT data
      real reftemp(6)          ! min, nominal and max instr temps (2 sensors)
      real nonlin(10,3)        ! non-linearity correction factors (for 2 LOs)
      real scanpos(8,4)        ! nominal calib viewing angles
      real curr_coef(2,6)      ! current sensors (2 coefs per sensor)
      real survival_coef(6)    ! coefs for survival sensors (same coefs for all)
      real moonthresh          ! angular threshold for moon (degrees)
      real moon_azcorr         ! Correction (deg) for optimising moon algorithm
      real moon_elevcorr       ! Correction (deg)
!---------------------------------------------------------------------------      
      real u0(5,3),u1(5,3),u2(5,3) ! default calib coefs for min,norm & max T
!
      common/mhs_clcoef/c,plck,tspace,modid,freq,a,b,nscan2,nview,
     & spview,refres,prtrestmp,prtwght,reftemp,thermcnttmp,intcorr,
     & spcorr,intcntmin,intcntmax,
     & spcntmin,spcntmax,dcount,ngap,ant_coef,pos_errc,pos_erre,
     & prtmin,prtmax,prtdt,nprtmin,nprtgap,nonlin,scanpos,
     & curr_coef,survival_coef,moonthresh
      common/mhs_tstcf/u0,u1,u2
