!NAME
! mstat.h
!
!DESCRIPTION 
!    include file for statistics of HIRS calibration
!
!    FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER  
!    Tiphaine Labrot
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
!  1.0     Dec.95       no              T. Labrot
!
      integer prtid     !determine if prt1a,prt2a,prt1b,prt2b
      integer prt       !one prt data
      integer txcallo   !low  calib. reference point for electronic syst. X
      integer txcalhi   !high calib. reference point for electronic syst. X
      integer infloflg  !flag=1 if txcallo inferior to the reference value
                        !    =0 if not inferior 
      integer suploflg  !flag=1 if txcallo superior to the reference value
                        !    =0 if not superior  
      integer infhiflg,suphiflg  !cf to txcallo but for txcalhi  
      integer zeroflg   !flag=1 if txcallo=txcalhi (=0 if not)
      integer misprtflg !flag=1  if the prt data is missing
      integer flg
      
      double precision talosum
      double precision talodevsum
      double precision tahisum
      double precision tahidevsum
      integer gtalonb,gtahinb
      integer inftalonb,inftahinb
      integer suptalonb,suptahinb
      integer talohinb
      
      double precision tblosum
      double precision tblodevsum
      double precision tbhisum
      double precision tbhidevsum
      integer gtblonb,gtbhinb
      integer inftblonb,inftbhinb
      integer suptblonb,suptbhinb
      integer tblohinb 
      
      double precision prt1asum,prt1bsum,prt2asum,prt2bsum
      double precision prt1adevsum,prt1bdevsum,prt2adevsum,prt2bdevsum
      integer gprt1anb,gprt1bnb,gprt2anb,gprt2bnb    
      integer misprt1anb,misprt1bnb,misprt2anb,misprt2bnb 
      
      double precision talomn,talodev,tahimn,tahidev
      integer talonb,tahinb   
      real inftalopct,suptalopct
      real inftahipct,suptahipct
      real gtalopct,gtahipct
      
      double precision tblomn,tblodev,tbhimn,tbhidev
      integer tblonb,tbhinb   
      real inftblopct,suptblopct
      real inftbhipct,suptbhipct 
      real gtblopct,gtbhipct
      real talohipct,tblohipct
      
      double precision prt1amn,prt1adev
      double precision prt1bmn,prt1bdev
      double precision prt2amn,prt2adev
      double precision prt2bmn,prt2bdev 
      real gprt1apct,gprt1bpct,gprt2apct,gprt2bpct
      real misprt1apct,misprt1bpct,misprt2apct,misprt2bpct
      integer prt1anb,prt1bnb,prt2anb,prt2bnb
      
      integer ind
      integer ch
      integer count
      integer miscntflg
      integer ejectcntflg
      integer flag
      
      integer misspnb(msu_mxchn)
      integer ejectspnb(msu_mxchn)
      integer gspnb(msu_mxchn)
      double precision spcntsum(msu_mxchn)
      double precision spcntdevsum(msu_mxchn)
      
      integer mistgnb(msu_mxchn)
      integer ejecttgnb(msu_mxchn)
      integer gtgnb(msu_mxchn)
      double precision tgcntsum(msu_mxchn)
      double precision tgcntdevsum(msu_mxchn)
      
      integer spnb(msu_mxchn)
      real missppct(msu_mxchn)
      real ejectsppct(msu_mxchn)
      real gsppct(msu_mxchn)
      double precision spcntmn(msu_mxchn)
      double precision spcntdev(msu_mxchn)
          
      integer tgnb(msu_mxchn)
      real mistgpct(msu_mxchn)
      real ejecttgpct(msu_mxchn)
      real gtgpct(msu_mxchn)
      double precision tgcntmn(msu_mxchn)
      double precision tgcntdev(msu_mxchn)
      
      common/prtlineinfo/prtid,prt,txcallo,txcalhi,
     &                   infloflg,suploflg,infhiflg,suphiflg,
     &                   zeroflg,misprtflg,flg
       
      common/systA/talosum,tahisum,
     &             talodevsum,tahidevsum,
     &             gtalonb,gtahinb,
     &             inftalonb,inftahinb,
     &             suptalonb,suptahinb,
     &             talohinb
      
      common/systB/tblosum,tbhisum,
     &             tblodevsum,tbhidevsum,
     &             gtblonb,gtbhinb,
     &             inftblonb,inftbhinb,
     &             suptblonb,suptbhinb,
     &             tblohinb
     
      common/cprt1A/prt1asum,prt1adevsum,gprt1anb,misprt1anb 
      
      common/cprt1B/prt1bsum,prt1bdevsum,gprt1bnb,misprt1bnb
       
      common/cprt2A/prt2asum,prt2adevsum,gprt2anb,misprt2anb 
      
      common/cprt2B/prt2bsum,prt2bdevsum,gprt2bnb,misprt2bnb
      
      common/prtstat/
     &talomn,talodev,tahimn,tahidev,tblomn,tblodev,
     &tbhimn,tbhidev,prt1amn,prt1adev,prt1bmn,prt1bdev,
     &prt2amn,prt2adev,prt2bmn,prt2bdev,
     &talonb,inftalopct,suptalopct,tahinb,inftahipct,suptahipct,
     &gtalopct,gtahipct,
     &tblonb,inftblopct,suptblopct,tbhinb,inftbhipct,suptbhipct,
     &gtblopct,gtbhipct,
     &talohipct,tblohipct,
     &gprt1apct,misprt1apct,prt1anb,
     &gprt1bpct,misprt1bpct,prt1bnb,
     &gprt2apct,misprt2apct,prt2anb,
     &gprt2bpct,misprt2bpct,prt2bnb
     
      common/countinfo/ind,ch,count,miscntflg,ejectcntflg,flag
      
      common/spacecounts/
     &spcntsum,spcntdevsum,misspnb,ejectspnb,gspnb

      common/targetcounts/
     &tgcntsum,tgcntdevsum,mistgnb,ejecttgnb,gtgnb
     
      common/spacestat/
     &spcntmn,spcntdev,missppct,ejectsppct,gsppct,spnb
     
      common/targetstat/
     &tgcntmn,tgcntdev,mistgpct,ejecttgpct,gtgpct,tgnb

