#define MWHS2_SPOTS 98
#define MWHS2_CHANS 15
#define MWHS2_MAPCHANS 13

char h_site[4];       /* dataset creation site ID (terminated by null) */
char h_1bsite[4];     /* creation site for original 1B data */
int  h_versnb;        /* level 1c format version number */
int  h_satid;         /* satellite id (e.g. 14 for NOAA-14) */
int  h_instrument;    /* instrument code (18=MWTS2, 19=MWHS2) */
int  h_satht;         /* nominal satellite altitude, km*10 */
int  h_period;        /* nominal orbit period (seconds) */
int  h_startorbit;    /* orbit number (at start of file) */
int  h_startdatayr;   /* start of data set year */
int  h_startdatady;   /* start of data set day of the year */
int  h_startdatatime; /* start of data set UTC time of day (ms) */
int  h_endorbit;      /* orbit number (at end of file) */
int  h_enddatayr;     /* end of data set year */
int  h_enddatady;     /* end of data set day of the year */
int  h_enddatatime;   /* end of data set UTC time of day (ms) */
int  h_scnlin;        /* count of scan lines in this data set */
int  h_misscnlin;     /* count of missing scan lines */
int  h_vnantennacorr; /* version number, antenna corrections */
int  h_tempradcnv[MWHS2_CHANS][3]; /* Wavenumber, const1, const2 */
int  h_wmosatid;      /* WMO satellite id (522=FY-3C) */
int  h_bandwidth[MWHS2_CHANS]; /* GHz*1E6 */
int  h_nchan;         /* number of MWHS channels in format */
int  h_nmapchan;      /* number of mapped channels in format */
int  h_nmapchanused;  /* number of mapped channels used */
int  h_beamversion;   /* User defined (see mwhs2_beamwidth.dat) */
int  h_beamwidth[MWHS2_CHANS];   /* deg*1E3 */
int  h_cutoff[MWHS2_CHANS];      /* fraction*1E3 */
int  h_nxaverage[MWHS2_CHANS];   /* number of spots averaged in x */
int  h_nyaverage[MWHS2_CHANS];   /* number of spots averaged in x */

int *scnlin;     /* scan line number */
int *scnlinyr;   /* scan line year */
int *scnlindy;   /* scan line day of year */
int *scnlintime; /* scan line UTC time of day in milliseconds */
int *qualind;    /* quality indicator bit field */
int *scanqual;   /* scan line quality flags */
int *chanqual;   /* quality flag for each channel */
int *instrtemp1; /* instrument temperature 1, K*100 */
int *instrtemp2; /* instrument temperature 2, K*100 */
int *latitude;   /* latitude, deg*10000 */
int *longitude;  /* longitude, deg*10000 */
int *satzen;     /* local zenith angle, deg*100 */
int *satazi;     /* local azimuth angle, deg*100 */
int *solzen;     /* solar zenith angle, deg*100 */
int *solazi;     /* solar azimuth angle, deg*100 */
int *scalti;     /* sat altitude above reference ellipsoid, km*10 */
int *satposition;/* x,y,z in metres */
int *satvelocity;/* vx,vy,vz in m/s */
int *orbitangle; /* angle round orbit relative to solar plane, in deg*100 */
int *btemps;     /* brightness temperatures, K*100 */
int *btmap;      /* mapped brightness temperatures, K*100 */
int *dataqual;   /* quality control word for the data in each field of view */
