/* Variables to hold the MWHS2 SDR */

/* MWHS2_SCANS is the max number of scans that we need to accommodate (1 orbit) */

#define MWHS2_SPOTS 98
#define MWHS2_CHANS 15
#define MWHS2_SCANS 2700
#define RMDI -9999.99
#define MDI -999999

/* Variables */

int          Count_scnlines;
int          Orbit_Number;
int          Orbit_Period;      /* minutes */

float        Latitude[MWHS2_SCANS][MWHS2_SPOTS];
float        Longitude[MWHS2_SCANS][MWHS2_SPOTS];
short int    Pixel_View_Angle[MWHS2_SCANS][2];
short int    Scnlin_daycnt[MWHS2_SCANS];
int          Scnlin_mscnt[MWHS2_SCANS];
float        Earth_Obs_BT[MWHS2_CHANS*MWHS2_SCANS*MWHS2_SPOTS];
short int    SensorZenith[MWHS2_SCANS][MWHS2_SPOTS];     /* deg *100 */
short int    SensorAzimuth[MWHS2_SCANS][MWHS2_SPOTS];
short int    SolarZenith[MWHS2_SCANS][MWHS2_SPOTS];
short int    SolarAzimuth[MWHS2_SCANS][MWHS2_SPOTS];
short int    DEM[MWHS2_SCANS][MWHS2_SPOTS];             /* metres */
short int    LandSeaMask[MWHS2_SCANS][MWHS2_SPOTS];
short int    QA_Ch_Flag[MWHS2_SCANS];
short int    QA_Scan_Flag[MWHS2_SCANS];
int          scnlin_qc[MWHS2_SCANS];

char         Beginning_Date[11];     /* e.g. "2010-11-30" */
char         Beginning_Time[13];     /* e.g. "04:00:28.000" */
char         Ending_Date[11];
char         Ending_Time[13];
char         Satellite_Name[6];      /* e.g. "FY-3C" */
