/* Variables to hold the MWRI SDR */

/* MWRI_SCANS is the max number of scans that we need to accommodate (1 orbit) */

#define MWRI_SPOTS 266
#define MWRI_CHANS 10
#define MWRI_SCANS 2000
#define RMDI -9999.99
#define MDI -999999

/* Variables */

int          Count_scnlines;
int          Orbit_Number;
int          Orbit_Period;      /* minutes */

float        Latitude[MWRI_SCANS][MWRI_SPOTS];
float        Longitude[MWRI_SCANS][MWRI_SPOTS];
short int    Pixel_View_Angle[MWRI_SCANS][2];
short int    Scnlin_daycnt[MWRI_SCANS];
float        Scnlin_mscnt[MWRI_SCANS][2];
int          Earth_Obs_BT[MWRI_CHANS*MWRI_SCANS*MWRI_SPOTS];
short int    SensorZenith[MWRI_SCANS][MWRI_SPOTS];     /* deg *100 */
short int    SensorAzimuth[MWRI_SCANS][MWRI_SPOTS];
short int    SolarZenith[MWRI_SCANS][MWRI_SPOTS];
short int    SolarAzimuth[MWRI_SCANS][MWRI_SPOTS];
short int    DEM[MWRI_SCANS][MWRI_SPOTS];             /* metres */
short int    LandSeaMask[MWRI_SCANS][MWRI_SPOTS];
short int    QA_Ch_Flag[MWRI_SCANS];
short int    QA_Scan_Flag[MWRI_SCANS];
int          scnlin_qc[MWRI_SCANS];

char         Beginning_Date[11];     /* e.g. "2010-11-30" */
char         Beginning_Time[13];     /* e.g. "04:00:28.000" */
char         Ending_Date[11];
char         Ending_Time[13];
char         Satellite_Name[6];      /* e.g. "FY-3C" */
