/* Variables to hold the MWTS2 SDR */

/* MWTS2_SCANS is the max number of scans that we need to accommodate (1 orbit) */

#define MWTS2_SPOTS 90
#define MWTS2_CHANS 13
#define MWTS2_SCANS 2700
#define RMDI -9999.99
#define MDI -999999

/* Variables */

int          Count_scnlines;
int          Orbit_Number;
int          Orbit_Period;      /* minutes */

float        Latitude[MWTS2_SCANS][MWTS2_SPOTS];
float        Longitude[MWTS2_SCANS][MWTS2_SPOTS];
float        Earth_Obs_Angle[MWTS2_SCANS][2];
float        Earth_Obs_Angle_all[MWTS2_SCANS][MWTS2_SPOTS];
int          Time[MWTS2_SCANS][8];
short int    Earth_Obs_BT[MWTS2_CHANS*MWTS2_SCANS*MWTS2_SPOTS];
short int    SensorZenith[MWTS2_SCANS][MWTS2_SPOTS];     /* deg *100 */
short int    SensorAzimuth[MWTS2_SCANS][MWTS2_SPOTS];
short int    SolarZenith[MWTS2_SCANS][MWTS2_SPOTS];
short int    SolarAzimuth[MWTS2_SCANS][MWTS2_SPOTS];
short int    DEM[MWTS2_SCANS][MWTS2_SPOTS];             /* metres */
short int    LandSeaMask[MWTS2_SCANS][MWTS2_SPOTS];
short int    Quality_Flag_Channels[MWTS2_SCANS];
short int    Quality_Flag_Scnlin[MWTS2_SCANS];

char         Beginning_Date[11];     /* e.g. "2010-11-30" */
char         Beginning_Time[13];     /* e.g. "04:00:28.000" */
char         Ending_Date[11];
char         Ending_Time[13];
char         Satellite_Name[6];      /* e.g. "FY-3C" */
