/* Variables to hold the MWTS SDR */

/* MWTS_SCANS is the max number of scans that we need to accommodate (1 orbit) */

#define MWTS_SPOTS 15
#define MWTS_CHANS 4
#define MWTS_SCANS 500
#define RMDI -9999.99
#define MDI -999999

/* Variables */

int          Count_scnlines;
int          Orbit_Number;
int          Orbit_Period;      /* minutes */

float        Earth_Obs_BT[MWTS_CHANS*MWTS_SCANS*MWTS_SPOTS];
float        Latitude[MWTS_SCANS][MWTS_SPOTS];
float        Longitude[MWTS_SCANS][MWTS_SPOTS];
short int    SensorZenith[MWTS_SCANS][MWTS_SPOTS];     /* deg *100 */
short int    SensorAzimuth[MWTS_SCANS][MWTS_SPOTS];
short int    SolarZenith[MWTS_SCANS][MWTS_SPOTS];
short int    SolarAzimuth[MWTS_SCANS][MWTS_SPOTS];
short int    Height[MWTS_SCANS][MWTS_SPOTS];           /* metres */
short int    LandSeaMask[MWTS_SCANS][MWTS_SPOTS];
short int    cal_qc[MWTS_SCANS];
int          Scan_Time[MWTS_SCANS];                    /* milliseconds */
short int    Black_Body_View_Ang[MWTS_SCANS];
float        EVS_orb_pos[MWTS_SCANS][3];               /* metres */
int          Cal_Coefficient[MWTS_SCANS][MWTS_CHANS][3];

float        Ave_Instr_Temp[4];

char         Beginning_Date[11];     /* e.g. "2010-11-30" */
char         Beginning_Time[13];     /* e.g. "04:00:28.000" */
char         Ending_Date[11];
char         Ending_Time[13];
char         Satellite_Name[6];      /* e.g. "FY-3A" */
