!       p_earth.h
!
! constants of the earth ellipsoid and rotation
!
! issued from the orbit extrapolation model mosaik (CNES)
!
        double precision req            ! earth equatorial radius       (km)
        double precision rpo            ! earth polar radius            (km)
        double precision flat           ! earth flattening factor
        double precision re2            ! req*req
        double precision rp2            ! rpo*rpo
        double precision re2_rp2        ! re2 / rp2
        double precision rp2_re2        ! rp2 / re2
        double precision exct2          ! square of earth eccentricity
        parameter( req  = 6378.140D0 ,
     >             flat = 1.d0 / 298.25722d0 ,
     >             rpo  = ( 1.d0 - flat ) * req  ,
     >             re2  = req * req ,
     >             rp2  = rpo * rpo ,
     >             re2_rp2 = re2 / rp2 ,
     >             rp2_re2 = rp2 / re2 ,
     >             exct2 = 1.d0 - rp2_re2 )
!
        double precision earthrot               ! earth rotation in rad / sec
        parameter ( earthrot=7.292115147d-5 )   ! = 6.300387486753296 rad /day
!
        double precision mu             ! gravitationnal constant km**3/s**2
        parameter ( mu =398600.64d0 )
!
        character*8 earth_modelid
        parameter ( earth_modelid ='  GRS 80')
!
! constants issued from the brolyd model
!       req = 6378.135
!       flat = 1.d0/ 298.25d0
!       mu = 398600.8d0
!       earth_modelid ='DODWGS72'

