!       p_timang.h
!
! constants for the scanning geometry and timing of NOAA instruments
!
        integer maxinst                 ! maximum number of instruments
        parameter (maxinst=12)

        double precision pi
        parameter ( pi = 3.14159265358979311600d0)

        double precision scsttim(maxinst) ! scanning step time  (jdays)
        double precision scdtim(maxinst)  ! scanning delta time (jdays)
        double precision scstang(maxinst) ! scanning step angle (rad)
        double precision scmpix(maxinst)  ! pixel number at nadir
        double precision steptl(maxinst)  ! step time between two lines (sec)

!       the medium pixel is the real pixel value at nadir(number of steps +1)/2.
!       scanning step angle > 0 <==> scanning from right to left according
!                                    to the satellite motion
!
!       the variable initialization is done by the include file timang.h
