!+ Numbers for processing AMSU-B within ATOVPP
!
! Name:  ppbfdata.h
!
! Purpose:
!   'INCLUDE' file containing numbers for processing AMSU-B within ATOVPP.
!
! Current Code Owner: R.J.Renshaw
!
! History:
! Version    Date     Comment
!
!  1.0        12/04/96  Original code. (R.J.Renshaw)
!  1.1         9/12/96  include Bboxlv89
!
! Code Description:
!   FORTRAN 77, following AAPP standards
!
! Declarations:
!
      INTEGER     BboxSize        ! size of grid-box used in SURFELEV
      PARAMETER ( BboxSize = 15 ) ! km
!
! version numbers for the pre-processing
      INTEGER       Bcorrvn       ! limb/emissivity correction (0=not done)
      INTEGER       Bpcpvn        ! precip/scattering detection (0=not done)
!
! numbers for local variance of AMSUB 89GHz channel
      INTEGER       Bboxlv89      ! size of grid-box for local variance
      REAL          Bmaxlv89      ! threshold for local variance
!
! bias corrections
      REAL          Bbiases(Bnchan,Bnfovs)  ! deg K, added to the obs
!
      COMMON / PPBFDATA / Bcorrvn, Bpcpvn, Bboxlv89, Bmaxlv89, Bbiases
