!
! This pre-existing routine has been included in AAPP as part 
! of EUMETSAT NWP-SAF
! IT BELONGS TO BACKUS-GILBERT-CONVOLUTION AMSU-B to AMSU-A
! see Bennartz (2000), J. Atmos. Ocean. Technology, Vol. 17, No. 9, 1215-1225
!
!
! Ralf Bennartz, 06/12/2000
!
! Fixed bug that affects N-16 and higher (expanded Lookuptables and
! added one dimension to amb_lin and amb_pix). also added N-17 
! Ralf Bennartz, 04/12/2004
!
!               

! Define the size of the convolution window for AMSU-B to AMSU-A
! I.e. a 7x7 set of AMSU-B pixels is averaged to the AMSU-A 
! observation
      INTEGER conv_size
      PARAMETER(conv_size = 7)
!
! THe parameter BG_NSATS is used to specifiy teh maximum number of 
! different convolution weights
! for the different NOAA-satellites. Currently three options are available
!  1 : NOAA-15
!  2 : NOAA-16
!  3 : NOAA-17
!  4 : otherwise
! 
!  The identification of which one is used, is done automatically via
!  the satellite-id in AAPP
!
      INTEGER BG_NSATS
      PARAMETER(BG_NSATS  = 4)

!
! The  following three fields hold the necessary information to convolve 
! AMSU-B .
!     amb_pix holds for each AMSU-A pixel the scan position of 
!             all of the 7x7 pixels relative to the one closest 
!             to the given AMSU-A pixel
!
!     amb_line holds for each AMSU-A pixel the scan line of 
!             all of the 7x7 pixels relative to the one closest 
!             to the given AMSU-A pixel
!
      INTEGER amb_pix   (conv_size,conv_size,ANFOVS,BG_NSATS)
      INTEGER amb_lin   (conv_size,conv_size,ANFOVS,BG_NSATS)

      REAL    amb_weight(conv_size,conv_size,ANFOVS,BG_NSATS)
      COMMON / amb_bg_conv /  amb_pix,amb_lin,amb_weight 



