!+ Numbers for processing HIRS within ATOVPP
!
! Name:  pphfdata.h
!
! Purpose:
!   'INCLUDE' file containing numbers for processing HIRS within ATOVPP.
!
! Current Code Owner: R.J.Renshaw
!
! History:
! Version    Date     Comment
!
!  1.0        12/04/96  Original code. (R.J.Renshaw)
!
! Code Description:
!   FORTRAN 77, following AAPP standards
!
! Declarations:
!
      INTEGER     HboxSize        ! size of grid-box used in SURFELEV
      PARAMETER ( HboxSize = 40 ) ! km
!
! version numbers for the pre-processing
      INTEGER       Hcorrvn       ! limb/emissivity correction (0=not done)
      INTEGER       Hcloudvn      ! cloud detection/correction (0=not done)
!
! bias corrections
      REAL          Hbiases(Hnchan,Hnfovs)  ! deg K, added to the obs
!
      COMMON / PPHFDATA / Hcorrvn, Hcloudvn, Hbiases
