!+ Numbers for processing MSU within ATOVPP
!
! Name:  ppmfdata.h
!
! Purpose:
!   'INCLUDE' file containing numbers for processing MSU within ATOVPP.
!
! Current Code Owner: R.J.Renshaw
!
! History:
! Version    Date     Comment
!
!  1.0        12/04/96  Original code. (R.J.Renshaw)
!
! Code Description:
!   FORTRAN 77, following AAPP standards
!
! Declarations:
!
      INTEGER     MboxSize        ! size of grid-box used in SURFELEV
      PARAMETER ( MboxSize = 200 )! km
!
! version numbers for the pre-processing
      INTEGER       Mcorrvn       ! limb/emissivity correction (0=not done)
!
! bias corrections
      REAL          Mbiases(Mnchan,Mnfovs)  ! deg K, added to the obs
!
! MSU limb-darkening curve
      REAL          Mlimb(Mnchan,Hnfovs/2,2) ! expected effect of limb-viewing
!                                    (deg K) for sea(1) & land(2) at HIRS fovs
!                             Limb effect is assumed symmetric with scan angle
!
      COMMON / PPMFDATA / Mcorrvn, Mbiases, Mlimb
