!/* Upper and lower values for SI
!   if limits exceeded flag_a bit 6 set and SI =-999.9*/
#define MIN_SI   -20.0   /*K was -50.0 */
#define MAX_SI   100.0

!/* Land fraction smaller than  ... [1] -> open ocean */
#define OCEAN_THRESHOLD    0.01
!/* Land fraction higher  than ... [1] -> land       */
#define LAND_THRESHOLD     0.95

!/* define Flags */
#define F_OCEAN          1 /* pixel is water (land fraction < OCEAN_THRESHOLD */
#define F_COAST          2 /* pixel is coast (NOT land AND NOT water) */
#define F_LAND           4 /* pixel is land (land fraction > LAND_THRESHOLD */
#define F_SI_FAIL       32 /* SI  processing    failed (limit exceeded)*/
#define F_SI_INCLUDES_A 64 /* SI includes AMSU-A 23 GHz channel */  

! Define the static parameters for the number of different SI
! values that are allowed and the number of different precip classes  
! that are retrieved

      PARAMETER( nwc_si_vals= 121)
      PARAMETER( nwc_si_clas=   4)
!
! Here we define the different variabloes that are needed to assign
! a SI value the likelihood of precipitation.
!  
!  Let X be either 'land' or 'sea' or 'coast'
! 
!  nwc_si_t150mtFF_X : holds the values of SI 
!  nwc_si_X          : holds the likelihood with which the corresponding
!                      SI belongs to a certain precip intensity
! 
! 
!
      COMMON / nwc_si_parameters / nwc_si_sea,  nwc_si_t150mt89_sea,
     +                             nwc_si_coast,nwc_si_t150mt89_coast,
     +                             nwc_si_land ,nwc_si_t150mt23_land

      REAL nwc_si_sea             (nwc_si_vals,nwc_si_clas)
      REAL nwc_si_t150mt89_sea    (nwc_si_vals)


      REAL nwc_si_coast             (nwc_si_vals,nwc_si_clas)
      REAL nwc_si_t150mt89_coast    (nwc_si_vals)

      REAL nwc_si_land            (nwc_si_vals,nwc_si_clas)
      REAL nwc_si_t150mt23_land   (nwc_si_vals)


