!
! include file for satid library
!
        integer maxsatid        ! maximum of satellites
        parameter (maxsatid=40)
        integer maxinst         ! maximum of instruments per satellite
        parameter (maxinst=10)
        integer maxparascan     ! maximum of parameters for scanning function
        parameter (maxparascan=10)
        integer maxparamisalign ! maximum of parameters for misalignment angles
        parameter (maxparamisalign=3)
        integer maxparaifov     ! maximum of parameters for field of view geometry
        parameter (maxparaifov=2)
        integer maxattbid       ! maximum of bulletins id for attitude bias
        parameter (maxattbid=4)

        integer satid_version ! SATID file version number

        ! Satellite id numbers and dates
        integer noa_sc_num(maxsatid)       ! noaa number
        integer l1b_sc_num(maxsatid)       ! level 1b number (PACS)
        integer avh_sc_num(maxsatid)       ! avhrr telemetry number
        integer tip_sc_num(2,maxsatid)     ! tip telemetry number
        integer sc_date_range(2,maxsatid)  ! operational date range
        integer sc_num_inst(maxsatid)      ! number of instruments

        ! instrument id strings
        integer inst_num(maxinst,maxsatid) ! instrument number
        character*16 inst_gen_name(maxinst,maxsatid) ! instrument generic name
        character*16 inst_ref_name(maxinst,maxsatid) ! instrument reference name

        ! instrument scanning function 
        integer inst_scan_mode(maxinst,maxsatid) ! scanning function mode
        integer inst_scan_mode_n(maxinst,maxsatid) ! number of parameters
        double precision inst_scan_mode_p(maxparascan,maxinst,
     &                                           maxsatid) ! parameters

        ! instrument misalignment angles 
        integer mis_align_mode(maxinst,maxsatid) ! misalignment mode
        integer mis_align_mode_n(maxinst,maxsatid) ! number of parameters
        double precision mis_align_mode_p(maxparamisalign,maxinst,
     &                                           maxsatid) ! parameters

        ! instrument field of view geometry
        integer ifov_mode(maxinst,maxsatid) ! field of view geometry mode
        integer ifov_mode_n(maxinst,maxsatid) ! number of parameters
        double precision ifov_mode_p(maxparaifov,maxinst,
     &                                           maxsatid) ! parameters

        ! Attitude
        integer sc_att_mode(maxsatid)      ! attitude mode
        integer sc_att_bias_n(maxsatid)
        integer sc_att_bias_bid(maxattbid,maxsatid)
        double precision sc_att_bias(3,maxattbid,maxsatid)

        ! satellite id strings
        character*8 sat_serie(maxsatid)    ! satellite serie
        character*16 launch_name(maxsatid)  ! pre-launch name
        character*9 sc_int_des(maxsatid)   ! s/c international designation
        character*16 sat_name(maxsatid)    ! satellite name (serie name + number)
        character*16 alias1(maxsatid)       ! first alias of noaa name (noaax)
        character*16 alias2(maxsatid)       ! second alias of noaa name (noaa-xx)
        character*16 alias3(maxsatid)       ! third alias of noaa name (noaa-x)


        ! common for character strings
        common/c_satid/sat_serie, launch_name, 
     &                 sat_name, alias1, alias2, alias3,
     &                 inst_gen_name, inst_ref_name,
     &                 sc_int_des
!
        ! common for integer variables
        common/i_satid/satid_version,
     &                 noa_sc_num, l1b_sc_num, avh_sc_num,
     &                 tip_sc_num, sc_date_range,
     &                 sc_num_inst, inst_num, 
     &                 inst_scan_mode, inst_scan_mode_n,
     &                 mis_align_mode, mis_align_mode_n,
     &                 ifov_mode, ifov_mode_n,
     &                 sc_att_mode, sc_att_bias_n, sc_att_bias_bid
!
        ! common for double precision variables
        common/dp_satid/inst_scan_mode_p, mis_align_mode_p, ifov_mode_p,
     &                 sc_att_bias
!

        
