C LIBS = avhrcl navnoaa tbus satid navtool f7nl1b f7ml f7tp f7cp f7gp auxaapp
!+
!NOM/NAME $Id: avhrcl.F 47 2006-08-21 08:44:41Z frna $
!  program avhrcl: avhrr calibration
!         the 1A file is read and rewritten to become 1B file
!         including calibration coefficients and earth location 
!
!BUT/PURPOSE 
! 
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER  
! Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0     15 Sept 95  initial          Marcel Derrien
! 1.1     19 March 96  update to take care of 
!   adding typorb to stat. file        Marcel Derrien
! 1.2     16 Feb 06   Use STOP instead of exit(0) - more portable. NCA
!
!EXIT CODES
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
!    
     
!commons
#include "avh1b.h"
#include "avhrcl.h"
!local variables
        integer avh_cloptn(2)
        integer ios
!functions      
!-
!-------------------------------
!init
!open 1B file and read 1B header
!-------------------------------
      call avhclin(avh_cloptn)        
      call avhsetu(avh_cloptn)
!-----------------
! read all 1B data
!-----------------
      call avh_get(ios)
      call ml_wt('info','1A file has been read')
!-----------------
! check bad data
!---------------
      call avh_qc
      call ml_wt('info','quality checking passed')
     
!------------------------------------
! compute IR calibration coefficients
! if requested by avh_cloptn(2)
!------------------------------------
      if(avh_cloptn(2).ne.0) then
        call avh_cal
        call ml_wt('info','calibration coefficients have been computed')
      endif
!------------------
! rewrite 1B file
!------------------    
      call avh_put(avh_cloptn,ios) 
      call ml_wt('info','1B file has been rewritten')
      
      if(ios.ne.0) then
        call ml_wti('error','avhrcl writing 1B avhrr data',ios)
        call aappexit(2)
      endif
!-----------------
! write stat file
!-----------------
      if(avh_cloptn(2).ne.0) then
        call avh_clst
      endif
!---------------------------
!  update 1B header and stop
!---------------------------
      call avhclex(avh_cloptn)  
      call ml_wt('info','normal end')     
      STOP
      end

