      subroutine amb_antpos(nvstat)
!+
!NOM/NAME $Id: amb_antpos.F 25 2006-02-03 15:43:53Z frna $
!
!------------------------------------------------------------------------------
!BUT/PURPOSE 
!    This module checks the antenna pointing of the AMSU-B Earth views.
!    if it is outside the threshold the navigation flag nvstat is set to
!    false and also the bit in the 1b scan line flag.     
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER  
!     Roger SAUNDERS
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0      February 96    no             R.Saunders
!         
!ARGUMENTS 
!      nvtat(mxlin) L*1 in/out  If .TRUE. then pointing ok 
!
!#########################################################################
! COPYRIGHT        THE CONTENTS OF THIS FILE ARE CROWN COPYRIGHT. THE
!                  SOFTWARE, DATA AND OTHER PROPRIETARY INFORMATION
!                  CONTAINED THEREIN IS SUPPLIED FOR BONAFIDE RESEARCH
!                  PURPOSES. COMMERCIAL OR BUSINESS USE IS NOT PERMITTED
!                  WITHOUT THE WRITTEN AUTHORITY OF THE U.K. MET. OFFICE.
!                  AT LONDON RD., BRACKNELL, BERKS, RG12 2SZ, U.K.
!#########################################################################

!--DECLARATIONS----------------------------------------------------------------
      implicit none                                                     
c-----------------------------------------
c
c
!      
! includes/commons
#include "ambclin.h"
#include "amb1b.h"
#include "ambscn.h"
#include "amb_cinit.h"
!
! local variables
      real op,nom_pos
      integer*4 iscan,i,iv
      logical*1 nvstat(mxlin)
!
!--END OF DECLARATIONS---------------------------------------------------------

      if (iprint.ge.1) write(amb_cllgu,*)
      if (iprint.ge.1) write(amb_cllgu,*) '***************************'
      if (iprint.ge.1) write(amb_cllgu,*) '**   SUBROUTINE AMB_ANTPOS*'
      if (iprint.ge.1) write(amb_cllgu,*) '***************************'
!..Loop in scan line................................................
      do 100 iscan = 1 , amb_h_scnlin
      nvstat(iscan) = .true.
!..Loop in Earth View...............................................
      do 10 i = 1 , mxpix
      iv = (i-1)*6 + 1
      OP = 41.05 + (0.5+abs(earth_data(iv,iscan)))*ant_coef ! Posn decode
      if(OP.GT.360)OP=OP-360.                       ! 0.5 BAe Memo
      NOM_POS = 41.05 + FLOAT(I-1)*1.1          ! AMS/J3662/BAE  
      IF(ABS(NOM_POS-OP).GT.pos_erre)then
       nvstat(iscan) = .false.
       if(iprint.ge.1)WRITE(amb_cllgu,200)iscan,NOM_POS-OP
 200  FORMAT(1X,' scan ',I4,
     &' Nominal - measured earth antenna posn=',F9.3,' deg')
      go to 100
      endif
 10   continue   ! .....end of pixel loop ..........
!
 100  Continue   ! ......end of scan line loop
!
      return
      end
