!+
!ROUTINE   AMB_TESTNEWBIAS
!
!PURPOSE   Detect presence of AMSU-B anomalous bias due to moding of STX-1
!          transmitter.
!
!VERSION   1.0   18/12/98   N C Atkinson, UKMO
!          1.1   March 03   f90 test   T.Labrot 
!                           Moved the comment line after the include 
!                           declaration
!
!ARGUMENTS INTEGER*4 EarthCOunts(540)
!          INTEGER*2 BiasFlag
!
!##############################################################################

      SUBROUTINE AMB_TESTNEWBIAS(Earthcounts,BiasFlag)

      implicit none



!This common block defines detection algorithm coefficients
#include "ambnewbias.h"   

      INTEGER*4 Earthcounts(540)
      INTEGER*2 BiasFlag
      INTEGER Chan,Pix
      REAL*4 Indicator,PixDiff

      Indicator=0.0
      PixDiff = newbias_pix(2)-newbias_pix(1)+1
      DO Pix=newbias_pix(1),newbias_pix(2)
        DO Chan=1,5
          IF (newbias_mult(Chan).NE.0) THEN
            Indicator = Indicator + 
     &         newbias_mult(Chan)*EarthCounts(1+Chan+(Pix-1)*6)/PixDiff
          ENDIF
        ENDDO
      ENDDO
      PixDiff = newbias_pix(4)-newbias_pix(3)+1
      DO Pix=newbias_pix(3),newbias_pix(4)
        DO Chan=1,5
          IF (newbias_mult(Chan).NE.0) THEN
            Indicator = Indicator - 
     &         newbias_mult(Chan)*EarthCounts(1+Chan+(Pix-1)*6)/PixDiff
          ENDIF
        ENDDO
      ENDDO

      IF (Indicator.GT.Threshold) THEN
        BiasFlag = 1
      ELSE
        BiasFlag = 0
      ENDIF
      RETURN
      END

!##############################################################################
