!+
!NOM/NAME $Id: avh_bcor.F 47 2006-08-21 08:44:41Z frna $
!
      real function avh_bcor(temp,chn)
!BUT/PURPOSE 
! compute the band corrected radiance for an AVHRR IR channel chn
!    chn 1 AVHRR channel 3 (3B for AVHRR/3)
!    chn 2 AVHRR channel 4
!    chn 3 AVHRR channel 5
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER
!  Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment                 <author>)
! 1.0      Nov. 95      no             Marcel Derrien
!
!         
!ARGUMENTS
!
!      input : double precision temp
!      input : integer chn      
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
!    
!arguments
      double precision temp
      integer chn
! commons
#include "cavh_cpi.h"
! local variables
        double precision t
!-
       if(chn.ge.1.and.chn.le.3) then
         t = temp * avh_bandcor(3,chn) + avh_bandcor(2 ,chn)
         avh_bcor = sngl(planck1(chn)/
     &          (dexp (planck2(chn)/t) - 1))
       else
         call ml_wti('error','avh_bcor invalid channel number'
     &       ,chn)
         call aappexit(11)
       endif
       end
         
         
