!+
!NOM/NAME $Id: avh_brig.F 25 2006-02-03 15:43:53Z frna $
!
      real function avh_brig(r,l,ier)
!BUT/PURPOSE 
! convert an avhrr ir channel l radiance into brightness temperature
! using band correction coefficients and central wave numbers
! already read from avhrr calibration coefficient file 
! and stored into cavh_cpi.h 
!
! (another way to develop later is to use 1B avhrr header variables  
! from  avh_h_radtempcnv array)
! 
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER
!  Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment                 <author>)
!  1.0      Nov. 95   initial                 Marcel Derrien
!      
!ARGUMENTS 
!     input real r
!     input integer l ir channel order
!                  1 for channle 3B
!                  2 for channel 4
!                  3 for channel 5  
!     output real brightness temperature
!     output ier exit status 0 =ok
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!      
!         
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
!
!DECLARATIONS
!
      implicit none                                                     
! 
!    
!
!arguments
      real r
      integer l
      integer ier
!commons
#include "cavh_cpi.h"
!local variables
      real alge,expn,tt
      integer k
!functions
      intrinsic alog
!-
      ier = 1
      k = l 
      avh_brig = 0.0
      
      if (k.ge.1 .or. k.le.3) then
        if(r.lt.0.) r = 1.e-12
        expn = planck1(k)/r + 1.
        if (expn.ge.1.) then
          alge = alog(expn)
          if (alge.ge.1.) then 
            tt = planck2(k)/alge
            avh_brig = (tt-avh_bandcor(2 ,k))/avh_bandcor(3,k)
            ier = 0
          endif
        endif
      endif
      return
      end

