!+
!NOM/NAME $Id: avh_cir.F 25 2006-02-03 15:43:53Z frna $
!
      integer*2  function avh_cir(r,c)
!BUT/PURPOSE 
! returns the 100 * Kelvin corresponding to the radiance r from avhrr
! channel c
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER
!  Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment                 <author>)
!  1.0      Nov. 95   initial                 Marcel Derrien
!      
!ARGUMENTS 
!     input real r
!     input integer c ir channel order
!                  1 for channle 3B
!                  2 for channel 4
!                  3 for channel 5  
!     output ier exit status 0 =ok
!
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!      
!         
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
!
!DECLARATIONS
!
      implicit none                                                     
! 
!    
! arguments
        real r
        integer c
!commons
         real rbeg(3),rstep(3),rend(3)
         real tconv(4000,3)
         common/temp_conv/rbeg,rstep,rend,tconv
! local variables
        integer k 
        real temp
!functions
!-

         k = int( ( r - rbeg(c) ) / rstep(c) ) + 1
!-saturations ?
         if(k.lt.1) then
           avh_cir = nint(tconv(1,c)*100.)
           return
         else if(k.ge.4000) then
            if(tconv(4000,c).gt.327.67) then 
              avh_cir = 32767
              return
            else
              avh_cir = nint(tconv(4000,c)*100.)
              return
            endif
         endif
!
! interpolation between k and k+1
!
         temp = tconv(k,c) 
     &   + ( tconv(k+1,c) -tconv(k,c) ) *
     &     ( r - ( rbeg(c) + (k-1)*rstep(c)) ) / rstep(c)
         if( temp.lt.327.67) then
          avh_cir = nint(temp*100.)
         else
           avh_cir = 32767
         endif
         return
         end
