      subroutine avh_filt(gen_flag)
!+
!NOM/NAME $Id: avh_filt.F 25 2006-02-03 15:43:53Z frna $
! avh_filt
!
!BUT/PURPOSE 
! performs filtering before for calibration counts 
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!  
!PROPRIETAIRE/OWNER 
! Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0      Nov. 95      no             Marcel Derrien
! 1.1      June 98    correct bug for ch3A presence (Marcel Derrien)
!         
!ARGUMENTS
!   output : logical gen_flag
!       
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
!    
!arguments
        logical gen_flag 
!commons
#include "cavh_cpi.h"
#include "avhrcl.h"
#include "avh1b.h"
#include "cavh_m1b.h"
#include "cavh_wrk.h"
!local variables
!
        logical gen_prt_flag,gen_bb_flag,gen_sp_flag
        integer ith    
        integer ichn
        integer ichstrt
!_

       gen_prt_flag = .true.
       gen_bb_flag  = .true.
       gen_sp_flag  = .true.
       gen_flag = .true.
! thermistors filtering
!
       gen_prt_flag = .true.
!
       do ith = 1,4
         call filter(therm(1,1,ith),33,cth_min(ith),cth_max(ith),
     &             cth_mean(ith),cth_sig(ith),cth_nbnul(ith),
     &             cth_nbinf(ith),cth_nbsup(ith),cth_nbrej(ith),
     &             cth_flag(ith) )
         if(weight_prt(1).gt.0.2.and.(.not.cth_flag(ith))) then
!
!          there is a problem for this thermistor
           gen_prt_flag = .false.
         endif
       enddo
!
! target counts filtering
! add discussion here for channel 3a 3b considerations
!
       if(nb_obsirchn.eq.2) then
         ichstrt=2
       else
         ichstrt=1
       endif
       do ichn=ichstrt,3
         call filter(target(1,ichn),50,bb_min(ichn),bb_max(ichn),
     &             bb_mean(ichn),bb_sig(ichn),bb_nbnul(ichn),
     &             bb_nbinf(ichn),bb_nbsup(ichn),bb_nbrej(ichn),
     &             bb_flag(ichn))
         if(.not.bb_flag(ichn)) then

!          type *,' target channel ',ichn,bb_min(ichn),bb_max(ichn),
!     &     bb_mean(ichn),bb_sig(ichn),bb_nbnul(ichn),
!     &     bb_nbinf(ichn),bb_nbsup(ichn),bb_nbrej(ichn)
           gen_bb_flag = .false.
         endif
       enddo
!
! space counts filtering
! 
!
       do ichn=1,nb_obsvischn
         call filter(space(1,ichn),50,sp_min(ichn),sp_max(ichn),
     &             sp_mean(ichn),sp_sig(ichn),sp_nbnul(ichn),
     &             sp_nbinf(ichn),sp_nbsup(ichn),sp_nbrej(ichn),
     &             sp_flag(ichn))
         if(.not.sp_flag(ichn)) then

!          type *,' sp vis channel ',ichn,sp_min(ichn),sp_max(ichn),
!     &     sp_mean(ichn),sp_sig(ichn),sp_nbnul(ichn),
!     &     sp_nbinf(ichn),sp_nbsup(ichn),sp_nbrej(ichn)
           gen_sp_flag = .false.
         endif
       enddo       
       do ichn = ichstrt , 3
         call filter( space(1,ichn + 3) ,50,
     &             sp_min(ichn + 3) ,
     &             sp_max(ichn + 3) ,
     &             sp_mean(ichn+3) ,sp_sig(ichn+3) , 
     &             sp_nbnul(ichn +3 ) , sp_nbinf(ichn+3) ,
     &             sp_nbsup(ichn+3) , sp_nbrej(ichn+3) ,
     &             sp_flag(ichn+3) )
         if(.not.sp_flag(ichn+3)) then
!
!          type *,' sp ir channel ',ichn,sp_min(ichn),sp_max(ichn),
!     &     sp_mean(ichn),sp_sig(ichn),sp_nbnul(ichn),
!     &     sp_nbinf(ichn),sp_nbsup(ichn),sp_nbrej(ichn)
           gen_sp_flag = .false.
         endif
       gen_flag=gen_prt_flag.and.gen_bb_flag.and.gen_sp_flag
!       type *,'gen_prt_flag,gen_bb_flag,gen_sp_flag',
!     &      gen_prt_flag,gen_bb_flag,gen_sp_flag
       enddo
       return
       end
