      subroutine avh_get(ios)
!+
!NOM/NAME $Id: avh_get.F 117 2008-06-27 09:18:12Z frna $
! avh_get
!
!BUT/PURPOSE 
! avh_get reads the hrpt 1B file (only a part of each record )
! and stores the data into memory
! this module depends on the 1B format structure and has to be updated if
! the format changes
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!  
!PROPRIETAIRE/OWNER 
! Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0      Sept. 95      no             Marcel Derrien
! 1.1      May  98      1B changes      Marcel Derrien
! 1.2      Apr  05      Use avhdtr, to allow byte swapping and so that
!                       1B format is only defined once.     Nigel Atkinson
! 1.3      Apr  08      Use first scan number as reference, in order to accept
!                       files that don't start at 1 (e.g. NOAA LAC). NCA
!         
!ARGUMENTS
!
!       output : integer ios ! io status
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
!    
!arguments
        integer ios ! io status 
!commons
#include "avhrcl.h"
#include "avh1b.h"
#include "cavh_m1b.h"
!local variables
       integer scn
       integer i,j
       integer scnlin0
C       integer recn
!-
!---------------------------
! loop for all scans reading
!---------------------------
       do scn = 1 , avh_h_scnlin

         call avhdtr(luavh, scn, ios)

         if(ios.ne.0) then
           return
         endif

         if (scn.eq.1) scnlin0 = avh_scnlin - 1

         scnlin(scn) = avh_scnlin - scnlin0
         scnlinyr(scn) = avh_scnlinyr

         scnlindy(scn) = avh_scnlindy
         clockdrift(scn) = avh_clockdrift
         scnlintime(scn) = avh_scnlintime
         scnlinbit(scn) = avh_scnlinbit
         qualind (scn) = avh_qualind
         scnlinqual(scn) = avh_scnlinqual
         do i = 1,avh_mxirchn
           calqual(i,scn) = avh_calqual(i)
         enddo
         cbiterr(scn) = avh_cbiterr
         navstat(scn) = avh_navstat
         attangtime(scn) = avh_attangtime
         rollang(scn) = avh_rollang
         pitchang(scn) = avh_pitchang
         yawang(scn) = avh_yawang
         scalti(scn) = avh_scalti
         do i = 1,6
           frsync(i,scn) = avh_telem(i)
         enddo
         do i = 1,2
           idavh(i,scn) = avh_telem(i+6)
         enddo
         do i = 1,4
           timecode(i,scn) = avh_telem(i+8)
         enddo
         do i = 1,5
           rampcal(i,scn) = avh_telem(i+12)
         enddo
         do i = 1,3
           thcnt(i,scn) = avh_telem(i+17)
         enddo
         patchcnt(scn) = avh_telem(21)
         sp1(scn) = avh_telem(22)
         do i = 1,10
           do j = 1,3
             iwtcnt(j,i,scn) = avh_telem(3*i+j+19)
           enddo
         enddo
         do i = 1,10
           do j = 1,5
             ispcnt(j,i,scn) = avh_telem(5*i+j+47)
           enddo
         enddo

C        recn = scn + avh_h_hdrcnt
C
C        read (luavh,rec=recn,iostat=ios)  , 
C     &   scnlinyr(scn) , scnlindy(scn) , clockdrift(scn) ,
C     &   scnlintime(scn) , scnlinbit(scn) ,
C     &   avh_filler0 , 
C     &   qualind (scn), scnlinqual(scn) , 
C     &   (calqual(i,scn),i=1,avh_mxirchn) ,
C     &   cbiterr(scn) , avh_filler1 ,
C     &   avh_calvis , avh_calir , avh_filler2 , navstat(scn) ,
C     &   attangtime(scn) , rollang(scn) , pitchang(scn) , yawang(scn) ,
C     &   scalti(scn) , avh_ang , avh_filler3 , avh_pos , avh_filler4 ,
C     &   (frsync(i,scn),i=1,6) , (idavh(i,scn),i=1,2) ,
C     &   (timecode(i,scn),i=1,4) ,
C     &   (rampcal(i,scn),i=1,5) , (thcnt(i,scn),i=1,3) ,
C     &   patchcnt(scn) , sp1(scn) , ((iwtcnt(j,i,scn),j=1,3),i=1,10),
C     &   ((ispcnt(j,i,scn),j=1,5),i=1,10)
C
C         if(ios.ne.0) then
C           return
C         endif

       enddo    
       return
       end
