      subroutine avh_gprt(sblock)
!+
!NOM/NAME $Id: avh_gprt.F 25 2006-02-03 15:43:53Z frna $
! avh_gprt
!
!BUT/PURPOSE 
! get prt counts for the sub-block to calibrate
! i.e. the prt counts from the scan lines inside the
!      sub-block number sblock + 6 
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!  
!PROPRIETAIRE/OWNER 
! Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0      Nov. 95      no             Marcel Derrien
!
!         
!ARGUMENTS
!
!       integer sblock : sub-block we are computing cal coefficients    
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
!    
!arguments
       integer sblock
!commons
#include "avhrcl.h"
#include "avh1b.h"
#include "cavh_m1b.h"
#include "cavh_wrk.h"
!local variables
       integer therm_ad
       integer scn
       integer i
!-
!   scan line to get
       scn= start_cal_seq + (sblock + 4 )*5 + 1
!   address in therm array to point
       therm_ad = MOD((scn - start_cal_seq)/5,11) +1
!       type *,'sblock ',sblock,' scn(prt) ',scn,
!     &         ' therm_ad ',therm_ad
!   fill arrays with thermistor counts
       do i = 1,3
         therm(therm_ad,i,1)=thcnt(i,scn)
         therm(therm_ad,i,2)=thcnt(i,scn+1)
         therm(therm_ad,i,3)=thcnt(i,scn+2)
         therm(therm_ad,i,4)=thcnt(i,scn+3)
       enddo
!       type *,'therm1',(therm(therm_ad,i,1),i=1,3)
!       type *,'therm2',(therm(therm_ad,i,2),i=1,3)
!       type *,'therm3',(therm(therm_ad,i,3),i=1,3)
!       type *,'therm4',(therm(therm_ad,i,4),i=1,3)
       return
       end
