      subroutine avh_gvie(sblock)
!+
!NOM/NAME $Id: avh_gvie.F 376 2014-01-07 11:01:57Z frna $
! avh_gvie
!
!BUT/PURPOSE 
! get internal target and space counts for the sub-block to calibrate 
! 
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!  
!PROPRIETAIRE/OWNER 
! Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0      Nov. 95      no             Marcel Derrien
! 1.1      Sep. 2012 Ensure scn_end does not exceed avh_h_scnlin. Nigel Atkinson
! 1.1      Dec  2013 Portability fix: use "avh_h_scnlin + 0"
!
!         
!ARGUMENTS
!
!       
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
!    
!arguments
       integer sblock     
!commons
#include "avhrcl.h"
#include "avh1b.h"
#include "cavh_m1b.h"
#include "cavh_wrk.h"
!local variables
       integer scn_strt
       integer scn_end
       integer i,j,scn
       integer chstrt
!-
!   which scan lines to get
!
       scn_strt= start_cal_seq + ( sblock - 1 ) * 5 + 1
       scn_end = MIN(scn_strt + 4, avh_h_scnlin + 0)
       if(ch3_ind(scn_strt).eq.ch3_ind(scn_end)) then
         ch3_val(sblock)=ch3_ind(scn_strt)
       else
         ch3_val(sblock)=0
       endif
!
!   determines the number of infra-red channels to calibrate
!   for this sub-block
!
       if(ch3_val(sblock).eq.ch3a) then
         nb_obsvischn=3
         nb_obsirchn=2
         chstrt=4
       else if(ch3_val(sblock).eq.ch3b) then
         nb_obsvischn=2
         nb_obsirchn=3
         chstrt=3
       else
         nb_obsvischn=2
         nb_obsirchn=2
         chstrt=4
       endif
!       type *, 'ch3_val,nb_obsvischn,nb_obsirchn' 
!     &       ,ch3_val(sblock),nb_obsvischn,nb_obsirchn
       do j = 1,6
         do i=1,50
          space(i,j)=0
         enddo
       enddo
       do j = 1,3
         do i=1,50
          target(i,j)=0
         enddo
       enddo
       do scn=scn_strt,scn_end
         do j = 1,3 
           do i = 1,10
            target((scn-scn_strt)*10+i, j ) =  iwtcnt(j,i,scn)  
           enddo
         enddo 
         do j = 1,nb_obsvischn 
           do i = 1,10
             space((scn-scn_strt)*10+i, j ) = ispcnt(j,i,scn)  
           enddo
         enddo
         do j = chstrt , chstrt+nb_obsirchn-1
           do i = 1,10
             space((scn-scn_strt)*10+i, j+1 ) = ispcnt(j,i,scn)  
           enddo
         enddo
       enddo
!       type *, ' gview,scn_strt', scn_strt
!       type *, ' target ',target
!       type *, ' space ',space
       return
       end
