      subroutine avh_icon
!+
!NOM/NAME $Id: avh_icon.F 501 2016-11-02 10:00:17Z frna $
! avh_icon
!
!BUT/PURPOSE 
! initialize lookup tables to convert radiances into temperature
! for the 3 AVHRR IR channels
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!  
!PROPRIETAIRE/OWNER 
! Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0      Sept. 95      no             Marcel Derrien
! 1.1      Nov 2016  Change rstep(1) from 5.0e-04 to 7.5e-04, to allow increase
!                    channel 3B range. NCA.
!
!         
!ARGUMENTS
!       
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
!    
!commons
#include "cavh_cpi.h"
         real rbeg(3),rstep(3),rend(3)
         real tconv(4000,3)
         common/temp_conv/rbeg,rstep,rend,tconv
!local variables
         real r
        integer i
        integer c
        integer ios
!functions
        real avh_brig
!-
        rbeg(1)=1.e-4
        rbeg(2)=1.
        rbeg(3)=1.
        rstep(1)=7.5e-04
        rstep(2)=0.1
        rstep(3)=0.1
        do i = 1 , 3
          rend(i)=rbeg(i) + 3999.* rstep(i)
        enddo
        do i = 1,4000
         do c = 1,3
           r = rbeg(c) + (i-1)* rstep(c)
           tconv(i,c) = avh_brig(r,c,ios)
         enddo
        enddo
        return
        end
