      subroutine avh_poly(cth,prt_temp)
!+
!NOM/NAME $Id: avh_poly.F 24 2006-02-03 11:51:40Z frna $
! avh_poly
!
!BUT/PURPOSE 
!
! calculate prt temperatures from counts 
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!  
!PROPRIETAIRE/OWNER 
! Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0      Nov. 95      no             Marcel Derrien
!
!         
!ARGUMENTS
!
!      real cth(4) ! input prt counts array
!      double precision prt_temp ! output mean prt temperature 
!	
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
!    
!arguments
      real cth(4) ! input prt counts array
      double precision prt_temp ! output mean prt temperature 
!commons
#include "cavh_cpi.h"
!local variables
       double precision temp
       integer i,j
!
       prt_temp=0.
       do i = 1,4
         temp = conv_prt(1,i)
         do j = 2,5
           temp= temp + conv_prt(j,i) * (cth(i)**(j-1))
         enddo
         prt_temp = prt_temp + weight_prt(i)*temp
       enddo
       return
       end
