      subroutine avh_sum(sblock)
!+
!NOM/NAME $Id: avh_sum.F 25 2006-02-03 15:43:53Z frna $
! avh_sum 
!
!BUT/PURPOSE
! compute cumulative variables and maintain counters
! in order to calculate final statistical values.
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!  
!PROPRIETAIRE/OWNER 
! Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0      Nov. 95      no             Marcel Derrien
! 1.1      Nov. 00                     Tiphaine Labrot
!                modified the order for the sum sumcthrej(i) 
!                because the run of AAPP failed with the compilator V5.0
!
!         
!ARGUMENTS
!
! input: integer sblock ! sub-block number
!
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
!    
!arguments
       integer sblock ! sub-block number     
!commons
#include "avhrcl.h"
#include "avh1b.h"
#include "cavh_wrk.h"
!
!local variables
       integer i
       integer chn,istrt
       logical first
       data first /.true./
       save first
!_
!---------------------------------------------------------
       if(first) then
         stat_cnt = 0
         stat_ch3b = 0
         stat_ch3a = 0
         do  i=1,3
           sumk1(i) = 0.
           sumk1(i) = 0.
           sumk3(i) = 0.
         enddo
         do  i=1,4
           sumcth(i)   = 0.
           sumcthmean(i) = 0. 
           sumcthinf(i)   = 0.
           sumcthsup(i)   = 0.
           sumcthrej(i)   = 0.
         enddo
         do i = 1 , 3
           sumbb(i)     = 0.
           sumbbmean(i) = 0.
           sumbbsig(i)  = 0.
           sumbbinf(i)  = 0.
           sumbbsup(i)  = 0.
           sumbbrej(i)  = 0.
         enddo
         do i = 1,6
           sumsp(i)     = 0.
           sumspmean(i) = 0.
           sumspsig(i)  = 0.
           sumspinf(i)  = 0.
           sumspsup(i)  = 0.
           sumsprej(i)  = 0.
         enddo
         first=.false.
       endif

!----------------------------------------------------------
! compute average coefficients from sub-blocks coefficients
!----------------------------------------------------------
       if(flag_coe(sblock)) then
         do  i=2,3         
           sumk1(i) = sumk1(i) + sb_k1(i,sblock)
           sumk2(i) = sumk2(i) + sb_k2(i,sblock)
           sumk3(i) = sumk3(i) + sb_k3(i,sblock)
         enddo
         if(ch3_val(sblock).eq.ch3b) then 
           i = 1
           sumk1(i) = sumk1(i) + sb_k1(i,sblock)
           sumk2(i) = sumk2(i) + sb_k2(i,sblock)
           sumk3(i) = sumk3(i) + sb_k3(i,sblock)
         endif
       endif
!---------------------------------------------
! cumulative variables for thermistor counts
!---------------------------------------------
       stat_cnt = stat_cnt + 1
       do  i = 1,4
         sumcth(i) = sumcth(i) + 55 - cth_nbnul(i)
         sumcthmean(i) = sumcthmean(i) + cth_mean(i)
         sumcthinf(i) = sumcthinf(i) + cth_nbinf(i)
         sumcthsup(i) = sumcthsup(i) + cth_nbsup(i)
         sumcthrej(i) = sumcthrej(i) + cth_nbrej(i) + cth_nbinf(i) 
     &                       + cth_nbsup(i)
        enddo
!---------------------------------------
! cumulative variables for target counts
!---------------------------------------
       if(ch3_val(sblock).eq.ch3b) then
         istrt=1
         stat_ch3b = stat_ch3b + 1
       else
         istrt = 2
         stat_ch3a = stat_ch3a + 1
       endif
         

       do i = istrt , 3
         sumbb(i) = sumbb(i) + 10 - bb_nbnul(i)
         sumbbmean(i) = sumbbmean(i) + bb_mean(i)
         sumbbsig(i) = sumbbsig(i) + bb_sig(i)
         sumbbinf(i) = sumbbinf(i) + bb_nbinf(i)
         sumbbsup(i) = sumbbsup(i) + bb_nbsup(i)
         sumbbrej(i) = bb_nbrej(i) + bb_nbinf(i) + bb_nbsup(i)
     &                        + sumbbrej(i)
       enddo
!---------------------------------------
! cumulative variables for space counts
!---------------------------------------
!  visible channels
!
       if(ch3_val(sblock).eq.ch3a) then
         chn = 3
       else
         chn = 2
       endif       
       do i=1, chn              
         sumsp(i) = sumsp(i) + 50 - sp_nbnul(i)
         sumspmean(i) = sumspmean(i) + sp_mean(i)
         sumspsig(i) = sumspsig(i) + sp_sig(i)
         sumspinf(i) = sumspinf(i) + sp_nbinf(i)
         sumspsup(i) = sumspsup(i) + sp_nbsup(i)
         sumsprej(i) = sp_nbrej(i) + sp_nbinf(i) + sp_nbsup(i)
     &                        + sumsprej(i)

       enddo
! IR channels
       if(ch3_val(sblock).eq.ch3b) then
         chn = 4
       else
         chn = 5
       endif       
       do i=chn, 6              
         sumsp(i) = sumsp(i) + 50 - sp_nbnul(i)
         sumspmean(i) = sumspmean(i) + sp_mean(i)
         sumspsig(i) = sumspsig(i) + sp_sig(i)
         sumspinf(i) = sumspinf(i) + sp_nbinf(i)
         sumspsup(i) = sumspsup(i) + sp_nbsup(i)
         sumsprej(i) = sp_nbrej(i) + sp_nbinf(i) + sp_nbsup(i)
     &                        + sumsprej(i)

       enddo

       return
       end





