      subroutine avhclex(avh_cloptn)
!+
!NOM/NAME $Id: avhclex.F 47 2006-08-21 08:44:41Z frna $
! avhclex 
!
!BUT/PURPOSE
! write summary to stderr
! write 1B header,close  1B file before exiting avhrcl main program
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!  
!PROPRIETAIRE/OWNER 
! Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0      Nov. 95      no             Marcel Derrien
!
!         
!ARGUMENTS
!
!       input : integer avh_cloptn(2)  ! options for avhrcl
!               avh_cloptn(1) -- 1  for AVHRR earth location option
!                                0  no earth location requested
!               avh_cloptn(2) -- 1  for AVHRR calibration option
!                                0  no calibration requested 
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
!    
!arguments
       integer avh_cloptn(2)
!commons
#include "avhrcl.h"
#include "cavh_wrk.h"
!               luavh       logical unit for AVHRR 1B file
!               lupar         logical unit for the calibration
!                                   parameters file
!               lustat        logical unit for the output statistics 
!                                           file
!               lusatpos      logical unit for the satpos file
!               luclock       logical unit for the clock error file
!local variables
       integer ios
!-
      call avh_hdu(avh_cloptn)
!--------------
! close 1B file
!--------------
      call avhhdw(luavh,ios)
      if (ios.ne.0) then
         call ml_wti('error','avhclex writing avhrr 1B header'
     &      ,ios)
          call aappexit(2)
      endif
      close(luavh,iostat=ios)
      if (ios.ne.0) then
         call ml_wti('notice','avhclex closing avhrr 1B file'
     &    ,ios)
      endif
      return
      end
