      subroutine avhclin(avh_cloptn)
!+
!NOM/NAME $Id: avhclin.F 47 2006-08-21 08:44:41Z frna $
! avhclin 
!
!BUT/PURPOSE 
! avhclin opens and reads the start program options for avhrcl
! and initializes work arrays
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!  
!PROPRIETAIRE/OWNER 
! Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0      Sept. 95      no             Marcel Derrien
!
!         
!ARGUMENTS
!
!       output : integer avh_cloptn(2)  ! options for avhrcl
!               avh_cloptn(1) -- 1  for AVHRR earth location option
!                                0  no earth location requested
!               avh_cloptn(2) -- 1  for AVHRR calibration option
!                                0  no calibration requested 
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
!    
!arguments
        integer avh_cloptn(2)       ! options for avhrcl
!commons
#include "avhrcl.h"
#include "cavh_wrk.h"
#include "c_1bnav.h"
!               luavh       logical unit for AVHRR 1B file
!               lupar         logical unit for the calibration
!                                   parameters file
!               lustat        logical unit for the output statistics 
!                                           file
!               lusatpos      logical unit for the satpos file
!               luclock       logical unit for the clock error file
!local variables
       integer ios,i
       integer optn(7)
       integer sblock
!-
       read(*,*,iostat=ios ) optn
       if(ios.ne.0) then
         call ml_wti('error','avhclin reading options',ios)
         call aappexit(2)
       endif
!
!     check input
      do i=1,2
        avh_cloptn(i)=optn(i)
        if(avh_cloptn(i).ne.0.and.avh_cloptn(i).ne.1) then
         call ml_wti('error','avhclin bad option number',i)
         call ml_wti('info','obtained value',avh_cloptn(i))
         call aappexit(2)
        endif 
      enddo
      do i=3,7
        if(optn(i).lt.0.or.optn(i).gt.255) then
         call ml_wti('error','avhclin bad option number',i)
         call ml_wti('info','obtained value',optn(i))
         call aappexit(2)
        endif 
      enddo
      
      luavh = optn(3)
      lupar = optn(4)
      lustat = optn(5)
      lusatpos = optn(6)
      luclock = optn(7)
        read(*,*,iostat=ios) yaw, roll, pitch
        if(ios.ne.0) then
          call ml_wti('error',
     &       'while reading attitude values I/O status',ios)
          call ml_wt('error','avhrcl aborted')
          call aappexit(1)
        endif
!       convert the values in radians
        yaw = yaw*1.d-3
        roll = roll*1.d-3
        pitch = pitch*1.d-3
!     ---------------------------
!     initialize sub-block arrays
!     ---------------------------
      do sblock =1,avh_mxsblock
        ch3_val(sblock)=0
        flag_coe(sblock)=.false.
        do i = 1,3
          sb_k1(i,sblock)=0.
          sb_k2(i,sblock)=0.
          sb_k3(i,sblock)=0.
        enddo
!     ----------------------------
!     initialize cumulative arrays
!     ----------------------------

      enddo


      return
      end
