      subroutine amedian(a,n,median)
!+
!NOM/NAME $Id: amedian.F 25 2006-02-03 15:43:53Z frna $
!
!------------------------------------------------------------------------------
!BUT/PURPOSE
!     Calculate the median of an array
!
!DESCRIPTION
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions
!
!PROPRIETAIRE/OWNER
!     Nigel ATKINSON
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES)
!(version   date      comment           <author>)
! 1.0     June 96         no             N.Atkinson
!
!ARGUMENTS
!      a(*)               Real       Input array
!      n                  Integer    Number of values to use
!      median             Real       Median value (returned by routine)
!
!#########################################################################
! COPYRIGHT        THE CONTENTS OF THIS FILE ARE CROWN COPYRIGHT. THE
!                  SOFTWARE, DATA AND OTHER PROPRIETARY INFORMATION
!                  CONTAINED THEREIN IS SUPPLIED FOR BONAFIDE RESEARCH
!                  PURPOSES. COMMERCIAL OR BUSINESS USE IS NOT PERMITTED
!                  WITHOUT THE WRITTEN AUTHORITY OF THE U.K. MET. OFFICE.
!                  AT LONDON RD., BRACKNELL, BERKS, RG12 2SZ, U.K.
!#########################################################################

!--DECLARATIONS---------------------------------------------------------------
      implicit none
!
      real a(*),median
      integer i,j,n,hi,lo,same

      do 10 i=1,n
        median=a(i)
        hi=0
        lo=0
        same=0
        do 20 j=1,n
          if (a(j).gt.median) then
            hi=hi+1
          else
            if (a(j).lt.median) then
              lo=lo+1
            else
              same=same+1
            endif
          endif
   20   continue
        if (abs(hi-lo).le.same) go to 100
   10 continue
  100 return
      end
