      subroutine redsmp(iscan,ichan,calsmp,scmean,sampok)
!+
!NOM/NAME $Id: redsmp.F 25 2006-02-03 15:43:53Z frna $
!
!------------------------------------------------------------------------------
!BUT/PURPOSE 
!     This module tries to compute from the two samples 
!     closest to the mean the average of the two saamples 
!     if they are within the defined 3 times standard deviation 
!     difference. If they are within the difference the mean
!     value is computed. If they are not the sampok flag is set
!     false so that this scan line for this channel is not used in the
!     subsequent caibration.
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER  
!     Roger SAUNDERS
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0      Dec 95      no             R.Saunders
!         
!ARGUMENTS  iscan  - scan line number
!           ichan  - channel number (1-5)
!           calsmp(24,mxlin) - scan mean internal target counts
!           scmean - scan mean counts
!           sampok(5,mxlin)- calibration ok flag 
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!#########################################################################
! COPYRIGHT        THE CONTENTS OF THIS FILE ARE CROWN COPYRIGHT. THE
!                  SOFTWARE, DATA AND OTHER PROPRIETARY INFORMATION
!                  CONTAINED THEREIN IS SUPPLIED FOR BONAFIDE RESEARCH
!                  PURPOSES. COMMERCIAL OR BUSINESS USE IS NOT PERMITTED
!                  WITHOUT THE WRITTEN AUTHORITY OF THE U.K. MET. OFFICE.
!                  AT LONDON RD., BRACKNELL, BERKS, RG12 2SZ, U.K.
!#########################################################################

!--DECLARATIONS----------------------------------------------------------------
      implicit none                                                     
!
! includes/commons
#include "amb_cinit.h"
#include "ambclin.h"
#include "amb1b.h"
#include "ambscn.h"
!
! local variables
      integer iv,is1,is2,ichan,iscan    !index of loops
      real atest(2),scmean,amax,amin
      integer*4 calsmp(24,mxlin)
      logical*1 sampok(5,mxlin)
!
      amax = 0.0                                  
      amin = 99999.
      atest(1) = 0.0
      atest(2) = 0.0
!      
      do 30 is1 = 1 , nview 
        iv = (is1-1)*6+ichan+1 
        amax = max(real(calsmp(iv,iscan)),amax)
        amin = min(real(calsmp(iv,iscan)),amin)
 30   continue
      is1 = 0
      do 40 is2 = 1 ,  nview
        iv = (is2-1)*6+ichan+1 
        if(calsmp(iv,iscan).eq.amax)go to 40
        if(calsmp(iv,iscan).eq.amin)go to 40
        is1 = is1 +1
        atest(is1) = calsmp(iv,iscan)
 40   continue
      if ( is1.lt.2 .or. (atest(1)-atest(2)).gt.dcount(ichan))then
         sampok(ichan,iscan)=.false.     ! give up with this line
      else
         scmean = (atest(1)+atest(2))/2.  ! 2 samples OK! will use
      endif
!
      return
      end
