!+
!NOM/NAME $Id: h_bright.F 25 2006-02-03 15:43:53Z frna $
!
      real function h_bright(r,l,ier)
!BUT/PURPOSE 
! convert a hirs channel l radiance into brightness temperature
! using band correction coefficients and central wave numbers
! already read from hirs calbration coefficient file
! by subroutine h_pfini
!
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER
!  Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment                 <author>)
!  1.0      15/09/95   initial                 Marcel Derrien
!      
!ARGUMENTS 
!     input real r
!     input integer l channel number
!     output real brightness temperature
!     output ier exit status 0 =ok
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!      
!         
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
!
!DECLARATIONS
!
      implicit none                                                     
! 
!    
!
!arguments
      real r
      integer l
      integer ier
!commons 
#include "cinit.h"
        double precision fk1(20),fk2(20) 
        common/plctn/fk1,fk2
!functions

!local variables
      real alge,expn,tt
      integer k

!functions
      intrinsic alog
      save
!-
      ier = 1
      k =l 
      h_bright = 0.0
      if (k.ge.1 .or. k.le.19) then
        if(r.gt.0.0001) then
          expn = fk1(k)/r + 1.
          if (expn.ge.1.) then
            alge = alog(expn)
            if (alge.ge.1.) then 
              tt = fk2(k)/alge
              h_bright = (tt-bdcorr(k,1))/bdcorr(k,2)
              ier = 0
            endif
          endif
        endif
      endif
      return
      end
