        subroutine h_loc
!+
!NOM/NAME $Id: h_loc.F 25 2006-02-03 15:43:53Z frna $
!
!------------------------------------------------------------------------------
!BUT/PURPOSE 
!     This module writes in the level1b file, header and records.
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER  
!     Tiphaine LABROT
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0      dec 95       no              T. LABROT
! 1.1      May  98    modified to conform to NOAA format l1b release (TL)
! 1.2      Dec 00     change message for clock error (PB)
!
!         
!ARGUMENTS 
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
!------------------------------------------------------------------------------

!--DECLARATIONS----------------------------------------------------------------

      implicit none                                                     

 
! includes/commons
#include "hrsparam.h"
#include "hrs1bhd.h"
#include "hrs1bdt.h"
#include "hrs1bdts.h"
#include "hclin.h"
#include "c_1bnav.h"

! local variables
       integer scn
       integer iqscn(3)
       integer jdate
       double precision ijscn
       double precision ijstrt
       logical clock_cor_ind

!functions
       integer*2 gp_gb16
!-
       iqscn(1)=hrs_scnlinyr(1)
       iqscn(2)=hrs_scnlindy(1)
       iqscn(3)=hrs_scnlintime(1)
       call xiqj(iqscn,ijstrt)
!
!      check if clock error not already applied 
!      if not we must correct
!      the current scan line times when computing earth location
!      ---------------------------------------------------------
       if(gp_gb16(hrs_scnlinf(1),14).eq.0) then
         ijstrt=ijstrt-errclock/86400.
         clock_cor_ind=.true.
         call ml_wt('info','clock error correction is valid')
         call ml_wt('info','datation will be corrected in this run')
       else
         clock_cor_ind=.false.
         call ml_wt('info','times are already corrected')
       endif


        do scn = 1,hrs_h_scnlin

           if(clock_cor_ind) then
!          -------------------------------
!          clock error correction to apply
!          and flag bit 14 in scnlinbit
!          -------------------------------
             iqscn(1)=hrs_scnlinyr(scn)
             iqscn(2)=hrs_scnlindy(scn)
             iqscn(3)=hrs_scnlintime(scn)
             call xiqj(iqscn,ijscn)
             ijscn=ijscn-errclock/86400.
             call xijq(ijscn,iqscn)
             hrs_scnlinyr(scn) = iqscn(1)
             hrs_scnlindy(scn) = iqscn(2)
             hrs_scnlintime(scn) = iqscn(3)
             call gp_sb16(hrs_scnlinf(scn),14,1)
             hrs_clockdrift(scn)=1000.*errclock
          endif

          call nav_1blin(ijstrt, 5, scn,
     &     hrs_scnlinf, hrs_qualind,
     &     hrs_attangtime, hrs_rollang , hrs_pitchang ,
     &     hrs_yawang , 
     &     hrs_navstat ,
     &     hrs_scalti ,
     &     hrs_ang(1,scn) , hrs_pos(1,scn) )
        enddo
!      --------------------------------------------------
!      update header times according to the clock_cor_ind
!      --------------------------------------------------
       if(clock_cor_ind) then
         iqscn(1)=hrs_scnlinyr(1)
         iqscn(2)=hrs_scnlindy(1)
         call xdqj(iqscn,jdate)
         hrs_h_startdatajd = jdate 
         hrs_h_startdatayr = hrs_scnlinyr(1)
         hrs_h_startdatady = hrs_scnlindy(1)
         hrs_h_startdatatime = hrs_scnlintime(1)
         iqscn(1)=hrs_scnlinyr(hrs_h_scnlin)
         iqscn(2)=hrs_scnlindy(hrs_h_scnlin)
         call xdqj(iqscn,jdate)
         hrs_h_enddatajd = jdate 
         hrs_h_enddatayr = hrs_scnlinyr(hrs_h_scnlin)
         hrs_h_enddatady = hrs_scnlindy(hrs_h_scnlin)
         hrs_h_enddatatime = hrs_scnlintime(hrs_h_scnlin)
       endif

       return
       end
