        subroutine h_pfinit(lu,satid)
!+
!NOM/NAME $Id: h_pfinit.F 25 2006-02-03 15:43:53Z frna $
!
!------------------------------------------------------------------------------
!BUT/PURPOSE 
!     This module opens and reads the calibration coefficients files. 
!     to initialize the values for 
!        planck function 
!        and brightness temperature calculation
!        using central wave numbers
!        and band correction coefficients (see NESS 107)
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!      
!PROPRIETAIRE/OWNER  
!     Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0      12/09/95     initial          M. Derrien
!         
!ARGUMENTS 
!     input:
!      lu       logical unit for coefficient file
!      satid    spacecraft number (order)
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!     
!   
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
!DECLARATIONS
      implicit none                                                      
! argument variables
      integer lu 
      integer satid 
! local variables
      integer versnb,versyr,versday,ch20year,ch20day 
      double precision f2,lambda  
        integer i
! includes/commons
#include "cinit.h"
      double precision fk1(20),fk2(20)
      common/plctn/fk1,fk2
!
!-
           
!Open and read calibration coefficients file

        call h_calibcoeffile(lu,satid,versnb,versyr,versday,
     &                             ch20year,ch20day,f2,lambda)

! Initialize plnctn common
       do i=1,19
         fk1(i)=plck(1)*(cwave(i)**3)
         fk2(i)=plck(2)*cwave(i)
       enddo
      end
