        subroutine hclin
!+
!NOM/NAME $Id: hclin.F 47 2006-08-21 08:44:41Z frna $
!
!------------------------------------------------------------------------------
!BUT/PURPOSE 
!     This module initializes the navigation and calibration tasks. 
!     It reads the input options (hrs_cloptn)
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!  
!PROPRIETAIRE/OWNER  
!     Tiphaine LABROT
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0      June 95      no              T. LABROT
! 1.1      Febr 97   A never used option has been suppressed  (TL)
!         
!ARGUMENTS 
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
!------------------------------------------------------------------------------

!--DECLARATIONS----------------------------------------------------------------

      implicit none 
                                                     

! includes/commons
#include "hclin.h"      
#include "c_1bnav.h"

! argument variables 

! local variables
      integer hrs_cloptn(11) 
!      hrs_cloptn(1) -- 1 for HIRS navigation/localisation (0 if not for)
!      hrs_cloptn(2) -- 1 for HIRS calibration (0 if not for)
!      hrs_cloptn(3) -- 1 for calib statistics file (0 if not for)
!      hrs_cloptn(4) -- logical unit for HIRS log/debug file
!      hrs_cloptn(5) -- logical unit for calib statistics file
!      hrs_cloptn(6) -- logical unit HIRS level1b file
!      hrs_cloptn(7) -- logical unit for SATPOS file
!      hrs_cloptn(8) -- logical unit for the clock drift data file
!      hrs_cloptn(9) -- logical unit for HIRS calibration coefficients file
!      hrs_cloptn(10)-- logical unit for HIRS calib/test coefficients file
!      hrs_cloptn(11)-- print option in the log.file
!                       = 0, nothing is printed
!                       = 1, entering routines and few values of the main
!                            parameters are printed
!                       = 2, computed values that would help in debugging 
!                            are printed

      integer i         !index of loop
      integer ios       !input/output status
      character*80 text !variable text

!--END OF DECLARATIONS---------------------------------------------------------

      read(*,*) hrs_cloptn

! Check hrs_cloptn values
      do i = 1,3
        if(hrs_cloptn(i).gt.1 .or. hrs_cloptn(i).lt.0) then
          text='**Invalid option number--correct input**'
          call ml_wti('error',text,hrs_cloptn(i))
          call aappexit(2)
        endif
      enddo

      if((hrs_cloptn(11).ne.0).and.(hrs_cloptn(11).ne.1).and.
     & (hrs_cloptn(11).ne.2)) then
         text='**Invalid print option value--correct input**'
         call ml_wt('error',text)
         call aappexit(2)
      endif

!
      hrs_lflg    = hrs_cloptn(1)
      hrs_cflg    = hrs_cloptn(2)
      hrs_stflg   = hrs_cloptn(3)

      hrs_cllgu   = hrs_cloptn(4)
      hrs_l1bu    = hrs_cloptn(6)
      iprint      = hrs_cloptn(11)

      if (hrs_stflg.eq.1) then
        hrs_stu    = hrs_cloptn(5)
      else
        hrs_stu   = 0 
      endif
     
      if (hrs_lflg.eq.1) then
        satposu     = hrs_cloptn(7)
        ckdriftu    = hrs_cloptn(8)

        read(*,*,iostat=ios) yaw, roll, pitch
        if(ios.ne.0) then
          call ml_wti('error',
     &       'while reading attitude values I/O status',ios)
          call ml_wt('error','hirscl aborted')
          call aappexit(1)
        endif
! convert the values in radians
        yaw = yaw*1.d-3
        roll = roll*1.d-3
        pitch = pitch*1.d-3
      endif
!
      if (hrs_cflg.eq.1) then
        hrs_coefu   = hrs_cloptn(9)
        hrs_tstcoefu= hrs_cloptn(10)
      endif

      return
      end








  
