        SUBROUTINE hclexit_algoV4

!------------------------------------------------------------------------------
!NAME $Id: hclexit_algoV4.F 55 2006-09-21 08:35:34Z frna $
!
!PURPOSE 
!    This module closes  the log/debug file (if it has been opened).
!    It also closes the HIRS.level1b.
!
!HISTORY (CHANGES) 
!   (version     date         comment           <author>)
!      1.0     January 05     creation          T. Labrot (MF)
!
!CURRENT CODE OWNER: SAF NWP
!
!COPYRIGHT
!    This software was developed within the context of
!    the EUMETSAT Satellite Application Facility on
!    Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 25 November 1998, between
!    EUMETSAT and the Met Office, UK, by one or more partners
!    within the NWP SAF. The partners in the NWP SAF are
!    the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2005, EUMETSAT, All Rights Reserved.              
!         
!ARGUMENTS 
!
!UPDATED ELEMENTS OF INCLUDES
!    
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!------------------------------------------------------------------------------

!--DECLARATIONS----------------------------------------------------------------

      IMPLICIT NONE                                                     

! includes/commons
#include "hclin_algoV4.h"

! local variables
      CHARACTER*80 text  !variable text
      
!--END OF DECLARATIONS---------------------------------------------------------

      IF (iprint.GE.1) WRITE(hrs_cllgu,*)
      IF (iprint.GE.2) WRITE(hrs_cllgu,*) '***************************'
      IF (iprint.GE.1) WRITE(hrs_cllgu,*) '**  SUB. HCLEXIT_ALGOV4  **'
      IF (iprint.GE.1) WRITE(hrs_cllgu,*) '***************************'
      IF (iprint.GE.1) WRITE(hrs_cllgu,*)
      
! Closes the HIRS-level1b file
      CLOSE(hrs_l1bu,err=900)
      IF (iprint.GE.1)  WRITE(hrs_cllgu,*)
     &      'the HIRS-l1b file has been closed'
      text='The HIRS-level1b file has been closed'
      CALL ml_wt('info',text)
      
! Closes the log/debug file
      IF (iprint.GE.1) THEN
        CLOSE(hrs_cllgu,err=901)
        text='The log/debug file has been closed'
        CALL ml_wt('info',text)
      ENDIF
      
      GO TO 200

 900  WRITE(hrs_cllgu,*)'Error closing HIRS_level1b file'
      text='Error closing HIRS_level1b file'
      CALL ml_wt('error',text)
      text='hclexit_algoV4 aborted'
      CALL ml_wt('error',text)
      CALL aappexit(2)
      
 901  WRITE(hrs_cllgu,*)'Error closing log/debug file'
      text='Error closing log/debug file'
      CALL ml_wt('error',text)
      text='hclexit_algoV4 aborted'
      CALL ml_wt('error',text)
      CALL aappexit(2)

 200  RETURN
      END
      





