        SUBROUTINE hgetl1belement_algoV4

!------------------------------------------------------------------------------
!NAME $Id: hgetl1belement_algoV4.F 25 2006-02-03 15:43:53Z frna $
!
!PURPOSE 
!    This module gets the elements of the HIRS level 1b commons that are useful 
!    for the calibration task. It does the difference between the 2 available 
!    formats of level1b file. 
!
!DESCRIPTION 
!       
!HISTORY (CHANGES) 
!   (version   date          comment           <author>)
!     1.0     January 05     creation          T. Labrot (MF)
!
!CURRENT CODE OWNER: SAF NWP
!
!COPYRIGHT
!    This software was developed within the context of
!    the EUMETSAT Satellite Application Facility on
!    Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 25 November 1998, between
!    EUMETSAT and the Met Office, UK, by one or more partners
!    within the NWP SAF. The partners in the NWP SAF are
!    the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2005, EUMETSAT, All Rights Reserved.
!                      
!ARGUMENTS 
!
!UPDATED ELEMENTS OF INCLUDES  
!    All the elements Inputs and Inputs/outputs in the include hrs1belem_algoV4.h
!    
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!------------------------------------------------------------------------------

!--DECLARATIONS----------------------------------------------------------------

      IMPLICIT NONE                                                     

! includes/commons
#include "hrsparam_algoV4.h"
#include "hclin_algoV4.h"
#include "hrs1belem_algoV4.h"
#include "hrs1bhd.h"
#include "hrs1bdts.h"

! local variables
      INTEGER i,j,ilin   !index of loops
                
!--END OF DECLARATIONS---------------------------------------------------------


      IF (iprint.GE.1) WRITE(hrs_cllgu,*)
      IF (iprint.GE.2) WRITE(hrs_cllgu,*) '***************************'
      IF (iprint.GE.1) WRITE(hrs_cllgu,*) '*SUB.HGETL1BELEMENT_ALGOV4*'
      IF (iprint.GE.1) WRITE(hrs_cllgu,*) '***************************'
      IF (iprint.GE.1) WRITE(hrs_cllgu,*)
      
      hsiteid = hrs_h_siteid
      hhdrcnt = hrs_h_hdrcnt 
      hprblkid= hrs_h_prblkid   
      hsatid  = hrs_h_satid
      hstartdatajd = hrs_h_startdatajd
      hstatchrecnb = hrs_h_statchrecnb
      hinststat1   = hrs_h_inststat1
      hscnlin      = hrs_h_scnlin
        
      DO ilin=1,hscnlin
        
        hscnlinyr(ilin)  = hrs_scnlinyr(ilin)
        hscnlindy(ilin)  = hrs_scnlindy(ilin)
        hscnlintime(ilin)= hrs_scnlintime(ilin)
        hscnlinf(ilin)   = hrs_scnlinf(ilin)
        hqualind(ilin)   = hrs_qualind(ilin)        

        DO i=1,168
          hang(i,ilin) = hrs_ang(i,ilin)
        ENDDO

        DO i=1,112
          hpos(i,ilin) = hrs_pos(i,ilin)
        ENDDO
          
        DO j=1,24
          DO i=0,63 
            helem(j,i,ilin) = hrs_elem(j,i,ilin)
          ENDDO
        ENDDO      

      ENDDO     !DO ilin=1,hscnlin      
        
      RETURN
      END


