!+
!NOM/NAME $Id: m_bright.F 25 2006-02-03 15:43:53Z frna $
!
      real function m_bright(r,l,ier)
!BUT/PURPOSE 
! convert a msu channel l radiance into brightness temperature
! using central wave numbers
! already read from msu calibration coefficient file
! by subroutine m_pfinit
!
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER
!  Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment                 <author>)
!  1.0      08/03/96   initial                 Marcel Derrien
!      
!ARGUMENTS 
!     input real r
!     input integer l channel number
!     output real brightness temperature
!     output ier exit status 0 =ok
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!      
!         
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
!
!DECLARATIONS
!
      implicit none                                                     
! 
!    
!
!arguments
      real r
      integer l
      integer ier
!commons 
#include "msuparam.h"
#include "mcinit.h"
        double precision fk1(4),fk2(4) 
        common/msu_plnctn/fk1,fk2
!functions

!local variables
      real alge,expn
      integer k

!functions
      intrinsic alog
      save
!-
      ier = 1
      k =l 
      m_bright = 0.0
      if (k.ge.1 .or. k.le.4) then
        if(r.gt.0.00001) then
          expn = fk1(k)/r + 1.
          if (expn.ge.1.) then
            alge = alog(expn)
              m_bright = fk2(k)/alge
              ier = 0
          endif
        endif
      endif
      return
      end
