        subroutine m_pfinit(lu,satid)
!+
!NOM/NAME $Id: m_pfinit.F 25 2006-02-03 15:43:53Z frna $
!
!------------------------------------------------------------------------------
!BUT/PURPOSE 
!     This module opens and reads the calibration coefficients files. 
!     to initialize the values for 
!        planck function 
!        and brightness temperature calculation
!        using central wave numbers
!        and band correction coefficients (see NESS 107)
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!      
!PROPRIETAIRE/OWNER  
!     Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0      08/03/96     initial          M. Derrien
!         
!ARGUMENTS 
!     input:
!      lu       logical unit for coefficient file
!      satid    spacecraft number (order)
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!     
!   
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
!DECLARATIONS
      implicit none                                                      
! argument variables
      integer lu 
      integer satid 
! local variables
      integer versnb,versyr,versday
        integer i
! includes/commons
#include "msuparam.h"
#include "mcinit.h"
      double precision fk1(4),fk2(4)
      common/msu_plnctn/fk1,fk2
!
!-
           
!Open and read calibration coefficients file

        call m_calibcoeffile(lu,satid,versnb,versyr,versday)

! Initialize msu_plnctn common
       do i=1,msu_mxchn
        
         fk1(i)=plck(1)*(cwave(i)**3)
         fk2(i)=plck(2)*cwave(i)

       enddo
      end
