        subroutine m_planck(ich,temp,rad)
!+
!NOM/NAME $Id: m_planck.F 25 2006-02-03 15:43:53Z frna $
!
!------------------------------------------------------------------------------
!BUT/PURPOSE 
!     Apply the Planck's function for a given channel and a given temperature
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!             
!PROPRIETAIRE/OWNER  
!     Tiphaine LABROT
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0      Nov. 95       no             T. LABROT
!         
!ARGUMENTS 
!     input :
!      integer ich
!      dble prec temp  
!
!     output:
!      dble prec rad 
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!    
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
!------------------------------------------------------------------------------


!--DECLARATIONS----------------------------------------------------------------

      implicit none   
                                                         
      
!includes/commons
#include "msuparam.h"
#include "mclin.h"
#include "mcinit.h"

! argument variables
      integer ich
      double precision temp,rad
      
! local variables
      double precision planck1,planck2

!--END OF DECLARATIONS----------------------------------------------------------

      planck1 = plck(1)*(cwave(ich)**3)
      planck2 = dexp( plck(2)*cwave(ich)/temp)-1
      rad     = planck1 / planck2

      return
      end
