      subroutine m_statsum
!+
!NOM/NAME $Id: m_statsum.F 25 2006-02-03 15:43:53Z frna $
!
!------------------------------------------------------------------------------
!BUT/PURPOSE
!      
!     This module maintains counters in order to calculate final statistical
!     values.
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!  
!PROPRIETAIRE/OWNER 
!     Tiphaine LABROT
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0      Dec. 95      no              T. LABROT
! 1.1      April 96   the error "if(prtid.eq.1)then" for PRT2B data has been
!                     corrected:"if(prtid.eq.4)then"  (TL)
!         
!ARGUMENTS
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
!------------------------------------------------------------------------------
!--DECLARATIONS----------------------------------------------------------------

      implicit none                                                     


!commons
#include "mclin.h"
#include "msuparam.h"
#include "missingval.h"
#include "mstat.h"

! argument variables 
 
! local variables
       integer ich
       logical first
       data first /.true./
       save first
       
! functions

!--END OF DECLARATIONS---------------------------------------------------------

      if(iprint.ge.2)write(msu_cllgu,*)'  *subroutine M_STATSUM*' 
     
      if(first) then
        talosum=0.d+0
        talodevsum=0.d+0
        tahisum=0.d+0
        tahidevsum=0.d+0
        gtalonb=0
        gtahinb=0
        inftalonb=0
        inftahinb=0
        suptalonb=0
        suptahinb=0
        talohinb=0  
        tblosum=0.d+0
        tblodevsum=0.d+0
        tbhisum=0.d+0
        tbhidevsum=0.d+0
        gtblonb=0
        gtbhinb=0
        inftblonb=0
        inftbhinb=0
        suptblonb=0
        suptbhinb=0
        tblohinb=0 
        
        prt1asum=0.d+0
        prt1adevsum=0.d+0
        prt1bsum=0.0+0
        prt1bdevsum=0.d+0
        prt2asum=0.d+0
        prt2adevsum=0.d+0
        prt2bsum=0.d+0
        prt2bdevsum=0.d+0
        gprt1anb=0
        gprt1bnb=0
        gprt2anb=0
        gprt2bnb=0
        misprt1anb=0
        misprt1bnb=0
        misprt2anb=0
        misprt2bnb=0
        
        talomn=0.d+0
        talodev=0.d+0
        tahimn=0.d+0
        tahidev=0.d+0
        talonb=0
        tahinb=0
        inftalopct=0.
        suptalopct=0.
        inftahipct=0.
        suptahipct=0.
        tblomn=0.d+0
        tblodev=0.d+0
        tbhimn=0.d+0
        tbhidev=0.d+0
        tblonb=0
        tbhinb=0
        inftblopct=0.
        suptblopct=0.
        inftbhipct=0.
        suptbhipct=0. 
        talohipct=0.
        tblohipct=0.
        prt1amn=0.d+0
        prt1adev=0.d+0    
        prt1bmn=0.d+0
        prt1bdev=0.d+0    
        prt2amn=0.d+0
        prt2adev=0.d+0    
        prt2bmn=0.d+0
        prt2bdev=0.d+0   
        misprt1apct=0.
        misprt1bpct=0.
        misprt2apct=0.
        misprt2bpct=0.
        prt1anb=0
        prt1bnb=0
        prt2anb=0
        prt2bnb=0 
        
        do ich=1,msu_mxchn
        
          misspnb(ich)=0
          ejectspnb(ich)=0
          gspnb(ich)=0
          spcntsum(ich)=0.d+0
          spcntdevsum(ich)=0.d+0
          
          mistgnb(ich)=0
          ejecttgnb(ich)=0
          gtgnb(ich)=0
          tgcntsum(ich)=0.d+0
          tgcntdevsum(ich)=0.d+0
          
          missppct(ich)=0.
          ejectsppct(ich)=0.
          gsppct(ich)=0.
          spnb(ich)=0
          spcntmn(ich)=0.d+0
          spcntdev(ich)=0.d+0
          
          mistgpct(ich)=0.
          ejecttgpct(ich)=0.
          gtgpct(ich)=0.
          tgnb(ich)=0
          tgcntmn(ich)=0.d+0
          tgcntdev(ich)=0.d+0
        enddo       
                
        first=.false.
      endif
      
!-----------------------------------------------------------------------
! For high and low calibration reference points for electronic system A 
!-----------------------------------------------------------------------
      if(prtid.eq.1) then
        if(infloflg.eq.0.and.suploflg.eq.0.and.zeroflg.eq.0) then
          talosum=talosum+txcallo
          talodevsum=talodevsum+txcallo*txcallo
          gtalonb=gtalonb+1
        endif
        if(infloflg.eq.1) inftalonb=inftalonb+1
        if(suploflg.eq.1) suptalonb=suptalonb+1
        if(infhiflg.eq.0.and.suphiflg.eq.0.and.zeroflg.eq.0) then
          tahisum=tahisum+txcalhi
          tahidevsum=tahidevsum+txcalhi*txcalhi
          gtahinb=gtahinb+1
        endif
        if(infhiflg.eq.1) inftahinb=inftahinb+1
        if(suphiflg.eq.1) suptahinb=suptahinb+1
        if(zeroflg.eq.1) talohinb=talohinb+1
      endif
      
!-----------------------------------------------------------------------
! For high and low calibration reference points for electronic system B 
!-----------------------------------------------------------------------
      if(prtid.eq.2) then
        if(infloflg.eq.0.and.suploflg.eq.0.and.zeroflg.eq.0) then
          tblosum=tblosum+txcallo
          tblodevsum=tblodevsum+txcallo*txcallo          
          gtblonb=gtblonb+1
        endif
        if(infloflg.eq.1) inftblonb=inftblonb+1
        if(suploflg.eq.1) suptblonb=suptblonb+1
        if(infhiflg.eq.0.and.suphiflg.eq.0.and.zeroflg.eq.0) then
          tbhisum=tbhisum+txcalhi
          tbhidevsum=tbhidevsum+txcalhi*txcalhi
          gtbhinb=gtbhinb+1
        endif
        if(infhiflg.eq.1) inftbhinb=inftbhinb+1
        if(suphiflg.eq.1) suptbhinb=suptbhinb+1
        if(zeroflg.eq.1) tblohinb=tblohinb+1
      endif
        
!-----------------------------------------------------------------------
! For PRT1A data
!-----------------------------------------------------------------------
      if(prtid.eq.1) then
        if(flg.eq.0) then
          prt1asum=prt1asum+prt
          prt1adevsum=prt1adevsum + prt*prt
          gprt1anb=gprt1anb+1
        endif
        if(misprtflg.eq.1) misprt1anb=misprt1anb+1
      endif
 
!-----------------------------------------------------------------------
! For PRT1B data
!-----------------------------------------------------------------------
      if(prtid.eq.2) then
        if(flg.eq.0) then
          prt1bsum=prt1bsum+prt
          prt1bdevsum=prt1bdevsum + prt*prt
          gprt1bnb=gprt1bnb+1
        endif
        if(misprtflg.eq.1) misprt1bnb=misprt1bnb+1
      endif
      
!-----------------------------------------------------------------------
! For PRT2A data
!-----------------------------------------------------------------------
      if(prtid.eq.3) then
        if(flg.eq.0) then
          prt2asum=prt2asum+prt
          prt2adevsum=prt2adevsum + prt*prt
          gprt2anb=gprt2anb+1
        endif
        if(misprtflg.eq.1) misprt2anb=misprt2anb+1
      endif
      
!-----------------------------------------------------------------------
! For PRT2B data
!-----------------------------------------------------------------------
      if(prtid.eq.4) then
        if(flg.eq.0) then
          prt2bsum=prt2bsum+prt
          prt2bdevsum=prt2bdevsum + prt*prt
          gprt2bnb=gprt2bnb+1
        endif
        if(misprtflg.eq.1) misprt2bnb=misprt2bnb+1
      endif

!-----------------------------------------------------------------------
! For space counts
!-----------------------------------------------------------------------
      if(ind.eq.91) then
        if(miscntflg.eq.1) misspnb(ch)=misspnb(ch)+1
        if(ejectcntflg.eq.1) ejectspnb(ch)=ejectspnb(ch)+1
        if(flag.eq.0) then
          spcntsum(ch)=spcntsum(ch)+count
          spcntdevsum(ch)=spcntdevsum(ch)+count*count
          gspnb(ch)=gspnb(ch)+1
        endif
      endif
      
!-----------------------------------------------------------------------
! For target1 and target2 counts
!-----------------------------------------------------------------------
      if(ind.eq.99) then
        if(miscntflg.eq.1) mistgnb(ch)=mistgnb(ch)+1
        if(ejectcntflg.eq.1) ejecttgnb(ch)=ejecttgnb(ch)+1
        if(flag.eq.0) then
          tgcntsum(ch)=tgcntsum(ch)+count
          tgcntdevsum(ch)=tgcntdevsum(ch)+count*count
          gtgnb(ch)=gtgnb(ch)+1
        endif
      endif
      
      return
      end
