        subroutine mclexit
!+
!NOM/NAME $Id: mclexit.F 47 2006-08-21 08:44:41Z frna $
!
!------------------------------------------------------------------------------
!BUT/PURPOSE 
!     This module closes  the log/debug file (if it has been opened).
!     It also closes the MSU.level1b file.
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER  
!     Tiphaine LABROT
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0      Nov. 95      no              T. LABROT
!         
!ARGUMENTS 
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
!------------------------------------------------------------------------------

!--DECLARATIONS----------------------------------------------------------------
      implicit none                                                     


! includes/commons
#include "mclin.h"

! local variables
      character*80 text  !variable text
      
!--END OF DECLARATIONS---------------------------------------------------------

      if (iprint.ge.1) write(msu_cllgu,*)
      if (iprint.ge.2) write(msu_cllgu,*) '***************************'
      if (iprint.ge.1) write(msu_cllgu,*) '**   SUBROUTINE MCLEXIT  **'
      if (iprint.ge.2) write(msu_cllgu,*) '***************************'
      
! Close the MSU-level1b file
      close(msu_l1bu,err=900)
      if(iprint.ge.1) write(msu_cllgu,*)
     &  'the MSU_level1b file has been closed' 
      text='the MSU-level1b file has been closed'
      call ml_wt('info',text)
      
! Close the log/debug file
      if (iprint.ge.1) then
        close(msu_cllgu,err=901)
        text='the log/debug file has been closed'
        call ml_wt('info',text)
      endif
      
      go to 200

 900  write(msu_cllgu,*)'Error closing MSU_level1b file'
      text='Error closing MSU_level1b file'
      call ml_wt('error',text)
      call aappexit(2)
 901  write(msu_cllgu,*)'Error closing log/debug file'
      text='Error closing log/debug file'
      call ml_wt('error',text)
      call aappexit(2)

 200  return
      end





