#!/bin/ksh
#$Id: convert_chrpt.ksh 123 2008-09-02 11:55:18Z frna $
#
# Wrapper script for convert_chrpt.exe
# Converts CHRPT data to a format compatible with that of NOAA HRPT
#
# 29/01/2008 Initial version. NCA
# 27/08/2008 Add -u option for unpacked input. NCA
#

usage(){
  echo 'usage: convert_chrpt [-u] infile outfile day_of_year'
}

. "$AAPP_PREFIX/ATOVS_CONF"

unpacked=0
while getopts u c
do
  case $c in
    u) unpacked=1;;
    *) usage
       exit 2;;
  esac
done
shift `expr $OPTIND - 1`

if [ $# != 3 ]; then
  usage
  exit 1
fi

infile=$1
outfile=$2
daynum=$3

convert_chrpt.exe <<EOF
$infile
$outfile
$daynum
$unpacked
EOF

exit $?
