!+
!NOM/NAME $Id: avhhdu.F 46 2006-08-18 14:39:27Z frna $
!
        subroutine avhhdu(startorb,endorb,satid,iqcur,
     &       orbmf,nbmiscn)
!BUT/PURPOSE 
! update header avhrr 1b variables 
! 
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
! 
!PROPRIETAIRE/OWNER
!  
!Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0        29/3/95  none          Marcel Derrien
! 2.0        12/5/98  last 1B format effects siteid, version... 
! 2.1        20/11/98 correction of TIP source code ( 4 instead of 1)
!                                   T. Labrot
! 2.2        Jun 2006 PM, character*16 l1bscnam + MA, MB, MC, MD in
!                     datasetname
! 2.3        Aug 2006 NCA Use station_id instead of fixed 'WE'
!
!ARGUMENTS 
!       input : startorb ! revolution in which is th beginning of data set
!       input : endorb ! revolution in which is the end of data set
!       input : integer satid   ! satellite id. order number from tiros-n (1)
!       input : integer iqcur(3)
!       input : integer satid   ! satellite id. order number from tiros-n (1)
!       input : integer orbmf! orbit minor frame number ,AVHRR scan line number
!       input : integer nbmiscn ! number of missing scan lines
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
! 
!    
!
!
!arguments
        integer startorb  
        integer endorb   
        integer satid   
        integer iqcur(3)
        integer orbmf
        integer nbmiscn 
!commons
#include "hrptdc.h"
#include "avh1b.h"
#include "nl1b.h"
        logical timok,partip(5),err_frsync
        integer nb_frsync,nb_auxsync
        logical err_auxsync
        common/gqc/timok,partip,err_frsync,nb_frsync,err_auxsync,
     & nb_auxsync
!local variables
        integer iq(3),jdate
        integer ig(7)
        character*22 ic
        character*4 str1
        character*3 str2
        character*5 str3,str4
        character*16 sname
        integer cp_lsc, sname_len
        character*2 rname

        logical ftim
        data ftim/.true./
        save ftim
!functions
        integer l1bscid
        character*16 l1bscnam
!-
!  init to be updated if modification in 1B format
!
       iq(1)= iqcur(1)
       iq(2)= iqcur(2)
       call xdqj(iq,jdate)
         iq(3)=iqcur(3) 
         call xiqg(iq,ig)
         call xigc(ig,ic)
       if(orbmf.eq.1) then
         iq(3)=iqcur(3)
         call xiqg(iq,ig)
         call xigc(ig,ic)
         write(str1,1000) iqcur(1)
1000     format(i4.4)
         write(str2,1001) iqcur(2)
1001     format(i3.3)
         write(str3,1002) startorb
1002     format(i5.5)
         write(str4,1002) endorb
         sname=l1bscnam(satid)
         sname_len = cp_lsc( sname )
         rname=sname(1:1)//sname(sname_len:sname_len)
         call cp_ups(rname)
         avh_h_dataname=loccentre//'.HRPT.'//rname//
     &   '.D'//str1(3:4)//str2//'.S'//ic(11:12)//ic(14:15)//
     &   '.E    .B'//str3//str4(4:5)//'.'//station_id
         avh_h_l1bversnb = libl1bvers
         avh_h_l1bversyr = libl1bversyr
         avh_h_l1bversdy = libl1bversdy
         avh_h_hdrcnt = nb1bhd
!
!
         avh_h_prblkid = 'B'//str3//str4(4:5)
         avh_h_siteid=loccentre
         avh_h_blank=' '
!  we restrict to local hrpt source
         avh_h_datatyp = 3
         avh_h_tipsrc = 4

         avh_h_satid=l1bscid(satid)
         avh_h_startdatajd = jdate 
         avh_h_startdatayr = iqcur(1)
         avh_h_startdatady = iqcur(2)
         avh_h_startdatatime = iqcur(3)
       
       endif
         avh_h_enddatajd = jdate 
         avh_h_enddatayr = iqcur(1)
         avh_h_enddatady = iqcur(2)
         avh_h_enddatatime = iqcur(3)
         avh_h_dataname(27:30)=ic(11:12)//ic(14:15)
       avh_h_scnlin = orbmf
       avh_h_misscnlin = avh_h_misscnlin + nbmiscn
       if(nbmiscn.ne.0) avh_h_datagaps = avh_h_datagaps + 1
       if(.not.err_frsync) avh_h_okdatafr = avh_h_okdatafr + 1 
        if(err_ auxsync) avh_h_auxsyncerrsum  = avh_h_auxsyncerrsum 
     &                     + nb_auxsync
        if(.not.timok.and.ftim) then
!       first occurence of time error sequence if exists
          ftim=.false.
          avh_h_timeseqerr = orbmf + nb1bhd
        endif   
        return
        end
           
