!+
!NOM/NAME $Id: avhrdc.F 25 2006-02-03 15:43:53Z frna $
!
        subroutine avhrdc(opmode,startorb,endorb,isystq,
     &       satid,iqcur,orbmf,nbmiscn,hmfn,hrptmf)
!BUT/PURPOSE 
! 
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER  
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
!   1.2     sept 2003  Change statement for test on noaa klm serie
!                                         P. Brunel
!
!         
!ARGUMENTS 
!       input : integer opmode  !( 0 = off-line, 1= real time)
!       input : startorb ! revolution in which is th beginning of data set
!       input : endorb ! revolution in which is the end of data set
!       input : integer isystq(2) ! system quant. time (tp library)
!       input : integer satid   ! satellite id. order number from tiros-n (1)
!       input : integer iqcur(3) ! current year,day and millsecs.
!       input : integer orbmf! orbit minor frame number ,AVHRR scan line number
!       input : integer nbmiscn ! number of missing scan lines
!       input : integer hmfn ! hrpt minor frame number
!       input : integer*2 hrptmf(11090)  ! hrpt minor frame to process   
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
! 
!    
!
!
!arguments
        integer opmode  
        integer startorb 
        integer endorb 
        integer isystq(2) 
        integer satid   
        integer iqcur(3)
        integer orbmf
        integer nbmiscn 
        integer hmfn
        integer*2 hrptmf(11090)     
!commons
#include "avh1b.h"
        logical timok,partip(5),err_frsync
        integer nb_frsync,nb_auxsync
        logical err_auxsync
        common/gqc/timok,partip,err_frsync,nb_frsync,err_auxsync,
     & nb_auxsync

!local variables
#include "hrptdc.h"
        character*80 txt ! for information to log
        integer id_in    ! noaa id corresponding to satid variable
        integer id_noaak ! noaa id corresponding to Noaa-K == 15
        integer nbit
        integer i
        integer word
        integer ios
        logical resync
        logical ftim
        data ftim/.true./
        data id_noaak/15/
!functions
        !integer genscid
        integer noascid
        logical gp_btn
!-
!--------------------------------
! fill scan line information part
!--------------------------------
        avh_scnlinyr  = iqcur(1)
        avh_scnlindy  = iqcur(2)
        avh_scnlintime = iqcur(3)
        avh_clockdrift = 0
        avh_scnlin = orbmf
!
!      update quality indicators from genqc results
!
        avh_qualind = 0
        avh_scnlinqual = 0
        if(.not.timok) then
! set time sequence error bit to 1 
           nbit = 30
           call gp_bse(avh_qualind,30)
! set data gap bit to 1
           nbit = 29
           if(nbmiscn.ne.0) call gp_bse(avh_qualind,nbit)           
        endif
!if frame sync errors set frame sync bit to 1
        nbit = 25
        if(err_frsync) call gp_bse(avh_qualind,nbit) 
!if tip parity errors set bit for the minor frame
        do i = 1 , 5
          nbit = 10 - i
          if(partip(i)) call gp_bse(avh_qualind,nbit)
        enddo
! update resync bit
        word=hrptmf(7)
        resync= gp_btn(word,2)
        if(resync) then
           nbit = 1
           call gp_bse(avh_qualind,nbit)
        endif
! update count of bit errors in frame sync
        avh_cbiterr=nb_frsync

!-------------------------- end of scan line information part------
!--------------------------
!  fill telemetry data part
!--------------------------
        call avtelm(hrptmf)
!--------------------------
!  fill hrpt video data
!--------------------------
        do i=1,avh_mxhrpchn*avh_mxpix       
          avh_video(i)=hrptmf(i+750)
        enddo
        
        ! test the noaa sc id (12 for noaa12) to
        ! determine if it is a klm serie or not
        id_in = noascid(satid)
        if(id_in .lt. id_noaak .or.hmfn.eq.1) then
        !if(satid.lt.genscid('noaa-k').or.hmfn.eq.1) then
!------------------------------------------------------
!         fill tip minor frame header and cpu telemetry
!------------------------------------------------------
          call avtipg(hrptmf)
        endif
!------------------------------
!       write avhrr data record
!------------------------------
        call avhdtw(luavh,orbmf,ios)
        if(ios.ne.0) then
          write(txt,*)'error in writing avhrr file iostat = ',ios,
     &    ' scan line number ',orbmf
          call ml_wt('warning',txt)
        endif
!------------------------------------------------------
!      update header variables in the avh1bhd common
!------------------------------------------------------
        call avhhdu(startorb,endorb,satid,iqcur,
     &              orbmf,nbmiscn)
           
        return

        end
