!+
!NOM/NAME $Id: avtelm.F 25 2006-02-03 15:43:53Z frna $
!
        subroutine avtelm(hrptmf)
!BUT/PURPOSE 
! fill the telemetry data part in a record of the LAC/HRPT 1B format 
! with the hrpt minor frame,  update the common avh1bdt
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions 
!  
!        it restitutes the 103 first 10 bit words 
!        from HRPT.
!        new release due to 1B format change ( spec. October 95)
!
!      
!PROPRIETAIRE/OWNER
!  
!Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0     28/03/95     none            Marcel Derrien
! 1.1     14/11/95  1B telemetry structure   
!                   is now unpacked    Marcel Derrien
!                  
!ARGUMENTS 
!       input : integer*2 hrptmf(11090)  ! hrpt minor frame to process  
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
! 
!    
!
!
!arguments
        integer*2 hrptmf(11090)
!commons

#include "avh1b.h"

!local variables
        integer i
!functions

!-
        do i=1,103
          avh_telem(i)=hrptmf(i)
        enddo

        return
        end
