!+
!NOM/NAME $Id: dcexit.F 25 2006-02-03 15:43:53Z frna $
!
        subroutine dcexit(optn)
!BUT/PURPOSE 
!

!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER  
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0      29/03/95    none             M. Derrien and R. Saunders
! 1.1      18/11/95  added AMSU         R. Saunders
! 1.2      26/09/03  added MHS          N.C.Atkinson
!         
!ARGUMENTS 
!       input : integer optn(12)
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
! 
!    
!
!
!arguments
        integer optn(12)
!commons

#include "hrptdc.h"
#include "hrs1b.h"
#include "avh1b.h"
#include "msu1b.h"
#include "ama1b.h"
#include "amb1b.h"
#include "mhs1b.h"
#include "dcs1b.h"

!local variables
        integer i,ios,k
        integer stream(12)
       character*8 startdatac,enddatac
       character*12 startdatatime,enddatatime
        logical error
        data error/.false./
        equivalence(stream,lulog)

!write  avh 1b Header
        if(optn(12).eq.1) then
          call avhhdw(luavh,ios)
            k=avh_h_scnlin
            call ml_wti('info','total avhrr scan lines',k)
            k=avh_h_misscnlin
            if(k.ne.0) call ml_wti('info','total avhrr missing lines',k)
            k=avh_h_pacsparityerr
            if(k.ne.0) then
              call ml_wti('info','total hrpt par. errors in fr. sync'
     &          ,k)
            endif
            call xdjc(avh_h_startdatajd,startdatac) 
            call ml_wt('info','avhrr start data day '//startdatac)
            call xhqc(avh_h_startdatatime,startdatatime) 
            call ml_wt('info','avhrr start data time '//startdatatime)
            call xdjc(avh_h_enddatajd,enddatac) 
            call ml_wt('info','avhrr end data day '//enddatac)
            call xhqc(avh_h_enddatatime,enddatatime) 
            call ml_wt('info','avhrr end data time '//enddatatime)
            if(ios.ne.0) then
              call ml_wti('info',' iostat = ',ios)
              call ml_wti('notice','HRPT 1B File pb to write unit'
     &           ,luavh)
              endif
        endif
!write  hirs2 1b Header
        if(optn(6).eq.1) then
          call hrshdw(luhirs2,ios)
            k=hrs_h_scnlin
            call ml_wti('info','hirs2 scan lines',k)
            k=hrs_h_misscnlin
            if(k.ne.0) then
              call ml_wti('info','hirs2 missing lines',k)
            endif
            k=hrs_h_pacsparityerr
            if(k.ne.0) then
              call ml_wti('info','parity errors in fr. sync',k)
            endif
            call xdjc(hrs_h_startdatajd,startdatac) 
            call ml_wt('info','hirs2 start data day '//startdatac)
            call xhqc(hrs_h_startdatatime,startdatatime) 
            call ml_wt('info','hirs2 start data time '//startdatatime)
            call xdjc(hrs_h_enddatajd,enddatac) 
            call ml_wt('info','hirs2 end data day '//enddatac)
            call xhqc(hrs_h_enddatatime,enddatatime) 
            call ml_wt('info','hirs2 end data time '//enddatatime)
            if(ios.ne.0) then
              call ml_wti('info',' iostat = ',ios)
              call ml_wti('notice','HIRS2 1B File pb to write unit'
     &           ,luhirs2)
              endif
              
        endif
!write  hirs3 1b Header
        if(optn(2).eq.1) then
          call hrshdw(luhirs3,ios)
            k=hrs_h_scnlin
            call ml_wti('info','hirs3 scan lines',k)
            k=hrs_h_misscnlin
            if(k.ne.0) then
              call ml_wti('info','hirs3 missing lines',k)
            endif
            k=hrs_h_pacsparityerr
            if(k.ne.0) then
              call ml_wti('info','parity errors in fr. sync',k)
            endif
            call xdjc(hrs_h_startdatajd,startdatac) 
            call ml_wt('info','hirs3 start data day '//startdatac)
            call xhqc(hrs_h_startdatatime,startdatatime) 
            call ml_wt('info','hirs3 start data time '//startdatatime)
            call xdjc(hrs_h_enddatajd,enddatac) 
            call ml_wt('info','hirs3 end data day '//enddatac)
            call xhqc(hrs_h_enddatatime,enddatatime) 
            call ml_wt('info','hirs3 end data time '//enddatatime)
            if(ios.ne.0) then
              call ml_wti('info',' iostat = ',ios)
              call ml_wti('notice','HIRS3 1B File pb to write unit'
     &           ,luhirs3)
              endif
              
        endif
!write msu Header
        if(optn(7).eq.1) then
          call msuhdw(lumsu,ios)
            k=msu_h_scnlin
            call ml_wti('info','msu scan lines',k)
            k=msu_h_misscnlin
            if(k.ne.0) then
              call ml_wti('info','msu missing lines',k)
            endif
            k=msu_h_pacsparityerr
            if(k.ne.0) then
              call ml_wti('info','parity errors in fr. sync ',k)
            endif
            call xdjc(msu_h_startdatajd,startdatac) 
            call ml_wt('info','msu start data day '//startdatac)
            call xhqc(msu_h_startdatatime,startdatatime) 
            call ml_wt('info','msu start data time '//startdatatime)
            call xdjc(msu_h_enddatajd,enddatac) 
            call ml_wt('info','msu end data day '//enddatac)
            call xhqc(msu_h_enddatatime,enddatatime) 
            call ml_wt('info','msu end data time '//enddatatime)
            if(ios.ne.0) then
              call ml_wti('info',' iostat = ',ios)
              call ml_wti('notice','MSU 1B File pb to write unit'
     &           ,lumsu)
              endif
        endif
!write amsu-a Header
        if(optn(3).eq.1.or.optn(4).eq.1) then
          call amahdw(luamsa1,ios)
            k=ama_h_scnlin
            call ml_wti('info','amsu-a scan lines',k)
            k=ama_h_misscnlin
            if(k.ne.0) then
              call ml_wti('info','amsu-a missing lines',k)
            endif
            k=ama_h_pacsparityerr
            if(k.ne.0) then
              call ml_wti('info','parity errors in fr. sync ',k)
            endif
            call xdjc(ama_h_startdatajd,startdatac) 
            call ml_wt('info','amsu-a start data day '//startdatac)
            call xhqc(ama_h_startdatatime,startdatatime) 
            call ml_wt('info','amsu-a start data time '//startdatatime)
            call xdjc(ama_h_enddatajd,enddatac) 
            call ml_wt('info','amsu-a end data day '//enddatac)
            call xhqc(ama_h_enddatatime,enddatatime) 
            call ml_wt('info','amsu-a end data time '//enddatatime)
            if(ios.ne.0) then
              call ml_wti('info',' iostat = ',ios)
              call ml_wti('notice','AMSU-A 1B File pb to write unit'
     &           ,luamsa1)
              endif
        endif
!write amsu-b Header
        if(optn(5).eq.1.and.amb_h_datatyp.eq.11) then
          call ambhdw(luamsb,ios)
            k=amb_h_scnlin
            call ml_wti('info','amsu-b scan lines',k)
            k=amb_h_misscnlin
            if(k.ne.0) then
              call ml_wti('info','amsu-b missing lines',k)
            endif
            k=amb_h_pacsparityerr
            if(k.ne.0) then
              call ml_wti('info','parity errors in fr. sync ',k)
            endif
            call xdjc(amb_h_startdatajd,startdatac) 
            call ml_wt('info','amsu-b start data day '//startdatac)
            call xhqc(amb_h_startdatatime,startdatatime) 
            call ml_wt('info','amsu-b start data time '//startdatatime)
            call xdjc(amb_h_enddatajd,enddatac) 
            call ml_wt('info','amsu-b end data day '//enddatac)
            call xhqc(amb_h_enddatatime,enddatatime) 
            call ml_wt('info','amsu-b end data time '//enddatatime)
            if(ios.ne.0) then
              call ml_wti('info',' iostat = ',ios)
              call ml_wti('notice','AMSU-B 1B File pb to write unit'
     &           ,luamsb)
              endif
        endif
!write MHS Header
        if(optn(5).eq.1.and.mhs_h_datatyp.eq.12) then
          call mhshdw(luamsb,ios)
            k=mhs_h_scnlin
            call ml_wti('info','MHS scan lines',k)
            k=mhs_h_misscnlin
            if(k.ne.0) then
              call ml_wti('info','MHS missing lines',k)
            endif
            k=mhs_h_pacsparityerr
            if(k.ne.0) then
              call ml_wti('info','parity errors in fr. sync ',k)
            endif
            call xdjc(mhs_h_startdatajd,startdatac) 
            call ml_wt('info','MHS start data day '//startdatac)
            call xhqc(mhs_h_startdatatime,startdatatime) 
            call ml_wt('info','MHS start data time '//startdatatime)
            call xdjc(mhs_h_enddatajd,enddatac) 
            call ml_wt('info','MHS end data day '//enddatac)
            call xhqc(mhs_h_enddatatime,enddatatime) 
            call ml_wt('info','MHS end data time '//enddatatime)
            if(ios.ne.0) then
              call ml_wti('info',' iostat = ',ios)
              call ml_wti('notice','MHS 1B File pb to write unit'
     &           ,luamsb)
              endif
        endif
!write dcs header
        if(optn(8).eq.1) then
          call dcshdw(ludcs,ios)
            k=dcs_h_scnlin
            call ml_wti('info','dcs scan lines',k)
            k=dcs_h_pacsparityerr
            if(k.ne.0) then
              call ml_wti('info','parity errors in fr. sync ',k)
            endif
            call xdjc(dcs_h_startdatajd,startdatac) 
            call ml_wt('info','dcs start data day '//startdatac)
            call xhqc(dcs_h_startdatatime,startdatatime) 
            call ml_wt('info','dcs start data time '//startdatatime)
            call xdjc(dcs_h_enddatajd,enddatac) 
            call ml_wt('info','dcs end data day '//enddatac)
            call xhqc(dcs_h_enddatatime,enddatatime) 
            call ml_wt('info','dcs end data time '//enddatatime)
            if(ios.ne.0) then
              call ml_wti('info',' iostat = ',ios)
              call ml_wti('notice','dcs 1B File pb to write unit'
     &           ,ludcs)
              endif
        endif

       do i=2,12
          if(optn(i).eq.1) then
            if(.not.(i.eq.4.and.optn(3).eq.1)) then
              close(stream(i),iostat=ios)
               if(ios.ne.0) then
                call ml_wti('info',' iostat =',ios)
                call ml_wti('notice','1B File could not be closed unit',
     &                       stream(i))
              else
                call ml_wti('info','1B File has been closed on unit',
     &                       stream(i))
              endif
            endif
          endif
        enddo
        return
        end
