!+
!NOM/NAME $Id: dcsetu.F 47 2006-08-21 08:44:41Z frna $
!
        subroutine dcsetu(optn)
!BUT/PURPOSE 
!  open output 1B files for hrptdc
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER  
! M. Derrien
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0    16/02/95       no              M. Derrien 
! 1.1    09/03/04     Modify for Linux  N Atkinson / A Korpela 
!         
!ARGUMENTS 
!       input : integer optn(12)
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
! 
!    
!
!
!arguments
        integer optn(12)
!commons
#include "hrptdc.h"
#include "avh1b.h"
#include "hrs1b.h"
#include "msu1b.h"
#include "dcs1b.h"
#include "ama1b.h"
#include "amb1b.h"
#include "reclopt.h"
!
!local variables
        character*80 txt
        integer i,ios
        integer reclen(11)
        integer loc_rl
        integer stream(12)
        equivalence(stream,lulog)
!
!               dcs   sem  sbuv  sar  hrpt
!
!functions
        reclen(1) = reclhrs       ! hirs3
        reclen(2) = reclama       ! amsua1
        reclen(3) = reclama       ! amsua2
        reclen(4) = reclamb       ! amsub
        reclen(5) = reclhrs       ! hirs2
        reclen(6) = reclmsu       ! msu
        reclen(7) = recldcs       ! dcs
        reclen(8) = 0             ! left for sem
        reclen(9) = 0             ! left for sbuv
        reclen(10) = 0            ! left for sar
        reclen(11) = reclavh      ! avhrr/hrpt
        avh_h_reclg = reclavh
        hrs_h_reclg = reclhrs
        msu_h_reclg = reclmsu
        dcs_h_reclg = recldcs
        ama_h_reclg = reclama
        amb_h_reclg = reclamb
! to add amsu
        

!-
        do i=2,12
          if(optn(i).eq.1) then
            if(.not.(i.eq.4.and.optn(3).eq.1)) then
              loc_rl=reclen(i-1)/rldiv
              open(stream(i),form='unformatted',access='direct',
     &           recl=loc_rl,status='new',iostat=ios)

!             If that didn't work, use STATUS="UNKNOWN" (Linux ifc compiler)
              if(ios.ne.0)
     &        open(stream(i),form='unformatted',access='direct',
     &           recl=loc_rl,status='unknown',iostat=ios)

              if(ios.ne.0) then
                call ml_wti('info',' iostat = ',ios)
                write(txt,*)'1B File could not be opened ',ios,
     &               ' on unit',stream(i),' recl',reclen(i-1)
                call ml_wt('error',txt)
                call aappexit(2)
              endif
            endif
          endif
        enddo 
        return
        end
