!+
!NOM/NAME $Id: dcshdu.F 46 2006-08-18 14:39:27Z frna $
!
        subroutine dcshdu(startorb,endorb,satid,dcserr,iqdcs,
     &       ndcs,nbmiscn)
!BUT/PURPOSE 
! update header dcs 1b variables  
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
! 
!PROPRIETAIRE/OWNER
!  
!Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0        29/3/95  none          Marcel Derrien
! 1.1        12/5/98  last version of NOAA 1B format
!                     add siteid
! 1.2        20/11/98 correction of TIP source code ( 4 instead of 1)
!                                   T. Labrot!         
! 1.3        Jun 2006 PM, character*16 l1bscnam + MA, MB, MC, MD in
!                     datasetname
! 1.4        Aug 2006 NCA Use station_id instead of fixed 'WE'
!
!ARGUMENTS 
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
! 
!    
!
!
!arguments
        integer startorb  
        integer endorb   
        integer satid 
        integer dcserr  
        integer iqdcs(3)
        integer ndcs
        integer nbmiscn 
!commons
#include "hrptdc.h"
#include "dcs1b.h"
#include "nl1b.h"
        logical timok,partip(5),err_frsync
        integer nb_frsync,nb_auxsync
        logical err_auxsync
        common/gqc/timok,partip,err_frsync,nb_frsync,err_auxsync,
     & nb_auxsync
!local variables
        integer jdate
        integer ig(7)
        character*22 ic
        character*4 str1
        character*3 str2
        character*5 str3,str4
        character*16 sname
        integer cp_lsc, sname_len
        character*2 rname

        logical first
        data first/.true./
        save first
!functions
        integer l1bscid
        character*16 l1bscnam
!-
!  init to be updated if modification in 1B format
!
       call xdqj(iqdcs,jdate)
       call xiqg(iqdcs,ig)
       call xigc(ig,ic)
       if(first) then
         dcs_h_datagaps = 0
         write(str1,1000) iqdcs(1)
1000     format(i4.4)
         write(str2,1001) iqdcs(2)
1001     format(i3.3)
         write(str3,1002) startorb
1002     format(i5.5)
         write(str4,1002) endorb
         sname=l1bscnam(satid)
         sname_len = cp_lsc( sname )
         rname=sname(1:1)//sname(sname_len:sname_len)
         call cp_ups(rname)
         dcs_h_siteid=loccentre
         dcs_h_blank=' '
         dcs_h_dataname=loccentre//'.DCSX.'//rname//
     &   '.D'//str1(3:4)//str2//'.S'//ic(11:12)//ic(14:15)//
     &   '.E    .B'//str3//str4(4:5)//'.'//station_id
         dcs_h_prblkid = 'B'//str3//str4(4:5)
         dcs_h_l1bversnb = libl1bvers
         dcs_h_l1bversyr = libl1bversyr
         dcs_h_l1bversdy = libl1bversdy
         dcs_h_hdrcnt = nb1bhd
!
!
!    we restrict to local hrpt source
         dcs_h_datatyp = 8
         dcs_h_tipsrc = 4
!
         dcs_h_satid=l1bscid(satid)
         dcs_h_startdatajd = jdate 
         dcs_h_startdatayr = iqdcs(1)
         dcs_h_startdatady = iqdcs(2)
         dcs_h_startdatatime = iqdcs(3)
         first =.false.
       endif
       dcs_h_enddatajd = jdate 
       dcs_h_enddatayr = iqdcs(1)
       dcs_h_enddatady = iqdcs(2)
       dcs_h_enddatatime = iqdcs(3)
       dcs_h_dataname(27:30)=ic(11:12)//ic(14:15)
       dcs_h_scnlin = ndcs
       if(nbmiscn.gt.0) dcs_h_datagaps = dcs_h_datagaps + nbmiscn
       if(dcserr.eq.0) dcs_h_okdatafr = dcs_h_okdatafr + 1              
        return
        end
           
