!+
!NOM/NAME $Id: dcsout.F 212 2010-04-28 09:29:11Z frna $
!
        subroutine dcsout(dcswrd4,dcsan,dcs,iqdcs,tipjmf,satid,dcserr,
     &                 gotime,startorb,endorb)
!BUT/PURPOSE 
! 
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER  
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0       15/09/95   initial         Marcel Derrien
! 1.1       28/02/97  correction to dcs_analog packing Marcel Derrien
! 1.2       15/05/98  adapt to new 1B format from nesdis (16 analog data)
! 1.3       March 03                     T. LABROT
!   f90 test: I.or.J not correct and modified by ior(I,J)
! 1.4       Apr 10    For portability, re-write the currect scan 
!                     when correcting times of first few scan lines. NCA
!
!ARGUMENTS 
!
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
! 
!    
!
!
!arguments
       integer dcswrd4                   !digital b data
       integer*2 dcsan(16)               ! analog data
       integer*2 dcs(10240)              ! DCS data
       integer iqdcs(3)                  ! year,day,msecs currebnt mjf
       integer tipjmf                    ! TIP major frame
       integer satid                     !spacecraft ID (num order)
       integer dcserr                    ! error flag
       logical*1 gotime,fulldc           ! flags
       integer startorb                  ! orbit number
       integer endorb                    !orbit number
       integer iq(3)
       double precision ij
       integer msb,lsb
!commons
#include "dcs1b.h"
#include "hrptdc.h"
!local variables
        integer ndcs  ! conter for dcs major frame
        integer lmsecs ! last msecs
        integer i ! work index
        integer nbmiscn ! missing major frames
        integer ios ! status from 1B access
        integer ind ! index
        integer wrd1,wrd2,wrd3,wrd4 ! words to pack dcs data
        logical first,start
        data first/.true./
        data start/.true./
!functions


!-
!   section 0 first call init
!----------------------------
        if(first) then
          first = .false.
          ndcs = 0
          lmsecs=iqdcs(3)
        endif
!    section 1
!      missing lines complete missing records
!--------------------------------------------
        nbmiscn=nint(float(iqdcs(3)-lmsecs)/32000.)-1        
        if(.not.gotime.and.nbmiscn.gt.0) then
          call ml_wti('info','dcsout lignes manquantes',nbmiscn)
          do i = 1, 2560
            dcs_data(i)=0
          enddo
          dcs_mjfryr=iqdcs(1)
          dcs_mjfrdy=iqdcs(2)
          do i = 1 ,nbmiscn
            dcs_mjfrtime=lmsecs+32000
            if(dcs_mjfrtime.gt.86400000) then
               iq(1)=dcs_mjfryr
               iq(2)=dcs_mjfrdy
               iq(3)=lmsecs
               call xiqj(iq,ij)
               ij=ij+32000.d0/86400000.d0
               call xijq(ij,iq)               
               dcs_mjfrtime=iq(3)
               dcs_mjfrdy=iq(2)
               dcs_mjfryr=iq(1)
            endif               
            dcs_mjfrcnt=0
!         write missing records
            ndcs=ndcs+1
            call dcsdtw(ludcs,ndcs,ios)
          enddo
        endif
! section 2 
!       update dcs header
!       pack dcs data
!       write data record
!------------------------
        ndcs = ndcs+1
        call dcshdu(startorb,endorb,satid,dcserr,iqdcs,
     &       ndcs,nbmiscn)

        lmsecs=iqdcs(3)
!
!       fill dcs common
!       and write data record
!
        dcs_mjfrcnt=tipjmf
        dcs_mjfryr=iqdcs(1)
        dcs_mjfrdy=iqdcs(2)
        dcs_mjfrtime=iqdcs(3)
!  CAUTION !!!!!!!!!!!
! TBD variables later init 0 for the moment
! if requested by user
        dcs_qualind=0
        dcs_mjfqf=0
        dcs_digbinvwbf=0
        dcs_aninvwbf=0
!!!!!!!!!!!!!!!!!!!!!!!
        dcs_digbtlm=dcswrd4
        do i=1,8
          msb = dcsan((i-1)*2+1)
          lsb = dcsan((i-1)*2+2)
          msb = msb*256
          if(msb.gt.32767) msb = msb - 65536
          dcs_analog(i)= msb + lsb
        enddo

!        write(lulog,9000) dcs_mjfrtime,dcs_digbtlm,dcs_analog1,
!     &       dcs_analog2
!9000    format(' dcs_mjfrtime ',i9,' dcs_digbtlm ',Z4,
!     &  ' dcs_analog1 ',5z4,' dcs_analog2 ',2z4)

! pack dcs data
        do i = 1,2560
          ind=(i-1)*4 + 1
          wrd1=dcs(ind)
          wrd2=dcs(ind+1)
          wrd3=dcs(ind+2)
          wrd4=dcs(ind+3)
          wrd1=ishft(wrd1,24)
          wrd2=ishft(wrd2,16)
          wrd3=ishft(wrd3,8)
          dcs_data(i)=ior(wrd1,wrd2)
          dcs_data(i)=ior(dcs_data(i),wrd3)
          dcs_data(i)=ior(dcs_data(i),wrd4)
        enddo
        call dcsdtw(ludcs,ndcs,ios)
!        write(lulog,*)' dcsout scan dcs ',ndcs,
!     &   ' dcs_mjfrtime  ',dcs_mjfrtime
        
!--------------------------------------------------                  
! section 3
! Correct time on first few scan lines if necessary
!--------------------------------------------------
      if(start.and.gotime.and.ndcs.gt.1) then
        start=.false.
        do i=1,ndcs
          
          call dcsdtr(ludcs,i,ios)
          dcs_mjfrtime=iqdcs(3)-(ndcs-i)*32000
          if(i.eq.1) dcs_h_startdatatime = dcs_mjfrtime
          call dcsdtw(ludcs,i,ios)
        enddo
      endif
!---------------------------------------
! section 4 reset flags,variables arrays
!---------------------------------------
        dcserr = 0
        fulldc=.false.
!       reset dcs array
        do i=1,10240
          dcs(i)=0
        enddo
        do i=1,16
          dcsan(i)=0
        enddo
        dcswrd4=0
        return
        end
