        integer function hrpdat(hrpadd)       
!+
!NAME  hrpdat.F version 1.1 on 3/24/98 
!
!PURPOSE 
!  extraction of binary day count from the integer*2 hrpadd 
!   where hrpadd is the 9th 16 bit word of hrpt minor frame  
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions   
!  
!OWNER  Marcel Derrien
!
!HISTORY 
!(version   date      comment           <author>)
!
!  1.0     08/02/94   Original code      M. Derrien
!  1.1     March 03                      T.Labrot
!   f90 test:  I.and.J not correct and modified by iand(I,J)
!              I and J must have the same type
!              Defined integer*2 i2word1022  and changed
!                        hrpdat=iand(1022,hrpadd)/2 to
!                        hrpdat=iand(i2word1022,hrpadd)/2       
!ARGUMENTS 
!   input: integer*2 hrpadd
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!      returns the binary day count in an integer
! 
!CHANGES 
!     none
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
      integer*2 hrpadd
      integer*2 i2word1022
      parameter (i2word1022=1022)
!    
!-
       hrpdat=iand(i2word1022,hrpadd)/2

       return
       end
