        integer function hrptim (hrpadd)       
!+
!NAME  hrptim.F version 1.1 on 3/24/98 
!
!PURPOSE 
!  extraction part of binary millisecond of day count from the integer*2 hrpadd 
!   where hrpadd is the 10th to 12th 16 bit words of hrpt minor frame  
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions   
!  
!OWNER  Marcel Derrien
!
!HISTORY 
!(version   date      comment           <author>)
!
!  1.0     08/02/94   Original code     M. Derrien
!  1.1     March 03                      T. Labrot and P.Brunel
!     f90 test: I.and.J not correct and modified by iand(I,J)
!               Add working variables for IAND/IOR tests
!  1.2     17/01/2006 : Philippe Marguinaud : change hex constants from
!                       '1234'X to Z'1234'
!         
!ARGUMENTS 
!   input: integer*2 hrpadd(3)
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!      returns the 
! 
!CHANGES 
!     none
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
      integer*2 hrpadd(3)
      integer part1,part2,part3 
!    
!-
!       version without iand,ishft (using only and,+,*)
!       take 1rst word mask with 127, shift left 20 bit
!       take second word shift left 10 bit
!       take last word
!       add the three values
!
        integer*2 i2word
        integer*2 mask1
        integer*4 mask2
        integer*4 mask3

        data mask1/Z'7F'/
        data mask2/Z'7F00000'/
        data mask3/Z'FFC00'/


        I2WORD=IAND(hrpadd(1),mask1)
        part1 = I2WORD * 1048576
        part1 = IAND( part1, mask2)

        part2 = hrpadd(2)*1024
        part2 = IAND(part2, mask3)

        part3 = hrpadd(3)

        hrptim = part1 + part2 + part3

       return
       end
