!+
!NOM/NAME $Id: msudc.F 25 2006-02-03 15:43:53Z frna $
!
      subroutine msudc(msu)
!-----------------------------------------------------------------------
!
! BUT/PURPOSE: 
!  converts TIP MSU data into NOAAK 
!             level 1b structure for one MSU scan line
!
! DESCRIPTION: FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions
!       see documentations     
!
! PROPRIETAIRE/OWNER: PAUL FLAMENT
!
! HISTORIQUE/HISTORY  (MODIFICATIONS/CHANGES)
!
! version       date            comment                 author
! 1.0           27/05/95                                Marcel Derrien
! 1.1           29/02/96        corrections             Marcel Derrien
! ARGUMENTS: 
      implicit none
c-----------------------------------------
c
c
c!
      integer*2 msu(112)
      integer*2 msublk(8,14)
      integer*4 i,j
      integer*2 scnposcnt(14),scnang(14)
      integer*2 ms3b
      integer*2 ze000
      integer*2 za000
      integer*2 z00ff
      integer*2 z0700
      integer*2 z0fff
      integer*2 sr13,sr8
      integer error8th,error17
      integer k
#include "msu1b.h"
        integer msecs,day,nmf,nhirs,nmsu,namsua,namsub,ndcs
       common /log/msecs,day,nmf,nhirs,nmsu,namsua,namsub,ndcs
!
!    fill msublk array (8,14)
!
      k=0
      do i=1,8
        do j=1,14
          k=k+1
          msublk(i,j)=msu(k)
        enddo
      enddo   
      ze000=z'e000'
      za000=z'a000'
      z00ff=z'00ff'
      z0700=z'0700'
      z0fff=z'0fff'
      sr13=-13
      sr8=-8
!
! check 8th word position in msu array
!
      error8th=0
      do j=1,14
        ms3b=iand(msublk(8,j),ze000)
        scnposcnt(j)=iand(msublk(8,j),z0700)/256
        scnang(j)=iand(msublk(8,j),z00ff)
        if(ms3b.ne.za000) then
           error8th = error8th+1
!           write(*,900) ms3b
!900       format('mots 8 :ms3b ',z8)
        endif
      enddo
!
!check the three first msb for all words except word 8
!                          and first word of the scan
!
      error17=0

      do j=1,14
      do i=1,7
       if(i.ne.1.and.j.ne.1) then
         ms3b=iand(msublk(i,j),ze000)
         ms3b=ishft(ms3b,sr13)
         if(ms3b.ne.4) then
          error17 = error17 + 1
!           write(*,901) ms3b,i,j
!901       format('mots 1 a 7 : ms3b ',z8,' i ',i4,' j ',i4)          
         endif
       endif
      enddo
      enddo
!      if(error8th.ne.0.or.error17.ne.0) then
!        call ml_wti('warning','suspect msu words in msu scan line',nmsu)
!        call ml_wti('info',' error8th',error8th)
!        call ml_wti('info',' error17',error17)
!        type *,' scnposcnt ',scnposcnt
!        type *,' scnang ',scnang
!      endif
      do i = 1 , 112
       msu_data(i) = iand(msu(i),z0fff) ! keep only the 12 last significant bits
      enddo
      return
      end
