! Name: $Id: maia_Avhrr_test_wrapper.F90 635 2019-04-15 15:08:00Z frna $
!---------------------------------------------------------------------------  
!> MAIA cloud mask
!
!> @author      MF/DP/CMS/R&D 
!> @author      lydie lavanant
!> @date        2015/03/01 
!> </dl>
!> @brief       Main program for AVHRR calling MAIA v4.3<br>
!> @brief       interfaced in input with the AAPP level 1c hdf5 files
!---------------------------------------------------------------------------  
!
! LIBS =   maia4 maia4IO aapp_viirs f7ml f7tp f7cp f7gp atov auxaapp
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 16 December 2003, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2005, EUMETSAT, All Rights Reserved.
!
! History:
!  Version     Date      Comment                          Author
!  1.O 2017         created                           P. Roquet  
!  1.1    25/08/2017   Pascale Roquet  maia_par is an array of maia_param type structure

PROGRAM maia_Avhrr_test_wapper
#ifdef HAS_LIBHDF5 
  use mod_maia_wrapper
  use mod_maia_types
  type(maia_param), allocatable   :: maia_par(:,:)
  integer nblines,nbpixels

  INTEGER :: idbg_maia                  ! debug level (0= nodebug, 2 is maximum)

 
  write(*,*) "call maia_wrapper"  
  call maia_wrapper( idbg_maia, maia_par, nb_lines,nb_pixels, .TRUE. )
  write(*,*) nblines,nbpixels

  stop 0
#else

  write(0,'("maia_Avhrr.exe has not been built with HDF-5 Fortran interface")')
  write(0,'("Please run configure with --external-libs=-Lxxx/lib -lhdf5hl_fortran")')
  write(0,'(" and --external-includes=-Lxxx/include")')
  write(0,'(" where xxx is the location of the HDF-5 library")')
  
#endif
                                      
END PROGRAM maia_Avhrr_test_wapper
