#! /bin/ksh
#--------------------------------------
# functions required to deal with dates
#--------------------------------------
#=====================================================================================
function date_MMDD {
#===================================================================================== 
  YYYY=$1
  DAY=$2

  MONTH=0 ;  NBJY=0 
  while [ "${NBJY}" -lt ${DAY} ]
  do
    RES=`expr ${DAY} - ${NBJY} `
    MONTH=`expr ${MONTH} + 1 `
    NBJM=`date_nbjmois ${MONTH} ${YYYY}`
    NBJY=`expr ${NBJY} + ${NBJM} `
  done
  MONTH=`echo ${MONTH} | awk '{printf("%.2d", $0)}'`
  RES=`echo ${RES} | awk '{printf("%.2d", $0)}'`
  echo ${MONTH}${RES}
}
#=====================================================================================
function date_HHMN {
#===================================================================================== 
  TIME=$1

  seconds=`expr ${TIME} / 1000 `
  minutes=`expr ${seconds} / 60 `
  hours=`expr ${minutes} / 60 `
  
  NBMN=`expr ${minutes} % 60 `
  NBSS=`expr ${seconds} % 60 `
  hours=`echo ${hours} | awk '{printf("%.2d", $0)}'`
  NBMN=`echo ${NBMN} | awk '{printf("%.2d", $0)}'`
  NBSS=`echo ${NBSS} | awk '{printf("%.2d", $0)}'`
  
  echo ${hours}${NBMN}
}
#=====================================================================================
function date_nbjmois {
#=====================================================================================
  # returns the number of days of a month
  # arg1 month
  # arg2 year
  MM=$1
  YYYY=$2
  case ${MM} in
    1|3|5|7|8|01|03|05|07|08|10|12) echo '31';;
    4|6|9|04|06|09|11) echo '30';;
    2|02) case ${YYYY} in
      1988|1992|1996|2000|2004|2008|2012|2016|2020|2024|2028|2032) echo '29';;
      *) echo '28';;
    esac
  esac
}
#end of function date_nbjmois
#=====================================================================================
function date_pn {
#=====================================================================================
  # returns the date in variable YYYYMMDD coresponding to
  # input date in argument 1 (format YYYYMMDD) PLUS a
  # number of days in argument 2 (can be negative)

  NBJ=$2
  YYYY=`echo $1 | cut -c1-4`
  MM=`echo $1 | cut -c5-6`
  DD=`echo $1 | cut -c7-8`
  
  NBJM=`date_nbjmois ${MM} ${YYYY}`
  JR=${NBJ}

  while [ "${JR}" -ne 0 ]
  do
    NDD=`expr 0  - ${DD} `
    ND=`expr ${DD} + ${JR} `
    if [ "${ND}" -gt ${NBJM} ]; then
      JR=`expr ${JR} - ${NBJM} + ${DD} - 1 `
      DD=1
      MM=`expr ${MM} + 1 `
      if [ "${MM}" -gt 12 ] ; then
        MM=1
        YYYY=`expr ${YYYY} + 1`
      fi
      NBJM=`date_nbjmois ${MM} ${YYYY}`

    elif [ "${ND}" -le 0 ]; then
      JR=`expr ${JR}  + ${DD} `
      MM=`expr ${MM} - 1 `
      if [ "${MM}" -eq 0 ] ; then
        MM=12
        YYYY=`expr ${YYYY} - 1`
      fi
      NBJM=`date_nbjmois ${MM} ${YYYY}`
      DD=${NBJM}
      
    else
      DD=${ND}
      JR=0
    fi
    #  echo ${JR}  ${DD} ${MM} ${YYYY}
  done

  MM=`echo ${MM} | awk '{printf("%.2d", $0)}'`
  DD=`echo ${DD} | awk '{printf("%.2d", $0)}'`    
    echo ${YYYY}${MM}${DD}
}
# end of function date_pn
#=====================================================================================
function time_pn {
#=====================================================================================
  # gives the time (YYYYMMDDHHMNSS) corresponding to the input TIME
  # minus nbs secondes
  # argument 1 reference time YYYYMMDDHHMNSS
  # argument 2 nombre de secondes
  
  YYYYMMDD=`echo $1 | cut -c1-8`
  HH=`echo $1 | cut -c9-10`
  MN=`echo $1 | cut -c11-12`
  SS=`echo $1 | cut -c13-14`
  
  NBS=$2
  DS=${NBS}
  
  YYYYMMDD1=${YYYYMMDD}
  HH1=${HH}
  MN1=${MN}
  SS1=${SS}
  
  if [ "${NBS}" -le 0 ]; then	# remove seconds
  while [ "${DS}" -ne 0 ]
  do

  SS1=`expr ${SS1} - 1 `
  DS=`expr ${DS} + 1 `
  
  if [ "${SS1}" -eq -1 ] ; then	
      SS1=59
      MN1=`expr ${MN1} - 1 `
      if [ "${MN1}" -eq -1 ] ; then
         MN1=59
         HH1=`expr ${HH1} - 1 `
         if [ "${HH1}" -eq -1 ] ; then
           HH1=23
           YYYYMMDD1=`date_pn ${YYYYMMDD} -1`
         fi
      fi
  fi
  done
  fi
  
  if [ "${NBS}" -gt 0 ]; then	# add seconds
  while [ "${DS}" -ne 0 ]
  do

  SS1=`expr ${SS1} + 1 `
  DS=`expr ${DS} - 1 `
  
  if [ "${SS1}" -eq 60 ] ; then	
      SS1=00
      MN1=`expr ${MN1} + 1 `
      if [ "${MN1}" -eq 60 ] ; then
         MN1=00
         HH1=`expr ${HH1} + 1 `
         if [ "${HH1}" -eq 24 ] ; then
           HH1=00
           YYYYMMDD1=`date_pn ${YYYYMMDD} +1`
         fi
      fi
  fi
  done
  fi  

  HH1=`echo ${HH1} | awk '{printf("%.2d", $0)}'`    
  MN1=`echo ${MN1} | awk '{printf("%.2d", $0)}'`
  SS1=`echo ${SS1} | awk '{printf("%.2d", $0)}'`    
  echo ${YYYYMMDD1}${HH1}${MN1}${SS1}
}
#=====================================================================================
function date_hour_phours {
#=====================================================================================
  # returns the date (YYYYMMDD) and hour (HHMN) 
  # corresponding to the input date $1 (YYYYMMDD) and
  # hour $2 (HHMN) plus  a number of hours $3 (HHMN) (can be negative)
  # BEWARE minutes are not considered all HOURS should
  # be of the form HH00 
  #YYYYMMDD=$1
  #HHMN=$2
  #HHH=$3

  HHL=`echo $2 $3 | awk '{printf("%.4d", $1 + $2)}'`
  if [ ${HHL} -lt 0 ] ; then
    NBJ=`echo ${HHL} | awk '{printf("%.4d", $1 / 2400 -1)}'`
    NHH=`echo ${HHL} | awk '{printf("%.4d", $1 % 2400 +2400)}'`
    if [ ${NHH} -eq 2400 ] ; then
      NHH=0000
      let NBJ=NBJ+1
    fi
  else
    NBJ=`echo ${HHL} | awk '{printf("%.4d", $1 / 2400)}'`
    NHH=`echo ${HHL} | awk '{printf("%.4d", $1 % 2400)}'`
  fi
  NDATE=`date_pn $1 ${NBJ}`
  echo ${NDATE} ${NHH}
}
# end of function date_hour_phours
#=====================================================================================
function grib_valid_date {
#=====================================================================================
  # $1: filename for a GRIB with Meteo-France syntax: YYYYMMDDHHMM.ECH
  # return filename + validity date 
  f=$1
  bs=`basename $f`
  datehour=`basename $f | awk -F. '{print $1}'`
  mydate=`echo ${datehour} | cut -c1-8`
  ech=`basename $f | awk -F. '{print $2}'`
  res=`basename $f | cut -c9-12`
  valid=`date_hour_phours $mydate ${res} +${ech}00`
  echo "${valid}"
}
# end of function grib_valid_date
#=====================================================================================
function date_nbjY {
#=====================================================================================
  # input date (format YYYYMMDD)
  # output nombre de jours in YYYYMMDD 

  YYYY=`echo $1 | cut -c1-4`
  MM=`echo $1 | cut -c5-6`
  DD=`echo $1 | cut -c7-8`

  MONTH=1
  NBJY=0 

  while [ "${MONTH}" -lt ${MM} ]
  do
    NBJM=`date_nbjmois ${MONTH} ${YYYY}`
    NBJY=`expr ${NBJY} + ${NBJM} `
    MONTH=`expr ${MONTH} + 1 `
  done

  NBJY=`expr ${NBJY} + ${DD} `
  NBJY=`echo ${NBJY} | awk '{printf("%.2d", $0)}'`
  echo ${NBJY}
}
# end of function date_nbjY
#=====================================================================================
function date_numPartM {
#=====================================================================================
  # input date (format YYYYMMDD)
  # output fifteen part 

  YYYY=`echo $1 | cut -c1-4`
  MM=`echo $1 | cut -c5-6`
  DD=`echo $1 | cut -c7-8`

  PartM=1
  if   [ "${DD}" -gt 15 ] ; then  
       PartM=2
  fi
  echo ${PartM}
}
# end of function date_numPartM
#=====================================================================================
function date_YYYY_MM_DD_CCC {
#=====================================================================================
  # input date (format YYYYMMDD)
  # output YYYY_MM_DD_CCC

  YYYY=`echo $1 | cut -c1-4`
  MM=`echo $1 | cut -c5-6`
  DD=`echo $1 | cut -c7-8`
  CCC=`date_nbjY $1`
  CCC=`echo ${CCC} | awk '{printf("%.3d", $0)}'`
  echo ${YYYY}_${MM}_${DD}_${CCC}
}
# end function date_YYYY_MM_DD_CCC 
