!
! Automatically generated by ./mod_att_rw.pl version 1.2
! Do not edit
!
! Name: $Id: jpss_meta_aggregate_io.F90
!
! Purpose: jpss meta aggregate fortran I/O module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!
module jpss_meta_aggregate_io

#ifdef HAS_LIBHDF5

#include "aapp_throw.h"
!use rttov_print_mod
use aapp_hdf_mod
use jpss_meta_aggregate_def
use jpss_meta_aggregate_mem
use hdf5
use h5lt
implicit none
private
public :: jpss_meta_aggregate_rh
public :: jpss_meta_aggregate_wh
public :: jpss_meta_aggregate_writea


contains


subroutine jpss_meta_aggregate_writea(x,lun,err)
type(jpss_meta_aggregate),intent(in)::x
integer,intent(in)::lun
integer,intent(out)::err
integer::lb(7),ub(7)
character(len=nlen)::sname

TRY
sname='AggregateBeginningDate'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Aggregate Beginning Date'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A9))',a0=x%AggregateBeginningDate)
!write(lun,err=999)x%AggregateBeginningDate

sname='AggregateBeginningGranuleID'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Aggregate Beginning Granule ID'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A16))',a0=x%AggregateBeginningGranuleID)
!write(lun,err=999)x%AggregateBeginningGranuleID

sname='AggregateBeginningOrbitNumber'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Aggregate Beginning Orbit Number'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_integer(lun,'(10000(I8))',a0=x%AggregateBeginningOrbitNumber)
!write(lun,err=999)x%AggregateBeginningOrbitNumber

sname='AggregateBeginningTime'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Aggregate Beginning Time'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A15))',a0=x%AggregateBeginningTime)
!write(lun,err=999)x%AggregateBeginningTime

sname='AggregateEndingDate'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Aggregate Ending Date'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A9))',a0=x%AggregateEndingDate)
!write(lun,err=999)x%AggregateEndingDate

sname='AggregateEndingGranuleID'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Aggregate Ending Granule ID'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A16))',a0=x%AggregateEndingGranuleID)
!write(lun,err=999)x%AggregateEndingGranuleID

sname='AggregateEndingOrbitNumber'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Aggregate Ending Orbit Number'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_integer(lun,'(10000(I8))',a0=x%AggregateEndingOrbitNumber)
!write(lun,err=999)x%AggregateEndingOrbitNumber

sname='AggregateEndingTime'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Aggregate Ending Time'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A15))',a0=x%AggregateEndingTime)
!write(lun,err=999)x%AggregateEndingTime

sname='AggregateNumberGranules'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Aggregate Number Granules'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_integer(lun,'(10000(I8))',a0=x%AggregateNumberGranules)
!write(lun,err=999)x%AggregateNumberGranules

write(lun,'("SECTION = EOF")',err=999)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
err=0
CATCH
end subroutine

subroutine jpss_meta_aggregate_rh(x,lun,dname,err)
type(jpss_meta_aggregate),intent(out)::x
integer(hid_t),intent(in)::lun
character(len=*)::dname
integer,intent(out)::err
character(len=nlen)::sname
logical :: lext
integer::ival(1)
real::sval(1)
integer(HSIZE_T),dimension(7):: dims 
integer :: type_class
integer(SIZE_T):: type_size

TRY

call jpss_meta_aggregate_init(x)

sname='AggregateBeginningDate'
call h5ltget_attribute_string_f(lun,dname,sname,x%AggregateBeginningDate,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='AggregateBeginningGranuleID'
call h5ltget_attribute_string_f(lun,dname,sname,x%AggregateBeginningGranuleID,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='AggregateBeginningOrbitNumber'
call h5ltget_attribute_int_f(lun,dname,sname,ival(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%AggregateBeginningOrbitNumber=ival(1)

sname='AggregateBeginningTime'
call h5ltget_attribute_string_f(lun,dname,sname,x%AggregateBeginningTime,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='AggregateEndingDate'
call h5ltget_attribute_string_f(lun,dname,sname,x%AggregateEndingDate,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='AggregateEndingGranuleID'
call h5ltget_attribute_string_f(lun,dname,sname,x%AggregateEndingGranuleID,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='AggregateEndingOrbitNumber'
call h5ltget_attribute_int_f(lun,dname,sname,ival(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%AggregateEndingOrbitNumber=ival(1)

sname='AggregateEndingTime'
call h5ltget_attribute_string_f(lun,dname,sname,x%AggregateEndingTime,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='AggregateNumberGranules'
call h5ltget_attribute_int_f(lun,dname,sname,ival(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%AggregateNumberGranules=ival(1)

err=0
CATCH
end subroutine

subroutine jpss_meta_aggregate_wh(x,lun,dname,err)
type(jpss_meta_aggregate),intent(in)::x
integer(hid_t),intent(in)::lun
character(len=*)::dname
integer,intent(out)::err
character(len=nlen)::sname
integer::ival(1)
real::sval(1)
INTEGER(SIZE_T) :: idims(1)

TRY
idims(1)=1
sname='AggregateBeginningDate'
call h5ltset_attribute_string_f(lun,dname,sname,x%AggregateBeginningDate,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='AggregateBeginningGranuleID'
call h5ltset_attribute_string_f(lun,dname,sname,x%AggregateBeginningGranuleID,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='AggregateBeginningOrbitNumber'
ival(1)=x%AggregateBeginningOrbitNumber
idims(1)=1
call h5ltset_attribute_int_f(lun,dname,sname,ival(1),idims(1),err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='AggregateBeginningTime'
call h5ltset_attribute_string_f(lun,dname,sname,x%AggregateBeginningTime,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='AggregateEndingDate'
call h5ltset_attribute_string_f(lun,dname,sname,x%AggregateEndingDate,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='AggregateEndingGranuleID'
call h5ltset_attribute_string_f(lun,dname,sname,x%AggregateEndingGranuleID,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='AggregateEndingOrbitNumber'
ival(1)=x%AggregateEndingOrbitNumber
idims(1)=1
call h5ltset_attribute_int_f(lun,dname,sname,ival(1),idims(1),err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='AggregateEndingTime'
call h5ltset_attribute_string_f(lun,dname,sname,x%AggregateEndingTime,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='AggregateNumberGranules'
ival(1)=x%AggregateNumberGranules
idims(1)=1
call h5ltset_attribute_int_f(lun,dname,sname,ival(1),idims(1),err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

err=0
CATCH
end subroutine

#endif

end module
