!
! Automatically generated by ./mod_att_rw.pl version 1.2
! Do not edit
!
! Name: $Id: jpss_meta_dataproducts_io.F90
!
! Purpose: jpss meta dataproducts fortran I/O module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!
module jpss_meta_dataproducts_io

#ifdef HAS_LIBHDF5

#include "aapp_throw.h"
!use rttov_print_mod
use aapp_hdf_mod
use jpss_meta_dataproducts_def
use jpss_meta_dataproducts_mem
use hdf5
use h5lt
implicit none
private
public :: jpss_meta_dataproducts_rh
public :: jpss_meta_dataproducts_wh
public :: jpss_meta_dataproducts_writea


contains


subroutine jpss_meta_dataproducts_writea(x,lun,err)
type(jpss_meta_dataproducts),intent(in)::x
integer,intent(in)::lun
integer,intent(out)::err
integer::lb(7),ub(7)
character(len=nlen)::sname

TRY
sname='Instrument_Short_Name'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Instrument_Short_Name'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A16))',a0=x%Instrument_Short_Name)
!write(lun,err=999)x%Instrument_Short_Name

sname='N_Collection_Short_Name'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Collection_Short_Name'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A64))',a0=x%N_Collection_Short_Name)
!write(lun,err=999)x%N_Collection_Short_Name

sname='N_Dataset_Type_Tag'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Dataset_Type_Tag'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A16))',a0=x%N_Dataset_Type_Tag)
!write(lun,err=999)x%N_Dataset_Type_Tag

sname='N_Instrument_Flight_SW_Version'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Instrument_Flight_SW_Version'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_integer(lun,'(10000(I8))',a0=x%N_Instrument_Flight_SW_Version)
!write(lun,err=999)x%N_Instrument_Flight_SW_Version

sname='Operational_Mode'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Operational_Mode'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A64))',a0=x%Operational_Mode)
!write(lun,err=999)x%Operational_Mode

sname='N_Processing_Domain'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Processing_Domain'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A16))',a0=x%N_Processing_Domain)
!write(lun,err=999)x%N_Processing_Domain

sname='N_Anc_Type_Tasked'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Anc_Type_Tasked'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A32))',a0=x%N_Anc_Type_Tasked)
!write(lun,err=999)x%N_Anc_Type_Tasked

write(lun,'("SECTION = EOF")',err=999)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
err=0
CATCH
end subroutine

subroutine jpss_meta_dataproducts_rh(x,lun,dname,err)
type(jpss_meta_dataproducts),intent(out)::x
integer(hid_t),intent(in)::lun
character(len=*)::dname
integer,intent(out)::err
character(len=nlen)::sname
logical :: lext
integer::ival(1)
real::sval(1)
integer(HSIZE_T),dimension(7):: dims 
integer :: type_class
integer(SIZE_T):: type_size

TRY

call jpss_meta_dataproducts_init(x)

sname='Instrument_Short_Name'
call h5ltget_attribute_string_f(lun,dname,sname,x%Instrument_Short_Name,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='N_Collection_Short_Name'
call h5ltget_attribute_string_f(lun,dname,sname,x%N_Collection_Short_Name,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='N_Dataset_Type_Tag'
call h5ltget_attribute_string_f(lun,dname,sname,x%N_Dataset_Type_Tag,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='N_Instrument_Flight_SW_Version'
call h5ltget_attribute_int_f(lun,dname,sname,ival(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%N_Instrument_Flight_SW_Version=ival(1)

sname='Operational_Mode'
call h5ltget_attribute_string_f(lun,dname,sname,x%Operational_Mode,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='N_Processing_Domain'
call h5ltget_attribute_string_f(lun,dname,sname,x%N_Processing_Domain,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='N_Anc_Type_Tasked'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_string_f(lun,dname,sname,x%N_Anc_Type_Tasked,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
endif

err=0
CATCH
end subroutine

subroutine jpss_meta_dataproducts_wh(x,lun,dname,err)
type(jpss_meta_dataproducts),intent(in)::x
integer(hid_t),intent(in)::lun
character(len=*)::dname
integer,intent(out)::err
character(len=nlen)::sname
integer::ival(1)
real::sval(1)
INTEGER(SIZE_T) :: idims(1)

TRY
idims(1)=1
sname='Instrument_Short_Name'
call h5ltset_attribute_string_f(lun,dname,sname,x%Instrument_Short_Name,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='N_Collection_Short_Name'
call h5ltset_attribute_string_f(lun,dname,sname,x%N_Collection_Short_Name,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='N_Dataset_Type_Tag'
call h5ltset_attribute_string_f(lun,dname,sname,x%N_Dataset_Type_Tag,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='N_Instrument_Flight_SW_Version'
ival(1)=x%N_Instrument_Flight_SW_Version
idims(1)=1
call h5ltset_attribute_int_f(lun,dname,sname,ival(1),idims(1),err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='Operational_Mode'
call h5ltset_attribute_string_f(lun,dname,sname,x%Operational_Mode,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='N_Processing_Domain'
call h5ltset_attribute_string_f(lun,dname,sname,x%N_Processing_Domain,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='N_Anc_Type_Tasked'
call h5ltset_attribute_string_f(lun,dname,sname,x%N_Anc_Type_Tasked,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

err=0
CATCH
end subroutine

#endif

end module
