!
! Automatically generated by ./mod_att_rw.pl version 1.2
! Do not edit
!
! Name: $Id: jpss_meta_granule_io.F90
!
! Purpose: jpss meta granule fortran I/O module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!
module jpss_meta_granule_io

#ifdef HAS_LIBHDF5

#include "aapp_throw.h"
!use rttov_print_mod
use aapp_hdf_mod
use jpss_meta_granule_def
use jpss_meta_granule_mem
use hdf5
use h5lt
implicit none
private
public :: jpss_meta_granule_rh
public :: jpss_meta_granule_wh
public :: jpss_meta_granule_writea


contains


subroutine jpss_meta_granule_writea(x,lun,err)
type(jpss_meta_granule),intent(in)::x
integer,intent(in)::lun
integer,intent(out)::err
integer::lb(7),ub(7)
character(len=nlen)::sname

TRY
sname='Ascending_Descending_Indicator'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Ascending/Descending_Indicator'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A2))',a0=x%Ascending_Descending_Indicator)
!write(lun,err=999)x%Ascending_Descending_Indicator

sname='Band_ID'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Band_ID'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A4))',a0=x%Band_ID)
!write(lun,err=999)x%Band_ID

sname='Beginning_Date'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Beginning_Date'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A9))',a0=x%Beginning_Date)
!write(lun,err=999)x%Beginning_Date

sname='Beginning_Time'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Beginning_Time'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A15))',a0=x%Beginning_Time)
!write(lun,err=999)x%Beginning_Time

sname='Cloud_Cover'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Cloud_Cover'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%Cloud_Cover)
!write(lun,err=999)x%Cloud_Cover

sname='East_Bounding_Coordinate'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'East_Bounding_Coordinate'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%East_Bounding_Coordinate)
!write(lun,err=999)x%East_Bounding_Coordinate

sname='Ending_Date'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Ending_Date'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A9))',a0=x%Ending_Date)
!write(lun,err=999)x%Ending_Date

sname='Ending_Time'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Ending_Time'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A15))',a0=x%Ending_Time)
!write(lun,err=999)x%Ending_Time

sname='G_Ring_Latitude'
if(associated(x%G_Ring_Latitude))then
  write(lun,'("SECTION = ",A)',err=999)trim(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'G-Ring_Latitude'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%G_Ring_Latitude), &
    & ubound(x%G_Ring_Latitude)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a1=x%G_Ring_Latitude)
! write(lun,*,err=999)x%G_Ring_Latitude
endif

sname='G_Ring_Longitude'
if(associated(x%G_Ring_Longitude))then
  write(lun,'("SECTION = ",A)',err=999)trim(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'G-Ring_Longitude'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%G_Ring_Longitude), &
    & ubound(x%G_Ring_Longitude)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a1=x%G_Ring_Longitude)
! write(lun,*,err=999)x%G_Ring_Longitude
endif

sname='N_Algorithm_Version'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Algorithm_Version'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A32))',a0=x%N_Algorithm_Version)
!write(lun,err=999)x%N_Algorithm_Version

sname='N_Anc_Filename'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Anc_Filename'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A128))',a0=x%N_Anc_Filename)
!write(lun,err=999)x%N_Anc_Filename

sname='N_Aux_Filename'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Aux_Filename'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A128))',a0=x%N_Aux_Filename)
!write(lun,err=999)x%N_Aux_Filename

sname='N_Creation_Date'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Creation_Date'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A9))',a0=x%N_Creation_Date)
!write(lun,err=999)x%N_Creation_Date

sname='N_Creation_Time'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Creation_Time'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A15))',a0=x%N_Creation_Time)
!write(lun,err=999)x%N_Creation_Time

sname='N_Day_Night_Flag'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Day_Night_Flag'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A4))',a0=x%N_Day_Night_Flag)
!write(lun,err=999)x%N_Day_Night_Flag

sname='N_Graceful_Degradation'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Graceful_Degradation'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A8))',a0=x%N_Graceful_Degradation)
!write(lun,err=999)x%N_Graceful_Degradation

sname='N_Granule_ID'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Granule_ID'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A32))',a0=x%N_Granule_ID)
!write(lun,err=999)x%N_Granule_ID

sname='N_Granule_Status'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Granule_Status'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A16))',a0=x%N_Granule_Status)
!write(lun,err=999)x%N_Granule_Status

sname='N_Granule_Version'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Granule_Version'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A8))',a0=x%N_Granule_Version)
!write(lun,err=999)x%N_Granule_Version

sname='N_Input_Prod'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Input_Prod'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A32))',a0=x%N_Input_Prod)
!write(lun,err=999)x%N_Input_Prod

sname='N_LEOA_Flag'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_LEOA_Flag'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A4))',a0=x%N_LEOA_Flag)
!write(lun,err=999)x%N_LEOA_Flag

sname='N_Nadir_Latitude_Max'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Nadir_Latitude_Max'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%N_Nadir_Latitude_Max)
!write(lun,err=999)x%N_Nadir_Latitude_Max

sname='N_Nadir_Latitude_Min'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Nadir_Latitude_Min'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%N_Nadir_Latitude_Min)
!write(lun,err=999)x%N_Nadir_Latitude_Min

sname='N_Nadir_Longitude_Max'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Nadir_Longitude_Max'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%N_Nadir_Longitude_Max)
!write(lun,err=999)x%N_Nadir_Longitude_Max

sname='N_Nadir_Longitude_Min'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Nadir_Longitude_Min'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%N_Nadir_Longitude_Min)
!write(lun,err=999)x%N_Nadir_Longitude_Min

sname='N_NPOESS_Document_Ref'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_NPOESS_Document_Ref'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A128))',a0=x%N_NPOESS_Document_Ref)
!write(lun,err=999)x%N_NPOESS_Document_Ref

sname='N_Number_Of_Scans'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Number_Of_Scans'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_integer(lun,'(10000(I8))',a0=x%N_Number_Of_Scans)
!write(lun,err=999)x%N_Number_Of_Scans

sname='North_Bounding_Coordinate'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'North_Bounding_Coordinate'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%North_Bounding_Coordinate)
!write(lun,err=999)x%North_Bounding_Coordinate

sname='N_Packet_Type'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Packet_Type'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A16))',a0=x%N_Packet_Type)
!write(lun,err=999)x%N_Packet_Type

sname='N_Percent_Erroneous_Data'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Percent_Erroneous_Data'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%N_Percent_Erroneous_Data)
!write(lun,err=999)x%N_Percent_Erroneous_Data

sname='N_Percent_Missing_Data'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Percent_Missing_Data'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%N_Percent_Missing_Data)
!write(lun,err=999)x%N_Percent_Missing_Data

sname='N_Percent_Not_Applicable_Data'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Percent_Not-Applicable_Data'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%N_Percent_Not_Applicable_Data)
!write(lun,err=999)x%N_Percent_Not_Applicable_Data

sname='N_Quality_Summary_Names'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Quality_Summary_Names'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A64))',a0=x%N_Quality_Summary_Names)
!write(lun,err=999)x%N_Quality_Summary_Names

sname='N_Quality_Summary_Values'
if(associated(x%N_Quality_Summary_Values))then
  write(lun,'("SECTION = ",A)',err=999)trim(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'N_Quality_Summary_Values'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%N_Quality_Summary_Values), &
    & ubound(x%N_Quality_Summary_Values)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(I8))',a1=x%N_Quality_Summary_Values)
! write(lun,*,err=999)x%N_Quality_Summary_Values
endif

sname='N_Reference_ID'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Reference_ID'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A64))',a0=x%N_Reference_ID)
!write(lun,err=999)x%N_Reference_ID

sname='N_Satellite_Local_Azimuth_Angle_Max'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Satellite/Local_Azimuth_Angle_Max'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%N_Satellite_Local_Azimuth_Angle_Max)
!write(lun,err=999)x%N_Satellite_Local_Azimuth_Angle_Max

sname='N_Satellite_Local_Azimuth_Angle_Min'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Satellite/Local_Azimuth_Angle_Min'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%N_Satellite_Local_Azimuth_Angle_Min)
!write(lun,err=999)x%N_Satellite_Local_Azimuth_Angle_Min

sname='N_Satellite_Local_Zenith_Angle_Max'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Satellite/Local_Zenith_Angle_Max'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%N_Satellite_Local_Zenith_Angle_Max)
!write(lun,err=999)x%N_Satellite_Local_Zenith_Angle_Max

sname='N_Satellite_Local_Zenith_Angle_Min'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Satellite/Local_Zenith_Angle_Min'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%N_Satellite_Local_Zenith_Angle_Min)
!write(lun,err=999)x%N_Satellite_Local_Zenith_Angle_Min

sname='N_Software_Version'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Software_Version'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A16))',a0=x%N_Software_Version)
!write(lun,err=999)x%N_Software_Version

sname='N_Solar_Azimuth_Angle_Max'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Solar_Azimuth_Angle_Max'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%N_Solar_Azimuth_Angle_Max)
!write(lun,err=999)x%N_Solar_Azimuth_Angle_Max

sname='N_Solar_Azimuth_Angle_Min'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Solar_Azimuth_Angle_Min'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%N_Solar_Azimuth_Angle_Min)
!write(lun,err=999)x%N_Solar_Azimuth_Angle_Min

sname='N_Solar_Zenith_Angle_Max'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Solar_Zenith_Angle_Max'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%N_Solar_Zenith_Angle_Max)
!write(lun,err=999)x%N_Solar_Zenith_Angle_Max

sname='N_Solar_Zenith_Angle_Min'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Solar_Zenith_Angle_Min'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%N_Solar_Zenith_Angle_Min)
!write(lun,err=999)x%N_Solar_Zenith_Angle_Min

sname='N_Spacecraft_Maneuver'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'N_Spacecraft_Maneuver'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A32))',a0=x%N_Spacecraft_Maneuver)
!write(lun,err=999)x%N_Spacecraft_Maneuver

sname='South_Bounding_Coordinate'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'South_Bounding_Coordinate'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%South_Bounding_Coordinate)
!write(lun,err=999)x%South_Bounding_Coordinate

sname='West_Bounding_Coordinate'
write(lun,'("SECTION = ",A)',err=999)trim(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'West_Bounding_Coordinate'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_real(lun,'(10000(G16.7E3))',a0=x%West_Bounding_Coordinate)
!write(lun,err=999)x%West_Bounding_Coordinate

write(lun,'("SECTION = EOF")',err=999)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
err=0
CATCH
end subroutine

subroutine jpss_meta_granule_rh(x,lun,dname,err)
type(jpss_meta_granule),intent(out)::x
integer(hid_t),intent(in)::lun
character(len=*)::dname
integer,intent(out)::err
character(len=nlen)::sname
logical :: lext
integer::ival(1)
real::sval(1)
integer(HSIZE_T),dimension(7):: dims 
integer :: type_class
integer(SIZE_T):: type_size

TRY

call jpss_meta_granule_init(x)

sname='Ascending/Descending_Indicator'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_string_f(lun,dname,sname,x%Ascending_Descending_Indicator,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
endif

sname='Band_ID'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_string_f(lun,dname,sname,x%Band_ID,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
endif

sname='Beginning_Date'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_string_f(lun,dname,sname,x%Beginning_Date,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
endif

sname='Beginning_Time'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_string_f(lun,dname,sname,x%Beginning_Time,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
endif

sname='Cloud_Cover'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%Cloud_Cover=sval(1)
endif

sname='East_Bounding_Coordinate'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%East_Bounding_Coordinate=sval(1)
endif

sname='Ending_Date'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_string_f(lun,dname,sname,x%Ending_Date,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
endif

sname='Ending_Time'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_string_f(lun,dname,sname,x%Ending_Time,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
endif

sname='G-Ring_Latitude'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
dims=-1
call h5ltget_attribute_info_f(lun, dname, sname, dims, type_class, type_size, err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE INFO "//trim(sname))
allocate(x%G_Ring_Latitude(maxval(dims)), stat=err) ! attribute info returns dims in reverse order; only valid for 1 dimension arrays
THROWM(err.ne.0,"CANNOT ALLOCATE "//trim(sname))
call h5ltget_attribute_float_f(lun,dname,sname,x%G_Ring_Latitude,err)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='G-Ring_Longitude'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
dims=-1
call h5ltget_attribute_info_f(lun, dname, sname, dims, type_class, type_size, err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE INFO "//trim(sname))
allocate(x%G_Ring_Longitude(maxval(dims)), stat=err) ! attribute info returns dims in reverse order; only valid for 1 dimension arrays
THROWM(err.ne.0,"CANNOT ALLOCATE "//trim(sname))
call h5ltget_attribute_float_f(lun,dname,sname,x%G_Ring_Longitude,err)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='N_Algorithm_Version'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_string_f(lun,dname,sname,x%N_Algorithm_Version,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
endif



sname='N_Creation_Date'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_string_f(lun,dname,sname,x%N_Creation_Date,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
endif

sname='N_Creation_Time'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_string_f(lun,dname,sname,x%N_Creation_Time,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
endif

sname='N_Day_Night_Flag'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_string_f(lun,dname,sname,x%N_Day_Night_Flag,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
endif

sname='N_Graceful_Degradation'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_string_f(lun,dname,sname,x%N_Graceful_Degradation,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
endif

sname='N_Granule_ID'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_string_f(lun,dname,sname,x%N_Granule_ID,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
endif


sname='N_Granule_Version'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_string_f(lun,dname,sname,x%N_Granule_Version,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
endif


sname='N_LEOA_Flag'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_string_f(lun,dname,sname,x%N_LEOA_Flag,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
endif

sname='N_Nadir_Latitude_Max'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%N_Nadir_Latitude_Max=sval(1)
endif

sname='N_Nadir_Latitude_Min'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%N_Nadir_Latitude_Min=sval(1)
endif

sname='N_Nadir_Longitude_Max'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%N_Nadir_Longitude_Max=sval(1)
endif

sname='N_Nadir_Longitude_Min'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%N_Nadir_Longitude_Min=sval(1)
endif


sname='N_Number_Of_Scans'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_int_f(lun,dname,sname,ival(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%N_Number_Of_Scans=ival(1)
endif

sname='North_Bounding_Coordinate'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%North_Bounding_Coordinate=sval(1)
endif


sname='N_Percent_Erroneous_Data'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%N_Percent_Erroneous_Data=sval(1)
endif

sname='N_Percent_Missing_Data'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%N_Percent_Missing_Data=sval(1)
endif

sname='N_Percent_Not-Applicable_Data'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%N_Percent_Not_Applicable_Data=sval(1)
endif


sname='N_Quality_Summary_Values'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
dims=-1
call h5ltget_attribute_info_f(lun, dname, sname, dims, type_class, type_size, err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE INFO "//trim(sname))
allocate(x%N_Quality_Summary_Values(maxval(dims)), stat=err) ! attribute info returns dims in reverse order; only valid for 1 dimension arrays
THROWM(err.ne.0,"CANNOT ALLOCATE "//trim(sname))
call h5ltget_attribute_int_f(lun,dname,sname,x%N_Quality_Summary_Values,err)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='N_Reference_ID'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_string_f(lun,dname,sname,x%N_Reference_ID,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
endif

sname='N_Satellite/Local_Azimuth_Angle_Max'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%N_Satellite_Local_Azimuth_Angle_Max=sval(1)
endif

sname='N_Satellite/Local_Azimuth_Angle_Min'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%N_Satellite_Local_Azimuth_Angle_Min=sval(1)
endif

sname='N_Satellite/Local_Zenith_Angle_Max'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%N_Satellite_Local_Zenith_Angle_Max=sval(1)
endif

sname='N_Satellite/Local_Zenith_Angle_Min'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%N_Satellite_Local_Zenith_Angle_Min=sval(1)
endif

sname='N_Software_Version'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_string_f(lun,dname,sname,x%N_Software_Version,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
endif

sname='N_Solar_Azimuth_Angle_Max'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%N_Solar_Azimuth_Angle_Max=sval(1)
endif

sname='N_Solar_Azimuth_Angle_Min'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%N_Solar_Azimuth_Angle_Min=sval(1)
endif

sname='N_Solar_Zenith_Angle_Max'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%N_Solar_Zenith_Angle_Max=sval(1)
endif

sname='N_Solar_Zenith_Angle_Min'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%N_Solar_Zenith_Angle_Min=sval(1)
endif

sname='N_Spacecraft_Maneuver'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_string_f(lun,dname,sname,x%N_Spacecraft_Maneuver,err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
endif

sname='South_Bounding_Coordinate'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%South_Bounding_Coordinate=sval(1)
endif

sname='West_Bounding_Coordinate'
call h5aexists_by_name_f(lun, dname, sname, lext, err)
if( lext ) then
call h5ltget_attribute_float_f(lun,dname,sname,sval(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))
x%West_Bounding_Coordinate=sval(1)
endif

err=0
CATCH
end subroutine

subroutine jpss_meta_granule_wh(x,lun,dname,err)
type(jpss_meta_granule),intent(in)::x
integer(hid_t),intent(in)::lun
character(len=*)::dname
integer,intent(out)::err
character(len=nlen)::sname
integer::ival(1)
real::sval(1)
INTEGER(SIZE_T) :: idims(1)

TRY
idims(1)=1
sname='Ascending/Descending_Indicator'
call h5ltset_attribute_string_f(lun,dname,sname,x%Ascending_Descending_Indicator,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='Band_ID'
call h5ltset_attribute_string_f(lun,dname,sname,x%Band_ID,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='Beginning_Date'
call h5ltset_attribute_string_f(lun,dname,sname,x%Beginning_Date,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='Beginning_Time'
call h5ltset_attribute_string_f(lun,dname,sname,x%Beginning_Time,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='Cloud_Cover'
sval(1)=x%Cloud_Cover
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='East_Bounding_Coordinate'
sval(1)=x%East_Bounding_Coordinate
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='Ending_Date'
call h5ltset_attribute_string_f(lun,dname,sname,x%Ending_Date,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='Ending_Time'
call h5ltset_attribute_string_f(lun,dname,sname,x%Ending_Time,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='G-Ring_Latitude'
idims = size(x%G_Ring_Latitude)
call h5ltset_attribute_float_f(lun,dname,sname,x%G_Ring_Latitude,idims(1),err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='G-Ring_Longitude'
idims = size(x%G_Ring_Longitude)
call h5ltset_attribute_float_f(lun,dname,sname,x%G_Ring_Longitude,idims(1),err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='N_Algorithm_Version'
call h5ltset_attribute_string_f(lun,dname,sname,x%N_Algorithm_Version,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))



sname='N_Creation_Date'
call h5ltset_attribute_string_f(lun,dname,sname,x%N_Creation_Date,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='N_Creation_Time'
call h5ltset_attribute_string_f(lun,dname,sname,x%N_Creation_Time,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='N_Day_Night_Flag'
call h5ltset_attribute_string_f(lun,dname,sname,x%N_Day_Night_Flag,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='N_Graceful_Degradation'
call h5ltset_attribute_string_f(lun,dname,sname,x%N_Graceful_Degradation,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='N_Granule_ID'
call h5ltset_attribute_string_f(lun,dname,sname,x%N_Granule_ID,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))


sname='N_Granule_Version'
call h5ltset_attribute_string_f(lun,dname,sname,x%N_Granule_Version,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))


sname='N_LEOA_Flag'
call h5ltset_attribute_string_f(lun,dname,sname,x%N_LEOA_Flag,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='N_Nadir_Latitude_Max'
sval(1)=x%N_Nadir_Latitude_Max
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='N_Nadir_Latitude_Min'
sval(1)=x%N_Nadir_Latitude_Min
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='N_Nadir_Longitude_Max'
sval(1)=x%N_Nadir_Longitude_Max
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='N_Nadir_Longitude_Min'
sval(1)=x%N_Nadir_Longitude_Min
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))


sname='N_Number_Of_Scans'
ival(1)=x%N_Number_Of_Scans
idims(1)=1
call h5ltset_attribute_int_f(lun,dname,sname,ival(1),idims(1),err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='North_Bounding_Coordinate'
sval(1)=x%North_Bounding_Coordinate
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))


sname='N_Percent_Erroneous_Data'
sval(1)=x%N_Percent_Erroneous_Data
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='N_Percent_Missing_Data'
sval(1)=x%N_Percent_Missing_Data
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='N_Percent_Not-Applicable_Data'
sval(1)=x%N_Percent_Not_Applicable_Data
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))


sname='N_Quality_Summary_Values'
idims = size(x%N_Quality_Summary_Values)
call h5ltset_attribute_int_f(lun,dname,sname,x%N_Quality_Summary_Values,idims(1),err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='N_Reference_ID'
call h5ltset_attribute_string_f(lun,dname,sname,x%N_Reference_ID,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='N_Satellite/Local_Azimuth_Angle_Max'
sval(1)=x%N_Satellite_Local_Azimuth_Angle_Max
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='N_Satellite/Local_Azimuth_Angle_Min'
sval(1)=x%N_Satellite_Local_Azimuth_Angle_Min
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='N_Satellite/Local_Zenith_Angle_Max'
sval(1)=x%N_Satellite_Local_Zenith_Angle_Max
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='N_Satellite/Local_Zenith_Angle_Min'
sval(1)=x%N_Satellite_Local_Zenith_Angle_Min
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='N_Software_Version'
call h5ltset_attribute_string_f(lun,dname,sname,x%N_Software_Version,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='N_Solar_Azimuth_Angle_Max'
sval(1)=x%N_Solar_Azimuth_Angle_Max
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='N_Solar_Azimuth_Angle_Min'
sval(1)=x%N_Solar_Azimuth_Angle_Min
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='N_Solar_Zenith_Angle_Max'
sval(1)=x%N_Solar_Zenith_Angle_Max
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='N_Solar_Zenith_Angle_Min'
sval(1)=x%N_Solar_Zenith_Angle_Min
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='N_Spacecraft_Maneuver'
call h5ltset_attribute_string_f(lun,dname,sname,x%N_Spacecraft_Maneuver,err)
THROWM(err.ne.0,"CANNOT WRITE ATTRIBUTE "//trim(sname))

sname='South_Bounding_Coordinate'
sval(1)=x%South_Bounding_Coordinate
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

sname='West_Bounding_Coordinate'
sval(1)=x%West_Bounding_Coordinate
idims(1)=1
call h5ltset_attribute_float_f(lun,dname,sname,sval(1),idims(1),err)
THROWM(err.ne.0,"CANNOT READ ATTRIBUTE "//trim(sname))

err=0
CATCH
end subroutine

#endif

end module
