!
! Automatically generated by ./mod_att_rw.pl version 1.2
! Do not edit
!
! Name: $Id: jpss_meta_granule_mem.F90
!
! Purpose: jpss meta granule init structure,free pointers,copy structures module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!  
module jpss_meta_granule_mem
#include "aapp_throw.h"
use jpss_meta_granule_def
implicit none
private
public :: jpss_meta_granule_free
public :: jpss_meta_granule_init
public :: jpss_meta_granule_copy
public :: jpss_meta_granule_paste


contains

subroutine jpss_meta_granule_free(x,err)
type(jpss_meta_granule),intent(inout)::x
integer,intent(out)::err
character(len=nlen)::sname
TRY
err = 0

sname='G_Ring_Latitude'
if(associated(x%G_Ring_Latitude))then
  deallocate(x%G_Ring_Latitude,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%G_Ring_Latitude)
endif
sname='G_Ring_Longitude'
if(associated(x%G_Ring_Longitude))then
  deallocate(x%G_Ring_Longitude,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%G_Ring_Longitude)
endif
sname='N_Quality_Summary_Values'
if(associated(x%N_Quality_Summary_Values))then
  deallocate(x%N_Quality_Summary_Values,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%N_Quality_Summary_Values)
endif
CATCH
end subroutine

subroutine jpss_meta_granule_init(x)
type(jpss_meta_granule),intent(inout)::x

  x%Ascending_Descending_Indicator=''
  x%Band_ID=''
  x%Beginning_Date=''
  x%Beginning_Time=''
  x%Cloud_Cover=0.
  x%East_Bounding_Coordinate=0.
  x%Ending_Date=''
  x%Ending_Time=''
  nullify(x%G_Ring_Latitude)
  nullify(x%G_Ring_Longitude)
  x%N_Algorithm_Version=''
  x%N_Anc_Filename=''
  x%N_Aux_Filename=''
  x%N_Creation_Date=''
  x%N_Creation_Time=''
  x%N_Day_Night_Flag=''
  x%N_Graceful_Degradation=''
  x%N_Granule_ID=''
  x%N_Granule_Status=''
  x%N_Granule_Version=''
  x%N_Input_Prod=''
  x%N_LEOA_Flag=''
  x%N_Nadir_Latitude_Max=0.
  x%N_Nadir_Latitude_Min=0.
  x%N_Nadir_Longitude_Max=0.
  x%N_Nadir_Longitude_Min=0.
  x%N_NPOESS_Document_Ref=''
  x%N_Number_Of_Scans=0
  x%North_Bounding_Coordinate=0.
  x%N_Packet_Type=''
  x%N_Percent_Erroneous_Data=0.
  x%N_Percent_Missing_Data=0.
  x%N_Percent_Not_Applicable_Data=0.
  x%N_Quality_Summary_Names=''
  nullify(x%N_Quality_Summary_Values)
  x%N_Reference_ID=''
  x%N_Satellite_Local_Azimuth_Angle_Max=0.
  x%N_Satellite_Local_Azimuth_Angle_Min=0.
  x%N_Satellite_Local_Zenith_Angle_Max=0.
  x%N_Satellite_Local_Zenith_Angle_Min=0.
  x%N_Software_Version=''
  x%N_Solar_Azimuth_Angle_Max=0.
  x%N_Solar_Azimuth_Angle_Min=0.
  x%N_Solar_Zenith_Angle_Max=0.
  x%N_Solar_Zenith_Angle_Min=0.
  x%N_Spacecraft_Maneuver=''
  x%South_Bounding_Coordinate=0.
  x%West_Bounding_Coordinate=0.
end subroutine

subroutine jpss_meta_granule_copy(x,y,err,data)
type(jpss_meta_granule),intent(inout)::x
type(jpss_meta_granule),intent(in)::y
integer,intent(out)::err
logical, optional :: data
integer::lb(7),ub(7)
logical :: data1

TRY

  data1=.true.
  if(present(data))data1 = data
  
  if(data1)x%Ascending_Descending_Indicator=y%Ascending_Descending_Indicator
  if(data1)x%Band_ID=y%Band_ID
  if(data1)x%Beginning_Date=y%Beginning_Date
  if(data1)x%Beginning_Time=y%Beginning_Time
  if(data1)x%Cloud_Cover=y%Cloud_Cover
  if(data1)x%East_Bounding_Coordinate=y%East_Bounding_Coordinate
  if(data1)x%Ending_Date=y%Ending_Date
  if(data1)x%Ending_Time=y%Ending_Time
  if(associated(y%G_Ring_Latitude))then
    lb(1:1)=lbound(y%G_Ring_Latitude)
    ub(1:1)=ubound(y%G_Ring_Latitude)
    allocate(x%G_Ring_Latitude(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE G_Ring_Latitude")
    if(data1)x%G_Ring_Latitude=y%G_Ring_Latitude
  else
    nullify(x%G_Ring_Latitude)
  endif
  if(associated(y%G_Ring_Longitude))then
    lb(1:1)=lbound(y%G_Ring_Longitude)
    ub(1:1)=ubound(y%G_Ring_Longitude)
    allocate(x%G_Ring_Longitude(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE G_Ring_Longitude")
    if(data1)x%G_Ring_Longitude=y%G_Ring_Longitude
  else
    nullify(x%G_Ring_Longitude)
  endif
  if(data1)x%N_Algorithm_Version=y%N_Algorithm_Version
  if(data1)x%N_Anc_Filename=y%N_Anc_Filename
  if(data1)x%N_Aux_Filename=y%N_Aux_Filename
  if(data1)x%N_Creation_Date=y%N_Creation_Date
  if(data1)x%N_Creation_Time=y%N_Creation_Time
  if(data1)x%N_Day_Night_Flag=y%N_Day_Night_Flag
  if(data1)x%N_Graceful_Degradation=y%N_Graceful_Degradation
  if(data1)x%N_Granule_ID=y%N_Granule_ID
  if(data1)x%N_Granule_Status=y%N_Granule_Status
  if(data1)x%N_Granule_Version=y%N_Granule_Version
  if(data1)x%N_Input_Prod=y%N_Input_Prod
  if(data1)x%N_LEOA_Flag=y%N_LEOA_Flag
  if(data1)x%N_Nadir_Latitude_Max=y%N_Nadir_Latitude_Max
  if(data1)x%N_Nadir_Latitude_Min=y%N_Nadir_Latitude_Min
  if(data1)x%N_Nadir_Longitude_Max=y%N_Nadir_Longitude_Max
  if(data1)x%N_Nadir_Longitude_Min=y%N_Nadir_Longitude_Min
  if(data1)x%N_NPOESS_Document_Ref=y%N_NPOESS_Document_Ref
  if(data1)x%N_Number_Of_Scans=y%N_Number_Of_Scans
  if(data1)x%North_Bounding_Coordinate=y%North_Bounding_Coordinate
  if(data1)x%N_Packet_Type=y%N_Packet_Type
  if(data1)x%N_Percent_Erroneous_Data=y%N_Percent_Erroneous_Data
  if(data1)x%N_Percent_Missing_Data=y%N_Percent_Missing_Data
  if(data1)x%N_Percent_Not_Applicable_Data=y%N_Percent_Not_Applicable_Data
  if(data1)x%N_Quality_Summary_Names=y%N_Quality_Summary_Names
  if(associated(y%N_Quality_Summary_Values))then
    lb(1:1)=lbound(y%N_Quality_Summary_Values)
    ub(1:1)=ubound(y%N_Quality_Summary_Values)
    allocate(x%N_Quality_Summary_Values(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE N_Quality_Summary_Values")
    if(data1)x%N_Quality_Summary_Values=y%N_Quality_Summary_Values
  else
    nullify(x%N_Quality_Summary_Values)
  endif
  if(data1)x%N_Reference_ID=y%N_Reference_ID
  if(data1)x%N_Satellite_Local_Azimuth_Angle_Max=y%N_Satellite_Local_Azimuth_Angle_Max
  if(data1)x%N_Satellite_Local_Azimuth_Angle_Min=y%N_Satellite_Local_Azimuth_Angle_Min
  if(data1)x%N_Satellite_Local_Zenith_Angle_Max=y%N_Satellite_Local_Zenith_Angle_Max
  if(data1)x%N_Satellite_Local_Zenith_Angle_Min=y%N_Satellite_Local_Zenith_Angle_Min
  if(data1)x%N_Software_Version=y%N_Software_Version
  if(data1)x%N_Solar_Azimuth_Angle_Max=y%N_Solar_Azimuth_Angle_Max
  if(data1)x%N_Solar_Azimuth_Angle_Min=y%N_Solar_Azimuth_Angle_Min
  if(data1)x%N_Solar_Zenith_Angle_Max=y%N_Solar_Zenith_Angle_Max
  if(data1)x%N_Solar_Zenith_Angle_Min=y%N_Solar_Zenith_Angle_Min
  if(data1)x%N_Spacecraft_Maneuver=y%N_Spacecraft_Maneuver
  if(data1)x%South_Bounding_Coordinate=y%South_Bounding_Coordinate
  if(data1)x%West_Bounding_Coordinate=y%West_Bounding_Coordinate
CATCH
end subroutine

subroutine jpss_meta_granule_paste(x,y,z,err,data)
! only pointer arrays are considered
! for any other type the Y value is passed to X
! paste the last dimension of array
type(jpss_meta_granule),intent(inout)::x
type(jpss_meta_granule),intent(in)::y
type(jpss_meta_granule),intent(in)::z
integer,intent(out)::err
logical, optional :: data
integer::lby(7),uby(7)
integer::lbz(7),ubz(7)
integer::lb1(7),ub1(7)
integer::lb2(7),ub2(7)

logical :: data1

TRY

  data1=.true.
  if(present(data))data1 = data
  
  if(data1)x%Ascending_Descending_Indicator=y%Ascending_Descending_Indicator
  if(data1)x%Band_ID=y%Band_ID
  if(data1)x%Beginning_Date=y%Beginning_Date
  if(data1)x%Beginning_Time=y%Beginning_Time
  if(data1)x%Cloud_Cover=y%Cloud_Cover
  if(data1)x%East_Bounding_Coordinate=y%East_Bounding_Coordinate
  if(data1)x%Ending_Date=y%Ending_Date
  if(data1)x%Ending_Time=y%Ending_Time
  if(associated(y%G_Ring_Latitude) .and. associated(z%G_Ring_Latitude))then
    lby(1:1)=lbound(y%G_Ring_Latitude)
    uby(1:1)=ubound(y%G_Ring_Latitude)

    lbz(1:1)=lbound(z%G_Ring_Latitude)
    ubz(1:1)=ubound(z%G_Ring_Latitude)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%G_Ring_Latitude(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE G_Ring_Latitude")
    if(data1) then
      x%G_Ring_Latitude(lb1(1):ub1(1))=y%G_Ring_Latitude
      x%G_Ring_Latitude(lb2(1):ub2(1))=z%G_Ring_Latitude
    endif
  else
    nullify(x%G_Ring_Latitude)
  endif
  if(associated(y%G_Ring_Longitude) .and. associated(z%G_Ring_Longitude))then
    lby(1:1)=lbound(y%G_Ring_Longitude)
    uby(1:1)=ubound(y%G_Ring_Longitude)

    lbz(1:1)=lbound(z%G_Ring_Longitude)
    ubz(1:1)=ubound(z%G_Ring_Longitude)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%G_Ring_Longitude(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE G_Ring_Longitude")
    if(data1) then
      x%G_Ring_Longitude(lb1(1):ub1(1))=y%G_Ring_Longitude
      x%G_Ring_Longitude(lb2(1):ub2(1))=z%G_Ring_Longitude
    endif
  else
    nullify(x%G_Ring_Longitude)
  endif
  if(data1)x%N_Algorithm_Version=y%N_Algorithm_Version
  if(data1)x%N_Anc_Filename=y%N_Anc_Filename
  if(data1)x%N_Aux_Filename=y%N_Aux_Filename
  if(data1)x%N_Creation_Date=y%N_Creation_Date
  if(data1)x%N_Creation_Time=y%N_Creation_Time
  if(data1)x%N_Day_Night_Flag=y%N_Day_Night_Flag
  if(data1)x%N_Graceful_Degradation=y%N_Graceful_Degradation
  if(data1)x%N_Granule_ID=y%N_Granule_ID
  if(data1)x%N_Granule_Status=y%N_Granule_Status
  if(data1)x%N_Granule_Version=y%N_Granule_Version
  if(data1)x%N_Input_Prod=y%N_Input_Prod
  if(data1)x%N_LEOA_Flag=y%N_LEOA_Flag
  if(data1)x%N_Nadir_Latitude_Max=y%N_Nadir_Latitude_Max
  if(data1)x%N_Nadir_Latitude_Min=y%N_Nadir_Latitude_Min
  if(data1)x%N_Nadir_Longitude_Max=y%N_Nadir_Longitude_Max
  if(data1)x%N_Nadir_Longitude_Min=y%N_Nadir_Longitude_Min
  if(data1)x%N_NPOESS_Document_Ref=y%N_NPOESS_Document_Ref
  if(data1)x%N_Number_Of_Scans=y%N_Number_Of_Scans
  if(data1)x%North_Bounding_Coordinate=y%North_Bounding_Coordinate
  if(data1)x%N_Packet_Type=y%N_Packet_Type
  if(data1)x%N_Percent_Erroneous_Data=y%N_Percent_Erroneous_Data
  if(data1)x%N_Percent_Missing_Data=y%N_Percent_Missing_Data
  if(data1)x%N_Percent_Not_Applicable_Data=y%N_Percent_Not_Applicable_Data
  if(data1)x%N_Quality_Summary_Names=y%N_Quality_Summary_Names
  if(associated(y%N_Quality_Summary_Values) .and. associated(z%N_Quality_Summary_Values))then
    lby(1:1)=lbound(y%N_Quality_Summary_Values)
    uby(1:1)=ubound(y%N_Quality_Summary_Values)

    lbz(1:1)=lbound(z%N_Quality_Summary_Values)
    ubz(1:1)=ubound(z%N_Quality_Summary_Values)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%N_Quality_Summary_Values(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE N_Quality_Summary_Values")
    if(data1) then
      x%N_Quality_Summary_Values(lb1(1):ub1(1))=y%N_Quality_Summary_Values
      x%N_Quality_Summary_Values(lb2(1):ub2(1))=z%N_Quality_Summary_Values
    endif
  else
    nullify(x%N_Quality_Summary_Values)
  endif
  if(data1)x%N_Reference_ID=y%N_Reference_ID
  if(data1)x%N_Satellite_Local_Azimuth_Angle_Max=y%N_Satellite_Local_Azimuth_Angle_Max
  if(data1)x%N_Satellite_Local_Azimuth_Angle_Min=y%N_Satellite_Local_Azimuth_Angle_Min
  if(data1)x%N_Satellite_Local_Zenith_Angle_Max=y%N_Satellite_Local_Zenith_Angle_Max
  if(data1)x%N_Satellite_Local_Zenith_Angle_Min=y%N_Satellite_Local_Zenith_Angle_Min
  if(data1)x%N_Software_Version=y%N_Software_Version
  if(data1)x%N_Solar_Azimuth_Angle_Max=y%N_Solar_Azimuth_Angle_Max
  if(data1)x%N_Solar_Azimuth_Angle_Min=y%N_Solar_Azimuth_Angle_Min
  if(data1)x%N_Solar_Zenith_Angle_Max=y%N_Solar_Zenith_Angle_Max
  if(data1)x%N_Solar_Zenith_Angle_Min=y%N_Solar_Zenith_Angle_Min
  if(data1)x%N_Spacecraft_Maneuver=y%N_Spacecraft_Maneuver
  if(data1)x%South_Bounding_Coordinate=y%South_Bounding_Coordinate
  if(data1)x%West_Bounding_Coordinate=y%West_Bounding_Coordinate
CATCH
end subroutine

end module
