! Name: $Id$
!
! Purpose:  jpss meta root fortan structure definition module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!   1.1   11/01/2018 Update for JPSS-1 (Pascale Roquet)
!
module jpss_meta_root_def

implicit none
private
integer, parameter :: nlen = 256   ! name length
public :: nlen
public :: jpss_meta_root

type jpss_meta_root
  character(len=5)::Distributor ! Distributor
  character(len=6)::Mission_Name ! Mission Name
  character(len=9)::N_Dataset_Source ! N_Dataset_Source
  character(len=9)::N_HDF_Creation_Date ! N_HDF_Creation_Date
  character(len=15)::N_HDF_Creation_Time ! N_HDF_Creation_Time
  character(len=79)::N_GEO_Ref ! N_GEO_Ref
  character(len=4)::Platform_Short_Name ! Platform_Short_Name
end type

end module
