!
! Automatically generated by ./mod_rw.pl version 1.2
! Do not edit
!
! Name: $Id: viirs_edr_img_data_def.F90
!
! Purpose: viirs edr img fortan structure definition module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!  

module viirs_edr_img_data_def

implicit none
private
integer, parameter :: nlen = 256   ! name length
public :: nlen
public :: viirs_edr_img_data

type viirs_edr_img_data
  integer::Channel ! Channel number (instrument number)
  character(len=3)::Channel_Name ! Instrument channel name ( I1 to I5, M1 to M16, NCC, left aligned, uppercase)
  real,pointer,dimension(:,:)::Radiance ! Calibrated TOA Radiance for each VIIRS pixel W/(m2 sr micron)
    !  [pixels, lines]
  integer,pointer,dimension(:,:)::Reflectance ! Calibrated TOA Relectance for each VIIRS pixel (from file)
    !  [pixels, lines]
  real,pointer,dimension(:,:)::BrightnessTemperature ! Calibrated TOA Brightness Temperature for each VIIRS pixel (K)
    !  [pixels, lines]
  real,pointer,dimension(:,:)::BrightnessTemperatureOrReflectance ! Calibrated TOA Bright. Temp. or Reflectance for each VIIRS pixel
    !  [pixels, lines]
  integer,pointer,dimension(:,:)::Albedo ! Normalised top of atmosphere reflectance (no atmospheric correction applied)
    !  [pixels, lines]
  integer,pointer,dimension(:,:)::QF1_VIIRSIMGEDR ! Pixel level quaility flags [pixels, lines]
  integer,pointer,dimension(:,:)::QF1_VIIRSNCCEDR ! Pixel level quaility flags [pixels, lines]
  real,pointer,dimension(:)::RadianceFactors ! Radiance scale and offset: first scale,second offset
  real,pointer,dimension(:)::ReflectanceFactors ! Reflectance scale and offset: first scale, second offset
  real,pointer,dimension(:)::BrightnessTemperatureFactors ! Brightness Temperature sc/offs: first scale, second offset
  real,pointer,dimension(:)::BrightnessTemperatureOrReflectanceFactors ! Bright. Temp. or Reflectance sc/offs: first scale, second offset
  real,pointer,dimension(:)::AlbedoFactors ! Albedo scale and offset: first scale, second offset
  real,pointer,dimension(:,:)::Reflectances ! Calibrated TOA Relectance for each VIIRS pixel REAL values
    !  [pixels, lines]
  real,pointer,dimension(:,:)::Albedos ! Normalised top of atmosphere reflectance REAL values
    !  [pixels, lines]
end type

end module
