!
! Automatically generated by ./mod_rw.pl  version 1.2
! Do not edit
! Name: $Id: viirs_edr_img_data_io.F90 
!
! Purpose:  viirs edr img Fortran I/O module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!
module viirs_edr_img_data_io

#ifdef HAS_LIBHDF5

#include "aapp_throw.h"
!use rttov_print_mod
use aapp_hdf_mod
use viirs_edr_img_data_def
use viirs_edr_img_data_mem
use hdf5
implicit none
private
public :: viirs_edr_img_data_rh
public :: viirs_edr_img_data_wh
public :: viirs_edr_img_data_writea


contains


subroutine viirs_edr_img_data_writea(x,lun,err)
type(viirs_edr_img_data),intent(in)::x
integer,intent(in)::lun
integer,intent(out)::err
integer::lb(7),ub(7)
character(len=nlen)::sname

TRY
sname='Channel'
write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Channel number (instrument number)'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("UNITS = ",A)',iostat=err)''
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_integer(lun,'(10000(I8))',a0=x%Channel)
!write(lun,err=999)x%Channel

sname='Channel_Name'
write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Instrument channel name ( I1 to I5, M1 to M16, NCC, left aligned, uppercase)'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("UNITS = ",A)',iostat=err)''
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A3))',a0=x%Channel_Name)
!write(lun,err=999)x%Channel_Name

sname='Radiance'
if(associated(x%Radiance))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Calibrated TOA Radiance for each VIIRS pixel W/(m2 sr micron)'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%Radiance), &
    & ubound(x%Radiance)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%Radiance)
! write(lun,*,err=999)x%Radiance
endif


sname='BrightnessTemperature'
if(associated(x%BrightnessTemperature))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Calibrated TOA Brightness Temperature for each VIIRS pixel (K)'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%BrightnessTemperature), &
    & ubound(x%BrightnessTemperature)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%BrightnessTemperature)
! write(lun,*,err=999)x%BrightnessTemperature
endif

sname='BrightnessTemperatureOrReflectance'
if(associated(x%BrightnessTemperatureOrReflectance))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Calibrated TOA Bright. Temp. or Reflectance for each VIIRS pixel'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%BrightnessTemperatureOrReflectance), &
    & ubound(x%BrightnessTemperatureOrReflectance)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%BrightnessTemperatureOrReflectance)
! write(lun,*,err=999)x%BrightnessTemperatureOrReflectance
endif

sname='Albedo'
if(associated(x%Albedo))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Normalised top of atmosphere reflectance (no atmospheric correction applied)'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%Albedo), &
    & ubound(x%Albedo)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(I8))',a2=x%Albedo)
! write(lun,*,err=999)x%Albedo
endif

sname='QF1_VIIRSIMGEDR'
if(associated(x%QF1_VIIRSIMGEDR))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Pixel level quaility flags [pixels, lines]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%QF1_VIIRSIMGEDR), &
    & ubound(x%QF1_VIIRSIMGEDR)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(Z4))',a2=x%QF1_VIIRSIMGEDR)
! write(lun,*,err=999)x%QF1_VIIRSIMGEDR
endif

sname='QF1_VIIRSNCCEDR'
if(associated(x%QF1_VIIRSNCCEDR))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Pixel level quaility flags [pixels, lines]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%QF1_VIIRSNCCEDR), &
    & ubound(x%QF1_VIIRSNCCEDR)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(Z4))',a2=x%QF1_VIIRSNCCEDR)
! write(lun,*,err=999)x%QF1_VIIRSNCCEDR
endif

sname='RadianceFactors'
if(associated(x%RadianceFactors))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Radiance scale and offset: first scale,second offset'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%RadianceFactors), &
    & ubound(x%RadianceFactors)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a1=x%RadianceFactors)
! write(lun,*,err=999)x%RadianceFactors
endif

sname='ReflectanceFactors'
if(associated(x%ReflectanceFactors))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Reflectance scale and offset: first scale, second offset'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%ReflectanceFactors), &
    & ubound(x%ReflectanceFactors)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a1=x%ReflectanceFactors)
! write(lun,*,err=999)x%ReflectanceFactors
endif

sname='BrightnessTemperatureFactors'
if(associated(x%BrightnessTemperatureFactors))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Brightness Temperature sc/offs: first scale, second offset'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%BrightnessTemperatureFactors), &
    & ubound(x%BrightnessTemperatureFactors)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a1=x%BrightnessTemperatureFactors)
! write(lun,*,err=999)x%BrightnessTemperatureFactors
endif

sname='BrightnessTemperatureOrReflectanceFactors'
if(associated(x%BrightnessTemperatureOrReflectanceFactors))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Bright. Temp. or Reflectance sc/offs: first scale, second offset'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%BrightnessTemperatureOrReflectanceFactors), &
    & ubound(x%BrightnessTemperatureOrReflectanceFactors)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a1=x%BrightnessTemperatureOrReflectanceFactors)
! write(lun,*,err=999)x%BrightnessTemperatureOrReflectanceFactors
endif

sname='AlbedoFactors'
if(associated(x%AlbedoFactors))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Albedo scale and offset: first scale, second offset'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%AlbedoFactors), &
    & ubound(x%AlbedoFactors)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a1=x%AlbedoFactors)
! write(lun,*,err=999)x%AlbedoFactors
endif

sname='Reflectances'
if(associated(x%Reflectances))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Calibrated TOA Relectance for each VIIRS pixel REAL values'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%Reflectances), &
    & ubound(x%Reflectances)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%Reflectances)
! write(lun,*,err=999)x%Reflectances
endif

sname='Albedos'
if(associated(x%Albedos))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Normalised top of atmosphere reflectance REAL values'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%Albedos), &
    & ubound(x%Albedos)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%Albedos)
! write(lun,*,err=999)x%Albedos
endif

write(lun,'("SECTION = EOF")',err=999)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
err=0
CATCH
end subroutine

subroutine viirs_edr_img_data_rh(x,lun,err)
type(viirs_edr_img_data),intent(out)::x
integer(hid_t),intent(in)::lun
integer,intent(out)::err
character(len=nlen)::sname
logical :: lext
TRY

call viirs_edr_img_data_init(x)



sname='Radiance'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr2=x%Radiance)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='Reflectance'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pi2=x%Reflectance)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='BrightnessTemperature'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr2=x%BrightnessTemperature)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='BrightnessTemperatureOrReflectance'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr2=x%BrightnessTemperatureOrReflectance)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='Albedo'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pi2=x%Albedo)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='QF1_VIIRSIMGEDR'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pi2=x%QF1_VIIRSIMGEDR)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='QF1_VIIRSNCCEDR'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pi2=x%QF1_VIIRSNCCEDR)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='RadianceFactors'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr1=x%RadianceFactors)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='ReflectanceFactors'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr1=x%ReflectanceFactors)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='BrightnessTemperatureFactors'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr1=x%BrightnessTemperatureFactors)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='BrightnessTemperatureOrReflectanceFactors'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr1=x%BrightnessTemperatureOrReflectanceFactors)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='AlbedoFactors'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr1=x%AlbedoFactors)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif



err=0
CATCH
end subroutine

subroutine viirs_edr_img_data_wh(x,lun,err, compress)
type(viirs_edr_img_data),intent(in)::x
integer(hid_t),intent(in)::lun
integer,intent(out)::err
logical,intent(in),optional::compress
character(len=nlen)::sname
TRY


sname='Radiance'
if(associated(x%Radiance))then
  call write_array_hdf(lun,sname,&
    & 'Calibrated TOA Radiance for each VIIRS pixel W/(m2 sr micron)',&
    & err,r2=x%Radiance  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='Reflectance'
if(associated(x%Reflectance))then
  call write_array_hdf(lun,sname,&
    & 'Calibrated TOA Relectance for each VIIRS pixel (from file)',&
    & err,i2=x%Reflectance  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='BrightnessTemperature'
if(associated(x%BrightnessTemperature))then
  call write_array_hdf(lun,sname,&
    & 'Calibrated TOA Brightness Temperature for each VIIRS pixel (K)',&
    & err,r2=x%BrightnessTemperature  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='BrightnessTemperatureOrReflectance'
if(associated(x%BrightnessTemperatureOrReflectance))then
  call write_array_hdf(lun,sname,&
    & 'Calibrated TOA Bright. Temp. or Reflectance for each VIIRS pixel',&
    & err,r2=x%BrightnessTemperatureOrReflectance  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='Albedo'
if(associated(x%Albedo))then
  call write_array_hdf(lun,sname,&
    & 'Normalised top of atmosphere reflectance (no atmospheric correction applied)',&
    & err,i2=x%Albedo  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='QF1_VIIRSIMGEDR'
if(associated(x%QF1_VIIRSIMGEDR))then
  call write_array_hdf(lun,sname,&
    & 'Pixel level quaility flags [pixels, lines]',&
    & err,i2=x%QF1_VIIRSIMGEDR  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='QF1_VIIRSNCCEDR'
if(associated(x%QF1_VIIRSNCCEDR))then
  call write_array_hdf(lun,sname,&
    & 'Pixel level quaility flags [pixels, lines]',&
    & err,i2=x%QF1_VIIRSNCCEDR  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='RadianceFactors'
if(associated(x%RadianceFactors))then
  call write_array_hdf(lun,sname,&
    & 'Radiance scale and offset: first scale,second offset',&
    & err,r1=x%RadianceFactors  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='ReflectanceFactors'
if(associated(x%ReflectanceFactors))then
  call write_array_hdf(lun,sname,&
    & 'Reflectance scale and offset: first scale, second offset',&
    & err,r1=x%ReflectanceFactors  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='BrightnessTemperatureFactors'
if(associated(x%BrightnessTemperatureFactors))then
  call write_array_hdf(lun,sname,&
    & 'Brightness Temperature sc/offs: first scale, second offset',&
    & err,r1=x%BrightnessTemperatureFactors  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='BrightnessTemperatureOrReflectanceFactors'
if(associated(x%BrightnessTemperatureOrReflectanceFactors))then
  call write_array_hdf(lun,sname,&
    & 'Bright. Temp. or Reflectance sc/offs: first scale, second offset',&
    & err,r1=x%BrightnessTemperatureOrReflectanceFactors  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='AlbedoFactors'
if(associated(x%AlbedoFactors))then
  call write_array_hdf(lun,sname,&
    & 'Albedo scale and offset: first scale, second offset',&
    & err,r1=x%AlbedoFactors  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif



err=0
CATCH
end subroutine

#endif

end module
