!
! Automatically generated by ./mod_rw.pl version 1.2
! Do not edit
!
! Name: $Id: viirs_edr_img_data_mem.F90
!
! Purpose: viirs edr img init structure,free pointers,copy structures module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!
module viirs_edr_img_data_mem
#include "aapp_throw.h"
use viirs_edr_img_data_def
implicit none
private
public :: viirs_edr_img_data_free
public :: viirs_edr_img_data_init
public :: viirs_edr_img_data_copy
public :: viirs_edr_img_data_paste


contains

subroutine viirs_edr_img_data_free(x,err)
type(viirs_edr_img_data),intent(inout)::x
integer,intent(out)::err
character(len=nlen)::sname
TRY
err = 0

sname='Radiance'
if(associated(x%Radiance))then
  deallocate(x%Radiance,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%Radiance)
endif
sname='Reflectance'
if(associated(x%Reflectance))then
  deallocate(x%Reflectance,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%Reflectance)
endif
sname='BrightnessTemperature'
if(associated(x%BrightnessTemperature))then
  deallocate(x%BrightnessTemperature,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%BrightnessTemperature)
endif
sname='BrightnessTemperatureOrReflectance'
if(associated(x%BrightnessTemperatureOrReflectance))then
  deallocate(x%BrightnessTemperatureOrReflectance,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%BrightnessTemperatureOrReflectance)
endif
sname='Albedo'
if(associated(x%Albedo))then
  deallocate(x%Albedo,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%Albedo)
endif
sname='QF1_VIIRSIMGEDR'
if(associated(x%QF1_VIIRSIMGEDR))then
  deallocate(x%QF1_VIIRSIMGEDR,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%QF1_VIIRSIMGEDR)
endif
sname='QF1_VIIRSNCCEDR'
if(associated(x%QF1_VIIRSNCCEDR))then
  deallocate(x%QF1_VIIRSNCCEDR,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%QF1_VIIRSNCCEDR)
endif
sname='RadianceFactors'
if(associated(x%RadianceFactors))then
  deallocate(x%RadianceFactors,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%RadianceFactors)
endif
sname='ReflectanceFactors'
if(associated(x%ReflectanceFactors))then
  deallocate(x%ReflectanceFactors,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%ReflectanceFactors)
endif
sname='BrightnessTemperatureFactors'
if(associated(x%BrightnessTemperatureFactors))then
  deallocate(x%BrightnessTemperatureFactors,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%BrightnessTemperatureFactors)
endif
sname='BrightnessTemperatureOrReflectanceFactors'
if(associated(x%BrightnessTemperatureOrReflectanceFactors))then
  deallocate(x%BrightnessTemperatureOrReflectanceFactors,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%BrightnessTemperatureOrReflectanceFactors)
endif
sname='AlbedoFactors'
if(associated(x%AlbedoFactors))then
  deallocate(x%AlbedoFactors,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%AlbedoFactors)
endif
sname='Reflectances'
if(associated(x%Reflectances))then
  deallocate(x%Reflectances,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%Reflectances)
endif
sname='Albedos'
if(associated(x%Albedos))then
  deallocate(x%Albedos,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%Albedos)
endif
CATCH
end subroutine

subroutine viirs_edr_img_data_init(x)
type(viirs_edr_img_data),intent(inout)::x

  x%Channel=0
  x%Channel_Name=''
  nullify(x%Radiance)
  nullify(x%Reflectance)
  nullify(x%BrightnessTemperature)
  nullify(x%BrightnessTemperatureOrReflectance)
  nullify(x%Albedo)
  nullify(x%QF1_VIIRSIMGEDR)
  nullify(x%QF1_VIIRSNCCEDR)
  nullify(x%RadianceFactors)
  nullify(x%ReflectanceFactors)
  nullify(x%BrightnessTemperatureFactors)
  nullify(x%BrightnessTemperatureOrReflectanceFactors)
  nullify(x%AlbedoFactors)
  nullify(x%Reflectances)
  nullify(x%Albedos)
end subroutine

subroutine viirs_edr_img_data_copy(x,y,err,data)
type(viirs_edr_img_data),intent(inout)::x
type(viirs_edr_img_data),intent(in)::y
integer,intent(out)::err
logical, optional :: data
integer::lb(7),ub(7)
logical :: data1

TRY

  data1=.true.
  if(present(data))data1 = data
  
  if(data1)x%Channel=y%Channel
  if(data1)x%Channel_Name=y%Channel_Name
  if(associated(y%Radiance))then
    lb(1:2)=lbound(y%Radiance)
    ub(1:2)=ubound(y%Radiance)
    allocate(x%Radiance(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Radiance")
    if(data1)x%Radiance=y%Radiance
  else
    nullify(x%Radiance)
  endif
  if(associated(y%Reflectance))then
    lb(1:2)=lbound(y%Reflectance)
    ub(1:2)=ubound(y%Reflectance)
    allocate(x%Reflectance(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Reflectance")
    if(data1)x%Reflectance=y%Reflectance
  else
    nullify(x%Reflectance)
  endif
  if(associated(y%BrightnessTemperature))then
    lb(1:2)=lbound(y%BrightnessTemperature)
    ub(1:2)=ubound(y%BrightnessTemperature)
    allocate(x%BrightnessTemperature(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE BrightnessTemperature")
    if(data1)x%BrightnessTemperature=y%BrightnessTemperature
  else
    nullify(x%BrightnessTemperature)
  endif
  if(associated(y%BrightnessTemperatureOrReflectance))then
    lb(1:2)=lbound(y%BrightnessTemperatureOrReflectance)
    ub(1:2)=ubound(y%BrightnessTemperatureOrReflectance)
    allocate(x%BrightnessTemperatureOrReflectance(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE BrightnessTemperatureOrReflectance")
    if(data1)x%BrightnessTemperatureOrReflectance=y%BrightnessTemperatureOrReflectance
  else
    nullify(x%BrightnessTemperatureOrReflectance)
  endif
  if(associated(y%Albedo))then
    lb(1:2)=lbound(y%Albedo)
    ub(1:2)=ubound(y%Albedo)
    allocate(x%Albedo(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Albedo")
    if(data1)x%Albedo=y%Albedo
  else
    nullify(x%Albedo)
  endif
  if(associated(y%QF1_VIIRSIMGEDR))then
    lb(1:2)=lbound(y%QF1_VIIRSIMGEDR)
    ub(1:2)=ubound(y%QF1_VIIRSIMGEDR)
    allocate(x%QF1_VIIRSIMGEDR(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF1_VIIRSIMGEDR")
    if(data1)x%QF1_VIIRSIMGEDR=y%QF1_VIIRSIMGEDR
  else
    nullify(x%QF1_VIIRSIMGEDR)
  endif
  if(associated(y%QF1_VIIRSNCCEDR))then
    lb(1:2)=lbound(y%QF1_VIIRSNCCEDR)
    ub(1:2)=ubound(y%QF1_VIIRSNCCEDR)
    allocate(x%QF1_VIIRSNCCEDR(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF1_VIIRSNCCEDR")
    if(data1)x%QF1_VIIRSNCCEDR=y%QF1_VIIRSNCCEDR
  else
    nullify(x%QF1_VIIRSNCCEDR)
  endif
  if(associated(y%RadianceFactors))then
    lb(1:1)=lbound(y%RadianceFactors)
    ub(1:1)=ubound(y%RadianceFactors)
    allocate(x%RadianceFactors(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE RadianceFactors")
    if(data1)x%RadianceFactors=y%RadianceFactors
  else
    nullify(x%RadianceFactors)
  endif
  if(associated(y%ReflectanceFactors))then
    lb(1:1)=lbound(y%ReflectanceFactors)
    ub(1:1)=ubound(y%ReflectanceFactors)
    allocate(x%ReflectanceFactors(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE ReflectanceFactors")
    if(data1)x%ReflectanceFactors=y%ReflectanceFactors
  else
    nullify(x%ReflectanceFactors)
  endif
  if(associated(y%BrightnessTemperatureFactors))then
    lb(1:1)=lbound(y%BrightnessTemperatureFactors)
    ub(1:1)=ubound(y%BrightnessTemperatureFactors)
    allocate(x%BrightnessTemperatureFactors(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE BrightnessTemperatureFactors")
    if(data1)x%BrightnessTemperatureFactors=y%BrightnessTemperatureFactors
  else
    nullify(x%BrightnessTemperatureFactors)
  endif
  if(associated(y%BrightnessTemperatureOrReflectanceFactors))then
    lb(1:1)=lbound(y%BrightnessTemperatureOrReflectanceFactors)
    ub(1:1)=ubound(y%BrightnessTemperatureOrReflectanceFactors)
    allocate(x%BrightnessTemperatureOrReflectanceFactors(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE BrightnessTemperatureOrReflectanceFactors")
    if(data1)x%BrightnessTemperatureOrReflectanceFactors=y%BrightnessTemperatureOrReflectanceFactors
  else
    nullify(x%BrightnessTemperatureOrReflectanceFactors)
  endif
  if(associated(y%AlbedoFactors))then
    lb(1:1)=lbound(y%AlbedoFactors)
    ub(1:1)=ubound(y%AlbedoFactors)
    allocate(x%AlbedoFactors(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE AlbedoFactors")
    if(data1)x%AlbedoFactors=y%AlbedoFactors
  else
    nullify(x%AlbedoFactors)
  endif
  if(associated(y%Reflectances))then
    lb(1:2)=lbound(y%Reflectances)
    ub(1:2)=ubound(y%Reflectances)
    allocate(x%Reflectances(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Reflectances")
    if(data1)x%Reflectances=y%Reflectances
  else
    nullify(x%Reflectances)
  endif
  if(associated(y%Albedos))then
    lb(1:2)=lbound(y%Albedos)
    ub(1:2)=ubound(y%Albedos)
    allocate(x%Albedos(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Albedos")
    if(data1)x%Albedos=y%Albedos
  else
    nullify(x%Albedos)
  endif
CATCH
end subroutine

subroutine viirs_edr_img_data_paste(x,y,z,err,data)
! only pointer arrays are considered
! for any other type the Y value is passed to X
! paste the last dimension of array
type(viirs_edr_img_data),intent(inout)::x
type(viirs_edr_img_data),intent(in)::y
type(viirs_edr_img_data),intent(in)::z
integer,intent(out)::err
logical, optional :: data
integer::lby(7),uby(7)
integer::lbz(7),ubz(7)
integer::lb1(7),ub1(7)
integer::lb2(7),ub2(7)

logical :: data1

TRY

  data1=.true.
  if(present(data))data1 = data
  
  if(data1)x%Channel=y%Channel
  if(data1)x%Channel_Name=y%Channel_Name
  if(associated(y%Radiance) .and. associated(z%Radiance))then
    lby(1:2)=lbound(y%Radiance)
    uby(1:2)=ubound(y%Radiance)

    lbz(1:2)=lbound(z%Radiance)
    ubz(1:2)=ubound(z%Radiance)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%Radiance(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Radiance")
    if(data1) then
      x%Radiance(lb1(1):ub1(1),lb1(2):ub1(2))=y%Radiance
      x%Radiance(lb2(1):ub2(1),lb2(2):ub2(2))=z%Radiance
    endif
  else
    nullify(x%Radiance)
  endif
  if(associated(y%Reflectance) .and. associated(z%Reflectance))then
    lby(1:2)=lbound(y%Reflectance)
    uby(1:2)=ubound(y%Reflectance)

    lbz(1:2)=lbound(z%Reflectance)
    ubz(1:2)=ubound(z%Reflectance)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%Reflectance(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Reflectance")
    if(data1) then
      x%Reflectance(lb1(1):ub1(1),lb1(2):ub1(2))=y%Reflectance
      x%Reflectance(lb2(1):ub2(1),lb2(2):ub2(2))=z%Reflectance
    endif
  else
    nullify(x%Reflectance)
  endif
  if(associated(y%BrightnessTemperature) .and. associated(z%BrightnessTemperature))then
    lby(1:2)=lbound(y%BrightnessTemperature)
    uby(1:2)=ubound(y%BrightnessTemperature)

    lbz(1:2)=lbound(z%BrightnessTemperature)
    ubz(1:2)=ubound(z%BrightnessTemperature)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%BrightnessTemperature(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE BrightnessTemperature")
    if(data1) then
      x%BrightnessTemperature(lb1(1):ub1(1),lb1(2):ub1(2))=y%BrightnessTemperature
      x%BrightnessTemperature(lb2(1):ub2(1),lb2(2):ub2(2))=z%BrightnessTemperature
    endif
  else
    nullify(x%BrightnessTemperature)
  endif
  if(associated(y%BrightnessTemperatureOrReflectance) .and. associated(z%BrightnessTemperatureOrReflectance))then
    lby(1:2)=lbound(y%BrightnessTemperatureOrReflectance)
    uby(1:2)=ubound(y%BrightnessTemperatureOrReflectance)

    lbz(1:2)=lbound(z%BrightnessTemperatureOrReflectance)
    ubz(1:2)=ubound(z%BrightnessTemperatureOrReflectance)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%BrightnessTemperatureOrReflectance(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE BrightnessTemperatureOrReflectance")
    if(data1) then
      x%BrightnessTemperatureOrReflectance(lb1(1):ub1(1),lb1(2):ub1(2))=y%BrightnessTemperatureOrReflectance
      x%BrightnessTemperatureOrReflectance(lb2(1):ub2(1),lb2(2):ub2(2))=z%BrightnessTemperatureOrReflectance
    endif
  else
    nullify(x%BrightnessTemperatureOrReflectance)
  endif
  if(associated(y%Albedo) .and. associated(z%Albedo))then
    lby(1:2)=lbound(y%Albedo)
    uby(1:2)=ubound(y%Albedo)

    lbz(1:2)=lbound(z%Albedo)
    ubz(1:2)=ubound(z%Albedo)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%Albedo(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Albedo")
    if(data1) then
      x%Albedo(lb1(1):ub1(1),lb1(2):ub1(2))=y%Albedo
      x%Albedo(lb2(1):ub2(1),lb2(2):ub2(2))=z%Albedo
    endif
  else
    nullify(x%Albedo)
  endif
  if(associated(y%QF1_VIIRSIMGEDR) .and. associated(z%QF1_VIIRSIMGEDR))then
    lby(1:2)=lbound(y%QF1_VIIRSIMGEDR)
    uby(1:2)=ubound(y%QF1_VIIRSIMGEDR)

    lbz(1:2)=lbound(z%QF1_VIIRSIMGEDR)
    ubz(1:2)=ubound(z%QF1_VIIRSIMGEDR)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%QF1_VIIRSIMGEDR(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF1_VIIRSIMGEDR")
    if(data1) then
      x%QF1_VIIRSIMGEDR(lb1(1):ub1(1),lb1(2):ub1(2))=y%QF1_VIIRSIMGEDR
      x%QF1_VIIRSIMGEDR(lb2(1):ub2(1),lb2(2):ub2(2))=z%QF1_VIIRSIMGEDR
    endif
  else
    nullify(x%QF1_VIIRSIMGEDR)
  endif
  if(associated(y%QF1_VIIRSNCCEDR) .and. associated(z%QF1_VIIRSNCCEDR))then
    lby(1:2)=lbound(y%QF1_VIIRSNCCEDR)
    uby(1:2)=ubound(y%QF1_VIIRSNCCEDR)

    lbz(1:2)=lbound(z%QF1_VIIRSNCCEDR)
    ubz(1:2)=ubound(z%QF1_VIIRSNCCEDR)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%QF1_VIIRSNCCEDR(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF1_VIIRSNCCEDR")
    if(data1) then
      x%QF1_VIIRSNCCEDR(lb1(1):ub1(1),lb1(2):ub1(2))=y%QF1_VIIRSNCCEDR
      x%QF1_VIIRSNCCEDR(lb2(1):ub2(1),lb2(2):ub2(2))=z%QF1_VIIRSNCCEDR
    endif
  else
    nullify(x%QF1_VIIRSNCCEDR)
  endif
  if(associated(y%RadianceFactors) .and. associated(z%RadianceFactors))then
    lby(1:1)=lbound(y%RadianceFactors)
    uby(1:1)=ubound(y%RadianceFactors)

    lbz(1:1)=lbound(z%RadianceFactors)
    ubz(1:1)=ubound(z%RadianceFactors)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%RadianceFactors(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE RadianceFactors")
    if(data1) then
      x%RadianceFactors(lb1(1):ub1(1))=y%RadianceFactors
      x%RadianceFactors(lb2(1):ub2(1))=z%RadianceFactors
    endif
  else
    nullify(x%RadianceFactors)
  endif
  if(associated(y%ReflectanceFactors) .and. associated(z%ReflectanceFactors))then
    lby(1:1)=lbound(y%ReflectanceFactors)
    uby(1:1)=ubound(y%ReflectanceFactors)

    lbz(1:1)=lbound(z%ReflectanceFactors)
    ubz(1:1)=ubound(z%ReflectanceFactors)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%ReflectanceFactors(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE ReflectanceFactors")
    if(data1) then
      x%ReflectanceFactors(lb1(1):ub1(1))=y%ReflectanceFactors
      x%ReflectanceFactors(lb2(1):ub2(1))=z%ReflectanceFactors
    endif
  else
    nullify(x%ReflectanceFactors)
  endif
  if(associated(y%BrightnessTemperatureFactors) .and. associated(z%BrightnessTemperatureFactors))then
    lby(1:1)=lbound(y%BrightnessTemperatureFactors)
    uby(1:1)=ubound(y%BrightnessTemperatureFactors)

    lbz(1:1)=lbound(z%BrightnessTemperatureFactors)
    ubz(1:1)=ubound(z%BrightnessTemperatureFactors)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%BrightnessTemperatureFactors(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE BrightnessTemperatureFactors")
    if(data1) then
      x%BrightnessTemperatureFactors(lb1(1):ub1(1))=y%BrightnessTemperatureFactors
      x%BrightnessTemperatureFactors(lb2(1):ub2(1))=z%BrightnessTemperatureFactors
    endif
  else
    nullify(x%BrightnessTemperatureFactors)
  endif
  if(associated(y%BrightnessTemperatureOrReflectanceFactors) .and. associated(z%BrightnessTemperatureOrReflectanceFactors))then
    lby(1:1)=lbound(y%BrightnessTemperatureOrReflectanceFactors)
    uby(1:1)=ubound(y%BrightnessTemperatureOrReflectanceFactors)

    lbz(1:1)=lbound(z%BrightnessTemperatureOrReflectanceFactors)
    ubz(1:1)=ubound(z%BrightnessTemperatureOrReflectanceFactors)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%BrightnessTemperatureOrReflectanceFactors(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE BrightnessTemperatureOrReflectanceFactors")
    if(data1) then
      x%BrightnessTemperatureOrReflectanceFactors(lb1(1):ub1(1))=y%BrightnessTemperatureOrReflectanceFactors
      x%BrightnessTemperatureOrReflectanceFactors(lb2(1):ub2(1))=z%BrightnessTemperatureOrReflectanceFactors
    endif
  else
    nullify(x%BrightnessTemperatureOrReflectanceFactors)
  endif
  if(associated(y%AlbedoFactors) .and. associated(z%AlbedoFactors))then
    lby(1:1)=lbound(y%AlbedoFactors)
    uby(1:1)=ubound(y%AlbedoFactors)

    lbz(1:1)=lbound(z%AlbedoFactors)
    ubz(1:1)=ubound(z%AlbedoFactors)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%AlbedoFactors(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE AlbedoFactors")
    if(data1) then
      x%AlbedoFactors(lb1(1):ub1(1))=y%AlbedoFactors
      x%AlbedoFactors(lb2(1):ub2(1))=z%AlbedoFactors
    endif
  else
    nullify(x%AlbedoFactors)
  endif
  if(associated(y%Reflectances) .and. associated(z%Reflectances))then
    lby(1:2)=lbound(y%Reflectances)
    uby(1:2)=ubound(y%Reflectances)

    lbz(1:2)=lbound(z%Reflectances)
    ubz(1:2)=ubound(z%Reflectances)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%Reflectances(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Reflectances")
    if(data1) then
      x%Reflectances(lb1(1):ub1(1),lb1(2):ub1(2))=y%Reflectances
      x%Reflectances(lb2(1):ub2(1),lb2(2):ub2(2))=z%Reflectances
    endif
  else
    nullify(x%Reflectances)
  endif
  if(associated(y%Albedos) .and. associated(z%Albedos))then
    lby(1:2)=lbound(y%Albedos)
    uby(1:2)=ubound(y%Albedos)

    lbz(1:2)=lbound(z%Albedos)
    ubz(1:2)=ubound(z%Albedos)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%Albedos(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Albedos")
    if(data1) then
      x%Albedos(lb1(1):ub1(1),lb1(2):ub1(2))=y%Albedos
      x%Albedos(lb2(1):ub2(1),lb2(2):ub2(2))=z%Albedos
    endif
  else
    nullify(x%Albedos)
  endif
CATCH
end subroutine

end module
