!
! Automatically generated by ./mod_rw.pl version 1.2
! Do not edit
!
! Name: $Id: viirs_edr_img_geo_def.F90
!
! Purpose: viirs edr img fortan structure definition module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!  

module viirs_edr_img_geo_def

implicit none
private
integer, parameter :: nlen = 256   ! name length
public :: nlen
public :: viirs_edr_img_geo

type viirs_edr_img_geo
  integer::StartDay ! Day of month of first scan (UTC), calculated
  integer::StartMonth ! Month of year of first row (UTC), calculated
  integer::StartYear ! Year of first row (UTC), calculated
  integer*8,pointer,dimension(:)::UTC ! Time of the nadir point of the GTM row in UTC (millisecond of day) , calculated
  integer*8,pointer,dimension(:)::Time ! Time of the nadir point of the GTM row in IET (1/1/1958) microsecond
  real,pointer,dimension(:,:)::Latitude ! Latitude of each pixel (positive North) degree 
    !    size is [pixels, lines] for latitude and following arrays
  real,pointer,dimension(:,:)::Longitude ! Longitude of each pixel (positive East) degree
  real,pointer,dimension(:,:)::SolarZenithAngle ! Zenith angle of sun at each pixel position degree
  real,pointer,dimension(:,:)::SolarAzimuthAngle ! Azimuth angle of sun (clockwise positive from North) at each pixel position degree 
  real,pointer,dimension(:,:)::SatelliteZenithAngle ! Zenith angle to Satellite at each pixel position degree 
  real,pointer,dimension(:,:)::SatelliteAzimuthAngle ! Azimuth angle (clockwise positive from North) to Satellite at each pixel position degree 
  real,pointer,dimension(:,:)::LunarZenithAngle ! Zenith angle of moon at each pixel position degree 
  real,pointer,dimension(:,:)::LunarAzimuthAngle ! Azimuth angle of moon (clockwise positive from North) at each pixel position degree 
  real,pointer,dimension(:,:)::Height ! Ellipsoid-Geoid separation meter 
  real,pointer,dimension(:,:)::SatelliteRange ! Line of sight distance from the ellipsoid intersection to the satellite meter 
  real,pointer,dimension(:)::MoonIllumFraction ! Fraction of the moon illuminated (expressed as percent) [granules]
  integer,pointer,dimension(:,:)::QF1_VIIRSGTMGEO ! Pixel level geolocation quality flags [pixels, lines]
  integer,pointer,dimension(:)::QF2_VIIRSGTMGEO ! Granule level geolocation quality flags
  integer,pointer,dimension(:,:)::PixelRowSDR ! Imagery SDR pixel row index number that was remapped to this
    ! GTM pixel (row numbering begins with zero) [pixels, lines]
  integer,pointer,dimension(:,:)::PixelColSDR ! Imagery SDR pixel column index number that was remapped to this
    ! GTM pixel (column numbering begins with zero) [pixels, lines]
end type

end module
