!
! Automatically generated by ./mod_rw.pl  version 1.2
! Do not edit
! Name: $Id: viirs_edr_img_geo_io.F90 
!
! Purpose:  viirs edr img Fortran I/O module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!
module viirs_edr_img_geo_io

#ifdef HAS_LIBHDF5

#include "aapp_throw.h"
!use rttov_print_mod
use aapp_hdf_mod
use viirs_edr_img_geo_def
use viirs_edr_img_geo_mem
use hdf5
implicit none
private
public :: viirs_edr_img_geo_rh
public :: viirs_edr_img_geo_wh
public :: viirs_edr_img_geo_writea


contains


subroutine viirs_edr_img_geo_writea(x,lun,err)
type(viirs_edr_img_geo),intent(in)::x
integer,intent(in)::lun
integer,intent(out)::err
integer::lb(7),ub(7)
character(len=nlen)::sname

TRY
sname='StartDay'
write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Day of month of first scan (UTC), calculated'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("UNITS = ",A)',iostat=err)''
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_integer(lun,'(10000(I2))',a0=x%StartDay)
!write(lun,err=999)x%StartDay

sname='StartMonth'
write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Month of year of first row (UTC), calculated'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("UNITS = ",A)',iostat=err)''
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_integer(lun,'(10000(I2))',a0=x%StartMonth)
!write(lun,err=999)x%StartMonth

sname='StartYear'
write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Year of first row (UTC), calculated'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("UNITS = ",A)',iostat=err)''
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_integer(lun,'(10000(I4))',a0=x%StartYear)
!write(lun,err=999)x%StartYear

sname='UTC'
if(associated(x%UTC))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Time of the nadir point of the GTM row in UTC (millisecond of day) , calculated'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%UTC), &
    & ubound(x%UTC)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_long(lun,'(10000(I18))',a1=x%UTC)
! write(lun,*,err=999)x%UTC
endif

sname='Time'
if(associated(x%Time))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Time of the nadir point of the GTM row in IET (1/1/1958) microsecond'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%Time), &
    & ubound(x%Time)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_long(lun,'(10000(I18))',a1=x%Time)
! write(lun,*,err=999)x%Time
endif

sname='Latitude'
if(associated(x%Latitude))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Latitude of each pixel (positive North) degree '
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%Latitude), &
    & ubound(x%Latitude)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%Latitude)
! write(lun,*,err=999)x%Latitude
endif

sname='Longitude'
if(associated(x%Longitude))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Longitude of each pixel (positive East) degree'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%Longitude), &
    & ubound(x%Longitude)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%Longitude)
! write(lun,*,err=999)x%Longitude
endif

sname='SolarZenithAngle'
if(associated(x%SolarZenithAngle))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Zenith angle of sun at each pixel position degree'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%SolarZenithAngle), &
    & ubound(x%SolarZenithAngle)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%SolarZenithAngle)
! write(lun,*,err=999)x%SolarZenithAngle
endif

sname='SolarAzimuthAngle'
if(associated(x%SolarAzimuthAngle))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Azimuth angle of sun (clockwise positive from North) at each pixel position degree '
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%SolarAzimuthAngle), &
    & ubound(x%SolarAzimuthAngle)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%SolarAzimuthAngle)
! write(lun,*,err=999)x%SolarAzimuthAngle
endif

sname='SatelliteZenithAngle'
if(associated(x%SatelliteZenithAngle))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Zenith angle to Satellite at each pixel position degree '
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%SatelliteZenithAngle), &
    & ubound(x%SatelliteZenithAngle)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%SatelliteZenithAngle)
! write(lun,*,err=999)x%SatelliteZenithAngle
endif

sname='SatelliteAzimuthAngle'
if(associated(x%SatelliteAzimuthAngle))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Azimuth angle (clockwise positive from North) to Satellite at each pixel position degree '
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%SatelliteAzimuthAngle), &
    & ubound(x%SatelliteAzimuthAngle)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%SatelliteAzimuthAngle)
! write(lun,*,err=999)x%SatelliteAzimuthAngle
endif

sname='LunarZenithAngle'
if(associated(x%LunarZenithAngle))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Zenith angle of moon at each pixel position degree '
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%LunarZenithAngle), &
    & ubound(x%LunarZenithAngle)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%LunarZenithAngle)
! write(lun,*,err=999)x%LunarZenithAngle
endif

sname='LunarAzimuthAngle'
if(associated(x%LunarAzimuthAngle))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Azimuth angle of moon (clockwise positive from North) at each pixel position degree '
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%LunarAzimuthAngle), &
    & ubound(x%LunarAzimuthAngle)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%LunarAzimuthAngle)
! write(lun,*,err=999)x%LunarAzimuthAngle
endif

sname='Height'
if(associated(x%Height))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Ellipsoid-Geoid separation meter '
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%Height), &
    & ubound(x%Height)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%Height)
! write(lun,*,err=999)x%Height
endif

sname='SatelliteRange'
if(associated(x%SatelliteRange))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Line of sight distance from the ellipsoid intersection to the satellite meter '
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%SatelliteRange), &
    & ubound(x%SatelliteRange)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%SatelliteRange)
! write(lun,*,err=999)x%SatelliteRange
endif

sname='MoonIllumFraction'
if(associated(x%MoonIllumFraction))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Fraction of the moon illuminated (expressed as percent) [granules]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%MoonIllumFraction), &
    & ubound(x%MoonIllumFraction)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a1=x%MoonIllumFraction)
! write(lun,*,err=999)x%MoonIllumFraction
endif

sname='QF1_VIIRSGTMGEO'
if(associated(x%QF1_VIIRSGTMGEO))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Pixel level geolocation quality flags [pixels, lines]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%QF1_VIIRSGTMGEO), &
    & ubound(x%QF1_VIIRSGTMGEO)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(Z4))',a2=x%QF1_VIIRSGTMGEO)
! write(lun,*,err=999)x%QF1_VIIRSGTMGEO
endif

sname='QF2_VIIRSGTMGEO'
if(associated(x%QF2_VIIRSGTMGEO))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Granule level geolocation quality flags'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%QF2_VIIRSGTMGEO), &
    & ubound(x%QF2_VIIRSGTMGEO)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(Z4))',a1=x%QF2_VIIRSGTMGEO)
! write(lun,*,err=999)x%QF2_VIIRSGTMGEO
endif

sname='PixelRowSDR'
if(associated(x%PixelRowSDR))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Imagery SDR pixel row index number that was remapped to this'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%PixelRowSDR), &
    & ubound(x%PixelRowSDR)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(I5))',a2=x%PixelRowSDR)
! write(lun,*,err=999)x%PixelRowSDR
endif

sname='PixelColSDR'
if(associated(x%PixelColSDR))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Imagery SDR pixel column index number that was remapped to this'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%PixelColSDR), &
    & ubound(x%PixelColSDR)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(I5))',a2=x%PixelColSDR)
! write(lun,*,err=999)x%PixelColSDR
endif

write(lun,'("SECTION = EOF")',err=999)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
err=0
CATCH
end subroutine

subroutine viirs_edr_img_geo_rh(x,lun,err)
type(viirs_edr_img_geo),intent(out)::x
integer(hid_t),intent(in)::lun
integer,intent(out)::err
character(len=nlen)::sname
logical :: lext
TRY

call viirs_edr_img_geo_init(x)





sname='Time'
call read_array_hdf(lun,sname,err,pil1=x%Time)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='Latitude'
call read_array_hdf(lun,sname,err,pr2=x%Latitude)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='Longitude'
call read_array_hdf(lun,sname,err,pr2=x%Longitude)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='SolarZenithAngle'
call read_array_hdf(lun,sname,err,pr2=x%SolarZenithAngle)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='SolarAzimuthAngle'
call read_array_hdf(lun,sname,err,pr2=x%SolarAzimuthAngle)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='SatelliteZenithAngle'
call read_array_hdf(lun,sname,err,pr2=x%SatelliteZenithAngle)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='SatelliteAzimuthAngle'
call read_array_hdf(lun,sname,err,pr2=x%SatelliteAzimuthAngle)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='LunarZenithAngle'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr2=x%LunarZenithAngle)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='LunarAzimuthAngle'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr2=x%LunarAzimuthAngle)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='Height'
call read_array_hdf(lun,sname,err,pr2=x%Height)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='SatelliteRange'
call read_array_hdf(lun,sname,err,pr2=x%SatelliteRange)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='MoonIllumFraction'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr1=x%MoonIllumFraction)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='QF1_VIIRSGTMGEO'
call read_array_hdf(lun,sname,err,pi2=x%QF1_VIIRSGTMGEO)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='QF2_VIIRSGTMGEO'
call read_array_hdf(lun,sname,err,pi1=x%QF2_VIIRSGTMGEO)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='PixelRowSDR'
call read_array_hdf(lun,sname,err,pi2=x%PixelRowSDR)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='PixelColSDR'
call read_array_hdf(lun,sname,err,pi2=x%PixelColSDR)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

err=0
CATCH
end subroutine

subroutine viirs_edr_img_geo_wh(x,lun,err, compress)
type(viirs_edr_img_geo),intent(in)::x
integer(hid_t),intent(in)::lun
integer,intent(out)::err
logical,intent(in),optional::compress
character(len=nlen)::sname
TRY




sname='Time'
if(associated(x%Time))then
  call write_array_hdf(lun,sname,&
    & 'Time of the nadir point of the GTM row in IET (1/1/1958) microsecond',&
    & err,il1=x%Time  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='Latitude'
if(associated(x%Latitude))then
  call write_array_hdf(lun,sname,&
    & 'Latitude of each pixel (positive North) degree ',&
    & err,r2=x%Latitude  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='Longitude'
if(associated(x%Longitude))then
  call write_array_hdf(lun,sname,&
    & 'Longitude of each pixel (positive East) degree',&
    & err,r2=x%Longitude  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='SolarZenithAngle'
if(associated(x%SolarZenithAngle))then
  call write_array_hdf(lun,sname,&
    & 'Zenith angle of sun at each pixel position degree',&
    & err,r2=x%SolarZenithAngle  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='SolarAzimuthAngle'
if(associated(x%SolarAzimuthAngle))then
  call write_array_hdf(lun,sname,&
    & 'Azimuth angle of sun (clockwise positive from North) at each pixel position degree ',&
    & err,r2=x%SolarAzimuthAngle  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='SatelliteZenithAngle'
if(associated(x%SatelliteZenithAngle))then
  call write_array_hdf(lun,sname,&
    & 'Zenith angle to Satellite at each pixel position degree ',&
    & err,r2=x%SatelliteZenithAngle  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='SatelliteAzimuthAngle'
if(associated(x%SatelliteAzimuthAngle))then
  call write_array_hdf(lun,sname,&
    & 'Azimuth angle (clockwise positive from North) to Satellite at each pixel position degree ',&
    & err,r2=x%SatelliteAzimuthAngle  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='LunarZenithAngle'
if(associated(x%LunarZenithAngle))then
  call write_array_hdf(lun,sname,&
    & 'Zenith angle of moon at each pixel position degree ',&
    & err,r2=x%LunarZenithAngle  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='LunarAzimuthAngle'
if(associated(x%LunarAzimuthAngle))then
  call write_array_hdf(lun,sname,&
    & 'Azimuth angle of moon (clockwise positive from North) at each pixel position degree ',&
    & err,r2=x%LunarAzimuthAngle  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='Height'
if(associated(x%Height))then
  call write_array_hdf(lun,sname,&
    & 'Ellipsoid-Geoid separation meter ',&
    & err,r2=x%Height  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='SatelliteRange'
if(associated(x%SatelliteRange))then
  call write_array_hdf(lun,sname,&
    & 'Line of sight distance from the ellipsoid intersection to the satellite meter ',&
    & err,r2=x%SatelliteRange  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='MoonIllumFraction'
if(associated(x%MoonIllumFraction))then
  call write_array_hdf(lun,sname,&
    & 'Fraction of the moon illuminated (expressed as percent) [granules]',&
    & err,r1=x%MoonIllumFraction  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='QF1_VIIRSGTMGEO'
if(associated(x%QF1_VIIRSGTMGEO))then
  call write_array_hdf(lun,sname,&
    & 'Pixel level geolocation quality flags [pixels, lines]',&
    & err,i2=x%QF1_VIIRSGTMGEO  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='QF2_VIIRSGTMGEO'
if(associated(x%QF2_VIIRSGTMGEO))then
  call write_array_hdf(lun,sname,&
    & 'Granule level geolocation quality flags',&
    & err,i1=x%QF2_VIIRSGTMGEO  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='PixelRowSDR'
if(associated(x%PixelRowSDR))then
  call write_array_hdf(lun,sname,&
    & 'Imagery SDR pixel row index number that was remapped to this',&
    & err,i2=x%PixelRowSDR  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='PixelColSDR'
if(associated(x%PixelColSDR))then
  call write_array_hdf(lun,sname,&
    & 'Imagery SDR pixel column index number that was remapped to this',&
    & err,i2=x%PixelColSDR  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

err=0
CATCH
end subroutine

#endif

end module
