!
! Automatically generated by ./mod_rw.pl version 1.2
! Do not edit
!
! Name: $Id: viirs_edr_img_geo_mem.F90
!
! Purpose: viirs edr img init structure,free pointers,copy structures module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!
module viirs_edr_img_geo_mem
#include "aapp_throw.h"
use viirs_edr_img_geo_def
implicit none
private
public :: viirs_edr_img_geo_free
public :: viirs_edr_img_geo_init
public :: viirs_edr_img_geo_copy
public :: viirs_edr_img_geo_paste


contains

subroutine viirs_edr_img_geo_free(x,err)
type(viirs_edr_img_geo),intent(inout)::x
integer,intent(out)::err
character(len=nlen)::sname
TRY
err = 0

sname='UTC'
if(associated(x%UTC))then
  deallocate(x%UTC,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%UTC)
endif
sname='Time'
if(associated(x%Time))then
  deallocate(x%Time,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%Time)
endif
sname='Latitude'
if(associated(x%Latitude))then
  deallocate(x%Latitude,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%Latitude)
endif
sname='Longitude'
if(associated(x%Longitude))then
  deallocate(x%Longitude,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%Longitude)
endif
sname='SolarZenithAngle'
if(associated(x%SolarZenithAngle))then
  deallocate(x%SolarZenithAngle,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%SolarZenithAngle)
endif
sname='SolarAzimuthAngle'
if(associated(x%SolarAzimuthAngle))then
  deallocate(x%SolarAzimuthAngle,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%SolarAzimuthAngle)
endif
sname='SatelliteZenithAngle'
if(associated(x%SatelliteZenithAngle))then
  deallocate(x%SatelliteZenithAngle,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%SatelliteZenithAngle)
endif
sname='SatelliteAzimuthAngle'
if(associated(x%SatelliteAzimuthAngle))then
  deallocate(x%SatelliteAzimuthAngle,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%SatelliteAzimuthAngle)
endif
sname='LunarZenithAngle'
if(associated(x%LunarZenithAngle))then
  deallocate(x%LunarZenithAngle,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%LunarZenithAngle)
endif
sname='LunarAzimuthAngle'
if(associated(x%LunarAzimuthAngle))then
  deallocate(x%LunarAzimuthAngle,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%LunarAzimuthAngle)
endif
sname='Height'
if(associated(x%Height))then
  deallocate(x%Height,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%Height)
endif
sname='SatelliteRange'
if(associated(x%SatelliteRange))then
  deallocate(x%SatelliteRange,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%SatelliteRange)
endif
sname='MoonIllumFraction'
if(associated(x%MoonIllumFraction))then
  deallocate(x%MoonIllumFraction,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%MoonIllumFraction)
endif
sname='QF1_VIIRSGTMGEO'
if(associated(x%QF1_VIIRSGTMGEO))then
  deallocate(x%QF1_VIIRSGTMGEO,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%QF1_VIIRSGTMGEO)
endif
sname='QF2_VIIRSGTMGEO'
if(associated(x%QF2_VIIRSGTMGEO))then
  deallocate(x%QF2_VIIRSGTMGEO,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%QF2_VIIRSGTMGEO)
endif
sname='PixelRowSDR'
if(associated(x%PixelRowSDR))then
  deallocate(x%PixelRowSDR,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%PixelRowSDR)
endif
sname='PixelColSDR'
if(associated(x%PixelColSDR))then
  deallocate(x%PixelColSDR,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%PixelColSDR)
endif
CATCH
end subroutine

subroutine viirs_edr_img_geo_init(x)
type(viirs_edr_img_geo),intent(inout)::x

  x%StartDay=0
  x%StartMonth=0
  x%StartYear=0
  nullify(x%UTC)
  nullify(x%Time)
  nullify(x%Latitude)
  nullify(x%Longitude)
  nullify(x%SolarZenithAngle)
  nullify(x%SolarAzimuthAngle)
  nullify(x%SatelliteZenithAngle)
  nullify(x%SatelliteAzimuthAngle)
  nullify(x%LunarZenithAngle)
  nullify(x%LunarAzimuthAngle)
  nullify(x%Height)
  nullify(x%SatelliteRange)
  nullify(x%MoonIllumFraction)
  nullify(x%QF1_VIIRSGTMGEO)
  nullify(x%QF2_VIIRSGTMGEO)
  nullify(x%PixelRowSDR)
  nullify(x%PixelColSDR)
end subroutine

subroutine viirs_edr_img_geo_copy(x,y,err,data)
type(viirs_edr_img_geo),intent(inout)::x
type(viirs_edr_img_geo),intent(in)::y
integer,intent(out)::err
logical, optional :: data
integer::lb(7),ub(7)
logical :: data1

TRY

  data1=.true.
  if(present(data))data1 = data
  
  if(data1)x%StartDay=y%StartDay
  if(data1)x%StartMonth=y%StartMonth
  if(data1)x%StartYear=y%StartYear
  if(associated(y%UTC))then
    lb(1:1)=lbound(y%UTC)
    ub(1:1)=ubound(y%UTC)
    allocate(x%UTC(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE UTC")
    if(data1)x%UTC=y%UTC
  else
    nullify(x%UTC)
  endif
  if(associated(y%Time))then
    lb(1:1)=lbound(y%Time)
    ub(1:1)=ubound(y%Time)
    allocate(x%Time(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Time")
    if(data1)x%Time=y%Time
  else
    nullify(x%Time)
  endif
  if(associated(y%Latitude))then
    lb(1:2)=lbound(y%Latitude)
    ub(1:2)=ubound(y%Latitude)
    allocate(x%Latitude(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Latitude")
    if(data1)x%Latitude=y%Latitude
  else
    nullify(x%Latitude)
  endif
  if(associated(y%Longitude))then
    lb(1:2)=lbound(y%Longitude)
    ub(1:2)=ubound(y%Longitude)
    allocate(x%Longitude(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Longitude")
    if(data1)x%Longitude=y%Longitude
  else
    nullify(x%Longitude)
  endif
  if(associated(y%SolarZenithAngle))then
    lb(1:2)=lbound(y%SolarZenithAngle)
    ub(1:2)=ubound(y%SolarZenithAngle)
    allocate(x%SolarZenithAngle(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE SolarZenithAngle")
    if(data1)x%SolarZenithAngle=y%SolarZenithAngle
  else
    nullify(x%SolarZenithAngle)
  endif
  if(associated(y%SolarAzimuthAngle))then
    lb(1:2)=lbound(y%SolarAzimuthAngle)
    ub(1:2)=ubound(y%SolarAzimuthAngle)
    allocate(x%SolarAzimuthAngle(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE SolarAzimuthAngle")
    if(data1)x%SolarAzimuthAngle=y%SolarAzimuthAngle
  else
    nullify(x%SolarAzimuthAngle)
  endif
  if(associated(y%SatelliteZenithAngle))then
    lb(1:2)=lbound(y%SatelliteZenithAngle)
    ub(1:2)=ubound(y%SatelliteZenithAngle)
    allocate(x%SatelliteZenithAngle(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE SatelliteZenithAngle")
    if(data1)x%SatelliteZenithAngle=y%SatelliteZenithAngle
  else
    nullify(x%SatelliteZenithAngle)
  endif
  if(associated(y%SatelliteAzimuthAngle))then
    lb(1:2)=lbound(y%SatelliteAzimuthAngle)
    ub(1:2)=ubound(y%SatelliteAzimuthAngle)
    allocate(x%SatelliteAzimuthAngle(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE SatelliteAzimuthAngle")
    if(data1)x%SatelliteAzimuthAngle=y%SatelliteAzimuthAngle
  else
    nullify(x%SatelliteAzimuthAngle)
  endif
  if(associated(y%LunarZenithAngle))then
    lb(1:2)=lbound(y%LunarZenithAngle)
    ub(1:2)=ubound(y%LunarZenithAngle)
    allocate(x%LunarZenithAngle(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE LunarZenithAngle")
    if(data1)x%LunarZenithAngle=y%LunarZenithAngle
  else
    nullify(x%LunarZenithAngle)
  endif
  if(associated(y%LunarAzimuthAngle))then
    lb(1:2)=lbound(y%LunarAzimuthAngle)
    ub(1:2)=ubound(y%LunarAzimuthAngle)
    allocate(x%LunarAzimuthAngle(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE LunarAzimuthAngle")
    if(data1)x%LunarAzimuthAngle=y%LunarAzimuthAngle
  else
    nullify(x%LunarAzimuthAngle)
  endif
  if(associated(y%Height))then
    lb(1:2)=lbound(y%Height)
    ub(1:2)=ubound(y%Height)
    allocate(x%Height(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Height")
    if(data1)x%Height=y%Height
  else
    nullify(x%Height)
  endif
  if(associated(y%SatelliteRange))then
    lb(1:2)=lbound(y%SatelliteRange)
    ub(1:2)=ubound(y%SatelliteRange)
    allocate(x%SatelliteRange(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE SatelliteRange")
    if(data1)x%SatelliteRange=y%SatelliteRange
  else
    nullify(x%SatelliteRange)
  endif
  if(associated(y%MoonIllumFraction))then
    lb(1:1)=lbound(y%MoonIllumFraction)
    ub(1:1)=ubound(y%MoonIllumFraction)
    allocate(x%MoonIllumFraction(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE MoonIllumFraction")
    if(data1)x%MoonIllumFraction=y%MoonIllumFraction
  else
    nullify(x%MoonIllumFraction)
  endif
  if(associated(y%QF1_VIIRSGTMGEO))then
    lb(1:2)=lbound(y%QF1_VIIRSGTMGEO)
    ub(1:2)=ubound(y%QF1_VIIRSGTMGEO)
    allocate(x%QF1_VIIRSGTMGEO(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF1_VIIRSGTMGEO")
    if(data1)x%QF1_VIIRSGTMGEO=y%QF1_VIIRSGTMGEO
  else
    nullify(x%QF1_VIIRSGTMGEO)
  endif
  if(associated(y%QF2_VIIRSGTMGEO))then
    lb(1:1)=lbound(y%QF2_VIIRSGTMGEO)
    ub(1:1)=ubound(y%QF2_VIIRSGTMGEO)
    allocate(x%QF2_VIIRSGTMGEO(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF2_VIIRSGTMGEO")
    if(data1)x%QF2_VIIRSGTMGEO=y%QF2_VIIRSGTMGEO
  else
    nullify(x%QF2_VIIRSGTMGEO)
  endif
  if(associated(y%PixelRowSDR))then
    lb(1:2)=lbound(y%PixelRowSDR)
    ub(1:2)=ubound(y%PixelRowSDR)
    allocate(x%PixelRowSDR(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE PixelRowSDR")
    if(data1)x%PixelRowSDR=y%PixelRowSDR
  else
    nullify(x%PixelRowSDR)
  endif
  if(associated(y%PixelColSDR))then
    lb(1:2)=lbound(y%PixelColSDR)
    ub(1:2)=ubound(y%PixelColSDR)
    allocate(x%PixelColSDR(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE PixelColSDR")
    if(data1)x%PixelColSDR=y%PixelColSDR
  else
    nullify(x%PixelColSDR)
  endif
CATCH
end subroutine

subroutine viirs_edr_img_geo_paste(x,y,z,err,data)
! only pointer arrays are considered
! for any other type the Y value is passed to X
! paste the last dimension of array
type(viirs_edr_img_geo),intent(inout)::x
type(viirs_edr_img_geo),intent(in)::y
type(viirs_edr_img_geo),intent(in)::z
integer,intent(out)::err
logical, optional :: data
integer::lby(7),uby(7)
integer::lbz(7),ubz(7)
integer::lb1(7),ub1(7)
integer::lb2(7),ub2(7)

logical :: data1

TRY

  data1=.true.
  if(present(data))data1 = data
  
  if(data1)x%StartDay=y%StartDay
  if(data1)x%StartMonth=y%StartMonth
  if(data1)x%StartYear=y%StartYear
  if(associated(y%UTC) .and. associated(z%UTC))then
    lby(1:1)=lbound(y%UTC)
    uby(1:1)=ubound(y%UTC)

    lbz(1:1)=lbound(z%UTC)
    ubz(1:1)=ubound(z%UTC)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%UTC(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE UTC")
    if(data1) then
      x%UTC(lb1(1):ub1(1))=y%UTC
      x%UTC(lb2(1):ub2(1))=z%UTC
    endif
  else
    nullify(x%UTC)
  endif
  if(associated(y%Time) .and. associated(z%Time))then
    lby(1:1)=lbound(y%Time)
    uby(1:1)=ubound(y%Time)

    lbz(1:1)=lbound(z%Time)
    ubz(1:1)=ubound(z%Time)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%Time(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Time")
    if(data1) then
      x%Time(lb1(1):ub1(1))=y%Time
      x%Time(lb2(1):ub2(1))=z%Time
    endif
  else
    nullify(x%Time)
  endif
  if(associated(y%Latitude) .and. associated(z%Latitude))then
    lby(1:2)=lbound(y%Latitude)
    uby(1:2)=ubound(y%Latitude)

    lbz(1:2)=lbound(z%Latitude)
    ubz(1:2)=ubound(z%Latitude)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%Latitude(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Latitude")
    if(data1) then
      x%Latitude(lb1(1):ub1(1),lb1(2):ub1(2))=y%Latitude
      x%Latitude(lb2(1):ub2(1),lb2(2):ub2(2))=z%Latitude
    endif
  else
    nullify(x%Latitude)
  endif
  if(associated(y%Longitude) .and. associated(z%Longitude))then
    lby(1:2)=lbound(y%Longitude)
    uby(1:2)=ubound(y%Longitude)

    lbz(1:2)=lbound(z%Longitude)
    ubz(1:2)=ubound(z%Longitude)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%Longitude(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Longitude")
    if(data1) then
      x%Longitude(lb1(1):ub1(1),lb1(2):ub1(2))=y%Longitude
      x%Longitude(lb2(1):ub2(1),lb2(2):ub2(2))=z%Longitude
    endif
  else
    nullify(x%Longitude)
  endif
  if(associated(y%SolarZenithAngle) .and. associated(z%SolarZenithAngle))then
    lby(1:2)=lbound(y%SolarZenithAngle)
    uby(1:2)=ubound(y%SolarZenithAngle)

    lbz(1:2)=lbound(z%SolarZenithAngle)
    ubz(1:2)=ubound(z%SolarZenithAngle)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%SolarZenithAngle(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE SolarZenithAngle")
    if(data1) then
      x%SolarZenithAngle(lb1(1):ub1(1),lb1(2):ub1(2))=y%SolarZenithAngle
      x%SolarZenithAngle(lb2(1):ub2(1),lb2(2):ub2(2))=z%SolarZenithAngle
    endif
  else
    nullify(x%SolarZenithAngle)
  endif
  if(associated(y%SolarAzimuthAngle) .and. associated(z%SolarAzimuthAngle))then
    lby(1:2)=lbound(y%SolarAzimuthAngle)
    uby(1:2)=ubound(y%SolarAzimuthAngle)

    lbz(1:2)=lbound(z%SolarAzimuthAngle)
    ubz(1:2)=ubound(z%SolarAzimuthAngle)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%SolarAzimuthAngle(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE SolarAzimuthAngle")
    if(data1) then
      x%SolarAzimuthAngle(lb1(1):ub1(1),lb1(2):ub1(2))=y%SolarAzimuthAngle
      x%SolarAzimuthAngle(lb2(1):ub2(1),lb2(2):ub2(2))=z%SolarAzimuthAngle
    endif
  else
    nullify(x%SolarAzimuthAngle)
  endif
  if(associated(y%SatelliteZenithAngle) .and. associated(z%SatelliteZenithAngle))then
    lby(1:2)=lbound(y%SatelliteZenithAngle)
    uby(1:2)=ubound(y%SatelliteZenithAngle)

    lbz(1:2)=lbound(z%SatelliteZenithAngle)
    ubz(1:2)=ubound(z%SatelliteZenithAngle)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%SatelliteZenithAngle(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE SatelliteZenithAngle")
    if(data1) then
      x%SatelliteZenithAngle(lb1(1):ub1(1),lb1(2):ub1(2))=y%SatelliteZenithAngle
      x%SatelliteZenithAngle(lb2(1):ub2(1),lb2(2):ub2(2))=z%SatelliteZenithAngle
    endif
  else
    nullify(x%SatelliteZenithAngle)
  endif
  if(associated(y%SatelliteAzimuthAngle) .and. associated(z%SatelliteAzimuthAngle))then
    lby(1:2)=lbound(y%SatelliteAzimuthAngle)
    uby(1:2)=ubound(y%SatelliteAzimuthAngle)

    lbz(1:2)=lbound(z%SatelliteAzimuthAngle)
    ubz(1:2)=ubound(z%SatelliteAzimuthAngle)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%SatelliteAzimuthAngle(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE SatelliteAzimuthAngle")
    if(data1) then
      x%SatelliteAzimuthAngle(lb1(1):ub1(1),lb1(2):ub1(2))=y%SatelliteAzimuthAngle
      x%SatelliteAzimuthAngle(lb2(1):ub2(1),lb2(2):ub2(2))=z%SatelliteAzimuthAngle
    endif
  else
    nullify(x%SatelliteAzimuthAngle)
  endif
  if(associated(y%LunarZenithAngle) .and. associated(z%LunarZenithAngle))then
    lby(1:2)=lbound(y%LunarZenithAngle)
    uby(1:2)=ubound(y%LunarZenithAngle)

    lbz(1:2)=lbound(z%LunarZenithAngle)
    ubz(1:2)=ubound(z%LunarZenithAngle)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%LunarZenithAngle(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE LunarZenithAngle")
    if(data1) then
      x%LunarZenithAngle(lb1(1):ub1(1),lb1(2):ub1(2))=y%LunarZenithAngle
      x%LunarZenithAngle(lb2(1):ub2(1),lb2(2):ub2(2))=z%LunarZenithAngle
    endif
  else
    nullify(x%LunarZenithAngle)
  endif
  if(associated(y%LunarAzimuthAngle) .and. associated(z%LunarAzimuthAngle))then
    lby(1:2)=lbound(y%LunarAzimuthAngle)
    uby(1:2)=ubound(y%LunarAzimuthAngle)

    lbz(1:2)=lbound(z%LunarAzimuthAngle)
    ubz(1:2)=ubound(z%LunarAzimuthAngle)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%LunarAzimuthAngle(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE LunarAzimuthAngle")
    if(data1) then
      x%LunarAzimuthAngle(lb1(1):ub1(1),lb1(2):ub1(2))=y%LunarAzimuthAngle
      x%LunarAzimuthAngle(lb2(1):ub2(1),lb2(2):ub2(2))=z%LunarAzimuthAngle
    endif
  else
    nullify(x%LunarAzimuthAngle)
  endif
  if(associated(y%Height) .and. associated(z%Height))then
    lby(1:2)=lbound(y%Height)
    uby(1:2)=ubound(y%Height)

    lbz(1:2)=lbound(z%Height)
    ubz(1:2)=ubound(z%Height)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%Height(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Height")
    if(data1) then
      x%Height(lb1(1):ub1(1),lb1(2):ub1(2))=y%Height
      x%Height(lb2(1):ub2(1),lb2(2):ub2(2))=z%Height
    endif
  else
    nullify(x%Height)
  endif
  if(associated(y%SatelliteRange) .and. associated(z%SatelliteRange))then
    lby(1:2)=lbound(y%SatelliteRange)
    uby(1:2)=ubound(y%SatelliteRange)

    lbz(1:2)=lbound(z%SatelliteRange)
    ubz(1:2)=ubound(z%SatelliteRange)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%SatelliteRange(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE SatelliteRange")
    if(data1) then
      x%SatelliteRange(lb1(1):ub1(1),lb1(2):ub1(2))=y%SatelliteRange
      x%SatelliteRange(lb2(1):ub2(1),lb2(2):ub2(2))=z%SatelliteRange
    endif
  else
    nullify(x%SatelliteRange)
  endif
  if(associated(y%MoonIllumFraction) .and. associated(z%MoonIllumFraction))then
    lby(1:1)=lbound(y%MoonIllumFraction)
    uby(1:1)=ubound(y%MoonIllumFraction)

    lbz(1:1)=lbound(z%MoonIllumFraction)
    ubz(1:1)=ubound(z%MoonIllumFraction)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%MoonIllumFraction(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE MoonIllumFraction")
    if(data1) then
      x%MoonIllumFraction(lb1(1):ub1(1))=y%MoonIllumFraction
      x%MoonIllumFraction(lb2(1):ub2(1))=z%MoonIllumFraction
    endif
  else
    nullify(x%MoonIllumFraction)
  endif
  if(associated(y%QF1_VIIRSGTMGEO) .and. associated(z%QF1_VIIRSGTMGEO))then
    lby(1:2)=lbound(y%QF1_VIIRSGTMGEO)
    uby(1:2)=ubound(y%QF1_VIIRSGTMGEO)

    lbz(1:2)=lbound(z%QF1_VIIRSGTMGEO)
    ubz(1:2)=ubound(z%QF1_VIIRSGTMGEO)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%QF1_VIIRSGTMGEO(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF1_VIIRSGTMGEO")
    if(data1) then
      x%QF1_VIIRSGTMGEO(lb1(1):ub1(1),lb1(2):ub1(2))=y%QF1_VIIRSGTMGEO
      x%QF1_VIIRSGTMGEO(lb2(1):ub2(1),lb2(2):ub2(2))=z%QF1_VIIRSGTMGEO
    endif
  else
    nullify(x%QF1_VIIRSGTMGEO)
  endif
  if(associated(y%QF2_VIIRSGTMGEO) .and. associated(z%QF2_VIIRSGTMGEO))then
    lby(1:1)=lbound(y%QF2_VIIRSGTMGEO)
    uby(1:1)=ubound(y%QF2_VIIRSGTMGEO)

    lbz(1:1)=lbound(z%QF2_VIIRSGTMGEO)
    ubz(1:1)=ubound(z%QF2_VIIRSGTMGEO)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%QF2_VIIRSGTMGEO(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF2_VIIRSGTMGEO")
    if(data1) then
      x%QF2_VIIRSGTMGEO(lb1(1):ub1(1))=y%QF2_VIIRSGTMGEO
      x%QF2_VIIRSGTMGEO(lb2(1):ub2(1))=z%QF2_VIIRSGTMGEO
    endif
  else
    nullify(x%QF2_VIIRSGTMGEO)
  endif
  if(associated(y%PixelRowSDR) .and. associated(z%PixelRowSDR))then
    lby(1:2)=lbound(y%PixelRowSDR)
    uby(1:2)=ubound(y%PixelRowSDR)

    lbz(1:2)=lbound(z%PixelRowSDR)
    ubz(1:2)=ubound(z%PixelRowSDR)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%PixelRowSDR(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE PixelRowSDR")
    if(data1) then
      x%PixelRowSDR(lb1(1):ub1(1),lb1(2):ub1(2))=y%PixelRowSDR
      x%PixelRowSDR(lb2(1):ub2(1),lb2(2):ub2(2))=z%PixelRowSDR
    endif
  else
    nullify(x%PixelRowSDR)
  endif
  if(associated(y%PixelColSDR) .and. associated(z%PixelColSDR))then
    lby(1:2)=lbound(y%PixelColSDR)
    uby(1:2)=ubound(y%PixelColSDR)

    lbz(1:2)=lbound(z%PixelColSDR)
    ubz(1:2)=ubound(z%PixelColSDR)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%PixelColSDR(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE PixelColSDR")
    if(data1) then
      x%PixelColSDR(lb1(1):ub1(1),lb1(2):ub1(2))=y%PixelColSDR
      x%PixelColSDR(lb2(1):ub2(1),lb2(2):ub2(2))=z%PixelColSDR
    endif
  else
    nullify(x%PixelColSDR)
  endif
CATCH
end subroutine

end module
