!
! Automatically generated by ./mod_rw.pl
! Do not edit
!
module viirs_edr_img_mem
#include "aapp_throw.h"
Use viirs_edr_img_def

Use jpss_meta_root_mem
Use jpss_meta_aggregate_mem
Use viirs_edr_img_data_mem
Use viirs_edr_img_geo_mem

implicit none
private
public :: viirs_edr_img_free
public :: viirs_edr_img_init
public :: viirs_edr_img_copy


contains

subroutine viirs_edr_img_free(x,err)
type(viirs_edr_img),intent(inout)::x
integer,intent(out)::err
integer::ichan, nchan
TRY
err = 0

Call jpss_meta_root_free(x%root_att,err)
THROWM(err.ne.0,"CANNOT FREE Root Attributes")


Call jpss_meta_aggregate_free(x%agg_att,err)
THROWM(err.ne.0,"CANNOT Free Aggregate Attributes")

If(associated(x%band))then
  nchan = size( x%band )
  Do ichan=1,nchan
    Call viirs_edr_img_data_free(x%band(ichan),err)
    THROWM(err.ne.0,"CANNOT Free Band data")
  End Do
  deallocate(x%band,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE Band data")
  nullify(x%band)
End If

Call viirs_edr_img_geo_free(x%geo,err)
THROWM(err.ne.0,"CANNOT Free Geolocation")

CATCH
end subroutine

subroutine viirs_edr_img_copy(x,y,err,data)
type(viirs_edr_img),intent(inout)::x
type(viirs_edr_img),intent(in)::y
integer,intent(out)::err
logical, optional :: data
integer::lb(7),ub(7)
logical :: data1
integer :: ichan, nchan

TRY

  data1=.true.
  if(present(data))data1 = data
  
  Call jpss_meta_root_copy(x%root_att,y%root_att,err,data)
  THROWM(err.ne.0,"CANNOT Copy Root Attributes")

  Call jpss_meta_aggregate_copy(x%agg_att,y%agg_att,err,data)
  THROWM(err.ne.0,"CANNOT Copy Aggregate Attributes")

  If(associated(y%band))then
    nchan = size( y%band )
    allocate(x%band(nchan),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE EDR IMG bands")
    Do ichan=1,nchan
      Call viirs_edr_img_data_copy(x%band(ichan),y%band(ichan),err,data)
      THROWM(err.ne.0,"CANNOT Copy Band data")
    End Do
  End If

  Call viirs_edr_img_geo_copy(x%geo,y%geo,err,data)
  THROWM(err.ne.0,"CANNOT Copy Geolocation")

CATCH
end subroutine

subroutine viirs_edr_img_init(x, band, err)
type(viirs_edr_img),intent(inout)::x
character(len=*) :: band   ! Band name I;M;DN
integer,intent(out)::err

character(len=1)::nband
integer::ichan, nchan

TRY

  Call jpss_meta_root_init(x%root_att)

  Call jpss_meta_aggregate_init(x%agg_att)
  
  nband = ADJUSTL(band)
  Select Case ( nband )
    case ('i','I')
      nchan = 5
    case ('m','M')
      nchan = 6 ! Only 6 channels among 16
    case default
      nchan = 1
  End Select

  allocate(x%band(nchan),stat=err)
  THROWM(err.ne.0,"CANNOT ALLOCATE EDR IMG bands")
  Do ichan=1,nchan
    Call viirs_edr_img_data_init(x%band(ichan))
  End Do

  Call viirs_edr_img_geo_init(x%geo)

CATCH
end subroutine

end module
