!
! Automatically generated by ./mod_rw.pl  version 1.2
! Do not edit
! Name: $Id: viirs_ip_cm_data_io.F90 
!
! Purpose:  viirs ip cm Fortran I/O module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!
module viirs_ip_cm_data_io

#ifdef HAS_LIBHDF5

#include "aapp_throw.h"
!use rttov_print_mod
use aapp_hdf_mod
use viirs_ip_cm_data_def
use viirs_ip_cm_data_mem
use hdf5
implicit none
private
public :: viirs_ip_cm_data_rh
public :: viirs_ip_cm_data_wh
public :: viirs_ip_cm_data_writea


contains


subroutine viirs_ip_cm_data_writea(x,lun,err)
type(viirs_ip_cm_data),intent(in)::x
integer,intent(in)::lun
integer,intent(out)::err
integer::lb(7),ub(7)
character(len=nlen)::sname

TRY
sname='QF1_VIIRSCMIP'
if(associated(x%QF1_VIIRSCMIP))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Cloud Mask IP Quality Flags [pixels, lines]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%QF1_VIIRSCMIP), &
    & ubound(x%QF1_VIIRSCMIP)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(Z4))',a2=x%QF1_VIIRSCMIP)
! write(lun,*,err=999)x%QF1_VIIRSCMIP
endif

sname='QF2_VIIRSCMIP'
if(associated(x%QF2_VIIRSCMIP))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Cloud Mask IP Quality Flags [pixels, lines]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%QF2_VIIRSCMIP), &
    & ubound(x%QF2_VIIRSCMIP)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(Z4))',a2=x%QF2_VIIRSCMIP)
! write(lun,*,err=999)x%QF2_VIIRSCMIP
endif

sname='QF3_VIIRSCMIP'
if(associated(x%QF3_VIIRSCMIP))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Cloud Mask IP Quality Flags [pixels, lines]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%QF3_VIIRSCMIP), &
    & ubound(x%QF3_VIIRSCMIP)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(Z4))',a2=x%QF3_VIIRSCMIP)
! write(lun,*,err=999)x%QF3_VIIRSCMIP
endif

sname='QF4_VIIRSCMIP'
if(associated(x%QF4_VIIRSCMIP))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Cloud Mask IP Quality Flags [pixels, lines]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%QF4_VIIRSCMIP), &
    & ubound(x%QF4_VIIRSCMIP)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(Z4))',a2=x%QF4_VIIRSCMIP)
! write(lun,*,err=999)x%QF4_VIIRSCMIP
endif

sname='QF5_VIIRSCMIP'
if(associated(x%QF5_VIIRSCMIP))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Cloud Mask IP Quality Flags [pixels, lines]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%QF5_VIIRSCMIP), &
    & ubound(x%QF5_VIIRSCMIP)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(Z4))',a2=x%QF5_VIIRSCMIP)
! write(lun,*,err=999)x%QF5_VIIRSCMIP
endif

sname='QF6_VIIRSCMIP'
if(associated(x%QF6_VIIRSCMIP))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Cloud Mask IP Quality Flags [pixels, lines]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%QF6_VIIRSCMIP), &
    & ubound(x%QF6_VIIRSCMIP)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(Z4))',a2=x%QF6_VIIRSCMIP)
! write(lun,*,err=999)x%QF6_VIIRSCMIP
endif

sname='SCANALLOCEAN'
if(associated(x%SCANALLOCEAN))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Scan All ocean flag - one value per scan per M-Band detector [lines]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%SCANALLOCEAN), &
    & ubound(x%SCANALLOCEAN)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(I8))',a1=x%SCANALLOCEAN)
! write(lun,*,err=999)x%SCANALLOCEAN
endif

sname='SCANNOOCEAN'
if(associated(x%SCANNOOCEAN))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Scan No ocean flag - one value per scan per M-Band detector [lines]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%SCANNOOCEAN), &
    & ubound(x%SCANNOOCEAN)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(I8))',a1=x%SCANNOOCEAN)
! write(lun,*,err=999)x%SCANNOOCEAN
endif

sname='GRANULEALLOCEAN'
if(associated(x%GRANULEALLOCEAN))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Granule All ocean flag [granules]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%GRANULEALLOCEAN), &
    & ubound(x%GRANULEALLOCEAN)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(I8))',a1=x%GRANULEALLOCEAN)
! write(lun,*,err=999)x%GRANULEALLOCEAN
endif

sname='GRANULENOOCEAN'
if(associated(x%GRANULENOOCEAN))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Granule No ocean flag [granules]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%GRANULENOOCEAN), &
    & ubound(x%GRANULENOOCEAN)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(I8))',a1=x%GRANULENOOCEAN)
! write(lun,*,err=999)x%GRANULENOOCEAN
endif

write(lun,'("SECTION = EOF")',err=999)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
err=0
CATCH
end subroutine

subroutine viirs_ip_cm_data_rh(x,lun,err)
type(viirs_ip_cm_data),intent(out)::x
integer(hid_t),intent(in)::lun
integer,intent(out)::err
character(len=nlen)::sname
logical :: lext
TRY

call viirs_ip_cm_data_init(x)

sname='QF1_VIIRSCMIP'
call read_array_hdf(lun,sname,err,pi2=x%QF1_VIIRSCMIP)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='QF2_VIIRSCMIP'
call read_array_hdf(lun,sname,err,pi2=x%QF2_VIIRSCMIP)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='QF3_VIIRSCMIP'
call read_array_hdf(lun,sname,err,pi2=x%QF3_VIIRSCMIP)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='QF4_VIIRSCMIP'
call read_array_hdf(lun,sname,err,pi2=x%QF4_VIIRSCMIP)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='QF5_VIIRSCMIP'
call read_array_hdf(lun,sname,err,pi2=x%QF5_VIIRSCMIP)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='QF6_VIIRSCMIP'
call read_array_hdf(lun,sname,err,pi2=x%QF6_VIIRSCMIP)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='SCANALLOCEAN'
call read_array_hdf(lun,sname,err,pi1=x%SCANALLOCEAN)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='SCANNOOCEAN'
call read_array_hdf(lun,sname,err,pi1=x%SCANNOOCEAN)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='GRANULEALLOCEAN'
call read_array_hdf(lun,sname,err,pi1=x%GRANULEALLOCEAN)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='GRANULENOOCEAN'
call read_array_hdf(lun,sname,err,pi1=x%GRANULENOOCEAN)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

err=0
CATCH
end subroutine

subroutine viirs_ip_cm_data_wh(x,lun,err, compress)
type(viirs_ip_cm_data),intent(in)::x
integer(hid_t),intent(in)::lun
integer,intent(out)::err
logical,intent(in),optional::compress
character(len=nlen)::sname
TRY
sname='QF1_VIIRSCMIP'
if(associated(x%QF1_VIIRSCMIP))then
  call write_array_hdf(lun,sname,&
    & 'Cloud Mask IP Quality Flags [pixels, lines]',&
    & err,i2=x%QF1_VIIRSCMIP  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='QF2_VIIRSCMIP'
if(associated(x%QF2_VIIRSCMIP))then
  call write_array_hdf(lun,sname,&
    & 'Cloud Mask IP Quality Flags [pixels, lines]',&
    & err,i2=x%QF2_VIIRSCMIP  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='QF3_VIIRSCMIP'
if(associated(x%QF3_VIIRSCMIP))then
  call write_array_hdf(lun,sname,&
    & 'Cloud Mask IP Quality Flags [pixels, lines]',&
    & err,i2=x%QF3_VIIRSCMIP  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='QF4_VIIRSCMIP'
if(associated(x%QF4_VIIRSCMIP))then
  call write_array_hdf(lun,sname,&
    & 'Cloud Mask IP Quality Flags [pixels, lines]',&
    & err,i2=x%QF4_VIIRSCMIP  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='QF5_VIIRSCMIP'
if(associated(x%QF5_VIIRSCMIP))then
  call write_array_hdf(lun,sname,&
    & 'Cloud Mask IP Quality Flags [pixels, lines]',&
    & err,i2=x%QF5_VIIRSCMIP  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='QF6_VIIRSCMIP'
if(associated(x%QF6_VIIRSCMIP))then
  call write_array_hdf(lun,sname,&
    & 'Cloud Mask IP Quality Flags [pixels, lines]',&
    & err,i2=x%QF6_VIIRSCMIP  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='SCANALLOCEAN'
if(associated(x%SCANALLOCEAN))then
  call write_array_hdf(lun,sname,&
    & 'Scan All ocean flag - one value per scan per M-Band detector [lines]',&
    & err,i1=x%SCANALLOCEAN  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='SCANNOOCEAN'
if(associated(x%SCANNOOCEAN))then
  call write_array_hdf(lun,sname,&
    & 'Scan No ocean flag - one value per scan per M-Band detector [lines]',&
    & err,i1=x%SCANNOOCEAN  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='GRANULEALLOCEAN'
if(associated(x%GRANULEALLOCEAN))then
  call write_array_hdf(lun,sname,&
    & 'Granule All ocean flag [granules]',&
    & err,i1=x%GRANULEALLOCEAN  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='GRANULENOOCEAN'
if(associated(x%GRANULENOOCEAN))then
  call write_array_hdf(lun,sname,&
    & 'Granule No ocean flag [granules]',&
    & err,i1=x%GRANULENOOCEAN  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

err=0
CATCH
end subroutine

#endif

end module
