!
! Automatically generated by ./mod_rw.pl version 1.2
! Do not edit
!
! Name: $Id: viirs_ip_cm_data_mem.F90
!
! Purpose: viirs ip cm init structure,free pointers,copy structures module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!
module viirs_ip_cm_data_mem
#include "aapp_throw.h"
use viirs_ip_cm_data_def
implicit none
private
public :: viirs_ip_cm_data_free
public :: viirs_ip_cm_data_init
public :: viirs_ip_cm_data_copy
public :: viirs_ip_cm_data_paste


contains

subroutine viirs_ip_cm_data_free(x,err)
type(viirs_ip_cm_data),intent(inout)::x
integer,intent(out)::err
character(len=nlen)::sname
TRY
err = 0

sname='QF1_VIIRSCMIP'
if(associated(x%QF1_VIIRSCMIP))then
  deallocate(x%QF1_VIIRSCMIP,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%QF1_VIIRSCMIP)
endif
sname='QF2_VIIRSCMIP'
if(associated(x%QF2_VIIRSCMIP))then
  deallocate(x%QF2_VIIRSCMIP,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%QF2_VIIRSCMIP)
endif
sname='QF3_VIIRSCMIP'
if(associated(x%QF3_VIIRSCMIP))then
  deallocate(x%QF3_VIIRSCMIP,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%QF3_VIIRSCMIP)
endif
sname='QF4_VIIRSCMIP'
if(associated(x%QF4_VIIRSCMIP))then
  deallocate(x%QF4_VIIRSCMIP,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%QF4_VIIRSCMIP)
endif
sname='QF5_VIIRSCMIP'
if(associated(x%QF5_VIIRSCMIP))then
  deallocate(x%QF5_VIIRSCMIP,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%QF5_VIIRSCMIP)
endif
sname='QF6_VIIRSCMIP'
if(associated(x%QF6_VIIRSCMIP))then
  deallocate(x%QF6_VIIRSCMIP,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%QF6_VIIRSCMIP)
endif
sname='SCANALLOCEAN'
if(associated(x%SCANALLOCEAN))then
  deallocate(x%SCANALLOCEAN,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%SCANALLOCEAN)
endif
sname='SCANNOOCEAN'
if(associated(x%SCANNOOCEAN))then
  deallocate(x%SCANNOOCEAN,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%SCANNOOCEAN)
endif
sname='GRANULEALLOCEAN'
if(associated(x%GRANULEALLOCEAN))then
  deallocate(x%GRANULEALLOCEAN,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%GRANULEALLOCEAN)
endif
sname='GRANULENOOCEAN'
if(associated(x%GRANULENOOCEAN))then
  deallocate(x%GRANULENOOCEAN,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%GRANULENOOCEAN)
endif
CATCH
end subroutine

subroutine viirs_ip_cm_data_init(x)
type(viirs_ip_cm_data),intent(inout)::x

  nullify(x%QF1_VIIRSCMIP)
  nullify(x%QF2_VIIRSCMIP)
  nullify(x%QF3_VIIRSCMIP)
  nullify(x%QF4_VIIRSCMIP)
  nullify(x%QF5_VIIRSCMIP)
  nullify(x%QF6_VIIRSCMIP)
  nullify(x%SCANALLOCEAN)
  nullify(x%SCANNOOCEAN)
  nullify(x%GRANULEALLOCEAN)
  nullify(x%GRANULENOOCEAN)
end subroutine

subroutine viirs_ip_cm_data_copy(x,y,err,data)
type(viirs_ip_cm_data),intent(inout)::x
type(viirs_ip_cm_data),intent(in)::y
integer,intent(out)::err
logical, optional :: data
integer::lb(7),ub(7)
logical :: data1

TRY

  data1=.true.
  if(present(data))data1 = data
  
  if(associated(y%QF1_VIIRSCMIP))then
    lb(1:2)=lbound(y%QF1_VIIRSCMIP)
    ub(1:2)=ubound(y%QF1_VIIRSCMIP)
    allocate(x%QF1_VIIRSCMIP(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF1_VIIRSCMIP")
    if(data1)x%QF1_VIIRSCMIP=y%QF1_VIIRSCMIP
  else
    nullify(x%QF1_VIIRSCMIP)
  endif
  if(associated(y%QF2_VIIRSCMIP))then
    lb(1:2)=lbound(y%QF2_VIIRSCMIP)
    ub(1:2)=ubound(y%QF2_VIIRSCMIP)
    allocate(x%QF2_VIIRSCMIP(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF2_VIIRSCMIP")
    if(data1)x%QF2_VIIRSCMIP=y%QF2_VIIRSCMIP
  else
    nullify(x%QF2_VIIRSCMIP)
  endif
  if(associated(y%QF3_VIIRSCMIP))then
    lb(1:2)=lbound(y%QF3_VIIRSCMIP)
    ub(1:2)=ubound(y%QF3_VIIRSCMIP)
    allocate(x%QF3_VIIRSCMIP(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF3_VIIRSCMIP")
    if(data1)x%QF3_VIIRSCMIP=y%QF3_VIIRSCMIP
  else
    nullify(x%QF3_VIIRSCMIP)
  endif
  if(associated(y%QF4_VIIRSCMIP))then
    lb(1:2)=lbound(y%QF4_VIIRSCMIP)
    ub(1:2)=ubound(y%QF4_VIIRSCMIP)
    allocate(x%QF4_VIIRSCMIP(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF4_VIIRSCMIP")
    if(data1)x%QF4_VIIRSCMIP=y%QF4_VIIRSCMIP
  else
    nullify(x%QF4_VIIRSCMIP)
  endif
  if(associated(y%QF5_VIIRSCMIP))then
    lb(1:2)=lbound(y%QF5_VIIRSCMIP)
    ub(1:2)=ubound(y%QF5_VIIRSCMIP)
    allocate(x%QF5_VIIRSCMIP(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF5_VIIRSCMIP")
    if(data1)x%QF5_VIIRSCMIP=y%QF5_VIIRSCMIP
  else
    nullify(x%QF5_VIIRSCMIP)
  endif
  if(associated(y%QF6_VIIRSCMIP))then
    lb(1:2)=lbound(y%QF6_VIIRSCMIP)
    ub(1:2)=ubound(y%QF6_VIIRSCMIP)
    allocate(x%QF6_VIIRSCMIP(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF6_VIIRSCMIP")
    if(data1)x%QF6_VIIRSCMIP=y%QF6_VIIRSCMIP
  else
    nullify(x%QF6_VIIRSCMIP)
  endif
  if(associated(y%SCANALLOCEAN))then
    lb(1:1)=lbound(y%SCANALLOCEAN)
    ub(1:1)=ubound(y%SCANALLOCEAN)
    allocate(x%SCANALLOCEAN(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE SCANALLOCEAN")
    if(data1)x%SCANALLOCEAN=y%SCANALLOCEAN
  else
    nullify(x%SCANALLOCEAN)
  endif
  if(associated(y%SCANNOOCEAN))then
    lb(1:1)=lbound(y%SCANNOOCEAN)
    ub(1:1)=ubound(y%SCANNOOCEAN)
    allocate(x%SCANNOOCEAN(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE SCANNOOCEAN")
    if(data1)x%SCANNOOCEAN=y%SCANNOOCEAN
  else
    nullify(x%SCANNOOCEAN)
  endif
  if(associated(y%GRANULEALLOCEAN))then
    lb(1:1)=lbound(y%GRANULEALLOCEAN)
    ub(1:1)=ubound(y%GRANULEALLOCEAN)
    allocate(x%GRANULEALLOCEAN(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE GRANULEALLOCEAN")
    if(data1)x%GRANULEALLOCEAN=y%GRANULEALLOCEAN
  else
    nullify(x%GRANULEALLOCEAN)
  endif
  if(associated(y%GRANULENOOCEAN))then
    lb(1:1)=lbound(y%GRANULENOOCEAN)
    ub(1:1)=ubound(y%GRANULENOOCEAN)
    allocate(x%GRANULENOOCEAN(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE GRANULENOOCEAN")
    if(data1)x%GRANULENOOCEAN=y%GRANULENOOCEAN
  else
    nullify(x%GRANULENOOCEAN)
  endif
CATCH
end subroutine

subroutine viirs_ip_cm_data_paste(x,y,z,err,data)
! only pointer arrays are considered
! for any other type the Y value is passed to X
! paste the last dimension of array
type(viirs_ip_cm_data),intent(inout)::x
type(viirs_ip_cm_data),intent(in)::y
type(viirs_ip_cm_data),intent(in)::z
integer,intent(out)::err
logical, optional :: data
integer::lby(7),uby(7)
integer::lbz(7),ubz(7)
integer::lb1(7),ub1(7)
integer::lb2(7),ub2(7)

logical :: data1

TRY

  data1=.true.
  if(present(data))data1 = data
  
  if(associated(y%QF1_VIIRSCMIP) .and. associated(z%QF1_VIIRSCMIP))then
    lby(1:2)=lbound(y%QF1_VIIRSCMIP)
    uby(1:2)=ubound(y%QF1_VIIRSCMIP)

    lbz(1:2)=lbound(z%QF1_VIIRSCMIP)
    ubz(1:2)=ubound(z%QF1_VIIRSCMIP)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%QF1_VIIRSCMIP(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF1_VIIRSCMIP")
    if(data1) then
      x%QF1_VIIRSCMIP(lb1(1):ub1(1),lb1(2):ub1(2))=y%QF1_VIIRSCMIP
      x%QF1_VIIRSCMIP(lb2(1):ub2(1),lb2(2):ub2(2))=z%QF1_VIIRSCMIP
    endif
  else
    nullify(x%QF1_VIIRSCMIP)
  endif
  if(associated(y%QF2_VIIRSCMIP) .and. associated(z%QF2_VIIRSCMIP))then
    lby(1:2)=lbound(y%QF2_VIIRSCMIP)
    uby(1:2)=ubound(y%QF2_VIIRSCMIP)

    lbz(1:2)=lbound(z%QF2_VIIRSCMIP)
    ubz(1:2)=ubound(z%QF2_VIIRSCMIP)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%QF2_VIIRSCMIP(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF2_VIIRSCMIP")
    if(data1) then
      x%QF2_VIIRSCMIP(lb1(1):ub1(1),lb1(2):ub1(2))=y%QF2_VIIRSCMIP
      x%QF2_VIIRSCMIP(lb2(1):ub2(1),lb2(2):ub2(2))=z%QF2_VIIRSCMIP
    endif
  else
    nullify(x%QF2_VIIRSCMIP)
  endif
  if(associated(y%QF3_VIIRSCMIP) .and. associated(z%QF3_VIIRSCMIP))then
    lby(1:2)=lbound(y%QF3_VIIRSCMIP)
    uby(1:2)=ubound(y%QF3_VIIRSCMIP)

    lbz(1:2)=lbound(z%QF3_VIIRSCMIP)
    ubz(1:2)=ubound(z%QF3_VIIRSCMIP)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%QF3_VIIRSCMIP(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF3_VIIRSCMIP")
    if(data1) then
      x%QF3_VIIRSCMIP(lb1(1):ub1(1),lb1(2):ub1(2))=y%QF3_VIIRSCMIP
      x%QF3_VIIRSCMIP(lb2(1):ub2(1),lb2(2):ub2(2))=z%QF3_VIIRSCMIP
    endif
  else
    nullify(x%QF3_VIIRSCMIP)
  endif
  if(associated(y%QF4_VIIRSCMIP) .and. associated(z%QF4_VIIRSCMIP))then
    lby(1:2)=lbound(y%QF4_VIIRSCMIP)
    uby(1:2)=ubound(y%QF4_VIIRSCMIP)

    lbz(1:2)=lbound(z%QF4_VIIRSCMIP)
    ubz(1:2)=ubound(z%QF4_VIIRSCMIP)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%QF4_VIIRSCMIP(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF4_VIIRSCMIP")
    if(data1) then
      x%QF4_VIIRSCMIP(lb1(1):ub1(1),lb1(2):ub1(2))=y%QF4_VIIRSCMIP
      x%QF4_VIIRSCMIP(lb2(1):ub2(1),lb2(2):ub2(2))=z%QF4_VIIRSCMIP
    endif
  else
    nullify(x%QF4_VIIRSCMIP)
  endif
  if(associated(y%QF5_VIIRSCMIP) .and. associated(z%QF5_VIIRSCMIP))then
    lby(1:2)=lbound(y%QF5_VIIRSCMIP)
    uby(1:2)=ubound(y%QF5_VIIRSCMIP)

    lbz(1:2)=lbound(z%QF5_VIIRSCMIP)
    ubz(1:2)=ubound(z%QF5_VIIRSCMIP)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%QF5_VIIRSCMIP(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF5_VIIRSCMIP")
    if(data1) then
      x%QF5_VIIRSCMIP(lb1(1):ub1(1),lb1(2):ub1(2))=y%QF5_VIIRSCMIP
      x%QF5_VIIRSCMIP(lb2(1):ub2(1),lb2(2):ub2(2))=z%QF5_VIIRSCMIP
    endif
  else
    nullify(x%QF5_VIIRSCMIP)
  endif
  if(associated(y%QF6_VIIRSCMIP) .and. associated(z%QF6_VIIRSCMIP))then
    lby(1:2)=lbound(y%QF6_VIIRSCMIP)
    uby(1:2)=ubound(y%QF6_VIIRSCMIP)

    lbz(1:2)=lbound(z%QF6_VIIRSCMIP)
    ubz(1:2)=ubound(z%QF6_VIIRSCMIP)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%QF6_VIIRSCMIP(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF6_VIIRSCMIP")
    if(data1) then
      x%QF6_VIIRSCMIP(lb1(1):ub1(1),lb1(2):ub1(2))=y%QF6_VIIRSCMIP
      x%QF6_VIIRSCMIP(lb2(1):ub2(1),lb2(2):ub2(2))=z%QF6_VIIRSCMIP
    endif
  else
    nullify(x%QF6_VIIRSCMIP)
  endif
  if(associated(y%SCANALLOCEAN) .and. associated(z%SCANALLOCEAN))then
    lby(1:1)=lbound(y%SCANALLOCEAN)
    uby(1:1)=ubound(y%SCANALLOCEAN)

    lbz(1:1)=lbound(z%SCANALLOCEAN)
    ubz(1:1)=ubound(z%SCANALLOCEAN)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%SCANALLOCEAN(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE SCANALLOCEAN")
    if(data1) then
      x%SCANALLOCEAN(lb1(1):ub1(1))=y%SCANALLOCEAN
      x%SCANALLOCEAN(lb2(1):ub2(1))=z%SCANALLOCEAN
    endif
  else
    nullify(x%SCANALLOCEAN)
  endif
  if(associated(y%SCANNOOCEAN) .and. associated(z%SCANNOOCEAN))then
    lby(1:1)=lbound(y%SCANNOOCEAN)
    uby(1:1)=ubound(y%SCANNOOCEAN)

    lbz(1:1)=lbound(z%SCANNOOCEAN)
    ubz(1:1)=ubound(z%SCANNOOCEAN)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%SCANNOOCEAN(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE SCANNOOCEAN")
    if(data1) then
      x%SCANNOOCEAN(lb1(1):ub1(1))=y%SCANNOOCEAN
      x%SCANNOOCEAN(lb2(1):ub2(1))=z%SCANNOOCEAN
    endif
  else
    nullify(x%SCANNOOCEAN)
  endif
  if(associated(y%GRANULEALLOCEAN) .and. associated(z%GRANULEALLOCEAN))then
    lby(1:1)=lbound(y%GRANULEALLOCEAN)
    uby(1:1)=ubound(y%GRANULEALLOCEAN)

    lbz(1:1)=lbound(z%GRANULEALLOCEAN)
    ubz(1:1)=ubound(z%GRANULEALLOCEAN)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%GRANULEALLOCEAN(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE GRANULEALLOCEAN")
    if(data1) then
      x%GRANULEALLOCEAN(lb1(1):ub1(1))=y%GRANULEALLOCEAN
      x%GRANULEALLOCEAN(lb2(1):ub2(1))=z%GRANULEALLOCEAN
    endif
  else
    nullify(x%GRANULEALLOCEAN)
  endif
  if(associated(y%GRANULENOOCEAN) .and. associated(z%GRANULENOOCEAN))then
    lby(1:1)=lbound(y%GRANULENOOCEAN)
    uby(1:1)=ubound(y%GRANULENOOCEAN)

    lbz(1:1)=lbound(z%GRANULENOOCEAN)
    ubz(1:1)=ubound(z%GRANULENOOCEAN)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%GRANULENOOCEAN(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE GRANULENOOCEAN")
    if(data1) then
      x%GRANULENOOCEAN(lb1(1):ub1(1))=y%GRANULENOOCEAN
      x%GRANULENOOCEAN(lb2(1):ub2(1))=z%GRANULENOOCEAN
    endif
  else
    nullify(x%GRANULENOOCEAN)
  endif
CATCH
end subroutine

end module
