!
! Automatically generated by ./mod_rw.pl  version 1.2
! Do not edit
! Name: $Id: viirs_maia4_data_io.F90 
!
! Purpose:  viirs maia4 data Fortran I/O module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!
module viirs_maia4_data_io

#ifdef HAS_LIBHDF5

#include "aapp_throw.h"
!use rttov_print_mod
use aapp_hdf_mod
use viirs_maia4_data_def
use viirs_maia4_data_mem
use hdf5
implicit none
private
public :: viirs_maia4_data_rh
public :: viirs_maia4_data_wh
public :: viirs_maia4_data_writea


contains


subroutine viirs_maia4_data_writea(x,lun,err)
type(viirs_maia4_data),intent(in)::x
integer,intent(in)::lun
integer,intent(out)::err
integer::lb(7),ub(7)
character(len=nlen)::sname

TRY
sname='Alt_surface'
if(associated(x%Alt_surface))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'surface altitude'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)'meters * 100'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%Alt_surface), &
    & ubound(x%Alt_surface)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(i10))',a2=x%Alt_surface)
! write(lun,*,err=999)x%Alt_surface
endif

sname='CloudMask'
if(associated(x%CloudMask))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & ' CLOUD MASK'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%CloudMask), &
    & ubound(x%CloudMask)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(z10))',a2=x%CloudMask)
! write(lun,*,err=999)x%CloudMask
endif

sname='CloudTopPres'
if(associated(x%CloudTopPres))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & ' CLOUD Top Pressure'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)'hPa * 10'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%CloudTopPres), &
    & ubound(x%CloudTopPres)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(i10))',a2=x%CloudTopPres)
! write(lun,*,err=999)x%CloudTopPres
endif

sname='CloudTopTemp'
if(associated(x%CloudTopTemp))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & ' CLOUD Top Temperature'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)'Celsius * 100'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%CloudTopTemp), &
    & ubound(x%CloudTopTemp)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(i10))',a2=x%CloudTopTemp)
! write(lun,*,err=999)x%CloudTopTemp
endif

sname='CloudType'
if(associated(x%CloudType))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & ' cloud classification'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%CloudType), &
    & ubound(x%CloudType)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(z5))',a2=x%CloudType)
! write(lun,*,err=999)x%CloudType
endif

sname='Nb_IChan_Used'
write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Number of Imaging resolution channels used in process'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("UNITS = ",A)',iostat=err)''
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_integer(lun,'(10000(i8))',a0=x%Nb_IChan_Used)
!write(lun,err=999)x%Nb_IChan_Used

sname='Nb_MChan_Used'
write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Number of Moderate resolution channels used in process'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("UNITS = ",A)',iostat=err)''
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_integer(lun,'(10000(i8))',a0=x%Nb_MChan_Used)
!write(lun,err=999)x%Nb_MChan_Used

sname='MChan_Used'
if(associated(x%MChan_Used))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'list of Moderate resolution channels used in process'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%MChan_Used), &
    & ubound(x%MChan_Used)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(i8))',a1=x%MChan_Used)
! write(lun,*,err=999)x%MChan_Used
endif

sname='IChan_Used'
if(associated(x%IChan_Used))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'list of Imaging resolution channels used in process'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%IChan_Used), &
    & ubound(x%IChan_Used)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(i8))',a1=x%IChan_Used)
! write(lun,*,err=999)x%IChan_Used
endif

sname='Latitude'
if(associated(x%Latitude))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'latitude'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)'degrees * 10^4 (North latitude positive)'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%Latitude), &
    & ubound(x%Latitude)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(i10))',a2=x%Latitude)
! write(lun,*,err=999)x%Latitude
endif

sname='Longitude'
if(associated(x%Longitude))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'longitude'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)'degrees * 10^4 (East longitude positive)'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%Longitude), &
    & ubound(x%Longitude)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(i10))',a2=x%Longitude)
! write(lun,*,err=999)x%Longitude
endif

sname='Mask_ind'
if(associated(x%Mask_ind))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Processes applied on the line'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)'0 Not Done'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%Mask_ind), &
    & ubound(x%Mask_ind)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(z5))',a2=x%Mask_ind)
! write(lun,*,err=999)x%Mask_ind
endif

sname='Sat_zenith'
if(associated(x%Sat_zenith))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'satellite zenith angle'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)'degrees * 10^2'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%Sat_zenith), &
    & ubound(x%Sat_zenith)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(i10))',a2=x%Sat_zenith)
! write(lun,*,err=999)x%Sat_zenith
endif

sname='Tsurf'
if(associated(x%Tsurf))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'retrieved surface temperature'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)'Celsius * 100'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%Tsurf), &
    & ubound(x%Tsurf)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(i10))',a2=x%Tsurf)
! write(lun,*,err=999)x%Tsurf
endif

sname='fov_qual'
if(associated(x%fov_qual))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & ' pixel quality flags 0= ok  '
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)'0= ok'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%fov_qual), &
    & ubound(x%fov_qual)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(z10))',a2=x%fov_qual)
! write(lun,*,err=999)x%fov_qual
endif

sname='scnlin_day'
if(associated(x%scnlin_day))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'scan line day of year'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%scnlin_day), &
    & ubound(x%scnlin_day)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(i10))',a1=x%scnlin_day)
! write(lun,*,err=999)x%scnlin_day
endif

sname='scnlin_time'
if(associated(x%scnlin_time))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'scan line UTC time of day in milliseconds'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%scnlin_time), &
    & ubound(x%scnlin_time)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(i10))',a1=x%scnlin_time)
! write(lun,*,err=999)x%scnlin_time
endif

sname='scnlin_year'
if(associated(x%scnlin_year))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'scan line year'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%scnlin_year), &
    & ubound(x%scnlin_year)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(i10))',a1=x%scnlin_year)
! write(lun,*,err=999)x%scnlin_year
endif

sname='scnline_qual'
if(associated(x%scnline_qual))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'scan line quality flag'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)'0= ok 1= bad'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%scnline_qual), &
    & ubound(x%scnline_qual)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(i10))',a1=x%scnline_qual)
! write(lun,*,err=999)x%scnline_qual
endif

write(lun,'("SECTION = EOF")',err=999)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
err=0
CATCH
end subroutine

subroutine viirs_maia4_data_rh(x,lun,err)
type(viirs_maia4_data),intent(out)::x
integer(hid_t),intent(in)::lun
integer,intent(out)::err
character(len=nlen)::sname
logical :: lext
TRY

call viirs_maia4_data_init(x)

sname='Alt_surface'
call read_array_hdf(lun,sname,err,pi2=x%Alt_surface)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='CloudMask'
call read_array_hdf(lun,sname,err,pi2=x%CloudMask)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='CloudTopPres'
call read_array_hdf(lun,sname,err,pi2=x%CloudTopPres)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='CloudTopTemp'
call read_array_hdf(lun,sname,err,pi2=x%CloudTopTemp)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='CloudType'
call read_array_hdf(lun,sname,err,pi2=x%CloudType)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='Nb_IChan_Used'
call read_array_hdf(lun,sname,err,i0=x%Nb_IChan_Used)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='Nb_MChan_Used'
call read_array_hdf(lun,sname,err,i0=x%Nb_MChan_Used)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='MChan_Used'
call read_array_hdf(lun,sname,err,pi1=x%MChan_Used)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='IChan_Used'
call read_array_hdf(lun,sname,err,pi1=x%IChan_Used)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='Latitude'
call read_array_hdf(lun,sname,err,pi2=x%Latitude)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='Longitude'
call read_array_hdf(lun,sname,err,pi2=x%Longitude)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='Mask_ind'
call read_array_hdf(lun,sname,err,pi2=x%Mask_ind)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='Sat_zenith'
call read_array_hdf(lun,sname,err,pi2=x%Sat_zenith)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='Tsurf'
call read_array_hdf(lun,sname,err,pi2=x%Tsurf)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='fov_qual'
call read_array_hdf(lun,sname,err,pi2=x%fov_qual)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='scnlin_day'
call read_array_hdf(lun,sname,err,pi1=x%scnlin_day)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='scnlin_time'
call read_array_hdf(lun,sname,err,pi1=x%scnlin_time)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='scnlin_year'
call read_array_hdf(lun,sname,err,pi1=x%scnlin_year)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='scnline_qual'
call read_array_hdf(lun,sname,err,pi1=x%scnline_qual)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

err=0
CATCH
end subroutine

subroutine viirs_maia4_data_wh(x,lun,err, compress)
type(viirs_maia4_data),intent(in)::x
integer(hid_t),intent(in)::lun
integer,intent(out)::err
logical,intent(in),optional::compress
character(len=nlen)::sname
TRY
sname='Alt_surface'
if(associated(x%Alt_surface))then
  call write_array_hdf(lun,sname,&
    & 'surface altitude',&
    & err,i2=x%Alt_surface , units = 'meters * 100' ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='CloudMask'
if(associated(x%CloudMask))then
  call write_array_hdf(lun,sname,&
    & ' CLOUD MASK',&
    & err,i2=x%CloudMask  ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='CloudTopPres'
if(associated(x%CloudTopPres))then
  call write_array_hdf(lun,sname,&
    & ' CLOUD Top Pressure',&
    & err,i2=x%CloudTopPres , units = 'hPa * 10' ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='CloudTopTemp'
if(associated(x%CloudTopTemp))then
  call write_array_hdf(lun,sname,&
    & ' CLOUD Top Temperature',&
    & err,i2=x%CloudTopTemp , units = 'Celsius * 100' ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='CloudType'
if(associated(x%CloudType))then
  call write_array_hdf(lun,sname,&
    & ' cloud classification',&
    & err,i2=x%CloudType  ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='Nb_IChan_Used'
call write_array_hdf(lun,sname,&
  & 'Number of Imaging resolution channels used in process',&
  & err,i0=x%Nb_IChan_Used  )
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))

sname='Nb_MChan_Used'
call write_array_hdf(lun,sname,&
  & 'Number of Moderate resolution channels used in process',&
  & err,i0=x%Nb_MChan_Used  )
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))

sname='MChan_Used'
if(associated(x%MChan_Used))then
  call write_array_hdf(lun,sname,&
    & 'list of Moderate resolution channels used in process',&
    & err,i1=x%MChan_Used  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='IChan_Used'
if(associated(x%IChan_Used))then
  call write_array_hdf(lun,sname,&
    & 'list of Imaging resolution channels used in process',&
    & err,i1=x%IChan_Used  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='Latitude'
if(associated(x%Latitude))then
  call write_array_hdf(lun,sname,&
    & 'latitude',&
    & err,i2=x%Latitude , units = 'degrees * 10^4 (North latitude positive)' ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='Longitude'
if(associated(x%Longitude))then
  call write_array_hdf(lun,sname,&
    & 'longitude',&
    & err,i2=x%Longitude , units = 'degrees * 10^4 (East longitude positive)' ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='Mask_ind'
if(associated(x%Mask_ind))then
  call write_array_hdf(lun,sname,&
    & 'Processes applied on the line',&
    & err,i2=x%Mask_ind , units = '0 Not Done' ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='Sat_zenith'
if(associated(x%Sat_zenith))then
  call write_array_hdf(lun,sname,&
    & 'satellite zenith angle',&
    & err,i2=x%Sat_zenith , units = 'degrees * 10^2' ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='Tsurf'
if(associated(x%Tsurf))then
  call write_array_hdf(lun,sname,&
    & 'retrieved surface temperature',&
    & err,i2=x%Tsurf , units = 'Celsius * 100' ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='fov_qual'
if(associated(x%fov_qual))then
  call write_array_hdf(lun,sname,&
    & ' pixel quality flags 0= ok  ',&
    & err,i2=x%fov_qual , units = '0= ok' ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='scnlin_day'
if(associated(x%scnlin_day))then
  call write_array_hdf(lun,sname,&
    & 'scan line day of year',&
    & err,i1=x%scnlin_day  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='scnlin_time'
if(associated(x%scnlin_time))then
  call write_array_hdf(lun,sname,&
    & 'scan line UTC time of day in milliseconds',&
    & err,i1=x%scnlin_time  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='scnlin_year'
if(associated(x%scnlin_year))then
  call write_array_hdf(lun,sname,&
    & 'scan line year',&
    & err,i1=x%scnlin_year  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='scnline_qual'
if(associated(x%scnline_qual))then
  call write_array_hdf(lun,sname,&
    & 'scan line quality flag',&
    & err,i1=x%scnline_qual , units = '0= ok 1= bad' )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

err=0
CATCH
end subroutine

#endif

end module
