! Name: $Id$
!
! Purpose: viirs maia4 header fortan structure definition module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!   1.1   5/1/2017   Change size printed array (Pascale Roquet)
!   1.2   4/4/2017  update format Nb_Lines -> Nb_lines(Pascale Roquet) 
!   1.3   28/9/2017 Change sat_id comment (Pascale Roquet)
module viirs_maia4_header_def

implicit none
private
integer, parameter :: nlen = 256   ! name length
public :: nlen
public :: viirs_maia4_header

type viirs_maia4_header
  integer::CMa_Version ! version number of the cloud mask
  integer,pointer,dimension(:)::ModScan ! Scan operational mode (0: processed)
  character(len=32),dimension(1)::N_Granule_ID ! Granule identifier of the RDR granule
  integer::Nb_Granules ! number of granules in this dataset
  integer::Nb_lines ! count of scan lines in this data set
  integer::Nb_pixels ! number of pixels in line
  character(len=67),dimension(1)::dataname ! dataname of this file
  character(len=80),dimension(1)::dataname_gmodo ! dataname of the SDR Geolocation file
  integer::datatyp ! data type code (1 : Direct Readout, 2 : Global)
  integer::end_day ! end of dataset: day of year
  integer::end_orbit ! end of orbit number
  integer::end_time ! end of dataset: UTC time of day in ms
  integer::end_year ! end of dataset: year
  integer::inst_id ! instrument identification (AVHRR=1, VIIRS=2)
  integer::sat_id !satellite id in series (1=NPP or METOP-1, 2=METOP-2, 19=NOAA19)
  character(len=3),dimension(1)::site1b ! creation site of SDR data (CMS, NOA)
  character(len=3),dimension(1)::site1c ! Dataset creation site ID (CMS)
  integer::start_day ! start of dataset: day of year
  integer::start_orbit ! start orbit number
  integer::start_time ! start of dataset: UTC time of day in ms
  integer::start_year ! start of dataset: year
end type

end module
