!
! Automatically generated by ./mod_rw.pl version 1.2
! Do not edit
!
! Name: $Id: viirs_sdr_data_def.F90
!
! Purpose: viirs sdr data fortan structure definition module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!  

module viirs_sdr_data_def

implicit none
private
integer, parameter :: nlen = 256   ! name length
public :: nlen
public :: viirs_sdr_data

type viirs_sdr_data
  integer::Channel ! Channel number
  character(len=3)::Channel_Name ! Channel name ( I1 to I5, M1 to M16, DNB, left aligned, uppercase)
  real,pointer,dimension(:,:)::Radiance ! Calibrated TOA Radiance for each VIIRS pixel W/(m2 sr micron)
    !  [pixels, lines]
  integer,pointer,dimension(:,:)::Reflectance ! Calibrated TOA Relectance for each VIIRS pixel (from file)
    !  [pixels, lines]
  real,pointer,dimension(:,:)::BrightnessTemperature ! Calibrated TOA Brightness Temperature for each VIIRS pixel (K)
    !  [pixels, lines]
  integer,pointer,dimension(:)::ModeScan ! The VIIRS operational mode, reported at the scan level [scans]
  integer,pointer,dimension(:)::ModeGran ! The VIIRS operational mode, reported at the granule level [granules]
  integer,pointer,dimension(:)::NumberOfScans ! Actual number of VIIRS scans that were used to create this granule  [granules]
  integer,pointer,dimension(:)::NumberOfMissingPkts ! Number of missing packets in scan [scans]
  integer,pointer,dimension(:)::NumberOfBadChecksums ! Number of packets with bad checksum in scan [scans]
  integer,pointer,dimension(:)::NumberOfDiscardedPkts ! Number of discarded packets in scan [scans]
  integer,pointer,dimension(:,:)::QF1_VIIRSIBANDSDR ! I-Band Quality Flag for each pixel [pixels, lines]
  integer,pointer,dimension(:,:)::QF1_VIIRSMBANDSDR ! M-Band Quality Flag for each pixel [pixels, lines]
  integer,pointer,dimension(:,:)::QF1_VIIRSDNBBANDSDR ! DNB-Band Quality Flag for each pixel [pixels, lines]
  integer,pointer,dimension(:)::QF2_SCAN_SDR ! Quality Flag for each Scan (indicates general SDR information)  [scans]
  integer,pointer,dimension(:)::QF3_SCAN_RDR ! Quality Flag for each Scan (indicates general RDR information)  [scans]
  integer,pointer,dimension(:)::QF4_SCAN_SDR ! Reduced Quality Indication [lines]
  integer,pointer,dimension(:)::QF5_GRAN_BADDETECTOR ! Quality Flag – Bad detector [granules]
  real,pointer,dimension(:)::RadianceFactors ! Radiance scale and offset: first scale,second offset
  real,pointer,dimension(:)::ReflectanceFactors ! Reflectance scale and offset: first scale, second offset
  real,pointer,dimension(:)::BrightnessTemperatureFactors ! Brightness Temperature sc/offs: first scale, second offset
  real,pointer,dimension(:,:)::Reflectances ! Calibrated TOA Relectance for each VIIRS pixel REAL values
    !  [pixels, lines]
end type

end module
