!
! Automatically generated by ./mod_rw.pl  version 1.2
! Do not edit
! Name: $Id: viirs_sdr_data_io.F90 
!
! Purpose:  viirs sdr data Fortran I/O module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!
module viirs_sdr_data_io

#ifdef HAS_LIBHDF5

#include "aapp_throw.h"
!use rttov_print_mod
use aapp_hdf_mod
use viirs_sdr_data_def
use viirs_sdr_data_mem
use hdf5
implicit none
private
public :: viirs_sdr_data_rh
public :: viirs_sdr_data_wh
public :: viirs_sdr_data_writea


contains


subroutine viirs_sdr_data_writea(x,lun,err)
type(viirs_sdr_data),intent(in)::x
integer,intent(in)::lun
integer,intent(out)::err
integer::lb(7),ub(7)
character(len=nlen)::sname

TRY
sname='Channel'
write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Channel number'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("UNITS = ",A)',iostat=err)''
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_integer(lun,'(10000(I8))',a0=x%Channel)
!write(lun,err=999)x%Channel

sname='Channel_Name'
write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Channel name ( I1 to I5, M1 to M16, DNB, left aligned, uppercase)'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("UNITS = ",A)',iostat=err)''
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_character(lun,'(10000(A3))',a0=x%Channel_Name)
!write(lun,err=999)x%Channel_Name

sname='Radiance'
if(associated(x%Radiance))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Calibrated TOA Radiance for each VIIRS pixel W/(m2 sr micron)'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%Radiance), &
    & ubound(x%Radiance)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%Radiance)
! write(lun,*,err=999)x%Radiance
endif


sname='BrightnessTemperature'
if(associated(x%BrightnessTemperature))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Calibrated TOA Brightness Temperature for each VIIRS pixel (K)'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%BrightnessTemperature), &
    & ubound(x%BrightnessTemperature)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%BrightnessTemperature)
! write(lun,*,err=999)x%BrightnessTemperature
endif

sname='ModeScan'
if(associated(x%ModeScan))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'The VIIRS operational mode, reported at the scan level [scans]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%ModeScan), &
    & ubound(x%ModeScan)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(I8))',a1=x%ModeScan)
! write(lun,*,err=999)x%ModeScan
endif

sname='ModeGran'
if(associated(x%ModeGran))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'The VIIRS operational mode, reported at the granule level [granules]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%ModeGran), &
    & ubound(x%ModeGran)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(I8))',a1=x%ModeGran)
! write(lun,*,err=999)x%ModeGran
endif

sname='NumberOfScans'
if(associated(x%NumberOfScans))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Actual number of VIIRS scans that were used to create this granule  [granules]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%NumberOfScans), &
    & ubound(x%NumberOfScans)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(I8))',a1=x%NumberOfScans)
! write(lun,*,err=999)x%NumberOfScans
endif

sname='NumberOfMissingPkts'
if(associated(x%NumberOfMissingPkts))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Number of missing packets in scan [scans]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%NumberOfMissingPkts), &
    & ubound(x%NumberOfMissingPkts)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(I8))',a1=x%NumberOfMissingPkts)
! write(lun,*,err=999)x%NumberOfMissingPkts
endif

sname='NumberOfBadChecksums'
if(associated(x%NumberOfBadChecksums))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Number of packets with bad checksum in scan [scans]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%NumberOfBadChecksums), &
    & ubound(x%NumberOfBadChecksums)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(I8))',a1=x%NumberOfBadChecksums)
! write(lun,*,err=999)x%NumberOfBadChecksums
endif

sname='NumberOfDiscardedPkts'
if(associated(x%NumberOfDiscardedPkts))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Number of discarded packets in scan [scans]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%NumberOfDiscardedPkts), &
    & ubound(x%NumberOfDiscardedPkts)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(I8))',a1=x%NumberOfDiscardedPkts)
! write(lun,*,err=999)x%NumberOfDiscardedPkts
endif

sname='QF1_VIIRSIBANDSDR'
if(associated(x%QF1_VIIRSIBANDSDR))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'I-Band Quality Flag for each pixel [pixels, lines]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%QF1_VIIRSIBANDSDR), &
    & ubound(x%QF1_VIIRSIBANDSDR)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(Z4))',a2=x%QF1_VIIRSIBANDSDR)
! write(lun,*,err=999)x%QF1_VIIRSIBANDSDR
endif

sname='QF1_VIIRSMBANDSDR'
if(associated(x%QF1_VIIRSMBANDSDR))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'M-Band Quality Flag for each pixel [pixels, lines]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%QF1_VIIRSMBANDSDR), &
    & ubound(x%QF1_VIIRSMBANDSDR)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(Z4))',a2=x%QF1_VIIRSMBANDSDR)
! write(lun,*,err=999)x%QF1_VIIRSMBANDSDR
endif

sname='QF1_VIIRSDNBBANDSDR'
if(associated(x%QF1_VIIRSDNBBANDSDR))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'DNB-Band Quality Flag for each pixel [pixels, lines]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%QF1_VIIRSDNBBANDSDR), &
    & ubound(x%QF1_VIIRSDNBBANDSDR)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(Z4))',a2=x%QF1_VIIRSDNBBANDSDR)
! write(lun,*,err=999)x%QF1_VIIRSDNBBANDSDR
endif

sname='QF2_SCAN_SDR'
if(associated(x%QF2_SCAN_SDR))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Quality Flag for each Scan (indicates general SDR information)  [scans]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%QF2_SCAN_SDR), &
    & ubound(x%QF2_SCAN_SDR)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(Z4))',a1=x%QF2_SCAN_SDR)
! write(lun,*,err=999)x%QF2_SCAN_SDR
endif

sname='QF3_SCAN_RDR'
if(associated(x%QF3_SCAN_RDR))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Quality Flag for each Scan (indicates general RDR information)  [scans]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%QF3_SCAN_RDR), &
    & ubound(x%QF3_SCAN_RDR)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(Z4))',a1=x%QF3_SCAN_RDR)
! write(lun,*,err=999)x%QF3_SCAN_RDR
endif

sname='QF4_SCAN_SDR'
if(associated(x%QF4_SCAN_SDR))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Reduced Quality Indication [lines]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%QF4_SCAN_SDR), &
    & ubound(x%QF4_SCAN_SDR)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(I8))',a1=x%QF4_SCAN_SDR)
! write(lun,*,err=999)x%QF4_SCAN_SDR
endif

sname='QF5_GRAN_BADDETECTOR'
if(associated(x%QF5_GRAN_BADDETECTOR))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Quality Flag – Bad detector [granules]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%QF5_GRAN_BADDETECTOR), &
    & ubound(x%QF5_GRAN_BADDETECTOR)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(Z4))',a1=x%QF5_GRAN_BADDETECTOR)
! write(lun,*,err=999)x%QF5_GRAN_BADDETECTOR
endif

sname='RadianceFactors'
if(associated(x%RadianceFactors))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Radiance scale and offset: first scale,second offset'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%RadianceFactors), &
    & ubound(x%RadianceFactors)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a1=x%RadianceFactors)
! write(lun,*,err=999)x%RadianceFactors
endif

sname='ReflectanceFactors'
if(associated(x%ReflectanceFactors))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Reflectance scale and offset: first scale, second offset'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%ReflectanceFactors), &
    & ubound(x%ReflectanceFactors)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a1=x%ReflectanceFactors)
! write(lun,*,err=999)x%ReflectanceFactors
endif

sname='BrightnessTemperatureFactors'
if(associated(x%BrightnessTemperatureFactors))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Brightness Temperature sc/offs: first scale, second offset'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%BrightnessTemperatureFactors), &
    & ubound(x%BrightnessTemperatureFactors)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a1=x%BrightnessTemperatureFactors)
! write(lun,*,err=999)x%BrightnessTemperatureFactors
endif

sname='Reflectances'
if(associated(x%Reflectances))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Calibrated TOA Relectance for each VIIRS pixel REAL values'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%Reflectances), &
    & ubound(x%Reflectances)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%Reflectances)
! write(lun,*,err=999)x%Reflectances
endif

write(lun,'("SECTION = EOF")',err=999)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
err=0
CATCH
end subroutine

subroutine viirs_sdr_data_rh(x,lun,err)
type(viirs_sdr_data),intent(out)::x
integer(hid_t),intent(in)::lun
integer,intent(out)::err
character(len=nlen)::sname
logical :: lext
TRY

call viirs_sdr_data_init(x)



sname='Radiance'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr2=x%Radiance)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='Reflectance'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pi2=x%Reflectance)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='BrightnessTemperature'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr2=x%BrightnessTemperature)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='ModeScan'
call read_array_hdf(lun,sname,err,pi1=x%ModeScan)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='ModeGran'
call read_array_hdf(lun,sname,err,pi1=x%ModeGran)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='NumberOfScans'
call read_array_hdf(lun,sname,err,pi1=x%NumberOfScans)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='NumberOfMissingPkts'
call read_array_hdf(lun,sname,err,pi1=x%NumberOfMissingPkts)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='NumberOfBadChecksums'
call read_array_hdf(lun,sname,err,pi1=x%NumberOfBadChecksums)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='NumberOfDiscardedPkts'
call read_array_hdf(lun,sname,err,pi1=x%NumberOfDiscardedPkts)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='QF1_VIIRSIBANDSDR'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pi2=x%QF1_VIIRSIBANDSDR)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='QF1_VIIRSMBANDSDR'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pi2=x%QF1_VIIRSMBANDSDR)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='QF1_VIIRSDNBBANDSDR'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pi2=x%QF1_VIIRSDNBBANDSDR)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='QF2_SCAN_SDR'
call read_array_hdf(lun,sname,err,pi1=x%QF2_SCAN_SDR)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='QF3_SCAN_RDR'
call read_array_hdf(lun,sname,err,pi1=x%QF3_SCAN_RDR)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='QF4_SCAN_SDR'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pi1=x%QF4_SCAN_SDR)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='QF5_GRAN_BADDETECTOR'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pi1=x%QF5_GRAN_BADDETECTOR)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='RadianceFactors'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr1=x%RadianceFactors)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='ReflectanceFactors'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr1=x%ReflectanceFactors)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='BrightnessTemperatureFactors'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr1=x%BrightnessTemperatureFactors)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='Reflectances'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr2=x%Reflectances)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

err=0
CATCH
end subroutine

subroutine viirs_sdr_data_wh(x,lun,err, compress)
type(viirs_sdr_data),intent(in)::x
integer(hid_t),intent(in)::lun
integer,intent(out)::err
logical,intent(in),optional::compress
character(len=nlen)::sname
TRY


sname='Radiance'
if(associated(x%Radiance))then
  call write_array_hdf(lun,sname,&
    & 'Calibrated TOA Radiance for each VIIRS pixel W/(m2 sr micron)',&
    & err,r2=x%Radiance  ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif


sname='BrightnessTemperature'
if(associated(x%BrightnessTemperature))then
  call write_array_hdf(lun,sname,&
    & 'Calibrated TOA Brightness Temperature for each VIIRS pixel (K)',&
    & err,r2=x%BrightnessTemperature  ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='ModeScan'
if(associated(x%ModeScan))then
  call write_array_hdf(lun,sname,&
    & 'The VIIRS operational mode, reported at the scan level [scans]',&
    & err,i1=x%ModeScan  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='ModeGran'
if(associated(x%ModeGran))then
  call write_array_hdf(lun,sname,&
    & 'The VIIRS operational mode, reported at the granule level [granules]',&
    & err,i1=x%ModeGran  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='NumberOfScans'
if(associated(x%NumberOfScans))then
  call write_array_hdf(lun,sname,&
    & 'Actual number of VIIRS scans that were used to create this granule  [granules]',&
    & err,i1=x%NumberOfScans  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='NumberOfMissingPkts'
if(associated(x%NumberOfMissingPkts))then
  call write_array_hdf(lun,sname,&
    & 'Number of missing packets in scan [scans]',&
    & err,i1=x%NumberOfMissingPkts  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='NumberOfBadChecksums'
if(associated(x%NumberOfBadChecksums))then
  call write_array_hdf(lun,sname,&
    & 'Number of packets with bad checksum in scan [scans]',&
    & err,i1=x%NumberOfBadChecksums  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='NumberOfDiscardedPkts'
if(associated(x%NumberOfDiscardedPkts))then
  call write_array_hdf(lun,sname,&
    & 'Number of discarded packets in scan [scans]',&
    & err,i1=x%NumberOfDiscardedPkts  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='QF1_VIIRSIBANDSDR'
if(associated(x%QF1_VIIRSIBANDSDR))then
  call write_array_hdf(lun,sname,&
    & 'I-Band Quality Flag for each pixel [pixels, lines]',&
    & err,i2=x%QF1_VIIRSIBANDSDR  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='QF1_VIIRSMBANDSDR'
if(associated(x%QF1_VIIRSMBANDSDR))then
  call write_array_hdf(lun,sname,&
    & 'M-Band Quality Flag for each pixel [pixels, lines]',&
    & err,i2=x%QF1_VIIRSMBANDSDR  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='QF1_VIIRSDNBBANDSDR'
if(associated(x%QF1_VIIRSDNBBANDSDR))then
  call write_array_hdf(lun,sname,&
    & 'DNB-Band Quality Flag for each pixel [pixels, lines]',&
    & err,i2=x%QF1_VIIRSDNBBANDSDR  ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='QF2_SCAN_SDR'
if(associated(x%QF2_SCAN_SDR))then
  call write_array_hdf(lun,sname,&
    & 'Quality Flag for each Scan (indicates general SDR information)  [scans]',&
    & err,i1=x%QF2_SCAN_SDR  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='QF3_SCAN_RDR'
if(associated(x%QF3_SCAN_RDR))then
  call write_array_hdf(lun,sname,&
    & 'Quality Flag for each Scan (indicates general RDR information)  [scans]',&
    & err,i1=x%QF3_SCAN_RDR  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='QF4_SCAN_SDR'
if(associated(x%QF4_SCAN_SDR))then
  call write_array_hdf(lun,sname,&
    & 'Reduced Quality Indication [lines]',&
    & err,i1=x%QF4_SCAN_SDR  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='QF5_GRAN_BADDETECTOR'
if(associated(x%QF5_GRAN_BADDETECTOR))then
  call write_array_hdf(lun,sname,&
    & 'Quality Flag – Bad detector [granules]',&
    & err,i1=x%QF5_GRAN_BADDETECTOR  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='RadianceFactors'
if(associated(x%RadianceFactors))then
  call write_array_hdf(lun,sname,&
    & 'Radiance scale and offset: first scale,second offset',&
    & err,r1=x%RadianceFactors  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif


sname='BrightnessTemperatureFactors'
if(associated(x%BrightnessTemperatureFactors))then
  call write_array_hdf(lun,sname,&
    & 'Brightness Temperature sc/offs: first scale, second offset',&
    & err,r1=x%BrightnessTemperatureFactors  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='Reflectances'
if(associated(x%Reflectances))then
  call write_array_hdf(lun,sname,&
    & 'Calibrated TOA Relectance for each VIIRS pixel REAL values',&
    & err,r2=x%Reflectances  ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

err=0
CATCH
end subroutine

#endif

end module
