!
! Automatically generated by ./mod_rw.pl version 1.2
! Do not edit
!
! Name: $Id: viirs_sdr_data_mem.F90
!
! Purpose: viirs sdr data init structure,free pointers,copy structures module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!
module viirs_sdr_data_mem
#include "aapp_throw.h"
use viirs_sdr_data_def
implicit none
private
public :: viirs_sdr_data_free
public :: viirs_sdr_data_init
public :: viirs_sdr_data_copy
public :: viirs_sdr_data_paste


contains

subroutine viirs_sdr_data_free(x,err)
type(viirs_sdr_data),intent(inout)::x
integer,intent(out)::err
character(len=nlen)::sname
TRY
err = 0

sname='Radiance'
if(associated(x%Radiance))then
  deallocate(x%Radiance,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%Radiance)
endif
sname='Reflectance'
if(associated(x%Reflectance))then
  deallocate(x%Reflectance,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%Reflectance)
endif
sname='BrightnessTemperature'
if(associated(x%BrightnessTemperature))then
  deallocate(x%BrightnessTemperature,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%BrightnessTemperature)
endif
sname='ModeScan'
if(associated(x%ModeScan))then
  deallocate(x%ModeScan,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%ModeScan)
endif
sname='ModeGran'
if(associated(x%ModeGran))then
  deallocate(x%ModeGran,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%ModeGran)
endif
sname='NumberOfScans'
if(associated(x%NumberOfScans))then
  deallocate(x%NumberOfScans,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%NumberOfScans)
endif
sname='NumberOfMissingPkts'
if(associated(x%NumberOfMissingPkts))then
  deallocate(x%NumberOfMissingPkts,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%NumberOfMissingPkts)
endif
sname='NumberOfBadChecksums'
if(associated(x%NumberOfBadChecksums))then
  deallocate(x%NumberOfBadChecksums,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%NumberOfBadChecksums)
endif
sname='NumberOfDiscardedPkts'
if(associated(x%NumberOfDiscardedPkts))then
  deallocate(x%NumberOfDiscardedPkts,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%NumberOfDiscardedPkts)
endif
sname='QF1_VIIRSIBANDSDR'
if(associated(x%QF1_VIIRSIBANDSDR))then
  deallocate(x%QF1_VIIRSIBANDSDR,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%QF1_VIIRSIBANDSDR)
endif
sname='QF1_VIIRSMBANDSDR'
if(associated(x%QF1_VIIRSMBANDSDR))then
  deallocate(x%QF1_VIIRSMBANDSDR,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%QF1_VIIRSMBANDSDR)
endif
sname='QF1_VIIRSDNBBANDSDR'
if(associated(x%QF1_VIIRSDNBBANDSDR))then
  deallocate(x%QF1_VIIRSDNBBANDSDR,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%QF1_VIIRSDNBBANDSDR)
endif
sname='QF2_SCAN_SDR'
if(associated(x%QF2_SCAN_SDR))then
  deallocate(x%QF2_SCAN_SDR,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%QF2_SCAN_SDR)
endif
sname='QF3_SCAN_RDR'
if(associated(x%QF3_SCAN_RDR))then
  deallocate(x%QF3_SCAN_RDR,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%QF3_SCAN_RDR)
endif
sname='QF4_SCAN_SDR'
if(associated(x%QF4_SCAN_SDR))then
  deallocate(x%QF4_SCAN_SDR,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%QF4_SCAN_SDR)
endif
sname='QF5_GRAN_BADDETECTOR'
if(associated(x%QF5_GRAN_BADDETECTOR))then
  deallocate(x%QF5_GRAN_BADDETECTOR,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%QF5_GRAN_BADDETECTOR)
endif
sname='RadianceFactors'
if(associated(x%RadianceFactors))then
  deallocate(x%RadianceFactors,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%RadianceFactors)
endif
sname='ReflectanceFactors'
if(associated(x%ReflectanceFactors))then
  deallocate(x%ReflectanceFactors,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%ReflectanceFactors)
endif
sname='BrightnessTemperatureFactors'
if(associated(x%BrightnessTemperatureFactors))then
  deallocate(x%BrightnessTemperatureFactors,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%BrightnessTemperatureFactors)
endif
sname='Reflectances'
if(associated(x%Reflectances))then
  deallocate(x%Reflectances,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%Reflectances)
endif
CATCH
end subroutine

subroutine viirs_sdr_data_init(x)
type(viirs_sdr_data),intent(inout)::x

  x%Channel=0
  x%Channel_Name=''
  nullify(x%Radiance)
  nullify(x%Reflectance)
  nullify(x%BrightnessTemperature)
  nullify(x%ModeScan)
  nullify(x%ModeGran)
  nullify(x%NumberOfScans)
  nullify(x%NumberOfMissingPkts)
  nullify(x%NumberOfBadChecksums)
  nullify(x%NumberOfDiscardedPkts)
  nullify(x%QF1_VIIRSIBANDSDR)
  nullify(x%QF1_VIIRSMBANDSDR)
  nullify(x%QF1_VIIRSDNBBANDSDR)
  nullify(x%QF2_SCAN_SDR)
  nullify(x%QF3_SCAN_RDR)
  nullify(x%QF4_SCAN_SDR)
  nullify(x%QF5_GRAN_BADDETECTOR)
  nullify(x%RadianceFactors)
  nullify(x%ReflectanceFactors)
  nullify(x%BrightnessTemperatureFactors)
  nullify(x%Reflectances)
end subroutine

subroutine viirs_sdr_data_copy(x,y,err,data)
type(viirs_sdr_data),intent(inout)::x
type(viirs_sdr_data),intent(in)::y
integer,intent(out)::err
logical, optional :: data
integer::lb(7),ub(7)
logical :: data1

TRY

  data1=.true.
  if(present(data))data1 = data
  
  if(data1)x%Channel=y%Channel
  if(data1)x%Channel_Name=y%Channel_Name
  if(associated(y%Radiance))then
    lb(1:2)=lbound(y%Radiance)
    ub(1:2)=ubound(y%Radiance)
    allocate(x%Radiance(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Radiance")
    if(data1)x%Radiance=y%Radiance
  else
    nullify(x%Radiance)
  endif
  if(associated(y%Reflectance))then
    lb(1:2)=lbound(y%Reflectance)
    ub(1:2)=ubound(y%Reflectance)
    allocate(x%Reflectance(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Reflectance")
    if(data1)x%Reflectance=y%Reflectance
  else
    nullify(x%Reflectance)
  endif
  if(associated(y%BrightnessTemperature))then
    lb(1:2)=lbound(y%BrightnessTemperature)
    ub(1:2)=ubound(y%BrightnessTemperature)
    allocate(x%BrightnessTemperature(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE BrightnessTemperature")
    if(data1)x%BrightnessTemperature=y%BrightnessTemperature
  else
    nullify(x%BrightnessTemperature)
  endif
  if(associated(y%ModeScan))then
    lb(1:1)=lbound(y%ModeScan)
    ub(1:1)=ubound(y%ModeScan)
    allocate(x%ModeScan(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE ModeScan")
    if(data1)x%ModeScan=y%ModeScan
  else
    nullify(x%ModeScan)
  endif
  if(associated(y%ModeGran))then
    lb(1:1)=lbound(y%ModeGran)
    ub(1:1)=ubound(y%ModeGran)
    allocate(x%ModeGran(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE ModeGran")
    if(data1)x%ModeGran=y%ModeGran
  else
    nullify(x%ModeGran)
  endif
  if(associated(y%NumberOfScans))then
    lb(1:1)=lbound(y%NumberOfScans)
    ub(1:1)=ubound(y%NumberOfScans)
    allocate(x%NumberOfScans(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE NumberOfScans")
    if(data1)x%NumberOfScans=y%NumberOfScans
  else
    nullify(x%NumberOfScans)
  endif
  if(associated(y%NumberOfMissingPkts))then
    lb(1:1)=lbound(y%NumberOfMissingPkts)
    ub(1:1)=ubound(y%NumberOfMissingPkts)
    allocate(x%NumberOfMissingPkts(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE NumberOfMissingPkts")
    if(data1)x%NumberOfMissingPkts=y%NumberOfMissingPkts
  else
    nullify(x%NumberOfMissingPkts)
  endif
  if(associated(y%NumberOfBadChecksums))then
    lb(1:1)=lbound(y%NumberOfBadChecksums)
    ub(1:1)=ubound(y%NumberOfBadChecksums)
    allocate(x%NumberOfBadChecksums(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE NumberOfBadChecksums")
    if(data1)x%NumberOfBadChecksums=y%NumberOfBadChecksums
  else
    nullify(x%NumberOfBadChecksums)
  endif
  if(associated(y%NumberOfDiscardedPkts))then
    lb(1:1)=lbound(y%NumberOfDiscardedPkts)
    ub(1:1)=ubound(y%NumberOfDiscardedPkts)
    allocate(x%NumberOfDiscardedPkts(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE NumberOfDiscardedPkts")
    if(data1)x%NumberOfDiscardedPkts=y%NumberOfDiscardedPkts
  else
    nullify(x%NumberOfDiscardedPkts)
  endif
  if(associated(y%QF1_VIIRSIBANDSDR))then
    lb(1:2)=lbound(y%QF1_VIIRSIBANDSDR)
    ub(1:2)=ubound(y%QF1_VIIRSIBANDSDR)
    allocate(x%QF1_VIIRSIBANDSDR(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF1_VIIRSIBANDSDR")
    if(data1)x%QF1_VIIRSIBANDSDR=y%QF1_VIIRSIBANDSDR
  else
    nullify(x%QF1_VIIRSIBANDSDR)
  endif
  if(associated(y%QF1_VIIRSMBANDSDR))then
    lb(1:2)=lbound(y%QF1_VIIRSMBANDSDR)
    ub(1:2)=ubound(y%QF1_VIIRSMBANDSDR)
    allocate(x%QF1_VIIRSMBANDSDR(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF1_VIIRSMBANDSDR")
    if(data1)x%QF1_VIIRSMBANDSDR=y%QF1_VIIRSMBANDSDR
  else
    nullify(x%QF1_VIIRSMBANDSDR)
  endif
  if(associated(y%QF1_VIIRSDNBBANDSDR))then
    lb(1:2)=lbound(y%QF1_VIIRSDNBBANDSDR)
    ub(1:2)=ubound(y%QF1_VIIRSDNBBANDSDR)
    allocate(x%QF1_VIIRSDNBBANDSDR(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF1_VIIRSDNBBANDSDR")
    if(data1)x%QF1_VIIRSDNBBANDSDR=y%QF1_VIIRSDNBBANDSDR
  else
    nullify(x%QF1_VIIRSDNBBANDSDR)
  endif
  if(associated(y%QF2_SCAN_SDR))then
    lb(1:1)=lbound(y%QF2_SCAN_SDR)
    ub(1:1)=ubound(y%QF2_SCAN_SDR)
    allocate(x%QF2_SCAN_SDR(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF2_SCAN_SDR")
    if(data1)x%QF2_SCAN_SDR=y%QF2_SCAN_SDR
  else
    nullify(x%QF2_SCAN_SDR)
  endif
  if(associated(y%QF3_SCAN_RDR))then
    lb(1:1)=lbound(y%QF3_SCAN_RDR)
    ub(1:1)=ubound(y%QF3_SCAN_RDR)
    allocate(x%QF3_SCAN_RDR(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF3_SCAN_RDR")
    if(data1)x%QF3_SCAN_RDR=y%QF3_SCAN_RDR
  else
    nullify(x%QF3_SCAN_RDR)
  endif
  if(associated(y%QF4_SCAN_SDR))then
    lb(1:1)=lbound(y%QF4_SCAN_SDR)
    ub(1:1)=ubound(y%QF4_SCAN_SDR)
    allocate(x%QF4_SCAN_SDR(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF4_SCAN_SDR")
    if(data1)x%QF4_SCAN_SDR=y%QF4_SCAN_SDR
  else
    nullify(x%QF4_SCAN_SDR)
  endif
  if(associated(y%QF5_GRAN_BADDETECTOR))then
    lb(1:1)=lbound(y%QF5_GRAN_BADDETECTOR)
    ub(1:1)=ubound(y%QF5_GRAN_BADDETECTOR)
    allocate(x%QF5_GRAN_BADDETECTOR(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF5_GRAN_BADDETECTOR")
    if(data1)x%QF5_GRAN_BADDETECTOR=y%QF5_GRAN_BADDETECTOR
  else
    nullify(x%QF5_GRAN_BADDETECTOR)
  endif
  if(associated(y%RadianceFactors))then
    lb(1:1)=lbound(y%RadianceFactors)
    ub(1:1)=ubound(y%RadianceFactors)
    allocate(x%RadianceFactors(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE RadianceFactors")
    if(data1)x%RadianceFactors=y%RadianceFactors
  else
    nullify(x%RadianceFactors)
  endif
  if(associated(y%ReflectanceFactors))then
    lb(1:1)=lbound(y%ReflectanceFactors)
    ub(1:1)=ubound(y%ReflectanceFactors)
    allocate(x%ReflectanceFactors(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE ReflectanceFactors")
    if(data1)x%ReflectanceFactors=y%ReflectanceFactors
  else
    nullify(x%ReflectanceFactors)
  endif
  if(associated(y%BrightnessTemperatureFactors))then
    lb(1:1)=lbound(y%BrightnessTemperatureFactors)
    ub(1:1)=ubound(y%BrightnessTemperatureFactors)
    allocate(x%BrightnessTemperatureFactors(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE BrightnessTemperatureFactors")
    if(data1)x%BrightnessTemperatureFactors=y%BrightnessTemperatureFactors
  else
    nullify(x%BrightnessTemperatureFactors)
  endif
  if(associated(y%Reflectances))then
    lb(1:2)=lbound(y%Reflectances)
    ub(1:2)=ubound(y%Reflectances)
    allocate(x%Reflectances(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Reflectances")
    if(data1)x%Reflectances=y%Reflectances
  else
    nullify(x%Reflectances)
  endif
CATCH
end subroutine

subroutine viirs_sdr_data_paste(x,y,z,err,data)
! only pointer arrays are considered
! for any other type the Y value is passed to X
! paste the last dimension of array
type(viirs_sdr_data),intent(inout)::x
type(viirs_sdr_data),intent(in)::y
type(viirs_sdr_data),intent(in)::z
integer,intent(out)::err
logical, optional :: data
integer::lby(7),uby(7)
integer::lbz(7),ubz(7)
integer::lb1(7),ub1(7)
integer::lb2(7),ub2(7)

logical :: data1

TRY

  data1=.true.
  if(present(data))data1 = data
  
  if(data1)x%Channel=y%Channel
  if(data1)x%Channel_Name=y%Channel_Name
  if(associated(y%Radiance) .and. associated(z%Radiance))then
    lby(1:2)=lbound(y%Radiance)
    uby(1:2)=ubound(y%Radiance)

    lbz(1:2)=lbound(z%Radiance)
    ubz(1:2)=ubound(z%Radiance)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%Radiance(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Radiance")
    if(data1) then
      x%Radiance(lb1(1):ub1(1),lb1(2):ub1(2))=y%Radiance
      x%Radiance(lb2(1):ub2(1),lb2(2):ub2(2))=z%Radiance
    endif
  else
    nullify(x%Radiance)
  endif
  if(associated(y%Reflectance) .and. associated(z%Reflectance))then
    lby(1:2)=lbound(y%Reflectance)
    uby(1:2)=ubound(y%Reflectance)

    lbz(1:2)=lbound(z%Reflectance)
    ubz(1:2)=ubound(z%Reflectance)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%Reflectance(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Reflectance")
    if(data1) then
      x%Reflectance(lb1(1):ub1(1),lb1(2):ub1(2))=y%Reflectance
      x%Reflectance(lb2(1):ub2(1),lb2(2):ub2(2))=z%Reflectance
    endif
  else
    nullify(x%Reflectance)
  endif
  if(associated(y%BrightnessTemperature) .and. associated(z%BrightnessTemperature))then
    lby(1:2)=lbound(y%BrightnessTemperature)
    uby(1:2)=ubound(y%BrightnessTemperature)

    lbz(1:2)=lbound(z%BrightnessTemperature)
    ubz(1:2)=ubound(z%BrightnessTemperature)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%BrightnessTemperature(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE BrightnessTemperature")
    if(data1) then
      x%BrightnessTemperature(lb1(1):ub1(1),lb1(2):ub1(2))=y%BrightnessTemperature
      x%BrightnessTemperature(lb2(1):ub2(1),lb2(2):ub2(2))=z%BrightnessTemperature
    endif
  else
    nullify(x%BrightnessTemperature)
  endif
  if(associated(y%ModeScan) .and. associated(z%ModeScan))then
    lby(1:1)=lbound(y%ModeScan)
    uby(1:1)=ubound(y%ModeScan)

    lbz(1:1)=lbound(z%ModeScan)
    ubz(1:1)=ubound(z%ModeScan)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%ModeScan(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE ModeScan")
    if(data1) then
      x%ModeScan(lb1(1):ub1(1))=y%ModeScan
      x%ModeScan(lb2(1):ub2(1))=z%ModeScan
    endif
  else
    nullify(x%ModeScan)
  endif
  if(associated(y%ModeGran) .and. associated(z%ModeGran))then
    lby(1:1)=lbound(y%ModeGran)
    uby(1:1)=ubound(y%ModeGran)

    lbz(1:1)=lbound(z%ModeGran)
    ubz(1:1)=ubound(z%ModeGran)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%ModeGran(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE ModeGran")
    if(data1) then
      x%ModeGran(lb1(1):ub1(1))=y%ModeGran
      x%ModeGran(lb2(1):ub2(1))=z%ModeGran
    endif
  else
    nullify(x%ModeGran)
  endif
  if(associated(y%NumberOfScans) .and. associated(z%NumberOfScans))then
    lby(1:1)=lbound(y%NumberOfScans)
    uby(1:1)=ubound(y%NumberOfScans)

    lbz(1:1)=lbound(z%NumberOfScans)
    ubz(1:1)=ubound(z%NumberOfScans)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%NumberOfScans(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE NumberOfScans")
    if(data1) then
      x%NumberOfScans(lb1(1):ub1(1))=y%NumberOfScans
      x%NumberOfScans(lb2(1):ub2(1))=z%NumberOfScans
    endif
  else
    nullify(x%NumberOfScans)
  endif
  if(associated(y%NumberOfMissingPkts) .and. associated(z%NumberOfMissingPkts))then
    lby(1:1)=lbound(y%NumberOfMissingPkts)
    uby(1:1)=ubound(y%NumberOfMissingPkts)

    lbz(1:1)=lbound(z%NumberOfMissingPkts)
    ubz(1:1)=ubound(z%NumberOfMissingPkts)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%NumberOfMissingPkts(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE NumberOfMissingPkts")
    if(data1) then
      x%NumberOfMissingPkts(lb1(1):ub1(1))=y%NumberOfMissingPkts
      x%NumberOfMissingPkts(lb2(1):ub2(1))=z%NumberOfMissingPkts
    endif
  else
    nullify(x%NumberOfMissingPkts)
  endif
  if(associated(y%NumberOfBadChecksums) .and. associated(z%NumberOfBadChecksums))then
    lby(1:1)=lbound(y%NumberOfBadChecksums)
    uby(1:1)=ubound(y%NumberOfBadChecksums)

    lbz(1:1)=lbound(z%NumberOfBadChecksums)
    ubz(1:1)=ubound(z%NumberOfBadChecksums)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%NumberOfBadChecksums(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE NumberOfBadChecksums")
    if(data1) then
      x%NumberOfBadChecksums(lb1(1):ub1(1))=y%NumberOfBadChecksums
      x%NumberOfBadChecksums(lb2(1):ub2(1))=z%NumberOfBadChecksums
    endif
  else
    nullify(x%NumberOfBadChecksums)
  endif
  if(associated(y%NumberOfDiscardedPkts) .and. associated(z%NumberOfDiscardedPkts))then
    lby(1:1)=lbound(y%NumberOfDiscardedPkts)
    uby(1:1)=ubound(y%NumberOfDiscardedPkts)

    lbz(1:1)=lbound(z%NumberOfDiscardedPkts)
    ubz(1:1)=ubound(z%NumberOfDiscardedPkts)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%NumberOfDiscardedPkts(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE NumberOfDiscardedPkts")
    if(data1) then
      x%NumberOfDiscardedPkts(lb1(1):ub1(1))=y%NumberOfDiscardedPkts
      x%NumberOfDiscardedPkts(lb2(1):ub2(1))=z%NumberOfDiscardedPkts
    endif
  else
    nullify(x%NumberOfDiscardedPkts)
  endif
  if(associated(y%QF1_VIIRSIBANDSDR) .and. associated(z%QF1_VIIRSIBANDSDR))then
    lby(1:2)=lbound(y%QF1_VIIRSIBANDSDR)
    uby(1:2)=ubound(y%QF1_VIIRSIBANDSDR)

    lbz(1:2)=lbound(z%QF1_VIIRSIBANDSDR)
    ubz(1:2)=ubound(z%QF1_VIIRSIBANDSDR)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%QF1_VIIRSIBANDSDR(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF1_VIIRSIBANDSDR")
    if(data1) then
      x%QF1_VIIRSIBANDSDR(lb1(1):ub1(1),lb1(2):ub1(2))=y%QF1_VIIRSIBANDSDR
      x%QF1_VIIRSIBANDSDR(lb2(1):ub2(1),lb2(2):ub2(2))=z%QF1_VIIRSIBANDSDR
    endif
  else
    nullify(x%QF1_VIIRSIBANDSDR)
  endif
  if(associated(y%QF1_VIIRSMBANDSDR) .and. associated(z%QF1_VIIRSMBANDSDR))then
    lby(1:2)=lbound(y%QF1_VIIRSMBANDSDR)
    uby(1:2)=ubound(y%QF1_VIIRSMBANDSDR)

    lbz(1:2)=lbound(z%QF1_VIIRSMBANDSDR)
    ubz(1:2)=ubound(z%QF1_VIIRSMBANDSDR)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%QF1_VIIRSMBANDSDR(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF1_VIIRSMBANDSDR")
    if(data1) then
      x%QF1_VIIRSMBANDSDR(lb1(1):ub1(1),lb1(2):ub1(2))=y%QF1_VIIRSMBANDSDR
      x%QF1_VIIRSMBANDSDR(lb2(1):ub2(1),lb2(2):ub2(2))=z%QF1_VIIRSMBANDSDR
    endif
  else
    nullify(x%QF1_VIIRSMBANDSDR)
  endif
  if(associated(y%QF1_VIIRSDNBBANDSDR) .and. associated(z%QF1_VIIRSDNBBANDSDR))then
    lby(1:2)=lbound(y%QF1_VIIRSDNBBANDSDR)
    uby(1:2)=ubound(y%QF1_VIIRSDNBBANDSDR)

    lbz(1:2)=lbound(z%QF1_VIIRSDNBBANDSDR)
    ubz(1:2)=ubound(z%QF1_VIIRSDNBBANDSDR)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%QF1_VIIRSDNBBANDSDR(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF1_VIIRSDNBBANDSDR")
    if(data1) then
      x%QF1_VIIRSDNBBANDSDR(lb1(1):ub1(1),lb1(2):ub1(2))=y%QF1_VIIRSDNBBANDSDR
      x%QF1_VIIRSDNBBANDSDR(lb2(1):ub2(1),lb2(2):ub2(2))=z%QF1_VIIRSDNBBANDSDR
    endif
  else
    nullify(x%QF1_VIIRSDNBBANDSDR)
  endif
  if(associated(y%QF2_SCAN_SDR) .and. associated(z%QF2_SCAN_SDR))then
    lby(1:1)=lbound(y%QF2_SCAN_SDR)
    uby(1:1)=ubound(y%QF2_SCAN_SDR)

    lbz(1:1)=lbound(z%QF2_SCAN_SDR)
    ubz(1:1)=ubound(z%QF2_SCAN_SDR)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%QF2_SCAN_SDR(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF2_SCAN_SDR")
    if(data1) then
      x%QF2_SCAN_SDR(lb1(1):ub1(1))=y%QF2_SCAN_SDR
      x%QF2_SCAN_SDR(lb2(1):ub2(1))=z%QF2_SCAN_SDR
    endif
  else
    nullify(x%QF2_SCAN_SDR)
  endif
  if(associated(y%QF3_SCAN_RDR) .and. associated(z%QF3_SCAN_RDR))then
    lby(1:1)=lbound(y%QF3_SCAN_RDR)
    uby(1:1)=ubound(y%QF3_SCAN_RDR)

    lbz(1:1)=lbound(z%QF3_SCAN_RDR)
    ubz(1:1)=ubound(z%QF3_SCAN_RDR)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%QF3_SCAN_RDR(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF3_SCAN_RDR")
    if(data1) then
      x%QF3_SCAN_RDR(lb1(1):ub1(1))=y%QF3_SCAN_RDR
      x%QF3_SCAN_RDR(lb2(1):ub2(1))=z%QF3_SCAN_RDR
    endif
  else
    nullify(x%QF3_SCAN_RDR)
  endif
  if(associated(y%QF4_SCAN_SDR) .and. associated(z%QF4_SCAN_SDR))then
    lby(1:1)=lbound(y%QF4_SCAN_SDR)
    uby(1:1)=ubound(y%QF4_SCAN_SDR)

    lbz(1:1)=lbound(z%QF4_SCAN_SDR)
    ubz(1:1)=ubound(z%QF4_SCAN_SDR)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%QF4_SCAN_SDR(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF4_SCAN_SDR")
    if(data1) then
      x%QF4_SCAN_SDR(lb1(1):ub1(1))=y%QF4_SCAN_SDR
      x%QF4_SCAN_SDR(lb2(1):ub2(1))=z%QF4_SCAN_SDR
    endif
  else
    nullify(x%QF4_SCAN_SDR)
  endif
  if(associated(y%QF5_GRAN_BADDETECTOR) .and. associated(z%QF5_GRAN_BADDETECTOR))then
    lby(1:1)=lbound(y%QF5_GRAN_BADDETECTOR)
    uby(1:1)=ubound(y%QF5_GRAN_BADDETECTOR)

    lbz(1:1)=lbound(z%QF5_GRAN_BADDETECTOR)
    ubz(1:1)=ubound(z%QF5_GRAN_BADDETECTOR)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%QF5_GRAN_BADDETECTOR(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE QF5_GRAN_BADDETECTOR")
    if(data1) then
      x%QF5_GRAN_BADDETECTOR(lb1(1):ub1(1))=y%QF5_GRAN_BADDETECTOR
      x%QF5_GRAN_BADDETECTOR(lb2(1):ub2(1))=z%QF5_GRAN_BADDETECTOR
    endif
  else
    nullify(x%QF5_GRAN_BADDETECTOR)
  endif
  if(associated(y%RadianceFactors) .and. associated(z%RadianceFactors))then
    lby(1:1)=lbound(y%RadianceFactors)
    uby(1:1)=ubound(y%RadianceFactors)

    lbz(1:1)=lbound(z%RadianceFactors)
    ubz(1:1)=ubound(z%RadianceFactors)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%RadianceFactors(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE RadianceFactors")
    if(data1) then
      x%RadianceFactors(lb1(1):ub1(1))=y%RadianceFactors
      x%RadianceFactors(lb2(1):ub2(1))=z%RadianceFactors
    endif
  else
    nullify(x%RadianceFactors)
  endif
  if(associated(y%ReflectanceFactors) .and. associated(z%ReflectanceFactors))then
    lby(1:1)=lbound(y%ReflectanceFactors)
    uby(1:1)=ubound(y%ReflectanceFactors)

    lbz(1:1)=lbound(z%ReflectanceFactors)
    ubz(1:1)=ubound(z%ReflectanceFactors)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%ReflectanceFactors(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE ReflectanceFactors")
    if(data1) then
      x%ReflectanceFactors(lb1(1):ub1(1))=y%ReflectanceFactors
      x%ReflectanceFactors(lb2(1):ub2(1))=z%ReflectanceFactors
    endif
  else
    nullify(x%ReflectanceFactors)
  endif
  if(associated(y%BrightnessTemperatureFactors) .and. associated(z%BrightnessTemperatureFactors))then
    lby(1:1)=lbound(y%BrightnessTemperatureFactors)
    uby(1:1)=ubound(y%BrightnessTemperatureFactors)

    lbz(1:1)=lbound(z%BrightnessTemperatureFactors)
    ubz(1:1)=ubound(z%BrightnessTemperatureFactors)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%BrightnessTemperatureFactors(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE BrightnessTemperatureFactors")
    if(data1) then
      x%BrightnessTemperatureFactors(lb1(1):ub1(1))=y%BrightnessTemperatureFactors
      x%BrightnessTemperatureFactors(lb2(1):ub2(1))=z%BrightnessTemperatureFactors
    endif
  else
    nullify(x%BrightnessTemperatureFactors)
  endif
  if(associated(y%Reflectances) .and. associated(z%Reflectances))then
    lby(1:2)=lbound(y%Reflectances)
    uby(1:2)=ubound(y%Reflectances)

    lbz(1:2)=lbound(z%Reflectances)
    ubz(1:2)=ubound(z%Reflectances)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%Reflectances(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Reflectances")
    if(data1) then
      x%Reflectances(lb1(1):ub1(1),lb1(2):ub1(2))=y%Reflectances
      x%Reflectances(lb2(1):ub2(1),lb2(2):ub2(2))=z%Reflectances
    endif
  else
    nullify(x%Reflectances)
  endif
CATCH
end subroutine

end module
