! Name: $Id: viirs_sdr_mod.F90
!
! Purpose: Definition for multi chanel/multi granule VIIRS SDR files in HDF5 format
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   05/2012       Initial version (Pascal Brunel)
!   1.1   10/12/2012    Release for AAPP Pascale Roquet)
!
!
module viirs_sdr_def
Use jpss_meta_root_def
Use jpss_meta_aggregate_def
Use jpss_meta_granule_def
Use jpss_meta_dataproducts_def
Use viirs_sdr_data_def
Use viirs_sdr_geo_def

implicit none
private
public :: viirs_sdr

type viirs_sdr
  TYPE(jpss_meta_root)::root_att ! Root Attributes
  TYPE(jpss_meta_aggregate)::agg_att ! Aggregate Attributes
  TYPE(jpss_meta_granule),pointer::gran0_att(:)! Gran_0 Attributes (channels)
  TYPE(jpss_meta_dataproducts),pointer::datap_att(:) ! Dataproducts Attributes (channels)
  TYPE(viirs_sdr_data),pointer::band(:) ! I/M/DN-Band values (channels)
  TYPE(viirs_sdr_geo)::geo ! GeoLocation
end type

end module
