!
! Automatically generated by ./mod_rw.pl version 1.2
! Do not edit
!
! Name: $Id: viirs_sdr_geo_def.F90
!
! Purpose: viirs sdr geo fortan structure definition module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!  

module viirs_sdr_geo_def

implicit none
private
integer, parameter :: nlen = 256   ! name length
public :: nlen
public :: viirs_sdr_geo

type viirs_sdr_geo
  integer::StartDay ! Day of month of first scan (UTC), calculated
  integer::StartMonth ! Month of year of first scan (UTC), calculated
  integer::StartYear ! Year of first scan (UTC), calculated
  integer::EndDay ! Day of month of last (effective) scan (UTC), calculated
  integer::EndMonth ! Month of year of last (effective) scan (UTC), calculated
  integer::EndYear ! Year of first last (effective) scan (UTC), calculated
  integer*8,pointer,dimension(:)::UTCJulianDay ! Starting Date of each scan in UTC ( julian day since 1/1/1950) , calculated
  integer*8,pointer,dimension(:)::UTC ! Starting Time of each scan in UTC (millisecond of day) , calculated
  integer*8,pointer,dimension(:)::StartTime ! Starting Time of each scan in IET (1/1/1958) microsecond
  integer*8,pointer,dimension(:)::MidTime ! Mid-Time of each scan in IET (1/1/1958) microsecond
  real,pointer,dimension(:,:)::Latitude ! Latitude of each pixel (positive North) degree 
    !    size is [pixels, lines] for latitude and following arrays
  real,pointer,dimension(:,:)::Longitude ! Longitude of each pixel (positive East) degree
  real,pointer,dimension(:,:)::SolarZenithAngle ! Zenith angle of sun at each pixel position degree
  real,pointer,dimension(:,:)::SolarAzimuthAngle ! Azimuth angle of sun (clockwise positive from North) at each pixel position degree 
  real,pointer,dimension(:,:)::SatelliteZenithAngle ! Zenith angle to Satellite at each pixel position degree 
  real,pointer,dimension(:,:)::SatelliteAzimuthAngle ! Azimuth angle (clockwise positive from North) to Satellite at each pixel position degree 
  real,pointer,dimension(:,:)::LunarZenithAngle ! Zenith angle of moon at each pixel position degree 
  real,pointer,dimension(:,:)::LunarAzimuthAngle ! Azimuth angle of moon (clockwise positive from North) at each pixel position degree 
  real,pointer,dimension(:,:)::Height ! Ellipsoid-Geoid separation meter 
  real,pointer,dimension(:,:)::SatelliteRange ! Line of sight distance from the ellipsoid intersection to the satellite meter 
  real,pointer,dimension(:,:)::SCPosition ! Spacecraft position in ECR Coordinates (X, Y, Z) at the mid-time of scan meter 
    !  [3, scans]
  real,pointer,dimension(:,:)::SCVelocity ! Spacecraft velocity in ECR Coordinates (dx/dt, dy/dt, dz/dt) at the mid-time of scan m/s
    !  [3, scans]
  real,pointer,dimension(:,:)::SCAttitude ! Spacecraft attitude with respect to Geodetic Ref Frame  (roll, pitch, yaw) arcsecond
    !  [3, scans]
  real,pointer,dimension(:)::SCSolarZenithAngle ! The angle from the normal vector of the Solar Diffuser to the solar vector (degree)
    !  [scans]
  real,pointer,dimension(:)::SCSolarAzimuthAngle ! The angle from the Solar Diffuser..... (observer looking toward the SD surface) (degree)
    !  [scans]
  real,pointer,dimension(:)::MoonPhaseAngle ! Angle between ray vector to moon from earth and ray vector of satellitre to earth (degree)
    !  [granules]
  real,pointer,dimension(:)::MoonIllumFraction ! Fraction of the moon illuminated (expressed as percent) [granules]
  integer,pointer,dimension(:)::ModeScan ! The VIIRS operational mode, reported at the scan level
  integer,pointer,dimension(:)::ModeGran ! The VIIRS operational mode, reported at the granule level
  integer,pointer,dimension(:)::NumberOfScans ! Actual number of VIIRS scans that were used to create this granule
  integer,pointer,dimension(:)::QF1_SCAN_VIIRSSDRGEO ! Quality flag for each scan
  integer,pointer,dimension(:,:)::QF2_VIIRSSDRGEO ! Quality Flag for each pixel [pixels, lines]
end type

end module
