!
! Automatically generated by ./mod_rw.pl  version 1.2
! Do not edit
! Name: $Id: viirs_sdr_geo_io.F90 
!
! Purpose:  viirs sdr geo Fortran I/O module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   3/12/2012  Initial version (Pascal Brunel) 
!
module viirs_sdr_geo_io

#ifdef HAS_LIBHDF5

#include "aapp_throw.h"
!use rttov_print_mod
use aapp_hdf_mod
use viirs_sdr_geo_def
use viirs_sdr_geo_mem
use hdf5
implicit none
private
public :: viirs_sdr_geo_rh
public :: viirs_sdr_geo_wh
public :: viirs_sdr_geo_writea


contains


subroutine viirs_sdr_geo_writea(x,lun,err)
type(viirs_sdr_geo),intent(in)::x
integer,intent(in)::lun
integer,intent(out)::err
integer::lb(7),ub(7)
character(len=nlen)::sname

TRY
sname='StartDay'
write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Day of month of first scan (UTC), calculated'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("UNITS = ",A)',iostat=err)''
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_integer(lun,'(10000(I2))',a0=x%StartDay)
!write(lun,err=999)x%StartDay

sname='StartMonth'
write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Month of year of first scan (UTC), calculated'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("UNITS = ",A)',iostat=err)''
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_integer(lun,'(10000(I2))',a0=x%StartMonth)
!write(lun,err=999)x%StartMonth

sname='StartYear'
write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Year of first scan (UTC), calculated'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("UNITS = ",A)',iostat=err)''
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_integer(lun,'(10000(I4))',a0=x%StartYear)
!write(lun,err=999)x%StartYear

sname='EndDay'
write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Day of month of last (effective) scan (UTC), calculated'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("UNITS = ",A)',iostat=err)''
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_integer(lun,'(10000(I2))',a0=x%EndDay)
!write(lun,err=999)x%EndDay

sname='EndMonth'
write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Month of year of last (effective) scan (UTC), calculated'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("UNITS = ",A)',iostat=err)''
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_integer(lun,'(10000(I2))',a0=x%EndMonth)
!write(lun,err=999)x%EndMonth

sname='EndYear'
write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("COMMENT = ",A)',err=999) &
 & 'Year of first last (effective) scan (UTC), calculated'
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
write(lun,'("UNITS = ",A)',iostat=err)''
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
call print_array_integer(lun,'(10000(I4))',a0=x%EndYear)
!write(lun,err=999)x%EndYear

sname='UTCJulianDay'
if(associated(x%UTCJulianDay))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Starting Date of each scan in UTC ( julian day since 1/1/1950) , calculated'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%UTCJulianDay), &
    & ubound(x%UTCJulianDay)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_long(lun,'(10000(I18))',a1=x%UTCJulianDay)
! write(lun,*,err=999)x%UTCJulianDay
endif

sname='UTC'
if(associated(x%UTC))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Starting Time of each scan in UTC (millisecond of day) , calculated'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%UTC), &
    & ubound(x%UTC)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_long(lun,'(10000(I18))',a1=x%UTC)
! write(lun,*,err=999)x%UTC
endif

sname='StartTime'
if(associated(x%StartTime))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Starting Time of each scan in IET (1/1/1958) microsecond'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%StartTime), &
    & ubound(x%StartTime)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_long(lun,'(10000(I18))',a1=x%StartTime)
! write(lun,*,err=999)x%StartTime
endif

sname='MidTime'
if(associated(x%MidTime))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Mid-Time of each scan in IET (1/1/1958) microsecond'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%MidTime), &
    & ubound(x%MidTime)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_long(lun,'(10000(I18))',a1=x%MidTime)
! write(lun,*,err=999)x%MidTime
endif

sname='Latitude'
if(associated(x%Latitude))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Latitude of each pixel (positive North) degree '
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%Latitude), &
    & ubound(x%Latitude)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%Latitude)
! write(lun,*,err=999)x%Latitude
endif

sname='Longitude'
if(associated(x%Longitude))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Longitude of each pixel (positive East) degree'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%Longitude), &
    & ubound(x%Longitude)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%Longitude)
! write(lun,*,err=999)x%Longitude
endif

sname='SolarZenithAngle'
if(associated(x%SolarZenithAngle))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Zenith angle of sun at each pixel position degree'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%SolarZenithAngle), &
    & ubound(x%SolarZenithAngle)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%SolarZenithAngle)
! write(lun,*,err=999)x%SolarZenithAngle
endif

sname='SolarAzimuthAngle'
if(associated(x%SolarAzimuthAngle))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Azimuth angle of sun (clockwise positive from North) at each pixel position degree '
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%SolarAzimuthAngle), &
    & ubound(x%SolarAzimuthAngle)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%SolarAzimuthAngle)
! write(lun,*,err=999)x%SolarAzimuthAngle
endif

sname='SatelliteZenithAngle'
if(associated(x%SatelliteZenithAngle))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Zenith angle to Satellite at each pixel position degree '
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%SatelliteZenithAngle), &
    & ubound(x%SatelliteZenithAngle)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%SatelliteZenithAngle)
! write(lun,*,err=999)x%SatelliteZenithAngle
endif

sname='SatelliteAzimuthAngle'
if(associated(x%SatelliteAzimuthAngle))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Azimuth angle (clockwise positive from North) to Satellite at each pixel position degree '
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%SatelliteAzimuthAngle), &
    & ubound(x%SatelliteAzimuthAngle)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%SatelliteAzimuthAngle)
! write(lun,*,err=999)x%SatelliteAzimuthAngle
endif

sname='LunarZenithAngle'
if(associated(x%LunarZenithAngle))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Zenith angle of moon at each pixel position degree '
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%LunarZenithAngle), &
    & ubound(x%LunarZenithAngle)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%LunarZenithAngle)
! write(lun,*,err=999)x%LunarZenithAngle
endif

sname='LunarAzimuthAngle'
if(associated(x%LunarAzimuthAngle))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Azimuth angle of moon (clockwise positive from North) at each pixel position degree '
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%LunarAzimuthAngle), &
    & ubound(x%LunarAzimuthAngle)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%LunarAzimuthAngle)
! write(lun,*,err=999)x%LunarAzimuthAngle
endif

sname='Height'
if(associated(x%Height))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Ellipsoid-Geoid separation meter '
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%Height), &
    & ubound(x%Height)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%Height)
! write(lun,*,err=999)x%Height
endif

sname='SatelliteRange'
if(associated(x%SatelliteRange))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Line of sight distance from the ellipsoid intersection to the satellite meter '
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%SatelliteRange), &
    & ubound(x%SatelliteRange)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%SatelliteRange)
! write(lun,*,err=999)x%SatelliteRange
endif

sname='SCPosition'
if(associated(x%SCPosition))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Spacecraft position in ECR Coordinates (X, Y, Z) at the mid-time of scan meter '
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%SCPosition), &
    & ubound(x%SCPosition)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%SCPosition)
! write(lun,*,err=999)x%SCPosition
endif

sname='SCVelocity'
if(associated(x%SCVelocity))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Spacecraft velocity in ECR Coordinates (dx/dt, dy/dt, dz/dt) at the mid-time of scan m/s'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%SCVelocity), &
    & ubound(x%SCVelocity)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%SCVelocity)
! write(lun,*,err=999)x%SCVelocity
endif

sname='SCAttitude'
if(associated(x%SCAttitude))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Spacecraft attitude with respect to Geodetic Ref Frame  (roll, pitch, yaw) arcsecond'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%SCAttitude), &
    & ubound(x%SCAttitude)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a2=x%SCAttitude)
! write(lun,*,err=999)x%SCAttitude
endif

sname='SCSolarZenithAngle'
if(associated(x%SCSolarZenithAngle))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'The angle from the normal vector of the Solar Diffuser to the solar vector (degree)'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%SCSolarZenithAngle), &
    & ubound(x%SCSolarZenithAngle)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a1=x%SCSolarZenithAngle)
! write(lun,*,err=999)x%SCSolarZenithAngle
endif

sname='SCSolarAzimuthAngle'
if(associated(x%SCSolarAzimuthAngle))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'The angle from the Solar Diffuser..... (observer looking toward the SD surface) (degree)'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%SCSolarAzimuthAngle), &
    & ubound(x%SCSolarAzimuthAngle)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a1=x%SCSolarAzimuthAngle)
! write(lun,*,err=999)x%SCSolarAzimuthAngle
endif

sname='MoonPhaseAngle'
if(associated(x%MoonPhaseAngle))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Angle between ray vector to moon from earth and ray vector of satellitre to earth (degree)'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%MoonPhaseAngle), &
    & ubound(x%MoonPhaseAngle)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a1=x%MoonPhaseAngle)
! write(lun,*,err=999)x%MoonPhaseAngle
endif

sname='MoonIllumFraction'
if(associated(x%MoonIllumFraction))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Fraction of the moon illuminated (expressed as percent) [granules]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%MoonIllumFraction), &
    & ubound(x%MoonIllumFraction)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_real(lun,'(10000(G16.7E3))',a1=x%MoonIllumFraction)
! write(lun,*,err=999)x%MoonIllumFraction
endif

sname='ModeScan'
if(associated(x%ModeScan))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'The VIIRS operational mode, reported at the scan level'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%ModeScan), &
    & ubound(x%ModeScan)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(I8))',a1=x%ModeScan)
! write(lun,*,err=999)x%ModeScan
endif

sname='ModeGran'
if(associated(x%ModeGran))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'The VIIRS operational mode, reported at the granule level'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%ModeGran), &
    & ubound(x%ModeGran)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(I8))',a1=x%ModeGran)
! write(lun,*,err=999)x%ModeGran
endif

sname='NumberOfScans'
if(associated(x%NumberOfScans))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Actual number of VIIRS scans that were used to create this granule'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%NumberOfScans), &
    & ubound(x%NumberOfScans)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(I8))',a1=x%NumberOfScans)
! write(lun,*,err=999)x%NumberOfScans
endif

sname='QF1_SCAN_VIIRSSDRGEO'
if(associated(x%QF1_SCAN_VIIRSSDRGEO))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Quality flag for each scan'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%QF1_SCAN_VIIRSSDRGEO), &
    & ubound(x%QF1_SCAN_VIIRSSDRGEO)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(Z4))',a1=x%QF1_SCAN_VIIRSSDRGEO)
! write(lun,*,err=999)x%QF1_SCAN_VIIRSSDRGEO
endif

sname='QF2_VIIRSSDRGEO'
if(associated(x%QF2_VIIRSSDRGEO))then
  write(lun,'("SECTION = ",A)',err=999)TRIM(sname)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("COMMENT = ",A)',err=999) &
  & 'Quality Flag for each pixel [pixels, lines]'
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("UNITS = ",A)',iostat=err)''
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  write(lun,'("BOUNDS  = ",14I5)',err=999) &
    & lbound(x%QF2_VIIRSSDRGEO), &
    & ubound(x%QF2_VIIRSSDRGEO)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
  call print_array_integer(lun,'(10000(Z4))',a2=x%QF2_VIIRSSDRGEO)
! write(lun,*,err=999)x%QF2_VIIRSSDRGEO
endif

write(lun,'("SECTION = EOF")',err=999)
THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
err=0
CATCH
end subroutine

subroutine viirs_sdr_geo_rh(x,lun,err)
type(viirs_sdr_geo),intent(out)::x
integer(hid_t),intent(in)::lun
integer,intent(out)::err
character(len=nlen)::sname
logical :: lext
TRY

call viirs_sdr_geo_init(x)









sname='StartTime'
call read_array_hdf(lun,sname,err,pil1=x%StartTime)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='MidTime'
call read_array_hdf(lun,sname,err,pil1=x%MidTime)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='Latitude'
call read_array_hdf(lun,sname,err,pr2=x%Latitude)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='Longitude'
call read_array_hdf(lun,sname,err,pr2=x%Longitude)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='SolarZenithAngle'
call read_array_hdf(lun,sname,err,pr2=x%SolarZenithAngle)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='SolarAzimuthAngle'
call read_array_hdf(lun,sname,err,pr2=x%SolarAzimuthAngle)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='SatelliteZenithAngle'
call read_array_hdf(lun,sname,err,pr2=x%SatelliteZenithAngle)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='SatelliteAzimuthAngle'
call read_array_hdf(lun,sname,err,pr2=x%SatelliteAzimuthAngle)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='LunarZenithAngle'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr2=x%LunarZenithAngle)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='LunarAzimuthAngle'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr2=x%LunarAzimuthAngle)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='Height'
call read_array_hdf(lun,sname,err,pr2=x%Height)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='SatelliteRange'
call read_array_hdf(lun,sname,err,pr2=x%SatelliteRange)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='SCPosition'
call read_array_hdf(lun,sname,err,pr2=x%SCPosition)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='SCVelocity'
call read_array_hdf(lun,sname,err,pr2=x%SCVelocity)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='SCAttitude'
call read_array_hdf(lun,sname,err,pr2=x%SCAttitude)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='SCSolarZenithAngle'
call read_array_hdf(lun,sname,err,pr1=x%SCSolarZenithAngle)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='SCSolarAzimuthAngle'
call read_array_hdf(lun,sname,err,pr1=x%SCSolarAzimuthAngle)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='MoonPhaseAngle'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr1=x%MoonPhaseAngle)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='MoonIllumFraction'
call h5lexists_f( lun, sname, lext, err )
if( lext ) then
call read_array_hdf(lun,sname,err,pr1=x%MoonIllumFraction)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))
endif

sname='ModeScan'
call read_array_hdf(lun,sname,err,pi1=x%ModeScan)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='ModeGran'
call read_array_hdf(lun,sname,err,pi1=x%ModeGran)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='NumberOfScans'
call read_array_hdf(lun,sname,err,pi1=x%NumberOfScans)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='QF1_SCAN_VIIRSSDRGEO'
call read_array_hdf(lun,sname,err,pi1=x%QF1_SCAN_VIIRSSDRGEO)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

sname='QF2_VIIRSSDRGEO'
call read_array_hdf(lun,sname,err,pi2=x%QF2_VIIRSSDRGEO)
THROWM(err.ne.0,"CANNOT READ "//trim(sname))

err=0
CATCH
end subroutine

subroutine viirs_sdr_geo_wh(x,lun,err, compress)
type(viirs_sdr_geo),intent(in)::x
integer(hid_t),intent(in)::lun
integer,intent(out)::err
logical,intent(in),optional::compress
character(len=nlen)::sname
TRY








sname='StartTime'
if(associated(x%StartTime))then
  call write_array_hdf(lun,sname,&
    & 'Starting Time of each scan in IET (1/1/1958) microsecond',&
    & err,il1=x%StartTime  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='MidTime'
if(associated(x%MidTime))then
  call write_array_hdf(lun,sname,&
    & 'Mid-Time of each scan in IET (1/1/1958) microsecond',&
    & err,il1=x%MidTime  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='Latitude'
if(associated(x%Latitude))then
  call write_array_hdf(lun,sname,&
    & 'Latitude of each pixel (positive North) degree ',&
    & err,r2=x%Latitude  ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='Longitude'
if(associated(x%Longitude))then
  call write_array_hdf(lun,sname,&
    & 'Longitude of each pixel (positive East) degree',&
    & err,r2=x%Longitude  ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='SolarZenithAngle'
if(associated(x%SolarZenithAngle))then
  call write_array_hdf(lun,sname,&
    & 'Zenith angle of sun at each pixel position degree',&
    & err,r2=x%SolarZenithAngle  ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='SolarAzimuthAngle'
if(associated(x%SolarAzimuthAngle))then
  call write_array_hdf(lun,sname,&
    & 'Azimuth angle of sun (clockwise positive from North) at each pixel position degree ',&
    & err,r2=x%SolarAzimuthAngle  ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='SatelliteZenithAngle'
if(associated(x%SatelliteZenithAngle))then
  call write_array_hdf(lun,sname,&
    & 'Zenith angle to Satellite at each pixel position degree ',&
    & err,r2=x%SatelliteZenithAngle  ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='SatelliteAzimuthAngle'
if(associated(x%SatelliteAzimuthAngle))then
  call write_array_hdf(lun,sname,&
    & 'Azimuth angle (clockwise positive from North) to Satellite at each pixel position degree ',&
    & err,r2=x%SatelliteAzimuthAngle  ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='LunarZenithAngle'
if(associated(x%LunarZenithAngle))then
  call write_array_hdf(lun,sname,&
    & 'Zenith angle of moon at each pixel position degree ',&
    & err,r2=x%LunarZenithAngle  ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='LunarAzimuthAngle'
if(associated(x%LunarAzimuthAngle))then
  call write_array_hdf(lun,sname,&
    & 'Azimuth angle of moon (clockwise positive from North) at each pixel position degree ',&
    & err,r2=x%LunarAzimuthAngle  ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='Height'
if(associated(x%Height))then
  call write_array_hdf(lun,sname,&
    & 'Ellipsoid-Geoid separation meter ',&
    & err,r2=x%Height  ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='SatelliteRange'
if(associated(x%SatelliteRange))then
  call write_array_hdf(lun,sname,&
    & 'Line of sight distance from the ellipsoid intersection to the satellite meter ',&
    & err,r2=x%SatelliteRange  ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='SCPosition'
if(associated(x%SCPosition))then
  call write_array_hdf(lun,sname,&
    & 'Spacecraft position in ECR Coordinates (X, Y, Z) at the mid-time of scan meter ',&
    & err,r2=x%SCPosition  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='SCVelocity'
if(associated(x%SCVelocity))then
  call write_array_hdf(lun,sname,&
    & 'Spacecraft velocity in ECR Coordinates (dx/dt, dy/dt, dz/dt) at the mid-time of scan m/s',&
    & err,r2=x%SCVelocity  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='SCAttitude'
if(associated(x%SCAttitude))then
  call write_array_hdf(lun,sname,&
    & 'Spacecraft attitude with respect to Geodetic Ref Frame  (roll, pitch, yaw) arcsecond',&
    & err,r2=x%SCAttitude  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='SCSolarZenithAngle'
if(associated(x%SCSolarZenithAngle))then
  call write_array_hdf(lun,sname,&
    & 'The angle from the normal vector of the Solar Diffuser to the solar vector (degree)',&
    & err,r1=x%SCSolarZenithAngle  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='SCSolarAzimuthAngle'
if(associated(x%SCSolarAzimuthAngle))then
  call write_array_hdf(lun,sname,&
    & 'The angle from the Solar Diffuser..... (observer looking toward the SD surface) (degree)',&
    & err,r1=x%SCSolarAzimuthAngle  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='MoonPhaseAngle'
if(associated(x%MoonPhaseAngle))then
  call write_array_hdf(lun,sname,&
    & 'Angle between ray vector to moon from earth and ray vector of satellitre to earth (degree)',&
    & err,r1=x%MoonPhaseAngle  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='MoonIllumFraction'
if(associated(x%MoonIllumFraction))then
  call write_array_hdf(lun,sname,&
    & 'Fraction of the moon illuminated (expressed as percent) [granules]',&
    & err,r1=x%MoonIllumFraction  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='ModeScan'
if(associated(x%ModeScan))then
  call write_array_hdf(lun,sname,&
    & 'The VIIRS operational mode, reported at the scan level',&
    & err,i1=x%ModeScan  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='ModeGran'
if(associated(x%ModeGran))then
  call write_array_hdf(lun,sname,&
    & 'The VIIRS operational mode, reported at the granule level',&
    & err,i1=x%ModeGran  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='NumberOfScans'
if(associated(x%NumberOfScans))then
  call write_array_hdf(lun,sname,&
    & 'Actual number of VIIRS scans that were used to create this granule',&
    & err,i1=x%NumberOfScans  )
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='QF1_SCAN_VIIRSSDRGEO'
if(associated(x%QF1_SCAN_VIIRSSDRGEO))then
  call write_array_hdf(lun,sname,&
    & 'Quality flag for each scan',&
    & err,i1=x%QF1_SCAN_VIIRSSDRGEO  ,compress=compress,compdims=(/-1,32/))
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

sname='QF2_VIIRSSDRGEO'
if(associated(x%QF2_VIIRSSDRGEO))then
  call write_array_hdf(lun,sname,&
    & 'Quality Flag for each pixel [pixels, lines]',&
    & err,i2=x%QF2_VIIRSSDRGEO  ,compress=compress)
  THROWM(err.ne.0,"CANNOT WRITE "//trim(sname))
endif

err=0
CATCH
end subroutine

#endif

end module
