! Name: $Id: maia_CT_Fl_opaq.F90 502 2016-11-15 10:22:21Z frna $
!
! Purpose: 
!          Subroutines maia_CT_Fl_opaq 
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 29 June 2011, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2014, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!  1.0    01/06/2013   Lydie Lavanant
!  1.1    20/05/2016   Lydie Lavanant maia 4 version 4.3
  SUBROUTINE maia_CT_Fl_opaq (idbg, pix, black)

! Authors       : lydie lavanant

!  determines if a pixel is opaque

USE MOD_MAIA_CONST
USE MOD_maia_types
implicit none

  type( debug ),       INTENT(in) :: idbg       ! 
  type( pix_data),   INTENT(in) :: pix  ! pix observations (albedo in %, Tb in K)
  INTEGER, INTENT(out)            :: black

!=======================================================
  if(idbg%debug) write(*,*) "maia_CT_Fl_opaq"
  if( (pix % Obs_108-pix % Obs_120) < CT_108_120_opaq) then     ! it a black body
     black = 1
  endif

END SUBROUTINE  maia_CT_Fl_opaq 
