! Name: $Id: maia_GetThres_CT_max108.F90 502 2016-11-15 10:22:21Z frna $
!
! Purpose: 
!          Subroutines maia_GetThres_CT_max108 
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 29 June 2011, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2014, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!  1.0    01/06/2013   Lydie Lavanant
!  1.1    20/05/2016   Lydie Lavanant maia 4 version 4.3
SUBROUTINE maia_GetThres_CT_max108 (idbg, box, thres )
 
! Set Cloud Type thresholds

! Authors       : lydie lavanant

USE MOD_MAIA_CONST
USE MOD_maia_types
IMPLICIT NONE

! input/output
  type( debug ),    INTENT(in)  :: idbg         ! 
  type( box_id ),   INTENT(in)  :: box          ! lat, lon, solar and satellite angles at the center of the box
  type( maia_thres),INTENT(out):: thres ! 

! ---------------------------------------------------------------------------     
  if( idbg % debug ) write(*,*) "maia_GetThres_CT_max108"
  thres % v_CT_max108_lo=   CT_max108_lo_c850* box% t850 +                              &
                           CT_max108_lo_c700* box% t700 + CT_max108_lo_offset

  thres % v_CT_max108_me=   CT_max108_me_c850* box% t850 +                              &
                           CT_max108_me_c700* box% t700 + CT_max108_me_offset
                
  thres % v_CT_max108_hi=   CT_max108_hi_c700* box% t700 +                              &
                           CT_max108_hi_c500* box% t500 + CT_max108_hi_offset
                
  if (box%ttropo > vmanq ) then
      thres % v_CT_max108_vh= CT_max108_vh_c500* box% t500  +                   &
                             CT_max108_vh_ctropo* box%ttropo + CT_max108_vh_offset 
  else
      thres % v_CT_max108_vh= thres % v_CT_max108_hi - CT_offthr_vh_hi
  endif

END SUBROUTINE maia_GetThres_CT_max108
