! Name: $Id: maia_Inland_Water.F90 502 2016-11-15 10:22:21Z frna $
!
! Purpose: looks to small surfaces of water from imager channels from toa ndvi
!          Subroutines maia_Inland_Water 
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 29 June 2011, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2014, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!  1.0    01/01/2014   Lydie Lavanant
!  1.1    20/05/2016   Lydie Lavanant maia 4 version 4.3
SUBROUTINE maia_Inland_Water (idbg, pix_id, pix)

! Authors       : lydie lavanant



USE MOD_maia_types
USE MOD_MAIA_CONST
IMPLICIT NONE

! input/ output
  type( debug )  ,  INTENT(in)     :: idbg      ! 
  type( pix_info),  INTENT(inout)  :: pix_id    ! 
  type( pix_data),  INTENT(in)     :: pix       ! 
  
! local
  real    :: ndvi
  integer :: i

!=============================================[ instructions ]==========
   if(idbg%debug) write(*,'(a30, 4f10.3)') 'maia_Inland_Water I1: ', pix % I(:,1)
   if(idbg%debug) write(*,'(a30, 4f10.3)') 'maia_Inland_Water I2: ', pix % I(:,2)
   !    --------------------------
   !    TOA NDVI
   !    --------------------------
   IF (pix % Qual_I(1)  .and. pix % Qual_I(2) ) then
       do i=1,4
          ndvi = (pix % I(i,2)-pix % I(i,1))/(pix % I(i,2)+ pix % I(i,1))
          if(ndvi<0.01) pix_id% coast = .true.
          if(idbg%debug) write(*,'(a30, f10.3)') 'maia_Inland_Water ndvi: ', ndvi
       end do
   else
       ndvi=vmanq
   endif


END SUBROUTINE maia_Inland_Water
