! Name: $Id: maia_Interp_InGrid.F90 502 2016-11-15 10:22:21Z frna $
!
! Purpose: 
!          Subroutines maia_Interp_InGrid 
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 29 June 2011, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2014, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!  1.0    01/06/2013   Lydie Lavanant
!  1.1    20/05/2016   Lydie Lavanant maia 4 version 4.3
SUBROUTINE  maia_Interp_InGrid (tab , rpg, rlg, value)


! interpolation between the 4 nodes of the grid

IMPLICIT NONE

  REAL, INTENT(in)    :: tab(2,2)
  REAL, INTENT(in)    :: rpg, rlg
  REAL, INTENT(out)   :: value

!================================================
  value = tab(1,1) * (1-rpg) * (1-rlg) +        &
          tab(2,1) * (rpg)   * (1-rlg) +        &
          tab(2,2) * (rpg)   * (rlg) +          &
          tab(1,2) * (1-rpg) * (rlg)
  
END SUBROUTINE maia_Interp_InGrid

