! Name: $Id: maia_Interp_InLut.F90 502 2016-11-15 10:22:21Z frna $
!
! Purpose: 
!          Subroutines 
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 29 June 2011, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2014, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!  1.0    01/06/2013   Lydie Lavanant
!  1.1    20/05/2016   Lydie Lavanant maia 4 version 4.3
FUNCTION maia_Interp_InLut (tab,difsec,difw,iw,isec) 
        
IMPLICIT NONE

  INTEGER, PARAMETER :: nb_sec = 7
  INTEGER, PARAMETER :: nb_w = 16

  REAL, INTENT(in) :: tab(nb_w,nb_sec)
  REAL, INTENT(in) :: difsec,difw
  INTEGER , INTENT(in) :: iw,isec

  REAL :: maia_Interp_InLut

  maia_Interp_InLut=   (1.-difsec) * (1.-difw) * tab(iw, isec)          &
                     +  difsec     * difw      * tab(iw+1, isec+1)      &
                     + (1.-difsec) * difw      * tab(iw+1, isec)        &
                     + difsec      * (1.-difw) * tab(iw, isec+1)
         
END FUNCTION maia_Interp_InLut
