! Name: $Id: maia_Lon_Norm.F90 502 2016-11-15 10:22:21Z frna $
!
! Purpose: 
!          Subroutines maia_Lon_Norm 
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 29 June 2011, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2014, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!  1.0    01/06/2013   Lydie Lavanant
!  1.1    20/05/2016   Lydie Lavanant maia 4 version 4.3
subroutine maia_Lon_Norm (debug, data_id, Lon)

USE MOD_MAIA_CONST
implicit none

  logical,    INTENT(in)        :: debug        ! 
  character(len=6), intent(in)  :: data_id      ! 
  real,       Intent(inout)     :: Lon

  character(len=35)     :: action       ! 

!----------------------------------------------------------------------------
  ! norm180 : true if [-180,180[ else [0,360[

  ! Longitude normalisation between -180 and +180 degrees
  ! -----------------------------------------------------
  if(norm180) then
     if(Lon  >=  180.) Lon = Lon - 360.
     if(Lon  <  -180.) Lon = Lon + 360.
     if(debug )  then
        action= data_id(1:3) // ' in [-180,180['
        call ml_wt ('info',action)
     endif
  else
     if(Lon  >=  360.) Lon = Lon - 360.
     if(Lon  <  0.)    Lon = Lon + 360.
     if(debug )  then
        action= data_id(1:3) // ' in [0,360['
        call ml_wt ('info',action)
     endif
  endif

END SUBROUTINE maia_Lon_Norm

