! Name: $Id: maia_Thres_reset.F90 502 2016-11-15 10:22:21Z frna $
!
! Purpose: 
!          Subroutines maia_Thres_reset 
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 29 June 2011, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2014, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!  1.0    01/06/2013   Lydie Lavanant
!  1.1    20/05/2016   Lydie Lavanant maia 4 version 4.3
SUBROUTINE maia_Thres_reset (idbg, thres)

! Authors       : lydie lavanant

USE MOD_MAIA_CONST
USE MOD_maia_types
IMPLICIT NONE

! input/output
  type( debug ),      INTENT(in)   :: idbg      ! 
  type( maia_thres), INTENT(inout):: thres      ! 
          
!-----------------------------------------------------------------------
  if (idbg % debug) write(*,*) "maia_Thres_reset"
  thres % v_CMa_sst             =vmanq  
  thres % v_CMa_108_sea         =vmanq  
  thres % v_CMa_108_120_sea     =vmanq          
  thres % v_CMa_37_40_sea       =vmanq
  thres % v_CMa_108_37_sea      =vmanq          
  thres % v_CMa_120_37_sea      =vmanq          
  thres % v_CMa_87_108_sea      =vmanq
  thres % v_CMa_37_108_sea      =vmanq           
  thres % v_CMa_37_120_sea      =vmanq           
  thres % v_CMa_06_sea          =vmanq  
  thres % v_CMa_08_sea          =vmanq  
  thres % v_CMa_06_08_sea       =vmanq          
  thres % v_CMa_16_sea          =vmanq
  thres % v_CMa_108_land        =vmanq          
  thres % v_CMa_108_120_land    =vmanq          
  thres % v_CMa_108_37_land     =vmanq          
  thres % v_CMa_87_108_land     =vmanq          
  thres % v_CMa_87_37_land      =vmanq          
  thres % v_CMa_37_40_land      =vmanq
  thres % v_CMa_37_108_land     =vmanq          
  thres % v_CMa_37_120_land     =vmanq          
  thres % v_CMa_04_land         =vmanq
  thres % v_CMa_06_land         =vmanq  
  thres % v_CMa_06_08_land      =vmanq          
  thres % v_CMa_13_land         =vmanq  
  thres % v_CMa_108_120_desert  =vmanq  
  thres % v_CMa_108_37_desert   =vmanq  
  thres % v_CMa_04_desert       =vmanq  
  thres % v_CMa_13_desert       =vmanq  
  thres % v_CMa_37_40_ice       =vmanq
  thres % v_CMa_108_37_ice      =vmanq  
  thres % v_CMa_13_ice          =vmanq
  thres % v_CMa_16_ice          =vmanq
  thres % v_CMa_37_120_ice      =vmanq          
  thres % v_CMa_108_ice         =vmanq  
  thres % v_CT_max108_lo        =vmanq
  thres % v_CT_max108_me        =vmanq
  thres % v_CT_max108_hi        =vmanq
  thres % v_CT_max108_vh        =vmanq
  thres % v_CT_108_120_opaq     =vmanq
  thres % v_CT_87_108_opaq      =vmanq
  thres % v_CT_37_108_opaq      =vmanq
  thres % v_CT_maxcirrus_06slope =vmanq
  thres % v_CT_maxcirrus_06intercept =vmanq
  thres % v_CT_maxcirrus_06     =vmanq
  thres % v_CT_mincirrus_06     =vmanq
  thres % v_CT_minlow_06        =vmanq
 
END SUBROUTINE maia_Thres_reset
