! Name: $Id: maia_ValMoy.F90 502 2016-11-15 10:22:21Z frna $
!
! Purpose: 
!          Subroutines maia_ValMoy 
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 29 June 2011, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2014, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!  1.0    01/06/2013   Lydie Lavanant
!  1.1    20/05/2016   Lydie Lavanant maia 4 version 4.3
subroutine maia_ValMoy (idbg, nx,ny, tab, valmanq, moy)

!BUT/PURPOSE 
!       computation of mean on the tab's.
!       missing values are not used in statistics.

USE MOD_maia_types
  implicit none     

  type( debug ), INTENT(inout)  :: idbg  
  integer, intent(in)           :: nx,ny
  real, intent(in)              :: tab (nx,ny)
  real, intent(in)              :: valmanq
  real, intent(out)             :: moy

  integer       :: i, j, kval
  real (kind=8) :: dmoy
  if(idbg %debug) write(*,*) "maia_ValMoy"
  dmoy=0.d0
  kval = 0
  do i=1,nx
  do j=1,ny
     if(tab(i,j)> valmanq) then
        kval = kval+1
        dmoy=dmoy + tab(i,j)
     endif 
  end do
  end do

  if(kval>0) then
     dmoy=dmoy/kval
     moy = sngl(dmoy)
  else
     moy= valmanq
  endif

END SUBROUTINE maia_ValMoy
