! Name: $Id: avhrr_maia4_data_def.F90 553 2017-09-29 12:34:44Z frna $
!
! Purpose: avhrr maia4 data fortan structure definition module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   4/4/2017  Initial version (Pascale Roquet) 
!   1.1   28/09/2017 Change sat_id comment  (Pascale Roquet) 

module avhrr_maia4_data_def

implicit none
private
integer, parameter :: nlen = 256   ! name length
public :: nlen
public :: avhrr_maia4_data

type avhrr_maia4_data
  integer,pointer,dimension(:,:)::Alt_surface ! surface altitude
  integer,pointer,dimension(:,:)::CloudMask !  CLOUD MASK
  integer,pointer,dimension(:,:)::CloudTopPres !  CLOUD Top Pressure
  integer,pointer,dimension(:,:)::CloudTopTemp !  CLOUD Top Temperature
  integer,pointer,dimension(:,:)::CloudType !  cloud classification
  integer::Nb_Chan_Used ! Number of Avhrr channels used in process
  integer,pointer,dimension(:)::Chan_Used ! list of Avhrr resolution channels used in process
  integer,pointer,dimension(:,:)::Latitude ! latitude
  integer,pointer,dimension(:,:)::Longitude ! longitude
  integer,pointer,dimension(:,:)::Mask_ind ! Processes applied on the line
  integer,pointer,dimension(:,:)::Sat_zenith ! satellite zenith angle
  integer,pointer,dimension(:,:)::Tsurf ! retrieved surface temperature
  integer,pointer,dimension(:,:)::fov_qual !  pixel quality flags 0= ok  
  integer,pointer,dimension(:)::scnlin_day ! scan line day of year
  integer,pointer,dimension(:)::scnlin_time ! scan line UTC time of day in milliseconds
  integer,pointer,dimension(:)::scnlin_year ! scan line year
  integer,pointer,dimension(:)::scnline_qual ! scan line quality flag
end type

end module
