!
! Automatically generated by ./mod_rw.pl version 1.4
! Do not edit
!
! Name: $Id: avhrr_maia4_data_mem.F90
!
! Purpose: avhrr maia4 data init structure,free pointers,copy structures module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   4/4/2017  Initial version (Pascale Roquet) 
!
module avhrr_maia4_data_mem
#include "aapp_throw.h"
use avhrr_maia4_data_def
implicit none
private
public :: avhrr_maia4_data_free
public :: avhrr_maia4_data_init
public :: avhrr_maia4_data_copy
public :: avhrr_maia4_data_paste


contains

subroutine avhrr_maia4_data_free(x,err)
type(avhrr_maia4_data),intent(inout)::x
integer,intent(out)::err
character(len=nlen)::sname
TRY
err = 0

sname='Alt_surface'
if(associated(x%Alt_surface))then
  deallocate(x%Alt_surface,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%Alt_surface)
endif
sname='CloudMask'
if(associated(x%CloudMask))then
  deallocate(x%CloudMask,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%CloudMask)
endif
sname='CloudTopPres'
if(associated(x%CloudTopPres))then
  deallocate(x%CloudTopPres,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%CloudTopPres)
endif
sname='CloudTopTemp'
if(associated(x%CloudTopTemp))then
  deallocate(x%CloudTopTemp,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%CloudTopTemp)
endif
sname='CloudType'
if(associated(x%CloudType))then
  deallocate(x%CloudType,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%CloudType)
endif
sname='Chan_Used'
if(associated(x%Chan_Used))then
  deallocate(x%Chan_Used,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%Chan_Used)
endif
sname='Latitude'
if(associated(x%Latitude))then
  deallocate(x%Latitude,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%Latitude)
endif
sname='Longitude'
if(associated(x%Longitude))then
  deallocate(x%Longitude,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%Longitude)
endif
sname='Mask_ind'
if(associated(x%Mask_ind))then
  deallocate(x%Mask_ind,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%Mask_ind)
endif
sname='Sat_zenith'
if(associated(x%Sat_zenith))then
  deallocate(x%Sat_zenith,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%Sat_zenith)
endif
sname='Tsurf'
if(associated(x%Tsurf))then
  deallocate(x%Tsurf,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%Tsurf)
endif
sname='fov_qual'
if(associated(x%fov_qual))then
  deallocate(x%fov_qual,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%fov_qual)
endif
sname='scnlin_day'
if(associated(x%scnlin_day))then
  deallocate(x%scnlin_day,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%scnlin_day)
endif
sname='scnlin_time'
if(associated(x%scnlin_time))then
  deallocate(x%scnlin_time,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%scnlin_time)
endif
sname='scnlin_year'
if(associated(x%scnlin_year))then
  deallocate(x%scnlin_year,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%scnlin_year)
endif
sname='scnline_qual'
if(associated(x%scnline_qual))then
  deallocate(x%scnline_qual,stat=err)
  THROWM(err.ne.0,"CANNOT DEALLOCATE "//trim(sname))
  nullify(x%scnline_qual)
endif
CATCH
end subroutine

subroutine avhrr_maia4_data_init(x)
type(avhrr_maia4_data),intent(inout)::x

  nullify(x%Alt_surface)
  nullify(x%CloudMask)
  nullify(x%CloudTopPres)
  nullify(x%CloudTopTemp)
  nullify(x%CloudType)
  x%Nb_Chan_Used=0
  nullify(x%Chan_Used)
  nullify(x%Latitude)
  nullify(x%Longitude)
  nullify(x%Mask_ind)
  nullify(x%Sat_zenith)
  nullify(x%Tsurf)
  nullify(x%fov_qual)
  nullify(x%scnlin_day)
  nullify(x%scnlin_time)
  nullify(x%scnlin_year)
  nullify(x%scnline_qual)
end subroutine

subroutine avhrr_maia4_data_copy(x,y,err,data)
type(avhrr_maia4_data),intent(inout)::x
type(avhrr_maia4_data),intent(in)::y
integer,intent(out)::err
logical, optional :: data
integer::lb(7),ub(7)
logical :: data1

TRY

  data1=.true.
  if(present(data))data1 = data
  
  if(associated(y%Alt_surface))then
    lb(1:2)=lbound(y%Alt_surface)
    ub(1:2)=ubound(y%Alt_surface)
    allocate(x%Alt_surface(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Alt_surface")
    if(data1)x%Alt_surface=y%Alt_surface
  else
    nullify(x%Alt_surface)
  endif
  if(associated(y%CloudMask))then
    lb(1:2)=lbound(y%CloudMask)
    ub(1:2)=ubound(y%CloudMask)
    allocate(x%CloudMask(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE CloudMask")
    if(data1)x%CloudMask=y%CloudMask
  else
    nullify(x%CloudMask)
  endif
  if(associated(y%CloudTopPres))then
    lb(1:2)=lbound(y%CloudTopPres)
    ub(1:2)=ubound(y%CloudTopPres)
    allocate(x%CloudTopPres(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE CloudTopPres")
    if(data1)x%CloudTopPres=y%CloudTopPres
  else
    nullify(x%CloudTopPres)
  endif
  if(associated(y%CloudTopTemp))then
    lb(1:2)=lbound(y%CloudTopTemp)
    ub(1:2)=ubound(y%CloudTopTemp)
    allocate(x%CloudTopTemp(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE CloudTopTemp")
    if(data1)x%CloudTopTemp=y%CloudTopTemp
  else
    nullify(x%CloudTopTemp)
  endif
  if(associated(y%CloudType))then
    lb(1:2)=lbound(y%CloudType)
    ub(1:2)=ubound(y%CloudType)
    allocate(x%CloudType(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE CloudType")
    if(data1)x%CloudType=y%CloudType
  else
    nullify(x%CloudType)
  endif
  if(data1)x%Nb_Chan_Used=y%Nb_Chan_Used
  if(associated(y%Chan_Used))then
    lb(1:1)=lbound(y%Chan_Used)
    ub(1:1)=ubound(y%Chan_Used)
    allocate(x%Chan_Used(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Chan_Used")
    if(data1)x%Chan_Used=y%Chan_Used
  else
    nullify(x%Chan_Used)
  endif
  if(associated(y%Latitude))then
    lb(1:2)=lbound(y%Latitude)
    ub(1:2)=ubound(y%Latitude)
    allocate(x%Latitude(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Latitude")
    if(data1)x%Latitude=y%Latitude
  else
    nullify(x%Latitude)
  endif
  if(associated(y%Longitude))then
    lb(1:2)=lbound(y%Longitude)
    ub(1:2)=ubound(y%Longitude)
    allocate(x%Longitude(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Longitude")
    if(data1)x%Longitude=y%Longitude
  else
    nullify(x%Longitude)
  endif
  if(associated(y%Mask_ind))then
    lb(1:2)=lbound(y%Mask_ind)
    ub(1:2)=ubound(y%Mask_ind)
    allocate(x%Mask_ind(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Mask_ind")
    if(data1)x%Mask_ind=y%Mask_ind
  else
    nullify(x%Mask_ind)
  endif
  if(associated(y%Sat_zenith))then
    lb(1:2)=lbound(y%Sat_zenith)
    ub(1:2)=ubound(y%Sat_zenith)
    allocate(x%Sat_zenith(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Sat_zenith")
    if(data1)x%Sat_zenith=y%Sat_zenith
  else
    nullify(x%Sat_zenith)
  endif
  if(associated(y%Tsurf))then
    lb(1:2)=lbound(y%Tsurf)
    ub(1:2)=ubound(y%Tsurf)
    allocate(x%Tsurf(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Tsurf")
    if(data1)x%Tsurf=y%Tsurf
  else
    nullify(x%Tsurf)
  endif
  if(associated(y%fov_qual))then
    lb(1:2)=lbound(y%fov_qual)
    ub(1:2)=ubound(y%fov_qual)
    allocate(x%fov_qual(lb(1):ub(1),lb(2):ub(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE fov_qual")
    if(data1)x%fov_qual=y%fov_qual
  else
    nullify(x%fov_qual)
  endif
  if(associated(y%scnlin_day))then
    lb(1:1)=lbound(y%scnlin_day)
    ub(1:1)=ubound(y%scnlin_day)
    allocate(x%scnlin_day(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE scnlin_day")
    if(data1)x%scnlin_day=y%scnlin_day
  else
    nullify(x%scnlin_day)
  endif
  if(associated(y%scnlin_time))then
    lb(1:1)=lbound(y%scnlin_time)
    ub(1:1)=ubound(y%scnlin_time)
    allocate(x%scnlin_time(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE scnlin_time")
    if(data1)x%scnlin_time=y%scnlin_time
  else
    nullify(x%scnlin_time)
  endif
  if(associated(y%scnlin_year))then
    lb(1:1)=lbound(y%scnlin_year)
    ub(1:1)=ubound(y%scnlin_year)
    allocate(x%scnlin_year(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE scnlin_year")
    if(data1)x%scnlin_year=y%scnlin_year
  else
    nullify(x%scnlin_year)
  endif
  if(associated(y%scnline_qual))then
    lb(1:1)=lbound(y%scnline_qual)
    ub(1:1)=ubound(y%scnline_qual)
    allocate(x%scnline_qual(lb(1):ub(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE scnline_qual")
    if(data1)x%scnline_qual=y%scnline_qual
  else
    nullify(x%scnline_qual)
  endif
CATCH
end subroutine

subroutine avhrr_maia4_data_paste(x,y,z,err,data)
! only pointer arrays are considered
! for any other type the Y value is passed to X
! paste the last dimension of array
type(avhrr_maia4_data),intent(inout)::x
type(avhrr_maia4_data),intent(in)::y
type(avhrr_maia4_data),intent(in)::z
integer,intent(out)::err
logical, optional :: data
integer::lby(7),uby(7)
integer::lbz(7),ubz(7)
integer::lb1(7),ub1(7)
integer::lb2(7),ub2(7)

logical :: data1

TRY

  data1=.true.
  if(present(data))data1 = data
  
  if(associated(y%Alt_surface) .and. associated(z%Alt_surface))then
    lby(1:2)=lbound(y%Alt_surface)
    uby(1:2)=ubound(y%Alt_surface)

    lbz(1:2)=lbound(z%Alt_surface)
    ubz(1:2)=ubound(z%Alt_surface)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%Alt_surface(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Alt_surface")
    if(data1) then
      x%Alt_surface(lb1(1):ub1(1),lb1(2):ub1(2))=y%Alt_surface
      x%Alt_surface(lb2(1):ub2(1),lb2(2):ub2(2))=z%Alt_surface
    endif
  else
    nullify(x%Alt_surface)
  endif
  if(associated(y%CloudMask) .and. associated(z%CloudMask))then
    lby(1:2)=lbound(y%CloudMask)
    uby(1:2)=ubound(y%CloudMask)

    lbz(1:2)=lbound(z%CloudMask)
    ubz(1:2)=ubound(z%CloudMask)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%CloudMask(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE CloudMask")
    if(data1) then
      x%CloudMask(lb1(1):ub1(1),lb1(2):ub1(2))=y%CloudMask
      x%CloudMask(lb2(1):ub2(1),lb2(2):ub2(2))=z%CloudMask
    endif
  else
    nullify(x%CloudMask)
  endif
  if(associated(y%CloudTopPres) .and. associated(z%CloudTopPres))then
    lby(1:2)=lbound(y%CloudTopPres)
    uby(1:2)=ubound(y%CloudTopPres)

    lbz(1:2)=lbound(z%CloudTopPres)
    ubz(1:2)=ubound(z%CloudTopPres)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%CloudTopPres(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE CloudTopPres")
    if(data1) then
      x%CloudTopPres(lb1(1):ub1(1),lb1(2):ub1(2))=y%CloudTopPres
      x%CloudTopPres(lb2(1):ub2(1),lb2(2):ub2(2))=z%CloudTopPres
    endif
  else
    nullify(x%CloudTopPres)
  endif
  if(associated(y%CloudTopTemp) .and. associated(z%CloudTopTemp))then
    lby(1:2)=lbound(y%CloudTopTemp)
    uby(1:2)=ubound(y%CloudTopTemp)

    lbz(1:2)=lbound(z%CloudTopTemp)
    ubz(1:2)=ubound(z%CloudTopTemp)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%CloudTopTemp(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE CloudTopTemp")
    if(data1) then
      x%CloudTopTemp(lb1(1):ub1(1),lb1(2):ub1(2))=y%CloudTopTemp
      x%CloudTopTemp(lb2(1):ub2(1),lb2(2):ub2(2))=z%CloudTopTemp
    endif
  else
    nullify(x%CloudTopTemp)
  endif
  if(associated(y%CloudType) .and. associated(z%CloudType))then
    lby(1:2)=lbound(y%CloudType)
    uby(1:2)=ubound(y%CloudType)

    lbz(1:2)=lbound(z%CloudType)
    ubz(1:2)=ubound(z%CloudType)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%CloudType(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE CloudType")
    if(data1) then
      x%CloudType(lb1(1):ub1(1),lb1(2):ub1(2))=y%CloudType
      x%CloudType(lb2(1):ub2(1),lb2(2):ub2(2))=z%CloudType
    endif
  else
    nullify(x%CloudType)
  endif
  if(data1)x%Nb_Chan_Used=y%Nb_Chan_Used
  if(associated(y%Chan_Used) .and. associated(z%Chan_Used))then
    lby(1:1)=lbound(y%Chan_Used)
    uby(1:1)=ubound(y%Chan_Used)

    lbz(1:1)=lbound(z%Chan_Used)
    ubz(1:1)=ubound(z%Chan_Used)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%Chan_Used(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Chan_Used")
    if(data1) then
      x%Chan_Used(lb1(1):ub1(1))=y%Chan_Used
      x%Chan_Used(lb2(1):ub2(1))=z%Chan_Used
    endif
  else
    nullify(x%Chan_Used)
  endif
  if(associated(y%Latitude) .and. associated(z%Latitude))then
    lby(1:2)=lbound(y%Latitude)
    uby(1:2)=ubound(y%Latitude)

    lbz(1:2)=lbound(z%Latitude)
    ubz(1:2)=ubound(z%Latitude)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%Latitude(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Latitude")
    if(data1) then
      x%Latitude(lb1(1):ub1(1),lb1(2):ub1(2))=y%Latitude
      x%Latitude(lb2(1):ub2(1),lb2(2):ub2(2))=z%Latitude
    endif
  else
    nullify(x%Latitude)
  endif
  if(associated(y%Longitude) .and. associated(z%Longitude))then
    lby(1:2)=lbound(y%Longitude)
    uby(1:2)=ubound(y%Longitude)

    lbz(1:2)=lbound(z%Longitude)
    ubz(1:2)=ubound(z%Longitude)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%Longitude(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Longitude")
    if(data1) then
      x%Longitude(lb1(1):ub1(1),lb1(2):ub1(2))=y%Longitude
      x%Longitude(lb2(1):ub2(1),lb2(2):ub2(2))=z%Longitude
    endif
  else
    nullify(x%Longitude)
  endif
  if(associated(y%Mask_ind) .and. associated(z%Mask_ind))then
    lby(1:2)=lbound(y%Mask_ind)
    uby(1:2)=ubound(y%Mask_ind)

    lbz(1:2)=lbound(z%Mask_ind)
    ubz(1:2)=ubound(z%Mask_ind)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%Mask_ind(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Mask_ind")
    if(data1) then
      x%Mask_ind(lb1(1):ub1(1),lb1(2):ub1(2))=y%Mask_ind
      x%Mask_ind(lb2(1):ub2(1),lb2(2):ub2(2))=z%Mask_ind
    endif
  else
    nullify(x%Mask_ind)
  endif
  if(associated(y%Sat_zenith) .and. associated(z%Sat_zenith))then
    lby(1:2)=lbound(y%Sat_zenith)
    uby(1:2)=ubound(y%Sat_zenith)

    lbz(1:2)=lbound(z%Sat_zenith)
    ubz(1:2)=ubound(z%Sat_zenith)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%Sat_zenith(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Sat_zenith")
    if(data1) then
      x%Sat_zenith(lb1(1):ub1(1),lb1(2):ub1(2))=y%Sat_zenith
      x%Sat_zenith(lb2(1):ub2(1),lb2(2):ub2(2))=z%Sat_zenith
    endif
  else
    nullify(x%Sat_zenith)
  endif
  if(associated(y%Tsurf) .and. associated(z%Tsurf))then
    lby(1:2)=lbound(y%Tsurf)
    uby(1:2)=ubound(y%Tsurf)

    lbz(1:2)=lbound(z%Tsurf)
    ubz(1:2)=ubound(z%Tsurf)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%Tsurf(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE Tsurf")
    if(data1) then
      x%Tsurf(lb1(1):ub1(1),lb1(2):ub1(2))=y%Tsurf
      x%Tsurf(lb2(1):ub2(1),lb2(2):ub2(2))=z%Tsurf
    endif
  else
    nullify(x%Tsurf)
  endif
  if(associated(y%fov_qual) .and. associated(z%fov_qual))then
    lby(1:2)=lbound(y%fov_qual)
    uby(1:2)=ubound(y%fov_qual)

    lbz(1:2)=lbound(z%fov_qual)
    ubz(1:2)=ubound(z%fov_qual)

    lb1(1:2)=lby(1:2)
    ub1(1:2)=uby(1:2)
    
    lb2(1:2)  =lby(1:2)
    lb2(2:2)=lby(2:2) + uby(2:2)
    ub2(1:2)  =ubz(1:2)
    ub2(2:2)=uby(2:2) + ubz(2:2)

    allocate(x%fov_qual(lb1(1):ub2(1),lb1(2):ub2(2)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE fov_qual")
    if(data1) then
      x%fov_qual(lb1(1):ub1(1),lb1(2):ub1(2))=y%fov_qual
      x%fov_qual(lb2(1):ub2(1),lb2(2):ub2(2))=z%fov_qual
    endif
  else
    nullify(x%fov_qual)
  endif
  if(associated(y%scnlin_day) .and. associated(z%scnlin_day))then
    lby(1:1)=lbound(y%scnlin_day)
    uby(1:1)=ubound(y%scnlin_day)

    lbz(1:1)=lbound(z%scnlin_day)
    ubz(1:1)=ubound(z%scnlin_day)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%scnlin_day(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE scnlin_day")
    if(data1) then
      x%scnlin_day(lb1(1):ub1(1))=y%scnlin_day
      x%scnlin_day(lb2(1):ub2(1))=z%scnlin_day
    endif
  else
    nullify(x%scnlin_day)
  endif
  if(associated(y%scnlin_time) .and. associated(z%scnlin_time))then
    lby(1:1)=lbound(y%scnlin_time)
    uby(1:1)=ubound(y%scnlin_time)

    lbz(1:1)=lbound(z%scnlin_time)
    ubz(1:1)=ubound(z%scnlin_time)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%scnlin_time(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE scnlin_time")
    if(data1) then
      x%scnlin_time(lb1(1):ub1(1))=y%scnlin_time
      x%scnlin_time(lb2(1):ub2(1))=z%scnlin_time
    endif
  else
    nullify(x%scnlin_time)
  endif
  if(associated(y%scnlin_year) .and. associated(z%scnlin_year))then
    lby(1:1)=lbound(y%scnlin_year)
    uby(1:1)=ubound(y%scnlin_year)

    lbz(1:1)=lbound(z%scnlin_year)
    ubz(1:1)=ubound(z%scnlin_year)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%scnlin_year(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE scnlin_year")
    if(data1) then
      x%scnlin_year(lb1(1):ub1(1))=y%scnlin_year
      x%scnlin_year(lb2(1):ub2(1))=z%scnlin_year
    endif
  else
    nullify(x%scnlin_year)
  endif
  if(associated(y%scnline_qual) .and. associated(z%scnline_qual))then
    lby(1:1)=lbound(y%scnline_qual)
    uby(1:1)=ubound(y%scnline_qual)

    lbz(1:1)=lbound(z%scnline_qual)
    ubz(1:1)=ubound(z%scnline_qual)

    lb1(1:1)=lby(1:1)
    ub1(1:1)=uby(1:1)
    
    lb2(1:1)  =lby(1:1)
    lb2(1:1)=lby(1:1) + uby(1:1)
    ub2(1:1)  =ubz(1:1)
    ub2(1:1)=uby(1:1) + ubz(1:1)

    allocate(x%scnline_qual(lb1(1):ub2(1)),stat=err)
    THROWM(err.ne.0,"CANNOT ALLOCATE scnline_qual")
    if(data1) then
      x%scnline_qual(lb1(1):ub1(1))=y%scnline_qual
      x%scnline_qual(lb2(1):ub2(1))=z%scnline_qual
    endif
  else
    nullify(x%scnline_qual)
  endif
CATCH
end subroutine

end module
