!
! Automatically generated by ./mod_rw.pl version 1.5
! Do not edit
!
! Name: $Id: avhrr_maia4_header_mem.F90
!
! Purpose: avhrr maia4 header init structure,free pointers,copy structures module
!
! Method:
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 1 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!   1.0   4/4/2017  Initial version (Pascale Roquet) 
!
module avhrr_maia4_header_mem
#include "aapp_throw.h"
use avhrr_maia4_header_def
implicit none
private
public :: avhrr_maia4_header_free
public :: avhrr_maia4_header_init
public :: avhrr_maia4_header_copy
public :: avhrr_maia4_header_paste


contains

subroutine avhrr_maia4_header_free(x,err)
type(avhrr_maia4_header),intent(inout)::x
integer,intent(out)::err
character(len=nlen)::sname
TRY
err = 0

CATCH
end subroutine

subroutine avhrr_maia4_header_init(x)
type(avhrr_maia4_header),intent(inout)::x

  x%CMa_Version=0
  x%Nb_lines=0
  x%Nb_pixels=0
  x%dataname=''
  x%datatyp=0
  x%end_day=0
  x%end_orbit=0
  x%end_time=0
  x%end_year=0
  x%inst_id=0
  x%sat_id=0
  x%site1b=''
  x%site1c=''
  x%start_day=0
  x%start_orbit=0
  x%start_time=0
  x%start_year=0
end subroutine

subroutine avhrr_maia4_header_copy(x,y,err,data)
type(avhrr_maia4_header),intent(inout)::x
type(avhrr_maia4_header),intent(in)::y
integer,intent(out)::err
logical, optional :: data
integer::lb(7),ub(7)
logical :: data1

TRY

  data1=.true.
  if(present(data))data1 = data
  
  if(data1)x%CMa_Version=y%CMa_Version
  if(data1)x%Nb_lines=y%Nb_lines
  if(data1)x%Nb_pixels=y%Nb_pixels
  if(data1)x%dataname=y%dataname
  if(data1)x%datatyp=y%datatyp
  if(data1)x%end_day=y%end_day
  if(data1)x%end_orbit=y%end_orbit
  if(data1)x%end_time=y%end_time
  if(data1)x%end_year=y%end_year
  if(data1)x%inst_id=y%inst_id
  if(data1)x%sat_id=y%sat_id
  if(data1)x%site1b=y%site1b
  if(data1)x%site1c=y%site1c
  if(data1)x%start_day=y%start_day
  if(data1)x%start_orbit=y%start_orbit
  if(data1)x%start_time=y%start_time
  if(data1)x%start_year=y%start_year
CATCH
end subroutine

subroutine avhrr_maia4_header_paste(x,y,z,err,data)
! only pointer arrays are considered
! for any other type the Y value is passed to X
! paste the last dimension of array
type(avhrr_maia4_header),intent(inout)::x
type(avhrr_maia4_header),intent(in)::y
type(avhrr_maia4_header),intent(in)::z
integer,intent(out)::err
logical, optional :: data
integer::lby(7),uby(7)
integer::lbz(7),ubz(7)
integer::lb1(7),ub1(7)
integer::lb2(7),ub2(7)

logical :: data1

TRY

  data1=.true.
  if(present(data))data1 = data
  
  if(data1)x%CMa_Version=y%CMa_Version
  if(data1)x%Nb_lines=y%Nb_lines
  if(data1)x%Nb_pixels=y%Nb_pixels
  if(data1)x%dataname=y%dataname
  if(data1)x%datatyp=y%datatyp
  if(data1)x%end_day=y%end_day
  if(data1)x%end_orbit=y%end_orbit
  if(data1)x%end_time=y%end_time
  if(data1)x%end_year=y%end_year
  if(data1)x%inst_id=y%inst_id
  if(data1)x%sat_id=y%sat_id
  if(data1)x%site1b=y%site1b
  if(data1)x%site1c=y%site1c
  if(data1)x%start_day=y%start_day
  if(data1)x%start_orbit=y%start_orbit
  if(data1)x%start_time=y%start_time
  if(data1)x%start_year=y%start_year
CATCH
end subroutine

end module
