!> The adjtable structure holds the necessary data for the 
!! VIIRS adjacency algorithm
!!
!! @author P. Brunel
!! @date October, 2014

MODULE MAP_VIIRS_ADJACENCY_DEF

IMPLICIT NONE

  !> All necessary data that is used by the GETADJPIXEL function
  !! when selecting the right pixel
  TYPE ADJTABLE
    INTEGER::TOTALSCANS !< Number of Scans
    INTEGER::ROWSPERSCAN !< Rows Per Scan
    INTEGER::COLUMNSPERSCAN !< Columns Per Scan
    REAL,POINTER,DIMENSION(:,:)::LAT !< Latitude of each pixel (positive North) degree 
      !!    size is [pixels, lines]
    REAL,POINTER,DIMENSION(:,:)::LON !< Longitude of each pixel (positive East) degree
      !!    size is [pixels, lines]
    INTEGER,POINTER,DIMENSION(:)::PIXELTRIM !< Pixel trim cells
    INTEGER,POINTER,DIMENSION(:,:)::TOP !< Top row == minimum row index
    INTEGER,POINTER,DIMENSION(:,:)::BOTTOM !< Bottom row == maximum row index
    INTEGER,POINTER,DIMENSION(:,:)::PREV !< Previous scan row index
    INTEGER,POINTER,DIMENSION(:,:)::PREVCOLOFFSET !< Previous column offset
    INTEGER,POINTER,DIMENSION(:,:)::NEXT !< Next scan row index
    INTEGER,POINTER,DIMENSION(:,:)::NEXTCOLOFFSET !< Next column offset
    REAL,POINTER,DIMENSION(:)::ROWSIZE !< Across scan pixel size (m)
    REAL::ROWSIZECOEF !< Empirical factor for tests with rowSize
    REAL,POINTER,DIMENSION(:)::COLSIZE !< Along scan pixel size (m)
  
  END TYPE

END MODULE
