#! /bin/ksh
#
# Korn Shell to run tbusdisp.exe: display a tbus bulletin
#
# PROPRIETAIRE/OWNER
#       P. Brunel - A. Marsouin
#
# HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
# (version   date      comment           <author>)
#  1.0     13/02/95   initial            P. Brunel
#  1.1     01/04/04   cleaning           P. Brunel
#  1.2     01/02/06   change config file P. Marguinaud
#
# COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
#     &/'%Z% %M% version %I% on %G%'/       
#

. "$AAPP_PREFIX/ATOVS_CONF"

DIR_DATA_TBUS=${DIR_DATA_TBUS:=${DIR_NAVIGATION}/tbus_db}
if [ ! -d ${DIR_DATA_TBUS} ]; then
  DIR_DATA_TBUS=${DIR_NAVIGATION}/orb_elem
fi  
export DIR_DATA_TBUS

LISTESAT='noaa09 noaa10 noaa11 noaa12 noaa14'
LISTMETH='nearest last_preceeding'

echo 'enter the satellite name '${LISTESAT} 'or end (default):'
read SAT
if [ "${SAT}" = "" ] ; then
  SAT=end
fi

until [ "${SAT}" = 'end' ]
do


  echo 'enter the search method (default=nearest) '${LISTMETH} :
  read METH
  if [ "${METH}" = "" ] ; then
    METH=nearest
  fi

  echo 'enter a date (dd/mm/yy  ou dd/mm/yy  hh:mm:ss.sss)'
  echo 'default is the last stored tbus:'
  read DATE
  if [ "${DATE}" = "" ] ; then
    DATE=01/01/49
  fi
	
  TBUS_INDEX=${DIR_DATA_TBUS}/tbus_${SAT}.index

  tbusdisp.exe << EOF >>tbusdisp.log 2>&1
${DIR_DATA_TBUS}
${SAT}
${TBUS_INDEX}
${DATE}
${METH}
EOF


  echo
  echo 'enter the satellite name : '${LISTESAT} 'or end (default)'
  read SAT
  if [ "${SAT}" = "" ] ; then
    SAT=end
  fi

done

exit
