#! /bin/ksh
#
# Korn Shell to run tleprint.exe: print a 2-Line bulletin
#
# PROPRIETAIRE/OWNER
#       P. Brunel - A. Marsouin
#
# HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
# (version   date      comment           <author>)
#  1.0     1 April 2004   initial            P. Brunel
#  1.1     1 Feb   2006   change config file P. Marguinaud
#
# COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
#     &/'%Z% %M% version %I% on %G%'/       
#


if [ -f $HOME/.profile ] ; then
  . $HOME/.profile
fi

# AAPP environment

. "$AAPP_PREFIX/ATOVS_CONF"

# SATellite IDentification
# Use operational satid file
SATID_FILE=${SATID_FILE:=satid.txt}
export DIR_SATID SATID_FILE


# variables for the TLE HOME directory
DIR_DATA_TLE=${DIR_NAVIGATION}/tle_db
if [ ! -d ${DIR_DATA_TLE} ]; then
  DIR_DATA_TLE=${DIR_NAVIGATION}/orb_elem
fi  

# 1 usage
#-------- 
usage(){
	echo
	echo ' TLE print'
	echo
	echo 'usage: tleprint ';
	echo
	echo '	interactive tool:';
	echo
	echo 'environment variables:'
	echo '	DIR_SATID  path for the satellite identification file'
	echo '	SATID_FILE  filename for the satellite identification file'
	}

if [ $# -ge 1 ] ; then
  usage
  exit 2
fi

tleprint.exe 

exit
