      DOUBLE PRECISION RST,UNAST,EPSE0,EPSE1,EPSINI
C
C     --------------------
C     CONSTANTES PHYSIQUES
C     --------------------
C
C     RST   : VITESSE DE ROTATION DE LA TERRE(GAMMA 50 MOYEN) (RD/S)
C     UNAST : UNITE ASTRONOMIQUE(DIST. MOY. TERRE-SOLEIL) (KM)
C
      PARAMETER (RST   = 7.2921151467052037037037037037037037037037D -5)
      PARAMETER (UNAST = 1.4959870000000000000000000000000000000000D  8)
C
C
C     VALEURS POUR LES TESTS DEFINISSANT LES TYPES D'ORBITE
C
C     - SUR L'EXCENTRICITE E (AVEC EVENTUELLEMENT E = SQRT(EX**2+EY**2))
C
C       + POUR TESTER SI L'ORBITE EST CIRCULAIRE 
C            SI EXCENTRICITE < EPSE0   ===> ORBITE CIRCULAIRE
C            SI EXCENTRICITE >= EPSE0  ===> ORBITE NON CIRCULAIRE
C
      PARAMETER (EPSE0 = 1.0000000000000000000000000000000000000000D-10)
C
C       + POUR TESTER SI ORBITE ELLIPTIQUE-PARABOLIQUE-HYPERBOLIQUE
C            SI EXCENTRICITE <= 1 - EPSE1            ===> ELLIPSE
C            SI EXCENTRICITE >= 1 + EPSE1            ===> HYPERBOLE
C            SI 1 - EPSE1 < EXCENTRICITE < 1 + EPSE1 ===> PARABOLE
C
      PARAMETER (EPSE1 = 1.0000000000000000000000000000000000000000D-10)
C
C
C     - SUR L'INCLINAISON
C       POUR TESTER SI ORBITE EQUATORIALE AVEC LE SINUS DE L'INCLINAISON
C            SI SIN(INCLINAISON) < EPSINI   ===> ORBITE EQUATORIALE
C
      PARAMETER (EPSINI= 1.0000000000000000000000000000000000000000D-10)
C
C       + POUR TESTER SI UNE ORBITE A UNE INCLINAISON EGALE A PI 
C         (ORBITE EQUATORIALE RETROGRADE)
C         DEUX TESTS POSSIBLES ET EQUIVALENTS:
C            SI INCLINAISON > PI - EPSIRETRO ===> INCLINAISON = PI
C               AVEC: EPSIRETRO = 20.0D0*SQRT(EPSDP)
C            SI H**2 > 4.D0*(1.D0-100.D0*EPSDP) ===> INCLINAISON = PI
C               AVEC: VECTEUR INCLINAISON H=(HX,HY)
C                     H**2 = NORME AU CARRE DU VECTEUR INCLINAISON H
C                     HX = 2 SIN(I/2)COS(OMEGA)
C                     HY = 2 SIN(I/2)SIN(OMEGA)
