      SUBROUTINE MRMNUT(RNUTLN,RNUTOB,ROBLIM,RMATNU,IER)
C
C**********************************************************************
C*
C*PRO MSLIB 0092
C*VER 26.11.87 - VERSION 2.0
C*AUT SPEC. CISI INGENIERIE -- LAGARRIGUE -- 2I/SE/MMS --
C*AUT PROG. CISI INGENIERIE (MATH. ET MECA. SPATIALE)
C*AUT (C) COPYRIGHT CNES  -  1990
C*ROL PROGRAMME : MATRICE DE NUTATION
C*ROL THEME : CHANGEMENT DE SYSTEME DE REFERENCE
C*ROL CALCUL DE LA MATRICE DE PASSAGE DU REPERE EQUATORIAL MOYEN
C*ROL A UNE EPOQUE T1 AU REPERE EQUATORIAL VRAI A LA MEME EPOQUE
C*PAR RNUTLN  (I) NUTATION EN LONGITUDE (RADIAN)
C*PAR RNUTOB  (I) NUTATION EN OBLIQUITE (RADIAN)
C*PAR ROBLIM  (I) OBLIQUITE MOYENNE     (RADIAN)
C*PAR RMATNU  (O) VECT(3,3) MATRICE DE NUTATION
C*PAR IER     (O) CODE RETOUR  SANS OBJET
C*NOT             0 : RETOUR NORMAL
C*HST VERSION 2.0  - 21.09.87 -  CREATION
C***********************************************************************
C
C
C     -------------------------
C     DECLARATION DES PARAMETRES
C     --------------------------
      INTEGER IER
      DOUBLE PRECISION    RNUTLN,RNUTOB,ROBLIM,RMATNU(3,3)
C
C     -------------------------------
C     DECLARATION DES DONNEES LOCALES
C     -------------------------------
C
C     COSINUS ET SINUS DE LA NUTAION EN LONGITUDE
      DOUBLE PRECISION RCNULN,RSNULN
C
C     COSINUS ET SINUS DE L'OBLIQUITE MOYENNE
      DOUBLE PRECISION RCOBLI,RSOBLI
C
C     COSINUS ET SINUS DE L'OBLIQUITE VRAI
      DOUBLE PRECISION RCOBLV,RSOBLV
C
C     VARIABLES DE TRAVAIL
      DOUBLE PRECISION RSCOVN,RCCOVN
      DOUBLE PRECISION ROBLIV
C
C     . . . INITIALISATION DE L'IDENTIFICATEUR SCCS 
C      
      CHARACTER*50 SCCSID
      DATA SCCSID/"%Z%  %M%  %Y%  %I%  %E%"/
C
C
C     ******************
C     DEBUT DU PROGRAMME
C     ******************
C
      IF (.FALSE.) THEN
         SCCSID = SCCSID
      ENDIF
C
C
      IER = 0
C
C     ====================
C*FON MATRICE DE NUTATION
C     ====================
      RCNULN = COS( RNUTLN )
      RSNULN = SIN( RNUTLN )
C
      RCOBLI = COS( ROBLIM )
      RSOBLI = SIN( ROBLIM )
C
      ROBLIV = RNUTOB + ROBLIM
C
      RCOBLV = COS( ROBLIV )
      RSOBLV = SIN( ROBLIV )
C
      RMATNU(1,1) = RCNULN
      RMATNU(1,2) = -RSNULN*RCOBLI
      RMATNU(1,3) = -RSNULN*RSOBLI
C
      RCCOVN = RCOBLV*RCNULN
C
      RMATNU(2,1) = RCOBLV*RSNULN
      RMATNU(2,2) = RCCOVN*RCOBLI + RSOBLV*RSOBLI
      RMATNU(2,3) = RCCOVN*RSOBLI - RSOBLV*RCOBLI
C
      RSCOVN = RSOBLV*RCNULN
C
      RMATNU(3,1) = RSOBLV*RSNULN
      RMATNU(3,2) = RSCOVN*RCOBLI - RCOBLV*RSOBLI
      RMATNU(3,3) = RSCOVN*RSOBLI + RCOBLV*RCOBLI
C
C     ****************
C     FIN DE PROGRAMME
C     ****************
C
      RETURN
      END
