      DOUBLE PRECISION FUNCTION MUAMOD (RPARX,RPARY,IER)
C
C***********************************************************************
C*
C*PRO MSLIB 0011
C*VER 24.09.87 V1.0
C*AUT SPEC.  C N E S - BERGES -  19.10.85
C*AUT PORT.  CISI INGENIERIE - (MATH. ET MECA. SPATIALE)
C*AUT (C) COPYRIGHT CNES  -  1990
C*ROL PROGRAMME : MUAMOD FONCTION MATHEMATIQUE MODULO
C*ROL THEME : UTILITAIRES MATHEMATIQUES
C*ROL CALCUL DE LA FONCTION MATHEMATIQUE MODULO SUR UN REEL
C*ROL AVEC CORRECTION EVENTUELLE POUR OBTENIR LA DEFINITION MATHEMATIQUE
C*PAR RPARX  (I) = VARIABLE LIBRE
C*PAR RPARY  (I) = ARGUMENT DU MODULO
C*PAR IER    (O) = CODE RETOUR (0:OK, -1:ARGUMENT=0)
C*NOT PROGRAMME DE TYPE INTERNE
C*HST V1.0 24.09.87 CREATION
C*HST VERSION 7.2 - 27.08.93 - EVOLUTION + TEST REEL : M-DE-011-1-II
C*HST VERSION 9.0 - 25.01.99 - MODIFICATION CAS X.Y <0: M-DE-011-2-CIS
C*
C***********************************************************************
C
C     --------------------------
C     DECLARATION DES PARAMETRES
C     --------------------------
C
      DOUBLE PRECISION RPARX,RPARY
      INTEGER IER
C
#include "minfo.h"
C
C     . . . INITIALISATION DE L'IDENTIFICATEUR SCCS 
C      
      CHARACTER*50 SCCSID
      DATA SCCSID/"%Z%  %M%  %Y%  %I%  %E%"/
C
C     ******************
C     DEBUT DE PROGRAMME
C     ******************
C
      IF (.FALSE.) THEN
         SCCSID = SCCSID
      ENDIF
      IER = 0
C
C     --------------------------------
C     CONTROLE ARGUMENT Y DU MODULO
C     --------------------------------
C
      IF (ABS(RPARY).LE.RMIN) THEN
         IER = -1
         MUAMOD = 0.D0
         GOTO 6000
      ENDIF
C
C     =================================================================
C*FON APPEL A LA FONCTION GENERIQUE MODULO
C*FON REMARQUE: LE MODULO FORTRAN DIFFERE DE LA DEFINITION MATHEMATIQUE
C*FON           LORSQUE LE PRODUIT DES ARGUMENTS EST NEGATIF
C     =================================================================
C
      MUAMOD = MOD (RPARX,RPARY)
C
C     ==================================================================
C*FON CORRECTION SI PRODUIT DES ARGUMENTS EST NEGATIF :
C*FON                   MODULO = MODULO + Y (SI MODULO NON NUL)
C*FON POUR OBTENIR LA DEFINITION MATHEMATIQUE: MODULO APPARTIENT A [0,Y[
C     ==================================================================
C
      IF ((RPARX*RPARY).LT.0.D0) THEN
         IF (MUAMOD.NE.0.D0) MUAMOD = MUAMOD + RPARY
      ENDIF
C
C     ****************
C     FIN DE PROGRAMME
C     ****************
C
 6000 CONTINUE
      RETURN
      END
