      SUBROUTINE MUCONVJCALJJS (IJOUR, IMOIS, IAN, IHEURE, IMIN, RSEC,
     -                          IJUL1950JOUR, RJUL1950SEC, IER)
C
C*******************************************************************
C*
C*PRO MSLIB 0247
C*VER 12.01.99 VERSION 9.0
C*AUT SPEC. CNES - LE DE -
C*AUT PROG. CISI DIS/MSS
C*AUT (C) COPYRIGHT CNES - 1999
C*ROL PROGRAMME : CONVERSION D'UNE DATE CALENDAIRE 
C*ROL EN UNE DATE EN JOUR JULIEN 1950 ET SECONDES DANS LE JOUR
C*ROL THEME :DATE, DUREE
C*ROL CONVERSION D'UNE DATE CALENDAIRE EN UNE DATE EXPRIMEE
C*ROL EN JOUR JULIEN 1950 ET SECONDES
C*PAR IJOUR        (I) : NUMERO DU JOUR DE LA DATE CALENDAIRE
C*PAR IMOIS        (I) : NUMERO DU MOIS DE LA DATE CALENDAIRE
C*PAR IAN          (I) : ANNEE DE LA DATE CALENDAIRE
C*PAR IHEURE       (I) : HEURE
C*PAR IMIN         (I) : MINUTE
C*PAR RSEC         (I) : SECONDE
C*PAR IJUL1950JOUR (O) : NOMBRE DE JOURS DE LA DATE JULIENNE
C*PAR RJUL1950SEC  (O) : NOMBRE DE SECONDES DE LA DATE JULIENNE
C*PAR IER          (O) : CODE RETOUR
C*NOT VALEURS DU CODE RETOUR :
C*NOT      0  : OK
C*NOT      -1 : NUMERO DU JOUR NON VALIDE
C*NOT      -2 : NUMERO DU MOIS NON VALIDE
C*NOT      -3 : ANNEE < 1950 OU > 2099
C*NOT      -4 : HEURE NON VALIDE
C*NOT      -5 : MINUTE NON VALIDE
C*NOT      -6 : SECONDES NON VALIDE
C*NOT DOCUMENT DE REFERENCE : M-NT-0-92-CIS
C*HST VERSION 9.0 - 12.01.99 - CREATION: M-SP-247-1-CIS
C*
C*******************************************************************
C*
      IMPLICIT NONE
C
C     --------------------------
C     DECLARATION DES PARAMETRES
C     --------------------------
C
      INTEGER IJOUR, IMOIS, IAN, IHEURE, IMIN, IJUL1950JOUR, IER
      DOUBLE PRECISION RSEC, RJUL1950SEC
C
C     ---------------------------------
C     DECLARATION DES VARIABLES LOCALES
C     ---------------------------------
C
      LOGICAL IBISEX
      INTEGER NJ2,IY,IA
C
C     -------------------------------
C     DECLARATION DES INITIALISATIONS
C     -------------------------------
C
      INTEGER NUMOIS(12),NBJOUR(12)
C
C     ---------------------------------------------
C     . . . INITIALISATION DE L'IDENTIFICATEUR SCCS 
C     ---------------------------------------------
C      
      CHARACTER*50 SCCSID
      DATA SCCSID/"%Z%  %M%  %Y%  %I%  %E%"/
C
C
C     NUMOIS : NUMERO DU JOUR DANS L'ANNEE POUR CHAQUE FIN DE MOIS
C     NBJOUR : NOMBRE DE JOURS DU MOIS COURANT
C
      DATA NUMOIS/-1,30,58,89,119,150,180,211,242,272,303,333/
      DATA NBJOUR/31,28,31,30,31,30,31,31,30,31,30,31/
C
C     ******************
C     DEBUT DE PROGRAMME
C     ******************
C
      IF (.FALSE.) THEN
         SCCSID = SCCSID
      ENDIF
      IER = 0
      IJUL1950JOUR = 0
      RJUL1950SEC = 0.D0
C
C     -----------------------------------------------
C*FON VERIFICATION DE LA VALIDITE DE LA DATE D'ENTREE
C     -----------------------------------------------
C
C
C     ----------------
C*FON TEST SUR L'ANNEE
C     ----------------
C
      IF ((IAN.LT.1950).OR.(IAN.GE.2100)) THEN
         IER = -3
         GOTO 6000
      ENDIF
C
C     ----------------
C*FON TEST SUR LE MOIS
C     ----------------
C
      IF (IMOIS.LT.1.OR.IMOIS.GT.12) THEN
         IER = -2
         GOTO 6000
      ENDIF
C
C     --------------------------------------------
C*FON VERIFICATION VALIDITE JOUR (AVEC MOIS ET AN)
C     --------------------------------------------
C
      IF (IJOUR.LT.1) THEN
         IER=-1
         GOTO 6000
      ENDIF
C
      IBISEX = MOD(IAN,4).EQ.0
C
      IF (IMOIS.NE.2) THEN
         IF (IJOUR.GT.NBJOUR(IMOIS)) THEN
            IER = -1
            GOTO 6000
         ENDIF
      ELSE
         IF (IBISEX) THEN
            NJ2=29
         ELSE
            NJ2=28
         ENDIF
         IF (IJOUR.GT.NJ2) THEN
            IER = -1
            GOTO 6000
         ENDIF
      ENDIF
C
C     ----------------
C*FON TEST SUR L'HEURE
C     ----------------
C
      IF ((IHEURE.LT.0).OR.(IHEURE.GE.24)) THEN
         IER = -4
         GOTO 6000
      ENDIF
C
C     --------------------
C*FON TEST SUR LES MINUTES
C     --------------------
C
      IF ((IMIN.LT.0).OR.(IMIN.GE.60)) THEN
         IER = -5
         GOTO 6000
      ENDIF
C
C     ---------------------
C*FON TEST SUR LES SECONDES
C     ---------------------
C
      IF ((RSEC.LT.0.D0).OR.(RSEC.GE.60.D0)) THEN
         IER = -6
         GOTO 6000
      ENDIF
C
C     ---------------------------------------------------------------
C*FON SI LES DONNEES D'ENTREE SONT VALIDES, CALCUL DU NOMBRE DE JOURS
C*FON JULIENS
C     ---------------------------------------------------------------
C
      IY = IAN - 1950
      IA = (IY+1)/4
      IJUL1950JOUR = 365*IY + IA + NUMOIS(IMOIS) + IJOUR
C
C     AJOUT EVENTUEL DE LA JOURNEE BISSEXTILE DE L'ANNEE COURANTE
C
      IF(IBISEX.AND.IMOIS.GT.2) IJUL1950JOUR = IJUL1950JOUR + 1
C
C     --------------------------------
C*FON CALCUL DES SECONDES DANS LE JOUR
C     --------------------------------
C
      RJUL1950SEC = DBLE(IHEURE) * 3600.D0 +  DBLE(IMIN) * 60.D0 + RSEC
C
C     ****************
C     FIN DE PROGRAMME
C     ****************
C
 6000 CONTINUE
      RETURN
      END
