      SUBROUTINE MUMATP(RA,RB,IM,IN,IP,ILMAX,ICMAX,RC,IER)
C
C**********************************************************************
C*
C*PRO MSLIB 0091
C*VER 26.11.87 - VERSION 2.0
C*AUT SPEC. CISI INGENIERIE -- LAGARRIGUE -- 2I/SE/MMS
C*AUT PROG. CISI INGENIERIE (MATH. ET MECA. SPATIALE)
C*AUT (C) COPYRIGHT CNES  -  1990
C*ROL PROGRAMME : PRODUIT DE DEUX MATRICES QUELCONQUES
C*ROL THEME : UTILITAIRES MATHEMATIQUES
C*ROL PRODUIT DE DEUX MATRICES QUELCONQUES
C*PAR RA   (I) : MATRICE DE GAUCHE (IM*IN)
C*PAR RB   (I) : MATRICE DE DROITE (IN*IP)
C*PAR IM   (I) : NOMBRE DE LIGNES DE RA   ( >= 1 )
C*PAR IN   (I) : NOMBRE DE COLONNES DE RA ( >= 1 )
C*PAR IP   (I) : NOMBRE DE COLONNES DE RB ( >= 1 )
C*PAR ILMAX(I) : NOMBRE DE LIGNES MAX
C*PAR ICMAX(I) : NOMBRE DE COLONNES MAX
C*PAR RC   (O) : MATRICE RESULTAT  (IM*IP)
C*PAR IER  (O) : CODE RETOUR
C*NOT               0 : RETOUR NORMAL
C*NOT              -1 : PARAMETRES D'ENTREE INCORRECTS
C*HST VERSION 2.0 - 02.10.87 - CREATION
C*HST VERSION 9.0 - 25.02.99 - MANQUE TEST IN > ILMAX : M-FA-091-1-CIS
C*
C***********************************************************************
C
C
C     -------------------------
C     DECLARATION DES PARAMETRES
C     --------------------------
C
      INTEGER IM,IN,IP,IER
      INTEGER ILMAX,ICMAX
      DOUBLE PRECISION RA(ILMAX,ICMAX),RB(ILMAX,ICMAX),RC(ILMAX,ICMAX)
C
C     -------------------------------
C     DECLARATION DES DONNEES LOCALES
C     -------------------------------
C
C     INDICES DE BOUCLE
      INTEGER I,J,K
C
C     . . . INITIALISATION DE L'IDENTIFICATEUR SCCS 
C      
      CHARACTER*50 SCCSID
      DATA SCCSID/"%Z%  %M%  %Y%  %I%  %E%"/
C
C     ******************
C     DEBUT DU PROGRAMME
C     ******************
C
C
      IF (.FALSE.) THEN
         SCCSID = SCCSID
      ENDIF
      IER = 0
C
C     ===================================
C*FON VERIFICATION DES DONNEES EN ENTREE
C     ===================================
C
      IF ((IM .LT. 1) .OR. (IN .LT. 1) .OR. (IP .LT. 1)) THEN
         IER = -1
         GOTO 6000
      ENDIF
      IF ((IM.GT.ILMAX).OR.(IN.GT.ICMAX).OR.(IN.GT.ILMAX)
     &                 .OR.(IP.GT.ICMAX)) THEN
         IER = -1
         GO TO 6000
      ENDIF
C
C
C     =========================
C*FON PRODUIT DES DEUX MATRICES
C     =========================
C
      DO 10 I=1,ILMAX
      DO 10 J=1,ICMAX
         RC(I,J) = 0.D0
 10   CONTINUE
C
      DO 20 I=1,IM
         DO 30 J=1,IP
            RC(I,J) = 0.D0
            DO 40 K=1,IN
               RC(I,J) = RC(I,J) + RA(I,K) * RB(K,J)
40          CONTINUE
C
30       CONTINUE
C
20    CONTINUE
C
C     ****************
C     FIN DE PROGRAMME
C     ****************
C
 6000 CONTINUE
      RETURN
      END
