      subroutine bfixed(key,gha,pv,vv,posout,velout,b)
      implicit real*8 (a-h,o-z)
c***********************************************************************
c
c   name - bfixed
c
c   language- forthxp     type- subroutine
c
c   version- 1.0    date- 10/14/77   programmer- sachs, a.
c
c   purpose -transform the position and velocity from tod to
c   psuedo body fixed.
c
c   input parameters -key= 3 for return of body fixed position only,
c   gha= greenwich  hour angle in radians, pv= position vector,
c   vv= velocity vector (km/sec).
c
c   output parameters -posout =position vector, velout =velocity vector,
c   b -rotation matrix .
c
c   subroutines called -ma3331
c
c   comment- b matrix computation is from subroutine eval of gtds.
c
c***********************************************************************
c
      dimension b(3,3),bdot(3,3),pv(3),vv(3),velout(3),vout(3)
      dimension posout(3)
      data omegae,bdot/7.29211585494d-5,9*0.d0/
c compute matrix to rotate poition  from tod to psuedo body fixed.
c spin factor is zero.
      xp=0.0d0
      yp=0.0d0
      b(1,1) = dcos(gha)
      b(1,2) = dsin(gha)
      b(1,3)= xp
      b(2,1) = -b(1,2)
      b(2,2) = b(1,1)
      b(2,3)=-yp
      b(3,1)=-xp*b(1,1)-yp*b(1,2)
      b(3,2)=-xp*b(1,2)+yp*b(1,1)
      b(3,3) = 1.0d0
c rotate the input position vector.
       call ma3331(b,pv,posout)
      if(key.eq.3) go to 30
c compute matrix to rotate velocity from tod to psuedo body fixed.
      bdot(1,1) =-b(1,2)
      bdot(1,2) = b(1,1)
      bdot(2,1) = -b(1,1)
      bdot(2,2) =  -b(1,2)
c rotate the input velocity bector.
      call ma3331(b,vv,vout)
c rotate the input position vector.
      call ma3331(bdot,pv,velout)
c obtain the body fixed velocity.
      do 20 i=1,3
   20 velout(i) = velout(i)*omegae + vout(i)
   30 continue
      return
      end
