c Block data to initialise the common block:
#include "bd_brolyd.h"

      subroutine brolyd
     *(oscele,dpele,ipert,ipass,idmean,orbel)
c***********************************************************************
c*  ref. '' brouwer-lyddane orbit generator routine''                  *
c*                  (x-553-70-223)                                     *
c*                by e.a. galbreath 1970                               *
c*---------------------------------------------------------------------*
c*  modified 7/31/74 viona brown and r.a. gordon to interface with gtds*
c***********************************************************************
      implicit real*8(a-h,o-z)
c-----------------------------------------
c
c
c 19/07/2011 originally here: #include "bd_brolyd.h"
c
      dimension oscele(6),dpele(6),orbel(5)
      double precision tto,r,ae,gm,bj2,bj3,bj4,bj5,fltinv,xke,esq
      common /blcnst/ tto,r,ae,gm,bj2,bj3,bj4,bj5,fltinv,xke,esq
      data bmu,re/1.0d0,1.0d0/,bksubc/0.01d0/
      data pi2/6.283185307179586d0/
      ek = dsqrt(gm/ae**3)
      delt = ek*tto
      go to (10,111 ), ipass
ci------------------------------i
ci epoch elements at epoch time i
ci------------------------------i
   10 adp = dpele(1)/ae
      edp = dpele(2)
      bidp = dpele(3)
      hdp = dpele(4)
      gdp = dpele(5)
      bldp = dpele(6)
      a0 = adp
      e0 = edp
      bi0 = bidp
      h0 = hdp
      g0 = gdp
      bl0 = bldp
      iflg = 0
c---------------------i
c compute mean motion i
c---------------------i
      anu=dsqrt(bmu/a0**3)
c-------------------i
c compute fractions i
c-------------------i
      f3d8=3.0d0/8.0d0
      f1d2=1.0d0/2.0d0
      f3d2=3.0d0/2.0d0
      f1d4=1.0d0/4.0d0
      f5d4=5.0d0/4.0d0
      f1d8=1.0d0/8.0d0
      f5d12=5.0d0/12.0d0
      f1d16=1.0d0/16.0d0
      f15d16=15.0d0/16.0d0
      f5d24=5.0d0/24.0d0
      f3d32=3.0d0/32.0d0
      f15d32=15.0d0/32.0d0
      f5d64=5.0d0/64.0d0
      f35384=35.0d0/384.0d0
      f35576=35.0d0/576.0d0
      f35d52=35.0d0/1152.0d0
      f1d3=1.0d0/3.0d0
      f5d16=5.0d0/16.0d0
      bk2 = -f1d2*(bj2*re*re)
      bk3 = bj3*re**3
      bk4 = f3d8*(bj4*re**4)
      bk5 = bj5*re**5
      go to 153
  111 if(ipert.eq.0)go to 7
      if(idmean.ne.0)go to 202
      adp = dpele(1)/ae
      edp = dpele(2)
      bidp = dpele(3)
      hdp = dpele(4)
      gdp = dpele(5)
      bldp = dpele(6)
  153 edp2=edp*edp
      cn2=1.0-edp2
      cn=dsqrt(cn2)
      gm2=bk2/adp**2
      gmp2=gm2/(cn2*cn2)
      gm4=bk4/adp**4
      gmp4=gm4/cn**8
      theta=dcos(bidp)
      theta2=theta*theta
      theta4=theta2*theta2
  202 if(idmean.eq.0)go to 155
      if ( ipass.eq.2 ) go to 150
c------------------------i
c compute ldot,gdot,hdot i
c------------------------i
  157 bldot=cn*anu*(gmp2*(f3d2*(3.0*theta2-1)+gmp2*f3d32*(theta2
     1*(-96.0*cn+30.0-90.0*cn2)+(16.0*cn+25.0*cn2-15.0)+theta4
     2*(144.0*cn+25.0*cn2+105.0)))+edp2*gmp4*f15d16*(3.0+35.0*theta4
     3-30.0*theta2))
      gdot=anu*(f5d16*gmp4*((theta2*(126.0*cn2-270.0)+theta4*(385.0
     1-189.0*cn2))-9.0*cn2+21.0)+gmp2*(f3d32*gmp2*(theta4*(45.0*cn2
     2+360.0*cn+385.0)+theta2*(90.0-192.0*cn-126.0*cn2)+(24.0*cn
     3+25.0*cn2-35))+f3d2*(5*theta2-1)))
      hdot=anu*(gmp4*f5d4*theta*(3.0-7.0*theta2)*(5.0-3.0*cn2)+gmp2
     1*(gmp2*f3d8*(theta*(12.0*cn+9.0*cn2-5.0)-theta*theta2*(5.0*cn2
     2+36.0*cn+35.0))-3*theta))
  155 if(iflg.eq.1)go to 19
ci--------------------------------------------i
ci compute isubc to test critical inclination i
ci--------------------------------------------i
      bisubc=((1.0-5.0*theta2)**(-2))*((25.0*theta4*theta)*(gmp2*edp2))
      iflg=1
ci--------------------------------------i
ci first check for critical inclination i
ci--------------------------------------i
      if(bisubc.gt.bksubc)go to 158
      assign 163 to id8
      go to 159
c-------------------------------i
c is there critical inclination i
c-------------------------------i
   19 if(bisubc.gt.bksubc)go to 150
  159 if(ipert.eq.1)go to 150
      gm3=bk3/adp**3
      gmp3=gm3/(cn2*cn2*cn2)
      gm5=bk5/adp**5
      gmp5=gm5/cn**10
      g3dg2=gmp3/gmp2
      g4dg2=gmp4/gmp2
      g5dg2=gmp5/gmp2
ci---------------i
ci compute a1-a8 i
ci---------------i
      a1=(f1d8*gmp2*cn2)*(1.0-11.0*theta2-((40.0*theta4)/(1.0-5.0*theta2
     1)))
      a2=(f5d12*g4dg2*cn2)*(1.0-((8.0*theta4)/(1.0-5.0*theta2))-3.0
     1*theta2)
      a3=g5dg2*((3.0*edp2)+4.0)
      a4=g5dg2*(1.0-(24.0*theta4)/(1.0-5.0*theta2)-9.0*theta2)
      a5=(g5dg2*(3.0*edp2+4.0))*(1.0-(24.0*theta4)/(1.0-5.0*theta2)-9.0
     1*theta2)
      a6=g3dg2*f1d4
      sini=dsin(bidp)
      a10=cn2*sini
      a7=a6*a10
      a8p=g5dg2*edp*(1.0-(16.0*theta4)/(1.0-5.0*theta2)-5.0*theta2)
      a8=a8p*edp
c
c    compute b13-b15
c
      b13=edp*(a1-a2)
      b14=a7+f5d64*a5*a10
      b15=a8*a10*f35384
c
c   compute a11-a27
c
      a11=2.0+edp2
      a12=3.0*edp2+2.0
      a13=theta2*a12
      a14=(5.0*edp2+2.0)*(theta4/(1.0-5.0*theta2))
      a17=theta4/((1.0-5.0*theta2)*(1.0-5.0*theta2))
      a15=(edp2*theta4*theta2)/((1.0-5.0*theta2)*(1.0-5.0*theta2))
      a16=theta2/(1.0-5.0*theta2)
      a18=edp*sini
      a19=a18/(1.0+cn)
      a21=edp*theta
      a22=edp2*theta
      sini2=dsin(bidp/2.0)
      cosi2=dcos(bidp/2.0)
      tani2=dtan(bidp/2.0)
      a26=16.0*a16+40.0*a17+3.0
      a27=a22*f1d8*(11.0+200.0*a17+80.0*a16)
ci----------------i
ci compute b1-b12 i
ci----------------i
      b1=cn*(a1-a2)-((a11-400.0*a15-40.0*a14-11.0*a13)*f1d16+(11.0+200.0
     1*a17+80.0*a16)*a22*f1d8)*gmp2+((-80.0*a15-8.0*a14-3.0*a13+a11)
     2*f5d24+f5d12*a26*a22)*g4dg2
      b2=a6*a19*(2.0+cn-edp2)+f5d64*a5*a19*cn2-f15d32*a4*a18*cn*cn2
     1+(f5d64*a5+a6)*a21*tani2+(9.0*edp2+26.0)*f5d64*a4*a18+f15d32*a3
     2*a21*a26*sini*(1.0-theta)
      b3=((80.0*a17+5.0+32.0*a16)*a22*sini*(theta-1.0)*f35576*g5dg2*edp)
     1-((a22*tani2+(2.0*edp2+3.0*(1.0-cn2*cn))*sini)*f35d52*a8p)
      b4=cn*edp*(a1-a2)
      b5=((9.0*edp2+4.0)*a10*a4*f5d64+a7)*cn
      b6=f35384*a8*cn2*cn*sini
      b7=((cn2*a18)/(1.0-5.0*theta2))*(f1d8*gmp2*(1.0-15.0*theta2)+(1.0
     1-7.0*theta2)*g4dg2*(-f5d12))
      b8=f5d64*(a3*cn2*(1.0-9.0*theta2-(24.0*theta4/(1.0-5.0*theta2))))
     1+a6*cn2
      b9=a8*f35384*cn2
      b10=sini*(a22*a26*g4dg2*f5d12-a27*gmp2)
      b11=a21*(a5*f5d64+a6+a3*a26*f15d32*sini*sini)
      b12=-((80.0*a17+32.0*a16+5.0)*(a22*edp*sini*sini*f35576*g5dg2)+(a8
     1*a21*f35d52))
  150 if(ipert.eq.0)go to 7
      if(idmean.eq.0)go to 4
c-----------------------i
c compute secular terms i
c-----------------------i
ci-----------------------i
ci ''mean'' mean anomaly i
ci-----------------------i
      bldp = anu*delt + bldot*delt + bl0
      bldp = dmod(bldp,pi2)
      if(bldp.lt.0.0d0)bldp = bldp + pi2
ci---------------------------i
ci  mean argument of perigee i
ci---------------------------i
      gdp = gdot*delt  + g0
      gdp = dmod(gdp,pi2)
      if(gdp.lt.0.0d0)gdp = gdp + pi2
c   mean longitude of ascending node
      hdp = hdot*delt + h0
      hdp = dmod(hdp,pi2)
      if(hdp.lt.0.0d0)hdp = hdp + pi2
    4 do 33 nn=1,6
   33 oscele(nn) = dpele(nn)
      a = adp
      e = edp
      bi = bidp
      h = hdp
      g = gdp
      bl = bldp
ci-------------------------------------i
ci compute true anomaly(double primed) i
ci-------------------------------------i
      eadp = dkeplr(bldp,edp)
      sinde= dsin(eadp)
      cosde= dcos(eadp)
      sinfd= cn*sinde
      cosfd= cosde - edp
      fdp = datan0(sinfd,cosfd)
      if(ipert.eq.1)go to 7
      dadr=(1.0-edp*cosde)**(-1)
      sinfd=sinfd*dadr
      cosfd=cosfd*dadr
      cs2gfd=dcos(2.0*gdp+2.0*fdp)
      dadr2=dadr*dadr
      dadr3=dadr2*dadr
      cosfd2=cosfd*cosfd
ci----------------------------i
ci compute a(semi-major axis) i
ci----------------------------i
      a=adp*(1.0+gm2*((3.0*theta2-1.0)*(edp2/(cn2*cn2*cn2))*(cn+(1.0/(1.
     1+cn)))+((3.0*theta2-1.0)/(cn2*cn2*cn2))*(edp*cosfd)*(3.0+3.0*edp
     2*cosfd+edp2*cosfd2)+3.0*(1.0-theta2)*dadr3*cs2gfd))
      sn2gfd=dsin(2.0*gdp+2.0*fdp)
      snf2gd=dsin(2.0*gdp+fdp)
      csf2gd=dcos(2.0*gdp+fdp)
      sn2gd=dsin(2.0*gdp)
      cs2gd=dcos(2.0*gdp)
      sn3gd=dsin(3.0*gdp)
      cs3gd=dcos(3.0*gdp)
      sn3fgd=dsin(3.0*fdp+2.0*gdp)
      cs3fgd=dcos(3.0*fdp+2.0*gdp)
      singd=dsin(gdp)
      cosgd=dcos(gdp)
      go to id8,(163,164)
  163 dlt1e=b14*singd+b13*cs2gd-b15*sn3gd
ci------------------------i
ci compute (l+g+h) primed i
ci------------------------i
      blghp=hdp+gdp+bldp+b3*cs3gd+b1*sn2gd+b2*cosgd
      blghp=dmod(blghp,pi2)
      if(blghp.lt.0.0d0)blghp=blghp+pi2
      edpdl=b4*sn2gd-b5*cosgd+b6*cs3gd-f1d4*cn2*cn*gmp2*(2.0*(3.0*theta2
     1-1.0)*(dadr2*cn2+dadr+1.0)*sinfd+3.0*(1.0-theta2)*((-dadr2*cn2
     2-dadr+1.0)*snf2gd+(dadr2*cn2+dadr+f1d3)*sn3fgd))
      dlti=f1d2*theta*gmp2*sini*(edp*cs3fgd+3.0*(edp*csf2gd+cs2gfd))
     1-(a21/cn2)*(b8*singd+b7*cs2gd-b9*sn3gd)
      sindh=(1.0/cosi2)*(f1d2*(b12*cs3gd+b11*cosgd+b10*sn2gd-(f1d2*gmp2
     1*theta*sini*(6.0*(edp*sinfd-bldp+fdp)-(3.0*(sn2gfd+edp*snf2gd)+edp
     2*sn3fgd)))))
ci-----------------i
ci compute (l+g+h) i
ci-----------------i
  164 blgh=blghp+((1.0/(cn+1.0))*f1d4*edp*gmp2*cn2*(3.0*(1.0-theta2)*
     1(sn3fgd*(f1d3+dadr2*cn2+dadr)+snf2gd*(1.0-(dadr2*cn2+dadr)))+2.0*
     2sinfd*(3.0*theta2-1.0)*(dadr2*cn2+dadr+1.0)))+gmp2*f3d2*((-2.0*
     3theta-1.0+5.0*theta2)*(edp*sinfd+fdp-bldp))+(3.0+2.0*theta-5.0*
     4theta2)*(gmp2*f1d4*(edp*sn3fgd+3.0*(sn2gfd+edp*snf2gd)))
      blgh=dmod(blgh,pi2)
      if(blgh.lt.0.0d0)blgh=blgh+pi2
      dlte=dlt1e+(f1d2*cn2*((3.0*(1.0/(cn2*cn2*cn2))*gm2*(1.0-theta2)
     1*cs2gfd*(3.0*edp*cosfd2+3.0*cosfd+edp2*cosfd*cosfd2+edp))-(gmp2
     2*(1.0-theta2)*(3.0*csf2gd+cs3fgd))+(3.0*theta2-1.0)*gm2*(1.0/
     3(cn2*cn2*cn2))*(edp*cn+(edp/(1.0+cn))+3.0*edp*cosfd2+3.0*cosfd+
     4edp2*cosfd*cosfd2)))
      edpdl2=edpdl*edpdl
      edpde2=(edp+dlte)*(edp+dlte)
ci-------------------------i
ci compute e(eccentricity) i
ci-------------------------i
      e=dsqrt(edpdl2+edpde2)
      sindh2=sindh*sindh
      squar=(dlti*cosi2*f1d2+sini2)*(dlti*cosi2*f1d2+sini2)
      sqri=dsqrt(sindh2+squar)
ci--------------------------i
ci compute bi (inclination) i
ci--------------------------i
      bi=dasin(sqri)
      bi=2.0*bi
      bi=dmod(bi,pi2)
      if(bi.lt.0.0d0)bi=bi+pi2
ci-----------------------------i
ci check for e(eccentricity)=0 i
ci-----------------------------i
      if(e.ne.0.0) go to 168
      bl=0.0
ci-----------------------------i
ci check for bi(inclination)=0 i
ci-----------------------------i
  145 if(bi.ne.0.0) go to 169
      h=0.0
ci---------------------------------i
ci compute g(argument  of perigee) i
ci---------------------------------i
  146 g=blgh-bl-h
      g=dmod(g,pi2)
      if(g.lt.0.0d0)g=g+pi2
ci----------------------i
ci compute true anomaly i
ci----------------------i
      ea   = dkeplr(bl,e)
      arg1 = dsin(ea) * dsqrt(1.0-e**2)
      arg2 = dcos(ea) - e
      f = datan0(arg1,arg2)
c
c
      oscele(1) = a*ae
      oscele(2) = e
      oscele(3) = bi
      oscele(4) = h
      oscele(5) = g
      oscele(6) = bl
    7 continue
      dpele(1) = adp*ae
      dpele(2) = edp
      dpele(3) = bidp
      dpele(4) = hdp
      dpele(5) = gdp
      dpele(6) = bldp
      if(ipert.eq.0)bl = dmod(anu*delt,pi2)
      orbel(1) = eadp
      orbel(2) = gdp + fdp
      orbel(3) = gdp
      orbel(4) = ek*(anu + bldot)
      orbel(5) = fdp
      r = a*ae*(1.0d0 - e*dcos(ea))
      go to 45
ci----------------------------------------i
ci modifications for critical inclination i
ci----------------------------------------i
  158 dlt1e=0.0
      blghp=0.0
      edpdl=0.0
      dlti=0.0
      sindh=0.0
      assign 164 to id8
      go to 150
  168 sinldp=dsin(bldp)
      cosldp=dcos(bldp)
      sinhdp=dsin(hdp)
      coshdp=dcos(hdp)
ci-------------------------i
ci compute l(mean anomaly) i
ci-------------------------i
      arg1=edpdl*cosldp+(edp+dlte)*sinldp
      arg2=(edp+dlte)*cosldp-(edpdl*sinldp)
      bl=datan2(arg1,arg2)
      bl=dmod(bl,pi2)
      if(bl.lt.0.0d0)bl=bl+pi2
      go to 145
ci----------------------------------------i
ci compute h(longitude of ascending node) i
ci----------------------------------------i
  169 arg1=sindh*coshdp+sinhdp*(f1d2*dlti*cosi2+sini2)
      arg2=coshdp*(f1d2*dlti*cosi2+sini2)-(sindh*sinhdp)
      h=datan2(arg1,arg2)
      h=dmod(h,pi2)
      if(h.lt.0.0d0)h=h+pi2
      go to 146
   45 continue
      return
      end
