      subroutine brworb (xto,xdto,oscele,dpele,ipert,ipass,idmean,orbel)
c**********************************************************************
c*                                                                    *
c     version 2.3
c*                                                                    *
c**********************************************************************
c*                                                                    *
c* purpose                                                            *
c*    to control calls to brouwr and brolyd                           *
c*                                                                    *
c**********************************************************************
c*                                                                    *
c* arguments in calling sequence                                      *
c*                                                                    *
c*    input/output                                                    *
c*      dpele(i)  - input is osculating elements if idmean=0          *
c*                           brouwer mean if idmean not equal to 0    *
c*                  output elements are brouwer mean                  *
c*                                                                    *
c*    input                                                           *
c*      idmean    - determines which elements (dpele) are input       *
c*                  =0, osculating                                    *
c*                  not = 0, brouwer mean                             *
c*      ipass     - if=1, compute constants needed in computation of  *
c*                        osculating elements                         *
c*                  if=2, update osculating elements to               *
c*                        observation time                            *
c*      ipert     - if=0, no perturbations due to oblateness computed *
c*                  if=1, secular terms computed                      *
c*                  if=2, secular + long and short terms              *
c*                                                                    *
c*    output                                                          *
c*      orbel(i)  - auxiliary orbital elements                        *
c*      oscele(i) - osculating elements                               *
c*      xdto(1)   - spacecraft velocity vector                        *
c*      xto(1)    - spacecraft position vector                        *
c* programmer      -     viona i. brown      code 582.1               *
c**********************************************************************
      implicit real*8(a-h,o-z),integer*4(i-n)
      dimension      dpele(6)  ,
     d               orbel(20) ,oscele(6),xto(3)   ,xdto(3)
      common /blcnst/ tto,r,ae,gm,bj2,bj3,bj4,bj5,fltinv,xke,esq
      call brolyd (oscele,dpele,ipert,ipass,idmean,orbel)
      call celem (oscele,gm,xto,xdto)
      return
      end
