      double precision function datan0(arg1,arg2)
c        version of 03/10/71
c
c        fortran iv function subroutine for the ibm-360
c
c        purpose
c           compute a value for the arctan between 0 and 2 pi where the
c           tangent is defined by the two input arguments as arg1/arg2
c
c        calling sequence
c           none
c        input
c           arg1 - fist argument of the arc tangent
c           arg2 - second argument of the arc tangent
c
c        output
c           a double precision arc tangent (+ value between 0 and 2pi)
c
c        method
c
c           uses fortran math subroutine datan2 which returns a value
c           between -pi and pi given two arguments
c
c        required subroutines
c           1- function subroutine datan2
c
c        programmer
c           r. e. gillian - computing and software
c
c********start program**************************************************
c
c        compute arctan between -pi and pi
c
      implicit real*8 (a-h,p-z)
   50 datan0=datan2(arg1,arg2)
c
c        if arctan is negative, add 2pi to the result
c
  100 if(datan0.ge.0) go to 999
      datan0 = datan0 + 6.283185307179586d0
        arg = datan0
  999 return
      end
