      subroutine eleme(ictype,ibody,posi,veli,elems,sphcor,orbel)
c
c     version of june 1974
c     modified by j.fein csc to calculate orbel array when ictype =2
c         fortran subroutine for ibm 360
c     purpose
c         to convert an element set vector input as cartesian, keplerian
c         orbit elements, or spherical coordinates to the remaining two
c         systems
c     calling sequence
c           call eleme(ictype,ibody,posi,veli,elems,sphcor,orbel)
c     calling sequence variables
c     input
c     ibody  = central body to which posit & vel are referenced
c     input/output
c     ictype = 1=cartesian  2=keplerian  3=spherical  4=dods
c     posi   = s/c position vector
c     veli   = s/c velocity vector
c     elems  = keplerian orbit elements
c     sphcor = spherical coordinates
c     orbel   = orbital elements computed in elem
c     common block variables
c     input
c     gm     = gravitational constant
c     ab     = mean radius of central body
c     references
c         gtds task name - element set conversions (eleme)
c     programmer
c         allen l. cohen - computer sciences corp.
c     modified by f. mcgarry 1/4/72
c        change calling sequence of elem
c
c     modified 1/20/72 by f mcgarry to include orbel in the calling
c     sequence instead of in common
c     modified 9/21/73 by robert a. gordon to correct dods coordinate
c                         conversion (ictype = 4)
c     .  4/1/74 c. l. berry csc
c     .  modified to accomodate n-body capability
c     modified on 6/01/74 by j.todd updating utilization of -j2 due to
c     increase of harmonics field to 21x21
c
c*****start program*****************************************************
c
      implicit real*8 (a-h,o-z)
      common /blcnst/ tto,r,ae,gm,bj2,bj3,bj4,bj5,fltinv,xke,esq
      dimension             orbel(20)
      dimension posi(3),veli(3),elems(6),sphcor(6)
      dimension dmn(6)
      c2=-bj2
c
c     test for coordinate system type
c            cartesian   keplerian   spherical   dods
      go to (   10,         20,         30,       20 ),   ictype
c
c     convert to elements & spherical
c
   10 call elem(posi,veli,gm,ae,c2,1,elems,orbel)
      go to 40
c
c     convert to cartesian & spherical
c
   20 call celem(elems,gm,posi,veli)
c
c      call elem to compute the orbel array
      call elem(posi,veli,gm,ae,c2,1,dmn,orbel)
      go to 40
c
c     convert to cartesian & elements
c
   30 call elem(posi,veli,gm,ae,c2,1,elems,orbel)
   40 ictype = 1
  999 return
      end
