!+
!NOM/NAME $Id: hd1bnav.F 25 2006-02-03 15:43:53Z frna $
!
        subroutine hd1bnav(modelid,nadloctol,locbit,yawerr,
     & rollerr,pitcherr,epoyr,epody,
     & epotime,smaxis,eccen,incli,
     & argper,rascnod,manom,xpos,
     & ypos,zpos,xvel,yvel,zvel,earthsun)
!BUT/PURPOSE 
! update header 1b navigation variables 
! 
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
! 
!PROPRIETAIRE/OWNER
!  
!Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0        Nov.  95  none          Marcel Derrien
! 1.1        May   98  change 1B     Marcel Derrien
!                  add modelid argument from p_earth.h include file
!                  change scaling factors for smaxis pos vel
!         
!ARGUMENTS 
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
!arguments
      character*8 modelid
      integer*2 nadloctol,locbit,yawerr
      integer*2 rollerr,pitcherr,epoyr,epody
      integer epotime,smaxis,eccen,incli
      integer argper,rascnod,manom,xpos
      integer ypos,zpos,xvel,yvel,zvel,earthsun
! 
!    
!
!commons
#include "p_earth.h"
#include "c_satpos.h"
#include "c_1bnav.h"
!
!local variables
        integer iq(3)
        double precision posun(3),dist
!-
        modelid= earth_modelid
        nadloctol = 0
        call gp_sb16(locbit,0,1) 
!
! attitude (converted to degrees * 1000)
        yawerr = yaw * crd *1.e+03
        rollerr = roll * crd *1.e+03
        pitcherr = pitch * crd *1.e+03

! orbital elements used
        call xijq(sp_epoch,iq)
        epoyr=iq(1)
        epody =iq(2)
        epotime = iq(3)
        smaxis = sp_semaxis * 1.e+05
        eccen = sp_eccent * 1.e+08
        incli = sp_inclin * crd *1.e+05
        argper = sp_argper * crd *1.e+05
        rascnod = sp_rigasc * crd *1.e+05
        manom = sp_meanano * crd *1.e+05
        xpos = sp_x * 1.e+05
        ypos = sp_y * 1.e+05
        zpos = sp_z * 1.e+05
        xvel = sp_vx * 1.e+08
        yvel = sp_vy * 1.e+08
        zvel = sp_vz * 1.e+08

! compute the earth/sun distance ratio
        call sunpos(sp_epoch,posun,dist)
! the distance is divided by the astronomical unit (A U = 149.599.000km)
        earthsun = (dist / 0.1495990d9) * 1.e+06

        return
        end


