
       SUBROUTINE osc_to_rec(PARAM, POVI, IER)
!
!NOM/NAME  $Id: osc_to_rec.F 30 2006-04-06 15:03:47Z frna $        
!
!BUT/PURPOSE 
!     convert osculating elemnts to rectangular, same ref frame
!DESCRIPTION 
!     code from CNES mosaik library (subroutine orrec)
!
!PROPRIETAIRE/OWNER
!       P. Brunel - A. Marsouin
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date        comment           <author>)
! 1.0      Feb 2006      no          A. Marsouin P.Brunel
!         
!COPYRIGHT (c) Meteo-France (NWP SAF - EUMETSAT project <2006>)
!
!
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
!ARGUMENTS 
! Input
       DIMENSION PARAM(6)
!
! Output
       DIMENSION POVI(6)
!DECLARATIONS
!
! Local variables
C
       double precision xmu, pi, cdr
       parameter (    XMU=0.39860064D+6 )
       DATA PI/3.141592653589793238D0/
! 
!-
       CDR=PI/180.
 
C     ******************************************************************
C     PASSAGE DES ELEMENTS OSCULATEURS AUX ELEMENTS RECTANGULAIRES
C     CORRESPONDANTS DANS UN REPERE GEOCENTRIQUE
C     ******************************************************************
C     ANGLES EN DEGRES SI IDEGRE=1
C     IER CODE D ERREUR DE LA FONCTION XKepler
C     ******************************************************************
C     BON FONCTIONNEMENT     IER=0,-2,-3
C     XK N A PAS CONVERGEE   IER=1
C     MAUVAISE EXCENTRICITE  IER=4,5
C     ******************************************************************
C
       A=PARAM(1)
       EXC=PARAM(2)
       XI=PARAM(3)
       POM=PARAM(4)
       OM=PARAM(5)
       XMOY=PARAM(6)
       IDEGRE=0
       XN= DSQRT(XMU/A**3)
       RAD=CDR
       IF(IDEGRE.NE.1) RAD=1.
       XA=XI*RAD
       OA=OM*RAD
       POA=POM*RAD
       XMOA=XMOY*RAD
       CPOM= DCOS(POA)
       COM= DCOS(OA)
       CXI= DCOS(XA)
       SPOM= DSIN(POA)
       SOM= DSIN(OA)
       SXI= DSIN(XA)
       PX=CPOM*COM-CXI*SOM*SPOM
       PY=CPOM*SOM+CXI*COM*SPOM
       PZ=SXI*SPOM
       QX=-SPOM*COM-CXI*SOM*CPOM
       QY=-SPOM*SOM+CXI*COM*CPOM
       QZ=CPOM*SXI
       AEX= XKepler(XMOA,EXC,IER)
       IF(IER.GT.0) RETURN
       CAEX= DCOS(AEX)
       SAEX= DSIN(AEX)
       DE=XN/(1.D0-EXC*CAEX)
       SQ= DSQRT(1.D0-EXC**2)
       X1=A*(PX*(CAEX-EXC)+QX*SQ*SAEX)
       X2=A*(PY*(CAEX-EXC)+QY*SQ*SAEX)
       X3=A*(PZ*(CAEX-EXC)+QZ*SQ*SAEX)
       XP1=A*DE*(QX*CAEX*SQ-PX*SAEX)
       XP2=A*DE*(QY*CAEX*SQ-PY*SAEX)
       XP3=A*DE*(QZ*CAEX*SQ-PZ*SAEX)
       POVI(1)=X1
       POVI(2)=X2
       POVI(3)=X3
       POVI(4)=XP1
       POVI(5)=XP2
       POVI(6)=XP3
       RETURN
       END
