        subroutine rotz2v(angle,u_old,v_old,u_new,v_new)
!+
!NOM/NAME $Id: rotz2v.F 25 2006-02-03 15:43:53Z frna $
!
!BUT/PURPOSE
!
!       calculates the coordinates of two vectors in a new reference frame
!       obtained from the old reference frame by a rotation along z axis
!
!DESCRIPTION 
!       FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions
! 
!
!PROPRIETAIRE/OWNER
!       P. Brunel - A. Marsouin
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date        comment           <author>)
! 1.0   01 Jul 1995      no          A. Marsouin P.Brunel
!         
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
        implicit none                                                     
!
!ARGUMENTS 
! Input
        double precision u_old(3)       ! first vector in old reference frame
        double precision v_old(3)       ! second vector in old reference frame
        double precision angle          ! rotation angle from old to new  (rad)
! Output
        double precision u_new(3)       ! first vector in new reference frame
        double precision v_new(3)       ! second vector in new reference frame
!
!
!DECLARATIONS
!
!
!
! Local parameters
!
! Commons
!
! Functions
!
! Local variables
! 
        double precision ca, sa         ! cosinus and sinus of angle
!-
!
        ca = dcos(angle)
        sa = dsin(angle)
        u_new(1) =   ca * u_old(1) +  sa * u_old(2)
        u_new(2) = - sa * u_old(1) +  ca * u_old(2)
        u_new(3) = u_old(3)

        v_new(1) =   ca * v_old(1) +  sa * v_old(2)
        v_new(2) = - sa * v_old(1) +  ca * v_old(2)
        v_new(3) = v_old(3)

        return

        end
