        double precision function sidert50(time)
!+
!NOM/NAME $Id: sidert50.F 25 2006-02-03 15:43:53Z frna $
!
!BUT/PURPOSE 
!       calculates the rotation angle in radians
!       from the quasi-inertial 1950 reference frame (Veis reference frame)
!       to the Greenwich reference frame
!
!       Greenwich right ascension = 1950 right ascension - sidert50
!
!DESCRIPTION 
!       FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions 
!
!       the formula has been supplied by CNES
!
!PROPRIETAIRE/OWNER
!       P. Brunel - A. Marsouin
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date        comment           <author>)
! 1.0   01 Jul 1995      no          A. Marsouin P.Brunel
!         
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
        implicit none                                                     
!
!ARGUMENTS 
! Input
        double precision time           ! julian instant
!
!
!DECLARATIONS
!
!
!
! Local parameters
      double precision twopi            ! = 2 * pi
      parameter ( twopi = 6.283185307179586476d0 )
!
! Commons
!
! Functions
!
! Local variables
! 
!-
!
        sidert50 = 1.746647708617865d0 + 6.30038748673296d0 * time
        sidert50 = dmod(sidert50,twopi)
        return
        end
