       DOUBLE PRECISION FUNCTION XKepler(AM,EX,IER)
!
!NOM/NAME  $Id: xkepler.F 30 2006-04-06 15:03:47Z frna $        
!
!BUT/PURPOSE 
C     ******************************************************************
C     RESOLUTION DE L EQUATION DE KEPLER PAR LA METHODE DE NEWTON
C     INITIALISATION DE ENCKE
C     ******************************************************************
C     AM = ANOMALIE MOYENNE (RADIANS)
C     EX = EXCENTRICITE
C     IER= CODE D ERREUR
C     ******************************************************************
C     IER=0 BON  FONCTIONNEMENT
C     IER=1 ARRET AU BOUT DE 10 ITERATIONS
C   POUR FAIRE 10 NOUVELLES ITERATIONS APPEL AVEC IER=10
C     IER=-2ANOMALIE MOYENNE INFERIEURE A 10-12  XK=0.
C     IER=-3EXCENTRICITE     INFERIEURE A 10-12  XK=AM
C     IER=4 EXCENTRICITE SUPERIEURE A 1
C     IER=5 EXCENTRICITE NEGATIVE
C     ******************************************************************
C
!DESCRIPTION 
!     code from CNES mosaik library (function xk)
!
!PROPRIETAIRE/OWNER
!       P. Brunel - A. Marsouin
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date        comment           <author>)
! 1.0      Feb 2006      no          A. Marsouin P.Brunel
!         
!COPYRIGHT (c) Meteo-France (NWP SAF - EUMETSAT project <2006>)
!
!
! 
!-
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      IF(IER.EQ.10) GO TO 80
      IF(EX.LT.0.E0) GO TO 82
      IF(EX.GE.1.E0) GO TO 81
      AMI=0.1E-11
      EPS=0.1E-11
      IF(EX.LE.EPS) GO TO 70
      IF(DABS(AM).LE.AMI) GO TO 50
      SI=DSIN(AM)
      CO=DCOS(AM)
      Z=EX*SI/DSQRT(EX*EX+1.D0-2.D0*EX*CO)
      EI=AM+Z-Z*Z*Z*Z*CO/(SI*6.D0)*(1.D0-EX*EX)
   80 CONTINUE
      IER=0
      DO 60 I=1,10
      ES=EI+(AM+EX*DSIN(EI)-EI)/(1.D0-EX*DCOS(EI))
      DELTAE=DABS(ES-EI)
      IF(DELTAE.LE.EPS) GO TO 30
   60 EI=ES
      IER=1
   30 XKEPLER=ES
      RETURN
   50 XKEPLER=0.
      IER=-2
      RETURN
   70 XKEPLER=AM
      IER=-3
      RETURN
   81 IER=4
      RETURN
82    IER=5
      RETURN
      END
