        subroutine clkdatnorm(inpdate,outdate)
!+
!NOM/NAME $Id: clkdatnorm.F 25 2006-02-03 15:43:53Z frna $
!
!BUT/PURPOSE 
!       normalize a string date to dd/mm/yy
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions   
!       The subroutine takes a date mm/dd/yy or m/dd/yy or m/d/yy ...
!       and creates a full date dd/mm/yy
!
!
!PROPRIETAIRE/OWNER
!       P. Brunel - A. Marsouin
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date        comment           <author>)
! 1.0   01 Jul 1995      no          A. Marsouin P.Brunel
!         
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!ARGUMENTS 
        character*(*) inpdate   ! input date
        character*8 outdate     ! output date
!
!DECLARATIONS
!
!
!
!
! Functions
!
! Local variables:
        integer is1                     ! index in strings
        integer is2                     ! index in strings
        integer is3                     ! index in strings
        integer ival                    ! value of the first character
        integer dmy                     ! day , month or year
        integer ios                     ! I/O status
        logical daterr                  ! true if there is an error
!
!-
!
        outdate='01/01/50'


!       1 create a dd/mm/yy type date corresponding to the input date

        read(inpdate(1:1),'(i1)',iostat=ios) ival
        if(ios.ne.0) then
c               the first character is not a number
                inpdate(1:1)='0'
        endif

        is1=index(inpdate,'/')
        if(is1.ne.0) then
          if(is1.eq.2) then
           outdate(4:4)='0'
           outdate(5:5)=inpdate(1:1)
          elseif(is1.eq.3) then
           outdate(4:4)=inpdate(1:1)
           outdate(5:5)=inpdate(2:2)
          endif
           
        is2=index(inpdate(is1+1:8),'/')
          is3=is1+is2
          if(is2.eq.2) then
           outdate(1:1)='0'
           outdate(2:2)=inpdate(is3-1:is3-1)
          elseif(is2.eq.3) then
           outdate(1:1)=inpdate(is3-2:is3-2)
           outdate(2:2)=inpdate(is3-1:is3-1)
          endif
        
        outdate(7:8)=inpdate(is3+1:is3+2)
        endif
        outdate(3:3)='/'
        outdate(6:6)='/'


!       2 check if the outdate variable is OK

        read(outdate(1:2),'(i2)',iostat=ios) dmy
        daterr = ios.ne.0 .or. dmy.le.0 .or. dmy.gt.31

        read(outdate(4:5),'(i2)',iostat=ios) dmy
        daterr = daterr .or. 
     &           (ios.ne.0 .or. dmy.le.0 .or. dmy.gt.12) 

        read(outdate(7:8),'(i2)',iostat=ios) dmy
        daterr = daterr .or.
     &           (ios.ne.0 .or. dmy.lt.0 .or. dmy.gt.99) 

        if(daterr) then
          outdate='01/01/50'
        endif

        

        return
        end
