        subroutine clkerr_wind(clkerru)
!+
!NOM/NAME $Id: clkerr_wind.F 46 2006-08-18 14:39:27Z frna $
!
!BUT/PURPOSE 
!       writes 1 to 4 records at the end of the clock error index file
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!       go to the end of the file and writes
!
!
!PROPRIETAIRE/OWNER
!       P. Brunel - A. Marsouin
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date        comment           <author>)
! 1.0   01 Jul 1995      no          A. Marsouin P.Brunel
! 1.1   07/08/01       rewinds the file before going the the end   P. Brunel
! 1.2   17 Aug 2006   insert "backspace clkerru". NCA
!         
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!       xdjc            ! conversion from julian date to string (f7tp)
!
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!ARGUMENTS 
        integer clkerru         ! logical unit of the index file
!
!DECLARATIONS
!
!
!
! Common declarations:
!
! Local parameters:
!
! Commons
! Clock information
#include "c_clkerr.h"
!
! Functions
!
! Local variables:
        integer ios                     ! I/O status variable
        character*10 dummyst            ! dummy string
        character*8 datest              ! date string
! 
!-
!
!       rewind the file
        rewind clkerru

!       go to the end of the file
        ios = 0
        do while (ios.eq.0) 
          read(clkerru,'(a10)',iostat=ios) dummyst
        end do
        backspace clkerru

        if(last_date.gt.0) then
          call xdjc(last_date,datest)
          write(clkerru,'(a4,i6,f8.3,2x,a8)') 
     &          'last',last_date, last_val, datest
        endif

        if(err_date.gt.0) then
          call xdjc(err_date,datest)
          write(clkerru,'(a4,i6,f8.3,2x,a8)') 
     &          'cerr',err_date, err_val, datest
        endif

        if(rate_date.gt.0) then
          call xdjc(rate_date,datest)
          write(clkerru,'(a4,i6,f8.3,2x,a8)') 
     &          'rate',rate_date, rate_val, datest
        endif

        if(next_date.gt.0) then
          call xdjc(next_date,datest)
          write(clkerru,'(a4,i6,8x,2x,a8)') 
     &          'next',next_date, datest
        endif

        return

        end
