        subroutine clkvalnorm(inpstr,val)
!+
!NOM/NAME $Id: clkvalnorm.F 25 2006-02-03 15:43:53Z frna $
!
!BUT/PURPOSE 
!       decodes a real value in a 5 character string
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions   
!       the input string must be 1 to 5 non blanck alphanum. characters
!       with a valid number at the beginning of the string
!       examples of allowed strings 
!       12.34 or 123.4 or   12abc (decoded = 12)  or 1.23a (decoded = 1.23)
!
! Revision 23 january 96:
!       filter the non-numbers characters NOW the following strings are allowed
!       a123b   12.a3   
!
!       if there is an error the value is set to -999.
!PROPRIETAIRE/OWNER
!       P. Brunel - A. Marsouin
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date        comment           <author>)
! 1.0   01 Jul 1995      no          A. Marsouin P.Brunel
!         
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!ARGUMENTS 
        character*(*) inpstr    ! input string
        real val                ! decoded value
!
!DECLARATIONS
!
!
!
!
! Functions
!
! Local variables:
        integer i                       ! loop index
        integer is1                     ! index in string
        integer lg                      ! length of string
        integer ival                    ! integer for intenal I/O
        integer ios                     ! I/O status
        character*6 form                ! fortran format
!
!-
!
        val=-999.
        lg=5
!       finds the dot position (real format)
        is1=index(inpstr(1:5),'.')
        
        do i=5,1,-1
          read(inpstr(i:i),'(i1)',iostat=ios) ival
          if(ios.ne.0 .and. i.ne.is1) then
               inpstr(i:i)=' '
          endif
        end do

!       finds the length of the numerical string
        do i=5,1,-1
          read(inpstr(i:i),'(i1)',iostat=ios) ival
          if(ios.ne.0 .and. i.ne.is1) then
               lg=i-1
          endif
        end do

!       if the length is 0 , output the default value
        if(lg.gt.0) then

          if(is1.ne.0) then
!         real format
            write(form,9000) lg,lg-is1
            read(inpstr(1:lg),fmt=form) val

          elseif(lg.gt.0) then
!         integer format
            write(form,9100) lg
            read(inpstr(1:lg),fmt=form) ival
            val=ival

          endif

        endif

        return
9000    format('(f',i1,'.',i1,')')
9100    format('(i',i1,')')

        end
