        subroutine tb_prn(scnam)
!+
!NOM/NAME $Id: tb_prn.F 25 2006-02-03 15:43:53Z frna $
!
!BUT/PURPOSE 
!        
!       Prints TBUS Part IV orbital elements
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!       Outputs the whole common tbus part IV (c_tbus4) on stdout  
!
!
!PROPRIETAIRE/OWNER
!       P. Brunel - A. Marsouin
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date        comment           <author>)
! 1.0   01 Jul 1995      no          A. Marsouin P.Brunel
!         
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!       xijc            ! conversion from julian instant to string (f7tp)
!       xhjc            ! conversion from julian hour to string (f7tp)
!
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!ARGUMENTS 
!input
        character*(*) scnam     ! any authorized NOAA s/c name
!
!DECLARATIONS
!
!
!
! Common declarations:
!
! Local parameters:
        double precision pi     ! PI constant  
        double precision crd    ! conversion factor radians to degrees 

        parameter ( pi = 3.14159265358979311600d0)
        parameter ( crd=180.0d0/pi)
!
! Commons
! common TBUS Part IV
#include "c_tbus4.h"
!
! Functions
!
! Local variables:
        character*22 ic                 ! epoch time string
        character*12 ich                ! string for hh:mm:ss.sss
! 
!-
!
          write(*,8000) scnam
          call xijc(tbus_epoch,ic)
          write(*,8010) ic
          write(*,8020) tbus_epoch
          write(*,8030) tbus_orbnum
          write(*,8040) tbus_tan
          write(*,8050) tbus_gha *crd
          call xhjc(tbus_anoper,ich)
          write(*,8060) ich
          call xhjc(tbus_nodper,ich)
          write(*,8070) ich
          write(*,8080) tbus_semaxis
          write(*,8090) tbus_eccent
          write(*,8100) tbus_inclin *crd
          write(*,8110) tbus_rigasc *crd
          write(*,8120) tbus_argper *crd
          write(*,8130) tbus_meanano *crd
          write(*,8140) tbus_x
          write(*,8150) tbus_y
          write(*,8160) tbus_z
          write(*,8170) tbus_vx
          write(*,8180) tbus_vy
          write(*,8190) tbus_vz
          write(*,8200) tbus_balcoef
          write(*,8210) tbus_dsolflux
          write(*,8220) tbus_msolflux
          write(*,8230) tbus_magind
          write(*,8240) tbus_dragcoef
          write(*,8250) tbus_radpres
          write(*,8260) tbus_permot*crd
          write(*,8270) tbus_rascmot*crd
          write(*,8280) tbus_manomot*crd

        return
8000    format(/,'TBUS part IV for satellite ',a16)
8010    format(/,'epoch time           : ',a22,/)
8020    format('epoch time           : ',f15.9,' (julian days)')
8030    format('orbit number         : ',i5)
8040    format('time of asc. node    : ',f15.9,' (days from january 1)')
8050    format('greenwich hour angle : ',f10.4,'  (deg)')
8060    format('anomalistic period   : ',a12)
8070    format('nodal period         : ',a12)
8080    format('semi major axis      : ',f10.4, '  (km)')
8090    format('eccentricity         : ',f10.9)
8100    format('inclination          : ',f10.5, '  (deg)')
8110    format('right ascension      : ',f10.5, '  (deg)')
8120    format('argument of perigee  : ',f10.5, '  (deg)')
8130    format('mean anomaly         : ',f10.5, '  (deg)')
8140    format('x position component : ',f10.4, '  (km)')
8150    format('y position component : ',f10.4, '  (km)')
8160    format('z position component : ',f10.4, '  (km)')
8170    format('x velocity component : ',f10.7, '  (km/s)')
8180    format('y velocity component : ',f10.7, '  (km/s)')
8190    format('z velocity component : ',f10.7, '  (km/s)')
8200    format('balistic coefficient : ',f10.8, '  (m2/kg)')
8210    format('daily solar flux     : ',i4,6x, '  (10-7 W/m2)')
8220    format('90-day mean sol flux : ',i4,6x, '  (10-7 W/m2)')
8230    format('planetary mag. index : ',i4,6x, '  (2x10-5 gauss)')
8240    format('drag modulation coef.: ',f6.4)
8250    format('radiation press. coef: ',f12.10)
8260    format('perigee motion       : ',f10.5,'  (deg/day)')
8270    format('right ascens. motion : ',f10.5,'  (deg/day)')
8280    format('mean anomaly motion  : ',f10.3,'  (deg/day)')

        end
