        subroutine tb_wind(tbindu,qflag,exterr,tbus_file)
!+
!NOM/NAME $Id: tb_wind.F 46 2006-08-18 14:39:27Z frna $
!
!BUT/PURPOSE 
!       writes a record at the end of the TBUS index file
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!       go to the end of the file and writes
!
!
!PROPRIETAIRE/OWNER
!       P. Brunel - A. Marsouin
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date        comment           <author>)
! 1.0   01 Jul 1995      no          A. Marsouin P.Brunel
! 1.1   17 Aug 2006   insert "backspace tbindu". NCA
!         
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!       xijc            ! conversion from julian instant to string (f7tp)
!       cp_lsc          ! last significant character (f7cp)
!
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!ARGUMENTS 
!input
        integer tbindu          ! logical unit of the index file
        integer qflag           ! quality flag
        real exterr(2)          ! extrapoaltion errors (km/day)
        character*(*) tbus_file ! fullname of the tbus file
!
!DECLARATIONS
!
!
!
! Common declarations:
!
! Local parameters:
!
! Commons
! common TBUS Part IV
#include "c_tbus4.h"
!
! Functions
        integer cp_lsc                  ! last significant character (f7cp)
!
! Local variables:
        integer ios                     ! I/O status variable
        integer lentb                   ! length of the tbus filename
        character*22 ic                 ! epoch time string
        character*10 dummyst            ! dummy string
! 
!-
!
!       go to the end of the file
        read(tbindu,'(a10)',iostat=ios) dummyst
        do while (ios.eq.0) 
          read(tbindu,'(a10)',iostat=ios) dummyst
        end do
        backspace tbindu

!       conversion of the epoch time in a readable string
        call xijc(tbus_epoch,ic)

        lentb = cp_lsc(tbus_file)
        write(tbindu,'(f15.9,1x,i1,1x,i5,2f7.2,1x,a22,1x,a)')
     &        tbus_epoch,qflag,tbus_orbnum,exterr,ic,tbus_file(1:lentb)

        return

        end
