        subroutine tle_prn(scnam)
!+
!NOM/NAME $Id: tle_prn.F 25 2006-02-03 15:43:53Z frna $
!
!BUT/PURPOSE 
!
!       print TLE orbital elements
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!       Outputs the whole common tle on stdout  
!
!
!PROPRIETAIRE/OWNER
!       P. Brunel - A. Marsouin
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date        comment           <author>)
! 1.0   01 April 2004      no          A. Marsouin P.Brunel
!         
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!       xijc            ! conversion from julian instant to string (f7tp)
!
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!ARGUMENTS 
!input
        character*(*) scnam     ! any authorized s/c name
!
!DECLARATIONS
!
!
!
! Common declarations:
!
! Local parameters:
        double precision pi     ! PI constant  
        double precision crd    ! conversion factor radians to degrees 

        parameter ( pi = 3.14159265358979311600d0)
        parameter ( crd=180.0d0/pi)
!
! Commons
! commonn TLE
#include "c_tle.h"
!
! Functions
!
! Local variables:
        character*22 ic                 ! epoch time string
! 
!-
!
          write(*,8000) scnam
          write(*,8001) tle_satnumber
          write(*,8002) tle_satclas
          write(*,8003) tle_intdes
          call xijc(tle_epoch,ic)
          write(*,8010) ic
          write(*,8020) tle_epoch
          write(*,8021) tle_epoch_tlf
          write(*,8030) tle_orbnum
          write(*,8100) tle_inclin *crd
          write(*,8120) tle_rigasc *crd
          write(*,8090) tle_eccent
          write(*,8110) tle_argper *crd
          write(*,8130) tle_meanano *crd
          write(*,8140) tle_meanmotion  * 1440. / (2.d0 * pi)
          write(*,8150) tle_ftdmm * 1440.* 1440. / (2.d0 * pi)
          write(*,8160) tle_stdmm *crd  * 1440.  / (2.d0 * pi)
          write(*,8170) tle_bstar
          write(*,8180) tle_deep

        return
8000    format(/,'TLE elements for satellite ',a16)
8001    format('sat. number          :',i5)
8002    format('sat. classification  :',a1)
8003    format('sat. int. designator :',a8)
8010    format(/,'epoch time           : ',a22,/)
8020    format('epoch time           : ',f15.8,' (julian days)')
8021    format('epoch time           : ',f15.8,' (TLE format)')
8030    format('orbit number         : ',i5)
8090    format('eccentricity         : ',f10.9)
8100    format('inclination          : ',f10.5, '  (deg)')
8110    format('argument of perigee  : ',f10.5, '  (deg)')
8120    format('right ascension      : ',f10.5, '  (deg)')
8130    format('mean anomaly         : ',f10.5, '  (deg)')
8140    format('mean motion          : ',f15.12, ' (revs/day)')
8150    format('first time derivative mean motion:  ',f15.12, 
     &  ' (revs/day/day)')
8160    format('second time derivative mean motion: ',f15.12, 
     &  ' (revs/day/day/day)')
8170    format('BSTAR drag term : ',f15.12, 
     &  ' (???)')
8180    format('Deep space satellite (T/F) : ',l1)

        end
