        subroutine tle_wind(tleindu,qflag,exterr,tle_file)
!+
!NOM/NAME $Id: tle_wind.F 46 2006-08-18 14:39:27Z frna $
!
!BUT/PURPOSE 
!       writes a record at the end of the TLE index file
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!       go to the end of the file and writes
!
!
!PROPRIETAIRE/OWNER
!       P. Brunel - A. Marsouin
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date        comment           <author>)
! 1.0   01 April 2004      no          A. Marsouin P.Brunel
! 1.1   17 Aug 2006   insert "backspace tleindu". NCA
!         
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!       xijc            ! conversion from julian instant to string (f7tp)
!       cp_lsc          ! last significant character (f7cp)
!
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!ARGUMENTS 
!input
        integer tleindu         ! logical unit of the index file
        integer qflag           ! quality flag
        real exterr(2)          ! extrapoaltion errors (km/day)
        character*(*) tle_file ! fullname of the tle file
!
!DECLARATIONS
!
!
!
! Common declarations:
!
! Local parameters:
!
! Commons
! commonn TLE
#include "c_tle.h"
!
! Functions
        integer cp_lsc                  ! last significant character (f7cp)
!
! Local variables:
        integer ios                     ! I/O status variable
        integer lentb                   ! length of the tle filename
        character*22 ic                 ! epoch time string
        character*10 dummyst            ! dummy string
! 
!-
!
!       go to the end of the file
        read(tleindu,'(a10)',iostat=ios) dummyst
        do while (ios.eq.0) 
          read(tleindu,'(a10)',iostat=ios) dummyst
        end do
        backspace tleindu

!       conversion of the epoch time in a readable string
        call xijc(tle_epoch,ic)

        lentb = cp_lsc(tle_file)
        write(tleindu,'(f15.9,1x,i1,1x,i5,2f7.2,1x,a22,1x,a)')
     &        tle_epoch,qflag,tle_orbnum,exterr,ic,
     &        tle_file(1:lentb)

        return

        end
