#!/bin/ksh
#$Id: hiras_channels.ksh 619 2019-02-12 12:49:41Z frna $
#
# script to run hiras_channels.exe
#
# Uses the channel selection in HIRAS.fdf or HIRAS_FSR.fdf (in current
# directory if it exists, otherwise in $DIR_PREPROC).
#
# 12/02/2019  from cris_channels.ksh 
#############################################################################

usage(){
  echo
  echo 'usage : hiras_channels infile outfile'
  echo
}

[ $# -ge 2 ] || { usage; exit 0; }
[ -f $1 ] || { usage; exit 1; }

. "$AAPP_PREFIX/ATOVS_CONF"

max_chan_number=$(od -An -t u4 -j 164 -N 4 $1)
if [ "$max_chan_number" -gt 2000 ]; then
  HIRAS_FDF=${HIRAS_FDF:-HIRAS_FSR.fdf}
  echo "CrIS file is FSR with $max_chan_number channels"
else
  HIRAS_FDF=${HIRAS_FDF:-HIRAS.fdf}
  echo "CrIS file is NSR with $max_chan_number channels"
fi

DIR_HIRAS_PREPROC=${DIR_HIRAS_PREPROC:-${DIR_PREPROC}}

rm -f ${FORT}18 ${FORT}28 ${FORT}55 

if [ -f ${HIRAS_FDF} ]; then
  ln -sf ${HIRAS_FDF} ${FORT}55
else
  ln -sf ${DIR_HIRAS_PREPROC}/${HIRAS_FDF} ${FORT}55
fi
ln -sf $1 ${FORT}18

hiras_channels.exe 
status=$?

[ $status = 0 ] && mv ${FORT}28 $2

rm -f ${FORT}18 ${FORT}28 ${FORT}55

exit $status
