!+ Convert character string to upper case
!
      SUBROUTINE C2Upper ( ChString )
      IMPLICIT NONE
c-----------------------------------------
! Name: $Id: c2upper.F 25 2006-02-03 15:43:53Z frna $
!
! Purpose:
!   Convert character string to upper case
!
! Method:
!   Loop through each character in ChString.
!   Convert any [a-z] to [A-Z]   (without assuming ASCII)
!
! Current Code Owner: R.J.Renshaw
!
! History:
! Version  Date      Comment
!
!  1.0      27/11/96  Original code. (R.J.Renshaw)
!
! Code Description:
!   FORTRAN 77, following AAPP standards
!
! Declarations:
!
! Global variables:
!
! Subroutine arguments
!   Scalar arguments with intent(InOut):
      CHARACTER*(*) ChString      ! character string
!
! Local Scalars:
      INTEGER       i             ! pointer that loops through ChString
      INTEGER       len_string    ! length of ChString
      CHARACTER*1   c             ! char in ChString pointed to by i

!- End of header

!     loop through ChString, converting lowercase characters

      len_string = LEN ( ChString )
      DO i = 1, len_string

!        Get the character pointed to by i
         c = ChString(i:i)

!        Is it a lower-case character ?   If so, convert to upper-case
         IF     ( c .EQ. "a" ) THEN
            ChString(i:i) = "A"
         ELSEIF ( c .EQ. "b" ) THEN
            ChString(i:i) = "B"
         ELSEIF ( c .EQ. "c" ) THEN
            ChString(i:i) = "C"
         ELSEIF ( c .EQ. "d" ) THEN
            ChString(i:i) = "D"
         ELSEIF ( c .EQ. "e" ) THEN
            ChString(i:i) = "E"
         ELSEIF ( c .EQ. "f" ) THEN
            ChString(i:i) = "F"
         ELSEIF ( c .EQ. "g" ) THEN
            ChString(i:i) = "G"
         ELSEIF ( c .EQ. "h" ) THEN
            ChString(i:i) = "H"
         ELSEIF ( c .EQ. "i" ) THEN
            ChString(i:i) = "I"
         ELSEIF ( c .EQ. "j" ) THEN
            ChString(i:i) = "J"
         ELSEIF ( c .EQ. "k" ) THEN
            ChString(i:i) = "K"
         ELSEIF ( c .EQ. "l" ) THEN
            ChString(i:i) = "L"
         ELSEIF ( c .EQ. "m" ) THEN
            ChString(i:i) = "M"
         ELSEIF ( c .EQ. "n" ) THEN
            ChString(i:i) = "N"
         ELSEIF ( c .EQ. "o" ) THEN
            ChString(i:i) = "O"
         ELSEIF ( c .EQ. "p" ) THEN
            ChString(i:i) = "P"
         ELSEIF ( c .EQ. "q" ) THEN
            ChString(i:i) = "Q"
         ELSEIF ( c .EQ. "r" ) THEN
            ChString(i:i) = "R"
         ELSEIF ( c .EQ. "s" ) THEN
            ChString(i:i) = "S"
         ELSEIF ( c .EQ. "t" ) THEN
            ChString(i:i) = "T"
         ELSEIF ( c .EQ. "u" ) THEN
            ChString(i:i) = "U"
         ELSEIF ( c .EQ. "v" ) THEN
            ChString(i:i) = "V"
         ELSEIF ( c .EQ. "w" ) THEN
            ChString(i:i) = "W"
         ELSEIF ( c .EQ. "x" ) THEN
            ChString(i:i) = "X"
         ELSEIF ( c .EQ. "y" ) THEN
            ChString(i:i) = "Y"
         ELSEIF ( c .EQ. "z" ) THEN
            ChString(i:i) = "Z"
         ENDIF  ! c

      ENDDO  ! i

      RETURN
      END
