!+  Return number of days in given year
      FUNCTION NumDays (Year)
      IMPLICIT NONE
c-----------------------------------------
! Name: $Id: numdays.F 25 2006-02-03 15:43:53Z frna $
!
! Description:
!   Return number of days in given year
!
! Method:
!   If year is divisible by 4, it is a leap year,
!   unless it is divisible by 100, excepting when it is
!   divisible by 400 !    (365.2524 solar days to a year)
!
! Current Code Owner: R.J.Renshaw
!
! History:
! Version    Date     Comment
!
!  1.0      22/02/95  Original code. (R.J.Renshaw)
!
! Code Description:
!   FORTRAN 77, following AAPP standards
!#########################################################################
! COPYRIGHT        THE CONTENTS OF THIS FILE ARE CROWN COPYRIGHT. THE
!                  SOFTWARE, DATA AND OTHER PROPRIETARY INFORMATION
!                  CONTAINED THEREIN IS SUPPLIED FOR BONAFIDE RESEARCH
!                  PURPOSES. COMMERCIAL OR BUSINESS USE IS NOT PERMITTED
!                  WITHOUT THE WRITTEN AUTHORITY OF THE U.K. MET. OFFICE.
!#########################################################################
!
! Declarations:
!
! Global variables:

! Function arguments
!   Scalar arguments with intent(in):
      INTEGER Year                ! year, e.g. 1995
!
! Function return value
      INTEGER NumDays             ! number of days in year
!
!- End of header

      IF ( MOD(Year,4).EQ.0 ) THEN

         IF (MOD(Year,100).EQ.0 .AND. MOD(Year,400).NE.0) THEN
            NumDays = 365
         ELSE
            NumDays = 366
         ENDIF

      ELSE

         NumDays = 365

      ENDIF

      RETURN
      END
