      SUBROUTINE average_T89_T150(Blastline, width, avdiff_89_150)
      
! Name: $Id: average_T89_T150.F 25 2006-02-03 15:43:53Z frna $
!
! Purpose: Compute average 89GHz & 150GHz diff over sea over a defined area,
! for use with scattering index calculation
!
! Code Owner : Nigel Atkinson
!
! Version 1.0  15 March 2005  Initial
!
! Declarations:

#include "ppparms.h"
#include "ppbstore.h"

! Arguments
      INTEGER Blastline, width
      REAL avdiff_89_150(Bnfovs, Bnlines)

! Local variables
      INTEGER ifov,iline,jfov,jline,fov1,fov2,line1,line2,n,w2
      REAL T89,T150
!
!- End of header
      
      w2 = width/2

      DO iline = 1,Blastline
        DO ifov = 1,Bnfovs
          avdiff_89_150(ifov,iline) = 0.0
          IF (BLandFrac(ifov,iline).NE.100) THEN
            n = 0
            fov1 = max(ifov-w2,1)
            fov2 = min(ifov+w2,Bnfovs)
            line1 = max(iline-w2,1)
            line2 = min(iline+w2,Blastline)
            DO jline = line1,line2
              DO jfov = fov1,fov2
                T89 = Bbtemps(1,jfov,jline) 
                T150 = Bbtemps(2,jfov,jline) 
                IF (T89.GE.BminBT.AND.T150.GE.BminBT.AND.
     &              T89.LE.BmaxBT.AND.T150.LE.BmaxBT.AND.
     &              Bsurftype(jfov,jline).EQ.0) THEN
                  avdiff_89_150(ifov,iline) = avdiff_89_150(ifov,iline)
     &                        +  T89 - T150 - 0.11*Bangles(1,jfov,jline)
                               !Allow for zenith angle (see retrieve_one_si.F)
                  n = n + 1
                ENDIF
              ENDDO
            ENDDO
            IF (n .GE. width) THEN   !Must have >=sqrt(no of points considered)
              avdiff_89_150(ifov,iline) = avdiff_89_150(ifov,iline)/n
            ELSE
              avdiff_89_150(ifov,iline) = -99999.9     !Insufficient sea points
            ENDIF
          ENDIF     !BLandFrac(ifov,iline).NE.100
        ENDDO     !ifov
      ENDDO     !iline
      END
