!+ Grody light rainfall test
!
      FUNCTION PPATMSGRODY ( T1, T2 )
      IMPLICIT NONE
c-----------------------------------------
! Name: $Id: ppatmsgrody.F 313 2012-02-28 14:51:43Z frna $
!
! Purpose:
!   apply Grody light rainfall test to ATMS channels 1 & 2
!
! Method:
!
! Current Code Owner: NWP SAF
!
! History:
! Version  Date      Comment
!
!  1.0     06/09/2010  From ppgrody.F
!
! Code Description:
!   FORTRAN 77, following AAPP standards
!
! Declarations:
!
! Global variables:
! general parameters for ATOVPP
#include "ppparms.h"        
! fixed data for processing ATMS
#include "ppatmsfdata.h"       
!
!   Scalar arguments with intent(In):
      REAL          T1            ! brightness temp in ATMS channel 1 (K)
      REAL          T2            ! brightness temp in ATMS channel 2 (K)
!
!   Return value of function:
      LOGICAL       PPATMSGRODY       ! .TRUE. if rain detected
!
!- End of header

      PPATMSGRODY = (atmsgrody1+atmsgrody2*T2) .GT. T1

      RETURN
      END
