!
!----67--1----*----2----*----3----*----4----*----5----*----6----*----7-!
      SUBROUTINE ppbginit(IO_UNIT)
!
! Name: $Id: ppbginit.F 5 2006-01-04 09:11:15Z frna $
!
! This pre-existing routine has been included in AAPP as part 
! of EUMETSAT NWP-SAF
! IT BELONGS TO BACKUS-GILBERT-CONVOLUTION AMSU-B to AMSU-A
! see Bennartz (2000), J. Atmos. Ocean. Technology, Vol. 17, No. 9, 1215-1225
!
! Short routine to initialize the Common block defined in ppbgb2a,h
! The fields hold the information which is necessary to convolve AMSU-B
! to AMSU-A
!
! Ralf Bennartz, 06/12/2000
!               
! History:
! Version  Date      Comment
!  1.1      09/03/04  Modify for Linux (N Atkinson / A Korpela)

#include "ppparms.h"
#include "ppbgb2a.h"
   
         INTEGER IO_UNIT,errStatus 
   
         OPEN(UNIT=IO_UNIT, STATUS="OLD", FORM="FORMATTED",
     &     IOSTAT=errStatus)

!        If that didn"t work, use STATUS="UNKNOWN" (Linux ifc compiler)
         IF ( errStatus.NE.0 )
     &   OPEN(UNIT=IO_UNIT, STATUS="UNKNOWN", FORM="FORMATTED",
     &     IOSTAT=errStatus)

         READ(IO_UNIT,*) amb_pix
         READ(IO_UNIT,*) amb_lin
         READ(IO_UNIT,*) amb_weight


      END       


