!+ pre-process IASI after mapping
!
      SUBROUTINE PPCRIS2 ( crisLastLine, LATMS )
      IMPLICIT NONE
c-----------------------------------------
! Name: $Id: ppcris2.F 313 2012-02-28 14:51:43Z frna $
!
! Purpose:
!   pre-process a block of level 1d CRIS data, after mapping
!
! Method:
! 1.  Repeat pre-processing tests for ATMS but on CRIS grid
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 01 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version  Date      Comment
!
!  1.0    02/09/2010  Based on ppiasi2.F (N.C.Atkinson)
!
! Code Description:
!   FORTRAN 77, following AAPP standards
!
! Declarations:
!
! Global variables:
!  general parameters for ATOVPP 
#include "ppparms.h"
!  IASI 1d format 
#include "cris1d.h"
!  fixed data for processing IASI 
#include "ppcrisfdata.h"
!  block of IASI data 
#include "ppcrisstore.h"
!  bit numbers for intrinsic bit routines (eg BTEST) 
#include "bits.h"
!
!   Scalar arguments with intent(In):
      INTEGER       crisLastLine  ! number of last CrIS line in store
!
      LOGICAL       LATMS         ! .TRUE. to process ATMS
!
! Local scalars:
!
! Local arrays:
!
! Function & Subroutine calls:
      External PPCATMS            ! ATMS pre-pro tests on CrIS grid
!
!- End of header

      WRITE(*,"(10X,""Pre-processing CrIS after the mapping"")")

! 1.  Repeat pre-processing tests for ATMS but on CrIS grid
!     ------ -------------- ----- --- ---- --- -- ---- ----

      IF ( LATMS ) CALL PPCATMS ( crisLastLine )

      RETURN
      END
