!+ Grody light rainfall test
!
      FUNCTION PPGRODY ( T1, T2 )
      IMPLICIT NONE
c-----------------------------------------
! Name: $Id: ppgrody.F 25 2006-02-03 15:43:53Z frna $
!
! Purpose:
!   apply Grody light rainfall test to AMSU-A channels 1 & 2
!
! Method:
!
! Current Code Owner: R.J.Renshaw
!
! History:
! Version  Date      Comment
!
!  1.0      27/11/96  Derived from Steve English's PV-Wave code (27/10/95)
!  1.1      10/12/96  coefficients in ppafdata.h
!
! Code Description:
!   FORTRAN 77, following AAPP standards
!
! Declarations:
!
! Global variables:
! general parameters for ATOVPP
#include "ppparms.h"        
! fixed data for processing AMSU-A
#include "ppafdata.h"       
!
!   Scalar arguments with intent(In):
      REAL          T1            ! brightness temp in AMSU-A channel 1 (K)
      REAL          T2            ! brightness temp in AMSU-A channel 2 (K)
!
!   Return value of function:
      LOGICAL       PPGRODY       ! .TRUE. if rain detected
!
!- End of header

      PPGRODY = (Agrody1+Agrody2*T2) .GT. T1

      RETURN
      END
