!+ pre-process IASI after mapping
!
      SUBROUTINE PPIASI2 ( ILastLine, LAMSA, LAMSB )
      IMPLICIT NONE
c-----------------------------------------
! Name: $Id: ppiasi2.F 25 2006-02-03 15:43:53Z frna $
!
! Purpose:
!   pre-process a block of level 1d IASI data, after mapping
!
! Method:
! 1.  Repeat pre-processing tests for AMSU but on IASI grid
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 16 December 2003, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2005, EUMETSAT, All Rights Reserved.
!
! History:
! Version  Date      Comment
!
!  1.0      11/08/05  Based on pphirs2.F (N.C.Atkinson)
!
! Code Description:
!   FORTRAN 77, following AAPP standards
!
! Declarations:
!
! Global variables:
!  general parameters for ATOVPP 
#include "ppparms.h"
!  IASI 1d format 
#include "iasi1d.h"
!  fixed data for processing IASI 
#include "ppifdata.h"
!  block of IASI data 
#include "ppistore.h"
!  bit numbers for intrinsic bit routines (eg BTEST) 
#include "bits.h"
!
!   Scalar arguments with intent(In):
      INTEGER       ILastLine     ! number of last IASI line in store
!
      LOGICAL       LAMSA         ! .TRUE. to process AMSU-A
      LOGICAL       LAMSB         ! .TRUE. to process AMSU-B
!
! Local scalars:
!
! Local arrays:
!
! Function & Subroutine calls:
      External PPIAMSU            ! AMSU pre-pro tests on IASI grid
!
!- End of header

      WRITE(*,"(10X,""Pre-processing IASI after the mapping"")")

! 1.  Repeat pre-processing tests for AMSU but on IASI grid
!     ------ -------------- ----- --- ---- --- -- ---- ----

      IF ( LAMSA ) CALL PPIAMSU ( ILastLine )

      RETURN
      END
