      subroutine xavg(data,np,avg,sd,xmin,xmax)

c-----------------------------------------------------------------------
c ... INTRODUCTION 
c ... input args
c ... data   - 1d array of data string
c ... np     - no points in data
c ... output args
c ... avg    - mean of data
c ... sd     - standard deviation of data
c ... xmin   - minimum data value
c ... xmax   - maximum data value
c-----------------------------------------------------------------------
c ... DECLARATIONS
c ... scalar arguments ..
      real avg,sd,xmax,xmin
      integer np
c ...
c ... array arguments ..
      real data(*)
c ...
c ... local scalars ..
      real xsum
      integer i
c ...
c ... intrinsic functions ..
      intrinsic float,sqrt
c-----------------------------------------------------------------------
      xsum = 0.
      xmin = 999999.
      xmax = -999999.
c-----------------------------------------------------------------------
c ...   sum for mean
      if (np.gt.0) then
      do i = 1,np

        xsum = xsum + data(i)

c ...   check for min/max
        if (data(i).lt.xmin) xmin = data(i)
        if (data(i).gt.xmax) xmax = data(i)

      end do
      avg = xsum/float(np)

c-----------------------------------------------------------------------
c ...   sum perturbations for sd
      xsum = 0.
      do i = 1,np
        xsum = xsum + (data(i)-avg)* (data(i)-avg)
      end do
c-----------------------------------------------------------------------

      sd = sqrt(xsum/np)
      end if

      return
      end
