#!/bin/ksh
#
#$Id$
#
#Convert AVHRR level 1b files from AAPP format to HDF-5
#
#History:
# 1.1   24/11/2008  initial version. N C Atkinson
# 1.2   24/06/2011  exe file could be elsewhere in $PATH
#==============================================================================

. "$AAPP_PREFIX/ATOVS_CONF"

#Look for the exe file, first in script directory then in $PATH

exe=$(dirname $0)/avh1b_to_hdf5.exe

[ -x $exe ] || exe=$(IFS=":"; for p in $PATH; do q=$p/avh1b_to_hdf5.exe; \
  [ -x $q ] && echo $q && return; done)

[ -x $exe ] || { echo "Cannot find avh1b_to_hdf5.exe"; exit 1; }

missing=$(ldd $exe | grep "not found")

if [ "$missing" != "" ]; then
  echo $missing
  echo "Library not found, please locate the shared library listed above"
  echo " and add it to your LD_LIBRARY_PATH environment variable"
  exit 1
fi

$exe $*

