#!/bin/ksh
#
#$Id: avhrr_1b_subset.ksh 487 2016-04-14 13:21:14Z frna $
#
# Create a subset of an AVHRR l1b file, based on sub-satellite latitude, and
# optionally specifying direction of travel
#
#History:
# 1.0   14/04/2016  initial version. N C Atkinson
#==============================================================================

. "$AAPP_PREFIX/ATOVS_CONF"

usage(){
  echo
  echo 'usage : avhrr_1b_subset infile outfile lat1 lat2 [direction]'
  echo
  echo ' direction=1 for south to north, -1 for north to south, 0 for either'
  echo
}

[ $# -lt 4 ] && { usage; exit 0; }

infile=$1
outfile=$2
lat1=$3
lat2=$4
direction=${5:-0}

rm -f $outfile

avhrr_1b_subset.exe <<EOF
$infile
$outfile
$lat1
$lat2
$direction
EOF
