#!/bin/ksh
#
#$Id: noaa_class_to_aapp.ksh 369 2013-09-16 13:30:48Z frna $
#
#Convert AVHRR 1B data from AAPP to NOAA/CLASS (KLM) format
#
#Links to format descriptions:
#  http://www.ncdc.noaa.gov/oa/pod-guide/ncdc/docs/intro.htm
#
#History:
#
# 1.0   12/09/2013  initial version. N C Atkinson

usage(){
  echo
  echo 'usage : avhrr_aapp_to_class inputfile outputfile'
  echo
}

[ $# -lt 2 ] && { usage; exit 1; }

infile=$1
outfile=$2
[ -f $infile ] || { echo "Cannot find $1"; exit 1; }

avhrr_aapp_to_class.exe <<EOF
$infile
$outfile
EOF

exit $?
