#!/usr/bin/perl -w
#
# Get centre and sub-centre from BUFR section 1 (first message of a file)
#
# 11/10/2016 NCA
#
##############################################################################

use strict;

my ($line, $index, $edition, $centre, $subcentre);

my ($infile) = @ARGV;

die "Usage: bufr_centre_info.pl infile\n" if (! $infile);

open (IN, $infile) || die "can't open $infile\n";

$/ = "BUFR";       #set record terminator to look for start of a message

$line = <IN>;      #go to start of first message

$/ = "7777";       #set record terminator to look for end of message

$line = <IN>;      #read first message

#Section 0 (excluding the initial "BUFR")

$index = 0;

$edition = ord(substr($line,$index+3,1));
  
#Section 1

$index = 4;
       
if ($edition == 4) {
  $centre = ord(substr($line,$index+4,1))*256
          + ord(substr($line,$index+5,1));
  $subcentre = ord(substr($line,$index+6,1))*256
             + ord(substr($line,$index+7,1))
} else {
  if ($edition < 4) {
    $centre = ord(substr($line,$index+5,1));
    $subcentre = ord(substr($line,$index+6,1))
  } else {
    die "unknown BUFR edition $edition\n"
  }
}
print "$centre $subcentre\n";

close (IN);
  
