#!/bin/ksh
#
#$Id: check_3A3B.ksh 500 2016-10-28 13:02:15Z frna $
#
#Examine the header record of an AVHRR .l1b file and display whether the
#instrument is set to use channel 3A or 3B (or both). Assume native endianness.
#
#Usage : check_3A3B file
#
#History:
# 1.0     21/10/2016  N C Atkinson

file=$1
set $(head -c 128 $file | od -An -v -t u4)
stat1=${30}
change=${31}
stat2=${32}

ch3a=$(($stat1 & 2048))
ch3a=$(($ch3a / 2048))

ch3b=$(($stat1 & 1024))
ch3b=$(($ch3b / 1024))

if [ "$ch3a $ch3b" = "0 1" ]; then
  echo "3B"
elif [ "$ch3a $ch3b" = "1 0" ]; then
  echo "3A"
fi

if [ $change != 0 ]; then
  ch3a2=$(($stat2 & 2048))
  ch3a2=$(($ch3a2 / 2048))

  ch3b2=$(($stat2 & 1024))
  ch3b2=$(($ch3b2 / 1024))

  if [ "$ch3a2 $ch3b2" != "$ch3a $ch3b" ]; then
    if [ "$ch3a2 $ch3b2" = "0 1" ]; then
      echo "3B"
    elif [ "$ch3a2 $ch3b2" = "1 0" ]; then
      echo "3A"
    fi
  fi
fi
