#!/bin/ksh

. "$AAPP_PREFIX/ATOVS_CONF"

# For AAPP v1-5 this was used to set up ATOVS_ENV
# For AAPP v6 it is just provided as a diagnostic to allow user to check that 
#     the configuration file is correct (NCA 06/06/06) 

echo "  "
echo "	Determining Unitname: ftn/fort?"

rm -f fort.21 det_ftnfort.out det_ftnfort.inp

echo "fort." > det_ftnfort.inp
ln -s det_ftnfort.inp fort.21

det_ftnfort.exe > det_ftnfort.out

if [ $? -eq 0 ]; then

  ftnfort=$(cat det_ftnfort.out | cut -c2-)
  echo "default value: $FORT"
  echo "actual value: $ftnfort"
  if [ "$FORT" != "$ftnfort" ]; then
    echo "Please fix your config file!!!"
  else
    echo "config file is OK"
  fi
  
else
  echo " Error: det_ftnfort.exe failed"
fi

rm -f fort.21 det_ftnfort.out det_ftnfort.inp
