#!/bin/ksh
#
#==============================================================================
#
# @(#) %m% version 1.1 on 10/13/98 COPYRIGHT (c) Meteo-France 1995  
#
#
# NOM DU MODULE/MODULE NAME
#
# l1bidf
#
# BUT/PURPOSE
#
# Utilitaire minimal du format l1b NOAAK  
#   [option -t  supplementaire pour connaitre le type de donnee 
#    presente dans le fichier 1B]
#
# DESCRIPTION    
#
# PROPRIETAIRE/OWNER
#
# HISTORIQUE/HISTORY 
# 
#  1.0     11/07/95  version initiale		 M.Derrien 
#  1.1     01/02/06  change config file P. Marguinaud
#  1.2     07/06/06  remove initialisation of DIR_SATID P. Marguinaud
#
#==============================================================================

#==============================================================================
# functions 
#==============================================================================
EXIT_OK=0
EXIT_USAGE=1
#------------------------------------------------------------------------------
l1bidf_exit()
{
  exit $1
}

#------------------------------------------------------------------------------
l1bidf_usage()
{
  log_error syntaxe : ${SYNTAXE} 
  l1bidf ${EXIT_USAGE} 
}


#==============================================================================
# main
#==============================================================================

#------------------------------------------------------------------------------
# includes
#------------------------------------------------------------------------------
. "$AAPP_PREFIX/ATOVS_CONF"
. liblog.sh

#------------------------------------------------------------------------------
# recuperation des options 
#------------------------------------------------------------------------------

SYNTAXE="l1bidf [-s | -d | -h | -n | -t | -i] file"
MODE=UNKNOWN

while getopts sdhnti c
do
    case $c in
      s)    MODE=S ;;
      d)    MODE=D ;;
      h)    MODE=H ;;
      n)    MODE=N ;;
      t)    MODE=T ;;
      i)    MODE=I ;;
      \?)   l1bidf_usage ;; 
    esac
done
shift `expr $OPTIND - 1`

#------------------------------------------------------------------------------
# recuperation des arguments
#------------------------------------------------------------------------------

FILE=$1

#------------------------------------------------------------------------------
# initialisation log  
#------------------------------------------------------------------------------
log_init `basename $0`



#------------------------------------------------------------------------------
# execution du programme fortran
#------------------------------------------------------------------------------
set `l1bidf.exe<<EOF
${FILE}
EOF`

case ${MODE} in
  S)	echo $1 ;;
  D)	echo $2 ;;
  H)	echo $3 ;;
  N)	echo $4 ;;
  T)    echo $5 ;;
  I)    echo $* ;;
esac

#------------------------------------------------------------------------------
# sortie normale
#------------------------------------------------------------------------------
l1bidf_exit ${EXIT_OK} 

