#! /bin/sh
#
#=======================================================
#
# @(#)liblog.sh version 1.2 11/25/98 COPYRIGHT (c) Meteo-France 1996
#
# fonction logs
#
#=======================================================


#=======================================================
# fonctions privees 
#=======================================================

#-------------------------------------------------------
_log_msg()
#-------------------------------------------------------
{
echo \> `date +"%Y/%m/%d %H:%M:%S"` \
     "${_LIBLOG_SH_HOST_NAME}" \
     "${_LIBLOG_SH_PROCESSUS_PID}" \
     "${_LIBLOG_SH_PROCESSUS_NAME}" "$*" >&2
}

#-------------------------------------------------------
_log_level()
#-------------------------------------------------------
{
_LIBLOG_SH_LEVEL=$1
 shift
_log_msg "${_LIBLOG_SH_LEVEL}": $*
}

#=======================================================
# fonctions publiques
#=======================================================

#-------------------------------------------------------
log_init()
#-------------------------------------------------------
{
#
# processus name cadre a gauche sur 12 caracteres
#
_LIBLOG_SH_PROCESSUS_NAME=`basename $1 | awk '{ printf "%-12s", $1 }'`
}

#-------------------------------------------------------
log_emergency()
#-------------------------------------------------------
{ 
log_line
_log_level "EMERGENCY "  $*
log_line
}

#-------------------------------------------------------
log_critical()
#-------------------------------------------------------
{ 
log_line
_log_level "CRITICAL  " $*
log_line
}

#-------------------------------------------------------
log_error()
#-------------------------------------------------------
{
log_line
_log_level "ERROR     "  $*
log_line
}


#-------------------------------------------------------
log_warning()
#-------------------------------------------------------
{ 
log_line
_log_level "WARNING   " $*
log_line
}

#-------------------------------------------------------
log_notice()
#-------------------------------------------------------
{ 
_log_level "NOTICE    " $*
}

#-------------------------------------------------------
log_info()
#-------------------------------------------------------
{
_log_level "INFO      " $*
}

#-------------------------------------------------------
log_debug()
#-------------------------------------------------------
{
if [ "${DEBUG}" = "ON" ]; then 
_log_level "DEBUG     " $*
fi
}

#-------------------------------------------------------
log_text()
#-------------------------------------------------------
{
  echo "$*" >&2
}


#-------------------------------------------------------
log_line()
#-------------------------------------------------------
{
_log_msg
}

#
# hostname cadre a gauche sur 8 caracteres
#
_LIBLOG_SH_HOST_NAME=`uname -n | awk '{printf "%-8s", $1 }'`
#
# processus PID cadre a gauche sur 5 caracteres
#
_LIBLOG_SH_PROCESSUS_PID=`echo $$ | awk '{ printf "%5s", $1 }'`
#
# processus name cadre a gauche sur 12 caracteres
# au cas ou log_init ne serait pas appele...
#
_LIBLOG_SH_PROCESSUS_NAME=`basename $0 | awk '{ printf "%-12s", $1 }'`
