C LIBS = decom satid f7nl1b f7ml f7tp f7cp f7gp
        program prhavh
!+
!NOM/NAME $Id: prl1bavh.F 37 2006-06-08 14:23:17Z frna $
! pravh
!------------------------------------------------------------------------------
!BUT/PURPOSE 
!    This program is a tool to output the content of a hrpt l1b file
!   
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!
!PROPRIETAIRE/OWNER  
!     Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment                       <author>)
! 1.0      Dec 95       no                         Marcel Derrien
! 1.1      
!         
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
!------------------------------------------------------------------------------

        implicit none
! includes/commons
#include "avh1b.h"
#include "reclopt.h"

! variables
        integer luavh ! logical unit for input l1b file
        integer ios   ! io status
        integer iscn,startscn,endscn ! scan line counters
        integer loc_rl ! local record length
        character*256 filnam ! input file name
! functions
        logical gp_btn  

!--END OF DECLARATIONS----------------------------------------------------------
        luavh=30
! get file name from standard input
        read (*,'(a)') filnam
        write(*,*) filnam
! get start and end scan lines to output.
        read (*,*) startscn,endscn
        loc_rl = reclavh /rldiv
! open file
        open(unit=30,
     &       file   = filnam,
     &       access = 'DIRECT',
     &       recl   = loc_rl,
     &       form   = 'UNFORMATTED',
     &       status = 'OLD',
     &       iostat = ios)
        if (ios.eq.0) then

!         header reading
          call avhhdr(luavh,ios)
          if (ios.eq.0) then

!           header output

            call avhhdp
 
!           data reading                
            write(*,*) ' '
            write(*,*) '  '
            write(*,*) 'reading data avhrr l1b'
            do 10 iscn=1,avh_h_scnlin
              call avhdtr(luavh,iscn,ios)
              if (ios.eq.0) then
                if(gp_btn(avh_qualind,31)) then
                  write(*,*) 'do not use scan line',avh_scnlin,
     &                       ' avh_qualind ',avh_qualind
                endif
                  write(*,*) 'avh_scnlin ',avh_scnlin,
     &            ' avh_scnlintime',avh_scnlintime
                if(iscn.ge.startscn.and.iscn.le.endscn) then
                  call avhddp
                endif

              else
                write(*,*) 'pb. reading data- ios=',ios
                write(*,*) 'numero de scan=',iscn
              endif
10          continue
          
          else
            write(*,*) 'pb. reading header - ios=',ios
          end if

          close(unit=luavh,iostat=ios)
          if (ios.ne.0) then
            write(*,*) 'pb. close avhrr 1b - ios=',ios
          end if    

        else
          write(*,*) 'pb. open avhrr 1b - ios=',ios
        end if

        stop
        end
