#!/bin/ksh
#
# Korn Shell for avhrr 1b header verification
#
# PROPRIETAIRE/OWNER
#  Marcel Derrien
#
# HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
# (version   date      comment           <author>)
#  1.0     13/11/95   initial            Marcel Derrien
#  1.1     08/06/06   prhavh -> prl1bavh  N Atkinson / T Labrot
#
# COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
#     &/'@(#) prl1bavh.ksh version 1.1 on 3/24/98'/       
#
# usage
#------- 
usage(){
	echo
	echo ' prl1bavh prints avhrr 1B header and records'
	echo
	echo 'usage : prl1bavh -s and -e for start scan line filename'
	echo
	echo ' -s sss starting avhrr scan line '
	echo ' -e eee ending   avhrr scan line '
        echo ' filename  file to look at'
        echo
        }

# get the arguments
#------------------
	while getopts s:e: c
	do
               case $c in
               s)	START_SCN=$OPTARG;;
               e)	END_SCN=$OPTARG;;
               \?)      usage
                        exit 2;;
               esac
	done
	shift `expr $OPTIND - 1`


if [ $# -ne 1 ]; then
  usage
  exit 1
fi
filename=$1
if [ ! -f $filename ]; then
  echo "file" $filename " doesn't exist"
  exit 2
fi

if [ "x${START_SCN}x" = "xx" -o "x${END_SCN}x" = "xx" ]; then
  usage
  exit 1
fi
cat << EOF > prl1bavh.inp
${filename}
${START_SCN},${END_SCN}
EOF

prl1bavh.exe < prl1bavh.inp 2>&1 || { rm -f prl1bavh.inp; exit 1; }

rm -f prl1bavh.inp
