C LIBS =  decom satid f7nl1b f7ml f7tp f7cp f7gp
        program prhdcs
!+
!NOM/NAME $Id: prl1bdcs.F 37 2006-06-08 14:23:17Z frna $
! pravh
!------------------------------------------------------------------------------
!BUT/PURPOSE 
!    This program is a tool to output the content of a dcs l1b file
!   
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!
!PROPRIETAIRE/OWNER  
!     Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment                       <author>)
! 1.0      Dec 95       no                         Marcel Derrien
! 2.0      March 03 Modified to be conformed to the other programs of that type (TL)
!         
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
!------------------------------------------------------------------------------
        implicit none
        
! includes/commons
#include "dcs1b.h"
#include "reclopt.h"

! variables
        integer ludcs                 ! logical unit for input l1b file
        integer ios                   ! io status
        integer iscn,startscn,endscn  ! scan line counters        
        integer loc_rl                ! local record length
        character*256 filnam          ! input file name

!--END OF DECLARATIONS----------------------------------------------------------
        ludcs=30
! get file name from standard input        
        read (*,'(a)') filnam
        write(*,*) filnam
! get start and end scan lines to output.
        read (*,*) startscn,endscn        
        loc_rl = recldcs /rldiv
! open file
        open(unit=30,
     &       file   = filnam,
     &       access = 'DIRECT',
     &       recl   = loc_rl,
     &       form   = 'UNFORMATTED',
     &       status = 'OLD',
     &       iostat = ios)
        if (ios.eq.0) then

! header reading
          call dcshdr(ludcs,ios)
          if (ios.eq.0) then

! header output 
            call dcshdp
 
! data reading               
            write(*,*) ' '
            write(*,*) ' '
            write(*,*) 'reading data dcs l1b'
            do 10 iscn=1,dcs_h_scnlin
              call dcsdtr(ludcs,iscn,ios)
              if (ios.eq.0) then
                write(*,*) 'dcs_mjfrcnt  = ',dcs_mjfrcnt
                if(iscn.ge.startscn.and.iscn.le.endscn) then
                  call dcsddp
                endif
              else
                write(*,*) 'pb.reading data - ios=',ios
                write(*,*) 'numero de scan=',iscn
              endif
10          continue
          
          else
            write(*,*) 'pb. reading header - ios=',ios
          end if

          close(unit=ludcs,iostat=ios)
          if (ios.ne.0) then
            write(*,*) 'pb. close dcs 1b - ios=',ios
          end if    

        else
          write(*,*) 'pb. open dcs 1b - ios=',ios
        end if

        stop
        end
