#!/bin/ksh
#
# Korn Shell for dcs 1b header and data verification
#
# PROPRIETAIRE/OWNER
#  Marcel Derrien
#
# HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
# (version   date      comment           <author>)
#  1.0     13/11/95   initial            Marcel Derrien
#  2.0     March 03 Modified to be conformed to the other programs of that type (TL)
#  2.1     08/06/06   prhdcs -> prl1bdcs  N Atkinson / T Labrot
#
# COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
#     &/'@(#) prl1bdcs.ksh version 1.1 on 3/24/98'/       
#

# usage
#------- 
usage(){
	echo
	echo ' prl1bdcs prints dcs 1B header and records'
	echo
	echo 'usage : prl1bdcs -s and -e for start scan line filename'
	echo
	echo ' -s sss starting dcs scan line '
	echo ' -e eee ending   dcs scan line '
        echo ' filename  file to look at'
        echo
        }

# get the arguments
#------------------

	while getopts s:e: c
	do
               case $c in
               s)	START_SCN=$OPTARG;;
               e)	END_SCN=$OPTARG;;
               \?)      usage
                        exit 2;;
               esac
	done
	shift `expr $OPTIND - 1`


if [ $# -ne 1 ]; then
  usage 
  exit 1
fi
filename=$1
if [ ! -f $filename ]; then
  echo "file" $filename " doesn't exist"
  exit 2
fi

if [ "x${START_SCN}x" = "xx" -o "x${END_SCN}x" = "xx" ]; then
  usage
  exit 1
fi

cat << EOF > prl1bdcs.inp
${filename}
${START_SCN},${END_SCN}
EOF
prl1bdcs.exe < prl1bdcs.inp 2>&1 || { rm -f prl1bdcs.inp; exit 1; }

rm -f prl1bdcs.inp
