C LIBS =  navnoaa navtool satid f7ml f7tp f7cp f7gp auxaapp
!+
!NOM/NAME $Id: sdh2orbnum.F 47 2006-08-21 08:44:41Z frna $
!
        program sdh2orbnum 
!
!BUT/PURPOSE 
!
!       Fournir le numero d'orbite correspondant un satellite
!       et a un instant donne.   
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!
!       L'executable sdh2orbnum.exe  est destine a etre encapsule dans un
!       script sdh2orbnum qui devra positionner les variables
!       d'environnement SDH2ORBNUM_SATID et SDH2ORBNUM_IJC a l'identificateur
!       du satellite et a l'instant julien chaine recherche.
!       Le numero d'orbite est fourni en I5.5 sur la sortie standard.
!       En cas d'erreur rine n'est fournit sur la sortie standard et le code
!       de retour est different de 0.
!  
!PROPRIETAIRE/OWNER  
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.1      5/07/95                      G. Legendre
!         25/11/98   Version EXPORT  Pascal Brunel
!
!EXIT CODES
!
! 0 : ok
! 
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
!    
     
!commons

!local variables

        integer unitsatpos      ! logical unit for the satpos file
        double precision ij     ! instant julien demande 
        integer ierr            ! return code 0=OK
        double precision pos(3),vel(3)
        integer orbnum

        character*22 ijc        ! instant julien chaine  
        character*16 satid      ! identificateur satellite
        character*256 satpos_file ! nom de fichier satpos

        integer status
        integer ios

!functions
        
!
!read parameters
        read(*,'(a)') satid
        read(*,'(a)') ijc
        read(*,'(a)') satpos_file
!work
        call xicj( ijc, ij )

        unitsatpos=10
        open(unit=unitsatpos,file=satpos_file,status='old',
     &       iostat=ios)
        if(ios.eq.0) then
           call sp_read(ij,ij,unitsatpos,satid,ierr)
           if (ierr.eq.0) then
              call intposvel(1,ij,pos,vel,orbnum,ierr)
              if (ierr.eq.0) then
                 write(*,"(i5.5)") orbnum
                 status=0
              else
                 status=2
              endif
           else
              status=1
           endif
        else
           status=3
        endif

        close(unit=unitsatpos,iostat=ios)

!exit
        if(status.ne.0) then
           call aappexit(status)
        endif

        stop
        end
