!+ Set up HIRS level 1d BUFR descriptors
!
      SUBROUTINE DEFINE_AMSUB_1D(JELEM,KTDLST,KTDLEN)
      IMPLICIT NONE
!----------------------------------------------------------------------------
!
! Name: $Id: define_amsub_1d.F 313 2012-02-28 14:51:43Z frna $
!
! Note this sequence uses a number of Met Office local descriptors
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 01 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2011, EUMETSAT, All Rights Reserved.
!
! History:
! Version  Date      Comment
! 1.0     17/06/2011 From define_hirs_1d.F
!
! Code Description:
!   FORTRAN 77, following AAPP standards
!
! Declarations:
!
!-----------------------------------------------------------------------
! Subroutine arguments:
!-----------------------------------------------------------------------

      INTEGER JELEM          !Size of array
      INTEGER KTDLST(JELEM)  !List of descriptors
      INTEGER KTDLEN         !Number of descriptors

! Local variables
      INTEGER I
      INTEGER TMPLEN
      PARAMETER (TMPLEN=49)
      INTEGER TMPLIST(TMPLEN)
      DATA TMPLIST /
     & 001007,004001,004002,004003,004004,004005,004006,005001,006001,
     & 008012,008070,001031,008070,001031,005040,055023,201133,005041,
     & 201000,005043,033030,033031,025214,008205,002224,025206,202126,
     & 007001,202000,010001,007024,005021,007025,005022,002151,012064,
     & 055024,055026,025208,109005,002150,025076,025077,025078,201132,
     & 202129,012063,202000,201000 /
         
!-----------------------------------------------------------------------
!- End of header
!=======================================================================

      DO I=1,TMPLEN
        KTDLST(I) = TMPLIST(I)
      ENDDO
      
      KTDLEN = TMPLEN
      
      RETURN
      END
