!+ Set up CrIS level 1d BUFR descriptors
!
      SUBROUTINE DEFINE_CRIS_1D(JELEM,KTDLST,KTDLEN)
      IMPLICIT NONE
!----------------------------------------------------------------------------
!
! Name: $Id: define_cris_1d.F 313 2012-02-28 14:51:43Z frna $
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 01 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2010, EUMETSAT, All Rights Reserved.
!
! History:
! Version  Date      Comment
! 1.0     24/09/2010 From define_iasi_1d.F
!
! Code Description:
!   FORTRAN 77, following AAPP standards
!
! Declarations:
!
!-----------------------------------------------------------------------
! Subroutine arguments:
!-----------------------------------------------------------------------

      INTEGER JELEM          !Size of array
      INTEGER KTDLST(JELEM)  !List of descriptors
      INTEGER KTDLEN         !Number of descriptors

! Local variables
      INTEGER I
      INTEGER TMPLEN
      PARAMETER (TMPLEN=99)
      INTEGER TMPLIST(TMPLEN)
      DATA TMPLIST /
     & 1007,8070,1033,1034,8070,1033,1034,2019,301011,301012,207003,
     & 4006,207000,304030,301021,7024,5021,7025,5022,8075,201133,5041,
     & 201000,5045,5043,5040,10001,201129,7002,201000,21166,8012,
     & 20010,20014,33078,55023,25214,8205,2224,25206,25206,
     & 25207,25206,25220,2019,33079,33080,108022,5042,25076,25077,
     & 25078,12163,12158,12159,33081,55007,2019,2165,33075,
     & 107003,8076,6029,6029,25140,25141,33076,33077,33003,
     & 55007,104000,31002,201133,5042,201000,14044,55007,40026,
     & 103000,31002,202124,25050,202000,101003,40016,14204,14203,
     & 2019,109000,31002,5042,8076,8023,14043,15042,8023,14043,15042,
     & 8023/
         
!-----------------------------------------------------------------------
!- End of header
!=======================================================================

      DO I=1,TMPLEN
        KTDLST(I) = TMPLIST(I)
      ENDDO
      
      KTDLEN = TMPLEN
      
      RETURN
      END
