!+ Set up level 1d BUFR descriptors
!
      SUBROUTINE DEFINE_FY3_GENERIC_1D(JELEM,KTDLST,KTDLEN)
      IMPLICIT NONE
!----------------------------------------------------------------------------
!
! Name: $Id: define_fy3_generic_1d.F 394 2014-05-19 14:27:12Z frna $
!
! Purpose:
!    This sequence accommodates up to 3 instruments mapped to a common grid, 
!    e.g. IRAS, MWTS, MWHS.
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 01 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2014, EUMETSAT, All Rights Reserved.
!
! History:
! Version  Date      Comment
! 1.0     14/01/2014 New 
!
! Code Description:
!   FORTRAN 77, following AAPP standards
!
! Declarations:
!
!-----------------------------------------------------------------------
! Subroutine arguments:
!-----------------------------------------------------------------------

      INTEGER JELEM          !Size of array
      INTEGER KTDLST(JELEM)  !List of descriptors
      INTEGER KTDLEN         !Number of descriptors

! Local variables
      INTEGER I
      INTEGER TMPLEN
      PARAMETER (TMPLEN=55)
      INTEGER TMPLIST(TMPLEN)
      DATA TMPLIST /
     & 001033,001034,001007,002019,005040,201136,005041,201000,005043,
     & 301011,301013,301021,007002,013040,007024,005021,007025,005022,
     & 304030,304031,025084,033082,002019,012064,033083,106000,031001,
     & 005042,201132,202129,012063,202000,201000,002019,012064,033083,
     & 106000,031001,005042,201132,202129,012063,202000,201000,002019,
     & 012064,033083,106000,031001,005042,201132,202129,012063,202000,
     & 201000/
         
!-----------------------------------------------------------------------
!- End of header
!=======================================================================

      DO I=1,TMPLEN
        KTDLST(I) = TMPLIST(I)
      ENDDO
      
      KTDLEN = TMPLEN
      
      RETURN
      END
