!+ Set up IASI level 1c BUFR descriptors
!
      SUBROUTINE DEFINE_IASI_1C(JELEM,KTDLST,KTDLEN)
      IMPLICIT NONE
!----------------------------------------------------------------------------
!
! Name: $Id: define_iasi_1c.F 20 2006-01-26 16:20:57Z frna $
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 16 December 2003, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2005, EUMETSAT, All Rights Reserved.
!
! History:
! Version  Date      Comment
! 1.0      16/09/05  N.C.Atkinson
! 1.1      26/01/06  Add X and Y centre of gravity
!
! Code Description:
!   FORTRAN 77, following AAPP standards
!
! Declarations:
!
!-----------------------------------------------------------------------
! Subroutine arguments:
!-----------------------------------------------------------------------

      INTEGER JELEM          !Size of array
      INTEGER KTDLST(JELEM)  !List of descriptors
      INTEGER KTDLEN         !Number of descriptors

!-----------------------------------------------------------------------
!- End of header
!=======================================================================

      KTDLST(1) = 001007
      KTDLST(2) = 001031
      KTDLST(3) = 002019
      KTDLST(4) = 002020
      KTDLST(5) = 004001
      KTDLST(6) = 004002
      KTDLST(7) = 004003
      KTDLST(8) = 004004
      KTDLST(9) = 004005
      KTDLST(10) = 202131
      KTDLST(11) = 201138
      KTDLST(12) = 004006
      KTDLST(13) = 201000
      KTDLST(14) = 202000
      KTDLST(15) = 005001
      KTDLST(16) = 006001
      KTDLST(17) = 007024
      KTDLST(18) = 005021
      KTDLST(19) = 007025
      KTDLST(20) = 005022
      KTDLST(21) = 005043
      KTDLST(22) = 005040
      KTDLST(23) = 201133
      KTDLST(24) = 005041
      KTDLST(25) = 201000
      KTDLST(26) = 201132
      KTDLST(27) = 025070
      KTDLST(28) = 201000
      KTDLST(29) = 202126
      KTDLST(30) = 007001
      KTDLST(31) = 202000
      KTDLST(32) = 033192
      KTDLST(33) = 033193
      KTDLST(34) = 033194
      KTDLST(35) = 033195
      KTDLST(36) = 033196
      KTDLST(37) = 033197
      KTDLST(38) = 103010
      KTDLST(39) = 025192
      KTDLST(40) = 025193
      KTDLST(41) = 025194
      KTDLST(42) = 105087
      KTDLST(43) = 104100
      KTDLST(44) = 201136
      KTDLST(45) = 005042
      KTDLST(46) = 201000
      KTDLST(47) = 014192
      KTDLST(48) = 002019
      KTDLST(49) = 025051
      KTDLST(50) = 109007
      KTDLST(51) = 005192
      KTDLST(52) = 005193
      KTDLST(53) = 025085
      KTDLST(54) = 105006
      KTDLST(55) = 005042
      KTDLST(56) = 025194
      KTDLST(57) = 014193
      KTDLST(58) = 025194
      KTDLST(59) = 014194
      
      KTDLEN = 59
      
      RETURN
      END
