!+ Set up MWTS/MWHS level 1c BUFR descriptors
!
      SUBROUTINE DEFINE_MWTS_MWHS_1C(JELEM,KTDLST,KTDLEN)
      IMPLICIT NONE
!----------------------------------------------------------------------------
!
! Name: $Id: define_mwts_mwhs.F 407 2014-07-30 14:15:48Z frna $
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 01 December 2006, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2012, EUMETSAT, All Rights Reserved.
!
! History:
! Version  Date      Comment
! 1.0     20/08/2012 Sequence from ECMWF. Increased the precision of the BTs
!                    to 0.01K.
! 1.1     28/07/2014 Use 008012 (land/sea qualifier - a coordinate class 
!                    descriptor) instead of 013040 (surface flag).
!
! Code Description:
!   FORTRAN 77, following AAPP standards
!
! Declarations:
!
!-----------------------------------------------------------------------
! Subroutine arguments:
!-----------------------------------------------------------------------

      INTEGER JELEM          !Size of array
      INTEGER KTDLST(JELEM)  !List of descriptors
      INTEGER KTDLEN         !Number of descriptors

! Local variables
      INTEGER I
      INTEGER TMPLEN
      PARAMETER (TMPLEN=28)
      INTEGER TMPLIST(TMPLEN)
      DATA TMPLIST /
     & 001033,001034,001007,002019,005040,201136,005041,201000,005043,
     & 301011,301013,301021,007002,008012,007024,005021,007025,005022,
     & 108000,031001,005042,002153,002154,201132,202129,012063,202000,
     & 201000/
         
!-----------------------------------------------------------------------
!- End of header
!=======================================================================

      DO I=1,TMPLEN
        KTDLST(I) = TMPLIST(I)
      ENDDO
      
      KTDLEN = TMPLEN
      
      RETURN
      END
