!+
!NOM/NAME $Id: gp_btn.F 25 2006-02-03 15:43:53Z frna $
!
        logical function gp_btn(word,bitnum)
!BUT/PURPOSE 
!     test bitnum in word
!     .true. if bitnum is 1, bits are numbered such that 0 is 
!      the least significant bit and 31 the most significant
!    
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions  
!        this routine is machine dependent, bit numbering and
!        FORTRAN extensions
!         this is a SUN implementation  (BIT subroutine)
!  
!PROPRIETAIRE/OWNER  
!    M. Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment                 <author>)
!  1.0      14/03/95    no                    M. Derrien
!  1.1      26/06/01 "word" no longer
!                    output parameter         R. Schraidt
!      
!ARGUMENTS 
!     input integer word
!     input integer bitnum 
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!       
!     .true. if bitnum is 1, bits are numbered such that 0 is 
!      the least significant bit and 31 the most significant
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
! 
!    
!
!arguments
        integer*4       word, bitnum
!commons
!local variables
        integer*4       mask, istamp, value
!functions
!-
        integer*4       iand

        if (bitnum .ge. 31 ) then
                mask=2**(bitnum-8)
                value=word/256
        else
                mask=2**bitnum
                value=word
        endif

        istamp=iand(value,mask)

        if (istamp.ne.0) then
                gp_btn=.true.
        else
                gp_btn=.false.
        endif
        return
        end
