!+
!NOM/NAME $Id: gp_fb2.F 25 2006-02-03 15:43:53Z frna $
!
        integer function gp_fb2(a,b,nbit)
!BUT/PURPOSE 
! 
!     compares the nbit least significant bits from a and b 
!     and returns the number of bits which are different
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!     uses the FORTRAN NON ANSI   ISHFT function.
!     may be system dependent
!PROPRIETAIRE/OWNER  
!    M. Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment                 <author>)
!  1.0     21/03/95   initial                  M.Derrien
!  2.0     March 03                           T.Labrot 
!          f90 test:   Change "mot3=ishft(mot1,-bitnum).and.1", and 
!                      "mot4=ishft(mot2,-bitnum).and.1"
!                      because "and" doesn't work.
!      
!ARGUMENTS 
!     input integer*2 a
!     input integer*2 b 
!     input integer nbit
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!     compares the nbit least significant bits from a and b 
!     returns the number of bits which are different
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
! 
!    
!
!arguments
        integer*2 a
        integer*2 b
        integer nbit
!commons

!local variables
        integer bitnum
        integer mot1,mot2,mot3,mot4,bad
        integer valtest
        parameter (valtest=1)
        
!functions
!       ishft   
!-
        mot1=a
        mot2=b
        bad=0
        do bitnum=0,nbit-1
          mot3=iand(ishft(mot1,-bitnum),valtest)
          mot4=iand(ishft(mot2,-bitnum),valtest)
          if(mot3.ne.mot4) bad=bad+1
        enddo
        gp_fb2=bad
        return
        end
