!+
!NOM/NAME $Id: gp_gb8.F 25 2006-02-03 15:43:53Z frna $
 
      integer*2 function gp_gb8(word8,n)
!----------------------------------------------------< role >------------
! 
! BUT/PURPOSE:  returns bit value from a byte,
!      bits are numbered such that 0 is 
!      the least significant bit and 31 the most significant

!
! DESCRIPTION: FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!
! PROPRIETAIRE/OWNER: PAUL FLAMENT
!
! HISTORIQUE/HISTORY  (MODIFICATIONS/CHANGES)
! version       date            comment                 author
! 1.0           05/05/95                                PAUL FLAMENT
! 1.1           02/03/05  Change byte to character*1 for portability. NCA.
!
! ARGUMENTS:
!     input: word8 ! character*1
!            n     ! integer*2
!
! FUNCTIONS AND SUBROUTINES CALLS (RETURN CODES FOR FUNCTIONS):
! 
!       XOR, IAND,ISHFT ! Fortran 77
!       gb8 ! get bit from 8 bits
!
! COPYRIGHT(c) Meteo-France ( EVOLUNIX - ATOVS - EUMETSAT project 1994 )
!
!-----------------------------------------------------------------------
 
      implicit none
c-----------------------------------------
c
c

!---- DECLARATIONS -----------------------------------------------------

!---- ARGUMENTS --------------------------------------------------------

      character*1 word8 
      integer n     
 
!---- COMMONS ----------------------------------------------------------

!---- LOCAL VARIABLES --------------------------------------------------
  
      character*1 word8b
      integer*2 c1,msk,word16,nm 
      equivalence(word8b,word16)               

!---- FUNCTIONS --------------------------------------------------------

!---- CODE ------------------------------------------------------------- 
      msk=Z'0001'
      nm = n
      word8b=word8
      c1=ISHFT(word16,-nm)
      gp_gb8=IAND(c1,msk)
      return
      end
!------------------------------------------------------------------------
