!+
!NOM/NAME $Id: gp_sb16.F 25 2006-02-03 15:43:53Z frna $
 
      subroutine gp_sb16(word16,n,val)
!----------------------------------------------------< role >------------
! 
! BUT/PURPOSE: 
! puts val ( 0 or 1) to bitnum n inside word16)
!               
!
! DESCRIPTION: FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!
! PROPRIETAIRE/OWNER: PAUL FLAMENT
!
! HISTORIQUE/HISTORY  (MODIFICATIONS/CHANGES)
! version       date            comment                 author
! 1.0           05/05/95                                PAUL FLAMENT
!
! ARGUMENTS:
!     input: word16 ! mot de 16 bits
!            n     ! numero du bit ( 0 a 15, poids fort a gauche )
!            val   ! valeur 0 ou 1 du bit
!
! FUNCTIONS AND SUBROUTINES CALLS (RETURN CODES FOR FUNCTIONS):
! 
!       MOD, ISHFT, AND ! Fortran 77
! 
!
! COPYRIGHT(c) Meteo-France ( EVOLUNIX - ATOVS - EUMETSAT project 1994 )
!
!-----------------------------------------------------------------------
 
      implicit none
c-----------------------------------------
c
c

!---- DECLARATIONS -----------------------------------------------------

      integer*2 msk16(0:15)
      data msk16/z'0001',z'0002',z'0004',z'0008',
     &           z'0010',z'0020',z'0040',z'0080',
     &           z'0100',z'0200',z'0400',z'0800',
     &           z'1000',z'2000',z'4000',z'8000'/

!---- ARGUMENTS --------------------------------------------------------

      integer*2 word16 ! word to process
      integer n     ! bit number
      integer val   ! value 0 ou 1 to assign to bit n         
 
!---- COMMONS ----------------------------------------------------------

!---- LOCAL VARIABLES --------------------------------------------------
                     
      integer*2 sp1,sp2,nm 

!---- FUNCTIONS --------------------------------------------------------

!---- CODE ------------------------------------------------------------- 
      nm=n
      if(val.eq.1)then
        sp1=IOR(word16,msk16(nm))
      else
        sp2=NOT(msk16(nm))
        sp1=IAND(word16,sp2)
      endif
      word16=sp1

      return
      end
!------------------------------------------------------------------------
