!+
!NOM/NAME $Id: gp_sb32.F 25 2006-02-03 15:43:53Z frna $
 
      subroutine gp_sb32(word32,n,val)
!----------------------------------------------------< role >------------
! 
! BUT/PURPOSE: 
! puts val ( 0 or 1) to bitnum n inside word32)
!               
!
! DESCRIPTION: FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!
! PROPRIETAIRE/OWNER: PAUL FLAMENT
!
! HISTORIQUE/HISTORY  (MODIFICATIONS/CHANGES)
! version       date            comment                 author
! 1.0           05/05/95                                PAUL FLAMENT
!
! ARGUMENTS:
!     input: word32 ! mot de 32 bits
!            n     ! numero du bit ( 0 a 15, poids fort a gauche )
!            val   ! valeur 0 ou 1 du bit
!
! FUNCTIONS AND SUBROUTINES CALLS (RETURN CODES FOR FUNCTIONS):
! 
!       MOD, ISHFT, AND ! Fortran 77
! 
!
! COPYRIGHT(c) Meteo-France ( EVOLUNIX - ATOVS - EUMETSAT project 1994 )
!
!-----------------------------------------------------------------------
 
      implicit none
c-----------------------------------------
c
c

!---- DECLARATIONS -----------------------------------------------------

      integer  msk32(0:31)
      data msk32/
     &           z'00000001',z'00000002',z'00000004',z'00000008',
     &           z'00000010',z'00000020',z'00000040',z'00000080',
     &           z'00000100',z'00000200',z'00000400',z'00000800',
     &           z'00001000',z'00002000',z'00004000',z'00008000',
     &           z'00010000',z'00020000',z'00040000',z'00080000',
     &           z'00100000',z'00200000',z'00400000',z'00800000',
     &           z'01000000',z'02000000',z'04000000',z'08000000',
     &           z'10000000',z'20000000',z'40000000',z'80000000'/

!---- ARGUMENTS --------------------------------------------------------

      integer word32 ! word to process
      integer n      ! bit number
      integer val    ! value 0 ou 1 to assign to bit n         
 
!---- COMMONS ----------------------------------------------------------

!---- LOCAL VARIABLES --------------------------------------------------
                     
      integer sp1,sp2 

!---- FUNCTIONS --------------------------------------------------------

!---- CODE ------------------------------------------------------------- 

      if(val.eq.1)then
        sp1=IOR(word32,msk32(n))
      else
        sp2=NOT(msk32(n))
        sp1=IAND(word32,sp2)
      endif
      word32=sp1

      return
      end
!------------------------------------------------------------------------
