!+
!NOM/NAME $Id: ml_hd.F 25 2006-02-03 15:43:53Z frna $
!
        subroutine ml_hd(msghd)
!BUT/PURPOSE 
!
! build a standard header for information messages (characters) to log
! containing the following date,hour,host name,pid,name
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!      this module is SYSTEM DEPENDENT
!      It uses the FORTRAN extension for UNIX allowing 
!          - get host name
!          - get processus id
!          - get args of the command ( 0 , its name)
!
!PROPRIETAIRE/OWNER
!  
!Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
!
! 1.0      19/05/95    initial        Marcel Derrien
!         
!ARGUMENTS 
!       output : msghd character*(*)
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)      
!
        implicit none
!
!DECLARATIONS
!
!    
!
!
!arguments
        character*(*) msghd
!local variables
      character*256 chaine
      character*80 hstnm ! host name
      character*80 cmdnm ! command name
      character*20 il ! current instant for log (yyyy/mm/dd  hh:mn:ss)
      character*8 cpid
        integer lgcpid, len_str, n1
        integer lgcmdnm
        integer lghstnm
      integer status
      integer pid
      integer nc,n,k
        logical first
!functions
      integer cp_lsc
      integer hostnm
      integer getpid
      character*12 cp_itc
!-
        data first/.true./

        save first, cpid, lgcpid, cmdnm, lgcmdnm, hstnm, lghstnm

!       get current date
        call gil(il)        
!
        if(first) then
!>>>>>>>        start of non standard statements  
!              
!          get host name
!          -------------

          status = hostnm(hstnm)
          if(status.ne.0) hstnm='unknown'
          lghstnm=cp_lsc(hstnm)
!
!         get process id
!         --------------
          pid=getpid()
          cpid=cp_itc(pid,k)
          lgcpid=cp_lsc(cpid)

!
!         get command name
!         ----------------
!       
          call getarg(0,chaine)
          nc=cp_lsc(chaine)
          if(nc.gt.10) then
            len_str=len(chaine)
            n=index(chaine,'/')
            if(n.gt.0) then
              do while (n .ne. 0)
                n1=n1+n
                n=index(chaine(n1:len_str),'/')
              end do
              n1=n1-1
            endif
            
            if((nc-n+1).lt.80) then
              cmdnm=chaine(n+1:nc)
            else
              cmdnm=chaine(n+1:n+80)
            endif
          else
             cmdnm=chaine(1:nc)
          endif 
          lgcmdnm=cp_lsc(cmdnm)

          first=.false.

        endif
               
!
!>>>>>>>>      end of non standard statements
!              ------------------------------

        msghd='> '//il(1:10)//' '//il(13:20)//' '//
     &                         hstnm(1:lghstnm)//' '//
     &                         cpid(1:lgcpid)//' '//cmdnm(1:lgcmdnm)
        return
        end
