        subroutine ml_wtr(level,text,rval)
!+
!NOM/NAME $Id: ml_wtr.F 25 2006-02-03 15:43:53Z frna $
!       subroutine ml_wtr(level,text,rval)
!
!BUT/PURPOSE 
!       writes a log message and a real value on standard error unit
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions 
!       get the log header
!       calculates the length of the strings
!       writes on standard error unit (0)
!
!PROPRIETAIRE/OWNER
!       P. Brunel
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date        comment           <author>)
! 1.0     06 Jun 1995     no              P. Brunel
! 2.0     March 03                        T.Labrot
!   f90 test: "(a,1x,a,' : ',a,1x,f)" doesn't work with f90 SUN compiler
!             Changed the format
!         
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!       cp_lsc          ! last significant character (f7cp)
!       cp_ups          ! string upper case (f7cp)
!       ml_hd           ! normalized message header (f7ml)
!
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!ARGUMENTS 
!input
        character*(*) level     ! emergency level
        character*(*) text      ! free form text
        real rval               ! real value which will be output
!
!DECLARATIONS
!
!
!
! Common declarations:
!
! Local parameters:
#include "stdio_unit.h"
!
! Commons
!
! Functions
        integer cp_lsc                  ! last significant character (f7cp)
!
! Local variables:
        character*80 msghd              ! normalized message header
        character*32 upc_level          ! upper case level text
        character*32 logform            ! output log format
        integer lghd                    ! last significant char. of the header
        integer lglev                   ! last significant char. of the level
        integer lgtext                  ! last significant char. of the text
! 
!-
!       0. Initializations
!       ------------------
        call ml_hd(msghd)

!       1. Lenght of strings variables
!       ------------------------------
        lghd   = cp_lsc(msghd)
        lglev  = cp_lsc(level)
        lgtext = cp_lsc(text)


!       2. Outputs the log message
!       --------------------------
        upc_level = level(1:lglev)
        call cp_ups(upc_level)
        logform = "(a,1x,a,' : ',a,1x,1p,e15.6)"
        write(stderru,logform) 
     &                         msghd(1:lghd),
     &                         upc_level(1:lglev),
     &                         text(1:lgtext),
     &                         rval
        

        return

        end
