!+
!NOM/NAME $Id: amadtr.F 25 2006-02-03 15:43:53Z frna $
!
        subroutine amadtr(luams,scn,ios)
!
!BUT/PURPOSE 
! read an AMSU-A 1B data record for the scn scan line
!         in the  common ama1bdt  
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  the common iocom is used by the variable luams 
!  it supposes a previous init and open
! 
!PROPRIETAIRE/OWNER
!  
!Marie-Madeleine Pinaud
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0       07/04/95  none        Marie-Madeleine Pinaud
! 1.1       12/03/04  Add call to byteswap1b. N C Atkinson
!         
!ARGUMENTS 
!      input  : integer luams
!      input  : integer scn
!      output : integer ios 
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
! 
!    
!
!
!arguments
        integer luams
        integer scn
        integer ios     
!commons
#include "nl1b.h"
#include "ama1b.h"
!local variables
        integer recn ! record number in AMSU-A 1B file
!functions
!-  
        recn=scn + nb1bhd
        read(luams,rec=recn,iostat=ios) ama_dt  
        call byteswap1b("AMA1BDT")
        return
        end
