!+
!NOM/NAME $Id: avhddp.F 25 2006-02-03 15:43:53Z frna $
!
        subroutine avhddp
!-----------------------------------------------------------------------
!
!BUT/PURPOSE: AVHRR 1B Data Display Procedure
!
!DESCRIPTION: FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER:  
!   M.Derrien 
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0       23/012/96  none            M. Derrien
!         
!ARGUMENTS: 
!               input common: hrs1b.h 
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!    subrouti!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
!-----------------------------------------------------------------------

      implicit none                                                     

!---- DECLARATIONS -----------------------------------------------------
 

!---- ARGUMENTS --------------------------------------------------------

!---- COMMONS ----------------------------------------------------------

#include "avh1b.h"

!---- LOCAL VARIABLES --------------------------------------------------

       character*12 scnlintime
       integer i,k
!---- FUNCTIONS --------------------------------------------------------

!---- CODE ------------------------------------------------------------- 

       write(*,*) ' '
       write(*,*) '             =========================='
       write(*,*) '             AVHRR/HRPT 1B  DATA RECORD'
       write(*,*) '             =========================='

       write(*,*) ' '

       write(*,*) 'scan line number --------------: ',avh_scnlin
       write(*,*) 'scan line year ----------------: ',avh_scnlinyr
       write(*,*) 'scan line day of year ---------: ',avh_scnlindy
       call xhqc(avh_scnlintime,scnlintime) 
       write(*,*) 'scan line UTC time of day -----: ',avh_scnlintime,
     &                             '  (',scnlintime,')'

       write(*,*) 'satellite clock drift delta ---: ',avh_clockdrift
       write(*,'('' scan line bit field -----------: '',$)')
       call gp_wb16( avh_scnlinbit )
       write(*,'('' quality indicator bit field ---: '',$)') 
       call gp_wb32( avh_qualind )
       write(*,'('' scan line quality flags -------: '',$)') 
       call gp_wb32( avh_scnlinqual )
       do k = 1 , avh_mxirchn
       write(*,'('' calibration quality flags -----: '',$)') 
       call gp_wb16( avh_calqual(k) )
       enddo      
       write(*,*) 'count of bit errors in frame sync --: ',
     &           avh_cbiterr




       write(*,*) ' '
       write(*,*) ' operational calibration coefficients'
       write(*,*) '====================================='
       write(*,*) ' '
       do i=1,avh_mxvischn
        write(*,'(''solar cal. slope 1 ['',i2.2,'']: '',$)')i
        write(*,*) avh_calvis(1,1,i)
        write(*,'(''solar cal. intercept 1['',i2.2,'']: '',$)')i
        write(*,*) avh_calvis(2,1,i)
        write(*,'(''solar cal. slope 2 ['',i2.2,'']: '',$)')i
        write(*,*) avh_calvis(3,1,i)
        write(*,'(''solar cal. intercept 2['',i2.2,'']: '',$)')i
        write(*,*) avh_calvis(4,1,i)
        write(*,'(''intersection ['',i2.2,'']: '',$)')i
        write(*,*) avh_calvis(5,1,i)
       enddo
       write(*,*) ' '
       write(*,*) ' test calibration coefficients'
       write(*,*) '=============================='
       write(*,*) ' '
       do i=1,avh_mxvischn
        write(*,'(''solar cal. slope 1 ['',i2.2,'']: '',$)')i
        write(*,*) avh_calvis(1,2,i)
        write(*,'(''solar cal. intercept 1['',i2.2,'']: '',$)')i
        write(*,*) avh_calvis(2,2,i)
        write(*,'(''solar cal. slope 2 ['',i2.2,'']: '',$)')i
        write(*,*) avh_calvis(3,2,i)
        write(*,'(''solar cal. intercept 2['',i2.2,'']: '',$)')i
        write(*,*) avh_calvis(4,2,i)
        write(*,'(''the zeroth one ['',i2.2,'']: '',$)')i
        write(*,*) avh_calvis(5,2,i)
       enddo
       write(*,*) ' '
       write(*,*) ' prelaunch calibration coefficients'
       write(*,*) '==================================='
       write(*,*) ' '
       do i=1,avh_mxvischn
        write(*,'(''solar cal. slope 1 ['',i2.2,'']: '',$)')i
        write(*,*) avh_calvis(1,3,i)
        write(*,'(''solar cal. intercept 1['',i2.2,'']: '',$)')i
        write(*,*) avh_calvis(2,3,i)
        write(*,'(''solar cal. slope 2 ['',i2.2,'']: '',$)')i
        write(*,*) avh_calvis(3,3,i)
        write(*,'(''solar cal. intercept 2['',i2.2,'']: '',$)')i
        write(*,*) avh_calvis(4,3,i)
        write(*,'(''the zeroth one ['',i2.2,'']: '',$)')i
        write(*,*) avh_calvis(5,3,i)
       enddo
       write(*,*) ' '
       write(*,*) ' IR operational calibration coefficients'
       write(*,*) '========================================'
       write(*,*) ' '
       do i=1,avh_mxirchn
        write(*,'(''IR sec. ord. coef. ch['',i2.2,'']: '',$)')i
        write(*,*) avh_calir(1,1,i)
        write(*,'(''IR first ord. ch['',i2.2,'']: '',$)')i
        write(*,*) avh_calir(2,1,i)
        write(*,'(''IR zeroth ord. ch. ['',i2.2,'']: '',$)')i
        write(*,*) avh_calir(3,1,i)
       enddo
        

       write(*,*) ' '
       write(*,*) 'time associated angles : ',avh_attangtime
       write(*,*) 'Roll angle in degrees  : ',avh_rollang
       write(*,*) 'pitch angle in degrees : ',avh_pitchang
       write(*,*) 'yaw  angle in degrees  : ',avh_yawang
!!       write(*,*) 'Roll errors correction  : ',avh_rollcor
!!       write(*,*) 'pitch errors correction : ',avh_pitchcor
!!       write(*,*) 'yaw  errors correction  : ',avh_yawcor
       write(*,'(''navigation status bit field : '',$)')
       call gp_wb32( avh_navstat )
       write(*,*) '10*spacecraft altitude (MSL) in km  : ',avh_scalti


       write(*,*) ' '
       write(*,*) 'scan angles in degrees'
       write(*,*) '======================'
       write(*,*) ' '
       do i=1,51
        write(*,*) 'solar zen: ',avh_ang(1,i),' sat zen: ',avh_ang(2,i),
     & ' local azimuth: ',avh_ang(3,i)
       enddo
 

       write(*,*) ' '
       write(*,*) 'lat/lon in degrees'
       write(*,*) '=================='
       write(*,*) ' '
       do i=1,51
        write(*,*) 'lat: ',avh_pos(1,i),' lon: ',avh_pos(2,i)
       enddo
 
       write(*,*) ' '
       write(*,*) 'AVHRR SENSOR DATA'
       write(*,*) '================='
       write(*,*) ' ' 

       write(*,'(15i5)') avh_hrpt 
       return
       end

