!+
!NOM/NAME $Id: avhdtr.F 25 2006-02-03 15:43:53Z frna $
!
        subroutine avhdtr(luavh,scn,ios)
!
!BUT/PURPOSE 
! read an AVHRR 1B data record for the scn scan line
!         in the  common avh1bdt 
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  the common iocom is used by the variable luavh 
!  it supposes a previous init and open
! 
!PROPRIETAIRE/OWNER
!  
!Marie-Madeleine Pinaud
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0       03/04/95  none        Marie-Madeleine Pinaud
! 1.1       13/04/05  Add call to byteswap1b. N C Atkinson
!         
!ARGUMENTS 
!      input  : integer luavh
!      input  : integer scn
!      output : integer ios 
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
! 
!    
!
!
!arguments
        integer luavh
        integer scn
        integer ios     
!commons
#include "avh1b.h"
!local variables
        integer recn ! record number in avhrr 1B file
!functions
!-
        recn = scn + avh_h_hdrcnt
        read(luavh,rec=recn,iostat=ios) avh_dt  
        call byteswap1b("AVH1BDT")
        return
        end
