!+
!NOM/NAME $Id: avhhdp.F 25 2006-02-03 15:43:53Z frna $
!
        subroutine avhhdp

!BUT/PURPOSE 
!  print an AVHRR 1B header record 
! 
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER  
!
!  Marie-Madeleine Pinaud/ Marcel Derrien
!   
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.1       02/06/95  none        Marie-Madeleine Pinaud
! 1.2       10/11/95  Change 1B   Marcel Derrien
! 1.3       15/05/98  Change 1B   Marcel Derrien
! 1.4       06/12/01 *Add the parameter irttcoef to have been written  
!                    *Corrected the bug for d5bvolt 
!                    *Modified the size and the elements of the character  
!                     array tipsrc to be consistent with the definition 
!                     of avh_h_tipsrc (include avh1b.h)  (T.Labrot)

!ARGUMENTS 
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
! 
!    
!
!
!arguments

!commons
#include "avh1b.h"
!local variables
       character*8 datatyp(12)
       data datatyp/'(  )','(LAC)','(GAC)','(HRPT)',
     &              '(TIP)','(HIRS)','(MSU)','(SSU)',
     &              '(DCS)','(SEM)','(AMSU-A)','(AMSU-B)'/
       character*16 tipsrc(5)
       data tipsrc/'(not applicable)','(GAC embedded)','(stored)',
     &             '(third CDA)','(HRPT embedded)'/
       character*9 pacsdatasrc(4)
       data pacsdatasrc/'(unused)','(Gilmore)',
     &                  '(Wallops)','(SOCC)'/
       character*8 startdatac,enddatac
       character*12 startdatatime,enddatatime,epotime
       integer*4 inststat14,pacsstatfield4,locbit4,racalind4
       integer   i,j
!
!functions
!-
       write(*,*) ' '
       write(*,*) '             AVHRR/HRPT 1B Data Set HEADER RECORD'
       write(*,*) ' '
       write(*,*) '             GENERAL INFORMATION'
       write(*,*) ' '
       write(*,*) 'site creation = ',avh_h_siteid
       write(*,*) 'l1bversnb     = ',avh_h_l1bversnb 
       write(*,*) 'l1bversyr     = ',avh_h_l1bversyr
       write(*,*) 'l1bversdy     = ',avh_h_l1bversdy
       write(*,*) 'record length = ',avh_h_reclg
       write(*,*) 'block size    = ',avh_h_blksz
       write(*,*) 'hdrcnt        = ',avh_h_hdrcnt
       write(*,*) 'dataname      = ',avh_h_dataname
       write(*,*) 'prblkid       = ',avh_h_prblkid
       write(*,*) 'satid         = ',avh_h_satid
       write(*,*) 'instid        = ',avh_h_instid 
       write(*,*) 'datatyp       = ',avh_h_datatyp,'  ',
     &             datatyp(avh_h_datatyp+1)(1:8) 
       write(*,*) 'tipsrc        = ',avh_h_tipsrc,'  ',
     &             tipsrc(avh_h_tipsrc+1)(1:16)
       call xdjc(avh_h_startdatajd,startdatac) 
       write(*,*) 'startdatajd   = ',avh_h_startdatajd,
     &                             '  (',startdatac,')' 
       write(*,*) 'startdatayr   = ',avh_h_startdatayr
       write(*,*) 'startdatady   = ',avh_h_startdatady
       call xhqc(avh_h_startdatatime,startdatatime) 
       write(*,*) 'startdatatime = ',avh_h_startdatatime,
     &                             '  (',startdatatime,')'
       call xdjc(avh_h_enddatajd,enddatac) 
       write(*,*) 'enddatajd     = ',avh_h_enddatajd,
     &                             '  (',enddatac,')' 
       write(*,*) 'enddatayr     = ',avh_h_enddatayr
       write(*,*) 'enddatady     = ',avh_h_enddatady
       call xhqc(avh_h_enddatatime,enddatatime) 
       write(*,*) 'enddatatime   = ',avh_h_enddatatime,
     &                             '  (',enddatatime,')'
       write(*,*) 'cpidsyr       = ',avh_h_cpidsyr
       write(*,*) 'cpidsdy       = ',avh_h_cpidsdy

       write(*,*) ' '
       write(*,*) '              DATA SET QUALITY INDICATORS'
       write(*,*) ' '
       write(*,1) avh_h_inststat1
1      format(' inststat1      = ',i5,$)
       inststat14  = avh_h_inststat1
       call gp_wbin(inststat14,16,31)  
       write(*,*) 'statchrecnb    = ',avh_h_statchrecnb 
       write(*,*) 'inststat2      = ',avh_h_inststat2
       write(*,*) 'scnlin         = ',avh_h_scnlin 
       write(*,*) 'callocscnlin   = ',avh_h_callocscnlin 
       write(*,*) 'misscnlin      = ',avh_h_misscnlin 
       write(*,*) 'datagaps       = ',avh_h_datagaps
       write(*,*) 'okdatafr       = ',avh_h_okdatafr 
       write(*,*) 'pacsparityerr  = ',avh_h_pacsparityerr 
       write(*,*) 'auxsyncerrsum  = ',avh_h_auxsyncerrsum 
       write(*,*) 'timeseqerr     = ',avh_h_timeseqerr 
       write(*,*) 'timeseqerrcode = ',avh_h_timeseqerrcode 
       write(*,*) 'socclockupind  = ',avh_h_socclockupind 
       write(*,*) 'locerrind      = ',avh_h_locerrind 
       write(*,*) 'locerrcode     = ',avh_h_locerrcode 
       write(*,2) avh_h_pacsstatfield
2      format(' pacsstatfield  = ',i5,$)
       pacsstatfield4 = avh_h_pacsstatfield
       call gp_wbin(pacsstatfield4,16,31)  
       write(*,*) 'pacsdatasrc    = ',avh_h_pacsdatasrc,'  ',
     &             pacsdatasrc(avh_h_pacsdatasrc+1)(1:9) 
       write(*,*) ' '
       write(*,*) '              CALIBRATION'
       write(*,*) ' '
       write(*,4) avh_h_racalind
4      format(' racalind     = ',i5,$)
       racalind4 = avh_h_racalind
       call gp_wbin(racalind4,16,31)  
       write(*,*) 'solarcalyr   = ',avh_h_solarcalyr 
       write(*,*) 'solarcaldy   = ',avh_h_solarcaldy
       write(*,*) 'pcalalgind   = ',avh_h_pcalalgind 
       write(*,*) 'pcalalgopt   = ',avh_h_pcalalgopt
       write(*,*) 'scalalgind   = ',avh_h_scalalgind 
       write(*,*) 'scalalgopt   = ',avh_h_scalalgopt
       do i=1,4
       write(*,*) 'i,irttcoef   = ',i,(avh_h_irttcoef(j,i),j=1,6)
       enddo
       write(*,*) ' '
       write(*,*) ' '
       write(*,*) '              ALBEDO and RADIANCE TO TEMPERATURE CONV
     &ERSION'
       write(*,*) ' '
       write(*,*) 'albcnv       = ',avh_h_albcnv
       write(*,*) 'radtempcnv   = ',avh_h_radtempcnv 
       write(*,*) ' '
       write(*,*) '              NAVIGATION'
       write(*,*) ' '
       write(*,*) 'modelid      = ',avh_h_modelid
       write(*,*) 'nadloctol    = ',avh_h_nadloctol 
       write(*,3) avh_h_locbit
3      format(' locbit       = ',i5,$)
       locbit4 = avh_h_locbit
       call gp_wbin(locbit4,16,31)  
        write(*,*) 'yawerr       = ',avh_h_yawerr 
       write(*,*) 'rollerr      = ',avh_h_rollerr 
       write(*,*) 'pitcherr     = ',avh_h_pitcherr
       write(*,*) 'epoyr        = ',avh_h_epoyr
       write(*,*) 'epody        = ',avh_h_epody 
       call xhqc(avh_h_epotime,epotime) 
       write(*,*) 'epotime      = ',avh_h_epotime,
     &                            '  (',epotime,')'
       write(*,*) 'smaxis       = ',avh_h_smaxis
       write(*,*) 'eccen        = ',avh_h_eccen
       write(*,*) 'incli        = ',avh_h_incli 
       write(*,*) 'argper       = ',avh_h_argper 
       write(*,*) 'rascnod      = ',avh_h_rascnod 
       write(*,*) 'manom        = ',avh_h_manom 
       write(*,*) 'xpos         = ',avh_h_xpos 
       write(*,*) 'ypos         = ',avh_h_ypos
       write(*,*) 'zpos         = ',avh_h_zpos 
       write(*,*) 'xvel         = ',avh_h_xvel 
       write(*,*) 'yvel         = ',avh_h_yvel 
       write(*,*) 'zvel         = ',avh_h_zvel 
       write(*,*) 'earthsun     = ',avh_h_earthsun 
       write(*,*) ' '
       write(*,*) '              ANALOG TELEMETRY CONVERSION'
       write(*,*) ' '
       write(*,*) '      conversion coefficients'
       write(*,*) 'pchtemp      = ',avh_h_pchtemp
       write(*,*) 'pchtempext   = ',avh_h_pchtempext 
       write(*,*) 'pchpow       = ',avh_h_pchpow 
       write(*,*) 'rdtemp       = ',avh_h_rdtemp
       write(*,*) 'bbtemp1      = ',avh_h_bbtemp1 
       write(*,*) 'bbtemp2      = ',avh_h_bbtemp2
       write(*,*) 'bbtemp3      = ',avh_h_bbtemp3 
       write(*,*) 'bbtemp4      = ',avh_h_bbtemp4
       write(*,*) 'eleccur      = ',avh_h_eleccur 
       write(*,*) 'motorcur     = ',avh_h_motorcur 
       write(*,*) 'earthpos     = ',avh_h_earthpos
       write(*,*) 'electemp     = ',avh_h_electemp 
       write(*,*) 'chtemp       = ',avh_h_chtemp 
       write(*,*) 'bptemp       = ',avh_h_bptemp 
       write(*,*) 'mhtemp       = ',avh_h_mhtemp 
       write(*,*) 'adcontemp    = ',avh_h_adcontemp
       write(*,*) 'd4bvolt      = ',avh_h_d4bvolt
       write(*,*) 'd5bvolt      = ',avh_h_d5bvolt  
       write(*,*) 'bbtempchn3B  = ',avh_h_bbtempchn3B
       write(*,*) 'bbtempchn4   = ',avh_h_bbtempchn4 
       write(*,*) 'bbtempchn5   = ',avh_h_bbtempchn5 
       write(*,*) 'refvolt      = ',avh_h_refvolt 
       write(*,*) ' '

        return
        end

