        subroutine avhhdr(luavh,ios)
!
!BUT/PURPOSE 
! read an AVHRR 1B header record 
!         in the  common avh1bhd
! 
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  the common iocom is used by the variable luavh 
!  it supposes a previous init and open
! 
!PROPRIETAIRE/OWNER
!  
!Marie-Madeleine Pinaud
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0       03/04/95  none        Marie-Madeleine Pinaud
! 1.1       May 98                   Marcel Derrien
!                     check library and data are at the same version number
! 1.2       13/04/05  Add call to byteswap1b. N C Atkinson
!         
!ARGUMENTS 
!       input : integer luavh
!       output: integer ios
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
! 
!    
!
!
!arguments
        integer luavh
        integer ios
!commons
#include "avh1b.h"
!local variables
!functions
!-
!
        read(luavh,rec=1,iostat=ios) avh_hd
        call byteswap1b("AVH1BHD")
        call chkhd1b(avh_h_siteid,avh_h_l1bversnb)
        return
        end
