!+
!NOM/NAME $Id: chkhd1b.F 25 2006-02-03 15:43:53Z frna $
!
        subroutine chkhd1b(siteid,l1bversnb)
!BUT/PURPOSE 
! check l1b I/O library version number and 1B file version number  
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!     if siteid is not NSS
!       the reading is stopped if version numbers does not agree
!       error messages are sent through ml_wti
!       return code is 10
!       
!     else
!      warning messages are sent through ml_wti
!      return to calling
!PROPRIETAIRE/OWNER
!  
!Marcel Derrien
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0        14/05/98  none          Marcel Derrien
! 2.0       March 2003               Tiphaine Labrot
!            f90 test :
! The 3th arg in call to ML_WTI must be an integer. 
! But l1bversnb is an integer*2
! Created an intermediate variable i4l1bversnb
!         
!ARGUMENTS 
!       input : siteid ! character*3 siteid
!       input : l1bversb ! version number of the 1B file to read
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
! ml_wti, exit
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
! 
!    
!
!
!arguments
        character*3 siteid  
        integer*2 l1bversnb
        integer i4l1bversnb   
!commons
#include "nl1b.h"
!local variables
!functions
!-
!
        i4l1bversnb=l1bversnb
        
        if(siteid.ne.'NSS') then
          if(l1bversnb.ne.libl1bvers) then
            call ml_wti('warning','level 1B I/O modules version number',
     &                  libl1bvers)
            call ml_wti('warning','does not agree with  file content',
     &                  i4l1bversnb)
            return
          endif
        else
          call ml_wti('warning','level 1B I/O modules version number',
     &                  libl1bvers)
          call ml_wti('warning','data file version number',
     &                  i4l1bversnb)
        endif                
        return
        end

