!+
!NOM/NAME $Id: dcsddp.F 25 2006-02-03 15:43:53Z frna $
!
        subroutine dcsddp
!-----------------------------------------------------------------------
!
!BUT/PURPOSE: DCS 1B Data Display Procedure
!
!DESCRIPTION: FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER:  
!   T.Labrot 
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0       March 2003  none           T.Labrot 
!         
!ARGUMENTS: 
!               input common: dcs1b.h 
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!    subrouti!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
!-----------------------------------------------------------------------

      implicit none                                                     

!---- DECLARATIONS -----------------------------------------------------

!---- ARGUMENTS --------------------------------------------------------

!---- COMMONS ----------------------------------------------------------

#include "dcs1b.h"

!---- LOCAL VARIABLES --------------------------------------------------
       integer i
!---- FUNCTIONS --------------------------------------------------------

!---- CODE ------------------------------------------------------------- 

       write(*,*) ' '
       write(*,*) '             =========================='
       write(*,*) '             DCS 1B  DATA RECORD'
       write(*,*) '             =========================='

       write(*,*) ' '
       write(*,*) 'FRAME INFORMATION STRUCTURE '
       write(*,*) '============================'
       write(*,*) ' ' 
       write(*,*) 'major frame count -------------------: ',dcs_mjfrcnt
       write(*,*) 'major frame year---------------------: ',dcs_mjfryr
       write(*,*) 'major frame day of year--------------: ',dcs_mjfrdy
       write(*,*) 'satellite clock drift delta mseconds-: ',
     &       dcs_clockdrift    
       write(*,*) 'scan line UTC time of day  mseconds--: ',
     &       dcs_mjfrtime
       write(*,*) 'major frame bit field----------------: ',
     &       dcs_mjfbf
       
       do i=1,5
       write(*,*) 'filler <zero fill>-------------------: ',
     &       i,dcs_filler1(i)
       enddo
       
       write(*,*) ' '
       write(*,*) 'QUALITY INDICATORS '
       write(*,*) '==================='
       write(*,*) ' '      
       
       write(*,'('' quality indicator bit field -------: '',$)') 
       call gp_wb32( dcs_qualind )
       
       write(*,'('' major frame quality flags----------: '',$)') 
       call gp_wb32( dcs_mjfqf )
       
       write(*,*) 'filler <zero fill>-----------------: ',
     &       dcs_filler2
       
       write(*,*) ' '
       write(*,*) 'DCS MINOR FRAME DATA '
       write(*,*) '====================='
       write(*,*) ' ' 
       write(*,'(5i14)') dcs_data
       write(*,*) ' '
       
       write(*,*) 'filler <zero fill>------------------: ',dcs_filler3
       
       write(*,*) ' '
       write(*,*) 'DIGITAL B TELEMETRY '
       write(*,*) '===================='
       write(*,*) ' ' 
       write(*,'('' invalid word bit flags------------: '',$)') 
       call gp_wb16( dcs_digbinvwbf )
       write(*,'('' digital B telemetry---------------: '',$)') 
       call gp_wb16( dcs_digbtlm )
       write(*,*) 'filler <zero fill>----------------: ',dcs_filler4
       
       write(*,*) ' '
       write(*,*) 'ANALOG TELEMETRY '
       write(*,*) '================='
       write(*,*) ' '
       write(*,'('' invalid word bit flags-----------: '',$)') 
       call gp_wb16( dcs_aninvwbf )
       write(*,'('' analog telemetry-----------------: '')') 
       do i=1,8
       call gp_wb16( dcs_analog(i) )
       enddo
       
       write(*,*) ' '
       write(*,*) ' dcs_filler5(221) '
       write(*,*) '=================='      
       write(*,'(17i4)') dcs_filler5
           
       return
       end

