!+
!NOM/NAME $Id: dcshdp.F 25 2006-02-03 15:43:53Z frna $
!
        subroutine dcshdp
!
!BUT/PURPOSE 
!  print an DCS 1B header record  
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER  
!
!  Marie-Madeleine Pinaud
!   
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0       22/09/95  none        Marie-Madeleine Pinaud
! 1.2       10/11/95  Change 1B   Marcel Derrien
! 1.3       15/05/98  Change 1B   Marcel Derrien
! 1.4       06/12/01  Modified the size and the elements of the character  
!                     array tipsrc to be consistent with the definition 
!                     of dcs_h_tipsrc (include dcs1b.h)  (T.Labrot)
!
!         
!ARGUMENTS 
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
! 
!    
!
!
!arguments

!commons
#include "dcs1b.h"
!local variables
       character*8 datatyp(12)
       data datatyp/'(  )','(LAC)','(GAC)','(HRPT)',
     &              '(TIP)','(HIRS)','(MSU)','(SSU)',
     &              '(DCS)','(SEM)','(AMSU-A)','(AMSU-B)'/
       character*16 tipsrc(5)
       data tipsrc/'(not applicable)','(GAC embedded)','(stored)',
     &             '(third CDA)','(HRPT embedded)'/
       character*9 pacsdatasrc(4)
       data pacsdatasrc/'(unused)','(Gilmore)','(Wallops)','(SOCC)'/
       character*8 startdatac,enddatac
       character*12 startdatatime,enddatatime
       integer*4 pacsstatfield4
!functions
!-
       write(*,*) ' '
       write(*,*) '             DCS Level 1B Data Set HEADER RECORD'
       write(*,*) ' '
       write(*,*) '             GENERAL INFORMATION'
       write(*,*) ' '
       write(*,*) 'site creation = ',dcs_h_siteid
       write(*,*) 'l1bversnb     = ',dcs_h_l1bversnb
       write(*,*) 'l1bversyr     = ',dcs_h_l1bversyr
       write(*,*) 'l1bversdy     = ',dcs_h_l1bversdy
       write(*,*) 'record length = ',dcs_h_reclg
       write(*,*) 'block size    = ',dcs_h_blksz
       write(*,*) 'hdrcnt        = ',dcs_h_hdrcnt
       write(*,*) 'dataname      = ',dcs_h_dataname
       write(*,*) 'prblkid       = ',dcs_h_prblkid
       write(*,*) 'satid         = ',dcs_h_satid
       write(*,*) 'datatyp       = ',dcs_h_datatyp,'  ',
     &             datatyp(dcs_h_datatyp+1)(1:8)
       write(*,*) 'tipsrc        = ',dcs_h_tipsrc,'  ',
     &             tipsrc(dcs_h_tipsrc+1)(1:16)
       call xdjc(dcs_h_startdatajd,startdatac) 
       write(*,*) 'startdatajd   = ',dcs_h_startdatajd,
     &                             '  (',startdatac,')' 
       write(*,*) 'startdatayr   = ',dcs_h_startdatayr
       write(*,*) 'startdatady   = ',dcs_h_startdatady
       call xhqc(dcs_h_startdatatime,startdatatime) 
       write(*,*) 'startdatatime = ',dcs_h_startdatatime,
     &                             '  (',startdatatime,')'
       call xdjc(dcs_h_enddatajd,enddatac) 
       write(*,*) 'enddatajd     = ',dcs_h_enddatajd,
     &                             '  (',enddatac,')' 
       write(*,*) 'enddatayr     = ',dcs_h_enddatayr
       write(*,*) 'enddatady     = ',dcs_h_enddatady
       call xhqc(dcs_h_enddatatime,enddatatime) 
       write(*,*) 'enddatatime   = ',dcs_h_enddatatime,
     &                             '  (',enddatatime,')'
       write(*,*) 'cpidsyr       = ',dcs_h_cpidsyr
       write(*,*) 'cpidsdy       = ',dcs_h_cpidsdy

       write(*,*) ' '
       write(*,*) '              DATA SET QUALITY INDICATORS'
       write(*,*) ' '
       write(*,1) dcs_h_inststat
  1    format(' inststat       = ',i5,$)
       call gp_wbin(dcs_h_inststat,16,31) 
       write(*,*) 'statchrecnb    = ',dcs_h_statchrecnb 
       write(*,*) 'scnlin        = ',dcs_h_scnlin
       write(*,*) 'datagaps      = ',dcs_h_datagaps
       write(*,*) 'okdatafr      = ',dcs_h_okdatafr
       write(*,*) 'pacsparityerr = ',dcs_h_pacsparityerr
       write(*,*) 'auxsyncerrsum = ',dcs_h_auxsyncerrsum 
       write(*,2) dcs_h_pacsstatfield
  2    format('pacsstatfield = ',i5,$)
       pacsstatfield4 = dcs_h_pacsstatfield
       call gp_wbin(pacsstatfield4,16,31)  
       write(*,*) 'pacsdatasrc    = ',dcs_h_pacsdatasrc,'  ',
     &             pacsdatasrc(dcs_h_pacsdatasrc+1)(1:9)

!       write(*,*) '             PRE PROCESSING INFORMATION'
    
!       write(*,*) 'ancnv (type 1) = ',dcs_h_ancnv(5,1)
!       write(*,*) 'ancnv (type 2) = ',dcs_h_ancnv(5,2)
!       write(*,*) 'ancnv (type 3) = ',dcs_h_ancnv(5,3)
!       write(*,*) 'ancnv (type 4) = ',dcs_h_ancnv(5,4)
!       write(*,*) 'ancnv (type 5) = ',dcs_h_ancnv(5,5)
!       write(*,*) 'ancnv (type 6) = ',dcs_h_ancnv(5,6)
!       write(*,*) 'ancnv (type 7) = ',dcs_h_ancnv(5,7)
!       write(*,*) ' '
        return
        end
