!+
!NOM/NAME $Id: hrshdp.F 25 2006-02-03 15:43:53Z frna $
!
        subroutine hrshdp

!BUT/PURPOSE 
!  print an HIRS 1B header record 
! 
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER  
!
!  Marie-Madeleine Pinaud
!   
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.1       02/06/95  none        Marie-Madeleine Pinaud
! 1.2       10/11/95  Change 1B   Marcel Derrien
! 1.3       15/05/98  Change 1B   Marcel Derrien
! 1.4       06/12/01  Modified the size and the elements of the character  
!                     array tipsrc to be consistent with the definition 
!                     of hrs_h_tipsrc (include hrs1b.h)  (T.Labrot)  
! 2.0       Feb 05    Update for new l1b format   T.LABROT       
!         
!ARGUMENTS 
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
!
!arguments

!commons
#include "hrs1b.h"
!local variables
       character*19 tipsrc(5)
       data tipsrc/'(unused)','(GAC embedded)','(stored TIP)',
     &             '(HRPT/LAC embedded)','(stored AIP)'/ 
       character*11 pacsdatasrc(6)
       data pacsdatasrc/'(unused)','(Fairbanks)','(Wallops)','(SOCC)',
     &                  '(Svalbard)','(Monterey)'/
       character*8 startdatac,enddatac
       character*12 startdatatime,enddatatime,epotime
       integer i
       integer ordchn(20)
       data ordchn/1,17,2,3,13,4,18,11,19,7,8,20,10,14,6,5,15,12,16,9/
!functions
!-
       write(*,*) ' '
       write(*,*) '             ===================================='
       write(*,*) '             HIRS Level 1B Data Set HEADER RECORD'
       write(*,*) '             ===================================='
       write(*,*) ' '
       write(*,*) '             GENERAL INFORMATION'
       write(*,*) ' '
       write(*,*) 'site creation                   = ',hrs_h_siteid
       write(*,*) 'ASCII blank                     = ',hrs_h_blank
       write(*,*) 'l1b format version number       = ',hrs_h_l1bversnb
       write(*,*) 'l1b format version year         = ',hrs_h_l1bversyr
       write(*,*) 'l1b format version day          = ',hrs_h_l1bversdy
       write(*,*) 'record length (bytes)           = ',hrs_h_reclg
       write(*,*) 'block size                      = ',hrs_h_blksz
       write(*,*) 'count of header records         = ',hrs_h_hdrcnt
       write(*,*) 'data set name                   = ',hrs_h_dataname
       write(*,*) 'processing block identif.       = ',hrs_h_prblkid
       write(*,*) 'spacecraft identif. code        = ',hrs_h_satid
       write(*,*) 'instrument ID                   = ',hrs_h_instid
       write(*,*) 'data type code (5 for HIRS)     = ',hrs_h_datatyp
       write(*,*) 'TIP source code                 = ',hrs_h_tipsrc,
     &             '  ',tipsrc(hrs_h_tipsrc+1)(1:17)
       call xdjc(hrs_h_startdatajd,startdatac) 
       write(*,*) 'start of data set Julian day    = ',
     & hrs_h_startdatajd,'  (',startdatac,')' 
       write(*,*) 'start of data set year          = ',hrs_h_startdatayr
       write(*,*) 'start of data set day           = ',hrs_h_startdatady
       call xhqc(hrs_h_startdatatime,startdatatime) 
       write(*,*) 'start of data set  UTC time     = ',
     & hrs_h_startdatatime,'  (',startdatatime,')'
       call xdjc(hrs_h_enddatajd,enddatac) 
       write(*,*) 'end of data set Julian day      = ',hrs_h_enddatajd,
     &                             '  (',enddatac,')' 
       write(*,*) 'end of data set year            = ',hrs_h_enddatayr
       write(*,*) 'end of data set day             = ',hrs_h_enddatady
       call xhqc(hrs_h_enddatatime,enddatatime) 
       write(*,*) 'end of data set  UTC time       = ',
     & hrs_h_enddatatime,'  (',enddatatime,')'
       write(*,*) 'year of last CPIDS update       = ',hrs_h_cpidsyr
       write(*,*) 'day of year of last CPIDS update= ',hrs_h_cpidsdy
       write(*,*) 'offset between start of scan ',
     &   'and center of first FOV= ',hrs_h_fov1offset
       write(*,*) 'instrument type HIRS 3 or 4     =',hrs_h_instrtype
            
       write(*,*) ' '
       write(*,*) '              DATA SET QUALITY INDICATORS'
       write(*,*) ' '
       write(*,'('' instrument status 1          = '',$)') 
       call gp_wb32( hrs_h_inststat1 )  
       write(*,*) 'record nb of status change   = ',hrs_h_statchrecnb
       write(*,'('' instrument status 2          = '',$)')
       call gp_wb32( hrs_h_inststat2 )
       write(*,*) 'count of data records        = ',hrs_h_scnlin
       write(*,*) 'count of calib located lines = ',hrs_h_callocsclin
       write(*,*) 'count of missing lines       = ',hrs_h_misscnlin
       write(*,*) 'count of data gaps           = ',hrs_h_datagaps
       write(*,*) 
     & 'count of data frames without frame sync errors       = ',
     & hrs_h_okdatafr
       write(*,*) 'count of PACS detected TIP parity errors  = ',
     & hrs_h_pacsparityerr
       write(*,*) 'sum of all auxiliary sync errors detected = ',
     & hrs_h_auxsyncerrsum
       write(*,*) 'time sequence error            = ',hrs_h_timeseqerr
       write(*,'('' time sequence error code       = '',$)') 
       call gp_wb16( hrs_h_timeseqerrcode )  
       write(*,*) 'SOCC clock update indicator    = ',
     & hrs_h_socclockupind
       write(*,*) 'Earth location error indicator = ',hrs_h_locerrind
       write(*,'('' Earth location error code      = '',$)') 
       call gp_wb16( hrs_h_locerrcode ) 
       write(*,'('' PACS status bit field          = '',$)') 
       call gp_wb16( hrs_h_pacsstatfield )
       write(*,*) 'data source                    = ',hrs_h_pacsdatasrc,
     & '  ',pacsdatasrc(hrs_h_pacsdatasrc+1)(1:11)
     
       write(*,*) ' '
       write(*,*) '               CALIBRATION'
       write(*,*) ' '
       write(*,'('' auto calib indicators bit field    = '',$)') 
       call gp_wb16( hrs_h_autocalind )
       write(*,*) 'year of solar channel calib        = ',
     & hrs_h_solarcalyr
       write(*,*) 'day of year of solar channel calib = ',
     &  hrs_h_solarcaldy
       write(*,*) 'calibration information '
       do i = 1, hrs_mxchn
          write(*,'(" CH Mean slope Stand. dev. slope    = ",
     &    I2,3X,F10.8,4X,F10.8 )')    
     &    ordchn(i), 
     &    hrs_h_calinf(1,i)*1.e-06,
     &    hrs_h_calinf(2,i)*1.e-06
          write(*,'(" CH  B1  Stand. dev.B1              = ",
     &    I2,3X,F10.8,4X,F10.8 )')     
     &    ordchn(i),     
     &    hrs_h_calinf(3,i)*1.e-06,
     &    hrs_h_calinf(4,i)*1.e-06
       enddo
       
       write(*,*) ' '
       write(*,*) '              TEMPERATURE-RADIANCE CONVERSION'
       write(*,*) ' '
       do i=1,hrs_mxirchn
        if (i.le.12) then
         write(*,'(" CH temp-radiance conversion       = ",
     &   I2,3X,F8.2,2(4X,F9.7) )')      
     &   i,hrs_h_tempradcnv(1,i)*1.e-06,
     &   hrs_h_tempradcnv(2,i)*1.e-06,hrs_h_tempradcnv(3,i)*1.e-06
        else
         write(*,'(" CH temp-radiance conversion       = ",
     &   I2,3X,F8.2,2(4X,F9.7) )') 
     &   i,hrs_h_tempradcnv(1,i)*1.e-05,
     &   hrs_h_tempradcnv(2,i)*1.e-06,hrs_h_tempradcnv(3,i)*1.e-06
        endif
       enddo
       write(*,*) 'alb-rad ch20 solar filtered irradiance = ',
     & hrs_h_20solfiltirrad*1.e-02
       write(*,*) 'alb-rad ch20 equivalent filter width   = ',
     & hrs_h_20equifiltwidth*1.e-04
     
       write(*,*) ' '
       write(*,*) '              NAVIGATION'
       write(*,*) ' '
       write(*,*) 'modelid                                     = ',
     & hrs_h_modelid
       write(*,*) 'nadir Earth loc tolerance in km             = ',
     & hrs_h_nadloctol*1.e-01 
       write(*,'('' Earth location bit field                   '',
     & '' = '',$)') 
       call gp_wb16( hrs_h_locbit )      
       write(*,*) 'constant roll error (dg)                    = ',
     & hrs_h_rollerr*1.e-3
       write(*,*) 'constant pitch error (dg)                   = ',
     & hrs_h_pitcherr*1.e-3
       write(*,*) 'constant yaw error (dg)                     = ',
     & hrs_h_yawerr*1.e-3
       write(*,*) 'epoch year for orbit vector                 = ',
     & hrs_h_epoyr
       write(*,*) 'day of epoch year for orbit vector          = ',
     & hrs_h_epody 
       call xhqc(hrs_h_epotime,epotime) 
       write(*,*) 'epoch UTC time of day  for orbit vector     = ',
     & hrs_h_epotime, '  (',epotime,')'
       write(*,*) 'semi=major axis in km                       = ',
     & hrs_h_smaxis*1.e-5
       write(*,*) 'eccentricity                                = ',
     & hrs_h_eccen*1.e-8           
       write(*,*) 'inclination in dg                           = ',
     & hrs_h_incli*1.e-5 
       write(*,*) 'arg of perigee in dg                        = ',
     & hrs_h_argper*1.e-5 
       write(*,*) 'right ascension of the asd node in dg       = ',
     & hrs_h_rascnod*1.e-5 
       write(*,*) 'mean anomaly in dg                          = ',
     & hrs_h_manom*1.e-5 
       write(*,*) 'position vector X component km              = ',
     & hrs_h_xpos*1.e-5 
       write(*,*) 'position vector Y component km              = ',
     & hrs_h_ypos*1.e-5
       write(*,*) 'position vector Z component km              = ',
     & hrs_h_zpos*1.e-5 
       write(*,*) 'velocity vector X-dot component km/s        = ',
     & hrs_h_xvel*1.e-8 
       write(*,*) 'velocity vector Y-dot component km/s        = ',
     & hrs_h_yvel*1.e-8 
       write(*,*) 'velocity vector Z-dot component km/s        = ',
     & hrs_h_zvel*1.e-8 
       write(*,*) 'Earth/sun distance ratio                    = ',
     & hrs_h_earthsun*1.e-6 
       
       write(*,*) ' '
       write(*,*) '             ANALOG TELEMETRY CONVERSION'
       write(*,*) '           scaling factors 10^(2,2,3,3,3,5)'
       write(*,*) ' '
       write(*,*) 'radiator temp conv coef          = ',hrs_h_rdtemp
       write(*,*) 'base plate temp conv coef        = ',hrs_h_bptemp
       write(*,*) 'electronics temp conv coef       = ',hrs_h_eltemp
       write(*,*) 'patch temp conv coef             = ',hrs_h_pchtemp
       write(*,*) 'filter housing controller current conv coef = ',
     & hrs_h_fhcc
       write(*,*) 'scan motor temp conv coef        = ',hrs_h_scnmtemp
       write(*,*) 'filter wheel motor temp conv coef= ',hrs_h_fwmtemp
       write(*,*) '+5VDC monitor conv coef          = ',hrs_h_p5v
       write(*,*) '+10VDC TLM/DC/DC conv coef       = ',hrs_h_p10v
       write(*,*) '+7.5VDC TLM/DC/DC conv coef      = ',hrs_h_p75v
       write(*,*) '-7.5VDC TLM/DC/DC conv coef      = ',hrs_h_m75v
       write(*,*) '+15VDC monitor conv coef         = ',hrs_h_p15v
       write(*,*) '-15VDC monitor conv coef         = ',hrs_h_m15v
       write(*,*) 'filter wheel motor current conv coef = ',hrs_h_fwmcur
       write(*,*) 'scan motor current conv coef     = ',hrs_h_scmcur
       write(*,*) 'patch controller power conv coef = ',hrs_h_pchcpow
       
       write(*,*) ' '
       write(*,*) '            DIGITAL A TELEMETRY CONVERSION'
       write(*,*) ' '
       do i=1,5
       write(*,*) 'IWT temp sensor conv coef = ',
     & hrs_h_iwtcnttmp(1,i)*1.e-06,hrs_h_iwtcnttmp(2,i)*1.e-09,
     & hrs_h_iwtcnttmp(3,i)*1.e-14,hrs_h_iwtcnttmp(4,i)*1.e-17,
     & hrs_h_iwtcnttmp(5,i)*1.e-21,hrs_h_iwtcnttmp(6,i)*1.e-25
       enddo
       do i=1,4
       write(*,*) 'ICT temp sensor conv coef = ',
     & hrs_h_ictcnttmp(1,i)*1.e-06,hrs_h_ictcnttmp(2,i)*1.e-09,
     & hrs_h_ictcnttmp(3,i)*1.e-14,hrs_h_ictcnttmp(4,i)*1.e-17,
     & hrs_h_ictcnttmp(5,i)*1.e-21,hrs_h_ictcnttmp(6,i)*1.e-25
       enddo
       write(*,*) 'tertiary telescopt temp sensor conv coef   = ', 
     & hrs_h_tttcnttmp(1)*1.e-06,hrs_h_tttcnttmp(2)*1.e-09,
     & hrs_h_tttcnttmp(3)*1.e-14,hrs_h_tttcnttmp(4)*1.e-17,
     & hrs_h_tttcnttmp(5)*1.e-21,hrs_h_tttcnttmp(6)*1.e-25
       do i=1,4
       write(*,*) 'filter wheel housing temp sensor conv coef = ', 
     & hrs_h_fwcnttmp(1,i)*1.e-06,hrs_h_fwcnttmp(2,i)*1.e-09,
     & hrs_h_fwcnttmp(3,i)*1.e-14,hrs_h_fwcnttmp(4,i)*1.e-17,
     & hrs_h_fwcnttmp(5,i)*1.e-21,hrs_h_fwcnttmp(6,i)*1.e-25
       enddo
       write(*,*) 'patch  temp conv coef                      = ', 
     & hrs_h_patchexpcnttmp(1)*1.e-06,hrs_h_patchexpcnttmp(2)*1.e-09,
     & hrs_h_patchexpcnttmp(3)*1.e-14,hrs_h_patchexpcnttmp(4)*1.e-17,
     & hrs_h_patchexpcnttmp(5)*1.e-21,hrs_h_patchexpcnttmp(6)*1.e-25
       write(*,*) 'first stage radiator temp sensor conv coef = ', 
     & hrs_h_fsradcnttmp(1)*1.e-06,hrs_h_fsradcnttmp(2)*1.e-09,
     & hrs_h_fsradcnttmp(3)*1.e-14,hrs_h_fsradcnttmp(4)*1.e-17,
     & hrs_h_fsradcnttmp(5)*1.e-21,hrs_h_fsradcnttmp(6)*1.e-25
       write(*,*) 'scan mirror temp sensor conv coef          = ', 
     & hrs_h_scmircnttmp(1)*1.e-06,hrs_h_scmircnttmp(2)*1.e-09,
     & hrs_h_scmircnttmp(3)*1.e-14,hrs_h_scmircnttmp(4)*1.e-17,
     & hrs_h_scmircnttmp(5)*1.e-21,hrs_h_scmircnttmp(6)*1.e-25
       write(*,*) 'primary telescope temp sensor conv coef    = ', 
     & hrs_h_pttcnttmp(1)*1.e-06,hrs_h_pttcnttmp(2)*1.e-09,
     & hrs_h_pttcnttmp(3)*1.e-14,hrs_h_pttcnttmp(4)*1.e-17,
     & hrs_h_pttcnttmp(5)*1.e-21,hrs_h_pttcnttmp(6)*1.e-25       
       write(*,*) 'secondary telescope temp sensor conv coef  = ', 
     & hrs_h_sttcnttmp(1)*1.e-06,hrs_h_sttcnttmp(2)*1.e-09,
     & hrs_h_sttcnttmp(3)*1.e-14,hrs_h_sttcnttmp(4)*1.e-17,
     & hrs_h_sttcnttmp(5)*1.e-21,hrs_h_sttcnttmp(6)*1.e-25
       write(*,*) 'baseplate temp conv coef          = ', 
     & hrs_h_bpcnttmp(1)*1.e-06,hrs_h_bpcnttmp(2)*1.e-09,
     & hrs_h_bpcnttmp(3)*1.e-14,hrs_h_bpcnttmp(4)*1.e-17,
     & hrs_h_bpcnttmp(5)*1.e-21,hrs_h_bpcnttmp(6)*1.e-25
       write(*,*) 'electronics temp conv coef        = ', 
     & hrs_h_electcnttmp(1)*1.e-06,hrs_h_electcnttmp(2)*1.e-09,
     & hrs_h_electcnttmp(3)*1.e-14,hrs_h_electcnttmp(4)*1.e-17,
     & hrs_h_electcnttmp(5)*1.e-21,hrs_h_electcnttmp(6)*1.e-25
       write(*,*) 'patch temp full range conv coef   = ', 
     & hrs_h_patchfcnttmp(1)*1.e-06,hrs_h_patchfcnttmp(2)*1.e-09,
     & hrs_h_patchfcnttmp(3)*1.e-14,hrs_h_patchfcnttmp(4)*1.e-17,
     & hrs_h_patchfcnttmp(5)*1.e-21,hrs_h_patchfcnttmp(6)*1.e-25
       write(*,*) 'scan motor temp conv coef         = ', 
     & hrs_h_scmotcnttmp(1)*1.e-06,hrs_h_scmotcnttmp(2)*1.e-09,
     & hrs_h_scmotcnttmp(3)*1.e-14,hrs_h_scmotcnttmp(4)*1.e-17,
     & hrs_h_scmotcnttmp(5)*1.e-21,hrs_h_scmotcnttmp(6)*1.e-25
       write(*,*) 'filter wheel motor temp conv coef = ', 
     & hrs_h_fwmcnttmp(1)*1.e-06,hrs_h_fwmcnttmp(2)*1.e-09,
     & hrs_h_fwmcnttmp(3)*1.e-14,hrs_h_fwmcnttmp(4)*1.e-17,
     & hrs_h_fwmcnttmp(5)*1.e-21,hrs_h_fwmcnttmp(6)*1.e-25
      write(*,*) 'cooler housing temp conv coef      = ', 
     & hrs_h_chsgcnttmp(1)*1.e-06,hrs_h_chsgcnttmp(2)*1.e-09,
     & hrs_h_chsgcnttmp(3)*1.e-14,hrs_h_chsgcnttmp(4)*1.e-17,
     & hrs_h_chsgcnttmp(5)*1.e-21,hrs_h_chsgcnttmp(6)*1.e-25
      
      write(*,*) ' '
      write(*,*) '            DIGITAL A TELEMETRY CONVERSION'
      write(*,*) '                 conversion constants'
      write(*,*) ' '
      
      write(*,*) '10^9*filter wheel housing heater current        =',
     &hrs_h_conversions(1)
      write(*,*) '10*electronic calib digital to analog converter =',
     &hrs_h_conversions(2)
      write(*,*) '10^17*patch control power   =',hrs_h_conversions(3)
      write(*,*) '10^9*scan motor power       =',hrs_h_conversions(4)
      write(*,*) '10^9*filter motor power     =',hrs_h_conversions(5)
      write(*,*) '10^8*+15 VDC                =',hrs_h_conversions(6)
      write(*,*) '10^8*-15 VDC                =',hrs_h_conversions(7)
      write(*,*) '10^8*+7.5 VDC               =',hrs_h_conversions(8)
      write(*,*) '10^8*-7.5 VDC               =',hrs_h_conversions(9)
      write(*,*) '10^8*+10 VDC                =',hrs_h_conversions(10)
      write(*,*) '10^8*+5 VDC                 =',hrs_h_conversions(11)
     
      write(*,*) ' '
      write(*,*) '            LUNAR CONTAMINATION'
      write(*,*) ' '
      write(*,*)
     &'count of space view scans containing lunar-contamination =',
     &hrs_h_moonscnlin
      write(*,*) 'lunar angle thresold in dg   = ',
     &hrs_h_moonthresh*1.e-02 
      
      write(*,*) ' '
      write(*,*) '         24-HOUR AVERAGE SPACE VIEW COUNTS'
      write(*,*) ' '
      do i=1,hrs_mxchn
        write(*,*) '24-hour space view count for ch ',i,' =',
     &  hrs_h_avspcounts(i)
      enddo
      
        return
        end


