!+
!NOM/NAME $Id: msuhdp.F 25 2006-02-03 15:43:53Z frna $
!
        subroutine msuhdp

!BUT/PURPOSE 
!  print an MSU 1B header record 
! 
!
!DESCRIPTION 
!     FORTRAN 77 with UKMO/METEO-FRANCE accepted extensions   
!  
!PROPRIETAIRE/OWNER  
!
!  Marie-Madeleine Pinaud/ Marcel Derrien
!   
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.1       02/06/95  none        Marie-Madeleine Pinaud
! 1.2       10/11/95  Change 1B   Marcel Derrien
! 1.3       15/05/98  Change 1B   Marcel Derrien
! 1.4       06/12/01  Modified the size and the elements of the character  
!                     array tipsrc to be consistent with the definition 
!                     of msu_h_tipsrc (include msu1b.h)  (T.Labrot)
!         
!ARGUMENTS 
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
! 
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!DECLARATIONS
! 
!    
!
!
!arguments

!commons
#include "msu1b.h"
!local variables
       character*8 datatyp(12)
       data datatyp/'(  )','(LAC)','(GAC)','(HRPT)',
     &              '(TIP)','(HIRS)','(MSU)','(SSU)',
     &              '(DCS)','(SEM)','(AMSU-A)','(AMSU-B)'/
       character*16 tipsrc(5)
       data tipsrc/'(not applicable)','(GAC embedded)','(stored)',
     &             '(third CDA)','(HRPT embedded)'/
       character*8 startdatac,enddatac
       character*12 startdatatime,enddatatime
       integer*4 inststat14,locbit4
!functions
!-
       write(*,*) ' '
       write(*,*) '             MSU Level 1B Data Set HEADER RECORD'
       write(*,*) ' '
       write(*,*) '               GENERAL INFORMATION'
       write(*,*) ' '
       write(*,*) 'site creation = ',msu_h_siteid
       write(*,*) 'l1bversnb     = ',msu_h_l1bversnb
       write(*,*) 'l1bversyr     = ',msu_h_l1bversyr
       write(*,*) 'l1bversdy     = ',msu_h_l1bversdy
       write(*,*) 'record length = ',msu_h_reclg
       write(*,*) 'block size    = ',msu_h_blksz
       write(*,*) 'hdrcnt        = ',msu_h_hdrcnt
       write(*,*) 'dataname      = ',msu_h_dataname
       write(*,*) 'prblkid       = ',msu_h_prblkid
       write(*,*) 'satid         = ',msu_h_satid
       write(*,*) 'instid        = ',msu_h_instid
       write(*,*) 'datatyp       = ',msu_h_datatyp,'  ',
     &             datatyp(msu_h_datatyp+1)(1:8)
       write(*,*) 'tipsrc        = ',msu_h_tipsrc,'  ',
     &             tipsrc(msu_h_tipsrc+1)(1:16)
       write(*,*) 'filler0       = ',msu_h_filler0
       call xdjc(msu_h_startdatajd,startdatac) 
       write(*,*) 'startdatajd   = ',msu_h_startdatajd,
     &                             '  (',startdatac,')' 
       write(*,*) 'startdatayr   = ',msu_h_startdatayr
       write(*,*) 'startdatady   = ',msu_h_startdatady
       call xhqc(msu_h_startdatatime,startdatatime) 
       write(*,*) 'startdatatime = ',msu_h_startdatatime,
     &                             '  (',startdatatime,')'
       call xdjc(msu_h_enddatajd,enddatac) 
       write(*,*) 'enddatajd     = ',msu_h_enddatajd,
     &                             '  (',enddatac,')' 
       write(*,*) 'enddatayr     = ',msu_h_enddatayr
       write(*,*) 'enddatady     = ',msu_h_enddatady
       call xhqc(msu_h_enddatatime,enddatatime) 
       write(*,*) 'enddatatime   = ',msu_h_enddatatime,
     &                             '  (',enddatatime,')'
       write(*,*) 'cpidsyr       = ',msu_h_cpidsyr
       write(*,*) 'cpidsdy       = ',msu_h_cpidsyr
       write(*,*) ' '
       write(*,*) '               DATA SET QUALITY INDICATORS'
       write(*,*) ' ' 
       write(*,1) msu_h_inststat1
1      format(' inststat1      = ',i5,$)
       inststat14 = msu_h_inststat1
       call gp_wbin(inststat14,16,31)  
       write(*,*) 'statchrecnb    = ',msu_h_statchrecnb
       write(*,*) 'inststat2      = ',msu_h_inststat2
       write(*,*) 'scnlin         = ',msu_h_scnlin
       write(*,*) 'callocsclin    = ',msu_h_callocsclin
       write(*,*) 'misscnlin      = ',msu_h_misscnlin
       write(*,*) 'datagaps       = ',msu_h_datagaps
       write(*,*) 'okdatafr       = ',msu_h_okdatafr
       write(*,*) 'pacsparityerr  = ',msu_h_pacsparityerr
       write(*,*) 'auxsyncerrsum  = ',msu_h_auxsyncerrsum
       write(*,*) 'timeseqerr     = ',msu_h_timeseqerr
       write(*,*) 'timeseqerrcode = ',msu_h_timeseqerrcode
       write(*,*) 'socclockupind  = ',msu_h_socclockupind
       write(*,*) 'locerrind      = ',msu_h_locerrind
       write(*,*) 'locerrcode     = ',msu_h_locerrcode
       write(*,*) ' '
       write(*,*) ' '
       write(*,*) '               CALIBRATION'
       write(*,*) ' '
       write(*,*) 'ramp/auto indicator = ',msu_h_racalind
       write(*,*) 'calinf    = ',msu_h_calinf
       write(*,*) ' '
       write(*,*) ' '
       write(*,*) '               RADIANCE TO TEMPERATURE CONVERSION'
       write(*,*) ' '
       write(*,*) 'nolincor  = ',msu_h_nolincor
       write(*,*) 'prttores  = ',msu_h_prttores
       write(*,*) 'iwttotemp = ',msu_h_iwttotemp
       write(*,*) 'censperes = ',msu_h_censperes
       write(*,*) 'radspa    = ',msu_h_radspa
       write(*,*) ' '
       write(*,*) '               NAVIGATION'
       write(*,*) ' '
       write(*,*) 'modelid      = ',msu_h_modelid
       write(*,*) 'nadloctol = ',msu_h_nadloctol
       write(*,2) msu_h_locbit
2      format(' locbit      = ',i5,$)
       locbit4 = msu_h_locbit
       call gp_wbin(locbit4,16,31)  
       write(*,*) 'yawerr    = ',msu_h_yawerr
       write(*,*) 'rollerr   = ',msu_h_rollerr
       write(*,*) 'pitcherr  = ',msu_h_pitcherr
       write(*,*) 'epoyr     = ',msu_h_epoyr
       write(*,*) 'epody     = ',msu_h_epody
       write(*,*) 'filler3   = ',msu_h_filler3
       write(*,*) 'epotime   = ',msu_h_epotime
       write(*,*) 'smaxis    = ',msu_h_smaxis
       write(*,*) 'eccen     = ',msu_h_eccen
       write(*,*) 'incli     = ',msu_h_incli
       write(*,*) 'argper    = ',msu_h_argper
       write(*,*) 'rascnod   = ',msu_h_rascnod
       write(*,*) 'manom     = ',msu_h_manom
       write(*,*) 'xpos      = ',msu_h_xpos
       write(*,*) 'ypos      = ',msu_h_ypos
       write(*,*) 'zpos      = ',msu_h_zpos
       write(*,*) 'xvel      = ',msu_h_xvel
       write(*,*) 'yvel      = ',msu_h_yvel
       write(*,*) 'zvel      = ',msu_h_zvel
       write(*,*) 'earthsun  = ',msu_h_earthsun
       write(*,*) ' '
       write(*,*) '               DIGITAL A CONVERSION'
       write(*,*) ' '
       write(*,*) 'TBD'
       write(*,*) ' '

        return
        end

