#ifdef HAS_IDATE_AS_MDY
      subroutine GDG (DG)
C
C=============================================[ documentation ]=========
C
C---------------------------------------------[ identification ]--------
C
C     auteur            : Gerard LEGENDRE
C     date de creation  : 26/08/87
C     support           : CMS:F7BBT.FTN
C     account           : 920
C
C Version 1.1, 18/8/04, N C Atkinson: Make Linux behave as for Hp - idate
C                       returns 100 when year is 2000.
C Version 1.2, 31/1/05, The above is incorrect. Instead, allow Idate to return
C                       0, 100 or 2000 in year 2000.
C gdg_vers2.F:
C Version 1.3, 07/2/05, For use with compilers that return [Month, Day, Year]
C                       from idate
C
C---------------------------------------------[ role ]------------------
C
C     Obtention de la date gregorienne machine.
C
C---------------------------------------------[ domaine de validite ]---
C
C     du 1er janvier 1950 au 31 decembre 2049.
C
C---------------------------------------------[ modifications ]---------
C
C     neant
C
C---------------------------------------------[ remarques ]-------------
C
C     *************************************************
C     * Ce S/P doit etre adapte a la machine support. *
C     *************************************************
C
C---------------------------------------------[ syntaxe d'appel ]-------
C
C     call GDG(DG)
C
C     DG : integer(3) = date gregorienne.
C
C---------------------------------------------[ variables globales ]----
C
C     neant
C
C---------------------------------------------[ common ]----------------
C
C     neant
C
C---------------------------------------------[ entrees/sorties ]-------
C
C     neant
C
C---------------------------------------------[ modules appeles ]-------
C
C     neant
C
C=============================================[ declarations ]==========
C
      implicit none
c-----------------------------------------
c
c
C
C---------------------------------------------[ parametres ]------------
C
      integer*4 DG(3)
        external idate
C
C---------------------------------------------[ variables locales ]-----
      integer inter
C---------------------------------------------[ fonctions appelees ]----
C
      logical VDG
C
C=============================================[ instructions ]==========
C
      call SFBBT(.true.)
C      call Idate(DG)
      call Idate(DG(1),DG(2),DG(3))      !Month Day Year
      IF (DG(3).LT.70) THEN
        DG(3)=DG(3)+2000   !For compilers that return 0 for year 2000 (Intel v8)
      ELSE IF (DG(3).LT.170) THEN
        DG(3)=DG(3)+1900   !For compilers that return 100 for year 2000
      ENDIF
      inter=DG(1)
      DG(1)=DG(3)
      DG(3)=DG(2)
      DG(2)=inter          !DG is now Year Month Day
      if (.not.VDG(DG)) then
         call SFBBT(.false.)
         call ZDG(DG)
      endif
      return
C
C=============================================[ formats ]===============
C
      end
#else

#ifdef HAS_DATE_AND_TIME

!
!     AUTHOR : Philippe Marguinaud
!     
!     DATE    : 16/01/2006
!     HISTORY : 22/11/2006 : Add a call to init function SFBBT
!
!


      subroutine GDG (DG)
      implicit none
      integer*4 DG(3)
      integer vl( 8 )
      logical VDG
      
      call SFBBT(.true.)
      call date_and_time( values = vl )
      
      DG( 1 ) = vl( 1 )
      DG( 2 ) = vl( 2 )
      DG( 3 ) = vl( 3 )
 
      if (.not.VDG(DG)) then
         call SFBBT(.false.)
         call ZDG(DG)
      endif

      end


#else

      subroutine GDG (DG)
C
C=============================================[ documentation ]=========
C
C---------------------------------------------[ identification ]--------
C
C     auteur            : Gerard LEGENDRE
C     date de creation  : 26/08/87
C     support           : CMS:F7BBT.FTN
C     account           : 920
C
C Version 1.1, 18/8/04, N C Atkinson: Make Linux behave as for Hp - idate
C                       returns 100 when year is 2000.
C Version 1.2, 31/1/05, The above is incorrect. Instead, allow Idate to return
C                       0, 100 or 2000 in year 2000.
C
C---------------------------------------------[ role ]------------------
C
C     Obtention de la date gregorienne machine.
C
C---------------------------------------------[ domaine de validite ]---
C
C     du 1er janvier 1950 au 31 decembre 2049.
C
C---------------------------------------------[ modifications ]---------
C
C     neant
C
C---------------------------------------------[ remarques ]-------------
C
C     *************************************************
C     * Ce S/P doit etre adapte a la machine support. *
C     *************************************************
C
C---------------------------------------------[ syntaxe d'appel ]-------
C
C     call GDG(DG)
C
C     DG : integer(3) = date gregorienne.
C
C---------------------------------------------[ variables globales ]----
C
C     neant
C
C---------------------------------------------[ common ]----------------
C
C     neant
C
C---------------------------------------------[ entrees/sorties ]-------
C
C     neant
C
C---------------------------------------------[ modules appeles ]-------
C
C     neant
C
C=============================================[ declarations ]==========
C
      implicit none
c-----------------------------------------
c
c
C
C---------------------------------------------[ parametres ]------------
C
      integer*4 DG(3)
        external idate
C
C---------------------------------------------[ variables locales ]-----
      integer inter
C---------------------------------------------[ fonctions appelees ]----
C
      logical VDG
C
C=============================================[ instructions ]==========
C
      call SFBBT(.true.)
C      call Idate(DG)
      call Idate(DG(1),DG(2),DG(3))      !Day Month Year
      IF (DG(3).LT.70) THEN
        DG(3)=DG(3)+2000   !For compilers that return 0 for year 2000 (Intel v8)
      ELSE IF (DG(3).LT.170) THEN
        DG(3)=DG(3)+1900   !For compilers that return 100 for year 2000
      ENDIF
      inter=DG(1)
      DG(1)=DG(3)
      DG(3)=inter          !DG is now Year Month Day
      if (.not.VDG(DG)) then
         call SFBBT(.false.)
         call ZDG(DG)
      endif
      return
C
C=============================================[ formats ]===============
C
      end

#endif

#endif
