      subroutine KSTOP(iK)
C
C=============================================[ documentation ]=========
C
C---------------------------------------------[ identification ]--------
C
C     auteur            : Gerard LEGENDRE
C     date de creation  : 31/08/87
C     support           : CMS:F7BBT.FTN
C     account           : 920
C
C---------------------------------------------[ role ]------------------
C
C     Arrete le chronometre d'indice iK.
C
C---------------------------------------------[ domaine de validite ]---
C
C     iK doit etre compris entre 0 et iKmax.
C
C---------------------------------------------[ modifications ]---------
C
C     neant
C
C---------------------------------------------[ remarques ]-------------
C
C     neant
C
C---------------------------------------------[ syntaxe d'appel ]-------
C
C     call KSTOP(iK)
C
C     iK : integer = indice du chronometre ou 0 (tous).
C
C---------------------------------------------[ variables globales ]----
C
C     neant
C
C---------------------------------------------[ common ]----------------
C
C     neant
C
C---------------------------------------------[ entrees/sorties ]-------
C
C     neant
C
C---------------------------------------------[ modules appeles ]-------
C
C     neant
C
C=============================================[ declarations ]==========
C
      implicit none
c-----------------------------------------
c
c
C
C---------------------------------------------[ parametres ]------------
C
      integer iK
C
C---------------------------------------------[ constantes ]------------
C
#include "f7tp2.h"
C
C---------------------------------------------[ variables locales ]-----
C
      integer i
      double precision IJ
C
C---------------------------------------------[ commons ]---------------
C
#include "f7tp4.h"
C
C---------------------------------------------[ fonctions appelees ]----
C
      logical VBBT
C
C=============================================[ instructions ]==========
C
      call GIJ(IJ)
      if (VBBT(.true.)) then
        if (iK.eq.0) then
          do 10 i=1,iKMax
            if(Marche(i)) then
              Marche(i)=.false.
              Cumul(i)=Cumul(i)+IJ-Depart(i)
            else
              call SFBBT(.false.)
            endif
10        continue
        else if (iK.ge.1.and.iK.le.iKMax) then
          if(Marche(iK)) then
            Marche(iK)=.false.
            Cumul(iK)=Cumul(iK)+IJ-Depart(iK)
          else
            call SFBBT(.false.)
          endif
        else
          call SFBBT(.false.)
        endif
      endif
      return
C
C=============================================[ formats ]===============
C
      end
