      integer function NA (A)
C
C=============================================[ documentation ]=========
C
C---------------------------------------------[ identification ]--------
C
C     auteur            : Gerard LEGENDRE
C     date de creation  : 26/08/87
C     support           : CMS:F7BBT.FTN
C     account           : 920
C
C---------------------------------------------[ role ]------------------
C
C     Normalisation d'une annee au format long.
C
C     Exemples : NA(87)=1987
C                NA(15)=2015
C
C---------------------------------------------[ domaine de validite ]---
C
C     Suppose annee a normaliser valide.
C
C---------------------------------------------[ modifications ]---------
C
C     neant
C
C---------------------------------------------[ remarques ]-------------
C
C     neant
C
C---------------------------------------------[ syntaxe d'appel ]-------
C
C     NA(A)
C
C     A : integer = annee a normaliser.
C
C---------------------------------------------[ variables globales ]----
C
C     neant
C
C---------------------------------------------[ common ]----------------
C
C     neant
C
C---------------------------------------------[ entrees/sorties ]-------
C
C     neant
C
C---------------------------------------------[ modules appeles ]-------
C
C     SFBBT : positionnement du flag de fonctionnement correct
C     VA    : validite d'une annee
C
C=============================================[ declarations ]==========
C
      implicit none
c-----------------------------------------
c
c
C
C---------------------------------------------[ parametres ]------------
C
      integer A
C
C---------------------------------------------[ fonctions appelees ]----
C
      logical VA
C
C=============================================[ instructions ]==========
C
      call SFBBT(.true.)
      if (VA(A)) then
        if     (A.ge. 0.and.A.le.49) then
          NA=A+2000
        else if(A.ge.50.and.A.le.99) then
          NA=A+1900
        else
          NA=A
        endif
      else
        call SFBBT(.false.)
        NA=1950
      endif
      return
C
C=============================================[ formats ]===============
C
      end
