C     ******************************************************************
C     *                                                                *
C     * F7BBT  Version 1.00                                            *
C     *                                                                *
C     * (Bibliotheque de gestion du temps)                             *
C     *                                                                *
C     ******************************************************************
C
      logical function VBBT(Etat)
C
C=============================================[ documentation ]=========
C
C---------------------------------------------[ identification ]--------
C
C     auteur            : Gerard LEGENDRE
C     date de creation  : 26/08/87
C     support           : CMS:F7BBT.FTN
C     account           : 920
C
C---------------------------------------------[ role ]------------------
C
C     Permet   l'utilisateur de tester l'indicateur de fonctionnement
C     correct de F7BBT.
C     Apres chaque appel a un S/P ou a une fonction de F7BBT un
C     indicateur interne de fonctionnement correct (flag F7BBT) est
C     positionne a "true" si tout s'est bien passe, a "false" dans le
C     cas contraire.
C     La fonction VBBT(Etat) vaut "true" si Flag = Etat et "false" dans
C     le cas contraire.
C
C---------------------------------------------[ domaine de validite ]---
C
C     Aucune restriction
C
C---------------------------------------------[ modifications ]---------
C
C     neant
C
C---------------------------------------------[ remarques ]-------------
C
C     neant
C
C---------------------------------------------[ syntaxe d'appel ]-------
C
C     VBBT(Etat)
C
C     Etat : logical
C
C     Etat = true suppose un test de bon fonctionnement.
C     Etat = false suppose un test d'erreur
C
C     Exemple :
C
C     IF (VBBT(.true.)) THEN                 IF (VVBT(.false.)) THEN
C       *** OK ***                             *** ERREUR ***
C     ELSE                                   ELSE
C       *** ERREUR ***                         *** OK ***
C     ENDIF                                  ENDIF
C
C---------------------------------------------[ variables globales ]----
C
C     neant
C
C---------------------------------------------[ common ]----------------
C
C     common CBBT contenant le flag
C
C---------------------------------------------[ entrees/sorties ]-------
C
C     neant
C
C---------------------------------------------[ modules appeles ]-------
C
C     neant
C
C=============================================[ declarations ]==========
C
      implicit none
C
C---------------------------------------------[ parametres ]------------
C
      logical Etat
C
C---------------------------------------------[ commons ]---------------
C
! DECLARATIONS
!
!
!
!
C
#include "f7tp3.h"
C
C=============================================[ instructions ]==========
C
      VBBT=(BBTFLG.eqv.Etat)
      return
C
C=============================================[ formats ]===============
C
      end
