      logical function VIC (IC)
C
C=============================================[ documentation ]=========
C
C---------------------------------------------[ identification ]--------
C
C     auteur            : Gerard LEGENDRE
C     date de creation  : 26/08/87
C     support           : CMS:F7BBT.FTN
C     account           : 920
C
C---------------------------------------------[ role ]------------------
C
C     Verification de la validite d'un instant chaine.
C     La fonction rend .true. (instant correct) si l'instant
C     correspond a une date chaine et a une heure chaine valides.
C
C---------------------------------------------[ domaine de validite ]---
C
C     du 1er janvier 1950 a 00h 00mn 00s 000ms
C     au 31 decembre 2049 a 23h 59mn 59s 999ms
C
C---------------------------------------------[ modifications ]---------
C
C     neant
C
C---------------------------------------------[ remarques ]-------------
C
C     neant
C
C---------------------------------------------[ syntaxe d'appel ]-------
C
C     VIC(IC)
C
C     IC : character*22 = instant chaine a valider.
C
C---------------------------------------------[ variables globales ]----
C
C     neant
C
C---------------------------------------------[ common ]----------------
C
C     neant
C
C---------------------------------------------[ entrees/sorties ]-------
C
C     neant
C
C---------------------------------------------[ modules appeles ]-------
C
C     VDC
C     VHC
C
C=============================================[ declarations ]==========
C
      implicit none
c-----------------------------------------
c
c
C
C---------------------------------------------[ parametres ]------------
C
      character*22 IC
C
C---------------------------------------------[ fonctions appelees ]----
C
      logical VDC,VHC
C
C=============================================[ instructions ]==========
C
      VIC=      VDC(IC(1:8))
     +    .and.(IC(9:10).eq.'  ')
     +    .and. VHC(IC(11:22))
      return
C
C=============================================[ formats ]===============
C
      end
