      logical function VIJ (IJ)
C
C=============================================[ documentation ]=========
C
C---------------------------------------------[ identification ]--------
C
C     auteur            : Gerard LEGENDRE
C     date de creation  : 26/08/87
C     support           : CMS:F7BBT.FTN
C     account           : 920
C
C---------------------------------------------[ role ]------------------
C
C     Verification de la validite d'un instant julien
C     La fonction rend .true. (instant correct) si
C        la partie entiere du jour julien est une date julienne valide
C     et la partie fractionnaire du jour julien est une heure julienne
C        valide.
C
C---------------------------------------------[ domaine de validite ]---
C
C     du 1er janvier 1950 a 00h 00mn 00s 000ms
C     au 31 decembre 2049 a 23h 59mn 59s 999ms
C
C---------------------------------------------[ modifications ]---------
C
C     neant
C
C---------------------------------------------[ remarques ]-------------
C
C     neant
C
C---------------------------------------------[ syntaxe d'appel ]-------
C
C     VIJ(IJ)
C
C     IJ : double precision = instant julien a verifier.
C
C---------------------------------------------[ variables globales ]----
C
C     neant
C
C---------------------------------------------[ common ]----------------
C
C     neant
C
C---------------------------------------------[ entrees/sorties ]-------
C
C     neant
C
C---------------------------------------------[ modules appeles ]-------
C
C     VDJ
C     VHJ
C
C=============================================[ declarations ]==========
C
      implicit none
c-----------------------------------------
c
c
C
C---------------------------------------------[ parametres ]------------
C
      double precision IJ
C
C---------------------------------------------[ fonctions appelees ]----
C
      logical VDJ
      logical VHJ
C
C=============================================[ instructions ]==========
C
      VIJ= (VDJ(idint(IJ)).and.VHJ(IJ-idint(IJ)))
      return
C
C=============================================[ formats ]===============
C
      end
