      logical function VIQ (IQ)
C
C=============================================[ documentation ]=========
C
C---------------------------------------------[ identification ]--------
C
C     auteur            : Gerard LEGENDRE
C     date de creation  : 26/08/87
C     support           : CMS:F7BBT.FTN
C     account           : 920
C
C---------------------------------------------[ role ]------------------
C
C     Verification de la validite d'un instant quantieme
C     La fonction rend .true. (instant correct) si l'instant
C     correspond a une date quantieme et a une heure quantieme
C     valides.
C
C---------------------------------------------[ domaine de validite ]---
C
C     du 1er janvier 1950 a 00h 00mn 00s 000ms
C     au 31 decembre 2049 a 23h 59mn 59s 999ms
C
C---------------------------------------------[ modifications ]---------
C
C     neant
C
C---------------------------------------------[ remarques ]-------------
C
C     neant
C
C---------------------------------------------[ syntaxe d'appel ]-------
C
C     VIQ(IQ)
C
C     IQ : integer(3) = instant quantieme a valider.
C
C---------------------------------------------[ variables globales ]----
C
C     neant
C
C---------------------------------------------[ common ]----------------
C
C     neant
C
C---------------------------------------------[ entrees/sorties ]-------
C
C     neant
C
C---------------------------------------------[ modules appeles ]-------
C
C     VDQ
C     VHQ
C
C=============================================[ declarations ]==========
C
      implicit none
c-----------------------------------------
c
c
C
C---------------------------------------------[ parametres ]------------
C
      integer IQ(3)
C
C---------------------------------------------[ fonctions appelees ]----
C
      logical VDQ
      logical VHQ
C
C=============================================[ instructions ]==========
C
      VIQ=(VDQ(IQ(1)).and.VHQ(IQ(3)))
      return
C
C=============================================[ formats ]===============
C
      end
