      subroutine XDGJ (DG,DJ)
C
C=============================================[ documentation ]=========
C
C---------------------------------------------[ identification ]--------
C
C     auteur            : Gerard LEGENDRE
C     date de creation  : 26/08/87
C     support           : CMS:F7BBT.FTN
C     account           : 920
C
C---------------------------------------------[ role ]------------------
C
C     Conversion d'une date gregorienne en date julienne.
C
C---------------------------------------------[ domaine de validite ]---
C
C     du 1er janvier 1950 au 31 decembre 2049
C
C---------------------------------------------[ modifications ]---------
C
C     neant
C
C---------------------------------------------[ remarques ]-------------
C
C     neant
C
C---------------------------------------------[ syntaxe d'appel ]-------
C
C     call XDGJ(DG,DJ)
C
C     DG : integer(3) = date gregorienne a convertir.
C     DJ : integer = date julienne convertie.
C
C---------------------------------------------[ variables globales ]----
C
C     neant
C
C---------------------------------------------[ common ]----------------
C
C     neant
C
C---------------------------------------------[ entrees/sorties ]-------
C
C     neant
C
C---------------------------------------------[ modules appeles ]-------
C
C     neant
C
C=============================================[ declarations ]==========
C
      implicit none
c-----------------------------------------
c
c
C
C---------------------------------------------[ parametres ]------------
C
      integer DG(3)
      integer DJ
C
C---------------------------------------------[ variables locales ]-----
C
      logical Ident
      logical Erreur
      integer DGC(3)
      double precision e1
      double precision e2
C
C---------------------------------------------[ constantes ]------------
C
#include "f7tp1.h"
C
C---------------------------------------------[ fonctions appelees ]----
C
      logical WDG,VDJ
      integer NA
C
C=============================================[ instructions ]==========
C
      call SFBBT(.true.)
      Erreur=.false.
      if (WDG(DG)) then
        e1=dfloat(NA(DG(1)))
        e2=DG(2)-1
        if (DG(2).lt.3) then
          e1=e1-1
          e2=e2+12
        endif
        e1=dint(365.25D0*(e1+4712))-dint(e1/100)+dint(e1/400)
        e2=dint((367*e2+5)/12)
        DJ=idnint(DG(3)+e1+e2-DJREF)
        if (VDJ(DJ)) then
           call XDJG(DJ,DGC)
           Ident=     (NA(DG(1)).eq.NA(DGC(1)))
     >           .and.(DG(2).eq.DGC(2))
     >           .and.(DG(3).eq.DGC(3))
           Erreur=.not.Ident
        else
           Erreur=.true.
        endif
      else
        Erreur=.true.
      endif
      if (Erreur) then
        call SFBBT(.false.)
        call ZDJ(DJ)
      endif
      return
C
C=============================================[ formats ]===============
C
      end
