        integer function avordid (ord_sc_num)
!+
!NOM/NAME $Id: avordid.F 25 2006-02-03 15:43:53Z frna $
!
!BUT/PURPOSE 
!       delivers the avhrr telemetry number (avh_sc_num)
!       for a given order satellite number (ord_sc_num)
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions   
!       The function returns the avhrr telemetry number (avh_sc_num)
!       the function returns 0 if the satellite is not found or 
!       if an error occur
!       
!
!PROPRIETAIRE/OWNER
!       P. Brunel
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!       version         date            comment           <author>
!       1.0             09/10/96        initial            CTI_LOG pf.
!       1.1            March 2003                         Tiphaine Labrot
!          f90 test : ord_sc_num was declared twice. Suppressed one.        
!       2.0             07/04/04   SATID version 2          P. Brunel
!         
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!ARGUMENTS 
        integer ord_sc_num ! order satellite number
!
!DECLARATIONS
!
!
!
! Common declarations:
#include "satid.h"
!
! Local variables:
        integer ierr            ! rdnoaaid return code =0 OK  else I/O error

        ierr = 0


!       call the file reading routine
        if(sat_name(1)(1:2).eq.'xx') then
          call rdnoaaid(ierr)
        endif

!       checks the return code
        if(ierr.eq.0) then

          if(ord_sc_num.le.maxsatid) then
!         the satellite id is found
            avordid = avh_sc_num(ord_sc_num)
          else
!           the satellite id is not present in the array
            avordid = 0
          endif

        else
!         an error occured during the file reading
          write(*,*)'an error occured during the file reading'
          avordid = 0
        endif

        return
        end
        
