        integer function genattid(scid)
!+
!NOM/NAME $Id: genattid.F 25 2006-02-03 15:43:53Z frna $
!
!BUT/PURPOSE 
!       delivers the attitude mode for a given satelliteid
!       the name can be of any type
!
!DEINSTRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions   
!       
!
!PROPRIETAIRE/OWNER
!       P. Brunel
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0     07/04/04  SATID version 2     P. Brunel
!         
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!ARGUMENTS 
      integer scid      ! satellite id
!
!DECLARATIONS
!
!
!
! Common declarations:
#include "satid.h"
!
! functions
! Local variables:
        integer ierr         ! rdnoaaid return code =0 OK  else I/O error
! 
!-
!
!       checks if it is the first calling sequence and then
!       call the file reading routine
        ierr = 0
        if(sat_name(1)(1:2).eq.'xx') then
          call rdnoaaid(ierr)
        endif

!       in case of any error continue with attitude mode 0
!       which corresponds to NOAA (POES and NPOES) satellites

!       checks the return code
        if(ierr.eq.0) then

          if(sat_serie(scid)(1:2).ne.'xx') then
!           the satellite id is found
            genattid = sc_att_mode(scid)
          else
!           the satellite id is not present in the array
            genattid = 0
          endif

        else
!         an error occured during the file reading
          genattid = 0
        endif

        return
        end
        
