        integer function l1bscid(ord_sc_num)
!+
!NOM/NAME $Id: l1bscid.F 38 2006-06-16 13:04:03Z frna $
!
!BUT/PURPOSE 
!       delivers the level 1b spacecraft number for a given 
!       order number.
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions   
!
!       the function returns 0 if the satellite is not found or 
!       if an error occurs
!       
!
!PROPRIETAIRE/OWNER
!       P. Brunel
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0     13/02/95   initial            P. Brunel
! 1.1     23/06/03   change test on maxsatid P. Brunel
! 2.0     07/04/04  SATID version 2     P. Brunel
! 2.1     12/06/06  character*16 function PM
!         
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!ARGUMENTS 
        integer ord_sc_num ! order number
!
!DECLARATIONS
!
!
!
! Common declarations:
#include "satid.h"
!
! Local variables:
        integer ierr         ! rdnoaaid return code =0 OK  else I/O error
! 
!-
!
!       checks if it is the first calling sequence and then
!       call the file reading routine
        ierr = 0
        if(sat_name(1)(1:2).eq.'xx') then
          call rdnoaaid(ierr)
        endif

!       checks the return code
        if(ierr.eq.0) then

!         search the argument value in the common array for the
!         right noaa s/c number.
          if( ord_sc_num.gt.0 .and. ord_sc_num.le.maxsatid) then
            l1bscid = l1b_sc_num(ord_sc_num)
          else
!           the order number is out of range
            l1bscid = 0
          endif

        else
!         an error occured during the file reading
          l1bscid = 0
        endif

        return
        end
        
