        character*16 function l1bscnam(ord_sc_num)
!+
!NOM/NAME $Id: l1bscnam.F 39 2006-06-19 08:12:39Z frna $
!
!BUT/PURPOSE 
!       delivers the NOAA level 1b satellite name for a given 
!       order number.
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions   
!       The level1b names correspond to the variable launch name
!       in the satid file, limiteed to 6 characters
!       the function returns 'xxxxxx' if the satellite is not found or 
!       if an error occur
!       
!
!PROPRIETAIRE/OWNER
!       P. Brunel
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0     13/02/95   initial            P. Brunel
! 1.1     23/06/03   change test on maxsatid P. Brunel
! 2.0     07/04/04  SATID version 2     P. Brunel
!         
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!ARGUMENTS 
        integer ord_sc_num ! order number
!
!DECLARATIONS
!
!
!
! Common declarations:
#include "satid.h"
!
! Local variables:
        integer ierr         ! rdnoaaid return code =0 OK  else I/O error
! 
!-
!
!       checks if it is the first calling sequence and then
!       call the file reading routine
        ierr = 0
        if(sat_name(1)(1:2).eq.'xx') then
          call rdnoaaid(ierr)
        endif

!       checks the return code
        if(ierr.eq.0) then

!         search the argument value in the common array for the
!         right noaa s/c number.
          if( ord_sc_num.gt.0 .and. ord_sc_num.le.maxsatid) then
            l1bscnam = launch_name(ord_sc_num)
          else
!           the order number is out of range
            l1bscnam = 'xxxxxx'
          endif

        else
!         an error occured during the file reading
          l1bscnam = 'xxxxxx'
        endif

        return
        end
        
