        integer function noascid(ord_sc_num)
!+
!NOM/NAME $Id: noascid.F 33 2006-06-06 14:08:06Z frna $
!
!BUT/PURPOSE 
!       delivers the NOAA satellite number for a given 
!       order number.
!
!DESCRIPTION 
!     FORTRAN 77 witth UKMO/METEO-FRANCE accepted extensions   
!       The function searches in the array noa_sc_num the element which
!       has the same value as the input argument.
!
!       the function returns 0 if the satellite is not found or 
!       if an error occur
!       
!
!PROPRIETAIRE/OWNER
!       P. Brunel
!
!HISTORIQUE/HISTORY (MODIFICATIONS/CHANGES) 
!(version   date      comment           <author>)
! 1.0     13/02/95   initial            P. Brunel
! 1.1     23/06/03   change test on maxsatid P. Brunel
! 2.0     07/04/04  SATID version 2     P. Brunel
! 2.1     28 Nov 2005 satid support for Metop PM
! 2.2     May 06 Metop numbers are now 1, 2, 3 ( instead of 51, 52, 53 ). PM/PB
!         
!
!FUNCTIONS AND SUBROUTINES CALLS  (RETURN CODES FOR FUNCTIONS)
!
!
!COPYRIGHT (c) Meteo-France (EVOLUNIX - ATOVS - EUMETSAT project <1994>)
!
      implicit none                                                     
!
!ARGUMENTS 
        integer ord_sc_num ! order number
!
!DECLARATIONS
!
!
!
! Common declarations:
#include "satid.h"
!
! Local variables:
        integer ierr         ! rdnoaaid return code =0 OK  else I/O error
! 
        logical cp_cus
!-
!
!       checks if it is the first calling sequence and then
!       call the file reading routine
        ierr = 0
        if(sat_name(1)(1:2).eq.'xx') then
          call rdnoaaid(ierr)
        endif

!       checks the return code
        if(ierr.eq.0) then

!         search the argument value in the common array for the
!         right noaa s/c number.
          if( ord_sc_num.gt.0 .and. ord_sc_num.le.maxsatid) then
            if( cp_cus(sat_name(ord_sc_num)(1:4),'noaa')) then
              noascid = noa_sc_num(ord_sc_num)
            else
              noascid = 0
            end if
          else
!           the order number is out of range
            noascid = 0
          endif

        else
!         an error occured during the file reading
          noascid = 0
        endif

        return
        end
        
