#ifndef _CNES_IASI_BRD_1_7_H
#define _CNES_IASI_BRD_1_7_H
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "eps_types.h"
#include "eps_buffer.h"
#include "eps_grh.h"


extern int cnes_iasi_brd_1_7_check_subclass;
extern int cnes_iasi_brd_1_7_check_subclass_version;

#define CTN 4
#define NB_SURF_RAD 10
#define IMLI 64
#define NBK 6
#define IMCO 64
#define MODEL 200
#define SPCT_COD 550
#define SS1 8500
#define PN 4
#define SGI_LI 5
#define DIM_ROT_MATRICE 3
#define COVAR_DIM 100
#define TAILLE_NB_SI_B 10
#define CCD 2
#define SP 37
#define SB 3
#define SGI_CO 5

typedef struct {
  eps_integer4 IDefIssueIcd;
  eps_integer4 IDefRevisionIcd;
  eps_integer4 IDefPTSI;
  eps_integer4 IDefConf;
  eps_integer4 IDefSdbID;
  eps_integer4 IDefStableparamID;
  eps_integer4 IDefParamDate_day;
  eps_integer4 IDefParamDate_millis;
  eps_integer4 IDefMETOPNumber;
  eps_integer4 ICtcNbSeg[CTN];
  eps_integer4 IDefNSegNsfirst;
  eps_integer4 ICtcTabNbBit[CTN][SPCT_COD];
  eps_integer4 ICtcTabOffset[CTN][SPCT_COD];
  eps_real8 ICtcTabOffsetC[CTN];
  eps_real8 ICtcTabOffsetM[CTN];
  eps_integer4 ICtcTabScale[CTN][SPCT_COD];
  eps_real8 ICtcTabScaleC[CTN];
  eps_real8 ICtcTabScaleM[CTN];
  eps_integer4 IDefArcNbNsSeg[SB];
  eps_integer4 IDefArcNbSeg[SB];
  eps_real8 IDefBBEmissivity[SS1];
  eps_integer4 IDefBBNbRrs;
  eps_real8 IDefBBRRs[NB_SURF_RAD];
  eps_integer4 IDefCcsChannelId[NBK];
  eps_real8 IDefCcsChannelNoise[NBK];
  eps_real8 IDefCcsChannelWn[NBK];
  eps_integer4 IDefCcsChannelWgt[NBK][CCD];
  eps_integer4 IDefCcsDimClassSpace;
  eps_real8 IDefCcsDistAgloInit;
  eps_real8 IDefCcsDistMax;
  eps_real8 IDefCcsGlueCutoff;
  eps_integer4 IDefCcsImgCILinMax;
  eps_integer4 IDefCcsImgCIColMax;
  eps_real8 IDefCcsIterConvCutoff;
  eps_integer4 IDefCcsMinIterNCCutoff;
  eps_integer4 IDefCcsMode;
  eps_integer4 IDefCcsNbClusMax;
  eps_integer4 IDefCcsNbIterMax;
  eps_integer4 IDefCcsNbNonClassifMax;
  eps_integer4 IDefCcsRadToTb;
  eps_integer4 IDefCcsSortingChannel;
  eps_real8 IDefCcsSplitCutoff;
  eps_real8 IDefCovarEigenValCalRad;
  eps_real8 IDefCovarEigenValSpect;
  eps_integer4 IDefCtcNbNsSeg;
  eps_real8 IDefCovarMatEigenVal1b[COVAR_DIM][CCD];
  eps_real8 IDefCovarMatEigenVal1c[COVAR_DIM][CCD];
  eps_real8 IDefDptGainCoeffCutoff;
  eps_integer4 IDefDptIISInHomPixMax;
  eps_real8 IDefDptIISVarianceCutoff;
  eps_integer4 IDefDptNbCycleFilter;
  eps_real8 IDefDurFltIsrfemOff;
  eps_real8 IDefDurBandMiss;
  eps_real8 IDefDurBBTMiss;
  eps_real8 IDefDurImgEWMiss;
  eps_real8 IDefDurImgBBMiss;
  eps_real8 IDefDurImgCSMiss;
  eps_real8 IDefDurRadAvhrrMiss;
  eps_integer4 IDefFaxFLS;
  eps_integer4 IDefFaxRegressDegre;
  eps_real8 IDefFaxRegressRmsCutoff;
  eps_real8 IDefFaxT0;
  eps_integer4 IDefFtbFLS;
  eps_integer4 IDefFtbRegressDegre;
  eps_real8 IDefFtbRegressRmsCutoff;
  eps_real8 IDefFtbT0;
  eps_integer4 IDefGeoIISSubGridSize;
  eps_integer4 IDefGeoIISSubGridNY[SGI_LI];
  eps_integer4 IDefGeoIISSubGridNZ[SGI_CO];
  eps_integer4 IDefGranuleSizeDefault;
  eps_real8 IDefHecTRrsModel[NB_SURF_RAD][MODEL];
  eps_real8 IDefIacCorrelCutoff;
  eps_integer4 IDefIacDCol;
  eps_integer4 IDefIacDLin;
  eps_real8 IDefIacPosMaxCutoff;
  eps_real8 IDefIASIMETOPMatRot[DIM_ROT_MATRICE][DIM_ROT_MATRICE];
  eps_real8 IDefIASIScanAngle[SP];
  eps_integer4 IDefIccNbCycle;
  eps_real8 IDefIISAVHRROffsetGuess[SP][CCD];
  eps_integer4 IDefIISColDeb[PN];
  eps_integer4 IDefIISColFin[PN];
  eps_real8 IDefIISDY;
  eps_real8 IDefIISDZ;
  eps_integer4 IDefIISLinDeb[PN];
  eps_integer4 IDefIISLinFin[PN];
  eps_integer4 IDefIISNbCol;
  eps_integer4 IDefIISNbLin;
  eps_real8 IDefIISNoiseNom;
  eps_real8 IDefIISRot;
  eps_real8 IDefIISY[IMLI];
  eps_real8 IDefIISZ[IMCO];
  eps_real8 IDefMcxColdSpectrum[TAILLE_NB_SI_B][SB];
  eps_real8 IDefMcxDphi[TAILLE_NB_SI_B][SB];
  eps_real8 IDefMcxBiasCalRadCutoff[SB];
  eps_real8 IDefMcxNoiseCalRadCutoff[SB];
  eps_real8 IDefMETOPOrbitPeriod;
  eps_integer4 IDefNsfirst[SB];
  eps_integer4 IDefNslast[SB];
  eps_real8 IDefOffsetSondIISModel[MODEL][CCD][PN];
  eps_real8 IDefPdsPix[PN];
  eps_real8 IDefPlkN;
  eps_real8 IDefPlkPK1;
  eps_real8 IDefPlkPK2;
  eps_real8 IDefPsfSondBaryCentreY[PN];
  eps_real8 IDefPsfSondBaryCentreZ[PN];
  eps_real8 IDefQisAvgRadNoise[PN][SB];
  eps_integer4 IDefS1bNsFFT;
  eps_integer4 IDefS1bOSFftFactor;
  eps_integer4 IDefS1bOSSplineFactor;
  eps_integer4 IDefS1bSigI;
  eps_integer4 IDefS1bSigS;
  eps_integer4 IDefS1cNbSWwidth;
  eps_integer4 IDefS1cNsErase;
  eps_integer4 IDefS1cSigS;
  eps_real8 IDefSmeTScanModel[MODEL];
  eps_real8 IDefSpectDWn1b;
  eps_integer4 IDefNsfirst1b;
  eps_integer4 IDefNslast1b;
  eps_real8 IDefSpectrDWn;
  eps_real8 IDefSsdModulCutoff[TAILLE_NB_SI_B][SB];
  eps_integer4 IDefSsdNhar[TAILLE_NB_SI_B];
  eps_integer4 IDefSsdNItera;
  eps_integer4 IDefSsdNsfirstSW[TAILLE_NB_SI_B];
  eps_integer4 IDefSsdNslastSW[TAILLE_NB_SI_B];
  eps_integer4 IDefSsdOSFftFactor[TAILLE_NB_SI_B];
  eps_integer4 IDefSsdOSSplineFactor[TAILLE_NB_SI_B];
  eps_integer4 IDefSsdSigI[TAILLE_NB_SI_B];
  eps_integer4 IDefSsdSigS[TAILLE_NB_SI_B];
  eps_integer4 IDefSsdSpectralWindowOPS;
  eps_real8 IDefSssStdImagCutoff;
  eps_real8 IDefSssWnShiftMax[PN];
  eps_real8 IDefSssWnShiftMin[PN];
  eps_integer4 IDefSysTECIISQual;
  eps_integer4 IDefSysTECSondQual;
  eps_real8 IDefTrCalRad;
  eps_real8 IDefTrnom;
  eps_real8 IDefTrSpect;
  eps_integer4 IDefWnpNharmonic[TAILLE_NB_SI_B];
  eps_integer4 IDefWnpSigG[TAILLE_NB_SI_B];
  eps_integer4 IDefWnpSign[TAILLE_NB_SI_B];
  eps_real8 IWnpDWnSWref[TAILLE_NB_SI_B];
  eps_real8 IWnpModulNat[TAILLE_NB_SI_B][SB];
  eps_integer4 IWnpNsFFT[TAILLE_NB_SI_B];
  eps_integer4 IWnpNsSSR[TAILLE_NB_SI_B];
  eps_integer4 IWnpNsSW[TAILLE_NB_SI_B];
  eps_real8 IWnpPhaseNat[TAILLE_NB_SI_B][SB];
  eps_real8 IWnpWnSWref[TAILLE_NB_SI_B];
  eps_integer4 IDefZpdBzpd;
} t_IASI_BRD_1_7;

int read_IASI_BRD_1_7( t_IASI_BRD_1_7 *X, buffer* B, int n );

int write_IASI_BRD_1_7( t_IASI_BRD_1_7 *X, buffer* B, int n );

int free_IASI_BRD_1_7( t_IASI_BRD_1_7 *X, int n );

int init_IASI_BRD_1_7( t_IASI_BRD_1_7 *X, int n );

int size_IASI_BRD_1_7( t_IASI_BRD_1_7 *X );

int print_IASI_BRD_1_7( const char* label, t_IASI_BRD_1_7 *X, FILE *fp, int ndim, const int *dims );

#endif
