#ifndef _CNES_IASI_GRD_1_7_H
#define _CNES_IASI_GRD_1_7_H
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "eps_types.h"
#include "eps_buffer.h"
#include "eps_grh.h"


extern int cnes_iasi_grd_1_7_check_subclass;
extern int cnes_iasi_grd_1_7_check_subclass_version;

#define SS1 8500
#define PN 4
#define IIS_MAX 100
#define NS_SW 4096
#define SN 37
#define TAILLE_NB_SI_B 10
#define SNOT 30
#define IMLI 64
#define NB_LIN_SOND 100
#define IMCO 64
#define NB_COL_SOND 100

typedef struct {
  eps_integer4 IDefIssueIcd;
  eps_integer4 IDefRevisionIcd;
  eps_integer4 IDefStableParamID;
  eps_integer4 IDefStableParamDate_day;
  eps_integer4 IDefStableParamDate_millis;
  eps_integer4 IDefMETOPNumber;
  eps_integer4 IDefAvhrrMarginBefore;
  eps_integer4 IDefAvhrrMarginAfter;
  eps_boolean IDefDptIISDeadPix[IMCO][IMLI];
  eps_real8 IDefIISNeDT[IMCO][IMLI];
  eps_real8 IDefIISSrf[IIS_MAX];
  eps_real8 IDefIISSrfDWn;
  eps_integer4 IDefIISSrfNsfirst;
  eps_integer4 IDefIISSrfNslast;
  eps_integer4 IDefPsfSondNbCol;
  eps_integer4 IDefPsfSondNbLin;
  eps_integer4 IDefPsfSondOverSampFactor;
  eps_real8 IDefPsfSondWgt[NB_COL_SOND][NB_LIN_SOND][PN];
  eps_real8 IDefPsfSondY[NB_COL_SOND][PN];
  eps_real8 IDefPsfSondZ[NB_COL_SOND][PN];
  eps_real8 ISmaRbb[SS1];
  eps_real8 ISmaRcs[SS1];
  eps_real8 ISmaRew[SS1][SN];
  eps_integer4 ISmaRNs;
  eps_real8 IWnpWnSW[NS_SW][TAILLE_NB_SI_B];
  eps_real8 IDefDeltaAvhrrDTbefore[SNOT];
  eps_real8 IDefDeltaAvhrrDTafter[SNOT];
  eps_integer4 IDefDeltaAvhrrColLeft[SNOT];
  eps_integer4 IDefDeltaAvhrrColRight[SNOT];
  eps_integer2 IDefScaleSondNbScale;
  eps_integer2 IDefScaleSondNsfirst[TAILLE_NB_SI_B];
  eps_integer2 IDefScaleSondNslast[TAILLE_NB_SI_B];
  eps_integer2 IDefScaleSondScaleFactor[TAILLE_NB_SI_B];
  eps_integer2 IDefScaleIISScaleFactor;
  eps_integer2 IDefScaleSondNbScale1a;
  eps_integer2 IDefScaleSondNsfirst1a[TAILLE_NB_SI_B];
  eps_integer2 IDefScaleSondNslast1a[TAILLE_NB_SI_B];
  eps_integer2 IDefScaleSondScaleFactor1a[TAILLE_NB_SI_B];
  eps_integer2 IDefAvhrrSubGridDl;
  eps_integer2 IDefAvhrrSubGridDc;
  eps_integer2 IDefIacAvhrrChannel;
  eps_real8 IDefSsdConverCutoff;
  eps_integer4 IDefFlagMultiBand;
  eps_real8 IDefFaxGuessY[2];
  eps_real8 IDefFaxGuessZ[2];
  eps_integer4 IDefPixRef;
  eps_integer4 IDefInterPixNZpd[PN*2];
  eps_integer4 IDefEUMAvhrrCldErrorCutoff;
  eps_integer4 IDefAvhrrNsfirst[2];
  eps_integer4 IDefAvhrrNslast[2];
  eps_real8 IDefAvhrrWgt[2 * 1500];
} t_IASI_GRD_1_7;

int read_IASI_GRD_1_7( t_IASI_GRD_1_7 *X, buffer* B, int n );

int write_IASI_GRD_1_7( t_IASI_GRD_1_7 *X, buffer* B, int n );

int free_IASI_GRD_1_7( t_IASI_GRD_1_7 *X, int n );

int init_IASI_GRD_1_7( t_IASI_GRD_1_7 *X, int n );

int size_IASI_GRD_1_7( t_IASI_GRD_1_7 *X );

int print_IASI_GRD_1_7( const char* label, t_IASI_GRD_1_7 *X, FILE *fp, int ndim, const int *dims );

#endif
