/*
 * COPYRIGHT : Meteo-France/EUMETSAT/SAFNWP
 *
 * DATE      : 2005/5
 * 
 * AUTHOR    : Philippe.Marguinaud@meteo.fr
 *
 * VERSION   : 1.0
 *
 */
#ifndef _CNES_IASI_ODB_1_4_H
#define _CNES_IASI_ODB_1_4_H
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "eps_types.h"
#include "eps_buffer.h"
#include "eps_grh.h"


extern int cnes_iasi_odb_1_4_check_subclass;
extern int cnes_iasi_odb_1_4_check_subclass_version;

#define SDB_NB_COL 11
#define SDB_NFSMAX 142
#define SDB_NB_LIG 11
#define PN 4
#define WNP_NB_SW 10
#define SAF_NS_OPD 301
#define CDX 2

typedef struct {
  eps_real4 real;
  eps_real4 imag;
} t_IASI_ODB_ISdbGridAf;

int read_IASI_ODB_ISdbGridAf( t_IASI_ODB_ISdbGridAf *X, buffer* B, int n );

int write_IASI_ODB_ISdbGridAf( t_IASI_ODB_ISdbGridAf *X, buffer* B, int n );

int free_IASI_ODB_ISdbGridAf( t_IASI_ODB_ISdbGridAf *X, int n );

int init_IASI_ODB_ISdbGridAf( t_IASI_ODB_ISdbGridAf *X, int n );

int size_IASI_ODB_ISdbGridAf( t_IASI_ODB_ISdbGridAf *X );

int print_IASI_ODB_ISdbGridAf( const char* label, t_IASI_ODB_ISdbGridAf *X, FILE *fp, int ndim, const int *dims );

typedef struct {
  eps_integer4 IDefIssueIcd;
  eps_integer4 IDefRevisionIcd;
  eps_integer4 IDefSdbID;
  eps_integer4 IDefSdbDate_day;
  eps_integer4 IDefSdbDate_millis;
  eps_integer4 IDefMETOPNumber;
  eps_real8 IDefSafDWn;
  eps_integer4 IDefSafNsfirst;
  eps_integer4 IDefSafNslast;
  eps_integer4 IDefSafNsOpd;
  eps_real8 IDefSafOpdMax;
  eps_integer4 IDefSdbGridNbCol;
  eps_integer4 IDefSdbGridNbLin;
  eps_real8 IDefSdbGridY[CDX][SDB_NB_COL];
  eps_real8 IDefSdbGridZ[CDX][SDB_NB_LIG];
  t_IASI_ODB_ISdbGridAf ISdbGridAf[SDB_NB_LIG][SDB_NB_COL][CDX][PN][SDB_NFSMAX][SAF_NS_OPD];
  eps_real8 ISdbGridFcs[SDB_NB_LIG][SDB_NB_COL][CDX][PN][SDB_NFSMAX];
  eps_real8 ISdbGridWnShift[SDB_NB_LIG][SDB_NB_COL][WNP_NB_SW][CDX][PN];
} t_IASI_ODB;

int read_IASI_ODB( t_IASI_ODB *X, buffer* B, int n );

int write_IASI_ODB( t_IASI_ODB *X, buffer* B, int n );

int free_IASI_ODB( t_IASI_ODB *X, int n );

int init_IASI_ODB( t_IASI_ODB *X, int n );

int size_IASI_ODB( t_IASI_ODB *X );

int print_IASI_ODB( const char* label, t_IASI_ODB *X, FILE *fp, int ndim, const int *dims );

#endif
