#!/bin/ksh
#
# Convert IASI level 1c PFS format to AAPP format (fixed record length)
#
# Arguments: (1) Input file (2) Output file (default ${1}.l1b)
#
# v1.1 23/11/2007 Created from convert_iasi1c.ksh (NCA)
# v1.2 22/07/2011 Remove ${FORT}10 before running exe
# v1.3 20/09/2013 Allow for format version 9.0
###############################################################################

. "$AAPP_PREFIX/ATOVS_CONF"

if [ ! -f "$1" ]; then
  echo "Usage: convert_iasi1c infile [outfile]"
  exit 1
fi

FORMAT_VERSION=$(strings $1 | head -20 | awk '$1=="FORMAT_MAJOR_VERSION" {print $3}')

rm -f ${FORT}10       #remove any existing link
if [ "$FORMAT_VERSION" -ge 11 ]; then
  echo "running convert_iasi1b_9.0.exe"
  convert_iasi1b_9.0.exe $1
else
  echo "running convert_iasi1b.exe"
  convert_iasi1b.exe $1
fi

code=$?
if [ $code -ne 0 ]
then 
  exit $code
fi

outfile=${2:-${1}.l1b}
mv ${FORT}10 $outfile
