/* 
! Name: $Id$
!
! Purpose: Top-level C program to convert IASI level 1b PFS format to AAPP 
!          format (fixed record length)
!
! Method: Open and read the IASI 1b PFS file (file name passed as argument) then
!         pass the data to Fortran subroutines which create the output file,
!         fill in the header and data record arrays and write to the AAPP 1b 
!         file (same format as AAPP 1c).
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 16 December 2003, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2005, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!  1.0      20/09/13  Created from convert_iasi1b.c (NCA)
!
! Code Description: C
!
! C subroutines and functions called:
!     convert_iasi1b_intf
!
* LIBS = eps_iasil1b_9.0
!-------------------------------------------------------------------------------
*/

#include "eps_iasil1b_9.0.h"
#include <stdio.h>


int main( int argc, char* argv[] ) {

  convert_iasi1b_intf (argc, argv);
  
  return 0;
}
