/* 
! Name: $Id$
!
! Purpose: Top-level C program to convert IASI level 1c PFS format to AAPP 
!          format (fixed record length)
!
! Method: Open and read the IASI 1c PFS file (file name passed as argument) then
!         pass the data to Fortran subroutines which create the output file,
!         fill in the header and data record arrays and write to the AAPP 1c 
!         file.
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 16 December 2003, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2005, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!  1.0      02/11/05  Original code. (N.C.Atkinson)
!  1.1      17/01/06  Add return code (PM)
!  1.2      29/07/09  Modify for library version 8.0 (NCA)
!  1.3      28/09/09  rename 8.0 -> 9.0
!
! Code Description: C
!
! C subroutines and functions called:
!     convert_iasi1c_intf
!
* LIBS = eps_iasil1c_9.0
!-------------------------------------------------------------------------------
*/

#include "eps_iasil1c_9.0.h"
#include <stdio.h>


int main( int argc, char* argv[] ) {

  convert_iasi1c_intf (argc, argv);
  
  return 0;
}
