#!/bin/ksh
#
# Convert IASI level 1c PFS format to HDF5 format
#
# Arguments: (1) Input file (2) Output file (default ${1}.h5)
#
###############################################################################

. "$AAPP_PREFIX/ATOVS_CONF"

if [ ! -f "$1" ]; then
  echo "Usage: convert_iasi1c_hdf5 infile [outfile]"
  exit 1
fi


convert_iasi1c_hdf5.exe $1

code=$?
if [ $code -ne 0 ]
then 
  exit $code
fi

outfile=${2:-${1}.h5}
mv iasi1c.h5 $outfile
