/*
 * COPYRIGHT : Meteo-France/EUMETSAT/SAFNWP
 *
 * DATE      : 2006/3
 * 
 * AUTHOR    : Philippe.Marguinaud@meteo.fr
 *
 * VERSION   : 1.0
 *
 *
 */
#include "cnes_iasi_ctx_1.2.h"

int cnes_iasi_ctx_1_2_check_subclass = 1;
int cnes_iasi_ctx_1_2_check_subclass_version = 1;


int read_IASI_CTX_GIaxHistAxeInterf( t_IASI_CTX_GIaxHistAxeInterf *X, buffer* B, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
    read_eps_ccsdstime( &X->GiaxDateElt, B, 1 );
    read_eps_real8( &X->GiaxAxeYElt, B, 1 );
    read_eps_real8( &X->GiaxAxeZElt, B, 1 );
    read_eps_real8( &X->GiaxAxeQualElt, B, 1 );
    read_eps_uinteger2( &X->GiaxFlagAxeNonQual, B, 1 );
  }
  return status_buffer( B );
}


int write_IASI_CTX_GIaxHistAxeInterf( t_IASI_CTX_GIaxHistAxeInterf *X, buffer* B, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
    write_eps_ccsdstime( &X->GiaxDateElt, B, 1 );
    write_eps_real8( &X->GiaxAxeYElt, B, 1 );
    write_eps_real8( &X->GiaxAxeZElt, B, 1 );
    write_eps_real8( &X->GiaxAxeQualElt, B, 1 );
    write_eps_uinteger2( &X->GiaxFlagAxeNonQual, B, 1 );
  }
  return status_buffer( B );
}


int free_IASI_CTX_GIaxHistAxeInterf( t_IASI_CTX_GIaxHistAxeInterf *X, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
  }
}


int init_IASI_CTX_GIaxHistAxeInterf( t_IASI_CTX_GIaxHistAxeInterf *X, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
  }
}


int size_IASI_CTX_GIaxHistAxeInterf( t_IASI_CTX_GIaxHistAxeInterf *X ) {
  int i;
  return 6 + 8 + 8 + 8 + 2;
}



int read_IASI_CTX_GBBTHistTempCN( t_IASI_CTX_GBBTHistTempCN *X, buffer* B, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
    read_eps_ccsdstime( &X->GiaxDateElt, B, 1 );
    read_eps_real8( &X->BIMSBBT, B, 1 );
    read_eps_uinteger2( &X->GBBTMissing, B, 1 );
  }
  return status_buffer( B );
}


int write_IASI_CTX_GBBTHistTempCN( t_IASI_CTX_GBBTHistTempCN *X, buffer* B, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
    write_eps_ccsdstime( &X->GiaxDateElt, B, 1 );
    write_eps_real8( &X->BIMSBBT, B, 1 );
    write_eps_uinteger2( &X->GBBTMissing, B, 1 );
  }
  return status_buffer( B );
}


int free_IASI_CTX_GBBTHistTempCN( t_IASI_CTX_GBBTHistTempCN *X, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
  }
}


int init_IASI_CTX_GBBTHistTempCN( t_IASI_CTX_GBBTHistTempCN *X, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
  }
}


int size_IASI_CTX_GBBTHistTempCN( t_IASI_CTX_GBBTHistTempCN *X ) {
  int i;
  return 6 + 8 + 2;
}



int read_IASI_CTX( t_IASI_CTX *X, buffer* B, int n ) {
  int i, i_NIAX, i_NBBT;
  for( i = 0; i < n; i++, X++ ) {
    read_eps_uinteger2( &X->integ, B, 1 );
    read_eps_uinteger2( &X->GCTXVersOPS_major, B, 1 );
    read_eps_uinteger2( &X->GCTXVersOPS_minor, B, 1 );
    read_eps_uinteger2( &X->GCTXVersCTX_major, B, 1 );
    read_eps_uinteger2( &X->GCTXVersCTX_minor, B, 1 );
    read_eps_uinteger2( &X->GCTXNatCTX, B, 1 );
    read_eps_ccsdstime( (eps_ccsdstime*)X->GEPSDatIASI, B, ( NB_VAL ) );
    read_eps_real8( (eps_real8*)X->BIMSBBT, B, ( NB_VAL ) );
    read_eps_uinteger4( (eps_uinteger4*)X->GCTXNumDerLig, B, ( NB_VAL ) );
    read_eps_uinteger2( (eps_uinteger2*)X->PTSI, B, ( NB_VAL ) );
    read_eps_integer2( (eps_integer2*)X->BIISEqualCountOld, B, ( NB_VAL ) );
    read_eps_integer4( &X->GIaxNbElt, B, 1 );
    i_NIAX = X->GIaxNbElt;
    X->GIaxHistAxeInterf = (t_IASI_CTX_GIaxHistAxeInterf*)getmem( sizeof( t_IASI_CTX_GIaxHistAxeInterf ) * ( CCD )*( i_NIAX ) );
    read_IASI_CTX_GIaxHistAxeInterf( (t_IASI_CTX_GIaxHistAxeInterf*)X->GIaxHistAxeInterf, B, ( CCD )*( i_NIAX ) );
    read_eps_real8( (eps_real8*)X->MExsSmin, B, ( SPCT_COD ) );
    read_eps_real8( (eps_real8*)X->MExsSmax, B, ( SPCT_COD ) );
    read_eps_uinteger4( &X->GBBTNbElt, B, 1 );
    i_NBBT = X->GBBTNbElt;
    X->GBBTHistTempCN = (t_IASI_CTX_GBBTHistTempCN*)getmem( sizeof( t_IASI_CTX_GBBTHistTempCN ) * ( i_NBBT ) );
    read_IASI_CTX_GBBTHistTempCN( (t_IASI_CTX_GBBTHistTempCN*)X->GBBTHistTempCN, B, ( i_NBBT ) );
    read_eps_real8( (eps_real8*)X->GIccRadCalSlopeImag, B, ( NB_VAL )*( IMLI )*( IMCO ) );
    read_eps_real8( (eps_real8*)X->GIccRadCalOffsetImag, B, ( NB_VAL )*( IMLI )*( IMCO ) );
    read_eps_real8( (eps_real8*)X->GIacOffsetIISAVHRRLin, B, ( NB_VAL ) );
    read_eps_real8( (eps_real8*)X->GIacOffsetIISAVHRRCol, B, ( NB_VAL ) );
    read_eps_integer4( (eps_integer4*)X->MDptIisLnHomePix, B, ( NB_VAL )*( IMCO )*( IMLI ) );
    read_eps_integer4( (eps_integer4*)X->MDptIisBadHealthPix, B, ( NB_VAL )*( IMCO )*( IMLI ) );
    read_eps_real8( (eps_real8*)X->MDptVarImag, B, ( NB_VAL )*( IMCO )*( IMLI ) );
    read_eps_ccsdstime( (eps_ccsdstime*)X->GOPSDatIsrfemOff, B, ( NB_VAL ) );
    read_eps_ccsdstime( (eps_ccsdstime*)X->GOPSDatBandMiss, B, ( NB_VAL ) );
    read_eps_ccsdstime( (eps_ccsdstime*)X->GOPSDatBBTMiss, B, ( NB_VAL ) );
    read_eps_ccsdstime( (eps_ccsdstime*)X->GOPSDatEWMiss, B, ( NB_VAL ) );
    read_eps_ccsdstime( (eps_ccsdstime*)X->GOPSDatImgBBMiss, B, ( NB_VAL ) );
    read_eps_ccsdstime( (eps_ccsdstime*)X->GOPSDatImgCSMiss, B, ( NB_VAL ) );
    read_eps_ccsdstime( (eps_ccsdstime*)X->GOPSDatRadAvhrrMiss, B, ( NB_VAL ) );
    read_eps_uinteger4( (eps_uinteger4*)X->GCTXNumGranule, B, ( NB_VAL ) );
  }
  return status_buffer( B );
}


int write_IASI_CTX( t_IASI_CTX *X, buffer* B, int n ) {
  int i, i_NIAX, i_NBBT;
  for( i = 0; i < n; i++, X++ ) {
    write_eps_uinteger2( &X->integ, B, 1 );
    write_eps_uinteger2( &X->GCTXVersOPS_major, B, 1 );
    write_eps_uinteger2( &X->GCTXVersOPS_minor, B, 1 );
    write_eps_uinteger2( &X->GCTXVersCTX_major, B, 1 );
    write_eps_uinteger2( &X->GCTXVersCTX_minor, B, 1 );
    write_eps_uinteger2( &X->GCTXNatCTX, B, 1 );
    write_eps_ccsdstime( (eps_ccsdstime*)X->GEPSDatIASI, B, ( NB_VAL ) );
    write_eps_real8( (eps_real8*)X->BIMSBBT, B, ( NB_VAL ) );
    write_eps_uinteger4( (eps_uinteger4*)X->GCTXNumDerLig, B, ( NB_VAL ) );
    write_eps_uinteger2( (eps_uinteger2*)X->PTSI, B, ( NB_VAL ) );
    write_eps_integer2( (eps_integer2*)X->BIISEqualCountOld, B, ( NB_VAL ) );
    write_eps_integer4( &X->GIaxNbElt, B, 1 );
    i_NIAX = X->GIaxNbElt;
    write_IASI_CTX_GIaxHistAxeInterf( (t_IASI_CTX_GIaxHistAxeInterf*)X->GIaxHistAxeInterf, B, ( CCD )*( i_NIAX ) );
    write_eps_real8( (eps_real8*)X->MExsSmin, B, ( SPCT_COD ) );
    write_eps_real8( (eps_real8*)X->MExsSmax, B, ( SPCT_COD ) );
    write_eps_uinteger4( &X->GBBTNbElt, B, 1 );
    i_NBBT = X->GBBTNbElt;
    write_IASI_CTX_GBBTHistTempCN( (t_IASI_CTX_GBBTHistTempCN*)X->GBBTHistTempCN, B, ( i_NBBT ) );
    write_eps_real8( (eps_real8*)X->GIccRadCalSlopeImag, B, ( NB_VAL )*( IMLI )*( IMCO ) );
    write_eps_real8( (eps_real8*)X->GIccRadCalOffsetImag, B, ( NB_VAL )*( IMLI )*( IMCO ) );
    write_eps_real8( (eps_real8*)X->GIacOffsetIISAVHRRLin, B, ( NB_VAL ) );
    write_eps_real8( (eps_real8*)X->GIacOffsetIISAVHRRCol, B, ( NB_VAL ) );
    write_eps_integer4( (eps_integer4*)X->MDptIisLnHomePix, B, ( NB_VAL )*( IMCO )*( IMLI ) );
    write_eps_integer4( (eps_integer4*)X->MDptIisBadHealthPix, B, ( NB_VAL )*( IMCO )*( IMLI ) );
    write_eps_real8( (eps_real8*)X->MDptVarImag, B, ( NB_VAL )*( IMCO )*( IMLI ) );
    write_eps_ccsdstime( (eps_ccsdstime*)X->GOPSDatIsrfemOff, B, ( NB_VAL ) );
    write_eps_ccsdstime( (eps_ccsdstime*)X->GOPSDatBandMiss, B, ( NB_VAL ) );
    write_eps_ccsdstime( (eps_ccsdstime*)X->GOPSDatBBTMiss, B, ( NB_VAL ) );
    write_eps_ccsdstime( (eps_ccsdstime*)X->GOPSDatEWMiss, B, ( NB_VAL ) );
    write_eps_ccsdstime( (eps_ccsdstime*)X->GOPSDatImgBBMiss, B, ( NB_VAL ) );
    write_eps_ccsdstime( (eps_ccsdstime*)X->GOPSDatImgCSMiss, B, ( NB_VAL ) );
    write_eps_ccsdstime( (eps_ccsdstime*)X->GOPSDatRadAvhrrMiss, B, ( NB_VAL ) );
    write_eps_uinteger4( (eps_uinteger4*)X->GCTXNumGranule, B, ( NB_VAL ) );
  }
  return status_buffer( B );
}


int free_IASI_CTX( t_IASI_CTX *X, int n ) {
  int i, i_NIAX, i_NBBT;
  for( i = 0; i < n; i++, X++ ) {
    free_IASI_CTX_GIaxHistAxeInterf( (t_IASI_CTX_GIaxHistAxeInterf*)X->GIaxHistAxeInterf, ( CCD) * (i_NIAX ) );
    freemem( X->GIaxHistAxeInterf );
    free_IASI_CTX_GBBTHistTempCN( (t_IASI_CTX_GBBTHistTempCN*)X->GBBTHistTempCN, ( i_NBBT ) );
    freemem( X->GBBTHistTempCN );
  }
}


int init_IASI_CTX( t_IASI_CTX *X, int n ) {
  int i, i_NIAX, i_NBBT;
  for( i = 0; i < n; i++, X++ ) {
    i_NIAX = X->GIaxNbElt;
    X->GIaxHistAxeInterf = (t_IASI_CTX_GIaxHistAxeInterf*)getmem( sizeof( t_IASI_CTX_GIaxHistAxeInterf ) * ( CCD) * (i_NIAX ) );
    i_NBBT = X->GBBTNbElt;
    X->GBBTHistTempCN = (t_IASI_CTX_GBBTHistTempCN*)getmem( sizeof( t_IASI_CTX_GBBTHistTempCN ) * ( i_NBBT ) );
  }
}


int size_IASI_CTX( t_IASI_CTX *X ) {
  int i, i_NIAX, i_NBBT;
  i_NIAX = X->GIaxNbElt;
  i_NBBT = X->GBBTNbElt;
  return 2 + 2 + 2 + 2 + 2 + 2 + ( NB_VAL ) * 6 + ( NB_VAL ) * 8 + ( NB_VAL ) * 4 + ( NB_VAL ) * 2 + ( NB_VAL ) * 2 + 4 + ( CCD )*( i_NIAX ) * size_IASI_CTX_GIaxHistAxeInterf( X->GIaxHistAxeInterf ) + ( SPCT_COD ) * 8 + ( SPCT_COD ) * 8 + 4 + ( i_NBBT ) * size_IASI_CTX_GBBTHistTempCN( X->GBBTHistTempCN ) + ( NB_VAL )*( IMLI )*( IMCO ) * 8 + ( NB_VAL )*( IMLI )*( IMCO ) * 8 + ( NB_VAL ) * 8 + ( NB_VAL ) * 8 + ( NB_VAL )*( IMCO )*( IMLI ) * 4 + ( NB_VAL )*( IMCO )*( IMLI ) * 4 + ( NB_VAL )*( IMCO )*( IMLI ) * 8 + ( NB_VAL ) * 6 + ( NB_VAL ) * 6 + ( NB_VAL ) * 6 + ( NB_VAL ) * 6 + ( NB_VAL ) * 6 + ( NB_VAL ) * 6 + ( NB_VAL ) * 6 + ( NB_VAL ) * 4;
}


