/*
 * COPYRIGHT : Meteo-France/EUMETSAT/SAFNWP
 *
 * DATE      : 2005/5
 * 
 * AUTHOR    : Philippe.Marguinaud@meteo.fr
 *
 * VERSION   : 1.0
 *
 * HISTORY   : 01/02/2006 : Changes types to eps_types
 *             03/11/2006 : Add msecs parameter in amsday
 *
 */
#ifndef _AMSUA_AAPP_H
#define _AMSUA_AAPP_H

#include "eps_types.h"

void aapp_init( eps_integer4 mhsl, char* filename );

void aapp_finish( eps_integer4 mhsl );

eps_integer4 aapp_genscid( char* satname );

void aapp_amsout(
  eps_integer4 *optn, char* amsua1, char* amsua2, char* amsub_dummy,
  char* mhs_dummy, char* amanag, char* amvalid, eps_integer4 yr, 
  eps_integer4 msech, eps_integer4* systim, eps_integer4 satid, 
  eps_integer4 *aerr, eps_integer4 *berr, eps_integer4 fullam, 
  eps_integer4 gotime, eps_integer4 startorb,
  eps_integer4 endorb, eps_integer4 mhspresent
);

void aapp_amsday( eps_integer4 day, eps_integer4 msecs );

void aapp_amahdw( eps_integer4 amal, eps_integer4 *ios );

#endif
