#ifndef _METOP_MMAM_H
#define _METOP_MMAM_H
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "eps_types.h"
#include "eps_buffer.h"
#include "eps_grh.h"
#ifndef BOOELAN
#define BOOLEAN unsigned char
#endif
#ifndef TRUE
#define TRUE (1)
#endif
#ifndef FALSE
#define FALSE (0)
#endif

typedef struct {
  eps_integer4 M;
  eps_uinteger4 J;
  eps_uinteger4 D;
} t_MMAM_PACKET_validity_time;

int read_MMAM_PACKET_validity_time( t_MMAM_PACKET_validity_time *X, buffer* B, int n );

int write_MMAM_PACKET_validity_time( t_MMAM_PACKET_validity_time *X, buffer* B, int n );

int free_MMAM_PACKET_validity_time( t_MMAM_PACKET_validity_time *X, int n );

int init_MMAM_PACKET_validity_time( t_MMAM_PACKET_validity_time *X, int n );

int size_MMAM_PACKET_validity_time( t_MMAM_PACKET_validity_time *X );

int print_MMAM_PACKET_validity_time( const char* label, t_MMAM_PACKET_validity_time *X, FILE *fp, int ndim, const int *dims );


typedef struct {
  eps_uinteger1 message_number; /* Message Number ( incremented number 
                                   used as rolling counter ) */
  t_MMAM_PACKET_validity_time validity_time; /* Starting time of valid
                                                 ity for this admin mes
                                                 sage ( MJD 2000 ) */
  eps_byte satellite_id[10]; /* METOP Satellite ID ( International Desi
                                gnator ) */
                          
  eps_uinteger4 mmam_size;
  char *mmam;
} t_MMAM_PACKET;

int read_MMAM_PACKET( t_MMAM_PACKET *X, buffer *B, int n);
int write_MMAM_PACKET( t_MMAM_PACKET *X, buffer *B, int n);
int write_file_MMAM_PACKET( t_MMAM_PACKET *X, FILE *fp, int n );

int print_formatted_mmam( t_MMAM_PACKET* MP );
BOOLEAN is_MMAM_PACKET  ( t_MMAM_PACKET * X );
int size_MMAM_PACKET( t_MMAM_PACKET *X );
#endif
