/*
 * COPYRIGHT : Meteo-France/EUMETSAT/SAFNWP
 *
 * DATE      : 2005/5
 * 
 * AUTHOR    : Philippe.Marguinaud@meteo.fr
 *
 * VERSION   : 1.0
 *
 * HISTORY   : 01/02/2006 : Changes types to eps_types
 *
 */
#ifndef _OBTUTC_H
#define _OBTUTC_H

#include "common-aapp.h"
#include "eps_types.h"
#include "ccsds.h"

int obtutc_a_b_jj2000( 
  packet_secondary_header *psh_a, 
  satellite_binary_time *sbt,
  double a_step, double b_offset,
  t_mphr *m0,
  eps_real8 *jj_r
);

int obtutc_viadr0_jj2000( 
  packet_secondary_header *psh_a, 
  satellite_binary_time *sbt,
  t_viadr_0 *v0,
  t_mphr *m0,
  eps_real8 *jj_r
);

int obtutc_jj2000_to_jj1950( eps_real8 *jj2000, eps_real8 *jj1950 );

#endif
