#!/bin/ksh

#
# COPYRIGHT : NWP SAF
#
# DATE      : 2010/03/23
#
# AUTHOR    : Nigel Atkinson
#
# VERSION   : 1.0
#             1.1 06/02/2017: Add "exit 0" at the end
#
# SYNOPSIS  : Wrapper script for aapp1d2pfs.exe
#
#

pfsfile=$1
avh1d=$2
pfsout=${3:-PFS.dat}

[ $# -lt 2 ]      && { echo "usage: aapp1d2pfs PFS.l1b AVHRR.l1d [PFS_out.l1b]"; exit 1; }
[ ! -f $pfsfile ] && { echo "cannot find $pfsfile"; exit 1; }
[ ! -f $avh1d ]   && { echo "cannot find $avh1d"; exit 1; }

. "$AAPP_PREFIX/ATOVS_CONF"

aapp1d2pfs.exe $pfsfile $avh1d $pfsout

c=$?

if [ $c -ne 0 ]
then 
  exit $c
fi

#over-write input file if no 3rd argument

[ $# = 2 ] && mv $pfsout $1

exit 0
