/* 
! Name: $Id: convert_avh1b.c 180 2010-01-08 12:04:35Z frna $
!
! Purpose: Top-level C program to convert AVHRR level 1b PFS format to AAPP 
!          format (fixed record length)
!
! Method: Open and read the AVHRR 1b PFS file (file name passed as argument) then
!         pass the data to Fortran subroutines which create the output file,
!         fill in the header and data record arrays and write to the AAPP 1b 
!         file.
!
! Current Code Owner: NWP SAF
!
! COPYRIGHT
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 16 December 2003, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2005, EUMETSAT, All Rights Reserved.
!
! History:
! Version    Date     Comment
!
!  1.0      28/11/06  Original code. (N.C.Atkinson)
!
! Code Description: C
!
! C subroutines and functions called:
!     convert_avh1b_intf
!
* LIBS = metop_common eps_avhrrl1b_6.5 aapp_avhrrl1b eps_common
!-------------------------------------------------------------------------------
*/

#include "eps_avhrrl1b_6.5.h"
#include <stdio.h>


int main( int argc, char* argv[] ) {

  convert_avh1b_intf (argc, argv);
  return 0;
  
}
