#!/usr/bin/perl -w
#
# COPYRIGHT : Meteo-France/EUMETSAT/SAFNWP
#
# DATE      : 2012/01
#
# AUTHOR    : Pascale.Roquet@meteo.fr
#
# SYNOPSIS  : extract obt-utc-correlation parameters from XML MMAM file
#
# VERSION   : 1.1
# 
# HISTORY   : 
# 1.2 14/09/2012 NCA. For portability, use XML::LibXML instead of XML::Simple
#


use strict;
use XML::LibXML;
@ARGV or die "Usage: $0 mmam-xml-message\n";


my $parser = XML::LibXML->new();

my $message = $parser->parse_file($ARGV[0]);

my @nodes = $message->findnodes("//obt-utc-correlation");
( not @nodes ) && die "can't find obt utc parameters\n";
my $node = $nodes[0];

my $utc0 = $node->getAttribute("utc-0");
my $ccuobt0 = $node->getAttribute("ccu-obt-0");
my $clockstep = $node->getAttribute("clock-step");

( not $utc0 ) && die "can't find obt utc parameters\n";
print $utc0." ".$ccuobt0." ".$clockstep."\n";

exit (0);
