#!/usr/bin/perl -w
#
# COPYRIGHT : NWP SAF
#
# AUTHOR    : Nigel Atkinson
#
# SYNOPSIS  : extract TLE bulletins from XML MMAM file
#
#          Usage: print-mmam-tle.pl mmam-xml-message [nsats]
#          where nsats is the max number of satellites to extract (default all)
#
# HISTORY   : 
# 1.1 18/10/2012 NCA.
#


use strict;
use XML::LibXML;
@ARGV or die "Usage: $0 mmam-xml-message [nsats]\n";


my $parser = XML::LibXML->new();

my $message = $parser->parse_file($ARGV[0]);

my @nodes1 = $message->findnodes("//line-1");
my @nodes2 = $message->findnodes("//line-2");

( @nodes1 ) || die "can't find two-line-elements\n";

my $maxsat = scalar(@nodes1);
my $nsat = $ARGV[1];

if ( $nsat ) {
  $nsat = $maxsat if $nsat > $maxsat;
} else {
  $nsat = $maxsat;
}

for my $i (0..$nsat-1){

  my $node1=$nodes1[$i];
  my $node2=$nodes2[$i];
  print $node1->textContent(),"\n";
  print $node2->textContent(),"\n";

  $i++;
}
exit (0);
