/*
 * COPYRIGHT : Meteo-France/EUMETSAT/SAFNWP
 *
 * DATE      : 2005/5
 * 
 * AUTHOR    : Philippe.Marguinaud@meteo.fr
 *
 * VERSION   : 1.1
 *
 * HISTORY   : 02/11/2005 fixup filler7 in t_record 191 -> 67
 *
 */
#include "aapp_avhrrl1b.h"

int aapp_avhrrl1b_check_subclass = 1;
int aapp_avhrrl1b_check_subclass_version = 1;


int read_header( t_header *X, buffer* B, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
    read_string( X->avh_h_siteid, B, 3, 1 );
    read_string( X->avh_h_blank, B, 1, 1 );
    read_eps_integer2( &X->avh_h_l1bversnb, B, 1 );
    read_eps_integer2( &X->avh_h_l1bversyr, B, 1 );
    read_eps_integer2( &X->avh_h_l1bversdy, B, 1 );
    read_eps_integer2( &X->avh_h_reclg, B, 1 );
    read_eps_integer2( &X->avh_h_blksz, B, 1 );
    read_eps_integer2( &X->avh_h_hdrcnt, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_filler0, B, ( 3 ) );
    read_string( X->avh_h_dataname, B, 42, 1 );
    read_string( X->avh_h_prblkid, B, 8, 1 );
    read_eps_integer2( &X->avh_h_satid, B, 1 );
    read_eps_integer2( &X->avh_h_instid, B, 1 );
    read_eps_uinteger2( &X->avh_h_datatyp, B, 1 );
    read_eps_uinteger2( &X->avh_h_tipsrc, B, 1 );
    read_eps_integer4( &X->avh_h_startdatajd, B, 1 );
    read_eps_integer2( &X->avh_h_startdatayr, B, 1 );
    read_eps_integer2( &X->avh_h_startdatady, B, 1 );
    read_eps_integer4( &X->avh_h_startdatatime, B, 1 );
    read_eps_integer4( &X->avh_h_enddatajd, B, 1 );
    read_eps_integer2( &X->avh_h_enddatayr, B, 1 );
    read_eps_integer2( &X->avh_h_enddatady, B, 1 );
    read_eps_integer4( &X->avh_h_enddatatime, B, 1 );
    read_eps_integer2( &X->avh_h_cpidsyr, B, 1 );
    read_eps_integer2( &X->avh_h_cpidsdy, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_filler1, B, ( 4 ) );
    read_eps_integer4( &X->avh_h_inststat1, B, 1 );
    read_eps_integer2( &X->avh_h_filler2, B, 1 );
    read_eps_integer2( &X->avh_h_statchrecnb, B, 1 );
    read_eps_integer4( &X->avh_h_inststat2, B, 1 );
    read_eps_integer2( &X->avh_h_scnlin, B, 1 );
    read_eps_integer2( &X->avh_h_callocsclin, B, 1 );
    read_eps_integer2( &X->avh_h_misscnlin, B, 1 );
    read_eps_integer2( &X->avh_h_datagaps, B, 1 );
    read_eps_integer2( &X->avh_h_okdatafr, B, 1 );
    read_eps_integer2( &X->avh_h_pacsparityerr, B, 1 );
    read_eps_integer2( &X->avh_h_auxsyncerrsum, B, 1 );
    read_eps_integer2( &X->avh_h_timeseqerr, B, 1 );
    read_eps_integer2( &X->avh_h_timeseqerrcode, B, 1 );
    read_eps_integer2( &X->avh_h_socclockupind, B, 1 );
    read_eps_integer2( &X->avh_h_locerrind, B, 1 );
    read_eps_integer2( &X->avh_h_locerrcode, B, 1 );
    read_eps_integer2( &X->avh_h_pacsstatfield, B, 1 );
    read_eps_integer2( &X->avh_h_pacsdatasrc, B, 1 );
    read_eps_integer4( &X->avh_h_filler3, B, 1 );
    read_string( X->avh_h_spare1, B, 8, 1 );
    read_string( X->avh_h_spare2, B, 8, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_filler4, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_racalind, B, 1 );
    read_eps_integer2( &X->avh_h_solarcalyr, B, 1 );
    read_eps_integer2( &X->avh_h_solarcaldy, B, 1 );
    read_eps_integer2( &X->avh_h_pcalalgind, B, 1 );
    read_eps_integer2( &X->avh_h_pcalalgopt, B, 1 );
    read_eps_integer2( &X->avh_h_scalalgind, B, 1 );
    read_eps_integer2( &X->avh_h_scalalgopt, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_irttcoef, B, ( 4 )*( 6 ) );
    read_eps_integer4( (eps_integer4*)X->avh_h_filler5, B, ( 2 ) );
    read_eps_integer4( (eps_integer4*)X->avh_h_albcnv, B, ( 3 )*( 2 ) );
    read_eps_integer4( (eps_integer4*)X->avh_h_radtempcv, B, ( 3 )*( 3 ) );
    read_eps_integer4( (eps_integer4*)X->avh_h_filler6, B, ( 3 ) );
    read_string( X->avh_h_modelid, B, 8, 1 );
    read_eps_integer2( &X->avh_h_nadloctol, B, 1 );
    read_eps_integer2( &X->avh_h_locbit, B, 1 );
    read_eps_integer2( &X->avh_h_filler7, B, 1 );
    read_eps_integer2( &X->avh_h_rollerr, B, 1 );
    read_eps_integer2( &X->avh_h_pitcherr, B, 1 );
    read_eps_integer2( &X->avh_h_yawerr, B, 1 );
    read_eps_integer2( &X->avh_h_epoyr, B, 1 );
    read_eps_integer2( &X->avh_h_epody, B, 1 );
    read_eps_integer4( &X->avh_h_epotime, B, 1 );
    read_eps_integer4( &X->avh_h_smaxis, B, 1 );
    read_eps_integer4( &X->avh_h_eccen, B, 1 );
    read_eps_integer4( &X->avh_h_incli, B, 1 );
    read_eps_integer4( &X->avh_h_argper, B, 1 );
    read_eps_integer4( &X->avh_h_rascnod, B, 1 );
    read_eps_integer4( &X->avh_h_manom, B, 1 );
    read_eps_integer4( &X->avh_h_xpos, B, 1 );
    read_eps_integer4( &X->avh_h_ypos, B, 1 );
    read_eps_integer4( &X->avh_h_zpos, B, 1 );
    read_eps_integer4( &X->avh_h_xvel, B, 1 );
    read_eps_integer4( &X->avh_h_yvel, B, 1 );
    read_eps_integer4( &X->avh_h_zvel, B, 1 );
    read_eps_integer4( &X->avh_h_earthsun, B, 1 );
    read_eps_integer4( (eps_integer4*)X->avh_h_filler8, B, ( 4 ) );
    read_eps_integer2( (eps_integer2*)X->avh_h_pchtemp, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved1, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_pchtempext, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved2, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_pchpow, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved3, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_rdtemp, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved4, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_bbtemp1, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved5, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_bbtemp2, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved6, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_bbtemp3, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved7, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_bbtemp4, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved8, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_eleccur, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved9, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_motorcur, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved10, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_earthpos, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved11, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_electemp, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved12, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_chtemp, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved13, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_bptemp, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved14, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_mhtemp, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved15, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_adcontemp, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved16, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_d4bvolt, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved17, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_d5bvolt, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved18, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_bbtempchn3B, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved19, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_bbtempchn4, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved20, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_bbtempchn5, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved21, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_refvolt, B, ( 5 ) );
    read_eps_integer2( &X->avh_h_reserved22, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_h_filler9, B, ( 10664 ) );
  }
  return status_buffer( B );
}


int write_header( t_header *X, buffer* B, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
    write_string( X->avh_h_siteid, B, 3, 1 );
    write_string( X->avh_h_blank, B, 1, 1 );
    write_eps_integer2( &X->avh_h_l1bversnb, B, 1 );
    write_eps_integer2( &X->avh_h_l1bversyr, B, 1 );
    write_eps_integer2( &X->avh_h_l1bversdy, B, 1 );
    write_eps_integer2( &X->avh_h_reclg, B, 1 );
    write_eps_integer2( &X->avh_h_blksz, B, 1 );
    write_eps_integer2( &X->avh_h_hdrcnt, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_filler0, B, ( 3 ) );
    write_string( X->avh_h_dataname, B, 42, 1 );
    write_string( X->avh_h_prblkid, B, 8, 1 );
    write_eps_integer2( &X->avh_h_satid, B, 1 );
    write_eps_integer2( &X->avh_h_instid, B, 1 );
    write_eps_uinteger2( &X->avh_h_datatyp, B, 1 );
    write_eps_uinteger2( &X->avh_h_tipsrc, B, 1 );
    write_eps_integer4( &X->avh_h_startdatajd, B, 1 );
    write_eps_integer2( &X->avh_h_startdatayr, B, 1 );
    write_eps_integer2( &X->avh_h_startdatady, B, 1 );
    write_eps_integer4( &X->avh_h_startdatatime, B, 1 );
    write_eps_integer4( &X->avh_h_enddatajd, B, 1 );
    write_eps_integer2( &X->avh_h_enddatayr, B, 1 );
    write_eps_integer2( &X->avh_h_enddatady, B, 1 );
    write_eps_integer4( &X->avh_h_enddatatime, B, 1 );
    write_eps_integer2( &X->avh_h_cpidsyr, B, 1 );
    write_eps_integer2( &X->avh_h_cpidsdy, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_filler1, B, ( 4 ) );
    write_eps_integer4( &X->avh_h_inststat1, B, 1 );
    write_eps_integer2( &X->avh_h_filler2, B, 1 );
    write_eps_integer2( &X->avh_h_statchrecnb, B, 1 );
    write_eps_integer4( &X->avh_h_inststat2, B, 1 );
    write_eps_integer2( &X->avh_h_scnlin, B, 1 );
    write_eps_integer2( &X->avh_h_callocsclin, B, 1 );
    write_eps_integer2( &X->avh_h_misscnlin, B, 1 );
    write_eps_integer2( &X->avh_h_datagaps, B, 1 );
    write_eps_integer2( &X->avh_h_okdatafr, B, 1 );
    write_eps_integer2( &X->avh_h_pacsparityerr, B, 1 );
    write_eps_integer2( &X->avh_h_auxsyncerrsum, B, 1 );
    write_eps_integer2( &X->avh_h_timeseqerr, B, 1 );
    write_eps_integer2( &X->avh_h_timeseqerrcode, B, 1 );
    write_eps_integer2( &X->avh_h_socclockupind, B, 1 );
    write_eps_integer2( &X->avh_h_locerrind, B, 1 );
    write_eps_integer2( &X->avh_h_locerrcode, B, 1 );
    write_eps_integer2( &X->avh_h_pacsstatfield, B, 1 );
    write_eps_integer2( &X->avh_h_pacsdatasrc, B, 1 );
    write_eps_integer4( &X->avh_h_filler3, B, 1 );
    write_string( X->avh_h_spare1, B, 8, 1 );
    write_string( X->avh_h_spare2, B, 8, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_filler4, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_racalind, B, 1 );
    write_eps_integer2( &X->avh_h_solarcalyr, B, 1 );
    write_eps_integer2( &X->avh_h_solarcaldy, B, 1 );
    write_eps_integer2( &X->avh_h_pcalalgind, B, 1 );
    write_eps_integer2( &X->avh_h_pcalalgopt, B, 1 );
    write_eps_integer2( &X->avh_h_scalalgind, B, 1 );
    write_eps_integer2( &X->avh_h_scalalgopt, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_irttcoef, B, ( 4 )*( 6 ) );
    write_eps_integer4( (eps_integer4*)X->avh_h_filler5, B, ( 2 ) );
    write_eps_integer4( (eps_integer4*)X->avh_h_albcnv, B, ( 3 )*( 2 ) );
    write_eps_integer4( (eps_integer4*)X->avh_h_radtempcv, B, ( 3 )*( 3 ) );
    write_eps_integer4( (eps_integer4*)X->avh_h_filler6, B, ( 3 ) );
    write_string( X->avh_h_modelid, B, 8, 1 );
    write_eps_integer2( &X->avh_h_nadloctol, B, 1 );
    write_eps_integer2( &X->avh_h_locbit, B, 1 );
    write_eps_integer2( &X->avh_h_filler7, B, 1 );
    write_eps_integer2( &X->avh_h_rollerr, B, 1 );
    write_eps_integer2( &X->avh_h_pitcherr, B, 1 );
    write_eps_integer2( &X->avh_h_yawerr, B, 1 );
    write_eps_integer2( &X->avh_h_epoyr, B, 1 );
    write_eps_integer2( &X->avh_h_epody, B, 1 );
    write_eps_integer4( &X->avh_h_epotime, B, 1 );
    write_eps_integer4( &X->avh_h_smaxis, B, 1 );
    write_eps_integer4( &X->avh_h_eccen, B, 1 );
    write_eps_integer4( &X->avh_h_incli, B, 1 );
    write_eps_integer4( &X->avh_h_argper, B, 1 );
    write_eps_integer4( &X->avh_h_rascnod, B, 1 );
    write_eps_integer4( &X->avh_h_manom, B, 1 );
    write_eps_integer4( &X->avh_h_xpos, B, 1 );
    write_eps_integer4( &X->avh_h_ypos, B, 1 );
    write_eps_integer4( &X->avh_h_zpos, B, 1 );
    write_eps_integer4( &X->avh_h_xvel, B, 1 );
    write_eps_integer4( &X->avh_h_yvel, B, 1 );
    write_eps_integer4( &X->avh_h_zvel, B, 1 );
    write_eps_integer4( &X->avh_h_earthsun, B, 1 );
    write_eps_integer4( (eps_integer4*)X->avh_h_filler8, B, ( 4 ) );
    write_eps_integer2( (eps_integer2*)X->avh_h_pchtemp, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved1, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_pchtempext, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved2, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_pchpow, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved3, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_rdtemp, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved4, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_bbtemp1, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved5, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_bbtemp2, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved6, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_bbtemp3, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved7, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_bbtemp4, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved8, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_eleccur, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved9, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_motorcur, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved10, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_earthpos, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved11, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_electemp, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved12, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_chtemp, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved13, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_bptemp, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved14, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_mhtemp, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved15, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_adcontemp, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved16, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_d4bvolt, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved17, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_d5bvolt, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved18, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_bbtempchn3B, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved19, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_bbtempchn4, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved20, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_bbtempchn5, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved21, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_refvolt, B, ( 5 ) );
    write_eps_integer2( &X->avh_h_reserved22, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_h_filler9, B, ( 10664 ) );
  }
  return status_buffer( B );
}


int free_header( t_header *X, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
  }
}


int init_header( t_header *X, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
  }
}


int size_header( t_header *X ) {
 return 22016;
}



int read_record( t_record *X, buffer* B, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
    read_eps_integer2( &X->avh_scnlin, B, 1 );
    read_eps_integer2( &X->avh_scnlinyr, B, 1 );
    read_eps_integer2( &X->avh_scnlindy, B, 1 );
    read_eps_integer2( &X->avh_clockdrift, B, 1 );
    read_eps_integer4( &X->avh_scnlintime, B, 1 );
    read_eps_integer2( &X->avh_scnlinbit, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_filler0, B, ( 5 ) );
    read_eps_integer4( &X->avh_qualind, B, 1 );
    read_eps_integer4( &X->avh_scnlinqual, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_calqual, B, ( 3 ) );
    read_eps_integer2( &X->avh_cbiterr, B, 1 );
    read_eps_integer4( (eps_integer4*)X->avh_filler1, B, ( 2 ) );
    read_eps_integer4( (eps_integer4*)X->avh_calvis, B, ( 3 )*( 3 )*( 5 ) );
    read_eps_integer4( (eps_integer4*)X->avh_calir, B, ( 3 )*( 2 )*( 3 ) );
    read_eps_integer4( (eps_integer4*)X->avh_filler2, B, ( 3 ) );
    read_eps_integer4( &X->avh_navstat, B, 1 );
    read_eps_integer4( &X->avh_attangtime, B, 1 );
    read_eps_integer2( &X->avh_rollang, B, 1 );
    read_eps_integer2( &X->avh_pitchang, B, 1 );
    read_eps_integer2( &X->avh_yawang, B, 1 );
    read_eps_integer2( &X->avh_scalti, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_ang, B, ( 51 )*( 3 ) );
    read_eps_integer2( (eps_integer2*)X->avh_filler3, B, ( 3 ) );
    read_eps_integer4( (eps_integer4*)X->avh_pos, B, ( 51 )*( 2 ) );
    read_eps_integer4( (eps_integer4*)X->avh_filler4, B, ( 2 ) );
    read_eps_integer2( (eps_integer2*)X->avh_telem, B, ( 103 ) );
    read_eps_integer2( &X->avh_filler5, B, 1 );
    read_eps_integer2( (eps_integer2*)X->avh_hrpt, B, ( 2048 )*( 5 ) );
    read_eps_integer4( (eps_integer4*)X->avh_filler6, B, ( 2 ) );
    read_eps_integer2( (eps_integer2*)X->avh_tipmfhd, B, ( 5 )*( 7 ) );
    read_eps_integer2( (eps_integer2*)X->avh_icputel, B, ( 5 )*( 6 ) );
    read_eps_integer2( (eps_integer2*)X->avh_filler7, B, ( 67 ) );
  }
  return status_buffer( B );
}


int write_record( t_record *X, buffer* B, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
    write_eps_integer2( &X->avh_scnlin, B, 1 );
    write_eps_integer2( &X->avh_scnlinyr, B, 1 );
    write_eps_integer2( &X->avh_scnlindy, B, 1 );
    write_eps_integer2( &X->avh_clockdrift, B, 1 );
    write_eps_integer4( &X->avh_scnlintime, B, 1 );
    write_eps_integer2( &X->avh_scnlinbit, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_filler0, B, ( 5 ) );
    write_eps_integer4( &X->avh_qualind, B, 1 );
    write_eps_integer4( &X->avh_scnlinqual, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_calqual, B, ( 3 ) );
    write_eps_integer2( &X->avh_cbiterr, B, 1 );
    write_eps_integer4( (eps_integer4*)X->avh_filler1, B, ( 2 ) );
    write_eps_integer4( (eps_integer4*)X->avh_calvis, B, ( 3 )*( 3 )*( 5 ) );
    write_eps_integer4( (eps_integer4*)X->avh_calir, B, ( 3 )*( 2 )*( 3 ) );
    write_eps_integer4( (eps_integer4*)X->avh_filler2, B, ( 3 ) );
    write_eps_integer4( &X->avh_navstat, B, 1 );
    write_eps_integer4( &X->avh_attangtime, B, 1 );
    write_eps_integer2( &X->avh_rollang, B, 1 );
    write_eps_integer2( &X->avh_pitchang, B, 1 );
    write_eps_integer2( &X->avh_yawang, B, 1 );
    write_eps_integer2( &X->avh_scalti, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_ang, B, ( 51 )*( 3 ) );
    write_eps_integer2( (eps_integer2*)X->avh_filler3, B, ( 3 ) );
    write_eps_integer4( (eps_integer4*)X->avh_pos, B, ( 51 )*( 2 ) );
    write_eps_integer4( (eps_integer4*)X->avh_filler4, B, ( 2 ) );
    write_eps_integer2( (eps_integer2*)X->avh_telem, B, ( 103 ) );
    write_eps_integer2( &X->avh_filler5, B, 1 );
    write_eps_integer2( (eps_integer2*)X->avh_hrpt, B, ( 2048 )*( 5 ) );
    write_eps_integer4( (eps_integer4*)X->avh_filler6, B, ( 2 ) );
    write_eps_integer2( (eps_integer2*)X->avh_tipmfhd, B, ( 5 )*( 7 ) );
    write_eps_integer2( (eps_integer2*)X->avh_icputel, B, ( 5 )*( 6 ) );
    write_eps_integer2( (eps_integer2*)X->avh_filler7, B, ( 67 ) );
  }
  return status_buffer( B );
}


int free_record( t_record *X, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
  }
}


int init_record( t_record *X, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
  }
}


int size_record( t_record *X ) {
 return 22016;
}


