#include "aapp_avhrrl1c.h"

int aapp_avhrrl1c_check_subclass = 1;
int aapp_avhrrl1c_check_subclass_version = 1;

static const int dims_header_avh1c_h_albcnv[] = { 2, avh1c_mxvischn };
static const int ndims_header_avh1c_h_albcnv = 2;
static const int dims_header_avh1c_h_radtempcnv[] = { 3, avh1c_mxirchn };
static const int ndims_header_avh1c_h_radtempcnv = 2;
static const int dims_header_avh1c_h_filler[] = { 7388 };
static const int ndims_header_avh1c_h_filler = 1;

int read_header( t_header *X, buffer* B, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
    read_string( X->avh1c_h_site, B, 3, 1 );
    read_string( X->avh1c_h_cfill1, B, 1, 1 );
    read_string( X->avh1c_h_l1bsite, B, 3, 1 );
    read_string( X->avh1c_h_cfill2, B, 1, 1 );
    read_eps_integer4( &X->avh1c_h_versnb, B, 1 );
    read_eps_integer4( &X->avh1c_h_versyr, B, 1 );
    read_eps_integer4( &X->avh1c_h_versdy, B, 1 );
    read_eps_integer4( &X->avh1c_h_hdrcnt, B, 1 );
    read_eps_integer4( &X->avh1c_h_satid, B, 1 );
    read_eps_integer4( &X->avh1c_h_instrument, B, 1 );
    read_eps_integer4( &X->avh1c_h_satht, B, 1 );
    read_eps_integer4( &X->avh1c_h_period, B, 1 );
    read_eps_integer4( &X->avh1c_h_startorbit, B, 1 );
    read_eps_integer4( &X->avh1c_h_startdatayr, B, 1 );
    read_eps_integer4( &X->avh1c_h_startdatady, B, 1 );
    read_eps_integer4( &X->avh1c_h_startdatatime, B, 1 );
    read_eps_integer4( &X->avh1c_h_endorbit, B, 1 );
    read_eps_integer4( &X->avh1c_h_enddatayr, B, 1 );
    read_eps_integer4( &X->avh1c_h_enddatady, B, 1 );
    read_eps_integer4( &X->avh1c_h_enddatatime, B, 1 );
    read_eps_integer4( &X->avh1c_h_scnlin, B, 1 );
    read_eps_integer4( &X->avh1c_h_misscnlin, B, 1 );
    read_eps_integer4( &X->avh1c_h_callocscnlin, B, 1 );
    read_eps_integer4( &X->avh1c_h_datagaps, B, 1 );
    read_eps_integer4( &X->avh1c_h_datatyp, B, 1 );
    read_string( X->avh1c_h_infilename, B, 68, 1 );
    read_eps_integer4( &X->avh1c_h_wmosatid, B, 1 );
    read_eps_integer4( &X->avh1c_h_cpidsyr, B, 1 );
    read_eps_integer4( &X->avh1c_h_cpidsdy, B, 1 );
    read_eps_integer4( &X->avh1c_h_rollerr, B, 1 );
    read_eps_integer4( &X->avh1c_h_pitcherr, B, 1 );
    read_eps_integer4( &X->avh1c_h_yawerr, B, 1 );
    read_eps_integer4( (eps_integer4*)X->avh1c_h_albcnv, B, ( 2 )*( avh1c_mxvischn ) );
    read_eps_integer4( (eps_integer4*)X->avh1c_h_radtempcnv, B, ( 3 )*( avh1c_mxirchn ) );
    read_eps_integer4( (eps_integer4*)X->avh1c_h_filler, B, ( 7388 ) );
  }
  return status_buffer( B );
}


int write_header( t_header *X, buffer* B, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
    write_string( X->avh1c_h_site, B, 3, 1 );
    write_string( X->avh1c_h_cfill1, B, 1, 1 );
    write_string( X->avh1c_h_l1bsite, B, 3, 1 );
    write_string( X->avh1c_h_cfill2, B, 1, 1 );
    write_eps_integer4( &X->avh1c_h_versnb, B, 1 );
    write_eps_integer4( &X->avh1c_h_versyr, B, 1 );
    write_eps_integer4( &X->avh1c_h_versdy, B, 1 );
    write_eps_integer4( &X->avh1c_h_hdrcnt, B, 1 );
    write_eps_integer4( &X->avh1c_h_satid, B, 1 );
    write_eps_integer4( &X->avh1c_h_instrument, B, 1 );
    write_eps_integer4( &X->avh1c_h_satht, B, 1 );
    write_eps_integer4( &X->avh1c_h_period, B, 1 );
    write_eps_integer4( &X->avh1c_h_startorbit, B, 1 );
    write_eps_integer4( &X->avh1c_h_startdatayr, B, 1 );
    write_eps_integer4( &X->avh1c_h_startdatady, B, 1 );
    write_eps_integer4( &X->avh1c_h_startdatatime, B, 1 );
    write_eps_integer4( &X->avh1c_h_endorbit, B, 1 );
    write_eps_integer4( &X->avh1c_h_enddatayr, B, 1 );
    write_eps_integer4( &X->avh1c_h_enddatady, B, 1 );
    write_eps_integer4( &X->avh1c_h_enddatatime, B, 1 );
    write_eps_integer4( &X->avh1c_h_scnlin, B, 1 );
    write_eps_integer4( &X->avh1c_h_misscnlin, B, 1 );
    write_eps_integer4( &X->avh1c_h_callocscnlin, B, 1 );
    write_eps_integer4( &X->avh1c_h_datagaps, B, 1 );
    write_eps_integer4( &X->avh1c_h_datatyp, B, 1 );
    write_string( X->avh1c_h_infilename, B, 68, 1 );
    write_eps_integer4( &X->avh1c_h_wmosatid, B, 1 );
    write_eps_integer4( &X->avh1c_h_cpidsyr, B, 1 );
    write_eps_integer4( &X->avh1c_h_cpidsdy, B, 1 );
    write_eps_integer4( &X->avh1c_h_rollerr, B, 1 );
    write_eps_integer4( &X->avh1c_h_pitcherr, B, 1 );
    write_eps_integer4( &X->avh1c_h_yawerr, B, 1 );
    write_eps_integer4( (eps_integer4*)X->avh1c_h_albcnv, B, ( 2 )*( avh1c_mxvischn ) );
    write_eps_integer4( (eps_integer4*)X->avh1c_h_radtempcnv, B, ( 3 )*( avh1c_mxirchn ) );
    write_eps_integer4( (eps_integer4*)X->avh1c_h_filler, B, ( 7388 ) );
  }
  return status_buffer( B );
}


int free_header( t_header *X, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
  }
}


int init_header( t_header *X, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
  }
}


int size_header( t_header *X ) {
 return 29808;
}


int print_header( const char* label, t_header *X, FILE *fp, int ndim, const int *dims ) {
  int i;
  fprintf( fp, label );
  fprintf( fp, "\n" );
  if( ndim == 0 ) {
    print_string( "avh1c_h_site", X->avh1c_h_site, fp, 3, 0, NULL );
    print_string( "avh1c_h_cfill1", X->avh1c_h_cfill1, fp, 1, 0, NULL );
    print_string( "avh1c_h_l1bsite", X->avh1c_h_l1bsite, fp, 3, 0, NULL );
    print_string( "avh1c_h_cfill2", X->avh1c_h_cfill2, fp, 1, 0, NULL );
    print_eps_integer4( "avh1c_h_versnb", &X->avh1c_h_versnb, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_versyr", &X->avh1c_h_versyr, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_versdy", &X->avh1c_h_versdy, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_hdrcnt", &X->avh1c_h_hdrcnt, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_satid", &X->avh1c_h_satid, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_instrument", &X->avh1c_h_instrument, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_satht", &X->avh1c_h_satht, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_period", &X->avh1c_h_period, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_startorbit", &X->avh1c_h_startorbit, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_startdatayr", &X->avh1c_h_startdatayr, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_startdatady", &X->avh1c_h_startdatady, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_startdatatime", &X->avh1c_h_startdatatime, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_endorbit", &X->avh1c_h_endorbit, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_enddatayr", &X->avh1c_h_enddatayr, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_enddatady", &X->avh1c_h_enddatady, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_enddatatime", &X->avh1c_h_enddatatime, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_scnlin", &X->avh1c_h_scnlin, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_misscnlin", &X->avh1c_h_misscnlin, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_callocscnlin", &X->avh1c_h_callocscnlin, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_datagaps", &X->avh1c_h_datagaps, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_datatyp", &X->avh1c_h_datatyp, fp, 0, NULL );
    print_string( "avh1c_h_infilename", X->avh1c_h_infilename, fp, 68, 0, NULL );
    print_eps_integer4( "avh1c_h_wmosatid", &X->avh1c_h_wmosatid, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_cpidsyr", &X->avh1c_h_cpidsyr, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_cpidsdy", &X->avh1c_h_cpidsdy, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_rollerr", &X->avh1c_h_rollerr, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_pitcherr", &X->avh1c_h_pitcherr, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_yawerr", &X->avh1c_h_yawerr, fp, 0, NULL );
    print_eps_integer4( "avh1c_h_albcnv", (eps_integer4*)X->avh1c_h_albcnv, fp, ndims_header_avh1c_h_albcnv, dims_header_avh1c_h_albcnv );
    print_eps_integer4( "avh1c_h_radtempcnv", (eps_integer4*)X->avh1c_h_radtempcnv, fp, ndims_header_avh1c_h_radtempcnv, dims_header_avh1c_h_radtempcnv );
    print_eps_integer4( "avh1c_h_filler", (eps_integer4*)X->avh1c_h_filler, fp, ndims_header_avh1c_h_filler, dims_header_avh1c_h_filler );
  } else {
    int k = 1;
    char label[16];
    for( i = 1; i < ndim; i++ ) {
      k *= dims[i];
    }
    for( i = 0; i < dims[0]; i++ ) {
      sprintf( label, "[%d]", i ); 
      print_header( label, X + i * k, fp, ndim-1, dims + 1 );
    }
  }
}


static const int dims_record_avh1c_spare0[] = { 2 };
static const int ndims_record_avh1c_spare0 = 1;
static const int dims_record_avh1c_calqual[] = { avh1c_mxirchn };
static const int ndims_record_avh1c_calqual = 1;
static const int dims_record_avh1c_spare1[] = { 2 };
static const int ndims_record_avh1c_spare1 = 1;
static const int dims_record_avh1c_ang[] = { 51, 3 };
static const int ndims_record_avh1c_ang = 2;
static const int dims_record_avh1c_pos[] = { 51, 2 };
static const int ndims_record_avh1c_pos = 2;
static const int dims_record_avh1c_spare2[] = { 2 };
static const int ndims_record_avh1c_spare2 = 1;
static const int dims_record_avh1c_btemps[] = { avh1c_mxpix, avh1c_mxhrpchn };
static const int ndims_record_avh1c_btemps = 2;
static const int dims_record_avh1c_mask[] = { avh1c_mxpix };
static const int ndims_record_avh1c_mask = 1;
static const int dims_record_avh1c_tsurf[] = { avh1c_mxpix };
static const int ndims_record_avh1c_tsurf = 1;
static const int dims_record_avh1c_spare3[] = { 10 };
static const int ndims_record_avh1c_spare3 = 1;

int read_record( t_record *X, buffer* B, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
    read_eps_integer4( &X->avh1c_scnlin, B, 1 );
    read_eps_integer4( &X->avh1c_scnlinyr, B, 1 );
    read_eps_integer4( &X->avh1c_scnlindy, B, 1 );
    read_eps_integer4( &X->avh1c_scnlintime, B, 1 );
    read_eps_integer4( &X->avh1c_clockdrift, B, 1 );
    read_eps_integer4( &X->avh1c_scnlinbit, B, 1 );
    read_eps_integer4( (eps_integer4*)X->avh1c_spare0, B, ( 2 ) );
    read_eps_integer4( &X->avh1c_qualind, B, 1 );
    read_eps_integer4( &X->avh1c_scnlinqual, B, 1 );
    read_eps_integer4( (eps_integer4*)X->avh1c_calqual, B, ( avh1c_mxirchn ) );
    read_eps_integer4( (eps_integer4*)X->avh1c_spare1, B, ( 2 ) );
    read_eps_integer4( &X->avh1c_scalti, B, 1 );
    read_eps_integer4( (eps_integer4*)X->avh1c_ang, B, ( 51 )*( 3 ) );
    read_eps_integer4( (eps_integer4*)X->avh1c_pos, B, ( 51 )*( 2 ) );
    read_eps_integer4( (eps_integer4*)X->avh1c_spare2, B, ( 2 ) );
    read_eps_uinteger2( (eps_uinteger2*)X->avh1c_btemps, B, ( avh1c_mxpix )*( avh1c_mxhrpchn ) );
    read_eps_integer4( &X->avh1c_maskind, B, 1 );
    read_eps_uinteger2( (eps_uinteger2*)X->avh1c_mask, B, ( avh1c_mxpix ) );
    read_eps_uinteger2( (eps_uinteger2*)X->avh1c_tsurf, B, ( avh1c_mxpix ) );
    read_eps_integer4( (eps_integer4*)X->avh1c_spare3, B, ( 10 ) );
  }
  return status_buffer( B );
}


int write_record( t_record *X, buffer* B, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
    write_eps_integer4( &X->avh1c_scnlin, B, 1 );
    write_eps_integer4( &X->avh1c_scnlinyr, B, 1 );
    write_eps_integer4( &X->avh1c_scnlindy, B, 1 );
    write_eps_integer4( &X->avh1c_scnlintime, B, 1 );
    write_eps_integer4( &X->avh1c_clockdrift, B, 1 );
    write_eps_integer4( &X->avh1c_scnlinbit, B, 1 );
    write_eps_integer4( (eps_integer4*)X->avh1c_spare0, B, ( 2 ) );
    write_eps_integer4( &X->avh1c_qualind, B, 1 );
    write_eps_integer4( &X->avh1c_scnlinqual, B, 1 );
    write_eps_integer4( (eps_integer4*)X->avh1c_calqual, B, ( avh1c_mxirchn ) );
    write_eps_integer4( (eps_integer4*)X->avh1c_spare1, B, ( 2 ) );
    write_eps_integer4( &X->avh1c_scalti, B, 1 );
    write_eps_integer4( (eps_integer4*)X->avh1c_ang, B, ( 51 )*( 3 ) );
    write_eps_integer4( (eps_integer4*)X->avh1c_pos, B, ( 51 )*( 2 ) );
    write_eps_integer4( (eps_integer4*)X->avh1c_spare2, B, ( 2 ) );
    write_eps_uinteger2( (eps_uinteger2*)X->avh1c_btemps, B, ( avh1c_mxpix )*( avh1c_mxhrpchn ) );
    write_eps_integer4( &X->avh1c_maskind, B, 1 );
    write_eps_uinteger2( (eps_uinteger2*)X->avh1c_mask, B, ( avh1c_mxpix ) );
    write_eps_uinteger2( (eps_uinteger2*)X->avh1c_tsurf, B, ( avh1c_mxpix ) );
    write_eps_integer4( (eps_integer4*)X->avh1c_spare3, B, ( 10 ) );
  }
  return status_buffer( B );
}


int free_record( t_record *X, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
  }
}


int init_record( t_record *X, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
  }
}


int size_record( t_record *X ) {
 return 29808;
}


int print_record( const char* label, t_record *X, FILE *fp, int ndim, const int *dims ) {
  int i;
  fprintf( fp, label );
  fprintf( fp, "\n" );
  if( ndim == 0 ) {
    print_eps_integer4( "avh1c_scnlin", &X->avh1c_scnlin, fp, 0, NULL );
    print_eps_integer4( "avh1c_scnlinyr", &X->avh1c_scnlinyr, fp, 0, NULL );
    print_eps_integer4( "avh1c_scnlindy", &X->avh1c_scnlindy, fp, 0, NULL );
    print_eps_integer4( "avh1c_scnlintime", &X->avh1c_scnlintime, fp, 0, NULL );
    print_eps_integer4( "avh1c_clockdrift", &X->avh1c_clockdrift, fp, 0, NULL );
    print_eps_integer4( "avh1c_scnlinbit", &X->avh1c_scnlinbit, fp, 0, NULL );
    print_eps_integer4( "avh1c_spare0", (eps_integer4*)X->avh1c_spare0, fp, ndims_record_avh1c_spare0, dims_record_avh1c_spare0 );
    print_eps_integer4( "avh1c_qualind", &X->avh1c_qualind, fp, 0, NULL );
    print_eps_integer4( "avh1c_scnlinqual", &X->avh1c_scnlinqual, fp, 0, NULL );
    print_eps_integer4( "avh1c_calqual", (eps_integer4*)X->avh1c_calqual, fp, ndims_record_avh1c_calqual, dims_record_avh1c_calqual );
    print_eps_integer4( "avh1c_spare1", (eps_integer4*)X->avh1c_spare1, fp, ndims_record_avh1c_spare1, dims_record_avh1c_spare1 );
    print_eps_integer4( "avh1c_scalti", &X->avh1c_scalti, fp, 0, NULL );
    print_eps_integer4( "avh1c_ang", (eps_integer4*)X->avh1c_ang, fp, ndims_record_avh1c_ang, dims_record_avh1c_ang );
    print_eps_integer4( "avh1c_pos", (eps_integer4*)X->avh1c_pos, fp, ndims_record_avh1c_pos, dims_record_avh1c_pos );
    print_eps_integer4( "avh1c_spare2", (eps_integer4*)X->avh1c_spare2, fp, ndims_record_avh1c_spare2, dims_record_avh1c_spare2 );
    print_eps_uinteger2( "avh1c_btemps", (eps_uinteger2*)X->avh1c_btemps, fp, ndims_record_avh1c_btemps, dims_record_avh1c_btemps );
    print_eps_integer4( "avh1c_maskind", &X->avh1c_maskind, fp, 0, NULL );
    print_eps_uinteger2( "avh1c_mask", (eps_uinteger2*)X->avh1c_mask, fp, ndims_record_avh1c_mask, dims_record_avh1c_mask );
    print_eps_uinteger2( "avh1c_tsurf", (eps_uinteger2*)X->avh1c_tsurf, fp, ndims_record_avh1c_tsurf, dims_record_avh1c_tsurf );
    print_eps_integer4( "avh1c_spare3", (eps_integer4*)X->avh1c_spare3, fp, ndims_record_avh1c_spare3, dims_record_avh1c_spare3 );
  } else {
    int k = 1;
    char label[16];
    for( i = 1; i < ndim; i++ ) {
      k *= dims[i];
    }
    for( i = 0; i < dims[0]; i++ ) {
      sprintf( label, "[%d]", i ); 
      print_record( label, X + i * k, fp, ndim-1, dims + 1 );
    }
  }
}


