C
C COPYRIGHT : Meteo-France/EUMETSAT/SAFNWP
C
C DATE      : 2005/10
C 
C AUTHOR    : Philippe.Marguinaud@meteo.fr
C
C VERSION   : 1.2
C
C HISTORY   : 24/01/2006 : Change INCLUDE to #include
C             26/01/2006 : Add subroutine FINISH
C                          Divide by RLDIV in open
C             13/01/2006 : Read in STATION_ID using GETENV. NCA
C             19/07/2011 : Fix compilation error for null literal string. NCA
C
C
C
C     OPEN FILENAME FOR WRITING
C
      SUBROUTINE INIT( LUN, FILENAME )
      INTEGER LUN
      CHARACTER*(*) FILENAME
#include "reclopt.h"
#include "avh1b.h"
#include "hrptdc.h"
      COMMON /GQC/ TIMOK
      LOGICAL TIMOK

      TIMOK = .TRUE.
      
      OPEN( LUN, FORM = 'UNFORMATTED', ACCESS = 'DIRECT',
     >      RECL = RECLAVH / RLDIV, FILE = FILENAME )
     
      LUAVH = LUN
      AVH_H_RECLG = RECLAVH
     
      CALL GETENV('STATION_ID',STATION_ID)
      IF (STATION_ID(1:1).EQ." ") STATION_ID="WE"
     
      END
      
      SUBROUTINE FINISH( LUN )
      
      CLOSE( LUN )
      
      END

      
