C
C COPYRIGHT : Meteo-France/EUMETSAT/SAFNWP
C
C DATE      : 2005/10
C 
C AUTHOR    : Philippe.Marguinaud@meteo.fr
C
C VERSION   : 1.2
C
C HISTORY   : 24/01/2006 : Change INCLUDE to #include
C             26/01/2006 : Add intermediate function HIROUT0
C                          Add function FINISH
C                          Divide by RLDIV in open
C             13/01/2006 : Read in STATION_ID using GETENV. NCA
C             19/07/2011 : Fix compilation error for null literal string. NCA
C
C

C
C     OPEN FILENAME FOR WRITING
C
      SUBROUTINE INIT( LUN, FILENAME )
      CHARACTER*(*) FILENAME
#include "reclopt.h"
#include "hrs1b.h"
#include "hrptdc.h"

C The following are in hrptdc.h:      
C      COMMON /IOCOM/ LULOG,LUHIRS3

      INTEGER MSECS, DAY, NMF, NHIRS
      COMMON /LOG/ MSECS, DAY, NMF, NHIRS

      OPEN( LUN, FORM = 'UNFORMATTED', ACCESS = 'DIRECT',
     >      RECL = RECLHRS / RLDIV, FILE = FILENAME )
     
      LUHIRS3 = LUN
      HRS_H_RECLG = RECLHRS
      NHIRS = 0
     
      CALL GETENV('STATION_ID',STATION_ID)
      IF (STATION_ID(1:1).EQ." ") STATION_ID="WE"
     
      END
C
C     SETS UP COMMON LOG
C      
      SUBROUTINE HIRDAY( IDAY )
      INTEGER MSECS, DAY, NMF, NHIRS
      COMMON /LOG/ MSECS, DAY, NMF, NHIRS

      DAY = IDAY
      
      END
      
      SUBROUTINE FINISH( LUN )
      
      CLOSE( LUN )
      
      END

      SUBROUTINE HIROUT0( HIRS, HIANAG, YR, MSECH, SYSTIM, SATID, 
     > ERR, FULLHI, GOTIME, STARTORB, ENDORB, HIRS3 )
      IMPLICIT NONE
      INTEGER*2 HIRS(1152)              
      INTEGER*4 SYSTIM(3)               
      INTEGER*4 YR  
      INTEGER*4 MSECH  
      INTEGER*4 SATID                   
      INTEGER*4 ERR                  
      INTEGER*4 HIRS3                   
      INTEGER*4 STARTORB, ENDORB         
      INTEGER*2 HIANAG(1)               
      INTEGER*4 FULLHI               
      INTEGER*4 GOTIME
      LOGICAL*1 L_FULLHI               
      LOGICAL*1 L_GOTIME
      
      L_FULLHI = FULLHI .NE. 0
      L_GOTIME = GOTIME .NE. 0
      
      CALL HIROUT( HIRS, HIANAG, YR, MSECH, SYSTIM, SATID, 
     > ERR, L_FULLHI, L_GOTIME, STARTORB, ENDORB, HIRS3 )
      
      END
