C
C COPYRIGHT : Meteo-France/EUMETSAT/SAFNWP
C
C DATE      : 2005/10
C 
C AUTHOR    : Philippe.Marguinaud@meteo.fr
C
C VERSION   : 1.2
C
C HISTORY   : 24/01/2006 : Change INCLUDE to #include
C             26/01/2006 : Add intermediate subroutine amsout0
C                          Add subroutine FINISH
C                          Divide by RLDIV in open
C             13/01/2006 : Read in STATION_ID using GETENV. NCA
C             06/11/2006 : Add a parameter to amsday
C             19/07/2011 : Fix compilation error for null literal string. NCA
C
C
      SUBROUTINE INIT( LUN, FILENAME )
      CHARACTER*(*) FILENAME
      INTEGER LUN
#include "reclopt.h"
#include "ama1b.h"
#include "amb1b.h"
#include "mhs1b.h"
#include "hrptdc.h"
      
C The following are in hrptdc.h:      
C      INTEGER LULOG, LUHIRS3, LUAMSA1, LUAMSA2, LUAMSB, LUHIRS2, LUMSU
C      INTEGER LUDCS, LUSEM, LUSBUV, LUSAR, LUAVH
C      COMMON / IOCOM / 
C     >        LULOG, LUHIRS3, LUAMSA1, LUAMSA2, LUAMSB, LUHIRS2, 
C     >        LUMSU, LUDCS,   LUSEM,   LUSBUV,  LUSAR,  LUAVH

      INTEGER MSECS, DAY, NMF, NHIRS, NMSU, NAMSUA, NAMSUB, NDCS
      COMMON /LOG/ 
     >        MSECS, DAY, NMF, NHIRS, NMSU, NAMSUA, NAMSUB, NDCS
      COMMON /FIRSTCOM/ FIRSTMF, FIRSTBSCAN
      INTEGER FIRSTMF, FIRSTBSCAN
      
      LUAMSB = LUN

      OPEN( LUN, FORM = 'UNFORMATTED', ACCESS = 'DIRECT',
     >      RECL = RECLMHS / RLDIV, FILE = FILENAME )

      NAMSUB = 0

      FIRSTBSCAN = 1
      
      MHS_H_RECLG = RECLMHS

      CALL GETENV('STATION_ID',STATION_ID)
      IF (STATION_ID(1:1).EQ." ") STATION_ID="WE"
     
      END

      SUBROUTINE AMSDAY( IDAY, IMSECS )
      INTEGER MSECS, DAY, NMF, NHIRS
      COMMON /LOG/ 
     >        MSECS, DAY, NMF, NHIRS, NMSU, NAMSUA, NAMSUB, NDCS

      DAY = IDAY
      MSECS = IMSECS

      END
      
      SUBROUTINE AMSOUT0( OPTN, AMSUA1, AMSUA2, AMSUB, MHS, AMANAG, 
     > AMVALID, YR, MSECA, SYSTIM, SATID, AERR, BERR, FULLAM, GOTIME, 
     > STARTORB, ENDORB, MHSPRESENT )
      IMPLICIT NONE
      INTEGER*2 AMSUA1(620),AMSUA2(156) 
      INTEGER*2 AMSUB(1950)             
      CHARACTER*1 MHS(3900)             
      INTEGER*2 AMANAG(71)              
      INTEGER*2 AMVALID(71)             
      INTEGER*4 SYSTIM(3)               
      INTEGER*4 DAY, MSECA   
      INTEGER*4 YR                
      INTEGER*4 SATID                   
      INTEGER*4 AERR, BERR(3)            
      INTEGER*4 OPTN(12)                
      INTEGER*4 STARTORB, ENDORB
      INTEGER*4 MHSPRESENT, FULLAM, GOTIME
      LOGICAL*1 L_MHSPRESENT, L_FULLAM, L_GOTIME
      
      L_MHSPRESENT = MHSPRESENT .NE. 0
      L_FULLAM = FULLAM .NE. 0
      L_GOTIME = GOTIME .NE. 0
      
      CALL AMSOUT( OPTN, AMSUA1, AMSUA2, AMSUB, MHS, AMANAG, AMVALID, 
     > YR, MSECA, SYSTIM, SATID, AERR, BERR, L_FULLAM, L_GOTIME, 
     > STARTORB, ENDORB, L_MHSPRESENT )
      
      
      END
      
      SUBROUTINE FINISH( LUN )
      INTEGER LUN
      
      CLOSE( LUN )
      
      END
