#include "metop_mmam.h"
#include "common-aapp.h"



int init_MMAM_PACKET_validity_time( t_MMAM_PACKET_validity_time *X, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
  }
}


int size_MMAM_PACKET_validity_time( t_MMAM_PACKET_validity_time *X ) {
  int i;
  return 4 + 4 + 4;
}
int read_MMAM_PACKET_validity_time( t_MMAM_PACKET_validity_time *X, buffer* B, int n ) {
  int i;
  for( i = 0; i < n; i++, X++ ) {
    read_eps_integer4( &X->M, B, 1 );
    read_eps_uinteger4( &X->J, B, 1 );
    read_eps_uinteger4( &X->D, B, 1 );
  }
  return status_buffer( B );
}

int print_MMAM_PACKET_validity_time( const char* label, t_MMAM_PACKET_validity_time *X, FILE *fp, int ndim, const int *dims ) {
  int i;
  fprintf( fp, label );
  fprintf( fp, "\n" );
  if( ndim == 0 ) {
    print_eps_integer4( "M", &X->M, fp, 0, NULL );
    print_eps_uinteger4( "J", &X->J, fp, 0, NULL );
    print_eps_uinteger4( "D", &X->D, fp, 0, NULL );
  } else {
    int k = 1;
    char label[16];
    for( i = 1; i < ndim; i++ ) {
      k *= dims[i];
    }
    for( i = 0; i < dims[0]; i++ ) {
      sprintf( label, "[%d]", i ); 
      print_MMAM_PACKET_validity_time( label, X +  i * k, fp, ndim-1, dims + 1 );
    }
  }
}



int read_MMAM_PACKET  ( t_MMAM_PACKET * X, buffer *B, int n ) {
  int i; 
  int size;
  for( i = 0; i < n; i++, X++ ) {
    read_eps_uinteger1( &X->message_number, B, 1 );
    read_MMAM_PACKET_validity_time( &X->validity_time, B, 1 );
    read_string( &X->satellite_id, B, 10, 1 );
    read_eps_uinteger4( &(X->mmam_size), B, 1 );
    
    X->mmam=(char *)calloc(  (size_t)X->mmam_size,1 ) ;
    read_buffer(X->mmam,X->mmam_size,B); 
   
    return status_buffer( B );
  }
  
}
BOOLEAN is_MMAM_PACKET  ( t_MMAM_PACKET * X ) {
  int i; 
  int size;
  BOOLEAN is_mmam=FALSE;
  char c1,c2;
    c1=X->mmam[0];
    c2=X->mmam[1];
    if ( c1 == 'B' && c2 == 'Z' ) is_mmam=TRUE;   
    return is_mmam;

  
}
int print_MMAM_PACKET ( const char* label, t_MMAM_PACKET *X, FILE *fp, int ndim, const int *dims ) {
  int i;
  fprintf( fp, label );
  fprintf( fp, "\n" ); 
  if( ndim == 0 ) { 
  print_eps_uinteger1( "message_number", &X->message_number, fp, 0, NULL );
  print_MMAM_PACKET_validity_time( "validity_time", &X->validity_time, fp, 0, NULL );
  print_string( "satellite_id", X->satellite_id, fp, 10, 0, NULL );
  fprintf(fp,"size MMAM=%d must be <= 7985\n",X->mmam_size);
   }else {
    int k = 1;
    char label[16];
    for( i = 1; i < ndim; i++ ) {
      k *= dims[i];
    }
    for( i = 0; i < dims[0]; i++ ) {
      sprintf( label, "[%d]", i ); 
      print_MMAM_PACKET( label, X +  i * k, fp, ndim-1, dims + 1 );
    }
  }
}    

int write_file_MMAM_PACKET( t_MMAM_PACKET *X, FILE *fp, int n ) {
  int i;
  int return_code;
  for( i = 0; i < n; i++, X++ ) {
 
   return_code=fwrite(X->mmam, X->mmam_size, 1, fp);
  }
  
  return return_code;
}
 
  

int size_MMAM_PACKET( t_MMAM_PACKET *X ) {
 return 8032;
}
static int print_time( eps_integer4 M, eps_uinteger4 J, eps_uinteger4 D ) {
  int YYYY, MM, DD, HH, mm, ss, mmmmmm;
  eps_real8 ij;
  eps_integer4 ig[7];

  ij = 18262.0 + M;
  
  aapp_xijg( &ij, ig );
  
  YYYY = ig[0];
  MM   = ig[1];
  DD   = ig[2];
  
  HH = J / 3600;
  J = J % 3600;
  mm = J / 60;
  J = J % 60;
  ss = J;
  
  mmmmmm = D;
  
  return printf( "%4.4d/%2.2d/%2.2d %2.2d:%2.2d:%2.2d.%6.6d", YYYY, MM, DD, HH, mm, ss, mmmmmm );
}

/*
 * print_MJD prints time in MJD format.
 */

static int print_MJD( eps_integer4 M, eps_uinteger4 J, eps_uinteger4 D ) {
  return printf( "%5.5d %5.5d %6.6d", M, J, D );
}

int print_formatted_mmam( t_MMAM_PACKET* MP ) {
  int i;
  printf( "! Message number\n" );
  printf( "%d\n", MP->message_number );
  printf( "! Message Start Time\n" );  
  print_time( MP->validity_time.M, MP->validity_time.J, MP->validity_time.D );
  printf( "\n" );
  printf( "! Message Start Time MJD-2000\n" );
  print_MJD( MP->validity_time.M, MP->validity_time.J, MP->validity_time.D );
  printf( "\n" );
  printf( "! METOP SCID\n" );
  for( i = 0; i < 10; i++ ) { printf( "%c", MP->satellite_id[i] ); }
  printf( "\n\n" );
}
