// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/DAT/src/CMN_DAT_DataGap.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ---------------------------------------------------------------------------
//@ Composant : CMN
//@ Sous-composant : CMN_DAT
//@ CLASSE : CMN_DAT_DataGap
//@
//@ Commentaire :
//@    Fichier d'entete de la classe CMN_DAT_DataGap, qui stocke
//@    les informations liees aux trous de donnees dans un fichier
//@    genere
//@                                                                     
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 06/01/2003 : P. CABANE
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

#ifndef CMN_DAT_DataGap_h
#define CMN_DAT_DataGap_h

//
// Fichiers include
//

// STL
#include <list>

// Standard

// Projet
#include "CMN__Commun.h"
#include "CMN__Date.h"


class CMN_DAT_DataGap {

    /*================================================================*/
    
 public:
    
    ////////////////////////////////
    // Constantes
    ////////////////////////////////
    static const unsigned int LENGTH_GAP_REASON;
    static const t_Chaine     GAP_REASON_ONE;
    static const t_Chaine     GAP_REASON_TWO;
    static const t_Chaine     GAP_REASON_THREE;
    static const t_Chaine     GAP_REASON_FOUR;
    static const t_Chaine     GAP_REASON_FIVE;
    static const t_Chaine     GAP_REASON_SIX;

    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    CMN_DAT_DataGap();
        
    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    ~CMN_DAT_DataGap();

    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    void Reason(t_Chaine reason) {m_Reason = reason;};
    t_Chaine Reason() {return m_Reason;};

    void Count(unsigned long count) {m_Count = count;};
    unsigned long Count() {return m_Count;};


    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    void Afficher();

    
    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////
    

    /*================================================================*/

 private:

    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
    t_Chaine      m_Reason;
    unsigned long m_Count;
};

// Type DataGap
typedef CMN_DAT_DataGap       t_DataGap;

// Liste de DataGap
typedef list<CMN_DAT_DataGap> t_ListeDataGap;

#endif
