// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/DAT/src/CMN_DAT_Evenement.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ---------------------------------------------------------------------------
//@ Composant : CMN
//@ Sous-composant : CMN_DAT
//@ CLASSE : CMN_DAT_Evenement
//@
//@ Commentaire :
//@    Fichier d'entete de la classe CMN_DAT_Evenement
//@                                                                     
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Adaptation a l'OPS : ajout des parametres JDB
//@ ---------------------------------------------------------------------------
//@ VERSION : 26/07/1999 : GRT
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

#ifndef CMN_DAT_Evenement_h
#define CMN_DAT_Evenement_h


//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Date.h"
#include "SD__Message.h"
#include "CMN_DAT_Objet.h"


class CMN_DAT_Evenement: public CMN_DAT_Objet {

    /*================================================================*/

 public:

    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    CMN_DAT_Evenement();
    CMN_DAT_Evenement(CMN_DAT_Evenement& Evenement);

    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    ~CMN_DAT_Evenement();

    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    CMN__Date& DateEvenement() {return m_DateEvenement;}

    void TypeEvenement(SD__Message::e_TypeMessageJDB unTypeEvenement) 
        {m_TypeEvenement = unTypeEvenement;}
    SD__Message::e_TypeMessageJDB TypeEvenement()
        {return m_TypeEvenement;}

    void Fonction(t_Chaine uneFonction) {m_Fonction = uneFonction;}
    t_Chaine Fonction() {return m_Fonction;}

    void Libelle(t_Chaine unLibelle) {m_Libelle = unLibelle;}
    t_Chaine Libelle() {return m_Libelle;}

    void Prm1(t_Chaine unLibelle) {m_Prm1 = unLibelle;}
    t_Chaine Prm1() {return m_Prm1;}

    void Prm2(t_Chaine unLibelle) {m_Prm2 = unLibelle;}
    t_Chaine Prm2() {return m_Prm2;}

    void Prm3(t_Chaine unLibelle) {m_Prm3 = unLibelle;}
    t_Chaine Prm3() {return m_Prm3;}


    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////

    // Genere une section pour l'evenement dans le fichier de
    // configuration
    virtual void Synthetiser(CMN__Configuration& Config);

    // Analyse une section du fichier de configuration pour remplir 
    //l'evenement
    virtual void Analyser(CMN__Configuration& Config,
                          t_Chaine sNomEvenement);

    // Operateur =
    virtual CMN_DAT_Evenement& operator =(CMN_DAT_Evenement&
                                          uneEvenement);


    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////


    /*================================================================*/

 private:

    ////////////////////////////////
    // Constantes
    ////////////////////////////////
    static const t_Chaine CHAMP_DATE;
    static const t_Chaine CHAMP_TYPE_EVENEMENT;
    static const t_Chaine CHAMP_FONCTION;
    static const t_Chaine CHAMP_LIBELLE;

    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////

    // Date de generation de l'evenement
    CMN__Date                     m_DateEvenement;

    // Type de l'evenement survenu
    SD__Message::e_TypeMessageJDB m_TypeEvenement;

    // Fonction
    t_Chaine                      m_Fonction;

    // Libelle de l'evenement
    t_Chaine                      m_Libelle;

    // Parametres pour le journal de bord
    t_Chaine                      m_Prm1;
    t_Chaine                      m_Prm2;
    t_Chaine                      m_Prm3;
};

#endif
