// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/DAT/src/CMN_DAT_GeneratedFile.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ---------------------------------------------------------------------------
//@ Composant : CMN
//@ Sous-composant : CMN_DAT
//@ CLASSE : CMN_DAT_GeneratedFile
//@
//@ Commentaire :
//@    Fichier d'entete de la classe CMN_DAT_GeneratedFile, qui stocke
//@    les informations liees a un fichier genere
//@                                                                     
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 06/01/2003 : P. CABANE
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-2100-CR-290-CN : VERSION : 31/03/2006 : B. GUENDE
//@ Degraded cases counters added as a private member.
//@ See IA-2100-CR-290-THA
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

#ifndef CMN_DAT_GeneratedFile_h
#define CMN_DAT_GeneratedFile_h

//
// Fichiers include
//

// STL
#include <list>

// Standard

// Projet
#include "CMN__Commun.h"
#include "CMN__Date.h"
#include "CMN_DAT_DataGap.h"


class CMN_DAT_GeneratedFile {

    /*================================================================*/
    
 public:

    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    CMN_DAT_GeneratedFile();
        
    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    ~CMN_DAT_GeneratedFile();

    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    void FileName(t_Chaine fileName) {m_FileName = fileName;};
    t_Chaine FileName() {return m_FileName;};

    t_CMN__Booleen MdrDefined() {return m_MdrDefined;};

    void MdrOk(unsigned long valeur);
    t_Chaine MdrOk() {return m_MdrOk;};

    void MdrDegraded(unsigned long valeur);
    t_Chaine MdrDegraded() {return m_MdrDegraded;};

    void AjouterDataGap(t_DataGap& dataGap);
    t_ListeDataGap& ListeDataGap() {return m_ListeDataGap;};
/* CR290 */
    void AjouterCasDeg(bool * listCG);
    t_Chaine GetNbCas(int noCas);
    void SetNbCas(int noCas, unsigned long valeur);
/* Fin CR290 */

    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    void Afficher();

    
    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////
    

    /*================================================================*/

 private:

    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
    t_Chaine       m_FileName;
    t_CMN__Booleen m_MdrDefined;
    unsigned long  m_MdrOk;
    unsigned long  m_MdrDegraded;
    t_ListeDataGap m_ListeDataGap;
/* CR290 */    
    unsigned long m_ListeCasDeg[CMN__NB_CGXX];
/* Fin CR290 */ 
};

// Type GeneratedFile
typedef CMN_DAT_GeneratedFile       t_GeneratedFile;

// Liste de GeneratedFile
typedef list<CMN_DAT_GeneratedFile> t_ListeGeneratedFile;

#endif
