// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/DAT/src/CMN_DAT_ListeObjets.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ---------------------------------------------------------------------------
//@ Composant : CMN
//@ Sous-composant : CMN_DAT
//@ CLASSE : CMN_DAT_ListeObjets
//@
//@ Commentaire :
//@    Fichier d'entete de la classe CMN_DAT_ListeObjets
//@                                                                     
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ SMM-M4-FA-2413-CN   30/10/01 GRT Rajout de la methode SauverListeTriee
//@ ---------------------------------------------------------------------------
//@ VERSION : 23/07/1999 : GRT
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

#ifndef CMN_DAT_ListeObjets_h
#define CMN_DAT_ListeObjets_h


//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Config.h"


class CMN_DAT_Objet;

class CMN_DAT_ListeObjets {

    /*================================================================*/

 public:
    
    ///////////////////////
    // Constructeur
    ///////////////////////
    CMN_DAT_ListeObjets();
        
    ///////////////////////
    // Destructeur
    ///////////////////////
    ~CMN_DAT_ListeObjets();


    ///////////////////////
    // Accesseurs
    ///////////////////////

    ///////////////////////
    // Methodes publiques
    ///////////////////////

    // Charge la liste a partir d'un fichier
    t_CMN__Statut ChargerListe(t_Chaine NomFichier);

    // Sauve la liste dans un fichier
    t_CMN__Statut SauverListe(t_Chaine NomFichier);

    // Retourne le contenu de la liste sous forme de chaine
    t_Chaine Contenu();
        
    // Nombre d'elements dans la liste des objets
    int CompterElements();
        
    // Recupere le nom d'un element en fonction de sa position
    t_CMN__Statut LireIdentifiantElement(int nPosition,
                                         t_Chaine& Identifiant);

    // Lit un element de la liste a partir de sa position
    t_CMN__Statut LireElement(int nPosition, CMN_DAT_Objet& Objet);
        
    // Rechercher d'un element dans la liste a partir de son nom et
    // retourne sa position
    int RechercherElement(t_Chaine  sIdentifiant);
        
    // Ajoute un objet dans la liste, , retourne sa position
    void AjouterElement(CMN_DAT_Objet& Objet);
        
    // Supprime un objet de la liste a partir de sa position
    t_CMN__Statut SupprimerElement(int nPosition);

    void operator =(CMN_DAT_ListeObjets& ListeObjets);


    /*================================================================*/

 protected:
    
    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////
    
    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////
    
    
    /*================================================================*/

 private:

    ///////////////////////
    // Methodes privees
    ///////////////////////
    
    ///////////////////////
    // Attributs prives
    ///////////////////////
    CMN__Configuration m_Config;
};

#endif
