// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/DAT/src/CMN_DAT_ModeleAction.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ---------------------------------------------------------------------------
//@ Composant : CMN
//@ Sous-composant : CMN_DAT
//@ CLASSE : CMN_DAT_ModeleAction
//@
//@ Commentaire :
//@    Fichier d'entete de la classe CMN_DAT_ModeleAction
//@                                                                     
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

#ifndef CMN_DAT_ModeleAction_h
#define CMN_DAT_ModeleAction_h


//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Config.h"
#include "CMN_DAT_Objet.h"


class CMN_DAT_ModeleAction : public CMN_DAT_Objet {

    /*================================================================*/

 public:

    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    CMN_DAT_ModeleAction();
    CMN_DAT_ModeleAction(CMN_DAT_ModeleAction& unModeleAction);

    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    ~CMN_DAT_ModeleAction();

    
    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////

    // Recupere le temps de simulation
    int Simulation() {return m_Simulation;}


    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////

    // Analyse une section du fichier de configuration pour remplir le 
    // modele d'actions
    virtual void Analyser(CMN__Configuration& Config,
                          t_Chaine sIdentifiantElement);

    // Operateur =
    CMN_DAT_ModeleAction& operator =(CMN_DAT_ModeleAction&
                                     unModeleAction);


    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////
 

    /*================================================================*/

 private:

    //
    // Constantes
    //
    static const t_Chaine CHAMP_SIMULATION;


    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
    int m_Simulation;
};

#endif
