// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/DAT/src/CMN_DAT_ModeleTache.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ---------------------------------------------------------------------------
//@ Composant : CMN
//@ Sous-composant : CMN_DAT
//@ CLASSE : CMN_DAT_ModeleTache
//@
//@ Commentaire :
//@    Ce module gere la classe CMN_DAT_ModeleTache, qui permet de 
//@    stocker l'ensemble des taches
//@                                                                     
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Adaptation a l'OPS : ajout des parametres de simulation
//@ ---------------------------------------------------------------------------
//@ VERSION : 22/07/1999 : GRT
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

#ifndef CMN_DAT_ModeleTache_h
#define CMN_DAT_ModeleTache_h


//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Chaine.h"
#include "CMN__Config.h"
#include "CMN_DAT_Objet.h"


class CMN_DAT_ModeleTache : public CMN_DAT_Objet {

    /*================================================================*/

 public:

    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    CMN_DAT_ModeleTache();
    CMN_DAT_ModeleTache(CMN_DAT_ModeleTache& unModeleTache);

    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    ~CMN_DAT_ModeleTache();
    
    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////

    // Recupere le temps de simulation
    int Simulation() {return m_Simulation;}

    // Recupere le nombre d'actions
    int NombreActions() {return m_NombreActions;}

    // Retourne une action a partir de son numero
    t_Chaine Action(int NoAction);


    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////

    // Analyse une section du fichier de configuration pour remplir le 
    // modele de taches
    virtual void Analyser(CMN__Configuration& Config,
                          t_Chaine sIdentifiantElement);

    // Operateur =
    CMN_DAT_ModeleTache& operator =(CMN_DAT_ModeleTache& unModeleTache);


    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////
    
    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////


    /*================================================================*/

 private:

    //
    // Constantes
    //
    static const t_Chaine CHAMP_SIMULATION;
    static const t_Chaine CHAMP_ACTION;
    static const t_Chaine CHAMP_NOMBRE_ACTIONS;


    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
    int           m_Simulation;
    int           m_NombreActions;
    t_ListeChaine m_ListeActions;
};

#endif
