// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/DAT/src/CMN_DAT_ModeleTraitement.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ---------------------------------------------------------------------------
//@ Composant : CMN
//@ Sous-composant : CMN_DAT
//@ CLASSE : CMN_DAT_ModeleTraitement
//@
//@ Commentaire :
//@    Fichier d'entete de la classe CMN_DAT_ModeleTraitement
//@                                                                     
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

#ifndef CMN_DAT_ModeleTraitement_h
#define CMN_DAT_ModeleTraitement_h


//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Config.h"
#include "CMN_DAT_Objet.h"


class CMN_DAT_ModeleTraitement : public CMN_DAT_Objet {

    /*================================================================*/

 public:

    //
    // Constantes
    //
    static const t_Chaine TYPE_TACHE_AUCUN;
    static const t_Chaine TYPE_TACHE_RDV;
    static const t_Chaine TYPE_TACHE_LIGNE;


    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    CMN_DAT_ModeleTraitement();
    CMN_DAT_ModeleTraitement(CMN_DAT_ModeleTraitement&
                             unModeleTraitement);

    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    ~CMN_DAT_ModeleTraitement();

    
    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    
    // Recupere le nombre de taches
    int NombreTaches() {return m_NombreTaches;}
    
    // Retourne une tache a partir de son numero
    t_Chaine Tache(int NoTache);

    // Retourne le type de la tache a partir de son numero
    t_Chaine TypeTache(int NoTache);

    
    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
        
    // Analyse une section du fichier de configuration pour remplir le
    // modele de traitements
    virtual void Analyser(CMN__Configuration& Config,
                          t_Chaine sIdentifiantElement);
    
    // Operateur =
    CMN_DAT_ModeleTraitement& operator =(CMN_DAT_ModeleTraitement&
                                         unModeleTraitement);
    
    
    /*================================================================*/
    
 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////
    
    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////


    /*================================================================*/

 private:

    //
    // Constantes
    //
    static const t_Chaine CHAMP_TACHE;
    static const t_Chaine CHAMP_TYPE_TACHE;
    static const t_Chaine CHAMP_NOMBRE_TACHES;


    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
    int           m_NombreTaches;
    t_ListeChaine m_ListeTaches;
    t_ListeChaine m_TypeTaches;
};

#endif
