// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/DAT/src/CMN_DAT_StageInfo.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ---------------------------------------------------------------------------
//@ Composant : CMN
//@ Sous-composant : CMN_DAT
//@ CLASSE : CMN_DAT_StageInfo
//@
//@ Commentaire :
//@    Fichier d'entete de la classe CMN_DAT_StageInfo, qui stocke les 
//@    informations liees a un Work Order
//@                                                                     
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

#ifndef CMN_DAT_StageInfo_h
#define CMN_DAT_StageInfo_h

//
// Fichiers include
//

// STL
#include <list>

// Standard

// Projet
#include "CMN__Commun.h"
#include "CMN__Date.h"
#include "CMN_DAT_GeneratedFile.h"


class CMN_DAT_StageInfo {

    /*================================================================*/
    
 public:
    
    ////////////////////////////////
    // Constantes
    ////////////////////////////////
    static const unsigned int LENGTH_STAGE_NAME;
    static const unsigned int LENGTH_LOG_MESSAGE;
    static const unsigned int LENGTH_TIME;
    static const t_Chaine     FORMAT_TIME;


    ////////////////////////////////
    // Types
    ////////////////////////////////


    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    CMN_DAT_StageInfo();
        
    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    ~CMN_DAT_StageInfo();

    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    void StageName(t_Chaine stageName);
    t_Chaine StageName() {return m_StageName;};

    void AjouterUsedFileName(t_Chaine file) 
        {m_ListeUsedFileName.push_back(file);};
    t_ListeChaine& ListeUsedFileName() 
        {return m_ListeUsedFileName;};

    void AjouterGeneratedFile(t_GeneratedFile& generatedFile);
    t_ListeGeneratedFile& ListeGeneratedFile() 
        {return m_ListeGeneratedFile;};

    void MHSTelemetry(t_Chaine telemetry) 
        {m_MHSTelemetry = telemetry;};
    t_Chaine MHSTelemetry() {return m_MHSTelemetry;};

    void ProcessingStart(t_Date processingStart)
        {m_ProcessingStart = processingStart.DateUTC(CMN__VRAI,
                                                     CMN__VRAI);};
    t_Chaine ProcessingStart() {return m_ProcessingStart;};

    void ProcessingStop(t_Date processingStop)
        {m_ProcessingStop = processingStop.DateUTC(CMN__VRAI,
                                                   CMN__VRAI);};
    t_Chaine ProcessingStop() {return m_ProcessingStop;};

    void ElapsedTime(double valeur);
    t_Chaine ElapsedTime() {return m_ElapsedTime;};

    void UserTime(double valeur);
    t_Chaine UserTime() {return m_UserTime;};

    void LogMessage(t_Chaine LogMessage);
    t_Chaine LogMessage() {return m_LogMessage;};


    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    void Afficher();

    
    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////
    

    /*================================================================*/

 private:

    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
    t_Chaine             m_StageName;
    t_ListeChaine        m_ListeUsedFileName;
    t_ListeGeneratedFile m_ListeGeneratedFile;
    t_Chaine             m_MHSTelemetry;

    // Processing info
    t_Chaine             m_ProcessingStart;
    t_Chaine             m_ProcessingStop;
    t_Chaine             m_ElapsedTime;
    t_Chaine             m_UserTime;

    // Message info
    t_Chaine             m_LogMessage;
};

// Liste de StageInfo
typedef list<CMN_DAT_StageInfo> t_ListeStageInfo;

#endif
