// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/DAT/src/CMN_DAT_WorkOrder.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ---------------------------------------------------------------------------
//@ Composant : CMN
//@ Sous-composant : CMN_DAT
//@ CLASSE : CMN_DAT_WorkOrder
//@
//@ Commentaire :
//@    Fichier d'entete de la classe CMN_DAT_WorkOrder, qui stocke les 
//@    informations liees a un Work Order
//@                                                                     
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

#ifndef CMN_DAT_WorkOrder_h
#define CMN_DAT_WorkOrder_h

//
// Fichiers include
//

// STL
#include <list>

// Standard

// Projet
#include "CMN__Commun.h"
#include "CMN__Date.h"
#include "CMN__StageTM.h"


class CMN_DAT_WorkOrder {

    /*================================================================*/
    
 public:
    
    // 
    // Constantes
    //
    static const t_Chaine WORK_ORDER_TYPE_FIRST;
    static const t_Chaine WORK_ORDER_TYPE_MIDDLE;
    static const t_Chaine WORK_ORDER_TYPE_LAST;
    static const t_Chaine WORK_ORDER_TYPE_FULL;


    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    CMN_DAT_WorkOrder();
        
    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    virtual ~CMN_DAT_WorkOrder();

    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    t_CMN__Statut ProcessingType(t_Chaine type);
    void ProcessingType(CMN__StageTM::e_CMN__StageId processingType) 
        {m_ProcessingType = processingType;};
    CMN__StageTM::e_CMN__StageId ProcessingType()
        {return m_ProcessingType;};

    t_CMN__Statut SensingStart(t_Chaine sensingDate) 
        {return m_SensingStart.TransformeDate(sensingDate);};
    t_Date SensingStart() {return m_SensingStart;};

    t_CMN__Statut SensingStop(t_Chaine sensingDate)
        {return m_SensingStop.TransformeDate(sensingDate);};
    t_Date SensingStop() {return m_SensingStop;};

    void TimeIntervalFlag(t_Chaine timeIntervalFlag) 
        {m_TimeIntervalFlag = timeIntervalFlag; 
        m_TimeIntervalFlag.Upper();};
    t_Chaine TimeIntervalFlag() {return m_TimeIntervalFlag;};

    void TimeIntervalCounter(long timeIntervalCounter)
        {m_TimeIntervalCounter = timeIntervalCounter;};
    long TimeIntervalCounter() {return m_TimeIntervalCounter;};

    void AjouterUnprocData(t_Chaine data) 
        {m_ListeUnprocData.push_back(data);};
    t_ListeChaine& ListeUnprocData()    {return m_ListeUnprocData;};

    void AjouterAuxData(t_Chaine auxData) 
        {m_ListeAuxData.push_back(auxData);};
    t_ListeChaine& ListeAuxData() {return m_ListeAuxData;};

    void AjouterProdModel(t_Chaine model) 
        {m_ListeProdModel.push_back(model);};
    t_ListeChaine& ListeProdModel() {return m_ListeProdModel;};
  

    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    void Afficher();

    
    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////
    

    /*================================================================*/

 private:

    //
    // Constantes
    //
    static const t_Chaine TIME_FLAG_NOT_DEFINED;

        
    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
    CMN__StageTM::e_CMN__StageId m_ProcessingType;
    t_Date                       m_SensingStart;
    t_Date                       m_SensingStop;
    t_Chaine                     m_TimeIntervalFlag;
    long                         m_TimeIntervalCounter;
    t_ListeChaine                m_ListeUnprocData;
    t_ListeChaine                m_ListeAuxData;
    t_ListeChaine                m_ListeProdModel;
};

#endif
