static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/OBS/src/CMN_OBS_Sujet.cc,v 1.3 2011/11/25 10:17:39 dpauly Exp $";
//@ ---------------------------------------------------------------------------
//@ Composant : CMN
//@ Sous-composant : CMN_OBS
//@ CLASSE : CMN_OBS_Sujet
//@ 
//@ Commentaire :
//@    Ce module gere la classe CMN_OBS_Sujet
//@                                     
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 23/07/1999 : GRT
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

//
// Fichiers include
//

// STL
#include <iostream>

// Standard

// Projet
#include "CMN_OBS_Observateur.h"
#include "CMN_OBS_Sujet.h"


//======================================================================
//                                      METHODES PUBLIQUES
//======================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : CMN_OBS_Sujet
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               Aucun
//@                  
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
CMN_OBS_Sujet::CMN_OBS_Sujet()
{
  m_Observateur = NULL;
}


//@ ------------------------------------------------------------------*/
//@ Methode : ~CMN_OBS_Sujet
//@
//@ Description : Destructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
CMN_OBS_Sujet::~CMN_OBS_Sujet()
{
}


//@ ------------------------------------------------------------------*/
//@ Methode : Attacher
//@
//@ Description : Associe un observateur au sujet
//@
//@ Parametres :
//@               (ENTREE) Observateur : Observateur a attacher
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void CMN_OBS_Sujet::Attacher(CMN_OBS_Observateur *Observateur)
{
  m_Observateur = Observateur;
}


//@ ------------------------------------------------------------------*/
//@ Methode : Detacher
//@
//@ Description : Detache un observateur du sujet
//@
//@ Parametres :
//@               (ENTREE) Observateur : Observateur a detacher
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void CMN_OBS_Sujet::Detacher(CMN_OBS_Observateur *Observateur)
{
  m_Observateur = NULL;
}


//@ ------------------------------------------------------------------*/
//@ Methode : Notifie
//@
//@ Description : Notifie les observateurs du sujet
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void CMN_OBS_Sujet::Notifier()
{
  if (m_Observateur != NULL) 
    {
      m_Observateur->MettreAJour(this);
    }
}


//======================================================================
//                                      METHODES PRIVEES
//======================================================================
