static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/PRS/src/CMN_PRS_DumpFormatTarget.cc,v 1.3 2011/11/25 10:17:39 dpauly Exp $";
//@ ---------------------------------------------------------------------------
//@ Composant : CMN
//@ Sous-composant : CMN_PRS
//@ CLASSE : CMN_PRS_DumpFormatTarget
//@
//@ Commentaire :
//@    Ce fichier gere la classe CMN_PRS_DumpFormatTarget, utiliese
//@    pour rediriger les lignes XML en sortie dans un fichier
//@
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 28/11/2002 : P. CABANE
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-144-CN : 21/09/2004 : B. MASSART
//@ Problemes lors du portage d'OPS vers Solaris par Meteo France
//@ Voir IA-2100-FC-144-THA.
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

/* FA144 : suppression define __MINMAX_DEFINED, residu BORLAND */

//
// Fichiers include
//

// STL
#include <iostream>

// Standard

// Projet
#include "CMN_PRS_DumpFormatTarget.h"


//=====================================================================
//                        METHODES PUBLIQUES
//=====================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : CMN_PRS_DumpFormatTarget
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
CMN_PRS_DumpFormatTarget::CMN_PRS_DumpFormatTarget()
{
}


//@ ------------------------------------------------------------------*/
//@ Methode : CMN_PRS_DumpFormatTarget
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               (ENTREE) filename : Nom du fichier de sortie
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
CMN_PRS_DumpFormatTarget::CMN_PRS_DumpFormatTarget(string filename)
{
  //@ SI un nom de fichier a ete defini
  if (! filename.empty())
    {
      //@ Ouvrir en ecriture ce fichier (fichier tronque)
      m_File.open(filename.c_str(), ios::out | ios::trunc);
    }
  //@ FIN SI un nom de fichier a ete defini
}


//@ ------------------------------------------------------------------*/
//@ Methode : ~CMN_PRS_DumpFormatTarget
//@
//@ Description : Destructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
CMN_PRS_DumpFormatTarget::~CMN_PRS_DumpFormatTarget()
{
  //@ SI un fichier de sortie a ete ouvert
  if (m_File.is_open())
    {
      //@ Le fermer
      m_File.close();
    }
  //@ FIN SI un fichier de sortie a ete ouvert
}


//@ ------------------------------------------------------------------*/
//@ Methode : writeChars
//@
//@ Description : Ecrit dans le fichier de sortie
//@
//@ Parametres :
//@               (ENTREE) toWrite
//@               (ENTREE) count
//@               (ENTREE) formatter
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void CMN_PRS_DumpFormatTarget::writeChars(const XMLByte* const toWrite,
                                          const unsigned int count,
                                          XMLFormatter* const formatter)
{
  //@ SI un fichier de sortie a ete ouvert
  if (m_File.is_open())
    {
      //@ Ecrire dans le fichier
      m_File.write((char *) toWrite, (int) count);
    }
  //@ SINON
  else
    {
      //@ Ecrire sur la sortie standard
      cout.write((char *) toWrite, (int) count);
    }
  //@ FIN SI un fichier de sortie a ete ouvert
}


//======================================================================
//                                      METHODES PRIVEES
//======================================================================
