static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/PRS/src/CMN_PRS_ErrorReporter.cc,v 1.3 2011/11/25 10:17:39 dpauly Exp $";
//@ ---------------------------------------------------------------------------
//@ Composant : CMN
//@ CLASSE : CMN_PRS_ErrorReporter
//@
//@ Commentaire :
//@    Ce fichier contient la classe CMN_PRS_ErrorReporter, qui gere
//@    les erreurs de parsing
//@
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-144-CN : 21/09/2004 : B. MASSART
//@ Problemes lors du portage d'OPS vers Solaris par Meteo France
//@ Voir IA-2100-FC-144-THA.
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

/* FA144 : suppression define __MINMAX_DEFINED, residu BORLAND */

//
// Fichiers include
//

// STL
#include <iostream>
#include <string>
#include <fstream>

using namespace std;

// Standard

// Xerces
#include <xercesc/sax/SAXParseException.hpp>
#include <xercesc/dom/DOMString.hpp>

// Projet
#include "CMN_PRS_ErrorReporter.h"


// Operateur defini dans CMN_PRS_Parser.cc
extern ostream& operator<<(ostream& target, const DOMString& s);


//=====================================================================
//                        METHODES PUBLIQUES
//=====================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : CMN_PRS_ErrorReporter
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
CMN_PRS_ErrorReporter::CMN_PRS_ErrorReporter() : m_SawErrors(false)
{
}


//@ ------------------------------------------------------------------*/
//@ Methode : ~CMN_PRS_ErrorReporter
//@
//@ Description : Destructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
CMN_PRS_ErrorReporter::~CMN_PRS_ErrorReporter()
{
}


//@ ------------------------------------------------------------------*/
//@ Methode : warning
//@
//@ Description : Gestion des warnings
//@
//@ Parametres :
//@               (ENTREE) toCatch
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void CMN_PRS_ErrorReporter::warning(const SAXParseException& toCatch)
{
  //@ Ignorer tous les warnings
}


//@ ------------------------------------------------------------------*/
//@ Methode : error
//@
//@ Description : Affiche une erreur
//@
//@ Parametres :
//@               (ENTREE) toCatch
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void CMN_PRS_ErrorReporter::error(const SAXParseException& toCatch)
{
  m_SawErrors = true;

  //@ Re-emission de l'exception
  throw(toCatch);
}


//@ ------------------------------------------------------------------*/
//@ Methode : fatalError
//@
//@ Description : Affiche une erreur fatale
//@
//@ Parametres :
//@               (ENTREE) toCatch
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void CMN_PRS_ErrorReporter::fatalError(const SAXParseException& toCatch)
{
  m_SawErrors = true;

  //@ Re-emission de l'exception
  throw(toCatch);
}


//@ ------------------------------------------------------------------*/
//@ Methode : resetErrors
//@
//@ Description : Reinitialise les erreurs
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void CMN_PRS_ErrorReporter::resetErrors()
{
}


//======================================================================
//                                      METHODES PRIVEES
//======================================================================
