// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/PRS/src/CMN_PRS_ErrorReporter.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ---------------------------------------------------------------------------
//@ Composant : CMN
//@ CLASSE : CMN_PRS_ErrorReporter
//@
//@ Commentaire :
//@    Fichier d'interface de la classe CMN_PRS_ErrorReporter, qui gere
//@    les erreurs de parsing
//@
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

#ifndef CMN_PRS_ErrorReporter_h
#define CMN_PRS_ErrorReporter_h

//
// Fichiers include
//

// STL

// Standard

// Xerces
#include <xercesc/util/XercesDefs.hpp>
#include <xercesc/sax/ErrorHandler.hpp>


class CMN_PRS_ErrorReporter : public ErrorHandler {
    
    /*================================================================*/
    
 public:
    
    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    CMN_PRS_ErrorReporter();

    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    virtual ~CMN_PRS_ErrorReporter();

    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    bool getSawErrors() const {return m_SawErrors;};

    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    
    // Mise en oeuvre de l'interface error handler 
    void warning(const SAXParseException& toCatch);
    void error(const SAXParseException& toCatch);
    void fatalError(const SAXParseException& toCatch);
    void resetErrors();

    
    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////
    

    /*================================================================*/

 private:
 
    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////

    // Indicateur de levee d'erreurs
    bool m_SawErrors;
};

#endif
