// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/PRS/src/CMN_PRS_RedirectHandler.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ---------------------------------------------------------------------------
//@ Composant : CMN
//@ CLASSE : CMN_PRS_RedirectHandler
//@
//@ Commentaire :
//@    Fichier d'interface de la classe CMN_PRS_RedirectHandler, qui
//@    gere le changement de fichier DTD
//@
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 22/01/2003 : P. CABANE
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

#ifndef CMN_PRS_RedirectHandler_h
#define CMN_PRS_RedirectHandler_h

//
// Fichiers include
//

// STL

// Standard

// Xerces
#include <xercesc/sax/HandlerBase.hpp>

// Projet
#include "CMN__Commun.h"
#include "CMN__Chaine.h"


class AttributeList;

class CMN_PRS_RedirectHandler : public HandlerBase {
    
    /*================================================================*/
    
 public:
    
    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    CMN_PRS_RedirectHandler();

    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    virtual ~CMN_PRS_RedirectHandler();

    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    unsigned int GetElementCount() {return m_ElementCount;}
    unsigned int GetAttrCount() {return m_AttrCount;}
    unsigned int GetCharacterCount() {return m_CharacterCount;}
    unsigned int GetSpaceCount() {return m_SpaceCount;}


    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    
    // Mise en oeuvre de l'interface error handler
    void startElement(const XMLCh* const name, AttributeList& attributes);
    void characters(const XMLCh* const chars, const unsigned int length);
    void ignorableWhitespace(const XMLCh* const chars, 
                             const unsigned int length);
    void resetDocument();
   
    // Surcharge de l'interface SAX ErrorHandler
    void warning(const SAXParseException& toCatch);
    void error(const SAXParseException& toCatch);
    void fatalError(const SAXParseException& toCatch);
    void resetErrors();

    // Handler pour l'interface SAX EntityResolver
    InputSource* resolveEntity(const XMLCh* const publicId,
                               const XMLCh* const systemId);


    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////
    

    /*================================================================*/

 private:

    //
    // Constante
    //
    static const t_Chaine EXTENSION_DTD;
    static const t_Chaine SEP_EXTENSION;
 
    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////
    t_CMN__Booleen EstDeTypeDTD(const t_Chaine& nomFichier);

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
    unsigned int m_AttrCount;
    unsigned int m_CharacterCount;
    unsigned int m_ElementCount;
    unsigned int m_SpaceCount;

    // Indicateur de levee d'erreurs
    bool         m_SawErrors;

    // Repertoire pour la redicection des fichiers DTD
    t_Chaine     m_ConfDir;
};

#endif
