// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/CFG__Configuration.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : CMN
//@ CLASSE : CFG__Configuration
//@
//@ Commentaire :
//@    Fichier d'entete de la classe CFG__Configuration
//@							
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 18/04/2000 : C.LACAZE
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef CFG__Configuration_h
#define CFG__Configuration_h

#include "CMN__Chaine.h"
#include "CFG__Configuration.h"

class CFG__Configuration {

/*====================================================================*/

public:

	//
	// Constantes
	//
	static const char *CFG__PREFIXE_REPERTOIRE;

	//
	// Constructeur
	//
	CFG__Configuration();

	//
	// Destructeur
	//
	~CFG__Configuration();

	//
	// Accesseurs
	//

	//
	// Methodes publiques
	//
	static t_Chaine GetFichier (const t_Chaine& fichier);
	static t_Chaine GetRepertoire (const t_Chaine& repertoire);
	static double GetNumerique (const t_Chaine& numerique);
	static t_Chaine GetAdresse (const t_Chaine& adresse );
	static t_ListeChaineTriee GetListeAdresse (const t_Chaine& adresses);
	static t_ListeChaine      GetListeChaine (const t_Chaine& chaine);
	static t_Chaine           GetChaine (const t_Chaine& chaine);

	/*====================================================================*/
protected:
	//
	// Methodes protegees
	//

	//
	// Attributs proteges
	//

	/*====================================================================*/
private:
	//
	// Constantes
	//
	static const char *CFG__PREFIXE_FICHIER;
	static const char *CFG__PREFIXE_NUMERIQUE;
	static const char *CFG__PREFIXE_ADRESSE;
	static const char *CFG__PREFIXE_LISTE_ADRESSE;
	static const char *CFG__PREFIXE_LISTE_CHAINE;
	static const char *CFG__PREFIXE_CHAINE;
	static const char CFG__SEPARATOR;

	//
	// Methodes privees
	//
	static t_Chaine GetValeurEnvironnement (const t_Chaine& variable);

	//
	// Attributs prives
	//
};

#endif
