// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/CMN__CGSCst.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : CMN
//@ CLASSE : CMN__CGSCst
//@
//@ Commentaire :
//@    Ce fichier regroupe les constantes utilisees pour echanger 
//@    des informations avec le CGS et l'OPS.
//@    
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 08/07/2002 : P. BRANET
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ VERSION : 16/12/2002 : PBR
//@ FA-ID : IA-2100-FA-3-CN : 12/12/2002 : PBR :
//@ In case of unknown service (at OPS start up), the default service 
//@ name is set to "MO1" (see CMN_CGS_SERVICES constant)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-2100-CR-292-CNE : 10/03/2006 : B.MASSART
//@ The PROCESSING_STATE field of HKTM messages is now an integer (1 means OK
//@ and 2 means FAILURE). See IA-2100-CR-292-THA.
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-3251 : 29/05/2017 : M. LANDIECH
//@ Ajout du nom court du process SD
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef CMN__CGSCst_h
#define CMN__CGSCst_h
//
//  Include Files
//
#include "CMN__Chaine.h"


#define CMN_OPS_MODE_NOMINAL "N"
#define CMN_OPS_MODE_DEBUG "I"

//
// EXPORTED TYPES & DATA
//

// CONSTANTES GENERALES
//  
static const int CMN_OPS_FACILITY_LEN = 3;
static const int CMN_OPS_LOCATION_LEN = 3;
static const char CMN_OPS_FACILITY_NAME [CMN_OPS_FACILITY_LEN]="I1";
static const char CMN_OPS_LOCATION [CMN_OPS_LOCATION_LEN]="GS";


// Enumere des produits genere par l'OPS
typedef enum {
           NO_PRODUCT = 0,
	   L1A        = 1,
	   L1B        = 2,
	   L1C        = 3,
	   ENGIN_DATA = 4,
           VERIF_DATA = 5,
           REPORT     = 6
	} e_CMN_OPSProducts;

// Enumere des spacecrafts qui collecteur de donnees
typedef enum {
           UNKNOWN_SERVICE = 0,  
	   METOP_1 = 1,
	   METOP_2 = 2,
	   METOP_3 = 3,
	   NOAA_16 = 4,
           NOAA_17 = 5,
           NbrSpacecraft = 6
	} e_CMN_CGSSpacecraft;

// Nom des services est indice par  e_CMN_CGSServices
static const t_Chaine CMN_CGS_SERVICES [] ={"M01","M01", "M02", "M03", "N16", "N17"};

// Constantes liees aux COMMANDES
//-------------------------------
// Cmd Group est indice par CMN__Cmd::e_CMN__CommandGroup
static const t_Chaine CMN_PGF_CMD_GROUP [] ={"CMD", "ACK", "STAGE"};

// Cmd Type est indice par CMN__CmdTM::e_CMN__CommandType
static const t_Chaine CMN_PGF_CMD_TYPE [] ={"START", "STEP", "BREAK", "STOP", "SUSPEND", "RESUME"};

// Cmd State est indice par CMN__CmdTM::e_CMN__CommandStatus
static const t_Chaine CMN_PGF_CMD_STATE [] ={"CODED", "COMPLETED", "REJECTED", "ABORTED"};

// Stage TM est indice par CMN__StageTM::e_CMN__StageId InstantaneousQuality
static const t_Chaine CMN_PGF_STAGE_ID [] ={"L1a", "L1b", "L1c"};

// Stage File est indice par CMN__StageTM::e_CMN__StageCategory
static const t_Chaine CMN_PGF_STAGE_FILE [] ={"P", "R", "W", "N"};


// Constantes liees aux HKTM STATUS
//---------------------------------

// HKTM readiness values est indice par MP_HKTMStatus::e_ReadinessStates
static const t_Chaine CMN_HKTM_READINESS[] = {"1", "2", "3", "4"};
 
// HKTM Processing State values est indice par MP_HKTMStatus::e_ReadinessStates
static const t_Chaine CMN_HKTM_PROCESSING_STATE[] = {"1", "2"}; /* CR292 */

// Constantes liees aux Message
//---------------------------------
// Severity du message a envoyer
static const t_Chaine CMN_EVENT_SEVERITY[] = {"I", "W", "A"};

// Nom du processus SD utilise comme variable d'environnement et dans le code
//--------------------
// FT-2765
static const t_Chaine CMN_NOM_PROCESS_SD = "SD_FRW__ServeurDonnees";
// ...FT-2765
// FT-3251
static const t_Chaine CMN_NOM_PROCESS_SD_COURT = "SD";
// ...FT-3251

#endif
