static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/CMN__Cmd.cc,v 1.3 2011/11/25 10:17:39 dpauly Exp $";
//@ --------------------------------------------------------------------
//@ Composant : CMN
//@ CLASSE : CMN__Cmd
//@
//@ Commentaire :
//@    This class manage the PPF-IASI/PGF interfaces. It centralizes
//@    the PGF API access
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 01/07/2002 : PBR
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

//
// Fichiers include
//
#include "CMN__Commun.h"
#include "CMN__CGSCst.h"
#include "CMN__Cmd.h"


//=====================================================================
//                        METHODES PUBLIQUES
//=====================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : SetCommandGroup
//@
//@ Description : This method stores the command group according to
//@               the string given as input parameter
//@
//@ Parametres :
//@               (ENTREE) commandGroup 
//@
//@ Valeur de retour :
//@               t_CMN__Statut : Statut d'execution
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut CMN__Cmd::SetCommandGroup (t_Chaine commandGroup)
{
 int iGroup=0;
 t_CMN__Booleen groupFound = CMN__FAUX;
 
 
 //@ TANT QUE command group non trouve
 while (iGroup<NbrCommandGroup && groupFound==CMN__FAUX)
 {
   //@ Compare type enum to command type given as parameter
   if (commandGroup == CMN_PGF_CMD_GROUP[iGroup])
     {
       m_CommandGroup=(e_CMN__CommandGroup)iGroup;
       groupFound=CMN__VRAI;
     }
   iGroup++;
 }
 //@ FIN TANT QUE

 //@ Compute status execution according to finding result
 if (groupFound==CMN__VRAI)
 {return CMN__STATUT_OK;}
 else
 {return CMN__STATUT_NOK;}
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetCommandGroupStr
//@
//@ Description : Retourne l'attribut commandGroup
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               Command group sous format chaine de caracteres
//@
//@ ------------------------------------------------------------------*/
t_Chaine CMN__Cmd::GetCommandGroupStr ()
{
  return CMN_PGF_CMD_GROUP[m_CommandGroup];
}
