// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/CMN__Cmd.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : CMN
//@ CLASSE : CMN__Cmd
//@
//@ Commentaire :
//@    Cette librairie gere les informations communes a tous les 
//@    type de commande traites par l'OPS (Cmd, CmdTM et StageTM).
//@    
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 08/07/2002 : P. BRANET
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ VERSION : 03/12/2002 : PBR
//@ FA-ID : OPS-I00-013  02/12/2002 :
//@ Etant donne que la constante CMN__OPS_INTERNAL_CMD est utilisee par
//@ plusieurs classes, son stockage est deplace de MP__GestionnaireActivite.h
//@ dans CMN__Cmd.h
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef CMN__Cmd_h
#define CMN__Cmd_h

//
//  Include Files
//
#include "CMN__Commun.h"
#include "CMN__Chaine.h"

//
// EXPORTED TYPES & DATA
//
#define CMN__OPS_INTERNAL_CMD -1
 
// CLASS DEFINITION
//

class CMN__Cmd {

/*====================================================================*/
public:
	
// Type definitions

    typedef enum {
      CMD =0,
      ACK=1,
      STAGE=2,
      NbrCommandGroup=3
    }e_CMN__CommandGroup;

    typedef int t_CMN__CommandId;

// Public Methods
    // Constructeur
	CMN__Cmd() {m_CommandGroup=NbrCommandGroup; m_CommandId=-1;};
	
	// Destructeur
	virtual ~CMN__Cmd() {};

    // Accesseurs

    // CommandGroup
    void SetCommandGroup (e_CMN__CommandGroup commandGroup)
         {m_CommandGroup = commandGroup;};
    t_CMN__Statut SetCommandGroup (t_Chaine commandGroup);

    e_CMN__CommandGroup GetCommandGroup () {return m_CommandGroup;};
    t_Chaine GetCommandGroupStr ();

    // CommandId
    void SetCommandId (t_CMN__CommandId id) {m_CommandId = id;};
    t_CMN__CommandId GetCommandId () {return m_CommandId;};

/*====================================================================*/
protected:


/*====================================================================*/
private:

    // Attributs Prives pour une Command
    e_CMN__CommandGroup       m_CommandGroup;
    t_CMN__CommandId          m_CommandId;

};

#endif
