static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/CMN__CmdTM.cc,v 1.3 2011/11/25 10:17:39 dpauly Exp $";
//@ --------------------------------------------------------------------
//@ Composant : CMN
//@ CLASSE : CMN__CmdTM
//@
//@ Description :
//@    Cette librairie gere un compte rendu d'execution d'une commande
//@    
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 01/07/2002 : PBR
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

//
// Fichiers include
//
#include "CMN__CmdTM.h"
#include "CMN__CGSCst.h"


//=====================================================================
//                        METHODES PUBLIQUES
//=====================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : CMN__CmdTM
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               (ENTREE) commandGroup : Groupe de la commande
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
CMN__CmdTM::CMN__CmdTM(e_CMN__CommandGroup commandGroup) 
{
  //@ Initialiser le type de commande
  this->SetCommandGroup(commandGroup);
  
  //@ Initialiser l'etat de la commande
  this->SetCommandStatus (CODED);  
  
  //@ Initialiser le nom du work order
  this->SetWOFilename("Empty");
}


//@ ------------------------------------------------------------------*/
//@ Methode : SetCommandType
//@
//@ Description : This method stores the command type according to the
//@               string given as input parameter
//@
//@ Parametres :
//@               (ENTREE) commandType
//@
//@ Valeur de retour :
//@               t_CMN__Statut : Statut d'execution
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut CMN__CmdTM::SetCommandType (t_Chaine commandType)
{
 int iType=0;
 t_CMN__Booleen typeFound = CMN__FAUX;


 //@ TANT QUE command type non trouve
 while (iType<NbrCommandType && typeFound==CMN__FAUX)
   {
     //@ Compare type enum to command type given as parameter
     if (commandType == CMN_PGF_CMD_TYPE[iType])
       {
	 m_CommandType=(e_CMN__CommandType)iType;
	 typeFound=CMN__VRAI;
       }
     iType++;		
   }
 //@ FIN TANT QUE
 
 //@ Compute status execution according to finding result
 if (typeFound==CMN__VRAI)
   {return CMN__STATUT_OK;}
 else
   {return CMN__STATUT_NOK;}
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetCommandTypeStr
//@
//@ Description : Retourne l'attribut commandType
//@               
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               Command type sous format chaine de caracteres
//@
//@ ------------------------------------------------------------------*/
t_Chaine CMN__CmdTM::GetCommandTypeStr ()
{
	return CMN_PGF_CMD_TYPE[m_CommandType];
}
