// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/CMN__Commun.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ------------------------------------------------------------------*/
//@ Composant : CMN
//@ MODULE : CMN__COMMUN
//@
//@ Commentaire :
//@    Fichier d'entete du module CMN__Commun
//@ 	definie les types et defines globaux aux services communs
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ Date de creation : 10/03/2000
//@ Auteur           : BBS
//@ --------------------------------------------------------------------
//@ VERSION : 14/12/2000 : C.LACAZE
//@  Portage sous systeme AIX 4.3
//@ --------------------------------------------------------------------
//@ DM-ID : IA-2100-CR-290-CN : VERSION: 30/03/2006 : B. GUENDE
//@  Added CMN__NB_CGXX constant
//@ See IA-2100-CR-290-THA
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef CMN__Commun_h
#define CMN__Commun_h

#include <malloc.h>

//extern "C" {
#include <sys/param.h>
//}
#include "CMN__Trace.h"


//====================================================================*/
// Declaration des define externes
//====================================================================*/

#ifdef __cplusplus
#include <list>
#include <vector>
#include <string>
#include <iostream>

#include "CMN__Chaine.h"

typedef vector<int> t_TableauEntier;
#endif


// typedef de retour d'etat
typedef int t_CMN__Statut;

// typedef booleen
typedef int t_CMN__Booleen;

// longueur des fichiers avec leur path
// FT-2765
static const int CMN__LG_PATH_UNIX = MAXPATHLEN;
// ...FT-2765

// longueur des fichiers sans leur path
// FT-2765
static const int CMN__LG_NOM_UNIX = 100;
// ...FT-2765

// longueur chaine de caracteres de longueur fixe
// FT-2765
static const int  CMN__LG_CHAINE_FIXE = 255;
// ...FT-2765

typedef char t_ChaineFixe[255]; //CMN__LG_CHAINE_FIXE];

typedef char t_FichierUnix[100]; //CMN__LG_NOM_UNIX];

// define des etats generaux
// FT-2765
static const int CMN__STATUT_OK = 0;
static const int CMN__STATUT_NOK = -1;
// ...FT-2765

// FT-2765
static const int CMN__VRAI = 1;
static const int CMN__FAUX = 0;
// ...FT-2765

// FT-2765
static const int CMN__OUI = 1;
static const int CMN__NON = 0;
// ...FT-2765

/* Prise en compte de l'inversion de certains flags CR211 et CR216 */
/* l'ancien booleen utilise etait CMN__VRAI =1 */
// FT-2765
static const int CMN__ERREUR = 0;
// ...FT-2765

#define SLEEP(j) {sleep (j); }

# ifndef MAX
#	define MAX(a,b) ((a>b)?(a):(b))
# endif

# ifndef MIN
#	define MIN(a,b) ((a<b)?(a):(b))
# endif

#ifdef NINT
#undef NINT
#endif
#define NINT(x) ( ((x) > 0.0) ? ((int) ((x) + 0.5)) : ((int) ((x) - 0.5)))

// macros de gestion memoire
#ifndef DEBUG
#define MALLOC(s) malloc(s)
#define REALLOC(a,s) realloc(a,s)
#ifdef FREE
#undef FREE
#endif
#define FREE(a)  if( a != NULL ){ free( a ); a = NULL; }
#define FREECPP(a)  if( a != NULL ){ ::free( a ); a = NULL; }
#else
#define MALLOC(s) CMN__Trace_malloc(s,__FILE__,__LINE__)
#define REALLOC(a,s) CMN__Trace_realloc(a,s,__FILE__,__LINE__)
#ifdef FREE
#undef FREE
#endif
#define FREE(a)  if( a != NULL ){ CMN__Trace_free( a ,__FILE__,__LINE__); a = NULL; }
#define FREECPP(a)  if( a != NULL ){ CMN__Trace_free( a ,__FILE__,__LINE__); a = NULL; }
#endif



// Define des repertoires
#define CONF_DIR       "CONF_DIR"
#define DEBUG_DIR      "DEBUG_DIR"

#ifdef CMN__PI
#undef CMN__PI
#endif
#define CMN__PI         3.1415926535897932

/* CR290 */
#define CMN__NB_CGXX 15
// CMN__NB_CGXX doit etre coherente avec SD_BAS_NB_CGXX
/* Fin CR290 */

//====================================================================*/
// Declaration des fonctions externes
//====================================================================*/

//====================================================================*/
// Declaration des variables externes
//====================================================================*/

#endif
