// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/CMN__PGEServicesAbstract.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : CMN
//@ CLASSE : CMN__PGEServices
//@
//@ Commentaire :
//@    Cette classe virtuelle pure encapsule l'acces aux interfaces
//@    du MCS et PGF via des librairies (MLA) ou des 
//@    developpements specifiques.
//@    Cette solution permet d'implementer le fonctionnement en
//@    standalone.
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 15/11/2002 : PBR
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ VERSION : 22/08/2002 : PBR
//@ FA-ID : OPS-I00-010  18/11/2002 :
//@ Non reception de commandes envoyees quasi-systematiquement
//@ Rajout de la constante MAX_LINE_SIZE
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef CMN__PGEServicesAbstract_h
#define CMN__PGEServicesAbstract_h
//
//  Include Files
//
#include "MLA.h"
#include "CMN__Commun.h"
#include "CMN__OPSProcess.h"

//
// EXPORTED TYPES & DATA
//
#define PGE_STATUS_OK 0

typedef int t_CMN__PGEStatus;

// FT-2765
static const int MAX_LINE_SIZE=4097;
// ...FT-2765

//
// CLASS DEFINITION
//

class CMN__PGEServicesAbstract  
{
/*====================================================================*/
public:
	
// Types


// Pulbic Methods
    // Constructeur
    CMN__PGEServicesAbstract(e_CMN__Processus processUtilisateur=PROCESS_NONE) {};

    // Desctructeur
    virtual ~CMN__PGEServicesAbstract() {};

    // Openning MLA Interface 
    virtual t_CMN__PGEStatus MLAInitialisation (const char * facilityName)=0;

    // Closing MLA interface
    virtual t_CMN__PGEStatus MLATerminate ()=0;

    // Service to send HKTM status
    virtual t_CMN__PGEStatus MLASendFunctionStatus (timeValue* timeEvt,
                                                    tmParam* HKTMparam)=0;

    // Sending OPS log events
    virtual t_CMN__PGEStatus  MLALogEvent (timeValue* timeEvt, 
                                           eventData* event)=0;

    // Sending OPS log events
    virtual t_CMN__PGEStatus MLALogTrace (timeValue* timeTrace, 
                                          logData* trace)=0;

    // Extracting PGF command
    virtual t_CMN__PGEStatus GetPGFCommand (char* command, bool* validCmd)=0;

    // Sending command TM to PGF
    virtual  t_CMN__PGEStatus SendPGFCommandTM (const char* commandTM)=0;

    // Sending Stage TM to PGF
    virtual t_CMN__PGEStatus SendPGFStageTM (const char* stageTM)=0;
/*====================================================================*/
protected:


/*====================================================================*/
private:


};

#endif
