// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/CMN__PGEServicesStub.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : CMN
//@ CLASSE : CMN__PGEServicesStub
//@
//@ Commentaire :
//@    Cette classe implemente dans le cas du fonctionnement en STANDALONE
//@    l'acces aux API du MCS et PGF.
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 10/07/2002 : P. BRANET
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef CMN__PGEServicesStub_h
#define CMN__PGEServicesStub_h
//
//  Include Files
//
#include <fstream>
// FT-2765
#include <sys/time.h>
// ...FT-2765
#include "CMN__PGEServicesAbstract.h"

//
// EXPORTED TYPES & DATA
//

//
// CLASS DEFINITION
//

class CMN__PGEServicesStub : public CMN__PGEServicesAbstract
{
/*====================================================================*/
public:
	
// Pulbic Methods
    // Constructeur
     CMN__PGEServicesStub(e_CMN__Processus processUtilisateur);

    // Desctructeur
     virtual ~CMN__PGEServicesStub();

    // Openning MLA Interface 
     t_CMN__PGEStatus MLAInitialisation (const char * facilityName);

    // Closing MLA interface
     t_CMN__PGEStatus MLATerminate();

    // Service to send HKTM status
     t_CMN__PGEStatus MLASendFunctionStatus (timeValue* timeEvt,
                                             tmParam* HKTMparam);

    // Sending OPS log events
     t_CMN__PGEStatus MLALogEvent (timeValue* timeEvt, eventData* event);

    // Sending OPS log events
     t_CMN__PGEStatus MLALogTrace (timeValue* timeTrace, logData* trace);

    // Extracting PGF command
     t_CMN__PGEStatus GetPGFCommand (char* command, bool* validCmd);

    // Sending command TM to PGF
     t_CMN__PGEStatus SendPGFCommandTM (const char* commandTM);

    // Sending Stage TM to PGF
     t_CMN__PGEStatus SendPGFStageTM (const char* stageTM);
/*====================================================================*/
protected:


/*====================================================================*/
private:
    //@ Masque de reception des commande initialiser avec le stdin
    fd_set m_MasqueRead;  
   
    //@ Timeout sur la reception de commande dans le stdin
    struct timeval m_Timeout;

     // Fichiers d'ecriture des informations transmises au MCS ou au PGF
     ofstream*  m_LogFile;
     ofstream*  m_TraceFile;
     ofstream*  m_CmdFile;
     ofstream*  m_HKTMFile;
};

#endif
