// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/CMN__ResourceMonitor.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : CMN
//@ CLASSE : CMN__ResourceMonitor
//@
//@ Commentaire :
//@    Cette librairie fournit les services pour calculer la 
//@    consommation CPU instantanee en % d'un processus.
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 03/03/2003 : P. BRANET
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef CMN__ResourceMonitor_h
#define CMN__ResourceMonitor_h

//
//  Include Files
//
#include <unistd.h>
#include <time.h>
#include <sys/times.h>
#include <sys/time.h>
#include <sys/resource.h>

class CMN__ResourceMonitor
{
public:

	/* constructor */ 
        CMN__ResourceMonitor();
	// Destructeur
	virtual ~CMN__ResourceMonitor() {};


        // Mesure de la consommation
	void GetResourceValue();

	// Calcul de la consommation en pourcentage de consommation CPU du process courant
        // entre les 2 dernieres mesures
	int instantaneousCPU();


private:
	struct timezone Z; // kept to 0
	// userT1, elapsedT1  are the more recently stamped times, 
	// userT0, elapsedT0  are the just previously stamped times
	double userT0, userT1; // user + system 
	double elapsedT0, elapsedT1; // elapsed time since start of day
};

#endif
