static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/CMN__StageTM.cc,v 1.3 2011/11/25 10:17:39 dpauly Exp $";
//@ --------------------------------------------------------------------
//@ Composant : CMN
//@ CLASSE : CMN__StageTM
//@
//@ Description :
//@    Cette librairie gere les informations liees aux produits
//@    genere sur l'execution d'une commande en provenance du PGF
//@    
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 01/07/2002 : PBR
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

//
// Fichiers include
//
#include "CMN__StageTM.h"
#include "CMN__CGSCst.h"


//=====================================================================
//                        METHODES PUBLIQUES
//=====================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : SetStageId
//@
//@ Description : Cette methode met a jour l'atribut stageId en 
//@               fonction de la chaine passee en parametre
//@
//@ Parametres :
//@               (ENTREE) idStr : stageId
//@
//@ Valeur de retour :
//@               CMN__STATUT_OK si la mise a jour de l'attribut a ete 
//@                 correcte
//@               CMN__STATUT_NOK sinon
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut CMN__StageTM::SetStageId (t_Chaine idStr)
{
 int iStage=0;
 t_CMN__Booleen idFound = CMN__FAUX;
 
 //@ TANT QUE stageId non trouve
 while (iStage<NbrStageId && idFound==CMN__FAUX)
   {
     //@ Compare type enum to id given as parameter
     if (idStr == CMN_PGF_STAGE_ID[iStage])
       {
	 m_StageId=(e_CMN__StageId)iStage;
	 idFound=CMN__VRAI;
       }
     iStage++;
   }
 //@ FIN TANT QUE
 
 //@ Compute status execution according to finding result
 if (idFound==CMN__VRAI)
   {return CMN__STATUT_OK;}
 else
   {return CMN__STATUT_NOK;}
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetStageIdStr
//@
//@ Description : Renvoie l'attribut stageId sous format ASCII
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               Stage id name sous format ASCII
//@
//@ ------------------------------------------------------------------*/
t_Chaine CMN__StageTM::GetStageIdStr ()
{
  return CMN_PGF_STAGE_ID[m_StageId];
}
