// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/CMN__StageTM.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : CMN
//@ CLASSE : CMN__StageTM
//@
//@ Commentaire :
//@    Cette librairie gere les informations liees aux produits
//@    genere sur l'execution d'une commande en provenance du PGF.
//@    
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ VERSION : 08/07/2002 : P. BRANET
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-095-CN : 5/02/2004 : JL.PASCAL
//@ modification du groupe de comande "STAGE" 
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef CMN__StageTM_h
#define CMN__StageTM_h
//
//  Include Files
//
#include "CMN__Commun.h"
#include "CMN__Chaine.h"
#include "CMN__Cmd.h"
//
// EXPORTED TYPES & DATA
//
 
// CLASS DEFINITION
//

class CMN__StageTM:public CMN__Cmd {

/*====================================================================*/
public:
	
// Type definitions


    typedef enum {
          PRODUCT=0,
	  REPORT=1,
	  AUXFILE=2,
	  NO_FILE=3,
          NbrStageCategory=4
	}e_CMN__StageCategory;


    typedef t_Chaine t_CMN__DeliveredFile;

    typedef enum {
          L1a=0,
	  L1b=1,
	  L1c=2,
          NbrStageId=3
	}e_CMN__StageId;

// Public Methods
    // Constructeur
	CMN__StageTM() {this->SetCommandGroup(STAGE);};
	
	// Destructeur
	virtual ~CMN__StageTM() {};

    // Accesseurs

    void SetStageCategory (e_CMN__StageCategory category)
	{m_StageCategory = category;};
    e_CMN__StageCategory GetStageCategory () {return m_StageCategory;};

    void SetStageId (e_CMN__StageId id) {m_StageId = id;};
    t_CMN__Statut SetStageId (t_Chaine idStr);

    e_CMN__StageId GetStageId () {return m_StageId;};
    t_Chaine GetStageIdStr ();

    void SetDeliveredFilename (t_CMN__DeliveredFile filename)
	{m_DeliveredFile = filename;};
    t_CMN__DeliveredFile GetDeliveredFilename () {return m_DeliveredFile;};

/*====================================================================*/
protected:


/*====================================================================*/
private:

	// Attributs Prives pour un StageTM
        e_CMN__StageCategory     m_StageCategory;
        e_CMN__StageId           m_StageId;
	t_CMN__DeliveredFile     m_DeliveredFile;
};

#endif
