// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/CMN__Verrou.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : MSG
//@ CLASSE : CMN__Verrou
//@
//@ Commentaire :
//@    Ce fichier gere la classe CMN__Verrou
//@    Classe permettant d'avoir une gestion de lock pour des sequences
//@    critiques dans les threads par exemple.
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 13/05/2003 : P.L. AGNETTI
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef CMN__Verrou_h
#define CMN__Verrou_h

//
// Fichiers include
//

// STL
#include <set>

// Standard
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

// Projet


class CMN__Verrou {

    /*=================================================================*/

 public:
    
    //
    // Constructeur
    //
    CMN__Verrou(key_t key=IPC_PRIVATE,int nsems=1,int semval=1);
    
    //
    // Destructeur
    //
    ~CMN__Verrou();
    
    //
    // Accesseurs
    //
    
    //
    // Methodes publiques
    //
    void Bloquer();
    void DeBloquer();


    /*=================================================================*/

 protected:

    //
    // Methodes protegees
    //

    //
    // Attributs proteges
    //
    
	
    /*=================================================================*/

 private:
    
    //
    // Methodes privees
    //
    
    //
    // Attributs prives
    //
	
    // Cle d'acces au semaphore
    key_t  m_key;
    
    // nombre de semaphore de l'ensemble
    int    m_nb_sems;
	
    // option de creation
    int    m_semflg;
	
    // semaphore id
    int    m_semid;

    // semaphore valeur initiale
    int    m_semval;

    // flag semaphore createur 1/oui 0/non
    int    m_instance_creatrice;
};

#endif
