// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/CMN__Version.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : CMN
//@ MODULE : CMN__Version
//@
//@ Commentaire :
//@    Fichier d'entete du module CMN__Version qui definit les
//@    variables et les procedures exportees pour le traitement
//@    des versions:
//@      - Printer sur -v
//@      - Rendre la valeur de la version
//@      - Rendre l'indice mineur de la version
//@      - Rendre l'indice majeur de la version
//@    La version du logiciel doit etre de la forme: Vxx-yy, avec:
//@      - xx : indice majeur
//@      - yy : indice mineur
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 20/09/1999 : Pierre-Louis Agnetti
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Adaptation a l'OPS : ajout des fonctions CMN__Version_Majeur et
//@                      CMN__Version_Mineur
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifdef __cplusplus
extern "C" {
#endif
#ifndef CMN__Version_h
#define CMN__Version_h

//====================================================================*/
// Declaration des define externes
//====================================================================*/

//====================================================================*/
// Declaration des fonctions externes
//====================================================================*/


//@ CMN__Version_Trace permet tracer la version et sortir sur -v
void CMN__Version_Trace(int argc,char **argv);

//@ CMN__Version_Valeur permet de donner la version
char *CMN__Version_Valeur();

//@ CMN__Version_Majeur permet de donner l'indice majeur de la version
int CMN__Version_Majeur();

//@ CMN__Version_Mineur permet de donner l'indice mineur de la version
int CMN__Version_Mineur();


//====================================================================*/
// Declaration des variables externes
//====================================================================*/

#endif
#ifdef __cplusplus
}
#endif
