// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/ERR__Erreur.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : CMN
//@ CLASSE : ERR__Erreur
//@
//@ Commentaire :
//@    Ce fichier gere la classe ERR__Erreur. Cette classe permet de
//@    repartir les codes d'erreur pour chaque module.
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 21/03/2000 : A.MONTMORY
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ VERSION : 29/09/2000 : C.LACAZE
//@  Verification de mot-cles errones
//@ FA-ID : FPA-F11-FA-634-CN : 29/09/2000 :
//@  Ajout d'une base des numeros d'erreurs pour les composants CMN
//@ --------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Adaptation a l'OPS : ajout des bases d'erreur liees au parseur XML,
//@                      au SD et au WOM
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef ERR__Erreur_h
#define ERR__Erreur_h

// Fichier include
#include "CMN__Commun.h"


#ifdef __cplusplus


class ERR__Erreur {
    
    /*================================================================*/

 public:
    
    //
    // Type
    //

    //
    // Constante
    //
    
    // Base d'erreur pour la gestion des chaines
    static const int CMN_BASE_ERROR    =  100;
    
    // Base d'erreur pour le gestionnaire des configurations
    static const int CFG_BASE_ERROR    =  200;
    
    // Base d'erreur pour la gestion des lecture/ecriture XML
    static const int PRS_BASE_ERROR    =  300;
    
    // Base d'erreur pour MessageApi
    static const int MSG_BASE_ERROR    =  400;
    
    // Base d'erreur pour le serveur de temps
    static const int SRV_BASE_ERROR    =  500;
    
    // Base d'erreur pour la gestion du journal de bord
    static const int JDB_BASE_ERROR    =  600;
    
    // Base d'erreur sur le serveur de journal de bord
    static const int JDBS_BASE_ERROR   =  700;
    
    // Base d'erreur pour la gestion du MP
    static const int MP_BASE_ERROR     =  800;
    
    // Base d'erreur pour le process WOM
    static const int WOM_BASE_ERROR    =  900;
    
    // Base d'erreur pour le serveur de donnees
    static const int SD_BASE_ERROR     = 1000;
    
    // Base d'erreur sur les acces aux donnees
    static const int SD_DON_BASE_ERROR = 1100;
    
    // Base d'erreur sur les couches de bases
    static const int SD_BAS_BASE_ERROR = 1200;
    
    // Base d'erreur pour la gestion des chaines algorithmiques
    static const int SD_ALG_BASE_ERROR = 1400;


    //
    // Constructeur
    //
    ERR__Erreur() {};
    
    //
    // Destructeur
    //
    ~ERR__Erreur() {};

    //
    // Accesseurs
    //
    
    
    //
    // Methodes publiques
    //
        
    
    
    /*================================================================*/

 protected:

    //
    // Methodes protegees
    //
    
    //
    // Attributs proteges
    //
    
    
    /*================================================================*/

 private:

    //
    // Methodes privees
    //
    
    //
    // Attributs prives
    //
};

#endif


// Base d'erreur pour le gestionnaire des configurations
// FT-2765
static const int CFG_BASE_ERROR                  =  200;
// ...FT-2765

// Base d'erreur sur les couches de base
#define SD_BAS_ERR_BASE 1200               // possibilite de 10 messages

// FT-2765
static const int SD_BAS_BASE_ERROR               = 1200;
static const int SD_BAS_ERR_BASE_OperateurLoc    = 1210; // possibilite de 10 messages
static const int SD_BAS_ERR_BASE_OperateurBase   = 1220; // possibilite de 10 messages
static const int SD_BAS_ERR_BASE_Traces          = 1230; // possibilite de 10 messages
static const int SD_BAS_ERR_BASE_ESSL            = 1240; // possibilite de 10 messages
static const int SD_BAS_ERR_BASE_ConfAutre       = 1250; // possibilite de 10 messages
static const int SD_BAS_ERR_BASE_ConfStable      = 1260; // possibilite de 10 messages
static const int SD_BAS_ERR_BASE_Produits        = 1270; // possibilite de 10 messages
static const int SD_BAS_ERR_BASE_BanqueSpectrale = 1280; // possibilite de 10 messages
static const int SD_BAS_ERR_BASE_Contexte        = 1290; // possibilite de 10 messages
static const int SD_BAS_ERR_BASE_Niveau0         = 1300; // possibilite de 10 messages
static const int SD_BAS_ERR_BASE_Niveau1         = 1310; // possibilite de 10 messages
static const int SD_ALG_ERR_BASE_ISRFEM          = 1320; // possibilite de 10 messages
static const int SD_BAS_ERR_BASE_AVHRR           = 1330; // possibilite de 10 messages
static const int SD_ALG_ERR_BASE_AVHRR           = 1340; // possibilite de 10 messages
static const int SD_ALG_ERR_BASE_MONITORING      = 1350; // possibilite de 10 messages
static const int SD_ALG_ERR_BASE_IMAGE           = 1360; // possibilite de 10 messages
static const int SD_ALG_ERR_BASE_SPECTRE         = 1370; // possibilite de 20 messages

// Base d'erreur sur les algorithmes
static const int SD_ALG_BASE_ERROR = 1400;
// ...FT-2765

#endif
