static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/MP__ArretProcess.cc,v 1.3 2011/11/25 10:17:39 dpauly Exp $";
//@ ---------------------------------------------------------------------------
//@ Composant : MP
//@ CLASSE : MP__ArretProcess
//@
//@ Commentaire :
//@    Cette classe encapsule et gere le message de type arret process
//@    envoye par les processus applicatifs au MP lorsque ceux-ci 
//@    s'arrete 
//@
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 17/07/2002 : PBR
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

//
// Fichiers include
//
#include "ERR__Exception.h"
#include "CMN__Config.h"
#include "CFG__Configuration.h"
#include "MP__Message.h"
#include "MP__ArretProcess.h"


//
// Definition des constantes 
//

// Version Classe
const  t_Chaine MP__ArretProcess::VERSION_CLASSE = "1.0";


//=====================================================================
//                        METHODES PUBLIQUES
//=====================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : MP__ArretProcess
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
MP__ArretProcess::MP__ArretProcess() 
{
}


//@ ------------------------------------------------------------------*/
//@ Methode : ~MP__ArretProcessus
//@
//@ Description : Destructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
MP__ArretProcess::~MP__ArretProcess()
{
}


//@ ------------------------------------------------------------------*/
//@ Methode : Serialiser
//@
//@ Description : Serialisation de l'objet
//@
//@ Parametres :
//@               (SORTIE) message : Message reseau
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void MP__ArretProcess::Serialiser( MSG__Message& message)
{
  CMN__Configuration config;
  t_Chaine           resultat;
   
   
  //@ Ecriture de la version de la classe
  config.EcrireValeur("SECTION_ENTETE", "CHAMP_CLASSE", VERSION_CLASSE);
  
  //@ Ecriture du type de PROCESSUS
  config.EcrireValeur("NOM_PROCESSUS", "VALEUR", m_Processus);
		       
  //@ Ecriture du type de l'arret du processus
  config.EcrireValeur("ETAT_FIN", "VALEUR", m_EtatFin);
  
  //@ Sauvegarde de la serialisation dans une chaine
  config.SauverChaine(resultat);
  
  //@ Sauvegarde du bloc dans le message
  message.SetBloc(resultat.c_str(),resultat.size()+1);
  
  //@ Sauvegarde du type dans le message
  message.SetType(MP__Message::EVT_ARRET_PROCESSUS);
  
  //@ Positionnement de l'adresse de publication du message si
  //@ elle n'est pas encore renseignee
  if( message.GetAdresse()[0] == 0 )
    {
      message.SetAdresse(CFG__Configuration::GetAdresse("MP_INPUT"));
    }
}


//@ ------------------------------------------------------------------*/
//@ Methode : Serialiser
//@
//@ Description : Serialisation de l'objet
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               message : Message reseau
//@
//@ ------------------------------------------------------------------*/
MSG__Message MP__ArretProcess::Serialiser()
{
  MSG__Message message;
  

  //@ Serialisation de l'objet
  Serialiser(message);
  
  //@ Retourne le message
  return (message);
}


//@ ------------------------------------------------------------------*/
//@ Methode : Deserialiser
//@
//@ Description : Deserialisation de l'objet
//@
//@ Parametres :
//@               (ENTREE) message : Message reseau contenant un objet
//@                                  MP__ArretProcessus serialise
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void MP__ArretProcess::Deserialiser(const MSG__Message& message)
{
  t_Chaine           bloc(message.GetBloc());
  CMN__Configuration config;
  t_Chaine           version;
  t_Chaine           idProcessus;
  t_Chaine           etatFin;


  //@ SI le type du message est bien EVT_ARRET_PROCESSUS
  if (message.GetType() == MP__Message::EVT_ARRET_PROCESSUS) 
    {
      //@ lecture de la version de la classe
      config.ChargerChaine(bloc);
      config.LireValeur("SECTION_ENTETE", "CHAMP_CLASSE", version);
      
      //@ lecture du nom du processus emetteur du message
      config.LireValeur("NOM_PROCESSUS", "VALEUR", idProcessus);
      m_Processus = (e_CMN__Processus) int(idProcessus);
      
      //@ lecture de l'etat de fin du processus
      config.LireValeur("ETAT_FIN", "VALEUR", etatFin);
      m_EtatFin = (e_EtatFinProcessus) int(etatFin);
    }
  //@ FIN SI
}
