// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/MP__ArretProcess.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ---------------------------------------------------------------------------
//@ Composant : MP
//@ CLASSE : MP__ArretProcess
//@
//@ Commentaire :
//@    Cette classe encapsule et gere le message de type arret process
//@    envoye par les processus applicatifs au MP lorsque ceux-ci s'arrete 
//@
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 17/07/2002 : PBR
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

#ifndef MP__ArretProcess_h
#define MP__ArretProcess_h

//
// Fichiers include
//
#include "CMN__Commun.h"
#include "MSG__Message.h"
#include "CMN__OPSProcess.h"


class MP__ArretProcess {

    /*=================================================================*/

 public:
    
    //
    // Constante
    //
    static const t_Chaine VERSION_CLASSE;
    
    // Liste des etat de fin d'un processus de l'OPS
    typedef enum {
	FIN_OK=0,
	FIN_NOK=1
    } e_EtatFinProcessus;		
    
    //
    // Constructeur
    //
    MP__ArretProcess();
    
    //
    // Destructeur
    //
    virtual ~MP__ArretProcess();
    
    //
    // Accesseurs
    //
    e_CMN__Processus GetProcessus() const {return m_Processus;};
    void SetProcessus(const  e_CMN__Processus Processus) {m_Processus = Processus;};

    e_EtatFinProcessus GetEtatArret() const {return m_EtatFin;};
    void SetEtatFin(const e_EtatFinProcessus EtatFin) {m_EtatFin = EtatFin;};


    //
    // Methodes publiques
    //
    void Serialiser(MSG__Message& message);
    MSG__Message Serialiser();
    void Deserialiser(const MSG__Message& message);

    
    /*=================================================================*/

 protected:

    //
    // Methodes protegees
    //
    
    //
    // Attributs proteges
    //

    /*=================================================================*/

 private:

    //
    // Methodes privees
    //

    //
    // Attributs prives
    //
    
    // Type du Processus
    e_CMN__Processus   m_Processus;
	
    // Etat de Fin du Processus
    e_EtatFinProcessus m_EtatFin;		
};

#endif
