// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/MP__Command.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ---------------------------------------------------------------------------
//@ Composant : MP
//@ CLASSE : MP__Command
//@
//@ Commentaire :
//@    Cette classe encapsule et gere les informations echangees entre
//@    le MP et le WOM liees au controle de la production via les 
//@    commandes envoyees par le PGF (step/stop/suspend/resume/break)
//@
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 18/07/2002 : PBR
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

#ifndef MP__Command_h
#define MP__Command_h

//
// Fichier include
//

#include "CMN__Commun.h"
#include "MSG__Message.h"
#include "CMN__CmdTM.h"
#include "MP__Message.h"


class MP__Command : public CMN__CmdTM {

/*====================================================================*/

public:
        //
	// Constante
	//
	static const t_Chaine VERSION_CLASSE;

        typedef int t_MP__ProcessId;

        //
	// Constructeur
	//
	//MP__Command(e_CMN__CommandGroup commandGroup);
	MP__Command(e_CMN__CommandGroup commandGroup=CMD);
	//
	// Destructeur
	//
        virtual ~MP__Command();

	//
	// Accesseurs
        t_MP__ProcessId GetProcessId() const {return m_SDprocessId;};
        void SetProcessId(const t_MP__ProcessId processId)  
             {m_SDprocessId = processId;};


	//
	// Methodes publiques
	//
	void Serialiser(MP__Message::e_TypeMessage typeMessage, MSG__Message& message);
	MSG__Message Serialiser(MP__Message::e_TypeMessage typeMessage);
	void Deserialiser(const MSG__Message& message);

	/*====================================================================*/
protected:
	//
	// Methodes protegees
	//

	//
	// Attributs proteges
	//

	/*====================================================================*/
private:
	//
	// Methodes privees
	//

	//
	// Attributs prives
	//


	// Id UNIX du processus SD (cette information est passee
        // au WOM par le MP car seul le MP connait l'Id du processus SD
        // cet id est utilise dans le cas d'envoi de signaux)
        t_MP__ProcessId m_SDprocessId;
};

#endif
