// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/MP__Dump.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ---------------------------------------------------------------------------
//@ Composant : MP
//@ CLASSE : MP__Dump
//@
//@ Commentaire :
//@    Cette classe encapsule et gere le message de type fin de 
//@    traitement d'un dump envoye par le processus WOM au MP 
//@    lorsque le traitement d'un dump est termine
//@
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 22/07/2002 : PBR
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

#ifndef MP__Dump_h
#define MP__Dump_h

//
// Fichiers include
//
#include "CMN__Commun.h"
#include "MSG__Message.h"
#include "MP__Dump.h"


class MP__Dump {
    
    /*=================================================================*/
    
 public:
    
    //
    // Constante
    //
    static const t_Chaine VERSION_CLASSE;
    
    // Liste des etat de fin de traitement du dump
    typedef enum {
	FIN_OK=0,
	FIN_NOK=1
    } e_EtatFinDump;
		
    //
    // Constructeur
    //
    MP__Dump();
	
    //
    // Destructeur
    //
    virtual ~MP__Dump();
	
    //
    // Accesseurs
    //
    e_EtatFinDump GetEtatFinDump() const {return m_EtatFin;};
    void SetEtatFinDump(const e_EtatFinDump EtatFin) {m_EtatFin = EtatFin;};
    
    //
    // Methodes publiques
    //
    void Serialiser(MSG__Message& message);
    MSG__Message Serialiser();
    void Deserialiser(const MSG__Message& message);


    /*=================================================================*/

 protected:

    //
    // Methodes protegees
    //

    //
    // Attributs proteges
    //

	
    /*=================================================================*/

 private:

    //
    // Methodes privees
    //

    //
    // Attributs prives
    //
	
    // Etat de Fin du traitement du dump
    e_EtatFinDump m_EtatFin;
};

#endif
