// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/MP__Message.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ---------------------------------------------------------------------------
//@ Composant : MP
//@ CLASSE : MP__Message
//@
//@ Commentaire :
//@    Ce fichier gere les messages JDB et MSGS utilises par le MP.
//@
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 18/07/2002 : PBR
//@ Adaptation a l'OPS
//@ ---------------------------------------------------------------------------
//@ VERSION : 21/03/2000 : A.MONTMORY
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

#ifndef MP__Message_h
#define MP__Message_h

//
// Fichier include
//

#include "CMN__Commun.h"
#include "MSG__Message.h"


class MP__Message {

/*====================================================================*/

public:
	
        //
	// Constructeur
	//
	MP__Message();
	
	//
	// Destructeur
	//
	~MP__Message();
	//
	// Type des messages utilises par le MP
	//
	typedef enum {
          // Messages recus :
          // ---------------
          // MP__HKTMStatus (Pipeline depuis SD et Operational depuis WOM)
          EVT_HKTM_STATUS = MSG__Message::APPLICATIF_MP + 1,  

          // MP__StageTM (depuis le WOM)
	  EVT_STAGE_TM = MSG__Message::APPLICATIF_MP + 2,
 
          // MP__CmdTM (depuis le WOM)
	  EVT_CMD_TM = MSG__Message::APPLICATIF_MP + 3, 

          // MP__ArretProcessus : mort d'un processus
          EVT_ARRET_PROCESSUS = MSG__Message::APPLICATIF_MP + 4,

          // MP__Dump : fin de traitement du dump (depuis le WOM)
          EVT_FIN_DUMP = MSG__Message::APPLICATIF_MP + 5,

          // MP__Spacecraft (depuis le WOM)
          EVT_SPACECRAFT = MSG__Message::APPLICATIF_MP + 6,

          // Timer de declenchement de l'envoi de la HKTM
          EVT_TIMER_STATUS = MSG__Message::APPLICATIF_MP + 7,

          // Timer de declenchement de la scrutation de cmde
          EVT_TIMER_CMD = MSG__Message::APPLICATIF_MP + 8,

          // Messages envoyes :
          // -----------------
          // MP__CmdTM : commande recus du PGF
          EVT_PRCSS_CTRL = MSG__Message::APPLICATIF_MP + 9

          // demande d'arret d'un processus 
          // MSG__Message::FIN
	} e_TypeMessage;

	//
	// Type des messages JDB utilises par le MP
	//
	typedef enum {
	  MP_SET                   = 1,
	  MSG_VERSION              = MP_SET,
	  MSG_LANCEMENT_OPS        = MP_SET +  1,
	  MSG_ARRET_OPS            = MP_SET +  2,
	  MSG_STATUS_RES           = MP_SET +  3,
	  MSG_PROCESS_ACTION       = MP_SET +  4,
	  MSG_UNEXPECTED_EXP       = MP_SET +  5,
          MSG_ENVOI_HKTM_NOK       = MP_SET +  6,
          MSG_CMD_PROCESSING_STATE = MP_SET +  7,
          MSG_INVALID_CMD          = MP_SET +  8,
          MSG_MORT_PROCESS         = MP_SET +  9,
	  MSG_MP_MESSAGE           = MP_SET + 10
	} e_TypeMessageJDB;

        
	/*====================================================================*/
protected:
	//
	// Methodes protegees
	//

	//
	// Attributs proteges
	//

	/*====================================================================*/
private:
	//
	// Methodes privees
	//
	
};

#endif
