// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/MP__Spacecraft.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ---------------------------------------------------------------------------
//@ Composant : MP
//@ CLASSE : MP__Spacecraft
//@
//@ Commentaire :
//@    Cette classe encapsule et gere le message qui permet au WOM
//@    de renvoyer au MP et au JDBS l'information SPACECRAFT extraite 
//@    des donnees d'entrees et utilisee pour construire les HKTM status 
//@    et les log events ou traces.
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 22/07/2002 : PBR
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

#ifndef MP__Spacecraft_h
#define MP__Spacecraft_h

//
// Fichier include
//

#include "CMN__Commun.h"
#include "MSG__Message.h"
#include "CMN__CGSCst.h"

class MP__Spacecraft {

/*====================================================================*/

public:
        //
	// Constante
	//
	static const t_Chaine VERSION_CLASSE;

	
        //
	// Constructeur
	//
	MP__Spacecraft();
	//
	// Destructeur
	//
	virtual ~MP__Spacecraft();

	//
	// Accesseurs
        void SetSpacecraft(e_CMN_CGSSpacecraft  spacecraft)
             {m_Spacecraft = spacecraft;};
        t_CMN__Statut SetSpacecraft(t_Chaine  spacecraft);

        e_CMN_CGSSpacecraft GetSpacecraft() const {return m_Spacecraft;};
        t_Chaine GetSpacecraftStr();

	//
	// Methodes publiques
	//
	void Serialiser (MSG__Message& message);
	MSG__Message Serialiser();
	void Deserialiser(const MSG__Message& message);

	/*====================================================================*/
protected:
	//
	// Methodes protegees
	//

	//
	// Attributs proteges
	//

	/*====================================================================*/
private:
	//
	// Methodes privees
	//

	//
	// Attributs prives
	//
	// Type du ProcessusSpacecraft
        e_CMN_CGSSpacecraft  m_Spacecraft;
			
};

#endif
