static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/MP__UnProcess.cc,v 1.3 2011/11/25 10:17:39 dpauly Exp $";
//@ ---------------------------------------------------------------------------
//@ Composant : MP
//@ CLASSE : MP__UnProcess
//@
//@ Commentaire :
//@    Ce fichier gere la classe MP__UnProcess
//@
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 30/03/00 : C.LACAZE
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

//
// Fichiers include
//

#include "ERR__Exception.h"
#include "MP__UnProcess.h"
#include "CMN__Config.h"
#include "CFG__Configuration.h"

//
// Version Classe
//
const  t_Chaine MP__UnProcess::VERSION_CLASSE = "1.0";

//=====================================================================
//                        METHODES PUBLIQUES
//=====================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : Deserialiser
//@
//@ Description : Construit un objet de la classe MP__UnProcess a
//@               partir du contenu du message passe en parametre
//@
//@ Parametres :
//@               (ENTREE) message : message contenant un process
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void MP__UnProcess::Deserialiser (const MSG__Message& message)
{
  t_Chaine bloc (message.GetBloc());
  CMN__Configuration config;
  t_Chaine version;
  t_Chaine temp;
  
  //@ SI le type du message est bien evenement PROCESS
  if (message.GetType() == MSG__Message::EVT_PROCESS) 
    {
      //@ lecture de la version de la classe
      config.ChargerChaine(bloc);
      
      //@ lecture de la version de la classe
      config.ChargerChaine(bloc);
      config.LireValeur("SECTION_ENTETE","CHAMP_CLASSE",
			version);
      
      //@ lecture de l'action demandee
      config.LireValeur("ACTION","VALEUR",temp);
      m_Action = (e_Action)int(temp);
      
      //@ lecture du process id
      config.LireValeur("PID","VALEUR",temp);
      m_Pid = (pid_t)int(temp);
      
      //@ lecture du nom du process
      config.LireValeur("NOM_PROCESS","VALEUR",m_NomProcess);
    }
  //@ FIN SI
}


//@ ------------------------------------------------------------------*/
//@ Methode : Serialiser
//@
//@ Description : Construit un message a partir de la description de
//@               l'objet courant
//@
//@ Parametres :
//@               (SORTIE) MSG__Message : Message reseau
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void MP__UnProcess::Serialiser(MSG__Message& message)
{
  CMN__Configuration config;
  t_Chaine resultat;

  //@ Ecriture de la version de la classe
  config.EcrireValeur("SECTION_ENTETE","CHAMP_CLASSE",
                       VERSION_CLASSE);

  //@ Ecriture de la valeur de l'action demandee
  config.EcrireValeur("ACTION","VALEUR",(int) m_Action);
   
  //@ Ecriture de la valeur du process id
  config.EcrireValeur("PID","VALEUR",(int) m_Pid);
   
  //@ Ecriture du nom du process
  config.EcrireValeur("NOM_PROCESS","VALEUR",m_NomProcess);

  //@ Sauvegarde de la serialisation dans une chaine
  config.SauverChaine(resultat);
   
  //@ Sauvegarde du bloc dans le message
  message.SetBloc (resultat.c_str(),resultat.size()+1);
    
  //@ Sauvegarde du type dans le message
  message.SetType(MSG__Message::EVT_PROCESS);

  //@ Positionnement de l'adresse de publication du message s'il 
  //@ n'est pas encore renseigne
  if( message.GetAdresse()[0] == 0 )
    {
      message.SetAdresse (CFG__Configuration::GetAdresse ("MP_INPUT"));
    }
}


//@ ------------------------------------------------------------------*/
//@ Methode : Serialiser
//@
//@ Description : Construit un message a partir de la description de
//@               l'objet courant
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               Message contenant la description de l'objet
//@
//@ ------------------------------------------------------------------*/
MSG__Message MP__UnProcess::Serialiser ()
{
  //@ Declaration d'un message
  MSG__Message message;
  
  //@ Appel de la serialisation
  Serialiser (message);
  
  //@ Retour du message
  return message;
}
