// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/MP__UnProcess.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ---------------------------------------------------------------------------
//@ Composant : MP
//@ CLASSE : MP__UnProcess
//@
//@ Commentaire :
//@    Ce fichier gere la classe MP__UnProcess
//@
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 21/03/00 : A.MONTMORY
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

#ifndef MP__UnProcess_h
#define MP__UnProcess_h

//
// Fichier include
//

#include "CMN__Configuration.h"
#include "CMN__Config.h"
#include "MSG__Message.h"

class MP__UnProcess {

public:
	
        //
        // Liste des actions possibles
        //
        typedef enum {
	  ACTION_UNKNOWN = 0,
	  ACTION_START = 1,
	  ACTION_STOP = 2
	} e_Action;

        //
	// Constructeur
	//
	MP__UnProcess(): m_Pid(0),m_Action(ACTION_UNKNOWN) {};
	
	//
	// Destructeur
	//
	~MP__UnProcess() {};

        //
	// Accesseurs
	//
	
        e_Action GetAction() const { 
                                       return m_Action;
                                 };
        void SetAction(const e_Action action)  { 
                                        m_Action = action;
                                 };
        pid_t GetPid() const { 
                                       return m_Pid;
                                 };
        void SetPid(const pid_t pid)  { 
                                        m_Pid = pid;
                                 };
        t_Chaine GetNomProcess() const { 
                                       return m_NomProcess;
                                 };
        void SetNomProcess(const t_Chaine nomProcess)  { 
                                        m_NomProcess = nomProcess;
                                 };
	//
	// Methodes publiques
	//
	void Deserialiser (const MSG__Message& message);
	void Serialiser (MSG__Message &message);
	MSG__Message Serialiser ();

	/*====================================================================*/
protected:
	//
	// Methodes protegees
	//

	//
	// Attributs proteges
	//

	/*====================================================================*/
private:
	//
	// Constante
	//
	static const t_Chaine VERSION_CLASSE;

	// Type d'action vehicule par l'objet
        e_Action m_Action;

        // Pid du process
	pid_t m_Pid;
	
	// Nom Logique du process
	t_Chaine m_NomProcess;
	
};

#endif
