// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/SD__Init.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ---------------------------------------------------------------------------
//@ Composant : CMN
//@ CLASSE : SD__Init
//@
//@ Commentaire :
//@    Ce fichier contient la classe SD__Init, qui permet de gerer le
//@    message de fin d'initialisation du composant SD
//@
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

#ifndef SD__Init_h
#define SD__Init_h

//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Commun.h"
#include "MSG__Message.h"


class SD__Init {

    /*================================================================*/

 public:
        
    //
    // Liste des status geres
    //
    typedef enum 
        {
            SD_INIT_OK       = 0,
            SD_INIT_NOK      = 1,
            SD_INIT_ERR_BANK = 2
        } e_ListeStatus;
        
                
    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    SD__Init();
        
    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    virtual ~SD__Init();

    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    e_ListeStatus Etat() {return m_Etat;};
    void Etat(e_ListeStatus etat) {m_Etat = etat;};


    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    void Serialiser( MSG__Message& message);
    MSG__Message Serialiser();
    void Deserialiser(const MSG__Message& message);

    
    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////
    

    /*================================================================*/

 private:
    
    //
    // Constantes
    //
    static const t_Chaine VERSION_CLASSE;
    static const t_Chaine SECTION_ENTETE;
    static const t_Chaine CHAMP_CLASSE;
    static const t_Chaine CHAMP_ETAT;
    static const t_Chaine VALEUR;
    static const t_Chaine ADR_INPUT;

    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////

    // Etat de l'initialisation
    e_ListeStatus m_Etat;
};

#endif
