static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/TES__Evenement.cc,v 1.3 2011/11/25 10:17:39 dpauly Exp $";
//@ ---------------------------------------------------------------------------
//@ Composant : TES
//@ CLASSE : TES__Evenement
//@
//@ Commentaire :
//@    Ce fichier gere la classe TES__Evenement
//@
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 21/03/2000 : A.MONTMORY
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

//
// Fichiers include
//
#include "ERR__Exception.h"
#include "TES__Evenement.h"
#include "CMN__Config.h"
#include "CFG__Configuration.h"

//
// Version Classe
//
const  t_Chaine TES__Evenement::VERSION_CLASSE = "1.0";


//=====================================================================
//                        METHODES PUBLIQUES
//=====================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : TES__Evenement
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
TES__Evenement::TES__Evenement(): m_Action(ACTION_UNKNOWN),
                                  m_TypeLogique(MSG__Message::UNKNOWN),
                                  m_Periode(0), m_StartDate(0.), m_NomLogique()
{
}


//@ ------------------------------------------------------------------*/
//@ Methode : ~TES__Evenement
//@
//@ Description : Destructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
TES__Evenement::~TES__Evenement()
{
}


//@ ------------------------------------------------------------------*/
//@ Methode : Serialiser
//@
//@ Description : Serialise un objet TES__Evnement en un paquet reseau
//@               propre a etre envoye
//@
//@ Parametres :
//@               (SORTIE) MSG__Message : Message reseau
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void TES__Evenement::Serialiser(MSG__Message& message)
{
  CMN__Configuration config;
  t_Chaine resultat;
   
  //@ Ecriture de la version de la classe
  config.EcrireValeur("SECTION_ENTETE","CHAMP_CLASSE",
                       VERSION_CLASSE);

  //@ Ecriture de la valeur de l'action demandee
  config.EcrireValeur("ACTION","VALEUR",(int) m_Action);
   
  //@ Ecriture de la periode du timer
  config.EcrireValeur("PERIODE","VALEUR", m_Periode);

  //@ Ecriture de la date de debut
  config.EcrireValeur("DATE_DEBUT","VALEUR",m_StartDate);

  //@ Ecriture du nom logique
  config.EcrireValeur("NOM_LOGIQUE","VALEUR",m_NomLogique);

  //@ Ecriture du type logique
  config.EcrireValeur("TYPE_LOGIQUE","VALEUR",(int) m_TypeLogique);

  //@ Ecriture de l'adresse
  config.EcrireValeur("ADRESSE","VALEUR",m_Adresse);

  //@ Ecriture des donnees utilisateur
  config.EcrireValeur("USER_DATA","VALEUR",m_UserData);

  //@ Sauvegarde de la serialisation dans une chaine
  config.SauverChaine(resultat);
   
  //@ Sauvegarde du bloc dans le message
  message.SetBloc (resultat.c_str(),resultat.size()+1);
    
  //@ Sauvegarde du type dans le message
  message.SetType(MSG__Message::EVT_TIMER);

  //@ Positionnement de l'adresse de publication du message si elle
  //@ n'est pas encore renseignee
  if( message.GetAdresse()[0] == 0 )
    {
      message.SetAdresse (CFG__Configuration::GetAdresse ("TES_INPUT"));
    }
}


//@ ------------------------------------------------------------------*/
//@ Methode : Serialiser
//@
//@ Description : Serialise un objet TES__Evnement en un paquet reseau
//@               propre a etre envoye
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               MSG__Message : Message reseau
//@
//@ ------------------------------------------------------------------*/
MSG__Message TES__Evenement::Serialiser()
{
  //@ Declaration d'un message
  MSG__Message message;
  
  //@ Appel de la serialisation
  Serialiser (message);
  
  //@ Retour du message
  return message;
}


//@ ------------------------------------------------------------------*/
//@ Methode : Deserialiser
//@
//@ Description : Construit un objet TES__Evenement a partir d'un  
//@               paquet reseau
//@
//@ Parametres :
//@               (ENTREE) MSG__Message : Message reseau
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void TES__Evenement::Deserialiser(const MSG__Message& message)
{
  t_Chaine bloc (message.GetBloc());
  CMN__Configuration config;
  t_Chaine version;
  t_Chaine temp;
  
  //@ SI le type du message est bien evenement TIMER alors
  if (message.GetType() == MSG__Message::EVT_TIMER) 
    {
      //@ lecture de la version de la classe
      config.ChargerChaine(bloc);
      config.LireValeur("SECTION_ENTETE","CHAMP_CLASSE",
			version);
      
      //@ lecture de l'action demandee
      config.LireValeur("ACTION","VALEUR",temp);
      m_Action = (e_Action)int(temp);
      
      //@ lecture de la periode du timer
      config.LireValeur("PERIODE","VALEUR", temp);
      m_Periode = int(temp);
      
      //@ lecture de la date de debut
      config.LireValeur("DATE_DEBUT","VALEUR", temp);
      m_StartDate = double(temp);
      
      //@ lecture du nom logique
      config.LireValeur("NOM_LOGIQUE","VALEUR",m_NomLogique);
      
      //@ lecture du type logique
      config.LireValeur("TYPE_LOGIQUE","VALEUR", temp);
      m_TypeLogique = int(temp);
      
      //@ lecture de l'adresse
      config.LireValeur("ADRESSE","VALEUR",m_Adresse);
      
      //@ lecture des donnees utilisateur
      config.LireValeur("USER_DATA","VALEUR",m_UserData);
  }
  //@ FIN SI
}
