// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/CMN/src/TES__Evenement.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ ---------------------------------------------------------------------------
//@ Composant : TES
//@ CLASSE : TES__Evenement
//@
//@ Commentaire :
//@    Ce fichier gere la classe TES__Evenement
//@
//@ ---------------------------------------------------------------------------
//@ HISTORIQUE
//@ ---------------------------------------------------------------------------
//@ VERSION : 21/03/00 : A.MONTMORY
//@ Creation du fichier
//@ ---------------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ ---------------------------------------------------------------------------

#ifndef TES__Evenement_h
#define TES__Evenement_h

//
// Fichier include
//

#include "MSG__Message.h"
#include <vector>


class TES__Evenement {

/*====================================================================*/

public:
        //
        // Constante
        //
        static const t_Chaine VERSION_CLASSE;
	
        //
        // Liste des actions possibles
        //
        typedef enum {
	  ACTION_UNKNOWN = 0,
	  ACTION_ADD = 1,
	  ACTION_DELETE = 2,
	  ACTION_PUBLISH = 3
	} e_Action;
	
        //
	// Constructeur
	//
	TES__Evenement();
	//
	// Destructeur
	//
	~TES__Evenement();

	//
	// Accesseurs
	//
        e_Action GetAction() const { 
                                       return m_Action;
                                 };
        void SetAction(const e_Action action)  { 
                                        m_Action = action;
                                 };

        t_Chaine GetAdresse() const { 
                                       return m_Adresse;
                                 };
        void SetAdresse(const t_Chaine& Adresse)  { 
                                        m_Adresse = Adresse;
                                 };
				 
        t_Chaine GetNomLogique() const { 
                                       return m_NomLogique;
                                 };
        void SetNomLogique(const t_Chaine& NomLogique)  { 
                                        m_NomLogique = NomLogique;
                                 };
        int GetTypeLogique() const { 
                                       return m_TypeLogique;
                                 };
        void SetTypeLogique(int TypeLogique)  { 
                                        m_TypeLogique = TypeLogique;
                                 };
        int GetPeriode() const { 
                                       return m_Periode;
                                 };
        void SetPeriode(const int periode)  { 
                                        m_Periode = periode;
                                 };

        double GetStartDate() const { 
                                       return m_StartDate;
                                 };
        void SetStartDate(double startDate)  { 
                                        m_StartDate = startDate;
                                 };

        t_Chaine GetUserData() const { 
                                       return m_UserData;
                                 };
        void SetUserData(const t_Chaine& UserData)  { 
                                        m_UserData = UserData;
                                 };
	
	//
	// Methodes publiques
	//
	//
	// Serialisation pour transporter l'objet sur le reseau
	//
        void Serialiser (MSG__Message &message);
        MSG__Message Serialiser ();
	//
	// Deseralisation pour reconstruire l'objet a partir d'un paquet reseau
	//
	void Deserialiser (const MSG__Message &message);
	
	/*====================================================================*/
protected:
	//
	// Methodes protegees
	//

	//
	// Attributs proteges
	//

	/*====================================================================*/
private:
	//
	// Methodes privees
	//

	//
	// Attributs prives
	//
	// Type d'action vehicule par l'objet
  e_Action m_Action;
	
	// Periode eventuel lie a l'evenement (en seconde)
	int m_Periode;
	
	// Date de publication de l'evenement (en seconde)
	double m_StartDate;
	
	// Nom logique de l'evenement (utilise pour l'identifier dans le gestionnaire)
	t_Chaine m_NomLogique;
	
	// Type logique de l'evenement (identifiant numerique fixe par convention entre 
	// le producteur et le conssomateur).
	int m_TypeLogique;
	
	// Adresse de diffusion de l'evenement
	t_Chaine m_Adresse;

	// Donnees utilisateur
	t_Chaine m_UserData;
};

#endif
