// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/ENV/src/FMES_FICHIER_MESSAGES.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ -------------------------------------------------------------------
//@ Composant : ENV
//@ MODULE : FMES_FICHIER_MESSAGES
//@
//@ Commentaire :
//@    Fichier d'entete du module FMES_FICHIER_MESSAGES
//@
//@ -------------------------------------------------------------------
//@ HISTORIQUE
//@ -------------------------------------------------------------------
//@ VERSION : 05/03/1997 : THALES-IS
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ -------------------------------------------------------------------

#ifdef __cplusplus
extern "C" {
#endif

#ifndef INCLUDE_spec_FMES_FICHIER_MESSAGES
#define INCLUDE_spec_FMES_FICHIER_MESSAGES

//
// Fichiers include
//

// STL

// Standard

// Projet

// Required OPERATION :
// 	OPERATION : Lire_valeur of object : FPARA_FICHIER_PARAMETRES
// Required EXCEPTION : NONE
// Required TYPE :
// 	TYPE : T_char of object : TYCST
// 	TYPE : T_int2 of object : TYCST
// 	TYPE : T_pt_char of object : TYCST
// 	TYPE : T_pt_pt_char of object : TYCST
// 	TYPE : T_status of object : FPARA_FICHIER_PARAMETRES
// Required CONSTANT : NONE
// Required DATA : NONE

#include "TYCST.h"


//
// Definition des constantes 
//

// Cle d'acces au nom du catalogue de messages pour l'objet FPARA
#define FMES_CLE_CAT_MESS "CAT_MESS"


//======================================================================
// Declaration des types externes
//======================================================================

// Description des status de retour des operations de l'objet
    typedef enum {
	FMES_Ok = 0,
	FMES_Nok = 1001,
	FMES_LectCatKo = 1002,
	FMES_CatDejaOuvert = 1003,
	FMES_OpenCatKo = 1004
    } e_FMES_Status;

// Ce type donne la liste des identificateurs d'ensemble de messages 
// associes a chaque objet
    typedef enum {
	FMES_Gapp        = 1,
	FMES_Gevt        = 2,
	FMES_GSPIP       = 3,
	FMES_Stdtp       = 4,
        FMES_PSVP        = 5,
        FMES_HmiYTool    = 6,
        FMES_Pfup        = 7,
        FMES_Ocdp        = 8,
        FMES_Ocdi        = 9,
        FMES_GSPI        = 10,
        FMES_RESS        = 11,        
        FMES_MONP        = 12,       
        FMES_PLMOC       = 13,        
        FMES_PLDA        = 14,        
        FMES_PLTIS       = 15,        
        FMES_PLRES       = 16,        
        FMES_PLBUI       = 17,        
        FMES_PLSTA       = 18,
        FMES_PFUM        = 19,
        FMES_TPLMO       = 20,
        FMES_FILE        = 21,
        FMES_PFUMM       = 22,
        FMES_FUFIL       = 23,
        FMES_UNMCF       = 24,
        FMES_FUSCF       = 25,
        FMES_CFUPR       = 26,
        FMES_DIREC       = 27,
        FMES_FUSET       = 28,
        FMES_GAEVT       = 29,
        FMES_GASET       = 30,
        FMES_RESET       = 31,
        FMES_RESOU       = 32,
        FMES_TESET       = 33,
        FMES_TEMPL       = 34,
	FMES_INST        = 35,
        FMES_IOFM        = 36,
        FMES_PHMI        = 37,
        FMES_THMI        = 38,
        FMES_PRCDB       = 39,
        FMES_GSPIDB      = 40,
        FMES_PACMN       = 41,
        FMES_DRAFTL      = 42,
        FMES_PLEX        = 43,
	FMES_DLOG        = 44,
	FMES_RESSDB      = 45,
	FMES_TMSDB       = 46,
	FMES_REPG        = 47,
	FMES_FOM         = 48
    } e_FMES_IdMsgSet;


//======================================================================
// Declaration des fonctions externes
//======================================================================

//@ ------------------------------------------------------------------*/
//@ Procedure : LireMessage 
//@
//@ Description : Grace au numero de sous-ensemble de messages et au
//@               numero de message precises, cette fonction retourne
//@               un pointeur sur un buffer interne contenant le
//@               message associe, stocke dans le buffer interne
//@               contenant le message associe, stocke dans le
//@               catalogue
//@
//@ Parametres :
//@               (ENTREE) id_message_set
//@               (ENTREE) id_message
//@               (SORTIE) message
//@
//@ Valeur de retour :
//@               e_FMES_Status
//@
//@ ------------------------------------------------------------------*/
extern
#ifdef __CPP
   "C"
#endif
e_FMES_Status
FMES_LireMessage(
	const TYCST__T_int2 id_message_set, 
	const TYCST__T_int2 id_message, 
	TYCST__T_pt_pt_char message
	);

//@ ------------------------------------------------------------------*/
//@ Procedure : InitSet
//@
//@ Description : Initialise les messages du catalogue
//@
//@ Parametres :
//@               (ENTREE) id_message_set
//@               (ENTREE) id_debut
//@               (ENTREE) id_fin
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
extern
#ifdef __CPP
   "C"
#endif
void
FMES_InitSet(
	const TYCST__T_int2 id_message_set, 
	const TYCST__T_int2 id_deb, 
	const TYCST__T_int2 id_fin 
	);

//@ ------------------------------------------------------------------*/
//@ Procedure : Initialiser
//@
//@ Description : Initialise le catalogue
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               e_FMES_Status
//@
//@ ------------------------------------------------------------------*/
extern
#ifdef __CPP
   "C"
#endif
e_FMES_Status
FMES_Initialiser(void
	);

//@ ------------------------------------------------------------------*/
//@ Procedure : Terminer
//@
//@ Description : Termine une session d'acces au catalogue des
//@               messages en fermant celui-ci et en liberant la
//@               memoire utilisee par celui-ci
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               e_FMES_Status
//@
//@ ------------------------------------------------------------------*/
extern
#ifdef __CPP
   "C"
#endif
e_FMES_Status
FMES_Terminer(void
	);

#endif

#ifdef __cplusplus
}
#endif
