// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/ENV/src/FPARA_FICHIER_PARAMETRES.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : ENV
//@ MODULE : FPARA_FICHIER_PARAMETRES
//@
//@ Commentaire :
//@    Fichier d'entete du module FPARA_FICHIER_PARAMETRES
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 05/03/1997 : THALES-IS
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifdef __cplusplus
extern "C" {
#endif

#ifndef INCLUDE_spec_FPARA_FICHIER_PARAMETRES
#define INCLUDE_spec_FPARA_FICHIER_PARAMETRES

//
// Fichiers include
//

// STL

// Standard

// Projet

// Required OPERATION : NONE
// Required EXCEPTION : NONE
// Required TYPE :
// 	TYPE : T_pt_char of object : TYCST
// Required CONSTANT : NONE
// Required DATA : NONE

#include "TYCST.h"


//
// Definition des constantes 
//


//======================================================================
// Declaration des types externes
//======================================================================

// Type d'un parametre : string , int2, int4,real 4, real8, uint2,
// uint4, boolean
typedef enum {
   FPARA__C_string = 0,
   FPARA__C_int2 = 1,
   FPARA__C_int4 = 2,
   FPARA__C_real4 = 3,
   FPARA__C_real8 = 4,
   FPARA__C_uint2 = 5,
   FPARA__C_uint4 = 6,
   FPARA__C_boolean = 7
} FPARA__T_type_param;

// Pointeur sur type d'un parametre
typedef FPARA__T_type_param  *FPARA__T_pt_type_param;
 
// Valeur d'un parametre
typedef TYCST__T_char *FPARA__T_val_param;

// Pointeur sur valeur d'un parametre
typedef FPARA__T_val_param *FPARA__T_pt_val_param;

// Type definissant la valeur retournee par les operations de cet objet
typedef enum {
   FPARA__C_ok 			= 0,
   FPARA__C_err_param_inconnu 	= 1001,
   FPARA__C_err_type_absent 	= 1002,
   FPARA__C_err_type_inconnu 	= 1003,
   FPARA__C_err_alloc 		= 1004
} FPARA__T_status;
      

//======================================================================
// Declaration des fonctions externes
//======================================================================

//@ ------------------------------------------------------------------*/
//@ Procedure : Lire_valeur
//@
//@ Description : L'operation permet de lire valeur d'un parametre
//@               statique, et son type.
//@               La valeur et le type sont lus dans les variables
//@               d'environnement initialisees dans le fichier
//@               parametre du client
//@
//@ Parametres :
//@               (ENTREE) nom_param
//@               (SORTIE) val_param
//@               (SORTIE) type_param
//@
//@ Valeur de retour :
//@               FPARA__T_status
//@
//@ ------------------------------------------------------------------*/
extern
#ifdef __CPP
   "C"
#endif
FPARA__T_status
FPARA__Lire_valeur(
		   const TYCST__T_pt_char nom_param, 
		   FPARA__T_pt_val_param val_param, 
		   FPARA__T_pt_type_param type_param
		   );

#endif
    
#ifdef __cplusplus
}
#endif

