// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/ENV/src/JDB_JOURNAL_DE_BORD.h,v 1.3 2011/11/25 10:17:39 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : ENV
//@ MODULE : JDB_JOURNAL_DE_BORD
//@
//@ Commentaire :
//@    Fichier d'entete du module JDB_JOURNAL_DE_BORD
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 05/03/1997 : Serge Bobin
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifdef __cplusplus
extern "C" {
#endif

#ifndef INCLUDE_spec_JDB_JOURNAL_DE_BORD
#define INCLUDE_spec_JDB_JOURNAL_DE_BORD


//
// Fichiers include
//

// STL

// Standard

// Projet

// Required OPERATION :
//      OPERATION : Substituer of object : STRING
//      OPERATION : Lire_message of object : FMES_FICHIER_MESSAGES
//      OPERATION : Lire_valeur of object : FPARA_FICHIER_PARAMETRES
// Required EXCEPTION : NONE
// Required TYPE :
//      TYPE : T_char of object : TYCST
//      TYPE : T_int2 of object : TYCST
//      TYPE : T_int4 of object : TYCST
//      TYPE : T_boolean of object : TYCST
// Required CONSTANT : NONE
// Required DATA : NONE

#include "TYCST.h"
#include "FMES_FICHIER_MESSAGES.h"
#include "FPARA_FICHIER_PARAMETRES.h"


//
// Definition des constantes 
//

// Nombre maximum de parametres dans une liste de parametres JDB
#define JDB_NB_MAX_PARAM                20

// Nombre maximum de couples (nom logique,callback)
#define JDB_NB_MAX_NOM_LOGIQUE_CALLBACK 10

// Longueur maximum d'un message JDB
#define JDB_LG_MAX_MESSAGE              500

// Nom du parametre FORMAT_DATE
#define JDB_PARAM_FORMAT_DATE           "JDB_FORMAT_DATE"

// Separateur entre 2 types d'attribut
#define JDB_SEP_TYPE_ATTR               " "

// Separateur d'attribut dans une liste d'attribut d'un message
#define JDB_SEP_LIST_ATTR               ","

// Separateur entre attributs et libelle du message
#define JDB_SEP_ATTR_LIBELLE            "|"

// Nom du parametre definissant le chemin d'acces au fichier trace
#define JDB_PARAM_FICHIER_TRACE         "JDB_FICHIER_TRACE"

// Taille maximum par defaut du fichier de trace (octets)
#define JDB_TAILLE_MAX_FIC_TRACE_DEFAUT 50000

// Taille maximum par defaut du fichier de trace (octets)
#define JDB_PARAM_TAILLE_MAX_FIC_TRACE  "JDB_TAILLE_MAX_FIC_TRACE"

// Chaine gravite info
#define JDB_G_STR_INFO                  "INFO" 

// Chaine gravite notice
#define JDB_G_STR_NOTICE                "NOTICE"       

// Chaine gravite warning
#define JDB_G_STR_WARNING               "WARNING"      

// Chaine gravite alert
#define JDB_G_STR_ALERT                 "ALERT" 

// Chaine gravite unknown
#define JDB_G_STR_UNKNOWN               "UNKNOWN" 

// Chaine destination fichier
#define JDB_D_STR_FICHIER               "FICHIER"      

// Chaine destination middleware
#define JDB_D_STR_MID_WARE              "CSF"  

// Chaine destination NONE
#define JDB_D_STR_NONE                  "NONE"         

// Nom du parametre process
#define JDB_PROCESS                     "$process"             


//======================================================================
// Declaration des types externes
//======================================================================

// Type definissant un parametre d'un message JDB. Chaque parametre
// comporte un nom et une valeur
typedef struct {
    TYCST__T_pt_char nom;          // Nom d'un parametre 
    TYCST__T_pt_char valeur;       // Valeur d'un parametre 
} t_JDB_Param;
    
// Type definissant un pointeur sur un parametre d'un message JDB
typedef t_JDB_Param *t_JDB_PtParam;
    
// Type definissant le status retournee par les operations de l'objet
typedef enum {
    JDB_Ok                                 = 0, // pas d'erreur 
    JDB_Nok                                = 1001, // erreur 
    JDB_ERR_MESSAGE_INEXISTANT             = 1002, // message non repertorie 
    JDB_ERR_TROP_DE_PARAMETRES             = 1003, // trop de parametres 
    JDB_ERR_PAS_ASSEZ_DE_MEMOIRE           = 1004, // pas assez de memoire 
    JDB_ERR_ACCES_FIC_MES                  = 1005, // acces fichier message 
    JDB_ERR_GRAVITE                        = 1006, // gravite inconnue 
    JDB_ERR_DESTINATION                    = 1007, // destination inconnue 
    JDB_ERR_OUVERTURE_FICHIER              = 1008, // pb ouverture fichier 
    JDB_ERR_ARG_INVALIDE                   = 1009, // argument invalide 
    JDB_ERR_SEP_ABSENT                     = 1010, // separateur absent 
    JDB_ERR_ATTRIBUT_ABSENT                = 1011, // attribut absent  
    JDB_ERR_LIBELLE_ABSENT                 = 1012, // libelle absent  
    JDB_ERR_DESTINATION_NON_TROUVE         = 1013,  // destination non trouvee
    JDB_ERR_LISTE_CALLBACK_NON_INITIALISE  = 1014 // liste callback non initialise   
    // pas d erreur objet --> NA 
} e_JDB_Status;

// Type definissant une liste de parametres d'un message JDB
typedef struct {
    TYCST__T_int4       nb;
    t_JDB_Param         tab[JDB_NB_MAX_PARAM];
} t_JDB_ListeParam;
    
// Type definissant un pointeur sur une liste de parametres d'un
// message JDB
typedef t_JDB_ListeParam *t_JDB_pt_ListeParam;
    
// Ce type donne la liste des identificateurs d'ensemble de messages
// associes a chaque objet
typedef e_FMES_IdMsgSet t_JDB_IdMsgSet;
    
// Type d'un message JDB  
typedef TYCST__T_char t_JDB_Message[JDB_LG_MAX_MESSAGE +1] ;
  
// Type definissant un couple (nom logique, callback)
typedef struct {
    TYCST__T_pt_char  nomLogique;
    TYCST__T_void     (*callback)(TYCST__T_pt_char,TYCST__T_pt_char,TYCST__T_pt_char,const t_JDB_Message);
} t_JDB_Callback;
    
    
// Type definissant une liste de parametres d'un message JDB
typedef struct {
    TYCST__T_int4       NbCallback;
    t_JDB_Callback      tab[JDB_NB_MAX_NOM_LOGIQUE_CALLBACK];
} t_JDB_ListeCallback;
    
    
//====================================================================*/
// Declaration des fonctions externes
//====================================================================*/
     
//@ ------------------------------------------------------------------*/
//@ Procedure : InitSet
//@
//@ Description : Cette operation permet d'initialiser un set de
//@               message
//@
//@ Parametres :
//@               (ENTREE) idSet
//@               (ENTREE) msgDeb
//@               (ENTREE) msgFin
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
extern
void
JDB__InitSet(int idSet, int msgDeb, int msgFin);

//@ ------------------------------------------------------------------*/
//@ Procedure : InitialiserMessage
//@
//@ Description : Initialise un message vide
//@
//@ Parametres :
//@               (SORTIE) messageJDB
//@
//@ Valeur de retour :
//@               e_JDB_Status
//@
//@ ------------------------------------------------------------------*/
extern
e_JDB_Status
JDB_InitialiserMessage(t_JDB_pt_ListeParam);


//@ ------------------------------------------------------------------*/
//@ Procedure : StockerParametres
//@
//@ Description : Stocke un nouveau parametre (nom,valeur)
//@
//@ Parametres :
//@               (ENTREE) NomParametre : Nom du parametre a stocker
//@               (ENTREE) ValeurParametre : Valeur du parametre a
//@                                          stocker
//@               (SORTIE) MsgJdb : Message JDB mis a jour avec le
//@                                 nouveau parametre
//@
//@ Valeur de retour :
//@               e_JDB_Status
//@
//@ ------------------------------------------------------------------*/
extern
e_JDB_Status
JDB_StockeParametre(
                    TYCST__T_pt_char NomParametre,
                    TYCST__T_pt_char ValeurParametre,
                    t_JDB_pt_ListeParam MsgJdb
                    );


//@ ------------------------------------------------------------------*/
//@ Procedure : VideMessage
//@
//@ Description : Vide le message (parametres)
//@
//@ Parametres :
//@               (ENTREE/SORTIE) MsgJdb
//@
//@ Valeur de retour :
//@               e_JDB_Status
//@
//@ ------------------------------------------------------------------*/
extern
e_JDB_Status
JDB_VideMessage(
                t_JDB_pt_ListeParam MsgJdb
                );


//@ ------------------------------------------------------------------*/
//@ Procedure : EcrireMessage
//@
//@ Description : Permet d'identifier la partie textuelle d'un
//@               message applicatif repertorie dans un fichier
//@               et de completer celui-ci en prenant en compte
//@               si necessaire des parametres dynamiques, puis
//@               de l'envoyer au Journal de bord via un 
//@               Datagroup specifique
//@
//@ Parametres :
//@               (ENTREE) id_ensemble
//@               (ENTREE) id_mess
//@               (ENTREE) pt_liste_param
//@
//@ Valeur de retour :
//@               e_JDB_Status
//@
//@ ------------------------------------------------------------------*/
extern
e_JDB_Status
JDB_EcrireMessage(
                  const TYCST__T_int2 id_ensemble, 
                  const TYCST__T_int2 id_mess, 
                  const t_JDB_pt_ListeParam pt_liste_param
                  );


//@ ------------------------------------------------------------------*/
//@ Procedure : InitialiserCallback
//@
//@ Description : Initialiser les couples (nom logique,callback)
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               e_JDB_Status
//@
//@ ------------------------------------------------------------------*/
extern
e_JDB_Status
JDB_InitialiserCallback();


//@ ------------------------------------------------------------------*/
//@ Procedure : PositionnerCallback
//@
//@ Description : Associe un callback a un nom logique
//@
//@ Parametres :
//@               (ENTREE) NomLogique : Destination dans un fichier
//@                                     message
//@               (ENTREE) Callback : Callback associe au nom logique
//@
//@ Valeur de retour :
//@               e_JDB_Status
//@
//@ ------------------------------------------------------------------*/
extern
e_JDB_Status
JDB_PositionnerCallback(
                        TYCST__T_pt_char NomLogique, 
                        TYCST__T_void (*Callback)(TYCST__T_pt_char,
                                                  TYCST__T_pt_char,
                                                  TYCST__T_pt_char,
                                                  const t_JDB_Message)
                        );

#endif

#ifdef __cplusplus
}
#endif

