// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/ENV/src/TYCST.h,v 1.2 2011/11/25 10:17:39 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : ENV
//@ MODULE : JDB_JOURNAL_DE_BORD
//@
//@ Commentaire :
//@    Fichier d'entete du module JDB_JOURNAL_DE_BORD
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ EURIDIS / REALISATION PAR SYSECA SA
//@ --------------------------------------------------------------------
//@ (15/04/1997) Modification de la definition de TYCST__T_uint4.
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------


/* FIN CARTOUCHE */

#ifdef __cplusplus
extern "C" {
#endif

#ifndef INCLUDE_spec_TYCST
#define INCLUDE_spec_TYCST

/*****************************************************************************/
/*                    CLAUSES DE VISIBILITE (#include)                       */
/*****************************************************************************/

/* NONE */
#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>

/*****************************************************************************/
/*                CONSTANTES NON TYPEES EXTERNES (#define)                   */
/*****************************************************************************/




/*C C_lg_nom_fichier :  */
/* Longueur maximum du nom d'un fichier
    */
#define TYCST__C_lg_nom_fichier  32

/*C C_LG_FILE_NAME :  */
/* Max length of a file name
    */
#define TYCST__C_LG_FILE_NAME 32

/*C C_lg_chemin_fichier :  */
/* Longueur maximum du chemin d'acces a un fichier
    */
#define TYCST__C_lg_chemin_fichier	500

/*C C_LG_FILE_PATH :  */
/* Max length of a file path
    */
#define TYCST__C_LG_FILE_PATH 500

/*C C_lg_nom_commande :  */
/* Longueur maximum d'une commande systeme
    */
#define TYCST__C_lg_nom_commande	512

/*C C_lg_command_name :  */
/* Max length of a system command
    */
#define TYCST__C_LG_COMMAND_NAME 512

/*C C_faux :  */
/* Constante definissant la valeur booleenne FAUX
    */
#define TYCST__C_faux 	0

/*C C_FALSE :  */
/* Constant for boolean value FALSE
    */
#define TYCST__C_FALSE 0

/*C C_vrai :  */
/* Constante definissant la valeur booleenne VRAI
    */
#define TYCST__C_vrai  ! TYCST__C_faux

/*C C_TRUE :  */
/* Constant for boolean value TRUE
    */
#define TYCST__C_TRUE ! TYCST__C_FALSE

/*C C_str_faux :  */
/* Constante definissant la chaine FAUX
    */
#define TYCST__C_str_faux 	"FAUX"

/*C C_STR_FALSE :  */
/* Constant for string FALSE
    */
#define TYCST__C_STR_FALSE 	"FALSE"


/*C C_str_vrai :  */
/* Constante definissant la chaine VRAI
    */
#define TYCST__C_str_vrai 	"VRAI"

/*C C_STR_TRUE :  */
/* Constant for string TRUE
    */
#define TYCST__C_STR_TRUE "TRUE"

/*C C_nok :  */
/* Constante definissant un retour en erreur d'une fonction systeme. */
#define TYCST__C_nok -1

/*C C_NOK :  */
/* Constant for system command error */
#define TYCST__C_NOK -1

/*C C_ok :  */
/* Constante definissant un retour nominal d'une fonction systeme. */
#define TYCST__C_ok  0

/*C C_OK :  */
/* Constant for no system command error. */
#define TYCST__C_OK  0

/*C C_zero_double :  */
/* Constante definissant la precision d'un double. */
#define TYCST__C_zero_double  1e-12

/*C C_DOUBLE_ZERO :  */
/* Constant for double float precision. */
#define TYCST__C_DOUBLE_ZERO  1e-12

/*C MIN :  */
/* Macro de comparaison de deux valeurs
    */
#define TYCST__MIN(a, b)  (((a)<(b))?(a):(b))

/*C MIN :  */
/* Macro de comparaison de deux valeurs
    */
#define TYCST__MAX(a, b)  (((a)>(b))?(a):(b))

/*C MALLOC :  */
/* Macro d'allocation d'un espace memoire
    */
#define TYCST__MALLOC(taille)	calloc((taille),1)


/*C REALLOC :  */
/* Macro de realocation d'un espace memoire
    */
#define TYCST__REALLOC(pointeur,taille)	realloc((pointeur),(taille))


/*C FREE :  */
/* Macro de liberation d'un espace memoire
    */
#define TYCST__FREE(pt)	if ((pt) != NULL) { free((pt)) ; (pt)=NULL ; }


/*C NB_ELT :  */
/* Macro calculant le nombre d'elements d'un tableau
    */
#define TYCST__NB_ELT(tab)	(sizeof((tab))/sizeof((tab[0])))
#define TYCST__NB_ITEM(tab)  TYCST__NB_ELT((tab))

/*C STRTOINT2 :  */
/* Macro  convertissant une chaine en int2 
    */
#define TYCST__STRTOINT2(chaine)	(TYCST__T_int2)strtol((chaine),(char **)NULL,0)

/*C STRTOUINT2 :  */
/* Macro  convertissant une chaine en unsigned int2 
    */
#define TYCST__STRTOUINT2(chaine)	(TYCST__T_uint2)strtoul((chaine),(char **)NULL,0)

/*C STRTOINT4 :  */
/* Macro  convertissant une chaine en int4 
    */
#define TYCST__STRTOINT4(chaine)	(TYCST__T_int4)strtol((chaine),(char **)NULL,0)

/*C STRTOUINT4 :  */
/* Macro  convertissant une chaine en unsigned int4 
    */
#define TYCST__STRTOUINT4(chaine)	(TYCST__T_uint4)strtoul((chaine),(char **)NULL,0)

/*C STRTOREAL4 :  */
/* Macro  convertissant une chaine en  real4
    */
#define TYCST__STRTOREAL4(chaine)	(TYCST__T_real4)strtod((chaine),(char **)NULL)

/*C STRTOREAL8 :  */
/* Macro  convertissant une chaine en  real4
    */
#define TYCST__STRTOREAL8(chaine)	(TYCST__T_real8)strtod((chaine),(char **)NULL)

/*C STRTOBOOLEAN :  */
/* Macro  convertissant une chaine en  boolean
    */
#define TYCST__STRTOBOOL(chaine)	(TYCST__T_boolean)!strcmp((chaine),TYCST__C_str_vrai) ? TYCST__C_vrai : TYCST__C_faux



/*****************************************************************************/
/*                DEFINITIONS DES TYPES EXTERNES                             */
/*****************************************************************************/

/*T T_char :  */
/* type caractere signe code sur un octet */
typedef char TYCST__T_char;


/*T T_pt_char :  */
/* type pointeur sur caractere signe code sur un octet
   
    */
typedef TYCST__T_char* TYCST__T_pt_char;

/*T T_pt_file :  */
/* type pointeur sur fichier
   
    */
typedef FILE* TYCST__T_pt_file;

/*T T_void :  */
/* type void
   
    */
typedef void TYCST__T_void;


/*T T_pt_void :  */
/* type pointeur sur void
   
    */
typedef TYCST__T_void *TYCST__T_pt_void;


/*T T_pt_pt_void :  */
/* type pointeur sur pointeur sur void
   
    */
typedef TYCST__T_pt_void* TYCST__T_pt_pt_void;

/*T T_pt_pt_char :  */
/* type pointeur de pointeur sur caractere signe code sur un octet
   
    */
typedef TYCST__T_pt_char *TYCST__T_pt_pt_char;


/*T T_funct : */
/* Type fonction */
typedef void TYCST__T_funct;


/*T T_uchar :  */
/* Type caractere non signe code sur un octet
   
    */
typedef unsigned char TYCST__T_uchar;

/*T T_schar :  */
/* Type caractere signe code sur un octet
   
    */
typedef signed char TYCST__T_schar;


/*T T_pt_uchar :  */
/* Type pointeur sur caractere non signe code sur un octet
   
    */
typedef TYCST__T_uchar* TYCST__T_pt_uchar;


/*T T_int2 :  */
/* Type entier signe code sur 2 octets
   
    */
typedef short int TYCST__T_int2;


/*T T_pt_int2 :  */
/* Type pointeur sur entier signe code sur 2 octets
   
    */
typedef TYCST__T_int2* TYCST__T_pt_int2;


/*T T_uint2 :  */
/* Type entier non signe code sur 2 octets
   
    */
typedef unsigned short int TYCST__T_uint2;


/*T T_pt_uint2 :  */
/* Type pointeur sur entier non signe code sur 2 octets
   
    */
typedef TYCST__T_uint2* TYCST__T_pt_uint2;


/*T T_int4 :  */
/* Type entier signe code sur 4 octets
   
    */
typedef int TYCST__T_int4;


/*T T_pt_int4 :  */
/* Type pointeur sur entier signe code sur 4 octets
   
    */
typedef  TYCST__T_int4* TYCST__T_pt_int4;


/*T T_uint4 :  */
/* Type entier non signe code sur 4 octets
   
    */
typedef unsigned int TYCST__T_uint4;


/*T T_pt_uint4 :  */
/* Type pointeur sur entier non signe code sur 4 octets
   
    */
typedef  TYCST__T_uint4* TYCST__T_pt_uint4;


/*T T_long :   */
/* type long */
typedef  long TYCST__T_long;


/*T T_real4 :  */
/* Type reel  code sur 4 octets
   
    */
typedef  float TYCST__T_real4;


/*T T_pt_real4 :  */
/* Type pointeur sur reel  code sur 4 octets
   
    */
typedef  TYCST__T_real4* TYCST__T_pt_real4;


/*T T_real8 :  */
/* Type reel code sur 8 octets
   
    */
typedef double  TYCST__T_real8;


/*T T_pt_real8 :  */
/* Type pointeur sur reel code sur 8 octets
   
    */
typedef TYCST__T_real8*  TYCST__T_pt_real8;


/*T T_boolean :  */
/* Type booleen code sur 1 octet
   
    */
typedef char TYCST__T_boolean;


/*T T_pt_boolean :  */
/* Type pointeur sur booleen code sur 1 octet
   
    */
typedef TYCST__T_boolean* TYCST__T_pt_boolean;


/*T T_nom_fichier :  */
/* Type definissant un nom de fichier ( sans le chemin d'acces )
   
    */
typedef char TYCST__T_nom_fichier[TYCST__C_lg_nom_fichier +1];

/*T T_filename :  */
/* Type for file name (without path)
   
    */
typedef char TYCST__T_filename[TYCST__C_LG_FILE_NAME + 1];


/*T T_chemin_fichier :  */
/* Type definissant un chemin d'acces a un fichier
   
    */
typedef char TYCST__T_chemin_fichier[TYCST__C_lg_chemin_fichier +1];

/*T T_file_path :  */
/* Type for file path
   
    */
typedef char TYCST__T_file_path[TYCST__C_LG_FILE_PATH +1];


/*T T_nom_commande :  */
/* Type definissant un nom de commande systeme
   
    */
typedef char TYCST__T_nom_commande[TYCST__C_lg_nom_commande +1];

/*T T_command_name :  */
/* Type for a system command name
   
    */
typedef char TYCST__T_command_name[TYCST__C_LG_COMMAND_NAME +1];

/*T T_status :  */
/* Type for returned function status. */
/* Return status can be either TYCST__C_nok or TYCST__C_ok  */
typedef TYCST__T_int4 TYCST__T_status;



/* longueur des fichiers sans leur path */
#define TYCST__T_LG_NON_UNIX 80

/* longueur chaine de caracteres de longueur fixe */
//#define TYCST_T_LG_CHAINE_FIXE 255

//typedef char t_ChaineFixe[TYCST_T_LG_CHAINE_FIXE];

typedef char t_TYCST_FichierUnix[TYCST__T_LG_NON_UNIX];

#define SLEEP(j) {sleep (j); }

/*****************************************************************************/
/*              DECLARATIONS DES OPERATIONS EXTERNES (extern)                */
/*****************************************************************************/

/* NONE */


			/* FIN DE TYCST.h */
#endif

#ifdef __cplusplus
}
#endif

