#ifndef NAVIGATION_H
#define NAVIGATION_H

int navigation_ops_init();

int navigation_ops_intposvel( double time, double pos[3], double vel[3] );

void navigation_calatt( double yaw, double roll, double pitch, double att[3][3] );

int navigation_ops_metop_to_earth( 
   double time, double pos[3], double vel[3],
   int att_mode, double att[3][3], int nbpts,
   double *azim, double *elev,
   double *lat, double *lon, double *elev_sat, double *azim_sat,
   double *elev_sol, double *azim_sol, double* earthsateldist );
   
int navigation_ops_earth_to_metop( 
   double pos[3], double vel[3], int att_mode,
   double att[3][3], int nbpts, double *lat, double *lon,
   double *azim, double *elev );

int navigation_ops_invloc( 
   int att_mode,
   double att[3][3], double lat, double lon,
   double tfirst, double tlast, double reftime, 
   double *alpha, double *time,
   double *pixel, double *line );

#endif
