// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/JDBS/src/JDBS__GestionnaireActivite.h,v 1.3 2011/11/25 10:17:44 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : JDBS
//@ CLASSE : JDBS__GestionnaireActivite
//@
//@ Commentaire :
//@   Cette classe gere le service de diffusion des message JDB emis
//@   par les processus applicatifs.
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 30/03/2000 : C.LACAZE
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef JDBS__GestionnaireActivite_h
#define JDBS__GestionnaireActivite_h

//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__CGSCst.h"
#include "CMN__PGEServices.h"
#include "MSG__Connexion.h"
#include "TES__Evenement.h"
#include "JDB__Message.h"


class JDBS__GestionnaireActivite {
    
    /*=================================================================*/

 public:

    //
    // Constructeur
    //
    JDBS__GestionnaireActivite();
  
    //
    // Destructeur
    //
    ~JDBS__GestionnaireActivite();

    //
    // Accesseurs
    //

    //
    // Methodes publiques
    //
    void Initialiser(CMN__PGEServices* ptPGEServices);
    void ConnecterServeur(char *host, char *service);
    void Ecouter();
    void Terminer( bool flagFin);
    bool Terminer () { return m_FlagFin; };
    void TraiterMessage (const MSG__Message& message);
    void EnvoyerMessage (MSG__Message& message);

    /*=================================================================*/

 protected:

    //
    // Methodes protegees
    //
    
    //
    // Attributs proteges
    //


    /*=================================================================*/

 private:

    //
    // Methodes privees
    //
        
    //
    // Attributs prives
    //
    
    // Gestionnaire d'adresse
    MSG__Connexion    m_ConnexionServeur;
    
    // Flag de fin
    bool              m_FlagFin;
    
    // PGE services
    CMN__PGEServices* m_ptPGEServices;
};

#endif
