// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/MP/src/MP__GestionnaireStatus.h,v 1.3 2011/11/25 10:17:44 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : MP
//@ CLASSE : MP__GestionnaireStatus
//@
//@ Commentaire :
//@    Cette classe fournit les services de gestion de la liste 
//@    des HKTM status a transmettre au MCS.
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 21/03/2000 : A.MONTMORY
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ VERSION : 28/08/2002 : PBR
//@ Adapation a l'OPS-IASI
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef MP__GestionnaireStatus_h
#define MP__GestionnaireStatus_h

//
// Fichier include
//

#include <map>
#include "MP__HKTMStatus.h"


class MP__GestionnaireStatus {

/*====================================================================*/

public:

        //
        // Liste des status
        //
        typedef map<MP__HKTMStatus::t_IdStatus,
	            MP__HKTMStatus, 
		    less<MP__HKTMStatus::t_IdStatus> > 
		    t_ListeStatus;
	
        //
	// Constructeur
	//
	MP__GestionnaireStatus();
	
	//
	// Destructeur
	//
	~MP__GestionnaireStatus();

	//
	// Accesseurs
	//
        t_ListeStatus GetListeStatus() const { 
                                       return m_ListeStatus;
                                 };
	
	//
	// Methodes publiques
	//
	// Retourne le status de la version du logiciel
	MP__HKTMStatus InitialiserStatus();
	void AjouterStatus (MP__HKTMStatus &status);
	void GetStatus(const MP__HKTMStatus::t_IdStatus idStatus, 
	                MP__HKTMStatus& status);
        void SetStatus(const MP__HKTMStatus::t_IdStatus idStatus, 
		       const MP__HKTMStatus& status);	
        /*===================================================================*/
protected:
	//
	// Methodes protegees
	//

	//
	// Attributs proteges
	//

	/*===================================================================*/
private:
	//
	// Methodes privees
	//

	//
	// Attributs prives
	//
	
	// Liste des connexions gere dans le gestionnaire de connexion
	t_ListeStatus m_ListeStatus;
	
	
};

#endif
