// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/MSG/src/MSG__Abonnement.h,v 1.3 2011/11/25 10:17:44 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : MSG
//@ CLASSE : MSG__Abonnement
//@
//@ Commentaire :
//@    Ce fichier gere la classe MSG__Abonnement
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 21/03/2000 : A.MONTMORY
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef MSG__Abonnement_h
#define MSG__Abonnement_h

//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Commun.h"
#include "MSG__Message.h"


class MSG__Abonnement {

    /*=================================================================*/

 public:
    
    //
    // Constante
    //
    static const t_Chaine VERSION_CLASSE;
    
    //
    // Type d'action demandee
    //
    typedef enum  {
	UNKNOWN = 0,
	ABONNER = 1,
	DESABONNER = 2
    } e_TypeAction;	
    
    //
    // Constructeur
    //
    MSG__Abonnement();
    
    //
    // Destructeur
    //
    ~MSG__Abonnement();
    
    //
    // Accesseurs
    //
    t_ListeChaineTriee GetListeAdresse() const {return m_ListeAdresse;};
    void SetListeAdresse(const t_ListeChaineTriee listeAdresse)
	{m_ListeAdresse = listeAdresse;};
    t_Chaine GetUniqueAdresse() const {return m_UniqueAdresse;};
    void SetUniqueAdresse(const t_Chaine UniqueAdresse) 
	{m_UniqueAdresse = UniqueAdresse;};
    e_TypeAction GetAction() const {return m_Action;};
    void SetAction(const e_TypeAction Action) {m_Action = Action;};
    
    
    //
    // Methodes publiques
    //
    void Serialiser( MSG__Message& message);
    MSG__Message Serialiser();
    void Deserialiser(const MSG__Message& message);


    /*=================================================================*/

 protected:

    //
    // Methodes protegees
    //
    
    //
    // Attributs proteges
    //

    
    /*=================================================================*/

 private:

    //
    // Methodes privees
    //
    
    //
    // Attributs prives
    //
    
    // Liste des adresses auxquelles il faut s'abonner
    t_ListeChaineTriee m_ListeAdresse;
    
    // Identificateur unique de la connexion
    t_Chaine m_UniqueAdresse;
    
    // Action demandee
    e_TypeAction m_Action;		
};

#endif
