// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/MSGS/src/MSGS__Adresse.cc,v 1.3 2011/11/25 10:17:44 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : MSG
//@ CLASSE : MSGS__Adresse
//@
//@ Commentaire :
//@    Ce fichier gere la classe MSGS__Adresse
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 21/03/2000 : A.MONTMORY
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

//
// Fichiers include
//

// STL

// Standard

// Projet
#include "ERR__Exception.h"
#include "MSGS__Adresse.h"


//=====================================================================
//                        METHODES PUBLIQUES
//=====================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : MSGS__Adresse
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
MSGS__Adresse::MSGS__Adresse()
{
}


//@ ------------------------------------------------------------------*/
//@ Methode : ~MSGS__Adresse
//@
//@ Description : Destructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
MSGS__Adresse::~MSGS__Adresse()
{
}


//@ ------------------------------------------------------------------*/
//@ Methode : AjouterCnxDiffusion
//@
//@ Description : Permet d'ajouter une connexion de diffusion
//@               pour cette adresse logique
//@
//@ Parametres :
//@               (ENTREE) connexion : Connexion a rajouter
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void MSGS__Adresse::AjouterCnxDiffusion(const MSG__Connexion& connexion)
{
  //@ Insertion de la connexion dans la collection
  m_ListeCnx.insert (m_ListeCnx.end(),connexion);
}


//@ ------------------------------------------------------------------*/
//@ Methode : EnleverCnxDiffusion
//@
//@ Description : Permet d'enlever une connexion de diffusion
//@               pour cette adresse logique
//@
//@ Parametres :
//@               (ENTREE) connexion : Connexion a enlever
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void MSGS__Adresse::EnleverCnxDiffusion(const MSG__Connexion& connexion)
{
  //@ Suppression de la connexion dans la collection
  t_ListeCnx::iterator pInfo;
  for (pInfo = m_ListeCnx.begin(); pInfo != m_ListeCnx.end() ; pInfo++) 
    {
      if (pInfo->GetSocket().GetSocketDescripteur() == 
	  connexion.GetSocket().GetSocketDescripteur())
	{
	  m_ListeCnx.erase (pInfo);
	  break;
	} 
    }  
}
