// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/MSGS/src/MSGS__Adresse.h,v 1.3 2011/11/25 10:17:44 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : MSG
//@ CLASSE : MSGS__Adresse
//@
//@ Commentaire :
//@    Ce fichier gere la classe MSGS__Adresse
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 21/03/2000 : A.MONTMORY
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef MSGS__Adresse_h
#define MSGS__Adresse_h

//
// Fichiers include
//

// STL
#include <vector>

// Standard

// Projet
#include "CMN__Commun.h"
#include "MSG__Connexion.h"


class MSGS__Adresse {

    /*=================================================================*/

 public:
    
    //
    // Identificateur d'une adresse
    //
    typedef t_Chaine t_Adresse;
    
    //
    // Liste des connexions
    //
    typedef vector<MSG__Connexion> t_ListeCnx;
    
    //
    // Constructeur
    //
    MSGS__Adresse();
    
    //
    // Destructeur
    //
    ~MSGS__Adresse();
    
    //
    // Accesseurs
    //
    t_ListeCnx GetListeCnx() const {return m_ListeCnx;};
    t_Adresse  GetName() const {return m_LogicalName;};
    void       SetName(const t_Adresse name) {m_LogicalName = name;};
    
    //
    // Methodes publiques
    //
    void AjouterCnxDiffusion(const MSG__Connexion& connexion);
    void EnleverCnxDiffusion(const MSG__Connexion& connexion);
    bool EstVide() {return (m_ListeCnx.empty());};
    

    /*=================================================================*/

 protected:
    
    //
    // Methodes protegees
    //
    
    //
    // Attributs proteges
    //

    /*=================================================================*/

 private:
    
    //
    // Methodes privees
    //
    
    //
    // Attributs prives
    //
    
    // Nom logique de l'adresse
    t_Adresse  m_LogicalName;
    
    // Liste des connexions attachees a adresse
    t_ListeCnx m_ListeCnx;
};

#endif
