// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/MSGS/src/MSGS__GestionnaireActivite.h,v 1.3 2011/11/25 10:17:44 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : MSG
//@ CLASSE : MSGS__GestionnaireActivite
//@
//@ Commentaire :
//@    Ce fichier gere la classe MSGS__GestionnaireActivite
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 21/03/2000 : A.MONTMORY
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef MSGS__GestionnaireActivite_h
#define MSGS__GestionnaireActivite_h

//
// Fichiers include
//

// STL
#include <list>

// Standard

// Projet
#include "CMN__Commun.h"
#include "MSGS__GestionnaireConnexion.h"
#include "MSGS__GestionnaireAdresse.h"


class MSGS__GestionnaireActivite {

    /*=================================================================*/

 public:
    
    //
    // Type de la connexion
    //
    typedef enum {
	CNX_UNKNOWN = 0,
	CNX_SERVEUR = 1,
	CNX_CLIENTE =2 	
    } e_TypeConnexion;
	
    //
    // Constructeur
    //
    MSGS__GestionnaireActivite();
    
    //
    // Destructeur
    //
    ~MSGS__GestionnaireActivite();
    
    //
    // Methodes publiques
    //
    void CreerConnexionServeur(char *host, char *service);
    void Ecouter();
    void TraiterMessage(const MSG__Connexion& connexionCliente,
			MSG__Message& message);
    void RouterMessage( MSG__Message& message);
    void Abonner(const MSG__Connexion& connexionCliente,
		 t_ListeChaineTriee listeAdresse);
    void Desabonner(const MSG__Connexion& connexionCliente,
		    t_ListeChaineTriee listeAdresse);
    void SupprimerConnexion (MSG__Connexion& connexionCliente);
    void Terminer( bool flagFin) {m_FlagFin = flagFin;};
    bool Terminer () {return m_FlagFin;};


    /*=================================================================*/

 protected:
    
    //
    // Methodes protegees
    //
    
    //
    // Attributs proteges
    //
    

    /*=================================================================*/

 private:

    //
    // Methodes privees
    //
    
    //
    // Attributs prives
    //
	
    // Gestionnaire de connexion
    MSGS__GestionnaireConnexion m_Connexions;

    // Gestionnaire d'adresse
    MSGS__GestionnaireAdresse   m_Adresses;
    
    // Connexion serveur
    MSG__Connexion              m_ConnectionServeur;
    
    // Flag de fin
    bool m_FlagFin;
};

#endif
