// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/MSGS/src/MSGS__GestionnaireAdresse.h,v 1.3 2011/11/25 10:17:44 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : MSG
//@ CLASSE : MSGS__GestionnaireAdresse
//@
//@ Commentaire :
//@    Ce fichier gere la classe MSGS__GestionnaireAdresse
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 21/03/2000 : A.MONTMORY
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef MSGS__GestionnaireAdresse_h
#define MSGS__GestionnaireAdresse_h

//
// Fichiers include
//

// STL
#include <map>

// Standard

// Projet
#include "CMN__Commun.h"
#include "MSGS__Adresse.h"


class MSGS__GestionnaireAdresse {

    /*=================================================================*/

 public:
    
    //
    // Type de l'adresse
        //
    typedef enum {
	CNX_UNKNOWN = 0,
	CNX_SERVEUR = 1,
	CNX_CLIENTE =2 	
    } e_TypeAdresse;
    
    //
    // Liste des Adresses
    //
    typedef map<MSGS__Adresse::t_Adresse,MSGS__Adresse,less<t_Chaine> > 
	t_ListeAdresse;
    
    //
    // Constructeur
    //
    MSGS__GestionnaireAdresse();
    
    //
    // Destructeur
    //
    ~MSGS__GestionnaireAdresse();
    
    //
    // Accesseurs
    //
    t_ListeAdresse GetListeAdresse() const {return m_ListeAdresse;};
    
    //
    // Methodes publiques
    //
    void AjouterAdresse (MSGS__Adresse::t_Adresse name, 
			 const MSGS__Adresse &adresse);
    void EnleverAdresse (const MSGS__Adresse::t_Adresse name);
    MSGS__Adresse& GetAdresse  (const MSGS__Adresse::t_Adresse name);
    bool ExisteAdresse  (const MSGS__Adresse::t_Adresse name);
    bool ExisteAdresse  (const MSGS__Adresse::t_Adresse name,
			 MSGS__Adresse& adresse);


    /*=================================================================*/

 protected:
    
    //
    // Methodes protegees
    //
    
    //
    // Attributs proteges
    //
    
    
    /*=================================================================*/

 private:

    //
    // Methodes privees
    //
    
    //
    // Attributs prives
    //
    
    // Liste des Adresses gerees dans le gestionnaire
    t_ListeAdresse m_ListeAdresse;
};

#endif
