// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/MSGS/src/MSGS__GestionnaireConnexion.h,v 1.3 2011/11/25 10:17:44 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : MSG
//@ CLASSE : MSGS__GestionnaireConnexion
//@
//@ Commentaire :
//@    Ce fichier gere la classe MSGS__GestionnaireConnexion
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 21/03/2000 : A.MONTMORY
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef MSGS__GestionnaireConnexion_h
#define MSGS__GestionnaireConnexion_h

//
// Fichiers include
//

// STL
#include <map>

// Standard

// Projet
#include "MSG__Connexion.h"


class MSGS__PaireCnxAdresse {

    /*=================================================================*/

public:

    //
    // Constructeur
    //
    
    //
    // Destructeur
    //
    
    //
    // Accesseurs
    //
    void SetConnexion(const MSG__Connexion& connexion) {m_Connexion = connexion;};
    MSG__Connexion GetConnexion () const {return m_Connexion;};	 
    void SetListe(const t_ListeChaineTriee& liste) {m_ListeAdresse = liste;};
    t_ListeChaineTriee GetListe() const {return m_ListeAdresse;};
    
    //
    // Methodes publiques
    //

        
    /*=================================================================*/

private:
    
    //
    // Methodes privees
    //
    
    //
    // Attributs prives
    //
    
    // Connexion
    MSG__Connexion m_Connexion;
    
    // Liste des adresses associees a la connexion
    t_ListeChaineTriee m_ListeAdresse;
};


class MSGS__GestionnaireConnexion {
    
    /*=================================================================*/

public:
    
    //
    // Type de la connexion
    //
    typedef enum {
	CNX_UNKNOWN = 0,
	CNX_SERVEUR = 1,
	CNX_CLIENTE =2 	
    } e_TypeConnexion;
    
    //
    // Liste des connexions
    //
    typedef map<MSG__Socket::t_SocketDescripteur,
	MSGS__PaireCnxAdresse, 
	less<MSG__Socket::t_SocketDescripteur> > t_ListeConnexion;
    
    //
    // Constructeur
    //
    MSGS__GestionnaireConnexion();
    
    //
    // Destructeur
    //
    ~MSGS__GestionnaireConnexion();

    //
    // Accesseurs
    //
    t_ListeConnexion GetListeConnexion() const {return m_ListeConnexion;};
	
    //
    // Methodes publiques
    //
    void AjouterConnexion(const MSG__Connexion &connexion);
    void EnleverConnexion(const MSG__Connexion &connexion);
    void GetCnxParDescripteur(const MSG__Socket::t_SocketDescripteur descripteur, 
	                          MSG__Connexion &connexion);
    t_ListeChaineTriee GetAdresses(const MSG__Connexion &connexion);
    void SetAdresses (const MSG__Connexion &connexion, 
		      t_ListeChaineTriee adresses);
    void SubAdresses (const MSG__Connexion &connexion, 
		      t_ListeChaineTriee adresses);
	

    /*=================================================================*/

 protected:
    
    //
    // Methodes protegees
    //
    
    //
    // Attributs proteges
    //
    
	
    /*=================================================================*/

 private:
    
    //
    // Methodes privees
    //
    
    //
    // Attributs prives
    //
    
    // Liste des connexions gerees dans le gestionnaire de connexion
    t_ListeConnexion m_ListeConnexion;
};

#endif
