
include $(TOPDIR)/../Makefile.local
include $(TOPDIR)/../Makefile.ARCH

EXT_INCLUDES=-I$(TOPDIR)/EXT/navigation/include   \
             -I$(TOPDIR)/EXT/MLA/include          \
             -I$(TOPDIR)/EXT/env/include          \
             -I$(TOPDIR)/EXT/misc/include         \
             -I$(TOPDIR)/EXT/lapack-lite/include  \
             -I$(TOPDIR)/EXT/ngmath-lite/include  \
             -I$(TOPDIR)/EXT/spline-lite/include  \
             -I$(TOPDIR)/EXT/numrec-lite/include  \
             -I$(TOPDIR)/EXT/fortran-lock/include  

EXT_LIBS=-L$(TOPDIR)/EXT/navigation/lib -lnavigation     \
         -L$(TOPDIR)/EXT/MLA/lib -lMLA                   \
         -L$(TOPDIR)/EXT/env/lib -lenv                   \
         -L$(TOPDIR)/EXT/ngmath-lite/lib -lngmath-lite   \
         -L$(TOPDIR)/EXT/lapack-lite/lib -llapack-lite   \
         -L$(TOPDIR)/EXT/spline-lite/lib -lspline-lite   \
         -L$(TOPDIR)/EXT/numrec-lite/lib -lnumrec-lite   \
         -L$(TOPDIR)/EXT/fortran-lock/lib -lfortran-lock

LOCAL_INCLUDES=$(AAPP_INCLUDES)            \
               $(XRCS_INCLUDES)            \
               $(FFT_INCLUDES)             \
               $(ESSL_INCLUDES)            \
               $(METOPLIB_INCLUDES)
              
LOCAL_LIBS=$(AAPP_LIBS)                    \
           $(XRCS_LIBS)                    \
           $(FFT_LIBS)                     \
           $(ESSL_LIBS)                    \
           $(METOPLIB_LIBS)



INCLUDES=-I. -I$(TOPDIR)/CMN/src -I$(TOPDIR)/CMN/OBS/src -I$(TOPDIR)/CMN/PRS/src -I$(TOPDIR)/CMN/DAT/src -I$(TOPDIR)/ENV/src -I$(TOPDIR)/MSG/src -I$(TOPDIR)/MSGS/src -I$(TOPDIR)/JDBS/src -I$(TOPDIR)/TES/src -I$(TOPDIR)/MP/src -I$(TOPDIR)/SD/DON/src -I$(TOPDIR)/SD/TAC/src -I$(TOPDIR)/SD/BAS/src -I$(TOPDIR)/SD/ACT/src -I$(TOPDIR)/SD/SRV/src -I$(TOPDIR)/SD/EVT/src -I$(TOPDIR)/SD/UTL/src -I$(TOPDIR)/SD/ALG/src -I$(TOPDIR)/SD/FRW/src -I$(TOPDIR)/SD/GES/src -I$(TOPDIR)/WOM/src $(LOCAL_INCLUDES) $(EXT_INCLUDES)
CFLAGS=$(ARCH_CFLAGS) -DOPS_RELEASE="\"OPS_V8.0-AAPP-l-20180118\""              \
       $(AAPP_FLAGS) $(XRCS_FLAGS) $(FFT_FLAGS) $(ESSL_FLAGS) \
       $(METOPLIB_FLAGS) 
CPPFLAGS=$(ARCH_CPPFLAGS) -DOPS_RELEASE="\"OPS_V8.0-AAPP-l-20180118\""            \
         $(AAPP_FLAGS) $(XRCS_FLAGS) $(FFT_FLAGS) $(ESSL_FLAGS) \
	 $(METOPLIB_FLAGS) 
FFLAGS=$(ARCH_FFLAGS) -DOPS_RELEASE="\"OPS_V8.0-AAPP-l-20180118\""              \
       $(AAPP_FLAGS) $(XRCS_FLAGS) $(FFT_FLAGS) $(ESSL_FLAGS) \
       $(METOPLIB_FLAGS) 
LDFLAGS=$(ARCH_LDFLAGS)
LIBS=$(TOPDIR)/SD/GES/src/SD_GES.a $(TOPDIR)/SD/ALG/src/SD_ALG.a $(TOPDIR)/SD/UTL/src/SD_UTL.a $(TOPDIR)/SD/EVT/src/SD_EVT.a $(TOPDIR)/SD/SRV/src/SD_SRV.a $(TOPDIR)/SD/ACT/src/SD_ACT.a $(TOPDIR)/SD/BAS/src/SD_BAS.a $(TOPDIR)/SD/TAC/src/SD_TAC.a $(TOPDIR)/SD/DON/src/SD_DON.a $(TOPDIR)/MSG/src/MSG.a $(TOPDIR)/ENV/src/ENV.a $(TOPDIR)/CMN/DAT/src/CMN_DAT.a $(TOPDIR)/CMN/PRS/src/CMN_PRS.a $(TOPDIR)/CMN/OBS/src/CMN_OBS.a $(TOPDIR)/CMN/src/CMN.a $(TOPDIR)/SD/GES/src/SD_GES.a $(TOPDIR)/SD/ALG/src/SD_ALG.a $(TOPDIR)/SD/UTL/src/SD_UTL.a $(TOPDIR)/SD/EVT/src/SD_EVT.a $(TOPDIR)/SD/SRV/src/SD_SRV.a $(TOPDIR)/SD/ACT/src/SD_ACT.a $(TOPDIR)/SD/BAS/src/SD_BAS.a $(TOPDIR)/SD/TAC/src/SD_TAC.a $(TOPDIR)/SD/DON/src/SD_DON.a $(TOPDIR)/MSG/src/MSG.a $(TOPDIR)/ENV/src/ENV.a $(TOPDIR)/CMN/DAT/src/CMN_DAT.a $(TOPDIR)/CMN/PRS/src/CMN_PRS.a $(TOPDIR)/CMN/OBS/src/CMN_OBS.a $(TOPDIR)/CMN/src/CMN.a 

depend: 
	perl $(TOPDIR)/../Makedepend.PL -- -Y $(CFLAGS) $(INCLUDES) -- $(SRC)

all: lib bin cat 

lib: $(LIB)

bin: $(BIN)

cat: $(CAT)

$(BIN): $(LIBS_BIN) $(LIB)
	$(LD) $(LDFLAGS) -o $(BIN) $(LIB) $(LIBS_BIN) $(EXT_LIBS) $(LOCAL_LIBS) $(ARCH_LIBS)

$(LIB): $(OBJ)
	$(AR) $(LIB) $(OBJ)

$(CAT): $(MSG)
	$(GENCAT) $(CAT) $(MSG)

clean: arch_clean
	\rm -f *.o *.a $(BIN) Makefile.bak *.cat


install: installbin installcat

installbin: $(TOPDIR)/../run/OPS/bin/$(BIN)

installcat: $(TOPDIR)/../run/OPS/conf/$(CAT)

$(TOPDIR)/../run/OPS/bin/$(BIN): $(BIN)
	\mkdir -p $(TOPDIR)/../run/OPS/bin
	\cp $(BIN) $(TOPDIR)/../run/OPS/bin/$(BIN)

$(TOPDIR)/../run/OPS/conf/$(CAT): $(CAT)
	\mkdir -p $(TOPDIR)/../run/OPS/conf
	\cp $(CAT) $(TOPDIR)/../run/OPS/conf/$(CAT)

.SUFFIXES: .o .cc .c .h

.cc.o:
	$(CPP) $(INCLUDES) $(CPPFLAGS) -c $*.cc

.c.o:
	$(CC) $(INCLUDES) $(CFLAGS) -c $*.c

.C.c:
	$(TOPDIR)/../Fortran.PL $*.C

