// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/ACT/src/SD_ACT_Action.h,v 1.3 2011/11/25 10:17:44 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_ACT
//@ CLASSE : SD_ACT_Action
//@
//@ Commentaire :
//@    Fichier d'entete de la classe SD_ACT_Action
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 09/09/1999 : SAS
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ SMM-M4-FA-76-CN    24/01/00    Rajout du producteur dans journaliserWarning
//@ --------------------------------------------------------------------                                   et JournaliserAlarme
//@ SMM-M4-FA-91-CN    26/01/00    Appel de JournaliserWarning, on n'utilise plus JournaliserAnomalie
//@ --------------------------------------------------------------------
//@ SMM-M4-FA-61-CN    27/01/00    Ajout d'un statut d'action
//@ --------------------------------------------------------------------
//@ SMM-M4-FA-158-CN   08/03/00 Un symptome booleen verifie doit avoir la valeur a 1
//@ --------------------------------------------------------------------
//@ SMM-M4-FA-2321-CN   30/08/01    GRT  Rajout de la fonction ModifierPrivilegesDuProcessus
//@ --------------------------------------------------------------------
//@ SMM-M4-FA-2555-CN   12/01/02 GRT On utilise des traces collectives
//@ --------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Adaptation a l'OPS : ajout des parametres de simulation
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_ACT_Action_h
#define SD_ACT_Action_h

//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN_DAT_Evenement.h"
#include "MP__HKTMStatus.h"


class SD_TAC_Tache;

class SD_ACT_Action {
    
    /*================================================================*/

 public:
    
    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    SD_ACT_Action();
    SD_ACT_Action(SD_TAC_Tache* tache);
        
    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    virtual ~SD_ACT_Action();

    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    SD_TAC_Tache* Tache();

    void     NomAction(t_Chaine nomAction) {m_NomAction = nomAction;};
    t_Chaine NomAction() {return m_NomAction;};

    t_CMN__Statut StatutAction() {return m_StatutAction;}; 

    void Simulation(int simulation) {m_Simulation = simulation;};
    
    
    //////////////////////////////// 
    // Methodes publiques
    //////////////////////////////// 
    virtual void   Executer(); 
    virtual void   VerifierSymptome(); 
    t_CMN__Booleen PeutEtreEnchainee(); 
    void           TracerDebut();
    void           TracerFin();


    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////
    void JournaliserEvenement(t_Chaine libelle,
                              SD__Message::e_TypeMessageJDB typeEvt);
    void EnvoyerSensingTime(t_TableauDate& sensingTime);

        
    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////
    SD_TAC_Tache*     m_Tache;
    t_Chaine          m_NomAction;
    t_CMN__Booleen    m_PeutEtreEnchainee;
    t_CMN__Statut     m_StatutAction;
    int               m_Simulation;


    /*================================================================*/

 private:
    
    ////////////////////////////////
    // Constantes
    ////////////////////////////////
    static const t_Chaine LIBELLE_DEBUT_ACTION;
    static const t_Chaine LIBELLE_FIN_ACTION;
    static const int      NB_TYPE_TM;

    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////
        
    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
};

#endif
