static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/ACT/src/SD_ACT_ActionDeTest.cc,v 1.3 2011/11/25 10:17:44 dpauly Exp $";
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_ACT
//@ CLASSE : SD_ACT_ActionDeTest
//@ 
//@ Commentaire :
//@    Ce module gere la classe SD_ACT_ActionDeTest utilisee en test
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 05/10/1999 : SAS
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

//
// Fichiers include
//

// STL
#include <iostream>

// Standard

// Projet
#include "CMN__Commun.h"
#include "SD_TAC_Tache.h"
#include "SD_ACT_ActionDeTest.h"


//
// Definition des constantes
//


//======================================================================
//                                      METHODES PUBLIQUES
//======================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : SD_ACT_ActionDeTest
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               (ENTREE) tache : Tache pere de l'action
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_ACT_ActionDeTest::SD_ACT_ActionDeTest(SD_TAC_Tache* tache) :
  SD_ACT_Action(tache)
{
  //@ Memoriser la tache parente de l'action
  m_Tache             = tache;
  m_PeutEtreEnchainee = CMN__FAUX;
  m_Simulation        = 0;
}


//@ ------------------------------------------------------------------*/
//@ Methode : ~SD_ACT_ActionDeTest
//@
//@ Description : Destructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_ACT_ActionDeTest::~SD_ACT_ActionDeTest()
{
}


//@ ------------------------------------------------------------------*/
//@ Methode : Executer
//@
//@ Description : Traitement principal de l'action
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_ACT_ActionDeTest::Executer()
{
  //@ Methode virtuelle surchargee
  //@ Pour test seulement...

#ifdef OPS_DEBUG
  for (int i=0; i<10; i++)
    {
      cerr << "Action de test pour la tache: " << Tache()->Id() << endl;
      sleep(3);
    }
#endif

 
  //@ Invoquer la verification des symptomes une fois l'action
  //@ executee
  VerifierSymptome();
}


//@ ------------------------------------------------------------------*/
//@ Methode : VerifierSymptome
//@
//@ Description : Verifie si les symptomes associes a l'action sont
//@               en erreur ou non
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_ACT_ActionDeTest::VerifierSymptome()
{
  //@ Methode virtuelle a surcharger dans les classes derivees
  //@ Les symptomes controles sont specifiques a l'action
  m_PeutEtreEnchainee = CMN__VRAI;
}


//======================================================================
//                                      METHODES PRIVEES
//======================================================================

