static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/ACT/src/SD_ACT_VerificateurSymptome.cc,v 1.3 2011/11/25 10:17:44 dpauly Exp $";
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_ACT
//@ CLASSE : SD_ACT_VerificateurSymptome
//@
//@ Commentaire :
//@    Ce module gere la classe SD_ACT_VerificateurSymptome
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 09/09/1999 : SAS
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Commun.h"
#include "SD_ACT_VerificateurSymptome.h"


//
// Definition des constantes
//


//======================================================================
//                                      METHODES PUBLIQUES
//======================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : SD_ACT_VerificateurSymptome
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               (ENTREE) pAction : Action dont la verification de
//@                                  symptome devra etre declenchee
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_ACT_VerificateurSymptome::SD_ACT_VerificateurSymptome(SD_ACT_Action*
                                                         pAction)
{
  //@ On memorise l'action a controler
  m_pAction = pAction;
}


//@ ------------------------------------------------------------------*/
//@ Methode : ~SD_ACT_VerificateurSymptome
//@
//@ Description : Destructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_ACT_VerificateurSymptome::~SD_ACT_VerificateurSymptome()
{
  //@ SI l'action existe
  if (m_pAction != NULL)
    {
      //@ alors on verifie les symptomes pour cette action
      m_pAction->VerifierSymptome();
    }
  //@ FIN SI
}
