//$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/BAS/src/SD_BAS_AUXLibESSL.h,v 1.1 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Component : SD_BAS
//@ MODULE : SD_BAS_AUXLibESSL
//@
//@ Comment :
//@   (Meteo-france)
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_BAS_AUX_LIBESSL_H
#define SD_BAS_AUX_LIBESSL_H

#ifdef OPS_USE_FFTW
#include "fftw3.h"
#endif

#ifdef OPS_USE_FFT_NUMREC
#include "fft_numrec.h"
#endif

#ifdef OPS_USE_FFT_FFTPACK
#include "dfftpack.h"
#endif

#include "SD_BAS_OPS_Essl.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
#ifdef OPS_USE_ESSL
  double * aux1;
  double * aux2;
  int naux1;
  int naux2;
#endif
#ifdef OPS_USE_FFTW
  fftw_plan plan;
  double* in;
  dcmplx* out;
#endif
#ifdef OPS_USE_FFT_NUMREC
  int dummy;  /* So that we do not have an empty struct */
#endif
#ifdef OPS_USE_FFT_FFTPACK
  dcmplx * wsave;
#endif
} AUX_SD_BAS_FFT1DirDR2C;

typedef struct {
#ifdef OPS_USE_ESSL
  double * aux12;
  double * aux22;
  int naux1;
  int naux2;
#endif
#ifdef OPS_USE_FFTW
  fftw_plan plan;
  dcmplx* in;
  dcmplx* out;
#endif
#ifdef OPS_USE_FFT_NUMREC
  int dummy; /* So that we do not have an empty struct */
#endif
#ifdef OPS_USE_FFT_FFTPACK
  dcmplx * wsave;
#endif
} AUX_SD_BAS_FFT1DirInvDC2C;

typedef struct {
#ifdef OPS_USE_ESSL
  int dummy;
#endif
#ifdef OPS_USE_FFTW
  fftw_plan plan;
  dcmplx* in;
  double* out;
#endif
#ifdef OPS_USE_FFT_NUMREC
  int dummy;
#endif
} AUX_SD_BAS_FFT1InvDC2R;

typedef struct {
#ifdef OPS_USE_ESSL
  double * auxi;
#else
  double *yp;
#endif
} AUX_SD_BAS_InterpLineaire1D;


#undef USE_SPLINE_LITE
#undef USE_SPLINE_NGMATH
#define USE_SPLINE_NUMREC

typedef struct {
#ifdef OPS_USE_ESSL
  double *y2;
#else
#ifdef USE_SPLINE_LITE
  double *as;
#endif
#ifdef USE_SPLINE_NGMATH
  int lintrvl;
  double *yp;
#endif
#ifdef USE_SPLINE_NUMREC
  double *y2;
#endif
#endif
} AUX_SD_BAS_InterpSpline1D;

AUX_SD_BAS_FFT1DirDR2C * get_AUX_SD_BAS_FFT1DirDR2C();

void free_AUX_SD_BAS_FFT1DirDR2C( AUX_SD_BAS_FFT1DirDR2C * );

AUX_SD_BAS_FFT1InvDC2R * get_AUX_SD_BAS_FFT1InvDC2R();

void free_AUX_SD_BAS_FFT1InvDC2R( AUX_SD_BAS_FFT1InvDC2R * );

AUX_SD_BAS_FFT1DirInvDC2C * get_AUX_SD_BAS_FFT1DirInvDC2C();

void free_AUX_SD_BAS_FFT1DirInvDC2C( AUX_SD_BAS_FFT1DirInvDC2C * );

AUX_SD_BAS_InterpLineaire1D * get_AUX_SD_BAS_InterpLineaire1D();
void free_AUX_SD_BAS_InterpLineaire1D( AUX_SD_BAS_InterpLineaire1D * );

AUX_SD_BAS_InterpSpline1D * get_AUX_SD_BAS_InterpSpline1D();
void free_AUX_SD_BAS_InterpSpline1D( AUX_SD_BAS_InterpSpline1D * );

#ifdef __cplusplus
};
#endif

#endif
