//$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/BAS/src/SD_BAS_AVHRR.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Component : SD_BAS
//@ MODULE : SD_BAS_AVHRR
//@
//@ Comment :
//@    include file for the SD_BAS_AVHRR class
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-148-CN : 10/11/2004 : B.MASSART
//@ Mise a jour de SD_BAS_AVHRR_VERSION = 6.4. Voir IA-2100-FC-148-THA.
//@ --------------------------------------------------------------------
//@ FA-ID :IA--CR-2100-257-CNE : 1/02/2005 : JL PASCAL
//@ Mise a jour de SD_BAS_AVHRR_VERSION = 4.0 selon EUM.EPS.SYS.TEN.02.014
//@ Mise a jour de NP a 102 a 103
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-159-CN : 26/05/2005 : JL. PASCAL
//@ modif suite a portage linux
//@ fiche de correction correspondante : IA-2100-FC-159-THA
//@ --------------------------------------------------------------------
//@ FA-ID :IA--CR-2100-269-CNE : 08/06/2005 : JL PASCAL
//@ test du nombre de pixel AVHRR et nombre de point de geoloc
//@ fiche de correction correspondante : IA-2100-FC-269-THA
//@ --------------------------------------------------------------------
//@ MODIFIED 14 Juin 2006 for WorkAround-V3.5.4
//@ --------------------------------------------------------------------
//@ DM-ID :IA-CR-2100-306-CNE : 15/09/2006 : C.MERIGUET
//@ Mise a jour de SD_BAS_AVHRR_VERSION, la version passe a 10.0
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2528(DM-2100-OPS) : 17/03/2009 : S. BRUNEL
//@ Ajouter les informations sur les nuages et la surface obtenue
//@ par AVHRR dans le produit L1C (Day 2,point 9)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_BAS_AVHRR_h
#define SD_BAS_AVHRR_h


// inserer ici les fichiers include 
#include "SD_BAS_Global.h"
#include "SD_BAS_Produits.h"


//====================================================================*/
//   External define  Declarations
//====================================================================*/

//====================================================================*/
// Constant Declaration 
//====================================================================*/

#define SD_BAS_ERR_BASE_AVHRR SD_BAS_ERR_BASE_AVHRR
#define SD_BAS_ERR_VERSION_AVHRR  (SD_BAS_ERR_BASE_AVHRR + 1)


/* cvs! CR257 */
#define SD_BAS_SIZE_OF_DATA_GEOLOC 103 /* CR257 */
#define SD_BAS_SAMPLE_OF_DATA_GEOLOC 20 /* CR269 pour le test dans le SPHR*/
//#define SD_BAS_SIZE_OF_DATA_GEOLOC 102 

// FT-2765
static const int SD_BAS_ERR_SET_AVHRR = 1;
// ...FT-2765

//====================================================================*/
// Exported types Declaration  
//====================================================================*/
// les valeurs doivent etre au depart initialises a 0 et les flag a faux
 

//CR 269 decodage du SPHR
//--------------------------------------------------------------------*/
// structure contenant les informations generales issues d'un SPHR de N1b 
//--------------------------------------------------------------------*/
// attention l'ordre suivant doit correspondre a l'ordre dans le fichier
// ASCII de decommutation
typedef enum  {
		AVHRR_EARTH_VIEW_PER_SCAN_LINE=0,
		AVHRR_NAV_SAMPLE_RATE=1
		} e_SD_BAS_IND_SPHRAVHRR;

//--------------------------------------------------------------------*/
// structure contenant les informations generales issues d'un MDR de N1b 
//--------------------------------------------------------------------*/
// attention l'ordre suivant doit correspondre a l'ordre dans le fichier
// ASCII de decommutation
typedef enum  {
		AVHRR_LONGUEURREC=0,
		AVHRR_OFFSET=1,
		AVHRR_VALIDREC=2,
		AVHRR_DATEDEB=3,
	 	AVHRR_DATEFIN=4,
		AVHRR_FLAG=5
		} e_SD_BAS_IND_DonGenAVHRR;


/* valeur possible pour ses bit 7 a 13 de DIGITAL_B_DATA */
typedef enum  {
  CHANNEL_3A=119, /* 1101110 */
  CHANNEL_3B=110  /* 1110111 */
} e_DIGITAL_B_DATA;

/* utilise pour CG9 */
typedef enum  {
  SELECTED_CHANNEL_3B=0, 
  SELECTED_CHANNEL_3A=1
} e_SELECTED_CHANNEL;

/* valeur possible pour ses bit 2 a 7 de QUALITY_INDICATOR  */
typedef enum  {
  QUALITY_INDICATOR_NULL = 0,
  QUALITY_INDICATOR_NOM  = 25
}  e_QUALITY_INDICATOR;

//--------------------------------------------------------------------*/
// structure contenant les informations codees issues d'un MDR de AVHRR
//--------------------------------------------------------------------*/
// attention l'ordre suivant doit correspondre a l'ordre dans le fichier
// ASCII de decommutation
typedef enum  {
		AVHRR_DEGRADED_INST_MDR,
		AVHRR_DEGRADED_PROC_MDR,
		AVHRR_EARTH_VIEW_PER_SCANLINE,
		AVHRR_NAVIGATION_STATUS,
		AVHRR_NUM_NAVIGATION_POINTS,
		AVHRR_EARTH_LOCATIONS, // FT-2528
		AVHRR_QUALITY_INDICATOR,
		AVHRR_SCAN_LINE_QUALITY,
		AVHRR_CALIBRATION_QUALITY,
                AVHRR_COUNT_ERROR_FRAME,  // FT-2528
                AVHRR_CLOUD_INFORMATION,  // FT-2528
		AVHRR_CHANNEL,
		AVHRR_DIGITAL_B_DATA
		} e_SD_BAS_IND_DonDetAVHRR;
	

//--------------------------------------------------------------------*/
// structure contenant les informations images issues d'un MDR de AVHRR
//--------------------------------------------------------------------*/
//FA159
typedef struct 
	{
	double  latitude[SD_BAS_SIZE_OF_DATA_GEOLOC] ; // issu de ??? (EARTH_LOCATION)
	double  longitude[SD_BAS_SIZE_OF_DATA_GEOLOC]  ; // issu de ??? (EARTH_LOCATION)
	float   im[SD_BAS_NPI_AVHRR*SD_BAS_NBA_AVHRR]; //  MDR utilise par les fonctions de lecture detaillees
		         // on stocke ici  les donnees images decodees pour les
			 // 5 canaux
	} t_SD_BAS_ImageAVHRR; 
	

//--------------------------------------------------------------------*/
// structure contenant les informations utiles issues d'un MDR 
// de N1b AVHRR 
// 0 : lecture rapide

// 1 : lecture detaillee 
// 3 :   allocation memoire  pour InfoDet (interne)
// 5 :   lecture de InfoCod pui decodage InfoDet
// 6 : liberation d'InfoCod (interne)


// 5 : liberation ( fonction specifique) a mettre dans le destructeur
//--------------------------------------------------------------------*/
typedef struct 
	{
	t_SD_BAS_Liste_Var InfoGene;
		// ceci est utilise et alloue uniquement en lecture
	t_SD_BAS_Liste_Var InfoDet;
		// ceci est  alloue par les fonction de lecture detaillee
	t_SD_BAS_ImageAVHRR Image;
		// ceci est  alloue par les fonction de lecture detaillee
	} t_SD_BAS_LigneAVHRR; 

//====================================================================*/
// External variables Declaration 
//====================================================================*/
// version de l'OPS en debut de vie
/*  CR257 */
//CR306
// FT-2765
static const t_SD_BAS_VERSION SD_BAS_AVHRR_VERSION={10,0};
// ...FT-2765
// ..CR306

// FT-2765
static const int SD_BAS_MDR_AVHRR_VERSION=4;
// ...FT-2765
//const int SD_BAS_MDR_AVHRR_VERSION=3;



#ifdef __cplusplus
extern "C" {
#endif

//====================================================================*/
// External fonctions Declaration 
//====================================================================*/

//					FONCTIONS EXTERNES
//======================================================================
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_LireMPHRAVHRR
//@
//@ Description : fonction de lecture du MPHR d'un produit AVHRR
//@  cette operation generique s'applique aux produits AVHRR de N2 
//@
//@
//@ Parameters :
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces
//@			(SORTIE)  mphr  : liste des variables lues dans le MPHR
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_LireMPHRAVHRR(
		t_SD_BAS_Fd * Descripteur,
		t_SD_BAS_MPHR * mphr,
    t_SD_BAS_DataThread *ctx
			)
;
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_LireMDRGenAVHRR
//@
//@ Description : fonction de lecture des donnees gen des IPR d'un produit 
//@  cette operation generique s'applique aux produits AVHRR 
//@  on lit ici le grh et quelques info detaillees  ( soit sequentiellement)
//@  soit a partir d'une adresse
//@ 
//@ SD_BAS_LireMPHRAVHRR doit avoir ete appele avant
//@
//@ Parameters :
//@			(ENTREE)  init  : contexte d'initialisation
//@				init = INIT ( on lit le suivant )
//@				init = NORMAL ( on lit a l'adresse indique )
//@			(ENTREE)  offset  : offset pour le mode normal
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces
//@			(SORTIE)  dongen  : liste des variables lues dans le MDR
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_LireMDRGenAVHRR(
		int init,
		int offset,
		t_SD_BAS_Fd * Descripteur,
		t_SD_BAS_Liste_Var * dongen,
    t_SD_BAS_DataThread *ctx
			)
;
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_LireMDRAVHRR
//@
//@ Description : fonction de lecture  des MDR  d'un produit AVHRR 1B
//@  cette operation s'applique aux produits AVHRR
//@  on lit ici les info detaillees 
//@  on lit ici les info detaillees  en considerant que l'offset est renseigne
//@
//@
//@ Parameters :
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces
//@			(SORTIE)  mdr  : liste des variables lues dans le MDR
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_LireMDRAVHRR(
		t_SD_BAS_Fd * Descripteur,
		t_SD_BAS_LigneAVHRR * mdr,
    t_SD_BAS_DataThread *ctx
			)
;
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_LibereMDRAVHRR
//@
//@ Description : fonction de liberation des MDR  d'un produit 
//@  cette operation s'applique aux produits AVHRR  
//@  on desallouie ici toute la place allouee precedenment 
//@
//@
//@ Parameters :
//@			(ENTREE/SORTIE)  mdr  : liste des variables lues dans le MDR
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_LibereMDRAVHRR(
				    t_SD_BAS_LigneAVHRR * mdr
				    )
       ;
//======================================================================

#ifdef __cplusplus
}
#endif

#endif

