//$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/BAS/src/SD_BAS_ConfAutre.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Component : SD_BAS
//@ MODULE : SD_BAS_ConfAutre
//@
//@ Comment :
//@    include file used to define "other" configuration file
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 31/01/2003 : [reference :] ott
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2520(DM-2100-OPS) : 19/12/2008 : S. BRUNEL
//@ Rendre les variables WnShiftMin et WnShiftMax dependante du numero de 
//@ pixel (Day 2,point 1)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2527(DM-2100-OPS) : 19/12/2008 : S. BRUNEL
//@ Permetrre le calcul des spectres dans les bandes B1 & B2 meme lorsque un
//@ spike affecte la bande B3 (Day 2,point 8)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------



#ifndef SD_BAS_ConfAutre_h
#define SD_BAS_ConfAutre_h


/* librairies C de bases utilisees par les modules du projet */
#include <stdio.h>       /* entree/sortie */
#include <stdlib.h>      /* alloc memoire, ...*/
#include <string.h>      /* chaines de carateres */
#include <unistd.h>      /* gestion pipes, ... */
#include <time.h>        /* gestion de la date */
#include <sys/param.h>   /* constantes systeme */


	

// inserer ici les fichiers include 
#include "SD_BAS_Global.h"
#include "ERR__Erreur.h"




/*====================================================================*/
//   External define  Declarations
/*====================================================================*/

/* FT-2520, FT-2527 */
// FT-2765
static const int SD_BAS_TAILLE_CA = 133200;
// ..FT-2765
/* ..FT-2520, FT-2527 */

#define ERR_BASE_CONFAUTRE SD_BAS_ERR_BASE_ConfAutre
#define SD_BAS_ERR_VERSION_CA (ERR_BASE_CONFAUTRE +1)

// FT-2765
static const int SD_BAS_ERR_SET_ConfAutre = 1;
// ..FT-2765
//===================================================================*/
// Exported types Declaration  
//====================================================================*/.




// structure contenant les informations contenue dans le fichier de conf
// autre 
typedef struct 
	{
// il faut definir ici l'ensemble des champs lus dans le fichier 
// apres decodage

	  int IDefIssueIcd;
	  int IDefRevisionIcd;
	  int IDefPTSI;
	  int IDefConf;
	  int IDefSdbID;
	  int IDefStableparamID;
	  t_SD_BAS_SCDSTime IDefParamDate;

	  int IDefMETOPNumber;
	  int ICtcNbSeg [SD_BAS_CTN];
	  int IDefNSegNsfirst;
	  int ICtcTabNbBit [SD_BAS_SPCT_COD * SD_BAS_CTN];
	  int ICtcTabOffset [SD_BAS_SPCT_COD * SD_BAS_CTN];
	  double ICtcTabOffsetC [SD_BAS_CTN];
	  double ICtcTabOffsetM [SD_BAS_CTN];

	  int ICtcTabScale [SD_BAS_SPCT_COD * SD_BAS_CTN];
	  double ICtcTabScaleC [SD_BAS_CTN];
	  double ICtcTabScaleM [SD_BAS_CTN];
	  
	  
	  int IDefArcNbNsSeg[ SD_BAS_SB];
	  int IDefArcNbSeg[ SD_BAS_SB];


	  double IDefBBEmissivity[SD_BAS_SS1];
	  int  IDefBBNbRrs;
	  double IDefBBRRs[SD_BAS_NB_SURF_RAD];
	  
	  int IDefCcsChannelId[ SD_BAS_NBK];
	  double IDefCcsChannelNoise[SD_BAS_NBK];
	  double IDefCcsChannelWn[ SD_BAS_NBK];
	  int IDefCcsChannelWgt[ SD_BAS_NBK * SD_BAS_CCD];

	  int IDefCcsDimClassSpace;
	  double IDefCcsDistAgloInit;
	  double IDefCcsDistMax;
	  double IDefCcsGlueCutoff;
    int IDefCcsImgCILinMax;
    int IDefCcsImgCIColMax;
	  double IDefCcsIterConvCutoff;
	  int IDefCcsMinIterNCCutoff;

    int IDefCcsMode;
	  int IDefCcsNbClusMax;
	  int IDefCcsNbIterMax;
	  int IDefCcsNbNonClassifMax;

	  int IDefCcsRadToTb;
	  int IDefCcsSortingChannel;
	  double IDefCcsSplitCutoff;
    
    double IDefCovarEigenValCalRad;
    double IDefCovarEigenValSpect;
    
	  int IDefCtcNbNsSeg;
    double IDefCovarMatEigenVal1b[SD_BAS_COVAR_DIM * SD_BAS_CCD];
    double IDefCovarMatEigenVal1c[SD_BAS_COVAR_DIM * SD_BAS_CCD];
	  double IDefDptGainCoeffCutoff;


	  int IDefDptIISInHomPixMax;
	  double IDefDptIISVarianceCutoff;
	  int IDefDptNbCycleFilter;

	  double IDefDurFltIsrfemOff;
	  double IDefDurBandMiss;
	  double IDefDurBBTMiss;
	  double IDefDurImgEWMiss;
	  double IDefDurImgBBMiss;
	  double IDefDurImgCSMiss;
	  double IDefDurRadAvhrrMiss;
	  
	  int IDefFaxFLS;
	  int IDefFaxRegressDegre;
	  double IDefFaxRegressRmsCutoff;
	  double IDefFaxT0;
	  
	  int IDefFtbFLS;
	  int IDefFtbRegressDegre;
	  double IDefFtbRegressRmsCutoff;
	  double IDefFtbT0;

	  int IDefGeoIISSubGridSize;
	  int IDefGeoIISSubGridNY[SD_BAS_SGI_LI];
	  int IDefGeoIISSubGridNZ[SD_BAS_SGI_CO];

	  int IDefGranuleSizeDefault;

	  double IDefHecTRrsModel[SD_BAS_MODEL * SD_BAS_NB_SURF_RAD];

	  double IDefIacCorrelCutoff;
	  int IDefIacDCol;
	  int IDefIacDLin;
	  double IDefIacPosMaxCutoff;
	  
	  double IDefIASIMETOPMatRot[SD_BAS_DIM_ROT_MATRICE *SD_BAS_DIM_ROT_MATRICE];
	  double IDefIASIScanAngle [SD_BAS_SP];
	 
	  int IDefIccNbCycle;
	  
	  double IDefIISAVHRROffsetGuess [SD_BAS_CCD * SD_BAS_SP];
	  int IDefIISColDeb[SD_BAS_PN];
	  int IDefIISColFin[SD_BAS_PN];
	  double IDefIISDY;
	  double IDefIISDZ;
	  int IDefIISLinDeb[SD_BAS_PN];
	  int IDefIISLinFin[SD_BAS_PN];
	  int IDefIISNbCol;
	  int IDefIISNbLin;
	  double IDefIISNoiseNom;
	  double IDefIISRot;
	  double IDefIISY[SD_BAS_IMLI];
	  double IDefIISZ[SD_BAS_IMCO];

	  double IDefMcxColdSpectrum[ SD_BAS_SB *SD_BAS_TAILLE_NB_SI_B];
	  double IDefMcxDphi[ SD_BAS_SB *SD_BAS_TAILLE_NB_SI_B];
	  double IDefMcxBiasCalRadCutoff[ SD_BAS_SB];
	  double IDefMcxNoiseCalRadCutoff[ SD_BAS_SB];
	  
	  
	  double IDefMETOPOrbitPeriod;

	  int IDefNsfirst[ SD_BAS_SB];
	  int IDefNslast[ SD_BAS_SB];

	  double IDefOffsetSondIISModel[SD_BAS_MODEL * SD_BAS_CCD * SD_BAS_PN];
	  double IDefPdsPix[SD_BAS_PN];
	  double IDefPlkN;
	  double IDefPlkPK1;
	  double IDefPlkPK2;

	  double IDefPsfSondBaryCentreY[SD_BAS_PN];
	  double IDefPsfSondBaryCentreZ[SD_BAS_PN];

	  double IDefQisAvgRadNoise[ SD_BAS_SB * SD_BAS_PN];
	  
	  int IDefS1bNsFFT;
	  int IDefS1bOSFftFactor;
	  int IDefS1bOSSplineFactor;
	  int IDefS1bSigI;
	  int IDefS1bSigS;
	  int IDefS1cNbSWwidth;
	  int IDefS1cNsErase;
	  int IDefS1cSigS;
	  
	  double IDefSmeTScanModel[SD_BAS_MODEL];
	
	  double IDefSpectDWn1b;
	  int IDefNsfirst1b;
	  int IDefNslast1b;
	  double IDefSpectrDWn;
	  double IDefSsdModulCutoff[ SD_BAS_SB * SD_BAS_TAILLE_NB_SI_B];

	  int IDefSsdNhar[SD_BAS_TAILLE_NB_SI_B];
	  int IDefSsdNItera;
	  int IDefSsdNsfirstSW[SD_BAS_TAILLE_NB_SI_B];
	  int IDefSsdNslastSW[SD_BAS_TAILLE_NB_SI_B];
	  int IDefSsdOSFftFactor[SD_BAS_TAILLE_NB_SI_B];
	  int IDefSsdOSSplineFactor[SD_BAS_TAILLE_NB_SI_B];
	  int IDefSsdSigI[SD_BAS_TAILLE_NB_SI_B];
	  int IDefSsdSigS[SD_BAS_TAILLE_NB_SI_B];
	  
	  int IDefSsdSpectralWindowOPS;
	  double IDefSssStdImagCutoff;

      // FT-2520 - Version 1.7
      double IDefSssWnShiftMax[SD_BAS_PN];
      double IDefSssWnShiftMin[SD_BAS_PN];
      // ..FT-2520

	  unsigned int IDefSysTECIISQual;
	  unsigned int IDefSysTECSondQual;

	  double IDefTrCalRad;
	  double IDefTrnom;
	  double IDefTrSpect;

	  int IDefWnpNharmonic[SD_BAS_TAILLE_NB_SI_B];
	  int IDefWnpSigG[SD_BAS_TAILLE_NB_SI_B];
	  int IDefWnpSign[SD_BAS_TAILLE_NB_SI_B];
	  double IWnpDWnSWref[SD_BAS_TAILLE_NB_SI_B];
	  double IWnpModulNat[ SD_BAS_SB * SD_BAS_TAILLE_NB_SI_B];
	  int IWnpNsFFT[SD_BAS_TAILLE_NB_SI_B];
	  int IWnpNsSSR[SD_BAS_TAILLE_NB_SI_B];
	  int IWnpNsSW[SD_BAS_TAILLE_NB_SI_B];
	  double IWnpPhaseNat[ SD_BAS_SB * SD_BAS_TAILLE_NB_SI_B];
	  double IWnpWnSWref[SD_BAS_TAILLE_NB_SI_B];

	  // FT-2527 - Version 1.7
	  int IDefZpdBzpd;
	  // FT-2527

} t_SD_BAS_ConfAutre; 


//====================================================================*/
// External variables Declaration 
//====================================================================*/
// version de l'ICD utilise pour le format du fichier de conf 
/* FT-2520, FT-2527 */
// FT-2765
static const t_SD_BAS_VERSION SD_BAS_CONFIGURATION_AUTRE_VERSION={1,7};
// ..FT-2765
/* ..FT-2520, FT-2527 */

//====================================================================*/
// External fonctions Declaration 
//====================================================================*/

#ifdef __cplusplus
extern "C" {
#endif

//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_ChargerConfAutre
//@
//@ Description : ouverture lecture et fermeture du fichier de configuration  
//@ autre indique en argument
//@
//@
//@ Parameters :
//@			(ENTREE)  Fichier : nom du fichier de configuration 
//@			(ENTREE/SORTIE)  Conf : configuration lu 
//@  			(ENTREE)  ctx : contexte de l'etape                   
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@		        SD_BAS_ERR_OUVERTURE si on ne peut pas ouvrir le fichier
//@                     SD_BAS_ERR_FERMETURE si on ne peut pas fermer le fichier
//@                     SD_BAS_ERR_LECTURE   si on ne peut lire
//@
//@                     SD_BAS_VERSION si la longueur du fichier ou le numero
//@                     d'enregistrement son different de ceux predefinis
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_ChargerConfAutre(
		char * Fichier,
		t_SD_BAS_ConfAutre * Conf,
		t_SD_BAS_DataThread *ctx
		);



#ifdef __cplusplus
}
#endif


#endif
