//$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/BAS/src/SD_BAS_Contexte.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_BAS
//@ MODULE : SD_BAS_Contexte
//@
//@ Comment :
//@    include file used to define Context file
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 13/10/2002 : [reference :] ott
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-158-CN : 30/06/2005 : JL PASCAL
//@ L'OPS genere des resulta VIADRENG_MEXSSMIN et MAX errone et qui  
//@ dependent du nombre de thread 
//@ Voir IA-2100-FC-158-THA.
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-169-CN : 27/02/2006 : B.MASSART
//@ Syntax correction for IisInHomPix. See IA-2100-FC-169-THA.
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------



#ifndef SD_BAS_Contexte_h
#define SD_BAS_Contexte_h


/* librairies C de bases utilisees par les modules du projet */
#include <stdio.h>       /* entree/sortie */
#include <stdlib.h>      /* alloc memoire, ...*/
#include <string.h>      /* chaines de carateres */
#include <unistd.h>      /* gestion pipes, ... */
#include <time.h>        /* gestion de la date */
#include <sys/param.h>   /* constantes systeme */
#include <fcntl.h>
#include "ERR__Erreur.h"
// inserer ici les fichiers include
#include "SD_BAS_Global.h"


/*====================================================================*/
//   External define  Declarations
/*====================================================================*/
#define SD_BAS_NB_HIST_INTERF 1600
#define SD_BAS_NB_HIST_BBT 400
#define SD_BAS_NB_VAL 2


#define ERR_BASE_CONTEXTE       SD_BAS_ERR_BASE_Contexte
#define SD_BAS_ERR_INTEGRITE  (ERR_BASE_CONTEXTE+1)
#define SD_BAS_ERR_VERSION    (ERR_BASE_CONTEXTE+2)
#define SD_BAS_ERR_SET_Contexte 1
//====================================================================*/
// Exported types Declaration
//====================================================================*/
// enumere pour  la nature du contexte
//
typedef enum
    {
    INIT_FROID=1,
    INIT_NORMAL=0
    } e_SD_BAS_NatureCtx;


// structure contenant un element de l'historique de l'axe interferometrique
//
typedef struct
{
  t_SD_BAS_SCDSTime   GiaxDateElt;
  double GiaxAxeYElt;
  double GiaxAxeZElt;
  double GiaxAxeQualElt;
  unsigned short int GiaxFlagAxeNonQual;
    } t_SD_BAS_HistAxeInterf;




// structure contenant un element de l'historique des temperatures du corps noir
//
typedef struct
{
  t_SD_BAS_SCDSTime     GBBTDateElt;
  double BIMSBBT;
  int GBBTMissing;
} t_SD_BAS_HistTempCN;


//
// structure contenant les informations contenues dans le contexte
//
typedef struct
    {
      t_SD_BAS_VERSION  GCTXVersOPS;
      t_SD_BAS_VERSION  GCTXVersCTX;
      e_SD_BAS_NatureCtx    GCTXNatCTX;
    t_SD_BAS_SCDSTime   GEPSDatIASI[SD_BAS_NB_VAL];
      double            BIMSBBT[SD_BAS_NB_VAL];
      int           GCTXNumDerLig[SD_BAS_NB_VAL];
      int           PTSI[SD_BAS_NB_VAL];
      int           BIISEqualCountOld[SD_BAS_NB_VAL];
// historiques axe interf
      int GIaxNbElt;
      t_SD_BAS_HistAxeInterf GIaxHistAxeInterf[SD_BAS_CCD * SD_BAS_NB_HIST_INTERF];
// 100_EXS
//FA158 gestion du multithread par allocation de 10 lignes
    double MExsSmin[SD_BAS_SPCT_COD*SD_BAS_PERIODE_VIADR];
    double MExsSmax[SD_BAS_SPCT_COD*SD_BAS_PERIODE_VIADR];
// historiques temp CN
      int GBBTNbElt;
       t_SD_BAS_HistTempCN GBBTHistTempCN[SD_BAS_NB_HIST_BBT];
// l'algo ICC
      double  GIccRadCalSlopeImag[SD_BAS_IMCO * SD_BAS_IMLI * SD_BAS_NB_VAL];
      double  GIccRadCalOffsetImag[ SD_BAS_IMCO * SD_BAS_IMLI * SD_BAS_NB_VAL];
// l'algo IAC
      double  GIacOffsetIISAVHRRLin[SD_BAS_NB_VAL];
      double  GIacOffsetIISAVHRRCol[SD_BAS_NB_VAL];
// l'algo 110_DPT
    /* FA169 */
    int  MDptIisInHomPix[SD_BAS_IMCO * SD_BAS_IMLI * SD_BAS_NB_VAL]; // table des compteur inhomogene
    
    int  MDptIisBadHealthPix[SD_BAS_IMCO * SD_BAS_IMLI * SD_BAS_NB_VAL]; // table  de sante des pixels
    double  MDptVarImag[ SD_BAS_IMCO * SD_BAS_IMLI* SD_BAS_NB_VAL]; //  pseudo variance de l'image espace froid
// initialisation des cas degrades
      t_SD_BAS_SCDSTime     GOPSDatIsrfemOff[SD_BAS_NB_VAL];
      t_SD_BAS_SCDSTime     GOPSDatBandMiss[SD_BAS_NB_VAL];
      t_SD_BAS_SCDSTime     GOPSDatBBTMiss[SD_BAS_NB_VAL];
      t_SD_BAS_SCDSTime     GOPSDatImgEWMiss[SD_BAS_NB_VAL];
      t_SD_BAS_SCDSTime     GOPSDatImgBBMiss[SD_BAS_NB_VAL];
      t_SD_BAS_SCDSTime     GOPSDatImgCSMiss[SD_BAS_NB_VAL];
      t_SD_BAS_SCDSTime     GOPSDatRadAvhrrMiss[SD_BAS_NB_VAL];

// donnees utilisees pour mettre a jour le VIADR toutes les 10 lignes
      int GCTXNumGranule[SD_BAS_NB_VAL];

    // a completer par le contenu du contexte
    } t_SD_BAS_Contexte;




//====================================================================*/
//                  FONCTIONS EXTERNES
//======================================================================

#ifdef __cplusplus
extern "C" {
#endif
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_LireCtx
//@
//@ Description : ouverture lecture et fermeture du fichier de contexte
//@ indique en argument
//@
//@
//@ Parameters :
//@         (ENTREE)  Fichier : nom du fichier de contexte
//@         (ENTREE/SORTIE)  Ctx : contexte lu
//@
//@ Return Status :
//@         t_CMN__Statut
//@         CMN__STATUT_OK si la fonction a reussi
//@         CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_LireCtx(
        char * Fichier,
        t_SD_BAS_Contexte * Ctx,
        t_SD_BAS_DataThread *err
            )
     ;
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_EcrireCtx
//@
//@ Description : ouverture lecture et fermeture du fichier de contexte
//@ indique en argument
//@
//@
//@ Parameters :
//@         (ENTREE)  Fichier : nom du fichier de contexte
//@         (ENTREE)  Ctx : contexte lu
//@
//@ Return Status :
//@         t_CMN__Statut
//@         CMN__STATUT_OK si la fonction a reussi
//@         CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_EcrireCtx(
        char * Fichier,
        t_SD_BAS_Contexte * Ctx,
        t_SD_BAS_DataThread *err
            )
     ;

//======================================================================


#ifdef __cplusplus
}
#endif

#endif

