// $header: $
//@ Composant : SD
//@ Sous-composant : SD_BAS
//@ MODULE : SD_BAS_Conversion
//@
//@ Comment :
//@    Include file for the  SD_BAS_Conversion class which encapsulates the
//@    conversion facility for IASI OPS  :
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#include <stdio.h>       /* entree/sortie */
#include <stdlib.h>      /* alloc memoire, ...*/
#include <string.h>      /* chaines de carateres */
#include <unistd.h>      /* gestion pipes, ... */
#include <time.h>        /* gestion de la date */
#include <sys/param.h>   /* constantes systeme */
#include <math.h>
// inserer ici les fichiers include 
#include "SD_BAS_Global.h"

#ifndef SD_BAS_Conversion_h
#define SD_BAS_Conversion_h

/*====================================================================*/
/*   External define  Declarations                                    */
/*====================================================================*/

#ifdef __cplusplus
extern "C" {
#endif


//======================================================================
//					FONCTIONS EXTERNES
//======================================================================


//@ ------------------------------------------------------------------*/
//@ Procedure :  SD_BAS_IsBitSet
//@
//@ Description :
//@
//@
//@ Parameters :
//@              
//@		 
//@
//@ Return Status : 
//@                    t_CMN__Statut
//@				CMN__STATUT_OK si la fonction a reussi
//@				CMN__STATUT_NOK si la fonction a echoue
//@

//@ ------------------------------------------------------------------*/ 
t_CMN__Statut  SD_BAS_Is_BitSet(unsigned short word,int bit);

// FT-2765
//@ ------------------------------------------------------------------*/
//@ Procedure :  SD_BAS_IsBitSet
//@
//@ Description :
//@
//@
//@ Parameters :
//@
//@
//@
//@ Return Status :
//@                    t_CMN__Statut
//@				CMN__STATUT_OK si la fonction a reussi
//@				CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut  SD_BAS_Is_BitSeti(unsigned short word,int bit);
// ...FT-2765

//@ ------------------------------------------------------------------*/
//@ Procedure :  SD_BAS_IsBitSet
//@
//@ Description : Renvoie la valeur du nombre represente par les bits
//@               bit1 a bit2 d'un mot de 16 bits
//@               La numerotation des bits est la suivante :
//@                    B0 (MSB) ..... B15 (LSB)
//@               Exemple : word = 0001100110101101 (=6573 en decimal)
//@                         bit1 = 5
//@                         bit2 = 12
//@                    =>  *val  = 00110101000 (= 53 en decimal)
//@
//@ Parameters :
//@     (ENTREE)  word : mot de 16 bits dont on veut extraire une valeur
//@     (ENTREE)  bit1 : indice du bit de poids fort de la valeur a extraire
//@     (ENTREE)  bit2 : indice du bit de poids faible de la valeur a extraire
//@     (SORTIE)  val  : valeur extraite
//@
//@ Return Status : 
//@                  CMN__STATUT_OK  si aucune erreur
//@                  CMN__STATUT_NOK si erreur rencontree
//@
//@ ------------------------------------------------------------------*/ 
t_CMN__Statut SD_BAS_ExtraireValeur(
  const unsigned   word,
  const unsigned short  bit1,
  const unsigned short  bit2,
        unsigned * val
  );

#ifdef __cplusplus
}
#endif

#endif
