// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/BAS/src/SD_BAS_DECOM_DECOMMUTATION.c,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_BAS
//@ MODULE : SD_BAS_DECOMMUTATION
//@
//@ Comment :
//@     code file for the  SD_BAS_DECOMMUTATION class which  the
//@    is used for commutation/ decommutation for product
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ AUTEUR            : A.MONTMORY
//@ DATE DE CREATION  : 05/05/98
//@ EURIDIS / REALISATION PAR SYSECA SA
//@ --------------------------------------------------------------------
//@ Prise en compte du rebouclage BLG le 21/02/1996 rajout de la fonction de
//@ conversion DECOM__Cnv_binaire_consigne_BLG et modification
//@ DECOM__Inserer_variable pour pouvoir traiter les valeurs sur cinq octets.
//@ --------------------------------------------------------------------
//@ 03/04/1997   ERD_FAI_151     A.MONTMORY      DECOM__Charger
//@ COMMENTAIRE : Sauvegarder le descripteur de stdin avant de rediriger vers
//@ le fichier que l'on veut charger, repositionner stdin en fin de
//@ chargement. Creation de la fonction DECOM__Cnv_status_irf.
//@ --------------------------------------------------------------------
//@ 15/04/1997 Simplification de la gestion des variables (offset +
//@ decalage) > 4 octets. Simplification de DECOM__Cnv_binaire_consigne_BLG
//@ fonction touchees : DECOM__Inserer_variable,
//@ DECOM__Extraire_variable_binaire.
//@ --------------------------------------------------------------------
//@ 29/09/1997   ERD_FAI_231     A.MONTMORY      DECOM__Cnv_temps_GNSS15
//@ Rajouter la recommutation de l'heure pour les recepteurs GNSS 15.
//@ --------------------------------------------------------------------
//@ 29/09/1997   ERD_FAI_231     A.MONTMORY      DECOM__Cnv_temps_BLG
//@ Rajouter la recommutation de l'heure pour la BLG.
//@ --------------------------------------------------------------------
//@ 27/01/1998   ERD_FAI_589     C.TEXIER      DECOM__Cnv_binaire_consigne_BLG
//@ Remplacer l'appel abs par fabs pour la recomm valeur negative.
//@                                           DECOM__Inserer_variable
//@ Ajout de la valeur absolue dans le test relatif a la taille max possible.
//@ --------------------------------------------------------------------
//@ 12/03/1998   ERD_FAI_619     C.TEXIER    DECOM__Cnv_binaire_signed_facteur
//@ Remplacer l'appel abs par fabs pour la recomm valeur negative.
//@ --------------------------------------------------------------------
//@ 23/03/1998   PM17            C.TEXIER    DECOM__Retourner_pt_conversion
//@ Ajout dans le tableau tab_conversion de DECOM__C_nom_conv_19.
//@                                          DECOM__Cnv_status_cma
//@ Creation de la fonction.
//@ --------------------------------------------------------------------
//@ 02/04/1998   ERD_FAI_634     C.TEXIER    DECOM__Cnv_temps_BLG
//@ Remplacement de 655536 par 65536 pour le decalage des heures ds formule
//@ final. Ajout de include time.h.
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-146-CN : 26/01/2005 : JL.PASCAL
//@ cadrage a droite des champs du MPHR
//@ fiche de correction correspondante : IA-2100-FC-146bis-THA
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-159-CN : 26/05/2005 : JL. PASCAL
//@ modif suite a portage linux
//@ fiche de correction correspondante : IA-2100-FC-159-THA*/
//@ --------------------------------------------------------------------
//@ FA-ID :IA--CR-2100-269-CNE : 08/06/2005 : JL PASCAL
//@ test du nombre de pixel AVHRR et nombre de point de geoloc
//@ fiche de correction correspondante : IA-2100-FC-269-THA
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-190-CN : 6/11/2006 : C. MERIGUET
//@ champ N1C_OBT nul quand proche du roll-over -> cast de la valeur
//@ ui4 en double avant passage dans FINITE
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2512 (FA-2100-OPS) : 17/11/2008 : S. BRUNEL
//@ Fuites memoires signalees par EUMETSAT (EUM.EPS.NCR.3627.1)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

/*****************************************************************************/
/*                                  EURIDIS                                  */
/*                         REALISATION PAR SYSECA SA                         */
/*****************************************************************************/
/* SYSTEME           :  Services Communs                                     */
/* NOM DU FICHIER    : DECOM_DECOMMUTATION.c                                                   */
/* OBJET HOOD        : DECOM_DECOMMUTATION                                   */
/* NOM ABREGE        : DECOM                                                 */
/* TYPE DU FICHIER   : INTERNAL                                              */
/* LANGAGE           : C ANSI                                                */
/* AUTEUR            : A.MONTMORY                                            */
/* DATE DE CREATION  : 05/05/98                                                   */
/*****************************************************************************/
/* MACHINE CIBLE     : SUN                                                   */
/* OS UNIX           : SOLARIS 2.5                                           */
/* COMPILATEUR       : cc                                                    */
/* LOGICIELS DE BASE :                                                       */
/* PROGICIELS        :                                                       */
/*****************************************************************************/
/* VERSION           : 1.13                                                   */
/* DATE VERSION      : 98/05/05                                                   */
/* AUTEUR VERSION    :                                                       */
/*****************************************************************************/
/* MODIFICATIONS     :                                                       */
/* Prise en compte du rebouclage BLG le 21/02/1996 rajout de la fonction de  */
/* conversion DECOM__Cnv_binaire_consigne_BLG et modification                */
/* DECOM__Inserer_variable pour pouvoir traiter les valeurs sur cinq octets. */ 
/* DATE         FA/DM           AUTEUR          FCT/DONNEES IMPACTES         */
/* 03/04/1997   ERD_FAI_151     A.MONTMORY      DECOM__Charger               */
/* COMMENTAIRE : Sauvegarder le descripteur de stdin avant de rediriger vers */
/* le fichier que l'on veut charger, repositionner stdin en fin de           */
/* chargement. Creation de la fonction DECOM__Cnv_status_irf.                */
/* 15/04/1997 Simplification de la gestion des variables (offset +           */
/* decalage) > 4 octets. Simplification de DECOM__Cnv_binaire_consigne_BLG   */
/* fonction touchees : DECOM__Inserer_variable,                              */
/* DECOM__Extraire_variable_binaire.                                         */ 
/* 29/09/1997   ERD_FAI_231     A.MONTMORY      DECOM__Cnv_temps_GNSS15      */
/* Rajouter la recommutation de l'heure pour les recepteurs GNSS 15.         */
/* 29/09/1997   ERD_FAI_231     A.MONTMORY      DECOM__Cnv_temps_BLG         */
/* Rajouter la recommutation de l'heure pour la BLG.                         */
/* 27/01/1998   ERD_FAI_589     C.TEXIER      DECOM__Cnv_binaire_consigne_BLG*/
/* Remplacer l'appel abs par fabs pour la recomm valeur negative.            */
/*                                            DECOM__Inserer_variable        */
/* Ajout de la valeur absolue dans le test relatif a la taille max possible. */
/* 12/03/1998   ERD_FAI_619     C.TEXIER    DECOM__Cnv_binaire_signed_facteur*/
/* Remplacer l'appel abs par fabs pour la recomm valeur negative.            */
/* 23/03/1998   PM17            C.TEXIER    DECOM__Retourner_pt_conversion   */
/* Ajout dans le tableau tab_conversion de DECOM__C_nom_conv_19.             */
/*                                          DECOM__Cnv_status_cma            */
/* Creation de la fonction.                                                  */
/* 02/04/1998   ERD_FAI_634     C.TEXIER    DECOM__Cnv_temps_BLG             */
/* Remplacement de 655536 par 65536 pour le decalage des heures ds formule   */
/* final. Ajout de include time.h.                                           */
/*****************************************************************************/

/*****************************************************************************/
/*                           IDENTIFICATION BINAIRE                          */
/*****************************************************************************/
/* FIN CARTOUCHE */

#include  <strings.h>
#include  <time.h>
#include  <stdlib.h>
#include  <stdio.h>
#include  <unistd.h>
#include  <math.h>
// FT-2765
#ifdef AIX
#include  <fp.h>
#endif
// ...FT-2765
#include  <search.h>
// FT-2765
#include <limits.h>
#include <inttypes.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
// ...FT-2765
#include  <math.h>
/*========== visibility on required objects :  */

// FT-2765
#include "SD_BAS_SwapEndian.h"
//...FT-2765

#include "SD_BAS_DECOM_DECOMMUTATION.h"

static char id[]="@(#) DECOM_DECOMMUTATION.c 1.13 98/05/05";
/*****************************************************************************/
/*                CONSTANTES NON TYPEES INTERNES (#define)                   */
/*****************************************************************************/

/*longeur des dates au format IASI GENERAL TIME */
#define DECOM__C_LG_GENTIME 15
#define DECOM__C_LG_LONGGENTIME 18

/*C C_Type_binaire :*/
/* Definition d'un type de bloc binaire. */
#define DECOM__C_type_binaire 1

/*C C_Type_binaire :*/
/* Definition d'un type de bloc binaire. */
#define DECOM__C_type_ascii   2

/*C C_nb_max_bloc :  */
/* Nombre maximum de bloc. */
#define DECOM__C_nb_max_bloc	50

/*C C_lg_nom_conversion :  */
/* Constante definissant la longueur maximum d'un nom de conversion. */
#define DECOM__C_lg_nom_conversion 19


/*C C_nb_max_conversion :  */
/* Nombre maximum de fonction de conversion. */
#define DECOM__C_nb_max_conversion   100

/*C C_nb_max_param_proc_conv :  */
/* Nombre maximum de parametre d'une fonction de conversion. */
#define DECOM__C_nb_max_param_proc_conv   5

/*C C_decommutation :*/
/* Identifie une action de decommutation en cours. */
#define DECOM__C_decommutation 1

/*C C_recommutation :*/
/* Identifie une action de recommutation en cours. */
#define DECOM__C_recommutation   2

/*C C_lg_max_variable :*/
/* longueur maximum d'une variable dans un bloc. */
#define DECOM__C_lg_max_variable 100000

/*C C_erreur_mtl :*/
/* Pattern de reconnaissance d'une erreur dans le bloc sortant de MTL. */
#define DECOM__C_erreur_mtl   "E0000"

/*C C_status_ho_on :*/
/* Pattern de reconnaissance d'un etat ON de l'horloge HO. */
#define DECOM__C_status_ho_on "ON"

/*C C_status_ho_off :*/
/* Pattern de reconnaissance d'un etat OFF de l'horloge HO. */
#define DECOM__C_status_ho_off "OFF"

/*C C_status_ho_enab :*/
/* Pattern de reconnaissance d'un etat ENAB de l'horloge HO. */
#define DECOM__C_status_ho_enab "ENAB"

/*C C_status_srf_on :*/
/* Pattern de reconnaissance d'un etat OK de l'interface SRF. */
#define DECOM__C_status_srf_on "R"

/*C C_status_srf_off :*/
/* Pattern de reconnaissance d'un etat OK de l'interface SRF. */
#define DECOM__C_status_srf_off "A"

/*C C_element_a_actif :*/
/* Pattern de reconnaissance d'un element a actif de l'interface IRF. */
#define DECOM__C_element_a_actif "a"

/*C C_element_b_actif :*/
/* Pattern de reconnaissance d'un element b actif de l'interface IRF. */
#define DECOM__C_element_b_actif "b"

/*C C_position_cma_O :*/
/* Pattern de reconnaissance de la position d'antenne O fournit par CMA. */
#define DECOM__C_position_cma_O "O"

/*C C_position_cma_D :*/
/* Pattern de reconnaissance de la position d'antenne D fournit par CMA. */
#define DECOM__C_position_cma_D "D"

/*C C_position_cma_E :*/
/* Pattern de reconnaissance de la position d'antenne E fournit par CMA. */
#define DECOM__C_position_cma_E "E"


/*****************************************************************************/
/*                DEFINITIONS DES TYPES INTERNES                             */
/*****************************************************************************/

/*T T_valeur_brute :  */
/* Description d'une valeur brute a extraire ou inserer dans le bloc de donnee */
                                 
typedef struct
{   
    TYCST__T_int4      action;     /* Action en cours sur la donnee (decommutation ou */
    /* recommutation).                                 */
    TYCST__T_int4      decalage;   /* Decalage par rapport a la frontiere d'octet la  */
    /* plus  proche.                                   */ 
    TYCST__T_int4      longueur;   /* Longueur en bit de l'information.               */
    TYCST__T_real8     valeur;     /* Valeur a recommutter.                           */
    TYCST__T_pt_void   buffer;     /* Buffer contetant l'information a decommuter.    */
    TYCST__T_int4      nb_octet;   /* Nombre d'octet dans buffer.                     */
    TYCST__T_int4      type;       /* type de la donnee en cours de traitementt.      */
   
} DECOM__T_valeur_brute;

/*T T_pt_valeur_brute :  */
/* pointeur sur T_valeur_brute */
typedef DECOM__T_valeur_brute *DECOM__T_pt_valeur_brute;


/*T T_proc_conv :  */
/*  */
typedef DECOM__T_status (*DECOM__T_proc_conv)(DECOM__T_pt_valeur_brute val_in , 
                                              DECOM__T_pt_valeur_brute val_out,
                                              TYCST__T_int4 nb_param, TYCST__T_pt_real8 param);

/*T T_conv :  */
/*  */
typedef struct {
    char nom[DECOM__C_lg_nom_conversion+1];
    DECOM__T_proc_conv proc_conv;    /* procedure de conversion */
    TYCST__T_int4      nb_param;     /* nombre de parametres */
    TYCST__T_real8     param[DECOM__C_nb_max_param_proc_conv]; /* parametres de la procedure de conversion */
} DECOM__T_conv;


/*T T_desc_var :  */
/* Type donnant la description d'une variable. */
typedef struct {
    DECOM__T_nom_var nom;     /* nom de la variable */
    TYCST__T_int4    offset;  /* offset en bits ou rang (ascii) par rapport au debut du bloc */
    TYCST__T_boolean isoffsetbit;   /* TRUE si offset est en bit */
    TYCST__T_int4    lg;      /* longueur en bits (ou octet pour ascii) de l'information dans le bloc */
    TYCST__T_boolean islgbit;   /* TRUE si lg est en bit */
    DECOM__T_conv    decom;   /* infos necessaires pour la conversion lors de la decommutation */
    TYCST__T_int4       dim;  /* dimension de la variable */
    char  nomcv[DECOM__C_lg_nom_conversion+1];	     /* nom de la fonction de conversion */
} DECOM__T_desc_var;

/*T T_desc_bloc :  */
/* Type donnant la description d'un bloc. */
typedef struct {
    DECOM__T_nom_bloc nom;           /* nom du bloc */
    TYCST__T_int4      type;         /* type du bloc (ASCII ou BINAIRE); */
    TYCST__T_int4      lg;           /* longueur du bloc (en bits binaire ou octet ascii*)*/
    TYCST__T_uchar     val_init;     /* valeur d'initialisation de chaque octet d'un bloc */
    TYCST__T_int4      nb_var;       /* nombre de variables dans le bloc */
    TYCST__T_char      separateur;   /* Type de separateur dans un bloc ascii. */
    DECOM__T_desc_var  *var;         /* liste des variables */
} DECOM__T_desc_bloc;
 


/*T T_pt_desc_bloc :  */
/* pointeur sur T_desc_bloc */
typedef DECOM__T_desc_bloc *DECOM__T_pt_desc_bloc;


/*T T_pt_desc_var :  */
/* pointeur sur T_desc_bloc */
typedef DECOM__T_desc_var *DECOM__T_pt_desc_var;

/*T T_nom_conversion :  */
/* type decrivant le nom d'une fonction de conversion. */
typedef TYCST__T_char    DECOM__T_nom_conversion[DECOM__C_lg_nom_conversion + 1];


/*T T_conversion :  */
/* Description d'une fonction de conversion */
                                 
typedef struct
{
    DECOM__T_nom_conversion  nom;  /* nom de la fonction de conversion */
    TYCST__T_int4      type_input; /* type de donnee d'entree (binaire ou ascii) */
 
    DECOM__T_proc_conv procedure;  /* Pointeur sur le code executable  */
   
} DECOM__T_conversion;

typedef union 
{
  TYCST__T_uint4 ValeurTYCST__T_uint4; 
  TYCST__T_real4 ValeurTYCST__T_real4;
} DECOM__T_UnionTypes;

extern int yydebug;

/*****************************************************************************/
/*                  VARIABLES GLOBALES A L'OBJET (static)                    */
/*****************************************************************************/
/*V DECOM__G_liste_bloc :  */
/* Liste des infos necessaires a la gestion de tous les blocs charge a partir
   du fichier description. */
static DECOM__T_desc_bloc DECOM__G_liste_bloc[DECOM__C_nb_max_bloc]; 

/*V DECOM__G_nb_bloc :  */
/* Nombre de blocs dans la liste . */
static
TYCST__T_int4 
DECOM__G_nb_bloc; 

/*V DECOM__G_tab_mask:  */
/* Liste des mask de bits possible pour une information sur 32 bits . */

static unsigned int DECOM__G_tab_mask [33] =
{0x00000000,
 0x00000001,
 0x00000003,
 0x00000007,
 0x0000000f,
 0x0000001f,
 0x0000003f,
 0x0000007f,
 0x000000ff,
 0x000001ff,
 0x000003ff,
 0x000007ff,
 0x00000fff,
 0x00001fff,
 0x00003fff,
 0x00007fff,
 0x0000ffff,
 0x0001ffff,
 0x0003ffff,
 0x0007ffff,
 0x000fffff,
 0x001fffff,
 0x003fffff,
 0x007fffff,
 0x00ffffff,
 0x01ffffff,
 0x03ffffff,
 0x07ffffff,
 0x0fffffff,
 0x1fffffff,
 0x3fffffff,
 0x7fffffff,
 0xffffffff};

/*****************************************************************************/
/*              DECLARATIONS DES OPERATIONS INTERNES (static)                */
/*****************************************************************************/


/*****************************************************************************/
/* DECLARATION : Enregistrer_bloc                                            */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Enregistre le bloc qui vient d'etre analyse dans la liste   */
/*             : des blocs deja decrit.                                      */
/*****************************************************************************/

static
DECOM__T_status
DECOM__Enregistrer_bloc(
    const DECOM__T_pt_desc_bloc info_bloc
    );

/*****************************************************************************/
/* DECLARATION : Rechercher_info_bloc                                        */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Rechercher les infos concernant un bloc dans la table       */
/*****************************************************************************/

static
TYCST__T_int4
DECOM__Rechercher_info_bloc(
    const DECOM__T_nom_bloc Bloc,
    DECOM__T_pt_desc_bloc info_bloc
    );

/*****************************************************************************/
/* DECLARATION : Enregistrer_variable                                        */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Enregistre la variable qui vient d'etre analyse dans la     */
/*             :liste des variables deja decrites.                           */
/*****************************************************************************/

static
DECOM__T_status
DECOM__Enregistrer_variable(
    DECOM__T_pt_desc_bloc pt_bloc,
    const DECOM__T_pt_desc_var info_var
    );
	
/*****************************************************************************/
/* DECLARATION : Rechercher_info_variable                                    */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Recherche une variable dans la liste des variables d'un     */
/*             : bloc.                                                       */
/*****************************************************************************/

static
TYCST__T_int4
DECOM__Rechercher_info_variable(
    const DECOM__T_desc_bloc info_bloc,
    const DECOM__T_nom_var Variable,
    DECOM__T_pt_desc_var   info_var
    );

/*****************************************************************************/
/* DECLARATION : Retourner_pt_conversion                                     */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Retourne le pointeur de la fonction de conversion dont le   */
/*             : nom est passe en parametre;                                 */
/*****************************************************************************/

static
DECOM__T_proc_conv
DECOM__Retourner_pt_conversion ( 
    const DECOM__T_nom_conversion nom, /* IN Nom de la fonction de conversion */
    TYCST__T_pt_int4 type_input          /* OUT type des donnees d'entree. */
    );


/*****************************************************************************/
/* DECLARATION : Comparer_bloc                                               */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Comparer le champ nom de 2 structures var                   */
/*             : Retourne une valeur > 0 si var_1->nom > var2->nom           */
/*             : Retourne une valeur < 0 si var_1->nom < var2->nom           */
/*             : Retourne une valeur = 0 si var_1->nom > var2->nom           */
/*****************************************************************************/

static
int
DECOM__Comparer_bloc(
    const void *var_1,   /* IN */
    const void *var_2    /* IN */
    );

/*****************************************************************************/
/* DECLARATION : Comparer_variable                                           */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Comparer le champ nom de 2 structures var                   */
/*             : Retourne une valeur > 0 si var_1->nom > var2->nom           */
/*             : Retourne une valeur < 0 si var_1->nom < var2->nom           */
/*             : Retourne une valeur = 0 si var_1->nom > var2->nom           */
/*****************************************************************************/

static
int
DECOM__Comparer_variable(
    const void *var_1,   /* IN */
    const void *var_2    /* IN */
    );


/*****************************************************************************/
/* DECLARATION : Inserer_variable                                            */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Insere dans le bloc la valeur d'une variable et la          */
/*             : formattant.                                                 */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Inserer_variable (

    TYCST__T_pt_void buffer,  /* INOUT Buffer d'ecriture.                     */
    TYCST__T_int4 lg_buffer,  /* IN Longueur du buffer a inserer.             */
    TYCST__T_int4 offset,     /* IN Offset en bit par rapport au debut du     */
    /* bloc. */   
    DECOM__T_type_var type,   /* type  de variable a inserer  		     */			                      
    TYCST__T_int4 longueur,   /* IN Longueur en bit de l'information.         */
    TYCST__T_real8 valeur_r);  /* IN Information a inserer.                   */

/*****************************************************************************/
/* DECLARATION : Recommuter_variable                                         */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Insere dans le bloc a construire la valeur contenu dans la  */
/*             : description de la variable.                                 */
/*****************************************************************************/

static
DECOM__T_status
DECOM__Recommuter_variable ( 
    const TYCST__T_pt_void   bloc,           /* INOUT */
    const TYCST__T_int4      lg,             /* IN */
    const DECOM__T_desc_bloc info_bloc,      /* IN */
    const DECOM__T_pt_var    variable        /* IN */      
    );

/*****************************************************************************/
/* DECLARATION : Extraire_variable_binaire                                   */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Extrait la valeur brute d'un buffer binaire.                */
/*****************************************************************************/


static 
DECOM__T_status 
DECOM__Extraire_variable_binaire (

    TYCST__T_pt_void buffer,  /* IN Buffer de lecture.                        */
    TYCST__T_int4 offset,     /* IN Offset en bit par rapport au debut du     */
    /* bloc.                                        */
    TYCST__T_int4 longueur,   /* IN Longueur en bit de l'information.         */
    TYCST__T_pt_real8 retour  /* OUT Information en retour.                   */
    );


/*****************************************************************************/
/* DECLARATION : Extraire_information_binaire                                */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Extrait la valeur brute d'un buffer binaire.                */
/*****************************************************************************/


static DECOM__T_status DECOM__Extraire_information_binaire(

    TYCST__T_pt_void buffer,  /* IN Buffer de lecture.                        */
    TYCST__T_int4 offset,     /* IN Offset en bit par rapport au debut du     */
    /* bloc.                                        */
    TYCST__T_int4 longueur,   /* IN Longueur en bit de l'information.         */
    DECOM__T_pt_valeur_brute retour /* OUT Information en retour.            */
    );

/*****************************************************************************/
/* DECLARATION : Extraire_information_ascii                                  */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Extrait la valeur brute d'un buffer ascii.                  */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Extraire_information_ascii (

    TYCST__T_pt_void buffer,  /* IN Buffer de lecture.                        */
    TYCST__T_int4 nb_octet,   /* IN Nombre d'octet dans le buffer.            */
    TYCST__T_char separateur, /* IN Separateur entre les variables.           */
    TYCST__T_int4 offset,     /* IN Offset en bit par rapport au debut du     */
    /* bloc.                                        */
    TYCST__T_int4 longueur,   /* IN Longueur en bit de l'information.         */
    DECOM__T_pt_valeur_brute retour /* OUT Information en retour.             */
    );


/*****************************************************************************/
/* DECLARATION : Decommuter_variable                                         */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Decommute une variable et la liste des variables deja       */
/*             : decommute.                                                  */
/*****************************************************************************/

static
DECOM__T_status
DECOM__Decommuter_variable (
    const TYCST__T_pt_char composante,
    const TYCST__T_pt_void bloc,
    DECOM__T_pt_liste_var liste_var_tmp,
    const DECOM__T_desc_bloc info_bloc,
    const TYCST__T_pt_char nom_variable
    );      

/*****************************************************************************/
/* DECLARATION : DECOM__Cnv_binaire_brut                                         */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Fonction de conversion donnees Binaire brute en entree pas  */
/*             : de transformation de l'information.                         */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_binaire_brut (
    DECOM__T_pt_valeur_brute val_in ,
    DECOM__T_pt_valeur_brute val_out,
    TYCST__T_int4 nb_param, 
    TYCST__T_pt_real8 param
    );

/*****************************************************************************/
/* DECLARATION :  DECOM__Cnv_ascii_brut                                          */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Fonction de conversion numero 2.                            */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_ascii_brut (
    DECOM__T_pt_valeur_brute val_in ,
    DECOM__T_pt_valeur_brute val_out,
    TYCST__T_int4 nb_param, 
    TYCST__T_pt_real8 param
    );

/*****************************************************************************/
/* DECLARATION : DECOM__Cnv_binaire_unsigned_facteur                         */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Fonction de conversion donnees Binaire brute non signee en  */
/*             : entree.                                                     */
/*             : algoritme <valeur> * parametre 1                            */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_binaire_unsigned_facteur (
    DECOM__T_pt_valeur_brute val_in ,
    DECOM__T_pt_valeur_brute val_out,
    TYCST__T_int4 nb_param, 
    TYCST__T_pt_real8 param
    );

/*****************************************************************************/
/* DECLARATION : DECOM__Cnv_binaire_consigne_BLG                             */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Fonction de conversion donnees Binaire brute signee      */
/*             : en entree sur 5 octets.                                     */
/*             : algoritme <valeur> * parametre 1                            */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_binaire_consigne_BLG (
    DECOM__T_pt_valeur_brute val_in ,
    DECOM__T_pt_valeur_brute val_out,
    TYCST__T_int4 nb_param, 
    TYCST__T_pt_real8 param
    );


/*****************************************************************************/
/* DECLARATION : DECOM__Cnv_binaire_signed_facteur                           */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Fonction de conversion donnees Binaire brute signee         */
/*             : complement a deux en entree.                                */
/*             : algoritme <valeur> * parametre 1                            */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_binaire_signed_facteur (
    DECOM__T_pt_valeur_brute val_in ,
    DECOM__T_pt_valeur_brute val_out,
    TYCST__T_int4 nb_param, 
    TYCST__T_pt_real8 param
    );
	       
/*****************************************************************************/
/* DECLARATION : DECOM__Cnv_binaire_sf_facteur                           */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Fonction de conversion donnees Binaire brute signee         */
/* ROLE      : Fonction de conversion donnees Binaire brute  en    */
/*           : entree.                                                       */
/*           : algorithme : <valeur_commutee> (int) = 			*/
/*		<valeur_entree> (reel) * 10^parametre1                          */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_binaire_sf_facteur (
    DECOM__T_pt_valeur_brute val_in ,
    DECOM__T_pt_valeur_brute val_out,
    TYCST__T_int4 nb_param, 
    TYCST__T_pt_real8 param
    );

/*****************************************************************************/
/* PROCEDURE : DECOM__Cnv_binaire_vint_facteur                           */
/*---------------------------------------------------------------------------*/
/* ROLE      : Fonction de conversion donnees Binaire brute  en    */
/*           : entree.                                                       */
/* algorithme : <valeur_decommutee> (int) = <valeur_commutee> (int) * 10^valeur_commutee (char)     */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_binaire_vint_facteur (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    );

/*****************************************************************************/
/* PROCEDURE : DECOM__Cnv_binaire_date_ccsds                           */
/*---------------------------------------------------------------------------*/
/* ROLE      : Fonction de conversion donnees Binaire brute  en    */
/*           : entree en ccsds date. ( recopie par memcpy)                                                      */
/* algorithme : <valeur_commutee> (48bits) = <day>  et <ms of day>     */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_binaire_date_ccsds (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    );
               
/*****************************************************************************/
/* DECLARATION :  DECOM__Cnv_ascii_facteur_mul                               */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Fonction de conversion donnees ASCII brute signee           */
/*             :  entree.                                                    */
/*             : algoritme <valeur> * parametre 1                            */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_ascii_facteur_mul (
    DECOM__T_pt_valeur_brute val_in ,
    DECOM__T_pt_valeur_brute val_out,
    TYCST__T_int4 nb_param, 
    TYCST__T_pt_real8 param
    );

               
/*****************************************************************************/
/* DECLARATION :  DECOM__Cnv_erreur_mtl                                      */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Traitement des champs E0000xx d'erreur dans la station      */
/*             : meteo.                                                      */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_erreur_mtl (
    DECOM__T_pt_valeur_brute val_in ,
    DECOM__T_pt_valeur_brute val_out,
    TYCST__T_int4 nb_param, 
    TYCST__T_pt_real8 param
    );
 


/*****************************************************************************/
/* DECLARATION :  DECOM__Cnv_valeur_bornee                                   */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Verifie que la valeur est compris dans deux bornes.         */
/*             : algoritme                                                   */
/*             : Retour = parametre3 SI Valeur entree (ascii) >= parametre 1 */
/*             :                     ET valeur entree <= parametre 2.        */
/*             : SINON retour = parametre 4.                                 */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_valeur_bornee (
    DECOM__T_pt_valeur_brute val_in ,
    DECOM__T_pt_valeur_brute val_out,
    TYCST__T_int4 nb_param, 
    TYCST__T_pt_real8 param
    );

/*****************************************************************************/
/* DECLARATION :  DECOM__Cnv_status_horloge                                  */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Traite le status de l'horloge (chaine ascii ON, OFF, ou     */
/*             : ENAB a transforme en valeur numerique.                      */
/*             : algoritme :                                                 */
/*             : SI chaine entree = ON alors retour = parametre 1            */
/*             : SI chaine entree = OFF alors retour = parametre 2           */
/*             : SI chaine sortie = ENAB alors retour = parametre 3          */
/*             : defaut retour = parametre4                                  */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_status_horloge (
    DECOM__T_pt_valeur_brute val_in ,
    DECOM__T_pt_valeur_brute val_out,
    TYCST__T_int4 nb_param, 
    TYCST__T_pt_real8 param
    );

/*****************************************************************************/
/* DECLARATION   :  DECOM__Cnv_status_irf                                    */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION   : Traite lelement actif de l'interface IRF.                 */
/*             : (chaine ascii a ou b) a transforme en valeur numerique.     */
/*             : algoritme :                                                 */
/*             : SI chaine entree = a alors retour = parametre 1             */
/*             : SI chaine entree = b alors retour = parametre 2             */
/*             : defaut retour = parametre3                                  */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_status_irf (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    );

/*****************************************************************************/
/* DECLARATION :  DECOM__Cnv_status_cma                                      */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Traite la position d'antenne fournit par le commutateur     */
/*             : (chaine ascii O, D ou E) a transforme en valeur numerique.  */
/*             : algoritme :                                                 */
/*             : SI chaine entree = O alors retour = parametre 1             */
/*             : SI chaine entree = D alors retour = parametre 2             */
/*             : SI chaine entree = E alors retour = parametre 3             */
/*             : defaut retour = parametre 4                                 */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_status_cma (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    );

/*****************************************************************************/
/* DECLARATION  :  DECOM__Cnv_status_srf                                     */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Traite le status de la station Radio Frequence              */
/*             : (chaine ascii R ou A) a transforme en valeur numerique.     */
/*             : algoritme :                                                 */
/*             : SI chaine entree = R alors retour = parametre 1             */
/*             : SI chaine entree = A alors retour = parametre 2             */
/*             : defaut retour = parametre3                                  */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_status_srf (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    );
	      
	      
/*****************************************************************************/
/* DECLARATION  :  DECOM__StockerVariable                                    */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION :    Determine et ecrit le type et l'une variable             */
/*             :    et l'ajoute a la liste de variable                       */
/*****************************************************************************/

static
DECOM__T_status	
DECOM__StockerVariable(
    const TYCST__T_int4  	dim,       /* dimension de la variable.   */
    DECOM__T_valeur_brute *valeur_convertie,
    DECOM__T_pt_liste_var liste_var,
    const TYCST__T_pt_char nom_variable,
    const TYCST__T_pt_char prefixe,
    char * conv
    );
/*****************************************************************************/
/*                     CORPS DES OPERATIONS EXTERNES (extern)                */
/*****************************************************************************/

/*****************************************************************************/
/* PROCEDURE : Decommuter                                                    */
/*---------------------------------------------------------------------------*/
/* ROLE      : Pour decommuter un bloc de donnees l'operation "Decommuter"   */
/*           : s'appuie sur une description de bloc.                         */
/*           : La description de tous les blocs est definie dans un fichier  */
/*           : ASCII. Ce fichier est charge lors du premier appel a l'une    */
/*           : des operations "Decommuter" ou "Recommuter"                   */
/*           : A partir de la description du bloc, l'operation "Decommuter"  */
/*           : va  :                                                         */
/*           : - extraire les donnees brutes correspondant a chacune des     */
/*           :   variables mentionnees dans la description de ce bloc.       */
/*           : - appliquer la fonction de conversion  pour chacune de ces    */
/*           :   variables.                                                  */
/*           : - retourner la liste des variables de ce bloc.                */
/*****************************************************************************/

extern
DECOM__T_status
DECOM__Decommuter(
    const TYCST__T_pt_void bloc, 
    const TYCST__T_int4 lg_bloc, 
    const DECOM__T_nom_bloc nom_bloc, 
    const TYCST__T_pt_char  composante, 
    DECOM__T_pt_liste_var liste_var
    )
{
  
    DECOM__T_status status = DECOM__C_nok;
    DECOM__T_desc_bloc info_bloc;
    int i;
    TYCST__T_int4 resu;
  
    bzero ( liste_var, sizeof (DECOM__T_liste_var));

    /* SI fichier description est charge ET le pointeur passe # nil ALORS */
    if (( DECOM__G_nb_bloc >= 0 ) && (strcmp (nom_bloc,"") != 0)) {
   
        /* SI la description du bloc est connu ALORS */
        resu=DECOM__Rechercher_info_bloc(nom_bloc, &info_bloc);
    
        if ( resu != -1) {
            status = DECOM__C_ok;
// ceci est inutile car info_bloc est initialise par DECOM__Rechercher_info_bloc
//            info_bloc.lg = lg_bloc;

            /* POUR toutes les variables du bloc */
            for (i=0; ((i < info_bloc.nb_var) && (status == DECOM__C_ok)) ; i++) {
	      
                /*     Appeler la fonction de decommutation pour chaque variable */
                status = DECOM__Decommuter_variable (composante,bloc,liste_var,
                                                     info_bloc,info_bloc.var[i].nom);

                if(status != DECOM__C_ok)
                  {
                    printf("DECOM :Pb variable : %s\n\n",
                           info_bloc.var[i].nom);
                  }

            }
            /* FINPOUR */
  
        
        }   
    } 
	
    return (status);
  
  
}


/* FIN DE Decommuter */

/*****************************************************************************/
/* PROCEDURE : Ajouter_variable                                              */
/*---------------------------------------------------------------------------*/
/* ROLE      : Permet d'ajouter une variable dans la liste des variables     */
/*           : a recommuter par exemple.                                     */
/* remarque : dans le cas de la commutation la variable dim utilisee est celle*/
/* dans la description du fichier et pas celle indiquee ici		     */
/*****************************************************************************/

extern
DECOM__T_status
DECOM__Ajouter_variable (
    DECOM__T_pt_liste_var liste_var, /* INOUT  Liste de variable a completer */
    const TYCST__T_pt_char   prefixe,      /* IN Prefixe a rajouter aux nom  */
    /* de variable.                   */ 
    const DECOM__T_nom_var   nom_variable, /* IN Nom de la variable.    */
    const DECOM__T_type_var  type,         /* IN Type de la variable.   */
    const TYCST__T_int4  	dim,       /* dimension de la variable.   */
    const DECOM__T_val_var   valeur        /* IN Valeur de la variable. */
    )
{
    DECOM__T_status status = DECOM__C_ok;
   
    if( dim <=0 )
        // erreur de taille
    {status = DECOM__C_err_taille_tab;   }
    else if (dim !=1 && type == DECOM__C_string)
        // tableaux de chaines non supportes
    {status = DECOM__C_err_tab_ascii;   }
    else {
        /* SI le tableau des variable est NULL ALORS */
        if (liste_var->tab_var == NULL) {
   
            /* il  faut faire une allocation */
            liste_var->tab_var =  TYCST__MALLOC (sizeof(DECOM__T_var));
   
            /* SINON */
        }else{
            /* Il faut faire une reallocation */
            liste_var->tab_var =  TYCST__REALLOC (liste_var->tab_var,
                                                  (liste_var->nb_var + 1)*
                                                  sizeof(DECOM__T_var));
            /* FINSI */
        }
        /* SI l'allocation est correcter ALORS */
        if (liste_var->tab_var != NULL) {
    
            /* Il faut recopier Nom , Type, Valeur de la variable */
            strcpy (liste_var->tab_var[liste_var->nb_var].nom,prefixe);
            strcat (liste_var->tab_var[liste_var->nb_var].nom,nom_variable);
	    // on effectue ici une copie superficielle de l'adresse allouee au dessus
	    switch (type) {
               case DECOM__C_int4 :
                  liste_var->tab_var[liste_var->nb_var].val.pi4  = valeur.pi4;
               break;
               case DECOM__C_uint4 :
                  liste_var->tab_var[liste_var->nb_var].val.pui4  = valeur.pui4;     
               // FT-2765
               break;
               // ...FT-2765
               case DECOM__C_real8 :
                  liste_var->tab_var[liste_var->nb_var].val.pr8  = valeur.pr8;  
               break;
               case DECOM__C_string :
                   liste_var->tab_var[liste_var->nb_var].val.s  = valeur.s;        
               break;
               case DECOM__C_date :
                   liste_var->tab_var[liste_var->nb_var].val.pdate  = valeur.pdate;  
               break;
               case DECOM__C_gentime :
                 liste_var->tab_var[liste_var->nb_var].val.pgentime  = valeur.pgentime;    
               break;
               default : status = DECOM__C_err_format; 
          	        }

//            liste_var->tab_var[liste_var->nb_var].val  = valeur;
	    // jlp on ajoute ici un pointeur sur le tableau dans le cas
	    // des tableau ascii ou des chaines
            liste_var->tab_var[liste_var->nb_var].type = type;
            liste_var->tab_var[liste_var->nb_var].dim = dim;
            /* et incremter le nombre de variable dans la liste */
            liste_var->nb_var = liste_var->nb_var + 1;
            
            /* SINON */
        }else{
     
            /* Il faut signaler une erreur d'allocation */
            status = DECOM__C_err_allocation; 
     
            /* FINSI */
        }
    }  /* FINSI */
   
    return (status);
}
               
/*****************************************************************************/
/* PROCEDURE : Recommuter                                                    */
/*---------------------------------------------------------------------------*/
/* ROLE      : Pour construire un bloc de donnees l'operation "Recommuter"   */
/*           : s'appuie sur une description de bloc.                         */
/*           : La description de tous les blocs est definie dans un fichier  */
/*           : ASCII. Ce fichier est charge lors de l'appel a loperation     */
/*           : DECOM__Charger.                                               */
/*           : A partir de la description du bloc et de la liste des         */
/*           : variables fournie par l'appelant, l'operation "Decommuter"    */
/*           : va :                                                          */
/*           : - creer un bloc en initialisant chaque octet avec la valeur   */
/*               d'initialisation indiquee dans la description,              */
/*           : - appliquer la fonction de conversion  pour chacune des       */
/*           :   variables de la liste                                       */
/*           : - inserer les valeurs obtenues dans le bloc                   */
/*           : - retourner le bloc.                                          */
/*****************************************************************************/

extern
DECOM__T_status
DECOM__Recommuter(
    const DECOM__T_nom_bloc nom_bloc, 
    const DECOM__T_liste_var liste_var, 
    TYCST__T_pt_pt_char bloc, 
    TYCST__T_pt_int4 lg_bloc
    )
{
    DECOM__T_status status = DECOM__C_nok;
    DECOM__T_desc_bloc info_bloc;
    int i;
    TYCST__T_pt_void bloc_tmp;
  
    /* SI fichier description charge ALORS */
    if ( DECOM__G_nb_bloc >= 0 ) {
  
        status = DECOM__C_err_bloc_inconnu;
     
        /* SI la description du bloc est connu */
        if ( DECOM__Rechercher_info_bloc(nom_bloc, &info_bloc) != -1) {
   
            bloc_tmp = TYCST__MALLOC (info_bloc.lg);

            /* SI l'allocation est OK ALORS */
  
            if (bloc_tmp != NULL) {
     
                /* Creer un bloc en initialisant chaque octet avec la valeur */
                /* d'initialisation indiquee dans la description du bloc     */
   
                memset (bloc_tmp,info_bloc.val_init,info_bloc.lg);
                status = DECOM__C_ok;
            
		/* POUR toutes les variables de la liste */
                for (i=0; ((i < liste_var.nb_var) && (status == DECOM__C_ok)) ; i++) {

		  /*      Appeler la fonction de decommutation pour chaque variable */
		  status = DECOM__Recommuter_variable (bloc_tmp,info_bloc.lg,
                                                         info_bloc,&liste_var.tab_var[i]);

		  if(status != DECOM__C_ok)
                    {
                      printf("DECOM :Pb variable : %s\n\n", 
                             liste_var.tab_var[i].nom);
			     // en cas de pb de commutation on continue
			     status = DECOM__C_ok;
                     }

                }
                /* FINPOUR */
  
                /* SI le status est OK ALORS */
                if (status == DECOM__C_ok) {
  
                    /* Affecter les parametres en retour : pointeur et longueur de bloc */
                    *lg_bloc = info_bloc.lg;
                    *bloc = bloc_tmp;
                }else {
  
                    /* SINON liberer le pointeur de travail */
                  TYCST__FREE (bloc_tmp);
                    /* FINSI */
                }
                /* SINON signaler l'erreur d'allocation */
            } else {
                status = DECOM__C_err_allocation;
                /* FINSI */
            }
       
            /* FINSI */
        }   
        /* FINSI */
    } 
    return (status); 
}

/* FIN DE Recommuter */

/*****************************************************************************/
/* PROCEDURE : Liberer_liste_var                                             */
/*---------------------------------------------------------------------------*/
/* ROLE      : Permet de liberer l'espace memoire alloue par l'operation     */
/*           : "DECOM__Ajouter_variable" pour retourner la liste des variables */
/* en particulier pour la commutation ou la donnees elle meme est allouee   */
/* par l'appelant */
/*****************************************************************************/

extern
void
DECOM__Liberer_liste_var(
    const DECOM__T_pt_liste_var liste_var /* IN Liste des variables a liberer. */
    )
{
  /* Liberer le  tableau des variables. */
  TYCST__FREE (liste_var->tab_var);

  // la liberation est ici superficielle
  /* Remettre a zero la structure. */
  bzero (liste_var,sizeof (DECOM__T_pt_liste_var));
}
/* FIN DE Liberer_liste_var */

/*****************************************************************************/
/* PROCEDURE : Liberer_bloc                                                  */
/*---------------------------------------------------------------------------*/
/* ROLE      : Permet de liberer l'espace memoire alloue par l'operation     */
/*           : "Recommuter"pour retourner le bloc de donnees.                */
/*****************************************************************************/

extern
void
DECOM__Liberer_bloc(
    TYCST__T_pt_void bloc /* IN Bloc de donnee retourne par */
    /* recommuter.                    */
    )
{
  /* Liberer le bloc de donnees passer en parametre */
  TYCST__FREE (bloc);
}
/* FIN DE Liberer_bloc */

/*****************************************************************************/
/* PROCEDURE : Charger                                                       */
/*---------------------------------------------------------------------------*/
/* ROLE      : Permet de charger la description de tous les blocs . Cette    */
/*           : description est defini dans un fichier ASCII dont le format   */
/*           : est le suivant :                                              */
/*           : VERSION   <NUM_VERSION>                                       */
/*           : [ BLOC BRUT                                                   */
/*           : NOM  <NOM_BLOC>                                               */
/*           : LG      <LONGUEUR_BLOC>                                       */
/*           : INIT     <VAL_INIT>                                           */
/*           : VAR                                                           */
/*           : NOM      <NOM_VARIABLE>                                       */
/*           : OFFSET <OFFSET>                                               */
/*           : LG          <LONGUEUR_VAR>                                    */
/*           : CONV <TYPE_CONV>                                              */
/*           : PARAM [  <PARAM_CONV>]*                                       */
/*           : FINVAR                                                        */
/*           : FINBLOC ]*                                                    */
/*           : [ BLOC ASCII                                                  */
/*           : SEP (<SEPARATEUR>)                                            */
/*           : INIT     <VAL_INIT>                                           */
/*           : VAR                                                           */
/*           : NOM      <NOM_VARIABLE>                                       */
/*           : RANG      <RANG_VARIABLE>                                     */
/*           : CONV <TYPE_CONV>                                              */
/*           : PARAM [  <PARAM_CONV>]*                                       */
/*           : FINVAR                                                        */
/*           : FINBLOC]*                                                     */
/*           : Les informations utiles sont entre <>                         */
/*           : Les mots cles ne sont pas entre <>                            */
/*           : Toute information entre [ ] et suivi de * peut apparaitre     */
/*           : en n exemplaire                                               */
/*           : ( n>= 0)                                                      */
/*           : <NUM_VERSION>     : numero de version du fichier              */
/*           : <NOM_BLOC>        : nom du bloc                               */
/*           : <LONGUEUR_BLOC>   : longueur du bloc en octets                */
/*           : <VAL_INIT>        : valeur d'initialisation des octets du     */
/*           :  bloc (en hexa)                                               */
/*           : <NOM_VARIABLE>    : nom d'une variable                        */
/*           : <OFFSET>          : deplacement en bits par rapport au        */
/*           :                     debut du bloc                             */
/*           : <LONGUEUR_VAR>    : longueur en bits des donnees dans le bloc */
/*           : <TYPE_CONV>       : Type de conversion                        */
/*           : <PARAM_CONV>      : Parametres de la conversion (double)      */
/*           : <SEPARATEUR>      : Caractere separateur de champs dans un    */
/*           :                     bloc ASCII                                */
/*           : <RANG_VARIABLE>   : Rang d'une variable dans un bloc ASCII .  */
/*           :                     La premiere variable commence au rang 0.  */
/*****************************************************************************/
extern
DECOM__T_status
DECOM__Charger(
    const TYCST__T_chemin_fichier fichier /* IN Chemin d'acces au fichier. */
    )
{
    // FT-2765
    DECOM__T_status status = DECOM__C_ok;
    int fd;
    int sauv_stdin;

    /* Sauvegarder le  descripteur de stdin */
    sauv_stdin = dup (STDIN_FILENO);
    if (sauv_stdin == -1)
    {
        status = DECOM__C_err_descripteur;
        goto out;
    }

    /* Ouvrir le fichier de description */
    fd = open(fichier, O_RDONLY);
    if (fd == -1)
    {
        status = DECOM__C_err_descripteur;
        goto out;
    }

    /* Associe le descripteur de fichier a l'entree standard */
    if (dup2(fd, STDIN_FILENO) == -1)
    {
        status = DECOM__C_err_descripteur;
        goto out;
    }
    close(fd);

    /* Analyser le fichier de description des blocs */
    if ( yyparse() != 0)
    {
        status = DECOM__C_err_analyse;
        goto out;
    }

    /* reaffecter le descripteur de stdin */
    if (dup2(sauv_stdin, STDIN_FILENO) == -1)
    {
        status = DECOM__C_err_descripteur;
        goto out;
    }

    /* Fermer la sauvegarde de stdin. */
    close (sauv_stdin);
out:
    // ...FT-2765

    /* retourner le status de l'operation */
    return (status);    
}
/* FIN DE Charger */


/*****************************************************************************/
/*                     CORPS DES OPERATIONS INTERNES (static)                */
/*****************************************************************************/

/*****************************************************************************/
/* PROCEDURE : Inserer_variable                                              */
/*---------------------------------------------------------------------------*/
/* ROLE      : Insere dans le bloc la valeur d'une variable en la            */
/*           : formattant sauf dans le cas reel                                                   */
/*****************************************************************************/


static DECOM__T_status DECOM__Inserer_variable (

    TYCST__T_pt_void buffer,  /* INOUT Buffer d'ecriture.                     */
    TYCST__T_int4 lg_buffer,  /* IN Longueur du buffer a inserer.             */
    TYCST__T_int4 offset,     /* IN Offset en bit par rapport au debut du     */
    /* bloc.                                        */
    DECOM__T_type_var type,   /* type  de variable a inserer  */	
    TYCST__T_int4 longueur,   /* IN Longueur en bit de l'information.         */
    TYCST__T_real8 valeur_r   /* IN Information a inserer.                    */
    )

{
    TYCST__T_uint4 var_loc = 0;
    TYCST__T_int4 var_loc2 = 0;
    TYCST__T_int4  longueur_MSB,longueur_LSB;
    TYCST__T_int4  offset_octet;
    TYCST__T_int4  decalage;
    DECOM__T_status status = DECOM__C_err_debordement;  
    TYCST__T_uint4 mask, debut, fin;
    TYCST__T_int4  nb;
    TYCST__T_uint4  valeur;
    TYCST__T_real4  valeur_r4;
    TYCST__T_real8 poids_MSB,valeur_MSB,valeur_LSB ; 

  
    /* SI la valeur est une date */
    if (type == DECOM__C_date )
    {
        status = DECOM__C_ok;
        /* Calcul du decalage par rapport a la frontiere d'octet la plus proche. */
        /* on ne prend en compte ici que les valeurs codees sur des octets entier */
        decalage  = (offset - ((offset / 8) * 8)) ;
        if (decalage !=0) 
        {status = DECOM__C_err_codage_date; goto ERREUR;}
        offset_octet = (offset / 8);
        /* calcul du nombre d'octet de l'information utile */
        nb = TYCST__MIN (lg_buffer - offset_octet,
                         (longueur)/8);
        /* ALORS on l'ecrit directement*/
        /* Insertion de la valeur dans le buffer */
        memcpy ((TYCST__T_pt_char)buffer + offset_octet, &valeur_r, nb);
    }
    
    /* SI la valeur est vraiment codee sur un reel simple precision */
    else if (type == DECOM__C_real4)
    {
      status = DECOM__C_ok;
      /* Calcul du decalage par rapport a la frontiere d'octet la plus proche. */
      /* on ne pren en compte ici que les valeurs codees sur des octets entier */
      decalage  = (offset - ((offset / 8) * 8)) ;
      if (decalage !=0) 
      {
        status = DECOM__C_err_codage_double; 
        goto ERREUR;
      }
      
      offset_octet = (offset / 8);
      
      /* calcul du nombre d'octet de l'information utile */
      nb = TYCST__MIN (lg_buffer - offset_octet, (longueur)/8);
      
      valeur_r4 = (TYCST__T_real4) valeur_r;
      
      /* Insertion de la valeur dans le buffer */
      memcpy ((TYCST__T_pt_char)buffer + offset_octet, &valeur_r4, nb);
      // FT-2765
      SWAP_INT_BUFFER( (TYCST__T_pt_char)buffer + offset_octet, nb, 1 );
      // ...FT-2765
    }

    /* SI la valeur est vraiment codee sur un reel double precision */
    else if (type == DECOM__C_real8 && longueur > 32 )
//      else if (type == DECOM__C_real8 )
    {
        status = DECOM__C_ok;
        /* Calcul du decalage par rapport a la frontiere d'octet la plus proche. */
        /* on ne pren en compte ici que les valeurs codees sur des octets entier */
        decalage  = (offset - ((offset / 8) * 8)) ;
        if (decalage !=0) 
        {status = DECOM__C_err_codage_double; goto ERREUR;}
        offset_octet = (offset / 8);
        /* calcul du nombre d'octet de l'information utile */
        nb = TYCST__MIN (lg_buffer - offset_octet,
                         (longueur)/8);
        /* ALORS on l'ecrit directement*/
        /* Insertion de la valeur dans le buffer */
        memcpy ((TYCST__T_pt_char)buffer + offset_octet, &valeur_r, nb);
    }
    /* SI la valeur tient bien dans la taille alloue ALORS */
//cas des valeurs negatives
    else if ((fabs(valeur_r) <= (pow (2,longueur) - 1) && valeur_r>=0.) ||
             (fabs(valeur_r) <= (pow (2,longueur) - 2) && valeur_r<0.)  ) {
        status = DECOM__C_ok;

        /* Calcul du decalage par rapport a la frontiere d'octet la plus proche. */
        decalage  = (offset - ((offset / 8) * 8)) ;
        offset_octet = (offset / 8);

        /* calcul du nombre d'octet de l'information utile */
        nb = TYCST__MIN (lg_buffer - offset_octet,
                         (longueur + decalage + 7)/8);

        /* SI la variable tient dans un TYCST__T_int4  ALORS */
        if ( nb <= sizeof (TYCST__T_int4)) {

            /* ALORS on la stocke */
//cas des valeurs negatives
            if (valeur_r >0.)
            valeur = (TYCST__T_uint4) valeur_r;
            else
            valeur = (TYCST__T_uint4) -valeur_r;
  
            memcpy (&var_loc, (TYCST__T_pt_char)buffer + offset_octet, nb);
            // FT-2765
            SWAP_INT_BUFFER( &var_loc, 4, 1 ); /* buffer( BIG ) */
            // ...FT-2765

            /* Calcul du masque a appliquer sur la valeur a inserer, */
  
            debut = 32 - decalage;
            if( debut == 32 ){
                mask = 0xFFFFFFFF;
            }else{
                mask = (1 << debut) - 1;
            }
            fin = debut - longueur;
            if( fin ){
                mask &= ~((1 << fin) - 1);
            }

            /* Application du masque sur la valeur */
            valeur <<= debut - longueur;
            valeur &= mask;
            var_loc &= ~mask;
            var_loc |= valeur;

  
            /* Insertion de la valeur dans le buffer */

//cas des valeurs negatives
            // FT-2765
    	    if  (valeur_r >=0.)
    	    {
    	    	SWAP_INT_BUFFER( &var_loc, 4, 1 );
                memcpy ((TYCST__T_pt_char)buffer + offset_octet, &var_loc, nb);
    	    }
    	    else
    	    {
                var_loc2=-var_loc;
                SWAP_INT_BUFFER( &var_loc2, 4, 1 );
                memcpy ((TYCST__T_pt_char)buffer + offset_octet, &var_loc2, nb);
    	    }
    	    // ...FT-2765

            /* SINON on doit inserer la valeur en plusieurs fois */
        } else if (nb <= 2 * (sizeof (TYCST__T_int4))) {
   
            /* Calcul de la longueur en bit de l'information poids forts */
            longueur_MSB = (nb * 8)-(sizeof (TYCST__T_int4)*8 + decalage);

            /* Calcul de la valeur de l'information poids forts */
            poids_MSB =  pow (2,longueur - longueur_MSB);
            valeur_MSB = floor (valeur_r / poids_MSB);

            /* Insertion de la valeur poids fort */
            status = DECOM__Inserer_variable (buffer,lg_buffer,offset,longueur_MSB,
                                              type,valeur_MSB);
            if (status == DECOM__C_ok){

                /* Calcul de la valeur poids faible */
                valeur_LSB = (valeur_r -  (valeur_MSB * poids_MSB));

                /* Insertion de la valeur poids faible */
                longueur_LSB = longueur - longueur_MSB;
                status = DECOM__Inserer_variable(buffer,lg_buffer,offset+longueur_MSB,
                                                 type,longueur_LSB,valeur_LSB);
            }

        } /* FINSI taille > a 4 octets */
    } /* FINSI risque de debordement */
 ERREUR:
    return (status);
}

/*****************************************************************************/
/* PROCEDURE : Recommuter_variable                                           */
/*---------------------------------------------------------------------------*/
/* ROLE      : Insere dans le bloc a construire la valeur contenu dans la    */
/*           : description de la variable.                                   */
/*****************************************************************************/
static
DECOM__T_status
DECOM__Recommuter_variable ( 
    const TYCST__T_pt_void   bloc,      /* INOUT  Bloc a reconstituer     */
    const TYCST__T_int4      lg,        /* IN Longueur du bloc.           */
    const DECOM__T_desc_bloc info_bloc, /* IN descriptif du bloc.         */
    const DECOM__T_pt_var    variable   /* IN Descriptif de la variable a */
    /*    inserer.                    */      
    )
{
  DECOM__T_desc_var desc_variable = {0};
  DECOM__T_status status = DECOM__C_nok;
  DECOM__T_valeur_brute * valeur_brute = NULL;
  DECOM__T_valeur_brute * valeur_convertie = NULL; 
  int i = 0;
  int offset = 0; 
  unsigned short local1 = 0;
  unsigned int local2 = 0;
  int year = 0;
  int month = 0;
  int day = 0;
  int hour = 0;
  int min = 0;
  int sec = 0;
  unsigned int millis = 0;
  int fin;
  
/* FA 190 */
  double valeur = 0.0;
/* ..FA 190 */

  /* SI la description de la variable existe dans le bloc  ALORS */		
  if (DECOM__Rechercher_info_variable(info_bloc,
                                      variable->nom,
                                      &desc_variable) != -1) 
    {
      /* Stocker dans une variable de travail la valeur a convertir */
      /* verification de la taille sur la variable */
	  // FT-2765
      if (desc_variable.dim == 0)
      // ...FT-2765
        {
          desc_variable.dim = 1;
        }

      if ((strcmp(desc_variable.nomcv, DECOM__C_nom_conv_26) != 0 && desc_variable.dim != variable->dim ) ||
          (strcmp(desc_variable.nomcv, DECOM__C_nom_conv_26) == 0 && desc_variable.dim != variable->dim*2))
        {
          status = DECOM__C_err_dim_variable;
          goto ERREUR;
        }
    
      /*on alloue de la memoire pour les tableaux de valeur*/ 
      valeur_brute = TYCST__MALLOC(desc_variable.dim * 
                                   sizeof(DECOM__T_valeur_brute));
      valeur_convertie = TYCST__MALLOC(desc_variable.dim * 
                                       sizeof(DECOM__T_valeur_brute));
      if ( (valeur_brute == NULL) || (valeur_convertie == NULL) )
        {
          status = DECOM__C_err_allocation;
        }
      else
        {
          /* SELON le type de la variable */
          
          /* on considere ici que la zone memoire des pointeurs a ete prealablement allouee   */
    
          switch (variable->type) 
            {
              /* Pour un entier signe, la valeur est transforme en un   */
              /* double et le type est marque a real8.                  */
              /* La longueur en bit de la variable cible (celle qui est */
              /* dans le bloc) est enregistree dans la structure pour   */
              /* etre passee au fonction de conversion.                 */ 
              
            case DECOM__C_int4 :
	      if (strcmp(desc_variable.nomcv, DECOM__C_nom_conv_26) != 0)
		{
		  for (i=0; i<desc_variable.dim; i++)
                    {
                      //   if (FINITE(variable->val.pi4[i]))
                      // on prevoir le cas NAN ou Inf et on met a 0
                      valeur_brute[i].valeur = (double) (variable->val.pi4[i]);
                      //   else
                      //     {valeur_brute[i].valeur =0;}
                      valeur_brute[i].type = DECOM__C_real8;
                      valeur_brute[i].longueur = desc_variable.lg;
                    }
		}
	      else
		{
		  for (i=0; i<desc_variable.dim/2; i++)
                    {
                      local1=(unsigned short)((variable->val.pi4[i])>>16);
                      valeur_brute[i].valeur =(double)local1;
                      local1=(unsigned short)(variable->val.pi4[i]);
                      valeur_brute[i + desc_variable.dim/2].valeur =(double)local1;
                      valeur_brute[i].type = DECOM__C_real8;
                      valeur_brute[i].longueur = desc_variable.lg;
                    }
                }
              status = DECOM__C_ok;
              break;

              /* Pour un entier non signe, la valeur est transforme en un   */
              /* double et le type est marque a real8.                  */
              /* La longueur en bit de la variable cible (celle qui est */
              /* dans le bloc) est enregistree dans la structure pour   */
              /* etre passee au fonction de conversion.                 */ 
            case DECOM__C_uint4 :
              for(i=0; i<desc_variable.dim; i++)
                {
                  // on prevoir le cas NAN ou Inf et on met a 0

/* FA 190 */
                 valeur = (double)variable->val.pui4[i];
		 if (FINITE(valeur))
/* .. FA 190 */
                    {
                      valeur_brute[i].valeur = (variable->val.pui4[i]);
                    }
                  else 
                    {
                      valeur_brute[i].valeur =0;
                    }
                  valeur_brute[i].longueur = desc_variable.lg;
                  
                  if(strcmp(desc_variable.nomcv, DECOM__C_nom_conv_25) == 0)
                    {
                      valeur_brute[i].type = DECOM__C_date;
                    }
                  valeur_brute[i].type = DECOM__C_real8;
                }
              status = DECOM__C_ok;
              break;

              /* Pour un reel, le type est marque a real8.              */
              /* La longueur en bit de la variable cible (celle qui est */
              /* dans le bloc) est enregistree dans la structure pour   */
              /* etre passee au fonction de conversion.                 */ 
            case DECOM__C_real8 :
              for(i=0; i<desc_variable.dim; i++)
                {
                  // on prevoir le cas NAN ou Inf et on met a 0
                  if (FINITE(variable->val.pr8[i]))
                    {
                      valeur_brute[i].valeur = (variable->val.pr8[i]);
                    }
                  else 
                    {
                      valeur_brute[i].valeur =0.;
                    }
                  valeur_brute[i].longueur = desc_variable.lg;
                  
                  /* Pour les reels codes sur 4 octets */
                  if ( (desc_variable.lg == 32) && 
                       (!strcmp(desc_variable.nomcv, DECOM__C_nom_conv_1)) )
                  {
                    valeur_brute[i].type = DECOM__C_real4;
                  }
                  else
                  {
                    valeur_brute[i].type = DECOM__C_real8;
                  }
                }	   
              status = DECOM__C_ok;
              break;
              
              /* Pour une chaine la valeur d'entree est garde et le type est marque */
              /* a String. */
            case DECOM__C_string :
              //  les tableaux de chaines ne sont pas traites
              valeur_brute[0].buffer = variable->val.s;
              valeur_brute[0].nb_octet = strlen (variable->val.s);
              valeur_brute[0].type = DECOM__C_string;
              status = DECOM__C_ok;
              break;
              
            case DECOM__C_date :
              for (i=0; i<desc_variable.dim; i++)
                {
                  local1 = (unsigned short) variable->val.pdate[i].day;
                  local2 = (unsigned int)variable->val.pdate[i].millis;
                  memcpy((TYCST__T_pt_char)(&valeur_brute[i].valeur),
                         (TYCST__T_pt_char)&(local1),
                         2);
                  memcpy((TYCST__T_pt_char)(&valeur_brute[i].valeur)+2,
                         (TYCST__T_pt_char)&(local2),
                         4);
                  valeur_brute[i].longueur = desc_variable.lg;
                  valeur_brute[i].type = DECOM__C_date;
                }
              status = DECOM__C_ok;
              break;
              
            case DECOM__C_gentime :
	    //jlp controles sur les dates pour eviter les debordements
                 year = variable->val.pgentime[0].year;
              if ( abs(year) >= 10000)
                 year = 0;
	      
              month = variable->val.pgentime[0].month;
              if ( abs(month) >= 13)
                 month = 0;
              day = variable->val.pgentime[0].day;
              if ( abs(day) >= 32)
                 day = 0;
              hour = variable->val.pgentime[0].hour;
              if ( abs(hour) >= 25)
                 hour = 0;
              min = variable->val.pgentime[0].min;
             if ( abs(min) >= 61)
                 min = 0;
               sec = variable->val.pgentime[0].sec;
             if ( abs(sec) >= 61)
                 sec = 0;

              /* si SHORT GENERALIZED TIME */
              if (desc_variable.lg/8 == DECOM__C_LG_GENTIME)
                {
                  valeur_brute[0].buffer = (char*)malloc((DECOM__C_LG_GENTIME)*sizeof(char));
                  sprintf(valeur_brute[0].buffer,
                          "%04d%02d%02d%02d%02d%02dZ",
                          year,month,day,hour,min,sec);
                  
                  valeur_brute[0].nb_octet = DECOM__C_LG_GENTIME;
                }
              /* si LONG GENERALIZED TIME */
              /* on rajoute les millisecondes */
              else
                {
                  millis = variable->val.pgentime[0].millis;
                  if ( abs(millis) >= 1000)
                     millis = 0;
                  valeur_brute[0].buffer = (char*)malloc(DECOM__C_LG_LONGGENTIME*sizeof(char)+1);
                  
                  sprintf(valeur_brute[0].buffer,
                          "%04d%02d%02d%02d%02d%02d%03dZ",
                          year,month,day,hour,min,sec,millis);
                  valeur_brute[0].nb_octet = DECOM__C_LG_LONGGENTIME;
                }

              valeur_brute[0].longueur = desc_variable.lg;
              valeur_brute[0].type = DECOM__C_string;
              status = DECOM__C_ok;
              break;
		
            default : 
              status = DECOM__C_err_format;
              break;
            }

          /* SI le type est correct */
          if (status == DECOM__C_ok) 
            {               
           fin=0;
              /* Appliquer la fonction de conversion */
              // pour chaque element du tableau
              for (i=0; i<desc_variable.dim; i++)
                {
                  valeur_brute[i].action = DECOM__C_recommutation;
                  status = desc_variable.decom.proc_conv (&valeur_brute[i],&valeur_convertie[i], 
                                                          desc_variable.decom.nb_param,
                                                          desc_variable.decom.param);
                  
                  /* Si la valeur retournee est de type binaire Et le status est OK */ 
                  if ( (valeur_convertie[i].type == DECOM__C_type_binaire ) &&
                       ( status == DECOM__C_ok)) 
                    {
                      /* inserer l'information dans le buffer. */
                      offset = desc_variable.offset + i*desc_variable.lg;
                      
                      status = DECOM__Inserer_variable (bloc,
                                                        lg,
                                                        offset,
                                                        valeur_brute[i].type,
                                                        desc_variable.lg,
                                                        valeur_convertie[i].valeur
                                                        );               
                    }
                  /* SINON elle est de type ascii et SI le status est OK */
                  else if ( status == DECOM__C_ok) 
                    {
                      /* Recopie les octets dans le buffer */  
                      
                      // l'offset des ascii doit etre un nombre entier d'octet !!!)
                      memcpy ((TYCST__T_pt_char) bloc + (desc_variable.offset/8),
                              valeur_convertie[i].buffer , 
                              valeur_convertie[i].nb_octet);
                  
                      //on ne libere pas les valeur_brute et valeur_convertie car ils pointent sur la valeur en entree
                      
                      // si type gentime on libere le buffer alloue
                      if(variable->type == DECOM__C_gentime)
                        {
                          TYCST__FREE (valeur_brute[i].buffer);
                          // TYCST__FREE (valeur_convertie[i].buffer);
                        }
                      else
                        {
                          //TYCST__FREE (valeur_convertie[i].buffer);
                        }
                        // FT-2512
                        if ((variable->type == DECOM__C_real8) || (variable->type == DECOM__C_uint4) || (variable->type == DECOM__C_int4)) {
                            TYCST__FREE (valeur_convertie[i].buffer);
                        }
                        // ..FT-2512
                    }
		 if(status != DECOM__C_ok)
                    {
// on memorise l'erreur de debordement
                      printf("DECOM :Pb insertion statut = %d indice = %d valeur = %lf\n\n", 
                             status,i,valeur_brute[i].valeur);
		      fin=1;
                   }

                } // fin pour chaque element                               
            } // fin si status = ok
// on memorise l'erreur de debordement
            if(fin == 1)
	     status=DECOM__C_err_debordement;

          // on libere ici les tableau de donnee allouee au debut 
          TYCST__FREE(valeur_convertie);
          TYCST__FREE(valeur_brute);
        } // fin si l'allocation s'est bien passee     
    }
  else
    {
      // si variable n'esiste pas on la saute
      status = DECOM__C_ok;
    }
  /* FIN SI la description de la variable existe dans le bloc  ALORS */	



 ERREUR:
	
  return (status);
}


/*****************************************************************************/
/* PROCEDURE : Extraire_variable_binaire                                     */
/*---------------------------------------------------------------------------*/
/* ROLE      : Extrait la valeur brute d'un buffer binaire.                  */
/*****************************************************************************/


static 
DECOM__T_status 
DECOM__Extraire_variable_binaire (

    TYCST__T_pt_void buffer,  /* IN Buffer de lecture.                        */
    TYCST__T_int4 offset,     /* IN Offset en bit par rapport au debut du     */
    /* bloc.                                        */
    TYCST__T_int4 longueur,   /* IN Longueur en bit de l'information.         */
    TYCST__T_pt_real8 retour  /* OUT Information en retour.                   */
    )

{
    TYCST__T_uint4 var_loc = 0;
    TYCST__T_uint4 var_octet_0 = 0;
    TYCST__T_uint4 var_octet_1 = 0;
    TYCST__T_uint4 var_octet_2 = 0;
    TYCST__T_uint4 var_octet_3 = 0;
    TYCST__T_uint4 var_octet_4 = 0;

    TYCST__T_int4 decalage,nb;
    TYCST__T_int4 decalage_insertion;
  
    /* Initialiser status a ok */
    DECOM__T_status status = DECOM__C_ok;
  
    /* Calcul du decalage par rapport a la frontiere d'octet la plus proche. */
    decalage  = (offset - ((offset / 8) * 8));
    offset = (offset / 8);


    /* calcul du nombre d'octet de l'information utile */
    nb = (longueur + decalage + 7)/8;

    /* SI la longueur de l'information (longueur + decalage) est compatible avec le codage */
    /* de la machine (32 bits) ALORS */
    if (longueur + decalage <= sizeof(TYCST__T_int4)*8 ){
  
        /* Recopier le mot de 32 bits du buffer dans la variable de travail */
        memcpy (&var_loc,((TYCST__T_pt_char) buffer + offset),sizeof(TYCST__T_int4));
        // FT-2765
        SWAP_INT_BUFFER( &var_loc, 4, 1 );
        // ...FT-2765

        /* Cadrer la valeur a droite */   
        var_loc = var_loc >> sizeof(TYCST__T_int4)*8 - decalage - longueur ;
     
        /* Masquer les bits qui ne font pas partis de l'information */   
        var_loc &= DECOM__G_tab_mask [longueur];
   
   
        /* Affecter la valeur */
        *retour = (TYCST__T_real8) var_loc;
  
        /* Longueur de l'information inferieure a 32 bits */   
    } else if (nb == 5) { 

        /* Calcul de decalage insertion */
        decalage_insertion = (nb * 8) - (longueur + decalage); 

        /* Dans ce cas on a forcement 5 octets en jeux */
        var_octet_0 = *((TYCST__T_pt_uchar) buffer + 4);
        var_octet_1 = *((TYCST__T_pt_uchar) buffer + 3);
        var_octet_2 = *((TYCST__T_pt_uchar) buffer + 2);
        var_octet_3 = *((TYCST__T_pt_uchar) buffer + 1);
        var_octet_4 = *((TYCST__T_pt_uchar) buffer);


        /* On decale le premier octet */
        var_octet_0 = var_octet_0 >> decalage_insertion;

        /* on lui ajoute en poid fort la partie basse de l'octet suivant */
        var_octet_0 |= (var_octet_1 << (8 - decalage_insertion));
        var_octet_0 &= (int) DECOM__G_tab_mask [8];

        /* On decale le deuxieme octet */
        var_octet_1 = var_octet_1 >> decalage_insertion;

        /* on lui ajoute en poid fort la partie basse de l'octet suivant */
        var_octet_1 |= (var_octet_2 << (8 - decalage_insertion));
        var_octet_1 &= (int) DECOM__G_tab_mask [8];

        /* On decale le troisieme octet */
        var_octet_2 = var_octet_2 >> decalage_insertion;

        /* on lui ajoute en poid fort la partie basse de l'octet suivant */
        var_octet_2 |= (var_octet_3 << (8 - decalage_insertion));
        var_octet_2 &= (int) DECOM__G_tab_mask [8];

        /* On decale le quatrieme octet */
        var_octet_3 = var_octet_3 >> decalage_insertion;

        /* on lui ajoute en poid fort la partie basse de l'octet suivant */
        var_octet_3 |= (var_octet_4 << (8 - decalage_insertion));
        var_octet_3 &= (int) DECOM__G_tab_mask [8];

        /* on reconstitue la valeur finale */
        var_loc = (var_octet_3 << 24) | (var_octet_2 << 16) | (var_octet_1 << 8) | var_octet_0 ;

        /* et on masque les bits qui ne font pas partis de l'information */   
        var_loc &= DECOM__G_tab_mask [longueur];

        /* Affecter la valeur */
        *retour = (TYCST__T_real8) var_loc;

    } else if (nb == 8) {
        /* cas d'une valeur sur 8 octets (double) cadree frontiere d'octet */
        memcpy (retour,((TYCST__T_pt_char) buffer + offset),sizeof(TYCST__T_real8));
        // FT-2765
        SWAP_INT_BUFFER( retour, 8, 1 );
        // ...FT-2765
        // cas des date ccsds 
    } else {
        /* SINON status = N_ok */
        status = DECOM__C_nok;
    }
  
    /* Retourner le  status */
    return (status);
}
/* FIN DE Extraire_variable_binaire */

// FT-2765
/*****************************************************************************/
/* PROCEDURE : Extraire_variable_binaire_brut                                */
/*---------------------------------------------------------------------------*/
/* ROLE      : Extrait la valeur brute d'un buffer binaire.                  */
/*****************************************************************************/
static
DECOM__T_status
DECOM__Extraire_variable_binaire_brut (

    TYCST__T_pt_void buffer,  /* IN Buffer de lecture.                        */
    TYCST__T_int4 offset,     /* IN Offset en bit par rapport au debut du     */
    /* bloc.                                        */
    TYCST__T_int4 longueur,   /* IN Longueur en bit de l'information.         */
    TYCST__T_pt_real8 retour  /* OUT Information en retour.                   */
    )

{
    TYCST__T_uint4 var_loc = 0;
    TYCST__T_uint4 var_octet_0 = 0;
    TYCST__T_uint4 var_octet_1 = 0;
    TYCST__T_uint4 var_octet_2 = 0;
    TYCST__T_uint4 var_octet_3 = 0;
    TYCST__T_uint4 var_octet_4 = 0;

    TYCST__T_int4 decalage,nb;
    TYCST__T_int4 decalage_insertion;

    /* Initialiser status a ok */
    DECOM__T_status status = DECOM__C_ok;

    /* Calcul du decalage par rapport a la frontiere d'octet la plus proche. */
    decalage  = (offset - ((offset / 8) * 8));
    offset = (offset / 8);


    /* calcul du nombre d'octet de l'information utile */
    nb = (longueur + decalage + 7)/8;

    /* SI la longueur de l'information (longueur + decalage) est compatible avec le codage */
    /* de la machine (32 bits) ALORS */
    if (longueur + decalage <= sizeof(TYCST__T_int4)*8 ){

        /* Recopier le mot de 32 bits du buffer dans la variable de travail */
        memcpy (&var_loc,((TYCST__T_pt_char) buffer + offset),sizeof(TYCST__T_int4));

        /* Cadrer la valeur a droite */
        var_loc = var_loc >> sizeof(TYCST__T_int4)*8 - decalage - longueur ;

        /* Masquer les bits qui ne font pas partis de l'information */
        var_loc &= DECOM__G_tab_mask [longueur];


        /* Affecter la valeur */
        *retour = (TYCST__T_real8) var_loc;

        /* Longueur de l'information inferieure a 32 bits */
    } else if (nb == 5) {

        /* Calcul de decalage insertion */
        decalage_insertion = (nb * 8) - (longueur + decalage);

        /* Dans ce cas on a forcement 5 octets en jeux */
        var_octet_0 = *((TYCST__T_pt_uchar) buffer + 4);
        var_octet_1 = *((TYCST__T_pt_uchar) buffer + 3);
        var_octet_2 = *((TYCST__T_pt_uchar) buffer + 2);
        var_octet_3 = *((TYCST__T_pt_uchar) buffer + 1);
        var_octet_4 = *((TYCST__T_pt_uchar) buffer);


        /* On decale le premier octet */
        var_octet_0 = var_octet_0 >> decalage_insertion;

        /* on lui ajoute en poid fort la partie basse de l'octet suivant */
        var_octet_0 |= (var_octet_1 << (8 - decalage_insertion));
        var_octet_0 &= (int) DECOM__G_tab_mask [8];

        /* On decale le deuxieme octet */
        var_octet_1 = var_octet_1 >> decalage_insertion;

        /* on lui ajoute en poid fort la partie basse de l'octet suivant */
        var_octet_1 |= (var_octet_2 << (8 - decalage_insertion));
        var_octet_1 &= (int) DECOM__G_tab_mask [8];

        /* On decale le troisieme octet */
        var_octet_2 = var_octet_2 >> decalage_insertion;

        /* on lui ajoute en poid fort la partie basse de l'octet suivant */
        var_octet_2 |= (var_octet_3 << (8 - decalage_insertion));
        var_octet_2 &= (int) DECOM__G_tab_mask [8];

        /* On decale le quatrieme octet */
        var_octet_3 = var_octet_3 >> decalage_insertion;

        /* on lui ajoute en poid fort la partie basse de l'octet suivant */
        var_octet_3 |= (var_octet_4 << (8 - decalage_insertion));
        var_octet_3 &= (int) DECOM__G_tab_mask [8];

        /* on reconstitue la valeur finale */
        var_loc = (var_octet_3 << 24) | (var_octet_2 << 16) | (var_octet_1 << 8) | var_octet_0 ;

        /* et on masque les bits qui ne font pas partis de l'information */
        var_loc &= DECOM__G_tab_mask [longueur];

        /* Affecter la valeur */
        *retour = (TYCST__T_real8) var_loc;

    } else if (nb == 8) {
        /* cas d'une valeur sur 8 octets (double) cadree frontiere d'octet */
        memcpy (retour,((TYCST__T_pt_char) buffer + offset),sizeof(TYCST__T_real8));
        // cas des date ccsds
    } else {
        /* SINON status = N_ok */
        status = DECOM__C_nok;
    }

    /* Retourner le  status */
    return (status);
}
/* FIN DE Extraire_variable_binaire_brut */
// ...FT-2765

/*****************************************************************************/
/* DECLARATION des fonctions de conversion.                                  */
/*****************************************************************************/

/*****************************************************************************/
/* PROCEDURE : DECOM__Cnv_binaire_brut                                       */
/*---------------------------------------------------------------------------*/
/* ROLE      : Traite le binaire brute sortie = entree (normalisee).         */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_binaire_brut (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )

{
    DECOM__T_status status = DECOM__C_nok;
    TYCST__T_real8  local;
   
   
    /* SI l'action en cours est une decommutation */   
    if (val_in->action == DECOM__C_decommutation) {
   
        /* ALORS il faut extraire la variable numerique de l'information brute */
    	// FT-2765
        status = DECOM__Extraire_variable_binaire_brut (
            val_in->buffer,
            val_in->decalage,   
            val_in->longueur,
            &local);
	    // ...FT-2765
    } else {
        /* SINON pour la recommutation la valeur est passe en parametre */
        local = val_in->valeur;
        status = DECOM__C_ok;
    }
   
    /* SI le status est OK ALORS */
    if (status == DECOM__C_ok) {
   
        /* Appliquer le traitement de la fonction de conversion. */
        val_out->valeur = local;
        val_out->type = DECOM__C_type_binaire;

    }
    return (status);
}                                 

// FT-2765/FT-2766
/*****************************************************************************/
/* PROCEDURE : DECOM__Cnv_real8                                              */
/*---------------------------------------------------------------------------*/
/* ROLE      : Traite le real8 en sortie = entree (normalisee).              */
/*****************************************************************************/

static
DECOM__T_status
DECOM__Cnv_real8 (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )

{
    DECOM__T_status status = DECOM__C_nok;
    TYCST__T_real8  local;


    /* SI l'action en cours est une decommutation */
    if (val_in->action == DECOM__C_decommutation) {

        /* ALORS il faut extraire la variable numerique de l'information brute */
        status = DECOM__Extraire_variable_binaire_brut (
            val_in->buffer,
            val_in->decalage,
            val_in->longueur,
            &local);
    } else {
        /* SINON pour la recommutation la valeur est passe en parametre */
        local = val_in->valeur;
        status = DECOM__C_ok;
    }

    /* SI le status est OK ALORS */
    if (status == DECOM__C_ok) {

	    SWAP_INT_BUFFER(&local, 8, 1);
        /* Appliquer le traitement de la fonction de conversion. */
        val_out->valeur = local;
        val_out->type = DECOM__C_type_binaire;

    }
    return (status);
}
// ...FT-2765

/*****************************************************************************/
/* PROCEDURE : DECOM__Cnv_ascii_brut                                         */
/*---------------------------------------------------------------------------*/
/* ROLE      : Fonction de conversion donnees ASCII brute signee             */
/*           :  en entree.                                                   */
/*           : Pour la decommutation resultat = strtonum (chaine entree)     */
/*           : pour la recommutation chaine_sortie = chaine_entree (seul     */
/*           : type traiter)                                                 */
/*****************************************************************************/
static 
DECOM__T_status 
DECOM__Cnv_ascii_brut (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )
{
    DECOM__T_status status = DECOM__C_nok;
   
 

    /* SI l'action en cours est une decommutation */   
    //  if ((val_in->action == DECOM__C_decommutation)
    //      && (strcmp (val_in->buffer,"") != 0))
    if (val_in->action == DECOM__C_decommutation)
    {
   
        /* ALORS il faut extraire la variable numerique de l'information brute */
//      local = TYCST__STRTOREAL8 (val_in->buffer);

        status = DECOM__C_ok;
        val_out->type = DECOM__C_type_binaire;
        /* et affecte la valeur en sortie */
// aucune conversion n'est ici effectuee  
//       val_out->buffer = strdup (val_in->buffer);
        val_out->nb_octet = val_in->nb_octet;
      
        val_out->buffer=val_in->buffer;
     
    } else {
        /* SINON pour la recommutation la valeur est passe en parametre */
     
        /* SELON le type de la valeur d'entree */
        switch (val_in->type) {
      
            /* CAS c'est un reel pas traiter dans le cas general */   
        case DECOM__C_real8 :
            status = DECOM__C_nok;
            bzero (val_out,sizeof (DECOM__T_valeur_brute));
            break;
         
            /* CAS c'est une string alors il faut duppliquer la chaine d'entree */
        case DECOM__C_string :
//            val_out->buffer = strdup (val_in->buffer);
            val_out->buffer = val_in->buffer;
            val_out->nb_octet = val_in->nb_octet;
            
            /* Le type de sortie est ascii */         
            status = DECOM__C_ok;
	    val_out->type = DECOM__C_type_ascii;
//   	    TYCST__FREE(val_in);
	    
            break;
        default : status = DECOM__C_err_format;
        }
    }
    return (status);
}                                 

/*****************************************************************************/
/* PROCEDURE :  DECOM__Cnv_ascii_facteur_mul                                 */
/*---------------------------------------------------------------------------*/
/* ROLE      : Fonction de conversion donnees ASCII brute signee             */
/*           :  en entree. uniquement pour la decommutation                  */
/*           : algoritme <valeur> * parametre 1                              */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_ascii_facteur_mul (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )
{
    DECOM__T_status status = DECOM__C_nok;
    TYCST__T_real8  local;
  
   
    /* SI le nombre de parametre est correct */
    if (nb_param == 1) {
   
        /* SI l'action en cours est une decommutation */   
        if ((val_in->action == DECOM__C_decommutation)
            && (strcmp (val_in->buffer,"") != 0)) {
   
            /* ALORS il faut extraire la variable numerique de l'information brute */
            local = TYCST__STRTOREAL8 (val_in->buffer);
            status = DECOM__C_ok;
            val_out->type = DECOM__C_type_binaire;
      
        }
   
        /* SI le status est OK ALORS */
        if (status == DECOM__C_ok) {
   
            /* Appliquer le traitement de la fonction de conversion. */
            val_out->type = DECOM__C_type_binaire;
            val_out->valeur = local * param[0];
        }
        /* FINSI */
   
    }
    /* FINSI */
    return (status);
}                                 

/*****************************************************************************/
/* PROCEDURE : DECOM__Cnv_binaire_unsigned_facteur                           */
/*---------------------------------------------------------------------------*/
/* ROLE      : Fonction de conversion donnees Binaire brute non signee en    */
/*           : entree.                                                       */
/*           : algoritme <valeur> * parametre 1                              */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_binaire_unsigned_facteur (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )

{
    DECOM__T_status status = DECOM__C_nok;
    TYCST__T_real8  local;
  

    /* SI le nombre de parametre est correct */
    if (nb_param == 1) {
    
        /* SI l'action en cours est une decommutation */   
        if (val_in->action == DECOM__C_decommutation) {
   
            /* ALORS il faut extraire la variable numerique de l'information brute */
            status = DECOM__Extraire_variable_binaire (
                val_in->buffer,
                val_in->decalage,   
                val_in->longueur,
                &local);
	   
        } else {
            /* SINON pour la recommutation la valeur est passe en parametre */
            local = val_in->valeur;
            status = DECOM__C_ok;
        }
      
        /* SI le status est OK ALORS */
        if (status == DECOM__C_ok) {
   
            /* Appliquer le traitement de la fonction de conversion. */
            val_out->type = DECOM__C_type_binaire;
            val_out->valeur = local * param[0];
        }
    }
    return (status);
}                                 
        

/*****************************************************************************/
/* PROCEDURE : DECOM__Cnv_binaire_sf_facteur                           */
/*---------------------------------------------------------------------------*/
/* ROLE      : Fonction de conversion donnees Binaire brute  en    */
/*           : entree.                                                       */
/*           : algorithme : <valeur_commutee> (int) = 			*/
/*		<valeur_entree> (reel) * 10^parametre1                          */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_binaire_sf_facteur (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )

{
    DECOM__T_status status = DECOM__C_nok;
    TYCST__T_real8  local;
 

    /* SI le nombre de parametre est correct */
    if (nb_param == 1) {
    
        /* SI l'action en cours est une decommutation */   
        if (val_in->action == DECOM__C_decommutation) {
   
            /* ALORS il faut extraire la variable numerique de l'information brute */
	    //  jlp
            status = DECOM__Extraire_variable_binaire (
                val_in->buffer,
                val_in->decalage,   
                val_in->longueur,
                &local);
            /* SI le bit de signe est mis */
            if (local >= pow (2,val_in->longueur -1)) {

                /* ALORS il faut appliquer la formule inverse du complement a deux :  */
                /* valeur = valeur - 2^^n */           
                local = local - pow (2,val_in->longueur);             
            }
            val_out->valeur = local / param[0];
	   
        } else {
            /* SINON pour la recommutation on realise l'inverse */
            local = val_in->valeur;
            val_out->valeur = local * param[0];
            status = DECOM__C_ok;
        }
      
        /* SI le status est OK ALORS */
        if (status == DECOM__C_ok) {
   
            /* Appliquer le traitement de la fonction de conversion. */
            val_out->type = DECOM__C_type_binaire;
        
        }
    }
    return (status);
}                                 

/*****************************************************************************/
/* PROCEDURE : DECOM__Cnv_binaire_vint_facteur                           */
/*---------------------------------------------------------------------------*/
/* ROLE      : Fonction de conversion donnees Binaire brute  en    */
/*           : entree.                                                       */
/* algorithme : <valeur_decommutee> (int) = <valeur_commutee> (int) * 10^valeur_commutee (char)     */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_binaire_vint_facteur (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )

{
    DECOM__T_status status = DECOM__C_nok;
    TYCST__T_real8  local;
    int i,temp;
    char sf;
    int decod;

  
    /* SI le nombre de parametre est correct */
    if (nb_param == 1) {
    
        /* SI l'action en cours est une decommutation */   
        if (val_in->action == DECOM__C_decommutation) {
   
            /* ALORS il faut extraire la variable numerique de l'information brute */
            status = DECOM__C_ok;
            memcpy(&local,val_in->buffer,val_in->longueur/8);
// on decode la donnee alors
            memcpy((TYCST__T_pt_char)(&sf),(TYCST__T_pt_char)(&local),1);
            memcpy((TYCST__T_pt_char)(&decod),(TYCST__T_pt_char)(&local)+1,4);
            // FT-2765
            SWAP_INT_BUFFER( &decod, 4, 1 );
            // ...FT-2765
            val_out->valeur=decod;


	    
            for (i=sf;i>0;i--)
   		val_out->valeur = val_out->valeur/10.;
   		
        } else {
            /* SINON pour la recommutation on realise l'inverse */
            local = val_in->valeur;
            sf=0;
            status = DECOM__C_ok;

            if (SD_BAS_MacEGAUX_D(val_in->valeur,0.))  
            {val_out->valeur =0;}
        
            else {
// jlp
                if (fabs(local) >= INT32_MAX)
                 {local = 0.;}
                else 
		{   
                    while ( fabs(local) < (INT32_MAX )  )
                    {
                        local = local*10.;
                        sf++;
                    }
                    local = local/10.;
                    sf--;
                    temp=local;
	        }
		   
                memcpy((TYCST__T_pt_char)(&val_out->valeur),(TYCST__T_pt_char)(&sf),1);
                memcpy((TYCST__T_pt_char)(&val_out->valeur)+1,(TYCST__T_pt_char)(&temp),4);
                // FT-2765
                SWAP_INT_BUFFER( (TYCST__T_pt_char)(&val_out->valeur)+1, 4, 1 );
                // ...FT-2765
              }
            }
      
// jlp       
        /* SI le status est OK ALORS */
        if (status == DECOM__C_ok) {
   
            /* Appliquer le traitement de la fonction de conversion. */
            val_out->type = DECOM__C_type_binaire;
        
        }
    }
    return (status);
}                                 


/*****************************************************************************/
/* PROCEDURE : DECOM__Cnv_binaire_date_ccsds                           */
/*---------------------------------------------------------------------------*/
/* ROLE      : Fonction de conversion donnees Binaire brute  en    */
/*           : entree en ccsds date.                                                       */
/* algorithme : <valeur_commutee> (48bits) = <day>  et <ms of day>     */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_binaire_date_ccsds (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )

{
    DECOM__T_status status = DECOM__C_nok;
    TYCST__T_real8  local;
  


  
    /* SI le nombre de parametre est correct */
    if (nb_param == 1) {
    
        /* SI l'action en cours est une decommutation */   
        if (val_in->action == DECOM__C_decommutation) {
   
            /* ALORS il faut extraire la variable numerique de l'information brute */
            memcpy(&local,val_in->buffer,val_in->longueur/8);
            status = DECOM__C_ok;
            memcpy(&val_out->valeur,&local,val_in->longueur/8);
            // FT-2765
    	    SWAP_INT_BUFFER( (char*)&val_out->valeur + 0, 2, 1 );
    	    SWAP_INT_BUFFER( (char*)&val_out->valeur + 2, 4, 1 );
            // ...FT-2765
        } else {
            /* SINON pour la recommutation on realise l'inverse */
            memcpy(&val_out->valeur,&val_in->valeur,val_in->longueur/8);
            // FT-2765
            SWAP_INT_BUFFER( (char*)&val_out->valeur + 0, 2, 1 );
            SWAP_INT_BUFFER( (char*)&val_out->valeur + 2, 4, 1 );
            // ...FT-2765
            status = DECOM__C_ok;
        }
      
        /* SI le status est OK ALORS */
        if (status == DECOM__C_ok) {
   
            /* Appliquer le traitement de la fonction de conversion. */
            val_out->type = DECOM__C_type_binaire;

        }
    }
    return (status);
}                                 
/*****************************************************************************/
/* PROCEDURE : DECOM__Cnv_binaire_date_ccsds                           */
/*---------------------------------------------------------------------------*/
/* ROLE      : Fonction de conversion donnees Binaire brute  en    */
/*           : entree en ccsds date.                                                       */
/* algorithme : <valeur_commutee> (48bits) = <day>  et <ms of day>     */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_binaire_date_obt (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )

{
    DECOM__T_status status = DECOM__C_nok;
    unsigned int local;

  
    /* SI le nombre de parametre est correct */
    if (nb_param == 1) {
    
        /* SI l'action en cours est une decommutation */   
        if (val_in->action == DECOM__C_decommutation) {
   
            /* ALORS il faut extraire la variable numerique de l'information brute */

            memcpy(&local, &((char*)val_in->buffer)[1], sizeof(unsigned int));
            // FT-2765
            SWAP_INT_BUFFER( &local, 4, 1 );
            // ...FT-2765
            val_out->valeur = (double) local;
	    status = DECOM__C_ok;
        } else {
	  /* SINON pour la recommutation on realise l'inverse */
	  local=(unsigned int) val_in->valeur;
	  // FT-2765
	  SWAP_INT_BUFFER( &local, 4, 1 );
	  // ...FT-2765
	  memcpy(((char*)&(val_out->valeur))+1,&local, 4);
	  status = DECOM__C_ok;
        }
      
        /* SI le status est OK ALORS */
/*        if (status == DECOM__C_ok) {*/
	 if (status != DECOM__C_ok)
           {

#ifdef OPS_DEBUG
             printf("DECOM :Pb OBT\n");
             fflush(stdout);
#endif
             
           }

            /* Appliquer le traitement de la fonction de conversion. */
            val_out->type = DECOM__C_type_binaire;

        
    }
    return (status);
}                                 

/*****************************************************************************/
/* PROCEDURE   : DECOM__Cnv_binaire_signed_facteur                           */
/*---------------------------------------------------------------------------*/
/* ROLE        : Fonction de conversion donnees Binaire brute signee         */
/*             : complement a deux en entree.                                */
/*             : algoritme <valeur> * parametre 1                            */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_binaire_signed_facteur (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )
{
    DECOM__T_status status = DECOM__C_nok;
    TYCST__T_real8  local;

    /* SI le nombre de parametre est correct */
    if (nb_param == 1) {
   
        /* SI l'action en cours est une decommutation */   
        if (val_in->action == DECOM__C_decommutation) {
   
            /* ALORS il faut extraire la variable numerique de l'information brute */
            status = DECOM__Extraire_variable_binaire (
                val_in->buffer,
                val_in->decalage,   
                val_in->longueur,
                &local);

            /* SI le bit de signe est mis */
            if (local >= pow (2,val_in->longueur -1)) {

                /* ALORS il faut appliquer la formule inverse du complement a deux :  */
                /* valeur = valeur - 2^^n */           
                local = local - pow (2,val_in->longueur);             
            }
            /* FINSI */
   
            /* SI le status est OK ALORS */
            if (status == DECOM__C_ok) {
   
                /* Appliquer le traitement de la fonction de conversion. */
                val_out->type = DECOM__C_type_binaire;
                val_out->valeur = local * param[0];
            }

        } else {
            /* SINON pour la recommutation la valeur est passe en parametre */
   
            /* Appliquer le traitement de la fonction de conversion. */
	 
	    
            local = val_in->valeur * param[0];
	  
            status = DECOM__C_ok;

            /* SI la valeur est negative alors la coder en complement a deux */
            /* = 2^^longueur - valeur.                                       */

            if (local < 0.0) {
                local = pow (2,val_in->longueur) - fabs(local);             
            } 
            /* Retourner la valeur en sortie */      
            val_out->type = DECOM__C_type_binaire;
            val_out->valeur = local;

	         
        }
        /* FINSI */
   
    } 
    /* FINSI */
//   free(val_in);
    return (status);

}               

/*****************************************************************************/
/* PROCEDURE   : DECOM__Cnv_binaire_consigne_BLG                             */
/*---------------------------------------------------------------------------*/
/* ROLE        : Fonction de conversion pour la consigne en position BLG     */
/*             : complement a deux en entree stocke sur 5 octets (cadree     */
/*             : frontiere d'octet).                                         */
/*             : algoritme <valeur> * parametre 1                            */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_binaire_consigne_BLG (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )
{
    DECOM__T_status status = DECOM__C_nok;
    TYCST__T_real8  valeur_LSB, valeur_MSB , valeur_consigne , local;
     

    /* SI le nombre de parametre est correct */
    if (nb_param == 1) {
   
        /* SI l'action en cours est une decommutation  ALORS */   
        if (val_in->action == DECOM__C_decommutation) {
   
            /* Recuperation des octets poids fort (8 bits) */
            status = DECOM__Extraire_variable_binaire (
                val_in->buffer,
                val_in->decalage,
                8,
                &valeur_MSB);
           
            /* Recuperation des octets poids faible */
            status = DECOM__Extraire_variable_binaire (
                val_in->buffer,
                8,
                32,
                &valeur_LSB);
            /* Calcul de la valeur de la consigne */
            valeur_consigne = (valeur_MSB * pow (2,32)) + valeur_LSB;

            /* SI la valeur du MSB est superieur a 128 (bit de signe positionnee) */
            /* alors il faut appliquer la formule inverse du complement a deux :  */
            /* valeur = valeur - 2^^40 */           

            if (valeur_MSB >= 128.0) {
                valeur_consigne = valeur_consigne - pow (2,40);             
            }
  
            /* SI le status est OK ALORS */
            if (status == DECOM__C_ok) {
  
                /* Appliquer le traitement de la fonction de conversion. */
                val_out->type = DECOM__C_type_binaire;
                val_out->valeur = valeur_consigne * param[0];
            }

        } else {
            /* SINON pour la recommutation la valeur est passe en parametre */
   
            /* Appliquer le traitement de la fonction de conversion. */
   
            status = DECOM__C_ok;
            local = val_in->valeur * param[0];
            /* Retourner la valeur en sortie */      
            val_out->type = DECOM__C_type_binaire;

            /* SI la valeur est negative alors la coder en complement a deux */
            /* = 2^^longueur - valeur.                                       */

            if (local < 0.0) {
                local = pow (2,val_in->longueur) - fabs(local);
            } 
            val_out->valeur = local ;
        }
        /* FINSI */
   
    } 
    /* FINSI */
    return (status);

}

/*****************************************************************************/
/* PROCEDURE   :  DECOM__Cnv_erreur_mtl                                      */
/*---------------------------------------------------------------------------*/
/* ROLE        : Traitement des champs E0000xx d'erreur dans la station      */
/*             : meteo.                                                      */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_erreur_mtl (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )
{
    DECOM__T_status status = DECOM__C_nok;
    TYCST__T_real8  local = 0.0;
    TYCST__T_pt_char  pt_err;
   
    /* SI l'action en cours est une decommutation */   
    if ((val_in->action == DECOM__C_decommutation)
        && (strcmp (val_in->buffer,"") != 0)) {
   
        /* ALORS il faut regarder si la chaine d'entree comporte la sequence  */
        /* E0000. */
   
        pt_err = strstr (val_in->buffer,DECOM__C_erreur_mtl);
   

        /* SI oui alors les deux caracteres suivant E0000 donne le code de l'erreur */   
        if (pt_err != NULL) {
            pt_err += strlen (DECOM__C_erreur_mtl);
            local = TYCST__STRTOREAL8 (pt_err);
            status = DECOM__C_ok;
        }
        status = DECOM__C_ok;
    }
   
    /* SI le status est OK ALORS */
    if (status == DECOM__C_ok) {
   
        /* Appliquer le traitement de la fonction de conversion. */
        val_out->type = DECOM__C_type_binaire;
        val_out->valeur = local;
    }
    return (status);

}

/*****************************************************************************/
/* PROCEDURE   :  DECOM__Cnv_status_horloge                                  */
/*---------------------------------------------------------------------------*/
/* ROLE        : Traite le status de l'horloge (chaine ascii ON, OFF, ou     */
/*             : ENAB a transforme en valeur numerique.                      */
/*             : algoritme :                                                 */
/*             : SI chaine entree = ON alors retour = parametre 1            */
/*             : SI chaine entree = OFF alors retour = parametre 2           */
/*             : SI chaine sortie = ENAB alors retour = parametre 3          */
/*             : defaut retour = parametre4                                  */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_status_horloge (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )
{
    DECOM__T_status status = DECOM__C_nok;
    TYCST__T_real8  local = 0.0;
    TYCST__T_pt_char  pt_status;

    /* SI le nombre de parametre est correct */
    if (nb_param == 4) {
   
        /* SI l'action en cours est une decommutation */   
        if ((val_in->action == DECOM__C_decommutation)
            && (strcmp (val_in->buffer,"") != 0)) {
   
            /* ALORS si la chaine d'entree comporte la sequence ON. */   
            if ((pt_status = strstr (val_in->buffer,DECOM__C_status_ho_on)) != NULL) {
                local = param[0];
        
                /* SINON si la chaine comporte la sequence OFF ALORS */        
            } else if ((pt_status = strstr (val_in->buffer,DECOM__C_status_ho_off)) != NULL) {
                local = param[1];
        
                /* SINON si la chaine comporte la sequence ENAB ALORS */        
            } else if ((pt_status = strstr (val_in->buffer,DECOM__C_status_ho_enab)) != NULL) {
                local = param[2];
     
                /* SINON la valeur par defaut est contenue dans le parametre 4 ALORS */        
            } else {
                local = param[3];
            }
            status = DECOM__C_ok;
        }
   
        /* SI le status est OK ALORS */
        if (status == DECOM__C_ok) {
   
            /* Appliquer le traitement de la fonction de conversion. */
            val_out->type = DECOM__C_type_binaire;
            val_out->valeur = local;
        }
    }
    /* FINSI nb_param */
    return (status);

}

/*****************************************************************************/
/* PROCEDURE   :  DECOM__Cnv_valeur_bornee                                   */
/*---------------------------------------------------------------------------*/
/* ROLE        : Verifie que la valeur est compris dans deux bornes.         */
/*             : algoritme                                                   */
/*             : Retour = parametre3 SI Valeur entree (ascii) >= parametre 1 */
/*             :                     ET valeur entree <= parametre 2.        */
/*             : SINON retour = parametre 4.                                 */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_valeur_bornee (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )
{
    DECOM__T_status status = DECOM__C_nok;
    TYCST__T_real8  local = 0.0;
  

    /* SI le nombre de parametre est correct */
    if (nb_param == 4) {
   
    
        /* SI l'action en cours est une decommutation */   
        if ((val_in->action == DECOM__C_decommutation)
            && (strcmp (val_in->buffer,"") != 0)) {
   
            /* ALORS il faut extraire la variable numerique de l'information brute */
            local = TYCST__STRTOREAL8 (val_in->buffer);
            status = DECOM__C_ok;
         
        }
   
        /* SI le status est OK ALORS */
        if (status == DECOM__C_ok) {
   
            /* Appliquer le traitement de la fonction de conversion. */
            if ((local >= param[0]) && (local <= param[1])) {
                local = param[2];
            } else {
                local = param[3];
            }  
            val_out->type = DECOM__C_type_binaire;
            val_out->valeur = local;
        }
        /* FINSI */
   
    }
    /* FINSI nb_param */
    return (status);

}


/*****************************************************************************/
/* PROCEDURE   : DECOM__Cnv_AscInt4                                           */
/*---------------------------------------------------------------------------*/
/* ROLE        : recommutation:                                              */
/*             : transforme une donnee numerique binaire de type int4        */
/*             : en chaine de caractere.                                     */
/*             : decommutation:                                              */
/*             : transforme une  chaine de caractere en donnee numerique     */
/*             : binaire de type int4.                                       */
/*             :  <valeur ASCII> = <valeur binaire * parametre>           */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_AscInt4 (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )
{
    DECOM__T_status status = DECOM__C_nok;
    TYCST__T_real8  donnee;
    char *buff = NULL;
    char *buff2 = NULL;
    int i;

    /* SI l'action en cours est une decommutation */   
    if (val_in->action == DECOM__C_decommutation)
    {  
        buff = (char*) malloc(val_in->nb_octet+1);
        strncpy( buff ,val_in->buffer,val_in->nb_octet);
	buff[val_in->nb_octet]='\0';
        donnee = TYCST__STRTOREAL8 (buff);
        free(buff);
        status = DECOM__C_ok; 
        val_out->type =  DECOM__C_type_binaire;
        val_out->valeur = donnee;   
    }
    /* SI l'action en cours est une recommutation */   
    else
    { 
        buff = (char*) malloc(20);
// FA 146
//        sprintf(buff,"%d",(int)val_in->valeur);
      for (i=0;i<20;i++)
	{
	buff[i]=' ';
	}
        buff2 = (char*) malloc(20);
        sprintf(buff2,"%d",(int)val_in->valeur);
	// on suppose ici que val_in->longueur/8 < 19
	if (strlen(buff2) < val_in->longueur/8)
	  {
	   for (i=0;i<strlen(buff2);i++)
	     {
	     buff[(val_in->longueur/8)-strlen(buff2)+i]=buff2[i];
	     }
	   buff[val_in->longueur/8]='\0';	   
	  }
	 else
	  {
	   for (i=0;i<19;i++)
	     {
	     buff[i]=buff2[i];
	     }
	   buff[val_in->longueur/8]='\0';	   
	  }
        free(buff2);
	
	val_out->buffer =buff;
        status = DECOM__C_ok; 
        val_out->type = DECOM__C_string;
        val_out->nb_octet = strlen(val_out->buffer);
    
    }


    return (status);
}
/*****************************************************************************/
/* PROCEDURE   : DECOM__Cnv_AscUint4                                         */
/*---------------------------------------------------------------------------*/
/* ROLE        : recommutation:                                              */
/*             : transforme une donnee numerique binaire de type uint4       */
/*             : en chaine de caractere.                                     */
/*             : decommutation:                                              */
/*             : transforme une  chaine de caractere en donnee numerique     */
/*             : binaire de type uint4.                                      */
/*             :                                                             */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_AscUint4 (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )
{
    DECOM__T_status status = DECOM__C_nok;
    TYCST__T_real8  donnee;
    char *buff = NULL;
    char *buff2 = NULL;
    int i;
 

    /* SI l'action en cours est une decommutation */   
    if (val_in->action == DECOM__C_decommutation)
    {  
        buff = (char*) malloc(val_in->nb_octet+1);
        strncpy( buff ,val_in->buffer,val_in->nb_octet);
        buff[val_in->nb_octet]='\0';
        donnee = TYCST__STRTOREAL8 (buff);
        free(buff);
        status = DECOM__C_ok; 
        val_out->type =  DECOM__C_type_binaire;
        val_out->valeur = donnee;
    }
    /* SI l'action en cours est une recommutation */   
    else
    {
        buff = (char*) malloc(20);
        sprintf(buff,"%d",(unsigned int)val_in->valeur);
//FA146
//        sprintf(buff,"%d",(unsigned int)val_in->valeur);
        for (i=0;i<20;i++)
	  {
	  buff[i]=' ';
	  }
        buff2 = (char*) malloc(20);
        sprintf(buff2,"%d",(unsigned int)val_in->valeur);
	// on suppose ici que val_in->longueur/8 < 19
	if (strlen(buff2) < val_in->longueur/8)
	  {
	   for (i=0;i<strlen(buff2);i++)
	     {
	     buff[(val_in->longueur/8)-strlen(buff2)+i]=buff2[i];
	     }
	   buff[val_in->longueur/8]='\0';	   
	  }
	 else
	  {
	   for (i=0;i<19;i++)
	     {
	     buff[i]=buff2[i];
	     }
	   buff[val_in->longueur/8]='\0';	   
	  }
        free(buff2);
//FA146

        val_out->buffer = buff;      
        status = DECOM__C_ok; 
        val_out->type = DECOM__C_string;
        val_out->nb_octet = strlen(val_out->buffer);
    }


    return (status);
}
/*****************************************************************************/
/* PROCEDURE   : DECOM__Cnv_AscReal8                                        */
/*---------------------------------------------------------------------------*/
/* ROLE        : recommutation:                                              */
/*             : transforme une donnee numerique binaire de type real8       */
/*             : en chaine de caractere.                                     */
/*             : decommutation:                                              */
/*             : transforme une  chaine de caractere en donnee numerique     */
/*             : binaire de type real8.                                      */
/*             :                                                             */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_AscReal8 (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )
{
    DECOM__T_status status = DECOM__C_nok;
    TYCST__T_real8  donnee;
    long long  donnee_int;
    char *buff = NULL;
    int i;
    char *buff2 = NULL;

    /* SI l'action en cours est une decommutation */   
    if (val_in->action == DECOM__C_decommutation)
    {  
        buff = (char*) malloc(val_in->nb_octet+1);
        strncpy( buff ,val_in->buffer,val_in->nb_octet);
	buff[val_in->nb_octet]='\0';
        donnee = TYCST__STRTOREAL8 (buff);
        free(buff);
        status = DECOM__C_ok; 
        val_out->type =  DECOM__C_type_binaire;
	val_out->valeur=donnee * pow(10.,-param[0]);
    }
    /* SI l'action en cours est une recommutation */   
    else
    {
       buff = (char*) malloc(40);

       //on ecrit un entier mutiplier par un SF
       donnee = val_in->valeur * pow(10.,param[0]);
       
       sprintf(buff,"%f",donnee);
       donnee_int = (long long)donnee;
       
       // on n'ecrit pas la partie flotante  xxx.000000 
       i=0;
       while(buff[i] != '.' && i<40)
         i++;
       buff[i] = '\0';   
            
//FA146
        buff2 = (char*) malloc(40);
        for (i=0;i<20;i++)
	  {
	  buff2[i]=' ';
	  }
	// on suppose ici que val_in->longueur/8 < 39
	if (strlen(buff) < val_in->longueur/8)
	  {
	   for (i=0;i<strlen(buff);i++)
	     {
	     buff2[(val_in->longueur/8)-strlen(buff)+i]=buff[i];
	     }
	   buff2[val_in->longueur/8]='\0';	   
	  }
	 else
	  {
	   for (i=0;i<39;i++)
	     {
	     buff2[i]=buff[i];
	     }
	   buff2[val_in->longueur/8]='\0';	   
	  }
        free(buff);         
       val_out->buffer = buff2;
//       val_out->buffer = buff;
//FA146            
       status = DECOM__C_ok; 
       val_out->type = DECOM__C_string;
       val_out->nb_octet = strlen(val_out->buffer);
    }


    return (status);
}


/*****************************************************************************/
/* PROCEDURE   :  DECOM__Cnv_status_irf                                      */
/*---------------------------------------------------------------------------*/
/* ROLE        : Traite lelement actif de l'interface IRF.                   */
/*             : (chaine ascii a ou b) a transforme en valeur numerique.     */
/*             : algoritme :                                                 */
/*             : SI chaine entree = a alors retour = parametre 1             */
/*             : SI chaine entree = b alors retour = parametre 2             */
/*             : defaut retour = parametre3                                  */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_status_irf (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )
{
    DECOM__T_status status = DECOM__C_nok;
    TYCST__T_real8  local = 0.0;
    TYCST__T_pt_char  pt_status;

    /* SI le nombre de parametre est correct */
    if (nb_param == 3) {
   
        /* SI l'action en cours est une decommutation */   
        if ((val_in->action == DECOM__C_decommutation)
            && (strcmp (val_in->buffer,"") != 0)) {
   
            /* ALORS si la chaine d'entree comporte la sequence ON. */   
            if ((pt_status = strstr (val_in->buffer,
                                     DECOM__C_element_a_actif)) != NULL) {
                local = param[0];
        
                /* SINON si la chaine comporte la sequence OFF ALORS */        
            } else if ((pt_status = strstr (val_in->buffer,
                                            DECOM__C_element_b_actif)) != NULL) {
                local = param[1];       
       
                /* SINON la valeur par defaut est contenue dans le parametre 3 ALORS */        
            } else {
                local = param[2];
            }
            status = DECOM__C_ok;
        }
   
        /* SI le status est OK ALORS */
        if (status == DECOM__C_ok) {
   
            /* Appliquer le traitement de la fonction de conversion. */
            val_out->type = DECOM__C_type_binaire;
            val_out->valeur = local;
        }
    }
    /* FINSI nb_param */
    return (status);

}

/*****************************************************************************/
/* PROCEDURE   :  DECOM__Cnv_status_cma                                      */
/*---------------------------------------------------------------------------*/
/* ROLE        : Traite la position d'antenne fournit par le commutateur     */
/*             : (chaine ascii O, D ou E) a transforme en valeur numerique.  */
/*             : algoritme :                                                 */
/*             : SI chaine entree = O alors retour = parametre 1             */
/*             : SI chaine entree = D alors retour = parametre 2             */
/*             : SI chaine entree = E alors retour = parametre 3             */
/*             : defaut retour = parametre 4                                 */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_status_cma (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )
{
    DECOM__T_status status = DECOM__C_nok;
    TYCST__T_real8  local = 0.0;
    TYCST__T_pt_char  pt_status;

    /* SI le nombre de parametre est correct */
    if (nb_param == 4) {
   
        /* SI l'action en cours est une decommutation */    
        if ((val_in->action == DECOM__C_decommutation)
            && (strcmp (val_in->buffer,"") != 0)) {
   
            /* ALORS si la chaine d'entree comporte la sequence O. */   
            if ((pt_status = strstr (val_in->buffer,
                                     DECOM__C_position_cma_O)) != NULL) {
                local = param[0];
        
                /* SINON si la chaine comporte la sequence D ALORS */        
            } else if ((pt_status = strstr (val_in->buffer,
                                            DECOM__C_position_cma_D)) != NULL) {
                local = param[1];       
       
                /* SINON si la chaine comporte la sequence E ALORS */        
            } else if ((pt_status = strstr (val_in->buffer,
                                            DECOM__C_position_cma_E)) != NULL) {
                local = param[2];       
       
                /* SINON la valeur par defaut est contenue dans le parametre 4 ALORS */        
            } else {
                local = param[3];
            }
            status = DECOM__C_ok;
        }
   
        /* SI le status est OK ALORS */
        if (status == DECOM__C_ok) {
   
            /* Appliquer le traitement de la fonction de conversion. */
            val_out->type = DECOM__C_type_binaire;
            val_out->valeur = local;
        }
    }
    /* FINSI nb_param */
    return (status);

}
/*****************************************************************************/
/* PROCEDURE   :  DECOM__Cnv_status_srf                                      */
/*---------------------------------------------------------------------------*/
/* ROLE        : Traite le status de la station Radio Frequence              */
/*             : (chaine ascii R ou A) a transforme en valeur numerique.     */
/*             : algoritme :                                                 */
/*             : SI chaine entree = R alors retour = parametre 1             */
/*             : SI chaine entree = A alors retour = parametre 2             */
/*             : defaut retour = parametre3                                  */
/*****************************************************************************/

static 
DECOM__T_status 
DECOM__Cnv_status_srf (
    DECOM__T_pt_valeur_brute val_in, /* IN Valeur a convertir. */
    DECOM__T_pt_valeur_brute val_out,    /* OUT valeur convertie.  */
    TYCST__T_int4 nb_param,       /* IN Nombre de parametre de la fonction */
    /* de conversion.                        */
    TYCST__T_pt_real8 param       /* IN Tableau des parametres. */
    )
{
    DECOM__T_status status = DECOM__C_nok;
    TYCST__T_real8  local = 0.0;
    TYCST__T_pt_char  pt_status;

    /* SI le nombre de parametre est correct */
    if (nb_param == 3) {
   
        /* SI l'action en cours est une decommutation */   
        if ((val_in->action == DECOM__C_decommutation)
            && (strcmp (val_in->buffer,"") != 0)) {
   
            /* ALORS si la chaine d'entree comporte la sequence ON. */   
            if ((pt_status = strstr (val_in->buffer,DECOM__C_status_srf_on)) != NULL) {
                local = param[0];
        
                /* SINON si la chaine comporte la sequence OFF ALORS */        
            } else if ((pt_status = strstr (val_in->buffer,DECOM__C_status_srf_off)) != NULL) {
                local = param[1];       
       
                /* SINON la valeur par defaut est contenue dans le parametre 4 ALORS */        
            } else {
                local = param[2];
            }
            status = DECOM__C_ok;
        }
   
        /* SI le status est OK ALORS */
        if (status == DECOM__C_ok) {
   
            /* Appliquer le traitement de la fonction de conversion. */
            val_out->type = DECOM__C_type_binaire;
            val_out->valeur = local;
        }
    }
    /* FINSI nb_param */
    return (status);

}

/*****************************************************************************/
/* PROCEDURE : Retourner_pt_conversion                                       */
/*---------------------------------------------------------------------------*/
/* ROLE      : Retourne le pointeur de la fonction de conversion dont le     */ 
/*           : ou depuis le temps passe en parametre                         */
/*****************************************************************************/

static
DECOM__T_proc_conv
DECOM__Retourner_pt_conversion ( 
    const DECOM__T_nom_conversion nom, /*IN Nom de la fonction de conversion */
    TYCST__T_pt_int4 type             /* OUT Type de la fonction de conversion. */
    )
{
    int i = 0 ; /*U compteur de travail */
    DECOM__T_conversion *desc_cnv = NULL;
    DECOM__T_proc_conv pt_fonc = NULL;
  
    /*U tab_conversion est declare ici car il n'est pas possible de le declarer */
    /* dans la section variable globale */
    /* tab_conversion :  */
    /* Liste des fonctions de conversion possible . */
    static
        DECOM__T_conversion 
        tab_conversion[DECOM__C_nb_max_conversion] = {

            DECOM__C_nom_conv_1, DECOM__C_type_binaire, DECOM__Cnv_binaire_brut, /* pour lire/ecrire des valeurs de type float : TYCST__T_real4 */
            // FT-2765
            DECOM__C_nom_conv_real8, DECOM__C_type_binaire, DECOM__Cnv_real8,
            // ...FT-2765
            DECOM__C_nom_conv_2, DECOM__C_type_ascii  , DECOM__Cnv_ascii_brut,
            DECOM__C_nom_conv_3, DECOM__C_type_binaire, DECOM__Cnv_binaire_unsigned_facteur,
            DECOM__C_nom_conv_4, DECOM__C_type_ascii, DECOM__Cnv_ascii_facteur_mul,
            DECOM__C_nom_conv_5, DECOM__C_type_ascii, DECOM__Cnv_erreur_mtl,
            DECOM__C_nom_conv_6, DECOM__C_type_ascii, DECOM__Cnv_valeur_bornee,
            DECOM__C_nom_conv_7, DECOM__C_type_ascii, DECOM__Cnv_status_horloge,
            DECOM__C_nom_conv_8, DECOM__C_type_binaire, DECOM__Cnv_binaire_signed_facteur,
            DECOM__C_nom_conv_10,DECOM__C_type_binaire, DECOM__Cnv_AscInt4,
            DECOM__C_nom_conv_11,DECOM__C_type_binaire, DECOM__Cnv_AscUint4,
            DECOM__C_nom_conv_12,DECOM__C_type_binaire, DECOM__Cnv_AscReal8,
            DECOM__C_nom_conv_13, DECOM__C_type_ascii, DECOM__Cnv_status_srf,
            DECOM__C_nom_conv_15, DECOM__C_type_binaire, DECOM__Cnv_binaire_consigne_BLG,
            DECOM__C_nom_conv_16, DECOM__C_type_binaire, DECOM__Cnv_status_irf,
            DECOM__C_nom_conv_19, DECOM__C_type_ascii, DECOM__Cnv_status_cma,
            DECOM__C_nom_conv_20, DECOM__C_type_binaire, DECOM__Cnv_binaire_sf_facteur,
            DECOM__C_nom_conv_21, DECOM__C_type_binaire, DECOM__Cnv_binaire_date_ccsds,
            DECOM__C_nom_conv_22, DECOM__C_type_binaire, DECOM__Cnv_binaire_vint_facteur,
            DECOM__C_nom_conv_24, DECOM__C_type_binaire, DECOM__Cnv_ascii_brut      ,
	    DECOM__C_nom_conv_25, DECOM__C_type_binaire, DECOM__Cnv_binaire_date_obt ,
	    DECOM__C_nom_conv_26, DECOM__C_type_binaire, DECOM__Cnv_binaire_unsigned_facteur,
            0
      
        };

  
    /* SI le nom de la conversion est chaine vide ALORS */
    if(  strcmp(nom,"") == 0 ){
  
        /* retourner pointeur a NULL */
        return (pt_fonc);  
    }
  
    /* TANTQUE i < Nombre max de fonction de conversion 
       ET pointeur fonction different NULL */
  
    while ((i < DECOM__C_nb_max_conversion) && (pt_fonc == NULL)) {
  
        /* SI le nom de la conversion a l'emplacement i egale le nom recherche ALORS */
  
        desc_cnv = &tab_conversion[i];
        if(  strcmp(desc_cnv->nom,nom) == 0 ){
      
            /* enregistrer le pointeur de la fonction trouve. */



            pt_fonc = desc_cnv->procedure;
            *type   = desc_cnv->type_input;	

        }
        i++ ;
    }
    /* retourner le pointeur de fonction trouve */
    return (pt_fonc);
  
}

/*****************************************************************************/
/* PROCEDURE : Comparer_bloc                                                  */
/*---------------------------------------------------------------------------*/
/* ROLE      : Comparer le champ nom de 2 structures Bloc                     */
/*           : Retourne une valeur > 0 si var_1->nom > var2->nom             */
/*           : Retourne une valeur < 0 si var_1->nom < var2->nom             */
/*           : Retourne une valeur = 0 si var_1->nom > var2->nom             */
/*****************************************************************************/

static
int
DECOM__Comparer_bloc(
    const void *var_1,   /* IN */
    const void *var_2    /* IN */
    )
{
    /*  Comparer les noms des 2 datagroups en utilisant l'ordre ascii */
    /*  Retourner le resultat */
    return(strcmp(((const DECOM__T_desc_bloc *)var_1)->nom,
                  ((const DECOM__T_desc_bloc *)var_2)->nom));

}

/*****************************************************************************/
/* PROCEDURE : Comparer_variable                                             */
/*---------------------------------------------------------------------------*/
/* ROLE      : Comparer le champ nom de 2 structures variable                */
/*           : Retourne une valeur > 0 si var_1->nom > var2->nom             */
/*           : Retourne une valeur < 0 si var_1->nom < var2->nom             */
/*           : Retourne une valeur = 0 si var_1->nom > var2->nom             */
/*****************************************************************************/

static
int
DECOM__Comparer_variable(
    const void *var_1,   /* IN */
    const void *var_2    /* IN */
    )
{
    /*  Comparer les noms des 2 datagroups en utilisant l'ordre ascii */
    /*  Retourner le resultat */
    return(strcmp(((const DECOM__T_desc_var *)var_1)->nom,
                  ((const DECOM__T_desc_var *)var_2)->nom));

}

/*****************************************************************************/
/* PROCEDURE : Rechercher_info_variable                                      */
/*---------------------------------------------------------------------------*/
/* ROLE      : Recherche une variable dans la liste des variables d'un bloc. */
/*****************************************************************************/

static
TYCST__T_int4
DECOM__Rechercher_info_variable(
    const DECOM__T_desc_bloc info_bloc,
    const DECOM__T_nom_var Variable,
    DECOM__T_pt_desc_var   info_var
    )
{
  
    DECOM__T_pt_desc_var pt_info = NULL;	/* Pointeur sur les infos d'une variable */
    DECOM__T_desc_var	 key;		/*  cle de recherche dans la table */
    TYCST__T_int4	 num_var;       /* Numero de la variable recherchee */
    // FT-2765
    size_t mysize;
    // ...FT-2765

    if (info_bloc.var != NULL) {
        strcpy(key.nom,Variable); 
        /* Rechercher le bloc dans la liste de tous les datagroups */
// modif pour sortir les element dans l'ordre du fichier
        // FT-2765
        mysize = info_bloc.nb_var;
        pt_info = lfind(&key,
                        info_bloc.var,
                        &mysize,
                        sizeof(key),
                        DECOM__Comparer_variable);
        // ...FT-2765
//      pt_info = bsearch(&key,info_bloc.var,
//                     info_bloc.nb_var,sizeof(key),DECOM__Comparer_variable);
    }
    /* SI pas trouve */
    if ( pt_info == NULL ) { 

    
        /* retour = -1 */
        num_var = -1;
    }
    /* SINON */
    else {
        /* calculer l'indice du datgroup dans la liste */
        num_var= (pt_info - &info_bloc.var[0]);
        if ( info_var != NULL ) {
            memcpy(info_var,pt_info,sizeof(*pt_info));
        }
    }
    /* FINSI */

    /* Retourner Ind_datag */
    return(num_var);
  
}
/* FIN DE Rechercher_info_variable */


/*****************************************************************************/
/* PROCEDURE : Rechercher_info_bloc                                          */
/*---------------------------------------------------------------------------*/
/* ROLE      : Recherche un bloc dans la table liste_bloc.                   */
/*****************************************************************************/

static
TYCST__T_int4
DECOM__Rechercher_info_bloc (
    const DECOM__T_nom_bloc Bloc,
    DECOM__T_pt_desc_bloc info_bloc
    )
{
    DECOM__T_pt_desc_bloc pt_info;	/* Pointeur sur les infos d'un bloc */
    DECOM__T_desc_bloc	 key;		/*  cle de recherche dans la table */
    TYCST__T_int4	 num_bloc;		/* Numero du bloc recherche */
  

    strcpy(key.nom, Bloc); 
  
    if (DECOM__G_nb_bloc <= 0)
      {

#ifdef OPS_DEBUG
        printf("DECOM__G_nb_bloc = %d pour %s\n", 
               DECOM__G_nb_bloc, key.nom);
        fflush(stdout);
#endif

        return -1;
      }

    /* Rechercher le bloc dans la liste de tous les datagroups */
    pt_info = bsearch(&key,DECOM__G_liste_bloc,
                      DECOM__G_nb_bloc,sizeof(key),DECOM__Comparer_bloc);

    /* SI pas trouve */
    if ( pt_info == NULL ) { 
        /* retour = -1 */
        num_bloc= -1;
    }
    /* SINON */
    else {
        /* calculer l'indice du datgroup dans la liste */
        num_bloc= (pt_info - &DECOM__G_liste_bloc[0]);
        if ( info_bloc != NULL ) {
            memcpy(info_bloc,pt_info,sizeof(*pt_info));
        }
    }
    /* FINSI */
   
    /* Retourner Ind_datag */
    return(num_bloc);
  
}
/* FIN DE Rechercher_info_bloc */

/*****************************************************************************/
/* PROCEDURE : Enregistrer_bloc                                              */
/*---------------------------------------------------------------------------*/
/* ROLE      : Enregistre le bloc qui vient d'etre analyse dans la liste     */
/*           : des blocs deja decrit.                                        */
/*****************************************************************************/

static
DECOM__T_status
DECOM__Enregistrer_bloc(
    const DECOM__T_pt_desc_bloc info_bloc
    )
{
    DECOM__T_status 	status;	  	/* status de retour de la fonction */

    status = DECOM__C_ok;

    /* SI il y a de la place */
    if ( DECOM__G_nb_bloc < DECOM__C_nb_max_bloc ) {
     
        /* SI bloc n'existe pas deja dans la table */
        if ( DECOM__Rechercher_info_bloc(info_bloc->nom, NULL) == -1) {

            /* Ajouter info_bloc dans la table */
            memcpy(&DECOM__G_liste_bloc[DECOM__G_nb_bloc],
                   info_bloc,sizeof(*info_bloc));
            DECOM__G_nb_bloc++;
            /* Trier le tableau selon le nom des conversions */
            qsort(DECOM__G_liste_bloc,DECOM__G_nb_bloc,
                  sizeof(DECOM__T_desc_bloc),DECOM__Comparer_bloc);
        }
        /* SINON bloc existe deja */
        else {
            /* retour = ERR_BLOC_EXISTE_DEJA*/
            status = DECOM__C_err_bloc_existe_deja;
        }
        /* FINSI */
    }
    /* SINON plus de place */
    else {
        /* retour = ERR_TROP_DE_BLOC */
        status = DECOM__C_err_trop_de_bloc;
    }
    /* FINSI */
  
    return ( status );
}
/* FIN DE Enregistrer_bloc */


/*****************************************************************************/
/* PROCEDURE : Enregistrer_variable                                          */
/*---------------------------------------------------------------------------*/
/* ROLE      : Enregistre la variable qui vient d'etre analyse dans la liste */
/*           : des variables deja decrites.                                  */
/*****************************************************************************/

static
DECOM__T_status
DECOM__Enregistrer_variable (
    DECOM__T_pt_desc_bloc pt_bloc,
    const DECOM__T_pt_desc_var info_var
    )
{
    DECOM__T_status 	status;	  	/* status de retour de la fonction */

    int nb_var = pt_bloc->nb_var;
   
    status = DECOM__C_ok;
    /* SI la variable n'existe pas deja dans la table */
    if ( DECOM__Rechercher_info_variable(*pt_bloc,
                                         info_var->nom, NULL) == -1) {
        /* si c'est la premiere variable on fait une allocation */
		     
        if (pt_bloc->var == NULL){
            pt_bloc->var = (DECOM__T_desc_var *)TYCST__MALLOC (sizeof(DECOM__T_desc_var));
      
            /* sinon on fait une reallocation. */
        }else{
            pt_bloc->var = TYCST__REALLOC (pt_bloc->var,
                                           (nb_var + 1) * 
                                           sizeof(DECOM__T_desc_var));
        }
        /* Si on a une erreur d'allocation */
        if (pt_bloc->var == NULL){
		     
            /* Appel de la procedure d'erreur. */
            status = DECOM__C_err_allocation;
        }else{	                              
                                                   
            /* Ajouter info_var dans la liste des variables */
            memcpy(&pt_bloc->var[nb_var],
                   info_var,sizeof(*info_var));
            pt_bloc->nb_var = nb_var + 1;
            
            /* Trier le tableau selon le nom des variables */
// modif pour sortir les element dans l'ordre du fichier
//         qsort(pt_bloc->var,pt_bloc->nb_var,
//                  sizeof(DECOM__T_desc_var),DECOM__Comparer_variable);        
        }
   
        /* SINON la variable existe deja */
    } else {
        /* retour = ERR_VARIABLE_EXISTE_DEJA*/
        status = DECOM__C_err_variable_existe_deja;
    }
    /* FINSI */
   
    return ( status );
}
/* FIN DE Enregistrer_variable */


/*****************************************************************************/
/* PROCEDURE : Extraire_information_binaire                                  */
/*---------------------------------------------------------------------------*/
/* ROLE      : Extrait la valeur brute d'un buffer binaire.                  */
/*****************************************************************************/


static DECOM__T_status DECOM__Extraire_information_binaire (

    TYCST__T_pt_void buffer,  /* IN Buffer de lecture.                        */
    TYCST__T_int4 offset,     /* IN Offset en bit par rapport au debut du     */
    /* bloc.                                        */
    TYCST__T_int4 longueur,   /* IN Longueur en bit de l'information.         */
    DECOM__T_pt_valeur_brute retour /* OUT Information en retour.             */
    )

{
    TYCST__T_int4 decalage;
    TYCST__T_real8 r_nb_octet;
    TYCST__T_int4 nb_octet;
  
    /* Declaration d'un buffer de travail statique pour eviter de faire des */
    /* allocations.                                                         */
    static TYCST__T_char travail[DECOM__C_lg_max_variable];
       
    /* Initialiser status a ok */
    DECOM__T_status status = DECOM__C_ok;
    bzero  (retour, sizeof (DECOM__T_valeur_brute));
   
    /* Calcul du decalage par rapport a la frontiere d'octet la plus proche. */
    decalage  = (offset - ((offset / 8) * 8));
    offset = (offset / 8);
  
    /* Calcul du nombre d'octet contenant l'information (en tenant compte des */
    /* possible chevauchement sur les frontiere d'octet).                     */
    r_nb_octet = ceil ((longueur + decalage) / 8.);
    nb_octet = (TYCST__T_int4) r_nb_octet;
  
    /* SI la longueur de l'information ne depasse pas DECOM__C_lg_max_variable octet!!! */
    if (nb_octet < DECOM__C_lg_max_variable){
  
        /* Recopier le mot de 32 bits du buffer dans la variable de travail */
        memcpy (travail,((TYCST__T_pt_char) buffer + offset),nb_octet);
     
        /* Affecter la strcuture decrivant la donnee en retour */
        bzero (retour,sizeof(DECOM__T_valeur_brute));
        retour->decalage   = decalage;
        retour->longueur = longueur;
        retour->buffer   = travail;
        retour->nb_octet = nb_octet;
    }else{ 
  
        /* SINON status = N_ok */
        status = DECOM__C_nok;
    }
  
    /* Retourner le  status */
    return (status);
}
/* FIN DE Extraire_information_binaire */

/*****************************************************************************/
/* PROCEDURE : Extraire_information_ascii                                    */
/*---------------------------------------------------------------------------*/
/* ROLE      : Extrait la valeur brute d'un buffer ascii.                    */
/*****************************************************************************/


static 
DECOM__T_status 
DECOM__Extraire_information_ascii (

    TYCST__T_pt_void buffer,  /* IN Buffer de lecture.                        */
    TYCST__T_int4 nb_octet,   /* IN Nombre d'octet dans le buffer.            */
    TYCST__T_char separateur, /* IN Separateur entre les variables.           */
    TYCST__T_int4 offset,     /* IN Offset en bit par rapport au debut du     */
    /* bloc.                                        */
    TYCST__T_int4 longueur,   /* IN Longueur en bit de l'information.         */
    DECOM__T_pt_valeur_brute retour /* OUT Information en retour.             */
    )

{
    TYCST__T_int4  i;
    /* Declaration d'un buffer de travail statique pour eviter de faire des */
    /* allocations.                                                         */
    static TYCST__T_char travail[DECOM__C_lg_max_variable];
    static TYCST__T_char buffer_entree[DECOM__C_lg_max_variable];
    TYCST__T_pt_char pt;
   TYCST__T_int4  longueur_oct;
   
    /* Initialiser status a nok */
    DECOM__T_status status = DECOM__C_nok;
    bzero  (retour, sizeof (DECOM__T_valeur_brute));
    bzero  (buffer_entree,DECOM__C_lg_max_variable);
    bzero  (travail,DECOM__C_lg_max_variable);

#ifdef OPS_DEBUG
    if (nb_octet>DECOM__C_lg_max_variable) 
      {
        printf("Erreur DECOM extraire ASCII\n");
      }
#endif

    memcpy (buffer_entree,(TYCST__T_pt_char) buffer,nb_octet);

    longueur_oct = ceil (longueur / 8.);
    /* SI le separateur est defini ALORS */
    if (separateur >= ' ') { 
        /* offset a la signification : sauter <offset> separateur, longueur n'est pas utilise */
        pt =  buffer_entree;
        for ( i = 0 ; (i < offset ) && (pt != NULL) ; i++) {
            pt = strchr (pt + 1,(TYCST__T_int4) separateur);
        }   
        /* SI on a pu sauter offset separateur ALORS */
        if (pt != NULL){
        
            /* On scanne la variable qui est apres le separateur */
            if ( i > 0 ) {
                pt++ ;
            }
            sscanf (pt,"%s",travail);
            status = DECOM__C_ok ;      
        }
    
        /* SINON offset et longueur ont leur signification habituelle */
    } else if ((offset + longueur) <= nb_octet) {
       memcpy (travail,((TYCST__T_pt_char) buffer_entree + offset),longueur_oct);
        status = DECOM__C_ok ;    
    }
    if (status == DECOM__C_ok) {
  
        /* Initialiser la structure de retour */
        retour->decalage = 0;
        retour->longueur = longueur;
        retour->buffer   = travail;
        retour->nb_octet = longueur_oct;
  
    } 
    /* Retourner le  status */
    return (status);
}
/* FIN DE Extraire_information_ascii */

/*****************************************************************************/
/* PROCEDURE : Decommuter_variable                                           */
/*---------------------------------------------------------------------------*/
/* ROLE      : Decommute une variable et la liste des variables deja         */
/*           : decommute.                                                    */
/*****************************************************************************/
static
DECOM__T_status
DECOM__Decommuter_variable (
    const TYCST__T_pt_char prefixe,       /* IN */
    const TYCST__T_pt_void bloc,          /* IN */
    DECOM__T_pt_liste_var liste_var_tmp,  /* INOUT */
    const DECOM__T_desc_bloc info_bloc,   /* IN */
    const TYCST__T_pt_char nom_variable  /* IN */ 
    )      
{	
  DECOM__T_desc_var desc_variable;
  DECOM__T_status   status = DECOM__C_nok;
  DECOM__T_valeur_brute *valeur_brute = NULL;
  DECOM__T_valeur_brute *valeur_convertie = NULL;
  DECOM__T_UnionTypes Conversion;
  TYCST__T_real8      ValeurDouble;
   
  int i = 0;
  int offset = 0;
  
  
  /* SI la description de la variable existe dans le bloc  ALORS */
  if ( DECOM__Rechercher_info_variable (info_bloc, 
                                        nom_variable,
                                        &desc_variable) != -1)
    {  
      /* si la dimension n'est pas definie o l'initialise a 1 */
	  // FT-2765
      if (desc_variable.dim == 0)
      // ...FT-2765
        {
          desc_variable.dim = 1;
        }
      
      /* on alloue de la memoire pour les tableaux de valeur */ 
      valeur_brute = TYCST__MALLOC (desc_variable.dim * sizeof(DECOM__T_valeur_brute));
      valeur_convertie = TYCST__MALLOC (desc_variable.dim * sizeof(DECOM__T_valeur_brute));
      if ( (valeur_brute == NULL) || (valeur_convertie == NULL) )
        {
          status = DECOM__C_err_allocation;
        }
      else
        {
          /*on initialise l'octect de depart */
          offset = desc_variable.offset;
          
          // pour chaque element du tableau   
          for(i=0;i<desc_variable.dim;i++)
            {
              /* SI le bloc est de type binaire ALORS */
              if (info_bloc.type == DECOM__C_type_binaire) 
                {
                  /* calcul de l'offset */
                  desc_variable.offset=offset + i * desc_variable.lg;
                  
                  /* extraire l'information du buffer binaire */
                  status = DECOM__Extraire_information_binaire (bloc,
                                                                desc_variable.offset,
                                                                desc_variable.lg,
                                                                &valeur_brute[i]);	
                }
              else
                {
                  /* SINON extraire l'information du bloc ascii */
                  status = DECOM__Extraire_information_ascii (bloc,
                                                              info_bloc.lg,
                                                              info_bloc.separateur,
                                                              desc_variable.offset,
                                                              desc_variable.lg,
                                                              &valeur_brute[i]);
                }
              
              
              if (status == DECOM__C_ok)
                {
                  /* Appliquer la fonction de conversion */
                  valeur_brute[i].action = DECOM__C_decommutation;
                  status = desc_variable.decom.proc_conv (&valeur_brute[i],&valeur_convertie[i],
                                                          desc_variable.decom.nb_param,
                                                          desc_variable.decom.param);
                  
                  /* SI la valeur est de type float (TYCST__T_real4) ALORS */
                  if ( (desc_variable.lg == 32) && 
                       (!strcmp(desc_variable.nomcv, DECOM__C_nom_conv_1)) )
                  {
                    ValeurDouble = valeur_convertie[i].valeur;
                    Conversion.ValeurTYCST__T_uint4 = (TYCST__T_uint4) ValeurDouble;
                    // ...FT-2765
                    SWAP_INT_BUFFER( &Conversion.ValeurTYCST__T_uint4, 4, 1 );
                    // ...FT-2765
                    
                    /* Convertir la valeur entiere lue en reelle */
                    valeur_convertie[i].valeur = (TYCST__T_real8) Conversion.ValeurTYCST__T_real4;
                  } /* FIN SI */
                } /* FIN SI */
            } // FIN FOR

          if ((status == DECOM__C_ok) 
              && (valeur_convertie[0].type == DECOM__C_type_binaire)) 
            {
              /* si la dimension est > 1 :    */
              /* on stocke un pointeur sur un tableau que l'on va allouer dans la fonction
                 suivante */
              status = DECOM__StockerVariable(
                                              desc_variable.dim,
                                              valeur_convertie,
                                              liste_var_tmp,
                                              nom_variable,
                                              prefixe,
                                              desc_variable.nomcv);	   
            } 
          
          // on libere ici les tableau de donnee allouee au debut 
          TYCST__FREE(valeur_convertie);
          TYCST__FREE(valeur_brute);
        }
    }

  return (status);
}

/* FIN DE Decommuter_variable */



/*****************************************************************************/
/* DECLARATION  :  DECOM__StockerVariable                                    */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION :    Determine et ecrit le type et l'une variable             */
/*             :    et l'ajoute a la liste de variable                       */
/*             :    Alloue de la memoire s'il s'agit d'un tableau            */   
/*             :    Ajoute dans la liste de variable un pointeur             */
/*             :    sur ce tableau  (utilise dans le cadre de la decommutation       */
/*             :                                                             */
/*****************************************************************************/
static
DECOM__T_status	
DECOM__StockerVariable(
    TYCST__T_int4 dim,
    DECOM__T_valeur_brute * valeur_convertie,
    DECOM__T_pt_liste_var liste_var,
    const TYCST__T_pt_char nom_variable,
    const TYCST__T_pt_char prefixe,
    char * conv 
    )
{
    int type,i;
    int year,month,day,hour,min,sec;
    unsigned int millis;
    int taille;
    DECOM__T_status   status = DECOM__C_ok;
    DECOM__T_val_var       valeur_ajoute;
    //char *buffer = NULL;
    char buffer[20];
    int local1;
    int local2;
    int ret;

// en lecture si BIN_MUL_UNSIGNED on stocke un entier non signe 
// ou conversion ASCII -> uint4 
    if( strcmp(DECOM__C_nom_conv_3,conv)==0 ||
        strcmp(DECOM__C_nom_conv_11,conv)==0 ||
	strcmp(DECOM__C_nom_conv_25,conv)==0)
    {
        type=DECOM__C_uint4;

        valeur_ajoute.pui4 =(unsigned int*)TYCST__MALLOC(sizeof(unsigned int)*dim);
        if (valeur_ajoute.pui4 == NULL) {status=DECOM__C_err_allocation; }   
        else {
// les valeurs sont recopiees une a une   
            for (i=0;i<dim;i++)
                valeur_ajoute.pui4[i] = (unsigned int) valeur_convertie[i].valeur;
        }
    }
// en lecture si BIN_MUL_SIGNED on stocke un entier
// ou conversion -> int4   
//CR269 on prevoit ici le stockage avec la fonction ASC_MUL dans un entier
    if( strcmp(DECOM__C_nom_conv_8,conv)==0 ||
        strcmp(DECOM__C_nom_conv_4,conv)==0 ||
        strcmp(DECOM__C_nom_conv_10,conv)==0 )
    {
        type=DECOM__C_int4;
        valeur_ajoute.pi4 =(int*)TYCST__MALLOC(sizeof(int)*dim);
        if (valeur_ajoute.pi4 == NULL){ status=DECOM__C_err_allocation;}
        else {
// les valeurs sont recopiees une a une   
            for (i=0;i<dim;i++)
                valeur_ajoute.pi4[i] = ( int) valeur_convertie[i].valeur;
        }
    
    }
// si word 32 on recupere 2 short int pour creer un int
    if(strcmp(DECOM__C_nom_conv_26,conv)==0)
      {
	type=DECOM__C_int4;
	dim = dim/2;
        valeur_ajoute.pi4 =(int*)TYCST__MALLOC(sizeof(int)*dim);
	for (i=0;i<dim;i++)
	  {
	  local1 = (int)(valeur_convertie[i].valeur);
	  local2 = (int)(valeur_convertie[i+dim].valeur);
	  local2 = (0x0000ffff)&local2;
	  local1 = (local1 << 16)&(0xffff0000);
	  valeur_ajoute.pi4[i] = (int)(local1 + local2);
	  }
      }
    
// en lecture si BINAIREBRUTE  ou BIN_SF_SIGNED ou BIN_VINT_SIGNED on stocke un reel   ou conversion ASCII -> real8 
    // FT-2765
    if( strcmp(DECOM__C_nom_conv_real8,conv)==0 ||
        strcmp(DECOM__C_nom_conv_1,conv)==0 ||
        strcmp(DECOM__C_nom_conv_20,conv)==0 ||
        strcmp(DECOM__C_nom_conv_22,conv)==0 ||
        strcmp(DECOM__C_nom_conv_12,conv)==0 )
    // ...FT-2765
    {
        type=DECOM__C_real8;
        valeur_ajoute.pr8 =(double *)TYCST__MALLOC(sizeof(double)*dim);
        if (valeur_ajoute.pr8 == NULL) {status=DECOM__C_err_allocation;}
        else {
// les valeurs sont recopiees une a une   
            for (i=0;i<dim;i++)
                valeur_ajoute.pr8[i] = (double) valeur_convertie[i].valeur;
        }      
    }
    
// en lecture si ASCIIBRUTE on stocke un ascii    
    if( strcmp(DECOM__C_nom_conv_2,conv)==0)
    {
        type=DECOM__C_string;
        // les tableau de chaine ne sont pas supportes
        if (dim != 1)
        {status=DECOM__C_err_tab_ascii;}
        else {
            valeur_ajoute.s=(char *)TYCST__MALLOC(valeur_convertie[0].nb_octet+1);
            if (valeur_ajoute.s == NULL)
            {status=DECOM__C_err_allocation;}
            else
            {memcpy(valeur_ajoute.s,valeur_convertie[0].buffer,valeur_convertie[0].nb_octet);
            valeur_ajoute.s[valeur_convertie[0].nb_octet]='\0';} 
        }
    }    

// en lecture si BIN_DATE_CCSDS on stocke une date CCSDS   
    if( strcmp(DECOM__C_nom_conv_21,conv)==0)
    {
        type=DECOM__C_date;
        valeur_ajoute.pdate =(t_SD_BAS_SCDSTime *)TYCST__MALLOC(sizeof(t_SD_BAS_SCDSTime)*dim);
        if (valeur_ajoute.pdate == NULL) {status=DECOM__C_err_allocation;}
        else {
// les valeurs sont recopiees une a une   
            for (i=0;i<dim;i++){
                memcpy(&(valeur_ajoute.pdate[i].day),
                       (TYCST__T_pt_char)(&valeur_convertie[i].valeur),
                       2);
                memcpy(&(valeur_ajoute.pdate[i].millis),((TYCST__T_pt_char)&(valeur_convertie[i].valeur))+2,4);
            }
        }      
    }


    // en lecture si BIN_GENTIME on stocke une date general time
    if( strcmp(DECOM__C_nom_conv_24,conv)==0)
      {
        type=DECOM__C_gentime;
        valeur_ajoute.pgentime =( t_SD_BAS_GeneralTime *)TYCST__MALLOC(sizeof(t_SD_BAS_GeneralTime)*dim);
        if (valeur_ajoute.pgentime == NULL) {status=DECOM__C_err_allocation;}
        else {
	  // les valeurs sont recopiees une a une   
	  
	  if (dim != 1)
            {status=DECOM__C_err_tab_ascii;}
	  else 
            {
              //buffer = (char*) malloc(valeur_convertie[0].nb_octet+1);
              memcpy(buffer,valeur_convertie[0].buffer,valeur_convertie[0].nb_octet);
              buffer[valeur_convertie[0].nb_octet]='\0';   
	    
              taille=strlen(buffer);
              
              if (taille == DECOM__C_LG_GENTIME)
                {
                  ret=sscanf(buffer,
                         "%04d%02d%02d%02d%02d%02dZ",
                         &year, &month, &day, &hour, &min, &sec); 
		//jlp controles de decodage
		 if (ret != 6)
		  {
		  year = 0;
		  month = 0; 
		  day = 0;
		  hour = 0;
		  min = 0;
		  sec = 0;
		  }
                }
              else
                {
                  ret=sscanf(buffer,
                         "%04d%02d%02d%02d%02d%02d%03dZ",
                         &year, &month, &day, &hour, &min, &sec, &millis); 
                  valeur_ajoute.pgentime[0].millis = millis;
		//jlp controles de decodage
 		 if (ret != 7)
		  {
		  year = 0;
		  month = 0; 
		  day = 0;
		  hour = 0;
		  min = 0;
		  sec = 0;
		  millis = 0;		  
		  }
                 valeur_ajoute.pgentime[0].millis   = millis;
                }
	    
              valeur_ajoute.pgentime[0].year  = year;
              valeur_ajoute.pgentime[0].month = month;
              valeur_ajoute.pgentime[0].day   = day;
              valeur_ajoute.pgentime[0].hour  = hour;
              valeur_ajoute.pgentime[0].min   = min;
              valeur_ajoute.pgentime[0].sec   = sec;

              //free(buffer);	    
            }
        }
      }

    /* il faut rajouter la variable dans la liste */
    if  ( status== DECOM__C_ok) {
        status = DECOM__Ajouter_variable (liste_var, 
                                          prefixe,
                                          nom_variable,
                                          type,
                                          dim,
                                          valeur_ajoute); }
  
  
    return (status);

}		
/*****************************************************************************/
/* PROCEDURE : Liberer_Stockage_liste_var                                             */
/*---------------------------------------------------------------------------*/
/* ROLE      : Permet de liberer l'espace memoire alloue par l'operation     */
/*           : "DECOM__StockerVariable" utilisee pour la decommutation */
/* 		ou la donnees elle meme est allouee en interne	  */
/*****************************************************************************/

extern
void
DECOM__Liberer_Stockage_liste_var(
    const DECOM__T_pt_liste_var liste_var /* IN Liste des variables a liberer. */
    )
{
  int i = 0;

  /* pour chaque element de la liste*/
  for (i=0;i<liste_var->nb_var;i++)
    {
      switch (liste_var->tab_var[i].type) 
        {
        case DECOM__C_string :
          TYCST__FREE (liste_var->tab_var[i].val.s);
          break;
        case DECOM__C_real8 :
          TYCST__FREE (liste_var->tab_var[i].val.pr8);
          break;
        case DECOM__C_int4 :
          TYCST__FREE (liste_var->tab_var[i].val.pi4);
          break;
        case DECOM__C_uint4 :
          TYCST__FREE (liste_var->tab_var[i].val.pui4);
          break;
        case DECOM__C_date :
          TYCST__FREE (liste_var->tab_var[i].val.pdate);
          break;
        case DECOM__C_gentime :
          TYCST__FREE (liste_var->tab_var[i].val.pgentime);
          break;
          
        default : 
          break;
        }
    }
  // fin pour chaque element de la liste*/
  
  /* Liberer le  tableau des variables. */
//FA159
  if (liste_var->nb_var>0) {
  TYCST__FREE (liste_var->tab_var);}

  // la liberation est ici superficielle
  /* Remettre a zero la structure. */
  bzero (liste_var,sizeof (DECOM__T_pt_liste_var));
}
/* FIN DE Liberer_liste_var */


/* FIN DE DECOM_DECOMMUTATION.c */

