// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/BAS/src/SD_BAS_DECOM_DECOMMUTATION.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_BAS
//@ MODULE : SD_BAS_DECOMMUTATION
//@
//@ Comment :
//@     include file for the  SD_BAS_DECOMMUTATION class which  the
//@    is used for commutation/ decommutation for product
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ AUTEUR            :   S. BOBIN
//@ DATE DE CREATION  : 05/05/98
//@ EURIDIS / REALISATION PAR SYSECA SA
//@ --------------------------------------------------------------------
//@ 23/03/1998   PM17            C.TEXIER    Ajout de DECOM__C_nom_conv_19
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

/*****************************************************************************/
/*                                  EURIDIS                                  */
/*                         REALISATION PAR SYSECA SA                         */
/*****************************************************************************/
/* SYSTEME           :   Services Communs                                    */
/* NOM DU FICHIER    : DECOM_DECOMMUTATION.h                                                   */
/* OBJET HOOD        : DECOM_DECOMMUTATION                                   */
/* NOM ABREGE        : DECOM                                                 */
/* TYPE DU FICHIER   : PROVIDED INTERFACE                                    */
/* LANGAGE           : C ANSI                                                */
/* AUTEUR            :   S. BOBIN                                            */
/* DATE DE CREATION  : 05/05/98                                                   */
/*****************************************************************************/
/* ABSTRACTION       :                                                       */
/*                   :                                                       */
/*****************************************************************************/
/* MACHINE CIBLE     : SUN                                                   */
/* OS UNIX           : SOLARIS 2.5                                           */
/* COMPILATEUR       : xlc                                                   */
/* LOGICIELS DE BASE :                                                       */
/* PROGICIELS        :                                                       */
/*****************************************************************************/
/* VERSION           : 1.6                                                   */
/* DATE VERSION      : 98/05/05                                                   */
/* AUTEUR VERSION    :                                                       */
/*****************************************************************************/
/* MODIFICATIONS     :                                                       */
/* 23/03/1998   PM17            C.TEXIER    Ajout de DECOM__C_nom_conv_19    */
/*****************************************************************************/

/*****************************************************************************/
/*                    CLAUSES DE VISIBILITE (#include)                       */
/*****************************************************************************/

/* ========== visibility on specification file :  */

/* FIN CARTOUCHE */

#ifndef INCLUDE_spec_DECOM_DECOMMUTATION
#define INCLUDE_spec_DECOM_DECOMMUTATION

/*****************************************************************************/
/*                    CLAUSES DE VISIBILITE (#include)                       */
/*****************************************************************************/


/* ========== required interface :  */
/* Required OPERATION : NONE */
/* Required EXCEPTION : NONE */
/* Required TYPE : */
/* 	TYPE : T_composante of object : TYPAP */
/* 	TYPE : T_char of object : TYCST */
/* 	TYPE : T_pt_char of object : TYCST */
/* 	TYPE : T_uchar of object : TYCST */
/* 	TYPE : T_int2 of object : TYCST */
/* 	TYPE : T_uint2 of object : TYCST */
/* 	TYPE : T_int4 of object : TYCST */
/* 	TYPE : T_pt_int4 of object : TYCST */
/* 	TYPE : T_uint4 of object : TYCST */
/* 	TYPE : T_real4 of object : TYCST */
/* 	TYPE : T_real8 of object : TYCST */
/* 	TYPE : T_boolean of object : TYCST */
/* 	TYPE : T_pt_void of object : TYCST */
/* 	TYPE : T_pt_pt_void of object : TYCST */
/* Required CONSTANT : NONE */
/* Required DATA : NONE */

/* ========== visibility on required objects :  */
#include "SD_BAS_DECOM_TYCST.h"
#include "SD_BAS_DECOM_TYPAP.h"
#include "SD_BAS_Global.h"

/*****************************************************************************/
/*                CONSTANTES NON TYPEES EXTERNES (#define)                   */
/*****************************************************************************/

/*C C_lg_nom_bloc :  */
/* Constante definissant la longueur maximum d'un nom de bloc. */
#define DECOM__C_lg_nom_bloc 31

/*C C_lg_nom_var :  */
/* Constante definissant la longueur maximum d'un nom de variable. */
#define DECOM__C_lg_nom_var 51

/*C C_nom_format :*/
/* Pattern de recherche de la variable d'environnement pointant vers le format. */
#define DECOM__C_nom_format "FORMAT%d"

/*C C_nom_conv_1 :  */
/* Constante definissant le nom de la fonction de conversion numero 1. */
/* Cette fonction traite les donnees numeriques brutes.                */
/* Si la donnee est codee sur 4 octets, il s'agit alors d'un float     */
/* (ie TYCST__T_real4 dans le code)                                    */

#define DECOM__C_nom_conv_1 "BINAIREBRUTE"
// FT-2765
#define DECOM__C_nom_conv_real8 "REAL8"
// ...FT-2765

/*C C_nom_conv_2 :  */
/* Constante definissant le nom de la fonction de conversion numero 2. */
/* Cette fonction traite les donnees ascii brutes.                     */

#define DECOM__C_nom_conv_2 "ASCIIBRUTE"

/*C C_nom_conv_3 :  */
/* Constante definissant le nom de la fonction de conversion numero 3. */
/* Cette fonction traite les donnees binaire brutes non signees.       */
/* algoritme : <valeur_sortie> = <valeur_entree> * parametre1          */

#define DECOM__C_nom_conv_3 "BIN_MUL_UNSIGNED"


/*C C_nom_conv_8 :  */
/* Constante definissant le nom de la fonction de conversion numero 3. */
/* Cette fonction traite les donnees binaire brutes signees.           */
/* algoritme : <valeur_sortie> = <valeur_entree> * parametre1          */

#define DECOM__C_nom_conv_8 "BIN_MUL_SIGNED"

/*C C_nom_conv_20 :  */
/* Constante definissant le nom de la fonction de conversion numero 20. */
/* Cette fonction traite les donnees binaire brutes signees.           */
/* algorithme : <valeur_commutee> (int) = <valeur_entree> (reel) * 10^parametre1     */

#define DECOM__C_nom_conv_20 "BIN_SF_SIGNED"

/*C C_nom_conv_21 :  */
/* Constante definissant le nom de la fonction de conversion numero 21. */
/* Cette fonction traite les date au format CCSDS.           */
/* algorithme : <valeur_commutee> (48bits) = <day>  et <ms of day>     */

#define DECOM__C_nom_conv_21 "BIN_DATE_CCSDS"


/*C C_nom_conv_24 :  */
/* Constante definissant le nom de la fonction de conversion numero 24. */
/* Cette fonction traite les dates au format generat time.           */
/* algorithme : <valeur_commutee> 15 octect (ASCII) = <year>, <month> ... <sec> */

#define DECOM__C_nom_conv_24 "BIN_GENTIME"


/*C C_nom_conv_25 :  */
/* Constante definissant le nom de la fonction de conversion numero 25. */
/* Cette fonction traite les date au format OBT.           */ 
/* algorithme : <valeur_commutee> (48bits) = (8bits)(date obt 32 bits)(8 bits)*/
#define DECOM__C_nom_conv_25 "DATE_OBT"

/*C C_nom_conv_26 :  */
/* Constante definissant le nom de la fonction de conversion numero 26. */
/* Cette fonction traite des entier 32 bits est les les ecrits en mot de 16 bits sepa*/

#define DECOM__C_nom_conv_26 "WORD_32"

/*C C_nom_conv_22 :  */
/* Constante definissant le nom de la fonction de conversion numero 20. */
/* Cette fonction traite les donnees binaire brutes signees.           */
/* algorithme : <valeur_decommutee> (int) = <valeur_commutee> (int) * 10^valeur_commutee (char)     */

#define DECOM__C_nom_conv_22 "BIN_VINT_SIGNED"

/*C C_nom_conv_4 :  */
/* Constante definissant le nom de la fonction de conversion numero 4. */
/* Cette fonction traite les donnees ascii signees.                    */
/* algoritme : <valeur_sortie> = <valeur_entree> * parametre1          */

#define DECOM__C_nom_conv_4 "ASC_MUL"

/*C C_nom_conv_5 :  */
/* Constante definissant le nom de la fonction de conversion numero 5. */
/* Cette fonction traite les erreurs dans le bloc MT.                  */
/* algoritme : retourne le xx de E0000xx O.O si pas de E0000.          */

#define DECOM__C_nom_conv_5 "ERREUR_MTL"

/*C C_nom_conv_6 :  */
/* Constante definissant le nom de la fonction de conversion numero 6. */
/* Cette fonction traite les valeurs d'entree ASCII compris entre deux */
/* valeurs. (utile pour etat de l'horloge HO).                         */
/* algoritme Retour=parametre3 SI Valeur entree (ascii) >= parametre 1 */
/*           ET valeur entree <= parametre 2.                          */
/*           SINON retour = parametre 4.                               */

#define DECOM__C_nom_conv_6 "VALEUR_BORNEE"

/*C C_nom_conv_7 :  */
/* Constante definissant le nom de la fonction de conversion numero 7. */
/* Cette fonction traite les valeurs d'entree ASCII ON, OFF ENANB      */
/* donnant le status de l'horloge HOL.                                 */
/* algoritme :                                                         */
/* SI chaine entree = ON alors retour = parametre 1                    */
/* SI chaine entree = OFF alors retour = parametre 2                   */
/* SI chaine sortie = ENAB alors retour = parametre 3                  */
/* defaut retour = parametre4                                          */

#define DECOM__C_nom_conv_7 "STATUS_HO"



/*C C_nom_conv_10 :  */
/* Permet d'extraire et ecrire des donnees ASCII sous forme de int4*/

#define DECOM__C_nom_conv_10 "ASCINT4"

/*C C_nom_conv_11 :  */
/* Permet d'extraire et ecrire des donnees ASCII sous forme de unsigned int4*/

#define DECOM__C_nom_conv_11 "ASCUINT4"

/*C C_nom_conv_12 :  */
/* Permet d'extraire et ecrire des donnees ASCII sous forme de real8 */

#define DECOM__C_nom_conv_12 "ASCREAL8"


/*C C_nom_conv_13 :  */
/* Constante definissant le nom de la fonction de conversion numero 13 */
/* Cette fonction traite les valeurs d'entree ASCII R, A               */
/* donnant le status de l'interface SRF.                               */
/* algoritme :                                                         */
/* SI chaine entree = R alors retour = parametre 1                     */
/* SI chaine entree = A alors retour = parametre 2                     */
/* defaut retour = parametre 3                                         */

#define DECOM__C_nom_conv_13 "STATUS_SRF"



/*C C_nom_conv_15 :  */
/* Constante definissant le nom de la fonction de conversion numero 15 */
/* Cette fonction traite les informations concernant la consigne de    */
/* vitesse de la BLG                                                   */
/* Les longueur et offset doivent en frontiere octet                   */
/* algoritme valeur = valeur_entree * parametre1                       */

#define DECOM__C_nom_conv_15 "CONSIGNE_BLG"

/*C C_nom_conv_16 :  */
/* Constante definissant le nom de la fonction de conversion numero 16 */
/* Cette fonction traite les valeurs d'entree ASCII a, b               */
/* donnant l'element actif de l'interface IRF.                         */
/* algoritme :                                                         */
/* SI chaine entree = a alors retour = parametre 1                     */
/* SI chaine entree = b alors retour = parametre 2                     */
/* defaut retour = parametre 3                                         */

#define DECOM__C_nom_conv_16 "STATUS_IRF"


/*C C_nom_conv_19 :  */
/* Constante definissant le nom de la fonction de conversion numero 19 */
/* Cette fonction traite les valeurs d'entree ASCII O, D, E            */
/* donnant la position d'antenne fournit par le commutateur.           */
/* algoritme :                                                         */
/* SI chaine entree = O alors retour = parametre 1                     */
/* SI chaine entree = D alors retour = parametre 2                     */
/* SI chaine entree = E alors retour = parametre 3                     */
/* defaut retour = parametre 4                                         */

#define DECOM__C_nom_conv_19 "STATUS_CMA"

/*****************************************************************************/
/*                DEFINITIONS DES TYPES EXTERNES                             */
/*****************************************************************************/
/*T T_nom_var :  */
/* Type definissant le nom d'une variable. */
typedef TYCST__T_char    DECOM__T_nom_var[DECOM__C_lg_nom_var];

/*T T_val_var :  */
/* Type union definissant la valeur d'une variable. */
typedef union {
  TYCST__T_pt_char    s;
  TYCST__T_pt_int4    pi4;
  TYCST__T_pt_uint4   pui4;
  TYCST__T_pt_real8   pr8;
  t_SD_BAS_SCDSTime  * pdate;
  t_SD_BAS_GeneralTime * pgentime;
} DECOM__T_val_var;

/*T T_type_var :  */
/* Type enumere definissant le type d'une variable. */
typedef enum {
   DECOM__C_int4=1,
   DECOM__C_uint4=2,
   DECOM__C_real8=3,
   DECOM__C_real4=4,
   DECOM__C_string=5,
   DECOM__C_date=6,
   DECOM__C_gentime=7
} DECOM__T_type_var;

/*T T_var :  */
/* Type decrivant une variable. */
typedef struct {
     DECOM__T_nom_var nom;      /* nom de la variable */
     DECOM__T_val_var val;         /* valeur variable */
     DECOM__T_type_var type;     /* type variable */
     TYCST__T_int4 dim;     /* dimension de la variable */
} DECOM__T_var;

/*T T_liste_var :  */
/* Type decrivant une liste de variables */
typedef struct {
   TYCST__T_uint2	nb_var;  /* nombre de variables dans la liste */
   DECOM__T_var *tab_var;     /* tableau de variables */
} DECOM__T_liste_var;

/*T T_nom_bloc :  */
/* type decrivant le nom d'un bloc. */
typedef TYCST__T_char    DECOM__T_nom_bloc[DECOM__C_lg_nom_bloc];

/*T T_pt_liste_var :  */
/* Type decrivant un pointeur sur une liste de variables */
typedef DECOM__T_liste_var *DECOM__T_pt_liste_var;

/*T T_pt_var :  */
/* Type decrivant un pointeur sur une description de variable */
typedef DECOM__T_var *DECOM__T_pt_var;

/*T T_status :  */
/* Type definissant le status retournee par les operations de l'objet. */
typedef enum {
   DECOM__C_ok 				= 0,     /* pas d'erreur */
   DECOM__C_nok 			= 1,  /* erreur */   
   DECOM__C_err_allocation 		= 2,  /* Erreur allocation */
   DECOM__C_err_bloc_existe_deja        = 3,  /* Bloc deja existant */
   DECOM__C_err_trop_de_bloc            = 4,  /* Trops de bloc */
   DECOM__C_err_fich_inex               = 5,  /* Fichier inexistant */
   DECOM__C_err_variable_existe_deja    = 6,  /* Variable deja existante */
   DECOM__C_err_debordement             = 7,  /* Depassement de codage */
   DECOM__C_err_format                  = 8,  /* erreur de format */
   DECOM__C_err_fct_conversion          = 9,  /* fonction de converstion inconnue */
   DECOM__C_err_type_fct_conversion     = 10,  /* Type de fonction de converstion inconpatible */
   DECOM__C_err_bloc_inconnu            = 11,  /* Nom de bloc inconnu */
   DECOM__C_err_analyse                 = 12,  /* Erreur analyse du fichier */
   DECOM__C_err_descripteur		= 13,   /* plus de descripteur */
   DECOM__C_err_tab_ascii		= 14,   /* tableau ascii non supportes */
   DECOM__C_err_taille_tab		= 15,   /* taille du tableau negative */
   DECOM__C_err_dim_variable		= 16,   /* incoherence de la taille des  variables */
   						 /* entre le memoire et le fichier de conf */
   DECOM__C_err_codage_double		= 17,   /* erreur lors de l'ecriture  d'un double */
   DECOM__C_err_codage_date		= 18,   /* erreur lors de l'ecriture  d'une      date */
   DECOM__C_err_conversion_vint		= 19   /* erreur lors   de    la conversion d'un reel */
   } DECOM__T_status;

// FT-2765
static char * DECOM__T_message[]= {
  (char *)"",
  (char *)" Erreur generale",
  (char *)" Erreur allocation ",
  (char *)" Bloc deja existant ",
  (char *)" Trops de bloc ",
  (char *)" Fichier de conf inexistant ",
  (char *)" Variable deja existante ",
  (char *)" Depassement de codage ",
  (char *)" erreur de format ",
  (char *)" fonction de converstion inconnue ",
  (char *)" Type de fonction de converstion incompatible ",
  (char *)" Nom de bloc inconnu ",
  (char *)" Erreur analyse du fichier de conf ",
  (char *)" plus de descripteur ",
  (char *)" tableau ascii non supportes ",
  (char *)" taille du tableau negative ",
  (char *)" incoherence sur la taille des  tableau de variables ",
  (char *)" erreur lors de l'ecriture  d'un double : alignement incorrect ",
  (char *)" erreur lors de l'ecriture  d'une date : alignement incorrect ",
  (char *)" erreur lors de la conversion d'un double en vinteger4 "
} ;
// ...FT-2765

/*****************************************************************************/
/*              DECLARATIONS DES OPERATIONS EXTERNES (extern)                */
/*****************************************************************************/

/*****************************************************************************/
/* DECLARATION : Decommuter                                                  */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Permet de decommuter un bloc de donnees. La decommutation   */
/*             : consiste a extraire les donnees presentes dans le bloc,     */
/*             : puis a convertir ces donnees brutes en variables            */
/*             : (fonction de conversion). L'operation  retourne la liste des */
/*             : variables ainsi obtenues en prefixant le nom de chaque variable par le */
/*             : nom de la composante.                                       */
/*****************************************************************************/

extern
DECOM__T_status
DECOM__Decommuter(
	const TYCST__T_pt_void bloc, 
	const TYCST__T_int4 lg_bloc, 
	const DECOM__T_nom_bloc nom_bloc, 
	const TYCST__T_pt_char composante, 
	DECOM__T_pt_liste_var liste_var
	);

/*****************************************************************************/
/* DECLARATION : Recommuter                                                  */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Permet de construire un bloc de donnees. La recommutation   */
/*             : consiste a convertir une liste de variables (fonction de    */
/*             : conversion) en donnees brutes puis de construire un bloc    */
/*             : contenant ces donnees.                                      */
/*****************************************************************************/

extern
DECOM__T_status
DECOM__Recommuter(
	const DECOM__T_nom_bloc nom_bloc, 
	const DECOM__T_liste_var liste_var, 
	TYCST__T_pt_pt_char bloc, 
	TYCST__T_pt_int4 lg_bloc
	);

/*****************************************************************************/
/* DECLARATION : Liberer_liste_var                                           */
/*---------------------------------------------------------------------------*/
/* ROLE      : Permet de liberer l'espace memoire alloue par l'operation     */
/*           : "DECOM__Ajouter_variable" pour retourner la liste des variables */
/* en particulier pour la commutation ou la donnees elle meme est allouee   */
/* par l'appelant */
/*****************************************************************************/

extern
void
DECOM__Liberer_liste_var(
        const DECOM__T_pt_liste_var liste_var
	);

/*****************************************************************************/
/* PROCEDURE : Liberer_Stockage_liste_var                                             */
/*---------------------------------------------------------------------------*/
/* ROLE      : Permet de liberer l'espace memoire alloue par l'operation     */
/*           : "DECOM__StockerVariable" utilisee pour la decommutation */
/* 		ou la donnees elle meme est allouee en interne	  */
/*****************************************************************************/

extern
void
DECOM__Liberer_Stockage_liste_var(
   const DECOM__T_pt_liste_var liste_var /* IN Liste des variables a liberer. */
   );
/*****************************************************************************/
/* DECLARATION : Ajouter_variable                                            */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Permet d'ajouter une variable dans la liste des variables   */
/*             : a recommuter par exemple.                                   */
/* remarque : dans le cas de la commutation la variable dim utilisee est celle*/
/* dans la description du fichier et pas celle indiquee ici		     */
/*****************************************************************************/

extern
DECOM__T_status
DECOM__Ajouter_variable (
    DECOM__T_pt_liste_var liste_var, /* INOUT  Liste de variable a completer */
    const TYCST__T_pt_char   prefixe,      /* IN Prefixe a rajouter aux nom  */
                                           /* de variable.                   */ 
    const DECOM__T_nom_var   nom_variable, /* IN Nom de la variable.    */
    const DECOM__T_type_var  type,         /* IN Type de la variable.   */
    const TYCST__T_int4  	dim,       /* dimension de la variable.   */
    const DECOM__T_val_var   valeur        /* IN Valeur de la variable. */
    );

/*****************************************************************************/
/* DECLARATION : Liberer_bloc                                                */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Permet de liberer l'espace memoire alloue par l'operation "Recommuter" */
/*             : pour retourner le bloc de donnees.                          */
/*****************************************************************************/

extern
void
DECOM__Liberer_bloc(
        TYCST__T_pt_void bloc
	);

/*****************************************************************************/
/* DECLARATION : Charger                                                     */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Permet de charger la description d'un bloc a partir d'un    */
/*             : fichier qui contient la description de ce bloc.             */
/*****************************************************************************/

extern
DECOM__T_status
DECOM__Charger (
	const TYCST__T_chemin_fichier description
	);

			/* FIN DE DECOM_DECOMMUTATION.h */
#endif
