// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/BAS/src/SD_BAS_DECOM_TYCST.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_BAS
//@ MODULE : SD_BAS_DECOM_TYCST
//@
//@ Comment :
//@     include file for the  SD_BAS_TYCST class which
//@    is used for commutation/ decommutation
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ DATE DE CREATION  : 05/02/97
//@ EURIDIS / REALISATION PAR SYSECA SA
//@ --------------------------------------------------------------------
//@ COMMENTAIRE : (15/04/1997) Modification de la definition de
//@ TYCST__T_uint4.
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

/*****************************************************************************/
/*                                  EURIDIS                                  */
/*                         REALISATION PAR SYSECA SA                         */
/*****************************************************************************/
/* SYSTEME           :  Services communs                                     */
/* NOM DU FICHIER    : TYCST.h                                                   */
/* OBJET HOOD        : TYCST                                                 */
/* NOM ABREGE        : TYCST                                                 */
/* TYPE DU FICHIER   : PROVIDED INTERFACE                                    */
/* LANGAGE           : C ANSI                                                */
/* AUTEUR            :                                                       */
/* DATE DE CREATION  : 05/02/97                                                   */
/*****************************************************************************/
/* ABSTRACTION       :                                                       */
/*                   :                                                       */
/*****************************************************************************/
/* MACHINE CIBLE     : SUN                                                   */
/* OS UNIX           : SOLARIS 2.5                                           */
/* COMPILATEUR       : xlc                                                   */
/* LOGICIELS DE BASE :                                                       */
/* PROGICIELS        :                                                       */
/*****************************************************************************/
/* VERSION           : 1.2                                                   */
/* DATE VERSION      : 97/05/02                                                   */
/* AUTEUR VERSION    :                                                       */
/*****************************************************************************/
/* MODIFICATIONS     :                                                       */
/* DATE         FA/DM           AUTEUR          FCT/DONNEES IMPACTES         */
/* COMMENTAIRE : (15/04/1997) Modification de la definition de               */
/* TYCST__T_uint4.                                                           */
/*****************************************************************************/


/* FIN CARTOUCHE */

#ifndef INCLUDE_spec_TYCST
#define INCLUDE_spec_TYCST

/*****************************************************************************/
/*                    CLAUSES DE VISIBILITE (#include)                       */
/*****************************************************************************/

/* NONE */
#include <stdlib.h>
#include <stdio.h>



/*****************************************************************************/
/*                CONSTANTES NON TYPEES EXTERNES (#define)                   */
/*****************************************************************************/

/*C C_lg_nom_fichier :  */
/* Longueur maximum du nom d'un fichier
    */
#define TYCST__C_lg_nom_fichier  20


/*C C_lg_chemin_fichier :  */
/* Longueur maximum du chemin d'acces a un fichier
    */
#define TYCST__C_lg_chemin_fichier	200


/*C C_lg_nom_commande :  */
/* Longueur maximum d'une commande systeme
    */
#define TYCST__C_lg_nom_commande	512


/*C C_faux :  */
/* Constante definissant la valeur booleenne FAUX
    */
#define TYCST__C_faux 	0


/*C C_vrai :  */
/* Constante definissant la valeur booleenne VRAI
    */
#define TYCST__C_vrai  ! TYCST__C_faux


/*C C_str_faux :  */
/* Constante definissant la chaine FAUX
    */
#define TYCST__C_str_faux 	"FAUX"


/*C C_str_vrai :  */
/* Constante definissant la chaine VRAI
    */
#define TYCST__C_str_vrai 	"VRAI"


/*C C_nok :  */
/* Constante definissant un retour en erreur d'une fonction systeme. */
#define TYCST__C_nok -1


/*C C_ok :  */
/* Constante definissant un retour nominal d'une fonction systeme. */
#define TYCST__C_ok  0


/*C C_zero_double :  */
/* Constante definissant la precision d'un double. */
#define TYCST__C_zero_double  1e-12


/*C MIN :  */
/* Macro de comparaison de deux valeurs
    */
#define TYCST__MIN(a, b)  ((a<b)?(a):(b))

/*C MIN :  */
/* Macro de comparaison de deux valeurs
    */
#define TYCST__MAX(a, b)  ((a>b)?(a):(b))

/*C MALLOC :  */
/* Macro d'allocation d'un espace memoire
    */
#define TYCST__MALLOC(taille)	calloc(taille,1)


/*C REALLOC :  */
/* Macro de realocation d'un espace memoire
    */
#define TYCST__REALLOC(pointeur,taille)	realloc(pointeur,taille)


/*C FREE :  */
/* Macro de liberation d'un espace memoire
    */
#define TYCST__FREE(pt)	if (pt != NULL) { free(pt) ; pt=NULL ; }


/*C NB_ELT :  */
/* Macro calculant le nombre d'elements d'un tableau
    */
#define TYCST__NB_ELT(tab)	(sizeof(tab)/sizeof(tab[0]))


/*C STRTOINT2 :  */
/* Macro  convertissant une chaine en int2 
    */
#define TYCST__STRTOINT2(chaine)	(TYCST__T_int2)strtol(chaine,(char **)NULL,0)

/*C STRTOUINT2 :  */
/* Macro  convertissant une chaine en unsigned int2 
    */
#define TYCST__STRTOUINT2(chaine)	(TYCST__T_uint2)strtoul(chaine,(char **)NULL,0)

/*C STRTOINT4 :  */
/* Macro  convertissant une chaine en int4 
    */
#define TYCST__STRTOINT4(chaine)	(TYCST__T_int4)strtol(chaine,(char **)NULL,0)

/*C STRTOUINT4 :  */
/* Macro  convertissant une chaine en unsigned int4 
    */
#define TYCST__STRTOUINT4(chaine)	(TYCST__T_uint4)strtoul(chaine,(char **)NULL,0)

/*C STRTOREAL4 :  */
/* Macro  convertissant une chaine en  real4
    */
#define TYCST__STRTOREAL4(chaine)	(TYCST__T_real4)strtod(chaine,(char **)NULL)

/*C STRTOREAL8 :  */
/* Macro  convertissant une chaine en  real4
    */
#define TYCST__STRTOREAL8(chaine)	(TYCST__T_real8)strtod(chaine,(char **)NULL)

/*C STRTOBOOLEAN :  */
/* Macro  convertissant une chaine en  boolean
    */
#define TYCST__STRTOBOOL(chaine)	(TYCST__T_boolean)!strcmp(chaine,TYCST__C_str_vrai) ? TYCST__C_vrai : TYCST__C_faux

/*****************************************************************************/
/*                DEFINITIONS DES TYPES EXTERNES                             */
/*****************************************************************************/

/*T T_char :  */
/* type caractere signe code sur un octet
   
    */
typedef char TYCST__T_char;


/*T T_pt_char :  */
/* type pointeur sur caractere signe code sur un octet
   
    */
typedef TYCST__T_char* TYCST__T_pt_char;

/*T T_pt_file :  */
/* type pointeur sur fichier
   
    */
typedef FILE* TYCST__T_pt_file;

/*T T_void :  */
/* type void
   
    */
typedef void TYCST__T_void;


/*T T_pt_void :  */
/* type pointeur sur void
   
    */
typedef TYCST__T_void *TYCST__T_pt_void;


/*T T_pt_pt_void :  */
/* type pointeur sur pointeur sur void
   
    */
typedef TYCST__T_pt_void TYCST__T_pt_pt_void;

/*T T_pt_pt_char :  */
/* type pointeur de pointeur sur caractere signe code sur un octet
   
    */
typedef TYCST__T_pt_char *TYCST__T_pt_pt_char;


/*T T_uchar :  */
/* Type caractere non signe code sur un octet
   
    */
typedef unsigned char TYCST__T_uchar;


/*T T_pt_uchar :  */
/* Type pointeur sur caractere non signe code sur un octet
   
    */
typedef TYCST__T_uchar* TYCST__T_pt_uchar;


/*T T_int2 :  */
/* Type entier signe code sur 2 octets
   
    */
typedef short int TYCST__T_int2;


/*T T_pt_int2 :  */
/* Type pointeur sur entier signe code sur 2 octets
   
    */
typedef TYCST__T_int2* TYCST__T_pt_int2;


/*T T_uint2 :  */
/* Type entier non signe code sur 2 octets
   
    */
typedef unsigned short int TYCST__T_uint2;


/*T T_pt_uint2 :  */
/* Type pointeur sur entier non signe code sur 2 octets
   
    */
typedef TYCST__T_uint2* TYCST__T_pt_uint2;


/*T T_int4 :  */
/* Type entier signe code sur 4 octets
   
    */
typedef int TYCST__T_int4;


/*T T_pt_int4 :  */
/* Type pointeur sur entier signe code sur 4 octets
   
    */
typedef  TYCST__T_int4* TYCST__T_pt_int4;


/*T T_uint4 :  */
/* Type entier non signe code sur 4 octets
   
    */
typedef unsigned int TYCST__T_uint4;


/*T T_pt_uint4 :  */
/* Type pointeur sur entier non signe code sur 4 octets
   
    */
typedef  TYCST__T_uint4* TYCST__T_pt_uint4;


/*T T_real4 :  */
/* Type reel  code sur 4 octets
   
    */
typedef  float TYCST__T_real4;


/*T T_pt_real4 :  */
/* Type pointeur sur reel  code sur 4 octets
   
    */
typedef  TYCST__T_real4* TYCST__T_pt_real4;


/*T T_real8 :  */
/* Type reel code sur 8 octets
   
    */
typedef double  TYCST__T_real8;


/*T T_pt_real8 :  */
/* Type pointeur sur reel code sur 8 octets
   
    */
typedef TYCST__T_real8*  TYCST__T_pt_real8;


/*T T_boolean :  */
/* Type booleen code sur 1 octet
   
    */
typedef char TYCST__T_boolean;


/*T T_pt_boolean :  */
/* Type pointeur sur booleen code sur 1 octet
   
    */
typedef TYCST__T_boolean* TYCST__T_pt_boolean;


/*T T_nom_fichier :  */
/* Type definissant un nom de fichier ( sans le chemin d'acces )
   
    */
typedef char TYCST__T_nom_fichier[TYCST__C_lg_nom_fichier +1];


/*T T_chemin_fichier :  */
/* Type definissant un chemin d'acces a un fichier
   
    */
typedef char TYCST__T_chemin_fichier[TYCST__C_lg_chemin_fichier +1];


/*T T_nom_commande :  */
/* Type definissant un nom de commande systeme
   
    */
typedef char TYCST__T_nom_commande[TYCST__C_lg_nom_commande +1];


/*****************************************************************************/
/*              DECLARATIONS DES OPERATIONS EXTERNES (extern)                */
/*****************************************************************************/

/* NONE */


			/* FIN DE TYCST.h */
#endif
