// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/BAS/src/SD_BAS_DECOM_TYPAP.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_BAS
//@ MODULE : SD_BAS_TYPAP
//@
//@ Comment :
//@     include file for the  SD_BAS_DECOM_TYCST class which
//@    is used for commutation/ decommutation
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ AUTEUR            : E. DIDIER (SEMA GROUP)
//@ EURIDIS / REALISATION PAR SYSECA SA
//@ --------------------------------------------------------------------
//@ 24/03/98 PM17        C.TEXIER: Ajout constantes relatives au dg
//@                                sdc_confmcr_s, sdc_conforb_s.
//@                                Ajout cte : TYPAP__C_type_antenne_omni,
//@                                TYPAP__C_type_antenne_dir.
//@ --------------------------------------------------------------------
//@ 26/05/98 ERD-FAI-670 C.TEXIER: Pour le dg TYPAP__C_sqm_pothgeo_s, ajout
//@                                de variables.
//@ --------------------------------------------------------------------
//@ 07/12/98 ERD-FAI-711 A.BRU   : suppression des constantes
//@                                    TYPAP__C_qualspectrfreq
//@                                 et TYPAP__C_qualspectrlgbd
//@ --------------------------------------------------------------------
//@ 09/12/98 ERD-FAI-714 A.BRU   : rajout de la variable TYPAP__C_epqtugnss
//@                                dans dg iex_bmccs_s
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

/*****************************************************************************/
/*                                  EURIDIS                                   */
/*                         REALISATION PAR SYSECA SA                         */
/*****************************************************************************/
/* SYSTEME           : SERVICES_COMMUNS                                      */
/* NOM DU FICHIER    : TYPAP.h                                                   */
/* OBJET HOOD        : TYPAP                                                 */
/* NOM ABREGE        : TYPAP                                                 */
/* TYPE DU FICHIER   : PROVIDED INTERFACE                                    */
/* LANGAGE           : C ANSI                                                */
/* AUTEUR            : E. DIDIER (SEMA GROUP)                                */
/* DATE DE CREATION  : 12/21/98                                              */
/*****************************************************************************/
/* ABSTRACTION       : Definition des types applicatifs.                     */
/*                   :                                                       */
/*****************************************************************************/
/* MACHINE CIBLE     : SUN                                                   */
/* OS UNIX           : SOLARIS 2.5                                           */
/* COMPILATEUR       : xlc                                                   */
/* LOGICIELS DE BASE :                                                       */
/* PROGICIELS        :                                                       */
/*****************************************************************************/
/* VERSION           : 1.18                                                   */
/* DATE VERSION      : 98/12/21                                              */
/* AUTEUR VERSION    :                                                       */
/*****************************************************************************/
/* MODIFICATIONS     :                                                       */
/* 24/03/98 PM17        C.TEXIER: Ajout constantes relatives au dg           */
/*                                sdc_confmcr_s, sdc_conforb_s.              */
/*                                Ajout cte : TYPAP__C_type_antenne_omni,    */
/*                                TYPAP__C_type_antenne_dir.                 */
/* 26/05/98 ERD-FAI-670 C.TEXIER: Pour le dg TYPAP__C_sqm_pothgeo_s, ajout   */
/*                                de variables.                              */
/* 07/12/98 ERD-FAI-711 A.BRU   : suppression des constantes                 */
/*                                    TYPAP__C_qualspectrfreq                */
/*                                 et TYPAP__C_qualspectrlgbd                */
/* 09/12/98 ERD-FAI-714 A.BRU   : rajout de la variable TYPAP__C_epqtugnss   */
/*                                dans dg iex_bmccs_s                        */ 
/*****************************************************************************/

/* FIN CARTOUCHE */

#ifndef INCLUDE_spec_TYPAP
#define INCLUDE_spec_TYPAP

/*****************************************************************************/
/*                    CLAUSES DE VISIBILITE (#include)                       */
/*****************************************************************************/


/* ========== required interface :  */
/* Required OPERATION : NONE */
/* Required EXCEPTION : NONE */
/* Required TYPE : */
/* 	TYPE : T_char of object : TYCST */
/* 	TYPE : T_int2 of object : TYCST */
/* 	TYPE : T_int4 of object : TYCST */
/* Required CONSTANT : NONE */
/* Required DATA : NONE */

/* ========== visibility on required objects :  */
#include "SD_BAS_DECOM_TYCST.h"
#include <sys/signal.h>

/*****************************************************************************/
/*                CONSTANTES NON TYPEES EXTERNES (#define)                   */
/*****************************************************************************/

/*C C_racine_euridis :  */
/* nom du parametre contenant le chemin d'acces a la RACINE de l'application euridis 
    */
#define TYPAP__C_racine_euridis "RACINE_EURIDIS"

/*U COMPOSANTES EURIDIS */
/*U ------------------- */
/*C C_comp_cmt :  */
/*  Centre de mission et de traitement */
#define TYPAP__C_comp_cmt "cmt"

/*C C_comp_slk :  */
/*  Station de localisation de KOUROU */
#define TYPAP__C_comp_slk "slk"

/*C C_comp_slh :  */
/*  Station de localisation de HBK */
#define TYPAP__C_comp_slh "slh"

/*C C_comp_scl :  */
/*  Station de connexion localisation de AUSSAGUEL */
#define TYPAP__C_comp_scl "scl"

/*U EQUIPEMENTS TECHNO et INFORMATIQUES STATION de LOCALISATION */
/*U ----------------------------------------------------------- */
/*C C_elt_trl :  */
/*  unite de traitement de la station de localisation */
#define TYPAP__C_elt_trl "trl"

/*C C_elt_hol :  */
/*  horloge au cesium */
#define TYPAP__C_elt_hol "hol"

/*C C_elt_cil :  */
/*  calibrateur ionospherique */
#define TYPAP__C_elt_cil "cil"

/*C C_elt_mtl :  */
/*  station meteo */
#define TYPAP__C_elt_mtl "mtl"

/*U EQUIPEMENTS TECHNO et INFORMATIQUES STATION de CONNEXION */
/*U -------------------------------------------------------- */
/*C C_elt_srf :  */
/* station RF */
#define TYPAP__C_elt_srf "srf"

/*C C_elt_trc :  */
/* unite de traitement de la station de connexion */
#define TYPAP__C_elt_trc "trc"

/*C C_elt_ana :  */
/*  analyseur de signaux */
#define TYPAP__C_elt_ana "ana"

/*C C_elt_mux :  */
/*  multiplexeur */
#define TYPAP__C_elt_mux "mux"

/*C C_elt_blg :  */
/*  boucle longue */
#define TYPAP__C_elt_blg "blg"

/*C C_elt_int :  */
/*  recepteur d'integrite */
#define TYPAP__C_elt_int "int"


/*U EQUIPEMENTS TECHNO et INFORMATIQUES du CMT */
/*U ------------------------------------------ */
/*C C_elt_ugs :  */
/* unite de traitement gestion */
#define TYPAP__C_elt_ugs "ugs"

/*C C_elt_utd :  */
/* unite de traitement temps differe */
#define TYPAP__C_elt_utd "utd"

/*C C_elt_utr :  */
/* unite de traitement temps reel */
#define TYPAP__C_elt_utr "utr"

/*C C_elt_ucl :  */
/* unite de traitement calcul */
#define TYPAP__C_elt_ucl "uor"


/*U LISTE DES FONCTIONS LOGICIELLES */
/*U ------------------------------- */
/*C C_elt_f1 :  */
/* Collecte des donnees */
#define TYPAP__C_elt_f1 "f1"

/*C C_elt_f2 :  */
/*  Synchronisation relative */
#define TYPAP__C_elt_f2 "f2"

/*C C_elt_f3 :  */
/* Trajectographie */
#define TYPAP__C_elt_f3 "f3"

/*C C_elt_f4 :  */
/* Synchronisation absolue */
#define TYPAP__C_elt_f4 "f4"

/*C C_elt_f5 :  */
/* elaboration message */
#define TYPAP__C_elt_f5 "f5"

/*C C_elt_f6 :  */
/* asservissement du signal */
#define TYPAP__C_elt_f6 "f6"

/*C C_elt_f7 :  */
/* Emission du signal */
#define TYPAP__C_elt_f7 "f7"

/*C C_elt_f8 :  */
/* Integrite de la mission */
#define TYPAP__C_elt_f8 "f8"

/*C C_elt_f9 :  */
/* Gestion */
#define TYPAP__C_elt_f9 "f9"


/*U ------------------------------------------------ */

/*C C_priorite_normale :  */
/*  Priorite normale d'un message
    */
#define TYPAP__C_priorite_normale 0

/*C C_nb_station :  */
/* Nombre de stations.
    */
#define TYPAP__C_nb_station 3


/*C C_nb_cple_sta :  */
/* Nombre de couples de stations.
    */
#define TYPAP__C_nb_cple_sta 3


/*C C_max_intervalles :  */
/* Nombre d'intervalles elementaires pour les pretraitements des fonctions
    Orbitographie et Synchronisation Relative. 16 j * 24 h * 4
    car 4 *15 minutes = 1 heure 
    */
#ifndef ATTOL
#define TYPAP__C_max_intervalles 1536
#else
/* car pour les TU on utilise un nombre plus petit (ne pas modifier) */
#define TYPAP__C_max_intervalles 96
#endif


/*C C_nb_gps :  */
/* Nombre de satellites GPS.
    */
#define TYPAP__C_nb_gps 37



/*C C_nb_geo :  */
/* Nombre de satellites geostationnaires.
    */
#define TYPAP__C_nb_geo 1



/*C C_nb_bul_inmarsat :  */
/* Nombre maximum de bulletins de manoeuvres INMARSAT.
    */
#define TYPAP__C_nb_bul_inmarsat 9


/*C C_nb_coef_sa :  */
/* Nombre de coefficients de la synchronisation absolue emis entre deux activations
    du calcul de la trajectographie
   du geostationnaire.
    */
#define TYPAP__C_nb_coef_sa 200


/*C C_nb_coef_sr :  */
/* Nombre de coefficients de la synchronisation relative emis entre deux activations
    du calcul de la
   trajectographie du geostationnaire.
    */
#define TYPAP__C_nb_coef_sr 100


/*C C_ok :  */
/* Retour fonction OK. */
#define TYPAP__C_ok	0

/*C C_pb_argument_incorrect :  */
/* Arguments du process incorrects. */
#define TYPAP__C_pb_argument_incorrect	1 

/*C C_pb_ouverture_fichier :  */
/* Retour fonction : Probleme ouverture fichier. */
#define TYPAP__C_pb_ouverture_fichier	10

/*C C_pb_ecriture_fichier :  */
/* Retour fonction : Probleme ecriture fichier. */
#define TYPAP__C_pb_ecriture_fichier	11

/*C C_pb_lecture_fichier :  */
/* Retour fonction : Probleme lecture fichier. */
#define TYPAP__C_pb_lecture_fichier	12

/*C C_pb_fermeture_fichier :  */
/* Retour fonction : Probleme fermeture fichier. */
#define TYPAP__C_pb_fermeture_fichier	13

/*C C_cpl_inconnu :  */
/* Retour fonction : couple de stations inconnu. */
#define TYPAP__C_cpl_inconnu	        300	

/*C C_station_inconnue :  */
/* Retour fonction : station inconnue. */
#define TYPAP__C_station_inconnue	301 

/*C C_donnees_vieilles :  */
/* Id message WARNING : "les donnees datent de plus de $date secondes" */
#define TYPAP__C_donnees_vieilles       302

/*C C_donnees_posterieures */
/* Id message WARNING : les donnees sont posterieures a la date souhaitee */
#define TYPAP__C_donnees_posterieures   303

/*C C_pb_init_jdb_compo_ele */
/* Message d'erreur sur pb d'initialisation de la composante et de l'element
   du JDB . */
#define TYPAP__C_pb_init_jdb_compo_ele  310

/*C C_msg_debut_processus */
/* Message de debut de processus */
#define TYPAP__C_msg_debut_processus    501

/*C C_msg_fin_processus */
/* Message de fin de processus */
#define TYPAP__C_msg_fin_processus      502

/*C C_nb_gps_visi_max :  */
/* Nombre maximum de satellites GPS en visibilite d'une 
   station.
    */
#define TYPAP__C_nb_gps_visi_max 15


/*C C_tous_client :  */
/*  nom du client indiquant le traitement de TOUS les clients .
     exemple : un seul envoi de la TAL TA_INTERRUPTION pour tous les clients */
#define TYPAP__C_tous_client "all_cl"

/*C C_lg_nom_client :  */
/* Longueur maximale du nom d'un client */
#define TYPAP__C_lg_nom_client	10

/*C C_lg_nom_composante :  */
/* Longueur maximum du nom d'une composante;
    */
#define TYPAP__C_lg_nom_composante	10

/*C C_prefix_slk :  */
/* Prefixe de la station SLK. */
#define TYPAP__C_prefix_slk	'k'

/*C C_prefix_scl :  */
/* Prefixe de la station SCL. */
#define TYPAP__C_prefix_scl	'a'

/*C C_prefix_slh :  */
/* Prefixe de la station SLH. */
#define TYPAP__C_prefix_slh	'h'

/*C C_lg_nom_station :  */
/* Longueur maximale du nom d'une station */
#define TYPAP__C_lg_nom_station	4

/*C C_nom_slk :  */
/* Nom de la station SLK. */
#define TYPAP__C_nom_slk	"slk"

/*C C_nom_scl :  */
/* Nom de la station SCL. */
#define TYPAP__C_nom_scl	"scl"

/*C C_nom_slh :  */
/* Nom de la station SLH. */
#define TYPAP__C_nom_slh	"slh"

/*C C_lg_nom_couple_station :  */
/* Longueur maximale du nom d'un couple de stations */
#define TYPAP__C_lg_nom_couple_station 3

/*C C_nom_slk_scl :  */
/* Nom du couple de stations SLK-SCL. */
#define TYPAP__C_nom_slk_scl    "ka"
 
/*C C_nom_slh_scl :  */
/* Nom du couple de stations SLH-SCL. */
#define TYPAP__C_nom_slh_scl    "ha"
 
/*C C_nom_slk_slh :  */
/* Nom du couple de stations SLK-SLH. */
#define TYPAP__C_nom_slk_slh    "kh"
 
/*C C_dg_format_1:  */
/* Format pour la construction des noms de variables (hors epoque d'emission) 
   pour les DATAGROUP :
   - MCR_PDGPSSLx_S,
   - MCR_EPHEGPSSLx_S,
*/
#define TYPAP__C_dg_format1	"%c%s%d"

/*C C_dg_format_2:  */
/* Format pour la construction de l'epoque d'emission pour les DATAGROUP :
   - MCR_PDGPSSLx_S,
   - MCR_EPHEGPSSLx_S,
*/
#define TYPAP__C_dg_format2	"%c%s"

/*C C_dg_format_3:  */
/* Format pour la construction des noms de variables 
*/
#define TYPAP__C_dg_format3	"%d%s"

/*C C_dg_format_4:  */
/* Format pour la construction des noms de variables 
*/
#define TYPAP__C_dg_format4	"s%d%s"

/*C C_dg_format_5:  */
/* Format pour la construction des noms de datagroup 
   se presentant sous la forme :
   exemple : CCR_CORECGEOSLx_S,  
*/
#define TYPAP__C_dg_format5	"%s%c_s"

/*C C_dg_format_6:  */
/* Format pour la construction des noms de variables de DATAGROUP
   exemple : SYR_COEFSR_S, SYR_STAT_S, SYR_MFIL_COMP_S
*/
#define TYPAP__C_dg_format6	"%s%s"

/*C C_dg_format_7:  */
/* Format pour la construction des noms de variables de DATAGROUP
   exemple : SYR_COEFSR_S, SYR_STAT_S
*/
#define TYPAP__C_dg_format7	"s%s%s"

/*C C_dg_format_8:  */
/* Format pour la construction de noms de variables
*/
#define TYPAP__C_dg_format8	"%s%d"

/*C C_conv_deg_kelvin */
/* Constante de conversion pour la temperature de degre en Kelvin */
#define TYPAP__C_conv_deg_kelvin  273.16

/*C C_type_antenne_omni */
/* Constante definissant la valeur associee au type d'antenne omnidirectionnelle */
#define TYPAP__C_type_antenne_omni  0

/*C C_type_antenne_dir */
/* Constante definissant la valeur associee au type d'antenne directionnelle */
#define TYPAP__C_type_antenne_dir   1


/*C ELT_NON_RENSEIGNE :  */
/* Macro permettant de definir si un element de tableau (de fichier indexe) */
/* est non renseigne. Le type teste est obligatoirement du double. */
/* Retourne vrai si l'element n'est pas renseigne, faux si l'element est */
/* renseigne */
#define TYPAP__ELT_NON_RENSEIGNE(valeur_double)   (TYCST__T_boolean) (finite(valeur_double) ? TYCST__C_faux : TYCST__C_vrai)

/*C CONV_TGST_COURANT :  */
/* Macro permettant d'obtenir le temps GST courant en fonction du temps */
/* GST fournit par le datagroup TPS_TGNSS_S dans la variable TPSTGST. */
#define TYPAP__CONV_TGST_COURANT(valeur_tgst)   (TYCST__T_real8) (valeur_tgst - 1.0)



/*U Nom des colonnes du fichier index contenant les ephemerides du geostationnaire */
/*U ------------------------------------------------------------------------------ */

/*C C_date_ephe_geo :  */
/* colonne "date" (index) du fichier des ephe du geostationnaire. */
#define TYPAP__C_date_ephe_geo "date_ephe_geo"

/*C C_pos_x_ephe_geo :  */
/* colonne "position en X" du fichier des ephe du geostationnaire. */
#define TYPAP__C_pos_x_ephe_geo "pos_x_ephe_geo"

/*C C_pos_y_ephe_geo :  */
/* colonne "position en Y" du fichier des ephe du geostationnaire. */
#define TYPAP__C_pos_y_ephe_geo "pos_y_ephe_geo"

/*C C_pos_z_ephe_geo :  */
/* colonne "position en Z" du fichier des ephe du geostationnaire. */
#define TYPAP__C_pos_z_ephe_geo "pos_z_ephe_geo"

/*C C_vit_x_ephe_geo :  */
/* colonne "vitesse en X" du fichier des ephe du geostationnaire. */
#define TYPAP__C_vit_x_ephe_geo "vit_x_ephe_geo"

/*C C_vit_y_ephe_geo :  */
/* colonne "vitesse en Y" du fichier des ephe du geostationnaire. */
#define TYPAP__C_vit_y_ephe_geo "vit_y_ephe_geo"

/*C C_vit_z_ephe_geo :  */
/* colonne "vitesse en Z" du fichier des ephe du geostationnaire. */
#define TYPAP__C_vit_z_ephe_geo "vit_z_ephe_geo"

/*C C_acc_x_ephe_geo :  */
/* colonne "acceleration en X" du fichier des ephe du geostationnaire. */
#define TYPAP__C_acc_x_ephe_geo "acc_x_ephe_geo"

/*C C_acc_y_ephe_geo :  */
/* colonne "acceleration en Y" du fichier des ephe du geostationnaire. */
#define TYPAP__C_acc_y_ephe_geo "acc_y_ephe_geo"

/*C C_acc_z_ephe_geo :  */
/* colonne "acceleration en Z" du fichier des ephe du geostationnaire. */
#define TYPAP__C_acc_z_ephe_geo "acc_z_ephe_geo"


/*U Nom des colonnes du fichier index contenant les almanachs du geostationnaire */
/*U ---------------------------------------------------------------------------- */

/*C C_date_alma_geo :  */
/* colonne "date" (index) du fichier des alma du geostationnaire. */
#define TYPAP__C_date_alma_geo "date_alma_geo"

/*C C_pos_x_alma_geo :  */
/* colonne "position en X" du fichier des alma du geostationnaire. */
#define TYPAP__C_pos_x_alma_geo "pos_x_alma_geo"

/*C C_pos_y_alma_geo :  */
/* colonne "position en Y" du fichier des alma du geostationnaire. */
#define TYPAP__C_pos_y_alma_geo "pos_y_alma_geo"

/*C C_pos_z_alma_geo :  */
/* colonne "position en Z" du fichier des alma du geostationnaire. */
#define TYPAP__C_pos_z_alma_geo "pos_z_alma_geo"

/*C C_vit_x_alma_geo :  */
/* colonne "vitesse en X" du fichier des alma du geostationnaire. */
#define TYPAP__C_vit_x_alma_geo "vit_x_alma_geo"

/*C C_vit_y_alma_geo :  */
/* colonne "vitesse en Y" du fichier des alma du geostationnaire. */
#define TYPAP__C_vit_y_alma_geo "vit_y_alma_geo"

/*C C_vit_z_alma_geo :  */
/* colonne "vitesse en Z" du fichier des alma du geostationnaire. */
#define TYPAP__C_vit_z_alma_geo "vit_z_alma_geo"

/* Datagroup TEMPS EURIDIS */
/* ---------------------- */
/*C C_erd_temps :  */
/* Nom du datagroup "TEMPS EURIDIS" */
#define TYPAP__C_erd_tps "erd_tps"

/*C C_tps_machine :  */
/* Nom de la variable temps machine ( temps TU ) */
#define TYPAP__C_tps_machine "tpsmachine"

/*C C_tps_reseau :  */
/* Nom de la variable temps reseau */
#define TYPAP__C_tps_reseau "tpsreseau"

/* Producteur TPS */
/* ______________ */

/* Datagroup TPS_TGNSS_S */
/* --------------------- */

/*C C_tps_tgnss_s :  */
/* Nom du datagroup "temps GNSS" */
#define TYPAP__C_tps_tgnss_s "tps_tgnss_s"

/* Datagroup CTU_TEMPS_TU */
/* --------------------- */

/*C C_ctu_tempstu_s :  */
/* Nom du datagroup "temps GNSS" */
#define TYPAP__C_ctu_tempstu_s "ctu_tempstu_s"

/*C C_tpstgst :  */
/* Nom de la variable temps GNSS diffuse par la boucle longue */
/* sous format temps GST du datagroup TPS_TGNSS_S */
#define TYPAP__C_tpstgst "tpstgst"

/*C C_tpstown1 :  */
/* Nom de la variable de la valeur du TOW(n+1) du datagroup TPS_TGNSS_S */
#define TYPAP__C_tpstown1 "tpstown1"

/*C C_tpswn :  */
/* Nom de la variable de la valeur du WN du datagroup TPS_TGNSS_S */
#define TYPAP__C_tpswn "tpswn"



/* Producteur MCR */
/* ______________ */

/* Datagroup MCR_PDGPDSLx_S */
/* ------------------------ */

/*C C_mcr_pdgpssla_s :  */
/* Nom du datagroup "Pseudo distance GPS corrigee" en visibilite de la SLA */
#define TYPAP__C_mcr_pdgpssla_s "mcr_pdgpssla_s"

/*C C_mcr_pdgpsslh_s :  */
/* Nom du datagroup "Pseudo distance GPS corrigee" en visibilite de la SLH */
#define TYPAP__C_mcr_pdgpsslh_s "mcr_pdgpsslh_s"

/*C C_mcr_pdgpsslk_s :  */
/* Nom du datagroup "Pseudo distance GPS corrigee" en visibilite de la SLK */
#define TYPAP__C_mcr_pdgpsslk_s "mcr_pdgpsslk_s"

/*C C_mcstgst :  */
/* Radical du nom de la variable "epoque GNSS sous format temps GST" */
/* pour le datagroup MCR_PDGPSSLx_S */
#define TYPAP__C_mcstgst "mcstgst"

/*C C_pdc :  */
/* Radical du nom de la variable "pseudo-distance corrigee d'un satellite" */
/* pour le datagroup MCR_PDGPSSLx_S */
#define TYPAP__C_pdc "pdc"


/* Datagroup MCR_PDGEOSLx_S */
/* ------------------------ */

/*C C_mcr_pdgeosla_s :  */
/* Nom du datagroup "Pseudo distance GEO corrigee" en visibilite de la SLA */
#define TYPAP__C_mcr_pdgeosla_s "mcr_pdgeosla_s"

/*C C_mcr_pdgeoslh_s :  */
/* Nom du datagroup "Pseudo distance GEO corrigee" en visibilite de la SLH */
#define TYPAP__C_mcr_pdgeoslh_s "mcr_pdgeoslh_s"

/*C C_mcr_pdgeoslk_s :  */
/* Nom du datagroup "Pseudo distance GEO corrigee" en visibilite de la SLK */
#define TYPAP__C_mcr_pdgeoslk_s "mcr_pdgeoslk_s"

/*C C_mcotgst :  */
/* Radical du nom de la variable "epoque GNSS sous format temps GST" */
/* pour le datagroup MCR_PDGEOSLx_S */
#define TYPAP__C_mcotgst "mcotgst"


/* Datagroup MCR_INFOSLx_S */
/* ----------------------- */

/*C C_mcr_infosla_s :  */
/* Nom du datagroup "information sur les mesures satellites de chaque station de localisation SLA" */
#define TYPAP__C_mcr_infosla_s "mcr_infosla_s"

/*C C_mcr_infoslh_s :  */
/* Nom du datagroup "information sur les mesures satellites de chaque station de localisation SLH" */
#define TYPAP__C_mcr_infoslh_s "mcr_infoslh_s"

/*C C_mcr_infoslk_s :  */
/* Nom du datagroup "information sur les mesures satellites de chaque station de localisation SLK" */
#define TYPAP__C_mcr_infoslk_s "mcr_infoslk_s"

/*C C_mcr_tauxmes :  */
/* Taux de mesures valides du recepteur de collecte des donnees */
#define TYPAP__C_tauxmes 	"tauxmes"

/* Datagroup MCR_EPHEGPSSLx_S */
/* -------------------------- */

/*C C_nb_var_ephem :  */
/* Nombre de variables dans le datagroup "Ephemeride en provenance des SLs" */
#define TYPAP__C_nb_var_ephem 17

/*C C_mcr_ephegpssla_s :  */
/* Nom du datagroup "Ephemeride en provenance de la SLA" */
#define TYPAP__C_mcr_ephegpssla_s "mcr_ephegpssla_s"

/*C C_mcr_ephegpsslh_s :  */
/* Nom du datagroup "Ephemeride en provenance de la SLH" */
#define TYPAP__C_mcr_ephegpsslh_s "mcr_ephegpsslh_s"

/*C C_mcr_ephegpsslk_s :  */
/* Nom du datagroup "Ephemeride en provenance de la SLK" */
#define TYPAP__C_mcr_ephegpsslk_s "mcr_ephegpsslk_s"

/*C C_toetgst :  */
/* Radical du nom de la variable "epoque GNSS sous format temps GST" */
/* pour le datagroup MCR_EPHEGPSSLx_S */
#define TYPAP__C_toetgst "toetgst"

/*C C_iode :  */
/* Radical du nom de la variable "terme iode" */
/* pour le datagroup MCR_EPHEGPSSLx_S */
#define TYPAP__C_iode "iode"

/*C C_crs :  */
/* Radical du nom de la variable "terme crs" */
/* pour le datagroup MCR_EPHEGPSSLx_S */
#define TYPAP__C_crs "crs"

/*C C_deltn :  */
/* Radical du nom de la variable "terme deltn" */
/* pour le datagroup MCR_EPHEGPSSLx_S */
#define TYPAP__C_deltn "deltn"

/*C C_m0 :  */
/* Radical du nom de la variable "terme m0" */
/* pour le datagroup MCR_EPHEGPSSLx_S */
#define TYPAP__C_m0 "m0"

/*C C_cuc :  */
/* Radical du nom de la variable "terme cuc" */
/* pour le datagroup MCR_EPHEGPSSLx_S */
#define TYPAP__C_cuc "cuc"

/*C C_exc :  */
/* Radical du nom de la variable "terme exc" */
/* pour le datagroup MCR_EPHEGPSSLx_S */
#define TYPAP__C_exc "exc"

/*C C_cus :  */
/* Radical du nom de la variable "terme cus" */
/* pour le datagroup MCR_EPHEGPSSLx_S */
#define TYPAP__C_cus "cus"

/*C C_ademi :  */
/* Radical du nom de la variable "terme ademi" */
/* pour le datagroup MCR_EPHEGPSSLx_S */
#define TYPAP__C_ademi "ademi"

/*C C_cic :  */
/* Radical du nom de la variable "terme cic" */
/* pour le datagroup MCR_EPHEGPSSLx_S */
#define TYPAP__C_cic "cic"

/*C C_lonod :  */
/* Radical du nom de la variable "terme lonod" */
/* pour le datagroup MCR_EPHEGPSSLx_S */
#define TYPAP__C_lonod "lonod"

/*C C_cis :  */
/* Radical du nom de la variable "terme cis" */
/* pour le datagroup MCR_EPHEGPSSLx_S */
#define TYPAP__C_cis "cis"

/*C C_i0 :  */
/* Radical du nom de la variable "terme i0" */
/* pour le datagroup MCR_EPHEGPSSLx_S */
#define TYPAP__C_i0 "i0"

/*C C_crc :  */
/* Radical du nom de la variable "terme crc" */
/* pour le datagroup MCR_EPHEGPSSLx_S */
#define TYPAP__C_crc "crc"

/*C C_perig :  */
/* Radical du nom de la variable "terme perig" */
/* pour le datagroup MCR_EPHEGPSSLx_S */
#define TYPAP__C_perig "perig"

/*C C_omeg :  */
/* Radical du nom de la variable "terme omeg" */
/* pour le datagroup MCR_EPHEGPSSLx_S */
#define TYPAP__C_omeg "omeg"

/*C C_idot :  */
/* Radical du nom de la variable "terme idot" */
/* pour le datagroup MCR_EPHEGPSSLx_S */
#define TYPAP__C_idot "idot"


/* Datagroup MCR_CALIONOSLx_S */
/* -------------------------- */

/*C C_mcr_calionosla_s :  */
/* Nom du datagroup "Donnees du calibrateur iono" en visibilite de la SLA */
#define TYPAP__C_mcr_calionosla_s "mcr_calionosla_s"

/*C C_mcr_calionoslk_s :  */
/* Nom du datagroup "Donnees du calibrateur iono" en visibilite de la SLK */
#define TYPAP__C_mcr_calionoslk_s "mcr_calionoslk_s"

/*C C_mcr_calionoslh_s :  */
/* Nom du datagroup "Donnees du calibrateur iono" en visibilite de la SLH */
#define TYPAP__C_mcr_calionoslh_s "mcr_calionoslh_s"

/*C C_iontgst :  */
/* Radical du nom de la variable "epoque GNSS, sous format temps GST" */
/* pour le datagroup MCR_CALIONOSLx_S */
#define TYPAP__C_iontgst "iontgst"

/*C C_mangel :  */
/* Radical du nom de la variable "angle d'elevation" */
/* pour le datagroup MCR_CALIONOSLx_S */
#define TYPAP__C_mangel "mangel"

/*C C_ml1mes :  */
/* Radical du nom de la variable "mesure bande L1" */
/* pour le datagroup MCR_CALIONOSLx_S */
#define TYPAP__C_ml1mes "ml1mes"

/*C C_ml1qal :  */
/* Radical du nom de la variable "indicateur de la qualite */
/* de la mesure bande L1" pour le datagroup MCR_CALIONOSLx_S */
#define TYPAP__C_ml1qal "ml1qal"

/*C C_ml2mes :  */
/* Radical du nom de la variable "mesure bande L2" */
/* pour le datagroup MCR_CALIONOSLx_S */
#define TYPAP__C_ml2mes "ml2mes"

/*C C_ml2qal :  */
/* Radical du nom de la variable "indicateur de la qualite */
/* de la mesure bande L2" pour le datagroup MCR_CALIONOSLx_S */
#define TYPAP__C_ml2qal "ml2qal"


/* Datagroup MCR_DMETEOSLx_S */
/* -------------------------- */

/*C C_mcr_dmeteosla_s :  */
/* Nom du datagroup "Donnees de la station meteo" en visibilite de la SLA */
#define TYPAP__C_mcr_dmeteosla_s "mcr_dmeteosla_s"

/*C C_mcr_dmeteoslh_s :  */
/* Nom du datagroup "Donnees de la station meteo" en visibilite de la SLH */
#define TYPAP__C_mcr_dmeteoslh_s "mcr_dmeteoslh_s"

/*C C_mcr_dmeteoslk_s :  */
/* Nom du datagroup "Donnees de la station meteo" en visibilite de la SLK */
#define TYPAP__C_mcr_dmeteoslk_s "mcr_dmeteoslk_s"

/*C C_mtotgst :  */
/* Radical du nom de la variable "epoque GNSS, sous format temps GST" */
/* pour le datagroup MCR_DMETEOSLx_S */
#define TYPAP__C_mtotgst "mtotgst"

/*C C_mpress :  */
/* Radical du nom de la variable "pression" */
/* pour le datagroup MCR_DMETEOSLx_S */
#define TYPAP__C_mpress "mpress"

/*C C_mtemp :  */
/* Radical du nom de la variable "temperature" */
/* pour le datagroup MCR_DMETEOSLx_S */
#define TYPAP__C_mtemp "mtemp"

/*C C_mhumid :  */
/* Radical du nom de la variable "humidite" */
/* pour le datagroup MCR_DMETEOSLx_S */
#define TYPAP__C_mhumid "mhumid"

/* Datagroup MCR_INNOVA_S */
/* ---------------------- */

/*C C_mcr_innova_s :  */
/* Nom du datagroup "Innovations corrigees des GPS et GEO de la SCL" */
#define TYPAP__C_mcr_innova_s "mcr_innova_s"

/*C C_mcritgst :  */
/* Nom de la variable "epoque d'emission sous format TGST" */
/* pour le datagroup MCR_INNOVA_S */
#define TYPAP__C_mcritgst "mcritgst"

/*C C_inno :  */
/* Radical du nom de la variable "innovation du satellite de numero <prn>" */
/* pour le datagroup MCR_INNOVA_S */
#define TYPAP__C_inno "inno"

/* Datagroup MCR_SANTEARCH_S */
/* ------------------------- */

/*C C_mcr_santearch_s :  */
/* Nom du datagroup "Etat de sante du satellite archive */
#define TYPAP__C_mcr_santearch_s	"mcr_santearch_s"

/*C C_etagps :  */
/* Etat de sante du satellite GPS de no <prn> obtenu par un ephemeride recu a la station <x> */
#define TYPAP__C_etagps		"etagps"

/* Datagroup MCR_QUALARCH_S */
/* ------------------------- */

/*C C_mcr_qualarch_s :  */
/* Nom du datagroup "Status de qualite des mesures GPS et GEO archives" */
#define TYPAP__C_mcr_qualarch_s		"mcr_qualarch_s"

/*C C_cn0s :  */
/* Rapport C/N0 d'un GPS */
#define	TYPAP__C_cn0s	"cn0s"

/*C C_gcps :  */
/* Glissement d'un GPS */
#define	TYPAP__C_gcps	"gcps"

/*C C_tems :  */
/* TEM d'un GPS */
#define	TYPAP__C_tems	"tems"

/*C C_toss :  */
/* TOSC d'un GPS */
#define	TYPAP__C_toss	"toss"

/*C C_toms :  */
/* TOMA d'un GPS */
#define	TYPAP__C_toms	"toms"

/*C C_cn0o :  */
/* Rapport C/N0 d'un GEO */
#define	TYPAP__C_cn0o	"cn0o"

/*C C_cn0o :  */
/* Rapport C/N0 d'un GEO */
#define	TYPAP__C_cn0o	"cn0o"

/*C C_gcpo :  */
/* Glissement d'un GEO */
#define	TYPAP__C_gcpo	"gcpo"

/*C C_iemo :  */
/* Iem d'un GEO */
#define	TYPAP__C_iemo	"iemo"

/*C C_toso :  */
/* Tosc d'un GEO */
#define	TYPAP__C_toso	"toso"

/*C C_frqgo :  */
/* Frequence du spectre GEO */
#define	TYPAP__C_frqgo	"frqgo"

/*C C_qalgo :  */
/* Rapport S/B (qualite du spectre niveau) GEO */
#define	TYPAP__C_qalgo	"qalgo"

/*C C_bandgo :  */
/* Indicateur de largeur de bande brouillee GEO */
#define	TYPAP__C_bandgo	"bandgo"

/* Producteur CCR */
/* ______________ */

/* Datagroup CCR_CORECGPSSLx_S */
/* --------------------------- */

/*C C_ccr_corecgpssl :  */
/* Radical du nom du datagroup "coefficients de correction pour les GPS" */
#define TYPAP__C_ccr_corecgpssl "ccr_corecgpssl"

/*C C_ccr_corecgpssla_s :  */
/* Nom du datagroup "coefficients de correction pour les GPS" pour la SLA */
#define TYPAP__C_ccr_corecgpssla_s "ccr_corecgpssla_s"

/*C C_ccr_corecgpsslh_s :  */
/* Nom du datagroup "coefficients de correction pour les GPS" pour la SLH */
#define TYPAP__C_ccr_corecgpsslh_s "ccr_corecgpsslh_s"

/*C C_ccr_corecgpsslk_s :  */
/* Nom du datagroup "coefficients de correction pour les GPS" pour la SLK */
#define TYPAP__C_ccr_corecgpsslk_s "ccr_corecgpsslk_s"

/*C C_coefc :  */
/* Radical du nom de la variable "coefficient de correction global valide" */
/* pour le datagroup CCR_CORECGPSSLx_S */
#define TYPAP__C_coefc "coefc"

/*C C_dtfin :  */
/* Radical du nom de la variable "date fin d'applicabilite sous format GST" */
/* pour le datagroup CCR_CORECGPSSLx_S */
#define TYPAP__C_dtfin "dtfin"

/*C C_nbsatel :  */
/* Radical du nom de la variable "nb de satellite GPS en vue du calib iono" */
/* pour le datagroup CCR_CORECGPSSLx_S */
#define TYPAP__C_nbsatel "nbsatel"


/* Datagroup CCR_CORECGEOSLx_S */
/* --------------------------- */

/*C C_ccr_corecgeosl :  */
/* Radical du nom du datagroup "coefficients de correction pour le GEO" */
#define TYPAP__C_ccr_corecgeosl "ccr_corecgeosl"

/*C C_ccr_corecgeosla_s :  */
/* Nom du datagroup "coefficients de correction pour le GEO" pour la SLA */
#define TYPAP__C_ccr_corecgeosla_s "ccr_corecgeosla_s"

/*C C_ccr_corecgeoslh_s :  */
/* Nom du datagroup "coefficients de correction pour le GEO" pour la SLH */
#define TYPAP__C_ccr_corecgeoslh_s "ccr_corecgeoslh_s"

/*C C_ccr_corecgeoslk_s :  */
/* Nom du datagroup "coefficients de correction pour le GEO" pour la SLK */
#define TYPAP__C_ccr_corecgeoslk_s "ccr_corecgeoslk_s"

/*C C_coefcgo :  */
/* Radical du nom de la variable "coefficient de correction global valide" */
/* pour le datagroup CCR_CORECGPSSLx_S */
#define TYPAP__C_coefcgo "coefcgo"

/*C C_datfgeo :  */
/* Radical du nom de la variable "date fin d'applicabilite sous format GST" */
/* pour le datagroup CCR_CORECGPSSLx_S */
#define TYPAP__C_datfgeo "datfgeo"



/* Datagroup CCR_CIONOSLx_S */
/* ------------------------ */

/*C C_ccr_cionosl :  */
/* Radical du nom du datagroup "coefficients de correction iono" */
#define TYPAP__C_ccr_cionosl "ccr_cionosl"

/*C C_ccr_cionosla_s :  */
/* Nom du datagroup "coefficients de correction iono" pour la SLA */
#define TYPAP__C_ccr_cionosla_s "ccr_cionosla_s"

/*C C_ccr_cionoslh_s :  */
/* Nom du datagroup "coefficients de correction iono" pour la SLH */
#define TYPAP__C_ccr_cionoslh_s "ccr_cionoslh_s"

/*C C_ccr_cionoslk_s :  */
/* Nom du datagroup "coefficients de correction iono" pour la SLK */
#define TYPAP__C_ccr_cionoslk_s "ccr_cionoslk_s"

/*C C_ciono :  */
/* Radical du nom de la variable "coefficient de correction iono pour le GPS */
/* de numero prn" pour le datagroup CCR_CIONOSLx_S */
#define TYPAP__C_ciono "ciono"

/*C C_cionogo :  */
/* Radical du nom de la variable "coefficient de correction iono pour le GEO"*/
/* pour le datagroup CCR_CIONOSLx_S */
#define TYPAP__C_cionogo "cionogo"

/*C C_datasso :  */
/* Radical du nom de la variable "date associee aux coefficients de correction*/
/* iono" pour le datagroup CCR_CIONOSLx_S */
#define TYPAP__C_datasso "datasso"



/* Producteur SYA */
/* ______________ */

/* Datagroup SYA_ETGNSSTU_S */
/* ------------------------ */

/*C C_sya_etgnsstu_s :  */
/* Nom du datagroup "ecart de temps entre temps gnss et temps utc et modele */
/* entre temps TGEO_O et TGNSS */
#define TYPAP__C_sya_etgnsstu_s "sya_etgnsstu_s"

/*C C_dateref :  */
/* Nom de la variable "date de reference de l'ecart de temps et des coeff */
/* du modele" pour le datagroup SYA_ETGNSSTU_S */
#define TYPAP__C_dateref "syaetgst"

/*C C_deltat :  */
/* Nom de la variable "ecart de temps entre le temps GNSS et le temps */
/* standard utc" pour le datagroup SYA_ETGNSSTU_S */
#define TYPAP__C_deltat "deltat"

/*C C_validdel :  */
/* Nom de la variable "validite de l'ecart de temps" */
/* pour le datagroup SYA_ETGNSSTU_S */
#define TYPAP__C_validdel "validdel"

/*C C_ageof0 :  */
/* Nom de la variable "coefficient arangf0 du modele affine de derive" */
/* Tranging/TGNSS pour le datagroup SYA_ETGNSSTU_S */
#define TYPAP__C_ageof0 "arangf0"

/*C C_ageof1 :  */
/* Nom de la variable "coefficient arangf1 du modele affine de derive" */
/* Tranging/TGNSS pour le datagroup SYA_ETGNSSTU_S */
#define TYPAP__C_ageof1 "arangf1"

/*C C_validgeo :  */
/* Nom de la variable "validite des coefficients du modele" */
/* pour le datagroup SYA_ETGNSSTU_S */
#define TYPAP__C_validgeo "validran"


/* Datagroup SYA_STAT_S */
/* -------------------- */

/*C C_sya_stat_s :  */
/* Nom du datagroup "statistiques de surveillance et autres infos" */
#define TYPAP__C_sya_stat_s "sya_stat_s"

/*C C_datappli :  */
/* Nom de la variable "date d'applicabilite (au format TGST) des coefficients */
/* fournis par SYA" pour le datagroup SYA_STAT_S */
#define TYPAP__C_datappli "datappli"

/*C C_agf0 :  */
/* Nom de la variable "coef agf0 du modele de derive entre TGPSO et TGNSS" */
/* pour le datagroup SYA_STAT_S */
#define TYPAP__C_agf0 "agf0"

/*C C_agf1 :  */
/* Nom de la variable "coef agf1 du modele de derive entre TGPSO et TGNSS" */
/* pour le datagroup SYA_STAT_S */
#define TYPAP__C_agf1 "agf1"

/*C C_sgpsgnss :  */
/* Nom de la variable "ecart type associe au modele de derive entre TGPSO et */
/* TGNSS" pour le datagroup SYA_STAT_S */
#define TYPAP__C_sgpsgnss "sgpsgnss"

/*C C_validgps :  */
/* Nom de la variable "validite de agf0, agf1 et sgpsgnss" */
/* pour le datagroup SYA_STAT_S */
#define TYPAP__C_validgps "validgps"

/*C C_agof0 :  */
/* Nom de la variable "coef ageof0 du modele de derive entre TGEO_O et TGNSS" */
/* pour le datagroup SYA_STAT_S */
#define TYPAP__C_agof0 "agof0"

/*C C_agof1 :  */
/* Nom de la variable "coef ageof1 du modele de derive entre TGEO_O et TGNSS" */
/* pour le datagroup SYA_STAT_S */
#define TYPAP__C_agof1 "agof1"

/*C C_sgeognss :  */
/* Nom de la variable "ecart type associe au modele de derive entre TGEO_O et */
/* TGNSS" pour le datagroup SYA_STAT_S */
#define TYPAP__C_sgeognss "sgeognss"

/*C C_validgeo :  */
/* Nom de la variable "validite de agof0, agof1 et sgeognss" */
/* pour le datagroup SYA_STAT_S */
#define TYPAP__C_validitegeo "validgeo"

/*C C_sgpsgeo :  */
/* Nom de la variable "ecart type associe au modele de derive entre TGPS_O et */
/* TGEO_O" pour le datagroup SYA_STAT_S */
#define TYPAP__C_sgpsgeo "sgpsgeo"

/*C C_mgpsgeo :  */
/* Nom de la variable "moyenne des residus associe au modele de derive entre */
/* TGPS_O et TGEO_O" pour le datagroup SYA_STAT_S */
#define TYPAP__C_mgpsgeo "mgpsgeo"

/*C C_validgg :  */
/* Nom de la variable "validite de sgpsgeo" */
/* pour le datagroup SYA_STAT_S */
#define TYPAP__C_validgg "validgg"

/*C C_tauxgps :  */
/* Nom de la variable "taux de mesures valides GPS considere par la SYA" */
/* pour le datagroup SYA_STAT_S */
#define TYPAP__C_tauxgps "tauxgps"

/*C C_tauxgeo :  */
/* Nom de la variable "taux de mesures valides GEO considere par la SYA" */
/* pour le datagroup SYA_STAT_S */
#define TYPAP__C_tauxgeo "tauxgeo"

/*C C_nbgpsmoy :  */
/* Nom de la variable "nombre de satellite GPS considere par la SYA en */
/* moyenne sue 2 heures */
/* pour le datagroup SYA_STAT_S */
#define TYPAP__C_nbgpsmoy "nbgpsmoy"


/* Datagroup SYA_COEFBLG_S */
/* ----------------------- */

/*C C_sya_coefblg_s :  */
/* Nom du datagroup "consigne de vitesse pour la BLG" */
#define TYPAP__C_sya_coefblg_s "sya_coefblg_s"

/*C C_appltgst :  */
/* Nom de la variable "date d'applicabilite des coefficients a0 et a1 de la */
/* formule de la consigne en position pour la BLG sous format temps GST */
/* pour le datagroup SYA_COEFBLG_S */
#define TYPAP__C_appltgst "appltgst"

/*C C_a0consig :  */
/* Nom de la variable coefficient a0 de la formule de la consigne en position*/
/* pour la BLG pour le datagroup SYA_COEFBLG_S */
#define TYPAP__C_a0consig "a0consig"

/*C C_a1consig :  */
/* Nom de la variable coefficient a1 de la formule de la consigne en position*/
/* pour la BLG pour le datagroup SYA_COEFBLG_S */
#define TYPAP__C_a1consig "a1consig"

/*C C_modecons :  */
/* Nom de la variable mode caracteristique des coefficients a0 et a1 */
/* 2 modes possibles : */
/* 0 : a0, a1 correspondant a la prise en compte des GPS seuls */
/* 1 : a0, a1 correspondant a la prise en compte des GPS et du GEO */
/* pour le datagroup SYA_COEFBLG_S */
#define TYPAP__C_modecons "modecons"


/* Datagroup SYA_BCOEFSQM_S */
/* ------------------------ */

/*C C_sya_bcoefsqm_s :  */
/* Nom du datagroup "identification des coeff pour le message type 9" */
#define TYPAP__C_sya_bcoefsqm_s "sya_bcoefsqm_s"

/*C C_fichcsya :  */
/* Nom de la variable "Nom du fichier de coeff pour le message type 9"*/
/* pour le datagroup SYA_BCOEFSQM_S */
#define TYPAP__C_fichcsya "fichcsya"

/*C C_dat1coef :  */
/* Nom de la variable "Date du 1er coeff se trouvant dans le fichier de */
/* coeff (au format temps GST) */
/* pour le datagroup SYA_BCOEFSQM_S */
#define TYPAP__C_dat1coef "dat1coef"


/* Datagroup SYA_MFILCOMP_S */
/* ------------------------ */

/*C C_sya_mfilcomp_s :  */
/* Nom du datagroup "Innovations" */
#define TYPAP__C_sya_mfilcomp_s "sya_mfilcomp_s"

/*C C_syaitgst :  */
/* Nom de la variable "temps relatif aux innovations (au format TGST)"*/
/* pour le datagroup SYA_MFILCOMP_S */
#define TYPAP__C_syaitgst "syaitgst"

/*C C_ordmi :  */
/* Radical du nom de la variable "valeur de l'ordonnee milieu pour le satellite numero <prn>"*/
/* pour le datagroup SYA_MFILCOMP_S */
#define TYPAP__C_ordmi "ordmi"

/*C C_ecaty :  */
/* Radical du nom de la variable "valeur de l'ecart type associe a l'ordonnee */
/* milieu pour le satellite numero <prn>" */
/* pour le datagroup SYA_MFILCOMP_S */
#define TYPAP__C_ecaty "ecaty"

/*C C_valoe :  */
/* Radical du nom de la variable "validite de l'ecart type et ordonnee milieu */
/* milieu pour le satellite numero <prn>" */
/* pour le datagroup SYA_MFILCOMP_S */
#define TYPAP__C_valoe "valoe"




/*C C_syr_coefsr_s :  */
/* Nom du datagroup "Coefficients de la synchronisation relative" en sortie
    de la synchronisation relative.
    */
#define TYPAP__C_syr_coefsr_s		"syr_coefsr_s"

/*C C_syr_stat_s :  */
/* Nom du datagroup "Statistiques de la synchronisation relative" en sortie
    de la synchronisation relative. */
#define TYPAP__C_syr_stat_s		"syr_stat_s"

/*C C_syr_mfil_comp_s :  */
/* Nom du datagroup "Mesures filtrees compactees de la synchronisation relative"
    en sortie de la synchronisation relative. */
#define TYPAP__C_syr_mfil_comp_s		"syr_mfil_comp_s"

/*C C_syr_coefsr_tgst :  */
/* Nom variable "temps GNSS" pour DATAGROUP SYR_COEFSR_S. */
#define TYPAP__C_syr_coefsr_tgst		"syrctgst"

/*C C_syr_coefsr_coef1 :  */
/* Nom variable "coefficient 'a' de la synchro. relative" pour DATAGROUP SYR_COEFSR_S. */
#define TYPAP__C_syr_coefsr_coef1	"coefsr1"

/*C C_syr_coefsr_coef2 :  */
/* Nom variable "coefficient 'b' de la synchro. relative" pour DATAGROUP SYR_COEFSR_S */
#define TYPAP__C_syr_coefsr_coef2	"coefsr2"

/*C C_syr_coefsr_scoef :  */
/* Nom variable "indicateur de validite des coefficients" pour DATAGROUP SYR_COEFSR_S. */
#define TYPAP__C_syr_coefsr_scoef	"coefsr"

/*C C_syr_stat_tgst :  */
/* Nom variable "temps GNSS" pour DATAGROUP SYR_STAT_S. */
#define TYPAP__C_syr_stat_tgst	"syrstgst"

/*C C_syr_stat_moyarc :  */
/* Nom variable "moyenne des residus sur l'arc complet" pour DATAGROUP SYR_STAT_S. */
#define TYPAP__C_syr_stat_moyarc		"moyarc"

/*C C_syr_stat_s_moyarc :  */
/* Nom variable "indicateur de depassement de la moyenne moyarc" pour DATAGROUP
    SYR_STAT_S. */
#define TYPAP__C_syr_stat_s_moyarc		"moyarc"

/*C C_syr_stat_moyder :  */
/* Nom variable "moyenne des residus sur l'arc partiel" pour DATAGROUP SYR_STAT_S. */
#define TYPAP__C_syr_stat_moyder		"moyder"

/*C C_syr_stat_s_moyder :  */
/* Nom variable "indicateur de depassement de la moyenne moyder" pour DATAGROUP
    SYR_STAT_S. */
#define TYPAP__C_syr_stat_s_moyder		"moyder"

/*C C_syr_stat_etarc :  */
/* Nom variable "ecart type des residus sur l'arc complet" pour DATAGROUP
    SYR_STAT_S. */
#define TYPAP__C_syr_stat_etarc		"etarc"

/*C C_syr_stat_s_etarc :  */
/* Nom variable "indicateur de depassement de l'ecart type etarc" pour DATAGROUP
    SYR_STAT_S. */
#define TYPAP__C_syr_stat_s_etarc		"etarc"

/*C C_syr_stat_etder :  */
/* Nom variable "ecart type des residus sur l'arc partiel" pour DATAGROUP
    SYR_STAT_S. */
#define TYPAP__C_syr_stat_etder		"etder"

/*C C_syr_stat_s_etder :  */
/* Nom variable "indicateur de depassement de l'ecart type etder" pour DATAGROUP
SYR_STAT_S. */
#define TYPAP__C_syr_stat_s_etder		"etder"

/*C C_syr_stat_taux :  */
/* Nom variable "taux de mesures utilisees" pour DATAGROUP SYR_STAT_S. */
#define TYPAP__C_syr_stat_taux		"tauxme"

/*C C_syr_stat_scoef :  */
/* Nom variable "indicateur de validite des coefficients" pour DATAGROUP SYR_STAT_S. */
#define TYPAP__C_syr_stat_scoef	"coef"

/*C C_syr_mfil_tgst :  */
/* Nom variable "temps GNSS" pour DATAGROUP SYR_MFIL_COMP_S. */
#define TYPAP__C_syr_mfil_tgst	"syrmtgst"

/*C C_syr_mfil_messync :  */
/* Nom variable "mesure filtree" pour DATAGROUP SYR_MFIL_COMP_S. */
#define TYPAP__C_syr_mfil_messync	"messync"

/*C C_syr_mfil_metarc :  */
/* Nom variable "ecart type des residus" pour DATAGROUP SYR_MFIL_COMP_S. */
#define TYPAP__C_syr_mfil_metarc	"metarc"



/* Producteur ORB */
/* ______________ */

/* Datagroup C_orb_stat_s */
/* ---------------------- */
/*C C_orb_stat_s :  */
/* Nom du datagroup "etat operationnel de l'orbitographie".
    (producteur ORB)*/
#define TYPAP__C_orb_stat_s "orb_stat_s"



/* Datagroup C_orb_btrageo_s */
/* ------------------------- */
/*C C_orb_btrageo_s :  */
/* Nom du datagroup indiquant la disponibilite des ephe/alma du geo.
    (producteur ORB) */
#define TYPAP__C_orb_btrageo_s "orb_btrageo_s"



/*C C_orbo_date :  */
/* Nom de la variable date d'activation pour l'orbitographie du geo.
    */
#define TYPAP__C_orbo_date "orbo_date"



/*C C_id_geo :  */
/* Nom de la variable id geostationnaire pour l'orbito du geo.
    */
#define TYPAP__C_id_geo "id_geo"



/*C C_valid :  */
/* Nom de la variable indicateur de validite pour l'orbito du geo.
    */
#define TYPAP__C_valid "valid"



/*C C_moy_nvl :  */
/* Nom de la variable moyenne residus sur nvles pd pour l'orbito du geo.
    */
#define TYPAP__C_moy_nvl "moy_nvl"



/*C C_ect_nvl :  */
/* Nom de la variable ecart-type residus sur nvles pd pour l'orbito.
    */
#define TYPAP__C_ect_nvl "ect_nvl"



/*C C_moy_arc :  */
/* Nom de la variable moyenne residus sur arc pour l'orbito du geo.
    */
#define TYPAP__C_moy_arc "moy_arc"



/*C C_ect_arc :  */
/* Nom de la variable ecart-type residus sur arc pour l'orbito du geo.
    */
#define TYPAP__C_ect_arc "ect_arc"



/*C C_long_geo :  */
/* Nom de la variable longitude du geo pour l'orbito du geo.
    */
#define TYPAP__C_long_geo "long_geo"



/*C C_lat_geo :  */
/* Nom de la variable latitude du geo pour l'orbito du geo.
    */
#define TYPAP__C_lat_geo "lat_geo"



/*C C_util_slk :  */
/* Nom de la variable taux de mesures utiles dans SLK pour l'orbito du geo
    */
#define TYPAP__C_util_slk "util_slk"



/*C C_util_slh :  */
/* Nom de la variable taux de mesures utiles dans SLH pour l'orbito du geo
    */
#define TYPAP__C_util_slh "util_slh"



/*C C_util_slc :  */
/* Nom de la variable taux de mesures utiles dans SLC pour l'orbito du geo
    */
#define TYPAP__C_util_slc "util_slc"



/*C C_tpg_cug :  */
/* Nom de la variable meconnaissance du TPG_CUG pour l'orbito du geo.
    */
#define TYPAP__C_tpg_cug "tpg_cug"



/*C C_valid_tpg :  */
/* Nom de la variable indicateur de validite sur la meconnaissance du TPG_CUG
    pour l'orbito du geo.
    */
#define TYPAP__C_valid_tpg "valid_tpg"



/*C C_date_restit :  */
/* Nom de la variable date du bulletin d'orbite restitue pour l'orbito du
    geo
    */
#define TYPAP__C_date_restit "date_restit"



/*C C_pos_x :  */
/* Nom de la variable position en X du geo pour l'orbito du geo
    */
#define TYPAP__C_pos_x "pos_x"



/*C C_pos_y :  */
/* Nom de la variable position en Y du geo pour l'orbito du geo
    */
#define TYPAP__C_pos_y "pos_y"



/*C C_fic_ephem :  */
/* Nom de la variable contenant le nom du fic des ephe genere par l'orbito
    du geo
    */
#define TYPAP__C_fic_ephem "fic_ephem"



/*C C_date_ephem :  */
/* Nom de la variable contenant la date de generation des ephe du geo
    */
#define TYPAP__C_date_ephem "date_ephem"



/*C C_fic_alma :  */
/* Nom de la variable contenant le nom du fic des alma genere par l'orbito
    du geo
    */
#define TYPAP__C_fic_alma "fic_alma"



/*C C_date_alma :  */
/* Nom de la variable contenant la date de generation des alma du geo
    */
#define TYPAP__C_date_alma "date_alma"



/*C C_pos_z :  */
/* Nom de la variable position en Z du geo pour l'orbito du geo
    */
#define TYPAP__C_pos_z "pos_z"


/*C C_acc_x :  */
/* Nom de la variable acceleration en X du geo pour l'orbito du geo
    */
#define TYPAP__C_acc_x "acc_x"



/*C C_acc_y :  */
/* Nom de la variable acceleration en Y du geo pour l'orbito du geo
    */
#define TYPAP__C_acc_y "acc_y"



/*C C_acc_z :  */
/* Nom de la variable acceleration en Z du geo pour l'orbito du geo
    */
#define TYPAP__C_acc_z "acc_z"



/*C C_orbe_date :  */
/* Nom de la variable contenant la date de mise a disposition des ephe/alma
    generes par l'orbito du geo
    */
#define TYPAP__C_orbe_date "orbe_date"



/*C C_vit_y :  */
/* Nom de la variable vitesse en Y du geo pour l'orbito du geo
    */
#define TYPAP__C_vit_y "vit_y"



/*C C_vit_x :  */
/* Nom de la variable vitesse en X du geo pour l'orbito du geo
    */
#define TYPAP__C_vit_x "vit_x"



/*C C_vit_z :  */
/* Nom de la variable vitesse en Z du geo pour l'orbito du geo
    */
#define TYPAP__C_vit_z "vit_z"


/*C C_jdb_msgmiss_e :  */
/* Nom du datagroup message controle  en entree
    du JDB. */
#define TYPAP__C_jdb_controle_e		"jdb_controle_e"

/*C C_jdb_update_mission :  */
/* Variable indiquant s'il faut mettre a jour le JDB mission . */
#define TYPAP__C_jdb_update_mission	"jdb_update_mission"

/*C C_jdb_update_techno :  */
/* Variable indiquant s'il faut mettre a jour le JDB techno . */
#define TYPAP__C_jdb_update_techno	"jdb_update_techno"

/*C C_jdb_msgmiss_e :  */
/* Nom du datagroup "message JdB surveillance mission" en entree
    du JDB. */
#define TYPAP__C_jdb_msgmiss_e		"jdb_msgmiss_e"

/*C C_jdb_msgtech_e :  */
/* Nom du datagroup "message JdB surveillance technologique" en entree
    du JDB. */
#define TYPAP__C_jdb_msgtech_e		"jdb_msgtech_e"


/* Producteur IEXA */
/* ______________ */

/* Datagroup IEX_EPHELUNE_S */
/* ------------------------ */

/*C C_iex_ephelune_s :  */
/* Nom du datagroup "ephemerides de la lune" */
#define TYPAP__C_iex_ephelune_s "iex_ephelune_s"

/* Datagroup IEX_MPOLEIERS_S */
/* ------------------------ */

/*C C_iex_mpoleiers_s :  */
/* Nom du datagroup "donnees IERS" */
#define TYPAP__C_iex_mpoleiers "iex_mpoleiers_s"

/* Datagroup IEX_EPHSOLU_S */
/* ------------------------ */

/*C C_iex_ephsolu_s :  */
/* Nom du datagroup "donnees ephemerides soleil/lune IERS" */
#define TYPAP__C_iex_ephsolu "iex_ephsolu_s"

/* Datagroup IEX_WOLFOBM_S */
/* ------------------------ */

/*C C_iex_wolfobm_s :  */
/* Nom du datagroup "nombre de taches solaires" */
#define TYPAP__C_iex_wolfobms "iex_wolfobm_s"

/* Datagroup IEX_ASOLOBM_S */
/* ------------------------ */

/*C C_iex_asolobm_s :  */
/* Nom du datagroup "bulletin quotidien" */
#define TYPAP__C_iex_asolobms "iex_asolobm_s"

/* Datagroup IEX_BMCCS_S */
/* ------------------------ */

/*C C_iex_bmccs_s :  */
/* Nom du datagroup "bulletin de manoeuvre CCS" */
#define TYPAP__C_iex_bmccs_ "iex_bmccs_s"

/*C C_epqgnss :  */
/* Instant de demarrage de la manoeuvre. */
#define TYPAP__C_epqgnss "iextgst"

/*C C_epqtugnss :  */
/* Instant de demarrage de la manoeuvre. */
#define TYPAP__C_epqtugnss "iextu"

/*C C_numanvr :  */
/* Numero de la manoeuvre. */
#define TYPAP__C_numanvr "numanvr"


/*C C_dirmanvr :  */
/* Direction de la manoeuvre. */
#define TYPAP__C_dirmanvr "dirmanvr"

/*C C_tpsmanvr :  */
/* Duree de la manoeuvre. */
#define TYPAP__C_tpsmanvr "tpsmanvr"

/*C C_prevtang :  */
/* Prevision de la vitesse tangentielle. */
#define TYPAP__C_prevtang "prevtang"

/*C C_prevnorm :  */
/* Prevision de la vitesse normal. */
#define TYPAP__C_prevnorm "prevnorm"

/*C C_prevrad :  */
/* Prevision de la vitesse radiale. */
#define TYPAP__C_prevrad "prevrad"

/*C C_angpnsol :  */
/* Angle des panneaux solaires au milieu de la poussee. */
#define TYPAP__C_angpnsol "angpnsol"

/*C C_massavm :  */
/* Masse du satellite avant la manoeuvre. */
#define TYPAP__C_massavm "massavm"

/*C C_deltamas :  */
/* Variation de la masse du satellite apres la poussee. */
#define TYPAP__C_deltamas "deltamas"

/* Datagroup IEX_EPHCGS_S */
/* ------------------------ */

/*C C_iex_ephcgs_s :  */
/* Nom du datagroup "ephemerides CGS" */
#define TYPAP__C_iex_ephcgs_s "iex_ephcgs_s"

/*C C_date :  */
/* Epoque ephemerides satellites */
#define TYPAP__C_date "date"

/*C C_posx1 :  */
/* Position en X satellite numero 1 */
#define TYPAP__C_posx1 "posx1"

/*C C_posy1 :  */
/* Position en Y satellite numero 1 */
#define TYPAP__C_posy1 "posy1"

/*C C_posz1 :  */
/* Position en Z satellite numero 1 */
#define TYPAP__C_posz1 "posz1"

/*C C_posx2 :  */
/* Position en X satellite numero 2 */
#define TYPAP__C_posx2 "posx2"

/*C C_posy2 :  */
/* Position en Y satellite numero 2 */
#define TYPAP__C_posy2 "posy2"

/*C C_posz2 :  */
/* Position en Z satellite numero 2 */
#define TYPAP__C_posz2 "posz2"

/*C C_posx3 :  */
/* Position en X satellite numero 3 */
#define TYPAP__C_posx3 "posx3"

/*C C_posy3 :  */
/* Position en Y satellite numero 3 */
#define TYPAP__C_posy3 "posy3"

/*C C_posz3 :  */
/* Position en Z satellite numero 3 */
#define TYPAP__C_posz3 "posz3"

/*C C_posx4 :  */
/* Position en X satellite numero 4 */
#define TYPAP__C_posx4 "posx4"

/*C C_posy4 :  */
/* Position en Y satellite numero 4 */
#define TYPAP__C_posy4 "posy4"

/*C C_posz4 :  */
/* Position en Z satellite numero 4 */
#define TYPAP__C_posz4 "posz4"

/*C C_posx5 :  */
/* Position en X satellite numero 5 */
#define TYPAP__C_posx5 "posx5"

/*C C_posy5 :  */
/* Position en Y satellite numero 5 */
#define TYPAP__C_posy5 "posy5"

/*C C_posz5 :  */
/* Position en Z satellite numero 5 */
#define TYPAP__C_posz5 "posz5"

/*C C_posx6 :  */
/* Position en X satellite numero 6 */
#define TYPAP__C_posx6 "posx6"

/*C C_posy6 :  */
/* Position en Y satellite numero 6 */
#define TYPAP__C_posy6 "posy6"

/*C C_posz6 :  */
/* Position en Z satellite numero 6 */
#define TYPAP__C_posz6 "posz6"

/*C C_posx7 :  */
/* Position en X satellite numero 7 */
#define TYPAP__C_posx7 "posx7"

/*C C_posy7 :  */
/* Position en Y satellite numero 7 */
#define TYPAP__C_posy7 "posy7"

/*C C_posz7 :  */
/* Position en Z satellite numero 7 */
#define TYPAP__C_posz7 "posz7"

/*C C_posx8 :  */
/* Position en X satellite numero 8 */
#define TYPAP__C_posx8 "posx8"

/*C C_posy8 :  */
/* Position en Y satellite numero 8 */
#define TYPAP__C_posy8 "posy8"

/*C C_posz8 :  */
/* Position en Z satellite numero 8 */
#define TYPAP__C_posz8 "posz8"

/*C C_posx9 :  */
/* Position en X satellite numero 9 */
#define TYPAP__C_posx9 "posx9"

/*C C_posy9 :  */
/* Position en Y satellite numero 9 */
#define TYPAP__C_posy9 "posy9"

/*C C_posz9 :  */
/* Position en Z satellite numero 9 */
#define TYPAP__C_posz9 "posz9"

/*C C_posx10 :  */
/* Position en X satellite numero 10 */
#define TYPAP__C_posx10 "posx10"

/*C C_posy10 :  */
/* Position en Y satellite numero 10 */
#define TYPAP__C_posy10 "posy10"

/*C C_posz10 :  */
/* Position en Z satellite numero 10 */
#define TYPAP__C_posz10 "posz10"

/*C C_posx11 :  */
/* Position en X satellite numero 11 */
#define TYPAP__C_posx11 "posx11"

/*C C_posy11 :  */
/* Position en Y satellite numero 11 */
#define TYPAP__C_posy11 "posy11"

/*C C_posz11 :  */
/* Position en Z satellite numero 11 */
#define TYPAP__C_posz11 "posz11"

/*C C_posx12 :  */
/* Position en X satellite numero 12 */
#define TYPAP__C_posx12 "posx12"

/*C C_posy12 :  */
/* Position en Y satellite numero 12 */
#define TYPAP__C_posy12 "posy12"

/*C C_posz12 :  */
/* Position en Z satellite numero 12 */
#define TYPAP__C_posz12 "posz12"

/*C C_posx13 :  */
/* Position en X satellite numero 13 */
#define TYPAP__C_posx13 "posx13"

/*C C_posy13 :  */
/* Position en Y satellite numero 13 */
#define TYPAP__C_posy13 "posy13"

/*C C_posz13 :  */
/* Position en Z satellite numero 13 */
#define TYPAP__C_posz13 "posz13"

/*C C_posx14 :  */
/* Position en X satellite numero 14 */
#define TYPAP__C_posx14 "posx14"

/*C C_posy14 :  */
/* Position en Y satellite numero 14 */
#define TYPAP__C_posy14 "posy14"

/*C C_posz14 :  */
/* Position en Z satellite numero 14 */
#define TYPAP__C_posz14 "posz14"

/*C C_posx15 :  */
/* Position en X satellite numero 15 */
#define TYPAP__C_posx15 "posx15"

/*C C_posy15 :  */
/* Position en Y satellite numero 15 */
#define TYPAP__C_posy15 "posy15"

/*C C_posz15 :  */
/* Position en Z satellite numero 15 */
#define TYPAP__C_posz15 "posz15"

/*C C_posx16 :  */
/* Position en X satellite numero 16 */
#define TYPAP__C_posx16 "posx16"

/*C C_posy16 :  */
/* Position en Y satellite numero 16 */
#define TYPAP__C_posy16 "posy16"

/*C C_posz16 :  */
/* Position en Z satellite numero 16 */
#define TYPAP__C_posz16 "posz16"

/*C C_posx17 :  */
/* Position en X satellite numero 17 */
#define TYPAP__C_posx17 "posx17"

/*C C_posy17 :  */
/* Position en Y satellite numero 17 */
#define TYPAP__C_posy17 "posy17"

/*C C_posz17 :  */
/* Position en Z satellite numero 17 */
#define TYPAP__C_posz17 "posz17"

/*C C_posx18 :  */
/* Position en X satellite numero 18 */
#define TYPAP__C_posx18 "posx18"

/*C C_posy18 :  */
/* Position en Y satellite numero 18 */
#define TYPAP__C_posy18 "posy18"

/*C C_posz18 :  */
/* Position en Z satellite numero 18 */
#define TYPAP__C_posz18 "posz18"

/*C C_posx19 :  */
/* Position en X satellite numero 19 */
#define TYPAP__C_posx19 "posx19"

/*C C_posy19 :  */
/* Position en Y satellite numero 19 */
#define TYPAP__C_posy19 "posy19"

/*C C_posz19 :  */
/* Position en Z satellite numero 19 */
#define TYPAP__C_posz19 "posz19"

/*C C_posx20 :  */
/* Position en X satellite numero 20 */
#define TYPAP__C_posx20 "posx20"

/*C C_posy20 :  */
/* Position en Y satellite numero 20 */
#define TYPAP__C_posy20 "posy20"

/*C C_posz20 :  */
/* Position en Z satellite numero 20 */
#define TYPAP__C_posz20 "posz20"

/*C C_posx21 :  */
/* Position en X satellite numero 21 */
#define TYPAP__C_posx21 "posx21"

/*C C_posy21 :  */
/* Position en Y satellite numero 21 */
#define TYPAP__C_posy21 "posy21"

/*C C_posz21 :  */
/* Position en Z satellite numero 21 */
#define TYPAP__C_posz21 "posz21"

/*C C_posx22 :  */
/* Position en X satellite numero 22 */
#define TYPAP__C_posx22 "posx22"

/*C C_posy22 :  */
/* Position en Y satellite numero 22 */
#define TYPAP__C_posy22 "posy22"

/*C C_posz22 :  */
/* Position en Z satellite numero 22 */
#define TYPAP__C_posz22 "posz22"

/*C C_posx23 :  */
/* Position en X satellite numero 23 */
#define TYPAP__C_posx23 "posx23"

/*C C_posy23 :  */
/* Position en Y satellite numero 23 */
#define TYPAP__C_posy23 "posy23"

/*C C_posz23 :  */
/* Position en Z satellite numero 23 */
#define TYPAP__C_posz23 "posz23"

/*C C_posx24 :  */
/* Position en X satellite numero 24 */
#define TYPAP__C_posx24 "posx24"

/*C C_posy24 :  */
/* Position en Y satellite numero 24 */
#define TYPAP__C_posy24 "posy24"

/*C C_posz24 :  */
/* Position en Z satellite numero 24 */
#define TYPAP__C_posz24 "posz24"

/*C C_posx25 :  */
/* Position en X satellite numero 25 */
#define TYPAP__C_posx25 "posx25"

/*C C_posy25 :  */
/* Position en Y satellite numero 25 */
#define TYPAP__C_posy25 "posy25"

/*C C_posz25 :  */
/* Position en Z satellite numero 25 */
#define TYPAP__C_posz25 "posz25"

/*C C_posx26 :  */
/* Position en X satellite numero 26 */
#define TYPAP__C_posx26 "posx26"

/*C C_posy26 :  */
/* Position en Y satellite numero 26 */
#define TYPAP__C_posy26 "posy26"

/*C C_posz26 :  */
/* Position en Z satellite numero 26 */
#define TYPAP__C_posz26 "posz26"

/*C C_posx27 :  */
/* Position en X satellite numero 27 */
#define TYPAP__C_posx27 "posx27"

/*C C_posy27 :  */
/* Position en Y satellite numero 27 */
#define TYPAP__C_posy27 "posy27"

/*C C_posz27 :  */
/* Position en Z satellite numero 27 */
#define TYPAP__C_posz27 "posz27"

/*C C_posx28 :  */
/* Position en X satellite numero 28 */
#define TYPAP__C_posx28 "posx28"

/*C C_posy28 :  */
/* Position en Y satellite numero 28 */
#define TYPAP__C_posy28 "posy28"

/*C C_posz28 :  */
/* Position en Z satellite numero 28 */
#define TYPAP__C_posz28 "posz28"

/*C C_posx29 :  */
/* Position en X satellite numero 29 */
#define TYPAP__C_posx29 "posx29"

/*C C_posy29 :  */
/* Position en Y satellite numero 29 */
#define TYPAP__C_posy29 "posy29"

/*C C_posz29 :  */
/* Position en Z satellite numero 29 */
#define TYPAP__C_posz29 "posz29"

/*C C_posx30 :  */
/* Position en X satellite numero 30 */
#define TYPAP__C_posx30 "posx30"

/*C C_posy30 :  */
/* Position en Y satellite numero 30 */
#define TYPAP__C_posy30 "posy30"

/*C C_posz30 :  */
/* Position en Z satellite numero 30 */
#define TYPAP__C_posz30 "posz30"

/*C C_posx31 :  */
/* Position en X satellite numero 31 */
#define TYPAP__C_posx31 "posx31"

/*C C_posy31 :  */
/* Position en Y satellite numero 31 */
#define TYPAP__C_posy31 "posy31"

/*C C_posz31 :  */
/* Position en Z satellite numero 31 */
#define TYPAP__C_posz31 "posz31"

/*C C_posx32 :  */
/* Position en X satellite numero 32 */
#define TYPAP__C_posx32 "posx32"

/*C C_posy32 :  */
/* Position en Y satellite numero 32 */
#define TYPAP__C_posy32 "posy32"

/*C C_posz32 :  */
/* Position en Z satellite numero 32 */
#define TYPAP__C_posz32 "posz32"

/*C C_posx33 :  */
/* Position en X satellite numero 33 */
#define TYPAP__C_posx33 "posx33"

/*C C_posy33 :  */
/* Position en Y satellite numero 33 */
#define TYPAP__C_posy33 "posy33"

/*C C_posz33 :  */
/* Position en Z satellite numero 33 */
#define TYPAP__C_posz33 "posz33"

/*C C_posx34 :  */
/* Position en X satellite numero 34 */
#define TYPAP__C_posx34 "posx34"

/*C C_posy34 :  */
/* Position en Y satellite numero 34 */
#define TYPAP__C_posy34 "posy34"

/*C C_posz34 :  */
/* Position en Z satellite numero 34 */
#define TYPAP__C_posz34 "posz34"

/*C C_posx35 :  */
/* Position en X satellite numero 35 */
#define TYPAP__C_posx35 "posx35"

/*C C_posy35 :  */
/* Position en Y satellite numero 35 */
#define TYPAP__C_posy35 "posy35"

/*C C_posz35 :  */
/* Position en Z satellite numero 35 */
#define TYPAP__C_posz35 "posz35"

/*C C_posx36 :  */
/* Position en X satellite numero 36 */
#define TYPAP__C_posx36 "posx36"

/*C C_posy36 :  */
/* Position en Y satellite numero 36 */
#define TYPAP__C_posy36 "posy36"

/*C C_posz36 :  */
/* Position en Z satellite numero 36 */
#define TYPAP__C_posz36 "posz36"

/*C C_posx37 :  */
/* Position en X satellite numero 37 */
#define TYPAP__C_posx37 "posx37"

/*C C_posy37 :  */
/* Position en Y satellite numero 37 */
#define TYPAP__C_posy37 "posy37"

/*C C_posz37 :  */
/* Position en Z satellite numero 37 */
#define TYPAP__C_posz37 "posz37"

/* Producteur TAC */
/* _____________ */
/* Datagroupe TAC_CRGENE_S */
/* ----------------------- */

/*C C_type_tae */
/* nom de variable : type */
#define TYPAP__C_type_tae "ttatype"

/*C C_verbe_tae */
/* nom de variable : type */
#define TYPAP__C_verbe_tae "ttaverbe"

/*C C_compo_tae */
/* nom de variable : type */
#define TYPAP__C_compo_tae "ttacompo"

/*C C_client_tae */
/* nom de variable : type */
#define TYPAP__C_client_tae "ttaclien"

/*C C_cr_tae */
/* nom de variable : type */
#define TYPAP__C_cr_tae "ttacr"
/* Producteur TAC */
/* _____________ */
/* Datagroupe TAC_CRGENE_S */
/* ----------------------- */

/*C C_type_tae */
/* nom de variable : type */
#define TYPAP__C_type_tae "ttatype"

/*C C_verbe_tae */
/* nom de variable : type */
#define TYPAP__C_verbe_tae "ttaverbe"

/*C C_compo_tae */
/* nom de variable : type */
#define TYPAP__C_compo_tae "ttacompo"

/*C C_client_tae */
/* nom de variable : type */
#define TYPAP__C_client_tae "ttaclien"

/*C C_cr_tae */
/* nom de variable : type */
#define TYPAP__C_cr_tae "ttacr"

/*C C_dg_tac_ems */
/* Datagroupe d'emission de CR de TAC vers EMS */
#define TYPAP__C_dg_tac_ems "tac_crgene_s"

/*C C_tac_confsys_e */
/* Datagroupe de reception des parametres */
#define TYPAP__C_tac_confsys_e "tac_confsys_e"


/* Producteur EMS */
/* _____________ */
/* Datagroupe EMS_TAGENE_S */
/* ----------------------- */

/*C C_dg_ems_tac */
/* Datagroupe d'emission de TA de EMS vers TAC */
#define TYPAP__C_dg_ems_tac "ems_tagene_s"


/* Producteur SDC */
/* _____________ */
/* Datagroupe SDC_CONFSYS_S */
/* ----------------------- */

/*C C_sdc_confsys_s */
/* Datagroupe d'emission de SDC */
#define TYPAP__C_sdc_confsys_s "sdc_confsys_s"

/*C C_antrclx */
/* Radical du nom de la coordonnee X de l'antenne du recepteur de collecte de donnees */
#define TYPAP__C_antrclx "antrclx"

/*C C_antrcly */
/* Radical du nom de la coordonnee Y de l'antenne du recepteur de collecte de donnees */
#define TYPAP__C_antrcly "antrcly"

/*C C_antrclz */
/* Radical du nom de la coordonnee Z de l'antenne du recepteur de collecte de donnees */
#define TYPAP__C_antrclz "antrclz"

/*C C_aantrclx */
/* Coordonnee X de l'antenne du recepteur de la collecte de donnees */
#define TYPAP__C_aantrclx "aantrclx"

/*C C_aantrcly */
/* Coordonnee Y de l'antenne du recepteur de la collecte de donnees */
#define TYPAP__C_aantrcly "aantrcly"

/*C C_aantrclz */
/* Coordonnee Z de l'antenne du recepteur de la collecte de donnees */
#define TYPAP__C_aantrclz "aantrclz"

/*C C_hantrclx */
/* Coordonnee X de l'antenne du recepteur de la collecte de donnees */
#define TYPAP__C_hantrclx "hantrclx"

/*C C_hantrcly */
/* Coordonnee Y de l'antenne du recepteur de la collecte de donnees */
#define TYPAP__C_hantrcly "hantrcly"

/*C C_hantrclz */
/* Coordonnee Z de l'antenne du recepteur de la collecte de donnees */
#define TYPAP__C_hantrclz "hantrclz"

/*C C_kantrclx */
/* Coordonnee X de l'antenne du recepteur de la collecte de donnees */
#define TYPAP__C_kantrclx "kantrclx"

/*C C_kantrcly */
/* Coordonnee Y de l'antenne du recepteur de la collecte de donnees */
#define TYPAP__C_kantrcly "kantrcly"

/*C C_kantrclz */
/* Coordonnee Z de l'antenne du recepteur de la collecte de donnees */
#define TYPAP__C_kantrclz "kantrclz"

/*C C_antcalx */
/* Radical du nom de la coordonnee X de l'antenne du calibrateur */
#define TYPAP__C_antcalx "antcalx"

/*C C_aantcaly */
/* Radical du nom de la coordonnee coordonnee Y de l'antenne du calibrateur */
#define TYPAP__C_antcaly "antcaly"

/*C C_antcalz */
/* Radical du nom de la coordonnee coordonnee Z de l'antenne du calibrateur */
#define TYPAP__C_antcalz "antcalz"

/*C C_aantcalx */
/* Coordonnee X de l'antenne du callibrateur */
#define TYPAP__C_aantcalx "aantcalx"

/*C C_aantcaly */
/* Coordonnee Y de l'antenne du callibrateur */
#define TYPAP__C_aantcaly "aantcaly"

/*C C_aantcalz */
/* Coordonnee Z de l'antenne du callibrateur */
#define TYPAP__C_aantcalz "aantcalz"

/*C C_hantcalx */
/* Coordonnee X de l'antenne du callibrateur */
#define TYPAP__C_hantcalx "hantcalx"

/*C C_hantcaly */
/* Coordonnee Y de l'antenne du callibrateur */
#define TYPAP__C_hantcaly "hantcaly"

/*C C_hantcalz */
/* Coordonnee Z de l'antenne du callibrateur */
#define TYPAP__C_hantcalz "hantcalz"

/*C C_kantcalx */
/* Coordonnee X de l'antenne du callibrateur */
#define TYPAP__C_kantcalx "kantcalx"

/*C C_kantcaly */
/* Coordonnee Y de l'antenne du callibrateur */
#define TYPAP__C_kantcaly "kantcaly"

/*C C_kantcalz */
/* Coordonnee Z de l'antenne du callibrateur */
#define TYPAP__C_kantcalz "kantcalz"

/*C C_anrclla */
/* Radical du nom de la latitude de l'antenne du recepteur de collecte de donnees */
#define TYPAP__C_anrclla "anrclla"

/*C C_anrcllo */
/* Radical du nom de la lontitude de l'antenne du recepteur de collecte de donnees */
#define TYPAP__C_anrcllo "anrcllo"

/*C C_anrclal */
/* Radical du nom de l'altitude de l'antenne du recepteur de collecte de donnees */
#define TYPAP__C_anrclal "anrclal"

/*C C_aanrclla */
/* Latitude de l'antenne du recepteur de la collecte de donnees */
#define TYPAP__C_aanrclla "aanrclla"

/*C C_aanrcllo */
/* Lontitude de l'antenne du recepteur de la collecte de donnees */
#define TYPAP__C_aanrcllo "aanrcllo"

/*C C_aanrclal */
/* Altitude de l'antenne du recepteur de la collecte de donnees */
#define TYPAP__C_aanrclal "aanrclal"

/*C C_hanrclla */
/* Latitude de l'antenne du recepteur de la collecte de donnees */
#define TYPAP__C_hanrclla "hanrclla"

/*C C_hanrcllo */
/* Lontitude de l'antenne du recepteur de la collecte de donnees */
#define TYPAP__C_hanrcllo "hanrcllo"

/*C C_hanrclal */
/* Altitude de l'antenne du recepteur de la collecte de donnees */
#define TYPAP__C_hanrclal "hanrclal"

/*C C_kanrclla */
/* Latitude de l'antenne du recepteur de la collecte de donnees */
#define TYPAP__C_kanrclla "kanrclla"

/*C C_kanrcllo */
/* Lontitude de l'antenne du recepteur de la collecte de donnees */
#define TYPAP__C_kanrcllo "kanrcllo"

/*C C_kanrclal */
/* Altitude de l'antenne du recepteur de la collecte de donnees */
#define TYPAP__C_kanrclal "kanrclal"

/*C C_anintla */
/* Latitude de l'antenne du recepteur d'integrite */
#define TYPAP__C_anintla "anintla"

/*C C_anintlo */
/* Lontitude de l'antenne du recepteur d'integrite */
#define TYPAP__C_anintlo "anintlo"

/*C C_anintal */
/* Altitude de l'antenne du recepteur d'integrite */
#define TYPAP__C_anintal "anintal"

/*C C_anintx */
/* Coordonnees X de l'antenne du recepteur d'integrite */
#define TYPAP__C_anintx "anintx"

/*C C_aninty */
/* Coordonnees Y l'antenne du recepteur d'integrite */
#define TYPAP__C_aninty "aninty"

/*C C_anintz */
/* Coordonnees Z de l'antenne du recepteur d'integrite */
#define TYPAP__C_anintz "anintz"

/*C C_anlnomla */
/* Latitude de l'antenne bande L nominale France Telecom */
#define TYPAP__C_anlnomla "anlnomla"

/*C C_anlnomlo */
/* Lontitude de l'antenne bande L nominale France Telecom */
#define TYPAP__C_anlnomlo "anlnomlo"

/*C C_anlnomal */
/* Altitude de l'antenne bande L nominale France Telecom */
#define TYPAP__C_anlnomal "anlnomal"

/*C C_anlnomfx */
/* Coordonnees X de l'antenne bande L nominale France Telecom */
#define TYPAP__C_anlnomfx "anlnomfx"

/*C C_anlnomfy */
/* Coordonnees Y l'antenne bande L nominale France Telecom */
#define TYPAP__C_anlnomfy "anlnomfy"

/*C C_anlnomfz */
/* Coordonnees Z de l'antenne bande L nominale France Telecom */
#define TYPAP__C_anlnomfz "anlnomfz"

/*C C_anlredla */
/* Latitude de l'antenne bande L redondante France Telecom */
#define TYPAP__C_anlredla "anlredla"

/*C C_anlredlo */
/* Lontitude de l'antenne bande L redondante France Telecom */
#define TYPAP__C_anlredlo "anlredlo"

/*C C_anlredal */
/* Altitude de l'antenne bande L redondante France Telecom */
#define TYPAP__C_anlredal "anlredal"

/*C C_anlredfx */
/* Coordonnees X de l'antenne bande L redondante France Telecom */
#define TYPAP__C_anlredfx "anlredfx"

/*C C_anlredfy */
/* Coordonnees Y l'antenne bande L redondante France Telecom */
#define TYPAP__C_anlredfy "anlredfy"

/*C C_anlredfz */
/* Coordonnees Z de l'antenne bande L redondante France Telecom */
#define TYPAP__C_anlredfz "anlredfz"

/*C C_ancblgla */
/* Latitude de l'antenne bande C BLG France Telecom */
#define TYPAP__C_ancblgla "ancblgla"

/*C C_ancblglo */
/* Lontitude de l'antenne bande C BLG France Telecom */
#define TYPAP__C_ancblglo "ancblglo"

/*C C_ancblgal */
/* Altitude de l'antenne bande C BLG France Telecom */
#define TYPAP__C_ancblgal "ancblgal"

/*C C_ancblgfx */
/* Coordonnees X de l'antenne bande C BLG France Telecom */
#define TYPAP__C_ancblgfx "ancblgfx"

/*C C_ancblgfy */
/* Coordonnees Y l'antenne bande C BLG France Telecom */
#define TYPAP__C_ancblgfy "ancblgfy"

/*C C_ancblgfz */
/* Coordonnees Z de l'antenne bande C BLG France Telecom */
#define TYPAP__C_ancblgfz "ancblgfz"

/*C C_prngeo */
/* Numero PRN du satellite geostationnaire */
#define TYPAP__C_prngeo "prngeo"

/*C C_blgablf0 */
/* Coeeficient ablf0 de recalage */
#define TYPAP__C_blgablf0 "blgablf0"

/*C C_blgablf1 */
/* Coeeficient ablf1 de recalage */
#define TYPAP__C_blgablf1 "blgablf1"

/*C C_blgdate */
/* Jour mois annee */
/* #define TYPAP__C_blgdate "BLGDATE" */

/*C C_blgtu */
/* Heure minute seconde */
/* #define TYPAP__C_blgtu "BLGTU" */

/*C C_bltprfc1 */
/* TPG RF de la voie C1 */
#define TYPAP__C_bltprfc1 "bltprfc1"

/*C C_bltprfc2 */
/* TPG RF de la voie C2 */
#define TYPAP__C_bltprfc2 "bltprfc2"

/*C C_bltrcac1 */
/* TPG RF calibrateur de la voie C1 */
#define TYPAP__C_bltrcac1 "bltrcac1"

/*C C_bltrcac2 */
/* TPG RF calibrateur de la voie C2 */
#define TYPAP__C_bltrcac2 "bltrcac2"

/*C C_bltprfl1 */
/* TPG RF de la voie L1 */
#define TYPAP__C_bltprfl1 "bltprfl1"

/*C C_bltrcal1 */
/* TPG RF calibrateur de la voie L1 */
#define TYPAP__C_bltrcal1 "bltrcal1"

/*C C_blcul1c1 */
/* TPG entre les centres de phase des antennes de reception bande C et L */
#define TYPAP__C_blcul1c1 "blcul1c1"

/*C C_blcuc2c1 */
/* TPG entre les centres de phase des antennes de reception bande C1 et C2*/
#define TYPAP__C_blcuc2c1 "blcuc2c1"

/*C C_blretc1s */
/* Retard du a la position de l'antenne C1 projete sur la ligne de la SCL */
#define TYPAP__C_blretc1s "blretc1s"

/*C C_blretc2s */
/* Retard du a la position de l'antenne C2 projete sur la ligne de la SCL */
#define TYPAP__C_blretc2s "blretc2s"

/*C C_blbralev */
/* ecart de temps entre le signal GEO et les antennes C et L */
#define TYPAP__C_blbralev "blbralev"

/* Datagroup SDC_CONFSQM_S */
/* ----------------------- */

/*C C_sdc_confsqm_s */
/* Datagroup concernant les informations de conf de SQM */
#define TYPAP__C_sdc_confsqm_s "sdc_confsqm_s"

/*C C_permsg9 */
/* Nom de la variable correspondant a la periode d'emission du message type 9 */
#define TYPAP__C_permsg9 "permsg9"

/* Datagroup SDC_CONFMCR_S */
/* ----------------------- */

/*C C_sdc_confmcr_s */
/* Datagroup concernant les informations de conf de MCR */
#define TYPAP__C_sdc_confmcr_s "sdc_confmcr_s"

/*C C_aantmcrx */
/* Nom de la variable correspondant a la coord x de l'antenne courante du RCL */
/* pour aussaguel */
#define TYPAP__C_aantmcrx "aantmcrx"

/*C C_aantmcry */
/* Nom de la variable correspondant a la coord y de l'antenne courante du RCL */
/* pour aussaguel */
#define TYPAP__C_aantmcry "aantmcry"

/*C C_aantmcrz */
/* Nom de la variable correspondant a la coord z de l'antenne courante du RCL */
/* pour aussaguel */
#define TYPAP__C_aantmcrz "aantmcrz"

/*C C_atpgmcr */
/* Nom de la variable correspondant au tpg de l'antenne courante du RCL */
/* pour aussaguel */
#define TYPAP__C_atpgmcr "atpgmcr"

/*C C_aquelant */
/* Nom de la variable correspondant a la valeur identifiant s'il s'agit de */
/* l'antenne omni ou directionnelle du RCL pour aussaguel */
#define TYPAP__C_aquelant "aquelant"

/* Datagroup SDC_CONFORB_S */
/* ----------------------- */

/*C C_sdc_conforb_s */
/* Datagroup concernant les informations de conf de ORB */
#define TYPAP__C_sdc_conforb_s "sdc_conforb_s"

/*C C_antorbx */
/* Radical du nom de la coordonnee X de l'antenne du RCL */
/* relative aux mesures GEO courantes de l'orbito */
#define TYPAP__C_antorbx "antorbx"

/*C C_antorby */
/* Radical du nom de la coordonnee Y de l'antenne du RCL */
/* relative aux mesures GEO courantes de l'orbito */
#define TYPAP__C_antorby "antorby"

/*C C_antorbz */
/* Radical du nom de la coordonnee Z de l'antenne du RCL */
/* relative aux mesures GEO courantes de l'orbito */
#define TYPAP__C_antorbz "antorbz"

/*C C_aantorbx */
/* Nom de la variable correspondant a la coord x de l'antenne du RCL */
/* relative aux mesures GEO courantes de l'orbito pour aussaguel */
#define TYPAP__C_aantorbx "aantorbx"

/*C C_aantorby */
/* Nom de la variable correspondant a la coord y de l'antenne du RCL */
/* relative aux mesures GEO courantes de l'orbito pour aussaguel */
#define TYPAP__C_aantorby "aantorby"

/*C C_aantorbz */
/* Nom de la variable correspondant a la coord z de l'antenne du RCL */
/* relative aux mesures GEO courantes de l'orbito pour aussaguel */
#define TYPAP__C_aantorbz "aantorbz"

/*C C_hantorbx */
/* Nom de la variable correspondant a la coord x de l'antenne du RCL */
/* relative aux mesures GEO courantes de l'orbito pour hbk */
#define TYPAP__C_hantorbx "hantorbx"

/*C C_hantorby */
/* Nom de la variable correspondant a la coord y de l'antenne du RCL */
/* relative aux mesures GEO courantes de l'orbito pour hbk */
#define TYPAP__C_hantorby "hantorby"

/*C C_hantorbz */
/* Nom de la variable correspondant a la coord z de l'antenne du RCL */
/* relative aux mesures GEO courantes de l'orbito pour hbk */
#define TYPAP__C_hantorbz "hantorbz"

/*C C_kantorbx */
/* Nom de la variable correspondant a la coord x de l'antenne du RCL */
/* relative aux mesures GEO courantes de l'orbito pour kourou */
#define TYPAP__C_kantorbx "kantorbx"

/*C C_kantorby */
/* Nom de la variable correspondant a la coord y de l'antenne du RCL */
/* relative aux mesures GEO courantes de l'orbito pour kourou */
#define TYPAP__C_kantorby "kantorby"

/*C C_kantorbz */
/* Nom de la variable correspondant a la coord z de l'antenne du RCL */
/* relative aux mesures GEO courantes de l'orbito pour kourou */
#define TYPAP__C_kantorbz "kantorbz"

/*C C_tpgorb */
/* Radical du nom du TPG RF des antennes de chaque station */
#define TYPAP__C_tpgorb "tpgorb"

/*C C_atpgorb */
/* Nom de la variable correspondant au tpg de l'antenne du RCL */
/* relative aux mesures GEO courantes de l'orbito pour aussaguel */
#define TYPAP__C_atpgorb "atpgorb"

/*C C_htpgorb */
/* Nom de la variable correspondant au tpg de l'antenne du RCL */
/* relative aux mesures GEO courantes de l'orbito pour hbk */
#define TYPAP__C_htpgorb "htpgorb"

/*C C_ktpgorb */
/* Nom de la variable correspondant au tpg de l'antenne du RCL */
/* relative aux mesures GEO courantes de l'orbito pour kourou */
#define TYPAP__C_ktpgorb "ktpgorb"



/* Producteur ISA */
/* ______________ */
/* Datagroup ISA_PDGPSB_S */
/* ---------------------- */

/*C C_isa_pdgpsb_s */
/* Datagroup de description des "Pseudo distance GPS brute" en visibilite de la station SLA */
#define TYPAP__C_isa_pdgpsb_s "isa_pdgpsb_s"

/*C C_ish_pdgpsb_s */
/* Datagroup de description des "Pseudo distance GPS brute" en visibilite de la station SLH */
#define TYPAP__C_ish_pdgpsb_s "ish_pdgpsb_s"

/*C C_isk_pdgpsb_s */
/* Datagroup de description des "Pseudo distance GPS brute" en visibilite de la station SLK */
#define TYPAP__C_isk_pdgpsb_s "isk_pdgpsb_s"

/*C C_tow */
/* Valeur du TOW */
#define TYPAP__C_tow "tow"

/*C C_awn */
/* Valeur de WN */
#define TYPAP__C_wn "wn"

/*C C_rcletat */
/* Etat global recepteur RCL */
#define TYPAP__C_rcletat "rcletat"

/*C C_aetablhf */
/* Etat recepteur RCL pour bloc HF */
#define TYPAP__C_etablhf "etablhf"

/*C C_aetaprea */
/* Etat recepteur RCL pour preampli */
#define TYPAP__C_etaprea "etaprea"

/*C C_aetapll */
/* Etat du recepteur RCL pour PLL */
#define TYPAP__C_etapll "etapll"

/*C C_aetahorl */
/* Etat du recepteur RCL pour horloge de reference */
#define TYPAP__C_etahorl "etahorl"

/*C C_aetabcpu */
/* Etat du recepteur RCL pour bloc CPU */
#define TYPAP__C_etabcpu "etabcpu"

/*C C_etaalim */
/* Etat du recepteur RCL pour alimentation */
#define TYPAP__C_etaalim "etaalim"

/*C C_etawdog */
/* Etat du recepteur RCL pour watch dog */
#define TYPAP__C_etawdog "etawdog"

/*C C_etaasic */
/* Etat du recepteur RCL pour ASIC GNSS */
#define TYPAP__C_etaasic "etaasic"

/*C C_etagluc */
/* Etat du recepteur RCL pour GLUCOMA */
#define TYPAP__C_etagluc "etagluc"

/*C C_etabmem */
/* Etat du recepteur RCL pour bloc memoire */
#define TYPAP__C_etabmem "etabmem"

/*C C_etaaten */
/* Etat du recepteur RCL pour attente commande */
#define TYPAP__C_etaaten "etaaten"

/*C C_frqgeo */
/* Frequence du spectre GEO */
#define TYPAP__C_frqgeo "frqgeo"

/*C C_qalgeo */
/* Rapport S/B (qualite du spectre niveau) GEO */
#define TYPAP__C_qalgeo "qalgeo"

/*C C_bandgeo */
/* Indicateur de largeur de bande brouillee GEO */
#define TYPAP__C_bandgeo "bandgeo"

/*C C_prn */
/* Numero de satellite GPS (PRN) sur un canal du recepteur */
#define TYPAP__C_prn "prn"

/*C C_pdb */
/* Valeur de la PD brute du GPS obtenue sur un canal du recepteur */
#define TYPAP__C_pdb "pdb"

/*C C_pdval */
/* Validite de la PD brute du GPS obtenue sur un canal du recepteur */
#define TYPAP__C_pdval "pdval"

/*C C_cn0 */
/* Rapport C/N0 du GPS obtenue sur un canal du recepteur */
#define TYPAP__C_cn0 "cn0"

/*C C_gcp */
/* Glissement du GPS obtenu sur un canal du recepteur */
#define TYPAP__C_gcp "gcp"

/*C C_tem */
/* TEM du GPS obtenu sur un canal du recepteur */
#define TYPAP__C_tem "tem"

/*C C_iem */
/* IEM du GEO obtenu sur un canal du recepteur */
#define TYPAP__C_iem "iem"

/*C C_tosc */
/* TOSC du GPS obtenu sur un canal du recepteur */
#define TYPAP__C_tosc "tosc"

/*C C_toma */
/* TOMA du GPS obtenu sur un canal du recepteur */
#define TYPAP__C_toma "toma"


/* Datagroup ISA_EPHEGPS_S */
/* ---------------------- */

/*C C_isa_ephegps_s */
/* Datagroup decrivant les ephemerides en provenance de la station SLA */
#define TYPAP__C_isa_ephegps_s "isa_ephegps_s"

/*C C_ish_ephegps_s */
/* Datagroup decrivant les ephemerides en provenance de la station SLH */
#define TYPAP__C_ish_ephegps_s "ish_ephegps_s"

/*C C_isk_ephegps_s */
/* Datagroup decrivant les ephemerides en provenance de la station SLK */
#define TYPAP__C_isk_ephegps_s "isk_ephegps_s"

/*C C_epheprn */
/* Numero de satellite GPS (PRN) */
#define TYPAP__C_epheprn "epheprn"

/*C C_etatgps */
/* Etat de sante du satellite GPS */
#define TYPAP__C_etatgps "etatgps"

/*C C_iode */
/* Version des donnees ephemerides */
#define TYPAP__C_iode "iode"

/*C C_crs */
/* Amplitude du terme de correction harmonique du sinus par rapport au rayon de l'orbite */
#define TYPAP__C_crs "crs"

/*C C_deltn */
/* Difference du mouvement moyen a partir de la valeur calculee */
#define TYPAP__C_deltn "deltn"

/*C C_m0 */
/* Anomalie moyenne au temps de reference */
#define TYPAP__C_m0 "m0"

/*C C_cuc */
/* Amplitude du terme de correction harmonique du cosinus par rapport a l'argument de la latitude */
#define TYPAP__C_cuc "cuc"

/*C C_exc */
/* Exentricite de l'orbite */
#define TYPAP__C_exc "exc"

/*C C_cus */
/* Amplitude du terme de correction harmonique du sinus par rapport a l'argument de la latitude */
#define TYPAP__C_cus "cus"

/*C C_ademi */
/* Racine carree du demi grand axe */
#define TYPAP__C_ademi "ademi"

/*C C_toe */
/* Temps de reference de l'ephemeride */
#define TYPAP__C_toe "toe"

/*C C_cic */
/* Amplitude du terme de correction harmonique du cosinus par rapport a l'angle d'inclinaison */
#define TYPAP__C_cic "cic"

/*C C_lonod */
/* Longitude du centre nodal ascendant du plan orbital a l'epoque hebdomadaire */
#define TYPAP__C_lonod "lonod"

/*C C_cis */
/* Amplitude du terme de correction harmonique du sinus par rapport a l'angle d'inclinaison */
#define TYPAP__C_cis "cis"

/*C C_i0 */
/* Angle d'inclinaison au temps de reference */
#define TYPAP__C_i0 "i0"

/*C C_crc */
/* Amplitude du terme de correction harmonique du cosinus par rapport au rayon de l'orbite */
#define TYPAP__C_crc "crc"

/*C C_perig */
/* Argument du perigee */
#define TYPAP__C_perig "perig"

/*C C_omeg */
/* Rythme de l'ascension directe */
#define TYPAP__C_omeg "omeg"

/*C C_idot */
/* Rythme de l'angle d'inclinaison */
#define TYPAP__C_idot "idot"


/* Datagroup ISA_DMETEO_S */
/* ------------------------ */

/*C C_isa_dmeteo_s */
/* Datagroup de description des donnees de la station SLA */
#define TYPAP__C_isa_dmeteo_s "isa_dmeteo_s"

/*C C_ish_dmeteo_s */
/* Datagroup de description des donnees de la station SLH */
#define TYPAP__C_ish_dmeteo_s "ish_dmeteo_s"

/*C C_isk_dmeteo_s */
/* Datagroup de description des donnees de la station SLK */
#define TYPAP__C_isk_dmeteo_s "isk_dmeteo_s"

/*C C_ipress */
/* Pression */
#define TYPAP__C_ipress "ipress"

/*C C_iepress */
/* Valeur de l'erreur sur la pression */
#define TYPAP__C_iepress "iepress"

/*C C_itemp */
/* Temperature */
#define TYPAP__C_itemp "itemp"

/*C C_ietemp */
/* Valeur de l'erreur sur la temperature */
#define TYPAP__C_ietemp "ietemp"

/*C C_ihumid */
/* Humidite */
#define TYPAP__C_ihumid "ihumid"

/*C C_iehumid */
/* Valeur de l'erreur sur l'humidite */
#define TYPAP__C_iehumid "iehumid"

/*C C_ialim */
/* Alimentation */
#define TYPAP__C_ialim "ialim"

/*C C_iealim */
/* Valeur de l'erreur sur l'alimentation */
#define TYPAP__C_iealim "iealim"

/*C C_itempin */
/* Temperature interne */
#define TYPAP__C_itempin "itempin"

/*C C_ietempin */
/* Valeur de l'erreur sur la temperature interne */
#define TYPAP__C_ietempin "ietempin"

/* Datagroup ISA_CALIONO_S */
/* ------------------------ */

/*C C_isa_caliono_s */
/* Datagroup de description des donnees du calibrateur iono de la station SLA */
#define TYPAP__C_isa_caliono_s "isa_caliono_s"

/*C C_iha_caliono_s */
/* Datagroup de description des donnees du calibrateur iono de la station SLH */
#define TYPAP__C_ish_caliono_s "ish_caliono_s"

/*C C_isk_caliono_s */
/* Datagroup de description des donnees du calibrateur iono de la station SLK */
#define TYPAP__C_isk_caliono_s "isk_caliono_s"

/*C C_calpr */
/* Numero de satellite GPS (PRN) */
#define TYPAP__C_calpr "calpr"

/*C C_angel */
/* Angle d'elevation */
#define TYPAP__C_angel "angel"

/*C C_l1mes */
/* Mesure bande L1 */
#define TYPAP__C_l1mes "l1mes"

/*C C_l1qal */
/* Indicateur de la qualite de la mesure bande L1 */
#define TYPAP__C_l1qal "l1qal"

/*C C_l2mes */
/* Mesure bande L2 */
#define TYPAP__C_l2mes "l2mes"

/*C C_l2qal */
/* Indicateur de la qualite de la mesure bande L2 */
#define TYPAP__C_l2qal "l2qal"

/* Datagroup ISA_ALMANACH_S */
/* ------------------------ */

/*C C_isa_almanach_s */
/* Datagroup d'emission de SDC */
#define TYPAP__C_isa_almanach_s "isa_almanach_s"

/*C C_almprn */
/* PRN de satellite GPS */
#define TYPAP__C_almprn "almprn"

/*C C_almexc */
/* Excentricite de l'orbite */
#define TYPAP__C_almexc "almexc"

/*C C_almtoa */
/* Temps de reference almanach */
#define TYPAP__C_almtoa "almtoa"

/*C C_almi */
/* Inclinaison de l'orbite */
#define TYPAP__C_almi "almi"

/*C C_almomdot */
/* Rythme de l'ascension directe */
#define TYPAP__C_almomdot "almomdot"

/*C C_almetat */
/* Resume de l'etat de satellite GPS concerne */
#define TYPAP__C_almetat "almetat"

/*C C_almademi */
/* Racine carre du demi grand axe */
#define TYPAP__C_almademi "almademi"

/*C C_almlong */
/* Longitude du centre nodal ascendant du plan orbital a l'epoque hebdomadaire */
#define TYPAP__C_almlong "almlong"

/*C C_almom */
/* Argument du perigee */
#define TYPAP__C_almom "almon"

/*C C_almm0 */
/* Anomalie moyenne au temps de reference */
#define TYPAP__C_almm0 "almm0"

/*C C_almaf0 */
/* Coefficient af0 */
#define TYPAP__C_almaf0 "almaf0"

/*C C_almaf1 */
/* Coefficient af1 */
#define TYPAP__C_almaf1 "almaf1"

/*C C_almwna */
/* Numero de semaine */
#define TYPAP__C_almwna "almwna"


/* Datagroup ISA_DTGPSUTC_S */
/* ------------------------ */

/*C C_isa_dtgpsutc_s */
/* Datagroup des parametres de temps UTC */
#define TYPAP__C_isa_dtgpsutc_s "isa_dtgpsutc_s"

/*C C_utca1 */
/* Terme du 1er ordre du polynome */
#define TYPAP__C_utca1 "autca1"

/*C C_utca0 */
/* Terme constant du polynome */
#define TYPAP__C_utca0 "autca0"

/*C C_utcdtls */
/* Delta de temps du au saut de secondes */
#define TYPAP__C_utcdtls "autcdtls"

/*C C_utctot */
/* Reference de temps pour les donnees utc */
#define TYPAP__C_utctot "autctot"

/*C C_utcwnt */
/* Numero de semaine de la reference utc */
#define TYPAP__C_utcwnt "autcwnt"

/*C C_utcwnlsf */
/* Numero de semaine ou le saut de seconde devient effectif */
#define TYPAP__C_utcwnlsf "autcwnlsf"

/*C C_utcdn */
/* Numero de jour ou le saut de seconde devient effectif */
#define TYPAP__C_utcdn "autcdn"

/*C C_utcdtlsf */
/* Delta de temps du au saut de seconde */
#define TYPAP__C_utcdtlsf "autcdtlsf"


/* Producteur EMS */
/* ______________ */
/* Datagroupe EMS_ETATMODE_S */
/* ------------------------- */

/*C C_ems_etatmode_s */
/* Nom de datagroup Diffusion de etats et modes*/
#define TYPAP__C_ems_etatmode_s "ems_etatmode_s"

/*C C_etatgs */
/* Etat et mode systeme */
#define TYPAP__C_etatgs "etatgs"

/* Producteur SQM */
/* ______________ */
/* Datagroupe SQM_BRLEVIER_S */
/* ------------------------- */

/*C C_sqm_brlevier_s */
/* Nom de datagroup Diffusion du bras de levier */
#define TYPAP__C_sqm_brlevier_s "sqm_brlevier_s"

/*C C_brlevier */
/* bras de levier */
#define TYPAP__C_brlevier "brlevier"

/*C Producteur SQM */
/* ______________ */
/* Datagroupe  SQM_ALMAGEO_S */
/* ------------------------- */

/*C C_sqm_almageo_s */
/* Nom de datagroup Diffusion de l'almanach du GEO */
#define TYPAP__C_sqm_almageo_s "sqm_almageo_s"

/*C C_dataid */
/* Datat idenification */
#define TYPAP__C_dataid "dataid"

/*C C_prngeo */
/* prn du geo */
#define TYPAP__C_prngeo "prngeo"

/*C C_health */
/* Status de sante du satellite */
#define TYPAP__C_health "health"

/*C C_xg */
/* Position en X du satellite */
#define TYPAP__C_xg "xg"

/*C C_yg */
/* Position en Y du satellite */
#define TYPAP__C_yg "yg"

/*C C_zg */
/* Position en Z du satellite */
#define TYPAP__C_zg "zg"

/*C C_xv */
/* Vitesse en X du satellite */
#define TYPAP__C_xv "xv"

/*C C_yv */
/* Vitesse en Y du satellite */
#define TYPAP__C_yv "dataid"

/*C C_zv */
/* Vitesse en Z du satellite */
#define TYPAP__C_zv "zv"

/*C C_tempsgst */
/* Date d'applicabilite de l'almanach */
#define TYPAP__C_tempsgst "tempsgst"

/* Datagroup  SQM_CONSIG_S */
/* ----------------------- */

/*C C_sqm_consig_s */
/* Nom de datagroup Informations caracteristiques de debut de consigne en */
/* en position emis a la BLG */
#define TYPAP__C_sqm_consig_s "sqm_consig_s"

/*C C_debutgst */
/* Nom de la variable Date d'applicabilite des coefficients a0 et a1 */
/* de la formule de la consigne de position pour la BLG */
/* sous format temps GST ayant servi a la 1ere */
/* consigne en position emis a la BLG apres la TA init */
#define TYPAP__C_debutgst "debutgst"

/*C C_a0debut */
/* Nom de la variable Coefficient a0 */
/* de la formule de la consigne de position pour la BLG ayant servi pour le */
/* calcul de la 1ere consigne en position emis a la BLG apres la TA init */
#define TYPAP__C_a0debut "a0debut"

/*C C_a1debut */
/* Nom de la variable Coefficient a1 */
/* de la formule de la consigne de position pour la BLG ayant servi pour le */
/* calcul de la 1ere consigne en position emis a la BLG apres la TA init */
#define TYPAP__C_a1debut "a1debut"

/* Datagroup  SQM_POTHGEO_S*/
/* ----------------------- */
/*C C_sqm_pothgeo_s */
/* Nom de datagroup "Position theorique du geo" */
#define TYPAP__C_sqm_pothgeo_s	"sqm_pothgeo_s"

/*C C_xpostheo :  */
/* Coeff ephemeride geocentrique X GEO */
#define TYPAP__C_xpostheo	"xpostheo"

/*C C_ypostheo :  */
/* Coeff ephemeride geocentrique Y GEO */
#define TYPAP__C_ypostheo	"ypostheo"

/*C C_zpostheo :  */
/* Coeff ephemeride geocentrique Z GEO */
#define TYPAP__C_zpostheo	"zpostheo"

/*C C_xptheo :  */
/* Coeff ephemeride geocentrique XP GEO */
#define TYPAP__C_xptheo		"xptheo"

/*C C_yptheo :  */
/* Coeff ephemeride geocentrique YP GEO */
#define TYPAP__C_yptheo		"yptheo"

/*C C_zptheo :  */
/* Coeff ephemeride geocentrique ZP GEO */
#define TYPAP__C_zptheo		"zptheo"

/*C C_xstheo :  */
/* Coeff ephemeride geocentrique XS GEO */
#define TYPAP__C_xstheo		"xstheo"

/*C C_ystheo :  */
/* Coeff ephemeride geocentrique YS GEO */
#define TYPAP__C_ystheo		"ystheo"

/*C C_zstheo :  */
/* Coeff ephemeride geocentrique ZS GEO */
#define TYPAP__C_zstheo		"zstheo"

/*C C_datappos :  */
/* Date d'applicabilite des coeff ephemeride */
#define TYPAP__C_datappos	"datappos"

/*C Client  PEX */
/* ____________ */
/* Datagroupe  PEX_PAREXP_S */
/* ------------------------ */

/*C C_pex_parexp_s */
/* Nom de datagroup  pour l'ecriture des seuils dans DCONF */
#define TYPAP__C_pex_parexp_s "pex_parexp_s"

/*C C_ueregeo */
/* seuil UEREgeo pour passage en mode degrade interne non critique */
#define TYPAP__C_ueregeo "suereopdi"

/*C C_sbinteginst */
/* seuil de S/B instantanee du recepteur d'integrite utilise pour la surveillance d'integrite  */
#define TYPAP__C_sbinteginst "sbinteginst"

/*C C_sbrecepinteg */
/* seuil du S/B recepteur d'integrite pour passage en mode degrade signal GEO */
#define TYPAP__C_sbrecepinteg "sbrecepinteg"

/*C C_sbl1anaspectr */
/* seuil du S/B du signal L1 fournis par l'analyseur de spectre pour passage en mode degrade signal GEO */
#define TYPAP__C_sbl1anaspectr "sbl1anaspectr"

/*C C_sbl2anaspectr */
/* seuil du S/B du signal L2 fournis par l'analyseur de spectre pour passage en mode degrade signal GEO */
#define TYPAP__C_sbl2anaspectr "sbl2anaspectr"

/*C C_sbc2anaspectr */
/* seuil du S/B du signal C2 fournis par l'analyseur de spectre pour passage en mode degrade signal GEO */
#define TYPAP__C_sbc2anaspectr "sbc2anaspectr"

/*C C_qualspectrniv */
/* seuil de surveillance qualite spectre niveau */
#define TYPAP__C_qualspectrniv "qualspectrniv"

/*C C_sbl1blgsimult */
/* seuil du signal L1 recu par la boucle longue pour emission d'une alarme vers le NOC en cas de degradation simultanee des deux signaux L1 et C2*/
#define TYPAP__C_sbl1blgsimult "sbl1blgsimult"

/*C C_sbc2blgsimult */
/* seuil du signal C2 recu par la boucle longue pour emission d'une alarme vers le NOC en cas de degradation simultanee des deux signaux L1 et C2*/
#define TYPAP__C_sbc2blgsimult "sbc2blgsimult"

/*C C_sbl1blgseul */
/* seuil du signal L1 recu par la boucle longue pour emission d'une alarme vers le NOC en cas de degradation */
#define TYPAP__C_sbl1blgseul "sbl1blgseul"

/*C C_errdistinst */
/* seuil de l'erreur de pseudo-distance instantanee utilisee par la surveillance d'integrite  */
#define TYPAP__C_errdistinst "errdistinst"

/*C C_errdiststat */
/* seuil de l'erreur de pseudo-distance statistique utilise pour la surveillance d'integrite  */
#define TYPAP__C_errdiststat "errdiststat"

/*C C_urainteg */
/* seuil de l'URA utilise par la surveillance d'integrite  */
#define TYPAP__C_urainteg "urainteg"

/*C C_deltapositon */
/* seuil de la surveillance instantanee entre la position station determinee avec les GPS et le GEO et la position connue  */
#define TYPAP__C_deltapositon "deltaposition"

/* FIN Datagroupe  PEX_PAREXP_S */
/* ---------------------------- */

/* Datagroup  PEX_REPEXP_S */
/* ----------------------- */

/*C C_pex_repexp_s */
/* Nom de datagroup  pour l'ecriture dans DCONF des parametres de la matrice de changement de repere WGS84 vers repere local recepteur d'integrite */
/* La matrice est de la forme : */ 
/*	a1	a4	a7      */
/*	a2	a5	a8      */
/*	a3	a6	a9      */
#define TYPAP__C_pex_repexp_s "pex_repexp_s"

/*C C_a1 */
/* parametre a1 de la matrice */
#define TYPAP__C_Mata1 "mata1"

/*C C_a2 */
/* parametre a2 de la matrice */
#define TYPAP__C_Mata2 "mata2"

/*C C_a3 */
/* parametre a3 de la matrice */
#define TYPAP__C_Mata3 "mata3"

/*C C_a4 */
/* parametre a4 de la matrice */
#define TYPAP__C_Mata4 "mata4"

/*C C_a5 */
/* parametre a5 de la matrice */
#define TYPAP__C_Mata5 "mata5"

/*C C_a6 */
/* parametre a6 de la matrice */
#define TYPAP__C_Mata6 "mata6"

/*C C_a7 */
/* parametre a7 de la matrice */
#define TYPAP__C_Mata7 "mata7"

/*C C_a8 */
/* parametre a8 de la matrice */
#define TYPAP__C_Mata8 "mata8"

/*C C_a9 */
/* parametre a9 de la matrice */
#define TYPAP__C_Mata9 "mata9"

/* FIN Datagroupe  PEX_REPEXP_S */
/* ---------------------------- */

/* Datagroupe  CTL_CH_CPU_S */
/* ------------------------ */

/*C C_ctl_chcpu_s */
/* datagroup  utilise pour diffuser la charge CPU d'une machine */
#define TYPAP__C_ctl_chcpu_s "ctl_chcpu_s"

/*C C_charge_cpu */
/* charge cpu variable generique */
#define TYPAP__C_charge_cpu "%scpu"

/*C C_charge_cpu_uor */
/* charge cpu */
#define TYPAP__C_charge_cpu_uor "uorcpu"

/*C C_charge_cpu_utd */
/* charge cpu */
#define TYPAP__C_charge_cpu_utd "utdcpu"

/*C C_charge_cpu_ugs */
/* charge cpu */
#define TYPAP__C_charge_cpu_ugs "ugscpu"

/*C C_charge_cpu_utr */
/* charge cpu */
#define TYPAP__C_charge_cpu_utr "utrcpu"

/*C C_charge_cpu_slh */
/* charge cpu */
#define TYPAP__C_charge_cpu_slh "hcpu"

/*C C_charge_cpu_slk */
/* charge cpu */
#define TYPAP__C_charge_cpu_slk "kcpu"

/*C C_charge_cpu_scla */
/* charge cpu */
#define TYPAP__C_charge_cpu_scla "acpu"


/* FIN Datagroupe  CTL_CH_CPU_S */
/* ---------------------------- */


/* Datagroupe  CTL_UTD_E */
/* --------------------- */

/*C C_ctl_utd_e */
/* datagroup en entree de l'UTD pour demarrer ou interrompre un process temps differe */
#define TYPAP__C_ctl_utd_e "ctl_utd_e"

/*C C_type_ta */
/* Type de Teleaction */
#define TYPAP__C_type_ta "typeta"

/*C C_Nom_du_client_cible */
/* Nom du client cible  */
#define TYPAP__C_nom_client "nomclient"

/* FIN Datagroupe  CTL_UTD_E */
/* ------------------------- */

/* Datagroupe  PAE_CR_TAL_E */
/* ------------------------ */

/*C C_pae_cr_tal_e */
/* datagroup de compte-rendu de teleaction pour PAE */
#define TYPAP__C_pae_cr_tal_e "pae_cr_tal_e"

/* FIN Datagroupe  PAE_CR_TAL_E */
/* ---------------------------- */

/*****************************************************************************/
/*                DEFINITIONS DES TYPES EXTERNES                             */
/*****************************************************************************/

/*T T_ident_station :  */
/* Identificateur de station.
    */
typedef enum {
	TYPAP__C_slk = 0, 
	TYPAP__C_slh = 1, 
	TYPAP__C_scl = 2 
} TYPAP__T_ident_station;

/*T T_pt_ident_station :  */
/* Pointeur sur identificateur de station. */
typedef  TYPAP__T_ident_station*  TYPAP__T_pt_ident_station;

/*T T_prefix_station :  */
/* Prefixe d'une station :
   - SLA => prefixe = A,
   - SLK => prefixe = K,
   - SLH => prefixe = H. */
typedef TYCST__T_char TYPAP__T_prefix_station;

/*T T_pt_prefix_station :  */
/* Pointeur sur prefixe d'une station. */
typedef TYPAP__T_prefix_station* TYPAP__T_pt_prefix_station; 

/*T T_id_cple_sta :  */
/* Identificateur de couple de station.
    */
typedef enum {
	TYPAP__C_slk_scl = 0, 
	TYPAP__C_slh_scl = 1, 
	TYPAP__C_slk_slh = 2
} TYPAP__T_id_cple_sta;


/*T T_pt_id_cple_sta :  */
/* Pointeur sur identificateur de couple de station. */
typedef  TYPAP__T_id_cple_sta*  TYPAP__T_pt_id_cple_sta;

/*T T_ident_gps :  */
/* Identificateur de satellite GPS.
    */
typedef TYCST__T_int4 TYPAP__T_ident_gps;


/*T T_pt_ident_gps :  */
/* Pointeur sur identificateur de satellite GPS. */
typedef TYPAP__T_ident_gps* TYPAP__T_pt_ident_gps;

/*T T_ident_geo :  */
/* Identificateur de satellite geostationnaire.
    */
typedef enum {
	TYPAP__C_aore = 0, 
	TYPAP__C_ior = 1
} TYPAP__T_ident_geo;

/*T T_pt_ident_geo :  */
/* Pointeur sur identificateur de satellite geostationnaire. */
typedef TYPAP__T_ident_geo* TYPAP__T_pt_ident_geo;

/*T T_orientation :  */
/* Direction de la manoeuvre d'orbite.
    */
typedef enum {
	TYPAP__C_est = 1, 
	TYPAP__C_ouest = 2, 
	TYPAP__C_nord = 3, 
	TYPAP__C_roues = 4
} TYPAP__T_orientation;

/*T T_pt_orientation :  */
/* Pointeur sur direction de la manoeuvre d'orbite. */
typedef  TYPAP__T_orientation* TYPAP__T_pt_orientation;

/*T T_status :  */
/* Type definissant le status retourne par les operations de l'objet. */
typedef TYCST__T_int2 TYPAP__T_status;

/*T T_client :  */
/* Type definissant le nom d'un client */
typedef TYCST__T_char TYPAP__T_client[TYPAP__C_lg_nom_client+2];

/*T T_pt_client :  */
/* Pointeur sur type definissant le nom d'un client */
typedef TYPAP__T_client* TYPAP__T_pt_client;

/*T T_composante :  */
/* Chaine de caracteres contenant le nom d'une composante.
    */
typedef TYCST__T_char  TYPAP__T_composante[TYPAP__C_lg_nom_composante+2];


/*T T_pt_composante :  */
/* Pointeur sur chaine de caracteres contenant le nom d'une composante.
    */
typedef TYPAP__T_composante*  TYPAP__T_pt_composante;

/*****************************************************************************/
/*              DECLARATIONS DES OPERATIONS EXTERNES (extern)                */
/*****************************************************************************/

/*****************************************************************************/
/* DECLARATION : Get_stations                                                */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Pour un couple de station retourne les 2 stations composant */
/*             : le couple.                                                  */
/*****************************************************************************/

#ifndef ATTOL
extern
TYPAP__T_status
TYPAP__Get_stations(
	const TYPAP__T_id_cple_sta Couple_station, 
	TYPAP__T_pt_ident_station Station1, 
	TYPAP__T_pt_ident_station Station2
	);

#else
extern
TYPAP__T_status
TYPAP__Get_stations(
	const TYPAP__T_id_cple_sta Couple_station, 
	TYPAP__T_ident_station *Station1, 
	TYPAP__T_ident_station *Station2
	);
#endif



/*****************************************************************************/
/* DECLARATION : Get_prefix_station                                          */
/*---------------------------------------------------------------------------*/
/* DESCRIPTION : Pour une station retourne son prefixe.                      */
/*****************************************************************************/

#ifndef ATTOL
extern
TYPAP__T_status
TYPAP__Get_prefix_station(
	const TYPAP__T_ident_station Station, 
	TYPAP__T_pt_prefix_station Prefix
	);
#else        
extern
TYPAP__T_status
TYPAP__Get_prefix_station(
	const TYPAP__T_ident_station Station, 
	TYPAP__T_prefix_station *Prefix
	);
#endif



			/* FIN DE TYPAP.h */
#endif
