/*$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/BAS/src/SD_BAS_DECOM_yacc.y,v 1.3 2011/11/25 10:17:45 dpauly Exp $*/
%{
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_BAS
//@ MODULE : SD_BAS_DECOM
//@
//@ Comment :
//@    yacc code file for the  SD_BAS_DECOM class which includes the
//@    commutation / decommutation rules
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ AUTEUR            : A.MONTMORY
//@ DATE DE CREATION  : 01/06/97
//@ EURIDIS / REALISATION PAR SYSECA SA
//@ --------------------------------------------------------------------
//@ FA-ID :IA--CR-2100-269-CNE : 08/06/2005 : JL PASCAL
//@ test du nombre de pixel AVHRR et nombre de point de geoloc
//@ fiche de correction correspondante : IA-2100-FC-269-THA
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

/*****************************************************************************/
/*                           IDENTIFICATION BINAIRE                          */
/*****************************************************************************/

/* static char id[]="@(#) DECOM_yacc.y 1.1 97/01/06"; */

/* FIN CARTOUCHE */

#include "SD_BAS_DECOM_DECOMMUTATION.c"
#include <math.h>
/*****************************************************************************/
/*                  VARIABLES GLOBALES A L'OBJET (static)                    */
/*****************************************************************************/

/*V G_bloc_courant :  */
/* Variable pointant vers le bloc en cours d'analyse. */

static
DECOM__T_desc_bloc G_bloc_courant;

/*V G_variable_courante :  */
/* Variable pointant vers le bloc en cours d'analyse. */

static
DECOM__T_desc_var G_variable_courante;


/*V G_status :  */

/* Status en cours d'analyse. */

static
TYCST__T_int4 G_status;

/* FT-2765 */
static
TYCST__T_int4
yyerror(
	const TYCST__T_pt_char string
	);
/* ...FT-2765 */

%}

%start descripteur
%union {
	int ival;
	double fval;
	char sval[256];
	unsigned char sep;
	}	
%token T_VERSION T_BLOC T_BRUT T_ASCII T_NOM  T_DIM T_LG T_INIT T_VAR T_OFFSET T_BIT
%token T_CONV T_PARAM_CONV
%token T_RANG T_SEP T_TYPE_SEP T_FINVAR T_FINBLOC T_INT T_COMMENT
%token T_IDENT	
%token T_FLOAT
%%
descripteur 	: T_VERSION T_INT section_bloc 
            	;
            	
section_bloc	: | section_bloc bloc_type ;

bloc_type 	: bloc_type_brute | bloc_type_ascii; 

bloc_type_brute	: T_BLOC
                  {
                     bzero (&G_bloc_courant,sizeof (DECOM__T_desc_bloc));
                  } 
                  T_BRUT 
                  {
                     G_bloc_courant.type = DECOM__C_type_binaire;
                  }
                  bloc_brute 
                  T_FINBLOC
                  {
                     G_status = DECOM__Enregistrer_bloc (&G_bloc_courant);
                     if (G_status != DECOM__C_ok){
		        yyerror ("Enregistrer bloc");
		     }
		  }
                  ;

bloc_type_ascii	: T_BLOC 
                  {
                     bzero (&G_bloc_courant,sizeof (DECOM__T_desc_bloc));
                  }
		  T_ASCII 
                  {
                     G_bloc_courant.type = DECOM__C_type_ascii;
                  }
                  bloc_ascii 
                  T_FINBLOC
                  {
                     G_status = DECOM__Enregistrer_bloc (&G_bloc_courant);
                     if (G_status != DECOM__C_ok){
		        yyerror ("Enregistrer bloc");
		     }
                  }
                  ;
		  
bloc_brute	: T_NOM T_IDENT 
                  { 
                     strcpy (G_bloc_courant.nom, yylval.sval);
                  } 
		  T_LG T_INT 
		  { 
		     G_bloc_courant.lg = yylval.ival; 
		  }
		  T_INIT T_INT 
		  { 
		     G_bloc_courant.val_init = yylval.ival; 
                  }
		  liste_var_brute;
		  
liste_var_brute	: | liste_var_brute var_position ;

		  
bloc_ascii	: T_NOM T_IDENT 
                  { 
                     strcpy (G_bloc_courant.nom, yylval.sval); 
                  } 
                  T_LG T_INT 
		  { 
		     G_bloc_courant.lg = yylval.ival; 
		  }
		  T_SEP T_TYPE_SEP 
		  {
		     G_bloc_courant.separateur = yylval.sep;
		  }
		  T_INIT T_INT 
		  { 
		     G_bloc_courant.val_init = yylval.ival; 
                  } 
                  liste_var_ascii;

liste_var_ascii	: | liste_var_ascii var_ascii;

var_ascii	: var_separateur | var_position;

var_separateur	: var_ident var_rang conversion;

var_ident	: T_VAR         T_IDENT
		  { 
		     bzero (&G_variable_courante,sizeof (DECOM__T_desc_var));
		     strcpy (G_variable_courante.nom, yylval.sval);
		  };
		  
var_rang	: T_RANG        T_INT
		  {
		     G_variable_courante.offset = yylval.ival;
		  }
		  ;
		  
var_position	: var_ident var_offset var_dim conversion;

var_offset	: offset longueur ;

offset : T_OFFSET	T_INT
		  {
/*CR 269 on prevoit les blocs ASCII*/
		 if ( G_bloc_courant.type != DECOM__C_type_ascii )
		   {
		     G_variable_courante.offset = yylval.ival*8;
		     G_variable_courante.isoffsetbit = TYCST__C_faux;
		   }
		   else
		   {
		     G_variable_courante.offset = yylval.ival;
		     G_variable_courante.isoffsetbit = TYCST__C_faux;
		   }
		  }
      | T_OFFSET	T_BIT T_INT
		  {
		     G_variable_courante.offset = yylval.ival;
		     G_variable_courante.isoffsetbit = TYCST__C_vrai;
		  }
      ;

longueur : T_LG	T_INT
		  {
		     G_variable_courante.lg = yylval.ival*8;
		     G_variable_courante.islgbit = TYCST__C_faux;
		  }
      | T_LG	T_BIT T_INT
		  {
		     G_variable_courante.lg = yylval.ival;
		     G_variable_courante.islgbit = TYCST__C_vrai;
		  }
      ;

var_dim   	: |
                  T_DIM	        T_INT
		  {
		     G_variable_courante.dim = yylval.ival;
		  }
                  ;

conversion :	  T_CONV        T_IDENT
		  {
		     int type_input;
		     strcpy(G_variable_courante.nomcv,yylval.sval);
		     G_variable_courante.decom.proc_conv = 
		      DECOM__Retourner_pt_conversion(G_variable_courante.nomcv,&type_input);
		     if (G_variable_courante.decom.proc_conv == NULL) {
		        G_status = DECOM__C_err_fct_conversion;
		        yyerror ("fonction conversion inconnue");
		     }
		    
		  }
		  T_PARAM_CONV  suite_par 
		  T_FINVAR
		  {
		     G_status = DECOM__Enregistrer_variable (&G_bloc_courant,
		                                             &G_variable_courante);
		     
		     if (G_status != DECOM__C_ok){
		        yyerror ("Enregistrer variable");
		     }
		  }
		  ;


suite_par	: | suite_par par;		  

par		: T_INT 
                  {
                    int nb_par = G_variable_courante.decom.nb_param;
                    G_variable_courante.decom.param[nb_par] =
                    (TYCST__T_real8) yylval.ival;
                    G_variable_courante.decom.nb_param = nb_par + 1;
                  }
                  | T_FLOAT
                  {
                    int nb_par = G_variable_courante.decom.nb_param;
                    G_variable_courante.decom.param[nb_par] = 
                    (TYCST__T_real8) yylval.fval;
                    G_variable_courante.decom.nb_param = nb_par + 1;
                  };


%%

/*****************************************************************************/
/*                    CLAUSES DE VISIBILITE (#include)                       */
/*****************************************************************************/

#include <stdio.h>
#include "lex.yy.c"



/*****************************************************************************/
/* PROCEDURE : yyerror                                                       */
/*---------------------------------------------------------------------------*/
/* ROLE      : permet de logger une erreur survenue au cours de l'analyse.    */
/*****************************************************************************/

static
TYCST__T_int4
yyerror(
	const TYCST__T_pt_char string
	)
{

/* FT-2765 */
#ifdef AIX
  printf ("Erreur ,%s, dans l'analyse a la ligne %d\n",string,yylineno);
#endif
/* ...FT-2765 */
  printf ("Token courant ,%s, \n", yytext);
  exit(1);

  return 0; 
}

          
 
 
    
 
 
 
 
 


 
 
 
 
 
           
