//$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/BAS/src/SD_BAS_Niveau1.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//MODIFIED 14 Juin 2006 for WorkAround-V3.5.4
//@ --------------------------------------------------------------------
//@ Component : SD_BAS
//@ MODULE : SD_BAS_Niveau1
//@
//@ Comment :
//@    include file for the SD_BAS_Niveau1 class
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 09/01/2003 : [reference :] ott
//@ --------------------------------------------------------------------
//@ VERSION : 04/09/2003 : [reference :] Benjamin MASSART
//@ cette version prend en compte les evolutions du code pour une gestion
//@ dynamique de l'ecriture des IPR dans les produits de niveau 1 suite
//@ aux modifications apparues dans la version 6.4 du GPFS et la version
//@ 6.5 du IASI Level 1 Product Format Specification
//@ --------------------------------------------------------------------
//@ DM-ID :PM-3 : 04/09/2003 :
//@ -mise a jour des numeros de RECORD SUBCLASS
//@ -les tailles de RECORD on ete deplacees de SD_BAS_Niveau1.c pour etre
//@  accessibles depuis SD_DON_GranuleN1.cc
//@ -ajout de SD_BAS_MDR_DUMMY_SUBCLASS = 5 qui n'apparait pas dans 
//@  la version 6.5 du IASI Level 1 Product Format Specification
//@  constante qui valait 1 (codee en dur) et qui rentrait en conflit avec
//@  le code SD_BAS_MDR_B_SUBCLASS
//@ --------------------------------------------------------------------
//@ DM-ID : IA-CR-0000-231-CNE : 31/03/2004 : B. MASSART
//@ -mise a jour dimensions de SD_BAS_TAILLE_MAX_MDR_1AB
//@ -mise a jour dimensions de SD_BAS_TAILLE_MAX_MDR_1C
//@ -mise a jour dimensions de SD_BAS_TAILLE_MAX_MDRENG
//@ --------------------------------------------------------------------
//@ DM-ID : IA-CR-0000-177-CNE : 31/03/2004 : B. MASSART
//@ ajout ENG_GOPSFLAGEOAVHRRMISS dans MDR_ENG
//@ --------------------------------------------------------------------
//@ DM-ID : PM4 : 31/03/2004 : B. MASSART
//@ -correction syntaxe N1C_GQISQUALINDEXIIS
//@ -correction syntaxe N1C_IDEFCCSCHANNELID
//@ -correction syntaxe ENG_GOPSFLTISRFEMOFF
//@ -correction syntaxe ENG_GOPSDATISRFEMOFF
//@ -correction syntaxe ENG_GOPSFLAIISCALIBMISS
//@ --------------------------------------------------------------------
//@ DM-ID :IA-CR-2100-246-CNE : 06/07/2004 : B. MASSART
//@ word # 16 in level 0 PX packets is no more read as part of PTSI number
//@ Variable ONBOARD_SOFTWARE_VERSION added in ENG, 1A, 1B and 1C products
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-148-CN : 10/11/2004 : B.MASSART
//@ Mise a jour de SD_BAS_IASIN1_VERSION = 6.6. Voir IA-2100-FC-148-THA.
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-152-CN : 28/01/2005 : JL PASCAL
//@ Mise a jour des versions MDR VUADR GIADR produit.
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-180-CN : 30/08/2006 : C.MERIGUET
//@ Mise a jour de l'entete MPHR en mode DUMP
//@ --------------------------------------------------------------------
//@ DM-ID :IA-CR-2100-306-CNE : 15/09/2006 : C.MERIGUET
//@ Mise a jour de SD_BAS_IASIN1_VERSION, la version passe a 10.0
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-CR-162-CN : 09/2006 : C.MERIGUET
//@ Gestion des IPR en mode DUMP
//@ --------------------------------------------------------------------
//@ FA-ID : IA-2100-FA-196-CN : 15/01/2007 : C.MERIGUET
//@ FA-ID : IA-2100-FA-198-CN : 15/01/2007 : C.MERIGUET
//@ Ces 2 FA sont traitees conjointement. Recuperation du PTSI lu dans 
//@ le mot 17 (2 octets) mais ecriture dans le champ PTSI des N1 des mots 
//@ 16 (version logiciel bord) et 17 (ptsi) (4 octets).
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2521(DM-2100-OPS) : 19/12/2008 : S. BRUNEL
//@ Calcul de 4 pseudo-canaux AVHRR (Day 2,point 2)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2522(DM-2100-OPS) : 19/12/2008 : S. BRUNEL
//@ Ajout de variables dans les produits L1C et ENG  (Day 2,point 3)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2523(DM-2100-OPS) : 19/12/2008 : S. BRUNEL
//@ Include BArcImagMeanRMS dans le produit ENG (Day 2,point 4)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2524(DM-2100-OPS) : 19/12/2008 : S. BRUNEL
//@ Ajouter un indice et un flag dans l'algorithme 22_SSD (Day 2,point 5)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2525(DM-2100-OPS) : 19/12/2008 : S. BRUNEL
//@ Modification du GQisFlagQual, ajout d'informations sur la cause de
//@ la rejection (Day 2,point 6)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2526(DM-2100-OPS) : 19/12/2008 : S. BRUNEL
//@ Include les differences de NZPD interpixel dans le produit 
//@ ENG (Day 2,point 7)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2528(DM-2100-OPS) : 19/12/2008 : S. BRUNEL
//@ Ajouter les informations sur les nuages et la surface obtenue
//@ par AVHRR dans le produit L1C (Day 2,point 9)
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2557(FA-2100-OPS) : 02/02/2009 : S. BRUNEL
//@ Non conformite des produits generes par la V4-2-1 a la PFS Day-2
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2635(FA-2100-OPS) : 11/06/2009 : S. BRUNEL
//@ Mise a jour des numeros de version des MDR 1A, 1B, 1C et ENG
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------



#ifndef SD_BAS_Niveau1_h
#define SD_BAS_Niveau1_h


// inserer ici les fichiers include 
#include "SD_BAS_Global.h"
#include "SD_BAS_Produits.h"
#include "CMN__Commun.h"
#include "SD_BAS_ConfStable.h"

//====================================================================*/
//   External define  Declarations
//====================================================================*/
// taille des different record avec GRH

//====================================================================*/
// Constant Declaration 
//====================================================================*/

#define SD_BAS_ERR_BASE_N1               SD_BAS_ERR_BASE_Niveau1
#define SD_BAS_ERR_VERSION_N1           (SD_BAS_ERR_BASE_N1 + 1)
#define SD_BAS_ERR_NATURE               (SD_BAS_ERR_BASE_N1 + 2)
#define SD_BAS_ERR_TRAITEMENT_SPECTRE   (SD_BAS_ERR_BASE_N1 + 3)
#define SD_BAS_ERR_TAILLE_SPECTRE       (SD_BAS_ERR_BASE_N1 + 4)
#define SD_BAS_ERR_TAILLE_IMAGE         (SD_BAS_ERR_BASE_N1 + 5)
#define SD_BAS_ERR_MDR                  (SD_BAS_ERR_BASE_N1 + 6)

/* liste des RECORD SUBCLASS definie dans la version 6.5 */
/* du IASI Level 1 Product Format Specification */
#define SD_BAS_MDR_A_SUBCLASS     0
#define SD_BAS_MDR_B_SUBCLASS     1
#define SD_BAS_MDR_C_SUBCLASS     2
#define SD_BAS_MDR_ENG_SUBCLASS   3
#define SD_BAS_MDR_VER_SUBCLASS   4
#define SD_BAS_MDR_DUMMY_SUBCLASS 1
#define SD_BAS_GIADR_SCA_SUBCLASS 1
#define SD_BAS_GIADR_QUA_SUBCLASS 0
#define SD_BAS_GIADR_ENG_SUBCLASS 2
#define SD_BAS_VIADR_ENG_SUBCLASS 0

// FT-2765
static const int SD_BAS_TAILLE_MAX_GIADRQUAL = 228346;
static const int SD_BAS_TAILLE_GIADR_SCA     = 84;

/* FT-2525 */
static const int SD_BAS_TAILLE_MAX_MDR_1AB   = 2365790;
/* ..FT-2525 */

/* FT-2522,FT-2525,FT-2528  */
static const int SD_BAS_TAILLE_MAX_MDR_1C    = 2728908;
/* ..FT-2522,FT-2525,FT-2528  */

static const int SD_BAS_TAILLE_MAX_GIADR_ENG = 70 ;
static const int SD_BAS_TAILLE_MAX_VIADRENG  = 9312;

/* FT-2521,FT-2522,FT-2523,FT-2524,FT-2525,FT-2526,FT-2528 */
static const int SD_BAS_TAILLE_MAX_MDRENG    = 126669;
/* ..FT-2521,FT-2522,FT-2523,FT-2524,FT-2525,FT-2526,FT-2528 */

static const int SD_BAS_TAILLE_DUMMY         = 21; /* taille des DMDR */

static const int SD_BAS_ERR_SET_Niveau1 = 1;
// ...FT-2765

//====================================================================*/
// Exported types Declaration  
//====================================================================*/
// 
// les valeurs doivent etre au depart initialises a 0 et les flag a faux
//@ REMARQUE : dans les cas ou des CGxx ne permettent pas l'execution
//@ les donnees en sortie doivent etre egalement initialisees a des
//@ valeurs factices (0)

//--------------------------------------------------------------------*/
// type definissant le type de record de niveau 1
//--------------------------------------------------------------------*/
typedef enum 
	{
	AT_1A=0,
	AT_1B=1,
	AT_1C=2,
	AT_IMAGE=3
	} e_SD_BAS_Atraiter; 

typedef enum
  {
    ENCODE=0,
    DECODE=1
  }e_SD_BAS_Sens;

//--------------------------------------------------------------------*/
// type definissant le type de record de niveau 1
//--------------------------------------------------------------------*/
typedef enum 
	{
	MDR_1A=0,
	MDR_1B=1,
	MDR_1C=2,
	MDR_ENG =3,
	MDR_VER=4,
	VIADR_ENG=5,
	GIADR_SCA=6,
	GIADR_QUA=7,
	GIADR_ENG=8,
	MDR_DUMMY=9,
	VIADR_DUMMY=10

	} e_BAS_TypeRecN1; 

//--------------------------------------------------------------------*/
// structure contenant les informations generales issues d'un MDR de N1
// cette structure est retournee par la fonctions de parcourt rapide
//--------------------------------------------------------------------*/
// attention l'ordre suivant doit correspondre a l'ordre dans le fichier
// ASCII de decommutation
// FA 196 et 198: suppression N1_ONBOARD_SOFTWARE_VERSION (contenu dans PTSI)
typedef enum  {
  N1_DATEDEB,
  N1_DATEFIN,
  N1_MODE,
  N1_PTSI,
  N1_GEPSDATIASI,
  N1_TYPEREC,
  N1_LONGUEURREC,
  N1_OFFSET,
  N1_VALIDREC,
  N1_FLAG
} e_SD_BAS_IND_DonGenN1;
// ..FA 196 et 198


	
//--------------------------------------------------------------------*/
// structure contenant les informations codees  d'un MDR de N1
//--------------------------------------------------------------------*/
// la taille du MDR a ete allouee par l'appelant de la couche (cf constantes)
typedef struct 
	{
	int	lgsp; // longueur de chaque tableau datasp ( si besoin)
	char    * datasp[3]; //  MDR utilise par les fonctions de lecture detaillees
		         // on stocke ici uniquement les donnees spectres codees
			 // qui contiennent selon le cas (TypePdt):
	// 1A : spectre 1A dans datasp[0] 
	// 1B : spectre 1B dans datasp[1]
	// 1C : spectre 1C dans datasp[2]
	// 1A1B1C : spectre 1A [0] + spectre 1B [1] + spectre 1C [2]
	// 1B1C : spectre 1B [1] + spectre 1C [2]
	int	lgim; // longueur du tableau dataim
	char    * dataim; //  MDR utilise par les fonctions de lecture detaillees
		         // on stocke ici uniquement les donnees images codees
			 // dans le cas des MDR de type 1ABC
	} t_SD_BAS_DonCodN1; 
	

//--------------------------------------------------------------------*/
// type definissant les resultats specifiques contenus dans les le MDR de type
// N1ABC
//--------------------------------------------------------------------*/
// attention l'odre suivant doit correspondre a l'ordre dans le fichier
// ASCII de decommutation

//Donnees communes au niveaux 1A et 1B
/* cette liste_var reste compatible mais est obsolete il est preferable d'utiliser 
e_SD_BAS_IND_DonDetMDRN1C */
// FA 196 et 198: suppression N1_ONBOARD_SOFTWARE_VERSION (contenu dans PTSI)
typedef enum  {
    N1AB_DATEDEB, 
    N1AB_DATEFIN, 
    N1AB_DEGRADED_INST_MDR,
    N1AB_DEGRADED_PROC_MDR,
    N1AB_INSTRUMENT_MODE,
    N1AB_SCAN_POSITION,
    N1AB_LEVEL,
    N1AB_MODE,
    N1AB_DEBUG_MODE,
    N1AB_INTERFACE_MODE,
    N1AB_TARGET,
    N1AB_PTSI,
    N1AB_IDEFIDCONF,
    N1AB_NORMAL_PROCESSING_MODE,
    N1AB_BACKLOG_PROCESSING_MODE,
    N1AB_REPROCESSING_MODE,
    N1AB_PARALLEL_VALIDATION,
    N1AB_MANOEUVRE,
    N1AB_DEGRADED_CASES,
    N1AB_GEPSLOCIASIAVHRR_IASI,
    N1AB_GEPSLOCIASIAVHRR_IIS,
    N1AB_OBT,
    N1AB_ONBOARD_UTC,
    N1AB_GEPSDATIASI,
    N1AB_GISFLINORIGIN,
    N1AB_GISFCOLORIGIN,
    N1AB_GISFPDS1,
    N1AB_GISFPDS2,
    N1AB_GISFPDS3,
    N1AB_GISFPDS4,
    N1AB_GEPS_CCD,
    N1AB_GEPS_SP,
    N1AB_GQISFLAGQUAL,
    N1AB_GQISFLAGQUALDETAILED, // FT-2557
    N1AB_GQISQUALINDEX,
    N1AB_GQISQUALINDEIIS,
    N1AB_GQISQUALINDEXLOC,
    N1AB_GQISQUALINDEXRAD,
    N1AB_GQISQUALINDEXSPECT,
    N1AB_GQISSYSTECIISQUAL,
    N1AB_GQISSYSTECSONDQUAL,
    N1AB_GGEOSONDLOC,
    N1AB_GGEOSONDANGLESMETOP,
    N1AB_GGEOIISANGLESMETOP,
    N1AB_GGEOSONDANGLESSUN,
    N1AB_GGEOIISANGLESSUN,
    N1AB_GGEOIISLOC,
    N1AB_EARTH_SATELLITE_DISTANCE
    
} e_SD_BAS_IND_DonDetMDRN1AB;

/* indice des listevar communes aux  produits 1ABC */
typedef enum  {
  N1C_DATEDEB, 
  N1C_DATEFIN, 
  N1C_DEGRADED_INST_MDR,
  N1C_DEGRADED_PROC_MDR,
  N1C_INSTRUMENT_MODE,
  N1C_SCAN_POSITION,
  N1C_LEVEL,
  N1C_MODE,
  N1C_DEBUG_MODE,
  N1C_INTERFACE_MODE,
  N1C_TARGET,
  N1C_PTSI,
  N1C_IDEFIDCONF,
  N1C_NORMAL_PROCESSING_MODE,
  N1C_BACKLOG_PROCESSING_MODE,
  N1C_REPROCESSING_MODE,
  N1C_PARALLEL_VALIDATION,
  N1C_MANOEUVRE,
  N1C_DEGRADED_CASES,
  N1C_GEPSLOCIASIAVHRR_IASI,
  N1C_GEPSLOCIASIAVHRR_IIS,
  N1C_OBT,
  N1C_ONBOARD_UTC,
  N1C_GEPSDATIASI,
  N1C_GISFLINORIGIN,
  N1C_GISFCOLORIGIN,
  N1C_GISFPDS1,
  N1C_GISFPDS2,
  N1C_GISFPDS3,
  N1C_GISFPDS4,
  N1C_GEPS_CCD,
  N1C_GEPS_SP,
  N1C_GQISFLAGQUAL,
  N1C_GQISFLAGQUALDETAILED, // FT-2525 
  N1C_GQISQUALINDEX,
  N1C_GQISQUALINDEXIIS,
  N1C_GQISQUALINDEXLOC,
  N1C_GQISQUALINDEXRAD,
  N1C_GQISQUALINDEXSPECT,
  N1C_GQISSYSTECIISQUAL,
  N1C_GQISSYSTECSONDQUAL,
  N1C_GGEOSONDLOC,
  N1C_GGEOSONDANGLESMETOP,
  N1C_GGEOIISANGLESMETOP,
  N1C_GGEOSONDANGLESSUN,
  N1C_GGEOIISANGLESSUN,
  N1C_GGEOIISLOC,
  N1C_EARTH_SATELLITE_DISTANCE, // dernier element commun
  N1C_IDEFSPECTDWN1B,           // 1B 1c
  N1C_IDEFNSFIRST1B,            // 1B 1c
  N1C_IDEFNSLAST1B,             // 1B 1c
  N1C_IDEFCOVARMATEIGENVAL1C,   // 1C
  N1C_IDEFCCSCHANNELID,         // 1C
  N1C_GCCSRADANALNBCLASS,       // 1C
  N1C_GCCSRADANALWGT,           // 1C
  N1C_GCCSRADANALY,             // 1C
  N1C_GCCSRADANALZ,             // 1C
  N1C_GCCSRADANALMEAN,          // 1C
  N1C_GCCSRADANALSTD,           // 1C
  N1C_GCCSIMAGECLASSIFIED,      // 1C
  N1C_IDEFCCSMODE,              // 1C
  N1C_GCCSIMAGECLASSIFIEDNBLIN, // 1C
  N1C_GCCSIMAGECLASSIFIEDNBCOL, // 1C
  N1C_GCCSIMAGECLASSIFIEDFIRSTLIN,// 1C
  N1C_GCCSIMAGECLASSIFIEDFIRSTCOL,// 1C
  N1C_GCCSRADANALTYPE,            // 1C
  N1C_GIACVARIMAGIIS,             // 1C, FT-2522
  N1C_GIACAVGIMAGIIS,             // 1C, FT-2522
  N1C_GEUMAVHRR1BCLDFRAC,         // 1C, FT-2528
  N1C_GEUMAVHRR1BLANDFRAC,        // 1C, FT-2528
  N1C_GEUMAVHRR1BQUAL,            // 1C, FT-2528
  N1A_IDEFSPECTDWN,               // 1A
  N1A_IDEFNSFIRST,                // 1A
  N1A_IDEFNSLAST,                 // 1A
  N1B_IDEFCOVARMATEIGENVAL1B      // 1A 1B
  
} e_SD_BAS_IND_DonDetMDRN1C;



//--------------------------------------------------------------------*/
// type definissant les resultats specifiques contenus dans les MDR de type ENG
//--------------------------------------------------------------------*/
// attention l'odre suivant doit correspondre a l'ordre dans le fichier
// ASCII de decommutation
typedef enum  {
  ENG_DATEDEB,
  ENG_DATEFIN,
  ENG_BIMSBBT,
  ENG_GFTBFILTEREDBBT,
  ENG_PTSI,
  ENG_IDEFIDCONF,
  ENG_NORMAL_PROCESSING_MODE,
  ENG_BACKLOG_PROCESSING_MODE,
  ENG_REPROCESSING_MODE,
  ENG_PARALLEL_VALIDATION,
  ENG_MANOEUVRE,
  ENG_DEGRADED_CASES,
  ENG_INSTRUMENT_MODE,
  ENG_SCAN_POSITION,
  ENG_GCCSCONFAVHRRCHANNEL,
  ENG_GEPSGRANULNUMBER,
  ENG_GEPSDATIASI,
  ENG_LEVEL,
  ENG_MODE,
  ENG_DEBUG_MODE,
  ENG_INTERFACE_MODE,
  ENG_TARGET,
  ENG_GEPS_SP,
  ENG_GEPS_CCD,
  ENG_CGEOSUBSATELLITEPOSITION,
  ENG_GEPSOPSFLAGNAN,
  ENG_GEPSENDECLIPSETIME,
  ENG_GSMETSCAN,
  ENG_GSMEFLAGDATENOK,
  ENG_GFTBBBTRES,
  ENG_GFTBFLAGBBTNONQUAL,
  ENG_GEPS_LN,
  ENG_GDOCFLAGUNDEROVERFLOW,
  ENG_GDOCNBUNDERFLOW,
  ENG_GDOCNBOVERFLOW,
  ENG_GDOCPOSUNDERFLOW,
  ENG_GDOCPOSOVERFLOW,
  ENG_BCODSPECVERIFF,
  ENG_GIACOFFSETIISAVHRR,
  ENG_GIACCORRELQUAL,
  ENG_GIACPOSMAXQUAL,
  ENG_GIACFLAGCOREGNONVALID,
  ENG_GIACFLAGCOREGNONQUAL,
  ENG_GIACVARIMAGIIS,
  ENG_GIACAVGIMAGIIS, /* FT-2522 */
  ENG_GEUMAVHRR1BCLDFRAC, /* FT-2528 */
  ENG_GEUMAVHRR1BLANDFRAC, /* FT-2528 */
  ENG_GEUMAVHRR1BQUAL, /* FT-2528 */
  ENG_GCCSOFFSETSONDAVHRR,
  ENG_GCCSOFFSETSONDIIS,
  ENG_GCCSQUALINDEX, 
  ENG_GCCSFLAGDATENOK,
  ENG_GPCHAVHRRPSEUDOCHN, /* FT-2521 */
  ENG_CGCCSRADANALNBCLASS,
  ENG_GCCSFLAGPOSTPROCESSING,
  ENG_GCCSNONCLASSIFRATE,
  ENG_GCCSVARIANCERATE,
  ENG_GSSDCONVERFLAG, /* FT-2524 */
  ENG_GSSDWNSHIFT,
  ENG_GSSDWNSHIFTQUAL,
  ENG_GSSDFLAGSPECTRALSHIFTNONQUAL,
  ENG_GSSSWNSHIFTMEAN, 
  ENG_GSSSWNSHIFTMEANQUAL,
  ENG_GSSSFLAGNONSELPX,
  ENG_GSSSFLAGDATENOK,
  ENG_GIAXAXEY,
  ENG_GIAXAXEZ,
  ENG_GIAXFLAGAXENONQUAL,
  ENG_GIAXAXEQUAL,
  ENG_GIAXAXERES,
  ENG_GFAXAXEY,
  ENG_GFAXAXEZ,
  ENG_GFAXFLAGAXENONQUAL,
  ENG_GFAXAXERES,
  ENG_GISFFLAGPDSNONVALID,
  ENG_GICCRADCALOFFSETIMAG,
  ENG_GICCRADCALSLOPEIMAG,
  ENG_GICCFLAGINIT,
  ENG_GQISFLAGQUAL,
  ENG_GQISFLAGQUALDETAILED, /* FT-2525 */
  ENG_GQISQUALINDEX,
  ENG_GQISQUALINDEXIIS,
  ENG_GQISQUALINDEXLOC,
  ENG_GQISQUALINDEXRAD,
  ENG_GQISQUALINDEXSPECT,
  ENG_MHIPNZPDINTERPIXEL, /* FT-2526 */
  ENG_MHIPFLAGINTERPIXNZPDNONQUAL, /* FT-2526 */
  ENG_MMCXNOISECALRAD,
  ENG_MMCXBIASCALRAD,
  ENG_MMCXFLAGNOISECALRAD,
  ENG_MMCXFLAGBIASCALRAD,
  ENG_MMCXCOEFFCALRAD,
  ENG_MDPTVARIMAGMAX, 
  ENG_MDPTVARIMAGMEAN,
  ENG_MDPTPIXQUAL,
  ENG_GHECFLAGDATENOK,
  ENG_DATA_PX,
  ENG_DATA_IP,
  ENG_EQUALIZATION_COUNTER,
  ENG_GOPSFLAPIXMISS,
  ENG_GOPSFLADATAGAP,
  ENG_GOPSFLTISRFEMOFF,
  ENG_GOPSDATISRFEMOFF,
  ENG_GOPSFLTBANDMISS,
  ENG_GOPSDATBANDMISS,
  ENG_GOPSFLTBBTMISS,
  ENG_GOPSDATBBTMISS,
  ENG_GOPSFLTIMGEWMISS,
  ENG_GOPSDATIMGEWMISS,
  ENG_GOPSFLTIMGBBMISS,
  ENG_GOPSDATIMGBBMISS,
  ENG_GOPSFLTIMGCSMISS,
  ENG_GOPSDATIMGCSMISS,
  ENG_GOPSFLAIISCALIBMISS,
  ENG_GOPSFLTRADAVHRRMISS,
  ENG_GOPSDATRADAVHRRMISS,
  ENG_GOPSFLAGPACKETVPMISS,
  ENG_GOPSFLAGPACKETAPMISS,
  ENG_GOPSFLAGPACKETPXMISS,
  ENG_GOPSFLAGPACKETIPMISS, 
  ENG_GOPSFLAGEOAVHRRMISS /* PM4 CR177 */
  
} e_SD_BAS_IND_DonDetMDRN1ENG;

// ..FA 196 et 198



//--------------------------------------------------------------------*/
// type definissant les resultats specifiques contenus dans les MDR de type VER
//--------------------------------------------------------------------*/
// attention l'odre suivant doit correspondre a l'ordre dans le fichier
// ASCII de decommutation
typedef enum  {
  VER_DATEDEB,
  VER_DATEFIN,
  VER_SIZE_OF_VERIFICATION_DATA,
  VER_SN,
  VER_PN
		} e_SD_BAS_IND_DonDetMDRN1VER;




//--------------------------------------------------------------------*/
// type definissant les resultats specifiques contenus dans le VIADR de type ENG
//--------------------------------------------------------------------*/
// attention l'odre suivant doit correspondre a l'ordre dans le fichier
// ASCII de decommutation
typedef enum  {
  VIADRENG_DATEDEB,
  VIADRENG_DATEFIN,
  VIADRENG_MEXSSMIN,
  VIADRENG_MEXSSMAX,
  VIADRENG_MDPTIISBADHEALTHPIX,
  VIADRENG_MDPTIISINHOMPIX
		  } e_SD_BAS_IND_DonDetVIADRN1ENG;


//--------------------------------------------------------------------*/
// structure contenant les informations utiles issues d'un MDR ou VIADR
// de N1 
// cette structure est retournee par les fonctions de lecture detaillees
// cett fonction est appelees apres la fonction de parcourt rapide
// en entree on indique l'offset du record a lire dans le produit et le type d'ISP
// sequence d'appel:
// 1 : lecture rapide
// 2 : lecture detaillee selon le type
// 3 :   allocation memoire en fonction du type lu  pour InfoDet2 (interne)
// 4 :   allocation  memoire en fonction du type lu  pour InfoCod (interne)
// 5 :   lecture  puis decodage InfoDet
// 5 : liberation ( fonction specifique) a mettre dans le destructeur
//
// pour l'ecriture :
// 4 : init ecriture
// 1 :   allocation memoire en fonction du type souhaite pour InfoDet2 (interne)
// 2 :   allocation  memoire en fonction du type souhaita pour InfoCod (interne)
// 3 : 	 allocation memoire  de  InfoCalc pour les variables de calcul (interne)
//	 les tableaux internes de calcul sont si besoin alloues avant initialisation 
//	( dans  xx_init ou autre)
// 3 : initialisation des valeurs par l'appelant
// 4 : ecriture
// 5 : liberation des donnees allouees apres ecriture (fonction specifique a mettre dans le
// destructeur)

//--------------------------------------------------------------------*/
typedef struct 
	{
	e_BAS_TypeRecN1 TypeRec; 	// type de record 1A 1B 1C ENG ...
	t_SD_BAS_Liste_Var InfoGen; // info generales 
		// ceci est utilise et alloue uniquement en lecture
	t_SD_BAS_DonCodN1 *InfoCod;  // info non decodees
		// ceci est rempli par la fonction de lecture detaillee
		// ceci est utilise par la fonction d'ecriture detaillee
	t_SD_BAS_Liste_Var InfoDet;	
		// ceci est  alloue par les fonction de lecture detaillee
		// ou d'init pour ecriture
	void * InfoDet2; 	    // pointeur sur t_SD_BAS_DonDetMDRN1ABC
				    // ou t_SD_BAS_DonDetMDRN1ENG 
				    // ou t_SD_BAS_DonDetMDRN1VER 
				    // ou t_SD_BAS_DonDetVIADRN1ENG 
				    // selon le type de produit et de record 
		// ceci n'est pas alloue par la fonction de lecture detaillee
		// ceci est  alloue par la fonction de d'init pour ecriture
		// 
		// les pointeurs sont repris dans InfoDet
		// on utilise ceci dans les calculs 
	t_SD_BAS_DataThreadProduit * InfoCalc; // info internes issus de calcul dans l'OPS
	// allouee et utilise pour les MDR N1ABC
	} t_SD_BAS_LigneN1; 
	
	
//--------------------------------------------------------------------*/
// structure contenant les informations generales issues d'un GIADR de N1
// de type quality
//--------------------------------------------------------------------*/
typedef enum  {
  GIADRQUA_DATEDEB, 
  GIADRQUA_DATEFIN, 
  GIADRQUA_IDEFPSFSONDNBLIN, 
  GIADRQUA_IDEFPSFSONDNBCOL, 
  GIADRQUA_IDEFPSFSONDOVERSAMPFACTOR, 
  GIADRQUA_IDEFPSFSONDY, 
  GIADRQUA_IDEFPSFSONDZ, 
  GIADRQUA_IDEFPSFSONDWGT,
  GIADRQUA_IDEFIISSRFNSFIRST, 
  GIADRQUA_IDEFIISSRFNSLAST, 
  GIADRQUA_IDEFIISSRF, 
  GIADRQUA_IDEFIISSRFDWN, 
  GIADRQUA_IDEFIISNEDT,
  GIADRQUA_IDEFDPTIISDEADPIX
} e_SD_BAS_IND_GIADRQual;




/*--------------------------------------------------------------------*/
// structure contenant les informations generales issues d'un GIADR de N1
// de type scalefactor
/*--------------------------------------------------------------------*/
typedef enum  {
  GIADRSCA_DATEDEB,
  GIADRSCA_DATEFIN,
  GIADRSCA_IDEFSCALESONDNBSCALE,
  GIADRSCA_IDEFSCALESONDNSFIRST,
  GIADRSCA_IDEFSCALESONDNSLAST,
  GIADRSCA_IDEFSCALESONDSCALEFACTOR,
  GIADRSCA_IDEFSCALEIISSSCALEFACTOR,
// version 1.6 du conf autre
  GIADRSCA_IDEFSCALESONDNBSCALE1A,
  GIADRSCA_IDEFSCALESONDNSFIRST1A,
  GIADRSCA_IDEFSCALESONDNSLAST1A,
  GIADRSCA_IDEFSCALESONDSCALEFACTOR1A
} e_SD_BAS_IND_GIADRScaleFactor;



//--------------------------------------------------------------------*/
// structure contenant les informations utiles issues d'un GIADR
// de type engineering 
//--------------------------------------------------------------------*/
typedef enum  {
  GIADRENG_DATEDEB,
  GIADRENG_DATEFIN,
  GIADRENG_GEPSDATPROCESSING,
  GIADRENG_GEPSUTCLEAPSECOND,
  GIADRENG_GEPSCCUOBTCORREL,
  GIADRENG_GEPSUTCCORREL,
  GIADRENG_GEPSASTEPCORREL,
  GIADRENG_GEPSBSTEPCORREL
} e_SD_BAS_IND_GIADREngineering;


//====================================================================*/
// External variables Declaration 
//====================================================================*/
// version de l'OPS en debut de vie

// FT-2765
/* FT-2521,FT-2522,FT-2523,FT-2524,FT-2525,FT-2526,FT-2528  */
static const t_SD_BAS_VERSION SD_BAS_IASIN1_VERSION={11,0};
/* ..FT-2521,FT-2522,FT-2523,FT-2524,FT-2525,FT-2526,FT-2528  */

// FT-2635
static const int SD_BAS_MDR1A_VERSION_N1=5;
static const int SD_BAS_MDR1B_VERSION_N1=5;
static const int SD_BAS_MDR1C_VERSION_N1=5;
static const int SD_BAS_MDRENG_VERSION_N1=6;
// ...FT-2635
static const int SD_BAS_MDRVER_VERSION_N1=3;
static const int SD_BAS_MDRDUM_VERSION_N1=2;
//const int SD_BAS_MDRDUM_VERSION_N1=3;
//const int SD_BAS_MDR_VERSION_N1=3;
static const int SD_BAS_VIADRENG_VERSION_N1=3;
//const int SD_BAS_VIADRENG_VERSION_N1=2;
//const int SD_BAS_VIADR_VERSION_N1=2;
static const int SD_BAS_GIADRQUA_VERSION_N1=2;
static const int SD_BAS_GIADRSCA_VERSION_N1=2;
static const int SD_BAS_GIADRENG_VERSION_N1=3;
//const int SD_BAS_GIADR_VERSION_N1=3;
//const int SD_BAS_GIADR_VERSION_N1=3;
//const int SD_BAS_SPHR_VERSION_N1=0;
// ...FT-2765

//====================================================================*/
// External fonctions Declaration 
//====================================================================*/

//					FONCTIONS EXTERNES
//======================================================================

#ifdef __cplusplus
extern "C" {
#endif

//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_LireMPHRGIADRN1
//@
//@ Description : fonction de lecture du MPHR d'un produit 
//@  cette operation generique s'applique aux produits IASI de N1
//@ elle lit a la fois le MPHR et le GIADR scale factor
//@
//@
//@ Parameters :
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces
//@			(SORTIE)  mphr  : liste des variables lues dans le MPHR
//@			(SORTIE)  giadr  : liste des variables lues dans le GIADR
//@				scale factor
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_LireMPHRGIADRN1(
		t_SD_BAS_Fd * Descripteur,
		t_SD_BAS_MPHR * mphr,
		t_SD_BAS_Liste_Var* giadr,
		t_SD_BAS_DataThread *ctx
			)
;
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_EcrireMPHRSPHRN1
//@
//@ Description : fonction d'ecriture du MPHR d'un produit IASI L1
//@  cette operation generique s'applique aux produits IASI de N1
//@ cette operation peut etre rappelee a la fin pour mettre a jour les
//@ pointeurs IPR
//@
//@ Parameters :
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces
//@			(ENTREE)  mphr  : liste des variables a ecrire dans le MPHR
//@			(ENTREE)  init  : mode 
//@			(ENTREE)  start : date de debut de produit
//@			(ENTREE)  stop  : date de fin de produit
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
/* FA 180 */
t_CMN__Statut SD_BAS_EcrireMPHRSPHRN1(
		e_BAS_ModeTrt mode_traitement, 
		e_BAS_PositionTrt position_Traitement,
		t_SD_BAS_Fd * Descripteur,
		t_CMN__Booleen	init, // init vrai ou faux
		t_SD_BAS_MPHR * mphr,
		t_SD_BAS_SCDSTime start,
		t_SD_BAS_SCDSTime stop,
		t_SD_BAS_DataThread *ctx
                )
;
/* ..FA 180 */
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_LireMDRGenN1
//@
//@ Description : fonction de lecture des donnees gen des IPR d'un produit
//@  cette operation generique s'applique aux produits IASI de N1
//@  on lit ici le grh et quelques info detaillees  ( soit sequentiellement
//@  soit a partir d'une adresse )
//@
//@ SD_BAS_LireMPHRGIADRN1 doit avoir ete appele avant
//@
//@ Parameters :
//@			(ENTREE)  init  : contexte d'initialisation
//@				init = INIT ( on lit le suivant )
//@				init = NORMAL ( on lit a l'adresse indique )
//@			(ENTREE)  offset  : offset pour le mode normal
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilisa par les fonctions d'acces
//@			(SORTIE)  dongen  : liste des variables lues dans le MDR
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_LireMDRGenN1(
		e_BAS_CtxInit init,
		int offset,
		t_SD_BAS_Fd * Descripteur,
		t_SD_BAS_Liste_Var * dongen,
		t_SD_BAS_DataThread *ctx
			)
;
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_LireMDRN1
//@
//@ Description : fonction de lecture  des MDR de type 1A 1B 1C ENG VER d'un produit 
//@  cette operation s'applique aux produits IASI de N1
//@  on lit ici les info detaillees  en considerant que l'offset est renseigne
//@
//@
//@ Parameters :
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces
//@			(SORTIE)  mdr  : liste des variables lues dans le MDR
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_LireMDRN1(
		t_SD_BAS_Fd * Descripteur,
		t_SD_BAS_LigneN1 * mdr,
    t_SD_BAS_DataThread *ctx
			)
;
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_LireVIADRN1
//@
//@ Description : fonction de lecture  des MDR de type  ENG  d'un produit 
//@  cette operation s'applique aux produits IASI de N1
//@  on lit ici les info detaillees  en considerant que l'on connait le numero
//@ du VIADR ( si granule on commence a 1 ) sinon on commence a
//@ (numdebLigneN1+ numabs)%10 +1
//@
//@
//@ Parameters :
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces
//@			(SORTIE)  num  : numero du VIADR e lire
//@			(SORTIE)  mdr  : liste des variables lues dans le VIADR
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_LireVIADRN1(
		t_SD_BAS_Fd * Descripteur,
		int num,
		t_SD_BAS_LigneN1 * mdr,
		t_SD_BAS_DataThread *ctx
			)
;
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_LireGIADRN1
//@
//@ Description : fonction de lecture  des MDR de type  ENG SCA oU qUA d'un produit 
//@  cette operation s'applique aux produits IASI de N1
//@
//@
//@ Parameters :
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces
//@			(SORTIE)  mdr  : liste des variables lues dans le VIADR
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_LireGIADRN1(
		t_SD_BAS_Fd * Descripteur,
		t_SD_BAS_LigneN1 * mdr,
		t_SD_BAS_DataThread *ctx
		);
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_LibereMDRVIADRN1
//@
//@ Description : fonction de liberation des MDR ou VIADR d'un produit 
//@  cette operation s'applique aux produits IASI de N1
//@  on desallouie ici toute la place allouee precedenment
//@
//@
//@ Parameters :
//@			(ENTREE)         mode : LECTURE ou ECRITURE
//@			(ENTREE/SORTIE)  mdr  : liste des variables lues dans le MDR
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_LibereMDR(
			       e_BAS_TypeAcces mode,
			       t_SD_BAS_LigneN1 * mdr
                               )
;
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_DecodeSpectreN1
//@
//@ Description : fonction de decodage du spectre de N1  
//@  cette operation s'applique aux produits IASI de N1
//@   la place  est allouee par l'appelant
//@
//@
//@ Parameters :
//@			(ENTREE)  mdr  : contenu du MDR
//@                     (ENTREE)  estValide : Temoin de validite
//@			(ENTREE)  niveau : info a traiter (1A/1B/1C)
//@			(ENTREE)  sens : sens (encodage /decodage)
//@			(ENTREE)  Paramdecodage : parametres de decodage
//@			(ENTREE/SORTIE)  spectre  : contenu de la donnee
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_DecodeSpectreN1(
		t_SD_BAS_ORIGINE numLigneSNPN,	   		     
		t_SD_BAS_LigneN1 * mdr,
		const t_CMN__Booleen  estValide,
		e_SD_BAS_Atraiter niveau, 
		e_SD_BAS_Sens	sens, // sens (decodage/encodage)
		t_SD_BAS_ConfStable * Paramdecodage,
		double * spectre,
    t_SD_BAS_DataThread *ctx
			)
;
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_DecodeImageN1
//@
//@ Description : fonction de decodage d'une image de N1  
//@  cette operation s'applique aux produits IASI de N1
//@   la place allouee precedenment est allouee par l'appelant
//@
//@
//@ Parameters :
//@			(ENTREE)  mdr  : contenu du MDR
//@                     (ENTREE)  estValide : Temoin de validite
//@			(ENTREE)  sens : sens (encodage /decodage)
//@			(ENTREE)  Paramdecodage : parametres de decodage
//@			(ENTREE/SORTIE)  image  : contenu de l'image allouee par
//@					l'appelant
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_DecodeImageN1(
				   t_SD_BAS_ORIGINE numLigneSNPN,
				   t_SD_BAS_LigneN1 * mdr,
				   const t_CMN__Booleen  estValide,
				   e_SD_BAS_Sens	sens, // sens (decodage/encodage)
				   t_SD_BAS_ConfStable * Paramdecodage,
				   double * image,
				   t_SD_BAS_DataThread *ctx
				   )
;
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_EcrireGIADRN1
//@
//@ Description : fonction d'ecriture du GIADR des produits IASI L1
//@  cette operation generique s'applique aux produits IASI de N1
//@
//@
//@ Parameters :
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces
//@			(ENTREE)  TypeRec  : type de GIADR a utiliser
//@			(ENTREE)  giadr  : liste des variables a ecrire dans le GIADR
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
/* FA 162*/
t_CMN__Statut SD_BAS_EcrireGIADRN1(
		e_BAS_ModeTrt mode_traitement,
		e_BAS_PositionTrt position_Traitement,
		t_SD_BAS_Fd * Descripteur,
		e_BAS_TypeRecN1 TypeRec,
		t_SD_BAS_Liste_Var * GIADR,
		t_SD_BAS_DataThread *ctx
			)
;			
/* ..FA 162*/
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_EcrireMDRN1
//@
//@ Description : fonction d'ecriture du MDR des produits IASI L1
//@  cette operation generique s'applique aux produits IASI de N1
//@ cette operation doit etre appelee apres SD_BAS_EcrireMPHRSPHRN1
//@
//@
//@ Parameters :
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces
//@			(SORTIE)  mdr  : liste des variables lues dans le MDR
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_EcrireMDRN1(	
    t_SD_BAS_Fd * Descripteur,
    t_SD_BAS_LigneN1 * mdr,
    t_SD_BAS_DataThread *ctx
			);

//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_EcrireVIADRN1
//@
//@ Description : fonction d'ecriture du VIADR des produits IASI L1 ENG
//@  cette operation generique s'applique aux produits IASI de N1
//@ cette operation doit etre appelee apres SD_BAS_EcrireMDRN1
//@
//@ Parameters :
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces
//@			(SORTIE)  mdr  : liste des variables lues dans le MDR
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
/* FA 162 */
t_CMN__Statut SD_BAS_EcrireVIADRN1(
		t_SD_BAS_Fd * Descripteur,
		t_SD_BAS_LigneN1 * mdr,
		t_SD_BAS_DataThread *ctx,
		const e_BAS_ModeTrt modeTraitement
			)
;
/* ..FA 162 */

//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_InitEcritureMDRN1
//@
//@ Description : fonction d'initialisation d'une liste de variable 
//@ correspondant a un MDR
//@ Parameters :
//@			(ENTREE)  TypeRec  : type de record initialise
//@					par la fonction de niveau superieur
//@			(ENTREE/sortie)  mdr  : MDR a initialiser
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_InitEcritureMDRN1(
    t_SD_BAS_Fd * Descripteur,
		e_BAS_TypeRecN1 TypeRec,
		t_SD_BAS_LigneN1 * mdr,
    t_SD_BAS_DataThread *ctx)			
;
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_DecodeSpectreN1b
//@
//@ Description : fonction de decodage du spectre de N1  
//@  cette operation s'applique aux produits IASI de N1
//@   la place  est allouee par l'appelant
//@
//@
//@ Parameters :
//@			(ENTREE)  mdr  : contenu du MDR
//@			(ENTREE)  niveau : info a traiter (1A/1B/1C)
//@			(ENTREE)  sens : sens (encodage /decodage)
//@			(ENTREE)  giadr_sca : GIADR contenant les parametres de decodage
//@			(ENTREE/SORTIE)  spectre  : contenu de la donnee
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_DecodeSpectreN1b(
                t_SD_BAS_ORIGINE numLigneSNPN,	
		t_SD_BAS_LigneN1 * mdr,
		e_SD_BAS_Atraiter niveau, 
		e_SD_BAS_Sens	sens, // sens (decodage/encodage)
		t_SD_BAS_Liste_Var * giadr_sca,
		double * spectre,
		t_SD_BAS_DataThread *ctx
		);
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_DecodeImageN1b
//@
//@ Description : fonction de decodage d'une image de N1  
//@  cette operation s'applique aux produits IASI de N1
//@   la place allouee precedenment est allouee par l'appelant
//@
//@
//@ Parameters :        (ENTREE)  numLigneSNPN : SN en cours
//@			(ENTREE)  mdr  : contenu du MDR
//@			(ENTREE)  sens : sens (encodage /decodage)
//@			(ENTREE)  Paramdecodage : parametres de decodage
//@			(ENTREE/SORTIE)  image  : contenu de l'image allouee par
//@					l'appelant
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_DecodeImageN1b(
				    t_SD_BAS_ORIGINE numLigneSNPN,	    
				    t_SD_BAS_LigneN1 * mdr,
				    e_SD_BAS_Sens	sens, // sens (decodage/encodage)
				    t_SD_BAS_Liste_Var * giadr_sca,
				    double * image,
				    t_SD_BAS_DataThread *ctx
				    );
//======================================================================


#ifdef __cplusplus
}
#endif

#endif
