//$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/BAS/src/SD_BAS_SwapEndian.h,v 1.1 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Component : SD_BAS
//@ MODULE : SD_BAS_SwapEndian
//@
//@ Comment :
//@    Gestion Big Endian / Little Endian (Origine Meteo-france)
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef _SWAP_ENDIAN_H
#define _SWAP_ENDIAN_H

#include <stdlib.h>
//#include <config.h>

#define OPS_LITTLE_ENDIAN 0
#define OPS_BIG_ENDIAN 1



#if defined( OPS_BYTE_ORDER ) && OPS_BYTE_ORDER == OPS_LITTLE_ENDIAN

static int swap_int_buffer( char *p, int t, int n ) {
  int i, j;
  char c;
  for( i = 0; i < n; i++ ) {
    for( j = 0; j < t / 2; j++ ) {
      c = p[ t * i + j ];
      p[ t * i + j ] = p[ t * ( i + 1 ) - ( j + 1 ) ];
      p[ t * ( i + 1 ) - ( j + 1 ) ] = c;
    }
  }
  return 0;
}

#define SWAP_INT_BUFFER( p, n, t ) \
  do { swap_int_buffer( (char*)( p ), n, t ); } while( 0 )

#else

#define SWAP_INT_BUFFER( p, n, t ) do { } while( 0 )

#endif

#endif
