//$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/BAS/src/SD_BAS_TraceOutils.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_BAS
//@ MODULE : SD_BAS_TraceOutils
//@
//@ Comment :
//@   
//@   
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

/* fichier include de toutes les informations necessaires au bon 
    fonctionnement de comparaison de fichiers ASCII */

#ifndef SD_BAS_TRACEOUTILS_H
#define SD_BAS_TRACEOUTILS_H

//====================================================================
//   External define  Declarations
//====================================================================

#define SD_BAS_NB_ALLOC		100
#define SD_BAS_TAILLE_MAX_CLE	70
// modif pour accelerer la lecture
#define	SD_BAS_NB_MAX_CLE		20000
#define SD_BAS_TAILLE_MAX_ASCII	1024  
#define SD_BAS_TAILLE_BUFFER       8192/* cette taille doit etre paire et > a    */
				    /* 2*taille du plus grand mot cle fichier */	#define SD_BAS_TAILLE_BUFFER	8192 
#define SD_BAS_TAILLE_MAX_LIG	200
#define OK			 0
#define KO 			 1
#define REELMAX			 1.E90
#define SD_BAS_FORMAT_DATE          15  /* dd/mm/aa xxhxx*/
#define EGALCHAR                 "Egal"
#define DIFFCHAR                 "Diff"
#define FICDOUBLE            "DOUBLE"
#define FICENTIER            "ENTIER"
#define CODAGE_DOUBLE        "DBLE"
#define CODAGE_ENTIER        "INTE"
#define LUM_DIRECTORY        "lum/"

#define PERMS 0666

#define SD_BAS_OK				 0
#define SD_BAS_KO		 		 1
#define SD_BAS_EOF         		-1
#define SD_BAS_ERREUR_OUV  		-2
#define SD_BAS_PB_LSEEK    		-3
#define SD_BAS_DEB_NEG     		-4
#define SD_BAS_FIN_DEP     		-5
#define SD_BAS_ECRASEMENT  		-6
#define SD_BAS_PB_READ 			-7
#define SD_BAS_PB_WRITE    		-8
#define SD_BAS_PB_FTRUNC   		-9
#define SD_BAS_ERR_FORME_FIC 		-10
#define SD_BAS_ERR_DO      		-11
#define SD_BAS_ERR_TYP			-12
#define SD_BAS_ERR_FIN_DO     		-13
#define SD_BAS_ERR_ASCII   		-14
#define SD_BAS_ERR_ALLOCA  		-15
#define SD_BAS_ERR_REEL    		-16
#define SD_BAS_ERR_ENTIER  		-17
#define SD_BAS_ERR_DIM			-18
#define SD_BAS_ERREUR_RECHERCHE_MOT	-19
#define SD_BAS_MOT_DEJA_EXISTE		-20
#define SD_BAS_ERREUR_ENCODE		-21
#define SD_BAS_ERR_ADRESSE			-22 
#define SD_BAS_CLE_TROP_LONG		-23
#define SD_BAS_MC_INCONNU			-24
#define SD_BAS_PAS_MC			-24
#define SD_BAS_ERR_CROCHET			-25
#define SD_BAS_TROUVE	         	-26
#define SD_BAS_NON_TROUVE       		-27


/* constantes relatives aux types de donnees */
#define SD_BAS_INCONNU -1
#define SD_BAS_ENTIER4 1
#define SD_BAS_REEL4   2
#define SD_BAS_REEL8   3
#define SD_BAS_ASCII   4 
#define SD_BAS_BLOC    5
#define SD_BAS_FIC_BIN_DOUBLE 6
#define SD_BAS_FIC_BIN_ENTIER 7


//====================================================================//
// Local types Declaration  
//====================================================================//

typedef enum{SD_BAS_LECTURE,SD_BAS_ECRITURE} e_SD_BAS_CpfModeOuvre;
typedef char 	t_SD_BAS_CpfMotCle[SD_BAS_TAILLE_MAX_CLE];
typedef char 	t_SD_BAS_CpfChain[1024];
typedef int     t_SD_BAS_CpfType;
typedef int     t_SD_BAS_OK_KO;
typedef char    t_SD_BAS_Char8[8];
typedef char    t_SD_BAS_Codage[5];


typedef struct {
   t_SD_BAS_CpfChain nom_fichier;     /* nom du fichier ouvert            */ 
   int  descr;	               /* file descriptor du fichier                */ 
   char *buffer;	       /* buffer de donnee ASCII                     */
   int  taille_buffer;         /* taille du buffer ASCII demande            */ 

   int  taille_buffer_lu;      /* taille du buffer ASCII lu                  */
   int  num_buffer;            /*( -1 si non lu )                            */
   t_SD_BAS_CpfMotCle *liste_mot_cle; /* liste mot cle ASCII presents ds le fichier */
   int *ad_mot_cle;            /* adres des mot cles ASCII dans le fichier   */
   int *ad_donnee;             /* adres  debut donnee apres chaque mot cle   */
   int  nb_mot_cle;            /* nb mot cles presents ( -1 si non alloue)   */
   t_SD_BAS_CpfMotCle dernier_mot_cle;/* dernier mot cle lu ds fichier       */
   int ad_dern_mot_cle;        /* adres dernier  mot cle ASCII lu ds fichier */
   int ad_dern_donnee;        /* adres debut donne apres dernier mot cle lu  */
   char REMPLI[128];
}t_SD_BAS_CpfFile;




//====================================================================
// External variables Declaration 
//====================================================================
/* message d'erreur fixe par les fonctions de traces dans SD_BAS_Trace ou SD_BAS_TraceOutils */
extern char s_SD_BAS_ERREUR[200];


//=====================================================================
//					FONCTIONS EXTERNES
//======================================================================


/*****************************************************************************/
/*                                                                           */
/* OPERATION :    SD_BAS_ComficOpen                                          */
/* ----------                                                                */
/*                                                                           */
/* ROLE :                                                                    */
/* ------                                                                    */
/*                                                                           */
/*                                                                           */
/* CONTEXTE D'APPEL :                                                        */
/* -----------------                                                         */
/*                                                                           */
/* VERSION :  V0                                                             */
/* --------                                                                  */
/*                                                                           */
/* LANGAGE: C  ANSI                                                          */
/* --------                                                                  */
/*                                                                           */
/*****************************************************************************/
t_SD_BAS_CpfFile *SD_BAS_TraceOpen(
		       char * nom_fichier, 
		       e_SD_BAS_CpfModeOuvre  mode_ouv ) 


;
/*
   Fin de l'operation SD_BAS_TraceOpen
*/

/************************************************************************/
/*                                                                      */
/* OPERATION:  SD_BAS_TraceAjoute                                     */
/*                                                                   	*/
/* ROLE:  Cette operation ajoute a la fin du fichier, une donnee 	*/
/*                                                                      */
/* CONTEXTE D'APPEL:                                                    */
/*	Cette operation doit etre appelee apres ouverture prealable 	*/
/*	du fichier de Donnees 						*/
/*                                                                      */
/* VERSION:                                                             */
/*									*/
/* CODE RETOUR : OK ou KO						*/
/*Si KO, l'erreur peut etre affichee via la variable globale SD_BAS_ERREUR	*/
/*	" fichier de donnees  %s non ouvert "			        */
/*	" erreur de positionnement en fin de fichier     		*/
/*	" erreur d'ecriture dans le fichier     			*/
/************************************************************************/
t_SD_BAS_OK_KO SD_BAS_TraceAjoute(t_SD_BAS_CpfFile *fd,
			     char * mot_cle,
			     t_SD_BAS_CpfType type,
			     int nb_lig,   
			     int nb_col,
			     int taille_cell,
			     void * donnee
			     )

/* [E] structure decrivant fichier donnees        */
/* [E] mot a rechercher ds fichier terminee par \0*/
/* [E] type de la donnee lue 			  */
/* [E] nombre de lignes du tableau lu 		  */
/* [E] nombre de colonnes du tableau lu 	  */  
/* [E] taille maxi en octets 1 element donnee lue */ 
/* [E] non significatif si le type diff SD_BAS_ASCII */ 
/* [E/S] pointeur sur zone memoire a ecrire       */

;
/*
   Fin de l'operation SD_BAS_TraceAjoute
*/


/*****************************************************************************/
/*                                                                           */
/* OPERATION: SD_BAS_TraceClose                                            */
/*                                                                           */
/* ROLE: Cette operation externe est chargee de fermer le fichier de donnees */
/*  precedenment ouvert par l'operation SD_BAS_TraceOpen et libere	     */
/* la zone memoire reservee lors des operations precedentes dans la structure*/
/* t_SD_BAS_CpfFile 	       						     */
/*                                                                           */
/*                                                                           */
/*                                                                           */
/* CONTEXTE D'APPEL:                                                         */
/*                                                                           */
/* VERSION:                                                                  */
/* CODES RETOUR: OK ou KO						     */
/*	" erreur a la fermeture du fichier %s "				     */
/*****************************************************************************/
t_SD_BAS_OK_KO SD_BAS_TraceClose(t_SD_BAS_CpfFile * fd)

 /* [E] structure decrivant le fichier de donnees  */

;
/*
   Fin de l'operation SD_BAS_TraceClose
*/


/**************************************************************************/
/*                                                                        */
/* OPERATION: SD_BAS_TraceListe                                         */
/*                                                                        */
/* ROLE:  Cette operation recherche la liste des mots cles presents ds un */
/*	  fichier de Donnees                                              */
/*                                                                        */
/* ATTENTION : cette fonction s'alloue de l'espace memoire qu'il faudra   */
/* liberer a la fin du traitement                                         */
/*                                                                        */
/* CONTEXTE D'APPEL:                                                      */
/*                                                                        */
/* VERSION:                                                               */
/* CODE RETOUR : OK ou KO						  */
/*	" taille d'un mot cle lu superieure a la limite "	          */
/*	" erreur a la lecture du fichier de donnees  "		          */
/**************************************************************************/
t_SD_BAS_OK_KO SD_BAS_TraceListe(t_SD_BAS_CpfFile * fd);
	/*[E/S] file descriptor du fichier de donnees */

/*****************************************************************************/
/*                                                                           */
/* OPERATION:  SD_BAS_TraceLireCaract                                            */
/*                                                                           */
/* ROLE:  cette operation externe est chargee de trouver le type et la taille*/
/*   d'une donnee  lue dans un fichier precedenment ouvert.                  */
/*   Il s'agit donc apres localisation du mot cle de lire le type de donnee  */
/*    puis de compter le nombres de cellules de ce type dans la ligne.       */
/*   Dans le cas d'une donnee de type SD_BAS_ASCII la taille maxi de la         */
/*   cellule est aussi indiquee a l'appelant.                                */
/*                                                                           */
/*                                                                           */
/* CONTEXTE D'APPEL:                                                         */
/* cette operation doit etre appele apres ouverture prealable du fichier     */
/* de donnees .						   		     */ 
/*                                                                           */
/* VERSION:                                                                  */
/* CODES RETOUR: OK ou KO						     */
/*   si KO l'erreur peut etre affiche via la variable globale s_SD_BAS_ERREUR     */
/*   " fichier de donnees  %s non ouvert"				     */ 
/*   " mot cle non present dans le fichier de donnees  %s"      	     */
/*   " aucun mot cle dans le fichier %s"			             */
/*   " taille du mot cle lue %s superieure a la limite %d ou egale a 0"      */ 
/*   " erreur a la lecture du fichier de donnees  %s"                        */
/*   " parenthese ouvrante non detectee (mot cle %s )                        */ 
/*   " parenthese fermante  non detectee (mot cle %s )                       */
/*   " nombre de niveaux de parentheses superieur a 2 ( mot cle %s )         */ 
/*   " % dimension du tableau non constante (mot cle %s)                     */
/*   " % dimension du tableau = 0     (mot cle %s)                           */
/*   " type de la donnee lue %s non reconnue (mot cle %s)                    */
/*   " erreur lors du decodage de la donnee lue %s" (mot cle)                */
/*****************************************************************************/

t_SD_BAS_OK_KO SD_BAS_TraceLireCaract( 
			 t_SD_BAS_CpfFile * fd, 
			 char * mot_cle,
			 t_SD_BAS_CpfType *type,
			 int * nb_lig,
			 int * nb_col, 	
			 int * taille_cell
			 );


/***************************************************************************/
/*                                                                         */
/* OPERATION:  TraceLire                                                 */
/*                                                                         */
/* ROLE:  Cette operation externe est chargee de lire une donne associee a */
/*	  un mot cle ds le fichier de donnees  precedenment ouvert.        */
/*        Il s'agit donc apres localisation du mot cle de lire la donnee et*/
/*    toutes les informations associees(nb_lig,nb_col,taille_cell).        */
/*    On verifie alors la coherence entre les informations lues et celles  */
/*    issues des arguments donnes par l'appelant.		           */
/*	  Si les 3 informations sont coherentes la donnee est recopiee ds  */
/*    la zone memoire reservee par l'appelant.				   */
/* 	                                                                   */
/*                                                                         */
/* CONTEXTE D'APPEL:                                                       */
/* cette operation doit etre appele apres ouverture prealable du fichier   */
/* de donnees .						                   */
/* pour une souplesse d'utilisation max, il est utile d'appeler auparavant */
/* l'operation  SD_BAS_TraceLireCaract afin de reserver la place necessaire*/
/*                                                                         */
/* VERSION:                                                                */
/* CODES RETOUR: OK ou KO				                   */
/*   si KO l'erreur peut etre affiche via la variable globale s_SD_BAS_ERREUR   */
/*   " fichier de donnees  %s non ouvert"			           */ 
/*   " mot cle non present dans le fichier de donnees  %s"    	           */
/*   " aucun mot cle dans le fichier %s"			           */
/*   " taille du mot cle lue %s superieure a la limite %d ou egale a 0"    */ 
/*   " erreur a la lecture du fichier de donnees  %s"                      */
/*   " parenthese ouvrante non detectee (mot cle %s )                      */ 
/*   " parenthese fermante  non detectee (mot cle %s )                     */
/*   " nombre de niveaux de parentheses superieur a 2 ( mot cle %s )       */
/*   " % dimension du tableau non constante (mot cle %s)                   */
/*   " % dimension du tableau = 0     (mot cle %s)                         */
/*   " type de la donnee lue %s non reconnue (mot cle %s)                  */
/*   " erreur lors du decodage de la donnee lue %s" (mot cle %s)           */
/* " incoherence entre nblig lue (%d) et nblig specifiee (%d) (mot cle %s) */
/* " incoherence entre nbcol lue (%d) et nbcol specifiee (%d) (mot cle %s) */ 
/* " incoherence entre taille_cell lue (%d) et taille_cell  specifiee (%d) */
/*            (mot cle %s) 						   */
/***************************************************************************/
t_SD_BAS_OK_KO SD_BAS_TraceLire( 
		   t_SD_BAS_CpfFile * fd,
		   char * mot_cle,
		   t_SD_BAS_CpfType * type,
		   int * nb_lig,
		   int * nb_col, 
		   int * taille_cell,
		   void * donnee
		   );

/*****************************************************************************/
/*                                                                           */
/* OPERATION:  SD_BAS_TraceModifie                                         */
/*                                                                           */
/* ROLE:  Cette operation modifie le contenu d'une donnee  dans un champ     */
/*	Toutes les autres donnees sont conservees dans le fichier .Si le mot */
/*	cle n'est pas trouve, une erreur est detectee.			     */
/*   NB : le fichier doit au prealable avoir ete ouvert en mode SD_BAS_ECRITURE */
/*                                                                           */
/*                                                                           */
/* CONTEXTE D'APPEL:                                                         */
/*                                                                           */
/* VERSION:                                                                  */
/* CODES RETOUR: OK ou KO						     */
/* "erreur fichier ouvert en mode lecture "				     */
/*****************************************************************************/
t_SD_BAS_OK_KO SD_BAS_TraceModifie( 
		      t_SD_BAS_CpfFile  * fd,
		      char * mot_cle,
		      t_SD_BAS_CpfType type,
		      int nb_lig,
		      int nb_col,
		      int taille_cell,
		      void * donnee
		      );

//======================================================================
#endif
