//$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/DON/src/SD_DON_BanqueSpectrale.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_DON
//@ CLASSE : SD_DON_BanqueSpectrale
//@
//@ Comment :
//@    this module implement the SD_DON_BanqueSpectrale class
//@    used to reference the Data Base COnfiguration FIle
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 30/11/2002 : P.GASSIE
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_DON_BanqueSpectrale_h
#define SD_DON_BanqueSpectrale_h


// Inserer ici les fichiers include 
#include <vector>
#include <complex>
#include "SD_BAS_Global.h"
#include "SD_BAS_CompteRendu.h"
extern "C" {
#include "SD_BAS_BanqueSpectrale.h"
}
#include "ERR__Exception.h"
#include "CMN__Date.h"
#include "CMN__Chaine.h"
#include "CMN__Fichier.h"
#include "SD__Message.h"


// Definition des exceptions

class SD_DON_BanqueSpectrale {

/*====================================================================*/

public:

        //
        // Type
        //  

        //
        // Constant
        //
  //
  // Constructeur
  //
  SD_DON_BanqueSpectrale();
  //
  // Destructeur
  //
  virtual ~SD_DON_BanqueSpectrale();

  //
  // Accesseurs
  //
  t_SD_BAS_BanqueSpectrale* GetData(
    );

  //
  // publics Methods 
  //
  void Lire(
    const int& Ident,
    const t_Chaine & repertoire,
    t_Chaine& nomfichier
    ) throw(ERR__Exception);
  t_CMN__Statut Verifie(
    const int& Ident
    );
  /*====================================================================*/
protected:
  //
  // protected Methods 
  //

  //
  // protected Attributes 
  //

  /*====================================================================*/
private:
  //
  // Private Methods 
  //
  //
  //
  // Constantes
  //
  static const int POS_VAL_DATE;
  static const int POS_IDENT;
  static const int NBRE_MIN;
  static const t_Chaine JDB_PARAM_1;
  static const t_Chaine DATA_AUX_BS_NOT_FOUND;
  static const t_Chaine DATA_AUX_BS_READ_ERROR;
  
  // Private Attributes 
  //
  

  // nom du fichier en entree 
  t_SD_BAS_NomFichier NomFichier;
    
  //
  // structure contenant les informations de la banque spectrale
  // pour une ligne
  t_SD_BAS_BanqueSpectrale* m_DataBS;

  // identificateur de la banque spectrale
  int m_ident;
    
  // date de validite issue du nom du fichier
  t_Date  m_DateValid;        

  // indicateur de chargement
  bool m_Charge;
  
};


#endif
