//$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/DON/src/SD_DON_ConfAutre.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_DON
//@ CLASSE : SD_DON_ConfAutre
//@
//@ Comment :
//@    this module implement the SD_DON_ConfAutre class
//@    used to reference the "other" Configuration FIle
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 30/11/2002 : P.GASSIE
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_DON_ConfAutre_h
#define SD_DON_ConfAutre_h


// Inserer ici les fichiers include 
#include "SD_BAS_ConfAutre.h"
#include "ERR__Exception.h"
#include "SD_BAS_Global.h"
#include "SD_BAS_CompteRendu.h"
#include "CMN__Chaine.h"
#include "CMN__Date.h"
#include "CMN__Fichier.h"
#include "SD__Message.h"


// Definition des exceptions

class SD_DON_ConfAutre {

/*====================================================================*/

public:

        //
        // Type
        //  

        //
        // Constant
        //
  //
  // Constructeur
  //
  SD_DON_ConfAutre();
  //
  // Destructeur
  //
  virtual ~SD_DON_ConfAutre();

  //
  // Accesseurs
  //
  int  GetPTSI(
    );
  t_Date GetDateValid(
    );

  t_Date GetDateCreation(
    );
  
  t_Chaine GetNom(
    );

  void  GetIdConf(
    int& IdCA,
    int& IdCS,
    int& IdBS
    );
  t_SD_BAS_ConfAutre* GetData(
    );
  //
  // publics Methods 
  //
  void Initialise(
    const t_Chaine& NomRepertoire,
    const t_Chaine& NomFichier
    );
  void Lire(
    ) throw(ERR__Exception);
        
  /*====================================================================*/
protected:
  //
  // protected Methods 
  //

  //
  // protected Attributes 
  //

  /*====================================================================*/
private:
  //
  // Private Methods 
  //
  //
  // Constantes
  //
  static const int POS_VAL_DATE;
  static const int POS_CRE_DATE;
  static const int POS_PTSI;
  static const int NBRE_MIN;
  static const t_Chaine JDB_PARAM_1;
  static const t_Chaine DATA_AUX_AUT_READ_ERROR;
  //
  // Private Attributes 
  //
  
  // nom complet du fichier
  t_Chaine m_NomComplet;

  // nom du fichier en entree 
  t_SD_BAS_NomFichier m_NomFichier;

  // date de validite issue du nom du fichier
  t_Date  m_DateValid;        

  // date de creation   du fichier
  t_Date  m_DateCreation;       

  // parametre PTSI identifiant la configuration systeme
  int m_PTSI;
    
  //
  // structure contenant les informations du fichier de conf
  // 
  t_SD_BAS_ConfAutre* m_DataCA;

  // identificateur du fichier de conf stable issue du fichier
  int m_identCS;
  
  // identificateur du fichier banque spectrale issue du fichier
  int m_identBS;  

  // indicateur de chargement
  bool m_Charge;
  
};


#endif
