//$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/DON/src/SD_DON_ConfStable.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_DON
//@ CLASSE : SD_DON_ConfStable
//@
//@ Comment :
//@    this module implement the SD_DON_ConfStable class
//@    used to reference the stable Configuration FIle
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 30/11/2002 : P.GASSIE
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_DON_ConfStable_h
#define SD_DON_ConfStable_h


// Inserer ici les fichiers include 
#include "SD_BAS_Global.h"
#include "SD_BAS_CompteRendu.h"
#include "SD_BAS_ConfStable.h"
#include "ERR__Exception.h"
#include "CMN__Chaine.h"
#include "CMN__Date.h"
#include "CMN__Fichier.h"
#include "SD__Message.h"
#include <vector>


// Definition des exceptions

class SD_DON_ConfStable {

/*====================================================================*/

public:

        //
        // Type
        //	

        //
        // Constant
        //
	//
	// Constructeur
	//
	SD_DON_ConfStable();
	//
	// Destructeur
	//
  virtual ~SD_DON_ConfStable();

	//
	// Accesseurs
	//
	t_SD_BAS_ConfStable* GetData();
	t_CMN__Statut Verifie(const int& Ident);

	//
	// publics Methods 
	//
void Initialise(
  const int &      IdStable, 
  const t_Date &   tcourante, 
  const t_Chaine & repertoire, 
  t_Chaine &       nom_fichier) 
	throw(ERR__Exception);
	void Lire(
		) throw(ERR__Exception);
	/*====================================================================*/
protected:
	//
	// protected Methods 
	//

	//
	// protected Attributes 
	//

	/*====================================================================*/
private:
	//
	// Private Methods 
	//
	//
	// Constantes
	//
	static const int POS_VAL_DATE;
	static const int POS_CRE_DATE;
	static const int POS_ID;
	static const int NBRE_MIN;
	static const t_Chaine JDB_PARAM_1;
	static const t_Chaine DATA_AUX_STA_NOT_FOUND;
	static const t_Chaine DATA_AUX_STA_READ_ERROR;
	
	//
	// Private Attributes 
	//
	

	// nom du fichier en entree 
	t_SD_BAS_NomFichier m_NomFichier;
		
	//
	// structure contenant les informations du fichier de conf
	// 
	t_SD_BAS_ConfStable* m_DataCS;

	// identificateur de la conf stable issue du nom du fichier
	int m_ident;
		
	// date de validite issue du nom du fichier
	t_Date 	m_DateValid;	      

	// date de creation   du fichier
	t_Date 	m_DateCreation;	      

	// indicateur de chargement
	bool m_Charge;
	
};


#endif
