//$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/DON/src/SD_DON_DonGenGranule.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_DON
//@ CLASSE : SD_DON_DonGenGranule
//@
//@ Comment :
//@    this module implement the SD_DON_DonGenGranule class
//@    used to reference the general data used by OPS L1 chain
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 11/02/2003 : P.GASSIE
//@ --------------------------------------------------------------------
//@ FA-ID :<No> : <date> : <commentaire libre>
//@ --------------------------------------------------------------------
//@ PM-ID :IA-2100-CR-301-CN : 03/07/2006 : B. MASSART
//@ PTSI is now read in the first PX valid record in N0 product to select the 
//@ BRD file. Before CR301, PTSI was read in the first CTX file where its 
//@ value is 0. (patch3-5-5). See IA-2100-CR-301-THA.
//@ --------------------------------------------------------------------
//@ MODIFIED FOR PATCH3-5-5 : 05/Jul/06
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_DON_DonGenGranule_h
#define SD_DON_DonGenGranule_h


// Inserer ici les fichiers include 
#include "SD_BAS_Global.h"
#include "SD_BAS_Contexte.h"
#include "SD_BAS_Traces.h"
#include "SD_BAS_OperateurLoc.h"
#include "ERR__Exception.h"
#include "JDB__Callback.h"
#include "JDB__Client.h"
#include "CFG__Configuration.h"
#include "SD_DON_Contexte.h"
#include "SD_DON_Traitement.h"
#include "SD_DON_InventaireConf.h"
#include "CFG__Configuration.h"
#include "CMN__Chaine.h"
#include "CMN__Date.h"

#include "SD_BAS_Niveau0.h" /* CR301 */

// Definition des exceptions

class SD_DON_DonGenGranule {

/*====================================================================*/

public:

        //
        // Type
        //  

        //
        // Constant
        //
  //
  // Constructeur
  //
  SD_DON_DonGenGranule();
  //
  // Destructeur
  //
  virtual ~SD_DON_DonGenGranule();

  //
  // Accesseurs
  //
  void GetData(
    t_SD_BAS_Contexte ** contextecourant,
    t_SD_BAS_DataGen  ** datagen
    );
  SD_DON_Contexte& GetContexte();

    
  //
  // publics Methods 
  //
  t_CMN__Statut InitLecture(
    const SD_DON_Traitement& Trt,
    int& Ptsi
    );

  t_CMN__Statut InitCalcul(
    SD_DON_InventaireConf &  Inventaire,
    const int Ptsi,
    const t_Date& dateDebutGranule
    ) throw(ERR__Exception);
  void FinCalcul();
  void AjouteElemHist(
    t_SD_BAS_HistAxeInterf** AxeInterf,
    t_SD_BAS_HistTempCN * TempCN
    );
  t_CMN__Statut SauverContexte(
    const t_Date& datefin,
    const int& orbitestart,
    const e_BAS_PositionTrt& slideid,
    t_Chaine& nomFichier
    );
  void MajContexte(
    const t_SD_BAS_Contexte * contextecourant
    );

  /*====================================================================*/
protected:
  //
  // protected Methods 
  //

  //
  // protected Attributes 
  //

  /*====================================================================*/
private:
  //
  // Private Methods 
  //
  void YY_CONF(
    t_SD_BAS_ConfAutre *        SV_ConfAutre,
    t_SD_BAS_ConfStable *       SV_ConfStable,
    t_SD_BAS_BanqueSpectrale *  SV_BanqueSpectrale);
  //
  // Private Attributes 
  //
  //
  // Constantes
  //
  static const t_Chaine SD_DON_GEN_MUTEX_METOP_MSG;
  
  //  contexte initial charge par lecture  
  SD_DON_Contexte   m_ContexteInit;
  
  //  contexte courant associe au granule 
  SD_DON_Contexte   m_ContexteCourant;
  
  //traitement
  SD_DON_Traitement m_Traitement;
    
  //
  // structure contenant les informations generales a utiliser dans les
  //  calculs  
  t_SD_BAS_DataGen * m_DataGen;

  //
  // PTSI utilise pour les donnees courantes
  //
  int m_Ptsi;
  
  //
  // indicateur d'init des calculs
  //
  bool m_Init;
       
};


#endif
