//$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/DON/src/SD_DON_GestCasDeg.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_DON
//@ CLASSE : SD_DON_GestCasDeg
//@ 
//@ Comment :
//@    this module implement the SD_DON_GestCasDeg class
//@    used to administrate the degraded cases found in OPS L1 PPF
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ VERSION : 17/01/2003 : P.GASSIE
//@ --------------------------------------------------------------------
//@ FA-ID : IA-2100-FA-139-CN : 21/09/2004 : B.MASSART
//@ Probleme d'initialisation de GDatFlagIsrfemOff quand on entre en mode
//@ calibration externe ne visant pas la Terre. On introduit le mode
//@ de prise de vue dans la gestion des cas degrades. Voir IA-2100-FC-139-THA.
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_DON_GestCasDeg_h
#define SD_DON_GestCasDeg_h


// Inserer ici les fichiers include 
#include "SD_DON_CasDegLigne.h"
#include "SD_BAS_Global.h"
#include "SD_DON_Contexte.h"
#include <list>
//#include "SD_DON_GranuleN0.h"
//#include "SD_DON_GranuleN1.h"
//#include "SD_DON_OBTUTC.h"


// Definition des exceptions

class SD_DON_GestCasDeg {

/*====================================================================*/

public:

       //
        // Type
        //	
        typedef list<SD_DON_CasDegLigne*> 
	        t_ListeCasDegLigne;
        //
        // Constant
        //
	//
	// Constructeur
	//
	SD_DON_GestCasDeg();
	//
	// Destructeur
	//
	virtual ~SD_DON_GestCasDeg();
 void Liberer();
	//
	// Accesseurs
	//
	//
	// publics Methods 
	//
	void Init(
			     SD_DON_Contexte  & Contexte,
			     SD_DON_CasDegLigne::t_SD_DON_IdefDur & durees
	);
	/* FA139 */
	void AjouteCasDegLigne(int NumLigne, e_BAS_ModePdv mode
		);
	void AjouteCasDegLignePart(int NumLigne,
	                                e_BAS_ModePdv mode, 
					SD_DON_CasDegLigne::t_SD_DON_Flt & Flags,
					SD_DON_CasDegLigne::t_SD_DON_GOPSDAT & Dates
		);
	/* FIN FA139 */
		
	SD_DON_CasDegLigne* GetCasDegLigne(
				int NumLigne
				);

	/*====================================================================*/
protected:
	//
	// protected Methods 
	//

	//
	// protected Attributes 
	//

	/*====================================================================*/
private:
	//
	// Private Methods 
	//

	//
	// Private Attributes 
	//
	// liste des lignes utilise dans le granule
	t_ListeCasDegLigne m_ListeCasDegLigne;
	
	// reference sur le contexte permettant d'initialiser les cas deg
	SD_DON_Contexte m_Contexte;
	
	// durees issues du fichier de conf
	SD_DON_CasDegLigne::t_SD_DON_IdefDur  m_Duree;

};


#endif
