//$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/DON/src/SD_DON_GestConfAutre.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_DON
//@ CLASSE : SD_DON_GestConfAutre
//@ 
//@ Comment :
//@    this module implement the SD_DON_GestConfAutre class
//@    used to reference the different "other" configuration files
//@	 needed by OPS L1 PPF
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 30/11/2002 : P.GASSIE
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_DON_GestConfAutre_h
#define SD_DON_GestConfAutre_h


// Inserer ici les fichiers include 
#include <vector>
#include <list>
#include "SD_DON_ConfAutre.h"
#include "SD_BAS_Global.h"
#include "SD_BAS_ConfAutre.h"
#include "CMN__Date.h"
#include "CMN__Chaine.h"
#include "CMN__Fichier.h"
#include "ERR__Exception.h"
#include "SD__Message.h"
#include <pthread.h>


// Definition des exceptions

class SD_DON_GestConfAutre {

/*====================================================================*/

public:

  //
  // Type
  //	
  typedef list<SD_DON_ConfAutre> t_ListeConfAutre;

  //
  // Constant
  //
	//
	// Constructeur
	//
	SD_DON_GestConfAutre();
	//
	// Destructeur
	//
	~SD_DON_GestConfAutre();

	//
	// Accesseurs
	//
	//
	// publics Methods 
	//
	void CreerInventaire(
		const t_Chaine & repertoire
			) throw(ERR__Exception);
	void ChargerPTSIDateValid(
		const int Ptsi,
		const t_Date & tcourante,
		t_Chaine& nom_fichier,
		int& IdCA,
		int& IdCS,
		int& IdBS
			) throw(ERR__Exception);
	t_SD_BAS_ConfAutre* GetData(
		);
	void InitialiserMutex();
	void LibererMutex();
	void Reserver();
	void Liberer();
		
	/*====================================================================*/
protected:
	//
	// protected Methods 
	//

	//
	// protected Attributes 
	//

	/*====================================================================*/
private:
	//
	// Private Methods 
	//
  //
  // Constantes
  //
  static const t_Chaine JDB_PARAM_1;
  static const t_Chaine DATA_AUX_AUT_NOT_FOUND;
	//
	// Private Attributes 
	//
	// liste desfichier de configuration autres 
	t_ListeConfAutre m_ListeConfAutre;

	// parametre PTSI identifiant la configuration systeme courante
	int m_PTSI;
	
	// parametre date de creation du fichier a charger
	double m_DateCreation;
	
	// repertoire des fichiers de conf autre
	t_Chaine m_repertoire;
		
   // Mutex pour la mise a jour de la conf 
   static pthread_mutex_t   s_MutexTravailleConf;
};


#endif
