// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/DON/src/SD_DON_Granule.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_DON
//@ CLASSE : SD_DON_Granule
//@
//@ Commentaire :
//@    Fichier d'entete de la classe SD_DON_Granule
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 06/01/2003 : P. CABANE
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_DON_Granule_h
#define SD_DON_Granule_h


//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Commun.h"
#include "CMN__Date.h"

#include "SD_DON_InfoGenLigne.h"


class SD_DON_Granule {

    /*================================================================*/

 public:

    ////////////////////////////////
    // Type definitions
    ////////////////////////////////

    // Type de granule
    typedef enum {
        INDETERMINE = 0,
        IASIN0      = 1,
        IASIN1      = 2,
        AVHRRN1     = 3
    } e_DON_TypeGran;

    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    SD_DON_Granule();
    
    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    virtual ~SD_DON_Granule();
    virtual void Liberer() {};

    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    t_Chaine             GetNomGranule() const;

    int                  GetNbLigne() const;
    void                 SetNbLigne(const int nbLigne);

    int                  GetNbDataGap() const;
    void                 SetNbDataGap(const int nbDataGap);

    e_DON_TypeGran       GetTypeGran() const;
    void                 SetTypeGran(const e_DON_TypeGran typeGranule);

    t_Date               GetDateDebut() const;
    t_Date               GetDateFin() const;
    void                 SetDates(const t_Date& dateDebut,
                                  const t_Date& dateFin);

    t_SD_BAS_MPHR&       GetEnteteMPHR();

    t_ListeInfoGenLigne& GetListeInfoGenLigne();
    void                 AjouterInfoGenLigne(t_InfoGenLigne& element);


    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    void GetInfoHKTM(t_Date& startTime, int& startOrbitNumber);
    virtual void Afficher();
    void AfficherMPHR(t_CMN__Booleen complet);
    void AfficherInfosDetMPHR();


    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////
        
    // Nom du granule
    t_Chaine            m_NomGranule;

    // Nombre de lignes du granule
    int                 m_NbLigne;

    // Nombre de trous de donnees
    int                 m_NbDataGap;
        
    // Type de granule
    e_DON_TypeGran      m_TypeGran;

    // Indice de la premiere ligne
    int                 m_IndiceDebut;  

    // Indice de la derniere ligne
    int                 m_IndiceFin;  
  
    // Date de debut de la premiere ligne a traiter
    t_Date              m_TP0;

    // Date de fin de la derniere ligne a traiter (i.e date du dernier
    // paquet de la derniere ligne a traiter)
    t_Date              m_TP1;
         
    // Contenu du MPH lu dans le produit 
    t_SD_BAS_MPHR       m_MPHR;

    // Liste des lignes a traiter
    t_ListeInfoGenLigne m_ListeInfoGenLigne; 
    
    
    /*================================================================*/
    
 private:

    ////////////////////////////////
    // Constantes
    ////////////////////////////////

    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////

    
    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
    
};

#endif
