static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/DON/src/SD_DON_GranuleN0.cc,v 1.3 2011/11/25 10:17:45 dpauly Exp $";
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_DON
//@ CLASSE : SD_DON_GranuleN0
//@
//@ Commentaire :
//@    Ce module gere la classe SD_DON_GranuleN0, qui contient les
//@    informations relatives a un granule de donnees de niveau 0
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 06/01/2003 : P. CABANE
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-074-CN : 29/10/2003 : JL.PASCAL
//@ lors de lignes incompletes le cas degrade CG12 et CG1 est leve sur la ligne suivante 
//@ le pb est du a l'iddentification incorrecte des debut et fin de ligne
//@ un cas est ajoute dans la fonction IdentifierLignes en gerant l'historique
//@ des ISP de plus la MARGE de detection des incoherence temporelle est augmentee
//@ dans SD_DON_LigneN0.c ( + 1
//@ fiche de correction correspondante : IA-2100-FC-074-THA
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-071-CN : 10/11/2003 : JL.PASCAL
//@ l'OPS ne detecte pas les absences de donnees si des dummy les remplacent 
//@ des messages d'information sont donc ajoutes a la detection et a la creation
//@ IdentifierLignes et InitLecture
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-118-CN : 06/02/2004 : JL.PASCAL
//@ l'OPS prend en compte  la derniere ligne meme si elle est incomplete
//@ fiche de correction correspondante : IA-2100-FC-118-THA
//@ --------------------------------------------------------------------
//@ fiche de correction correspondante : IA-2100-FC-071-THA
//@ --------------------------------------------------------------------
//@ DM-ID :IA-CR-2100-246-CNE : 06/07/2004 : B. MASSART
//@ word # 16 in level 0 PX packets is no more read as part of PTSI number
//@ Variable ONBOARD_SOFTWARE_VERSION added in ENG, 1A, 1B and 1C products
//@ --------------------------------------------------------------------
//@ DM-ID :IA-CR-2100-243-CNE : 02/08/2004 : B. MASSART
//@ Line identification uses N0_LN in ISP packets. See IA-2100-CR-243-THA.
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-127-CN : 22/09/2004 : B.MASSART
//@ Le filtrage de la position de l'axe interferometrique ne converge pas en
//@ mode dump. Un test si t0 est compris entre DateFin[LN-1] et DateDebut[LN]
//@ a ete rajoute. Voir IA-2100-FC-127-THA.
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-CR-271-CN : 22/06/2005 : JL.PASCAL
//@ prise en compte du mode transition
//@ fiche de correction correspondante : IA-2100-CR-271-THA
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-CR-270-CN : 24/06/2005 : JL.PASCAL
//@ prise en compte des SN manquant
//@ fiche de correction correspondante : IA-2100-CR-270-THA
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-168-CN : 21/02/2006 : B.MASSART
//@ an exception is added in method DeterminerBornes when time range specified
//@ in a workorder does not match the date of the last line of the granule.
//@ See IA-2100-FC-168-THA
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-183-CN : 08/08/2006 : C.MERIGUET
//@ Ne pas lever d'exception en mode dump si aucune lignes n'a ete trouvee
//@ pour empecher le rejet du work order global et l'arret de l'OPS en cas 
//@ de trou de donnees.
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-162-CN : 09/2006 : C.MERIGUET
//@ Gestion des IPR en mode DUMP
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-186-CN : 09/2006 : R.MORENO
//@ Generation de DMDR
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-199-CN : 22/01/2007 : C.MERIGUET
//@ Pb dans fonction DeterminerBornes detecte par Meteo-France
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2512 (FA-2100-OPS) : 17/11/2008 : S. BRUNEL
//@ Fuites memoires signalees par EUMETSAT (EUM.EPS.NCR.3627.1)
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2750(FA-2100-OPS) : 22/03/2010 : S. BRUNEL
//@ Probleme de gestion des lignes avec transition de mode,
//@ impact sur FTB (NCR 3924)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-3353(DM-2100-OPS) : 22/05/2017 : MPE
//@ Gestion Dummy MDR et MDR en overlap => Msg et sortie en erreur de l'OPS
//@ ---------------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

//
// Fichiers include
//

// STL
#include <cstdio>

// Standard

// Projet
#include "CMN__Commun.h"
#include "CMN__Date.h"

#include "SD_DON_GranuleN0.h"


//
// Definition des constantes
//
const t_Chaine SD_DON_GranuleN0::JDB_PARAM_1          = "$PRM1";
const t_Chaine SD_DON_GranuleN0::JDB_PARAM_2          = "$PRM2";
const t_Chaine SD_DON_GranuleN0::EXCEPTION_SEPARATEUR = ": ";
const t_Chaine SD_DON_GranuleN0::ERROR_INIT_READING   = "Error while attempting to process product ";
const t_Chaine SD_DON_GranuleN0::NO_LINE_IN_PRODUCT   = "Product does not contain any line ";
// DM 3353 : Gestion Dummy MDR incohérent avec le MDR suivant
const t_Chaine SD_DON_GranuleN0::ERROR_DUMMY_NEXT_MDR_INCONSISTENT = "Error MDR is inconsistent with last DMDR data ";

// FT-2765/FT-2766
// CR243: Initialisation de l'indice de ligne absolu precedent
int SD_DON_GranuleN0::m_N0_LN_prec = -1;
// ...FT-2765/FT-2766

/* FA168 */
const t_Chaine SD_DON_GranuleN0::ERROR_IN_TIME_RANGE  = "No line in time range";

const int SD_DON_GranuleN0::NB_ISP_LIGNE_NORM_COMPLETE= 160   ;
const int SD_DON_GranuleN0::NB_ISP_LIGNE_CAL_COMPLETE = 145   ;


//======================================================================
//                                      METHODES PUBLIQUES
//======================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : SD_DON_GranuleN0
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_DON_GranuleN0::SD_DON_GranuleN0()
  : m_EtatGranule(EVT_INDETERMINE)
{
  //@ Mise a jour du type du granule
  m_TypeGran = SD_DON_Granule::IASIN0;
}


//@ ------------------------------------------------------------------*/
//@ Methode : ~SD_DON_GranuleN0
//@
//@ Description : Destructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_DON_GranuleN0::~SD_DON_GranuleN0()
{
  //@ On libere ici les listes eventuellement remplies
  m_ListeLigneN0.clear();
}


//@ ------------------------------------------------------------------*/
//@ Methode : Liberer
//@
//@ Description : Liberation memoire des donnees de l'objet
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN0::Liberer()
{
  //@ POUR toutes les lignes du granule
  for (int i=0; i<m_ListeLigneN0.size(); i++)
    {
      //@ Liberation memoire des donnees
      m_ListeLigneN0[i].Liberer();
    }
  //@ FIN POUR toutes les lignes du granule
  
  //@ RAZ de la liste
  m_ListeLigneN0.clear();

  // FT-2512
  SD_BAS_LibereListeVar(ECRITURE, &m_MPHR.listevar);
  SD_BAS_LibereListeVar(ECRITURE, &m_MPHR.grh);
  // ..FT-2512
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetNbPaquetN0
//@
//@ Description : Recupere le nombre de paquets N0 pour une ligne et
//@               un type donnes
//@
//@ Parametres :
//@               (ENTREE) numLigne : Numero de la ligne demandee
//@               (ENTREE) type : Type des paquets choisis
//@
//@ Valeur de retour : 
//@               Nombre de paquets N0
//@
//@ ------------------------------------------------------------------*/
int SD_DON_GranuleN0::GetNbPaquetN0(const int numLigne, 
                                    const e_SD_BAS_TypeN0 type)
{
  // Nombre de paquets N0
  int            nbPaquets = 0;

  //@ Recuperation de la ligne
  SD_DON_LigneN0 ligneN0 = GetLigne(numLigne);
  
  //@ SI la ligne n'est pas valide, aucun paquet n'est renvoye
  //@ SI la ligne est valide
  if (ligneN0.EstValide() == CMN__VRAI)
    {
      //@ Recuperation du nombre de paquets de la ligne via la 
      //@ methode SD_DON_LigneN0::GetNbPaquetN0()
      nbPaquets = ligneN0.GetNbPaquetN0(type);
    }  
  //@ FIN SI la ligne est valide


  //@ Retourner le nombre de paquets N0
  return nbPaquets;
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetDataGenLigne
//@
//@ Description : Recupere la liste des donnees generales pour une 
//@               ligne
//@
//@ Parametres :
//@               (ENTREE) numLigne : Numero de la ligne demandee
//@               (SORTIE) dataGenLigne : Donnees generales ligne
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN0::GetDataGenLigne(const int numLigne,
                                       t_InfoGenLigne& dataGenLigne)
{
  //@ Recuperation de la ligne
  SD_DON_LigneN0 ligneN0 = GetLigne(numLigne);

  //@ Recuperation des donnees generales de la ligne via la 
  //@ methode SD_DON_LigneN0::GetDataGen()
  dataGenLigne = ligneN0.GetDataGen();
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetDataLigne
//@
//@ Description : Recupere la liste des paquets de niveau 0 contenus
//@               dans une ligne. On ne retourne ici que les paquets
//@               coherents (cf CG 13 14)
//@
//@ Parametres :
//@               (ENTREE) numLigne : Numero de la ligne demandee
//@               (ENTREE) type : Type des paquets choisis
//@               (SORTIE) nbPaquets : Nombre de paquets retournes
//@               (SORTIE) listePaquetLigne : Liste des paquets
//@                                           retournes
//@
//@ Valeur de retour : 
//@              Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN0::GetDataLigne(const int numLigne,
                                    const e_SD_BAS_TypeN0 type,
                                    int& nbPaquets,
                                    t_SD_BAS_PaquetN0**
                                    listePaquetLigne) 
{
  //@ Recuperation de la ligne
  SD_DON_LigneN0 ligneN0 = GetLigne(numLigne);
  
  //@ SI la ligne n'est pas valide
  if (ligneN0.EstValide() == CMN__FAUX)
    {
      //@ Aucun paquet n'est renvoye
      nbPaquets = 0;
    }
  //@ SINON
  else
    {
      //@ Recuperation de la liste des paquets de la ligne via la 
      //@ methode SD_DON_LigneN0::GetPaquetLigne()
      ligneN0.GetPaquetLigne(type, nbPaquets, listePaquetLigne);
    }         
  //@ FIN SI la ligne n'est pas valide
}


//@ ------------------------------------------------------------------*/
//@ Methode : InitLecture
//@
//@ Description : Initialise l'acces au granule de niveau 0 en lecture
//@
//@ Parametres :
//@               (ENTREE) nomProduit : Nom du produit
//@               (ENTREE) t0 : Date de debut issue du Work Order
//@               (ENTREE) t1 : Date de fin issue du Work Order
//@               (ENTREE) OBTUTC : Objet pour la correction temps UTC
//@               (ENTREE) gestionCasDegrade : Gestionnaire de cas 
//@                                            degrade
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
/* FA 183 */
void SD_DON_GranuleN0::InitLecture(const t_Chaine& nomProduit,
                                   const t_Date& t0,
                                   const t_Date& t1,
                                   SD_DON_OBTUTC& OBTUTC,
                                   SD_DON_GestCasDeg& gestionCasDegrade,
				   const e_BAS_ModeTrt& modeTraitement )
/* ..FA 183 */
  throw (ERR__Exception)
{
  // Exception generee
  ERR__Exception       exception;

  // Message pour l'exception
  t_ChaineFixe         message;
  t_Chaine             messageException("");

  // Donnees de contexte
  t_SD_BAS_DataThread* ctx            = NULL;

  // Descripteur de fichier
  t_SD_BAS_Fd          ficDesc;
  t_CMN__Booleen       ficOuvert      = CMN__FAUX;

  // Nom de fichier
  t_SD_BAS_NomProduit  nomFichier;

  // Nombre de MDR pour une ligne
  int                  nbMDR          = 0;

  // Code retour des fonctions utilisees
  t_CMN__Statut        statut         = CMN__STATUT_OK;

#ifdef OPS_DEBUG
  // Nom de la methode
  static const char    tcProcName_F[] = "SD_DON_GranuleN0::InitLecture";
#endif

  //@ En captant les exceptions  
  try
    {
      //@ Allocation memoire pour les donnees de contexte
      ctx = new t_SD_BAS_DataThread;
      InitialiserCompteRendu(&(ctx->cr));

      //@ m_NomGranule = nomProduit
      m_NomGranule = nomProduit;
      strcpy(nomFichier, m_NomGranule.c_str());
      
      //@ 1. Lecture du fichier en entree
  
      //@ Ouverture du produit N0
 /* FA 162 */
      statut = SD_BAS_OuvrirProduit(LECTURE, 
                                    NA_IASIL0, 
                                    nomFichier, 
                                    &ficDesc, 
                                    ctx,
				    modeTraitement);

/* ..FA 162 */
      //@ SI l'ouverture du produit N0 a genere une erreur
      if (statut != CMN__STATUT_OK)
        {

#ifdef OPS_DEBUG
          cerr << tcProcName_F << ": Erreur OuvrirProduit: " << 
            nomFichier << " (" << statut << ")" << endl;
#endif
          
          //@ Recuperation du message d'erreur genere par 
          //@ les couches basses
          RecupererDernierMessageStocke(&(ctx->cr.msgJDB), message);
          messageException = t_Chaine(message) + EXCEPTION_SEPARATEUR +
            m_NomGranule;

          //@ Emission d'une exception SD_DON_FILE_OPEN
          exception.SetErrorCode(ERR__Exception::SD_DON_FILE_OPEN);
          exception.SetParametre(messageException);
          THROW(exception);
        }
      //@ FIN SI l'ouverture du produit N0 a genere une erreur
      
    
#ifdef OPS_DEBUG
      cout << tcProcName_F << ": OuvrirProduit: " << 
        nomFichier << "(" << statut << ")" << endl;
#endif

      //@ Le fichier est ouvert
      ficOuvert = CMN__VRAI;

      //@ Lecture et initialisation du MPHR du granule m_MPHR
      statut = SD_BAS_LireMPHRN0(&ficDesc, &m_MPHR, ctx);

      //@ SI la lecture du MPHR a genere une erreur
      if (statut != CMN__STATUT_OK)
        {

#ifdef OPS_DEBUG
          cerr << tcProcName_F << ": Erreur LireMPHRN0: " << 
            nomFichier << " (" << statut << ")" << endl;
#endif
          
          //@ Recuperation du message d'erreur genere par 
          //@ les couches basses
          RecupererDernierMessageStocke(&(ctx->cr.msgJDB), message);
          messageException = t_Chaine(message) + EXCEPTION_SEPARATEUR +
            m_NomGranule;

          //@ Emission d'une exception SD_DON_FILE_READ
          exception.SetErrorCode(ERR__Exception::SD_DON_FILE_READ);
          exception.SetParametre(messageException);
          THROW(exception);
        }
      //@ FIN SI la lecture du MPHR a genere une erreur
      
#ifdef OPS_DEBUG
      cout << tcProcName_F << ": LireMPHRN0: " << 
        nomFichier << "(" << statut << ")" << endl;
      
      // Affichage MPHR
      AfficherMPHR(CMN__VRAI);
      
      cout << "1er offset MDR: " << ficDesc.offsetMDR << endl;
      cout << "Offset suivant: " << ficDesc.offsetMDRSuivant << endl;
#endif
      
 
      //@ 2. Gestion de l'overlap (pour determiner le debut
      //@    et la fin du produit a traiter)
/* FA 183 */
      GestionOverlap(t0, t1, OBTUTC, ficDesc, ctx, modeTraitement);
/* ..FA 183 */
      
      //@ 3. Lecture des donnees
      //@ On se deplace jusqu'a la ligne numero m_IndiceDebut
      
      //@ POUR chaque ligne du tableau m_ListeInfoGenLigne
      for (int i=m_IndiceDebut; i<m_ListeInfoGenLigne.size(); i++)
        {
          nbMDR = m_ListeInfoGenLigne[i].GetNumMDRFin() -
            m_ListeInfoGenLigne[i].GetNumMDRDebut() + 1;
          
#ifdef OPS_DEBUG
          cout << "Ligne: " << i+1 << " - Nb MDR: " << nbMDR << endl;
#endif
          
          //@ Creation d'une ligne de niveau 0 (SD_DON_LigneN0)
          SD_DON_LigneN0 nouvelleLigneN0;
          nouvelleLigneN0.Init(i-m_IndiceDebut, 
                               m_ListeInfoGenLigne[i], 
                               gestionCasDegrade);
 
          //@ Mise a jour de l'offset de lecture
          ficDesc.offsetMDRSuivant = m_ListeInfoGenLigne[i].GetOffset();

          //@ SI la ligne est valide
          if (nouvelleLigneN0.EstValide() == CMN__VRAI)
            {
              //@ POUR chaque MDR de la ligne
              for (int j=0; j<nbMDR; j++)
                {
                  //@ Creation d'un paquet de niveau 0
                  SD_DON_PaquetN0* nouveauPaquetN0 = 
                    new SD_DON_PaquetN0;
                  
                  //@ Lire un MDR via la methode 
                  //@ SD_DON_PaquetN0::Lire()
                  nouveauPaquetN0->Lire(ficDesc);
                  
#ifdef INVESTIGATION
                  cout << "Lecture MDR: offset: "
                       << ficDesc.offsetMDR << " - offset suivant: " 
                       << ficDesc.offsetMDRSuivant << endl;
#endif
                  
                  //@ On stocke ici toute la donnee non decodee
                  
                  //@ Ajouter le MDR courant a la ligne de 
                  //@ niveau 0 via la methode
                  //@ SD_DON_LigneN0::AddPaquetLigne()
	         // si le mdr n'est pas dummy
		  t_SD_BAS_PaquetN0 * dataN0=nouveauPaquetN0->GetData();
		  if (dataN0->InfoGen.tab_var[N0_VALIDREC].val.pui4[0] == INVALIDE)
		    {
		    delete nouveauPaquetN0;
		    }
		  else
		    {
                    nouvelleLigneN0.AddPaquetLigne(nouveauPaquetN0);
		    }
		  
                }
              //@ FIN POUR chaque MDR de la ligne
            }
          //@ FIN SI la ligne est valide
	  else
	  //@ sinon
           {
          // emission d'un message indiquant la presence d'un MDR dummy
          //@ Emission d'un message de type JDB 
           JDB__Client messageJDB;
           messageJDB.SetParametre(JDB_PARAM_1, i-m_IndiceDebut+1);
           messageJDB.EcrireMessage(SD_DATA_SET, 
                                   SD__Message::
                                   MSG_DUMMY_DATA_GENERATED);
           messageJDB.Liberer();
          }

          //@ SI la ligne est valide
          if (nouvelleLigneN0.EstValide() == CMN__VRAI)
            {
              //@ Valider la ligne courante via la methode 
              //@ SD_DON_LigneN0::ValideLigne(), afin de cloturer
              //@ le calcul de tous les cas degrades
              nouvelleLigneN0.ValideLigne();
            }
          //@ FIN SI la ligne est valide

          //@ Ajouter la ligne dans la liste des lignes du granule
             m_ListeLigneN0.push_back(nouvelleLigneN0);
        }
      //@ FIN POUR chaque ligne du tableau m_ListeInfoGenLigne
      

      //@ Fermeture du fichier de N0 en lecture
/* FA 162 */
      SD_BAS_FermerProduit(LECTURE, &ficDesc, ctx,modeTraitement);
/* ..FA 162 */
      //@ Liberation memoire pour les donnees de contexte
      LibererCompteRendu(&(ctx->cr.msgJDB));
      delete ctx;
    }


  //@ Traiter les exceptions
  catch(ERR__Exception& exception)
    {

#ifdef OPS_DEBUG
      //@ Impression des exceptions
      cout << "Exception in " << tcProcName_F << endl;
      cout << "\tFile : " << exception.GetFile() << endl;
      cout << "\tLine : " << exception.GetLine() << endl;
      cout << "\tError: " << exception.GetErrorCode() << endl;
      for (int i=0; i<exception.GetNbParametre(); i++)
        {
          cout << "\tInfo : " << exception.GetParametre(i) << endl;
        }
#endif

      //@ SI le fichier est ouvert
      if (ficOuvert == CMN__VRAI)
        {
          //@ Fermeture du fichier de N0 en lecture
/* FA 162 */
          SD_BAS_FermerProduit(LECTURE, &ficDesc, ctx,modeTraitement);
/* ..FA 162 */ 
        }
      //@ FIN SI le fichier est ouvert

      //@ Envoi des messages generes au JDB
      EnvoyerMessagesStockes(&(ctx->cr.msgJDB));

      //@ Liberation memoire pour les donnees de contexte
      LibererCompteRendu(&(ctx->cr.msgJDB));
      delete ctx;

      //@ Emission d'un message de type JDB MSG_SD_FILE_READ_ERROR
      JDB__Client messageJDB;
      messageJDB.SetParametre(JDB_PARAM_1, m_NomGranule);
      messageJDB.EcrireMessage(SD_SET, 
                               SD__Message::MSG_SD_FILE_READ_ERROR);
      messageJDB.Liberer();

      //@ Re-emission de l'exception
      exception.SetDebParametre(ERROR_INIT_READING + m_NomGranule);
      throw(exception);
    }
}


//@ ------------------------------------------------------------------*/
//@ Methode : DecodeDataLigne
//@
//@ Description : Decode un paquet de niveau 0 contenue dans une
//@               ligne. Le decodage se limite ici a l'extraction
//@               du champ de bit correspondant au spectre
//@
//@ Parametres :
//@               (ENTREE) paquetLigne : Paquet N0
//@               (SORTIE) dataDecode : Donnees decodees
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN0::DecodeDataLigne(t_SD_BAS_PaquetN0* paquetLigne,
                                       void* dataDecode)
{
  // Objet paquet de niveau 0
  SD_DON_PaquetN0 paquetN0;


  //@ Mise a jour des donnees de l'objet paquet de niveau 0
  paquetN0.SetData(paquetLigne);

  //@ Decodage du paquet courant via la methode 
  //@ SD_DON_PaquetN0::Decode()
  paquetN0.Decode(dataDecode);
}


//@ ------------------------------------------------------------------*/
//@ Methode : Afficher
//@
//@ Description : Afficher les infos du granule
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN0::Afficher()
{
  cout << "------------------------------------------------------------"
       << endl;
  cout << "--------------------- Infos Granule N0 ---------------------"
       << endl;
  SD_DON_Granule::Afficher();

  cout << "Etat granule    : " << m_EtatGranule
       << " (0:?? 1:DEBUT 2:FIN)" << endl;
  cout << "Nb lignes N0    : " << m_ListeLigneN0.size() << endl;
  cout << endl;
  cout << "------------------------------------------------------------"
       << endl << endl;
}


//======================================================================
//                                      METHODES PRIVEES 
//======================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : GetLigne
//@
//@ Description : Recupere une ligne du granule
//@
//@ Parametres :
//@               (ENTREE) numLigne : Numero de la ligne demandee
//@
//@ Valeur de retour : 
//@               Ligne demandee
//@
//@ ------------------------------------------------------------------*/
SD_DON_LigneN0& SD_DON_GranuleN0::GetLigne(const int numLigne) 
  throw (ERR__Exception)
{
  // Exception generee
  ERR__Exception           exception;

  // Iterateur pour la liste des lignes
  t_ListeLigneN0::iterator pInfo;

  // Temoin de recherche
  t_CMN__Booleen           trouve = CMN__FAUX;


  //@ Verification de coherence du numero de la ligne: il doit 
  //@ etre compris dans l'ensemble [0, m_NbLigne-1]

  //@ SI le numero de la ligne n'est pas coherent
  if ( (numLigne < 0) || (numLigne > (m_NbLigne-1)) )
    {
      //@ Emission d'une exception SD_DON_OPER_FAILED
      exception.SetErrorCode(ERR__Exception::SD_DON_OPER_FAILED);
      THROW(exception);
    }
  //@ FIN SI le numero de la ligne n'est pas coherent


  //@ Recherche de la ligne souhaitee
  pInfo = m_ListeLigneN0.begin();

  //@ TANT QUE il existe des lignes ET QUE la ligne
  //@ souhaitee n'a pas ete trouvee
  /* modif CNES R. MORENO */
  do
    {
      //@ SI le numero de la ligne correspond a celui de la
      //@ ligne souhaitee
      if (pInfo->GetNumLigne() == numLigne)
        {
          //@ La ligne a ete trouvee
          //@ Mettre a jour le temoin de recherche
          trouve = CMN__VRAI;
        }
      //@ SINON ce n'est pas la ligne souhaitee
      else
        {
          //@ Passer a la ligne suivante
          pInfo++;
        }
      //@ FIN SI
    }
  while (pInfo != m_ListeLigneN0.end() && (trouve == CMN__FAUX));
  //@ FIN TANT QUE
  
  //@ SI la ligne n'a pas ete trouvee
  if (trouve != CMN__VRAI)
    {
      //@ Emission d'une exception SD_DON_OPER_FAILED
      exception.SetErrorCode(ERR__Exception::SD_DON_OPER_FAILED);
      THROW(exception);
    }         
  //@ FIN SI la ligne n'a pas ete trouvee

  
  //@ On retourne la ligne trouvee
  return *pInfo;
}


//@ ------------------------------------------------------------------*/
//@ Methode : GestionOverlap
//@
//@ Description : Determine les dates de debut et fin des lignes
//@               utilisees dans le traitement de niveau 1. On prend
//@               en compte ici le cas des dumps qui se traduit par
//@               le choix de dates t0 et t1 inclues dans le produit
//@
//@ Parametres :
//@               (ENTREE) t0 : Date de debut issue du Work Order
//@               (ENTREE) t1 : Date de fin issue du Work Order
//@               (ENTREE) OBTUTC : Objet pour la correction temps UTC
//@               (ENTREE/SORTIE) ficDesc : Descripteur de fichier
//@               (ENTREE/SORTIE) ctx : Donnees de contexte
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/

/* FA 183 */
void SD_DON_GranuleN0::GestionOverlap(const t_Date& t0,
                                      const t_Date& t1,
                                      SD_DON_OBTUTC& OBTUTC,
                                      t_SD_BAS_Fd& ficDesc,
                                      t_SD_BAS_DataThread* ctx,
				      const e_BAS_ModeTrt& modeTraitement)
/* ..FA 183 */
  throw (ERR__Exception)
{
  // Donnees generales
  t_SD_BAS_Liste_Var donneesGenerales;

  // Contexte d'appel des fonctions de lecture MDR
  e_BAS_CtxInit      ctxInit      = CTX_INIT;

  // Donnees generales recuperees
  unsigned int       tOBT         = 0;
  t_SCDSTime         tSCDS;
  t_Date             dateMDR;
  int                nbInfoGen    = 0;

  // Indice de parcours
  int                iMDR         = 0;

  // Temoin de recherche
  t_CMN__Booleen     dateDepassee = CMN__FAUX;

  // Code retour des fonctions utilisees 
  t_CMN__Statut      statut       = CMN__STATUT_OK;


  //@ Initialiser l'etat interne a EVT_INDETERMINE
  m_EtatGranule = EVT_INDETERMINE;
  
  //@ Mise a jour du contexte d'appel: INIT

  //@ TANT QUE il existe des MDR ET QUE le MDR courant 
  //@ n'a pas depasse la date de fin du traitement

#ifdef OPS_DEBUG
   cout <<"NbMdr fic desc = " << ficDesc.nombreMDR << endl;
#endif

  while ( (iMDR < ficDesc.nombreMDR) && (dateDepassee == CMN__FAUX) )
    {
      donneesGenerales.nb_var  = 0;
      donneesGenerales.tab_var = 0;

      //@ Lire le premier MDR en ne decodant que le type, la date UTC,
      //@ le numero de SN et de SP, le PTSI et le mode
      //@ On ne stocke pas ici la donnee elle meme
      
      //@ Appel de la fonction de lecture des donnees generales 
      //@ d'un MDR
      statut = SD_BAS_LireMDRGenN0(ctxInit,
                                   ficDesc.offsetMDR,
                                   &ficDesc,
                                   ctx,
                                   &donneesGenerales);

#ifdef INVESTIGATION
          cout << "LireMDRGenN0 MDR# " << iMDR << " - statut: " 
               << statut << endl;
#endif

      //@ SI la lecture du MDR a genere une erreur
      if (statut != CMN__STATUT_OK)
        {

#ifdef OPS_DEBUG
          cerr << "SD_DON_GranuleN0::GestionOverlap: "
               << "erreur LireMDRGenN0 " << m_NomGranule << 
               " (" << statut << ")" << endl;
#endif

          //@ Envoi des messages generes au JDB
          EnvoyerMessagesStockes(&(ctx->cr.msgJDB));
          InitialiserListeErreurs(&(ctx->cr.errinterne));
        }
      //@ SINON 
      else
        {      

#ifdef INVESTIGATION
          cout << "Offset MDR     : " << ficDesc.offsetMDR << endl;
          cout << "Offset suivant : " << ficDesc.offsetMDRSuivant 
               << endl;
          cout << "Type           : " 
               << donneesGenerales.tab_var[N0_TYPE].val.pui4[0]
               << endl;
          cout << "Longueur data  : "
               << donneesGenerales.tab_var[N0_LONGUEURDATA].val.pui4[0] 
               << endl;
          cout << "Numero PN      : " 
               << donneesGenerales.tab_var[N0_PN].val.pui4[0] 
               << endl;
          cout << "Date UTC       : "
               <<  donneesGenerales.tab_var[N0_DATEUTC].val.pdate->day
               << " - " 
               << donneesGenerales.tab_var[N0_DATEUTC].val.pdate->millis
               << endl;
          cout << "Date OBT       : "
               << donneesGenerales.tab_var[N0_DATEOBT].val.pui4[0] 
               << endl;
          cout << "Numero SN      : " 
               << donneesGenerales.tab_var[N0_SN].val.pui4[0] 
               << endl;
          cout << "Numero SP      : " 
               << donneesGenerales.tab_var[N0_SP].val.pui4[0] 
               << endl;
          cout << "PTSI           : " 
               << donneesGenerales.tab_var[N0_PTSI].val.pui4[0] 
               << endl;
          cout << "Version a bord : " 
               << donneesGenerales.tab_var[N0_ONBOARD_SOFTWARE_VERSION].val.pui4[0] 
               << endl;
          
          /* CR243*/
          cout << "LN             : " 
               << donneesGenerales.tab_var[N0_LN].val.pui4[0] 
               << endl;
          
          cout << "Mode           : " 
               << donneesGenerales.tab_var[N0_MODE].val.pui4[0] 
               << endl;
          cout << "Longueur record: " 
               << donneesGenerales.tab_var[N0_LONGUEURREC].val.pui4[0] 
               << endl;
          cout << "Validite record: " 
               << donneesGenerales.tab_var[N0_VALIDREC].val.pui4[0] 
               << endl;
          cout << "Offset         : " 
               << donneesGenerales.tab_var[N0_OFFSET].val.pui4[0] 
               << endl;
          cout << "Date debut     : "
               <<  donneesGenerales.tab_var[N0_DATEDEB].val.pdate->day
               << " - " 
               << donneesGenerales.tab_var[N0_DATEDEB].val.pdate->millis
               << endl;
          cout << "Date fin       : "
               <<  donneesGenerales.tab_var[N0_DATEFIN].val.pdate->day
               << " - " 
               << donneesGenerales.tab_var[N0_DATEFIN].val.pdate->millis
               << endl;
#endif
          
          tSCDS.day    = donneesGenerales.tab_var[N0_DATEUTC].val.
            pdate->day;
          tSCDS.millis = donneesGenerales.tab_var[N0_DATEUTC].val.
            pdate->millis;
          tOBT         = donneesGenerales.tab_var[N0_DATEOBT].val.
            pui4[0];
      
          //@ Corriger les dates UTC par l'utilisation de 
          //@ SD_DON_OBTUTC:CorrigeOBT()
          dateMDR.SCDSTime(tSCDS);
          OBTUTC.CorrigeOBT(tOBT, dateMDR);
      
          //@ Identifier les differentes lignes du produit
          IdentifierLignes(iMDR,
                           t0, /* CR243 */
                           t1, 
                           donneesGenerales, 
                           dateMDR, 
                           dateDepassee);

          //@ Liberation memoire des donnees generales
          //@ via la fonction SD_BAS_LibereListeVar()
          SD_BAS_LibereListeVar(LECTURE, &donneesGenerales);
       }
      //@ FIN SI la lecture du MDR a genere une erreur

      //@ Mise a jour du contexte d'appel: NORMAL
      ctxInit = CTX_NORMAL;
      iMDR++;
    }
  //@ FIN TANT QUE il existe des MDR ET QUE le MDR courant 
  //@ n'a pas depasse la date de fin du traitement

  nbInfoGen = m_ListeInfoGenLigne.size();

#ifdef INVESTIGATION
  cout << endl << "SD_DON_GranuleN0::GestionOverlap: " << endl
       << "Nb lignes identifiees : " << nbInfoGen << endl << endl;
#endif

  //@ SI des lignes ont ete identifiees
  if (nbInfoGen > 0)
    {
    
    // FT-2750
 	int RefPDV = m_ListeInfoGenLigne[0].GetModePriseDeVue();
    int ModePDV;

    for (int indexLine=1; indexLine < nbInfoGen; indexLine++)
    {
      ModePDV = m_ListeInfoGenLigne[indexLine].GetModePriseDeVue();
      if (ModePDV != RefPDV)
      {
        if (m_ListeInfoGenLigne[indexLine-1].GetValidite() != INVALIDE)
        {
          //@ SI la derniere ligne n'est pas complete en mode normal
          // on considere ici du'il faut tous les pixels
          if ((RefPDV == SD_BAS_NORMAL) && 
               m_ListeInfoGenLigne[indexLine-1].GetNumMDRFin() < (m_ListeInfoGenLigne[indexLine-1].GetNumMDRDebut() 
               + NB_ISP_LIGNE_NORM_COMPLETE -1))
          {
            // Marque la ligne comme DMDR
            m_ListeInfoGenLigne[indexLine-1].SetValidite(INVALIDE);
          }
          //@ SI la derniere ligne n'est pas complete en mode CALIBRATION
          // on considere ici du'il faut tous les pixels
          else if ( m_ListeInfoGenLigne[indexLine-1].GetNumMDRFin() < (m_ListeInfoGenLigne[indexLine-1].GetNumMDRDebut()
                    + NB_ISP_LIGNE_CAL_COMPLETE -1))
          {
            // Marque la ligne comme DMDR
            m_ListeInfoGenLigne[indexLine-1].SetValidite(INVALIDE);
          }
        }
        RefPDV = ModePDV;
      }
    }  
    // ...FT-2750

      //@ SI la derniere ligne n'est pas complete en mode normal
      // on considere ici du'il faut tous les pixels
      if (  m_ListeInfoGenLigne[nbInfoGen-1].GetModePriseDeVue() == SD_BAS_NORMAL 
           && (m_ListeInfoGenLigne[nbInfoGen-1].GetNumMDRFin() <
              (m_ListeInfoGenLigne[nbInfoGen-1].GetNumMDRDebut() + NB_ISP_LIGNE_NORM_COMPLETE -1 )) )
        {
          /* CR243 : on ne veut pas supprimer un DMDR */
          if (m_ListeInfoGenLigne[nbInfoGen-1].GetValidite() != INVALIDE)
          {
            //@ Suppression de la derniere ligne
            m_ListeInfoGenLigne.pop_back();
            nbInfoGen--;
          }
          /* FIN CR243 */
        }
      //@ SI la derniere ligne n'est pas complete en mode CALIBRATION
      // on considere ici du'il faut tous les pixels
     else if ( (m_ListeInfoGenLigne[nbInfoGen-1].GetNumMDRFin() <
              (m_ListeInfoGenLigne[nbInfoGen-1].GetNumMDRDebut() + NB_ISP_LIGNE_CAL_COMPLETE -1)) )
	      
        {
          /* CR243 : on ne veut pas supprimer un DMDR */
          if (m_ListeInfoGenLigne[nbInfoGen-1].GetValidite() != INVALIDE)
          {
            //@ Suppression de la derniere ligne
            m_ListeInfoGenLigne.pop_back();
            nbInfoGen--;
          }
          /* FIN CR243 */
        }
     
      //@ FIN SI la derniere ligne n'est pas complete    
    }
  //@ FIN SI des lignes ont ete identifiees

  //@ SI aucune ligne n'a ete identifiee
  if (nbInfoGen == 0)
    {
      // Exception generee
      ERR__Exception exception;
         

#ifdef OPS_DEBUG
      cerr << "SD_DON_GranuleN0::GestionOverlap: "
           << "aucune ligne n'a ete identifiee pour " 
           << m_NomGranule << endl;
#endif

      //@ Le nombre de lignes est egal a 0 
      m_NbLigne = 0;

      //@ Emission d'une exception SD_DON_FILE_READ
      exception.SetErrorCode(ERR__Exception::SD_DON_FILE_READ);
      exception.SetParametre(NO_LINE_IN_PRODUCT+m_NomGranule);
/* FA 183 */
    // Si mode dump alors ne pas envoyer l'exception qui bloque l'OPS
    if (DUMP != modeTraitement)
    {
        THROW(exception);
    }
    else
   { 
     cout << "Mode DUMP: exception non envoyee 1!" << endl;
   }
/* ..FA 183 */
    }
  //@ FIN SI aucune ligne n'a ete identifiee
 
  //@ En captant les exceptions
  try
  {
    //@ Determiner les bornes du granule
    DeterminerBornes(t0, t1);
  }
  catch (ERR__Exception& exception)
  {
#ifdef OPS_DEBUG
    cerr << "SD_DON_GranuleN0::GestionOverlap: "
         << "m_NbLigne=0 apres DeterminerBornes pour" 
         << m_NomGranule << endl;
#endif

/* FA 183 */
    // Si mode dump alors ne pas envoyer l'exception qui bloque l'OPS
    if (DUMP != modeTraitement)
    {    THROW(exception);}
    else
      {cout << "Mode DUMP: exception non envoyee 2!" << endl;
         // on conserve la date T1 precedente 
	  m_TP1  = t1;
      }
/* ..FA 183 */
  }
}


//@ ------------------------------------------------------------------*/
//@ Methode : IdentifierLignes
//@
//@ Description : Determine les debut et fin des lignes d'un MDR
//@
//@ Parametres :
//@               (ENTREE) noMDR : Indice du MDR dans le granule
//@               (ENTREE) t0 : Date de debut issue du Work Order
//@               (ENTREE) t1 : Date de fin issue du Work Order
//@               (ENTREE) donneesGenerales : Donnees generales lues
//@                                           dans l'entete du MDR
//@               (ENTREE) dateMDR : Date du MDR
//@               (SORTIE) dateDepassee : Temoin d'arret de lecture
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN0::IdentifierLignes(const int indiceMDR,
                                        const t_Date& t0, /* CR243 */
                                        const t_Date& t1,
                                        const t_SD_BAS_Liste_Var& 
                                        donneesGenerales,
                                        const t_Date& dateMDR, 
                                        t_CMN__Booleen& dateDepassee)
{
  /* CR243 : reecriture complete de la methode */
  // Declaration des variables
  int                   LN;
  unsigned int          offset;
  e_BAS_ValidRec        validite;
  
  /* static int            LNprec = -1; */
  
  static e_BAS_ModePdv  modeInitial = 
    (e_BAS_ModePdv) donneesGenerales.tab_var[N0_MODE].val.pui4[0];
  static e_BAS_ValidRec validiteLigne  = VALIDE;
  
  unsigned int type = donneesGenerales.tab_var[N0_TYPE].val.pui4[0];
  
  // DM 3353
  // Exception generee
  ERR__Exception       exception;

  // Initialisation des variables
  LN = 0;
  offset = donneesGenerales.tab_var[N0_OFFSET].val.pui4[0];
  validite = (e_BAS_ValidRec) donneesGenerales.tab_var[N0_VALIDREC].val.pui4[0];
  
  // Gestion des DMDR N0
  if (validite == INVALIDE)
  {
    t_SCDSTime tSCDS;
    t_Date     dateDebut;
    t_Date     dateFin;

    // emission d'un message indiquant la presence d'un MDR dummy
    //@ Emission d'un message de type JDB MSG_DUMMY_DATA_DETECTED
    JDB__Client messageJDB;
    messageJDB.EcrireMessage(
      SD_DATA_SET, 
      SD__Message::MSG_DUMMY_DATA_DETECTED);
    messageJDB.Liberer();
    
    //@ Referencer le trou de donnees
    m_NbDataGap++;

    //@ Recuperation des dates de debut et de fin
    tSCDS.day    = donneesGenerales.tab_var[N0_DATEDEB].val.pdate->day;
    tSCDS.millis = donneesGenerales.tab_var[N0_DATEDEB].val.pdate->millis;
    dateDebut.SCDSTime(tSCDS);

    tSCDS.day    = donneesGenerales.tab_var[N0_DATEFIN].val.pdate->day;
    tSCDS.millis = donneesGenerales.tab_var[N0_DATEFIN].val.pdate->millis;
    dateFin.SCDSTime(tSCDS);
    
/* FA 186*/
    if(dateDebut < t0)
      dateDebut = t0;

    if(dateFin > t1)
      dateFin=t1;

/* ..FA 186*/


    // on cree ici une ligne si la duree est suffisante  SD_BAS_DUREE_LGN    
    if ( (dateFin - dateDebut) > SD_BAS_DUREE_LGN )
    {
#ifdef OPS_DEBUG
      cout << "Ligne DUMMY: " << endl;
      cout << "\tindice MDR : " << indiceMDR << endl;
      cout << "\toffset     : " << offset << endl;
      cout << "\tdate debut : " << dateDebut.Chaine() << endl;
      cout << "\tdate fin   : " << dateFin.Chaine() << endl;
#endif

      //@ Creer un nouvel element descripteur de ligne
      CreerLigneDummy(
        indiceMDR, 
        offset, 
        dateDebut, 
        dateFin);
      
    }
    
    // on cree ici une ligne si la duree est suffisante      
    //@ SI date de fin > t1
    if (dateFin > t1)
    {
      //@ On arrete: on met a jour le temoin d'arret
      dateDepassee = CMN__VRAI;
#ifdef OPS_DEBUG
	      cout << "##1 dateFin > t1 => dateDepassee = CMN__VRAI " << endl;
#endif

    } //@ FIN SI date de fin > t1
    
  } // FIN SI DMDR N0
  
  // SI pas de DMDR N0
  else
  {
    // Gestion depassement de date t1
    t_Date dateMDRtmp(dateMDR);
#ifdef INVESTIGATION
      cout << "dateMDR : " << dateMDRtmp.Chaine() << endl;
#endif
    if (dateMDRtmp > t1)
    {
      /* si VDS=35 ou 36, la date des paquets VPC est a 0. cf IMVD */
      /* Il ne faut pas activer le flag dateDepassee dans ce cas */
      if (type != VP)
      {
        //@ On arrete: on met a jour le temoin d'arret
        dateDepassee = CMN__VRAI;

#ifdef OPS_DEBUG
              cout << "##2 dateMDRtmp > t1 => dateDepassee = CMN__VRAI " << endl;
              t_Date datet1(t1);
              cout << "dateMDRtmp = "<< dateMDRtmp.Chaine() << endl;
              cout << "t1 = " << datet1.Chaine() << endl;
#endif


      }
    }
    
    // Recuperer le numero de ligne dans le MDR N0
    LN = donneesGenerales.tab_var[N0_LN].val.pui4[0]; // a implementer
    
    //@ SI Debut de granule sans debut de dump ALORS
    // ATTENTION: Pour conserver la 1ere ligne du tout premier granule, 
    // il faudrait remplacer le test par celui-ci:
    // if ( (indiceMDR == 0) && (LNprec != -1) )
    // cela permettrait de garder la 1ere ligne d'un dump et pas la 1ere ligne 
    // des granules >0 de ce dump seulement. LNprec n'etant pas remis a -1 pour 
    // les dump suivants, la 1ere ligne des dump suivants ne serait pas traitee.
    if (indiceMDR == 0)
    {
      if (dateMDRtmp < t0)
      {
        m_N0_LN_prec = LN;
      }
    }
    
    //@ SI nouvelle ligne
    /* on laisse le test != au lieu de >  car l'indice de ligne N0_LN peut */
    /* etre remis a zero dans le produit N0 */
    if (LN != m_N0_LN_prec)
    {
      unsigned int PTSI = 
        (unsigned int) donneesGenerales.tab_var[N0_PTSI].val.pi4[0];
      
      // CR246 version du logiciel bord
      unsigned int VersionLogicielBord = 
        (unsigned int) donneesGenerales.tab_var[N0_ONBOARD_SOFTWARE_VERSION].val.pi4[0];
      
      //@ Mode instrument AUXILIARY, NORMAL ou CALIB EXTERN
      modeInitial = 
        (e_BAS_ModePdv) donneesGenerales.tab_var[N0_MODE].val.pui4[0];      
	
      //@ Creer un nouvel element
      //@ descripteur de ligne
      CreerLigne(
        indiceMDR, 
        offset, 
        PTSI, 
        VersionLogicielBord, 
        modeInitial, 
        LN, 
        dateMDR);
      
      // Mettre a jour la validite de la ligne avec celle du MDR
      validiteLigne = validite;
      
      m_N0_LN_prec = LN;
      
    } // FIN SI nouvelle ligne
    
    //@ SI meme ligne
    else
    {
      e_BAS_ModePdv mode = 
        (e_BAS_ModePdv) donneesGenerales.tab_var[N0_MODE].val.pui4[0];
      
      //@ SI le mode a change
// CR271 prise en compte mode de transition pour creation d'un statud de ligne
      e_BAS_Transition transition = 
        (e_BAS_Transition) donneesGenerales.tab_var[N0_MODE_TRANSITION].val.pui4[0];

      if (transition == SD_BAS_TRANSITION && validite == VALIDE)
      {
        //@ Emission d'un message de type 
        //@ JDB MSG_DATA_MODE_HAS_CHANGED
        JDB__Client messageJDB;
        messageJDB.SetParametre(JDB_PARAM_1, mode);
        messageJDB.EcrireMessage(
          SD_DATA_SET, 
          SD__Message::MSG_DATA_TRANSITION_DETECTED);
        messageJDB.Liberer();
                
        //@ Mise a jour de la validite de la ligne
        validiteLigne = TRANSITION;
        
      } //@ FIN SI le mode a change
      

      if (mode != modeInitial && validite == VALIDE)
      {
        //@ Emission d'un message de type 
        //@ JDB MSG_DATA_MODE_HAS_CHANGED
        JDB__Client messageJDB;
        messageJDB.SetParametre(JDB_PARAM_1, modeInitial);
        messageJDB.SetParametre(JDB_PARAM_2, mode);
        messageJDB.EcrireMessage(
          SD_DATA_SET, 
          SD__Message::MSG_DATA_MODE_HAS_CHANGED);
        messageJDB.Liberer();
        
        //@ Mise a jour du mode initial
        modeInitial = mode;
        
        //@ Mise a jour de la validite de la ligne
        validiteLigne = INVALIDE;
        
      } //@ FIN SI le mode a change
    } //@ FIN SI meme ligne
    
    // Numero de la ligne courante
    int iLig = m_ListeInfoGenLigne.size()-1;
    
    //@ SI une ligne est definie
    if (iLig >= 0)
    {
      // DM 3353 : Si la ligne courante est invalide et
      // que la date du MDR est inferieur à la date de la ligne courante
      if (m_ListeInfoGenLigne[iLig].GetValidite() == INVALIDE && validiteLigne == VALIDE)
      {
        if (m_ListeInfoGenLigne[iLig].GetDateFin() > dateMDR)
        {
            //@ Emission d'un message de type JDB MSG_SD_FILE_WRITE_ERROR
            JDB__Client messageJDB;
            messageJDB.SetParametre(JDB_PARAM_1, m_NomGranule);
            messageJDB.EcrireMessage(SD_DATA_SET,
                                     SD__Message::MSG_DUMMY_NEXT_MDR_INCONSITENT);
            messageJDB.Liberer();

            //@ Re-emission de l'exception
            exception.SetParametre(ERROR_DUMMY_NEXT_MDR_INCONSISTENT + m_NomGranule);
            throw(exception);
        }
      }
      //@ Mettre a jour la date de fin et la validite
      m_ListeInfoGenLigne[iLig].SetDateFin(dateMDR);
      m_ListeInfoGenLigne[iLig].SetValidite(validiteLigne);
      
      //@ RAZ de l'indicateur de validite ligne
//      validiteLigne = VALIDE; CR271
      
      //@ Mettre a jour le numero du dernier MDR
      m_ListeInfoGenLigne[iLig].SetNumMDRFin(indiceMDR);
      
    } // FIN SI une ligne est definie
  } // FIN SI pas de DMDR N0
}// FIN SD_DON_GranuleN0::IdentifierLignes


//@ ------------------------------------------------------------------*/
//@ Methode : CreerLigneDummy
//@
//@ Description : Cree une nouvelle ligne de type DUMMY
//@
//@ Parametres :
//@               (ENTREE) indiceMDR : Indice du MDR dans le granule
//@               (ENTREE) offset : Offset du MDR
//@               (ENTREE) dateDebut : Date de debut de la ligne
//@               (ENTREE) dateFin : Date de fin de la ligne
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN0::CreerLigneDummy(const int indiceMDR,
                                       const unsigned int offset,
                                       const t_Date& dateDebut,
                                       const t_Date& dateFin)
{
  t_InfoGenLigne nouvelleLigne;

  
  //@ Mettre a jour la date de debut et l'offset
  //@ Mettre a jour la date de fin et la validite
  nouvelleLigne.SetOffset(offset);
  nouvelleLigne.SetDateDebut(dateDebut);
  nouvelleLigne.SetDateFin(dateFin);
  nouvelleLigne.SetValidite(INVALIDE);
              
  //@ Mettre a jour le numero du MDR
  nouvelleLigne.SetNumMDRDebut(indiceMDR);
  nouvelleLigne.SetNumMDRFin(indiceMDR);
  
  //@ Ajouter l'element dans le tableau des 
  //@ descripteurs de lignes
  m_ListeInfoGenLigne.push_back(nouvelleLigne);
}


//@ ------------------------------------------------------------------*/
//@ Methode : CreerLigne
//@
//@ Description : Cree une nouvelle ligne
//@
//@ Parametres :
//@               (ENTREE) indiceMDR : Indice du MDR dans le granule
//@               (ENTREE) offset : Offset du MDR
//@               (ENTREE) PTSI : PTSI du MDR
//@               (ENTREE) version_logiciel_bord : version du logiciel bord
//@               (ENTREE) mode : Mode du MDR
//@               (ENTREE) LN : indice de ligne absolu N0_LN
//@               (ENTREE) dateMDR : Date du MDR
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN0::CreerLigne(const int indiceMDR,
                                  const unsigned int offset,
                                  const unsigned int PTSI,
                                  const unsigned int version_logiciel_bord,
                                  const e_BAS_ModePdv mode,
                                  const unsigned int LN, /* CR243 */
                                  const t_Date& dateMDR)
{
  t_InfoGenLigne nouvelleLigne;
  
  
  //@ Mettre a jour la date de debut et l'offset
  nouvelleLigne.SetOffset(offset);
  nouvelleLigne.SetDateDebut(dateMDR);
  nouvelleLigne.SetDateFin(dateMDR);
  
  //@ Mettre a jour le PTSI
  nouvelleLigne.SetPTSI(PTSI);
  
  //@ Mettre a jour le numero de version du logiciel bord CR246
  nouvelleLigne.SetVersionLogicielBord(version_logiciel_bord);
  
  //@ Mettre a jour le mode prise de vue
  nouvelleLigne.SetModePriseDeVue(mode);
              
  //@ Mettre a jour le numero du MDR
  nouvelleLigne.SetNumMDRDebut(indiceMDR);
  
  /* CR243 */
  //@ Mettre a jour le numero de ligne absolu
  nouvelleLigne.SetNumLigneAbsolu(LN);
  /* FIN CR243 */
  
  //@ Ajouter l'element dans le tableau des 
  //@ descripteurs de lignes
  m_ListeInfoGenLigne.push_back(nouvelleLigne);
}


//@ ------------------------------------------------------------------*/
//@ Methode : DeterminerBornes
//@
//@ Description : Determine les dates de debut et fin des lignes
//@               utilisees dans le traitement de niveau 1
//@
//@ Parametres :
//@               (ENTREE) t0 : Date de debut issue du Work Order
//@               (ENTREE) t1 : Date de fin issue du Work Order
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN0::DeterminerBornes(const t_Date& t0,
                                        const t_Date& t1)
  throw (ERR__Exception) /* FA168 */
{
  // Indicateur d'initialisation d'overlap
  t_CMN__Booleen bInit = CMN__FAUX;
  

#ifdef OPS_DEBUG
  // Affichage liste des descripteurs de lignes
  cout << endl 
       << "--------------------------------------------------" << endl;
  cout << "- Affichage liste des infos generales des lignes -" << endl;
  cout << "- Nombre de lignes: " << m_ListeInfoGenLigne.size() 
       << endl;
  for (int i=0; i<m_ListeInfoGenLigne.size(); i++)
    {
      cout << "Element: " << i+1 << endl;
      m_ListeInfoGenLigne[i].Afficher();
    }
  cout << "--------------------------------------------------" << endl;
#endif

  m_IndiceDebut = -1;
  m_IndiceFin = -1; /* FA168 */

  //@ POUR toutes les lignes du tableau precedent
  for (int i=0; i<m_ListeInfoGenLigne.size(); i++)
    {
      //@ SI dateDebut <= t0 et bInit = faux
      if ( (m_ListeInfoGenLigne[i].GetDateDebut() <= t0) &&
           (bInit == CMN__FAUX) )
        {
          //@ m_TP0         = dateDebut
          m_TP0         = m_ListeInfoGenLigne[i].GetDateDebut();
          
          //@ m_IndiceDebut = numLigne
          m_IndiceDebut = i;
        }
      //@ SINON
      else
        {
          
 // FA 199
          //@ bInit = VRAI
          bInit = CMN__VRAI;
          /* FA127 */
          //@ SI t0 est compris entre DateFin[i-1] et DateDebut[i]
          if ((i!=0) && (m_ListeInfoGenLigne[i-1].GetDateFin() < t0))
          {
            if (i < m_ListeInfoGenLigne.size())
            {
              //@ m_TP0         = dateDebut
              m_TP0         = m_ListeInfoGenLigne[i].GetDateDebut();
          
              //@ m_IndiceDebut = numLigne
              m_IndiceDebut = i;
            }
          }
	  
          /* FIN FA127 */
	 
// ..FA 199
        }
      //@ FIN SI dateDebut <= t0 et bInit = faux

      //@ SI dateFin >= t0 ET dateFin <= t1 
      if ((m_ListeInfoGenLigne[i].GetDateFin() >= t0) && /* FA168 */
          (m_ListeInfoGenLigne[i].GetDateFin() <= t1))
        {
          //@ m_TP1       = dateFin
          m_TP1       = m_ListeInfoGenLigne[i].GetDateFin();
          
          //@ m_IndiceFin = numLigne
          m_IndiceFin = i;
        }
      //@ FIN SI dateFin >= t0 ET dateFin <= t1 FA168
    }
  //@ FIN POUR toutes les lignes du tableau precedent
  
  //@ SI m_IndiceDebut = -1
     //CR270 
  if ( (m_IndiceDebut == -1) && (m_ListeInfoGenLigne.size() > 0) )
    {
      //@ m_TP0 = dateDebut[0]
      m_TP0         = m_ListeInfoGenLigne[0].GetDateDebut();

      //@ m_IndiceDebut = 0
      m_IndiceDebut = 0;
     //CR270 
    // dans le cas premiere ligne incomplete on ne la prend pas en compte
    if (  (m_ListeInfoGenLigne.size() > 1) &&
          (   m_ListeInfoGenLigne[0].GetModePriseDeVue() == SD_BAS_NORMAL 
           && (m_ListeInfoGenLigne[0].GetNumMDRFin()+1-m_ListeInfoGenLigne[0].GetNumMDRDebut()) < NB_ISP_LIGNE_NORM_COMPLETE ) ||
          (   m_ListeInfoGenLigne[0].GetModePriseDeVue() == SD_BAS_EXTERNAL_CALIBRATION
           && (m_ListeInfoGenLigne[0].GetNumMDRFin()+1-m_ListeInfoGenLigne[0].GetNumMDRDebut()) < NB_ISP_LIGNE_CAL_COMPLETE )
      )
     {
      m_TP0         = m_ListeInfoGenLigne[1].GetDateDebut();
      m_IndiceDebut = 1;
     }

      //@ Emission d'un message de type JDB MSG_DATA_START_DATE_INFO
      JDB__Client messageJDB;
      messageJDB.SetParametre(JDB_PARAM_1, m_TP0.Chaine());
      messageJDB.SetParametre(JDB_PARAM_2, t_Date(t0).Chaine());
      messageJDB.EcrireMessage(SD_DATA_SET, 
                               SD__Message::MSG_DATA_START_DATE_INFO);
      messageJDB.Liberer();
    }
  //@ FIN SI m_IndiceDebut = -1

  /* FA168 */
  if ((m_IndiceFin >= m_IndiceDebut) && (m_IndiceFin > -1))
  {
    //@ m_NbLigne = m_IndiceFin - m_IndiceDebut + 1
    m_NbLigne = m_IndiceFin - m_IndiceDebut + 1;
    /* CR243 */
    m_N0_LN_prec = m_ListeInfoGenLigne[m_IndiceFin].GetNumLigneAbsolu();
  }
  else
  {
    //@ m_NbLigne = 0
    m_NbLigne = 0;
    
    if ((m_ListeInfoGenLigne.size() > 0) && (m_IndiceFin == -1))
    {
      // Exception generee
      ERR__Exception exception;
      t_Chaine       messageException("");
#ifdef OPS_DEBUG
      cerr << "SD_DON_GranuleN0::DeterminerBornes: "
           << "Le produit est anterieur a la plage de dates demandees "
           << m_NomGranule << endl;
#endif
      //@ Emission d'une exception SD_DON_FILE_READ
      messageException = ERROR_IN_TIME_RANGE+"["+t_Date(t0).Chaine()+";"+
        t_Date(t1).Chaine()+"].";
      exception.SetErrorCode(ERR__Exception::SD_DON_FILE_READ);
      exception.SetParametre(messageException);
      THROW(exception);
    }
  }
  /* FIN FA168 */
}
