static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/DON/src/SD_DON_InfoGenLigne.cc,v 1.3 2011/11/25 10:17:45 dpauly Exp $";
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_DON
//@ CLASSE : SD_DON_InfoGenLigne
//@ 
//@ Commentaire :
//@    Ce module gere la classe SD_DON_InfoGenLigne, qui contient les
//@    informations generales sur une ligne de donnees
//@                                     
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 06/01/2003 : P. CABANE
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

//
// Fichiers include
//

// STL
#include <iostream>

// Standard

// Projet
#include "SD_DON_InfoGenLigne.h"


//
// Definition des constantes
//


//======================================================================
//                                       METHODES PUBLIQUES 
//======================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : SD_DON_InfoGenLigne
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_DON_InfoGenLigne::SD_DON_InfoGenLigne()
  : m_Offset(0), m_ModePriseDeVue(SD_BAS_NORMAL), m_BBT(-1), 
    m_PTSI(0), m_NumMDRDebut(-1), m_NumMDRFin(-1), m_Validite(VALIDE)
{
  m_DateDebut.DateInit();
  m_DateFin.DateInit();
}


//@ ------------------------------------------------------------------*/
//@ Methode : ~SD_DON_InfoGenLigne
//@
//@ Description : Destructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_DON_InfoGenLigne::~SD_DON_InfoGenLigne()
{
}


//@ ------------------------------------------------------------------*/
//@ Methode : Afficher
//@
//@ Description : Afficher les infos generales d'une la ligne
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_InfoGenLigne::Afficher()
{
  cout << "\tOffset      : " << m_Offset << endl;
  cout << "\tDate debut  : " << m_DateDebut.Chaine() << endl;
  cout << "\tDate fin    : " << m_DateFin.Chaine() << endl;
  cout << "\tPrise de vue: " << m_ModePriseDeVue
       << " (248:AUX 161:NORM 162:EXT)" << endl;
  cout << "\tBBT         : " << m_BBT << endl;
  cout << "\tPTSI        : " << m_PTSI << endl;
  cout << "\tMDR debut   : " << m_NumMDRDebut << endl;
  cout << "\tMDR fin     : " << m_NumMDRFin << endl;
  cout << "\tValidite    : " << m_Validite 
       << " (1:VAL 2:INVAL 3:INCOH)" << endl << endl;
}



//======================================================================
//                                      METHODES PRIVEES 
//======================================================================

