// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/DON/src/SD_DON_InfoGenLigne.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_DON
//@ CLASSE : SD_DON_InfoGenLigne
//@
//@ Commentaire :
//@    Fichier d'entete de la classe SD_DON_InfoGenLigne
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 06/01/2003 : P. CABANE
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID :IA-CR-2100-246-CNE : 06/07/2004 : B. MASSART
//@ word # 16 in level 0 PX packets is no more read as part of PTSI number
//@ Variable ONBOARD_SOFTWARE_VERSION added in ENG, 1A, 1B and 1C products
//@ --------------------------------------------------------------------
//@ DM-ID :IA-CR-2100-243-CNE : 02/08/2004 : B. MASSART
//@ Line identification uses N0_LN in ISP packets. See IA-2100-CR-243-THA.
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_DON_InfoGenLigne_h
#define SD_DON_InfoGenLigne_h


//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Commun.h"
#include "CMN__Date.h"

#include "SD_BAS_Global.h"
#include "SD_BAS_Produits.h"


class SD_DON_InfoGenLigne {

    /*================================================================*/

 public:

    ////////////////////////////////
    // Type definitions
    ////////////////////////////////



    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    SD_DON_InfoGenLigne();
    
    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    ~SD_DON_InfoGenLigne();

    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    unsigned int   GetOffset() const {return m_Offset;};
    void           SetOffset(const unsigned int offset) 
        {m_Offset = offset;};

    t_Date         GetDateDebut() const {return m_DateDebut;};
    void           SetDateDebut(const t_Date& date) 
        {m_DateDebut = date;};

    t_Date         GetDateFin() const {return m_DateFin;};
    void           SetDateFin(const t_Date& date) {m_DateFin = date;};
    
    e_BAS_ModePdv  GetModePriseDeVue() const {return m_ModePriseDeVue;};
    void           SetModePriseDeVue(const e_BAS_ModePdv modePriseDeVue) 
        {m_ModePriseDeVue = modePriseDeVue;};

    int            GetBBT() const {return m_BBT;};
    void           SetBBT(const int BBT) {m_BBT = BBT;};

    unsigned int   GetPTSI() const {return m_PTSI;};
    void           SetPTSI(const unsigned int PTSI) {m_PTSI = PTSI;};

    /* CR246 */
    unsigned int   GetVersionLogicielBord() const {return m_VersionLogicielBord;};
    void           SetVersionLogicielBord(const unsigned int VersionLogicielBord) {m_VersionLogicielBord = VersionLogicielBord;};
    
    int            GetNumMDRDebut() const {return m_NumMDRDebut;};
    void           SetNumMDRDebut(const int num) 
        {m_NumMDRDebut = num;};

    int            GetNumMDRFin() const {return m_NumMDRFin;};
    void           SetNumMDRFin(const int num) {m_NumMDRFin = num;};

    e_BAS_ValidRec GetValidite() const {return m_Validite;};
    void           SetValidite(const e_BAS_ValidRec validite) 
        {m_Validite = validite;};

    /* CR243 */
    unsigned int   GetNumLigneAbsolu() const {return m_N0_LN;};
    void           SetNumLigneAbsolu(const unsigned int N0_LN) {m_N0_LN = N0_LN;};
    /* FIN CR243 */
    
    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    void Afficher();


    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////
    
    
    /*================================================================*/
    
 private:

    ////////////////////////////////
    // Constantes
    ////////////////////////////////

    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////

    
    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////

    // Offset depuis le debut du produit
    unsigned int   m_Offset;
    
    // Date de debut
    t_Date         m_DateDebut;
    
    // Date de fin
    t_Date         m_DateFin;
    
    // Mode prise de vue
    e_BAS_ModePdv  m_ModePriseDeVue;
    
    // Temperature du corps noir issu du paquet AP
    int            m_BBT;
    
    // PTSI de la ligne
    unsigned int   m_PTSI;
    
    // CR246 numero de version du logiciel bord
    unsigned int   m_VersionLogicielBord;
    
    //@ Numero du premier MDR de la ligne
    int            m_NumMDRDebut;
    
    //@ Numero du dernier MDR de la ligne
    int            m_NumMDRFin;
    
    // Validite de la ligne (NORMAL ou DMDR)
    e_BAS_ValidRec m_Validite;   
    
    // CR243: numero de ligne absolu NO_LN
    unsigned int   m_N0_LN;
};

// Type infos generales d'une ligne
typedef SD_DON_InfoGenLigne         t_InfoGenLigne;

// Type liste des infos generales sur les lignes
typedef vector<SD_DON_InfoGenLigne> t_ListeInfoGenLigne;

#endif
