//$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/DON/src/SD_DON_InventaireConf.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_DON
//@ CLASSE : SD_DON_InventaireConf
//@ 
//@ Comment :
//@    this module implement the SD_DON_InventaireConf class
//@    It is the central point for acces to configuration file
//@     coherence between them is also verified here
//@      needed by OPS L1 PPF
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ VERSION : 12/12/2002 : P.GASSIE
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_DON_InventaireConf_h
#define SD_DON_InventaireConf_h


// Inserer ici les fichiers include 
#include <complex>
#include "SD_BAS_Global.h"
#include "CMN__Date.h"
#include "SD_DON_GestConfAutre.h"
#include "SD_DON_ConfStable.h"
#include "SD_DON_ConfAutre.h"
#include "SD_DON_BanqueSpectrale.h"
#include "SD_DON_Traitement.h"
#include "CFG__Configuration.h"
#include "CMN__Fichier.h"
#include "ERR__Exception.h"
#include "JDB__Client.h"
#include "SD__Message.h"

// Definition des exceptions

class SD_DON_InventaireConf {

    /*====================================================================*/

 public:

    //
    // Type
    //    

    //
    // Constantes
    //

    static const char *SD_DON_VAR_ENV_AUX_DATA;
    static const char *SD_DON_VAR_ENV_CTX_DATA;
    //
    // Constructeur
    //
    SD_DON_InventaireConf();
    //
    // Destructeur
    //
    virtual ~SD_DON_InventaireConf();

    //
    // Accesseurs
    //
    int GetPTSI() {return m_PTSI;};

    //
    // publics Methods 
    //
    void CreerInventaire(
                        );
    void InitConf(
                  const int& Ptsi,
                  SD_DON_Traitement& Trt,
                  const t_Date & tcourante,
                  int& IdCA
                  );
    void ChargerConf(
                     const int& Ptsi,
                     SD_DON_Traitement& Trt,
                     const t_Date & tcourante,
                     int& IdCA
                     );
    void GetConf(
                 const int& Ptsi,
                 const t_Date & tcourante,
                 t_SD_BAS_ConfAutre**  ConfAutre,
                 t_SD_BAS_ConfStable** ConfStable,
                 t_SD_BAS_BanqueSpectrale** BanqueSpectrale
                 );
        
    /*====================================================================*/
 protected:
    //
    // protected Methods 
    //

    //
    // protected Attributes 
    //

    /*====================================================================*/
 private:

    //
    // Private Methods 
    //

    //
    // Private Attributes 
    //
    // fichier de configuration stable 
    SD_DON_ConfStable m_ConfStable;
        
    // gestionnaire des fichiers de configuration autre 
    SD_DON_GestConfAutre m_GestConfAutre;
        
    // Banque spectrale 
    SD_DON_BanqueSpectrale m_BanqueSpectrale;

    // repertoire aux_data 
    t_Chaine m_RepAuxData;

    // parametre PTSI identifiant la configuration systeme courante
    int m_PTSI;


                        
};


#endif
