// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/DON/src/SD_DON_LigneN0.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_DON
//@ CLASSE : SD_DON_LigneN0
//@
//@ Commentaire :
//@    Fichier d'entete de la classe SD_DON_LigneN0
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 06/01/2003 : P. CABANE
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-CR-271-CN : 22/06/2005 : JL.PASCAL
//@ prise en compte du mode transition
//@ fiche de correction correspondante : IA-2100-CR-271-THA
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-CR-270-CN : 24/06/2005 : JL.PASCAL
//@ prise en compte des SN manquant
//@ fiche de correction correspondante : IA-2100-CR-270-THA
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_DON_LigneN0_h
#define SD_DON_LigneN0_h


//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Commun.h"
#include "CMN__Date.h"
#include "ERR__Exception.h"

#include "SD_DON_Granule.h"
#include "SD_DON_PaquetN0.h"
#include "SD_DON_GestCasDeg.h"


class SD_DON_LigneN0 {

    /*================================================================*/

 public:

    ////////////////////////////////
    // Type definitions
    ////////////////////////////////


    ////////////////////////////////
    // Constantes
    ////////////////////////////////

    // Marge(s) sur la detection des trous
    static const double SD_DON_MARGE_NORMAL;
    static const double SD_DON_MARGE_CALIBRATION;
    //CR270
    static const double SD_DON_DUREEE_SN_MIN;


    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    SD_DON_LigneN0();

    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    ~SD_DON_LigneN0();
    void Liberer();

    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    virtual SD_DON_LigneN0& operator =(const SD_DON_LigneN0& ligne);
    t_CMN__Booleen EstValide() 
    const {return ((m_InfoGenLigne.GetValidite() == VALIDE) || (m_InfoGenLigne.GetValidite() == TRANSITION));};
//CR271
    t_CMN__Booleen EstTransition() 
    const {return (m_InfoGenLigne.GetValidite() == TRANSITION);};
    int GetNumLigne() const {return m_NumLigne;};

    
    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    int GetNbPaquetN0(const e_SD_BAS_TypeN0 type);
    const t_InfoGenLigne& GetDataGen() const;
    void GetPaquetLigne(const e_SD_BAS_TypeN0 type,
                        int& nbPaquets,
                        t_SD_BAS_PaquetN0** listePaquetLigne);
    void Init(const int numLigne,
              const t_InfoGenLigne& infoGenLigne,
              SD_DON_GestCasDeg& gestionCasDegrade);
    void AddPaquetLigne(SD_DON_PaquetN0* paquetN0);
    void ValideLigne();

        
    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////


    /*================================================================*/

 private:
    
    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////
    t_CMN__Statut VerifieTemp(SD_DON_PaquetN0& paquetN0);
    t_CMN__Statut VerifieTelem(SD_DON_PaquetN0& paquetN0);
    t_CMN__Statut VerifieTelemPX(unsigned short* pWord,
                                 const unsigned int noSN,
                                 const unsigned int noPN);
    t_CMN__Statut VerifieTelemIP(unsigned short* pWord,
                                 unsigned int noSN);
    t_CMN__Statut VerifieTelemAP(unsigned short* pWord);

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////

    // Numero de la ligne
    int                 m_NumLigne;

    // Nombre de paquets dans la ligne
    int                 m_NbPaquet;
    
    // Informations generales sur la ligne
    t_InfoGenLigne      m_InfoGenLigne;
    
    // Liste des paquets references dans la ligne
    t_ListePaquetN0     m_ListePaquets;
    
    // Gestionnaire de cas degrade de la ligne
    SD_DON_CasDegLigne* m_CasDegradeLigne;
};

// Type liste de lignes N0
typedef vector<SD_DON_LigneN0> t_ListeLigneN0;

#endif
