static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/DON/src/SD_DON_LigneN1.cc,v 1.3 2011/11/25 10:17:45 dpauly Exp $";
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_DON
//@ CLASSE : SD_DON_LigneN1
//@
//@ Commentaire :
//@    Ce module gere la classe SD_DON_LigneN1, qui contient les
//@    informations relatives a une ligne de donnees de niveau 1
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 06/01/2003 : P. CABANE
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-CR-0000-177
//@ SD_DON_LigneN1::InitCasDegrade:
//@ -correction gestion CG14
//@ -ajout gestion CG15
//@ -mise a jour dimensions ENG_GOPSFLTISRFEMOFF
//@ --------------------------------------------------------------------
//@ DM-ID : PM4 : 31/03/2004 : B. MASSART
//@ SD_DON_LigneN1::InitCasDegrade:
//@ -correction syntaxe ENG_GOPSDATISRFEMOFF
//@ -suppression SD_DON_LigneN1::AdapteSN rendue inutile
//@ -correction definition de ENG_DATA_IP
//@ --------------------------------------------------------------------
//@ DM-ID :IA-CR-2100-246-CNE : 06/07/2004 : B. MASSART
//@ word # 16 in level 0 PX packets is no more read as part of PTSI number
//@ Variable ONBOARD_SOFTWARE_VERSION added in ENG, 1A, 1B and 1C products
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-143-CN : 21/09/2004 : B.MASSART
//@ L'OPS s'arrete sur l'initialisation de VIADRENG_MEXSSMIN avec le contexte 
//@ a froid dans SD_GES_ChaineProd0_1C::Corpstraitement lorsque la 10ieme ligne 
//@ est un DMDR. On opte pour une gestion des VIADR_DUMMY similaire a celle des 
//@ VIADR_ENG valides. Voir IA-2100-FC-143-THA.
//@ --------------------------------------------------------------------
//@ FA-ID : IA-2100-FA-139-CN : 21/09/2004 : B.MASSART
//@ Probleme d'initialisation de GDatFlagIsrfemOff quand on entre en mode
//@ calibration externe ne visant pas la Terre. On introduit le mode
//@ de prise de vue dans la gestion des cas degrades. Voir IA-2100-FC-139-THA.
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-155-CN : 1/03/2005 : JL.PASCAL
//@ Les DMDR ne sont pas dates correctement 
//@ Voir IA-2100-FC-155-THA.
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-CR-271-CN : 22/06/2005 : JL.PASCAL
//@ prise en compte du mode transition
//@ fiche de correction correspondante : IA-2100-CR-271-THA
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-CR-270-CN : 24/06/2005 : JL.PASCAL
//@ prise en compte des SN manquant
//@ fiche de correction correspondante : IA-2100-CR-270-THA
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-162-CN : 09/2006 : C.MERIGUET
//@ Gestion des IPR en mode DUMP
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-191-CN : 18/10/2006 : C.MERIGUET
//@ Recopie du spectre L0 dans les produits ENG (champ BCODSPECVERIFF)
//@ --------------------------------------------------------------------
//@ FA-ID : IA-2100-FA-196-CN : 15/01/2007 : C.MERIGUET
//@ FA-ID : IA-2100-FA-198-CN : 15/01/2007 : C.MERIGUET
//@ Ces 2 FA sont traitees conjointement. Recuperation du PTSI lu dans 
//@ le mot 17 (2 octets) mais ecriture dans le champ PTSI des N1 des mots 
//@ 16 (version logiciel bord) et 17 (ptsi) (4 octets).
//@ --------------------------------------------------------------------
//@ FA-ID : IA-2100-FA-215-CN : 23/05/2007 : S.BRUNEL
//@ Correction de l'encodage du spectre L0 dans le produit ENG
//@(champ BCODSPECVERIFF)
//@ --------------------------------------------------------------------
//@ FA-ID : IA-2100-FA-219-CN : 25/06/2007 : S.BRUNEL
//@ Depassement de tableau lors de l'encodage du spectre L0 
//@ dans le produit ENG
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2523(DM-2100-OPS) : 06/03/2009 : S. BRUNEL
//@ Include BArcImagMeanRMS dans le produit ENG (Day 2,point 4)
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2656(FA-2100-OPS) : 02/09/2009 : S. BRUNEL
//@ Variation aleatoire des variables DATA_Px et GCcsAvhrrPseudoChn
//@ dans les produits ENG
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2364(FA-2100-OPS) : 20/09/2010 : S. BRUNEL
//@ Product without  manoeuvre flag raised 
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Commun.h"
#include "CMN__Date.h"
#include "CFG__Configuration.h"

#include "SD_DON_LigneN1.h"


/* FA 191*/
#include "SD_BAS_Niveau0.h"
#include "SD_BAS_Conversion.h"
// FT-2765
#include "SD_BAS_SwapEndian.h"
// ...FT-2765

//
// Definition des constantes
#define SD_DON_MARGE                          0 
/* FA 215 */
//#define SD_DON_ZERO_HEXA_16BITS               0x0000 
#define SD_DON_ZERO_HEXA_8BITS               0x00
/* ..FA 215 */
/*..FA 191*/

// Definition des constantes
//
const t_Chaine SD_DON_LigneN1::EXCEPTION_SEPARATEUR = ": ";
const t_Chaine SD_DON_LigneN1::STR_OPS_MODE         = "OPS_MODE";
const t_Chaine SD_DON_LigneN1::STR_OPS_MODE_NOMINAL = "N";


//======================================================================
//                                      METHODES PUBLIQUES
//======================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : SD_DON_LigneN1
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_DON_LigneN1::SD_DON_LigneN1()
  : m_NumLigne(0), m_TypeLigne(SD_DON_PRODUIT_N1_1A1B1C), 
    m_TypeRecord(TR_MDR), m_TypeAcces(LECTURE), m_CasDegradeLigne(0)
{  
  m_DataN1.InfoGen.nb_var = 0;
  m_DataN1.InfoDet.nb_var = 0;
}


//@ ------------------------------------------------------------------*/
//@ Methode : ~SD_DON_LigneN1
//@
//@ Description : Destructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_DON_LigneN1::~SD_DON_LigneN1()
{
  //@ La liberation memoire pour le cas degrade ligne
  //@ est effectuee par le gestionnaire de cas degrades
}


//@ ------------------------------------------------------------------*/
//@ Methode : Liberer
//@
//@ Description : Liberation memoire des donnees de l'objet
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_LigneN1::Liberer()
{
  //@ SI la ligne est valide
  if (EstValide() == CMN__VRAI)
    {
      //@ On libere ici les donnees allouees
      //@ via un appel a SD_BAS_LibereMDR()
      SD_BAS_LibereMDR(m_TypeAcces, &m_DataN1);
    }
  //@ FIN SI la ligne est valide
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetDataGen
//@
//@ Description : Recupere les informations globales a une ligne de
//@               niveau 1
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Informations globales
//@
//@ ------------------------------------------------------------------*/
const t_InfoGenLigne& SD_DON_LigneN1::GetDataGen() const
{
  //@ On retourne l'attribut m_InfoGenLigne
  return (m_InfoGenLigne); 
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetData
//@
//@ Description : Recupere les informations detaillees d'une ligne de
//@               niveau 0. Le retour se fait via une liste de 
//@               pointeurs afin de faciliter l'utilisation en C
//@
//@ Parametres :
//@               (SORTIE) ligneN1 : Ligne retournee
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_LigneN1::GetData(t_SD_BAS_LigneN1& ligneN1)
{
  //@ On retourne l'attribut m_DataN1
  ligneN1 = m_DataN1;
}


//@ ------------------------------------------------------------------*/
//@ Methode : SetData
//@
//@ Description : Met a jour les informations detaillees d'une ligne
//@               de niveau 1
//@
//@ Parametres :
//@               (ENTREE) ligneN1 : Informations detaillees
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_LigneN1::SetData(t_SD_BAS_LigneN1& ligneN1)
{
  //@ Met a jour les informations detaillees
  m_DataN1 = ligneN1;
}


//@ ------------------------------------------------------------------*/
//@ Methode : InitLecture
//@
//@ Description : Initialise l'objet ligne N1 et lecture associee.
//@               cette methode doit etre appelee en premier pour les
//@               produits technologiques (cas degrade)
//@
//@ Parametres :
//@               (ENTREE) numLigne : Numero de la ligne a creer
//@               (ENTREE) infoGenLigne : Infos generales de la ligne
//@               (ENTREE) typeLigne : Type du produit contenu dans
//@                                      la ligne
//@               (ENTREE) typeRecord : Type du record contenu dans
//@                                     la ligne (MDR ou VIADR)
//@               (ENTREE/SORTIE) gestionCasDegrade : Gestionnaire de 
//@                                                   cas degrade
//@               (ENTREE/SORTIE) ficDesc : Descripteur de fichier
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_LigneN1::InitLecture(const int numLigne,
                                 const t_InfoGenLigne& infoGenLigne,
                                 const e_SD_DON_ProduitN1 typeProduit,
                                 const e_BAS_TypeRec typeRecord,
                                 SD_DON_GestCasDeg& gestionCasDegrade,
                                 t_SD_BAS_Fd& ficDesc)
{
  // Donnees de contexte
  t_SD_BAS_DataThread* ctx    = NULL;

  // Numero de ligne produit
  int                  numPdt = 0;

  // Code retour des fonctions utilisees
  t_CMN__Statut        statut = CMN__STATUT_OK;


  //@ Initialisation du numero de ligne
  m_NumLigne     = numLigne;
  numPdt         = numLigne;

  // Initialisation des infos generales de la ligne
  m_InfoGenLigne = infoGenLigne;

  //@ Initialisation du type de produit (1A/1B/1C/ENG/VER)
  m_TypeLigne    = typeProduit;

  //@ Initialisation du type de record (MDR ou VIADR)
  m_TypeRecord   = typeRecord;

  //@ m_TypeAcces = LECTURE
  m_TypeAcces    = LECTURE;


  //@ On lit l'ensemble des donnees du record
  //@ L'ensemble est stocke dans la structure m_DataN1.InfoDet
  //@ qui est allouee ici
  //@ Le decodage n'est pas fait ici, il sera fait a la volee
  //@ lors du traitement
 
  //@ Allocation memoire pour les donnees de contexte
  ctx = new t_SD_BAS_DataThread;
  InitialiserCompteRendu(&(ctx->cr));

  //@ SELON le type de record
  switch (m_TypeRecord)
    {
      //@ TR_MDR:
    case TR_MDR:
      //@ Appel a la fonction SD_BAS_Niveau1::LireMDRN1()
      statut = SD_BAS_LireMDRN1(&ficDesc, &m_DataN1, ctx);

#ifdef OPS_DEBUG
      cout << "INFO: lecture ligne de type: " << m_DataN1.TypeRec
           << " - 1A=" << MDR_1A 
           << ";1B=" << MDR_1B 
           << ";1C=" << MDR_1C
           << ";ENG=" << MDR_ENG
           << ";VER=" << MDR_VER << endl;
#endif

      break;
      
      //@ TR_VIADR:
    case TR_VIADR:
      //@ Calcul du numero de ligne VIADR
      //numPdt = ((infoGenLigne.GetNumMDRDebut()+1)/PERIODE_VIADR)-1;

#ifdef OPS_DEBUG
      cout << "Numero ligne VIADR: " << numPdt << endl;
#endif

      //@ Appel a la fonction SD_BAS_Niveau1::LireVIADRN1()
      statut = SD_BAS_LireVIADRN1(&ficDesc, numPdt, &m_DataN1, ctx);
      break;
      
      //@ Defaut:
    default:
      //@ Rien a faire
      break;
    }
  //@ FIN SELON le type de record


  //@ SI la lecture de la ligne a genere une erreur
  if (statut != CMN__STATUT_OK)
    {

#ifdef OPS_DEBUG
      cerr << "SD_DON_LigneN1::InitLecture: Erreur LireN1: " << 
        ficDesc.nom << " (" << statut << ")" << endl;
#endif
                  
      //@ Mise a jour de la validite des donnees
      m_InfoGenLigne.SetValidite(INVALIDE);

      //@ Envoi des messages generes au JDB
      EnvoyerMessagesStockes(&(ctx->cr.msgJDB));
    }
  //@ FIN SI la lecture de la ligne a genere une erreur

      
  //@ Liberation memoire pour les donnees de contexte
  LibererCompteRendu(&(ctx->cr.msgJDB));
  delete ctx;

  //@ Pour le produit technologique et pour les MDR
  if ( (typeProduit == SD_DON_PRODUIT_N1_ENG) && 
       (m_TypeRecord == TR_MDR) )
    {
      SD_DON_CasDegLigne::t_SD_DON_Flt     flagsCG;
      SD_DON_CasDegLigne::t_SD_DON_GOPSDAT datesCG;
      
      //@ Initialisation des CG: aucun CG n'est detecte
      for (int iCG=0; iCG<SD_BAS_NB_CGXX; iCG++)
        {
          for (int iSN=0; iSN<SD_BAS_SN; iSN++)
            {
              for (int iPN=0; iPN<SD_BAS_PN; iPN++)
                {
                  for (int iSB=0; iSB<SD_BAS_SB; iSB++)
                    {
                      flagsCG[iCG].flag[iSN][iPN][iSB] = false;
                    }
                }
            }
          
          datesCG[iCG] = m_InfoGenLigne.GetDateDebut();
        }
      
      //@ SI la ligne est valide
      if (EstValide() != VALIDE)
        {
          
          //@ On cree un gestionnaire de cas degrades 
          //@ initialise pour la ligne via la methode
          //@ SD_DON_GestCasDeg::AjouteCasDegLignePart()
          /* FA139 */
          gestionCasDegrade.AjouteCasDegLignePart(numLigne+1, 
	                                          m_InfoGenLigne.GetModePriseDeVue(), 
                                                  flagsCG,
                                                  datesCG);

          //@ On recupere le cas degrade pour la ligne via la
          //@ methode SD_DON_GestCasDeg::GetCasDegLigne()
          m_CasDegradeLigne = gestionCasDegrade.
            GetCasDegLigne(numLigne+1);

          //@ POUR tous les SN 
          for(int iSN=0; iSN<SD_BAS_SN; iSN++)
            {
              //@ On leve CG2 via la methode
              //@ SD_DON_CasDegLigne::SetDetecte()
              m_CasDegradeLigne->SetDetecte(2, 
                                            m_InfoGenLigne.
                                            GetDateDebut(),
                                            iSN,
                                            0,
                                            0);
            }
          //@ FIN POUR tous les SN
        }
      //@ SINON
      else
        {
          //@ On appelle la methode d'init des cas degrades
          //@ SD_DON_LigneN1::InitCasDegrade()
          InitCasDegrade(flagsCG, datesCG);

          //@ On cree un gestionnaire de cas degrades
          //@ pour la ligne via la methode 
          //@ SD_DON_GestCasDeg::AjouteCasDegLignePart()
          /* FA139 */
          gestionCasDegrade.AjouteCasDegLignePart(m_NumLigne+1, 
	                                          m_InfoGenLigne.GetModePriseDeVue(), 
                                                  flagsCG, 
                                                  datesCG);

          //@ et on le reference au niveau de la ligne
          //@ Celui ci est initialise avec tous les cas degrades
          //@ associes issus du produit
        }
      //@ SI la ligne est valide
    }
  //@ FIN Pour le produit technologique et pour les MDR


  //@ Non pris en compte pour la V1:  
  //@   Pour les produits de N1 et les MDR,
  //@   on decode le spectre via la methode 
  //@   SD_BAS_Niveau1::SD_BAS_DecodeSpectreN1()
  //@   en prenant des facteurs de decodage = 1 
  //@   afin de tester si des valeurs factices 
  //@   sont presentes sur tout le spectre
  //@   Dans ce cas, on leve le cas CG2 pour ne
  //@   pas generer de donnees en sortie
}


//@ ------------------------------------------------------------------*/
//@ Methode : InitEcritureN0
//@
//@ Description : Initialisation en ecriture de l'objet ligne N1 a
//@               partir de l'objet ligne N0
//@
//@ Parametres :
//@               (ENTREE) numLigne : Numero de la ligne a creer
//@               (ENTREE) typeProduit : Type de produit contenu dans
//@                                      la ligne (1A/1B/1C/EG/VER)
//@               (ENTREE) typeRecord : Type du record contenu dans
//@                                     la ligne (MDR ou VIADR)
//@               (ENTREE) processingMode : NRT, Backlog ou reprocessing
//@               (ENTREE) dispositionMode : Operationnal, Validation
//@                                          ou Commissioning
//@               (ENTREE) modePTF : Mode plateforme
//@               (ENTREE) modeTraitement : Mode de traitement (dump
//@                                         ou granule)
//@               (ENTREE) dataGenLigne : Donnees generales ligne N0
//@               (ENTREE) nbLigneAbsolu : Nombre de lignes absolues
//@                                        depuis le debut du dump
//@               (ENTREE) nbPaquet1 : Nombre de paquets de type PX 
//@                                    sauf pour VER de type VP
//@               (ENTREE) nbPaquet2 : Nombre de paquets de type IP 
//@                                    sauf pour VER de type AP
//@               (ENTREE) dataPaquet1 : Donnees generales des ISP de
//@                                      N0 de la ligne (de type PX 
//@                                      sauf pour VER de type VP)
//@               (ENTREE) dataPaquet2 : Donnees generales des ISP de
//@                                      N0 de la ligne (de type IP
//@                                      sauf pour VER de type AP)
//@               (ENTREE) casDegradeLigne : Gestionnaire de cas 
//@                                          degrade
//@               (ENTREE) OBTUTC : Objet pour la correction temps UTC
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
/* FA 191*/
// FT-2364
void SD_DON_LigneN1::InitEcritureN0(const int numLigne,
                                    const e_SD_DON_ProduitN1 
                                    typeProduit,
                                    const e_BAS_TypeRec typeRecord,
                                    const e_BAS_PROCMODE processingMode,
                                    const e_BAS_DISPMODE 
                                    dispositionMode,
                                    const e_BAS_ModePlateforme modePTF,
                                    const e_BAS_ModeTrt modeTraitement,
                                    const t_InfoGenLigne& infoGenLigne,
                                    const int nbLigneAbsolu,
                                    const int nbPaquet1,
                                    const int nbPaquet2,
                                    t_SD_BAS_PaquetN0** dataPaquet1,
                                    t_SD_BAS_PaquetN0** dataPaquet2,
                                    SD_DON_CasDegLigne& casDegradeLigne,
                                    SD_DON_OBTUTC& OBTUTC,
                                    const int InfosVds,
                                    bool flagManoeuvre)
// ...FT-2364
/* ..FA 191*/
  throw (ERR__Exception)
{
  // Exception generee
  ERR__Exception       exception;

  // Message pour l'exception
  t_ChaineFixe         message;
  t_Chaine             messageException("");

  // Donnees de contexte
  t_SD_BAS_DataThread* ctx    = NULL;

  // Descripteur de fichier
  t_SD_BAS_Fd          ficDesc;

  // Type de record N1 a initialiser
  e_BAS_TypeRecN1      record = MDR_DUMMY;

  // Code retour des fonctions utilisees
  t_CMN__Statut        statut = CMN__STATUT_OK;


  //@ Initialisation du numero de ligne
  m_NumLigne     = numLigne;

  // Initialisation des infos generales de la ligne
  m_InfoGenLigne = infoGenLigne;

  //@ Initialisation du type de produit (1A/1B/1C, 
  //@ 1B/1C, 1C, VER ou ENG)
  m_TypeLigne    = typeProduit;

  //@ Initialisation du type de record (MDR ou VIADR)
  m_TypeRecord   = typeRecord;
  
  //@ m_TypeAcces = ECRITURE
  m_TypeAcces    = ECRITURE;


  //@ Calcul du type de record N1 a initialiser
  record = GetTypeRecordN1(typeRecord, typeProduit, EstValide());

  //@ On recupere le gestionnaire de cas degrades ligne
  //@ et on le reference au niveau de la ligne 
  //@ Il est issu de l'analyse de la telemesure de N0 
  //@ avec tous les cas degrades associes
  m_CasDegradeLigne = &casDegradeLigne;

  //@ Allocation memoire pour les donnees de contexte
  ctx = new t_SD_BAS_DataThread;
  InitialiserCompteRendu(&(ctx->cr));

  //@ On alloue les pointeurs dans m_DataN1 selon le type de produit
  //@ via la fonction SD_BAS_InitEcritureMDRN1()
  ficDesc.etat = ENCOURS;
  ficDesc.mode = ECRITURE;


  statut = SD_BAS_InitEcritureMDRN1(&ficDesc,
                                    record,
                                    &m_DataN1,
                                    ctx);

  //@ SI l'initialisation de m_DataN1 a genere une erreur
  if (statut != CMN__STATUT_OK)
    {

#ifdef OPS_DEBUG
      cerr << "SD_DON_LigneN1::InitEcritureN0: " 
           << "erreur SD_BAS_InitEcritureMDRN1 ("
           << statut << ")" << endl;
#endif

      //@ Recuperation du message d'erreur genere par 
      //@ les couches basses
      RecupererDernierMessageStocke(&(ctx->cr.msgJDB), message);
      messageException = t_Chaine(message);
      
      //@ Envoi des messages generes au JDB
      EnvoyerMessagesStockes(&(ctx->cr.msgJDB));
          
      //@ Liberation memoire pour les donnees de contexte
      LibererCompteRendu(&(ctx->cr.msgJDB));
      delete ctx;
      
      //@ Emission d'une exception SD_DON_TMT_ALLOC
      exception.SetErrorCode(ERR__Exception::SD_DON_TMT_ALLOC);
      exception.SetParametre(messageException);
      THROW(exception);
    }
  //@ FIN SI l'initialisation de m_DataN1 a genere une erreur
        
  //@ Liberation memoire pour les donnees de contexte
  LibererCompteRendu(&(ctx->cr.msgJDB));
  delete ctx;


  //@ SI la ligne est valide
  /* FA143 */
  if ( (EstValide() == CMN__VRAI) || (record == VIADR_DUMMY) || (record == MDR_DUMMY) ) //FA155
  /* FIN FA143 */
    {
      //@ Les InfoDet sont recopiees ou initialisees
      //@ Sont concernes :
      //@   - les indicateurs en debut de MDR (idconf, ...)
      //@   - les differentes dates par SN
      //@   DATA_PX et DATA_IP pour les donnees ENG (AC))
      
      //@ Dates de debut et de fin 
      InfoDetInitDates(record);
      
      //@ SELON le type de record
      switch (record)
        {
          //@ SI MDR_1A ou MDR_1B ou MDR_1C:
        case MDR_1A:
        case MDR_1B:
        case MDR_1C:
          //@ Appel de la methode InfoDetInit1C()
          // FT-2364
          InfoDetInit1C(processingMode,
                        dispositionMode,
                        modePTF,
                        modeTraitement,
                        nbPaquet1, 
                        dataPaquet1, 
                        OBTUTC,
                        flagManoeuvre);
          // ...FT-2364 
          break;
          
          //@ SI MDR_ENG:
        case MDR_ENG:
/* FA 191*/
          //@ Appel de la methode InfoDetInitENG()
          // FT-2364 
          InfoDetInitENG(processingMode,
                         dispositionMode,
                         modePTF,
                         modeTraitement,
                         nbLigneAbsolu,
                         nbPaquet1, 
                         nbPaquet2, 
                         dataPaquet1, 
                         dataPaquet2, 
                         OBTUTC,
                         InfosVds,
                         flagManoeuvre);
          // ...FT-2364 
/* ..FA 191*/
          break;
          
          //@ SI MDR_VER:
        case MDR_VER:
          //@ Appel de la methode InfoDetInitVER()
          InfoDetInitVER(nbPaquet1, 
                         nbPaquet2, 
                         dataPaquet1, 
                         dataPaquet2);
          break;
          
          //@ Defaut:
        default:
          //@ Rien a faire
          break;
        }
      //@ FIN SELON le type de record
    }
  //@ FIN SI la ligne est valide


  //@ Le decodage n'est pas fait ici, il sera fait a la volee 
  //@ specifiquement avant ecriture
}


//@ ------------------------------------------------------------------*/
//@ Methode : InitEcritureN1
//@
//@ Description : Initialisation en ecriture de l'objet ligne N1 a
//@               partir de l'objet ligne N1
//@
//@ Parametres :
//@               (ENTREE) numLigne : Numero de la ligne a creer
//@               (ENTREE) typeProduit : Type de produit contenu dans
//@                                      la ligne (1A/1B/1C/EG/VER)
//@               (ENTREE) typeRecord : Type du record contenu dans
//@                                     la ligne (MDR ou VIADR)
//@               (ENTREE) modeTraitement : Mode de traitement (dump
//@                                         ou granule)
//@               (ENTREE) dataGenLigne : Donnees generales ligne N1
//@               (ENTREE) dataN1 : Donnees de base de la ligne N1
//@               (ENTREE) casDegradeLigne : Gestionnaire de cas 
//@                                          degrade
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_LigneN1::InitEcritureN1(const int numLigne,
                                    const e_SD_DON_ProduitN1 
                                    typeProduit,
                                    const e_BAS_TypeRec typeRecord,
                                    const e_BAS_ModeTrt modeTraitement,
                                    const t_InfoGenLigne& infoGenLigne,
                                    t_SD_BAS_LigneN1& dataN1,
                                    SD_DON_CasDegLigne& casDegradeLigne)
  throw (ERR__Exception)
{
  // Exception generee
  ERR__Exception       exception;
  
  // Message pour l'exception
  t_ChaineFixe         message;
  t_Chaine             messageException("");

  // Donnees de contexte
  t_SD_BAS_DataThread* ctx    = NULL;

  // Descripteur de fichier
  t_SD_BAS_Fd          ficDesc;

  // Type de record N1 a initialiser
  e_BAS_TypeRecN1      record = MDR_DUMMY;

  // Code retour des fonctions utilisees
  t_CMN__Statut        statut = CMN__STATUT_OK;


  //@ Initialisation du numero de ligne
  m_NumLigne     = numLigne;

  // Initialisation des infos generales de la ligne
  m_InfoGenLigne = infoGenLigne;

  //@ Initialisation du type de produit (1A/1B/1C/ENG/VER)
  m_TypeLigne    = typeProduit;

  //@ Initialisation du type de record (MDR ou VIADR)
  m_TypeRecord   = typeRecord;
   
  //@ m_TypeAcces = ECRITURE
  m_TypeAcces    = ECRITURE;


  //@ Calcul du type de record N1 a initialiser
  record = GetTypeRecordN1(typeRecord, typeProduit, EstValide());

  //@ On recupere le gestionnaire de cas degrades ligne
  //@ et on le reference au niveau de la ligne 
  //@ Il est issu de l'analyse de la telemesure de N1
  //@ avec tous les cas degrades associes
  m_CasDegradeLigne = &casDegradeLigne;

  //@ Allocation memoire pour les donnees de contexte
  ctx = new t_SD_BAS_DataThread;
  InitialiserCompteRendu(&(ctx->cr));

  //@ On alloue les pointeurs dans m_DataN1 selon le type de produit
  //@ via la fonction SD_BAS_InitEcritureMDRN1()
  ficDesc.etat = ENCOURS;
  ficDesc.mode = ECRITURE;
  statut = SD_BAS_InitEcritureMDRN1(&ficDesc,
                                    record,
                                    &m_DataN1,
                                    ctx);

  //@ SI l'initialisation de m_DataN1 a genere une erreur
  if (statut != CMN__STATUT_OK)
    {
      
#ifdef OPS_DEBUG
      cerr << "SD_DON_LigneN1::InitEcritureN1: " 
           << "erreur SD_BAS_InitEcritureMDRN1 ("
           << statut << ")" << endl;
#endif
      
      //@ Recuperation du message d'erreur genere par 
      //@ les couches basses
      RecupererDernierMessageStocke(&(ctx->cr.msgJDB), message);
      messageException = t_Chaine(message);
      
      //@ Envoi des messages generes au JDB
      EnvoyerMessagesStockes(&(ctx->cr.msgJDB));
          
      //@ Liberation memoire pour les donnees de contexte
      LibererCompteRendu(&(ctx->cr.msgJDB));
      delete ctx;
      
      //@ Emission d'une exception SD_DON_TMT_ALLOC
      exception.SetErrorCode(ERR__Exception::SD_DON_TMT_ALLOC);
      exception.SetParametre(messageException);
      THROW(exception);
    }
  //@ FIN SI l'initialisation de m_DataN1 a genere une erreur
  
  //@ Liberation memoire pour les donnees de contexte
  LibererCompteRendu(&(ctx->cr.msgJDB));
  delete ctx;
  

  //@ On initialise ici les infos generales a partir des infos
  //@ issues du niveau 1 et issues de DataGenLigne
 
  //@ Dates de debut et de fin 
  InfoDetInitDates(record);

  //@ Les InfoDet sont recopiees
  //@ L'ensemble est stocke dans la structure m_DataN1.InfoGene
  //@ La structure m_DataN1.InfoDet doit etre initialisee et
  //@ allouee ici
  //@ Ici, il faut recuperer un maximum d'informations issues
  //@ du N1 en entree et qui sont directement recopiees 

  //@ SELON le type de record
  switch (record)
    {
      //@ SI MDR_1A ou MDR_1B ou MDR_1C:
    case MDR_1A:
    case MDR_1B:
    case MDR_1C:
      //@ Appel de la methode InfoDetCopie1C()
      InfoDetCopie1C(dataN1, modeTraitement, typeProduit);
      break;

      //@ SI MDR_ENG:
    case MDR_ENG:
       //@ Appel de la methode InfoDetCopieENG()
      InfoDetCopieENG(dataN1, modeTraitement);
      break;
 
      //@ SI MDR_VER:
    case MDR_VER:
       //@ Appel de la methode InfoDetCopieVER()
      InfoDetCopieVER(dataN1);
      break;

      //@ Defaut:
    default:
      //@ Rien a faire
      break;
    }
  //@ FIN SELON le type de record

  //@ Le decodage n'est pas fait ici, il sera fait a la volee 
  //@ specifiquement avant ecriture
}


//@ ------------------------------------------------------------------*/
//@ Methode : Ecrire
//@
//@ Description : Ecriture de l'objet ligne N1 dans le produit de
//@               niveau 1. Ceci est fait en recopiant les 
//@               informations necessaires et en les codant 
//@               eventuellement
//@
//@ Parametres :
//@               (ENTREE/SORTIE) ficDesc : Descripteur de fichier
//@               (ENTREE) idCA : Identifiant fichier de conf autre
//@               (ENTREE) natureProduit : Type du produit a ecrire dans
//@                                        la ligne (1A/1B/1C/ENG/VER)
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
/* FA 162 */
void SD_DON_LigneN1::Ecrire(t_SD_BAS_Fd& ficDesc,
                            const int idCA,
                            const e_BAS_Nature natureProduit,
			    const e_BAS_ModeTrt mode_traitement) 
/* ..FA 162 */
  throw (ERR__Exception)
{
  // Exception generee
  ERR__Exception       exception;

  // Message pour l'exception
  t_ChaineFixe         message;
  t_Chaine             messageException("");

  // Donnees de contexte
  t_SD_BAS_DataThread* ctx    = NULL;

  // Code retour des fonctions utilisees
  t_CMN__Statut        statut = CMN__STATUT_OK;
 

  //@ Ecriture physiques d'une ligne record d'un produit de
  //@ niveau 1 MDR ou VIADR
 
  //@ Allocation memoire pour les donnees de contexte
  ctx = new t_SD_BAS_DataThread;
  InitialiserCompteRendu(&(ctx->cr));

  //@ Mise a jour du type de record a ecrire
  MettreAJourTypeRecord(natureProduit);

  //@ SELON m_TypeRecord et SELON sa validite
  //@ (DUMMY ou PAS: valeur de EstValide())
  switch (m_TypeRecord)
    {
      //@ TR_MDR:
    case TR_MDR:
 
      //@ SI la ligne est valide
      if (EstValide() == CMN__VRAI)
        {
          //@ Mise a jour du IdefIdConf dans le MDR avec IdCA
          if (m_TypeLigne == SD_DON_PRODUIT_N1_ENG)
            {
              m_DataN1.InfoDet.tab_var[ENG_IDEFIDCONF].val.pui4[0] = 
                (unsigned int) idCA;
            }
          else if (m_TypeLigne != SD_DON_PRODUIT_N1_VER)
            {
              m_DataN1.InfoDet.tab_var[N1C_IDEFIDCONF].val.pui4[0] = 
                (unsigned int) idCA;
            }
        }
      //@ FIN SI la ligne est valide

      //@ L'encodage des donnees principales (images spectre)
      //@ via la fonction de SD_BAS_Niveau1 doit avoir ete
      //@ fait au prealable dans les traitements
      
      //@ Appel fonction SD_BAS_Niveau1::EcrireMDRN1()

#ifdef OPS_DEBUG
      cout << "INFO: ecriture ligne de type: " << m_DataN1.TypeRec 
           << " - 1A=" << MDR_1A 
           << ";1B=" << MDR_1B 
           << ";1C=" << MDR_1C
           << ";ENG=" << MDR_ENG
           << ";VER=" << MDR_VER << endl;
#endif

      statut = SD_BAS_EcrireMDRN1(&ficDesc, &m_DataN1, ctx);
      break;

      //@ TR_VIADR:
    case TR_VIADR:

      //@ Appel fonction SD_BAS_Niveau1::EcrireVIADRN1()
/* FA 162 */
      statut = SD_BAS_EcrireVIADRN1(&ficDesc, &m_DataN1, ctx,mode_traitement);
/* ..FA 162 */
      break;

     //@ Defaut:
    default:
      break;
    }
  //@ FIN SELON m_TypeRecord et SELON sa 
  //@ validite (DUMMY ou PAS)


  //@ SI l'ecriture de la ligne a genere une erreur
  if (statut != CMN__STATUT_OK)
    {
      
#ifdef OPS_DEBUG
      cerr << "SD_DON_LigneN1::EcrireN1: " 
           << "Erreur ecriture (" << statut << ")" << endl;
#endif
          
      //@ Recuperation du message d'erreur genere par 
      //@ les couches basses
      RecupererDernierMessageStocke(&(ctx->cr.msgJDB), message);
      messageException = t_Chaine(message) + EXCEPTION_SEPARATEUR +
        t_Chaine(ficDesc.nom);
      
      //@ Envoi des messages generes au JDB
      EnvoyerMessagesStockes(&(ctx->cr.msgJDB));
      
      //@ Liberation memoire pour les donnees de contexte
      LibererCompteRendu(&(ctx->cr.msgJDB));
      delete ctx;
      
      //@ Emission d'une exception SD_DON_FILE_WRITE
      exception.SetErrorCode(ERR__Exception::SD_DON_FILE_WRITE);
      exception.SetParametre(messageException);
      THROW(exception);
    }      
  //@ FIN SI l'ecriture de la ligne a genere une erreur


  //@ Liberation memoire pour les donnees de contexte
  LibererCompteRendu(&(ctx->cr.msgJDB));
  delete ctx;
}


//@ ------------------------------------------------------------------*/
//@ Methode : DecodeEncode
//@
//@ Description : Decode les donnees fondamentales des lignes de
//@               niveau 1 (images ou spectres) en se basant sur 
//@               les couches d'acces en C
//@
//@ Parametres :
//@               (ENTREE) numLigneSNPN : Info SN et PN
//@               (ENTREE) niveau : Info a traiter (IMAGE/1A/1B/1C)
//@               (ENTREE) paramDecodage : Parametres de decodage
//@               (ENTREE) sens : Sens decodage/encodage
//@               (ENTREE/SORTIE) data : Donnees decodees
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_LigneN1::DecodeEncode(const t_SD_BAS_ORIGINE numLigneSNPN,
                                  const e_SD_BAS_Atraiter niveau,
                                  t_SD_BAS_ConfStable* paramDecodage,
                                  const e_SD_BAS_Sens sens,
                                  double* data) 
  throw (ERR__Exception)
{
  // Tester si CG4 est leve pour chacun des SB

  //@ On appelle la fonction de decodage en fonction du 
  //@ type de donnees

  //@ SI les donnees sont de type MDR_1A, MDR_1B ou MDR_1C
  if ( (m_DataN1.TypeRec == MDR_1A) || 
       (m_DataN1.TypeRec == MDR_1B) || 
       (m_DataN1.TypeRec == MDR_1C) )
    {
      // Code retour des fonctions utilisees
      t_CMN__Statut        statut = CMN__STATUT_OK;
      
      // Donnees de contexte
      t_SD_BAS_DataThread* ctx    = 0;
      
      
      //@ Allocation memoire pour les donnees de contexte
      ctx = new t_SD_BAS_DataThread;
      InitialiserCompteRendu(&(ctx->cr));
      
      //@ SI decodage image demande
      if (niveau == AT_IMAGE)
        {
          //@ Appel de la procedure SD_BAS_DecodeImageN1
          statut = SD_BAS_DecodeImageN1(numLigneSNPN,
                                        &m_DataN1, 
					EstValide(),
                                        sens,
                                        paramDecodage,
                                        data,
                                        ctx);
        }
      //@ SINON
      else
        {         
          //@ Appel de la procedure SD_BAS_DecodeSpectreN1
          statut = SD_BAS_DecodeSpectreN1(numLigneSNPN,
                                          &m_DataN1, 
					EstValide(),
                                          niveau,
                                          sens,
                                          paramDecodage,
                                          data,
                                          ctx);
        }
      //@ FIN SI decodage image demande
      
      //@ SI le decodage a echoue
      if (statut != CMN__STATUT_OK)
        {
          // Exception generee
          ERR__Exception exception;
          
          // Message pour l'exception
          t_ChaineFixe   message;
          t_Chaine       messageException("");
          
#ifdef OPS_DEBUG
          cerr << "SD_DON_LigneN1::DecodeEncode: Erreur Decode (" 
               << statut << ")" << endl;
#endif
          
          //@ Recuperation du message d'erreur genere par 
          //@ les couches basses
          RecupererDernierMessageStocke(&(ctx->cr.msgJDB), message);
          messageException = t_Chaine(message);
          
          //@ Envoi des messages generes au JDB
          EnvoyerMessagesStockes(&(ctx->cr.msgJDB));
          
          //@ Liberation memoire pour les donnees de contexte
          LibererCompteRendu(&(ctx->cr.msgJDB));
          delete ctx;
          
          //@ Emission d'une exception SD_DON_OPER_FAILED
          exception.SetErrorCode(ERR__Exception::
                                 SD_DON_OPER_FAILED);
          exception.SetParametre(messageException);
          THROW(exception);
        }
      //@ FIN SI le decodage a echoue
      
      //@ Liberation memoire pour les donnees de contexte
      LibererCompteRendu(&(ctx->cr.msgJDB));
      delete ctx;
    }
  //@ FIN SI les donnees sont de type MDR_1A, MDR_1B ou MDR_1C
}



//======================================================================
//                                      METHODES PRIVEES 
//======================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : InitCasDegrade
//@
//@ Description : Initialise la coherence d'un ISP dans une ligne de
//@               niveau 1. La coherence se fait au niveau temporel
//@               et telemesure (via les indicateurs de qualite du
//@               produit technologique).
//@               Remarque: c'est dans le granule engeneering que 
//@                         sont leves les CGxx mais ils seront
//@                         utilises par tout le monde
//@
//@ Parametres :
//@               (SORTIE) flagsCG : Flags issus de la ligne concernee
//@               (SORTIE) datesCG : Dates issues de la ligne concernee
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_LigneN1::InitCasDegrade(SD_DON_CasDegLigne::t_SD_DON_Flt& 
                                    flagsCG,
                                    SD_DON_CasDegLigne::
                                    t_SD_DON_GOPSDAT& datesCG)
{
  // Valeurs de lecture dans les donnees ENG
  unsigned int   valeur   = 0;

  // Compteurs iteration
  int            iCG      = 0;
  int            iSN      = 0;
  int            iPN      = 0;
  int            iSB      = 0;
  int            iPaquet  = 0;


  //@ Identifier les cas degrades temporels
  IdentifierCasTemporel(flagsCG, datesCG);

  //@ Identification CG1
  for (iSN=0; iSN<SD_BAS_SNOT; iSN++)
    {
      for (iPN=0; iPN<SD_BAS_PN; iPN++)
        {
          valeur = m_DataN1.InfoDet.tab_var[ENG_GOPSFLAPIXMISS].
            val.pui4[iSN*SD_BAS_PN+iPN];
          if (valeur == 1)
            {
              flagsCG[0].flag[iSN][iPN][0] = true;
            }
        }
    }

  //@ Identification CG2
  valeur = m_DataN1.InfoDet.tab_var[ENG_GOPSFLADATAGAP].val.pui4[0];
  if (valeur == 1)
    {
      for (iSN=0; iSN<SD_BAS_SN; iSN++)
        {
          flagsCG[1].flag[iSN][0][0] = true;
        }
    }

  //@ Identification CG11
  for (iPaquet=0; iPaquet<5; iPaquet++)
    {
      valeur = m_DataN1.InfoDet.tab_var[ENG_GOPSFLAGPACKETVPMISS].val.
        pui4[iPaquet];
      if (valeur == 1)
        {
          flagsCG[10].flag[iPaquet][0][0] = true;
        }
    }

  //@ Identification CG12
  valeur = m_DataN1.InfoDet.tab_var[ENG_GOPSFLAGPACKETAPMISS].val.
    pui4[0];
  if (valeur == 1)
    {
      flagsCG[11].flag[0][0][0] = true;
    }

  //@ Identification CG13
  for (iSN=0; iSN<SD_BAS_SNOT; iSN++)
    {
      for (iPN=0; iPN<SD_BAS_PN; iPN++)
        {
          valeur = m_DataN1.InfoDet.tab_var[ENG_GOPSFLAGPACKETPXMISS].
            val.pui4[iSN*SD_BAS_PN+iPN];
          if (valeur == 1)
            {
              flagsCG[12].flag[iSN][iPN][0] = true;
            }
        }
    }

  //@ Identification CG14
  /* PM4 CR177 */
  for (iSN=0; iSN<SD_BAS_SNOT+4; iSN++)
  {
    valeur = m_DataN1.InfoDet.tab_var[ENG_GOPSFLAGPACKETIPMISS].val.pui4[iSN];
    if (valeur == 1)
    {
      switch (iSN)
      {
        case IND1(SD_BAS_SNOT+1): iSN = IND1(SD_BAS_SN_IP_SUP_1); break; /* BB */
        case IND1(SD_BAS_SNOT+2): iSN = IND1(SD_BAS_SN_IP_SUP_2); break; /* BB */
        case IND1(SD_BAS_SNOT+3): iSN = IND1(SD_BAS_SN_IP_SUP_3); break; /* CS */
        case IND1(SD_BAS_SNOT+4): iSN = IND1(SD_BAS_SN_IP_SUP_4); break; /* CS */
        default: break;
      }
    
      flagsCG[13].flag[iSN][0][0] = true;
    }
  }
  
  //@ Identification CG15
  for (iSN=0; iSN<SD_BAS_SNOT; iSN++)
  {
    valeur = m_DataN1.InfoDet.tab_var[ENG_GOPSFLAGEOAVHRRMISS].val.pui4[iSN];
    if (valeur == 1)
    {
      flagsCG[14].flag[iSN][0][0] = true;
    }
  }
  

  //@ On recupere ici les flags dans le cas du produit technologique
  //@ Cet ensemble de flag est recopie dans les structures
  //@ t_SD_DON_Flt et t_SD_DON_GOPSDAT
}


//@ ------------------------------------------------------------------*/
//@ Methode : IdentifierCasTemporel
//@
//@ Description : Identifie les cas degrades temporels
//@
//@ Parametres :
//@               (SORTIE) flagsCG : Flags issus de la ligne concernee
//@               (SORTIE) datesCG : Dates issues de la ligne concernee
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_LigneN1::IdentifierCasTemporel(SD_DON_CasDegLigne::t_SD_DON_Flt& 
                                           flagsCG,
                                           SD_DON_CasDegLigne::
                                           t_SD_DON_GOPSDAT& datesCG)
{
  // Valeurs de lecture dans les donnees ENG
  unsigned int   valeur   = 0;

  // Temoin de lecture
  t_CMN__Booleen lireDate = CMN__FAUX;

  // Compteurs iteration
  int            iSN      = 0;
  int            iPN      = 0;
  int            iSB      = 0;


  //@ Identification CG3
  lireDate = CMN__FAUX;
  /* PM4 CR177 */
  for (iSN=0; iSN<SD_BAS_SNOT; iSN++)
  {
    valeur = m_DataN1.InfoDet.tab_var[ENG_GOPSFLTISRFEMOFF].val.pui4[iSN];
    if (valeur == 1)
    {
      flagsCG[2].flag[iSN][0][0] = true;
      lireDate = CMN__VRAI;
    }
  }
  
  if (lireDate == CMN__VRAI)
    {
      datesCG[2] = RecupererDate(ENG_GOPSDATISRFEMOFF);
    }

  //@ Identification CG4
  lireDate = CMN__FAUX;
  for (iSN=0; iSN<SD_BAS_SNOT; iSN++)
    {
      valeur = m_DataN1.InfoDet.tab_var[ENG_GOPSFLTBANDMISS].val.
        pui4[iSN];
      if (valeur == 1)
        {
          for (iPN=0; iPN<SD_BAS_PN; iPN++)
            {
              for (iSB=0; iSB<SD_BAS_SB; iSB++)
                {
                  flagsCG[3].flag[iSN][iPN][iSB] = true;
                }
            }
          lireDate = CMN__VRAI;
         }
    }
  if (lireDate == CMN__VRAI)
    {
      datesCG[3] = RecupererDate(ENG_GOPSDATBANDMISS);
    }

  //@ Identification CG5
  valeur = m_DataN1.InfoDet.tab_var[ENG_GOPSFLTBBTMISS].val.pui4[0];
  if (valeur == 1)
    {
      flagsCG[4].flag[0][0][0] = true;
      datesCG[4] = RecupererDate(ENG_GOPSDATBBTMISS);
    }

  //@ Identification CG6
  lireDate = CMN__FAUX;
  for (iSN=0; iSN<SD_BAS_SNOT; iSN++)
    {
      valeur = m_DataN1.InfoDet.tab_var[ENG_GOPSFLTIMGEWMISS].val.
        pui4[iSN];
      if (valeur == 1)
        {
          flagsCG[5].flag[iSN][0][0] = true;
          lireDate = CMN__VRAI;
        }
    }
  if (lireDate == CMN__VRAI)
    {
      datesCG[5] = RecupererDate(ENG_GOPSDATIMGEWMISS);
    }

  //@ Identification CG7
  valeur = m_DataN1.InfoDet.tab_var[ENG_GOPSFLTIMGBBMISS].val.pui4[0];
  if (valeur == 1)
    {
      flagsCG[6].flag[0][0][0] = true;
      datesCG[6] = RecupererDate(ENG_GOPSDATIMGBBMISS);
    }

  //@ Identification CG8
  valeur = m_DataN1.InfoDet.tab_var[ENG_GOPSFLTIMGCSMISS].val.pui4[0];
  if (valeur == 1)
    {
      flagsCG[7].flag[0][0][0] = true;
      datesCG[7] = RecupererDate(ENG_GOPSDATIMGCSMISS);
    }

  //@ Identification CG9
  lireDate = CMN__FAUX;
  for (iSN=0; iSN<SD_BAS_SNOT; iSN++)
    {
      valeur = m_DataN1.InfoDet.tab_var[ENG_GOPSFLTRADAVHRRMISS].val.
        pui4[iSN];
      if (valeur == 1)
        {
          flagsCG[8].flag[iSN][0][0] = true;
          lireDate = CMN__VRAI;
        }
    }
  if (lireDate == CMN__VRAI)
    {
      datesCG[8] = RecupererDate(ENG_GOPSDATRADAVHRRMISS);
    }
}


//@ ------------------------------------------------------------------*/
//@ Methode : RecupererDate
//@
//@ Description : Recupere la date pour un cas degrade temporel
//@
//@ Parametres :
//@               (ENTREE) champ : Champ contenant la date
//@
//@ Valeur de retour : 
//@               Date pour le champ donne
//@
//@ ------------------------------------------------------------------*/
t_Date SD_DON_LigneN1::RecupererDate(e_SD_BAS_IND_DonDetMDRN1ENG champ)
{
  // Valeurs de lecture dans les donnees ENG
  t_SCDSTime valDate;
  t_Date     dateTmp;


  valDate.day    = m_DataN1.InfoDet.tab_var[champ].val.pdate->day;
  valDate.millis = m_DataN1.InfoDet.tab_var[champ].val.pdate->millis;
  dateTmp.SCDSTime(valDate);
  

  //@ Retourner la date lue dans le champ de donnee
  return dateTmp;
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetTypeRecordN1
//@
//@ Description : Calcul du type de record N1 a initialiser
//@
//@ Parametres :
//@               (ENTREE) typeRecord : Type de record general
//@               (ENTREE) typeProduit : Type de produit a generer
//@               (ENTREE) estValide : Temoin de validite du produit
//@
//@ Valeur de retour : 
//@               Type de record N1 a initialiser
//@
//@ ------------------------------------------------------------------*/
e_BAS_TypeRecN1 SD_DON_LigneN1::GetTypeRecordN1(const e_BAS_TypeRec 
                                                typeRecord, 
                                                const 
                                                e_SD_DON_ProduitN1 
                                                typeProduit,
                                                const t_CMN__Booleen 
                                                estValide) 
{
  // Valeur de retour de la methode
  e_BAS_TypeRecN1 typeRecordN1 = MDR_DUMMY;

  
  //@ SELON le type de record
  switch (typeRecord)
    {
      //@ TR_MDR:
    case TR_MDR:
      {
        //@ SI le produit n'est pas valide
        if (estValide == CMN__FAUX)
          {
            //@ Mise a jour du type de record (MDR_DUMMY)
            typeRecordN1 = MDR_DUMMY;
          }
        //@ SINON
        else
          {
            //@ SELON le type de produit (1A/1B/1C, 1B/1C, 
            //@ 1C, VER ou ENG)
            switch (typeProduit)
              {
                //@ SI 1C ou 1B/1C ou 1A/1B/1C:
              case SD_DON_PRODUIT_N1_1C: 
              case SD_DON_PRODUIT_N1_1B1C: 
              case SD_DON_PRODUIT_N1_1A1B1C: 
                //@ Mise a jour du type de record (MDR_1C)
                typeRecordN1 = MDR_1C;
                break;
                
                //@ SI ENG:
              case SD_DON_PRODUIT_N1_ENG: 
                //@ Mise a jour du type de record (MDR_ENG)
                typeRecordN1 = MDR_ENG;
                break;
                
                //@ SI VER:
              case SD_DON_PRODUIT_N1_VER: 
                //@ Mise a jour du type de record (MDR_VER)
                typeRecordN1 = MDR_VER;
                break;
                
                //@ Defaut:
              default:
                //@ Par defaut, rien a faire
                break;
              }
            //@ FIN SELON le type de produit
          }
        //@ FIN SI le produit n'est pas valide

        break;
      }
      
      //@ TR_VIADR:
    case TR_VIADR:
      {
        //@ SI le produit n'est pas valide
        if (estValide == CMN__FAUX)
          {
            //@ Mise a jour du type de record (VIADR_DUMMY)
            typeRecordN1 = VIADR_DUMMY;
          }
        //@ SINON
        else
          {
            //@ SELON le type de produit (1A/1B/1C, 1B/1C, 
            //@ 1C, VER ou ENG)
            switch (typeProduit)
              {
                //@ SI ENG:
              case SD_DON_PRODUIT_N1_ENG: 
                //@ Mise a jour du type de record (VIADR_ENG)
                typeRecordN1 = VIADR_ENG;
                break;
                
                //@ Defaut:
              default:
                //@ Par defaut, rien a faire
                break;
              }
            //@ FIN SELON le type de produit
          }
        //@ FIN SI le produit n'est pas valide

        break;
      }
      
      //@ Defaut:
    default:
      //@ Rien a faire
      break;
    }
  //@ FIN SELON le type de record
  

  //@ Renvoyer la valeur de retour de la methode
  return typeRecordN1;
}


//@ ------------------------------------------------------------------*/
//@ Methode : MettreAJourTypeRecord
//@
//@ Description : Met a jour le type de record a ecrire pour la ligne
//@
//@ Parametres :
//@               (ENTREE) natureProduit : Type du produit a ecrire dans
//@                                        la ligne (1A/1B/1C/ENG/VER)  
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_LigneN1::MettreAJourTypeRecord(const e_BAS_Nature 
                                           natureProduit)
{
  //@ SELON m_TypeRecord
  switch (m_TypeRecord)
    {
      //@ TR_MDR:
    case TR_MDR:
      //@ SI la ligne n'est pas valide
      if (EstValide() == CMN__FAUX)
        {
          //@ Mise a jour du type de record (MDR_DUMMY)
          m_DataN1.TypeRec = MDR_DUMMY;

#ifdef OPS_DEBUG          
          cout << "Ecriture MDR DUMMY" << endl;
#endif

        }
      //@ SINON
      else
        {
          //@ SELON la nature du produit auquel appartient la ligne
          switch (natureProduit)
            {
              //@ NA_IASIL1A:
            case NA_IASIL1A:
              //@ Mise a jour du type de record (MDR_1A)
              m_DataN1.TypeRec = MDR_1A;
              break;
              
              //@ NA_IASIL1B:
            case NA_IASIL1B:
              //@ Mise a jour du type de record (MDR_1B)
              m_DataN1.TypeRec = MDR_1B;
              break;
              
              //@ NA_IASIL1C:
            case NA_IASIL1C:
              //@ Mise a jour du type de record (MDR_1C)
              m_DataN1.TypeRec = MDR_1C;
              break;
              
              //@ NA_IASIL1ENG:
            case NA_IASIL1ENG:
              //@ Mise a jour du type de record (MDR_ENG)
              m_DataN1.TypeRec = MDR_ENG;
              break;
              
              //@ NA_IASIL1VER:
            case NA_IASIL1VER:
              //@ Mise a jour du type de record (MDR_VER)
              m_DataN1.TypeRec = MDR_VER;
              break;
              
              //@ Defaut:
            default:
              //@ Par defaut, rien a faire
              break;
            }
          //@ FIN SELON la nature du produit auquel appartient la ligne
        }
      //@ FIN SI la ligne n'est pas valide
        
      break;
          
      //@ TR_VIADR:
    case TR_VIADR:
      //@ SI la ligne n'est pas valide
      if (EstValide() == CMN__FAUX)
        {
          //@ Mise a jour du type de record (MDR_DUMMY)
          m_DataN1.TypeRec = VIADR_DUMMY;
        }
      //@ SINON
      else
        {
          //@ Mise a jour du type de record (VIADR_ENG)
          m_DataN1.TypeRec = VIADR_ENG;
        }
      //@ FIN SI la ligne n'est pas valide
      
      break;

      //@ Defaut:
    default:
      //@ Par defaut, rien a faire
      break;
    }
  //@ SELON m_TypeRecord
}


//@ ------------------------------------------------------------------*/
//@ Methode : InfoDetInitDates
//@
//@ Description : Initialisation des dates dans les infos detaillees
//@               de la ligne
//@
//@ Parametres :
//@               (ENTREE) typeRecordN1 : Type de record de niveau 1
//@
//@ Valeur de retour : 
//@               Type de record N1 a initialiser
//@
//@ ------------------------------------------------------------------*/
void SD_DON_LigneN1::InfoDetInitDates(const e_BAS_TypeRecN1 typeRecordN1)
{
  // Structure CDS
  t_SCDSTime tempsDebut = m_InfoGenLigne.GetDateDebut().SCDSTime();
  t_SCDSTime tempsFin   = m_InfoGenLigne.GetDateFin().SCDSTime();


  //@ SELON le type de record
  switch (typeRecordN1)
    {
      //@ SI MDR_1A ou MDR_1B:
    case MDR_1A:
    case MDR_1B:
      //@ Mise a jour des champs N1AB_DATEDEB et N1AB_DATEFIN
      m_DataN1.InfoDet.tab_var[N1AB_DATEDEB].val.pdate->day = 
        tempsDebut.day;
      m_DataN1.InfoDet.tab_var[N1AB_DATEDEB].val.pdate->millis = 
        tempsDebut.millis;
      m_DataN1.InfoDet.tab_var[N1AB_DATEFIN].val.pdate->day = 
        tempsFin.day;
      m_DataN1.InfoDet.tab_var[N1AB_DATEFIN].val.pdate->millis = 
        tempsFin.millis;
      break;
      
      //@ SI MDR_1C:
    case MDR_1C:
      //@ Mise a jour des champs N1C_DATEDEB et N1C_DATEFIN
      m_DataN1.InfoDet.tab_var[N1C_DATEDEB].val.pdate->day = 
        tempsDebut.day;
      m_DataN1.InfoDet.tab_var[N1C_DATEDEB].val.pdate->millis = 
        tempsDebut.millis;
      m_DataN1.InfoDet.tab_var[N1C_DATEFIN].val.pdate->day = 
        tempsFin.day;
      m_DataN1.InfoDet.tab_var[N1C_DATEFIN].val.pdate->millis = 
        tempsFin.millis;
      break;
      
      //@ SI MDR_ENG:
    case MDR_ENG:
      //@ Mise a jour des champs ENG_DATEDEB et ENG_DATEFIN
      m_DataN1.InfoDet.tab_var[ENG_DATEDEB].val.pdate->day = 
        tempsDebut.day;
      m_DataN1.InfoDet.tab_var[ENG_DATEDEB].val.pdate->millis = 
        tempsDebut.millis;
      m_DataN1.InfoDet.tab_var[ENG_DATEFIN].val.pdate->day = 
        tempsFin.day;
      m_DataN1.InfoDet.tab_var[ENG_DATEFIN].val.pdate->millis = 
        tempsFin.millis;
      break;
      
      //@ SI MDR_VER:
    case MDR_VER:
      //@ Mise a jour des champs VER_DATEDEB et VER_DATEFIN
      m_DataN1.InfoDet.tab_var[VER_DATEDEB].val.pdate->day = 
        tempsDebut.day;
      m_DataN1.InfoDet.tab_var[VER_DATEDEB].val.pdate->millis = 
        tempsDebut.millis;
      m_DataN1.InfoDet.tab_var[VER_DATEFIN].val.pdate->day = 
        tempsFin.day;
      m_DataN1.InfoDet.tab_var[VER_DATEFIN].val.pdate->millis = 
        tempsFin.millis;
      break;

      //@ SI VIADR_ENG:
    case VIADR_ENG:
    /* FA143 */
    case VIADR_DUMMY:
    /* FIN FA143 */
      //@ Mise a jour des champs VIADRENG_DATEDEB et VIADRENG_DATEFIN
      m_DataN1.InfoDet.tab_var[VIADRENG_DATEDEB].val.pdate->day = 
        tempsDebut.day;
      m_DataN1.InfoDet.tab_var[VIADRENG_DATEDEB].val.pdate->millis = 
        tempsDebut.millis;
      m_DataN1.InfoDet.tab_var[VIADRENG_DATEFIN].val.pdate->day = 
        tempsFin.day;
      m_DataN1.InfoDet.tab_var[VIADRENG_DATEFIN].val.pdate->millis = 
        tempsFin.millis;

      break;
   /* FA155 initialisation correcte des dates DMDR*/
    case MDR_DUMMY:
      //@ Mise a jour des champs DMDR_DATEDEB et DMDR_DATEFIN
      m_DataN1.InfoDet.tab_var[DMDR_DATEDEB].val.pdate->day = 
        tempsDebut.day;
      m_DataN1.InfoDet.tab_var[DMDR_DATEDEB].val.pdate->millis = 
        tempsDebut.millis;
      m_DataN1.InfoDet.tab_var[DMDR_DATEFIN].val.pdate->day = 
        tempsFin.day;
      m_DataN1.InfoDet.tab_var[DMDR_DATEFIN].val.pdate->millis = 
        tempsFin.millis;

      break;

      //@ Defaut:
    default:
      //@ Rien a faire
      break;
    }
  //@ FIN SELON le type de record
}


//@ ------------------------------------------------------------------*/
//@ Methode : InfoDetInitGen
//@
//@ Description : Initialisation des donnees generales
//@
//@ Parametres :
//@               (ENTREE) instrumentMode
//@               (ENTREE) scanPosition
//@               (ENTREE) mode
//@               (ENTREE) target
//@               (ENTREE) level
//@               (ENTREE) debugMode
//@               (ENTREE) interfaceMode
//@               (ENTREE) PTSI
//@               (ENTREE) version_logiciel_bord CR246
//@               (ENTREE) normalProcessingMode
//@               (ENTREE) backlogProcessingMode
//@               (ENTREE) reprocessingMode
//@               (ENTREE) parallelValidation
//@               (ENTREE) manoeuvre
//@               (ENTREE) processingMode
//@               (ENTREE) dispositionMode
//@               (ENTREE) modePTF
//@               (ENTREE) modeTraitement
//@               (ENTREE) noSP
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
// FA 196 et 198
// FT-2364
void SD_DON_LigneN1::InfoDetInitGen(const int instrumentMode,
                                    const int scanPosition,
                                    const int mode, 
                                    const int target,
                                    const int level,
                                    const int debugMode,
                                    const int interfaceMode,
                                    const int PTSI,
                                    const int normalProcessingMode,
                                    const int backlogProcessingMode,
                                    const int reprocessingMode,
                                    const int parallelValidation,
                                    const int manoeuvre,
                                    const e_BAS_PROCMODE 
                                    processingMode, 
                                    const e_BAS_DISPMODE 
                                    dispositionMode,
                                    const e_BAS_ModePlateforme modePTF,
                                    const e_BAS_ModeTrt modeTraitement,
                                    unsigned int noSP,
                                    bool flagManoeuvre)
// ...FT-2364
// ..FA 196 et 198
{
  //@ Instrument mode
  m_DataN1.InfoDet.tab_var[instrumentMode].val.pui4[0] =
    m_InfoGenLigne.GetModePriseDeVue();
  //CR271
  if  (this->EstTransition()== CMN__FAUX)
    m_DataN1.InfoDet.tab_var[instrumentMode].val.pui4[0] =
    m_InfoGenLigne.GetModePriseDeVue()+128;
  //@ Scan position
  //@ Mode
  //@ Target type
  if (m_InfoGenLigne.GetModePriseDeVue() != SD_BAS_EXTERNAL_CALIBRATION)
    {
      m_DataN1.InfoDet.tab_var[scanPosition].val.pui4[0] = 0;
      m_DataN1.InfoDet.tab_var[mode].val.pui4[0]         = 0;
      m_DataN1.InfoDet.tab_var[target].val.pui4[0]       = 0;
    }
  else
    {
      m_DataN1.InfoDet.tab_var[scanPosition].val.pui4[0] = noSP;
      m_DataN1.InfoDet.tab_var[mode].val.pui4[0] = 1;

      if ( (noSP < SD_BAS_SP_EARTH_MIN) || (noSP > SD_BAS_SP_EARTH_MAX) )
        {
          m_DataN1.InfoDet.tab_var[target].val.pui4[0] = 1;
        }
      else
        {
          m_DataN1.InfoDet.tab_var[target].val.pui4[0] = 0;
        }
   }


  //@ Level (donnees issues de N0)
  m_DataN1.InfoDet.tab_var[level].val.pui4[0] = 0;

  //@ Debug mode
  if (CFG__Configuration::GetChaine(STR_OPS_MODE) == 
      STR_OPS_MODE_NOMINAL)
    {
      m_DataN1.InfoDet.tab_var[debugMode].val.pui4[0] = 0;
    }
  else
    {
      m_DataN1.InfoDet.tab_var[debugMode].val.pui4[0] = 1;
    }

  //@ Interface mode: e_BAS_ModeTrt -> uint
  m_DataN1.InfoDet.tab_var[interfaceMode].val.pui4[0] = 
    (unsigned int) modeTraitement;

  //@ PTSI
// FA 196 et 198
  int ptsi;
  int version_logbord;
  ptsi = m_InfoGenLigne.GetPTSI();
  version_logbord =  m_InfoGenLigne.GetVersionLogicielBord();
  // recombinaison de ces deux valeurs sur 4 octets 
  // mot 17 = ptsi, mot 16 = version logicielle bord  (GEPSIdConf)
  m_DataN1.InfoDet.tab_var[PTSI].val.pui4[0] = 
     ((unsigned short) version_logbord) * 65536 +(unsigned short)ptsi; 
//bad formule     ((unsigned short) ptsi) * 65536 +(unsigned short)version_logbord; 
// ..FA 196 et 198

  //@ Normal Processing mode
  //@ Backlog Processing mode
  //@ Reprocessing mode
  if (processingMode == PM_NRT)
    {
      m_DataN1.InfoDet.tab_var[normalProcessingMode].val.pui4[0]  = 1;
      m_DataN1.InfoDet.tab_var[backlogProcessingMode].val.pui4[0] = 0;
      m_DataN1.InfoDet.tab_var[reprocessingMode].val.pui4[0]      = 0;
    } 
  else if (processingMode == PM_BACKLOG)
    {
      m_DataN1.InfoDet.tab_var[normalProcessingMode].val.pui4[0]  = 0;
      m_DataN1.InfoDet.tab_var[backlogProcessingMode].val.pui4[0] = 1;
      m_DataN1.InfoDet.tab_var[reprocessingMode].val.pui4[0]      = 0;
    } 
  else if (processingMode == PM_REPROCESSING)
    {
      m_DataN1.InfoDet.tab_var[normalProcessingMode].val.pui4[0]  = 0;
      m_DataN1.InfoDet.tab_var[backlogProcessingMode].val.pui4[0] = 0;
      m_DataN1.InfoDet.tab_var[reprocessingMode].val.pui4[0]      = 1;
    } 

  //@ Parallel validation
  if (dispositionMode == VALIDATION)
    {
      m_DataN1.InfoDet.tab_var[parallelValidation].val.pui4[0] = 1;
    }
  else
    {
      m_DataN1.InfoDet.tab_var[parallelValidation].val.pui4[0] = 0;
    }

  //@ Manoeuvre mode
  // FT-2364
  if (flagManoeuvre == false)
  // ...FT-2364
    {
      m_DataN1.InfoDet.tab_var[manoeuvre].val.pui4[0] = 0;
    }
  else
    {
      m_DataN1.InfoDet.tab_var[manoeuvre].val.pui4[0] = 1;
    }
}


//@ ------------------------------------------------------------------*/
//@ Methode : InfoDetInit1C
//@
//@ Description : Initialisation des donnees 1C dans les infos
//@               detaillees de la ligne a partir de donnees N0
//@
//@ Parametres :
//@               (ENTREE) processingMode : NRT, Backlog ou reprocessing
//@               (ENTREE) dispositionMode : Operationnal, Validation
//@                                          ou Commissioning
//@               (ENTREE) modePTF : Mode plateforme
//@               (ENTREE) modeTraitement : Mode de traitement (dump
//@                                         ou granule)
//@               (ENTREE) nbPaquetPX : Nombre de paquets de type PX
//@               (ENTREE) dataPaquetPX : Donnees generales des ISP de
//@                                       N0 de la ligne (de type PX)
//@               (ENTREE) OBTUTC : Objet pour la correction temps UTC
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
// FT-2364
void SD_DON_LigneN1::InfoDetInit1C(const e_BAS_PROCMODE processingMode,
                                   const e_BAS_DISPMODE dispositionMode,
                                   const e_BAS_ModePlateforme modePTF,
                                   const e_BAS_ModeTrt modeTraitement,
                                   const int nbPaquetPX,
                                   t_SD_BAS_PaquetN0** dataPaquetPX,
                                   SD_DON_OBTUTC& OBTUTC,
                                   bool flagManoeuvre)
// ...FT-2364
{
  // Donnees generales recuperees
  unsigned int   tOBT               = 0;
  t_SCDSTime     tSCDS;
  t_Date         dateTmp;
  unsigned int   noSP               = 0;

  // Temoin de recherche
  t_CMN__Booleen paquetValideTrouve = CMN__FAUX;

  // Indice du premier packet PX valide
  int            iPX                = 0;

  // Indice SN
  int            iSN                = 0;


  //@ Recuperation de l'indice du premier spectre valide
  iPX=0;
  while ( (iPX<nbPaquetPX) && (paquetValideTrouve == CMN__FAUX) )
    {
      if (dataPaquetPX[iPX]->InfoGen.tab_var[N0_VALIDREC].val.pui4[0] ==
          VALIDE)
        {
          paquetValideTrouve = CMN__VRAI;
        }
      else
        {
          iPX++;
        }
    }
  if (paquetValideTrouve == CMN__FAUX)
    {
      iPX = 0;
    }

  //@ Recuperation du numero de SP
  noSP = dataPaquetPX[iPX]->InfoGen.tab_var[N0_SP].val.pui4[0];

  //@ Appel de la methode InfoDetInitGen()
// FA 196 et 198
  // FT-2364
  InfoDetInitGen(N1C_INSTRUMENT_MODE, 
                 N1C_SCAN_POSITION,
                 N1C_MODE,
                 N1C_TARGET,
                 N1C_LEVEL,
                 N1C_DEBUG_MODE,
                 N1C_INTERFACE_MODE,
                 N1C_PTSI,
                 N1C_NORMAL_PROCESSING_MODE,
                 N1C_BACKLOG_PROCESSING_MODE,
                 N1C_REPROCESSING_MODE,
                 N1C_PARALLEL_VALIDATION,
                 N1C_MANOEUVRE,
                 processingMode,
                 dispositionMode,
                 modePTF,
                 modeTraitement,
                 noSP,
                 flagManoeuvre);
  // ...FT-2364
// ..FA 196 et 198
  //@ On board time
  //@ On board UTC date
  //@ Corner Cube Direction
  //@ SP
  //@ Corrected UTC date
  //CR270
  int isnmin;
  t_SCDSTime  tSCDSmin,tSCDSsn1;
  int deltamillis;
  isnmin=9999;
  for (iPX=0; iPX<nbPaquetPX; iPX++)
     {
      if (dataPaquetPX[iPX]->InfoGen.tab_var[N0_VALIDREC].val.pui4[0] ==
          VALIDE)
        {
          iSN = dataPaquetPX[iPX]->InfoGen.tab_var[N0_SN].val.pui4[0]-1;
          
          if (iSN < SD_BAS_SNOT)
            {
              tOBT         = dataPaquetPX[iPX]->InfoGen.
                tab_var[N0_DATEOBT].val.pui4[0];
              tSCDS.day    = dataPaquetPX[iPX]->InfoGen.
                tab_var[N0_DATEUTC].val.pdate->day;
              tSCDS.millis = dataPaquetPX[iPX]->InfoGen.
                tab_var[N0_DATEUTC].val.pdate->millis;

              m_DataN1.InfoDet.tab_var[N1C_OBT].val.pui4[iSN] = tOBT;

              m_DataN1.InfoDet.tab_var[N1C_ONBOARD_UTC].val.pdate[iSN].
                day    = tSCDS.day;
              m_DataN1.InfoDet.tab_var[N1C_ONBOARD_UTC].val.pdate[iSN].
                millis = tSCDS.millis;

              m_DataN1.InfoDet.tab_var[N1C_GEPS_CCD].val.pui4[iSN] = 
                dataPaquetPX[iPX]->InfoDet.tab_var[PX_ICD].val.pui4[0];

              m_DataN1.InfoDet.tab_var[N1C_GEPS_SP].val.pi4[iSN] = 
                dataPaquetPX[iPX]->InfoGen.tab_var[N0_SP].val.pi4[0];

              //@ Corriger les dates UTC par l'utilisation de 
              //@ SD_DON_OBTUTC:CorrigeOBT()
              dateTmp.SCDSTime(tSCDS);
              OBTUTC.CorrigeOBT(tOBT, dateTmp);
              tSCDS = dateTmp.SCDSTime();
              m_DataN1.InfoDet.tab_var[N1C_GEPSDATIASI].val.pdate[iSN].
                day    = tSCDS.day;
              m_DataN1.InfoDet.tab_var[N1C_GEPSDATIASI].val.pdate[iSN].
                millis = tSCDS.millis;
	//CR270 on calcule la date du plus petit sn valide
	     if (iSN+1<isnmin)
	     	{
	         isnmin=iSN+1;
		 tSCDSmin.day=tSCDS.day;
		 tSCDSmin.millis=tSCDS.millis;
		 }
            }
        }
     }
     //CR271 il faut alors extrapoler pour le sn=1
    if (isnmin >1 && isnmin <=30)
     {
     deltamillis=(isnmin-1)*SD_BAS_DUREE_ASE_SPECTN0;
     if (tSCDSmin.millis < deltamillis)
       {
          tSCDSsn1.day=tSCDSmin.day-1;
	  tSCDSsn1.millis=tSCDSmin.millis+86400000-deltamillis;
       }     
     else
       {     
          tSCDSsn1.day=tSCDSmin.day;
	  tSCDSsn1.millis=tSCDSmin.millis-deltamillis;
       }
     m_DataN1.InfoDet.tab_var[N1C_GEPSDATIASI].val.pdate[0].day    = tSCDSsn1.day;
     m_DataN1.InfoDet.tab_var[N1C_GEPSDATIASI].val.pdate[0].millis = tSCDSsn1.millis;       
     }
}


//@ ------------------------------------------------------------------*/
//@ Methode : InfoDetCopie1C
//@
//@ Description : Copie des donnees 1C dans les infos detaillees
//@               de la ligne a partir de donnees N1
//@
//@ Parametres :
//@               (ENTREE) dataN1 : Donnees a recopier
//@               (ENTREE) modeTraitement : Mode de traitement (dump
//@                                         ou granule)
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/

void SD_DON_LigneN1::InfoDetCopie1C(
  t_SD_BAS_LigneN1&   dataN1, 
  const e_BAS_ModeTrt modeTraitement, 
  const e_SD_DON_ProduitN1 typeProduit)

{
  // Indice SN
  int iSN = 0;
  CMN__StageTM::e_CMN__StageId typeTraitement;

  //@ Instrument mode
  m_DataN1.InfoDet.tab_var[N1C_INSTRUMENT_MODE].val.pui4[0] = 
    dataN1.InfoDet.tab_var[N1AB_INSTRUMENT_MODE].val.pui4[0];

  //@ Scan position
  m_DataN1.InfoDet.tab_var[N1C_SCAN_POSITION].val.pui4[0] = 
    dataN1.InfoDet.tab_var[N1AB_SCAN_POSITION].val.pui4[0];

  //@ Mode
  m_DataN1.InfoDet.tab_var[N1C_MODE].val.pui4[0] = 
    dataN1.InfoDet.tab_var[N1AB_MODE].val.pui4[0];

  //@ Target type
  m_DataN1.InfoDet.tab_var[N1C_TARGET].val.pui4[0] = 
    dataN1.InfoDet.tab_var[N1AB_TARGET].val.pui4[0];

  //@ Level (donnees issues de N1)
  m_DataN1.InfoDet.tab_var[N1C_LEVEL].val.pui4[0] = 1;

  //@ Debug mode
  if (CFG__Configuration::GetChaine(STR_OPS_MODE) == 
      STR_OPS_MODE_NOMINAL)
    {
      m_DataN1.InfoDet.tab_var[N1C_DEBUG_MODE].val.pui4[0] = 0;
    }
  else
    {
      m_DataN1.InfoDet.tab_var[N1C_DEBUG_MODE].val.pui4[0] = 1;
    }

  //@ Interface mode: e_BAS_ModeTrt -> uint
  m_DataN1.InfoDet.tab_var[N1C_INTERFACE_MODE].val.pui4[0] = 
    (unsigned int) modeTraitement;

  //@ PTSI
  m_DataN1.InfoDet.tab_var[N1C_PTSI].val.pui4[0] = 
    dataN1.InfoDet.tab_var[N1AB_PTSI].val.pui4[0];

// FA 196 et 198
  //@ on-board software version

  //@ Normal Processing mode
  m_DataN1.InfoDet.tab_var[N1C_NORMAL_PROCESSING_MODE].val.pui4[0] =
    dataN1.InfoDet.tab_var[N1AB_NORMAL_PROCESSING_MODE].val.pui4[0];
  
  //@ Backlog Processing mode
  m_DataN1.InfoDet.tab_var[N1C_BACKLOG_PROCESSING_MODE].val.pui4[0] = 
    dataN1.InfoDet.tab_var[N1AB_BACKLOG_PROCESSING_MODE].val.pui4[0];

  //@ Reprocessing mode
  m_DataN1.InfoDet.tab_var[N1C_REPROCESSING_MODE].val.pui4[0] =
    dataN1.InfoDet.tab_var[N1AB_REPROCESSING_MODE].val.pui4[0];
  
  //@ Parallel validation
  m_DataN1.InfoDet.tab_var[N1C_PARALLEL_VALIDATION].val.pui4[0] =
    dataN1.InfoDet.tab_var[N1AB_PARALLEL_VALIDATION].val.pui4[0];

  //@ Manoeuvre mode
  m_DataN1.InfoDet.tab_var[N1C_MANOEUVRE].val.pui4[0] =
    dataN1.InfoDet.tab_var[N1AB_MANOEUVRE].val.pui4[0];

  //@ On board time
  //@ On board UTC date
  //@ Corner Cube Direction
  //@ SP
  //@ Corrected UTC date
  for (iSN=0; iSN<SD_BAS_SNOT; iSN++)
     {
       m_DataN1.InfoDet.tab_var[N1C_OBT].val.pui4[iSN] =
         dataN1.InfoDet.tab_var[N1AB_OBT].val.pui4[iSN];

       m_DataN1.InfoDet.tab_var[N1C_ONBOARD_UTC].val.pdate[iSN].day    =
         dataN1.InfoDet.tab_var[N1AB_ONBOARD_UTC].val.pdate[iSN].day;
       m_DataN1.InfoDet.tab_var[N1C_ONBOARD_UTC].val.pdate[iSN].millis =
         dataN1.InfoDet.tab_var[N1AB_ONBOARD_UTC].val.pdate[iSN].millis;
  
       m_DataN1.InfoDet.tab_var[N1C_GEPS_CCD].val.pui4[iSN] =
         dataN1.InfoDet.tab_var[N1AB_GEPS_CCD].val.pui4[iSN];

       m_DataN1.InfoDet.tab_var[N1C_GEPS_SP].val.pui4[iSN] =
         dataN1.InfoDet.tab_var[N1AB_GEPS_SP].val.pui4[iSN];

       m_DataN1.InfoDet.tab_var[N1C_GEPSDATIASI].val.pdate[iSN].day    =
         dataN1.InfoDet.tab_var[N1AB_GEPSDATIASI].val.pdate[iSN].day; 
       m_DataN1.InfoDet.tab_var[N1C_GEPSDATIASI].val.pdate[iSN].millis =
         dataN1.InfoDet.tab_var[N1AB_GEPSDATIASI].val.pdate[iSN].millis;
     }

  //@ Number of the first sample of IASI 1C spectra (same as 1B)
  m_DataN1.InfoDet.tab_var[N1A_IDEFNSFIRST].val.pi4 = 
    dataN1.InfoDet.tab_var[N1A_IDEFNSFIRST].val.pi4;
  
  //@ Number of the last sample of IASI 1C spectra (same as 1B)
  m_DataN1.InfoDet.tab_var[N1A_IDEFNSLAST].val.pi4 = 
    dataN1.InfoDet.tab_var[N1A_IDEFNSLAST].val.pi4;

  //@ Copie du spectre et de l'image
  if (typeProduit == SD_DON_PRODUIT_N1_1B1C)
    typeTraitement = CMN__StageTM::L1b;
  
  if (typeProduit == SD_DON_PRODUIT_N1_1C)
    typeTraitement = CMN__StageTM::L1c;
  
  //@ SI on est en mode intermediaire et que les 
  if ( (typeTraitement == CMN__StageTM::L1b) || 
       (typeTraitement == CMN__StageTM::L1c) )
  {
    memcpy(
      m_DataN1.InfoCod->datasp[dataN1.TypeRec], 
      dataN1.InfoCod->datasp[dataN1.TypeRec], 
      dataN1.InfoCod->lgsp);
    
    memcpy(
      m_DataN1.InfoCod->dataim, 
      dataN1.InfoCod->dataim, 
      dataN1.InfoCod->lgim);
  }
}


//@ ------------------------------------------------------------------*/
//@ Methode : InfoDetInitENG
//@
//@ Description : Initialisation des donnees ENG dans les infos
//@               detaillees de la ligne
//@
//@ Parametres :
//@               (ENTREE) processingMode : NRT, Backlog ou reprocessing
//@               (ENTREE) dispositionMode : Operationnal, Validation
//@                                          ou Commissioning
//@               (ENTREE) modePTF : Mode plateforme
//@               (ENTREE) modeTraitement : Mode de traitement (dump
//@                                         ou granule)
//@               (ENTREE) nbLigneAbsolu : Nombre de lignes absolues
//@                                        depuis le debut du dump
//@               (ENTREE) nbPaquetPX : Nombre de paquets de type PX 
//@               (ENTREE) nbPaquetIP : Nombre de paquets de type IP 
//@               (ENTREE) dataPaquetPX : Donnees generales des ISP de
//@                                       N0 de la ligne (de type PX)
//@               (ENTREE) dataPaquetIP : Donnees generales des ISP de
//@                                       N0 de la ligne (de type IP)
//@               (ENTREE) OBTUTC : Objet pour la correction temps UTC
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
/* FA 191*/
// FT-2364
void SD_DON_LigneN1::InfoDetInitENG(const e_BAS_PROCMODE processingMode,
                                    const e_BAS_DISPMODE 
                                    dispositionMode,
                                    const e_BAS_ModePlateforme modePTF,
                                    const e_BAS_ModeTrt modeTraitement,
                                    const int nbLigneAbsolu,
                                    const int nbPaquetPX,
                                    const int nbPaquetIP,
                                    t_SD_BAS_PaquetN0** dataPaquetPX,
                                    t_SD_BAS_PaquetN0** dataPaquetIP,
                                    SD_DON_OBTUTC& OBTUTC,
				    				const int InfosVds,
									bool flagManoeuvre)
// ...FT-2364
/* ..FA 191*/
{
  // Donnees generales recuperees
  unsigned int    tOBT               = 0;
  t_SCDSTime      tSCDS;
  t_Date          dateTmp;

  // Temoin de recherche
  t_CMN__Booleen  paquetValideTrouve = CMN__FAUX;

  // Indice du premier packet PX valide
  int             iPX                = 0;

  // Indice SN
  int             iSN                = 0;

  // Indice PN
  int             iPN                = 0;

  // Indice IP
  int             iIP                = 0;

  // Numero SP
  unsigned int    noSP               = 0;

  // Compteur d'iterations
  int             i                  = 0;

  // Pointeur de parcours des mots
  unsigned short* pWord              = NULL;


  //@ Recuperation de l'indice du premier spectre valide
  iPX=0;
  while ( (iPX<nbPaquetPX) && (paquetValideTrouve == CMN__FAUX) )
    {
      if (dataPaquetPX[iPX]->InfoGen.tab_var[N0_VALIDREC].val.pui4[0] ==
          VALIDE)
        {
          paquetValideTrouve = CMN__VRAI;
        }
      else
        {
          iPX++;
        }
    }
  if (paquetValideTrouve == CMN__FAUX)
    {
      iPX = 0;
    }


  //@ Recuperation du numero de SP
  noSP = dataPaquetPX[iPX]->InfoGen.tab_var[N0_SP].val.pui4[0];

  //@ Appel de la methode InfoDetInitGen()
  /* CR246 ajout de N1C_ONBOARD_SOFTWARE_VERSION */
// FA 196 et 198
  // FT-2364
  InfoDetInitGen(ENG_INSTRUMENT_MODE, 
                 ENG_SCAN_POSITION,
                 ENG_MODE,
                 ENG_TARGET,
                 ENG_LEVEL,
                 ENG_DEBUG_MODE,
                 ENG_INTERFACE_MODE,
                 ENG_PTSI,
                 ENG_NORMAL_PROCESSING_MODE,
                 ENG_BACKLOG_PROCESSING_MODE,
                 ENG_REPROCESSING_MODE,
                 ENG_PARALLEL_VALIDATION,
                 ENG_MANOEUVRE,
                 processingMode,
                 dispositionMode,
                 modePTF,
                 modeTraitement,
                 noSP,
                 flagManoeuvre);
  // ...FT-2364
// ..FA 196 et 198

  //@ Black body temperature (in K)
  m_DataN1.InfoDet.tab_var[ENG_BIMSBBT].val.pr8[0] = 
    (double) (m_InfoGenLigne.GetBBT()/1000.);

/* FA 191 */
  //@ decomposition des infos VDS pour recuperer les indices Sn, Pn, Sb.
  //@ B0 a B3: Pn
  //@ B4 a B7: Sb
  //@ B8 a B15: Sn
  t_CMN__Statut  cr_op;
  unsigned int Pn_Vds;
  unsigned int Sn_Vds;
  char* tableauSpectre;
  tableauSpectre = new char[SD_BAS_MAXLENGTH_SPECTN0 + SD_DON_MARGE];
  SD_DON_PaquetN0 paquetN0;
  
  //@extraction des bits qui nous interessent
  // Pn_Vds = B0, B3 soit 12,15 car les bits ont ete inverses lors de la lecture
  //(SD_BAS_DecodeSpectreN0 appelle SD_BAS_InverserMot)
  
  SD_BAS_ExtraireValeur(InfosVds,12,15,&Pn_Vds);
  //Sn_Vds = B8,B15
  SD_BAS_ExtraireValeur(InfosVds,0,7,&Sn_Vds);
  
  //@ si sn, pn ok
  if ( (Pn_Vds>0) && (Pn_Vds<=4) && (Sn_Vds>0) && (Sn_Vds<37) )
  {
    int paquetTrouve = -1;
    for(iPX = 0; iPX < nbPaquetPX && paquetTrouve < 0; iPX++)
    {
       if( Sn_Vds == dataPaquetPX[iPX]->InfoGen.tab_var[N0_SN].val.pui4[0]
             && Pn_Vds == dataPaquetPX[iPX]->InfoGen.tab_var[N0_PN].val.pui4[0])
       {
          paquetTrouve = iPX;
       }
    }

    //@ SI un paquet PX correspond au (SN, PN)
    if(paquetTrouve != -1)
    {
#ifdef OPS_DEBUG
       cout << "FA191 : Paquet trouve pour Sn_Vds = " << Sn_Vds << " ,Pn_Vds = " << Pn_Vds << endl;
#endif
       //@ decodage du train binaire  spectre dans un tableau temporaire
       //@ appel DecodeDataLigne pour le spectre 
       for (int i = 0 ; i < (SD_BAS_MAXLENGTH_SPECTN0 + SD_DON_MARGE) ; i++)
       {
       	    /* FA 215 */
            tableauSpectre[i] = SD_DON_ZERO_HEXA_8BITS;
	    /* ..FA 215 */ 
       }
       //@ Mise a jour des donnees de l'objet paquet de niveau 0
       paquetN0.SetData(dataPaquetPX[paquetTrouve]);

       //@ Decodage du paquet courant via la methode 
       //@ SD_DON_PaquetN0::Decode()
       paquetN0.Decode(tableauSpectre);
     
       //@ mise a jour de la structure m_DataN1
       /* FA 215 */
       // FA 219
       for (int i = 0 ; i < (SD_BAS_VERIF-1) ; i++)
 	// ...FA 219
       {
	    // Le spectre de sortie est encode sur des entiers 16 bits
    	   m_DataN1.InfoDet.tab_var[ENG_BCODSPECVERIFF].val.pui4[i] = (unsigned int)
    		// FT-2765
    	   	(((unsigned char)tableauSpectre[i*2])<<8)+
    		((unsigned char)tableauSpectre[(i*2)+1]);
    	   // ...FT-2765
       }
       /* ..FA 215 */

    }  // fin si paquet trouve
  }//fin si pn, sn ok
  else
  {
     cout << "ERREUR: (SD_DON_LigneN1::InfoDetInitENG) Sn, et/ou Pn de la VDS non conforme(s) " << endl;
     cout << "Recuperation du spectre L0 impossible" << endl;
  }
  
  delete [] tableauSpectre;
/* ..FA 191 */

  //@ POUR tous les paquets PX
  //CR270
  int isnmin;
  t_SCDSTime  tSCDSmin,tSCDSsn1;
  int deltamillis;
  isnmin=9999;
  for (iPX=0; iPX<nbPaquetPX; iPX++)
    {
      //@ SI les donnees sont valides
      if (dataPaquetPX[iPX]->InfoGen.tab_var[N0_VALIDREC].val.pui4[0] ==
          VALIDE)
        {
          iSN = dataPaquetPX[iPX]->InfoGen.tab_var[N0_SN].val.pui4[0]-1;
          
          //@ SI le numero de SN est inferieur a SD_BAS_SNOT
          if (iSN < SD_BAS_SNOT)
            {
              tOBT         = dataPaquetPX[iPX]->InfoGen.
                tab_var[N0_DATEOBT].val.pui4[0];
              tSCDS.day    = dataPaquetPX[iPX]->InfoGen.
                tab_var[N0_DATEUTC].val.pdate->day;
              tSCDS.millis = dataPaquetPX[iPX]->InfoGen.
                tab_var[N0_DATEUTC].val.pdate->millis;
              iPN          = dataPaquetPX[iPX]->InfoGen.
                tab_var[N0_PN].val.pui4[0]-1;

              //@ Corner Cube Direction
              m_DataN1.InfoDet.tab_var[ENG_GEPS_CCD].val.pui4[iSN] = 
                dataPaquetPX[iPX]->InfoDet.tab_var[PX_ICD].val.pui4[0];

              //@ SP
              m_DataN1.InfoDet.tab_var[ENG_GEPS_SP].val.pi4[iSN] = 
                dataPaquetPX[iPX]->InfoGen.tab_var[N0_SP].val.pi4[0];

              //@ Corriger les dates UTC par l'utilisation de 
              //@ SD_DON_OBTUTC:CorrigeOBT()
              dateTmp.SCDSTime(tSCDS);
              OBTUTC.CorrigeOBT(tOBT, dateTmp);
              tSCDS = dateTmp.SCDSTime();

              //@ Corrected UTC date
              m_DataN1.InfoDet.tab_var[ENG_GEPSDATIASI].val.pdate[iSN].
                day    = tSCDS.day;
              m_DataN1.InfoDet.tab_var[ENG_GEPSDATIASI].val.pdate[iSN].
                millis = tSCDS.millis;

              //CR270 on calcule la date du plus petit sn valide
              if (iSN+1<isnmin)
              {
                isnmin=iSN+1;
                tSCDSmin.day=tSCDS.day;
                tSCDSmin.millis=tSCDS.millis;
              }
		 
              //@ PX data
              // FT-2523 - Words 4 to 151 in PX packet
              pWord = (unsigned short*) dataPaquetPX[iPX]->InfoCod.data;
              for (i=0; i<148; i++)
              {
                m_DataN1.InfoDet.tab_var[ENG_DATA_PX].val.pui4[i*SD_BAS_SNOT*SD_BAS_PN+iSN*SD_BAS_PN+iPN] = 
                  (unsigned int) (*(pWord+i+3));
                // FT-2765
                SWAP_INT_BUFFER( &m_DataN1.InfoDet.tab_var[ENG_DATA_PX].val.pui4[i*SD_BAS_SNOT*SD_BAS_PN+iSN*SD_BAS_PN+iPN], 2, 2 );
                // ...FT-2765
              }
              // ..FT-2523
           }
          //@ FIN SI le numero de SN est inferieur a SD_BAS_SNOT
        }
      //@ FIN SI les donnees sont valides
     }
  //@ FIN POUR tous les paquets PX
     //CR271 il faut alors extrapoler pour le sn=1
    if (isnmin >1 && isnmin <=30)
     {
     deltamillis=(isnmin-1)*SD_BAS_DUREE_ASE_SPECTN0;
     if (tSCDSmin.millis < deltamillis)
       {
          tSCDSsn1.day=tSCDSmin.day-1;
	  tSCDSsn1.millis=tSCDSmin.millis+86400000-deltamillis;
       }     
     else
       {     
          tSCDSsn1.day=tSCDSmin.day;
	  tSCDSsn1.millis=tSCDSmin.millis-deltamillis;
       }
     m_DataN1.InfoDet.tab_var[ENG_GEPSDATIASI].val.pdate[0].day    = tSCDSsn1.day;
     m_DataN1.InfoDet.tab_var[ENG_GEPSDATIASI].val.pdate[0].millis = tSCDSsn1.millis;       
     }

  //@ Line number
  m_DataN1.InfoDet.tab_var[ENG_GEPS_LN].val.pui4[0] = 
    nbLigneAbsolu + m_NumLigne + 1;

  //@ POUR tous les paquets IP
  for (iIP=0; iIP<nbPaquetIP; iIP++)
  {
    //@ SI les donnees sont valides
    if (dataPaquetIP[iIP]->InfoGen.tab_var[N0_VALIDREC].val.pui4[0] == VALIDE)
    {
      //@ Les SN IP sont compris entre 0 et 29, 31, 32, 34 et 35
      iSN = dataPaquetIP[iIP]->InfoGen.tab_var[N0_SN].val.pui4[0]-1;
      
      //@ SI le numero de SN est inferieur a SD_BAS_SNOT_BIS
      if ( (iSN < SD_BAS_SNOT) || 
           (iSN == IND1(SD_BAS_SN_IP_SUP_1)) ||
           (iSN == IND1(SD_BAS_SN_IP_SUP_2)) ||
           (iSN == IND1(SD_BAS_SN_IP_SUP_3)) ||
           (iSN == IND1(SD_BAS_SN_IP_SUP_4)) )
      {
        switch (iSN)
        {
          case IND1(SD_BAS_SN_IP_SUP_1): iSN = IND1(SD_BAS_SNOT+1); break; /* BB */
          case IND1(SD_BAS_SN_IP_SUP_2): iSN = IND1(SD_BAS_SNOT+2); break; /* BB */
          case IND1(SD_BAS_SN_IP_SUP_3): iSN = IND1(SD_BAS_SNOT+3); break; /* CS */
          case IND1(SD_BAS_SN_IP_SUP_4): iSN = IND1(SD_BAS_SNOT+4); break; /* CS */
          default: break;
	       }
        
        pWord = (unsigned short*) dataPaquetIP[iIP]->InfoCod.data;
        for (int i=0; i<19; i++)
        {
          for (iPN=0; iPN<SD_BAS_PN; iPN++)
          {
            m_DataN1.InfoDet.tab_var[ENG_DATA_IP].val.
            pi4[i*SD_BAS_SNOT_BIS*SD_BAS_PN+iSN*SD_BAS_PN+iPN] = ( int) (*(pWord+i+3));
            // FT-2765
            SWAP_INT_BUFFER( &m_DataN1.InfoDet.tab_var[ENG_DATA_IP].val.pi4[i*SD_BAS_SNOT_BIS*SD_BAS_PN+iSN*SD_BAS_PN+iPN], 2, 2 );
           // ...FT-2765          
					} /* FIN boucle su PN */
        } /* FIN boucle sur nombre de mots a recopier */
      } //@ FIN SI le numero de SN est inferieur a SD_BAS_SNOT_BIS
    } //@ FIN SI les donnees sont valides
  } //@ FIN POUR tous les paquets IP
}


//@ ------------------------------------------------------------------*/
//@ Methode : InfoDetCopieENG
//@
//@ Description : Copie des donnees ENG dans les infos detaillees
//@               de la ligne a partir de donnees N1
//@
//@ Parametres :
//@               (ENTREE) dataN1 : Donnees a recopier
//@               (ENTREE) modeTraitement : Mode de traitement (dump
//@                                         ou granule)
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_LigneN1::InfoDetCopieENG(t_SD_BAS_LigneN1& dataN1,
                                     const e_BAS_ModeTrt modeTraitement)
{
  // Indice SN
  int iSN = 0;


  //@ Instrument mode
  m_DataN1.InfoDet.tab_var[ENG_INSTRUMENT_MODE].val.pui4[0] =
    dataN1.InfoDet.tab_var[ENG_INSTRUMENT_MODE].val.pui4[0];

  //@ Scan position
  m_DataN1.InfoDet.tab_var[ENG_SCAN_POSITION].val.pui4[0] = 
    dataN1.InfoDet.tab_var[ENG_SCAN_POSITION].val.pui4[0];

  //@ Mode
  m_DataN1.InfoDet.tab_var[ENG_MODE].val.pui4[0] = 
    dataN1.InfoDet.tab_var[ENG_MODE].val.pui4[0];

  //@ Target type
  m_DataN1.InfoDet.tab_var[ENG_TARGET].val.pui4[0] = 
    dataN1.InfoDet.tab_var[ENG_TARGET].val.pui4[0];

  //@ Level (donnees issues de N1)
  m_DataN1.InfoDet.tab_var[ENG_LEVEL].val.pui4[0] = 1;

  //@ Debug mode
  if (CFG__Configuration::GetChaine(STR_OPS_MODE) == 
      STR_OPS_MODE_NOMINAL)
    {
      m_DataN1.InfoDet.tab_var[ENG_DEBUG_MODE].val.pui4[0] = 0;
    }
  else
    {
      m_DataN1.InfoDet.tab_var[ENG_DEBUG_MODE].val.pui4[0] = 1;
    }

  //@ Interface mode
  m_DataN1.InfoDet.tab_var[ENG_INTERFACE_MODE].val.pui4[0] = 
    (unsigned int) modeTraitement;

  //@ PTSI
  m_DataN1.InfoDet.tab_var[ENG_PTSI].val.pui4[0] = 
    dataN1.InfoDet.tab_var[ENG_PTSI].val.pui4[0];

  //@ Normal Processing mode
  m_DataN1.InfoDet.tab_var[ENG_NORMAL_PROCESSING_MODE].val.pui4[0] = 
    dataN1.InfoDet.tab_var[ENG_NORMAL_PROCESSING_MODE].val.pui4[0];

  //@ Backlog Processing mode
  m_DataN1.InfoDet.tab_var[ENG_BACKLOG_PROCESSING_MODE].val.pui4[0] = 
    dataN1.InfoDet.tab_var[ENG_BACKLOG_PROCESSING_MODE].val.pui4[0];

  //@ Reprocessing mode
  m_DataN1.InfoDet.tab_var[ENG_REPROCESSING_MODE].val.pui4[0] = 
    dataN1.InfoDet.tab_var[ENG_REPROCESSING_MODE].val.pui4[0];

  //@ Parallel validation
  m_DataN1.InfoDet.tab_var[ENG_PARALLEL_VALIDATION].val.pui4[0] = 
    dataN1.InfoDet.tab_var[ENG_PARALLEL_VALIDATION].val.pui4[0];

  //@ Manoeuvre mode
  m_DataN1.InfoDet.tab_var[ENG_MANOEUVRE].val.pui4[0] = 
    dataN1.InfoDet.tab_var[ENG_MANOEUVRE].val.pui4[0];

  //@ Corner Cube Direction
  //@ SP
  //@ Corrected UTC date
  for (iSN=0; iSN<SD_BAS_SNOT; iSN++)
     {
       m_DataN1.InfoDet.tab_var[ENG_GEPS_CCD].val.pui4[iSN] = 
         dataN1.InfoDet.tab_var[ENG_GEPS_CCD].val.pui4[iSN];

       m_DataN1.InfoDet.tab_var[ENG_GEPS_SP].val.pui4[iSN] = 
         dataN1.InfoDet.tab_var[ENG_GEPS_SP].val.pui4[iSN];

       m_DataN1.InfoDet.tab_var[ENG_GEPSDATIASI].val.pdate[iSN].day    =
         dataN1.InfoDet.tab_var[ENG_GEPSDATIASI].val.pdate[iSN].day;
       m_DataN1.InfoDet.tab_var[ENG_GEPSDATIASI].val.pdate[iSN].millis =
         dataN1.InfoDet.tab_var[ENG_GEPSDATIASI].val.pdate[iSN].millis;
     }

  //@ Line number
  m_DataN1.InfoDet.tab_var[ENG_GEPS_LN].val.pui4[0] = 
    dataN1.InfoDet.tab_var[ENG_GEPS_LN].val.pui4[0];

  //@ PX data
  // FT-2523
  // 148 = Words 4 to 151 in PX packet 
  // FT-2656
  memcpy(m_DataN1.InfoDet.tab_var[ENG_DATA_PX].val.pui4,
         dataN1.InfoDet.tab_var[ENG_DATA_PX].val.pui4,
         SD_BAS_PN*SD_BAS_SNOT*148*sizeof(unsigned int));
  // ...FT-2656
  // ..FT-2523
  //@ IP data
  memcpy(m_DataN1.InfoDet.tab_var[ENG_DATA_IP].val.pui4,
         dataN1.InfoDet.tab_var[ENG_DATA_IP].val.pui4,
         SD_BAS_PN*SD_BAS_SNOT_BIS*19*sizeof(unsigned int));
}


//@ ------------------------------------------------------------------*/
//@ Methode : InfoDetInitVER
//@
//@ Description : Initialisation des donnees VER dans les infos
//@               detaillees de la ligne a partir de donnees N0
//@
//@ Parametres :
//@               (ENTREE) nbPaquetVP : Nombre de paquets de type VP
//@               (ENTREE) nbPaquetAP : Nombre de paquets de type AP
//@               (ENTREE) dataPaquetVP : Donnees generales des ISP de
//@                                       N0 de la ligne (de type VP)
//@               (ENTREE) dataPaquetAP : Donnees generales des ISP de
//@                                       N0 de la ligne (de type AP)
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_LigneN1::InfoDetInitVER(const int nbPaquetVP,
                                    const int nbPaquetAP,
                                    t_SD_BAS_PaquetN0** dataPaquetVP,
                                    t_SD_BAS_PaquetN0** dataPaquetAP)
{
  // Taille des donnees paquet AP
  unsigned int tailleDonneesPaquetAP = 0;

  // Taille des donnees paquet VP
  unsigned int tailleDonneesPaquetVP[5] = {0,0,0,0,0};

  // Taille des donnees MAX
  unsigned int tailleDonneesMAX    = 0;

  // Taille des donnees VER
  unsigned int tailleDonneesVER    = 0;

  // Indice AP
  int iAP                          = 0;

  // Indice VP
  int iVP                          = 0;


  tailleDonneesMAX = m_DataN1.InfoDet.
    tab_var[VER_SIZE_OF_VERIFICATION_DATA].val.pui4[0];

  //@ POUR tous les paquets AP
  for (iAP=0; iAP<nbPaquetAP; iAP++)
    {
      //@ SI le paquet est valide
      if (dataPaquetAP[iAP]->InfoGen.tab_var[N0_VALIDREC].val.pui4[0] ==
          VALIDE)
        {
          tailleDonneesPaquetAP = dataPaquetAP[iAP]->InfoGen.
            tab_var[N0_LONGUEURDATA].val.pui4[0];

          if ( (tailleDonneesVER + tailleDonneesPaquetAP) <= 
               tailleDonneesMAX )
            {
              //@ Ajouter le paquet aux donnees VER
              memcpy((char*)m_DataN1.InfoDet2+tailleDonneesVER,
                      dataPaquetAP[iAP]->InfoCod.data,
                      tailleDonneesPaquetAP);

              tailleDonneesVER += tailleDonneesPaquetAP;
            }
        }
      //@ FIN SI le paquet est valide
    }
  //@ FIN POUR tous les paquets AP

  //@ Premier parcours des paquets pour recuperer les tailles
  //@ POUR tous les paquets VP
  for (iVP=0; iVP<nbPaquetVP && iVP <5 ; iVP++)
    {
      //@ SI le paquet est valide
      if (dataPaquetVP[iVP]->InfoGen.tab_var[N0_VALIDREC].val.pui4[0] ==
          VALIDE)
        {
          tailleDonneesPaquetVP[iVP] = dataPaquetVP[iVP]->InfoGen.
            tab_var[N0_LONGUEURDATA].val.pui4[0];
        }
      //@ FIN SI le paquet est valide
    }
  //@ FIN POUR tous les paquets VP

  //@ Deuxieme parcours des paquets pour les copier
  //@ Copie paquet VPA
  if (tailleDonneesPaquetVP[1] > 0)
    {
      if ( (tailleDonneesVER + tailleDonneesPaquetVP[1]) <= 
           tailleDonneesMAX )
        {
          //@ Ajouter le paquet aux donnees VER
          memcpy((char*)m_DataN1.InfoDet2+tailleDonneesVER,
                 dataPaquetVP[1]->InfoCod.data,
                 tailleDonneesPaquetVP[1]);
          
          tailleDonneesVER += tailleDonneesPaquetVP[1];
        }
    }

  //@ Copie paquet VPB
  if (tailleDonneesPaquetVP[2] > 0)
    {
      if ( (tailleDonneesVER + tailleDonneesPaquetVP[2]) <= 
           tailleDonneesMAX )
        {
          //@ Ajouter le paquet aux donnees VER
          memcpy((char*)m_DataN1.InfoDet2+tailleDonneesVER,
                 dataPaquetVP[2]->InfoCod.data,
                 tailleDonneesPaquetVP[2]);
          
          tailleDonneesVER += tailleDonneesPaquetVP[2];
        }
    }

  //@ Copie paquet VPC
  if (tailleDonneesPaquetVP[0] > 0)
    {
      if ( (tailleDonneesVER + tailleDonneesPaquetVP[0]) <= 
           tailleDonneesMAX )
        {
          //@ Ajouter le paquet aux donnees VER
          memcpy((char*)m_DataN1.InfoDet2+tailleDonneesVER,
                 dataPaquetVP[0]->InfoCod.data,
                 tailleDonneesPaquetVP[0]);
          
          tailleDonneesVER += tailleDonneesPaquetVP[0];
        }
    }

  //@ Copie paquet VPD et VPE
  for (iVP=3; iVP<5; iVP++)
    {
      if (tailleDonneesPaquetVP[iVP] > 0)
        {
          if ( (tailleDonneesVER + tailleDonneesPaquetVP[iVP]) <= 
               tailleDonneesMAX )
            {
              //@ Ajouter le paquet aux donnees VER
              memcpy((char*)m_DataN1.InfoDet2+tailleDonneesVER,
                     dataPaquetVP[iVP]->InfoCod.data,
                     tailleDonneesPaquetVP[iVP]);
              
              tailleDonneesVER += tailleDonneesPaquetVP[iVP];
            }
        }
    }

  //@ Taille des donnees de verification
  m_DataN1.InfoDet.tab_var[VER_SIZE_OF_VERIFICATION_DATA].val.pui4[0] =
    tailleDonneesVER;
}


//@ ------------------------------------------------------------------*/
//@ Methode : InfoDetCopieVER
//@
//@ Description : Copie des donnees VER dans les infos detaillees
//@               de la ligne a partir de donnees N1
//@
//@ Parametres :
//@               (ENTREE) dataN1 : Donnees a recopier
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_LigneN1::InfoDetCopieVER(t_SD_BAS_LigneN1& dataN1)
{
  // Taille des donnees VER
  int tailleDonnees = 0;

  //@ Taille des donnees de verification
  tailleDonnees = 
    dataN1.InfoDet.tab_var[VER_SIZE_OF_VERIFICATION_DATA].val.pui4[0];
  m_DataN1.InfoDet.tab_var[VER_SIZE_OF_VERIFICATION_DATA].val.pui4[0] =
    tailleDonnees;

  //@ SI la taille des donnees est superieure a 0
  if (tailleDonnees > 0)
    {
      //@ Donnees de verification
      memcpy(m_DataN1.InfoDet.tab_var[VER_SIZE_OF_VERIFICATION_DATA].
             val.pui4,
             m_DataN1.InfoDet.tab_var[VER_SIZE_OF_VERIFICATION_DATA].
             val.pui4,
             tailleDonnees);
    }
  //@ FIN SI la taille des donnees est superieure a 0
}
