//$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/DON/src/SD_DON_OSV.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD_DON
//@ Sous-composant : SD_DON
//@ CLASSE : SD_DON_OSV
//@
//@ Comment :
//@    this module implement the SD_DON_OSV class
//@    used to offer the method to determine the end of the last
//@    orbit
//@    it contains also acces to OSV xml aux datafile
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 18/12/2002 : Olivier Duffez
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2364(FA-2100-OPS) : 20/09/2010 : S. BRUNEL
//@ Product without  manoeuvre flag raised 
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_DON_OSV_h
#define SD_DON_OSV_h


// Inserer ici les fichiers include 
#include "CMN__Commun.h"
#include "CMN__Date.h"
#include "CMN_PRS_Parser.h"
#include "SD_BAS_Global.h"


// Definition des exceptions

class SD_DON_OSV {

/*====================================================================*/

public:

  //
  // Type
  //	

  //
  // Constant
  //

  //
	// Constructeur
	//
	SD_DON_OSV();

	//
	// Destructeur
	//
	~SD_DON_OSV();

	//
	// Accesseurs
	//

	//
	// public Methods 
	//
	void Lire(
		const t_Chaine & NomFichier
		) throw (ERR__Exception);
        // FT-2364
	void GetModePlateforme(
		t_Date& dateDebutUTC,
		t_Date& dateFinUTC,
		e_BAS_ModePlateforme& mode,
		bool &flagManoeuvre
		);
        // ...FT-2364
	/*====================================================================*/
protected:
	//
	// protected Methods 
	//

	//
	// protected Attributes 
	//

	/*====================================================================*/
private:
  //
  // Constantes
  //

  // valeurs possibles du flag representant le mode de plateforme
  static const t_Chaine FLAG_ANX;
  static const t_Chaine FLAG_OOP_END;
  static const t_Chaine FLAG_IP_END;
  static const t_Chaine FLAG_IP_START;
  static const t_Chaine FLAG_OOP_START;

  //
	// Private Methods 
	//
	//
	// Private Attributes 
	//
	
	// nom du fichier en entree 
	t_Chaine m_NomFichier;
		
	// objet XML contenant les coefficients de correction des dates 
	CMN_PRS_Parser m_DataXml;
	
	// indicateur de chargement
	bool m_Charge;
	
};


#endif
