static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/DON/src/SD_DON_Traitement.cc,v 1.3 2011/11/25 10:17:45 dpauly Exp $";
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_DON
//@ CLASSE : SD_DON_Traitement
//@ 
//@ Commentaire :
//@    Ce module gere la classe SD_DON_Traitement, qui contient les
//@    informations relatives a un traitement execute par le Serveur
//@    de Donnees
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-115-CN : 10/02/2004 : JL.PASCAL
//@ no report were generated in cas of missing data
//@ fiche de correction correspondante : IA-2100-FC-115-THA
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-130-CN : 29/07/2004 : P.CABANE
//@ m_PbFichierE member not correctly initialized in constructors, 
//@ not treated in operator = and in serialization methods
//@ fiche de correction correspondante : IA-2100-FC-130-THA
//@ --------------------------------------------------------------------
//@ DM-ID :IA-2100-CR-287-CNE : 08/03/2006 : B. GUENDE
//@ OPS must run if the type of the work order is FIRST or MIDDLE.
//@ OPS still stops if the type is LAST. See IA-2100-CR-287-THA.
//@ --------------------------------------------------------------------
//@ FA-ID : IA-2100-CR-290-CN : 30/03/2006 : B. GUENDE
//@ Added Degraded cases strings in order to serialize counters of each
//@  Degraded case.
//@ Added serialization and deserialization of degraded cases counters
//@ See IA-2100-CR-290-THA
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-174-CN : 03/07/2006 : C. MERIGUET
//@ Pattern * in work order can be used for auxiliary files. (patch3-5-5). 
//@ See IA-2100-FC-174-THA.
//@ --------------------------------------------------------------------
//@ MODIFIED FOR PATCH3-5-5 : 05/Jul/06
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Commun.h"
#include "CFG__Configuration.h"
#include "CMN__Fichier.h"
#include "SD__Message.h"
#include "SD_DON_Traitement.h"


//
// Definition des constantes
//

// Version Classe
const t_Chaine SD_DON_Traitement::VERSION_CLASSE             = "1.0";

const t_Chaine SD_DON_Traitement::SECTION_ENTETE             = "SECTION_ENTETE";
const t_Chaine SD_DON_Traitement::CHAMP_CLASSE               = "CHAMP_CLASSE";
const t_Chaine SD_DON_Traitement::VALEUR                     = "VALEUR";
const int      SD_DON_Traitement::NB_DIGIT_FRAC_SEC          = 6;

const t_Chaine SD_DON_Traitement::CHAMP_TYPE_TRAITEMENT      = "TYPE_TRAITEMENT";
const t_Chaine SD_DON_Traitement::CHAMP_DATE_T0              = "DATE_T0";
const t_Chaine SD_DON_Traitement::CHAMP_DATE_T1              = "DATE_T1";
const t_Chaine SD_DON_Traitement::CHAMP_POSITION_TRAITEMENT  = "POSITION_TRAITEMENT";
const t_Chaine SD_DON_Traitement::CHAMP_MODE_TRAITEMENT      = "MODE_TRAITEMENT";
const t_Chaine SD_DON_Traitement::CHAMP_COMPTEUR             = "COMPTEUR";
const t_Chaine SD_DON_Traitement::CHAMP_NOMBRE_PRODUIT_E     = "NOMBRE_PRODUIT_E";
const t_Chaine SD_DON_Traitement::CHAMP_PRODUIT_E            = "PRODUIT_E_";
const t_Chaine SD_DON_Traitement::CHAMP_NOMBRE_PRODUIT_S     = "NOMBRE_PRODUIT_S";
const t_Chaine SD_DON_Traitement::CHAMP_PRODUIT_S            = "PRODUIT_S_";
const t_Chaine SD_DON_Traitement::CHAMP_NOMBRE_DONNEES_AUX   = "NOMBRE_DONNEES_AUX";
const t_Chaine SD_DON_Traitement::CHAMP_DONNEES_AUX          = "DONNEES_AUX_";
const t_Chaine SD_DON_Traitement::CHAMP_NOMBRE_PRODUCT_MODEL = "NOMBRE_PRODUCT_MODEL";
const t_Chaine SD_DON_Traitement::CHAMP_PRODUCT_MODEL        = "PRODUCT_MODEL_";
const t_Chaine SD_DON_Traitement::CHAMP_NOMBRE_PRODUIT_AVHRR = "NOMBRE_PRODUIT_AVHRR";
const t_Chaine SD_DON_Traitement::CHAMP_PRODUIT_AVHRR        = "PRODUIT_AVHRR_";

const t_Chaine SD_DON_Traitement::CHAMP_ETAT                 = "ETAT";
const t_Chaine SD_DON_Traitement::CHAMP_PCD                  = "PCD";
const t_Chaine SD_DON_Traitement::CHAMP_START_TIME           = "START_TIME";
const t_Chaine SD_DON_Traitement::CHAMP_STOP_TIME            = "STOP_TIME";
const t_Chaine SD_DON_Traitement::CHAMP_ELAPSED_TIME         = "ELAPSED_TIME";
const t_Chaine SD_DON_Traitement::CHAMP_USER_TIME            = "USER_TIME";
const t_Chaine SD_DON_Traitement::CHAMP_LOG_MESSAGE          = "LOG_MESSAGE";

/* FA130 */
const t_Chaine SD_DON_Traitement::CHAMP_WORKING_ROOT         = "WORKING_ROOT";
const t_Chaine SD_DON_Traitement::CHAMP_PB_FICHIER_E         = "PB_FICHIER_E";

const t_Chaine SD_DON_Traitement::CHAMP_GF_FILENAME          = "GF_FILENAME";
const t_Chaine SD_DON_Traitement::CHAMP_GF_MDR_DEFINED       = "GF_MDR_DEFINED";
const t_Chaine SD_DON_Traitement::CHAMP_GF_MDR_OK            = "GF_MDR_OK";
const t_Chaine SD_DON_Traitement::CHAMP_GF_MDR_DEGRADED      = "GF_MDR_DEGRADED";

/* CR290 */
const t_Chaine SD_DON_Traitement::CHAMP_GF_CG1               = "GF_CG1";
const t_Chaine SD_DON_Traitement::CHAMP_GF_CG2               = "GF_CG2";
const t_Chaine SD_DON_Traitement::CHAMP_GF_CG3               = "GF_CG3";
const t_Chaine SD_DON_Traitement::CHAMP_GF_CG4               = "GF_CG4";
const t_Chaine SD_DON_Traitement::CHAMP_GF_CG5               = "GF_CG5";
const t_Chaine SD_DON_Traitement::CHAMP_GF_CG6               = "GF_CG6";
const t_Chaine SD_DON_Traitement::CHAMP_GF_CG7               = "GF_CG7";
const t_Chaine SD_DON_Traitement::CHAMP_GF_CG8               = "GF_CG8";
const t_Chaine SD_DON_Traitement::CHAMP_GF_CG9               = "GF_CG9";
const t_Chaine SD_DON_Traitement::CHAMP_GF_CG10              = "GF_CG10";
const t_Chaine SD_DON_Traitement::CHAMP_GF_CG11              = "GF_CG11";
const t_Chaine SD_DON_Traitement::CHAMP_GF_CG12              = "GF_CG12";
const t_Chaine SD_DON_Traitement::CHAMP_GF_CG13              = "GF_CG13";
const t_Chaine SD_DON_Traitement::CHAMP_GF_CG14              = "GF_CG14";
const t_Chaine SD_DON_Traitement::CHAMP_GF_CG15              = "GF_CG15";
/* FIN CR290 */

const t_Chaine SD_DON_Traitement::CHAMP_GF_NOMBRE_DATA_GAP   = "GF_NOMBRE_DATA_GAP";
const t_Chaine SD_DON_Traitement::CHAMP_GF_DATA_GAP_REASON   = "GF_DATA_GAP_REASON";
const t_Chaine SD_DON_Traitement::CHAMP_GF_DATA_GAP_COUNT    = "GF_DATA_GAP_COUNT";

const t_Chaine SD_DON_Traitement::PREFIXE_AVHRR              = "AVHR_";

const t_Chaine SD_DON_Traitement::DIR_ROOT                   = "WORKING_ROOT";
const t_Chaine SD_DON_Traitement::ENV_ROOT_NOT_DEFINED       = "Undefined REP_WORKING_ROOT environment variable";

const t_Chaine SD_DON_Traitement::BAD_TIME_FLAG              = "Bad time flag : ";
const t_Chaine SD_DON_Traitement::DATA_IN_NOT_FOUND          = "Data in not found: ";
const t_Chaine SD_DON_Traitement::DATA_AUX_NOT_FOUND         = "Aux data not found: ";
const t_Chaine SD_DON_Traitement::PRODUCT_MODEL_NOT_FOUND    = "Product model not found: ";


//======================================================================
//                                      METHODES PUBLIQUES
//======================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : SD_DON_Traitement
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_DON_Traitement::SD_DON_Traitement()
  : m_TypeTraitement(CMN__StageTM::L1a), m_SlideId(FIRST), 
    m_ModeTraitement(GRANULE), m_Counter(-1), m_Etat(SD_TMT_TO_BE_RUN), 
    m_PCD(0), m_ElapsedTime(0.0), m_UserTime(0.0), m_LogMessage(""), 
    m_WorkingRoot("")
{
  //@ Initialiser les dates
  m_T0.DateInit();
  m_T1.DateInit();
  m_StartTime.DateInit();
  m_StopTime.DateInit();
 
  //@ Recuperer la variable d'environnement Working_Root
  m_WorkingRoot = CFG__Configuration::GetRepertoire(DIR_ROOT);
  if (m_WorkingRoot.length() > 0)
    {
      m_WorkingRoot += CMN__SEP_REPERTOIRE;
    }
  //FA 115 : attribut pour gerer les pb de donnees
  m_PbFichierE =CMN__FAUX; 
}


//@ ------------------------------------------------------------------*/
//@ Methode : SD_DON_Traitement
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               (ENTREE) workOrder : Work Order a partir duquel le
//@                                    traitement doit etre construit
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_DON_Traitement::SD_DON_Traitement(CMN_DAT_WorkOrder& workOrder) 
  throw (ERR__Exception)
{
  // Exception
  ERR__Exception          exception;

  t_Chaine                nomFichier("");
  t_ListeChaine           listeFichier;
  t_ListeChaine::iterator pInfo;
  t_ListeChaine::iterator pFic;

  // Code retour des fonctions utilisees
  t_CMN__Booleen          status = CMN__FAUX;


  //@ Initialiser les valeurs de fin de traitement
  m_Etat           = SD_TMT_TO_BE_RUN;
  m_PCD            = 0;
  m_StartTime.DateInit();
  m_StopTime.DateInit();
  m_ElapsedTime    = 0.0;
  m_UserTime       = 0.0;
  m_LogMessage     = "";

  //FA130 : initialisation de l'attribut pour gerer les pb de donnees
  m_PbFichierE     = CMN__FAUX;
  
  //@ Positionner le type de traitement
  m_TypeTraitement = workOrder.ProcessingType();

  //@ Positionner les dates de debut et de fin
  m_T0 = workOrder.SensingStart();
  m_T1 = workOrder.SensingStop();

  //@ Positionner le Counter
  m_Counter = workOrder.TimeIntervalCounter();

  //@ Positionner le SlideId et le mode de traitement
  PositionnerModeType(workOrder.TimeIntervalFlag());

  //@ Recuperer la variable d'environnement Working_Root
  m_WorkingRoot = CFG__Configuration::GetRepertoire(DIR_ROOT);

  //@ SI la variable est definie
  if (m_WorkingRoot.length() > 0)
    {
      //@ Ajouter le separateur de repertoire
      m_WorkingRoot += CMN__SEP_REPERTOIRE;
    }
  //@ SINON
  else
    {
      //@ Emission d'une exception SD_DON_TMT_ROOT
      exception.SetErrorCode(ERR__Exception::SD_DON_TMT_ROOT);
      exception.SetParametre(ENV_ROOT_NOT_DEFINED);
      THROW(exception);
    }

  //@ Elaboration de la liste des produits en entree
  
  //@ POUR chaque element de la liste des produits
  //@ en entree du work order
  for (pInfo = workOrder.ListeUnprocData().begin();
       pInfo != workOrder.ListeUnprocData().end(); 
       pInfo++) 
    {
      nomFichier = *pInfo;
      
      //@ Recuperation du nom complet du fichier
      CheminComplet(nomFichier);
      
      //@ Rechercher le fichier physique
      status = CMN__RechercherFichier(nomFichier,
                                      CMN__FAUX,
                                      listeFichier);
      
      //@ SI le fichier n'existe pas
      if (status == CMN__FAUX)
        {
          //@ Emission d'une exception SD_DON_TMT_DATA_IN
          exception.SetErrorCode(ERR__Exception::SD_DON_TMT_DATA_IN);
          exception.SetParametre(DATA_IN_NOT_FOUND + *pInfo);
  //FA 115 : utilisation de attribut pour gerer les pb de donnees
//          THROW(exception);
  	m_PbFichierE =CMN__VRAI; 
         }
      //@ FIN SI le fichier n'existe pas

      //@ Ajouter le nom complet du fichier dans la liste
      //@ des produits en entree du traitement
      AjouterProduitE(nomFichier);
      listeFichier.clear();
    }
  //@ FIN POUR chaque element de la liste des produits
  //@ en entree du work order
  

  //@ Elaboration de la liste des donnees auxiliaires
  
  //@ POUR chaque element de la liste des donnees
  //@ auxiliaires du work order
  for (pInfo = workOrder.ListeAuxData().begin();
       pInfo != workOrder.ListeAuxData().end(); 
       pInfo++) 
    {
      nomFichier = *pInfo;
      
      //@ Recuperation du nom complet du fichier
      CheminComplet(nomFichier);
      
      //@ Rechercher le ou les fichier physique
      /* FA174 : gestion du pattern * dans les noms de fichiers */
      /* aux du work order sauf avhrr */
      //@ SI le fichier est de type AVHRR
      if (EstDeTypeAVHRR(nomFichier) == CMN__VRAI)
      {
        status = CMN__RechercherFichier(
          nomFichier, 
          CMN__FAUX, 
          listeFichier);
        //@ SI aucun fichier n'existe
        if (status == CMN__FAUX)
        {
          //@ Emission d'une exception SD_DON_TMT_DATA_AUX
          exception.SetErrorCode(ERR__Exception::SD_DON_TMT_DATA_AUX);
          exception.SetParametre(DATA_AUX_NOT_FOUND + *pInfo);
          //FA 115 : utilisation de attribut pour gerer les pb de donnees
          //          THROW(exception);
          m_PbFichierE =CMN__VRAI; 
        }//@ FIN SI aucun fichier n'existe

        //@ L'ajouter dans la liste des fichiers
        //@ AVHRR du traitement
        AjouterProduitAVHRR(nomFichier);
      }
      else
      {
        status = CMN__RechercherFichier(
          nomFichier, 
          CMN__VRAI, 
          listeFichier);
        //@ SI aucun fichier n'existe
        if (status == CMN__FAUX)
        {
          //@ Emission d'une exception SD_DON_TMT_DATA_AUX
          exception.SetErrorCode(ERR__Exception::SD_DON_TMT_DATA_AUX);
          exception.SetParametre(DATA_AUX_NOT_FOUND + *pInfo);
          //FA 115 : utilisation de attribut pour gerer les pb de donnees
          //          THROW(exception);
          m_PbFichierE =CMN__VRAI; 
        }//@ FIN SI aucun fichier n'existe

        //@ POUR tous les fichiers trouves
        for (pFic = listeFichier.begin(); 
             pFic != listeFichier.end();
             pFic++) 
        {
          //@ L'ajouter dans la liste des donnees
          //@ auxiliaires du traitement
          AjouterDonneesAux(*pFic);
        }//@ FIN POUR tous les fichiers trouves
      }//@ FIN SI le fichier est de type AVHRR
					              
      listeFichier.clear();
    }
  //@ FIN POUR chaque element de la liste des donnees
  //@ auxiliaires du work order
  
  
  //@ Elaboration de la liste des product model et
  //@ des fichiers en sortie
  
  //@ POUR chaque element de la liste des product
  //@ model du work order
  for (pInfo = workOrder.ListeProdModel().begin();
       pInfo != workOrder.ListeProdModel().end(); 
       pInfo++) 
    {
      nomFichier = *pInfo;
      
      //@ Recuperation du nom complet du fichier
      CheminComplet(nomFichier);
      
      //@ Rechercher le ou les fichier physique
      status = CMN__RechercherFichier(nomFichier, 
                                      CMN__FAUX,
                                      listeFichier);
      
      //@ SI le fichier n'existe pas
      if (status == CMN__FAUX)
        {
          //@ Emission d'une exception SD_DON_TMT_DATA_PROD
          exception.SetErrorCode(ERR__Exception::SD_DON_TMT_DATA_PROD);
          exception.SetParametre(PRODUCT_MODEL_NOT_FOUND + *pInfo);
  //FA 115 : utilisation de attribut pour gerer les pb de donnees
//          THROW(exception);
  	m_PbFichierE =CMN__VRAI; 
         }
      //@ FIN SI le fichier n'existe pas

      //@ Ajouter le nom complet du fichier dans la liste
      //@ des product model du traitement
      AjouterProductModel(nomFichier);
      
      listeFichier.clear();
    }
  //@ FIN POUR chaque element de la liste des product
  //@ model du work order
}


//@ ------------------------------------------------------------------*/
//@ Methode : SD_DON_Traitement
//@
//@ Description : Constructeur de recopie
//@
//@ Parametres :
//@               (ENTREE) traitement : Traitement a recopier
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_DON_Traitement::SD_DON_Traitement(const SD_DON_Traitement& 
                                     traitement)
{
  m_TypeTraitement = traitement.m_TypeTraitement;
  m_T0             = traitement.m_T0;
  m_T1             = traitement.m_T1;
  m_SlideId        = traitement.m_SlideId;
  m_ModeTraitement = traitement.m_ModeTraitement;
  m_Counter        = traitement.m_Counter;

  m_ListeProduitE.insert(m_ListeProduitE.begin(),
                         traitement.m_ListeProduitE.begin(),
                         traitement.m_ListeProduitE.end());

  m_ListeProduitS.insert(m_ListeProduitS.begin(),
                         traitement.m_ListeProduitS.begin(),
                         traitement.m_ListeProduitS.end());
  
  m_ListeDonneesAux.insert(m_ListeDonneesAux.begin(),
                           traitement.m_ListeDonneesAux.begin(),
                           traitement.m_ListeDonneesAux.end());

  m_ListeProductModel.insert(m_ListeProductModel.begin(),
                             traitement.m_ListeProductModel.begin(),
                             traitement.m_ListeProductModel.end());

  m_ListeProduitAVHRR.insert(m_ListeProduitAVHRR.begin(),
                             traitement.m_ListeProduitAVHRR.begin(),
                             traitement.m_ListeProduitAVHRR.end());
  
  m_Etat           = traitement.m_Etat;
  m_PCD            = traitement.m_PCD;
  m_StartTime      = traitement.m_StartTime;
  m_StopTime       = traitement.m_StopTime;
  m_ElapsedTime    = traitement.m_ElapsedTime;
  m_UserTime       = traitement.m_UserTime;
  m_LogMessage     = traitement.m_LogMessage;
  m_GeneratedFile  = traitement.m_GeneratedFile;
  m_WorkingRoot    = traitement.m_WorkingRoot;
  
  //FA130 : recopie de l'attribut pour gerer les pb de donnees
  m_PbFichierE     = traitement.m_PbFichierE;
}


//@ ------------------------------------------------------------------*/
//@ Methode : ~SD_DON_Traitement
//@
//@ Description : Destructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_DON_Traitement::~SD_DON_Traitement()
{
  m_ListeProduitE.clear();
  m_ListeProduitS.clear();
  m_ListeDonneesAux.clear();
  m_ListeProductModel.clear();
  m_ListeProduitAVHRR.clear();
}


//@ ------------------------------------------------------------------*/
//@ Methode : operator =
//@
//@ Description : Operateur =
//@
//@ Parametres :
//@               (ENTREE) traitement : Traitement origine
//@
//@ Valeur de retour : 
//@               SD_DON_Traitement : Objet destination
//@
//@ ------------------------------------------------------------------*/
SD_DON_Traitement& SD_DON_Traitement::operator =(const SD_DON_Traitement& 
                                                 traitement)
{
  if (&traitement == this)
    {
      return *this;
    }

  m_TypeTraitement = traitement.m_TypeTraitement;
  m_T0             = traitement.m_T0;
  m_T1             = traitement.m_T1;
  m_SlideId        = traitement.m_SlideId;
  m_ModeTraitement = traitement.m_ModeTraitement;
  m_Counter        = traitement.m_Counter;

  m_ListeProduitE.clear();
  m_ListeProduitE.insert(m_ListeProduitE.begin(),
                         traitement.m_ListeProduitE.begin(),
                         traitement.m_ListeProduitE.end());

  m_ListeProduitS.clear();
  m_ListeProduitS.insert(m_ListeProduitS.begin(),
                         traitement.m_ListeProduitS.begin(),
                         traitement.m_ListeProduitS.end());
  
  m_ListeDonneesAux.clear();
  m_ListeDonneesAux.insert(m_ListeDonneesAux.begin(),
                           traitement.m_ListeDonneesAux.begin(),
                           traitement.m_ListeDonneesAux.end());

  m_ListeProductModel.clear();
  m_ListeProductModel.insert(m_ListeProductModel.begin(),
                             traitement.m_ListeProductModel.begin(),
                             traitement.m_ListeProductModel.end());

  m_ListeProduitAVHRR.clear();
  m_ListeProduitAVHRR.insert(m_ListeProduitAVHRR.begin(),
                             traitement.m_ListeProduitAVHRR.begin(),
                             traitement.m_ListeProduitAVHRR.end());
  
  m_Etat           = traitement.m_Etat;
  m_PCD            = traitement.m_PCD;
  m_StartTime      = traitement.m_StartTime;
  m_StopTime       = traitement.m_StopTime;
  m_ElapsedTime    = traitement.m_ElapsedTime;
  m_UserTime       = traitement.m_UserTime;
  m_LogMessage     = traitement.m_LogMessage;
  m_GeneratedFile  = traitement.m_GeneratedFile;
  m_WorkingRoot    = traitement.m_WorkingRoot;

  //FA130 : recopie de l'attribut pour gerer les pb de donnees
  m_PbFichierE     = traitement.m_PbFichierE;
  
  return *this;
}


//@ ------------------------------------------------------------------*/
//@ Methode : EstDeTypeFinDump
//@
//@ Description : Teste si le traitement est de type fin de dump
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               CMN__VRAI si le traitement est un dump ou un granule
//@                 de type fin de dump
//@               CMN__FAUX sinon
//@
//@ ------------------------------------------------------------------*/
t_CMN__Booleen SD_DON_Traitement::EstDeTypeFinDump()
{
  // Valeur de retour de la fonction
  t_CMN__Booleen valRetour = CMN__FAUX;


  //@ SI le traitement est de type DUMP
  if (m_ModeTraitement == DUMP)
    {
      //@ Le traitement est de type fin de dump, i.e. il faut arreter
      //@ l'application des qu'il est termine
      //@ Mettre a jour la valeur de retour
      valRetour = CMN__VRAI;
    }
  //@ SINON SI le traitement est de type GRANULE LAST
  else if ( (m_ModeTraitement == GRANULE) && (m_SlideId == LAST) )
    {
      //@ Le traitement est de type fin de dump, i.e. il faut
      //@ arreter l'application des qu'il est termine
      //@ Mettre a jour la valeur de retour
      valRetour = CMN__VRAI;
    }
  //@ FIN SI test du type du traitement

  
  //@ Retourner la valeur de retour
  return valRetour;
}


//@ ------------------------------------------------------------------*/
//@ Methode : Deserialiser
//@
//@ Description : Construit un objet de la classe SD_DON_Traitement a
//@               partir du contenu du message passe en parametre
//@
//@ Parametres :
//@               (ENTREE) message : Message contenant l'objet
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_Traitement::Deserialiser(const MSG__Message& message)
{
  t_Chaine           bloc(message.GetBloc());
  CMN__Configuration config;
  t_Chaine           version("");
  t_Chaine           temp("");


  //@ SI le type du message est bien du type evenement TRAITEMENT
  if (message.GetType() == SD__Message::EVT_TMT_SD)
    {
      //@ Chargement du bloc de donnees
      config.ChargerChaine(bloc);

      //@ Lecture de la version de la classe
      config.ChargerChaine(bloc);
      config.LireValeur(SECTION_ENTETE, CHAMP_CLASSE, version);

      //@ Lecture du type de traitement
      config.LireValeur(CHAMP_TYPE_TRAITEMENT, VALEUR, temp);
      m_TypeTraitement = (CMN__StageTM::e_CMN__StageId) int(temp);
 
      //@ Lecture de la date t0
      config.LireValeur(CHAMP_DATE_T0, VALEUR, temp);
      t_Date dateT0(temp, FORMAT_DATE);
      m_T0 = dateT0;

      //@ Lecture de la date t1
      config.LireValeur(CHAMP_DATE_T1, VALEUR, temp);
      t_Date dateT1(temp, FORMAT_DATE);
      m_T1 = dateT1;

      //@ Lecture de la position du traitement
      config.LireValeur(CHAMP_POSITION_TRAITEMENT, VALEUR, temp);
      m_SlideId = (e_BAS_PositionTrt) int(temp);
 
      //@ Lecture du mode du traitement
      config.LireValeur(CHAMP_MODE_TRAITEMENT, VALEUR, temp);
      m_ModeTraitement = (e_BAS_ModeTrt) int(temp);

      //@ Lecture du compteur
      config.LireValeur(CHAMP_COMPTEUR, VALEUR, temp);
      m_Counter = long(temp);

      //@ Lecture du nombre de produits en entree
      RecupererListeProduits(config,
                             CHAMP_NOMBRE_PRODUIT_E,
                             CHAMP_PRODUIT_E,
                             m_ListeProduitE);

      //@ Lecture du nombre de produits en sortie
      RecupererListeProduits(config,
                             CHAMP_NOMBRE_PRODUIT_S,
                             CHAMP_PRODUIT_S,
                             m_ListeProduitS);
      
      //@ Lecture du nombre de donnees auxiliaires
      RecupererListeProduits(config,
                             CHAMP_NOMBRE_DONNEES_AUX,
                             CHAMP_DONNEES_AUX,
                             m_ListeDonneesAux);
      
      //@ Lecture du nombre de product model
      RecupererListeProduits(config,
                             CHAMP_NOMBRE_PRODUCT_MODEL,
                             CHAMP_PRODUCT_MODEL,
                             m_ListeProductModel);

      //@ Lecture du nombre de produits AVHRR
      RecupererListeProduits(config,
                             CHAMP_NOMBRE_PRODUIT_AVHRR,
                             CHAMP_PRODUIT_AVHRR,
                             m_ListeProduitAVHRR);

      //@ Lecture de l'etat du traitement
      config.LireValeur(CHAMP_ETAT, VALEUR, temp);
      m_Etat = (e_ListeStatus) ((int)temp);

      //@ Lecture du PCD
      config.LireValeur(CHAMP_PCD, VALEUR, temp);
      m_PCD = (int)temp;

      //@ Lecture de la date StartTime
      config.LireValeur(CHAMP_START_TIME, VALEUR, temp);
      t_Date dateStartTime(temp, FORMAT_DATE);
      m_StartTime = dateStartTime;

      //@ Lecture de la date StopTime
      config.LireValeur(CHAMP_STOP_TIME, VALEUR, temp);
      t_Date dateStopTime(temp, FORMAT_DATE);
      m_StopTime = dateStopTime;
 
      //@ Lecture de Elapsed Time 
      config.LireValeur(CHAMP_ELAPSED_TIME, VALEUR, temp);
      m_ElapsedTime = double(temp);

      //@ Lecture de User Time
      config.LireValeur(CHAMP_USER_TIME, VALEUR, temp);
      m_UserTime = double(temp);

      //@ Lecture du message de log
      config.LireValeur(CHAMP_LOG_MESSAGE, VALEUR, temp);
      m_LogMessage = temp;

      //@ Lecture du Generated File
      config.LireValeur(CHAMP_GF_FILENAME, VALEUR, temp);
      m_GeneratedFile.FileName(temp);
      config.LireValeur(CHAMP_GF_MDR_DEFINED, VALEUR, temp);
      if ((int) temp == CMN__VRAI)
        {
          config.LireValeur(CHAMP_GF_MDR_OK, VALEUR, temp);
          m_GeneratedFile.MdrOk((int) temp);
          config.LireValeur(CHAMP_GF_MDR_DEGRADED, VALEUR, temp);
          m_GeneratedFile.MdrDegraded((int) temp);
          
          /* CR290 */
          config.LireValeur(CHAMP_GF_CG1, VALEUR, temp);
          m_GeneratedFile.SetNbCas(1, (int) temp);
          config.LireValeur(CHAMP_GF_CG2, VALEUR, temp);
          m_GeneratedFile.SetNbCas(2, (int) temp);
          config.LireValeur(CHAMP_GF_CG3, VALEUR, temp);
          m_GeneratedFile.SetNbCas(3, (int) temp);
          config.LireValeur(CHAMP_GF_CG4, VALEUR, temp);
          m_GeneratedFile.SetNbCas(4, (int) temp);
          config.LireValeur(CHAMP_GF_CG5, VALEUR, temp);
          m_GeneratedFile.SetNbCas(5, (int) temp);
          config.LireValeur(CHAMP_GF_CG6, VALEUR, temp);
          m_GeneratedFile.SetNbCas(6, (int) temp);
          config.LireValeur(CHAMP_GF_CG7, VALEUR, temp);
          m_GeneratedFile.SetNbCas(7, (int) temp);
          config.LireValeur(CHAMP_GF_CG8, VALEUR, temp);
          m_GeneratedFile.SetNbCas(8, (int) temp);
          config.LireValeur(CHAMP_GF_CG9, VALEUR, temp);
          m_GeneratedFile.SetNbCas(9, (int) temp);
          config.LireValeur(CHAMP_GF_CG10, VALEUR, temp);
          m_GeneratedFile.SetNbCas(10, (int) temp);
          config.LireValeur(CHAMP_GF_CG11, VALEUR, temp);
          m_GeneratedFile.SetNbCas(11, (int) temp);
          config.LireValeur(CHAMP_GF_CG12, VALEUR, temp);
          m_GeneratedFile.SetNbCas(12, (int) temp);
          config.LireValeur(CHAMP_GF_CG13, VALEUR, temp);
          m_GeneratedFile.SetNbCas(13, (int) temp);
          config.LireValeur(CHAMP_GF_CG14, VALEUR, temp);
          m_GeneratedFile.SetNbCas(14, (int) temp);
          config.LireValeur(CHAMP_GF_CG15, VALEUR, temp);
          m_GeneratedFile.SetNbCas(15, (int) temp);
          /* FIN CR290 */
        }

      //@ Lecture du nombre de data gaps
      RecupererListeDataGaps(config,
                             CHAMP_GF_NOMBRE_DATA_GAP,
                             CHAMP_GF_DATA_GAP_REASON,
                             CHAMP_GF_DATA_GAP_COUNT,
                             m_GeneratedFile.ListeDataGap());
      
      //@ FA130 : Lecture du repertoire Root
      config.LireValeur(CHAMP_WORKING_ROOT, VALEUR, temp);
      m_WorkingRoot = temp;

      //@ FA130 : Lecture de l'attribut pour gerer les pb de donnees
      config.LireValeur(CHAMP_PB_FICHIER_E, VALEUR, temp);
      m_PbFichierE = (int)temp;
    }
  //@ FIN SI
}


//@ ------------------------------------------------------------------*/
//@ Methode : Serialiser
//@
//@ Description : Construit un message a partir de la description de
//@               l'objet courant
//@
//@ Parametres :
//@               (SORTIE) MSG__Message : Message reseau
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_Traitement::Serialiser(MSG__Message& message)
{
  CMN__Configuration       config;
  t_Chaine                 resultat("");
  t_Chaine                 dateText("");
  t_Date                   date;
  t_ListeChaine::iterator  itListe;
  t_ListeDataGap::iterator itDataGap;
  t_Chaine                 nomSection("");
  int                      indiceListe = 1;


  //@ Ecriture de la version de la classe
  config.EcrireValeur(SECTION_ENTETE, CHAMP_CLASSE, VERSION_CLASSE);

  //@ Ecriture du type de traitement
  config.EcrireValeur(CHAMP_TYPE_TRAITEMENT, 
                      VALEUR, 
                      (int) m_TypeTraitement);

  //@ Ecriture de la date t0
  date = m_T0;
  dateText = date.Formater(FORMAT_DATE, NB_DIGIT_FRAC_SEC);
  config.EcrireValeur(CHAMP_DATE_T0, VALEUR, dateText);
 
  //@ Ecriture de la date t1
  date = m_T1;
  dateText = date.Formater(FORMAT_DATE, NB_DIGIT_FRAC_SEC);
  config.EcrireValeur(CHAMP_DATE_T1, VALEUR, dateText);

  //@ Ecriture de la position du traitement
  config.EcrireValeur(CHAMP_POSITION_TRAITEMENT, 
                      VALEUR, 
                      (int) m_SlideId);

  //@ Ecriture du mode du traitement
  config.EcrireValeur(CHAMP_MODE_TRAITEMENT, 
                      VALEUR, 
                      (int) m_ModeTraitement);

  //@ Ecriture du compteur
  config.EcrireValeur(CHAMP_COMPTEUR, VALEUR, (long) m_Counter);

  //@ Ecriture du nombre de produits en entree
  config.EcrireValeur(CHAMP_NOMBRE_PRODUIT_E, VALEUR, 
                      (int) m_ListeProduitE.size());

  //@ POUR chaque element de la liste des produits en entree
  indiceListe = 1;
  for(itListe = m_ListeProduitE.begin();
      itListe != m_ListeProduitE.end(); 
      itListe++)
    {
      nomSection = CHAMP_PRODUIT_E + t_Chaine(indiceListe++);

      //@ Ecriture de son nom
      config.EcrireValeur(nomSection, VALEUR, *itListe);
    }
  //@ FIN POUR

  //@ Ecriture du nombre de produits en sortie
  config.EcrireValeur(CHAMP_NOMBRE_PRODUIT_S, 
                      VALEUR, 
                      (int) m_ListeProduitS.size());
  
  //@ POUR chaque element de la liste des produits en sortie
  indiceListe = 1;
  for(itListe = m_ListeProduitS.begin(); 
      itListe != m_ListeProduitS.end(); 
      itListe++)
    {
      nomSection = CHAMP_PRODUIT_S + t_Chaine(indiceListe++);

      //@ Ecriture de son nom
      config.EcrireValeur(nomSection, VALEUR, *itListe);
    }
  //@ FIN POUR
  
  //@ Ecriture du nombre de donnees auxiliaires
  config.EcrireValeur(CHAMP_NOMBRE_DONNEES_AUX, 
                      VALEUR, 
                      (int) m_ListeDonneesAux.size());
  
  //@ POUR chaque element de la liste des donnees auxiliaires
  indiceListe = 1;
  for(itListe = m_ListeDonneesAux.begin();
      itListe != m_ListeDonneesAux.end(); 
      itListe++)
    {
      nomSection = CHAMP_DONNEES_AUX + t_Chaine(indiceListe++);

      //@ Ecriture de son nom
      config.EcrireValeur(nomSection, VALEUR, *itListe);
    }
  //@ FIN POUR

  //@ Ecriture du nombre de product model
  config.EcrireValeur(CHAMP_NOMBRE_PRODUCT_MODEL, 
                      VALEUR, 
                      (int) m_ListeProductModel.size());

  //@ POUR chaque element de la liste des product model
  indiceListe = 1;
  for(itListe = m_ListeProductModel.begin();
      itListe != m_ListeProductModel.end(); 
      itListe++)
    {
      nomSection = CHAMP_PRODUCT_MODEL + t_Chaine(indiceListe++);

      //@ Ecriture de son nom
      config.EcrireValeur(nomSection, VALEUR, *itListe);
    }
  //@ FIN POUR

  //@ Ecriture du nombre de produits AVHRR
  config.EcrireValeur(CHAMP_NOMBRE_PRODUIT_AVHRR, 
                      VALEUR, 
                      (int) m_ListeProduitAVHRR.size());

  //@ POUR chaque element de la liste des produits AVHRR
  indiceListe = 1;
  for(itListe = m_ListeProduitAVHRR.begin(); 
      itListe != m_ListeProduitAVHRR.end(); 
      itListe++)
    {
      nomSection = CHAMP_PRODUIT_AVHRR + t_Chaine(indiceListe++);

      //@ Ecriture de son nom
      config.EcrireValeur(nomSection, VALEUR, *itListe);
    }
  //@ FIN POUR

  //@ Ecriture de l'etat du traitement
  config.EcrireValeur(CHAMP_ETAT, VALEUR, m_Etat);

  //@ Ecriture du PCD
  config.EcrireValeur(CHAMP_PCD, VALEUR, m_PCD);

  //@ Ecriture de la date StartTime
  date = m_StartTime;
  dateText = date.Formater(FORMAT_DATE, NB_DIGIT_FRAC_SEC);
  config.EcrireValeur(CHAMP_START_TIME, VALEUR, dateText);
 
  //@ Ecriture de la date StopTime
  date = m_StopTime;
  dateText = date.Formater(FORMAT_DATE, NB_DIGIT_FRAC_SEC);
  config.EcrireValeur(CHAMP_STOP_TIME, VALEUR, dateText);

  //@ Ecriture de Elapsed Time
  config.EcrireValeur(CHAMP_ELAPSED_TIME, 
                      VALEUR, 
                      (double)m_ElapsedTime);

  //@ Ecriture de User Time
  config.EcrireValeur(CHAMP_USER_TIME, VALEUR, (double)m_UserTime);

  //@ Ecriture du message de log
  config.EcrireValeur(CHAMP_LOG_MESSAGE, VALEUR, m_LogMessage);
   
  //@ Ecriture du Generated File
  config.EcrireValeur(CHAMP_GF_FILENAME, 
                      VALEUR, 
                      m_GeneratedFile.FileName());
  config.EcrireValeur(CHAMP_GF_MDR_DEFINED, 
                      VALEUR, 
                      int(m_GeneratedFile.MdrDefined()));
  config.EcrireValeur(CHAMP_GF_MDR_OK, 
                      VALEUR, 
                      m_GeneratedFile.MdrOk());
  config.EcrireValeur(CHAMP_GF_MDR_DEGRADED, 
                      VALEUR, 
                      m_GeneratedFile.MdrDegraded());
  
  /* CR290 */
  config.EcrireValeur(CHAMP_GF_CG1,
                      VALEUR,
                      m_GeneratedFile.GetNbCas(1));
  config.EcrireValeur(CHAMP_GF_CG2,
                      VALEUR,
                      m_GeneratedFile.GetNbCas(2));
  config.EcrireValeur(CHAMP_GF_CG3,
                      VALEUR,
                      m_GeneratedFile.GetNbCas(3));
  config.EcrireValeur(CHAMP_GF_CG4,
                      VALEUR,
                      m_GeneratedFile.GetNbCas(4));
  config.EcrireValeur(CHAMP_GF_CG5,
                      VALEUR,
                      m_GeneratedFile.GetNbCas(5));
  config.EcrireValeur(CHAMP_GF_CG6,
                      VALEUR,
                      m_GeneratedFile.GetNbCas(6));
  config.EcrireValeur(CHAMP_GF_CG7,
                      VALEUR,
                      m_GeneratedFile.GetNbCas(7));
  config.EcrireValeur(CHAMP_GF_CG8,
                      VALEUR,
                      m_GeneratedFile.GetNbCas(8));
  config.EcrireValeur(CHAMP_GF_CG9,
                      VALEUR,
                      m_GeneratedFile.GetNbCas(9));
  config.EcrireValeur(CHAMP_GF_CG10,
                      VALEUR,
                      m_GeneratedFile.GetNbCas(10));
  config.EcrireValeur(CHAMP_GF_CG11,
                      VALEUR,
                      m_GeneratedFile.GetNbCas(11));
  config.EcrireValeur(CHAMP_GF_CG12,
                      VALEUR,
                      m_GeneratedFile.GetNbCas(12));
  config.EcrireValeur(CHAMP_GF_CG13,
                      VALEUR,
                      m_GeneratedFile.GetNbCas(13));
  config.EcrireValeur(CHAMP_GF_CG14,
                      VALEUR,
                      m_GeneratedFile.GetNbCas(14));
  config.EcrireValeur(CHAMP_GF_CG15,
                      VALEUR,
                      m_GeneratedFile.GetNbCas(15));
  /* FIN CR290 */
  
  //@ Ecriture du nombre de data gaps
  config.EcrireValeur(CHAMP_GF_NOMBRE_DATA_GAP, 
                      VALEUR, 
                      (int) m_GeneratedFile.ListeDataGap().size());

  //@ POUR chaque element de la liste des data gaps
  indiceListe = 1;
  for(itDataGap = m_GeneratedFile.ListeDataGap().begin();
      itDataGap != m_GeneratedFile.ListeDataGap().end(); 
      itDataGap++)
    {
      //@ Ecriture de la raison
      nomSection = CHAMP_GF_DATA_GAP_REASON + t_Chaine(indiceListe);
      config.EcrireValeur(nomSection, VALEUR, itDataGap->Reason());

      //@ Ecriture du nombre
      nomSection = CHAMP_GF_DATA_GAP_COUNT + t_Chaine(indiceListe++);
      config.EcrireValeur(nomSection, VALEUR, itDataGap->Count());
    }
  //@ FIN POUR

  //@ FA130 : Ecriture du repertoire Root
  config.EcrireValeur(CHAMP_WORKING_ROOT, VALEUR, m_WorkingRoot);
  
  //@ FA130 : Ecriture de l'attribut pour gerer les pb de donnees
  config.EcrireValeur(CHAMP_PB_FICHIER_E, VALEUR, m_PbFichierE);

  //@ Sauvegarde de la serialisation dans une chaine
  config.SauverChaine(resultat);
   
  //@ Sauvegarde du bloc dans le message
  message.SetBloc(resultat.c_str(), resultat.size()+1);
    
  //@ Sauvegarde du type dans le message
  message.SetType(SD__Message::EVT_TMT_SD);
}


//@ ------------------------------------------------------------------*/
//@ Methode : Serialiser
//@
//@ Description : Construit un message a partir de la description de
//@               l'objet courant
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               Message contenant la description de l'objet
//@
//@ ------------------------------------------------------------------*/
MSG__Message SD_DON_Traitement::Serialiser()
{
  //@ Declaration d'un message
  MSG__Message message;
  
  //@ Appel de la serialisation
  Serialiser(message);
  
  //@ Retour du message
  return message;
}


//@ ------------------------------------------------------------------*/
//@ Methode : Afficher
//@
//@ Description : Affiche le contenu de l'objet
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_Traitement::Afficher()
{
  t_ListeChaine::iterator pInfo;
  int                     i = 1;


  cout << "SD_DON_Traitement:" << endl;

  //@ Affichage du type de traitement
  cout << "\tTypeTraitement     : " 
       << m_TypeTraitement << endl;

  //@ Affichage de la date t0
  cout << "\tT0                 : " 
       << m_T0.Chaine() << endl;
 
  //@ Affichage de la date t1
  cout << "\tT1                 : " 
       << m_T1.Chaine() << endl;

  //@ Affichage de la position du traitement
  cout << "\tSlideId            : " 
       << m_SlideId << endl;

  //@ Affichage du mode du traitement
  cout << "\tModeTraitement     : " 
       << m_ModeTraitement << endl;

  //@ Affichage du compteur
  cout << "\tCounter            : " 
       << m_Counter << endl;

  //@ Affichage de l'etat du traitement
  cout << "\tEtat               : " 
       << m_Etat << endl;

  //@ Affichage du PCD
  cout << "\tPCD                : " 
       << m_PCD << endl;

  //@ Affichage de la date StartTime
  cout << "\tStartTime          : " 
       << m_StartTime.Chaine() << endl;
 
  //@ Affichage de la date StopTime
  cout << "\tStopTime           : " 
       << m_StopTime.Chaine() << endl;

  //@ Affichage de Elapsed Time
  cout << "\tElapsedTime        : " 
       << m_ElapsedTime << endl;
 
  //@ Affichage de UserTime
  cout << "\tUserTime           : " 
       << m_UserTime << endl;

  //@ Affichage du message de log
  cout << "\tLog message        : " 
       << m_LogMessage << endl;

  //@ FA130 : Affichage du repertoire Root
  cout << "\tWorking root       : " 
       << m_WorkingRoot << endl;

  //@ FA130 : Affichage de l'attribut pour gerer les pb de donnees
  cout << "\tData in problem    : " 
       << m_PbFichierE << endl;

  //@ Affichage des fichiers generes
  cout << "\tgenerated file     : "; 
  m_GeneratedFile.Afficher() ;
  cout << endl;

  //@ Affichage du nombre de produits en entree
  cout << "\tNombre ProduitE    : " 
       << m_ListeProduitE.size() 
       << endl;

  //@ POUR chaque element de la liste des produits en entree
  for (pInfo = m_ListeProduitE.begin(); 
       pInfo != m_ListeProduitE.end(); pInfo++) 
    {
      //@ Affichage de son nom
      cout << "\t\tno" << i++ << ":" << *pInfo << endl;
    }
  //@ FIN POUR

  i = 1;

  //@ Affichage du nombre de produits en sortie
  cout << "\tNombre ProduitS    : " 
       << m_ListeProduitS.size() << endl;
  
  //@ POUR chaque element de la liste des produits en sortie
  for (pInfo = m_ListeProduitS.begin(); 
       pInfo != m_ListeProduitS.end(); pInfo++) 
    {
      //@ Affichage de son nom
      cout << "\t\tno" << i++ << ":" << *pInfo << endl;
    }
  //@ FIN POUR

  i = 1;

  //@ Affichage du nombre de donnees auxiliaires
  cout << "\tNombre DonneesAux  : " 
       << m_ListeDonneesAux.size() << endl;
  
  //@ POUR chaque element de la liste des donnees auxiliaires
  for (pInfo = m_ListeDonneesAux.begin(); 
       pInfo != m_ListeDonneesAux.end(); 
       pInfo++) 
    {
      //@ Affichage de son nom
     cout << "\t\tno" << i++ << ":" << *pInfo << endl;
    }
  //@ FIN POUR

  i = 1;

  //@ Affichage du nombre de product model
  cout << "\tNombre ProductModel : " 
       << m_ListeProductModel.size() << endl;

  //@ POUR chaque element de la liste des product model
  for (pInfo = m_ListeProductModel.begin(); 
       pInfo != m_ListeProductModel.end(); 
       pInfo++) 
    {
        //@ Affichage de son nom
    cout << "\t\tno" << i++ << ":" << *pInfo << endl;
    }
  //@ FIN POUR

  i = 1;

  //@ Affichage du nombre de produits AVHRR
  cout << "\tNombre ProduitAVHRR: " 
       << m_ListeProduitAVHRR.size() << endl;

  //@ POUR chaque element de la liste des produits AVHRR
  for (pInfo = m_ListeProduitAVHRR.begin(); 
       pInfo != m_ListeProduitAVHRR.end();
       pInfo++) 
    {
      //@ Affichage de son nom
      cout << "\t\tno" << i++ << ":" << *pInfo << endl;
    }
  //@ FIN POUR

  cout << "Fin SD_DON_Traitement" << endl;
}


//======================================================================
//                                      METHODES PRIVEES
//======================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : PositionnerModeType
//@
//@ Description : Positionner le type (SlideId) et le mode de
//@               traitement
//@
//@ Parametres :
//@               (ENTREE) valeurTIF : Valeur du TimeIntervalFlag
//@
//@ Valeur de retour :
//@               Aucun
//@
//@ ------------------------------------------------------------------*/
void SD_DON_Traitement::PositionnerModeType(t_Chaine valeurTIF)
  throw (ERR__Exception)
{
  static int initSD = CMN__FAUX; /* CR287 */
  
  //@ SI le TimeIntervalFlag est de type First
  if (valeurTIF == CMN_DAT_WorkOrder::WORK_ORDER_TYPE_FIRST)
    {
      //@ Positionner le SlideId a FIRST
      m_SlideId = FIRST;
      
      //@ Positionner le mode de traitement
      m_ModeTraitement = GRANULE;
      
      initSD = CMN__VRAI; /* CR287 */
    }
  //@ SINON SI le TimeIntervalFlag est de type Middle
  else if (valeurTIF == CMN_DAT_WorkOrder::WORK_ORDER_TYPE_MIDDLE)
    {
      //@ Positionner le SlideId a MIDDLE
      m_SlideId = MIDDLE;
      
      //@ Positionner le mode de traitement
      m_ModeTraitement = GRANULE;
      
      /* CR287 */
      if(initSD == CMN__FAUX)
     	{
        m_SlideId = FIRST;
        initSD = CMN__VRAI;
      }
      /* FIN CR287 */
    }
  //@ SINON SI le TimeIntervalFlag est de type Last
  else if (valeurTIF == CMN_DAT_WorkOrder::WORK_ORDER_TYPE_LAST)
    {
      //@ Positionner le SlideId a LAST
      m_SlideId = LAST;
      
      //@ Positionner le mode de traitement
      m_ModeTraitement = GRANULE;
    }
  //@ SINON SI le TimeIntervalFlag est de type Full
  else if (valeurTIF == CMN_DAT_WorkOrder::WORK_ORDER_TYPE_FULL)
    {
      //@ Positionner le SlideId a FIRST par defaut
      m_SlideId = FIRST;

      //@ Positionner le mode de traitement
      m_ModeTraitement = DUMP;
    }
  //@ SINON
  else
    {
      // Exception generee
      ERR__Exception exception;

      //@ Emission d'une exception SD_DON_TMT_SLIDE_ID
      exception.SetErrorCode(ERR__Exception::SD_DON_TMT_SLIDE_ID);
      exception.SetParametre(BAD_TIME_FLAG + valeurTIF);
      THROW(exception);
    }
  //@ FIN SI le TimeIntervalFlag est de type First

/* CR287 */
#ifdef OPS_DEBUG
  cout << "SlideID: " << m_SlideId << endl;
  cout << "FIRST=" << FIRST << " MIDDLE=" << MIDDLE<< " LAST=" << LAST <<endl;
#endif
/* FIN CR287 */
}


//@ ------------------------------------------------------------------*/
//@ Methode : CheminComplet
//@
//@ Description : Transforme le nom de fichier en chemin complet
//@
//@ Parametres :
//@               (ENTREE/SORTIE) nomFichier : Nom du fichier
//@
//@ Valeur de retour :
//@               Aucun
//@
//@ ------------------------------------------------------------------*/
void SD_DON_Traitement::CheminComplet(t_Chaine& nomFichier)
{
  if (nomFichier.at(0) != CMN__CAR_SEP_REPERTOIRE)
    {
      nomFichier = m_WorkingRoot + nomFichier;
    }
}


//@ ------------------------------------------------------------------*/
//@ Methode : EstDeTypeAVHRR
//@
//@ Description : Teste si un fichier est du type AVHRR
//@
//@ Parametres :
//@               (ENTREE) nomFichier : Nom du fichier
//@
//@ Valeur de retour : 
//@               CMN__VRAI si le fichier est de type AVHRR
//@               CMN__FAUX sinon
//@
//@ ------------------------------------------------------------------*/
t_CMN__Booleen SD_DON_Traitement::EstDeTypeAVHRR(const t_Chaine&
                                                 nomFichier)
{
  // Racine du nom du fichier
  t_Chaine       racine("");

  // Valeur de retour de la fonction
  t_CMN__Booleen valRetour = CMN__FAUX;


  //@ Recuperation du debut du nom court du fichier
  racine = nomFichier.substr(nomFichier.rfind(CMN__SEP_REPERTOIRE)+1, 
                             PREFIXE_AVHRR.length());

  //@ Comparaison de la chaine recuperee avec le motif AVHR
  //@ SI les deux chaines sont identiques
  if (racine == PREFIXE_AVHRR)
    {
      //@ Positionner la valeur de retour a VRAI
      valRetour = CMN__VRAI;
    }
  //@ FIN SI les deux chaines sont identiques


  //@ Retourner la valeur de retour de la fonction
  return valRetour;
}


//@ ------------------------------------------------------------------*/
//@ Methode : RecupererListeProduits
//@
//@ Description : Recupere dans une configuration une liste de produits
//@
//@ Parametres :
//@               (ENTREE) config
//@               (ENTREE) champNombre
//@               (ENTREE) champProduit
//@               (SORTIE) liste
//@
//@ Valeur de retour :
//@               Aucun
//@
//@ ------------------------------------------------------------------*/
void SD_DON_Traitement::RecupererListeProduits(CMN__Configuration& config,
                                               t_Chaine champNombre, 
                                               t_Chaine champProduit,
                                               t_ListeChaine& liste)
{
  int      indiceListe = 1;
  int      nbElement   = 0;
  t_Chaine temp("");
  t_Chaine nomSection("");


  //@ Lecture du nombre de produits en entree
  config.LireValeur(champNombre, VALEUR, temp);
  nbElement = int(temp);
  liste.clear();
  
  //@ POUR chacun des produits
  for (indiceListe = 0; indiceListe < nbElement; indiceListe++)
    {
      nomSection = champProduit + t_Chaine(indiceListe+1);
      
      //@ Lecture de son nom
      config.LireValeur(nomSection, VALEUR, temp);
      liste.push_back(temp);
    }
  //@ FIN POUR
}


//@ ------------------------------------------------------------------*/
//@ Methode : RecupererListeDataGaps
//@
//@ Description : Recupere dans une configuration une liste de trous
//@               de donnees
//@
//@ Parametres :
//@               (ENTREE) config
//@               (ENTREE) champNombre
//@               (ENTREE) champReason
//@               (ENTREE) champCount
//@               (SORTIE) liste
//@
//@ Valeur de retour :
//@               Aucun
//@
//@ ------------------------------------------------------------------*/
void SD_DON_Traitement::RecupererListeDataGaps(CMN__Configuration& config,
                                               t_Chaine champNombre, 
                                               t_Chaine champReason,
                                               t_Chaine champCount,
                                               t_ListeDataGap& liste)
{
  int       indiceListe = 1;
  int       nbElement   = 0;
  t_Chaine  temp("");
  t_Chaine  nomSection("");
  t_DataGap dataGap;


  //@ Lecture du nombre de produits en entree
  config.LireValeur(champNombre, VALEUR, temp);
  nbElement = int(temp);
  liste.clear();
  
  //@ POUR chacun des produits
  for (indiceListe = 0; indiceListe < nbElement; indiceListe++)
    {
      //@ Lecture de la raison
      nomSection = champReason + t_Chaine(indiceListe+1);
      config.LireValeur(nomSection, VALEUR, temp);
      dataGap.Reason(temp);

      //@ Lecture du nombre d'occurrences
      nomSection = champCount + t_Chaine(indiceListe+1);
      config.LireValeur(nomSection, VALEUR, temp);
      dataGap.Count((int) temp);

      liste.push_back(dataGap);
    }
  //@ FIN POUR
}
