// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/DON/src/SD_DON_Traitement.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_DON
//@ CLASSE : SD_DON_Traitement
//@
//@ Commentaire :
//@    Fichier d'entete de la classe SD_DON_Traitement
//@                                                                     
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-115-CN : 10/02/2004 : JL.PASCAL
//@ no report were generated in cas of missing data
//@ fiche de correction correspondante : IA-2100-FC-115-THA
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-130-CN : 29/07/2004 : P.CABANE
//@ m_PbFichierE member not correctly initialized in constructors, 
//@ not treated in operator = and in serialization methods
//@ fiche de correction correspondante : IA-2100-FC-130-THA
//@ --------------------------------------------------------------------
//@ FA-ID : IA-2100-CR-290-CN : 30/03/2006 : B. GUENDE
//@ Added Degraded cases strings in order to serialize counters of each
//@  Degraded case.
//@ See IA-2100-CR-290-THA
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_DON_Traitement_h
#define SD_DON_Traitement_h


//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Commun.h"
#include "CMN__Config.h"
#include "CMN__CGSCst.h"
#include "CMN__Date.h"
#include "CMN__StageTM.h"
#include "ERR__Exception.h"
#include "MSG__Message.h"
#include "CMN_DAT_WorkOrder.h"
#include "CMN_DAT_GeneratedFile.h"
#include "SD_BAS_Global.h"

class SD_DON_Traitement {

    /*================================================================*/
    
 public:
    
    ////////////////////////////////
    // Type definitions
    ////////////////////////////////

    // Liste des status geres
    typedef enum {
        SD_TMT_TO_BE_RUN = -1,
        SD_TMT_OK        =  0,
        SD_TMT_NOK       =  1,
        SD_TMT_ERR_ALGO  =  2,
        SD_TMT_ABORTED   =  3,
        SD_TMT_PB_INITDUMP   =  4,
        SD_TMT_PB_INITGRAN   =  5
    } e_ListeStatus;
    //FA 115 : 2 etats sont rejoutes pour indiquer au WOM l'origine du pb

    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    SD_DON_Traitement();
    SD_DON_Traitement(CMN_DAT_WorkOrder& workOrder) 
        throw (ERR__Exception);

    // Constructeur de recopie
    SD_DON_Traitement(const SD_DON_Traitement& traitement);

    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    virtual ~SD_DON_Traitement();

    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    SD_DON_Traitement& operator =(const SD_DON_Traitement& traitement);

    CMN__StageTM::e_CMN__StageId TypeTraitement() const 
        {return m_TypeTraitement;};
    t_Chaine TypeTraitementStr() const
        {return CMN_PGF_STAGE_ID[m_TypeTraitement];};
    void     TypeTraitement(CMN__StageTM::e_CMN__StageId typeTraitement)
        {if ((typeTraitement >= 0) && 
             (typeTraitement < CMN__StageTM::NbrStageId))
            m_TypeTraitement = typeTraitement;};

    t_Date T0() const {return m_T0;};
    void   T0(t_Date date) {m_T0 = date;};

    t_Date T1() const {return m_T1;};
    void   T1(t_Date date) {m_T1 = date;};

    e_BAS_PositionTrt SlideId() const {return m_SlideId;};
    void              SlideId(e_BAS_PositionTrt position) 
        {m_SlideId = position;};

    e_BAS_ModeTrt ModeTraitement() const {return m_ModeTraitement;};
    void          ModeTraitement(e_BAS_ModeTrt modeTraitement) 
        {m_ModeTraitement = modeTraitement;};

    long Counter() const {return m_Counter;};
    void Counter(long counter) {m_Counter = counter;};

    t_ListeChaine& ListeProduitE() {return m_ListeProduitE;};
    void AjouterProduitE(t_Chaine produitE) 
        {m_ListeProduitE.push_back(produitE);};
    void ListeProduitE(t_ListeChaine& liste) {m_ListeProduitE = liste;};

    t_ListeChaine& ListeProduitS() {return m_ListeProduitS;};
    void AjouterProduitS(t_Chaine produitS) 
        {m_ListeProduitS.push_back(produitS);};
    void ListeProduitS(t_ListeChaine& liste) {m_ListeProduitS = liste;};

    t_ListeChaine& ListeDonneesAux() {return m_ListeDonneesAux;};
    void AjouterDonneesAux(t_Chaine aux) 
        {m_ListeDonneesAux.push_back(aux);};
    void ListeDonneesAux(t_ListeChaine& liste) 
        {m_ListeDonneesAux = liste;};

    t_ListeChaine& ListeProductModel() {return m_ListeProductModel;};
    void AjouterProductModel(t_Chaine model) 
        {m_ListeProductModel.push_back(model);};
    void ListeProductModel(t_ListeChaine& liste) 
        {m_ListeProductModel = liste;};

    t_ListeChaine& ListeProduitAVHRR() {return m_ListeProduitAVHRR;};
    void AjouterProduitAVHRR(t_Chaine pAVHRR) 
        {m_ListeProduitAVHRR.push_back(pAVHRR);};
    void ListeProduitAVHRR(t_ListeChaine& liste) 
        {m_ListeProduitAVHRR = liste;};

    e_ListeStatus Etat() const {return m_Etat;};
    void          Etat(e_ListeStatus etat) {m_Etat = etat;};
 
    int  PCD() const {return m_PCD;};
    void PCD(int valeur) {m_PCD = valeur;};

    t_Date& StartTime() {return m_StartTime;};
    void    StartTime(t_Date date) {m_StartTime = date;};

    t_Date& StopTime() {return m_StopTime;};
    void    StopTime(t_Date date) {m_StopTime = date;};

    double ElapsedTime() const {return m_ElapsedTime;};
    void   ElapsedTime(double elapsedTime) {m_ElapsedTime = elapsedTime;};

    double UserTime() const {return m_UserTime;};
    void   UserTime(double userTime) {m_UserTime = userTime;};

    t_Chaine LogMessage() const {return m_LogMessage;};
    void     LogMessage(t_Chaine message) {m_LogMessage = message;};

    t_GeneratedFile& GeneratedFile() {return m_GeneratedFile;};
    void             GeneratedFile(t_GeneratedFile& generatedFile) 
        {m_GeneratedFile = generatedFile;};

 //FA 115 : attribut pour gerer les pb de donnees
    void SetPbFichierE(t_CMN__Booleen pbfichiere) 
        {m_PbFichierE=pbfichiere;};
    t_CMN__Booleen GetPbFichierE() {return m_PbFichierE;};

    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    t_CMN__Booleen EstDeTypeFinDump();

    void           Deserialiser(const MSG__Message& message);
    void           Serialiser(MSG__Message &message);
    MSG__Message   Serialiser();
    void           Afficher();


    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////
    

    /*================================================================*/

 private:

    //
    // Constante
    //
    static const t_Chaine VERSION_CLASSE;

    static const t_Chaine SECTION_ENTETE;
    static const t_Chaine CHAMP_CLASSE;
    static const t_Chaine VALEUR;
    static const int      NB_DIGIT_FRAC_SEC;
    
    static const t_Chaine CHAMP_TYPE_TRAITEMENT;
    static const t_Chaine CHAMP_DATE_T0;
    static const t_Chaine CHAMP_DATE_T1;
    static const t_Chaine CHAMP_POSITION_TRAITEMENT;
    static const t_Chaine CHAMP_MODE_TRAITEMENT;
    static const t_Chaine CHAMP_COMPTEUR;
    static const t_Chaine CHAMP_NOMBRE_PRODUIT_E;
    static const t_Chaine CHAMP_PRODUIT_E;
    static const t_Chaine CHAMP_NOMBRE_PRODUIT_S;
    static const t_Chaine CHAMP_PRODUIT_S;
    static const t_Chaine CHAMP_NOMBRE_DONNEES_AUX;
    static const t_Chaine CHAMP_DONNEES_AUX;
    static const t_Chaine CHAMP_NOMBRE_PRODUCT_MODEL;
    static const t_Chaine CHAMP_PRODUCT_MODEL;
    static const t_Chaine CHAMP_NOMBRE_PRODUIT_AVHRR;
    static const t_Chaine CHAMP_PRODUIT_AVHRR;
    
    /* FA130 */
    static const t_Chaine CHAMP_WORKING_ROOT;
    static const t_Chaine CHAMP_PB_FICHIER_E;
    
    static const t_Chaine CHAMP_ETAT;
    static const t_Chaine CHAMP_PCD;
    static const t_Chaine CHAMP_START_TIME;
    static const t_Chaine CHAMP_STOP_TIME;
    static const t_Chaine CHAMP_ELAPSED_TIME;
    static const t_Chaine CHAMP_USER_TIME;
    static const t_Chaine CHAMP_LOG_MESSAGE;
    
    static const t_Chaine CHAMP_GF_FILENAME;
    static const t_Chaine CHAMP_GF_MDR_DEFINED;
    static const t_Chaine CHAMP_GF_MDR_OK;
    static const t_Chaine CHAMP_GF_MDR_DEGRADED;
/* CR290 */
    static const t_Chaine CHAMP_GF_CG1; 
    static const t_Chaine CHAMP_GF_CG2; 
    static const t_Chaine CHAMP_GF_CG3; 
    static const t_Chaine CHAMP_GF_CG4; 
    static const t_Chaine CHAMP_GF_CG5; 
    static const t_Chaine CHAMP_GF_CG6; 
    static const t_Chaine CHAMP_GF_CG7; 
    static const t_Chaine CHAMP_GF_CG8; 
    static const t_Chaine CHAMP_GF_CG9; 
    static const t_Chaine CHAMP_GF_CG10; 
    static const t_Chaine CHAMP_GF_CG11; 
    static const t_Chaine CHAMP_GF_CG12; 
    static const t_Chaine CHAMP_GF_CG13; 
    static const t_Chaine CHAMP_GF_CG14; 
    static const t_Chaine CHAMP_GF_CG15; 
/* Fin CR290 */
    static const t_Chaine CHAMP_GF_NOMBRE_DATA_GAP;
    static const t_Chaine CHAMP_GF_DATA_GAP_REASON;
    static const t_Chaine CHAMP_GF_DATA_GAP_COUNT;

    static const t_Chaine PREFIXE_AVHRR;
    
    static const t_Chaine DIR_ROOT;
    static const t_Chaine ENV_ROOT_NOT_DEFINED;
    static const t_Chaine BAD_TIME_FLAG;
    static const t_Chaine DATA_IN_NOT_FOUND;
    static const t_Chaine DATA_AUX_NOT_FOUND;
    static const t_Chaine PRODUCT_MODEL_NOT_FOUND;

        
    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////
    void           PositionnerModeType(t_Chaine valeurTIF) 
        throw (ERR__Exception);
    void           CheminComplet(t_Chaine& nomFichier);
    t_CMN__Booleen EstDeTypeAVHRR(const t_Chaine& nomFichier);
    void           RecupererListeProduits(CMN__Configuration& config,
                                          t_Chaine champNombre, 
                                          t_Chaine champProduit,
                                          t_ListeChaine& liste);
    void           RecupererListeDataGaps(CMN__Configuration& config,
                                          t_Chaine champNombre, 
                                          t_Chaine champReason,
                                          t_Chaine champCount,
                                          t_ListeDataGap& liste);

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////

    // Type du traitement
    CMN__StageTM::e_CMN__StageId m_TypeTraitement;

    t_Date                       m_T0;
    t_Date                       m_T1;

    e_BAS_PositionTrt            m_SlideId;
    e_BAS_ModeTrt                m_ModeTraitement;

    long                         m_Counter;

    t_ListeChaine                m_ListeProduitE;
    t_ListeChaine                m_ListeProduitS;
    t_ListeChaine                m_ListeDonneesAux;
    t_ListeChaine                m_ListeProductModel;
    t_ListeChaine                m_ListeProduitAVHRR;

    // Etat du traitement
    e_ListeStatus                m_Etat;

    int                          m_PCD;
    t_Date                       m_StartTime;
    t_Date                       m_StopTime;
    double                       m_ElapsedTime;
    double                       m_UserTime;
    t_Chaine                     m_LogMessage;
    t_GeneratedFile              m_GeneratedFile;

    // Repertoire Root
    t_Chaine                     m_WorkingRoot;
 //FA 115 : attribut pour gerer les pb de donnees
    t_CMN__Booleen               m_PbFichierE;
};

// Liste de traitements
typedef list<SD_DON_Traitement*> t_ListeTraitement;

#endif
