static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/EVT/src/SD_EVT_ObservateurTerminaisonTache.cc,v 1.3 2011/11/25 10:17:45 dpauly Exp $";
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_EVT
//@ CLASSE : SD_EVT_ObservateurTerminaisonTache
//@ 
//@ Commentaire :
//@    Ce module gere la classe SD_EVT_ObservateurTerminaisonTache
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ --------------------------------------------------------------------
//@ VERSION : 12/08/1999 : SAS
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Commun.h"
#include "SD_EVT_SujetTerminaisonTache.h"
#include "SD_FRW_Echeancier.h"
#include "SD_FRW_ApplicationServeurDonnees.h"
#include "SD_EVT_ObservateurTerminaisonTache.h"


//
// Definition des constantes
//


//======================================================================
//                                      METHODES PUBLIQUES
//======================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : SD_EVT_ObservateurTerminaisonTache
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               (ENTREE) Sujet : Sujet auquel s'interesse 
//@                                l'observateur
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_EVT_ObservateurTerminaisonTache::
SD_EVT_ObservateurTerminaisonTache(SD_EVT_SujetTerminaisonTache* sujet)
{
  //@ Memoriser le sujet
  m_Sujet = sujet;

  //@ S'attacher au sujet
  m_Sujet->Attacher(this);
}


//@ ------------------------------------------------------------------*/
//@ Methode : ~SD_EVT_ObservateurTerminaisonTache
//@
//@ Description : Destructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_EVT_ObservateurTerminaisonTache::~SD_EVT_ObservateurTerminaisonTache()
{
  //@ Se detacher du sujet
  m_Sujet->Detacher(this);
}


//@ ------------------------------------------------------------------*/
//@ Methode : MettreAJour
//@
//@ Description : CallBack de notification du sujet d'interet
//@
//@ Parametres :
//@               (ENTREE) sujet : Sujet d'interet
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_EVT_ObservateurTerminaisonTache::MettreAJour(CMN_OBS_Sujet * sujet)
{
  SD_TAC_Tache* tache;


  //@ Interroger le sujet sur la tache a observer
  tache = m_Sujet->Tache();

  //@ Verrouiller l'application
  m_Application->Verrouiller();

  //@ SI Tache->Id() > 0
  if (tache->Id() > 0) 
    {
      //@ Mettre a jour l'echeancier
      m_Application->Echeancier()->MettreAJour(tache);
    }
  //@ FIN SI Tache->Id() > 0
  
  //@ Deverrouiller l'application
  m_Application->Deverrouiller();
}


//@ ------------------------------------------------------------------*/
//@ Methode : Application
//@
//@ Description : Accesseur a l'application
//@
//@ Parametres :
//@               (ENTREE) application
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_EVT_ObservateurTerminaisonTache::
Application(SD_FRW_ApplicationServeurDonnees* application)
{
  //@ Memoriser l'application cible
  m_Application = application;
}


//======================================================================
//                                      METHODES PRIVEES
//======================================================================

