// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/FRW/src/SD_FRW_FabriqueAction.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_FRW
//@ CLASSE : SD_FRW_FabriqueAction
//@
//@ Commentaire :
//@    Fichier d'entete de la classe SD_FRW_FabriqueAction
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 20/08/1999 : SAS
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Adaptation a l'OPS : ajout de la gestion des exceptions
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_FRW_FabriqueAction_h
#define SD_FRW_FabriqueAction_h


//
// Fichiers include
//

// STL
#include <map>

// Standard

// Projet
#include "CMN__Chaine.h"
#include "ERR__Exception.h"
#include "CMN_DAT_ListeObjets.h"
#include "SD_ACT_Action.h"


class SD_FRW_FabriqueAction {

    /*================================================================*/

 public:

    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    SD_FRW_FabriqueAction();
    
    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    virtual ~SD_FRW_FabriqueAction();
        
    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////

    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    void           ChargerModelesActions() throw (ERR__Exception);
    SD_ACT_Action* CreerAction(t_Chaine& action, SD_TAC_Tache* tache)
        throw (ERR__Exception);


    /*================================================================*/

 protected:
    
    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////
    int RechercherSimulationAction(t_Chaine& mnemo);

    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////


    /*================================================================*/

 private:
 
    ////////////////////////////////
    // Types
    ////////////////////////////////
    typedef map<t_Chaine, int> mapActions;
   
    ////////////////////////////////
    // Constantes
    ////////////////////////////////
    static const t_Chaine FICHIER_MODELES_ACTIONS;
   
    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
    CMN_DAT_ListeObjets    m_ListeModelesActions;
    mapActions             m_Actions;
};

#endif
