// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/FRW/src/SD_FRW_FabriqueDeTache.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_FRW
//@ CLASSE : SD_FRW_FabriqueDeTache
//@
//@ Commentaire :
//@    Fichier d'entete de la classe SD_FRW_FabriqueDeTache
//@                                                             
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 20/08/1999 : SAS
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Adaptation a l'OPS : ajout de la gestion des exceptions
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_FRW_FabriqueDeTache_h
#define SD_FRW_FabriqueDeTache_h


//
// Fichiers include
//

// STL

// Standard

// Projet
#include "ERR__Exception.h"
#include "CMN_DAT_ListeObjets.h"
#include "SD_FRW_FabriqueAction.h"
#include "SD_TAC_Tache.h"


class SD_FRW_FabriqueDeTache {

    /*================================================================*/

 public:
    
    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    SD_FRW_FabriqueDeTache(void);
    
    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    virtual ~SD_FRW_FabriqueDeTache();

    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    
    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    void          ChargerModelesTaches() throw (ERR__Exception);
    SD_TAC_Tache* CreerTache(t_Chaine& travail);


    /*================================================================*/

 protected:
    
    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////
    
    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////
    
    
    /*================================================================*/

 private:
 
    ////////////////////////////////
    // Constantes
    ////////////////////////////////
    static const t_Chaine FICHIER_MODELES_TACHES;

    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////
    SD_TAC_Tache* RechercherTache(t_Chaine& mnemo) 
        throw (ERR__Exception);
    
    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
    SD_FRW_FabriqueAction*  m_FabriqueAction;
    CMN_DAT_ListeObjets     m_ListeModelesTaches;
};

#endif
