// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/FRW/src/SD_FRW_GestionnaireThread.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_FRW
//@ CLASSE : SD_FRW_GestionnaireThread
//@
//@ Commentaire :
//@    Fichier d'entete de la classe SD_FRW_GestionnaireThread
//@                                                                     
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 10/08/1999 : SAS
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Adaptation a l'OPS
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_FRW_GestionnaireThread_h
#define SD_FRW_GestionnaireThread_h


//
// Fichiers include
//

// STL
#include <iostream>

// Standard
#include <pthread.h>

// Projet
#include "SD_FRW_ContexteThread.h"
#include "SD_EVT_SujetTerminaisonTache.h"
#include "SD_TAC_Tache.h"


class SD_FRW_ApplicationServeurDonnees;

class SD_FRW_GestionnaireThread {

    /*================================================================*/

 public:
   
    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    SD_FRW_GestionnaireThread(int noThreads);
        
    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    virtual ~SD_FRW_GestionnaireThread();


    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    SD_EVT_SujetTerminaisonTache* SujetTerminaisonTache()
        {return m_SujetTerminaisonTache;};

    SD_FRW_ApplicationServeurDonnees* Application()
        {return m_Application;};
    void  Application(SD_FRW_ApplicationServeurDonnees* application)
        {m_Application = application;};
    

    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    t_CMN__Booleen LancerTache(SD_TAC_Tache* tache);
    int            CompterLesTachesEnCours();
    void           Reprendre();
    int            ArreterTache(int id);
    void           ArreterToutesLesTaches();


    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////
    
    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////

        
    /*================================================================*/

 private:
    
    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////
    void CreerThread(int i);

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
    SD_EVT_SujetTerminaisonTache*       m_SujetTerminaisonTache;
    SD_FRW_ContexteThread*              m_Threads;
    int                                 m_NbThreadsReels;
    int                                 m_NbThreadsVirtuels;
    int                                 m_NbThreadsVirtuelsDisponibles;
    SD_FRW_ApplicationServeurDonnees*   m_Application;
};

#endif

