static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/FRW/src/SD_FRW_VerrouApplication.cc,v 1.3 2011/11/25 10:17:45 dpauly Exp $";
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_FRW
//@ CLASSE : SD_FRW_VerrouApplication
//@
//@ Commentaire :
//@    Ce module gere la classe SD_FRW_VerrouApplication, qui definit
//@    un mecanisme de verrouillage de l'acces aux donnees partagees
//@    par les threads du Serveur de Donnees
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 09/09/99 : SAS
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Commun.h"
#include "SD_FRW_VerrouApplication.h"


//======================================================================
//                                      METHODES PUBLIQUES
//======================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : SD_FRW_VerrouApplication
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               (ENTREE) Appli : Pointeur sur l'objet 
//@                                application a verrouiller
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_FRW_VerrouApplication::
SD_FRW_VerrouApplication(SD_FRW_ApplicationServeurDonnees & Appli)
{
  m_Appli = & Appli;
  
  //@ Verrouiller l'application
  m_Appli->Verrouiller();
}


//@ ------------------------------------------------------------------*/
//@ Methode : ~SD_FRW_VerrouApplication
//@
//@ Description : Destructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_FRW_VerrouApplication::~SD_FRW_VerrouApplication()
{
  //@ Deverrouiller l'application
  m_Appli->Deverrouiller();
}


//======================================================================
//                                      METHODES PRIVEES
//======================================================================
