// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/GES/src/SD_GES_ChaineImageISRFEM.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_GES
//@ CLASSE : SD_GES_ChaineImageISRFEM
//@
//@ Comment :
//@    this module contains the second action used for the IASI OPS 
//@     L1 Processing chain level 0-1C ( multi-threaded bu line)
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 10/03/2003 : P.GASSIE
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_GES_ChaineImageISRFEM_h
#define SD_GES_ChaineImageISRFEM_h


//
// Fichiers include
//

// STL

// Standard

// Projet
#include "SD_ACT_Action.h"
#include "SD_DON_GestDonnees.h"
#include "SD_BAS_Global.h"
#include "CMN__Date.h"
#include "SD_ALG_ISRFEM.h"



class SD_GES_ChaineImageISRFEM : public SD_ACT_Action {

    /*================================================================*/

 public:

    ////////////////////////////////
    // Type definitions
    ////////////////////////////////

    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    SD_GES_ChaineImageISRFEM(SD_TAC_Tache* tache);

    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    virtual ~SD_GES_ChaineImageISRFEM();

    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////


    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    virtual void Executer();
    virtual void VerifierSymptome();


    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////


    /*================================================================*/

 private:
     
    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////
    void Corpstraitement(
				const  int numeroLigne,
			         SD_DON_GestDonnees* gestionnaire,
  				 t_SD_BAS_Contexte* contextecourant,
 				 t_SD_BAS_DataGen  * datagen,
				 SD_DON_GestCasDeg & gestCasDeg,
				const int NbPaquetsPX,
				 t_SD_BAS_PaquetN0** ListePaquetPX,							
				const int NbPaquetsIP,
				 t_SD_BAS_PaquetN0** ListePaquetIP,							
  				 t_SD_BAS_MPHR * Mphr1ABC,
 				 t_SD_BAS_LigneN1 * LigneMDR1ABC,
 				 t_SD_BAS_LigneN1 * LigneMDRENG,
 				 t_SD_BAS_ConfAutre *  ConfAutre ,
  				 t_SD_BAS_ConfStable * ConfStable ,
  				 t_SD_BAS_BanqueSpectrale * BanqueSpectrale ,
				 double* slope,
				 double* offset,
				 int *NombreSNminValide,
 				 t_SD_BAS_DataThreadImageISRFEM* dataImageISRFEM,
  				 t_SD_BAS_DataThread22SOS* data22SOS,
				 t_SD_BAS_DataThread *ctx
    			);
    void InitialiserNiveau1(t_SD_BAS_LigneN1* LigneMDR1ABC,
                            t_SD_BAS_LigneN1& LigneMDRENG,
                            t_SD_BAS_ConfAutre* ConfAutre,
                            t_SD_BAS_Contexte* contexte
                            );
    void AllouerPointeurs22SOS(t_SD_BAS_DataThread22SOS *data22SOS,
                               t_SD_BAS_ConfAutre *ConfAutre
                              );
    void DesallouerPointeurs22SOS(t_SD_BAS_DataThread22SOS* data22SOS
                                 );
    void AllouerPointeursImageISRFEM(t_SD_BAS_DataThreadImageISRFEM* dataImageISRFEM,
                                     t_SD_BAS_ConfAutre *ConfAutre,
                                     t_SD_BAS_BanqueSpectrale *BanqueSpectrale,
                                     t_SD_BAS_Contexte* contextecourant,
                                     int  nombreLignes
                                    );
    void DesallouerPointeursImageISRFEM(t_SD_BAS_DataThreadImageISRFEM* dataImageISRFEM
                                       );
    int Maximum(int *tableau,
                int dimension
               );
    void Traiter(t_CMN__Statut& cr_op,
                 t_SD_BAS_DataThread *ctx
                );
    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
        
};

#endif
