// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/GES/src/SD_GES_ChaineProd0_1C.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_GES
//@ CLASSE : SD_GES_ChaineProd0_1C
//@
//@ Comment :
//@    this module contains the fourth action used for the IASI OPS 
//@     L1 Processing chain level 0-1C ( multi-threaded by line)
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 10/03/2003 : P.GASSIE
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-CR-271-CN : 22/06/2005 : JL.PASCAL
//@ prise en compte du mode transition
//@ fiche de correction correspondante : IA-2100-CR-271-THA
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_GES_ChaineProd0_1C_h
#define SD_GES_ChaineProd0_1C_h


//
// Fichiers include
//

// STL

// Standard

// Projet
#include "SD_ACT_Action.h"
#include "SD_DON_GestDonnees.h"
#include "SD_BAS_Global.h"
#include "CMN__Date.h"
#include "SD_ALG_ISRFEM.h"


class SD_GES_ChaineProd0_1C : public SD_ACT_Action {

    /*================================================================*/

 public:

    ////////////////////////////////
    // Type definitions
    ////////////////////////////////

    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    SD_GES_ChaineProd0_1C(SD_TAC_Tache* tache);

    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    virtual ~SD_GES_ChaineProd0_1C();

    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////


    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    virtual void Executer();
    virtual void VerifierSymptome();


    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////


    /*================================================================*/

 private:
     
    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////
   void Corpstraitement(
				const  int numeroLigne,
				 t_Date & dateLN,
			         SD_DON_GestDonnees* gestionnaire,
  				 t_SD_BAS_Contexte* contextecourant,
 				 t_SD_BAS_DataGen  * datagen,
				 SD_DON_GestCasDeg & gestCasDeg,
				const int NbPaquetsPX,
				 t_SD_BAS_PaquetN0** ListePaquetPX,							
  				 t_SD_BAS_MPHR * Mphr1ABC,
 				 t_SD_BAS_LigneN1 * LigneMDR1ABC,
 				 t_SD_BAS_LigneN1 * LigneMDRENG,
  				 t_SD_BAS_LigneN1 * LigneVIADRENG,
  				const double BBT,
  				const double FilteredBBTLN_1,
 				 t_SD_BAS_ConfAutre *  ConfAutre ,
  				 t_SD_BAS_ConfStable * ConfStable ,
  				 t_SD_BAS_BanqueSpectrale * BanqueSpectrale ,
				 int nombreLignes,
  				 t_SD_BAS_LigneAVHRR** ListeLignesAVHRR,
  				 t_SD_BAS_DataThreadProduit* DataThreadProduit,
  				 t_SD_BAS_DataThread22SOS* data22SOS,
				 t_SD_BAS_22_SOS_Sortie * Sortie_22_SOS,
 				 t_SD_BAS_StatMphr* statMphr,
				 int modePdv,
				 t_SD_BAS_DataThread *ctx,
				 double t_scan 								
    			);
    void AllouerPointeursDataThreadProduit(t_SD_BAS_DataThreadProduit* DataThreadProduit,
                                           t_SD_BAS_ConfAutre *ConfAutre,
                                           t_SD_BAS_BanqueSpectrale *BanqueSpectrale,
                                           t_SD_BAS_Contexte* contextecourant,
					   int nombreLignes
                                          );
    void DesallouerPointeursDataThreadProduit(t_SD_BAS_DataThreadProduit* DataThreadProduit);
    void AllouerPointeurs22SOS(t_SD_BAS_DataThread22SOS* data22SOS,
                               t_SD_BAS_ConfAutre *ConfAutre
                              );
    void DesallouerPointeurs22SOS(t_SD_BAS_DataThread22SOS* data22SOS);
    int Maximum(int *tableau,
                int dimension
               );
    void FinDeTraitement1(t_SD_BAS_LigneN1* LigneMDR1ABC,
                         t_SD_BAS_LigneN1* LigneMDRENG,
                         t_SD_BAS_Contexte* contextecourant,
                         SD_DON_GestDonnees* gestionnaire,
                         t_SD_BAS_ConfStable* ConfStable,
                         t_SD_BAS_ConfAutre* ConfAutre,
                         SD_DON_GestCasDeg& gestCasDeg,
                         int numeroLigne,
                         t_SD_BAS_StatMphr* statMphr
                        );
      void FinDeTraitement2(t_SD_BAS_LigneN1* LigneMDR1ABC,
                         t_SD_BAS_LigneN1* LigneMDRENG,
                         t_SD_BAS_Contexte* contextecourant,
                         SD_DON_GestDonnees* gestionnaire,
                         t_SD_BAS_ConfStable* ConfStable,
                         t_SD_BAS_ConfAutre* ConfAutre,
                         SD_DON_GestCasDeg& gestCasDeg,
                         int numeroLigne,
                         t_SD_BAS_StatMphr* statMphr
                        );
    void Traiter(t_CMN__Statut& cr_op,
                 t_SD_BAS_DataThread *ctx
                );
//CR271
   void InitialiseTransition(
                            t_SD_BAS_ConfStable* ConfStable,
  			    SD_DON_GestDonnees* gestionnaire,
			    t_SD_BAS_LigneN1* LigneMDR1ABC,
                            t_SD_BAS_LigneN1* LigneMDRENG
                            );
    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
        
};

#endif
