static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/GES/src/SD_GES_ChaineProd1B_1C.cc,v 1.7 2014/05/14 15:41:10 lcaspar Exp $";
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_GES
//@ CLASSE : SD_GES_ChaineProd1B_1C
//@ 
//@ Comment :
//@    this module contains the fourth action used for the IASI OPS 
//@     L1 Processing chain level 1B-1C ( multi-threaded by line)
//@                                     
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 10/03/2003 : P.GASSIE
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-084-CN : 13/11/2003 : JL. PASCAL
//@ optimisation du code ( les init de fft  sont fait une fois par ligne );
//@ pour S1C
//@ fiche de correction correspondante : IA-2100-FC-084-THA
//@ --------------------------------------------------------------------
//@ DM-ID : PM4 : 31/03/2004 : B. MASSART
//@ SD_GES_ChaineProd1B_1C::Executer:
//@ -date SN=15 pour 32_HEC, 33_SME, 34_SMC
//@ -correction syntaxe N1C_IDEFCCSCHANNELID
//@ -correction syntaxe ENG_GOPSFLTISRFEMOFF
//@ SD_GES_ChaineProd1B_1C::FinDeTraitement2:
//@ -correction syntaxe ENG_GOPSDATISRFEMOFF
//@ --------------------------------------------------------------------
//@ DM-ID : IA-CR-0000-177-CNE : 31/03/2004 : B. MASSART
//@ SD_GES_ChaineProd1B_1C::FinDeTraitement1:
//@ -mise a jour de GEPSIdConf
//@ -mise a jour dimensions de N1C_GQISFLAGQUAL
//@ -mise a jour dimensions de ENG_GOPSFLTISRFEMOFF
//@ -ajout gestion CG15 et ENG_GOPSFLAGEOAVHRRMISS
//@ -gestion CG14 pour le mode calibration externe
//@ SD_GES_ChaineProd1B_1C::FinDeTraitement2:
//@ -mise a jour de GEPSIdConf
//@ --------------------------------------------------------------------
//@ PM-ID : IA-CR-0000-234-CNE : 31/03/2004 : B. MASSART
//@ SD_GES_ChaineProd1B_1C::FinDeTraitement1:
//@ -inversion logique de ENG_GQISFLAGQUAL
//@ --------------------------------------------------------------------
//@ PM-ID : IA-CR-0000-231-CNE : 31/03/2004 : B. MASSART
//@ SD_GES_ChaineProd1B_1C::FinDeTraitement1:
//@ -conversion en degres de ENG_GIAXAXEYZ, ENG_GFAXAXEYZ, ENG_GIAXAXEQUAL et
//@  ENG_GFAXAXERES
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-133-CN : 05/08/2004 : B. MASSART
//@ correction of N1C_GGEOIISLOC index in Corpstraitement 
//@ to store ENG_CGEOSUBSATELLITEPOSITION. See IA-2100-FC-133-CN.
//@ --------------------------------------------------------------------
//@ PM-ID : IA-CR-0000-242-CNE : 06/08/2004 : B. MASSART
//@ 44_GEO is now called if Cdegraded cases #9 and #15 are raised.
//@ See IA-2100-CR-242-THA.
//@ --------------------------------------------------------------------
//@ FA-ID : IA-2100-FA-151-CN : 28/01/2005 : JL PASCAL
//@ il ne faut pas executer la chaine IAC CCS si on ne vise pas la terre
//@ SP < 30 et SP > 1
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-153-CN : 29/01/2005 : JL. PASCAL
//@ calcul du champ SUBSAT_LAT et SUBSAT_LON du MPHR
//@ fiche de correction correspondante : IA-2100-FC-153-THA
//@ --------------------------------------------------------------------
//@ DM-ID : IA-2100-CR-292-CNE : 10/03/2006 : B.MASSART
//@ Function SD_ALG_AVHRR_GetSubSatLatLon is added to set up 
//@ MPHR_SUBSAT_LATITUDE/LONGITUDE_START/END fields in Level1 products.
//@ See IA-2100-CR-292-THA.
//@ --------------------------------------------------------------------
//@ DM-ID : IA-2100-CR-288-CNE : 20/03/2006 : B. GUENDE
//@ Call to SyntheseCasDegrades at the end of FinTraitement to print in trace file
//@  which cases has been encountered. See IA-2100-CR-288-THA.
//@ --------------------------------------------------------------------
//@ DM-ID : IA-2100-CR-290-CNE : 04/04/2006 : B. GUENDE
//@ Call to AjouterCasDeg to update the line counter for each CG, to add info
//@  to report file.
//@ See IA-2100-CR-290-THA.
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-182-CN : 30/08/2006 : C. MERIGUET
//@ Lever le cas degrade 15 lors d'un pb de geoloc
//@ --------------------------------------------------------------------
//@ FA-ID : IA-2100-FA-193-CN : 9/11/2006 : R.MORENO
//@ Levee de CG pour les images associees aux visees da calibration CS
//@ et BB
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-194-CN : 19/12/2006 : C.MERIGUET
//@ Plantage memoire en mode calibration externe: delete [] ImageCalibree
//@ mal place (dans if )  
//@ --------------------------------------------------------------------
//@ FA-ID : IA-2100-FA-196-CN : 15/01/2007 : C.MERIGUET
//@ FA-ID : IA-2100-FA-198-CN : 15/01/2007 : C.MERIGUET
//@ Ces 2 FA sont traitees conjointement. Recuperation du PTSI lu dans 
//@ le mot 17 (2 octets) mais ecriture dans le champ PTSI des N1 des mots 
//@ 16 (version logiciel bord) et 17 (ptsi) (4 octets).
//@ --------------------------------------------------------------------
//@ FA-ID : IA-2100-FA-202-CN : 29/01/2007 : R.MORENO
//@ CCSNbClass a 0 pour SP 34
//@ --------------------------------------------------------------------
//@ FA-ID :IA-FT-2466(FA-2100-OPS) : 30/05/2008 : S. BRUNEL
//@ Probleme de reproductibilite: SUBSAT_LATITUDE_START et 
//@ SUBSAT_LONGITUDE_START
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2525(DM-2100-OPS) : 06/03/2009 : S. BRUNEL
//@ Modification du GQisFlagQual, ajout d'informations sur la cause de
//@ la rejection (Day 2,point 6)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2526(DM-2100-OPS) : 06/03/2009 : S. BRUNEL
//@ Include les differences de NZPD interpixel dans le produit 
//@ ENG (Day 2,point 7)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2527(DM-2100-OPS) : 06/03/2009 : S. BRUNEL
//@ Permettre le calcul des spectres dans les bandes B1 & B2 meme
//@ lorsque un spike affecte la bande B3 (Day 2,point 8)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2521(DM-2100-OPS) : 27/04/2009 : S. BRUNEL
//@ Calcul de 4 pseudo-canaux AVHRR (Day 2, point 2)
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2600(FA-2100-OPS) : 24/04/2009 : S. BRUNEL
//@ Mise a 0 des spectres dans la bande du ZPD lorsqu'un spike 
//@ est observe dans la bande du ZPD
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2609(DM-2100-OPS) : 30/05/2009 : S. BRUNEL
//@ Suppression temporaire de la mise a 0 des spectres dans la 
//@ bande de determination du ZPD
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2638(FA-2100-OPS) : 17/06/2009 : S. BRUNEL
//@ Valeurs erronees de MHipNZpdInterPixel pour les SN 32,33, 35 et 36
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2642(FA-2100-OPS) : 23/06/2009 : S. BRUNEL
//@ Pas de mise a 0 des spectres lors de l'utilisation des 
//@ chaines intermediaires
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2650(FA-2100-OPS) : 08/07/2009 : S. BRUNEL
//@ Valeur erronnee des flags internes de l'OPS (GOPSXxxxXxxx)
//@ en entree de 45_QIS
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2652(DM-2100-OPS) : 08/07/2009 : S. BRUNEL
//@ Suppression des verrous temporaires assurant la non regression
//@ entre V4-2-5 et V4-2
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2656(FA-2100-OPS) : 02/09/2009 : S. BRUNEL
//@ Variation aleatoire des variables DATA_Px et GCcsAvhrrPseudoChn
//@ dans les produits ENG
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2667(DM-2100-OPS) : 06/10/2009 : S. BRUNEL
//@ Suppression de la mise a 0 des spectres en B3 lorsque un spike affecte la bande B3
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2751(FA-2100-OPS) : 06/04/2010 : S.BRUNEL
//@ Probleme de reproductibilite sur les variables 
//@ SUBSAT_XXXX_START et SUBSAT_XXXX_END
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2997(DM-2100-OPS) : 21/06/2012 : L. CASPAR
//@ Sortie de calcoffset de 41_CCS, pour l'ajouter dans la chaine de traitement  
//@ entre 40_IAC et 41_CCS. Adaptation de l'appel a 44_GEO
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-3047(FA-2100-OPS) : 19/09/2012 : L. CASPAR
//@ Suppression des traces "Date de la ligne" dans SD.log (log trop gros sinon)
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-3068(FA-2100-OPS) : 19/12/2012 : L. CASPAR
//@ Calcul des offsets Sond-IIS et Sond-Avhrr : Changement de l'indice permettant
//@ de récupérer les dates AvhrrDatBefore et AvhrrDatAfter (SP => sn)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-3150(DM-2100-OPS) : 24/04/2014 : M. PENZES
//@ Ajout de variables et de condition pour les count_degraded_xxx_mdr  
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------


//
// Fichiers include
//

// STL
#include <iostream>

// Standard

// Projet
#include "CMN__Commun.h"
#include "CMN__Chaine.h"

#include "SD_TAC_Tache.h"
#include "SD_GES_ChaineProd1B_1C.h"
#include "SD_FRW_ApplicationServeurDonnees.h"
#include "SD_ALG_Image.h"
#include "SD_ALG_Spectre.h"
#include "SD_ALG_Monitoring.h"
#include "SD_ALG_AVHRR.h"

/*====================================================================*/
//    define  Declarations
/*====================================================================*/
// marge rajoutee en fin de chaque allocation
#define SD_GES_MARGE                          100 
//======================================================================
//                                       METHODES PUBLIQUES 
//======================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : SD_GES_ChaineProd1B_1C
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               (ENTREE) tache : Tache pere de l'action
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_GES_ChaineProd1B_1C::SD_GES_ChaineProd1B_1C(SD_TAC_Tache* tache) 
  : SD_ACT_Action(tache)
{
  //@ Memoriser la tache parente de l'action
  m_Tache = tache;
  m_PeutEtreEnchainee = CMN__FAUX;
}


//@ ------------------------------------------------------------------*/
//@ Methode : ~SD_GES_ChaineProd1B_1C
//@
//@ Description : Destructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_GES_ChaineProd1B_1C::~SD_GES_ChaineProd1B_1C()
{
}


//@ ------------------------------------------------------------------*/
//@ Methode : Executer
//@
//@ Description : Traitement principal de l'action
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_GES_ChaineProd1B_1C::Executer()
{
  t_CMN__Statut cr_op = CMN__STATUT_OK;
  t_Date dateTmp;
  //@ Methode virtuelle surchargee pour executer la chaine produit 
  cout << "SD_GES_ChaineProd1B_1C pour la tache " << Tache()->Id() 
       << endl;

  //@ principes generaux a appliquer :
  //@ 0 - on considere que l'initialisation des traces a ete faite au prealable
  //@     dans  InitGranule, la structure t_SD_BAS_DataGen est passe aux 
  //@ algorithmes qui emettent eux meme leur traces
  //@ 1 - c'est a ce niveau que sont emis les messages au JdBS (  
  //@    trace  applicatives a partir de la structure t_SD_BAS_DataThread )
  //@  via : la remontee d'erreurs des algo
  //@ 2 - la memoire utilisee est de 2 type :
  //@   - partagee entre thread elle a alors ete allouee au prealable 
  //@   - locale au traitement, elle est alors allouee en debut puis liberee
  //@     en fin de methode 

  //@ recuperer le serveur de donnees reference dans application serveur de donnee/
  SD_FRW_ApplicationServeurDonnees* application;
  application = m_Tache->Application();

  //@ recuperer le numero de ligne a traiter
  int numeroLigne;
  int numeroLigneGES; //dans DON les numeros commencent a 0, sauf pour GestCasDeg
  numeroLigne = m_Tache->Contexte()->IndiceLigne();
  numeroLigneGES = numeroLigne - 1;
  SD_DON_GestDonnees* gestionnaire = application->Donnees();


  //@ SI le contexte indique l'envoi de la telemesure SensingTime
  if (m_Tache->Contexte()->SignalerTemps() == CMN__VRAI)
    {
      //@ Appel de la methode SD_DON_GestDonnees::GetSensingTime()
      t_TableauDate sensingTime;
      gestionnaire->GetSensingTime(numeroLigneGES, sensingTime);

      //@ Envoyer la telemesure SensingTime
      EnvoyerSensingTime(sensingTime);
    }
  //@ FIN SI

  //@----------------------------------------------------------------------*/
  //@ recuperer les donnees temporaire globales initialisees */
  //@ appel GetDonGenGranule 
  //@ contexte + donnes generale YY_CONF
  //@----------------------------------------------------------------------*/
  t_SD_BAS_Contexte* contextecourant;
  t_SD_BAS_DataGen  * datagen ;
  gestionnaire->GetDonGenGranule(&contextecourant, &datagen);
  //@ Recuperation du gestionniare des cas degrades
  SD_DON_GestCasDeg gestCasDeg = gestionnaire->GetGestCasDeg();
// recuperer le nombre de lignes du granule
  int nombreLignesIASI = gestionnaire->GetNbLignesIASI();
  
  //@ recuperer les donnees de niveau 1 initialisees pour la ligne N
  //@ 1ABC
  t_SD_BAS_MPHR * Mphr1ABC;
  t_SD_BAS_LigneN1 * LigneMDR1ABC;
  t_SD_BAS_LigneN1 * LigneVIADR1ABC;
  Mphr1ABC        = new t_SD_BAS_MPHR;
  LigneMDR1ABC    = new t_SD_BAS_LigneN1;
  LigneVIADR1ABC  = new t_SD_BAS_LigneN1;
  gestionnaire->GetLigneS1(
    numeroLigneGES, 
    SD_DON_GranuleN1::SD_DON_GRANULE_N1_DATA, 
    *Mphr1ABC, 
    *LigneMDR1ABC, 
    *LigneVIADR1ABC);

  // FT-2638
  //@ VER
  t_SD_BAS_MPHR * MphrVER;
  t_SD_BAS_LigneN1 * LigneMDRVER;
  t_SD_BAS_LigneN1 * LigneVIADRVER;
  MphrVER          = new t_SD_BAS_MPHR;
  LigneMDRVER      = new t_SD_BAS_LigneN1;
  LigneVIADRVER    = new t_SD_BAS_LigneN1;
  gestionnaire->GetLigneS1(
    numeroLigneGES,
    SD_DON_GranuleN1::SD_DON_GRANULE_N1_VER,
    *MphrVER,
    *LigneMDRVER,
    *LigneVIADRVER);
  // ...FT-2638

  //@ ENG
  t_SD_BAS_MPHR * MphrENG;
  t_SD_BAS_LigneN1 * LigneMDRENG;
  t_SD_BAS_LigneN1 * LigneVIADRENG;
  MphrENG        = new t_SD_BAS_MPHR;
  LigneMDRENG    = new t_SD_BAS_LigneN1;
  LigneVIADRENG  = new t_SD_BAS_LigneN1;  
  gestionnaire->GetLigneS1(
    numeroLigneGES, 
    SD_DON_GranuleN1::SD_DON_GRANULE_N1_ENG, 
    *MphrENG, 
    *LigneMDRENG, 
    *LigneVIADRENG);
  
// cas des DMDR
if (LigneMDRENG->TypeRec != MDR_DUMMY)
 {
   double BBT;
  t_SD_BAS_SCDSTime dateLigneLN_1;
  
  //@ SI pas premiere ligne 
  if(numeroLigne > 1)
  {
    //@ recuperer les donnees de niveau 1 initialisees pour la ligne N-1
    //@ ENG
    t_SD_BAS_MPHR * MphrENGPrec;
    t_SD_BAS_LigneN1 * LigneMDRENGPrec;
    t_SD_BAS_LigneN1 * LigneVIADRENGPrec;
    MphrENGPrec        = new t_SD_BAS_MPHR;
    LigneMDRENGPrec    = new t_SD_BAS_LigneN1;
    LigneVIADRENGPrec    = new t_SD_BAS_LigneN1;
    gestionnaire->GetLigneS1(
      numeroLigneGES - 1, 
      SD_DON_GranuleN1::SD_DON_GRANULE_N1_ENG, 
      *MphrENGPrec, 
      *LigneMDRENGPrec, 
      *LigneVIADRENGPrec);

    //@ on initialise date ligne LN-1
    /* DM 11/03/2004 pt 1.17 pour 32_HEC, 33_SME, 34_SMC */
    dateLigneLN_1.day = LigneMDRENGPrec->InfoDet.tab_var[ENG_GEPSDATIASI].val.pdate[IND1(SD_BAS_SNREFDATELIGNE)].day;
    dateLigneLN_1.millis = LigneMDRENGPrec->InfoDet.tab_var[ENG_GEPSDATIASI].val.pdate[IND1(SD_BAS_SNREFDATELIGNE)].millis;
    
    //@ on initialise le BBT avec le BBT de la ligne N-1
    BBT = LigneMDRENGPrec->InfoDet.tab_var[ENG_BIMSBBT].val.pr8[0];
    delete MphrENGPrec;
    delete LigneMDRENGPrec;
    delete LigneVIADRENGPrec;
   }
  //@ SINON
  else
  {
    //@ on initialise date ligne LN-1 avec  le contexte
    dateLigneLN_1.day = contextecourant->GEPSDatIASI[0].day;
    dateLigneLN_1.millis = contextecourant->GEPSDatIASI[0].millis;
    //@ on recupere le  BBT et la date a partir du contexte
    BBT = contextecourant->BIMSBBT[0];
  }
  //@ FIN SI
  //@ recuperer les donnees de configuration en fonction du PTSI
// FA 196 et 198
   // inversion de mots
  int version_log = (int)(LigneMDRENG->InfoDet.tab_var[ENG_PTSI].val.pui4[0]/65536);
  int PTSI = LigneMDRENG->InfoDet.tab_var[ENG_PTSI].val.pui4[0] - (version_log * 65536);
 // int PTSI = (int)(LigneMDRENG->InfoDet.tab_var[ENG_PTSI].val.pui4[0]/65536);
// ..FA 196 et 198

  //@ appel GetConf
  t_SD_BAS_ConfAutre *  ConfAutre ;
  t_SD_BAS_ConfStable * ConfStable ;
  t_SD_BAS_BanqueSpectrale * BanqueSpectrale ;
  t_Date datePremiereLigne;
  datePremiereLigne.SCDSTime(LigneMDRENG->InfoDet.tab_var[ENG_DATEDEB].val.pdate[0]);
  gestionnaire->GetConf(PTSI, datePremiereLigne, &ConfAutre, &ConfStable, &BanqueSpectrale);
  
  //@ Initialiser l'intervalle des nombres d'onde du produit 1C
  *LigneMDR1ABC->InfoDet.tab_var[N1C_IDEFNSFIRST1B].val.pi4 = 
    ConfAutre->IDefNsfirst1b;
  *LigneMDR1ABC->InfoDet.tab_var[N1C_IDEFNSLAST1B].val.pi4  = 
    ConfAutre->IDefNslast1b;
  
  //@ Recopie des donnees de conf */
  // FT-2765
  *LigneMDR1ABC->InfoDet.tab_var[N1C_IDEFSPECTDWN1B].val.pi4 = 
    static_cast<int>(ConfAutre->IDefSpectDWn1b);
  // ...FT-2765
  for (int i = 0; i < SD_BAS_COVAR_DIM * SD_BAS_CCD; i++)
  {
    LigneMDR1ABC->InfoDet.tab_var[N1C_IDEFCOVARMATEIGENVAL1C].val.pr8[i] = 
      ConfAutre->IDefCovarMatEigenVal1c[i];
  }
  for (int i = 0; i < SD_BAS_NBK; i++)
  {
    LigneMDR1ABC->InfoDet.tab_var[N1C_IDEFCCSCHANNELID].val.pui4[i] = 
      ConfAutre->IDefCcsChannelId[i];
  }
  *LigneMDR1ABC->InfoDet.tab_var[N1C_IDEFCCSMODE].val.pui4 = 
    ConfAutre->IDefCcsMode;
  
  //@  recuperation de la date de l'eclipse precedente la ligne N-1 a partir
  //@ de la date UTC
  t_Date dateEclipse_1;
  t_Date dateEclipse;
  t_Date datePrec;
  t_Date dateLN;
  datePrec.SCDSTime(dateLigneLN_1);
  dateLN.SCDSTime(LigneMDRENG->InfoDet.tab_var[ENG_DATEDEB].val.pdate[0]);
  dateEclipse_1 = gestionnaire->GetDateEclipse(datePrec);
  dateEclipse = gestionnaire->GetDateEclipse(dateLN);
// maj date eclipse dans le produit
 ((LigneMDRENG->InfoDet).tab_var[ENG_GEPSENDECLIPSETIME].val.pdate)->day=dateEclipse_1.SCDSTime().day;
 ((LigneMDRENG->InfoDet).tab_var[ENG_GEPSENDECLIPSETIME].val.pdate)->millis=dateEclipse_1.SCDSTime().millis;
  
  //@ recuperation des indices lignes disponible entre TSN - marge
  //@ et TSN + marge  
  t_Date dateDebutLigne;
  t_Date dateFinLigne;
  t_Date dateMilieuLigne;
  dateDebutLigne.SCDSTime(LigneMDRENG->InfoDet.tab_var[ENG_DATEDEB].val.pdate[0]);
  dateFinLigne.SCDSTime(LigneMDRENG->InfoDet.tab_var[ENG_DATEFIN].val.pdate[0]);
  dateMilieuLigne.ConvertirTempsEnDate((dateDebutLigne.ConvertirDateEnTemps() + dateFinLigne.ConvertirDateEnTemps())/2.);
  t_Date date_t0;
  t_Date date_t1;
  date_t0.ConvertirTempsEnDate(dateMilieuLigne.ConvertirDateEnTemps()
            - ConfStable->IDefAvhrrMarginBefore * SD_BAS_AVHRR_LINE_PERIOD / 1000.);
  date_t1.ConvertirTempsEnDate(dateMilieuLigne.ConvertirDateEnTemps()
            + ConfStable->IDefAvhrrMarginAfter * SD_BAS_AVHRR_LINE_PERIOD / 1000.);
            
  //@ recuperer les donnees AVHRR en fonction des dates  de la ligne avec une marge 
  //@ une liste  de pointeurs est ici retournee
  //@ definition du nombre de lignes AVHRR (avec une marge)
  int nombreLignesMax = ConfStable->IDefAvhrrMarginBefore + ConfStable->IDefAvhrrMarginAfter + 1;
  int nombreLignes = gestionnaire->GetNbLignesAVHRR(date_t0, date_t1);
  t_SD_BAS_LigneAVHRR** ListeLignesAVHRR;
  ListeLignesAVHRR = new t_SD_BAS_LigneAVHRR*[nombreLignes];
  gestionnaire->GetBandeauAVHRR(date_t0,
                                date_t1,  
                                numeroLigneGES,
                                1,  // car pas d'info SN
                                gestCasDeg,
                                nombreLignesMax,
                            				nombreLignes,
                                ListeLignesAVHRR);
  //@ SI (CG9) positionne sur SN = 1
  if(gestCasDeg.GetCasDegLigne(numeroLigne)->IsDetecte(9, 0, 0, 0, dateTmp))
  {
    //@ alors on le positionne sur tous les SN de la ligne
    //@ car pas d'info SN pour GetBandeauAVHRR
    // pour mettre a jour la date
    gestCasDeg.GetCasDegLigne(numeroLigne)->SetDetecte(9, dateMilieuLigne, 10, 0, 0, true);
    for(int sn = 1; sn < SD_BAS_SNOT; sn++)
    {
      gestCasDeg.GetCasDegLigne(numeroLigne)->SetDetecte(9, dateTmp, sn, 0, 0, false);
    }
  }
  //@ allocation pointeurs dans   t_SD_BAS_DataThreadProduit (ft interne)
  t_SD_BAS_DataThreadProduit* DataThreadProduit;
  DataThreadProduit = new t_SD_BAS_DataThreadProduit;
  AllouerPointeursDataThreadProduit(DataThreadProduit,
                                    ConfAutre,
                                    BanqueSpectrale,
                                    contextecourant,
				    nombreLignesIASI);
  //@ allocation StatMphr
  t_SD_BAS_StatMphr* statMphr;
  statMphr = new t_SD_BAS_StatMphr;
  //  initialisations
  statMphr->subsat_latitude_start =0;
  statMphr->subsat_longitude_start =0;
  statMphr->subsat_latitude_end =0;
  statMphr->subsat_longitude_end = 0;
  //@ remplissage t_SD_BAS_22_SOS_Sortie
  t_SD_BAS_22_SOS_Sortie * Sortie_22_SOS = new t_SD_BAS_22_SOS_Sortie;
  int surechFFT       = ConfAutre->IDefS1bOSFftFactor;
  int surechSpline    = ConfAutre->IDefS1bOSSplineFactor;
  int Nfirst          = ConfAutre->IDefNsfirst[SD_BAS_B1];
  int Nlast           = ConfAutre->IDefNslast[SD_BAS_B3];
  int Factor          = surechFFT * surechSpline;
  double deltanu         = ConfAutre->IDefSpectrDWn;
  Sortie_22_SOS->GSosSsdOSFActor = Factor ;
  Sortie_22_SOS->GSosSsdOSNsLastSpect = Factor * (Nlast - 1) + 1;
  Sortie_22_SOS->GSosSsdOSNsFirstSpect = Factor * (Nfirst - 1) + 1;
  Sortie_22_SOS->GSosSsdDWnOSSpect = (double)deltanu/(double)Factor;
  //@ initialisation ctx
  t_SD_BAS_DataThread *ctx;
  ctx = new t_SD_BAS_DataThread;
  ctx->ctxtrt.LN=0;
  ctx->ctxtrt.SN=0;
  ctx->ctxtrt.PN=0;
  ctx->ctxtrt.CCD=0;
  ctx->ctxtrt.SB=0;
  ctx->ctxtrt.Thread=0;
  ctx->ctxtrt.LN = numeroLigne;
  InitialiserCompteRendu(&(ctx->cr));
// initialisation pour diminuer la taille de la pile metop
 ctx->ptmsg = new t_SD_BAS_MetopMSG[256];

  //@ determination du mode de prise de vue
  int modePdv = LigneMDR1ABC->InfoDet.tab_var[N1C_MODE].val.pui4[0];
  //@ SI pas ( CG2 ou CG12 )
  if(!gestCasDeg.GetCasDegLigne(numeroLigne)->IsDetecte(12, 0, 0, 0, dateTmp)
      && !gestCasDeg.GetCasDegLigne(numeroLigne)->IsDetecte(2, 0, 0, 0, dateTmp))
  {
    t_CMN__Booleen  * flag_date_NOK= new t_CMN__Booleen[1];
    //@POUR chaque direction de coin de cube ( de 1 ,2 )
    for(int ccd = 0; ccd < SD_BAS_CCD; ccd++)
    {
      ctx->ctxtrt.CCD = ccd;
      //@ POUR chaque pixel ( de 1 a 4 )
      for(int pn = 1; pn <= SD_BAS_PN; pn++)
      {
        ctx->ctxtrt.PN = pn;
        //@ Interpolation de la banque spectrale (A1343)
        //@ Call 43_ISF
        cr_op = SD_ALG_43_ISF(ctx,
                              DataThreadProduit,
                              BanqueSpectrale,
                              ConfAutre,
                              &(LigneMDRENG->InfoDet),
                              &(LigneMDR1ABC->InfoDet));
        //@ traitement du compte-rendu
        Traiter(cr_op, ctx);
    //@  Call XX_INI
       cr_op = SD_ALG_XX_Initprod(ctx, 
                               ConfAutre,
                               BanqueSpectrale,
                               DataThreadProduit, 
                               Sortie_22_SOS, 
                               dateLigneLN_1, 
                               dateEclipse_1.SCDSTime(), 
                               BBT, 
                               flag_date_NOK);
    //@ traitement du compte-rendu
       Traiter(cr_op, ctx);
  //@     appel InfoCalcisp
      }
      //@ FIN POUR chaque pixel
    }
    //@ FIN POUR chaque direction de coin de cube 
      ctx->ctxtrt.CCD = 0;
      ctx->ctxtrt.PN = 0;
    delete [] flag_date_NOK;

    // FT-2650
    // Mise a jour des flags internes GOPS en fonction des Cas degrades
    // avant l'appel de 45_QIS. Le traitement effectues provient de 
    // FinTraitement1() en fin de chaine produit.
    for (int sn = 0; sn < SD_BAS_SNOT; sn++)
    {
      for (int pn = 0; pn < SD_BAS_PN; pn++)
      {
        //@ CG1
        if(gestCasDeg.GetCasDegLigne(numeroLigne)->GetFlt(1).flag[sn][pn][0])
        {
          LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLAPIXMISS].val.pui4[sn*SD_BAS_PN+pn] = 1;
        }
        //@ CG4
        for (int sb = 0; sb < SD_BAS_SB; sb++)
        {
          if(gestCasDeg.GetCasDegLigne(numeroLigne)->GetFlt(4).flag[sn][pn][sb])
          {
            LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLTBANDMISS].val.pui4[sn] = 1;
          }
        }
      }
      //@ CG3
      for (int ccd = 0; ccd < SD_BAS_CCD; ccd++)
      {
        if (gestCasDeg.GetCasDegLigne(numeroLigne)->GetFlt(3).flag[sn][0][ccd])
        {
          LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLTISRFEMOFF].val.pui4[sn] = 1;
        }
      }
      //@ CG6
      if (gestCasDeg.GetCasDegLigne(numeroLigne)->GetFlt(6).flag[sn][0][0])
      {
        LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLTIMGEWMISS].val.pui4[sn] = 1;
      }
    }
    // ...FT-2650

    // FT-2526
    //@ Calcul les differences de NZPD interpixel
    cr_op = SD_ALG_46_HIP(
                          ctx,
                          ConfStable,
                          // FT-2638
                          LigneMDRVER->InfoDet2,
                          // ...FT-2638
                          &LigneMDRENG->InfoDet
                          );
    // ...FT-2526

// realisation du corps du traitement image  pour une ligne dans une fonction specifique
  Corpstraitement(
		numeroLigne,
		dateLN,
		gestionnaire,
  		contextecourant,
 		datagen,
		gestCasDeg,
  		Mphr1ABC,
 		LigneMDR1ABC,
 		LigneMDRENG,
 		ConfAutre ,
  		ConfStable ,
  		BanqueSpectrale ,
		nombreLignes,
  		ListeLignesAVHRR,
  		DataThreadProduit,
 		statMphr,
		modePdv,
		ctx
    		);

 

    //@ calcul flag et indices de qualite
    //@ Call 45_QIS
    // FT-2525
    cr_op = SD_ALG_45_QIS(ctx,
                          ConfStable,
                          ConfAutre,
                          &LigneMDRENG->InfoDet,
                          &LigneMDR1ABC->InfoDet);
    // ...FT-2525
    //@ traitement du compte-rendu
    Traiter(cr_op, ctx);
  }
  //@ FIN SI
// realisation de la fin  de traitement (partie 1)
  FinDeTraitement1(LigneMDR1ABC,
                  LigneMDRENG,
                  contextecourant,
                  gestionnaire,
                  ConfStable,
                  ConfAutre,
                  gestCasDeg,
                  numeroLigne,
                  statMphr);
// realisation de la fin  de traitement (partie 2)
  FinDeTraitement2(LigneMDR1ABC,
                  LigneMDRENG,
                  contextecourant,
                  gestionnaire,
                  ConfStable,
                  ConfAutre,
                  gestCasDeg,
                  numeroLigne,
                  statMphr);

  //@ liberation pointeurs dans   t_SD_BAS_DataThreadProduit
  DesallouerPointeursDataThreadProduit(DataThreadProduit);
  delete DataThreadProduit;
  //@ liberation pointeurs dans   t_SD_BAS_Data22SOS
  delete [] ListeLignesAVHRR;
  delete Sortie_22_SOS;
  delete statMphr;
  delete [] ctx->ptmsg;
  delete ctx;  
  }
// fin cas des DMDR
   delete Mphr1ABC;
  delete LigneMDR1ABC;
  delete LigneVIADR1ABC;
  delete MphrENG;
  delete LigneMDRENG;
  delete LigneVIADRENG;
  // FT-2638
  delete MphrVER;
  delete LigneMDRVER;
  delete LigneVIADRVER;
  // ...FT-2638

//@Fin SI


  //@ Invoquer la verification des symptomes une fois l'action
  //@ executee
  VerifierSymptome();
}


//@ ------------------------------------------------------------------*/
//@ Methode : VerifierSymptome
//@
//@ Description : Verifie si les symptomes associes a l'action sont
//@               en erreur ou non
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_GES_ChaineProd1B_1C::VerifierSymptome()
{
  //@ Methode virtuelle a surcharger dans les classes derivees
  //@ Les symptomes controles sont specifiques a l'action
        
  m_PeutEtreEnchainee = CMN__VRAI;
}


//======================================================================
//                                      METHODES PRIVEES 
//======================================================================
//@ ------------------------------------------------------------------*/
//@ Methode : Corpstraitement
//@
//@ Description : algorithme principal de l'action
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_GES_ChaineProd1B_1C::Corpstraitement(
				const  int numeroLigne,
				 t_Date & dateLN,
			         SD_DON_GestDonnees* gestionnaire,
  				 t_SD_BAS_Contexte* contextecourant,
 				 t_SD_BAS_DataGen  * datagen,
				 SD_DON_GestCasDeg & gestCasDeg,
  				 t_SD_BAS_MPHR * Mphr1ABC,
 				 t_SD_BAS_LigneN1 * LigneMDR1ABC,
 				 t_SD_BAS_LigneN1 * LigneMDRENG,
 				 t_SD_BAS_ConfAutre *  ConfAutre ,
  				 t_SD_BAS_ConfStable * ConfStable ,
  				 t_SD_BAS_BanqueSpectrale * BanqueSpectrale ,
				 int nombreLignes,
  				 t_SD_BAS_LigneAVHRR** ListeLignesAVHRR,
  				 t_SD_BAS_DataThreadProduit* DataThreadProduit,
 				 t_SD_BAS_StatMphr* statMphr,
				 int modePdv,
				 t_SD_BAS_DataThread *ctx
    			)
{
  t_CMN__Statut cr_op = CMN__STATUT_OK;
  t_Date dateTmp;

    //@ reservation tableaux temporaires spectre ( 1B ,1C)
    double *S1bSpect;
    int Nsfirst1b = ConfAutre->IDefNsfirst1b;
    int Nslast1b = ConfAutre->IDefNslast1b;
    S1bSpect = new double[Nslast1b - Nsfirst1b + 1 + SD_GES_MARGE];
    double *S1cSpect;
    S1cSpect = new double[Nslast1b - Nsfirst1b + 1 + SD_GES_MARGE];
    // FT-2527
    // FT-2521
    double *tmp2Spect[SD_BAS_PN];
    int tmp2SpectLen = Nslast1b - Nsfirst1b + 1 + SD_GES_MARGE;
    tmp2Spect[0] = new double[tmp2SpectLen]; // PN1
    tmp2Spect[1] = new double[tmp2SpectLen]; // PN2
    tmp2Spect[2] = new double[tmp2SpectLen]; // PN3
    tmp2Spect[3] = new double[tmp2SpectLen]; // PN4
    // ...FT-2521
    // ...FT-2527
    // FA 194 : declaration + init ici.
    double * imageCalibree;
    imageCalibree = new double[SD_BAS_IMLI * SD_BAS_IMCO + SD_GES_MARGE];
    // FT-2527
    int ZpdBzpd   = ConfAutre->IDefZpdBzpd;   // Spectral band ID for NZPD determination
    unsigned int  GOPSFlagSpikNZpdBzpd;       //@ flag de spike dans la bande de determination du NZPD
    unsigned int  BSpkFlagSpikB1;             //@ flag BSpkFlagSpik for band B1
    unsigned int  BSpkFlagSpikB2;             //@ flag BSpkFlagSpik for band B2
    unsigned int  BSpkFlagSpikB3;             //@ flag BSpkFlagSpik for band B3
    unsigned int  BSpkFlagSpikZpdBzpd;        //@ flag BSpkFlagSpik for band ZpdBzpd
    unsigned int  BZpdFlagNZpdNonQual;    
    unsigned int  BArcFlagCalSpectNonQualB1;
    unsigned int  BArcFlagCalSpectNonQualB2;
    unsigned int  BArcFlagCalSpectNonQualB3;
    // ...FT-2527

  // FT-2997
  double                OffsetSondIIS[SD_BAS_DEUX*SD_BAS_PN*SD_BAS_SNOT];   // double( SD_BAS_DEUX * SD_BAS_PN * SD_BAS_SNOT)
  double                OffsetSondAvhrr[SD_BAS_DEUX*SD_BAS_PN*SD_BAS_SNOT]; // double( SD_BAS_DEUX * SD_BAS_PN * SD_BAS_SNOT)
  double                OffsetIISAvhrrRI[SD_BAS_DEUX]; // double(SD_BAS_DEUX)
  int                   FlagDateNOK;                                        // int(1)
  int                   AvhrrLinDeb;         // Premiere ligne avhrr
  int                   AvhrrLinFin;         // Derniere ligne avhrr
  int                   AvhrrColDeb;         // premiere colonne avhrr
  int                   AvhrrColFin;         // Derniere colonne avhrr
  double         		datetmp;      		 // Date temporaire
  int volatile   		il;           		 // index lignes
  int volatile   		ic;           		 // index colonnes
  int                   SP;                  // Scan position
  double                AvhrrDatBefore;      // double(1)
  double                AvhrrDatAfter;       // double(1)
  int					CalcOffsetMode; 	 // flag indiquant s'il faut utiliser les donnes AVHRR
  int 					Ipsf;
  int					pix_1_2;
  // ...FT-2997

    // initialisation des images
    for (int i = 0;i<SD_BAS_IMLI * SD_BAS_IMCO +SD_GES_MARGE ;i++)
    {
      imageCalibree[i]=0;
    }
    // .. FA 194
    // initialisation des spectres
    for (int i = 0;i<Nslast1b - Nsfirst1b + 1 + SD_GES_MARGE ;i++)
    {
    	S1bSpect[i]=0;
    	S1cSpect[i]=0;
    }
    
    int SNmin;
    int SNmax;
    //@ SI modePdv = external_calibration
    if(modePdv == 1)
    {
      //@ SNmin = 3 et SNmax = 29
      SNmin = 3;
      SNmax = 29;
    }
    //@ SINON (mode normal ou auxiliary)
    else
    {
      //@ SNmin = 1 et SNmax = 30
      SNmin = 1;
      SNmax = 30;
    }
    //@ FIN SI
    //@ POUR chaque sous-cycle de la ligne ( de 1 a 30 ou 3 a 29 )
    for(int sn = SNmin; sn <= SNmax; sn++)
    {  
//FA151
      int sp=0;
      sp=LigneMDRENG->InfoDet.tab_var[ENG_SCAN_POSITION].val.pui4[0];
      ctx->ctxtrt.SN = sn;
      t_SD_BAS_ORIGINE numlignesnpn;
      numlignesnpn.LN = numeroLigne;
      numlignesnpn.SN = sn;
      //@ POUR chaque pixel ( de 1 a 4 )
      for(int pn = 1; pn <= 4; pn++)
      {
        ctx->ctxtrt.PN = pn;

        // ..FT-2527
        cr_op = sub_45_QIS(
                ctx, 
                ConfStable, 
                ConfAutre, 
                &LigneMDRENG->InfoDet, 
                sn, 
                pn, 
                &GOPSFlagSpikNZpdBzpd,
                &BSpkFlagSpikB1,
                &BSpkFlagSpikB2,
                &BSpkFlagSpikB3,
                &BSpkFlagSpikZpdBzpd,
                &BZpdFlagNZpdNonQual,
                &BArcFlagCalSpectNonQualB1,
                &BArcFlagCalSpectNonQualB2,
                &BArcFlagCalSpectNonQualB3        
                );

        //@ deCodage du spectre dans le produit 1B
        //@ appel EncodeDecodeLigneS1 
        numlignesnpn.PN = pn;
        gestionnaire->EncodeDecodeLigneS1(
          numlignesnpn, 
          *LigneMDR1ABC,
          AT_1B, 
          *ConfStable,
          DECODE,
          *S1bSpect);

        //@ SI pas (CG1)
        if(!gestCasDeg.GetCasDegLigne(numeroLigne)->IsDetecte(1, sn - 1, pn - 1, 0, dateTmp))
        {
          //@ Apodisation du spectre
          //@ Call 37_S1C
          cr_op = SD_ALG_37_S1C(ctx, 
                              BanqueSpectrale,
                              ConfAutre,
                              DataThreadProduit,
                              S1bSpect,
                              S1cSpect);
          //@ traitement du compte-rendu
          Traiter(cr_op, ctx);

          // FT-2521
          memcpy((void *)tmp2Spect[IND1(pn)],(const void *)S1cSpect, tmp2SpectLen * sizeof(double)); 
          // ...FT-2521

          // FT-2667
          // Suppression de la mise a zero du spectre
          if (GOPSFlagSpikNZpdBzpd == CMN__OUI)
          {
    		std::cout << "GOPSFlagSpikNZpdBzpd=" << GOPSFlagSpikNZpdBzpd << " ligneDPS=" <<
                 LigneMDRENG->InfoDet.tab_var[ENG_DATA_PX].val.pui4[14*SD_BAS_PN*SD_BAS_SNOT + IND2(pn,sn,SD_BAS_PN)]<<
                 " SN=" << sn << " PN=" << pn << std::endl;
          }
          // ...FT-2667

          //@ Codage du spectre dans le produit 1C
          //@ appel EncodeDecodeLigneS1
          gestionnaire->EncodeDecodeLigneS1(
            numlignesnpn, 
            *LigneMDR1ABC,
            AT_1C, 
            *ConfStable,
            ENCODE,
            *S1cSpect);
        }
        //@ FIN SI
      }
      //@ FIN POUR chaque pixel 
      ctx->ctxtrt.PN = 0;

      // FA 194 : deplacement declaration + alloc de imageCalibree en debut de traitement

       //@ Decodage de l'image a partir du produit 1A
        gestionnaire->EncodeDecodeLigneS1(
          numlignesnpn, 
          *LigneMDR1ABC,
          AT_IMAGE,
          *ConfStable,
          DECODE,
          *imageCalibree);
     // FA 202
     if( ((sp<=30) && (sp>0)) || (sp==34))
     // .. FA 202
       {
      //@ SI pas ( CG9 ) et pas ( CG6 ) et IDefCcsMode = 0
      if(!gestCasDeg.GetCasDegLigne(numeroLigne)->IsDetecte(9, 0 , 0, 0, dateTmp)
         && !gestCasDeg.GetCasDegLigne(numeroLigne)->IsDetecte(6, sn - 1, 0, 0, dateTmp)
         && ConfAutre->IDefCcsMode == 0)
         
      {
 
        //@ corregistration Imageur / AVHRR 
        //@ Call 40_IAC
        cr_op = SD_ALG_40_IAC(ctx,
                              DataThreadProduit,
                              contextecourant,
                              ConfAutre,
                              ConfStable,
                              Mphr1ABC,
                              imageCalibree,
                              ListeLignesAVHRR,
                              nombreLignes,
                              &LigneMDRENG->InfoDet);
        //@ traitement du compte-rendu
        Traiter(cr_op, ctx);
        //FA160
        if(cr_op != CMN__STATUT_OK)
        {
           //@ SI erreur alors l'offset n'a pas ete calcule et on leve CG15 pour ne pas passer dans CCS et GEO ??
           gestCasDeg.GetCasDegLigne(numeroLigne)->SetDetecte(15, dateLN, sn-1, 0, 0);
        }
        //..FA160
      }
      //@ SINON
      else
      { 
        //@ on prend  offset estime dans le fichier de conf
        LigneMDRENG->InfoDet.tab_var[ENG_GIACOFFSETIISAVHRR].val.pr8[2 * IND1(sn) + 0] 
                  = ConfAutre->IDefIISAVHRROffsetGuess[2 * IND1(sn) + 0];
        LigneMDRENG->InfoDet.tab_var[ENG_GIACOFFSETIISAVHRR].val.pr8[2 * IND1(sn) + 1]
                  = ConfAutre->IDefIISAVHRROffsetGuess[2 * IND1(sn) + 1];
        //@ on met a jour le contexte
        contextecourant->GIacOffsetIISAVHRRLin[0] = ConfAutre->IDefIISAVHRROffsetGuess[2 * IND1(sn) + 0];
        contextecourant->GIacOffsetIISAVHRRCol[0] = ConfAutre->IDefIISAVHRROffsetGuess[2 * IND1(sn) + 1];
      }
      //@ FIN SI
		// FT-2997
		SP = LigneMDRENG->InfoDet.tab_var[ENG_GEPS_SP].val.pui4[IND1(sn)];
      	//@ SI (IDefCcsMode=0 et pas ( CG9 ))
      	//FA160 on test le cas CG 15 leve par IAC
      	if (!gestCasDeg.GetCasDegLigne(numeroLigne)->IsDetecte(9, 0, 0, 0, dateTmp) 
            &&   !gestCasDeg.GetCasDegLigne(numeroLigne)->IsDetecte(15, sn-1, 0, 0, dateTmp)
            && ConfAutre->IDefCcsMode == 0)
      	{
 		    // --------------------------------------------------------------------------------------
		    // Calcul des offsets Sond-IIS et Sond-Avhrr
		    // --------------------------------------------------------------------------------------  
		   	if(34 != SP)
		    {
     			// FT-3068
     			AvhrrDatBefore = CMN__DATE_CONV_SCDS_2_SEC(LigneMDR1ABC->InfoDet.tab_var[N1C_GEPSDATIASI].val.pdate[IND1(sn)]) - ConfStable->IDefDeltaAvhrrDTbefore[IND1(SP)];  // double(1)
     			AvhrrDatAfter  = CMN__DATE_CONV_SCDS_2_SEC(LigneMDR1ABC->InfoDet.tab_var[N1C_GEPSDATIASI].val.pdate[IND1(sn)]) + ConfStable->IDefDeltaAvhrrDTafter[IND1(SP)];   // double(1)
		    	// .. FT-3068
		    	AvhrrColDeb    = ConfStable->IDefDeltaAvhrrColLeft[IND1(SP)];   // int(1)  
		     	AvhrrColFin    = ConfStable->IDefDeltaAvhrrColRight[IND1(SP)];  // int(1)
		    }
		  	else
		    {
     			// FT-3068
           		AvhrrDatBefore = CMN__DATE_CONV_SCDS_2_SEC(LigneMDR1ABC->InfoDet.tab_var[N1C_GEPSDATIASI].val.pdate[IND1(sn)]) - ConfStable->IDefDeltaAvhrrDTbefore[IND1(15)];  // double(1)
     			AvhrrDatAfter  = CMN__DATE_CONV_SCDS_2_SEC(LigneMDR1ABC->InfoDet.tab_var[N1C_GEPSDATIASI].val.pdate[IND1(sn)]) + ConfStable->IDefDeltaAvhrrDTafter[IND1(15)];   // double(1)
		    	// .. FT-3068
		    	AvhrrColDeb    = ConfStable->IDefDeltaAvhrrColLeft[IND1(16)];   // int(1)  
		     	AvhrrColFin    = ConfStable->IDefDeltaAvhrrColRight[IND1(15)];  // int(1)
		    }
    		
    		// Calcul des numeros de premiere et derniere ligne de l'image AVHRR en fonction des dates
    		//------------------------------------------------------------------------
    		// Premiere ligne
    		AvhrrLinDeb = 0;
    		il = 0;
    		datetmp = CMN__DATE_CONV_SCDS_2_SEC( *(ListeLignesAVHRR[il]->InfoGene.tab_var[AVHRR_DATEDEB].val.pdate));

    		while( (datetmp <= AvhrrDatBefore) && (il < nombreLignes))
    		{
      			datetmp = (double)CMN__DATE_CONV_SCDS_2_SEC( *(ListeLignesAVHRR[il]->InfoGene.tab_var[AVHRR_DATEDEB].val.pdate));
				/* bma depassement de tableau */
      			il++;
				/* fin bma */
	     		// FT-3047
    			/*
      			#ifdef OPS_DEBUG
        			cout << "Date de la ligne " <<  il << " : " << datetmp << endl;
      			#endif
      			*/
	     		// ..FT-3047
    		}
    		AvhrrLinDeb = il - 1;

    		if( AvhrrLinDeb < 0)   AvhrrLinDeb = 0;

     		// FT-3047
    		/*
    		#ifdef OPS_DEBUG
      			cout << "Date debut a la ligne : " << AvhrrLinDeb << endl;
    		#endif
   			*/
     		// ..FT-3047

    		// Derniere ligne
    		AvhrrLinFin = 0;
    		il = 0;
    		datetmp = CMN__DATE_CONV_SCDS_2_SEC( *(ListeLignesAVHRR[il]->InfoGene.tab_var[AVHRR_DATEFIN].val.pdate));
    		while( (datetmp < AvhrrDatAfter) && (il < nombreLignes))
    		{
      			datetmp = CMN__DATE_CONV_SCDS_2_SEC( *(ListeLignesAVHRR[il]->InfoGene.tab_var[AVHRR_DATEFIN].val.pdate));
				/* bma depassement de tableau */
      			il++;
				/* fin bma */
	     		// FT-3047
    			/*
      			#ifdef OPS_DEBUG
        			cout << "Date de la ligne " <<  il << " : " << datetmp << endl;
      			#endif
      			*/
	     		// ..FT-3047
     		}
    		AvhrrLinFin = il;

		    if( AvhrrLinFin > (nombreLignes - 1))   AvhrrLinFin = nombreLignes - 1;

     		// FT-3047
    		/*
    		#ifdef OPS_DEBUG
      			cout << "Date fin   a la ligne : " << AvhrrLinFin << endl;
    		#endif
   			*/
     		// ..FT-3047
	  		CalcOffsetMode = 0;
		}
      	else
      	{
			AvhrrLinDeb = 0;           
			AvhrrLinFin = 0;       
			AvhrrColDeb = 0;
			AvhrrColFin = 0;
	  		CalcOffsetMode = 1;
      	}	

		// --------------------------------------------------------------------------------------
		// Calcul des offsets Sond-IIS et Sond-Avhrr
		// --------------------------------------------------------------------------------------

	  	// ========================================================================================
		// Boucle sur les IPSF ( Ipsf = 1 a 4 )
  		// ========================================================================================			
  		for( Ipsf= 1; Ipsf <= SD_BAS_PN; Ipsf++)
 		{
	    	cr_op= SD_ALG_CalcOffset(
	             	// Entrees pour MetopAVHRR
		      		CalcOffsetMode,    	   																		// Utilisation des donnees AVHRR ?
	              	ctx,      			   																		// Contexte_courant
	             	Mphr1ABC,               																	// MphrN1
	              	ListeLignesAVHRR,      																		// AvhrrListeLin : Not used
	              	nombreLignes,          																		// AvhrrNbLin : Not used
		            AvhrrLinDeb,          																		//            
		            AvhrrLinFin,          																		//        
			        AvhrrColDeb,          																		// 
			        AvhrrColFin,          																		// 
	             	// Entrees
	              	LigneMDR1ABC->InfoDet.tab_var[N1C_GEPSDATIASI].val.pdate[IND1(sn)],             			// IasiTime
	              	ConfAutre->IDefIASIScanAngle[IND1(SP)],														// IasiScanAngle
	              	ConfAutre->IDefIASIMETOPMatRot,      														// IasiMetopMatRot
	             	&(ConfAutre->IDefOffsetSondIISModel[IND3(1,1,Ipsf,SD_BAS_MODEL,SD_BAS_CCD)]),   			// OffsetSondIISModel
	              	*(LigneMDRENG->InfoDet.tab_var[ENG_GEPSENDECLIPSETIME].val.pdate),                 			// t_FE
	              	ConfAutre->IDefMETOPOrbitPeriod,          													// MetopPeriod
	             	&(LigneMDRENG->InfoDet.tab_var[ENG_GIACOFFSETIISAVHRR].val.pr8[IND2(1,sn,SD_BAS_DEUX)]),	// OffsetIISAvhrr
	             	// Sorties
	             	&FlagDateNOK,                                                								// unsigned int(1)
	             	&(OffsetSondIIS[IND3(1,Ipsf,sn,SD_BAS_DEUX,SD_BAS_PN)]),     								// double( SD_BAS_DEUX)
	             	&(OffsetSondAvhrr[IND3(1,Ipsf,sn,SD_BAS_DEUX,SD_BAS_PN)]),  								// double( SD_BAS_DEUX)
	             	&OffsetIISAvhrrRI[IND1(1)]);  																// double( SD_BAS_DEUX)
	   	
        	//@ traitement du compte-rendu
        	Traiter(cr_op, ctx);
				        	
	    	// --------------------------------------------------------------------------------------
			// ========================================================================================
			// Copie dans les variables de sorties
			// ========================================================================================
				
			// ----------------------------------------------------------------------------------------
			for( pix_1_2 = 1; pix_1_2 <= SD_BAS_DEUX; pix_1_2++)
			{
				// Offset Sondeur/AVHRR
				//  conversion en degres
				LigneMDRENG->InfoDet.tab_var[ENG_GCCSOFFSETSONDAVHRR].val.pr8[IND3(pix_1_2,Ipsf,sn,SD_BAS_DEUX,SD_BAS_PN)] = OffsetSondAvhrr[IND3(pix_1_2,Ipsf,sn,SD_BAS_DEUX,SD_BAS_PN)];
				// Offset Sondeur/IIS
				//  conversion en degres
				LigneMDRENG->InfoDet.tab_var[ENG_GCCSOFFSETSONDIIS].val.pr8[IND3(pix_1_2,Ipsf,sn,SD_BAS_DEUX,SD_BAS_PN)] = OffsetSondIIS[IND3(pix_1_2,Ipsf,sn,SD_BAS_DEUX,SD_BAS_PN)];
			}
			
			// ----------------------------------------------------------------------------------------

 		} // Fin Boucle sur les IPSF  
 		
		*(LigneMDRENG->InfoDet.tab_var[ENG_GCCSFLAGDATENOK].val.pui4) = FlagDateNOK;
		// ...FT-2997

      //@ SI (IDefCcsMode=0 et pas ( CG9 )) ou (IDefCcsMode=1 et pas ( CG6 ))
      if((!gestCasDeg.GetCasDegLigne(numeroLigne)->IsDetecte(9, 0 , 0, 0, dateTmp)
	  		//FA160 on test le cas CG 15 leve par IAC
			&&   !gestCasDeg.GetCasDegLigne(numeroLigne)->IsDetecte(15, sn-1, 0, 0, dateTmp)
            && ConfAutre->IDefCcsMode == 0)
       || (!gestCasDeg.GetCasDegLigne(numeroLigne)->IsDetecte(6, sn - 1, 0, 0, dateTmp)
            && ConfAutre->IDefCcsMode == 1))
      {
        //@ analyse des radiances dans les FOV sondeur
        //@ Call 41_CCS // en parler a Pierre
                          // factoriser transform IPSF
        double EigValCutoff = 1.0E-2;
        cr_op = SD_ALG_41_CCS(
          ctx,
          ConfAutre,
          ConfStable,
          Mphr1ABC,
          imageCalibree,
          ListeLignesAVHRR,
          nombreLignes,
          EigValCutoff,
          LigneMDR1ABC->InfoDet,
          DataThreadProduit,
          LigneMDRENG->InfoDet);
        //@ traitement du compte-rendu
        Traiter(cr_op, ctx);

        // FT-2521
        for (int PN=1; PN<=SD_BAS_PN; PN++)
        {
          ctx->ctxtrt.PN = PN;
           // FT-2656
          unsigned int BBofFlagSpecNonQual;
          unsigned int tmp;
          tmp = LigneMDRENG->InfoDet.tab_var[ENG_DATA_PX].val.pui4[146*SD_BAS_PN*SD_BAS_SNOT + IND2(PN,sn,SD_BAS_PN)];
          BBofFlagSpecNonQual = SD_BAS_Is_BitSeti( (unsigned short)tmp,2);
  		
          if ((0 != BBofFlagSpecNonQual) && 
              (LigneMDRENG->InfoDet.tab_var[ENG_GDOCFLAGUNDEROVERFLOW].val.pui4[IND2(PN,sn,SD_BAS_PN)] == CMN__FAUX))
          {
            cr_op = SD_ALG_42_PCH(
                ctx,
                ConfAutre,
                ConfStable,
                tmp2Spect[IND1(PN)], 
                LigneMDR1ABC->InfoDet,
                LigneMDRENG->InfoDet                
                );
            //@ traitement du compte-rendu
            Traiter(cr_op, ctx); 
          }
          else
          {
            cout << "SD_ALG_42_PCH : Impossible pour GEPS_LN=" << 
                    LigneMDRENG->InfoDet.tab_var[ENG_GEPS_LN].val.pui4[0] << "SN=" << sn << "PN=" << PN << endl;
          }
          // ...FT-2656
        }
        // ...FT-2521
      }
      //@ SINON
      else
      {
        //@ on remplit les MDR 1C et ENG
        //@ POUR tous les PN (1, 4)
        for(int pn = 1; pn <= 4; pn ++)
        {
          	LigneMDRENG->InfoDet.tab_var[ENG_CGCCSRADANALNBCLASS].val.pi4[IND1(sn) * SD_BAS_PN + IND1(pn)] = 0;
			// FT-2997
			// Offset Sondeur/AVHRR conversion en degres
			LigneMDRENG->InfoDet.tab_var[ENG_GCCSOFFSETSONDAVHRR].val.pr8[IND3(1,pn,sn,SD_BAS_DEUX,SD_BAS_PN)] = 
						LigneMDRENG->InfoDet.tab_var[ENG_GCCSOFFSETSONDAVHRR].val.pr8[IND3(1,pn,sn,SD_BAS_DEUX,SD_BAS_PN)]*180./M_PI;
			LigneMDRENG->InfoDet.tab_var[ENG_GCCSOFFSETSONDAVHRR].val.pr8[IND3(2,pn,sn,SD_BAS_DEUX,SD_BAS_PN)] = 
						LigneMDRENG->InfoDet.tab_var[ENG_GCCSOFFSETSONDAVHRR].val.pr8[IND3(2,pn,sn,SD_BAS_DEUX,SD_BAS_PN)]*180./M_PI;
			// Offset Sondeur/IIS conversion en degres
			LigneMDRENG->InfoDet.tab_var[ENG_GCCSOFFSETSONDIIS].val.pr8[IND3(1,pn,sn,SD_BAS_DEUX,SD_BAS_PN)] = 
						LigneMDRENG->InfoDet.tab_var[ENG_GCCSOFFSETSONDIIS].val.pr8[IND3(1,pn,sn,SD_BAS_DEUX,SD_BAS_PN)]*180./M_PI;
			LigneMDRENG->InfoDet.tab_var[ENG_GCCSOFFSETSONDIIS].val.pr8[IND3(2,pn,sn,SD_BAS_DEUX,SD_BAS_PN)] = 
						LigneMDRENG->InfoDet.tab_var[ENG_GCCSOFFSETSONDIIS].val.pr8[IND3(2,pn,sn,SD_BAS_DEUX,SD_BAS_PN)]*180./M_PI;
			// ...FT-2997
        }
        LigneMDR1ABC->InfoDet.tab_var[N1C_GCCSIMAGECLASSIFIEDNBLIN].val.pi4[IND1(sn)] = 0;
        LigneMDR1ABC->InfoDet.tab_var[N1C_GCCSIMAGECLASSIFIEDNBCOL].val.pi4[IND1(sn)] = 0;
      }
      //@ FIN SI

// FA 194: a l'origine delete [] imageCalibree ici (on est dans if)

      //@ geolocalisation (A1353)
      //@ Call 44_GEO
        //  initialisations
//FA153 suppression init mphr subsat 
    
     /* CR242 */
     t_CMN__Booleen FlagGeoAvhrrMiss = CMN__FAUX;
     //@ SI CG9 ou CG15 est leve ALORS
     if (gestCasDeg.GetCasDegLigne(numeroLigne)->IsDetecte(9, 0, 0, 0, dateTmp)  
		 //FA160 on teste le cas CG15 leve par IAC
         || gestCasDeg.GetCasDegLigne(numeroLigne)->IsDetecte(15, 0, 0, 0, dateTmp)
        )
     {
       FlagGeoAvhrrMiss = CMN__VRAI;
     }
     
	// FT-2997
    cr_op = SD_ALG_44_GEO(
       						ctx,
       						DataThreadProduit,
       						ConfAutre,
       						ConfStable,
       						statMphr,
       						Mphr1ABC,
       						&LigneMDRENG->InfoDet,
       						&LigneMDR1ABC->InfoDet,
       						nombreLignes,
       						ListeLignesAVHRR,
       						OffsetIISAvhrrRI,
       						FlagGeoAvhrrMiss);		
	// ...FT-2997
     
//FA182
        if(cr_op != CMN__STATUT_OK)
	
           {
        //@ SI erreur alors l'offset n'a pas ete calcule et on leve CG15 pour ne pas fasser dans CCS et GEO ??
           gestCasDeg.GetCasDegLigne(numeroLigne)->SetDetecte(15, dateLN, sn-1, 0, 0);
  	  }
//..FA182
     Traiter(cr_op, ctx);
     
     //@ SI SN=15
     if(sn == 15)
     {
       //@ enregistrement de ENG_CGEOSUBSATELLITEPOSITION
       //@ centre de l'image ( pt 3,3 du tableau 5 5 issu de 44_GEO) SN = 15
       for(int i = 0; i < 2; i++)
       {
         // FA133
         LigneMDRENG->InfoDet.tab_var[ENG_CGEOSUBSATELLITEPOSITION].val.pr8[i] =
           LigneMDR1ABC->InfoDet.tab_var[N1C_GGEOIISLOC].val.pr8[IND3(i+1,SD_BAS_SGI_CTR_INDEX+1, sn, 2, SD_BAS_SGI)];
       }
     }  //@ FIN SI SN=15
     /* FIN CR242 */
     }//FIN if( (sp<=30) && (sp>0) FA151
     
    }
    //@ FIN POUR chaque sous-cycle de la ligne
    
    /* CR292 */
    ctx->ctxtrt.SN = 1;

    //@ Initialisation des champs MPHR_SUBSAT_LATITUDE/LONGITUDE_START/END
    Mphr1ABC->listevar.tab_var[MPHR_SUBSAT_LATITUDE_START].val.pr8[0] = 0.0;
    Mphr1ABC->listevar.tab_var[MPHR_SUBSAT_LONGITUDE_START].val.pr8[0] = 0.0;
    Mphr1ABC->listevar.tab_var[MPHR_SUBSAT_LATITUDE_END].val.pr8[0] = 0.0;
    Mphr1ABC->listevar.tab_var[MPHR_SUBSAT_LONGITUDE_END].val.pr8[0] = 0.0;
    
    //@ Calcul des champs MPHR_SUBSAT_LATITUDE/LONGITUDE_START/END
    // FT-2751
    cr_op = SD_ALG_AVHRR_GetSubSatLatLon (
      ctx, 
      ConfAutre, 
      statMphr, 
      Mphr1ABC, 
      &LigneMDRENG->InfoDet,
      gestionnaire->GetNbLignesIASI());
    // ...FT-2751
    
    Traiter(cr_op, ctx);
    /* FIN CR292 */
    
    //@ liberation tableaux temporaires spectre (1B ,1C)
    delete [] S1bSpect;
    delete [] S1cSpect;
    // FT-2600
    // FT-2521
    delete [] tmp2Spect[0]; // PN1
    delete [] tmp2Spect[1]; // PN2
    delete [] tmp2Spect[2]; // PN3
    delete [] tmp2Spect[3]; // PN4
    // ...FT-2521
    // ...FT-2600
//FA 194
    delete [] imageCalibree;
// .. FA 194
    }
//@ ------------------------------------------------------------------*/
//@ Methode : FinDeTraitement1
//@
//@ Description : Cloture le traitement (partie 1)
//@
//@ Parametres :
//@
//@ Valeur de retour : 
//@
//@ ------------------------------------------------------------------*/
void SD_GES_ChaineProd1B_1C::FinDeTraitement1(t_SD_BAS_LigneN1* LigneMDR1ABC,
                                            t_SD_BAS_LigneN1* LigneMDRENG,
                                            t_SD_BAS_Contexte* contextecourant,
                                            SD_DON_GestDonnees* gestionnaire,
                                            t_SD_BAS_ConfStable* ConfStable,
                                            t_SD_BAS_ConfAutre* ConfAutre,
                                            SD_DON_GestCasDeg& gestCasDeg,
                                            int numeroLigne,
                                            t_SD_BAS_StatMphr* statMphr
                                            )
{
  /* PM4 CR177 */
  t_CMN__Booleen CG01_GOPSFLAPIXMISS_Trouve       = CMN__FAUX;
  t_CMN__Booleen CG02_GOPSFLADATAGAP_Trouve       = CMN__FAUX;
  t_CMN__Booleen CG03_GOPSFLTLISFERMOFF_Trouve    = CMN__FAUX;
  t_CMN__Booleen CG04_GOPSFLTBANDMISS_Trouve      = CMN__FAUX;
  t_CMN__Booleen CG06_GOPSFLTIMGEWMISS_Trouve     = CMN__FAUX;
  t_CMN__Booleen CG13_GOPSFLAGPACKETPXMISS_Trouve = CMN__FAUX;
  t_CMN__Booleen CG14_GOPSFLAGPACKETIPMISS_Trouve = CMN__FAUX;
  t_CMN__Booleen CG15_GOPSFLAGEOAVHRRMISS_Trouve  = CMN__FAUX;
  t_CMN__Booleen MdrDegradedTrouve;
  TYCST__T_uint4 Mask;
  int i, CCD;
  
  /* DM-3150 : Declaration des variables des bits de GQisFlagDetailed pour les count_degraded_xxx_mdr */
  unsigned int uiGQisFlagQualDetailed; 
  unsigned int BspkFlagSpikB1_leve;
  unsigned int BspkFlagSpikB2_leve;
  unsigned int BspkFlagSpikB3_leve;
  unsigned int BBofFlagSpectNonQual_leve;
  unsigned int GQisFlagQual_leve;
  /* ...DM-3150 */
  
  //@ mise a jour PTSI contexte
// FA 196 et 198
  //inversion de mots
  int version = (int)(LigneMDRENG->InfoDet.tab_var[ENG_PTSI].val.pui4[0]/65536);
  contextecourant->PTSI[0] = LigneMDRENG->InfoDet.tab_var[ENG_PTSI].val.pui4[0] - (version*65536);
//  contextecourant->PTSI[0] = (int)(LigneMDRENG->InfoDet.tab_var[ENG_PTSI].val.pui4[0]/65536);
// ..FA 196 et 198

  //  initialisations
  statMphr->count_degraded_inst_mdr =0;
  statMphr->count_degraded_inst_mdr_blocks =0;
  statMphr->count_degraded_proc_mdr_blocks =0;
  statMphr->count_degraded_proc_mdr = 0;
  bool* Idconf;
  Idconf = new bool[SD_BAS_NB_CGXX + SD_GES_MARGE];
  //@ on determine si la ligne contient un cas degrade CGxx 
  if(gestCasDeg.GetCasDegLigne(numeroLigne)->IsCasDeg(Idconf))
  {
    //@ ceci est utilise pour mettre a jour l'indicateur Degraded_Inst_MDR des N1 (+1)
    LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_INST_MDR].val.pui4[0] = 1;
    // DM-3150 : Changement des conditions d'incrémentation du count_degraded_inst_mdr
    //@ en comptabilisant la ligne si besoin dans  les donnees inst corrompues
    //statMphr->count_degraded_inst_mdr = 1;
    // ...DM-3150
  }
  
  //@  mise a jour de GEPSIdconf du N1ABC
  LigneMDR1ABC->InfoDet.tab_var[N1C_IDEFIDCONF].val.pui4[0] = ConfAutre->IDefConf;
  LigneMDR1ABC->InfoDet.tab_var[N1AB_IDEFIDCONF].val.pui4[0] = ConfAutre->IDefConf;
  LigneMDRENG->InfoDet.tab_var[ENG_IDEFIDCONF].val.pui4[0] = ConfAutre->IDefConf;
  
  //@ on determine si la ligne a donne lieu a un traitement degrade GQISQUAl
  int sommeGQIS = 0;
  /* PM4 CR177 */
  MdrDegradedTrouve = CMN__FAUX;
  for(int sn = 0; sn < SD_BAS_SNOT; sn++)
  {
    for(int pn = 0; pn < SD_BAS_PN; pn++)
    {
	  // DM-3150 : Decommutation du parametre GQisFlagQualDetailed
  	  uiGQisFlagQualDetailed = LigneMDRENG->InfoDet.tab_var[ENG_GQISFLAGQUALDETAILED].val.pui4[sn*SD_BAS_PN+pn];
  	  //@ BSpkFlagSpik B1 = bit 1 ; BSpkFlagSpik B2 = bit 2; BSpkFlagSpik B3 = bit 3 (le 14, 13 et 12 sur le schéma du Niv0);
  	  BspkFlagSpikB1_leve = SD_BAS_Is_BitSeti( (unsigned short)uiGQisFlagQualDetailed, 14);
  	  BspkFlagSpikB2_leve = SD_BAS_Is_BitSeti( (unsigned short)uiGQisFlagQualDetailed, 13);
  	  BspkFlagSpikB3_leve = SD_BAS_Is_BitSeti( (unsigned short)uiGQisFlagQualDetailed, 12);     	
  	  //@ BBofFlagSpectNonQual = bit 5 (le 10 sur le schéma du Niv0);
  	  BBofFlagSpectNonQual_leve = SD_BAS_Is_BitSeti( (unsigned short)uiGQisFlagQualDetailed, 10);
  	  //@ GQisGFlagQual = bit 9 (le 6 sur le schéma du Niv0);
  	  GQisFlagQual_leve = SD_BAS_Is_BitSeti( (unsigned short)uiGQisFlagQualDetailed, 6);
	  // La condition de l'incrémentation du count_degraded_inst_mdr est modifiee
  	  // Comptabilise le nombre de fois ou BBofFlagSpectNonQual est leve (bit 5 GQisFlagQualDetailed)
      if ( BBofFlagSpectNonQual_leve == CMN__OUI)
      {
        statMphr->count_degraded_inst_mdr = statMphr->count_degraded_inst_mdr + 1;
      }
 	  // La condition de l'incrémentation du count_degraded_inst_proc est modifiee
  	  // Comptabilise le nombre de fois ou GQisFlagQual (bit n°5 GQisFlagQualDetailed) est leve 
  	  // sachant que chaque BspkFlagSpik B1-2-3 n'est pas leve
  	  if ( BspkFlagSpikB1_leve == CMN__NON and BspkFlagSpikB2_leve == CMN__NON and BspkFlagSpikB3_leve == CMN__NON )
  	  {
  	    if ( GQisFlagQual_leve == CMN__OUI )
  		{
  		  statMphr->count_degraded_proc_mdr = statMphr->count_degraded_proc_mdr + 1;
  		}
  	  }
  	  // ...DM-3150
      // FT-2525
      for(int sb = 0; sb < SD_BAS_SB; sb++)
      {
        /* PM4 CR234 */
        if(LigneMDRENG->InfoDet.tab_var[ENG_GQISFLAGQUAL].val.pui4[sb*SD_BAS_SNOT*SD_BAS_PN+sn*SD_BAS_PN+pn] == CMN__OUI)
        {
          //@ Degraded_Proc_MDR des N1 (+1)
          LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_PROC_MDR].val.pui4[0] = 1;
          // DM-3150 : Changement des conditions d'incrémentation du count_degraded_proc_mdr
          //@ en comptabilisant la ligne si besoin dans les donnees corrompues par le traitement
          //statMphr->count_degraded_proc_mdr = 1;
          // ... DM-3150
          sommeGQIS ++;
        }
        if(gestCasDeg.GetCasDegLigne(numeroLigne)->IsCasDeg(Idconf)
           && (LigneMDR1ABC->InfoDet.tab_var[N1C_GQISFLAGQUAL].val.pui4[sb*SD_BAS_SNOT*SD_BAS_PN+sn*SD_BAS_PN+pn] == CMN__NON)
	          && (MdrDegradedTrouve == CMN__FAUX) )
        {
          MdrDegradedTrouve = CMN__VRAI;
        }
      }
      // .. FT-2525
    }
  }
  
  if (MdrDegradedTrouve == CMN__VRAI)
  {
/* CR290 */
#ifdef OPS_DEBUG
    cout << "Mdr Degraded trouve, MAJ du GeneratedFile." << endl;
#endif /* OPS_DEBUG */
    //@ on renseigne aussi fin traitement en faisant +1 sur MDRDEGRADED
    unsigned long nb = atoi(gestionnaire->GetTraitement().GeneratedFile().MdrDegraded().c_str());
    nb ++;
    gestionnaire->GetTraitement().GeneratedFile().MdrDegraded(nb);

    gestCasDeg.GetCasDegLigne(numeroLigne)->IsCasDeg(Idconf);
    gestionnaire->GetTraitement().GeneratedFile().AjouterCasDeg(Idconf);
/* Fin CR290 */
  }
  
  //@ on extrait les cas degrades CGxx par 
  //@ SD_DON_CasDegLigne::GetDate et SD_DON_CasDegLigne::GetFlt
  //@ et on initialise le MDRENG avec ceci
  for(int sn = 0; sn < SD_BAS_SNOT; sn++)
  {
    //@ CG1
    for(int pn = 0; pn < SD_BAS_PN; pn++)
    {
      if(gestCasDeg.GetCasDegLigne(numeroLigne)->GetFlt(1).flag[sn][pn][0])
      {
        LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLAPIXMISS].val.pui4[sn * SD_BAS_PN + pn] = 1;
        /* PM4 CR177 */
        CG01_GOPSFLAPIXMISS_Trouve = CMN__VRAI;
      }
    }
    
    //@ CG2
    if(gestCasDeg.GetCasDegLigne(numeroLigne)->GetFlt(2).flag[sn][0][0])
    {
      LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLADATAGAP].val.pui4[0] = 1;
      /* PM4 CR177 */
      CG02_GOPSFLADATAGAP_Trouve = CMN__VRAI;
    }
    
    //@ CG3
    for(int ccd = 0; ccd < SD_BAS_CCD; ccd++)
    {
      if(gestCasDeg.GetCasDegLigne(numeroLigne)->GetFlt(3).flag[sn][0][ccd])
      {
        /* PM4 CR177 */
        LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLTISRFEMOFF].val.pui4[sn] = 1;
        CG03_GOPSFLTLISFERMOFF_Trouve = CMN__VRAI;
      }
    }
    
    //@ CG4
    for(int pn = 0; pn < SD_BAS_PN; pn++)
    {
      for(int sb = 0; sb < SD_BAS_SB; sb++)
      {
        if(gestCasDeg.GetCasDegLigne(numeroLigne)->GetFlt(4).flag[sn][pn][sb])
        {
          LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLTBANDMISS].val.pui4[sn] = 1;
          /* PM4 CR177 */
          CG04_GOPSFLTBANDMISS_Trouve = CMN__VRAI;
        }
      }
    }
    
    //@ CG6
    if(gestCasDeg.GetCasDegLigne(numeroLigne)->GetFlt(6).flag[sn][0][0])
    {
      LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLTIMGEWMISS].val.pui4[sn] = 1;
      /* PM4 CR177 */
      CG06_GOPSFLTIMGEWMISS_Trouve = CMN__VRAI;
    }
    
    //@ CG9
    if(gestCasDeg.GetCasDegLigne(numeroLigne)->GetFlt(9).flag[sn][0][0])
    {
      LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLTRADAVHRRMISS].val.pui4[sn] = 1;
    }
    
    //@ CG13
    for(int pn = 0; pn < SD_BAS_PN; pn++)
    {
      if(gestCasDeg.GetCasDegLigne(numeroLigne)->GetFlt(13).flag[sn][pn][0])
      {
        LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLAGPACKETPXMISS].val.pui4[sn * SD_BAS_PN + pn] = 1;
        /* PM4 CR177 */
        CG13_GOPSFLAGPACKETPXMISS_Trouve = CMN__VRAI;
      }
    }
    
    //@ CG14
    if(gestCasDeg.GetCasDegLigne(numeroLigne)->GetFlt(14).flag[sn][0][0])
    {
      LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLAGPACKETIPMISS].val.pui4[sn] = 1;
      /* PM4 CR177 */
      CG14_GOPSFLAGPACKETIPMISS_Trouve = CMN__VRAI;
    }
    
    /* PM4 CR177 */
    //@ CG15
    if(gestCasDeg.GetCasDegLigne(numeroLigne)->GetFlt(15).flag[sn][0][0])
    {
      LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLAGEOAVHRRMISS].val.pui4[sn] = 1;
      CG15_GOPSFLAGEOAVHRRMISS_Trouve = CMN__VRAI;
    }
  }

  /* PM4 CR177 */
  //@ SI CG14 leve pour calibration externe ALORS
  for (int sn = SD_BAS_SNOT+1 ; sn <= SD_BAS_SN ; sn++)
  {
    if (gestCasDeg.GetCasDegLigne(numeroLigne)->GetFlt(14).flag[IND1(sn)][0][0])
    {
// FA 193
      // Pb init i
      //Pb : on ecrivait un cran trop loin : les +1 +2 +3 +4 transformes en +0 +1 +2 +3
      switch (sn)
      {
        case SD_BAS_SN_IP_SUP_1: /* BB */
	  LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLAGPACKETIPMISS].val.pui4[IND1(SD_BAS_SNOT+1)] = 1;
	  CG14_GOPSFLAGPACKETIPMISS_Trouve = CMN__VRAI;
	  break; /* BB */

        case SD_BAS_SN_IP_SUP_2: /* BB */
	  LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLAGPACKETIPMISS].val.pui4[IND1(SD_BAS_SNOT+2)] = 1;
	  CG14_GOPSFLAGPACKETIPMISS_Trouve = CMN__VRAI;
	  break; /* BB */

        case SD_BAS_SN_IP_SUP_3: /* CS */
	  LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLAGPACKETIPMISS].val.pui4[IND1(SD_BAS_SNOT+3)] = 1;
	  CG14_GOPSFLAGPACKETIPMISS_Trouve = CMN__VRAI;
	  break; /* CS */

        case SD_BAS_SN_IP_SUP_4: /* CS */
	  LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLAGPACKETIPMISS].val.pui4[IND1(SD_BAS_SNOT+4)] = 1;
	  CG14_GOPSFLAGPACKETIPMISS_Trouve = CMN__VRAI;
	  break; /* CS */

        default: break;
      }

// ..FA 193
    }
  }
  
  /* Mise a jour de GEPSIdConf defini dans SD_BAS_Niveau1.env */
  if (CG01_GOPSFLAPIXMISS_Trouve == CMN__VRAI)
  {
    Mask = 1;
    for (i = 0 ; i < SD_BAS_CG01_GOPSFLAPIXMISS ; i++)
    {
      Mask = Mask * 2;
    }
    LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] = 
      LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] | Mask;
    LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] = 
      LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] | Mask;
  }
  
  if (CG02_GOPSFLADATAGAP_Trouve == CMN__VRAI)
  {
    Mask = 1;
    for (i = 0 ; i < SD_BAS_CG02_GOPSFLADATAGAP ; i++)
    {
      Mask = Mask * 2;
    }
    LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] = 
      LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] | Mask;
    LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] = 
      LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] | Mask;
  }
  
  if (CG03_GOPSFLTLISFERMOFF_Trouve == CMN__VRAI)
  {
    Mask = 1;
    for (i = 0 ; i < SD_BAS_CG03_GOPSFLTLISFERMOFF ; i++)
    {
      Mask = Mask * 2;
    }
    LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] = 
      LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] | Mask;
    LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] = 
      LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] | Mask;
  }
  
  if (CG04_GOPSFLTBANDMISS_Trouve == CMN__VRAI)
  {
    Mask = 1;
    for (i = 0 ; i < SD_BAS_CG04_GOPSFLTBANDMISS ; i++)
    {
      Mask = Mask * 2;
    }
    LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] = 
      LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] | Mask;
    LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] = 
      LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] | Mask;
  }
  
  if (CG06_GOPSFLTIMGEWMISS_Trouve == CMN__VRAI)
  {
    Mask = 1;
    for (i = 0 ; i < SD_BAS_CG06_GOPSFLTIMGEWMISS ; i++)
    {
      Mask = Mask * 2;
    }
    LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] = 
      LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] | Mask;
    LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] = 
      LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] | Mask;
  }
  
  if (CG13_GOPSFLAGPACKETPXMISS_Trouve == CMN__VRAI)
  {
    Mask = 1;
    for (i = 0 ; i < SD_BAS_CG13_GOPSFLAGPACKETPXMISS ; i++)
    {
      Mask = Mask * 2;
    }
    LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] = 
      LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] | Mask;
    LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] = 
      LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] | Mask;
  }
  
  if (CG14_GOPSFLAGPACKETIPMISS_Trouve == CMN__VRAI)
  {
    Mask = 1;
    for (i = 0 ; i < SD_BAS_CG14_GOPSFLAGPACKETIPMISS ; i++)
    {
      Mask = Mask * 2;
    }
    LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] = 
      LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] | Mask;
    LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] = 
      LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] | Mask;
  }
  
  if (CG15_GOPSFLAGEOAVHRRMISS_Trouve == CMN__VRAI)
  {
    Mask = 1;
    for (i = 0 ; i < SD_BAS_CG15_GOPSFLAGEOAVHRRMISS ; i++)
    {
      Mask = Mask * 2;
    }
    LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] = 
      LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] | Mask;
    LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] = 
      LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] | Mask;
  }
  
  /* PM4 CR231 */
  for (CCD = 1 ; CCD <= SD_BAS_CCD ; CCD++)
  {
    LigneMDRENG->InfoDet.tab_var[ENG_GIAXAXEY].val.pr8[IND1(CCD)] = 
      LigneMDRENG->InfoDet.tab_var[ENG_GIAXAXEY].val.pr8[IND1(CCD)] * 180.0 / CMN__PI;
    LigneMDRENG->InfoDet.tab_var[ENG_GIAXAXEZ].val.pr8[IND1(CCD)] = 
      LigneMDRENG->InfoDet.tab_var[ENG_GIAXAXEZ].val.pr8[IND1(CCD)] * 180.0 / CMN__PI;
    LigneMDRENG->InfoDet.tab_var[ENG_GIAXAXEQUAL].val.pr8[IND1(CCD)] = 
      LigneMDRENG->InfoDet.tab_var[ENG_GIAXAXEQUAL].val.pr8[IND1(CCD)] * 180.0 / CMN__PI;
    
    LigneMDRENG->InfoDet.tab_var[ENG_GFAXAXEY].val.pr8[IND1(CCD)] = 
      LigneMDRENG->InfoDet.tab_var[ENG_GFAXAXEY].val.pr8[IND1(CCD)] * 180.0 / CMN__PI;
    LigneMDRENG->InfoDet.tab_var[ENG_GFAXAXEZ].val.pr8[IND1(CCD)] = 
      LigneMDRENG->InfoDet.tab_var[ENG_GFAXAXEZ].val.pr8[IND1(CCD)] * 180.0 / CMN__PI;
    LigneMDRENG->InfoDet.tab_var[ENG_GFAXAXERES].val.pr8[IND1(CCD)] = 
      LigneMDRENG->InfoDet.tab_var[ENG_GFAXAXERES].val.pr8[IND1(CCD)] * 180.0 / CMN__PI;
  }
  
  //@ mise a jour de l'entete et des donnees generales par appel a SetEntete
  // FT-2751
  if (numeroLigne == gestionnaire->GetNbLignesIASI())
  {
    // Derniere ligne du granule 
    gestionnaire->SetEnteteS1(statMphr, ConfStable, -1);
  }
  else
  {
    // FT-2466
    gestionnaire->SetEnteteS1(statMphr, ConfStable, numeroLigne);
    // ..FT-2466
  }
  // ...FT-2751

  //@ mise a jour du PCD pour la ligne par la somme des Gqisflagqual
  int pcd = gestionnaire->GetTraitement().PCD();
  pcd = sommeGQIS + pcd;
  gestionnaire->GetTraitement().PCD(pcd);  
  
  delete [] Idconf;
}


//@ ------------------------------------------------------------------*/
//@ Methode : FinDeTraitement2
//@
//@ Description : Cloture le traitement (partie 2)
//@
//@ Parametres :
//@
//@ Valeur de retour : 
//@
//@ ------------------------------------------------------------------*/
void SD_GES_ChaineProd1B_1C::FinDeTraitement2(t_SD_BAS_LigneN1* LigneMDR1ABC,
                                            t_SD_BAS_LigneN1* LigneMDRENG,
                                            t_SD_BAS_Contexte* contextecourant,
                                            SD_DON_GestDonnees* gestionnaire,
                                            t_SD_BAS_ConfStable* ConfStable,
                                            t_SD_BAS_ConfAutre* ConfAutre,
                                            SD_DON_GestCasDeg& gestCasDeg,
                                            int numeroLigne,
                                            t_SD_BAS_StatMphr* statMphr
                                            )
{
  /* PM4 CR177 */
  t_CMN__Booleen CG05_GOPSFLTBBTMISS_Trouve       = CMN__FAUX;
  t_CMN__Booleen CG07_GOPSFLTIMGBBMISS_Trouve     = CMN__FAUX;
  t_CMN__Booleen CG08_GOPSFLTIMGCSMISS_Trouve     = CMN__FAUX;
  t_CMN__Booleen CG11_GOPSFLAGPACKETVPMISS_Trouve = CMN__FAUX;
  t_CMN__Booleen CG12_GOPSFLAGPACKETAPMISS_Trouve = CMN__FAUX;
  TYCST__T_uint4 Mask;
  int i, CCD;

  //@ date CG3
  LigneMDRENG->InfoDet.tab_var[ENG_GOPSDATISRFEMOFF].val.pdate[0].day
        = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(3).SCDSTime().day;
  LigneMDRENG->InfoDet.tab_var[ENG_GOPSDATISRFEMOFF].val.pdate[0].millis
        = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(3).SCDSTime().millis;
  contextecourant->GOPSDatIsrfemOff[0].day = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(3).SCDSTime().day;
  contextecourant->GOPSDatIsrfemOff[0].millis = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(3).SCDSTime().millis;
  
  //@ date CG4
  LigneMDRENG->InfoDet.tab_var[ENG_GOPSDATBANDMISS].val.pdate[0].day
        = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(4).SCDSTime().day;
  LigneMDRENG->InfoDet.tab_var[ENG_GOPSDATBANDMISS].val.pdate[0].millis
        = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(4).SCDSTime().millis;
  contextecourant->GOPSDatBandMiss[0].day = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(4).SCDSTime().day;
  contextecourant->GOPSDatBandMiss[0].millis = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(4).SCDSTime().millis;
  
  //@ CG5
  if(gestCasDeg.GetCasDegLigne(numeroLigne)->GetFlt(5).flag[0][0][0])
  {
    LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLTBBTMISS].val.pui4[0] = 1;
    /* PM4 CR177 */
    CG05_GOPSFLTBBTMISS_Trouve = CMN__VRAI;
  }
  
  //@ date CG5
  LigneMDRENG->InfoDet.tab_var[ENG_GOPSDATBBTMISS].val.pdate[0].day
        = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(5).SCDSTime().day;
  LigneMDRENG->InfoDet.tab_var[ENG_GOPSDATBBTMISS].val.pdate[0].millis
        = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(5).SCDSTime().millis;
  contextecourant->GOPSDatBBTMiss[0].day = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(5).SCDSTime().day;
  contextecourant->GOPSDatBBTMiss[0].millis = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(5).SCDSTime().millis;
  
  //@ date CG6
  LigneMDRENG->InfoDet.tab_var[ENG_GOPSDATIMGEWMISS].val.pdate[0].day
        = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(6).SCDSTime().day;
  LigneMDRENG->InfoDet.tab_var[ENG_GOPSDATIMGEWMISS].val.pdate[0].millis
        = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(6).SCDSTime().millis;
  contextecourant->GOPSDatImgEWMiss[0].day = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(6).SCDSTime().day;
  contextecourant->GOPSDatImgEWMiss[0].millis = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(6).SCDSTime().millis;
  
  /* PM4 CR177 */
// FA 193
  //confusion sn et IND1(sn) sur le switch
  //La boucle n'a pas besoin de 0
  //Pb initialisation i, et remplissage systematique de GOPSFLAIISCALIBMISS
  //En fait au bout du compte : le CG7 et CG8 leve que pour SN=0 car simple flag, pas tableau de flag
  //Note actuellement il n'y a que les CALIB IP=32 et IP=35 qui sont activables
    //@ CG7
  if(gestCasDeg.GetCasDegLigne(numeroLigne)->GetFlt(7).flag[0][0][0])
    {
      switch (SD_BAS_SN_IP_SUP_BB)
	{
        case SD_BAS_SN_IP_SUP_1: /* BB */
	  LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLAIISCALIBMISS].val.pui4[IND1(1)] = 1;
	  CG07_GOPSFLTIMGBBMISS_Trouve = CMN__VRAI;
	  break; /* BB */

        case SD_BAS_SN_IP_SUP_2: /* BB */
	  LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLAIISCALIBMISS].val.pui4[IND1(2)] = 1;
	  CG07_GOPSFLTIMGBBMISS_Trouve = CMN__VRAI;
	  break; /* BB */

        default: break;
	} //FIN switch
    } //FIN if CG7

  //@ CG8
  if(gestCasDeg.GetCasDegLigne(numeroLigne)->GetFlt(8).flag[0][0][0])
    {
      switch (SD_BAS_SN_IP_SUP_CS)
	{
        case SD_BAS_SN_IP_SUP_3: /* CS */
	  LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLAIISCALIBMISS].val.pui4[IND1(3)] = 1;
	  CG08_GOPSFLTIMGCSMISS_Trouve = CMN__VRAI;
	  break; /* CS */

        case SD_BAS_SN_IP_SUP_4: /* CS */
	  LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLAIISCALIBMISS].val.pui4[IND1(4)] = 1;
	  CG08_GOPSFLTIMGCSMISS_Trouve = CMN__VRAI;
	  break; /* CS */

        default: break;
	} //FIN switch
    } //FIN if CG8

// ..FA 193
  
  if (CG07_GOPSFLTIMGBBMISS_Trouve == CMN__VRAI)
  {
    LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLTIMGBBMISS].val.pui4[0] = 1;
  }
  
  //@ date CG7
  LigneMDRENG->InfoDet.tab_var[ENG_GOPSDATIMGBBMISS].val.pdate[0].day
        = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(7).SCDSTime().day;
  LigneMDRENG->InfoDet.tab_var[ENG_GOPSDATIMGBBMISS].val.pdate[0].millis
        = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(7).SCDSTime().millis;
  contextecourant->GOPSDatImgBBMiss[0].day = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(7).SCDSTime().day;
  contextecourant->GOPSDatImgBBMiss[0].millis = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(7).SCDSTime().millis;
  
  if (CG08_GOPSFLTIMGCSMISS_Trouve == CMN__VRAI)
  {
    LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLTIMGCSMISS].val.pui4[0] = 1;
  }
  
  //@ date CG8
  LigneMDRENG->InfoDet.tab_var[ENG_GOPSDATIMGCSMISS].val.pdate[0].day
        = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(8).SCDSTime().day;
  LigneMDRENG->InfoDet.tab_var[ENG_GOPSDATIMGCSMISS].val.pdate[0].millis
        = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(8).SCDSTime().millis;
  contextecourant->GOPSDatImgCSMiss[0].day = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(8).SCDSTime().day;
  contextecourant->GOPSDatImgCSMiss[0].millis = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(8).SCDSTime().millis;
  
  //@ date CG9
  LigneMDRENG->InfoDet.tab_var[ENG_GOPSDATRADAVHRRMISS].val.pdate[0].day
        = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(9).SCDSTime().day;
  LigneMDRENG->InfoDet.tab_var[ENG_GOPSDATRADAVHRRMISS].val.pdate[0].millis
        = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(9).SCDSTime().millis;
  contextecourant->GOPSDatRadAvhrrMiss[0].day = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(9).SCDSTime().day;
  contextecourant->GOPSDatRadAvhrrMiss[0].millis = gestCasDeg.GetCasDegLigne(numeroLigne)->GetDate(9).SCDSTime().millis;       
  
  //@ CG11
  for(int i = 0; i < 5; i++)
  {
    if(gestCasDeg.GetCasDegLigne(numeroLigne)->GetFlt(11).flag[i][0][0])
    {
      LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLAGPACKETVPMISS].val.pui4[i] = 1;
      /* PM4 CR177 */
      CG11_GOPSFLAGPACKETVPMISS_Trouve = CMN__VRAI;
    }
  }
  
  //@ CG12
  if(gestCasDeg.GetCasDegLigne(numeroLigne)->GetFlt(12).flag[0][0][0])
  {
    LigneMDRENG->InfoDet.tab_var[ENG_GOPSFLAGPACKETAPMISS].val.pui4[0] = 1;
    /* PM4 CR177 */
    CG12_GOPSFLAGPACKETAPMISS_Trouve = CMN__VRAI;
  }
  
  /* PM4 CR177 */
  /* Mise a jour de GEPSIdConf defini dans SD_BAS_Niveau1.env */
  if (CG05_GOPSFLTBBTMISS_Trouve == CMN__VRAI)
  {
    Mask = 1;
    for (i = 0 ; i < SD_BAS_CG05_GOPSFLTBBTMISS ; i++)
    {
      Mask = Mask * 2;
    }
    LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] = 
      LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] | Mask;
    LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] = 
      LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] | Mask;
  }
  
  if (CG07_GOPSFLTIMGBBMISS_Trouve == CMN__VRAI)
  {
    Mask = 1;
    for (i = 0 ; i < SD_BAS_CG07_GOPSFLTIMGBBMISS ; i++)
    {
      Mask = Mask * 2;
    }
    LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] = 
      LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] | Mask;
    LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] = 
      LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] | Mask;
  }
  
  if (CG08_GOPSFLTIMGCSMISS_Trouve == CMN__VRAI)
  {
    Mask = 1;
    for (i = 0 ; i < SD_BAS_CG08_GOPSFLTIMGCSMISS ; i++)
    {
      Mask = Mask * 2;
    }
    LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] = 
      LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] | Mask;
    LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] = 
      LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] | Mask;
  }
  
  if (CG11_GOPSFLAGPACKETVPMISS_Trouve == CMN__VRAI)
  {
    Mask = 1;
    for (i = 0 ; i < SD_BAS_CG11_GOPSFLAGPACKETVPMISS ; i++)
    {
      Mask = Mask * 2;
    }
    LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] = 
      LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] | Mask;
    LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] = 
      LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] | Mask;
  }
  
  if (CG12_GOPSFLAGPACKETAPMISS_Trouve == CMN__VRAI)
  {
    Mask = 1;
    for (i = 0 ; i < SD_BAS_CG12_GOPSFLAGPACKETAPMISS ; i++)
    {
      Mask = Mask * 2;
    }
    LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] = 
      LigneMDR1ABC->InfoDet.tab_var[N1C_DEGRADED_CASES].val.pui4[0] | Mask;
    LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] = 
      LigneMDRENG->InfoDet.tab_var[ENG_DEGRADED_CASES].val.pui4[0] | Mask;
  }  
/* CR288 */
  gestCasDeg.GetCasDegLigne(numeroLigne)->SyntheseCasDegrades();
/* Fin CR288 */
}


//@ ------------------------------------------------------------------*/
//@ Methode : AllouerPointeursDataThreadProduit
//@
//@ Description : Alloue les pointeurs de la structure t_SD_BAS_DataThreadProduit
//@
//@ Parametres :
//@
//@ Valeur de retour : 
//@
//@ ------------------------------------------------------------------*/
void SD_GES_ChaineProd1B_1C::AllouerPointeursDataThreadProduit(t_SD_BAS_DataThreadProduit* DataThreadProduit,
                                                               t_SD_BAS_ConfAutre *ConfAutre,
                                                               t_SD_BAS_BanqueSpectrale *BanqueSpectrale,
                                                               t_SD_BAS_Contexte*
							       contextecourant,
							       int nombreLignes
                                                              )
{
  int surechFFT       = ConfAutre->IDefS1bOSFftFactor;
  int surechSpline    = ConfAutre->IDefS1bOSSplineFactor;
  int Nfirst          = ConfAutre->IDefNsfirst[SD_BAS_B1];
  int Nlast           = ConfAutre->IDefNslast[SD_BAS_B3];
  int Factor = surechFFT * surechSpline;
  int GSosSsdOSNsFirstSpect = Factor * (Nfirst - 1) + 1;
  int GSosSsdOSNsLastSpect = Factor * (Nlast - 1) + 1;
  
// initialisation de l'indicateur d'initialisation (optimisation de calcul des FFT )
  DataThreadProduit->CalculFFTS1C =0;
// ajout dimension
  DataThreadProduit->GSosSsdOSNsLastSpect=GSosSsdOSNsLastSpect;
  DataThreadProduit->GSosSsdOSNsFirstSpect=GSosSsdOSNsFirstSpect;
  /***************************************************************************/
  /* Liste des variables initialisees par 43_ISF                             */
  /***************************************************************************/
  // Pour le spline
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << BanqueSpectrale->IDefSafNslast - BanqueSpectrale->IDefSafNsfirst +1
       << " elements pour DataThreadProduit->Fcs";
#endif
//  attention la 1er dim est issu de la BD SD_BAS_SDB_NFSMAX
  DataThreadProduit->Fcs = new double[(BanqueSpectrale->IDefSafNslast - BanqueSpectrale->IDefSafNsfirst+1)*SD_BAS_CCD*SD_BAS_PN + SD_GES_MARGE];

#ifdef OPS_DEBUG
#define OPS_LIMIT
#undef OPS_DEBUG
#endif

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << 4*BanqueSpectrale->IDefSafNsOpd
       << " elements pour DataThreadProduit->y2isf";
#endif
  // FT-2765
    DataThreadProduit->y2isf = get_AUX_SD_BAS_InterpSpline1D();
    // ...FT-2765

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << BanqueSpectrale->IDefSafNsOpd
       << " elements pour DataThreadProduit->OpdTab";
#endif
  DataThreadProduit->OpdTab = new double[BanqueSpectrale->IDefSafNsOpd + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << 2*ConfAutre->IDefS1cNbSWwidth + 1
       << " elements pour DataThreadProduit->Opd";
#endif
  DataThreadProduit->Opd = new double[2*ConfAutre->IDefS1cNbSWwidth + 1 + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << (BanqueSpectrale->IDefSafNslast - BanqueSpectrale->IDefSafNsfirst +1) * (2*ConfAutre->IDefS1cNbSWwidth + 1)
       << " elements pour DataThreadProduit->Af";
#endif
//  attention la 1er dim est issu de la BD SD_BAS_SDB_NFSMAX
  DataThreadProduit->Af = new dcmplx[(2*ConfAutre->IDefS1cNbSWwidth + 1)*(BanqueSpectrale->IDefSafNslast - BanqueSpectrale->IDefSafNsfirst +1) * SD_BAS_CCD*SD_BAS_PN + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << BanqueSpectrale->IDefSafNsOpd
       << " elements pour DataThreadProduit->Af0";
#endif
  DataThreadProduit->Af0 = new dcmplx[BanqueSpectrale->IDefSafNsOpd + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << BanqueSpectrale->IDefSafNsOpd
       << " elements pour DataThreadProduit->REtmp";
#endif
  DataThreadProduit->REtmp = new double[BanqueSpectrale->IDefSafNsOpd + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << BanqueSpectrale->IDefSafNsOpd
       << " elements pour DataThreadProduit->IMtmp";
#endif
  DataThreadProduit->IMtmp = new double[BanqueSpectrale->IDefSafNsOpd + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << 2*ConfAutre->IDefS1cNbSWwidth + 1
       << " elements pour DataThreadProduit->REint";
#endif
  DataThreadProduit->REint = new double[2*ConfAutre->IDefS1cNbSWwidth + 1 + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << 2*ConfAutre->IDefS1cNbSWwidth + 1
       << " elements pour DataThreadProduit->IMint";
#endif
  DataThreadProduit->IMint = new double[2*ConfAutre->IDefS1cNbSWwidth + 1 + SD_GES_MARGE];

  /***************************************************************************/
  /* Liste des variables initialisees par 09_PLK                             */
  /***************************************************************************/
  /* Fonction de Planck utilisee a bord pour la ligne precedente */
  /* taille ConfAutre->IDefNslast[SB=3]-ConfAutre->IDefNsfirst[SB=1]+1 */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << ConfAutre->IDefNslast[SD_BAS_B3]-ConfAutre->IDefNsfirst[SD_BAS_B1] + 1
       << " elements pour DataThreadProduit->PlanckBBT";
#endif
  DataThreadProduit->PlanckBBT = new double[ConfAutre->IDefNslast[SD_BAS_B3]-ConfAutre->IDefNsfirst[SD_BAS_B1] + 1 + SD_GES_MARGE]; /* LN-1 */

  /***************************************************************************/
  /* Liste des variables initialisees par XX_InitProd (XX_Init dans la doc)  */
  /***************************************************************************/
  /* Zone de travail pour l'interpolation lineaire 1D de la librairie ESSL */
  /* taille = conf_autre->IDefNslast[SD_BAS_B3] - conf_autre->IDefNsfirst[SD_BAS_B1] + 1 */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << ConfAutre->IDefNslast[SD_BAS_B3]-ConfAutre->IDefNsfirst[SD_BAS_B1] + 1
       << " elements pour DataThreadProduit->TabAuxESSLTailleWn0";
#endif
  // FT-2765
  DataThreadProduit->TabAuxESSLTailleWn0 = get_AUX_SD_BAS_InterpLineaire1D();
  // ...FT-2765

  /* Zone de travail pour l'interpolation lineaire 1D de la librairie ESSL */
  /* taille = t_SD_BAS_22_SOS_Sortie->GSosSsdOSNsLastSpect - t_SD_BAS_22_SOS_Sortie->GSosSsdOSNsFirstSpect + 1 */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << GSosSsdOSNsLastSpect - GSosSsdOSNsFirstSpect + 1
       << " elements pour DataThreadProduit->TabAuxESSLTailleWnOSSpect";
#endif
  // FT-2765
    DataThreadProduit->TabAuxESSLTailleWnOSSpect = get_AUX_SD_BAS_InterpLineaire1D();
    // ...FT-2765

  /* Variables initialement utilisees pour 31_SCR, 32_HEC, 34_SMC */
  /*--------------------------------------------------------------*/
  /* Vecteur des nb d'onde des fonctions de calibration spectrale tabulees */
  /* entre NsfirstFcsTab et NslastFcsTab */
  /* taille BanqueSpectrale->IDefSafNslast - BanqueSpectrale->IDefSafNsfirst + 1 */
  /* occurence : indice de ligne du granule = LN */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << BanqueSpectrale->IDefSafNslast - BanqueSpectrale->IDefSafNsfirst + 1
       << " elements pour DataThreadProduit->WnFcsTab";
#endif
  DataThreadProduit->WnFcsTab = new double[BanqueSpectrale->IDefSafNslast - BanqueSpectrale->IDefSafNsfirst + 1 + SD_GES_MARGE];
  
  /* Vecteur des positions nominales des echantillons entre Nsfirst et Nslast */
  /* taille ConfAutre->IDefNslast[SD_BAS_B3] - ConfAutre->IDefNsfirst[SD_BAS_B1] + 1 */
  /* occurence : indice de ligne du granule = LN */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << ConfAutre->IDefNslast[SD_BAS_B3]-ConfAutre->IDefNsfirst[SD_BAS_B1]+1
       << " elements pour DataThreadProduit->Wn0";
#endif
  DataThreadProduit->Wn0 = new double[ConfAutre->IDefNslast[SD_BAS_B3] - ConfAutre->IDefNsfirst[SD_BAS_B1] + 1 + SD_GES_MARGE];
  
  /* Fonction de calibration spectrale interpolee lineairement */
  /* taille ConfAutre->IDefNslast[SD_BAS_B3] - ConfAutre->IDefNsfirst[SD_BAS_B1] + 1 */
  /* occurence : indice de ligne du granule = LN */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << ConfAutre->IDefNslast[SD_BAS_B3]-ConfAutre->IDefNsfirst[SD_BAS_B1]+1
       << " elements pour DataThreadProduit->FcsInterpolee";
#endif
   DataThreadProduit->FcsInterpolee= new double[(ConfAutre->IDefNslast[SD_BAS_B3] -
  ConfAutre->IDefNsfirst[SD_BAS_B1] + 1)*SD_BAS_CCD*SD_BAS_PN + SD_GES_MARGE];
  
  /* Vecteur des nb d'onde nominaux calibres */
  /* taille ConfAutre->IDefNslast[SB=3] - ConfAutre->IDefNsfirst[SB=1] + 1 */
  /* occurence : indice de ligne du granule = LN */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << ConfAutre->IDefNslast[SD_BAS_B3]-ConfAutre->IDefNsfirst[SD_BAS_B1]+1
       << " elements pour DataThreadProduit->WnSpect";
#endif
 DataThreadProduit->WnSpect = new double[(ConfAutre->IDefNslast[SD_BAS_B3] -
  ConfAutre->IDefNsfirst[SD_BAS_B1] + 1)*SD_BAS_CCD*SD_BAS_PN + SD_GES_MARGE];

  /* Variables initialement utilisees pour 31_SCR */
  /*----------------------------------------------*/
  /* Valeurs de la fontion de Planck calibree pour la ligne precedente */
  /* taille ConfAutre->IDefNslast[SB=3]-ConfAutre->IDefNsfirst[SB=1]+1 */
  /* occurence : indice de ligne du granule = LN-1 */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << ConfAutre->IDefNslast[SD_BAS_B3]-ConfAutre->IDefNsfirst[SD_BAS_B1]+1
       << " elements pour DataThreadProduit->B1";
#endif
 DataThreadProduit->B1 = new
  double[(ConfAutre->IDefNslast[SD_BAS_B3]-ConfAutre->IDefNsfirst[SD_BAS_B1]+1)*SD_BAS_CCD*SD_BAS_PN + SD_GES_MARGE];

  /* Variables initialement utilisees pour 32_HEC */
  /*----------------------------------------------*/
  /* Temperature des surfaces radiatives */
  /* taille conf_autre->IDefBBNbRrs */
  /* occurence : indice de ligne du granule = LN-1 */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << ConfAutre->IDefBBNbRrs
       << " elements pour DataThreadProduit->TRrs";
#endif
  DataThreadProduit->TRrs = new double[ConfAutre->IDefBBNbRrs + SD_GES_MARGE];
  
  /* Radiance emise par le corps noir chaud pour les echantillons dont */
  /* l'indice est compris entre Nsfirst et Nslast */
  /* taille ConfAutre->IDefNslast[SB=3]-ConfAutre->IDefNsfirst[SB=1]+1 */
  /* occurence : indice de ligne du granule = LN-1 */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << ConfAutre->IDefNslast[SD_BAS_B3]-ConfAutre->IDefNsfirst[SD_BAS_B1]+1
       << " elements pour DataThreadProduit->Bbb";
#endif
  DataThreadProduit->Bbb = new
  double[(ConfAutre->IDefNslast[SD_BAS_B3]-ConfAutre->IDefNsfirst[SD_BAS_B1]+1)*SD_BAS_CCD*SD_BAS_PN + SD_GES_MARGE];

  /* Variables initialement utilisees pour 35_S1B */
  /*----------------------------------------------*/
  /* Vecteur des nb d'onde nominaux 1b calibres */
  /* taille ConfAutre->IDefSpectNslast1b - ConfAutre->IDefSpectNsfirst1b + 1 */
  /* occurence : indice de ligne du granule = LN */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << ConfAutre->IDefNslast1b - ConfAutre->IDefNsfirst1b + 1
       << " elements pour DataThreadProduit->WnSpect1b";
#endif
  DataThreadProduit->WnSpect1b = new double[ConfAutre->IDefNslast1b - ConfAutre->IDefNsfirst1b + 1 + SD_GES_MARGE];

  /* Fonction de calibration spectrale interpolee lineairement */
  /* taille sortie_22_SOS->GSosSsdOSNsLastSpect - sortie_22_SOS->GSosSsdOSNsFirstSpect + 1 */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << GSosSsdOSNsLastSpect - GSosSsdOSNsFirstSpect + 1 
       << " elements pour DataThreadProduit->OSFcsInterpolee";
#endif
  DataThreadProduit->OSFcsInterpolee = new double[(GSosSsdOSNsLastSpect -
  GSosSsdOSNsFirstSpect + 1)*SD_BAS_CCD*SD_BAS_PN + SD_GES_MARGE];

  /* Vecteur des nb d'onde du spectre surechantillonne d'indice compris entre */
  /* OSNsfirst et OSNslast */
  /* taille SD_BAS_22_SOS_Sortie->GSosSsdOSNsLastSpect - */
  /*       SD_BAS_22_SOS_Sortie->GSosSsdOSNsFirstSpect + 1 */
  /* occurence : indice de ligne du granule = LN */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << GSosSsdOSNsLastSpect - GSosSsdOSNsFirstSpect + 1 
       << " elements pour DataThreadProduit->WnOSSpect";
#endif
  DataThreadProduit->WnOSSpect = new double[(GSosSsdOSNsLastSpect - GSosSsdOSNsFirstSpect  + 1)*SD_BAS_CCD*SD_BAS_PN + SD_GES_MARGE];

  /* Variables initialement utilisees pour 37_S1C */
  /*----------------------------------------------*/
  /* Vecteur des nb d'onde des fonctions d'apodisation d'indice compris entre NsfirstAfTab et */
  /* NslastAfTab */
  /* taille BanqueSpectrale->IDefSafNslast - BanqueSpectrale->IDefSafNsfirst + 1 */
  /* occurence : indice de ligne du granule = LN */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << BanqueSpectrale->IDefSafNslast - BanqueSpectrale->IDefSafNsfirst + 1
       << " elements pour DataThreadProduit->WnAf";
#endif
  DataThreadProduit->WnAf = new double[BanqueSpectrale->IDefSafNslast - BanqueSpectrale->IDefSafNsfirst + 1 + SD_GES_MARGE];
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << ConfAutre->IDefNslast1b - ConfAutre->IDefNsfirst1b + 1 + 2 * ConfAutre->IDefS1cNbSWwidth 
       << " elements pour DataThreadProduit->Spectre1bProlonge"
       << endl;
#endif
  DataThreadProduit->Spectre1bProlonge = new double[ConfAutre->IDefNslast1b - ConfAutre->IDefNsfirst1b + 1 + 2 * ConfAutre->IDefS1cNbSWwidth + SD_GES_MARGE];
  
  /* Fonction d'amortissement de la fenetre spectrale */
  /* taille 2*conf_autre->IDefS1cNbSWwidth+1 */
  /* occurence : indice de ligne du granule = LN */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << 2*ConfAutre->IDefS1cNbSWwidth+1
       << " elements pour DataThreadProduit->FctAmortissement";
#endif
  DataThreadProduit->FctAmortissement = new double[2*ConfAutre->IDefS1cNbSWwidth+1 + SD_GES_MARGE];
  
  /* Tableau des coeff necessaires a l'interpolation par Spline cubique */
  /* taille 4*(t_SD_BAS_22_SOS_Sortie->GSosSsdOSNsLastSpect - t_SD_BAS_22_SOS_Sortie->GSosSsdOSNsFirstSpect + 1) */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << 4*(GSosSsdOSNsLastSpect - GSosSsdOSNsFirstSpect + 1)
       << " elements pour DataThreadProduit->CoeffSpline";
#endif
  // FT-2765
  DataThreadProduit->CoeffSpline = get_AUX_SD_BAS_InterpSpline1D();
  // ...FT-2765

  /* Tableau temporaire du noyau pour le calcul de la fonction d'amortissement */
  /* taille 8*conf_autre->IDefS1cSigS+1 */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << 8*ConfAutre->IDefS1cSigS+1
       << " elements pour DataThreadProduit->G";
#endif
  DataThreadProduit->G = new double[8*ConfAutre->IDefS1cSigS+1 + SD_GES_MARGE];
  
  /* Fenetre spectrale du spectre 1B */
  /* taille 2*conf_autre->IDefS1cNbSWwidth+1 */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << 2*ConfAutre->IDefS1cNbSWwidth+1
       << " elements pour DataThreadProduit->S";
#endif
  DataThreadProduit->S = new double[2*ConfAutre->IDefS1cNbSWwidth+1 + SD_GES_MARGE];
  
  /* Fenetre spectrale completee par des zeros pour atteindre pour atteindre */
  /* une taille qui soit une puissance de 2 */
  /* taille SD_ALG_CalculPuissance2Sup (2*conf_autre->IDefS1cNbSWwidth+1) */
  int nFFT = SD_BAS_CalculPuissance2Sup(2*ConfAutre->IDefS1cNbSWwidth+1);
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << nFFT
       << " elements pour DataThreadProduit->SpectrePadde";
#endif
  DataThreadProduit->SpectrePadde = new double[nFFT + SD_GES_MARGE];
  
  /* Pour les FFT                                                 */
  int naux1, naux2;
  if(nFFT <= 2048)
        {
            naux1 = 22000;                          // cf doc lib ESSL p. 738 730 (max dcft drcft)
            naux2 = 20000;
        }
   else
        {
            naux1 = (int)(20000 + 2.28*nFFT);       // cf doc lib ESSL p. 738 730 (max dcft drcft)
            naux2 = (int)(20000 + 2.28*nFFT);
        }

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << naux1
       << " elements pour DataThreadProduit->aux1";
#endif
  // FT-2765
  DataThreadProduit->aux1 = get_AUX_SD_BAS_FFT1DirDR2C();
  DataThreadProduit->aux12 = get_AUX_SD_BAS_FFT1DirInvDC2C();
  // ...FT-2765

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << naux2
       << " elements pour DataThreadProduit->aux2";
#endif
  // FT-2765
  DataThreadProduit->aux2 = NULL;
  DataThreadProduit->aux22 = NULL;
  // ...FT-2765
  
  /* Transformee du spectre apres apodisation et zero-padding */
  /* taille SD_ALG_CalculPuissance2Sup(2*conf_autre->IDefS1cNbSWwidth+1) */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << nFFT
       << " elements pour DataThreadProduit->Stf";
#endif
  DataThreadProduit->Stf = new dcmplx[nFFT + SD_GES_MARGE];
  
  /* Moitie de la TF du spectre reel renvoyee par la librairie ESSL */
  /* (cf symetrie Hermitienne) */
  /* taille (1/2)*SD_ALG_CalculPuissance2Sup(2*conf_autre->IDefS1cNbSWwidth+1) */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << nFFT / 2 + 1
       << " elements pour DataThreadProduit->MoitieStf";
#endif
  DataThreadProduit->MoitieStf = new dcmplx[nFFT / 2 + 1 + SD_GES_MARGE];
  
  /* FFT de la fenetre spectrale 1B apodisee */
  /* taille SD_ALG_CalculPuissance2Sup(2*conf_autre->IDefS1cNbSWwidth+1) */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << nFFT
       << " elements pour DataThreadProduit->SAtf";
#endif
  DataThreadProduit->SAtf = new dcmplx[nFFT + SD_GES_MARGE];
  
  /* FFT de la fenetre spectrale 1B apodisee rearrangee*/
  /* taille SD_ALG_CalculPuissance2Sup(2*conf_autre->IDefS1cNbSWwidth+1) */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << nFFT
       << " elements pour DataThreadProduit->SAtfArrangee";
#endif
  DataThreadProduit->SAtfArrangee = new dcmplx[nFFT + SD_GES_MARGE];
  
  /* FFT inverse de SAtf */
  /* taille SD_ALG_CalculPuissance2Sup(2*conf_autre->IDefS1cNbSWwidth+1) */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << nFFT
       << " elements pour DataThreadProduit->TFInvSAtf";
#endif
  DataThreadProduit->TFInvSAtf = new dcmplx[nFFT + SD_GES_MARGE];
  
  /* Partie reelle de la FFT inverse de SAtf */
  /* taille SD_ALG_CalculPuissance2Sup(2*conf_autre->IDefS1cNbSWwidth+1) */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << nFFT
       << " elements pour DataThreadProduit->ReTFInvSAtf";
#endif
  DataThreadProduit->ReTFInvSAtf = new double[nFFT + SD_GES_MARGE];
  
  /* Spectre apodise temporaire */
  /* taille nFFT = SD_BAS_CalculPuissance2Sup (TailleFenetreSpectrale) */
  /* TailleFenetreSpectrale = 2*conf_autre->IDefS1cNbSWwidth + 1 */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << nFFT
       << " elements pour DataThreadProduit->SA2Padde";
#endif
  DataThreadProduit->SA2Padde = new double[nFFT + SD_GES_MARGE];
  
  /* Partie reelle de la FFT inverse de SAtf apres rearrangement des coeff */
  /* taille 2*conf_autre->IDefS1cNbSWwidth + 1 */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << 2*ConfAutre->IDefS1cNbSWwidth+1
       << " elements pour DataThreadProduit->SA1";
#endif
  DataThreadProduit->SA1 = new double[2*ConfAutre->IDefS1cNbSWwidth+1 + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << 2*ConfAutre->IDefS1cNbSWwidth+1
       << " elements pour DataThreadProduit->SA2";
#endif
  DataThreadProduit->SA2 = new double[2*ConfAutre->IDefS1cNbSWwidth+1 + SD_GES_MARGE];


  /* Variables initialement utilisees pour 41_CCS */
  /*----------------------------------------------*/
  int NbElements = SD_BAS_NPI_AVHRR * SD_BAS_NLI_MAX_UTIL_AVHRR;

  NbElements = SD_BAS_NLI_MAX_UTIL_AVHRR * SD_BAS_NBK;
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->AvhrrChannelState"
       << endl;
#endif
  DataThreadProduit->AvhrrChannelState = new unsigned int[NbElements + SD_GES_MARGE];

  NbElements = SD_BAS_NB_COL_SOND * SD_BAS_NB_LIN_SOND;
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->ImgYpsf"
       << endl;
#endif
  DataThreadProduit->ImgYpsf = new double[NbElements + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->ImgZpsf"
       << endl;
#endif
  DataThreadProduit->ImgZpsf = new double[NbElements + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->ImgWgtpsf"
       << endl;
#endif
  DataThreadProduit->ImgWgtpsf = new double[NbElements + SD_GES_MARGE];

  NbElements = SD_BAS_NPI_AVHRR * SD_BAS_NLI_MAX_UTIL_AVHRR;
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->IdPix"
       << endl;
#endif
  DataThreadProduit->IdPix = new int[NbElements + SD_GES_MARGE];

  NbElements = (SD_BAS_NPI_AVHRR * SD_BAS_NLI_MAX_UTIL_AVHRR) * SD_BAS_NBK;
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->RadNW"
       << endl;
#endif
  DataThreadProduit->RadNW = new float[NbElements + SD_GES_MARGE];

  NbElements = SD_BAS_NPI_AVHRR * SD_BAS_NLI_MAX_UTIL_AVHRR * SD_BAS_NCL_MAX;
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->Dist"
       << endl;
#endif
  DataThreadProduit->Dist = new double[NbElements + SD_GES_MARGE];

  NbElements = SD_BAS_IMCO * SD_BAS_IMLI;
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->ImgY0"
       << endl;
#endif
  DataThreadProduit->ImgY0 = new double[NbElements + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->ImgZ0"
       << endl;
#endif
  DataThreadProduit->ImgZ0 = new double[NbElements + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->ImgY"
       << endl;
#endif
  DataThreadProduit->ImgY = new double[NbElements + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->ImgZ"
       << endl;
#endif
  DataThreadProduit->ImgZ = new double[NbElements + SD_GES_MARGE];

  NbElements = SD_BAS_NPI_AVHRR * SD_BAS_NLI_MAX_UTIL_AVHRR * SD_BAS_NBK;
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->RadVectFov"
       << endl;
#endif
  DataThreadProduit->RadVectFov = new float[NbElements + SD_GES_MARGE];

  NbElements = SD_BAS_NPI_AVHRR * SD_BAS_NLI_MAX_UTIL_AVHRR;
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->IdPixFov"
       << endl;
#endif
  DataThreadProduit->IdPixFov = new int[NbElements + SD_GES_MARGE];

  NbElements = SD_BAS_NPI_AVHRR * SD_BAS_NLI_MAX_UTIL_AVHRR;
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->Index"
       << endl;
#endif
  DataThreadProduit->Index = new int[NbElements + SD_GES_MARGE];

  NbElements = (SD_BAS_NPI_AVHRR * SD_BAS_NLI_MAX_UTIL_AVHRR) * SD_BAS_NBK;
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->RadN"
       << endl;
#endif
  DataThreadProduit->RadN = new float[NbElements + SD_GES_MARGE];

  NbElements = SD_BAS_NPI_AVHRR * SD_BAS_NLI_MAX_UTIL_AVHRR;
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->UsedPixTest"
       << endl;
#endif
  DataThreadProduit->UsedPixTest = new unsigned int[NbElements + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->DistZero"
       << endl;
#endif
  DataThreadProduit->DistZero = new double[NbElements + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->Dist1"
       << endl;
#endif
  DataThreadProduit->Dist1 = new double[NbElements + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->IdPixAglo"
       << endl;
#endif
  DataThreadProduit->IdPixAglo = new int[NbElements + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->ImgIJ"
       << endl;
#endif
  DataThreadProduit->ImgIJ = new float[NbElements + SD_GES_MARGE];

  NbElements = SD_BAS_NPI_AVHRR * SD_BAS_NLI_MAX_UTIL_AVHRR * SD_BAS_NBK;
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << NbElements
       << " elements pour DataThreadProduit->Y"
       << endl;
#endif
  DataThreadProduit->Y = new float[NbElements + SD_GES_MARGE];
  /* Variables initialement utilisees pour 40_IAC */
  /*----------------------------------------------*/
   int Dl              = ConfAutre->IDefIacDLin;
   int Dc              = ConfAutre->IDefIacDCol;

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << 2*(Dl+1)
       << " elements pour DataThreadProduit->Ybar";
#endif
   DataThreadProduit->Ybar = new double[2*(Dl+1) + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << 2*(Dl+1)
       << " elements pour DataThreadProduit->Y2bar";
#endif
   DataThreadProduit->Y2bar = new double[2*(Dl+1) + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << 4*(Dl+1)*(Dc+1)
       << " elements pour DataThreadProduit->R";
#endif
   DataThreadProduit->R = new double[4*(Dl+1)*(Dc+1) + SD_GES_MARGE];


  /* Variables initialement utilisees par 44_GEO */
  /*----------------------------------------------*/
  int Ssize  = ConfAutre->IDefGeoIISSubGridSize;
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << Ssize*Ssize
       << " elements pour DataThreadProduit->SgIISY";
#endif
  DataThreadProduit->SgIISY = new double[Ssize*Ssize + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << Ssize*Ssize
       << " elements pour DataThreadProduit->SgIISZ";
#endif
  DataThreadProduit->SgIISZ = new double[Ssize*Ssize + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << Ssize*Ssize
       << " elements pour DataThreadProduit->SgIISRM";
#endif
  DataThreadProduit->SgIISRM = new double[2*Ssize*Ssize + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << Ssize*Ssize
       << " elements pour DataThreadProduit->lat";
#endif
  DataThreadProduit->lat = new double[Ssize*Ssize + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << Ssize*Ssize
       << " elements pour DataThreadProduit->lon";
#endif
  DataThreadProduit->lon = new double[Ssize*Ssize + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << Ssize*Ssize
       << " elements pour DataThreadProduit->Ang_mesY";
#endif
  DataThreadProduit->Ang_mesY = new double[Ssize*Ssize + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << Ssize*Ssize
       << " elements pour DataThreadProduit->Ang_mesZ";
#endif
  DataThreadProduit->Ang_mesZ = new double[Ssize*Ssize + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << Ssize*Ssize
       << " elements pour DataThreadProduit->Azim_sol";
#endif
  DataThreadProduit->Azim_sol = new double[Ssize*Ssize + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << Ssize*Ssize
       << " elements pour DataThreadProduit->Elev_sol";
#endif
  DataThreadProduit->Elev_sol = new double[Ssize*Ssize + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << Ssize*Ssize
       << " elements pour DataThreadProduit->IISCornerAvhrrLin";
#endif
  DataThreadProduit->IISCornerAvhrrLin = new double[Ssize*Ssize + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << Ssize*Ssize
       << " elements pour DataThreadProduit->IISCornerAvhrrCol";
#endif
  DataThreadProduit->IISCornerAvhrrCol = new double[Ssize*Ssize + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << Ssize*Ssize
       << " elements pour DataThreadProduit->LocIasiAvhrrLin";
#endif
  DataThreadProduit->LocIasiAvhrrLin = new double[Ssize*Ssize + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << Ssize*Ssize
       << " elements pour DataThreadProduit->LocIasiAvhrrCol";
#endif
  DataThreadProduit->LocIasiAvhrrCol = new double[Ssize*Ssize + SD_GES_MARGE];

#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << Ssize*Ssize
       << " elements pour DataThreadProduit->EarthSatDist";
#endif
  DataThreadProduit->EarthSatDist = new double[Ssize*Ssize + SD_GES_MARGE];

  /* Variables initialement utilisees par 100_EXS */
  /*----------------------------------------------*/
  /* Temperature de brillance min */
  /* taille = SD_BAS_SPCT_COD */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << SD_BAS_SPCT_COD
       << " elements pour DataThreadProduit->SpectreFroid";
#endif
  DataThreadProduit->SpectreFroid = new double[SD_BAS_SPCT_COD + SD_GES_MARGE];
  
  /* Temperature de brillance max */
  /* taille = SD_BAS_SPCT_COD */
#ifdef OPS_DEBUG
  cout << "Allocation de " 
       << SD_BAS_SPCT_COD
       << " elements pour DataThreadProduit->SpectreChaud";
#endif
  DataThreadProduit->SpectreChaud = new double[SD_BAS_SPCT_COD + SD_GES_MARGE];
#ifdef OPS_LIMIT
#define OPS_DEBUG
#undef OPS_LIMIT
#endif

}


//@ ------------------------------------------------------------------*/
//@ Methode : DesallouerPointeursDataThreadProduit
//@
//@ Description : Alloue les pointeurs de la structure t_SD_BAS_DataThreadProduit
//@
//@ Parametres :
//@
//@ Valeur de retour : 
//@
//@ ------------------------------------------------------------------*/
void SD_GES_ChaineProd1B_1C::DesallouerPointeursDataThreadProduit(t_SD_BAS_DataThreadProduit* DataThreadProduit)
{
  delete []  DataThreadProduit->Fcs;
  // FT-2765
  free_AUX_SD_BAS_InterpSpline1D( DataThreadProduit->y2isf );
  // ...FT-2765
  delete []  DataThreadProduit->OpdTab;
  delete []  DataThreadProduit->Opd;
  delete []  DataThreadProduit->Af;
  delete []  DataThreadProduit->Af0;
  delete []  DataThreadProduit->REtmp;
  delete []  DataThreadProduit->IMtmp;
  delete []  DataThreadProduit->REint;
  delete []  DataThreadProduit->IMint;
  delete []  DataThreadProduit->PlanckBBT;
  // FT-2765
  free_AUX_SD_BAS_InterpLineaire1D( DataThreadProduit->TabAuxESSLTailleWn0 );
  free_AUX_SD_BAS_InterpLineaire1D( DataThreadProduit->TabAuxESSLTailleWnOSSpect );
  // ...FT-2765
  delete []  DataThreadProduit->WnFcsTab;
  delete []  DataThreadProduit->Wn0;
  delete []  DataThreadProduit->FcsInterpolee;
  delete []  DataThreadProduit->WnSpect;
  delete []  DataThreadProduit->B1;
  delete []  DataThreadProduit->TRrs;
  delete []  DataThreadProduit->Bbb;
  delete []  DataThreadProduit->WnSpect1b;
  delete []  DataThreadProduit->OSFcsInterpolee;
  delete []  DataThreadProduit->WnOSSpect;
  delete []  DataThreadProduit->WnAf;
  delete []  DataThreadProduit->Spectre1bProlonge;
  delete []  DataThreadProduit->FctAmortissement;
  // FT-2765
  free_AUX_SD_BAS_InterpSpline1D( DataThreadProduit->CoeffSpline );
  // ...FT-2765
  delete []  DataThreadProduit->G;
  delete []  DataThreadProduit->S;
  delete []  DataThreadProduit->SpectrePadde;
  // FT-2765
  free_AUX_SD_BAS_FFT1DirDR2C( DataThreadProduit->aux1 );
  free_AUX_SD_BAS_FFT1DirInvDC2C( DataThreadProduit->aux12 );
  // ...FT-2765
  delete []  DataThreadProduit->Stf;
  delete []  DataThreadProduit->MoitieStf;
  delete []  DataThreadProduit->SAtf;
  delete []  DataThreadProduit->SAtfArrangee;
  delete []  DataThreadProduit->TFInvSAtf;
  delete []  DataThreadProduit->ReTFInvSAtf;
  delete []  DataThreadProduit->SA2Padde;
  delete []  DataThreadProduit->SA1;
  delete []  DataThreadProduit->SA2;
  delete [] DataThreadProduit->AvhrrChannelState;
  delete [] DataThreadProduit->ImgYpsf;
  delete [] DataThreadProduit->ImgZpsf;
  delete [] DataThreadProduit->ImgWgtpsf;
  delete [] DataThreadProduit->IdPix;
  delete [] DataThreadProduit->RadNW;
  delete [] DataThreadProduit->Dist;
  delete [] DataThreadProduit->ImgY0;
  delete [] DataThreadProduit->ImgZ0;
  delete [] DataThreadProduit->ImgY;
  delete [] DataThreadProduit->ImgZ;
  delete [] DataThreadProduit->RadVectFov;
  delete [] DataThreadProduit->IdPixFov;
  delete [] DataThreadProduit->Index;
  delete [] DataThreadProduit->RadN;
  delete [] DataThreadProduit->UsedPixTest;
  delete [] DataThreadProduit->DistZero;
  delete [] DataThreadProduit->Dist1;
  delete [] DataThreadProduit->IdPixAglo;
  delete [] DataThreadProduit->ImgIJ;
  delete [] DataThreadProduit->Y;
  delete []  DataThreadProduit->Ybar;
  delete []  DataThreadProduit->Y2bar;
  delete []  DataThreadProduit->R;
  delete []  DataThreadProduit->SgIISY;
  delete []  DataThreadProduit->SgIISZ;
  delete []  DataThreadProduit->SgIISRM;
  delete []  DataThreadProduit->lat;
  delete []  DataThreadProduit->lon;
  delete []  DataThreadProduit->Ang_mesY;
  delete []  DataThreadProduit->Ang_mesZ;
  delete []  DataThreadProduit->Azim_sol;
  delete []  DataThreadProduit->Elev_sol;
  delete []  DataThreadProduit->IISCornerAvhrrLin;
  delete []  DataThreadProduit->IISCornerAvhrrCol;
  delete []  DataThreadProduit->LocIasiAvhrrLin;
  delete []  DataThreadProduit->LocIasiAvhrrCol;
  delete []  DataThreadProduit->EarthSatDist;
  delete []  DataThreadProduit->SpectreFroid;
  delete []  DataThreadProduit->SpectreChaud;
}


//@ ------------------------------------------------------------------*/
//@ Methode : Maximum
//@
//@ Description : Retourne la valeur max d'un tableau
//@
//@ Parametres :
//@
//@ Valeur de retour : 
//@
//@ ------------------------------------------------------------------*/
int SD_GES_ChaineProd1B_1C::Maximum(int *tableau,
                                   int dimension
                                  )
{
  int maxi = tableau[0];
  for(int i = 1; i < dimension; i++)
    maxi = MAX(maxi, tableau[i]);
  return(maxi);
}
//@ ------------------------------------------------------------------*/
//@ Methode : Traiter
//@
//@ Description : Permet de traiter les ctx
//@
//@ Parametres :
//@
//@ Valeur de retour : 
//@
//@ ------------------------------------------------------------------*/
void SD_GES_ChaineProd1B_1C::Traiter(t_CMN__Statut& cr_op,
                                     t_SD_BAS_DataThread *ctx
                                    )
{
  //@ SI erreur
  if(cr_op != CMN__STATUT_OK)
  {
    //@ emission des messages du ctx
    EnvoyerMessagesStockes(&(ctx->cr.msgJDB));
    InitialiserListeErreurs(&(ctx->cr.errinterne));
  }
}
