static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/TAC/src/SD_TAC_ContexteDeTache.cc,v 1.3 2011/11/25 10:17:45 dpauly Exp $";
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_TAC
//@ CLASSE : SD_TAC_ContexteDeTache
//@ 
//@ Commentaire :
//@    Ce module gere la classe SD_TAC_ContexteDeTache, qui contient
//@    les informations relatives au contexte d'execution d'une tache
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 24/08/1999 : SAS
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ SMM-M4-FA-2366-CN 02/10/01 GRT rajout de la liste des fichiers deja recuperes
//@ --------------------------------------------------------------------
//@ SMM-DM-M4-GO-21329  27/11/01        GRT     Import export sur une periode
//@ --------------------------------------------------------------------
//@ SMM-M4-FA-2490-CN   11/12/01    GRT on gere la liste des fichiers origine dans le cas d'un export zippe
//@ --------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Adaptation a l'OPS : changement des donnees du contexte d'une tache
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Commun.h"
#include "CMN__Date.h"
#include "SD_TAC_ContexteDeTache.h"


//
// Definition des constantes
//


//======================================================================
//                                      METHODES PUBLIQUES
//======================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : SD_TAC_ContexteDeTache
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_TAC_ContexteDeTache::SD_TAC_ContexteDeTache()
  : m_ActionCourante(0), m_NomTravail(""), m_IndiceLigne(1), 
    m_NbRessources(1), m_SignalerTemps(CMN__FAUX)
{
  //@ Initialisation des proprietes du contexte de tache a leur valeur
  //@ par defaut
}


//@ ------------------------------------------------------------------*/
//@ Methode : ~SD_TAC_ContexteDeTache
//@
//@ Description : Destructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_TAC_ContexteDeTache::~SD_TAC_ContexteDeTache()
{
}


//======================================================================
//                                      METHODES PRIVEES
//======================================================================
