// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/TAC/src/SD_TAC_ContexteDeTache.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_TAC
//@ CLASSE : SD_TAC_ContexteDeTache
//@
//@ Commentaire :
//@    Fichier d'entete de la classe SD_TAC_ContexteDeTache
//@                                                                     
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 24/08/1999 : SAS
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ SMM-M4-FA-2366-CN 02/10/01 GRT on gere dans le contexte la liste des fichiers importes le coup precedent
//@ --------------------------------------------------------------------
//@ SMM-DM-M4-GO-21329  27/11/01        GRT     Import export sur une periode
//@ --------------------------------------------------------------------
//@ SMM-M4-FA-2490-CN   11/12/01    GRT on gere la liste des fichiers origine dans le cas d'un export zippe
//@ --------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Adaptation a l'OPS : changement des donnees du contexte d'une tache
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_TAC_ContexteDeTache_h
#define SD_TAC_ContexteDeTache_h


//
// Fichiers include
//

// STL

// Standard

// Projet


class SD_TAC_ContexteDeTache {

    /*================================================================*/

 public:
    
    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    SD_TAC_ContexteDeTache();
    
    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    virtual ~SD_TAC_ContexteDeTache();


    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    void     ActionCourante(int noAction) {m_ActionCourante = noAction;};
    int      ActionCourante() {return m_ActionCourante;};

    void     NomTravail(t_Chaine& nomTravail)
        {m_NomTravail = nomTravail;};
    t_Chaine NomTravail() {return m_NomTravail;};

    void     IndiceLigne(int indiceLigne) {m_IndiceLigne = indiceLigne;};
    int      IndiceLigne() {return m_IndiceLigne;};
        
    void     NbRessources(int unNombre) {m_NbRessources = unNombre;};
    int      NbRessources() {return m_NbRessources;};
        
    void     SignalerTemps(t_CMN__Booleen signalerTemps)
                {m_SignalerTemps = signalerTemps;};
    t_CMN__Booleen SignalerTemps() {return m_SignalerTemps;};

 
    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////


    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////
    
    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////


    /*================================================================*/

 private:
    
    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
    int              m_ActionCourante;  // Defini par TacheDeTraitement
    t_Chaine         m_NomTravail;      // Defini par Echeancier
    int              m_IndiceLigne;     // Defini par Echeancier
    int              m_NbRessources;    // Defini par Echeancier
    t_CMN__Booleen   m_SignalerTemps;   // Defini par Echeancier
};
#endif

