// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/TAC/src/SD_TAC_Tache.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_TAC
//@ CLASSE : SD_TAC_Tache
//@
//@ Commentaire :
//@    Fichier d'entete de la classe SD_TAC_Tache
//@                                                                     
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 10/08/1999 : SAS
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Adaptation a l'OPS : modification des attributs d'une tache
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_TAC_Tache_h
#define SD_TAC_Tache_h


//
// Fichiers include
//

// STL
#include <iostream>
#include <list>

// Standard
#include <unistd.h>

// Projet
#include "CMN__Date.h"
#include "SD_TAC_ContexteDeTache.h"
#include "SD_ACT_Action.h"


class SD_FRW_ApplicationServeurDonnees;

class SD_TAC_Tache {
    
    /*================================================================*/
    
 public:
    
    ////////////////////////////////
    // Type
    ////////////////////////////////
    typedef list<SD_ACT_Action*> t_ListeAction;

    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    SD_TAC_Tache();
    
    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    virtual ~SD_TAC_Tache();

    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    void     Id(int id) {m_Id = id;};
    int      Id() {return m_Id;};

    void     NomTache(t_Chaine nom) {m_NomTache = nom;};
    t_Chaine NomTache() {return m_NomTache;};

    void     TypeTache(t_Chaine nom) {m_TypeTache = nom;};
    t_Chaine TypeTache() {return m_TypeTache;};

    void     Contexte(SD_TAC_ContexteDeTache* contexte)
                {m_Contexte = contexte;};
    SD_TAC_ContexteDeTache*  Contexte() {return m_Contexte;};

    void     Application(SD_FRW_ApplicationServeurDonnees* application)
                {m_Application = application;};
    SD_FRW_ApplicationServeurDonnees* Application()
        {return m_Application;};

    void     Simulation(int simulation) {m_Simulation = simulation;};
    int      Simulation() {return m_Simulation;};

    t_Chaine ActionCourante() {return m_ActionCourante;};
    void     ActionCourante(t_Chaine action) {m_ActionCourante = action;};

    t_CMN__Booleen  EstActive() {return m_EstActive ;}
    void     EstActive(t_CMN__Booleen unEtat) {m_EstActive = unEtat;}

    void     DateCreation(CMN__Date& dateCreation)
                {m_DateCreation = dateCreation;};
    CMN__Date DateCreation() {return m_DateCreation;};

    void     DateDebut(CMN__Date& dateDebut)
                {m_DateDebut = dateDebut;};
    CMN__Date DateDebut() {return m_DateDebut;};

    void     DateFin(CMN__Date& dateFin)
                {m_DateFin = dateFin;};
    CMN__Date DateFin() {return m_DateFin;};

    void     Arreter() {m_Arreter = CMN__VRAI;};
    

    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    virtual void                TracerFin();
    virtual void                TracerDemarrage();
    t_CMN__Booleen              VerifierConditionArret();
    virtual void                Executer();
    virtual t_CMN__Booleen      EstTerminee();
    virtual void                AjouterAction(SD_ACT_Action* action);
    

    /*================================================================*/

 protected:
        
    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////
    
    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////
    int                                  m_Id;
    t_Chaine                             m_NomTache;
    t_Chaine                             m_TypeTache;
    SD_TAC_ContexteDeTache*              m_Contexte;
    SD_FRW_ApplicationServeurDonnees*    m_Application;
    int                                  m_Simulation;
    t_ListeAction                        m_Actions;
    t_Chaine                             m_ActionCourante;
    t_CMN__Booleen                       m_EstActive;
    t_CMN__Booleen                       m_EstTerminee;
    CMN__Date                            m_DateCreation;
    CMN__Date                            m_DateDebut;
    CMN__Date                            m_DateFin;
    t_CMN__Booleen                       m_Arreter;


    /*================================================================*/

 private:
        
    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////
    
    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
 
};

#endif
