// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/UTL/src/SD_UTL_Facteur.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD_UTL
//@ CLASSE : SD_UTL_Facteur
//@
//@ Commentaire :
//@    Ce fichier gere la classe SD_UTL_Facteur
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_UTL_Facteur_h
#define SD_UTL_Facteur_h

//
// Fichiers include
//

// STL

// Standard

// Projet
#include "SD_UTL_GestionnaireActivite.h"


class SD_UTL_Facteur {
    
    /*================================================================*/
    
 public:
    
    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    SD_UTL_Facteur();
    
    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    virtual ~SD_UTL_Facteur();
    
    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    
    
    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    void Initialiser(const t_Chaine mode);
    void Lancer();
    void Terminer();
    
    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////
    
    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////

    
    /*================================================================*/

 private:
     
    ////////////////////////////////
    // Type definitions
    ////////////////////////////////

    // Mode d'execution
    typedef enum 
    {
        MODE_NORMAL,
        MODE_AUTO
    } e_ModeExecution;

    ////////////////////////////////
    // Constantes
    ////////////////////////////////
    static const int      BUFFER_SIZE;
    static const t_Chaine FICHIER_CONSOLE;
    static const t_Chaine MSG_SERVER_HOST;
    static const t_Chaine MSG_SERVER_PORT;
   
    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
    
    // Gestionnaire d'activites
    SD_UTL_GestionnaireActivite m_GestionnaireActivite;

    // Mode d'execution
    e_ModeExecution             m_ModeExecution;

    // Timeout d'attente pour la lecture des messages
    int                         m_AttenteAUTO;
};

#endif
