// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/UTL/src/SD_UTL_GestionnaireActivite.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : SD_UTL
//@ CLASSE : SD_UTL_GestionnaireActivite
//@
//@ Commentaire :
//@    Ce fichier gere la classe SD_UTL_GestionnaireActivite
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef SD_UTL_GestionnaireActivite_h
#define SD_UTL_GestionnaireActivite_h

//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Commun.h"
#include "MSG__Connexion.h"
#include "CMN_DAT_WorkOrder.h"
#include "SD_DON_Traitement.h"


class SD_UTL_GestionnaireActivite 
{

    /*================================================================*/

 public:
    
    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    SD_UTL_GestionnaireActivite();
    
    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    ~SD_UTL_GestionnaireActivite();
    
    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    int NbTraitement() {return m_ListeTraitement.size();};

    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    void           ConnecterServeur(char *host, char *service);
    void           Ecouter();
    void           Terminer(t_CMN__Booleen flagFin) 
        {m_FlagFin = flagFin;};
    t_CMN__Booleen Terminer() {return m_FlagFin;};
    void           StopperProcess(t_Chaine nomProcess);
    void           StopperTraitement();
    void           DemarrerTraitement(t_Chaine fichierWorkOrder,
                                      t_CMN__Booleen analyseRealisee);


    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////
    
    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////

    
    /*================================================================*/

 private:
    
    ////////////////////////////////
    // Constantes
    ////////////////////////////////
    static const t_Chaine ENV_DUREE_GRANULE;
    static const int      DEFAUT_DUREE_GRANULE;

    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////
    void ManageException(ERR__Exception exception);
    void TraiterMessage(const MSG__Message& message);
    void IdentifierTraitement(CMN_DAT_WorkOrder& workOrder) 
        throw (ERR__Exception);

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////

    // Flag de fin
    t_CMN__Booleen    m_FlagFin;
        
    // Connexion avec le serveur
    MSG__Connexion    m_ConnexionServeur;

    // Duree d'un granule
    int               m_DureeGranule;
    
    // Liste des traitements
    t_ListeTraitement m_ListeTraitement;
};

#endif
