// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/TES/src/TES__GestionnaireActivite.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : TES
//@ CLASSE : TES__GestionnaireActivite
//@
//@ Commentaire :
//@    Ce fichier gere la classe TES__GestionnaireActivite
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 21/03/2000 : A.MONTMORY
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef TES__GestionnaireActivite_h
#define TES__GestionnaireActivite_h

//
// Fichiers include
//

// STL

// Standard

// Projet
#include "TES__GestionnaireEvenement.h"


class TES__GestionnaireActivite {

    /*=================================================================*/

 public:
    
    //
    // Constructeur
    //
    TES__GestionnaireActivite();
    
    //
    // Destructeur
    //
    ~TES__GestionnaireActivite();
    
    //
    // Accesseurs
    //
    
    //
    // Methodes publiques
    //
    void ConnecterServeur(char *host, char *service);
    void Ecouter();
    void Terminer(bool flagFin) {m_FlagFin = flagFin;};
    bool Terminer() {return m_FlagFin;};
    void EnvoyerMessage(MSG__Message& message);

    /*=================================================================*/

protected:

    //
    // Methodes protegees
    //
    
    //
    // Attributs proteges
    //
    
    
    /*=================================================================*/

 private:

    typedef enum {
	EVT_DEST_DEF = 0,
	EVT_DEST_PLAN,
	EVT_AJOUT,
	EVT_MAJ_INV
    } e_TypeLogique;

    //
    // Methodes privees
    //
    void TraiterMessage(const MSG__Message& message);
    void AjouterEvenement(TES__Evenement& evenementTimer);
    void DetruireEvenement(const TES__Evenement& evenementTimer);
    void TirerEvenement();

    //
    // Attributs prives
    //
    
    // Gestionnaire des evenements
    TES__GestionnaireEvenement m_Evenements;
    
    // Gestionnaire d'adresse
    MSG__Connexion             m_ConnexionServeur;
    
    // Flag de fin
    bool                       m_FlagFin;
};

#endif
