// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/TES/src/TES__GestionnaireEvenement.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : TES
//@ CLASSE : TES__GestionnaireEvenement
//@
//@ Commentaire :
//@    Ce fichier gere la classe TES__GestionnaireEvenement
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 21/03/2000 : A.MONTMORY
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef TES__GestionnaireEvenement_h
#define TES__GestionnaireEvenement_h

//
// Fichiers include
//

// STL
#include <map>

// Standard

// Projet
#include "CMN__Commun.h"
#include "TES__Evenement.h"
#include "MSG__Connexion.h"


class TES__GestionnaireEvenement {

    /*=================================================================*/

 public:
    
    //
    // Liste des evenements
    //
    typedef multimap<double, TES__Evenement, less<double> > t_ListeEvenement;
	
    //
    // Constructeur
    //
    TES__GestionnaireEvenement();
    
    //
    // Destructeur
    //
    ~TES__GestionnaireEvenement();
    
    //
    // Accesseurs
    //
    t_ListeEvenement GetListeEvenement() const {return m_ListeEvenement;};
    double           GetResolution() const {return m_Resolution;};
    void             SetResolution(const double resolution)
	{m_Resolution = resolution;};
    MSG__Connexion*  GetConnexion() const {return m_ptConnexionSrv;};
    void             SetConnexion(MSG__Connexion* pt) {m_ptConnexionSrv = pt;};

    //
    // Methodes publiques
    //
    void AjouterEvenement(TES__Evenement& evenementTimer);
    void DetruireEvenement(const TES__Evenement& evenementTimer);
    void TirerEvenement();


    /*=================================================================*/

 protected:

    //
    // Methodes protegees
    //

    //
    // Attributs proteges
    //

    
    /*=================================================================*/

 private:
    
    //
    // Methodes privees
    //
    
    //
    // Attributs prives
    //
    
    // Liste des evenements geres dans le gestionnaire d'evenement
    t_ListeEvenement m_ListeEvenement;
	
    // Resolution de la base de temps
    double           m_Resolution;
	
    // Pointeur vers la connexion serveur
    MSG__Connexion*  m_ptConnexionSrv;
};

#endif
