// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/WOM/src/WOM__Message.h,v 1.3 2011/11/25 10:17:45 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : WOM
//@ CLASSE : WOM__Message
//@
//@ Commentaire :
//@    Ce fichier gere la classe WOM__Message
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ FA-ID : IA-2100-FA-130-CN : 16/09/2004 : P.CABANE
//@ If work order contains missing files, it's coded all the same
//@ (later the treatment will detect if missing file is mandatory).
//@ A warning message is sent
//@ fiche de correction correspondante : IA-2100-FC-130-THA
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef WOM__Message_h
#define WOM__Message_h


//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Commun.h"
#include "MSG__Message.h"


class WOM__Message {
    
    /*================================================================*/

 public:
    
    ////////////////////////////////
    // Type definitions
    ////////////////////////////////

    // Type des messages JDB utilises par le WOM
    typedef enum {
        WOM_SET                      = 1,
        MSG_WOM_START                = WOM_SET,
        MSG_WOM_STOP_OK              = WOM_SET+1,
        MSG_WOM_STOP_ON_ERROR        = WOM_SET+2,
        MSG_UNEXPECTED_MSG           = WOM_SET+3,
        MSG_UNEXPECTED_EXP           = WOM_SET+4,
        MSG_UNEXPECTED_TYP           = WOM_SET+5,
        MSG_WOM_MESSAGE              = WOM_SET+6,
        MSG_WOM_ERROR                = WOM_SET+7,
        MSG_WOM_STATE                = WOM_SET+8,
        MSG_WOM_STEP_BEGIN           = WOM_SET+9,
        MSG_WOM_STEP_END             = WOM_SET+10,
        MSG_WOM_STEP_SUSPEND         = WOM_SET+11,
        MSG_WOM_STEP_RESUME          = WOM_SET+12,
        MSG_WOM_STEP_BREAK           = WOM_SET+13,
        MSG_WOM_STEP_STOP            = WOM_SET+14,
        MSG_WOM_STEP_ERROR           = WOM_SET+15,
        MSG_WOM_STEP_DATA_NOT_FOUND  = WOM_SET+16,
        MSG_WOM_STEP_DATA_PRODUCED   = WOM_SET+17,
        MSG_WOM_STEP_AUX_PRODUCED    = WOM_SET+18,
        MSG_WOM_STEP_REPORT_PRODUCED = WOM_SET+19,
        MSG_WOM_STEP_DATA_PCD        = WOM_SET+20,
        MSG_WOM_WO_VALID             = WOM_SET+21,
        MSG_WOM_WO_INVALID           = WOM_SET+22,
        MSG_WOM_FILE_WRITE_ERROR     = WOM_SET+23,
        MSG_WOM_FILE_OPEN_ERROR      = WOM_SET+24,
        MSG_WOM_ENV_UNDEFINED        = WOM_SET+25,
        /* FA130 */
        MSG_WOM_WO_MISSING_FILE      = WOM_SET+26,
        MSG_FIN                      = WOM_SET+27 // to mark the set end
       /* FIN FA130 */
    } e_TypeMessageJDB;


    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    WOM__Message();
    
    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    virtual ~WOM__Message();

    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////

    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////

    
    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////


    /*================================================================*/

 private:
    
    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
};

#endif
