// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/WOM/src/WOM__ServeurWorkOrder.h,v 1.3 2011/11/25 10:17:46 dpauly Exp $
//@ -------------------------------------------------------------------
//@ Composant : WOM
//@ CLASSE : WOM__ServeurWorkOrder
//@
//@ Commentaire :
//@    Fichier d'interface de la classe WOM__ServeurWorkOrder, qui
//@    est le point d'entree du Work Order Manager
//@
//@ -------------------------------------------------------------------
//@ HISTORIQUE
//@ -------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ -------------------------------------------------------------------

#ifndef WOM__ServeurWorkOrder_h
#define WOM__ServeurWorkOrder_h

//
// Fichiers include
//

// STL

// Standard

// Projet
#include "MP__ArretProcess.h"
#include "WOM__GestionnaireActivite.h"


class WOM__ServeurWorkOrder {
    
    /*================================================================*/
    
public:
    
    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    WOM__ServeurWorkOrder();
    
    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    ~WOM__ServeurWorkOrder();
    
    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
   
    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    void Initialiser();
    void Lancer();
    void Terminer(MP__ArretProcess::e_EtatFinProcessus etat);
    

    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////

    
    /*================================================================*/

 private:

    ////////////////////////////////
    // Constantes
    ////////////////////////////////
    static const t_Chaine MSG_SERVER_HOST;
    static const t_Chaine MSG_SERVER_PORT;
 
    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////
   
    // Liste des connexions gere dans le gestionnaire de connexion
    WOM__GestionnaireActivite m_GestionnaireActivite;
};

#endif
