// $Header: /root/indusdrci/artf84050/IASI_OPS/OPS/WOM/src/WOM__WorkOrder.h,v 1.3 2011/11/25 10:17:46 dpauly Exp $
//@ --------------------------------------------------------------------
//@ Composant : WOM
//@ CLASSE : WOM__WorkOrder
//@
//@ Commentaire :
//@    Fichier d'interface de la classe WOM__WorkOrder, qui gere
//@    un Work Order et son (ou ses) traitement(s) associe(s)
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 15/11/2002 : P. CABANE
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

#ifndef WOM__WorkOrder_h
#define WOM__WorkOrder_h

//
// Fichiers include
//

// STL

// Standard

// Projet
#include "CMN__Commun.h"
#include "ERR__Exception.h"
#include "CMN_DAT_WorkOrder.h"
#include "CMN_DAT_StageInfo.h"
#include "SD_DON_Traitement.h"


class WOM__WorkOrder 
{
    /*================================================================*/

 public:
   
    ////////////////////////////////
    // Constructeur
    ////////////////////////////////
    WOM__WorkOrder();
    WOM__WorkOrder(int id, t_Chaine nom, t_Chaine fichier);
     
    ////////////////////////////////
    // Destructeur
    ////////////////////////////////
    ~WOM__WorkOrder();
    
    ////////////////////////////////
    // Accesseurs
    ////////////////////////////////
    int                   Id() {return m_Id;};
    CMN_DAT_WorkOrder&    Data() {return m_Data;};

    ////////////////////////////////
    // Methodes publiques
    ////////////////////////////////
    void               IdentifierTraitement() throw (ERR__Exception);
    SD_DON_Traitement* TraitementCourant() throw (ERR__Exception);
    void               MettreAJour(SD_DON_Traitement& traitement);
    t_CMN__Booleen     EstTermine();
    void               CreerRapport(t_Chaine& rapport, 
                                    t_ListeChaine& listeProduit,
                                    t_ListeChaine& listeAux);


    /*================================================================*/

 protected:

    ////////////////////////////////
    // Methodes protegees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs proteges
    ////////////////////////////////


    /*================================================================*/

 private:

    ////////////////////////////////
    // Constantes
    ////////////////////////////////
    static const t_Chaine ENV_DUREE_GRANULE;
    static const int      DEFAUT_DUREE_GRANULE;
    static const t_Chaine EXT_RAPPORT;
    static const t_Chaine MSG_NO_MHS_TELEMETRY;
    static const t_Chaine MSG_END_OF_STAGE;
    static const t_Chaine ERR_REPORT_CREATION;
    static const t_Chaine BAD_NUMBER_OF_TMT;

    /* FA171 */
    static const t_Chaine s_SPACECRAFT_ID;
    static const t_Chaine SPACECRAFT_ID_DEFAUT;
    
    ////////////////////////////////
    // Methodes privees
    ////////////////////////////////

    ////////////////////////////////
    // Attributs prives
    ////////////////////////////////

    // Identifiant du Work Order
    int                  m_Id;

    // Nom du Work Order
    t_Chaine             m_Nom;

    // Nom complet du fichier Work Order
    t_Chaine             m_Filename;

    // Duree d'un granule
    int                  m_DureeGranule;

    // Donnees WorkOrder
    CMN_DAT_WorkOrder    m_Data;
    
    // Liste des traitements
    t_ListeTraitement    m_ListeTraitement;
};

#endif
