#!/bin/bash

# Build AAPP, OPS-LRS, and Metopizer in Singularity container

# Set version and container
VERSION=8.4
CONTAINER=aapp_${VERSION}.simg

# Build AAPP, OPS-LRS, and Metopizer
echo -e "\nBuilding AAPP, OPS-LRS, Metopizer"
sudo singularity build $CONTAINER Singularity_aapp_${VERSION}

# Save the tarfiles (saves time on next build)
echo -e "\nSaving tarfiles"
singularity run -B $PWD:/mnt $CONTAINER rsync -av /opt/tarfiles $PWD

# Create AAPP data directory on local host (so it can be updated offline) 
echo -e "\nCreating AAPP data directory"
mkdir AAPP 
mkdir AAPP/orbelems
mkdir AAPP/aux_data
lftp -c "mirror --parallel=8 --continue ftp://ftp.eumetsat.int/pub/NWPSAF/aapp_data_files/OPS-LRS/aux_data AAPP/aux_data"
singularity run -B $PWD:/mnt $CONTAINER rsync -av /opt/install/AAPP_${VERSION}/AAPP/data AAPP

echo -e "\nDone"
exit 0
