#!/bin/bash

# Update AAPP ancillary data

# Set version and container
VERSION=8.4
CONTAINER=aapp_${VERSION}.simg

# Update OPS-LRS auxiliary data
echo -e "\nUpdating OPS-LRS auxiliary data"
./get_aux_files.sh AAPP/aux_data

# Update AAPP calibration files
echo -e "\nUpdating AAPP calibration files"
export AAPP_PREFIX=$PWD
./get_atovs_cal_files.sh

# Update orbital elements
echo -e "\nUpdating TLEs"
singularity run -B $PWD:/mnt,$PWD/AAPP/orbelems:/opt/install/AAPP_${VERSION}/AAPP/orbelems $CONTAINER get_tle
