#!/bin/bash

cd $HOME/AIX/metopizer

make distclean
./configure --prefix=$HOME/AIX
make
make install

cd src

PREFIX=$HOME/AIX

for cpp in common.cpp ccsds.cpp eps.cpp ccsdsreader.cpp filereader.cpp \
sband.cpp pyamsuareader.cpp pyascatreader.cpp pyavhrrreader.cpp pygrasreader.cpp \
pyhirsreader.cpp pyiasireader.cpp pygomereader.cpp pysemreader.cpp \
pymhsreader.cpp pyreader.cpp pymetopizer.cpp pyhktmreader.cpp; do echo Compiling $cpp \
&& g++ -pthread -g -O0 -DMAJOR_VERSION=1 -DMINOR_VERSION=1 -DHAVE_CONFIG_H -DPYMETOPIZER -DNO_INFINITY -DNO_NAN -c $cpp -I.. \
-I$PREFIX/include/python2.6 -o $cpp.o; done

echo Linking
$PREFIX/lib/python2.6/config/ld_so_aix g++ \
-bI:$PREFIX/lib/python2.6/config/python.exp \
-O0 -shared \
common.cpp.o \
ccsds.cpp.o eps.cpp.o ccsdsreader.cpp.o filereader.cpp.o sband.cpp.o \
pyamsuareader.cpp.o pyavhrrreader.cpp.o pyascatreader.cpp.o pygrasreader.cpp.o \
pyhirsreader.cpp.o pyiasireader.cpp.o pygomereader.cpp.o pyhktmreader.cpp.o \
pymhsreader.cpp.o pyreader.cpp.o pymetopizer.cpp.o pysemreader.cpp.o \
-L/opt/freeware/lib/gcc-lib/powerpc-ibm-aix5.1.0.0/3.3.2/pthread \
-ljpeg -lpng `xml2-config --libs` -lz -o metopizer.so
