# This script will build and install Metopizer and Metopizer Python extension
# on the EPS CGS build environment (AIX + gcc compiler)

#PREFIX=/opt/cots/python2.5

CC=gcc CXX=g++ CXXFLAGS="-DNO_INFINITY -DNO_NAN" ./configure --disable-python --prefix=$PREFIX

gmake
gmake install

cd src
for cpp in common.cpp ccsds.cpp eps.cpp ccsdsreader.cpp filereader.cpp \
sband.cpp pyamsuareader.cpp pyascatreader.cpp pyavhrrreader.cpp pygrasreader.cpp \
pyhirsreader.cpp pyiasireader.cpp pygomereader.cpp pysemreader.cpp \
pymhsreader.cpp pyreader.cpp pymetopizer.cpp pyhktmreader.cpp; do echo Compiling $cpp \
&& g++ -O0 -DHAVE_CONFIG_H -DPYMETOPIZER -DNO_INFINITY -DNO_NAN -c $cpp -I.. \
-I$PREFIX/include/python2.5 -o $cpp.o; done

$PREFIX/lib/python2.5/config/ld_so_aix g++ \
-bI:$PREFIX/lib/python2.5/config/python.exp -shared -O0 common.cpp.o \
ccsds.cpp.o eps.cpp.o ccsdsreader.cpp.o filereader.cpp.o sband.cpp.o \
pyamsuareader.cpp.o pyavhrrreader.cpp.o pyascatreader.cpp.o pygrasreader.cpp.o \
pyhirsreader.cpp.o pyiasireader.cpp.o pygomereader.cpp.o pyhktmreader.cpp.o \
pymhsreader.cpp.o pyreader.cpp.o pymetopizer.cpp.o pysemreader.cpp.o \
-L/opt/freeware/lib/gcc-lib/powerpc-ibm-aix5.1.0.0/3.3.2/pthread -o metopizer.so

strip metopizer.so

mkdir -p $PREFIX/lib/python2.5/site-packages
rm -f $PREFIX/lib/python2.5/site-packages/metopizer.so
cp metopizer.so $PREFIX/lib/python2.5/site-packages
