#ifndef brd_defined
#define brd_defined

#pragma pack(1)
struct BRD
{
	int32_be	 IDefIssueIcd;			/* Issue number of the format of the confi	 n/a		*/
	int32_be	 IDefRevisionIcd;			/* Revision number of the format of the co	 n/a		*/
	int32_be	 IDefPTSI;				/* Identification of the on-board tables (	 n/a		*/
	int32_be	 IDefIDConf;			/* Identification of the configuration of	 n/a		*/
	int32_be	 IDefSdbID;				/* Identification of the spectral database	 n/a		*/
	int32_be	 IDefStableparamID;			/* Identification of the stable configurat	 n/a		*/
	uint16_be pack;
	short_cds_time IDefParamDate;			/* Date of the validity period of the IASIDate			*/
	int32_be	 IDefMETOPNumber;			/* Number of the METOP satellite			 n/a		*/
	int32_be	 ICtcNbSeg[4];			/* On-board spectra coding : number of spe	 n/a		*/
	int32_be	 IDefNSegNsFirst;			/* Number of the first sample of the first	 n/a		*/
	int32_be	 ICtcTabNbBit[4][550];		/* On-board spectra coding : number of bit	 n/a		*/
	int32_be	 ICtcTabOffset[4][550];		/* On-board spectra coding : scaling facto	 n/a		*/
	float64_be	 ICtcTabOffsetC[4];			/* On-board spectra coding : scaling facto	 none		*/
	float64_be	 ICtcTabOffsetM[4];			/* On-board spectra coding : scaling facto	 none		*/
	int32_be	 ICtcTabScale[4][550];		/* On-board spectra coding : scaling facto	 n/a		*/
	float64_be	 ICtcTabScaleC[4];			/* On-board spectra coding : scaling facto1/(W/m2/sr)	*/
	float64_be	 ICtcTabScaleM[4];			/* On-board spectra coding : scaling facto1/(W/m2/sr)	*/
	int32_be	 IDefArcNbNsSeg[3];			/* Number of samples per 100cm-1 spectral	 n/a		*/
	int32_be	 IDefArcNbSeg[3];			/* Number of 100cm-1 spectral interval use	 n/a		*/
	float64_be	 IDefBBEmissivity[8500];		/* Black body emissivity					 none		*/
	int32_be	 IDefBBNbRrs;			/* Number of radiative surfaces in the bla	 n/a		*/
	float64_be	 IDefBBRRs[10];			/* Emissivity of the radiative surfaces		 none		*/
	int32_be	 IDefCcsChannelId[6];		/* Radiance analysis : identification of AAvhrr chan	*/
	float64_be	 IDefCcsChannelNoise[6];		/* Radiance analysis : AVHRR channels nois	 none		*/
	float64_be	 IDefCcsChannelWn[6];		/* Radiance analysis : AVHRR channels wavem-1			*/
	int32_be	 IDefCcsChannelWgt[2][6];		/* Weight of the channel for each of the 2	 n/a		*/
	int32_be	 IDefCcsDimClassSpace;		/* Radiance analysis : number of AVHRR cha	 n/a		*/
	float64_be	 IDefCcsDistAgloInit;		/* Radiance analysis : initial value of th	 none		*/
	float64_be	 IDefCcsDistMax;			/* Radiance analysis : maximum distance be	 none		*/
	float64_be	 IDefCcsGlueCutoff;			/* Radiance analysis : Clusters coalsescen	 none		*/
	int32_be	 IDefCcsImgClLinMax;		/* Maximal number of lines of the classifi	 none		*/
	int32_be	 IDefCcsImgClColMax;		/* Maximal number of columns of the classi	 none		*/
	float64_be	 IDefCcsIterConvCutoff;		/* Radiance analysis : convergence thresho	 none		*/
	int32_be	 IDefCcsMinIterNCCutoff;		/* Radiance analysis : minimum number of i	 n/a		*/
	int32_be	 IDefCcsMode;			/* Flag indicationg the functionning mode	 n/a		*/
	int32_be	 IDefCcsNbClusMax;			/* Radiance analysis : maximum number of c	 n/a		*/
	int32_be	 IDefCcsNbIterMax;			/* Radiance analysis : maximum number of i	 n/a		*/
	int32_be	 IDefCcsNbNonClassifMax;		/* Radiance analysis : maximum number of u	 n/a		*/
	int32_be	 IDefCcsRadToTb;			/* Radiance analysis : flag for radiance t	 n/a		*/
	int32_be	 IDefCcsSortingChannel;		/* Radiance analysis : AVHRR channel used Avhrr chan	*/
	float64_be	 IDefCcsSplitCutoff;		/* Radiance analysis : Clusters splitting	 none		*/
	float64_be	 IDefCovarEigenValCalRad;		/* Noise index associated to radiometric c	 none	   */
	float64_be	 IDefCovarEigenValSpect;		/* Noise index associated to spectral cali	 none		*/
	int32_be	 IDefCtcNbNsSeg;			/* Number of samples per spectral region IASI sampl		*/
	float64_be	 IDefCovarMatEigenVal1b[2][100];	/* Level 1b noise variance-covariance matr	 n/a		*/
	float64_be	 IDefCovarMatEigenVal1c[2][100];	/* Level 1c noise variance-covariance matr	 n/a		*/
	float64_be	 IDefDptGainCoeffCutoff;		/* Gain loss admissible with respect to m	none		*/
	int32_be	 IDefDptIISInHomPixMax;		/* Maximum number a IIS pixel can be no-ho	 n/a		*/
	float64_be	 IDefDptIISVarianceCutoff;		/* Threshold for pseudo variance of the II(W/m2/sr/m  */
	int32_be	 IDefDptNbCycleFilter;		/* Number of filtering cycles in DPT algorIASI lines	*/
	float64_be	 IDefDurFltIsrfemOff;		/* Maximum duration of the degraded case				*/
	float64_be	 IDefDurBandMiss;			/* Maximum duration of the degraded case				*/
	float64_be	 IDefDurBBTMiss;			/* Maximum duration of the degraded case				*/
	float64_be	 IDefDurImgEWMiss;			/* Maximum duration of the degraded case				*/
	float64_be	 IDefDurImgBBMiss;			/* Maximum duration of the degraded case				*/
	float64_be	 IDefDurImgCSMiss;			/* Maximum duration of the degraded case				*/
	float64_be	 IDefDurRadAvhrrMiss;		/* Maximum duration of the degraded case				*/
	int32_be	 IDefFaxFLS;			/* Number of IASI lines required for the tIASI lines	*/
	int32_be	 IDefFaxRegressDegre;		/* Degree of the polynomial regression		 n/a		*/
	float64_be	 IDefFaxRegressRmsCutoff;		/* Rms threshold of the regression		  rad		   */
	float64_be	 IDefFaxT0;				/* Forgetting duration of the interferomets				*/
	int32_be	 IDefFtbFLS;			/* Number of lines used for the black-body	 n/a		*/
	int32_be	 IDefFtbRegressDegre;		/* Degree of the polynomial regression for	 n/a		*/
	float64_be	 IDefFtbRegressRmsCutoff;		/* Rms threshold of the regression for BBTrad		   */
	float64_be	 IDefFtbT0;				/* Forgetting duration of the interferomets				*/
	int32_be	 IDefGeoIISSubGridSize;		/* Size of the subgrid of IASI imager (IIS	 n/a		*/
	int32_be	 IDefGeoIISSubGridNY[5];		/* Line numbers of the IIS subgrid		  IIS line		*/
	int32_be	 IDefGeoIISSubGridNZ[5];		/* Column numbers of the IIS subgrid	  IIS column	*/
	int32_be	 IDefGranuleSizeDefault;		/* Default size of a granule (required onlIASI lines	*/
	float64_be	 IDefHecTRrsModel[10][200];		/* Temperature Model for the radiative sur	 n/a		*/
	float64_be	 IDefIacCorrelCutoff;		/* Quality threshold for the maximum of co	 none		*/
	int32_be	 IDefIacDCol;			/* Search range for the coregistration	  Avhrr colu	*/
	int32_be	 IDefIacDLin;			/* Search range for the coregistration	  Avhrr line	*/
	float64_be	 IDefIacPosMaxCutoff;		/* Quality threshold for the position of t	 none		*/
	float64_be	 IDefIASIMETOPMatRot[3][3];		/* Rotation matrix from IASI nominal refer	 none		*/
	float64_be	 IDefIASIScanAngle[37];		/* Sighting angles of the scan mirror		 n/a		*/
	int32_be	 IDefIccNbCycle;			/* Number of cycles for the filtering of I	 n/a		*/
	float64_be	 IDefIISAVHRROffsetGuess[37][2];	/* Guess of the IIS-AVHRR offset		  Avhrr pixe   */
	int32_be	 IDefIISColDeb[4];			/* First column of the IIS region containiIIS column	*/
	int32_be	 IDefIISColFin[4];			/* Last column of the IIS region containinIIS column	*/
	float64_be	 IDefIISDY;				/* Nominal angular width of the IIS pixelsrad			*/
	float64_be	 IDefIISDZ;				/* Nominal angular height of the IIS pixelrad			*/
	int32_be	 IDefIISLinDeb[4];			/* First line of the IIS region containingIIS line		*/
	int32_be	 IDefIISLinFin[4];			/* Last line of the IIS region containing IIS line		*/
	int32_be	 IDefIISNbCol;			/* Number of IIS columns					 n/a		*/
	int32_be	 IDefIISNbLin;			/* Number of IIS lines						 n/a		*/
	float64_be	 IDefIISNoiseNom;			/* Radiometric noise of the nominal mean I	 n/a		*/
	float64_be	 IDefIISRot;			/* Rotation angles between R_IIS (IIS referad			*/
	float64_be	 IDefIISY[64];			/* Nominal angular coordinates of the IIS rad			*/
	float64_be	 IDefIISZ[64];			/* Nominal angular coordinates of the IIS rad			*/
	float64_be	 IDefMcxColdSpectrum[10][3];	/* Nominal radiance of the cold space spec W/m2/sr/m-	*/
	float64_be	 IDefMcxDphi[10][3];		/* Nominal spectral shift between the specm-1			*/
	float64_be	 IDefMcxBiasCalRadCutoff[3];	/* Threshold for the radiometric calibrati W/m2/sr/m-	*/
	float64_be	 IDefMcxNoiseCalRadCutof[3];	/* Threshold for the radiometric calibrati W/m2/sr/m-	*/
	float64_be	 IDefMETOPOrbitPeriod;		/* Nominal orbital period of METOP (nodal s				*/
	int32_be	 IDefNsfirst[3];			/* Index of the first sample of each band	 n/a		*/
	int32_be	 IDefNslast[3];			/* Index of the last sample of each band	 n/a		*/
	float64_be	 IDefOffsetSondIISModel[4][2][200];	/* Parameters of the orbital model of the	 n/a		*/
	float64_be	 IDefPdsPix[4];			/* IASI sounder pixels weight for the spec	 n/a		*/
	float64_be	 IDefPlkN;				/* Scaling factor for the calculous of int	 n/a		*/
	float64_be	 IDefPlkPK1;			/* 'Constant' used for PLK algorithm : 2.hJ.m2.s-1		*/
	float64_be	 IDefPlkPK2;			/* 'Constant' used for PLK algorithm : h.cK.m			*/
	float64_be	 IDefPsfSondBaryCentreY[4];		/* X barycentric coordinates of the IPSF irad			*/
	float64_be	 IDefPsfSondBaryCentreZ[4];		/* Y barycentric coordinates of the IPSF irad			*/
	float64_be	 IDefQisAvgRadNoise[4][3];		/* Nominal mean noise in the band (NeDT atK				*/
	int32_be	 IDefS1bNsFFT;			/* Number of samples for the Fourier trans	 n/a		*/
	int32_be	 IDefS1bOSFftFactor;		/* Oversampling factor of the Fourier tran	 n/a		*/
	int32_be	 IDefS1bOSSplineFactor;		/* Oversampling factor of the spline inter	 n/a		*/
	int32_be	 IDefS1bSigI;			/* Semi-width at mid-height of the gaussiaIasi sampl	*/
	int32_be	 IDefS1bSigS;			/* Semi-width at mid-height of the gaussiaIasi sampl	*/
	int32_be	 IDefS1cNbSWwidth;			/* Number of samples contained in the apodIasi sampl	*/
	int32_be	 IDefS1cNsErase;			/* Number of samples set to 0 in the apodiIasi sampl	*/
	int32_be	 IDefS1cSigS;			/* Semi-width at mid-height of the gaussiaIasi sampl	*/
	float64_be	 IDefSmeTScanModel[200];		/* Temperature Model for the scan mirror	 n/a		*/
	float64_be	 IDefSpectDWn1b;			/* Nominal level 1B spectra sampling	  m-1			*/
	int32_be	 IDefNsfirst1b;			/* Index of the first sample of the level Iasi sampl	*/
	int32_be	 IDefNslast1b;			/* Index of the last sample of the level 1Iasi sampl	*/
	float64_be	 IDefSpectrDWn;			/* Nominal measured spectra sampling	  m-1			*/
	float64_be	 IDefSsdModulCutoff[10][3];		/* Validity threshold for the harmonic mag	 n/a		*/
	int32_be	 IDefSsdNhar[10];			/* Harmonic number of the used spectral li	 n/a		*/
	int32_be	 IDefSsdNItera;			/* Number of iteration for the phase compu	 n/a		*/
	int32_be	 IDefSsdNsfirstSW[10];		/* Index of the first sample of the spectrIasi sampl	*/
	int32_be	 IDefSsdNslastSW[10];		/* Index of the last sample of the spectraIasi sampl	*/
	int32_be	 IDefSsdOSFftFactor[10];		/* Oversampling factor of the Fourier tran	 n/a		*/
	int32_be	 IDefSsdOSSplineFactor[10];		/* Oversampling factor of the spline inter	 n/a		*/
	int32_be	 IDefSsdSigI[10];			/* Semi-width at mid-height of the gaussiaIasi sampl	*/
	int32_be	 IDefSsdSigS[10];			/* Semi-width at mid-height of the gaussiaIasi sampl	*/
	int32_be	 IDefSsdSpectralWindowOP;		/* Number of the spectral window to be use	 n/a	   */
	float64_be	 IDefSssStdImagCutoff;		/* Intra-pixel homogeneity threshold	  W/m2/sr/m-	*/
	float64_be	 IDefSssWnShiftMax;			/* Maximum spectral shift which is admissim-1			*/
	float64_be	 IDefSssWnShiftMin;			/* Minimum spectral shift which is admissim-1			*/
	int32_be	 IDefSysTECIISQual;			/* System-TEC quality index for IIS			 n/a		*/
	int32_be	 IDefSysTECSondQual;		/* System-TEC quality index for sounder		 n/a		*/
	float64_be	 IDefTrCalRad;			/* First diagonal of the radiometric calib	 n/a		*/
	float64_be	 IDefTrnom;				/* First diagonal of the nominal covarianc	 n/a		*/
	float64_be	 IDefTrSpect;			/* First diagonal of the spectral calibrat	 n/a		*/
	int32_be	 IDefWnpNharmonic[10];		/* Number of harmonics that can be represe	 none		*/
	int32_be	 IDefWnpSigG[10];			/* Semi-width at mid-height of the gaussiaIasi sampl	*/
	int32_be	 IDefWnpSign[10];			/* Sign for absorbtion/emission of the spe	 n/a		*/
	float64_be	 IWnpDWnSWref[10];			/* Spectral width between two lines in them-1			*/
	float64_be	 IWnpModulNat[10][3];		/* Magnitudes of the harmonics of the Four	 n/a		*/
	int32_be	 IWnpNsFFT[10];			/* Number of samples used for the spectral	 n/a		*/
	int32_be	 IWnpNsSSR[10];			/* Number of samples between two lines	  Iasi sampl	*/
	int32_be	 IWnpNsSW[10];			/* Number of samples in the spectral windoIasi sampl	*/
	float64_be	 IWnpPhaseNat[10][3];		/* Natural phase of the harmonics of the Frad			*/
	float64_be	 IWnpWnSWref[10];			/* Representative wawenumber of the spectrm-1			*/
};

#endif
