////////////////////////////////////////////////////////////////////////////////
//
//	File: caduextractor.hpp
//
//	Provides: CADUExtractor filter
//
//	Purpose: Write CADU packets to a FileConsumer
//
//	Copyright (c) 2006 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef cadu_extractor_defined
#define cadu_extractor_defined

#include "fileproducer.hpp"
#include "caduproducer.hpp"

class CADUExtractor : public FileProducer
{
public:

	CADUExtractor(CADUProducer* _source);
	void output_text_summary( ostream& os = cout );
	istream_type* get_next_file(void);
	bool produce_files( FileConsumer& consumer );

private:

	CADUProducer* source;
	int count;
};

#endif
