////////////////////////////////////////////////////////////////////////////////
//
//	File: cadugenerator.hpp
//
//	Provides: CADUGenerator filter
//
//	Purpose: Synthesize a stream of Fill CADU packets
//
//	Copyright (c) 2006 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef cadu_generator_defined
#define cadu_generator_defined

#include "interface.hpp"
#include "caduproducer.hpp"
#include "cadurandomizer.hpp"

class CADUGenerator : public CADUProducer
{
public:

	CADUGenerator(int _count, int _initial_vccount, int _mod_vccount, int _scid);
	CADU* get_next_cadu(void);
	void output_text_summary( ostream& os = cout );

private:

	CADURandomizer randomizer;

	int count;
	int initial_vccount;
	int mod_vccount;
	int scid;
	int remaining;
	int vccount;

	CADU cadu;
};

#endif
