////////////////////////////////////////////////////////////////////////////////
//
//	File: caduwriter.hpp
//
//	Provides: CADUWriter class
//
//	Purpose:
//
//	Copyright (c) 2005 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef caduwriter_defined
#define caduwriter_defined

#include "cadu.hpp"
#include "caduproducer.hpp"

class CADUWriter :
	public Interface
{
public:

	CADUWriter( CADUProducer& _source, const string& _filename, bool _pad);
	virtual void output_text_summary( ostream&os = cout);

private:

	string filename;
	int counter;
	auto_ptr<ofstream64> ofs;
	bool pad;
	unsigned long long bytes_written;
};

#endif
