////////////////////////////////////////////////////////////////////////////////
//
//	File: ccsdsproducer.hpp
//
//	Provides: CCSDSProducer interface
//
//	Purpose:
//
//	Copyright (c) 2002, 2003, 2004 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef ccsdsproducer_defined
#define ccsdsproducer_defined

#include "ccsds.hpp"
#include "epsproducer.hpp"

class CCSDSProducer
{
public:
	enum GROUPID { NOT_IMPLEMENTED, FILE_ERROR, UNSUPPORTED, UNRECOGNISED, GENERIC,
				   AMSUA, ASCAT, ATOVS, AVHRR, GOME,
				   GRAS, HIRS, IASI, MHS, SEM, ADCS, SBUV, HKTM, DUMMY };

	virtual ~CCSDSProducer(void) {}
	virtual CCSDS* get_next_ccsds(void) =0;
	virtual EPSProducer* as_eps_product(void) =0;

	virtual void reset_stream(void) {;}
	virtual void delete_source(void) {;}
	virtual GROUPID get_data_type(void) { return NOT_IMPLEMENTED; }

	virtual string get_scid(void) {return "";}

};

#endif
