#ifndef EPSL0SEGMENTER_HPP
#define EPSL0SEGMENTER_HPP


#include <vector>

#include "common.hpp"
#include "ccsds.hpp"
#include "epsl0.hpp"
#include "ccsdstol0.hpp"

using std::vector;

class EPSL0Segmenter
{

public:
    EPSL0Segmenter(CCSDSToL0* aConverter, unsigned int aSegmentSize);
    ~EPSL0Segmenter();

public:

    void addISP(CCSDS* ccsds);
    void completeL0();

public:

    void propagateOBTcoefficients();

public:

    virtual void output_text_summary(ostream& os=cout);

private:

    CCSDSToL0* m_Converter;
    unsigned int m_segmentSize;

    //container that will hold per instrument, segmented L0 output
    typedef map<string, vector<EPSL0*> > EPSL0_SEGMENTED_MAP;
    EPSL0_SEGMENTED_MAP m_segmentedEpsl0_map;

};

#endif // EPSL0SEGMENTER_HPP
