////////////////////////////////////////////////////////////////////////////////
//
//	File: epsproducer.hpp
//
//	Provides: EPSProducer interface
//
//	Purpose:
//
//	Copyright (c) 2006 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef epsproducer_defined
#define epsproducer_defined

#include "interface.hpp"
#include "eps.hpp"

class EPSProducer : virtual public Interface
{
public:
	virtual short_cds_time get_grh_start(void) const=0;
	virtual short_cds_time get_grh_stop(void) const=0;
	virtual const VIADR_OBT2UTC* get_viadr_l0_obt2utc(const short_cds_time& grh_start_time, int* viadr_matching) const=0;
	virtual string get_mphr_field(const string& field) const=0;
};

#endif
