////////////////////////////////////////////////////////////////////////////////
//
//	Provides: FileConsumer interface
//
//	Purpose: Allow a source filter to send multiple binary streams (files)
//			 to its target filter
//
//	Copyright (c) 2002, 2003, 2004 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef fileconsumer_defined
#define fileconsumer_defined

#include "interface.hpp"

class FileConsumer : virtual public Interface
{
public:

	virtual ~FileConsumer(void) {}
	virtual ostream_type* get_output_stream(void) =0;
	virtual ostream_type* get_named_output_stream(
		const string& filename_suffix) =0;

	virtual string get_filename_base(void) =0;

};

#endif
