////////////////////////////////////////////////////////////////////////////////
//
//	File: fileproducer.hpp
//
//	Provides: FileProducer interface
//
//	Purpose:
//
//	Copyright (c) 2002, 2003, 2004 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef fileproducer_defined
#define fileproducer_defined

#include "interface.hpp"

class FileConsumer;

class FileProducer : virtual public Interface
{
public:
	virtual ~FileProducer(void) {}

	// at least one function must be overloaded
	virtual istream_type* get_next_file(void) =0;

	// a consumer should try produce_files first
	virtual bool produce_files( FileConsumer& ) =0;

	// reset file pointer to beginning
	virtual void reset_files(void) {;}

	// Check if last open file attempt was valid
	virtual bool is_valid(void) { return true; }
};

#endif
