////////////////////////////////////////////////////////////////////////////////
//
//	File: image.hpp
//
//	Provides: General graphics handling classes
//
//	Purpose:
//
//	Copyright (c) 2002, 2003, 2004 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef image_defined
#define image_defined

class Image
{
public:

	enum ColourType { IMAGE_MONO , IMAGE_COLOUR };
	enum Format { IMAGE_TIFF , IMAGE_JPEG };

	virtual ~Image(void)
		{
		}

	void set_filename_prefix(const string& _filename_prefix)
		{
			filename_prefix = _filename_prefix;
		}

	void set_filename_suffix(const string& _filename_suffix)
		{
			filename_suffix = _filename_suffix;
		}

	void set_attributes(ColourType _colour_type, int _width, int _height)
		{
			colour_type = _colour_type;
			width = _width;
			height = _height;
		}

	virtual void begin_output(void) =0;
	virtual void write_line(byte* line) =0;
	virtual void end_output(void) =0;

	string get_full_filename(void) const
		{
			return (filename_prefix+filename_suffix+get_filename_extension());
		}

	virtual string get_filename_extension(void) const =0;

protected:

	string filename_prefix;
	string filename_suffix;
	ColourType colour_type;
	int width;
	int height;
};

#endif

