////////////////////////////////////////////////////////////////////////////////
//
//	File: mpdudisplayer.hpp
//
//	Provides: MPDUDisplayer filter
//
//	Purpose: Show brief contents of MPDU packets as text
//
//	Copyright (c) 2002, 2003, 2004 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef mpdudisplayer_defined
#define mpdudisplayer_defined

#include "textrecordproducer.hpp"

class MPDUDisplayer :
	public TextRecordProducer
{
public:

	MPDUDisplayer(MPDUProducer& _source)
		: source(_source)
		{
		}

	virtual void output_text_record(textoutstream_type& os,
									int,
									bool)
		{
			while(MPDU* mpdu = source.get_next_mpdu())
			{
				os << "MPDU packet summary: First header pointer "
				   << ntofs(mpdu->get_first_header_pointer(),4)
				   << " Checksum " << mpdu->generate_a_checksum()
				   << endl;
			}
		}

private:

	MPDUProducer& source;
};

#endif
