////////////////////////////////////////////////////////////////////////////////
//
//	File: multifilewriter.hpp
//
//	Provides: MultiFileWriter filter
//
//	Purpose: Write a set of files to disk
//
//	Copyright (c) 2002, 2003, 2004 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef multiplefilewriter_defined
#define multiplefilewriter_defined

#include "interface.hpp"
#include "fileproducer.hpp"
#include "fileconsumer.hpp"

class MultiFileWriter :
	virtual public Interface,
	public FileConsumer
{
public:

	/// constructor
	MultiFileWriter(
		FileProducer& source,
		const string& _filename_base);

	/// destructor
	~MultiFileWriter(void);

	/// output_text_summary
	void output_text_summary(ostream& os = cout);

	/// get_named_output_stream
	virtual ostream_type* get_named_output_stream(const string& filename_suffix);

	/// get_output_stream
	virtual ostream_type* get_output_stream(void);

	/// get_filename_base
	virtual string get_filename_base(void);

private:

	string filename_base;

	int file_count;

	auto_ptr<ofstream_type> single_file_output;

	typedef map<string, ofstream_type* > OStreams;
	OStreams ostreams;

};

#endif
