////////////////////////////////////////////////////////////////////////////////
//
//	File: productproducer.hpp
//
//	Provides: ProductProducer interface
//
//	Purpose:
//
//	Copyright (c) 2002, 2003, 2004 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef productproducer_defined
#define productproducer_defined

class ProductProducer
{
public:

	virtual ~ProductProducer(void) {}
	virtual NOAA_Archive_Header* get_archive_header(void) =0;
	virtual NOAA_L1b_GEN_Header* get_product_header(void) =0;

	virtual NOAA_L1b_GEN_Data* get_current_record(void) const=0;
	virtual void skip_records(unsigned int offset) =0;
	virtual int get_record_size(void) const=0;

	virtual void output_text_archive_header(ostream& os = cout) =0;
	virtual void output_text_gen_header(ostream& os = cout) =0;
	virtual void output_text_gen_record(int record_no, ostream& os = cout) =0;

};

#endif
