///////////////////////////////////////////////////////////////////////////////
//
//	File: pyascatreader.hpp
//
//	Provides: python interface
//
//	Purpose:
//
//	Copyright (c) 2006 EUMETSAT
//
//	This file is part of Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef pyascatreader_defined
#define pyascatreader_defined

#include "pyreader.hpp"

// Forward declare methods
class CCSDSProducer;

////////////////////////////////////////////////////////////////////////////////

class PyASCATReader : public PyReader
{
public:

	PyASCATReader(CCSDSProducer* source);

	///	 return a list of strings
	PyObject* get_channels(void) const;

	/// return a array of 256-element long arrays. optional 2nd parameter gives modulus [only every 5th sample included])
	PyObject* get_samples(int channel, int band, int modulus, int count, int skip, int modulus2);

	/// instrument name for this reader
	string get_instrument_name(void) const;

private:

	double convert_ASCAT_payload(unsigned int ascat_payload_sample);
};

#endif
