///////////////////////////////////////////////////////////////////////////////
//
//	File: pygomereader.hpp
//
//	Provides: python interface
//
//	Purpose:
//
//	Copyright (c) 2006 EUMETSAT
//
//	This file is part of Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef pygomereader_defined
#define pygomereader_defined

#include "pyreader.hpp"

class CCSDSProducer;

class PyGOMEReader : public PyReader
{
public:
	PyGOMEReader(CCSDSProducer* source);

	///	 return a list of strings
	PyObject* get_channels(void) const;

	/// return a array of 90-element long arrays. optionalal 2nd parameter gives modulus [only every 5th sample included])
	PyObject* get_samples(int channel, int band, int modulus, int count, int skip, int modulus2);

	/// instrument name for this reader
	string get_instrument_name(void) const;

private:

	//CCSDS* get_gome_ccsds(void);

	int band_channels[6];
	int band_starts[6];
	int band_ends[6];

	//queue<CCSDS*> buffer;
	//CCSDS* hold;
};

#endif
