///////////////////////////////////////////////////////////////////////////////
//
//	File: pyhktmreader.hpp
//
//	Provides: python interface
//
//	Purpose:
//
//	Copyright (c) 2006 EUMETSAT
//
//	This file is part of Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef pyhktmreader_defined
#define pyhktmreader_defined

#include "pyreader.hpp"

// Forward declare methods
class CCSDSProducer;

////////////////////////////////////////////////////////////////////////////////
/// Specialisation for MHS Instrument with APID of 34

class PyHKTMReader : public PyReader
{
public:
	PyHKTMReader(CCSDSProducer* source);

	///	 return a list of available channels
	PyObject* get_channels(void) const;

	/// return a array of 90-element long arrays. optionalal 2nd parameter gives modulus
	PyObject* get_samples(int channel, int band, int modulus, int count, int skip, int modulus2 );

	/// get number of samples produced for a single scan line
	int get_samples_count(void);

	/// instrument name for this reader
	string get_instrument_name(void) const;
};

#endif
