///////////////////////////////////////////////////////////////////////////////
//
//	File: pymhsreader.hpp
//
//	Provides: python interface
//
//	Purpose:
//
//	Copyright (c) 2006 EUMETSAT
//
//	This file is part of Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef pymhsreader_defined
#define pymhsreader_defined

#include "pyreader.hpp"

// Forward declare methods
class CCSDSProducer;

////////////////////////////////////////////////////////////////////////////////
/// Specialisation for MHS Instrument with APID of 34

class PyMHSReader : public PyReader
{
public:
	PyMHSReader(CCSDSProducer* source);

	///	 return a list of strings ["Channel1". "Channel2", "Channel3", "Channel4", "Channel5"]
	PyObject* get_channels(void) const;

	/// return a array of 90-element long arrays. optionalal 2nd parameter gives modulus [only every 5th sample included])
	PyObject* get_samples(int channel, int band, int modulus, int count, int skip, int modulus2 );

	/// get number of samples produced for a single scan line
	int get_samples_count(void);

	/// instrument name for this reader
	string get_instrument_name(void) const;
};

#endif
