////////////////////////////////////////////////////////////////////////////////
//
//	File: readfromstdin.cpp
//
//	Provides: ReadFromStdin filter
//
//	Purpose: Open standard input as a file
//
//	Copyright (c) 2002, 2003, 2004 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#include "common.hpp"
#include "readfromstdin.hpp"

ReadFromStdin::ReadFromStdin(void)
	: eos(false)
	, valid(false)
{
	
	if (isatty(0)==1)
	{
		error << "Invalid input - either specify an input file or pipe "
			  << "data in from another process\n";
		gerror = -1;
		return;
	}
	
	valid = true;
}

void ReadFromStdin::output_text_summary(textoutstream_type& os)
{
	os << "\nReadFromStdin report:\n";
//		os << "	   " << cin.tellg() << " bytes read\n";
	os << endl;
}

istream_type* ReadFromStdin::get_next_file(void)
{
	if (valid && !eos)
	{
		eos = true;
#ifdef _USE_LARGE_FILES
		stdin_stream.reset(new ifstream_type(stdin));
		return stdin_stream.get();
#else
		return &cin;
#endif
	}
	else
	{
		return NULL;
	}
}

bool ReadFromStdin::produce_files( FileConsumer& )
{
	return false;
}
