////////////////////////////////////////////////////////////////////////////////
//
//	File: readfromstdin.hpp
//
//	Provides: ReadFromStdin filter
//
//	Purpose: Open standard input as a file
//
//	Copyright (c) 2002, 2003, 2004 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef readfromstdin_defined
#define readfromstdin_defined

#include "fileproducer.hpp"
#include "textsummaryproducer.hpp"

class ReadFromStdin :
	public FileProducer,
	public TextSummaryProducer
{
public:

	/// constructor
	ReadFromStdin(void);

	/// output_text_summary
	virtual void output_text_summary(textoutstream_type& os);

	/// get_next_file
	istream_type* get_next_file(void);

	/// produce_files
	virtual bool produce_files( FileConsumer& );

private:

#ifdef _USE_LARGE_FILES
	auto_ptr<ifstream_type> stdin_stream;
#endif

	bool eos;
	bool valid;

};

#endif
