////////////////////////////////////////////////////////////////////////////////
//
//	File: singlefilewriter.hpp
//
//	Provides: SingleFileWriter filter
//
//	Purpose: Write data to disk as one file
//
//	Copyright (c) 2002, 2003, 2004 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef singlefilewriter_defined
#define singlefilewriter_defined

#include "fileproducer.hpp"
#include "fileconsumer.hpp"

class SingleFileWriter :
	public FileConsumer
{
public:

	/// constructor
	SingleFileWriter( FileProducer* source, const string& _filename);

	/// get_output_stream
	virtual ostream_type* get_output_stream(void);

	/// get_names_output_stream
	virtual ostream_type* get_named_output_stream(
		const string& filename_suffix);

	/// output_text_summary
	virtual void output_text_summary( ostream& os = cout );

	/// get_filename_base
	virtual string get_filename_base(void);

private:

	auto_ptr<ofstream_type> ofs;
	int total_bytes;
	string filename;

};

#endif
