////////////////////////////////////////////////////////////////////////////////
//
//	File: spinner.hpp
//
//	Provides: Spinner class
//
//	Purpose: Display an ascii animation during long calculations
//
//	Copyright (c) 2002, 2003, 2004 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef spinner_defined
#define spinner_defined

class Spinner
{
public:

	enum { INITIAL_DELAY = 0 }; // 500
	enum { SPIN_DELAY = 120 }; // 150
	enum { DOT_DELAY = 4000 }; // 5000
	enum { STAR_DELAY = 1000 };
	enum { MINIMUM_SPIN_TIME = 0 };

	Spinner(const string& _message = "");
	void tick(void);
	void end(void);
	void pause(void);
	void unpause(void);
	unsigned int current_time(void);

	static void restream( textoutstream_type* new_outstr);
	static void use_simple_spinner(bool use = true);

private:

	unsigned int activate_time;
	unsigned int next_spin_time;
	unsigned int next_dot_time;
	unsigned int earliest_end_time;
	string symbols;
	int pos;

	bool ended;
	bool activated;
	string message;

	static textoutstream_type* outstr;
	static int type;
	static bool simple_spinner;
};

#endif
