////////////////////////////////////////////////////////////////////////////////
//
//	File: tvcduwriter.cpp
//
//	Provides: tVCDUWriter class
//
//	Purpose:
//
//	Copyright (c) 2006 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#include "common.hpp"
#include "tvcduwriter.hpp"

tVCDUWriter::tVCDUWriter(tVCDUProducer& source, const string& _filename)
	: filename(_filename),
	  counter(0)
{
	ofs.reset(new ofstream64(filename.c_str()));

	if (!spinner.get())
	{
		spinner.reset(new Spinner());
	}

	tVCDU* tvcdu;
	while((tvcdu=source.get_next_tvcdu())!=NULL)
	{
		ofs->write(reinterpret_cast<char*>(tvcdu), tVCDU::SIZE);
		counter++;
		spinner->tick();
	}

	spinner->end();
}

void tVCDUWriter::output_text_summary( ostream& os )
{
	os << "tVCDUWriter report:\n"
	   << "	   Output filename " << filename << endl
	   << "	   Packets written " << counter << endl
	   << "	   Bytes written " << ofs->tellp() << endl
	   << endl;
}
