////////////////////////////////////////////////////////////////////////////////
//
//	File: vcduscidsetter.hpp
//
//	Provides: VCDUSCIDSetter class
//
//	Purpose:
//
//	Copyright (c) 2008 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef vcduscidsetter_defined
#define vcduscidsetter_defined

#include "vcduproducer.hpp"
#include "spinner.hpp"

class VCDUSCIDSetter : public VCDUProducer
{
public:

	VCDUSCIDSetter(VCDUProducer& _source, int _new_scid);
	VCDU* get_next_vcdu(void);
	virtual void output_text_summary( ostream& os = cout );

private:

	int new_scid;
	typedef map<int,int> Scids;
	Scids old_scids;
	VCDUProducer& source;
	auto_ptr<Spinner> spinner;
};

#endif
