////////////////////////////////////////////////////////////////////////////////
//
//	File: vcdutocadu.hpp
//
//	Provides: VCDUToCADU class
//
//	Purpose: Convert VCDU packets to CADU packets
//
//	Copyright (c) 2008 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef vcdutocadu_defined
#define vcdutocadu_defined

#include "vcdu.hpp"
#include "cadu.hpp"
#include "vcduproducer.hpp"
#include "caduproducer.hpp"
#include "cadurandomizer.hpp"

class VCDUToCADU : public CADUProducer
{
public:

	VCDUToCADU(VCDUProducer* _source);
	CADU* get_next_cadu(void);
	void output_text_summary( ostream& os = cout );

private:

	VCDUProducer* source;
	int count;
	CADURandomizer randomizer;
	CADU cadu;
};

#endif
