////////////////////////////////////////////////////////////////////////////////
//
//	File: writetonull.hpp
//
//	Provides: WriteToNull filter
//
//	Purpose: Discard inputs but report on them
//
//	Copyright (c) 2004 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef writetonull_defined
#define writetonull_defined

#include "interface.hpp"
#include "fileproducer.hpp"
#include "fileconsumer.hpp"

class WriteToNull:
	virtual public Interface,
	public FileConsumer
{
public:

	/// constructor
	WriteToNull(FileProducer& source);

	/// destructor
	~WriteToNull(void);

	/// output_text_summary
	void output_text_summary(ostream& os = cout);

	/// get_named_output_stream
	virtual ostream_type* get_named_output_stream(
		const string& filename_suffix);

	/// get_output_stream
	virtual ostream_type* get_output_stream(void);

	/// get_filename_base
	virtual string get_filename_base(void);

private:

	int file_count;
	unsigned long long byte_count;

	auto_ptr<ofstream_type> single_file_output;

	typedef map<string, ofstream_type* > OStreams;
	OStreams ostreams;

};

#endif
