////////////////////////////////////////////////////////////////////////////////
//
//	File: writetostdout.hpp
//
//	Provides: WriteoStdout filter
//
//	Purpose: Spool data to standard output
//
//	Copyright (c) 2002, 2003, 2004 EUMETSAT
//
//	This file is part of the Metopizer.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef writetostdout_defined
#define writetostdout_defined

#include "fileconsumer.hpp"
#include "fileproducer.hpp"
#include "textsummaryproducer.hpp"

class WriteToStdout :
	public FileConsumer
{
public:

	/// constructor
	WriteToStdout(FileProducer* source, bool force = false);

	/// get_output_stream
	virtual ostream_type* get_output_stream(void);

	/// get_named_output_stream
	virtual ostream_type* get_named_output_stream(
		const string& filename_suffix);

	/// output_text_summary
	virtual void output_text_summary(ostream& os = cout);

	/// get_filename_base
	virtual string get_filename_base(void);

private:

#ifdef _USE_LARGE_FILES
	auto_ptr<ofstream_type> stdout_stream;
#endif

};

#endif
