//$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/BAS/src/SD_BAS_Niveau1.c,v 1.4 2011/12/20 15:42:01 lcaspar Exp $
//@ --------------------------------------------------------------------/
//@ Composant : SD
//@ Sous-composant : SD_BAS
//@ MODULE : SD_BAS_Niveau1
//@
//@ Comment :
//@    Code file for the  SD_BAS_Niveau1 class which includes the
//@    acces to the IASI L1 product  : reading and writing
//@	this is done thanks to SD_BAS_Conversion and SD_BAS_Produits
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 09/01/2003 : [reference :] Ott
//@ --------------------------------------------------------------------
//@ VERSION : 04/09/2003 : [reference :] Benjamin MASSART
//@ cette version prend en compte les evolutions du code pour une gestion
//@ dynamique de l'ecriture des IPR dans les produits de niveau 1 suite
//@ aux modifications apparues dans la version 6.4 du GPFS et la version
//@ 6.5 du IASI Level 1 Product Format Specification
//@ --------------------------------------------------------------------
//@ DM-ID : PM-3 : 04/09/2003 :
//@ -SD_BAS_TAILLE_MAX_MDR_1AB   deplaces dans SD_BAS_Niveau1.h
//@  SD_BAS_TAILLE_MAX_MDR_1C
//@  SD_BAS_TAILLE_MAX_GIADRQUAL
//@  SD_BAS_TAILLE_GIADR_SCA
//@  SD_BAS_TAILLE_MAX_MDRENG
//@  SD_BAS_TAILLE_MAX_VIADRENG
//@  SD_BAS_TAILLE_MAX_GIADR_ENG
//@  SD_BAS_TAILLE_DUMMY
//@ -SD_BAS_MDR_ABC_SUBCLASS   redefinies dans SD_BAS_Niveau1.h
//@  SD_BAS_MDR_ENG_SUBCLASS
//@  SD_BAS_MDR_VER_SUBCLASS
//@  SD_BAS_GIADR_SCA_SUBCLASS
//@  SD_BAS_GIADR_QUA_SUBCLASS
//@  SD_BAS_GIADR_ENG_SUBCLASS
//@  SD_BAS_VIADR_ENG_SUBCLASS
//@ -t_SD_BAS_Produit redefinie dans SD_BAS_Produit.h
//@ -suppression des listes P1ABC, P1ENG, P1VER
//@ -l'offset de chaque record est calcule dans SD_DON_GranuleN1::DecrireIPR()
//@ --------------------------------------------------------------------
//@ DM-ID : IA-CR-0000-177-CNE : 31/03/2004 B. MASSART
//@ -mise a jour SD_BAS_OFFSET_SPECTRE
//@ -mise a jour dimensions de N1C_GQISFLAGQUAL
//@ -mise a jour dimensions de ENG_GOPSFLTISRFEMOFF
//@ -ajout de ENG_GOPSFLAGEOAVHRRMISS dans MDR_ENG
//@ --------------------------------------------------------------------
//@ DM-ID : PM4 : 31/03/2004 : B. MASSART
//@ -correction syntaxe N1C_GQISQUALINDEXIIS
//@ -correction syntaxe N1C_IDEFCCSCHANNELID
//@ -correction syntaxe ENG_GOPSFLTISRFEMOFF
//@ -correction syntaxe ENG_GOPSDATISRFEMOFF
//@ -correction syntaxe ENG_GOPSFLAIISCALIBMISS
//@ --------------------------------------------------------------------
//@ DM-ID : IA-CR-0000-185-CNE : 31/03/2004 B. MASSART
//@ SD_BAS_DecodeSpectreN1:
//@ -spectres codes sur short int au lieu de unsigned short int
//@ SD_BAS_DecodeSpectreN1b:
//@ -spectres codes sur short int au lieu de unsigned short int
//@ --------------------------------------------------------------------
//@ DM-ID :IA-CR-2100-246-CNE : 06/07/2004 : B. MASSART
//@ word # 16 in level 0 PX packets is no more read as part of PTSI number
//@ Variable ONBOARD_SOFTWARE_VERSION added in ENG, 1A, 1B and 1C products
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-143-CN : 21/09/2004 : B.MASSART
//@ L'OPS s'arrete sur l'initialisation de VIADRENG_MEXSSMIN avec le contexte 
//@ a froid dans SD_GES_ChaineProd0_1C::Corpstraitement lorsque la 10ieme ligne 
//@ est un DMDR. On opte pour une gestion des VIADR_DUMMY similaire a celle des 
//@ VIADR_ENG valides. Voir IA-2100-FC-143-THA.
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-155-CN : 1/03/2005 : JL.PASCAL
//@ Les DMDR ne sont pas dates correctement 
//@ Voir IA-2100-FC-155-THA.
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-158-CN : 30/06/2005 : JL PASCAL
//@ L'OPS genere des resulta VIADRENG_MEXSSMIN et MAX errone et qui  
//@ dependent du nombre de thread 
//@ Voir IA-2100-FC-158-THA.
//@ --------------------------------------------------------------------
//@ DM-ID :IA-CR-2100-277-CNE : 07/06/2005 :  JL PASCAL
//@ ecriture du champ GIADRENG_GEPSUTCCORREL comme un entier non signe
//@ Voir IA-2100-CR-277-THA.
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-180-CN : 30/08/2006 : C.MERIGUET
//@ Mise a jour de l'entete MPHR en mode DUMP
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-CR-162-CN : 09/2006 : C.MERIGUET
//@ Gestion des IPR en mode DUMP
//@ --------------------------------------------------------------------
//@ FA-ID : IA-2100-FA-196-CN : 15/01/2007 : C.MERIGUET
//@ FA-ID : IA-2100-FA-198-CN : 15/01/2007 : C.MERIGUET
//@ Ces 2 FA sont traitees conjointement. Recuperation du PTSI lu dans 
//@ le mot 17 (2 octets) mais ecriture dans le champ PTSI des N1 des mots 
//@ 16 (version logiciel bord) et 17 (ptsi) (4 octets).
//@ --------------------------------------------------------------------
//@ DM-ID :IA-CR-2100-349-CNE : 26/06/2007 :  S. BRUNEL
//@ Correction de l'overflow dans les radiances des produits. Une valeur 
//@ calculee inferieure a -5000 est fixee a la plus grande valeur negative
//@ (-32768 pour un short)
//@ --------------------------------------------------------------------
//@ FA-ID : IA-2100-FA-1767-CN rev1 : 12/09/2007 : S.BRUNEL
//@ GQISFLAGQUAL non leve en cas d'overflow
//@ --------------------------------------------------------------------
//@ FA-ID : IA-2100-FA-1769-CN : 12/09/2007 : S.BRUNEL
//@ Incorrect setting of TARGET_INSTRUMENT_GROUP in IASI_ENG product
//@ --------------------------------------------------------------------
//@ DM-ID : IA-2100-CR-1777-CN : 13/09/2007 : S.BRUNEL
//@ BUFR encoding of IASI_L1C product failed
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2512 (FA-2100-OPS) : 17/11/2008 : S. BRUNEL
//@ Fuites memoires signalees par EUMETSAT (EUM.EPS.NCR.3627.1)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2521(DM-2100-OPS) : 19/12/2008 : S. BRUNEL
//@ Calcul de 4 pseudo-canaux AVHRR (Day 2,point 2)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2522(DM-2100-OPS) : 19/12/2008 : S. BRUNEL
//@ Ajout de variables dans les produits L1C et ENG  (Day 2,point 3)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2523(DM-2100-OPS) : 19/12/2008 : S. BRUNEL
//@ Include BArcImagMeanRMS dans le produit ENG (Day 2,point 4)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2524(DM-2100-OPS) : 19/12/2008 : S. BRUNEL
//@ Ajouter un indice et un flag dans l'algorithme 22_SSD (Day 2,point 5)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2525(DM-2100-OPS) : 19/12/2008 : S. BRUNEL
//@ Modification du GQisFlagQual, ajout d'informations sur la cause de
//@ la rejection (Day 2,point 6)19
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2526(DM-2100-OPS) : 19/12/2008 : S. BRUNEL
//@ Include les differences de NZPD interpixel dans le produit 
//@ ENG (Day 2,point 7)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2528(DM-2100-OPS) : 19/12/2008 : S. BRUNEL
//@ Ajouter les informations sur les nuages et la surface obtenue
//@ par AVHRR dans le produit L1C (Day 2,point 9)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2525(DM-2100-OPS) : 06/03/2009 : S. BRUNEL
//@ Modification du GQisFlagQual, ajout d'informations sur la cause de
//@ la rejection (Day 2,point 6)19
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2574(DM-2100-OPS) : 16/04/2009 : S. BRUNEL
//@ Modification de la valeur d'initialisation des bits spare de 
//@ GQisFlagQualDetailed (1=>0)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2573(DM-2100-OPS) : 16/04/2009 : S. BRUNEL
//@ Modification de la valeur d'initialisation de la variable 
//@ MHipNZpdInterpixel (0=>valeur minimum codable)
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2562(FA-2100-OPS) : 02/09/2009 : S.BRUNEL
//@ Les valeurs par defaut de geolocalisation ne sont pas conformes
//@ a GPS (EUM.EPS.NCR.3742.2)
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2669(FA-2100-OPS) : 16/10/2009 : S.BRUNEL
//@ La valeur par defaut des variables de geolocalisation est 
//@ -2147.0 au lieu de -2147.483648
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2941(FA-2100-OPS) : 14/12/2011 : L. CASPAR
//@ Mauvaise initialisation de MHIPFlagInterpixNZPDNonQual 
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-3358(DM-2100-OPS) : 13/04/2017 : MLA
//@ Pour produits > 2Go, il faut utiliser des long long pour stocker la position du curseur 
//@ et les fonctions fseeko et ftello
//@ --------------------------------------------------------------------
//@FIN-HISTORIQUE
//@ --------------------------------------------------------------------


#include <stdio.h>
#include <math.h>
#include <sys/stat.h>
#include <limits.h>
#include "SD_BAS_Niveau1.h"
#include "SD_BAS_DECOM_DECOMMUTATION.h"
#include "ERR__Erreur.h"
#include "SD_BAS_Niveau0.h"

/* FA 180 */
#include "CMN__Date.h"
/* ..FA 180 */

// FT-2765
#include "SD_BAS_SwapEndian.h"
// ...FT-2765

// declaration des fonctions importees



//*====================================================================*/
//* Local Constant Declaration 
//*====================================================================*/


const char* SD_BAS_NOM_FIC_PROD1 = "SD_BAS_Niveau1.env";	 //* fichier descripteur de contenu */
const char* SD_BAS_BLOC_DONGEN1ABC = "DONGENABC";	 	//* nom du bloc DONGEN 1ABC*/
const char* SD_BAS_BLOC_DONGENENG = "DONGENENG";	 	//* nom du bloc DONGEN ENG*/

const char* SD_BAS_BLOC_MDR_1A = "MDR_1A";	 		//* nom du bloc DONDET MDR 1A */
const char* SD_BAS_BLOC_MDR_1B = "MDR_1B";	 		//* nom du bloc DONDET MDR 1B */

const char* SD_BAS_BLOC_MDR_1C = "MDR_1C";	 		//* nom du bloc DONDET MDR 1C*/
const char* SD_BAS_BLOC_GIADR_QUAL = "GIADR_QUAL";	 	//* nom du bloc DONDET GIADR 1A*/
const char* SD_BAS_BLOC_GIADR_SCA = "GIADR_SCA";	 	//* nom du bloc DONDET GIADR 1A*/

const char* SD_BAS_BLOC_MDR_ENG = "MDR_ENG";	 		//* nom du bloc DONDET MDR ENG*/
const char* SD_BAS_BLOC_VIADR_ENG = "VIADR_ENG";	 	//* nom du bloc DONDET VIADR ENG*/
const char* SD_BAS_BLOC_GIADR_ENG = "GIADR_ENG";	 	//* nom du bloc DONDET GIADR ENG*/
const char* SD_BAS_BLOC_MDR_VER = "MDR_VER";	 		//* nom du bloc DONDET MDR VER*/
const int SD_BAS_TAILLE_MAX_MDRVER = 300000;
// FT-2765
static const char* SD_BAS_BLOC_GRH = "GRH";  	 	//* nom du bloc GRH */
static const char* SD_BAS_BLOC_DUMMY = "DUMMY"; 	//* nom du bloc dmdr */
// ...FT-2765

/* FT-2522/FT-2525/FT-2528 */
const int SD_BAS_OFFSET_SPECTRE = 276790; // OFFSET DES SPECTRES
/* ..FT-2522/FT-2525/FT-2528 */

const int SD_BAS_OFFSET_IMAGE = 9500;     // OFFSET DE L'IMAGE
const int SD_BAS_OFFSET_VER = 24;         // OFFSET DES DONNEES DE VERIFICATION

// FT-2765
static const int SD_BAS_NB_OCTET_DATA = 2;
// ...FT-2765
const int SD_BAS_TAILLE_GRH_SANS_DATE = 8;
const int SD_BAS_DATA_STRING = 256;
const int SD_BAS_ECHEC = -1;

/* FT-2522/FT-2525/FT-2528 */
#define SD_BAS_DATA_PX 148
/* ..FT-2522/FT-2525/FT-2528 */

/* taille de DATA_IP sans le conteur d'equalisation qui est decommute separemment */
#define SD_BAS_DATA_IP 19 

/* TAILLE DES TABLEAUX */
#define SD_BAS_NB_IPR_FIELD 14
#define SD_BAS_NB_GRH_FIELD 7
#define SD_BAS_NB_DONGEN_AJOUTE 4
#define SD_BAS_NB_MAX_SF  20	  // nombre scale factor       


#define SD_BAS_MARGE 0

/* CR 349 */
/* FA 1767 rev1 */
#define  SD_BAS_SATSPEC -5000
/*  SD_BAS_MAX_NFLOAT = -32768 */
#define  SD_BAS_MAX_NFLOAT SHRT_MIN;
/* ... FA 1767 rev1 */
/* ... CR 349 */
// FT-2669
// FT-2562
#define SD_BAS_MAXNEG_INT4_SF6 -2147.483648
// ...FT-2562
// ...FT-2669

char* SD_BAS_MSG_VERSION_N1 ="INVALID PRODUCT L1 VERSION";
char* SD_BAS_MSG_NATURE = "INVALID TYPE";
char* SD_BAS_MSG_TRAITEMENT_SPECTRE = "SPECTRUM DECODING IMPOSSIBLE";
char* SD_BAS_MSG_TAILLE_SPECTRE = "THE SIZE OF SPECTRUM IS TOO LARGE";
char* SD_BAS_MSG_TAILLE_IMAGE = "THE SIZE OF IMAGE IS TOO LARGE";
char* SD_BAS_MSG_MDR = "RECORD MUST BE A MDR";
char* SD_BAS_MSG_LIREMPHRN1     = "INVALID LEVEL_1 MPHR";
char* SD_BAS_MSG_ECRIREMPHRN1   = "LEVEL_1 MPHR WRITE FAILED";
char* SD_BAS_MSG_LIREIPRN1      = "INVALID LEVEL_1 IPR";
char* SD_BAS_MSG_ECRIREIPRN1    = "LEVEL_1 IPR WRITE FAILED";
char* SD_BAS_MSG_LIREMDRGENN1   = "INVALID LEVEL_1 MDR";
char* SD_BAS_MSG_INITMDRDUMMY   = "LEVEL_1 MDR DUMMY INIT FAILED";
char* SD_BAS_MSG_INITMDR1C      = "LEVEL_1 MDR 1C INIT FAILED";
char* SD_BAS_MSG_INITMDRENG     = "LEVEL_1 MDR ENG INIT FAILED";
char* SD_BAS_MSG_INITMDRVER     = "LEVEL_1 MDR VER INIT FAILED";
char* SD_BAS_MSG_INITVIADRENG   = "LEVEL_1 VIADR ENG INIT FAILED";
char* SD_BAS_MSG_INITVIADRDUMMY = "LEVEL_1 VIADR DUMMY INIT FAILED";
char* SD_BAS_MSG_INITGIADRENG   = "LEVEL_1 GIADR ENG INIT FAILED";
char* SD_BAS_MSG_INITGIADRSCA   = "LEVEL_1 GIADR SCA INIT FAILED";
char* SD_BAS_MSG_INITGIADRQUAL  = "LEVEL_1 GIADR QUAL INIT FAILED";
char* SD_BAS_MSG_RECOMMUTERTYPERECORD = "LEVEL_1 RECORD SWAPPING FAILED";


/* indice des donnees decommutees dans les paquets N0 recopies dans */
/* les produits de verif */
typedef enum {
    VERN0_TYPE,
    VERN0_LONGUEUR,
    VERN0_SN,
    VERN0_PN
} e_SD_BAS_IND_VERN0;

//*====================================================================*/
//* Local types Declaration  
//*====================================================================*/
// structure utilisee pour la fonction de recopie superficielle
typedef struct 
	{
	DECOM__T_nom_var   nom_variable; // DECOM__C_lg_nom_var + 1
	DECOM__T_type_var  type; // type de la variable (1:int4 2:uint4
				 // 3:r8 4:char*)
	  int dim;     // dimension de la variable  
	}SD_BAS_Record;


//======================================================================
// Internal fonctions Declaration
//======================================================================
static t_CMN__Statut SD_BAS_InitMdrN1Ver(t_SD_BAS_Liste_Var *VIADR,
					   t_SD_BAS_DataThread *ctx);

static t_CMN__Statut SD_BAS_InitViadrN1Eng(t_SD_BAS_Liste_Var *VIADR,
                                    t_SD_BAS_DataThread *ctx);

static t_CMN__Statut SD_BAS_InitGiadrQual(t_SD_BAS_Liste_Var *GIADR,
					  t_SD_BAS_DataThread *ctx);

static t_CMN__Statut SD_BAS_InitGiadrSca(t_SD_BAS_Liste_Var *GIADR,
                                  t_SD_BAS_DataThread *ctx);

static t_CMN__Statut SD_BAS_InitGiadrEng(t_SD_BAS_Liste_Var *GIADR,
                                  t_SD_BAS_DataThread *ctx);

static t_CMN__Statut SD_BAS_InitMdr1C(t_SD_BAS_Liste_Var *MDR,
                               t_SD_BAS_DataThread *ctx);

static t_CMN__Statut SD_BAS_InitMdrEng(t_SD_BAS_Liste_Var  *MDR,
                                t_SD_BAS_DataThread *ctx);

static t_CMN__Statut SD_BAS_InitMdrDummy(t_SD_BAS_Liste_Var *MDR,
					 t_SD_BAS_DataThread *ctx);

static t_CMN__Statut SD_BAS_RecommuterTypeRecord(
  t_SD_BAS_DataThread * ctx, 
  t_SD_BAS_LigneN1 *    mdr, 
  char **               bloc, 
  unsigned int *        instr, 
  unsigned int *        taille_record, 
  unsigned int *        rec_subclass, 
  int *                 version_mdr);

//======================================================================
// Global variables Definition
//======================================================================

//======================================================================
//					FONCTIONS EXTERNES
//======================================================================
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_LireMPHRGIADRN1
//@
//@ Description : fonction de lecture du MPHR d'un produit 
//@  cette operation generique s'applique aux produits IASI de N1 
//@ elle lit a la fois le MPHR et le GIADR scale factor
//@
//@
//@ Parameters :
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces
//@			(SORTIE)  mphr  : liste des variables lues dans le MPHR
//@			(SORTIE)  giadr  : liste des variables lues dans le GIADR
//@				scale factor
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_LireMPHRGIADRN1(
		t_SD_BAS_Fd * Descripteur,
		t_SD_BAS_MPHR * mphr,
		t_SD_BAS_Liste_Var * giadr,
		t_SD_BAS_DataThread *ctx
			)
{
  /* nom de la fonction */
  static const char tcProcName_F[] = "SD_BAS_LireMPHRGIADRN1";
  /* retour de la fonction */
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  /* buffer lu */
  char *bloc;
  /* longueur du bloc lu */
  int lg = 0;
  /* retour de fonction */
  int ret;
  /* retour des fonctions de DECOM */
  t_SD_BAS_status_d status_d;
  /* message d'erreur pour le contexte d'erreur */
  char *msg_err;
  /* numero de ligne pour le contexte d'erreur */
  int num_lig;
  /* retour de fonction */
  int nb_element;
  

// on appelle la fonction SD_BAS_LireMPHR afin 
//@ de lire le MPHR

  cr_op = SD_BAS_LireMPHR(Descripteur, mphr, ctx);
  if (cr_op != CMN__STATUT_OK)
    {
      cr_op   = SD_BAS_ERR_BAS_NIVEAU;
      msg_err = SD_BAS_MSG_LIREMPHRN1;
      num_lig = __LINE__;
      goto fin;
    }


  //@ on verifie que la version lue dans le MPH est compatible avec la version
  //@ de la couche : Descripteur->version <= SD_BAS_IASIN1_VERSION
  if( (Descripteur->version.major > SD_BAS_IASIN1_VERSION.major) ||
     (Descripteur->version.major == SD_BAS_IASIN1_VERSION.major &&
      Descripteur->version.minor > SD_BAS_IASIN1_VERSION.minor) )
    {
      cr_op = SD_BAS_ERR_VERSION_N1;
      msg_err = SD_BAS_MSG_VERSION_N1;
      num_lig = __LINE__;
      goto fin;
    } 

  //@ sinon on emmet une erreur et on sort
  //@ on stocke en interne le nombre de MDR
  Descripteur->nombreMDR = *(mphr->listevar.tab_var[MPHR_TOTAL_MDR].val.pui4);
 
  //@ on stocke en interne le nombre de VIADR			 
  Descripteur->nombreVIADR = *(mphr->listevar.tab_var[MPHR_TOTAL_VIADR].val.pui4);

  cr_op = SD_BAS_LireIPR(Descripteur, ctx);
  if (cr_op != CMN__STATUT_OK)
    {
      cr_op   = SD_BAS_ERR_BAS_NIVEAU;
      msg_err = SD_BAS_MSG_LIREIPRN1;
      num_lig = __LINE__;
      goto fin;
    }


  //@ si le produit est de nature 1A ou 1B ou 1C
  //@on lit le GIADR SCA
  if (Descripteur->nature == NA_IASIL1A || 
      Descripteur->nature == NA_IASIL1B ||
      Descripteur->nature == NA_IASIL1C )
    {
      if( SD_BAS_MacMALLOC(bloc, char, SD_BAS_TAILLE_GIADR_SCA) == FALSE)
        {
          cr_op = SD_BAS_ERR_BAS_NIVEAU;
          msg_err = SD_BAS_MSG_ALLOC;
          num_lig = __LINE__;
          goto fin;
        }
   
      //@ on se place prealablement a l'offset de SD_BAS_OFFSET_GIADR_SCA
      ret =fseeko(Descripteur->fd, Descripteur->offsetGAD + SD_BAS_TAILLE_MAX_GIADRQUAL, SEEK_SET);
      if(ret == SD_BAS_ECHEC)
        {
          cr_op = SD_BAS_ERR_BAS_NIVEAU;
          msg_err = SD_BAS_MSG_SEEK;
          num_lig = __LINE__;
          goto fin;
        }
      
      //@ on recupere un bloc correspondant a une taille de SD_BAS_TAILLE_MAX_GIADRQUAL
      nb_element = 1;
      ret=fread(bloc, SD_BAS_TAILLE_GIADR_SCA, nb_element, Descripteur->fd);
      if(ret != nb_element)
        {
          cr_op = SD_BAS_ERR_BAS_NIVEAU;
          msg_err = SD_BAS_MSG_READ;
          num_lig = __LINE__;
          goto fin;
        }
      
      //@ on appelle la couche de decodage afin de lire le contenu du GIADR 
      //@ DECOM__Decommuter ( fic SD_BAS_NOM_FIC_PROD bloc SD_BAS_BLOC_GIADR_SCA 
      status_d=DECOM__Decommuter(bloc,lg,SD_BAS_BLOC_GIADR_SCA,"",giadr);
      SD_BAS_TEST_DECOM(status_d, SD_BAS_ERR_DECOMMUTER, __LINE__);

      //@ on libere le bloc alloue
      SD_BAS_MacFREE(bloc); 
    }
 

 fin:
 /* si une erreur est detectee */
 if ( cr_op != CMN__STATUT_OK )
       {
     /* mise a jour de la variable ctx->cr.errinterne */
     SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                         SD_BAS_ERR_SET_Niveau1,
                         SD_BAS_ERR_NUM_JDB,
                         tcProcName_F,
                         num_lig,
                         msg_err);
   }

 /* on retourne le status */
 return(cr_op); 

}



//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_EcrireMPHRSPHRN1
//@
//@ Description : fonction d'ecriture du MPHR d'un produit IASI L1
//@  cette operation generique s'applique aux produits IASI de N1 
//@ cette operation peut etre rappelee a la fin pour mettre a jour les 
//@ pointeurs IPR
//@
//@ Parameters :
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces
//@			(ENTREE)  mphr  : liste des variables a ecrire dans le MPHR
//@			(ENTREE)  init  : mode 
//@			(ENTREE)  start : date de debut de produit
//@			(ENTREE)  stop  : date de fin de produit
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
/* FA 180 */
t_CMN__Statut SD_BAS_EcrireMPHRSPHRN1(
		e_BAS_ModeTrt mode_traitement,
		e_BAS_PositionTrt position_Traitement,
		t_SD_BAS_Fd * Descripteur,
		t_CMN__Booleen	init, // init vrai ou faux
		t_SD_BAS_MPHR * mphr,
		t_SD_BAS_SCDSTime start,
		t_SD_BAS_SCDSTime stop,
		t_SD_BAS_DataThread *ctx
                )
/* ..FA 180 */
{
  /* nom de la fonction */
  static const char tcProcName_F[] = "SD_BAS_EcrireMPHRSPHRN1";
  /*retour de la fonction */
  t_CMN__Statut cr_op=CMN__STATUT_OK;
 
  /* message d'erreur pour le contexte d'erreur */
  char *msg_err=NULL; 
  /* numero de ligne pour le contexte d'erreur */
  int num_lig;  
  /* Descripteur de l'ipr a ecrire */
  t_SD_BAS_Produit *Produit;
  /* indice de boucle */
  int i;
  /* taille du fichier */
  int unsigned taille_fic;
  /* retour de fonction */
  int ret;
/* FA 180 */
  /* position du descripteur de fichier */
  off_t  PositionCourante;
  off_t  PositionRetour;
  /* taille du fichier secondaire en mode dump */
  off_t  taille_mdr;
  off_t  taille_viadr;

  t_SD_BAS_MPHR  * mphrPrec;
  mphrPrec = malloc (sizeof(t_SD_BAS_MPHR));
/* ..FA 180 */
  
  //@ si init = 0 alors
  if(init == CMN__FAUX)
    {
      //@ on initialise le start et le stop time
      mphr->grh.tab_var[GRH_RECORD_START_TIME].val.pdate->day = start.day; 
      mphr->grh.tab_var[GRH_RECORD_START_TIME].val.pdate->millis = start.millis; 
      mphr->grh.tab_var[GRH_RECORD_STOP_TIME].val.pdate->day = stop.day; 
      mphr->grh.tab_var[GRH_RECORD_STOP_TIME].val.pdate->millis = stop.millis;


      //@   on initialise la version du produit avec SD_BAS_IASIN1_VERSION

      *(mphr->listevar.tab_var[MPHR_FORMAT_MAJOR_VERSION].val.pui4)=  SD_BAS_IASIN1_VERSION.major;
      *(mphr->listevar.tab_var[MPHR_FORMAT_MINOR_VERSION].val.pui4)=  SD_BAS_IASIN1_VERSION.minor;

      /* on calcule la taille du produit pour remplir le champ ACTUAL_PRODUCT_SIZE */ 
    }
  //@ fin si

/* FA 180 */
if ( DUMP == mode_traitement )
{
      *(mphr->listevar.tab_var[MPHR_FORMAT_MAJOR_VERSION].val.pui4)=  SD_BAS_IASIN1_VERSION.major;
      *(mphr->listevar.tab_var[MPHR_FORMAT_MINOR_VERSION].val.pui4)=  SD_BAS_IASIN1_VERSION.minor;
}
/* ..FA 180 */


  /* suivant le type du produit on ecrit les IPRs correspondant */
  Produit = Descripteur->descripteurIPR;

  /* on parcourt le descripteur de produit et on ecrit les ipr */
  i=0;
  while(Produit[i].Rec != TR_UNDEFINED)
    {
      //@   on appelle la fonction SD_BAS_EcrireIPR afin 
      //@   d'ecrire les IPR
 
      cr_op = SD_BAS_EcrireIPR(
        Descripteur, 
        Produit[i].Rec, 
        Produit[i].Instrument, 
        Produit[i].subclass, 
        Produit[i].Offset, 
        start, 
        stop, 
        i, 
        ctx);
        
      if (cr_op != CMN__STATUT_OK)
      {
        cr_op   = SD_BAS_ERR_BAS_NIVEAU;
        msg_err = SD_BAS_MSG_ECRIREIPRN1;
        num_lig = __LINE__;
        goto fin;
      }

      i++;
    }
 

  /* on se place a la fin du fichier */
  ret = fseeko(Descripteur->fd, 0, SEEK_END);
  if(ret == -1)
    {
      cr_op = SD_BAS_ERR_BAS_NIVEAU;
      num_lig = __LINE__;
      msg_err = SD_BAS_MSG_SEEK;
      goto fin;
    }

/* FA 180 */
  /* on recupere la taille du fichier primaire */
  taille_fic = ftello(Descripteur->fd);
 
  //@ SI mode = DUMP ALORS
  if ((DUMP == mode_traitement) && (CMN__VRAI == init))
  {
    if (NULL == Descripteur->fd_sec)
    {
      cr_op = SD_BAS_ERR_BAS_NIVEAU;
      num_lig = __LINE__;
      msg_err = SD_BAS_MSG_OPEN; 
      goto fin;
    }
    else
    {
      /* on memorise la position courante du descripteur du fichier secondaire
      */
      PositionCourante = ftello(Descripteur->fd_sec);
      
      /* on se place en fin de fichier secondaire */
      ret = fseeko(Descripteur->fd_sec, 0, SEEK_END);
      if(ret == -1)
      {
        cr_op = SD_BAS_ERR_BAS_NIVEAU;
        num_lig = __LINE__;
        msg_err = SD_BAS_MSG_SEEK;
        goto fin;
      }

      /* on recupere la taille du fichier */
      taille_mdr = ftello(Descripteur->fd_sec);
      
      /* on se replace en position initiale */
      ret = fseeko(Descripteur->fd_sec, PositionCourante, SEEK_SET);
      if(ret == -1)
      {
        cr_op = SD_BAS_ERR_BAS_NIVEAU;
        num_lig = __LINE__;
        msg_err = SD_BAS_MSG_SEEK;
        goto fin;
      }
#ifdef INVESTIGATION
      PositionRetour = ftello(Descripteur->fd_sec);
      printf ("PositionCourante=%d\n", PositionCourante);
      printf ("PositionRetour  =%d\n", PositionRetour);
#endif   
      
      taille_fic = taille_fic + taille_mdr;

      if (Descripteur->nature == NA_IASIL1ENG)
      {
        /* meme operation pour trouver la taille du fichier secondaire viadr*/
        PositionCourante = ftello(Descripteur->fd_viadr_tmp);
        ret = fseeko(Descripteur->fd_viadr_tmp, 0, SEEK_END);
        if(ret == -1)
        {
          cr_op = SD_BAS_ERR_BAS_NIVEAU;
          num_lig = __LINE__;
          msg_err = SD_BAS_MSG_SEEK;
          goto fin;
        }

        /* on recupere la taille du fichier */
        taille_viadr = ftello(Descripteur->fd_viadr_tmp);
      
         /* on se replace en position initiale */
        ret = fseeko(Descripteur->fd_viadr_tmp, PositionCourante, SEEK_SET);
        if(ret == -1)
        {
          cr_op = SD_BAS_ERR_BAS_NIVEAU;
          num_lig = __LINE__;
          msg_err = SD_BAS_MSG_SEEK;
          goto fin;
        }
        taille_fic = taille_fic + taille_viadr;

      }/* fin si fichier ENG*/
      
    }
  }
/* ..FA 180 */
 
  /* on initialise la taille du produit */
  *(mphr->listevar.tab_var[MPHR_ACTUAL_PRODUCT_SIZE].val.pui4)= taille_fic;

  /* on met a jour le nombre d' IPR */ 
  *(mphr->listevar.tab_var[MPHR_TOTAL_IPR].val.pui4) = i;

  /* on met a jour le nombre total de records */
  *(mphr->listevar.tab_var[MPHR_TOTAL_RECORDS].val.pui4) =
    *(mphr->listevar.tab_var[MPHR_TOTAL_MPHR].val.pui4) +
    *(mphr->listevar.tab_var[MPHR_TOTAL_SPHR].val.pui4) +
    *(mphr->listevar.tab_var[MPHR_TOTAL_IPR].val.pui4) +
    *(mphr->listevar.tab_var[MPHR_TOTAL_GEADR].val.pui4) +
    *(mphr->listevar.tab_var[MPHR_TOTAL_GIADR].val.pui4) +
    *(mphr->listevar.tab_var[MPHR_TOTAL_VEADR].val.pui4) +
    *(mphr->listevar.tab_var[MPHR_TOTAL_VIADR].val.pui4) +
    *(mphr->listevar.tab_var[MPHR_TOTAL_MDR].val.pui4);

/* FA 180 */
/* si mode dump et au moins second granule , on recupere le mphr qui avait ete ecrit au
granule precedent */
if ((DUMP == mode_traitement) && (FIRST != position_Traitement))
{
  cr_op = SD_BAS_LireMPHR( Descripteur,
		           mphrPrec,
		           ctx);
  if (cr_op != CMN__STATUT_OK)
    {
      cr_op   = SD_BAS_ERR_BAS_NIVEAU;
      msg_err = SD_BAS_MSG_ECRIREMPHRN1;
      num_lig = __LINE__;
      goto fin;
    }
  //@ mise a jour des champs lies au premier granule 
  //@ TOTAL_MDR
  *(mphr->listevar.tab_var[MPHR_TOTAL_MDR].val.pui4) = *(mphr->listevar.tab_var[MPHR_TOTAL_MDR].val.pui4) +
      *(mphrPrec->listevar.tab_var[MPHR_TOTAL_MDR].val.pui4) ;
  
  //@ TOTAL_VIADR
  *(mphr->listevar.tab_var[MPHR_TOTAL_VIADR].val.pui4) = *(mphr->listevar.tab_var[MPHR_TOTAL_VIADR].val.pui4) +
      *(mphrPrec->listevar.tab_var[MPHR_TOTAL_VIADR].val.pui4) ;
  
  //@ SUBSAT_LATITUDE_START
     *(mphr->listevar.tab_var[MPHR_SUBSAT_LATITUDE_START].val.pr8) =    
        *(mphrPrec->listevar.tab_var[MPHR_SUBSAT_LATITUDE_START].val.pr8); 
  
  //@ SUBSAT_LONGITUDE_START
     *(mphr->listevar.tab_var[MPHR_SUBSAT_LONGITUDE_START].val.pr8) =    
        *(mphrPrec->listevar.tab_var[MPHR_SUBSAT_LONGITUDE_START].val.pr8); 
  
  //@ SENSING_START
     strcpy(mphr->listevar.tab_var[MPHR_SENSING_START].val.s, 
            mphrPrec->listevar.tab_var[MPHR_SENSING_START].val.s);

  //@ MPHR_DURATION_OF_PRODUCT
  mphr->listevar.tab_var[MPHR_DURATION_OF_PRODUCT].val.pui4[0] = 
    CMN__DATE_CONV_SEC_2_MSEC(CMN__DATE_DIFF_SCDS_2_SEC_CME(start,stop));
  
  //@ MPHR_MILLISECONDS_OF_DATA_PRESENT
  mphr->listevar.tab_var[MPHR_MILLISECONDS_OF_DATA_PRESENT].val.pui4[0] = 
    mphr->listevar.tab_var[MPHR_DURATION_OF_PRODUCT].val.pui4[0] - 
    mphr->listevar.tab_var[MPHR_MILLISECONDS_OF_DATA_MISSING].val.pui4[0];
 
if ((Descripteur->nature != NA_IASIL1A) && (Descripteur->nature != NA_IASIL1C))
{

  //@ MPHR_COUNT_DEGRADED_PROC_MDR
  *(mphr->listevar.tab_var[MPHR_COUNT_DEGRADED_PROC_MDR].val.pui4) = *(mphr->listevar.tab_var[MPHR_COUNT_DEGRADED_PROC_MDR].val.pui4) +
      *(mphrPrec->listevar.tab_var[MPHR_COUNT_DEGRADED_PROC_MDR].val.pui4) ;
  
  //@ MPHR_COUNT_DEGRADED_INST_MDR
  *(mphr->listevar.tab_var[MPHR_COUNT_DEGRADED_INST_MDR].val.pui4) = *(mphr->listevar.tab_var[MPHR_COUNT_DEGRADED_INST_MDR].val.pui4) +
      *(mphrPrec->listevar.tab_var[MPHR_COUNT_DEGRADED_INST_MDR].val.pui4) ;
}

  //@ MPHR_COUNT_DEGRADED_INST_MDR_BLOCKS
  *(mphr->listevar.tab_var[MPHR_COUNT_DEGRADED_INST_MDR_BLOCKS].val.pui4) = *(mphr->listevar.tab_var[MPHR_COUNT_DEGRADED_INST_MDR_BLOCKS].val.pui4) +
      *(mphrPrec->listevar.tab_var[MPHR_COUNT_DEGRADED_INST_MDR_BLOCKS].val.pui4) ;
  
  //@ MPHR_COUNT_DEGRADED_PROC_MDR_BLOCKS
  *(mphr->listevar.tab_var[MPHR_COUNT_DEGRADED_PROC_MDR_BLOCKS].val.pui4) = *(mphr->listevar.tab_var[MPHR_COUNT_DEGRADED_PROC_MDR_BLOCKS].val.pui4) +
      *(mphrPrec->listevar.tab_var[MPHR_COUNT_DEGRADED_PROC_MDR_BLOCKS].val.pui4) ;

  /* on met a jour le nombre total de records */
  *(mphr->listevar.tab_var[MPHR_TOTAL_RECORDS].val.pui4) =
    *(mphr->listevar.tab_var[MPHR_TOTAL_MPHR].val.pui4) +
    *(mphr->listevar.tab_var[MPHR_TOTAL_SPHR].val.pui4) +
    *(mphr->listevar.tab_var[MPHR_TOTAL_IPR].val.pui4) +
    *(mphr->listevar.tab_var[MPHR_TOTAL_GEADR].val.pui4) +
    *(mphr->listevar.tab_var[MPHR_TOTAL_GIADR].val.pui4) +
    *(mphr->listevar.tab_var[MPHR_TOTAL_VEADR].val.pui4) +
    *(mphr->listevar.tab_var[MPHR_TOTAL_VIADR].val.pui4) +
    *(mphr->listevar.tab_var[MPHR_TOTAL_MDR].val.pui4);
  
}

free (mphrPrec);

/* ..FA 180 */

  //@   on appelle la fonction SD_BAS_EcrireMPHR afin 
  //@   d'ecrire le MPHR
 
  cr_op = SD_BAS_EcrireMPHR(Descripteur, mphr, ctx);
  if (cr_op != CMN__STATUT_OK)
    {
      cr_op   = SD_BAS_ERR_BAS_NIVEAU;
      msg_err = SD_BAS_MSG_ECRIREMPHRN1;
      num_lig = __LINE__;
      goto fin;
    }

 
  //@s'il s'agit du premier appel a la fonction
  if (init == CMN__FAUX)
    {
      //@   on incremente  offsetGADSuivant et offsetVIADRsuivant
      //@     Descripteur->offsetGADSuivant = 
      //@       Descripteur->offsetGADSuivant + SD_BAS_OFFSET_GIADR_SCA;
      Descripteur->offsetVIADRSuivant = 
        Descripteur->offsetVIADRSuivant + Descripteur->offsetGAD;
      //@   on incremente  offsetMDRSuivant si on n'est pas en mode APPEND
      if( (Descripteur->mode != APPEND) && (Descripteur->mode != APPEND_INIT) )
        {
          Descripteur->offsetMDRSuivant = 
            Descripteur->offsetMDRSuivant + Descripteur->offsetGAD;
        }

      //@  on incremente offsetGAD  offset MDR et offsetVIADR
      Descripteur->offsetVIADR = 
        Descripteur->offsetVIADR + Descripteur->offsetGAD;
      Descripteur->offsetMDR = 
        Descripteur->offsetMDR + Descripteur->offsetGAD;
    }
  //@ fin si   
   

  //@ sortie de la fonction 
 fin:

  /* si une erreur est detectee */
  if ( cr_op != CMN__STATUT_OK)
    {
      /* mise a jour de la variable ctx->cr.errinterne */
      SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                          SD_BAS_ERR_SET_Niveau1,
                          SD_BAS_ERR_NUM_JDB,
                          tcProcName_F,
                          num_lig,
                          msg_err);
    }

  /* on retourne le status */
  return(cr_op); 
}


//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_LireMDRGenN1
//@
//@ Description : fonction de lecture des donnees gen des IPR d'un produit 
//@  cette operation generique s'applique aux produits IASI de N1 
//@  on lit ici le grh et quelques info detaillees  ( soit sequentiellement
//@  soit a partir d'une adresse )
//@
//@ SD_BAS_LireMPHRGIADRN1 doit avoir ete appele avant
//@
//@ Parameters :
//@			(ENTREE)  init  : contexte d'initialisation
//@				init = CTX_INIT ( on lit le suivant )
//@				init = CTX_NORMAL ( on lit a l'adresse indique )
//@			(ENTREE)  offset  : offset pour le mode normal
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces
//@			(SORTIE)  dongen  : liste des variables lues dans le MDR
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_LireMDRGenN1(
		e_BAS_CtxInit init,
		int offset,
		t_SD_BAS_Fd * Descripteur,
		t_SD_BAS_Liste_Var * dongen,
		t_SD_BAS_DataThread *ctx
		)
{
  /* nom de la fonction */
  static const char tcProcName_F[] = "SD_BAS_LireMDRGenN1";
  /*retour de la fonction */
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  /* retour de fonction */
  int ret;
  /* version du MDR lu */
  int version;
  /* longueur des donnees lues */
  int lg = 0;
  /* buffer de lecture */
  char *bloc;
  /* taille du buffer a lire */
  off_t taille_rec=0;
  /* instrument lu dans le GRH */
  off_t instrument;
  /* offset du debut de lecture */
  off_t offset_vrai;
  /* element ajouter a la listevar */
  DECOM__T_val_var   valeur;
  /* retour des fonctions de commutations */
  t_SD_BAS_status_d status_d;
  /* liste du grh lu */
  t_SD_BAS_Liste_Var grh;
  /* message d'erreur pour le contexte d'erreur */
  char *msg_err;
  /* numero de ligne pour le contexte d'erreur */
  int num_lig;
  /* retour de fonction */
  int nb_element;
  int versionmdrref;

//@ on verifie que l'etat est a INIT ou ENCOURS 
//@ et que le mode est lecture 
if ( (Descripteur->etat == INIT || Descripteur->etat == ENCOURS)
      &&( Descripteur->mode == LECTURE))
   {



//@ si INIT
//@   offset = offset MDR courant

     if( init == CTX_INIT )
       offset_vrai = Descripteur-> offsetMDR;

//@ sinon NORMAL
//@   offset = parametre
     else
       offset_vrai = offset;

   
//@   on alloue un tableau de char de taille SD_BAS_TAILLE_GRH
     if( SD_BAS_MacMALLOC(bloc,char,SD_BAS_TAILLE_GRH) == FALSE)
           {
	     cr_op = SD_BAS_ERR_BAS_NIVEAU;
	     msg_err = SD_BAS_MSG_ALLOC;
	     num_lig = __LINE__;
	     goto fin;
           }


//@   on recupere un bloc correspondant a une taille de SD_BAS_TAILLE_GRH dans le
//@   fichier prealablement ouvert a l'offset 
     ret = fseeko(Descripteur->fd ,offset_vrai , SEEK_SET);
     
     if(ret == SD_BAS_ECHEC)
       {
	 cr_op = SD_BAS_ERR_BAS_NIVEAU;
	 msg_err = SD_BAS_MSG_SEEK;
	 num_lig = __LINE__;
	 goto fin;
       }
         
     nb_element=1;
     ret = fread(bloc, SD_BAS_TAILLE_GRH, nb_element, Descripteur->fd);
     if(ret != nb_element)
       {
	 cr_op = SD_BAS_ERR_BAS_NIVEAU;
	 msg_err = SD_BAS_MSG_READ;
	 num_lig = __LINE__;
	 goto fin;
       }

         
//@   on appelle la couche de decodage afin de lire le contenu du GRH (SD_BAS_DecommuteGRH) 
//@   DECOM__Decommuter ( bloc SD_BAS_BLOC_GRH fic SD_BAS_NOM_FIC_PROD1)
	 
     status_d =  SD_BAS_DecommuteGRH(&grh, bloc);
     SD_BAS_TEST_DECOM(status_d, SD_BAS_ERR_DECOMMUTER ,__LINE__);  
	

     /* on libere le bloc lu */
     SD_BAS_MacFREE(bloc);
     

//@   on recupere ici la taille du record ( champ record_size ) ainsi que le type de record
     taille_rec = grh.tab_var[GRH_RECORD_SIZE].val.pui4[0];
     instrument = grh.tab_var[GRH_INSTRUMENT_GROUP].val.pui4[0];


//@   on recupere ici la version du record ( champ record_subclass_version ) 
//@   et on verifie que la version est < SD_BAS_MDR_VERSION
     version = *(grh.tab_var[GRH_RECORD_SUBCLASS_VERSION].val.pui4);
     
//@  selon le type de mdr (champ nature)
          switch(Descripteur->nature){
	  
//@  NA_IASIL1A:

          case NA_IASIL1A:
	  versionmdrref = SD_BAS_MDR1A_VERSION_N1;
            break;
  
    
//@  NA_IASIL1B:
          case NA_IASIL1B:
	  versionmdrref = SD_BAS_MDR1B_VERSION_N1;
            break;

            
//@  NA_IASIL1C:
          case NA_IASIL1C:
	  versionmdrref = SD_BAS_MDR1C_VERSION_N1;
            break;

        
//@  NA_IASIL1ENG:
          case NA_IASIL1ENG:
	  versionmdrref = SD_BAS_MDRENG_VERSION_N1;
            break;

//@  NA_IASIL1VER:
          case NA_IASIL1VER:
	  versionmdrref = SD_BAS_MDRVER_VERSION_N1;
            break;
	  case MDR_DUMMY:

	  versionmdrref = SD_BAS_MDRDUM_VERSION_N1;
	    break;

	  default:
	    cr_op = SD_BAS_ERR_NATURE;
	    msg_err = SD_BAS_MSG_NATURE;
	    num_lig = __LINE__;
	    goto fin;
          }
          //@fin switch
	  
	  
        if(version > versionmdrref)
       {
	 cr_op = SD_BAS_ERR_VERSION_N1;
	 msg_err = SD_BAS_MSG_VERSION_N1;
	 num_lig = __LINE__;
	 goto fin;
       }


//@   ( subclass = 1 instrument = dummy)

//@ on verifie que le type du record est ENG ou 1A1B
     if(Descripteur->nature == NA_IASIL1A || 
        Descripteur->nature == NA_IASIL1B || 
        Descripteur->nature == NA_IASIL1C ||
        Descripteur->nature == NA_IASIL1ENG)

       {

         if ( instrument != IN_DUMMY )
           {


//@ on alloue un tableau de char de la taille du record
             if( SD_BAS_MacMALLOC(bloc, char, taille_rec) == FALSE)
               {
                      cr_op = SD_BAS_ERR_BAS_NIVEAU;
                      msg_err = SD_BAS_MSG_ALLOC;
                      num_lig = __LINE__;
                      goto fin;
               }

//@   fichier prealablement ouvert a l'offset 
         ret = fseeko(Descripteur->fd ,offset_vrai , SEEK_SET);
	 
         if(ret == SD_BAS_ECHEC)
           {
             cr_op = SD_BAS_ERR_BAS_NIVEAU;
             msg_err = SD_BAS_MSG_SEEK;
             num_lig = __LINE__;
             goto fin;
           }


//@on lit dans le fichier ce buffer
	     nb_element=1;
             ret=fread(bloc ,taille_rec ,nb_element ,Descripteur->fd);
             if(ret != nb_element)
               {
                 cr_op = SD_BAS_ERR_BAS_NIVEAU;
                 msg_err = SD_BAS_MSG_READ;
                 num_lig = __LINE__;
                 goto fin;
               }  


//@    a partir de l'adresse du MDR suivant
//@    on decode dans ce fichier le word 1 pour determiner le type

    
//@    si type MDR1ABC
             if (Descripteur->nature == NA_IASIL1A ||
                 Descripteur->nature == NA_IASIL1B ||
                 Descripteur->nature == NA_IASIL1C)
               {
//@     on appelle la couche de decodage afin de lire le contenu du MDR  
//@     DECOM__Decommuter ( bloc SD_BAS_BLOC_DONGEN1ABC fic SD_BAS_NOM_FIC_PROD)
                 status_d=DECOM__Decommuter(bloc,
                                            lg,
                                            SD_BAS_BLOC_DONGEN1ABC,"",
                                            dongen);
                 SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_DECOMMUTER,__LINE__);   
               }
//@    sinon 

             else
               {
//@     on appelle la couche de decodage afin de lire le contenu du MDR  
//@     DECOM__Decommuter ( bloc DONGENENG fic SD_BAS_NOM_FIC_PROD)
                 status_d=DECOM__Decommuter(bloc,
                                            lg,
                                            SD_BAS_BLOC_DONGENENG,"",
                                            dongen);
                 SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_DECOMMUTER,__LINE__);

               }
//@    fin si

//@    on ajoute un type de donnee dans la liste de variable qui vaut normal

//@    liberation du tableau
             SD_BAS_MacFREE(bloc);
           }/* fin != dummy */
       }/* fin 1a 1b 1c eng */
//@   fin si
     
//@ si produit de verification ou DUMMY    
     if( Descripteur->nature == NA_IASIL1VER || instrument == IN_DUMMY)
       {
	 
/* on cree la listevar a la main */
	 dongen->nb_var = 0;
	 dongen->tab_var = NULL;

       /* on ajoute les dates */
	 status_d=DECOM__Ajouter_variable (dongen,"",
					   "N1_DATEDEB",
					   DECOM__C_date,1,valeur);
	 SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);

 //@ on alloue suivant le type  dans la liste des variables
	 ret = SD_BAS_MacMALLOC(dongen->tab_var[N1_DATEDEB].val.pdate, t_SD_BAS_SCDSTime , 1);
	 if(ret == FALSE)
	   {
	     cr_op = SD_BAS_ERR_BAS_NIVEAU;
	     msg_err = SD_BAS_MSG_ALLOC;
	     num_lig = __LINE__;
	     goto fin;
       }
	 
	 //@ affecte la valeur
	 dongen->tab_var[N1_DATEDEB].val.pdate->day = grh.tab_var[GRH_RECORD_START_TIME].val.pdate->day;
	 dongen->tab_var[N1_DATEDEB].val.pdate->millis = grh.tab_var[GRH_RECORD_START_TIME].val.pdate->millis;
	 


	 /* on ajoute les dates */
	 status_d=DECOM__Ajouter_variable (dongen,"",
					   "N1_DATEFIN",
					   DECOM__C_date,1,valeur);
       SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);
       
 //@ on alloue suivant le type  dans la liste des variables
       ret = SD_BAS_MacMALLOC(dongen->tab_var[N1_DATEFIN].val.pdate, t_SD_BAS_SCDSTime , 1);
       if(ret == FALSE)
	 {
	   cr_op = SD_BAS_ERR_BAS_NIVEAU;
	   msg_err = SD_BAS_MSG_ALLOC;
	   num_lig = __LINE__;
         goto fin;
	 }

     //@ affecte la valeur
       dongen->tab_var[N1_DATEFIN].val.pdate->day = grh.tab_var[GRH_RECORD_STOP_TIME].val.pdate->day;
       dongen->tab_var[N1_DATEFIN].val.pdate->millis = grh.tab_var[GRH_RECORD_STOP_TIME].val.pdate->millis;  
       
       /* on cree les elements N1_MODE N1_PTSI N1_GEPSDATEIASI */
       /* mais on affecte aucune valeur */
       status_d=DECOM__Ajouter_variable (dongen,"",
					 "N1_MODE",
					 DECOM__C_uint4,1,valeur);
       SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);
       // FT-2765
       dongen->tab_var[N1_MODE].val.pui4 = NULL;
       // ...FT-2765

       status_d=DECOM__Ajouter_variable (dongen,"",
					 "N1_PTSI",
					 DECOM__C_uint4,1,valeur);
       SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);
       // FT-2765
       dongen->tab_var[N1_PTSI].val.pui4 = NULL;
       // ...FT-2765
       
// FA 196 et 198: suppresion de N1_ONBOARD_SOFTWARE_VERSION (contenu dans PTSI)
      
       status_d=DECOM__Ajouter_variable (dongen,"",
					 "N1_GEPSDATEIASI",
					 DECOM__C_date, 1,valeur);
       SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);
       // FT-2765
       dongen->tab_var[N1_GEPSDATIASI].val.pdate = NULL;
       // ...FT-2765
      
       }/* fin mdr ver */


//@   on ajoute dans la liste des variables decommutees la taille du record

     status_d=DECOM__Ajouter_variable (dongen,"",
                                       "N1_TYPEREC",
                                       DECOM__C_uint4,1,valeur);
     SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);

  //@ on alloue suivant le type  dans la liste des variables
     ret = SD_BAS_MacMALLOC(dongen->tab_var[N1_TYPEREC].val.pui4, unsigned int, 1);
     if(ret == FALSE)
       {
         cr_op = SD_BAS_ERR_BAS_NIVEAU;
         msg_err = SD_BAS_MSG_ALLOC;
         num_lig = __LINE__;
         goto fin;
       }
    
     //@ affecte la valeur
     switch(Descripteur->nature)
       {
       case NA_IASIL1A:
         *dongen->tab_var[N1_TYPEREC].val.pui4 = MDR_1A;
	 break;
       case NA_IASIL1B:
         *dongen->tab_var[N1_TYPEREC].val.pui4 = MDR_1B;
	 break;
       case NA_IASIL1C:
         *dongen->tab_var[N1_TYPEREC].val.pui4 = MDR_1C;
	 break;
       case NA_IASIL1ENG:
         *dongen->tab_var[N1_TYPEREC].val.pui4 = MDR_ENG;
	 break;
       case NA_IASIL1VER:
	 *dongen->tab_var[N1_TYPEREC].val.pui4 = MDR_VER;
	 break;
       default:
	 cr_op = SD_BAS_ERR_NATURE;
         msg_err = SD_BAS_MSG_NATURE;
         num_lig = __LINE__;
         goto fin;
       }
    


//@   on ajoute un element dans la liste des variables decommutees la longueur du record

     status_d=DECOM__Ajouter_variable (dongen,"",
                                       "N1_LONGUEURREC",
                                       DECOM__C_uint4,1,valeur);
     SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);
     
     //@ on alloue suivant le type  dans la liste des variables
     ret = SD_BAS_MacMALLOC(dongen->tab_var[N1_LONGUEURREC].val.pui4, unsigned int, 1);
     if(ret == FALSE)
       {
         cr_op = SD_BAS_ERR_BAS_NIVEAU;
         msg_err = SD_BAS_MSG_ALLOC;
         num_lig = __LINE__;
         goto fin;
       }
    
     //@ affecte la valeur
     *dongen->tab_var[N1_LONGUEURREC].val.pui4 = taille_rec;




//@   on ajoute un element dans la liste des variables decommutees 

     status_d=DECOM__Ajouter_variable (dongen,"",
                                       "N1_OFFSET",
                                       DECOM__C_uint4,1,valeur);
     SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);

     //@ on alloue suivant le type  dans la liste des variables
     ret = SD_BAS_MacMALLOC(dongen->tab_var[N1_OFFSET].val.pui4, unsigned int, 1);
     if(ret == FALSE)
       {
         cr_op = SD_BAS_ERR_BAS_NIVEAU;
         msg_err = SD_BAS_MSG_ALLOC;
         num_lig = __LINE__;
         goto fin;
       }
    
     //@ affecte la valeur
     *dongen->tab_var[N1_OFFSET].val.pui4 = offset;

//@   si intrument == dummy
//@    on ajoute un type de donnee dans la liste de variable qui vaut INVALIDE

     status_d=DECOM__Ajouter_variable (dongen,"",
                                       "N1_VALIDREC",
                                       DECOM__C_uint4,1,valeur);
     SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);


     //@ on alloue suivant le type  dans la liste des variables
     ret = SD_BAS_MacMALLOC(dongen->tab_var[N1_VALIDREC].val.pui4, unsigned int, 1);
     if(ret == FALSE)
       {
         cr_op = SD_BAS_ERR_BAS_NIVEAU;
         msg_err = SD_BAS_MSG_ALLOC;
         num_lig = __LINE__;
         goto fin;
       }

     //@on affecte la valeur

     if(instrument == IN_DUMMY)
       *dongen->tab_var[N1_VALIDREC].val.pui4 = INVALIDE;
     else
       *dongen->tab_var[N1_VALIDREC].val.pui4 = VALIDE;
     



//@   on ajoute dans la liste des variables decommutees la validite du record
     status_d=DECOM__Ajouter_variable (dongen,"","N1_FLAG",
				       DECOM__C_uint4,1,valeur);
     SD_BAS_TEST_DECOM(status_d, SD_BAS_ERR_AJOUTER, __LINE__);

//@ on alloue dans la liste de variable la taille de la valeur

     ret = SD_BAS_MacMALLOC(dongen->tab_var[N1_FLAG].val.pui4,unsigned int, 1 );
     if( ret == FALSE )

       {
	 cr_op = SD_BAS_ERR_BAS_NIVEAU;
	 num_lig = __LINE__;
	 msg_err = SD_BAS_MSG_ALLOC;
	 goto fin;
       }

//@ on teste la date UTC par rapport a la date UTC precedente et on
//@ retourne une erreur si date UTC <= date UTC precedente
//@ on renseigne dateSCDSprec
	  
     if(dongen->tab_var[N1_DATEDEB].val.pdate->day < Descripteur->dateSCDSprec.day 
	||(dongen->tab_var[N1_DATEDEB].val.pdate->day == Descripteur->dateSCDSprec.day 
	   && dongen->tab_var[N1_DATEDEB].val.pdate->millis < Descripteur->dateSCDSprec.millis ))
       *(dongen->tab_var[N1_FLAG].val.pui4) = INCOHERENT;
     
     else
       *(dongen->tab_var[N1_FLAG].val.pui4) = VALIDE;

 
     /* on libere la listevar du grh*/
     SD_BAS_LibereListeVar(LECTURE, &grh);



   } /* fin si init, lecture ou encours */
//@ 
fin:
//@ on met a jour offsetMDRsuivant = offsetMDRsuivant + record_size
 Descripteur->offsetMDRSuivant = Descripteur->offsetMDRSuivant + taille_rec;


//@ sortie de la fonction 
 if ( cr_op != CMN__STATUT_OK)
   {
     /* mise a jour de la variable ctx->cr.errinterne */
     SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                         SD_BAS_ERR_SET_Niveau1,
                         SD_BAS_ERR_NUM_JDB,
                         tcProcName_F,
                         num_lig,
                         msg_err);


   }
/* on retourne le status */
return(cr_op); 
   

}

//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_LireMDRN1
//@
//@ Description : fonction de lecture  des MDR de type 1A 1B 1C ENG VER d'un produit 
//@  cette operation s'applique aux produits IASI de N1 
//@  on lit ici les info detaillees  en considerant que l'offset est renseigne
//@
//@
//@ Parameters :
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces
//@			(SORTIE)  mdr  : liste des variables lues dans le MDR
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_LireMDRN1(
		t_SD_BAS_Fd * Descripteur,
		t_SD_BAS_LigneN1 * mdr,
		t_SD_BAS_DataThread *ctx
			)
{
  /* nom de la fonction */
  static const char tcProcName_F[] = "SD_BAS_LireMDRN1";
  /*retour de la fonction */
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  /* offset du debut de lecture */
  off_t offset_PK;
  /* taille du buffer a lire */
  off_t taille_rec;
   /* retour de fonction */
  int ret;
  /* buffer de lecture */
  char *bloc;
  /* longueur des donnees lues */
  int lg = 0;
  /* retour des fonctions de commutations */
  t_SD_BAS_status_d status_d;
  /* message d'erreur pour le contexte d'erreur */
  char *msg_err;
  /* numero de ligne pour le contexte d'erreur */
  int num_lig;
  /* retour de fonction */
  int nb_element;
  /* element ajouter a la listevar */
  DECOM__T_val_var   valeur;
  /* infos de verification */
  t_SD_BAS_Liste_Var verif;
  /* offset dans les donnees de verif */
  int offset=0;
  /* type de paquet N0 dans les donnees se verif */
  int type=0;
  e_BAS_ValidRec     validite;

//@ on verifie que l'etat est a INIT ou ENCOURS 
//@ et que le mode est lecture 
  
  if ( (Descripteur->etat == INIT || Descripteur->etat == ENCOURS)
       &&( Descripteur->mode == LECTURE))
    {


//@ on initialise la structure mdr->InfoGen par appel a SD_BAS_LireMDRGen
//@(NORMAL)
      cr_op = SD_BAS_LireMDRGenN1(
                                  CTX_NORMAL,
                                  Descripteur->offsetMDRSuivant,
                                  Descripteur,
                                  &mdr->InfoGen,
                                  ctx);
      if( cr_op != CMN__STATUT_OK )
        {
          cr_op   = SD_BAS_ERR_BAS_NIVEAU;
          msg_err = SD_BAS_MSG_LIREMDRGENN1;
          num_lig = __LINE__;
          goto fin;
        }


//@ on recupere dans la liste des variables decommutees offsetMDRsuivant
      offset_PK  = *(mdr->InfoGen.tab_var[N1_OFFSET].val.pui4);

//@ on recupere dans la liste des variables decommutees la taille du record
      taille_rec  = *(mdr->InfoGen.tab_var[N1_LONGUEURREC].val.pui4);


    /* ainsi que la validite du record */
    validite = *(mdr->InfoGen.tab_var[N1_VALIDREC].val.pui4);

    /* si le record n'est pas invalide */
    if ( validite != INVALIDE )
    {
/* on initialise le type de record du MDR */
      mdr->TypeRec = *(mdr->InfoGen.tab_var[N1_TYPEREC].val.pui4);

      //@   on s'alloue un tableau de char de longueur taille du record 
      ret = SD_BAS_MacMALLOC( bloc, 
                              char, 
                              taille_rec);
      if(ret == FALSE)
        {
          cr_op = SD_BAS_ERR_BAS_NIVEAU;
          msg_err = SD_BAS_MSG_ALLOC;
          num_lig = __LINE__;
          goto fin;
        }

//@   on recupere un bloc correspondant a une taille du record dans le
//@   fichier prealablement ouvert a l'offset du MDR courant 

      ret = fseeko(Descripteur->fd ,offset_PK , SEEK_SET);
      
      if(ret == SD_BAS_ECHEC)
        {
          cr_op = SD_BAS_ERR_BAS_NIVEAU;
          msg_err = SD_BAS_MSG_SEEK;
          num_lig = __LINE__;
          goto fin;
        }

      nb_element=1;
      ret = fread(bloc, taille_rec ,nb_element ,Descripteur->fd);
      if(ret != nb_element)
        {
          cr_op = SD_BAS_ERR_BAS_NIVEAU;
          msg_err = SD_BAS_MSG_READ;
          num_lig = __LINE__;
          goto fin;
        }




      //@ si le type de record est 1ABC ou ENG
      if( mdr->TypeRec == MDR_1A || 
          mdr->TypeRec == MDR_1B ||
          mdr->TypeRec == MDR_1C)
        {
         
          //@on alloue une  structure t_SD_BAS_DonCodN1 ou sont ecrit les spectres et les images
          ret = SD_BAS_MacMALLOC(mdr->InfoCod, t_SD_BAS_DonCodN1, 1);
          if(ret == FALSE)
            {
              cr_op = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_ALLOC;
              num_lig = __LINE__;
              goto fin;
            }
//@   la taille du champ datasp est determine
//@   SD_BAS_SS1*SD_BAS_SNOT*SD_BAS_PN* 16 bits 
//@   on stocke la taille dans la structure t_SD_BAS_DonCodN1
 
          mdr->InfoCod->lgsp = SD_BAS_SS*SD_BAS_PN*SD_BAS_SNOT* SD_BAS_NB_OCTET_DATA;
 
//@   on s'alloue un tableau de char de longueur taille  que l'on stocke dans 
//@   data de mdr->InfoCod.datasp[0]


//@ 1A : spectre 1A dans datasp[0] 
//@ 1B : spectre 1B dans datasp[1]
//@ 1C : spectre 1C dans datasp[2]

     
          
//@   on s'alloue un tableau de char de longueur taille  que l'on stocke dans 
//@   data de mdr->InfoCod.datasp[ num_prod ]    
      
          ret = SD_BAS_MacMALLOC( mdr->InfoCod->datasp[ mdr->TypeRec], 
                                  char, 
                                  mdr->InfoCod->lgsp);
          if(ret == FALSE)
            {
                 cr_op = SD_BAS_ERR_BAS_NIVEAU;
                 msg_err = SD_BAS_MSG_ALLOC;
                 num_lig = __LINE__;
                 goto fin;
            }


//@   la taille du champ dataim est determine
//@   SD_BAS_SNOT*SD_BAS_IMLI*SD_BAS_IMCO 16 bits 
//@   on stocke la taille dans la structure t_SD_BAS_DonCodN1 

          mdr->InfoCod->lgim =  SD_BAS_SNOT*SD_BAS_IMLI*SD_BAS_IMCO*SD_BAS_NB_OCTET_DATA;

//@   on s'alloue un tableau de char de longueur taille  que l'on stocke dans 
//@   data de mdr->InfoCod->dataim

          ret = SD_BAS_MacMALLOC( mdr->InfoCod->dataim, 
                                  char, 
                                  mdr->InfoCod->lgim);
          if(ret == FALSE)
            {
              cr_op = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_ALLOC;
              num_lig = __LINE__;
              goto fin;
            }


//@   on recopie la donnee depuis ce buffer dans le buffer datasp 
          memcpy(mdr->InfoCod->datasp[  mdr->TypeRec ],
                 &bloc [ SD_BAS_OFFSET_SPECTRE],
                 mdr->InfoCod->lgsp);
	
//@   on recopie la donnee depuis ce buffer dans le buffer dataim 
          memcpy(mdr->InfoCod->dataim,
                 &bloc [SD_BAS_OFFSET_IMAGE ],
                 mdr->InfoCod->lgim);



        }






//@   selon la nature du produit (1A 1B ENG) on appelle la couche de decodage afin de lire 
//@   le contenu du MDR         
//@   DECOM__Decommuter ( bloc MDR_1A ou MDR_1B ou MDR_ENG fic SD_BAS_NOM_FIC_PROD1)
//@   on stocke ceci dans le champ InfoDet;


      switch( mdr->TypeRec)
        {
        case MDR_1A:
	  status_d=DECOM__Decommuter(bloc,
                                     lg,
                                     SD_BAS_BLOC_MDR_1A,"",
                                     &mdr->InfoDet);
          SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_DECOMMUTER,__LINE__);
	  break;
        case MDR_1B:
          status_d=DECOM__Decommuter(bloc,
                                     lg,
                                     SD_BAS_BLOC_MDR_1B,"",
                                     &mdr->InfoDet);
          SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_DECOMMUTER,__LINE__);

          break;

	case MDR_1C:
	  status_d=DECOM__Decommuter(bloc,
                                     lg,
                                     SD_BAS_BLOC_MDR_1C,"",
                                     &mdr->InfoDet);
          SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_DECOMMUTER,__LINE__);
	  break;
	  
        case MDR_ENG:
          status_d=DECOM__Decommuter(bloc,
                                     lg,
                                     SD_BAS_BLOC_MDR_ENG,"",
                                     &mdr->InfoDet);
          SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_DECOMMUTER,__LINE__);
          
          break;

	  
	case MDR_VER:
	   status_d=DECOM__Decommuter(bloc,
                                     lg,
                                     SD_BAS_BLOC_MDR_VER,"",
                                     &mdr->InfoDet);
	   SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_DECOMMUTER,__LINE__);

	   //@   on recopie les donnee de verification dans indodet2 
	   break;
	   


	default:
	  cr_op = SD_BAS_ERR_NATURE;
	  msg_err = SD_BAS_MSG_NATURE;
	  num_lig = __LINE__;
	  goto fin;

              
        }


      if( mdr->TypeRec == MDR_VER)
	{
	  /* on alloue un bloc de la taille des infos de verif */
	  ret = SD_BAS_MacMALLOC( mdr->InfoDet2, 
                                  char, 
                                  *mdr->InfoDet.tab_var[VER_SIZE_OF_VERIFICATION_DATA].val.pui4);

          if(ret == FALSE)
            {
              cr_op = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_ALLOC;
              num_lig = __LINE__;
              goto fin;
            }

	 
	  /* on recopie les infos de verif */
	  memcpy(mdr->InfoDet2,
                 &bloc [SD_BAS_OFFSET_VER ],
                 *mdr->InfoDet.tab_var[VER_SIZE_OF_VERIFICATION_DATA].val.pui4);

	  /* on cherche le premier paquet VP */
	  while(type != APID_VP && offset<*mdr->InfoDet.tab_var[VER_SIZE_OF_VERIFICATION_DATA].val.pui4)

	    {
	      /* on recopie BCodSpecVerlf */
	      status_d=DECOM__Decommuter(&((char*)mdr->InfoDet2)[offset],
					 lg,
					 "SD_BAS_BLOC_N0","",
					 &verif);
	      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_DECOMMUTER,__LINE__);
	      
	      taille_rec = *(verif.tab_var[VERN0_LONGUEUR].val.pui4);
	      type = *(verif.tab_var[VERN0_TYPE].val.pui4);
	      offset =  offset + taille_rec+7;
	    }
	  
	  /* on ajoute le SN au infodet */
	  status_d=DECOM__Ajouter_variable (&mdr->InfoDet,"","VER_SN",
					    DECOM__C_uint4,1,valeur);
	  SD_BAS_TEST_DECOM(status_d, SD_BAS_ERR_AJOUTER, __LINE__);
     
	  //@ on alloue dans la liste de variable la taille de la valeur
	  
	  ret = SD_BAS_MacMALLOC(mdr->InfoDet.tab_var[VER_SN].val.pui4,unsigned int, 1 );
	  
	  if( ret == FALSE )
       	    {
	      cr_op = SD_BAS_ERR_BAS_NIVEAU;
	      num_lig = __LINE__;
	      msg_err = SD_BAS_MSG_ALLOC;
	      goto fin;
	    }

	  
	  /* on ajoute le SN au infodet */
	  status_d=DECOM__Ajouter_variable (&mdr->InfoDet,"","VER_PN",
					    DECOM__C_uint4,1,valeur);
	  SD_BAS_TEST_DECOM(status_d, SD_BAS_ERR_AJOUTER, __LINE__);
     
	  //@ on alloue dans la liste de variable la taille de la valeur
	  
	  ret = SD_BAS_MacMALLOC(mdr->InfoDet.tab_var[VER_PN].val.pui4,unsigned int, 1 );
	  
	  if( ret == FALSE )
       	    {
	      cr_op = SD_BAS_ERR_BAS_NIVEAU;
	      num_lig = __LINE__;
	      msg_err = SD_BAS_MSG_ALLOC;
	      goto fin;
	    }
	  *(mdr->InfoDet.tab_var[VER_SN].val.pui4) = *(verif.tab_var[VERN0_SN].val.pui4);
	  *(mdr->InfoDet.tab_var[VER_PN].val.pui4) = *(verif.tab_var[VERN0_PN].val.pui4);
	}     

      //@ on libere le buffer de lecture.
      SD_BAS_MacFREE( bloc );
    } /* fin du cas ou le record est valide */

   }
//@ remarque ici on ne s'alloue pas la structure InfoDet2
//@ 
fin:
//@ sortie de la fonction 
 if ( cr_op != CMN__STATUT_OK)
   {
     /* mise a jour de la variable ctx->cr.errinterne */
     SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                         SD_BAS_ERR_SET_Niveau1,
                         SD_BAS_ERR_NUM_JDB,
                         tcProcName_F,
                         num_lig,
                         msg_err);


   }
/* on retourne le status */
return(cr_op); 

}
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_LireVIADRN1
//@
//@ Description : fonction de lecture  des MDR de type  ENG  d'un produit 
//@  cette operation s'applique aux produits IASI de N1 
//@  on lit ici les info detaillees  en considerant que l'on connait le numero
//@ du VIADR ( si granule on commence a 1 ) sinon on commence a  
//@ (numdebLigneN1+ numabs)%10 +1
//@
//@
//@ Parameters :
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces
//@			(SORTIE)  num  : numero du VIADR a lire
//@			(SORTIE)  mdr  : liste des variables lues dans le VIADR
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_LireVIADRN1(
		t_SD_BAS_Fd * Descripteur,
		int num,
		t_SD_BAS_LigneN1 * mdr,
		t_SD_BAS_DataThread *ctx
		)
{
  /* nom de la fonction */
  static const char tcProcName_F[] = "SD_BAS_LireVIADRN1";
  /*retour de la fonction */
  t_CMN__Statut cr_op=CMN__STATUT_OK;
    /* longueur des donnees lues */
  int lg = 0;
  /* buffer de lecture */
  char *bloc;
  /* retour de fonction */
  int ret;
  /* retour des fonctions de commutations */
  t_SD_BAS_status_d status_d;
  /* message d'erreur pour le contexte d'erreur */
  char *msg_err;
  /* numero de ligne pour le contexte d'erreur */
  int num_lig;
  /* retour de fonction */
  int nb_element;
  /* GRH */
  t_SD_BAS_Liste_Var grh;

//@ on verifie que l'etat est a INIT ou ENCOURS 
//@ et que le mode est lecture et que la nature du produit est eng 
if ( (Descripteur->etat == INIT || Descripteur->etat == ENCOURS)
     &&( Descripteur->mode == LECTURE))
    {


//@   SI c'est le premier appel on lit les IPR par appel a SD_BAS_LireIPR
//@     on stocke en interne l'offset du premier VIADR 
//@     on libere les variables de l'IPR
//@   FinSI

//@ on initialise la structure mdr->InfoGen par appel a SD_BAS_LireMDRGen (init = 1)
//@ on recupere dans la liste des variables decommutees offsetMDRsuivant
//@ on recupere dans la liste des variables decommutees la taille du record




//@   on s'alloue un tableau de char de longueur taille du record 
      ret = SD_BAS_MacMALLOC( bloc, 
                              char, 
                              SD_BAS_TAILLE_MAX_VIADRENG);
      if(ret == FALSE)
        {
                cr_op = SD_BAS_ERR_BAS_NIVEAU;
                msg_err = SD_BAS_MSG_ALLOC;
                num_lig = __LINE__;
                goto fin;
        }




//@   on recupere un bloc correspondant a une taille du record dans le
//@   fichier prealablement ouvert a l'offset du VIADR ( offset premier + num * taille)
      ret = fseeko(Descripteur->fd ,
                  Descripteur->offsetVIADR + num * SD_BAS_TAILLE_MAX_VIADRENG,
                  SEEK_SET);
      if(ret == SD_BAS_ECHEC)
        {          
          cr_op = SD_BAS_ERR_BAS_NIVEAU;
          msg_err = SD_BAS_MSG_SEEK;
          num_lig = __LINE__;         
          goto fin;
        }

      nb_element = 1;
      ret = fread(bloc, SD_BAS_TAILLE_MAX_VIADRENG ,nb_element ,Descripteur->fd);
      if(ret != nb_element)
        {
          cr_op = SD_BAS_ERR_BAS_NIVEAU;
          msg_err = SD_BAS_MSG_READ;
          num_lig = __LINE__;
          goto fin;
        }


//@   on appelle la couche de decodage afin de lire le contenu du GRH (SD_BAS_DecommuteGRH) 
//@   DECOM__Decommuter ( bloc SD_BAS_BLOC_GRH fic SD_BAS_NOM_FIC_PROD1)
	 
     status_d =  SD_BAS_DecommuteGRH(&grh, bloc);
     SD_BAS_TEST_DECOM(status_d, SD_BAS_ERR_DECOMMUTER ,__LINE__);  


     if( *(grh.tab_var[GRH_INSTRUMENT_GROUP].val.pui4) == IN_DUMMY)
       mdr->TypeRec = VIADR_DUMMY;
     else
       mdr->TypeRec = VIADR_ENG;

/* onn libere le GRH */
     SD_BAS_LibereListeVar(LECTURE, &grh);


//@    on appelle la couche de decodage afin de lire 
//@   le contenu du VIADR  
//@   DECOM__Decommuter ( bloc VIADR_ENG fic SD_BAS_NOM_FIC_PROD1)
//@   on stocke ceci dans le champ InfoDet;
      status_d=DECOM__Decommuter(bloc,
                                 lg,
                                 SD_BAS_BLOC_VIADR_ENG,"",
                                 &mdr->InfoDet);
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_DECOMMUTER,__LINE__);

//@   on libere le buffer de lecture
      SD_BAS_MacFREE(bloc);
     


    }
//@ remarque ici on ne s'alloue pas la structure InfoDet2
fin:
/* si une erreur est detectee */
 if ( cr_op != CMN__STATUT_OK)
   {
     /* mise a jour de la variable ctx->cr.errinterne */
     SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                         SD_BAS_ERR_SET_Niveau1,
                         SD_BAS_ERR_NUM_JDB,
                         tcProcName_F,
                         num_lig,
                         msg_err);


   }
/* on retourne le status */
return(cr_op); 

}
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_LireGIADRN1
//@
//@ Description : fonction de lecture  des MDR de type  ENG SCA oU qUA d'un produit 
//@  cette operation s'applique aux produits IASI de N1 
//@
//@
//@ Parameters :
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces
//@			(SORTIE)  mdr  : liste des variables lues dans le VIADR
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_LireGIADRN1(
		t_SD_BAS_Fd * Descripteur,
		t_SD_BAS_LigneN1 * mdr,
		t_SD_BAS_DataThread *ctx
		)
{
  /* nom de la fonction */
  static const char tcProcName_F[] = "SD_BAS_LireGIADRN1";
  /*retour de la fonction */
  t_CMN__Statut cr_op=CMN__STATUT_OK;
    /* longueur des donnees lues */
  int lg = 0;
  /* buffer de lecture */
  char *bloc;
  /* retour de fonction */
  int ret;
  /* retour des fonctions de commutations */
  t_SD_BAS_status_d status_d;
  /* message d'erreur pour le contexte d'erreur */
  char *msg_err;
  /* numero de ligne pour le contexte d'erreur */
  int num_lig;
  /* retour de fonction */
  int nb_element;
  /* taille des donnees a ecrire */
  int taille_rec;
  /* nom du bloc a ecrire */
  char nom_bloc[SD_BAS_LG_NOM_BLOC];

//@ on verifie que l'etat est a INIT ou ENCOURS 
//@ et que le mode est lecture et que la nature du produit est eng 
if ( (Descripteur->etat == INIT || Descripteur->etat == ENCOURS)
     &&( Descripteur->mode == LECTURE))
    {

      //@ suivant le type de produit
      switch(mdr->TypeRec)
	{
	case GIADR_SCA:
	  taille_rec = SD_BAS_TAILLE_GIADR_SCA;
	  strcpy(nom_bloc, SD_BAS_BLOC_GIADR_SCA);
	  break;
	  
	case GIADR_QUA:
	  taille_rec = SD_BAS_TAILLE_MAX_GIADRQUAL;
	  strcpy(nom_bloc, SD_BAS_BLOC_GIADR_QUAL);
	  break;
	  
	case GIADR_ENG:
	  taille_rec = SD_BAS_TAILLE_MAX_GIADR_ENG;
	  strcpy(nom_bloc, SD_BAS_BLOC_GIADR_ENG);
	  break;
	  
	default:
	  cr_op = SD_BAS_ERR_NATURE;
	  msg_err = SD_BAS_MSG_NATURE;
	  num_lig = __LINE__;
	  goto fin;


	}


//@   on s'alloue un tableau de char de longueur taille du record 
      ret = SD_BAS_MacMALLOC( bloc, 
                              char, 
                              taille_rec);
      if(ret == FALSE)
        {
                cr_op = SD_BAS_ERR_BAS_NIVEAU;
                msg_err = SD_BAS_MSG_ALLOC;
                num_lig = __LINE__;
                goto fin;
        }




//@   on recupere un bloc correspondant a une taille du record dans le
//@   fichier prealablement ouvert a l'offset du  GIADR 
      ret = fseeko(Descripteur->fd ,
                  Descripteur->offsetGADSuivant,
                  SEEK_SET);
      if(ret == SD_BAS_ECHEC)
        {          
          cr_op = SD_BAS_ERR_BAS_NIVEAU;
          msg_err = SD_BAS_MSG_SEEK;
          num_lig = __LINE__;         
          goto fin;
        }

      nb_element = 1;
      ret = fread(bloc, taille_rec ,nb_element ,Descripteur->fd);
      if(ret != nb_element)
        {
          cr_op = SD_BAS_ERR_BAS_NIVEAU;
          msg_err = SD_BAS_MSG_READ;
          num_lig = __LINE__;
          goto fin;
        }


//@    on appelle la couche de decodage afin de lire 
//@   le contenu du GIADR  
//@   DECOM__Decommuter ( bloc GIADR_ENG fic SD_BAS_NOM_FIC_PROD1)
//@   on stocke ceci dans le champ InfoDet;
      status_d=DECOM__Decommuter(bloc,
                                 lg,
				 nom_bloc,"",
                                 &mdr->InfoDet);
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_DECOMMUTER,__LINE__);

//@   on libere le buffer de lecture
      SD_BAS_MacFREE(bloc);

    }
//@ remarque ici on ne s'alloue pas la structure InfoDet2
fin:
/* si une erreur est detectee */
 if ( cr_op != CMN__STATUT_OK)
   {
     /* mise a jour de la variable ctx->cr.errinterne */
     SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                         SD_BAS_ERR_SET_Niveau1,
                         SD_BAS_ERR_NUM_JDB,
                         tcProcName_F,
                         num_lig,
                         msg_err);

   }
/* on retourne le status */
return(cr_op); 

}

//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_LibereMDRVIADRN1
//@
//@ Description : fonction de liberation des MDR ou VIADR d'un produit 
//@  cette operation s'applique aux produits IASI de N1 
//@  on desallouie ici toute la place allouee precedenment 
//@
//@
//@ Parameters :
//@			(ENTREE)         mode : LECTURE ou ECRITURE
//@			(ENTREE/SORTIE)  mdr  : liste des variables lues dans le MDR
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_LibereMDR(
			       e_BAS_TypeAcces mode,
			       t_SD_BAS_LigneN1 * mdr
			       )
{
 
  /*retour de la fonction */
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  /* indice de boucle */
  int i;

//@ on verifie que l'etat est a INIT ou ENCOURS 
//@ et que le mode est lecture 

//@ si mode = lecture
 if (mode == LECTURE)
   {
//@   on libere la liste dans la structure mdr->InfoGen par appel a SD_BAS_LibereListeVar
//@( liberation globale)
     SD_BAS_LibereListeVar(LECTURE, &mdr->InfoGen);

//@   on libere la liste dans la structure mdr->InfoDet par appel a SD_BAS_LibereListeVar
//@( liberation globale)
    SD_BAS_LibereListeVar(LECTURE, &mdr->InfoDet);

     if (mdr->TypeRec == MDR_VER)
       {
         //@  on libere la liste dans la structure mdr->InfoDet2 par appel a SD_BAS_LibereListeVar
         SD_BAS_MacFREE(mdr->InfoDet2);
       }

    if(mdr->TypeRec == MDR_1A ||
       mdr->TypeRec == MDR_1B ||
       mdr->TypeRec == MDR_1C)
      { 
        // FT-2765
        if (mdr->InfoCod != NULL)
        {
	  //@   on libere les info codees  dans la structure mdr->Infocod 
	  for(i=0; i<SD_BAS_SB; i++)
          {
	    SD_BAS_MacFREE( mdr->InfoCod->datasp[i] );
	  }
	  SD_BAS_MacFREE( mdr->InfoCod->dataim );
	
	  SD_BAS_MacFREE( mdr->InfoCod);
        }
        // ...FT-2765
      }
   }
    //@ sinon (ecriture ou append)
 else
   {


//@   on libere la liste dans la structure mdr->InfoGen par appel a SD_BAS_LibereListeVar
//@( liberation superficielle)
     SD_BAS_LibereListeVar(ECRITURE, &mdr->InfoGen);


//@   on libere la liste dans la structure mdr->InfoDet par appel a SD_BAS_LibereListeVar
//@( liberation superficielle)
     SD_BAS_LibereListeVar(LECTURE, &mdr->InfoDet);

     if (mdr->TypeRec == MDR_VER)
       {
         //@  on libere la liste dans la structure mdr->InfoDet2 par appel a SD_BAS_LibereListeVar
         SD_BAS_MacFREE(mdr->InfoDet2);
       }

     if(mdr->TypeRec == MDR_1A ||
	mdr->TypeRec == MDR_1B ||
	mdr->TypeRec == MDR_1C)
       { 
	 

	 //@  on libere les info codees  dans la structure mdr->Infocod 
	 for(i=0; i<SD_BAS_SB; i++)
	   SD_BAS_MacFREE( mdr->InfoCod->datasp[i] );
	 
	 SD_BAS_MacFREE( mdr->InfoCod->dataim );
	 
	 SD_BAS_MacFREE( mdr->InfoCod);
//@   on libere Infocalc si le type est MDR_1ABC
	 SD_BAS_MacFREE( mdr->InfoCalc);
       }
   }
//@ 
fin:
//@ sortie de la fonction 

/* on retourne le status */
return(cr_op); 

}
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_DecodeSpectreN1
//@
//@ Description : fonction de decodage du spectre de N1  
//@  cette operation s'applique aux produits IASI de N1 
//@   la place  est allouee par l'appelant
//@
//@
//@ Parameters :        (ENTREE)  numLigneSNPN : SN PN en cours
//@			(ENTREE)  mdr  : contenu du MDR
//@                     (ENTREE) estValide : Temoin de validite 
//@			(ENTREE)  niveau : info a traiter (1A/1B/1C)
//@			(ENTREE)  sens : sens (encodage /decodage)
//@			(ENTREE)  Paramdecodage : parametres de decodage
//@			(ENTREE/SORTIE)  spectre  : contenu de la donnee
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_DecodeSpectreN1(
			t_SD_BAS_ORIGINE numLigneSNPN,	     
			t_SD_BAS_LigneN1 * mdr,
			const t_CMN__Booleen  estValide,
			e_SD_BAS_Atraiter niveau, 
			e_SD_BAS_Sens	sens, // sens (decodage/encodage)
			t_SD_BAS_ConfStable * Paramdecodage,
			double * spectre,
			t_SD_BAS_DataThread *ctx
			)

{
  static const char tcProcName_F[] = "SD_BAS_DecodeSpectreN1";
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  int nbs;
  int ns;
  int N;
  char *msg_err;
  int num_lig; 
  short int first[SD_BAS_TAILLE_NB_SI_B];
  short int last [SD_BAS_TAILLE_NB_SI_B];
  short int *SF;
  short int * pt_spect; /* PM4 CR185 */
  int nbscale;
  int k;
  int i,j;
  double fact[SD_BAS_NB_MAX_SF];
  double invfact[SD_BAS_NB_MAX_SF];

  /* si le record n'est pas invalide */
  if ( estValide == CMN__VRAI )
  {
    //@ on verifie que le type de la ligne est 1A ou 1B ou 1C
    if(mdr->TypeRec == MDR_1A ||
       mdr->TypeRec == MDR_1B ||
       mdr->TypeRec == MDR_1C)
    {
      //@on recupere les parametre de conversion
      //@ on verifie la coherence du niveau avec le type de la ligne :
      //@ niveau <= type de la ligne
      if(niveau > mdr->TypeRec)
      {
        cr_op = SD_BAS_ERR_TRAITEMENT_SPECTRE;
        msg_err = SD_BAS_MSG_TRAITEMENT_SPECTRE;
        num_lig = __LINE__;
        goto fin; 
      }
      
      //@ on travaille a partir de InfoDet.datasp[niveau]
      //@ le nombre d'echantillon est  SD_BAS_SS*SD_BAS_SNOT*SD_BAS_PN
      //@ la taille d'un echantillon est  * 16 bits
      //@ on verifie que SD_BAS_SS1*SD_BAS_SNOT*SD_BAS_PN<longueur du tableau Datasp
      //@ sinon erreur de taille 

      /* on recupere les infos dans le le fichier de configuration stable */
      nbscale = Paramdecodage->IDefScaleSondNbScale;
      SF = Paramdecodage->IDefScaleSondScaleFactor;
      /* on recopie les elements pour pouvoir les modifier localement */
      memcpy(first, Paramdecodage->IDefScaleSondNsfirst, SD_BAS_TAILLE_NB_SI_B*sizeof(short int));
      memcpy(last, Paramdecodage->IDefScaleSondNslast, SD_BAS_TAILLE_NB_SI_B*sizeof(short int));

      /* si MDR 1A */
      if(niveau == AT_1A)
	     {
	       /* on modifie IDefScaleSondNsfirst[0] et IDefScaleSondNslast[nbscale -1] */
	       /* pour la coherence de la taille */
        // pour la V2 (version 1.6 fichier de conf)
        nbscale = Paramdecodage->IDefScaleSondNbScale1a;
        SF = Paramdecodage->IDefScaleSondScaleFactor1a;
        memcpy(first, Paramdecodage->IDefScaleSondNsfirst1a, SD_BAS_TAILLE_NB_SI_B*sizeof(short int));
        memcpy(last, Paramdecodage->IDefScaleSondNslast1a, SD_BAS_TAILLE_NB_SI_B*sizeof(short int));
//	  first[0] = *(mdr->InfoDet.tab_var[N1A_IDEFNSFIRST].val.pi4);
//	  last[nbscale -1] = *(mdr->InfoDet.tab_var[N1A_IDEFNSLAST].val.pi4);
//        last[nbscale -1]= first[0] + (*(mdr->InfoDet.tab_var[N1A_IDEFNSLAST].val.pi4)-*(mdr->InfoDet.tab_var[N1A_IDEFNSFIRST].val.pi4));
	     }
      
      //@ on verifie la coherence de la taille des fonction d'encodage:
      if ( 
           ( (niveau == AT_1A) && 
             ( 
	              (last[nbscale -1] - first[0]) > 
	              (*(mdr->InfoDet.tab_var[N1A_IDEFNSLAST].val.pi4) - 
	               *(mdr->InfoDet.tab_var[N1A_IDEFNSFIRST].val.pi4)) 
             ) 
           ) || 
	          (
	            (niveau == AT_1C) && 
             ( 
	              (last[nbscale -1] - first[0]) > 
	              (*(mdr->InfoDet.tab_var[N1C_IDEFNSLAST1B].val.pi4) - 
	               *(mdr->InfoDet.tab_var[N1C_IDEFNSFIRST1B].val.pi4)) 
             )
	          )
         )
      {
      	 cr_op = SD_BAS_ERR_TRAITEMENT_SPECTRE;
        msg_err = SD_BAS_MSG_TRAITEMENT_SPECTRE;
        num_lig = __LINE__;
        goto fin; 
      }
             
      /* on recupere les infos du MDR */
      //@ on verifie la coherence de la taille des tableaux:
      if ( (last[nbscale -1] - first[0]) > SD_BAS_SS )
      {
        cr_op = SD_BAS_ERR_TAILLE_SPECTRE;
        msg_err = SD_BAS_MSG_TAILLE_SPECTRE;
        num_lig = __LINE__;
        goto fin; 
      }
      
      if(mdr->InfoCod->lgsp > SD_BAS_SS*SD_BAS_SNOT*SD_BAS_PN*SD_BAS_NB_OCTET_DATA)
      {
        cr_op = SD_BAS_ERR_TAILLE_SPECTRE;
        msg_err = SD_BAS_MSG_TAILLE_SPECTRE;
        num_lig = __LINE__;
        goto fin;
      }

      //@ pour chaque spectre
      k = ((numLigneSNPN.SN-1)*SD_BAS_PN + (numLigneSNPN.PN-1));

      // precalcul des scale facteurs 
      for (i=0;i<nbscale;i++)
      {
        fact[i]=1.;
        for (j=0;j<SF[i];j++)
          fact[i]=fact[i]*10.;
        invfact[i]=1./fact[i];
      }
      
      /* PM4 CR185 */
      pt_spect = (short int*)(mdr->InfoCod->datasp[niveau])+(k * SD_BAS_SS);
      
      //@ si decodage alors
      if(sens == DECODE)
	     {
        //@ on reconstruit le signal et on stocke la valeur dans le double en sortie
        //@ Do nbs=1, IDefScaleSondNbScale  
	       for(nbs=0; nbs<nbscale; nbs++)
        {
          //@	Do ns=IDefScaleSondNsfirst(nbs), IDefScaleSondNslast(nbs)
          for( ns=first[nbs]; ns<=last[nbs]; ns++)
          {
            //@	 N = ns - IDefScaleSondNsfirst(nbs)+ 1
            N = ns - first[0];
            
            //@      on extrait les 16 bits courant du buffer
            //@	 valdecod = SpecCod(n)*10^(- IDefScaleSondScaleFactor(nbs) )
            spectre[N] = (double)(pt_spect[N]) * invfact[nbs];
            //	        		(double)(pt_spect[N]) * pow(10., (double)(- SF[nbs])) ;
		        }/*end for */
    		  }/* end for */
      }/* end if decodage */
      //@ sinon codage alors
    	 else
      {
        //@ on reconstruit le signal et on stocke la valeur dans le double en sortie
        //@   Do nbs=1, IDefScaleSondNbScale  
        for(nbs=0; nbs<nbscale; nbs++) 
        {
          //@	Do ns=IDefScaleSondNsfirst(nbs), IDefScaleSondNslast(nbs)  
          for( ns=first[nbs]; ns<=last[nbs]; ns++)
          {
            //@	 N = ns - IDefScaleSondNsfirst(nbs)+ 1    
            N = ns - first[0];
            
            //@	valcod = entier le plus proche sur 16 bits de Spec(n)*10^( IDefScaleSondScaleFactor(nbs))
            // corection  erreur nint
            
            /* PM4 CR185 */
            pt_spect[N]=(short int)(NINT(spectre[N] * fact[nbs]));
	/* CR 349 */
           if (pt_spect[N] < SD_BAS_SATSPEC)
	   {
	   	pt_spect[N] = SD_BAS_MAX_NFLOAT;
	   }
	/* ...CR 349 */
           // FT-2765
           SWAP_INT_BUFFER( pt_spect + N, 2, 1 );
           // ...FT-2765
//    		      pt_spect[N]=(unsigned short int)(spectre[N] * fact[nbs]);
//		          pt_spect[N]=(unsigned short int)(spectre[N] * pow(10. , (double)SF[nbs]));
		        } /* end for */
		      } /* end for */

      } /* end si codage */
   	} /* finsi */
  } /* fin si le record n'est pas invalide */

fin:

 /* si une erreur est detectee */
  if ( cr_op != CMN__STATUT_OK )
  {
    /* mise a jour de la variable ctx->cr.errinterne */
    SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                        SD_BAS_ERR_SET_Niveau1,
                        SD_BAS_ERR_NUM_JDB,
                        tcProcName_F,
                        num_lig,
                        msg_err);

    /* on imprime le message d'erreur sur la sortie standard */
  }

  /* on retourne le status */
  return(cr_op); 
}


//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_DecodeSpectreN1b
//@
//@ Description : fonction de decodage du spectre de N1  
//@  cette operation s'applique aux produits IASI de N1 
//@   la place  est allouee par l'appelant
//@
//@
//@ Parameters :
//@			(ENTREE)  mdr  : contenu du MDR
//@			(ENTREE)  niveau : info a traiter (1A/1B/1C)
//@			(ENTREE)  sens : sens (encodage /decodage)
//@			(ENTREE)  giadr_sca : GIADR contenant les parametres de decodage
//@			(ENTREE/SORTIE)  spectre  : contenu de la donnee
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_DecodeSpectreN1b(
                t_SD_BAS_ORIGINE numLigneSNPN,	
		t_SD_BAS_LigneN1 * mdr,
		e_SD_BAS_Atraiter niveau, 
		e_SD_BAS_Sens	sens, // sens (decodage/encodage)
		t_SD_BAS_Liste_Var * giadr_sca,
		double * spectre,
		t_SD_BAS_DataThread *ctx
		)

{
  static const char tcProcName_F[] = "SD_BAS_DecodeSpectreN1";
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  int nbs;
  int ns;
  int N;
  char *msg_err;
  int num_lig; 
  int nbscale;
  int first[SD_BAS_TAILLE_NB_SI_B];
  int last[SD_BAS_TAILLE_NB_SI_B];
  int *SF;
  short int * pt_spect; /* PM4 CR185 */
  int k;


  /* si le record n'est pas invalide */
  if ( *(mdr->InfoGen.tab_var[N1_VALIDREC].val.pui4) != INVALIDE )
  {
    //@ on verifie que le type de la ligne est 1A ou 1B ou 1C
    if(mdr->TypeRec == MDR_1A ||
       mdr->TypeRec == MDR_1B ||
       mdr->TypeRec == MDR_1C)
    {
      //@on recupere les parametre de conversion
      //@ on verifie la coherence du niveau avec le type de la ligne :
      //@ niveau <= type de la ligne
      if(niveau > mdr->TypeRec)
      {
        cr_op = SD_BAS_ERR_TRAITEMENT_SPECTRE;
        msg_err = SD_BAS_MSG_TRAITEMENT_SPECTRE;
        num_lig = __LINE__;
        goto fin; 
      }
      
      //@ on travaille a partir de InfoDet.datasp[niveau]
      /* on recupere les infos du GIADR */
      nbscale = *(giadr_sca->tab_var[GIADRSCA_IDEFSCALESONDNBSCALE].val.pi4);

      memcpy(first, giadr_sca->tab_var[GIADRSCA_IDEFSCALESONDNSFIRST].val.pi4, SD_BAS_TAILLE_NB_SI_B * sizeof(int));
      memcpy(last, giadr_sca->tab_var[GIADRSCA_IDEFSCALESONDNSLAST].val.pi4, SD_BAS_TAILLE_NB_SI_B * sizeof(int));
      SF = giadr_sca->tab_var[GIADRSCA_IDEFSCALESONDSCALEFACTOR].val.pi4;

      /* si MDR 1A */
      if(mdr->TypeRec == MDR_1A)
      {
        /* on modifie IDefScaleSondNsfirst[0] et IDefScaleSondNslast[nbscale -1] */
        /* pour la coherence de la taille */
// pour la V2 (version 1.6 fichier de conf)
//          memcpy(first, Paramdecodage->IDefScaleSondNsfirst1a, nbscale*sizeof(short int));
//          memcpy(last, Paramdecodage->IDefScaleSondNslast1a, nbscale*sizeof(short int));
     	}
      
      //@ le nombre d'echantillon est  SD_BAS_SS*SD_BAS_SNOT*SD_BAS_PN
      //@ la taille d'un echantillon est  * 16 bits
      //@ on verifie que SD_BAS_SS1*SD_BAS_SNOT*SD_BAS_PN<longueur du tableau Datasp
      //@ sinon erreur de taille 
      if(mdr->InfoCod->lgsp > SD_BAS_SS*SD_BAS_SNOT*SD_BAS_PN*SD_BAS_NB_OCTET_DATA)
      {
        cr_op = SD_BAS_ERR_TAILLE_SPECTRE;
        msg_err = SD_BAS_MSG_TAILLE_SPECTRE;
        num_lig = __LINE__;
        goto fin;
      }

      //@ pour chaque spectre
      k = (numLigneSNPN.SN*SD_BAS_PN + numLigneSNPN.PN);
      /* PM4 CR185 */
      pt_spect = (short int*)(mdr->InfoCod->datasp[mdr->TypeRec])+(k * SD_BAS_SS);
      
      //@ si decodage alors			  
      if(sens == DECODE)
	     {
        //@ on reconstruit le signal et on stocke la valeur dans le double en sortie
        //@ Do nbs=1, IDefScaleSondNbScale  
        for(nbs=0; nbs<nbscale; nbs++) 
        {
          //@	Do ns=IDefScaleSondNsfirst(nbs), IDefScaleSondNslast(nbs)   
          for( ns=first[nbs]; ns<=last[nbs]; ns++)
          {
            //@	 N = ns - IDefScaleSondNsfirst(nbs)+ 1    
            N = ns - first[0];
            
            //@ on extrait les 16 bits courant du buffer
            //@	valdecod = SpecCod(n)*10^(- IDefScaleSondScaleFactor(nbs) )
            spectre[N] = (double)(*(pt_spect++)) * pow(10., (double)(- SF[nbs]));
          } /*end for */
        } /* end for */
      } /* end if decodage */
      //@ sinon codage alors
      else
      {
        //@ on reconstruit le signal et on stocke la valeur dans le double en sortie
        //@   Do nbs=1, IDefScaleSondNbScale  
	       for(nbs=0; nbs<nbscale; nbs++) 
        {
          //@	Do ns=IDefScaleSondNsfirst(nbs), IDefScaleSondNslast(nbs)  
          for( ns=first[nbs]; ns<=last[nbs]; ns++)
          {
            //@	 N = ns - IDefScaleSondNsfirst(nbs)+ 1    
            N = ns - first[0];
            
            //@	valcod = entier le plus proche sur 16 bits de Spec(n)*10^( IDefScaleSondScaleFactor(nbs))
            // corection  erreur nint
            /* PM4 CR185 */
            *(pt_spect++) = (short int)(NINT(spectre[N] * pow(10., (double)SF[nbs])));
            // FT-2765
            SWAP_INT_BUFFER( pt_spect - 1, 2, 1 );
            // ...FT-2765
          } /* end for */
        } /* end for */
	     } /* end si codage */
    } /* finsi */
  } /* fin si le record n'est pas invalide */

fin:
 /* si une erreur est detectee */
  if ( cr_op != CMN__STATUT_OK )
  {
    /* mise a jour de la variable ctx->cr.errinterne */
    SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                        SD_BAS_ERR_SET_Niveau1,
                        SD_BAS_ERR_NUM_JDB,
                        tcProcName_F,
                        num_lig,
                        msg_err);

    /* on imprime le message d'erreur sur la sortie standard */
  }

  /* on retourne le status */
  return(cr_op); 
}


//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_DecodeImageN1
//@
//@ Description : fonction de decodage d'une image de N1  
//@  cette operation s'applique aux produits IASI de N1 
//@   la place allouee precedenment est allouee par l'appelant
//@
//@
//@ Parameters :        (ENTREE)  numLigneSNPN : SN en cours
//@			(ENTREE)  mdr  : contenu du MDR
//@                     (ENTREE)  estValide : Temoin de validite 
//@			(ENTREE)  sens : sens (encodage /decodage)
//@			(ENTREE)  Paramdecodage : parametres de decodage
//@			(ENTREE/SORTIE)  image  : contenu de l'image allouee par
//@					l'appelant
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_DecodeImageN1(
				   t_SD_BAS_ORIGINE numLigneSNPN,
				   t_SD_BAS_LigneN1 * mdr,
				   const t_CMN__Booleen  estValide,
				   e_SD_BAS_Sens	sens, // sens (decodage/encodage)
				   t_SD_BAS_ConfStable * Paramdecodage,
				   double * image,
				   t_SD_BAS_DataThread *ctx
			)
{
  static const char tcProcName_F[] = "SD_BAS_DecodeImageN1";
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  int N;
  int i,j,k;
  unsigned short int * pt_im;
  // FT-2765
  unsigned short int i_im;
  // ...FT-2765
  char *msg_err;
  int num_lig;
  double fact;
  double invfact;

/* si le record n'est pas invalide */
 if ( estValide == CMN__VRAI )
  {
//@ on verifie que le type de la ligne est 1A ou 1B ou 1C
  if(mdr->TypeRec == MDR_1A ||
     mdr->TypeRec == MDR_1B ||
     mdr->TypeRec == MDR_1C)

    {



//@ on travaille a partir de InfoDet.datasp[niveau]
 
//@ le nombre d'echantillon est  SD_BAS_SNOT*SD_BAS_IMLI*SD_BAS_IMCO
//@ la taille d'un echantillon est  * 16 bits
//@ on verifie que SD_BAS_SNOT*SD_BAS_IMLI*SD_BAS_IMCO<longueur du tableau Dataim
//@ sinon erreur de taille 
      if(mdr->InfoCod->lgim >  SD_BAS_SNOT*SD_BAS_IMLI*SD_BAS_IMCO*SD_BAS_NB_OCTET_DATA )
        {
	  cr_op = SD_BAS_ERR_TAILLE_IMAGE;
          msg_err = SD_BAS_MSG_TAILLE_IMAGE;
          num_lig = __LINE__;
          goto fin;
	}

      k = (numLigneSNPN.SN-1);
      pt_im=(unsigned short int *)(mdr->InfoCod->dataim) + k * SD_BAS_IMCO * SD_BAS_IMLI;

      // precalcul des scale facteurs 
       fact=1.;
       for (j=0;j<Paramdecodage->IDefScaleIISScaleFactor;j++)
           fact=fact*10.;
       invfact=1./fact;
 //@ si decodage alors
      if( sens == DECODE)
	{
	  //@   on reconstruit le signal et on stocke la valeur dans le double en sortie
	  //@   Do i=1, 64
	  for(i=0;i<SD_BAS_IMLI;i++)
	    {
	      //@     Do j=1, 64    
	      for(j=0;j<SD_BAS_IMCO;j++)
		{
		  N=i * SD_BAS_IMCO + j;
		  //@      on extrait les 16 bits courant du buffer
		  
		  
		  //@      ImgdeCode =   img(n)*10^( -IDefScaleIISScaleFactor)//  
		  // FT-2765
		  i_im = *(pt_im++);
		  SWAP_INT_BUFFER( &i_im, 2, 1 );
		  image[N] = (double)(i_im)* invfact;
		  // ...FT-2765
//		  image[N] = (double)(*(pt_im++))* pow( 10. ,(double)-Paramdecodage->IDefScaleIISScaleFactor );


		    }
              /*     end do colonne */
		}
	  /*   end do ligne */
	    }
      /* fin decodage */

//@ sinon codage alors
//@   on reconstruit le signal et on stocke la valeur dans le double en sortie
      else
	{
	  /*   Do i=1, 64 */
	  for(i=0;i<SD_BAS_IMLI;i++)
	    {
	      /*     Do j=1, 64     */
	      for(j=0;j<SD_BAS_IMCO;j++)
		{
		  N=i * SD_BAS_IMCO + j;
		  //@      ImgCode = entier le plus proche sur 16 bits de img(n)*10^( IDefScaleIISScaleFactor)//  
                  
// corection  erreur nint
		  // FT-2765
		  i_im = (unsigned short int)(NINT(image[N] * fact));
		  SWAP_INT_BUFFER( &i_im, 2, 1 );
		  *(pt_im++) = i_im;
		  // ...FT-2765
//		  *(pt_im++) = (unsigned short int)(image[N] * fact);
//		  *(pt_im++) = (unsigned short int)(image[N] * pow(10., (double)Paramdecodage->IDefScaleIISScaleFactor));
                  
		}
	      /*     end do colonne */
	    }
	  /*     end do ligne */
	}
      /* finsi codage */
    }
/* fin si le record n'est pas invalide */
 } 
fin:
 /* si une erreur est detectee */
 if ( cr_op != CMN__STATUT_OK)
   {
     /* mise a jour de la variable ctx->cr.errinterne */
     SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                         SD_BAS_ERR_SET_Niveau1,
                         SD_BAS_ERR_NUM_JDB,
                         tcProcName_F,
                         num_lig,
                         msg_err);

    /* on imprime le message d'erreur sur la sortie standard */
   }
/* on retourne le status */
return(cr_op); 

}
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_DecodeImageN1
//@
//@ Description : fonction de decodage d'une image de N1  
//@  cette operation s'applique aux produits IASI de N1 
//@   la place allouee precedenment est allouee par l'appelant
//@
//@
//@ Parameters :        (ENTREE)  numLigneSNPN : SN en cours
//@			(ENTREE)  mdr  : contenu du MDR
//@			(ENTREE)  sens : sens (encodage /decodage)
//@			(ENTREE)  Paramdecodage : parametres de decodage
//@			(ENTREE/SORTIE)  image  : contenu de l'image allouee par
//@					l'appelant
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_DecodeImageN1b(
				    t_SD_BAS_ORIGINE numLigneSNPN,	    
				    t_SD_BAS_LigneN1 * mdr,
				    e_SD_BAS_Sens	sens, // sens (decodage/encodage)
				    t_SD_BAS_Liste_Var * giadr_sca,
				    double * image,
				    t_SD_BAS_DataThread *ctx
				    )
{
  static const char tcProcName_F[] = "SD_BAS_DecodeImageN1";
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  int N;
  int i,j,k;
  unsigned short int * pt_im;
  char *msg_err;
  int num_lig;
  int SF;

/* si le record n'est pas invalide */
 if ( *(mdr->InfoGen.tab_var[N1_VALIDREC].val.pui4) != INVALIDE )
  {
//@ on verifie que le type de la ligne est 1A ou 1B ou 1C
  if(mdr->TypeRec == MDR_1A ||
     mdr->TypeRec == MDR_1B ||
     mdr->TypeRec == MDR_1C)

    {



//@ on travaille a partir de InfoDet.datasp[niveau]
 
//@ le nombre d'echantillon est  SD_BAS_SNOT*SD_BAS_IMLI*SD_BAS_IMCO
//@ la taille d'un echantillon est  * 16 bits
//@ on verifie que SD_BAS_SNOT*SD_BAS_IMLI*SD_BAS_IMCO<longueur du tableau Dataim
//@ sinon erreur de taille 
      if(mdr->InfoCod->lgim >  SD_BAS_SNOT*SD_BAS_IMLI*SD_BAS_IMCO*SD_BAS_NB_OCTET_DATA )
        {
	  cr_op = SD_BAS_ERR_TAILLE_IMAGE;
          msg_err = SD_BAS_MSG_TAILLE_IMAGE;
          num_lig = __LINE__;
          goto fin;
	}

      SF=*(giadr_sca->tab_var[GIADRSCA_IDEFSCALEIISSSCALEFACTOR].val.pi4);

      k = numLigneSNPN.SN;
      pt_im=(unsigned short int *)(mdr->InfoCod->dataim) + k * SD_BAS_IMCO * SD_BAS_IMLI;

//@ si decodage alors
      if( sens == DECODE)
	{
	  //@   on reconstruit le signal et on stocke la valeur dans le double en sortie
	  //@   Do i=1, 64
	  for(i=0;i<SD_BAS_IMLI;i++)
	    {
	      //@     Do j=1, 64    
	      for(j=0;j<SD_BAS_IMCO;j++)
		{
		  N=i * SD_BAS_IMLI + j;
		  //@      on extrait les 16 bits courant du buffer
		  
		  
		  //@      ImgdeCode =   img(n)*10^( -IDefScaleIISScaleFactor)//  
		  image[N] = (double)(*(pt_im++))* pow( 10. ,(double)-SF );


		    }
              /*     end do colonne */
		}
	  /*   end do ligne */
	    }
      /* fin decodage */

//@ sinon codage alors
//@   on reconstruit le signal et on stocke la valeur dans le double en sortie
      else
	{
	  /*   Do i=1, 64 */
	  for(i=0;i<SD_BAS_IMLI;i++)
	    {
	      /*     Do j=1, 64     */
	      for(j=0;j<SD_BAS_IMCO;j++)
		{
		    N= i * SD_BAS_IMLI + j;

		  //@      ImgCode = entier le plus proche sur 16 bits de img(n)*10^( IDefScaleIISScaleFactor)//  
                  
// corection  erreur nint
		  *(pt_im++) = (unsigned short int)(NINT(image[N] * pow(10.,(double)SF)));
//		  *(pt_im++) = (unsigned short int)(image[N] * pow(10., (double)SF));
                  
		}
	      /*     end do colonne */
	    }
	  /*     end do ligne */
	}
      /* finsi codage */
    }
/* fin si le record n'est pas invalide */
 }  
fin:
 /* si une erreur est detectee */
 if ( cr_op != CMN__STATUT_OK)
   {
     /* mise a jour de la variable ctx->cr.errinterne */
     SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                         SD_BAS_ERR_SET_Niveau1,
                         SD_BAS_ERR_NUM_JDB,
                         tcProcName_F,
                         num_lig,
                         msg_err);

    /* on imprime le message d'erreur sur la sortie standard */
   }
/* on retourne le status */
return(cr_op); 

}

//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_EcrireGIADRN1
//@
//@ Description : fonction d'ecriture du GIADR des produits IASI L1
//@  cette operation generique s'applique aux produits IASI de N1 
//@
//@
//@ Parameters :
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces
//@			(ENTREE)  TypeRec  : type de GIADR a utiliser
//@			(ENTREE)  giadr  : liste des variables a ecrire dans le GIADR
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
/* FA 162*/
t_CMN__Statut SD_BAS_EcrireGIADRN1(
		e_BAS_ModeTrt mode_traitement,
		e_BAS_PositionTrt position_Traitement,
		t_SD_BAS_Fd * Descripteur,
		e_BAS_TypeRecN1 TypeRec,
		t_SD_BAS_Liste_Var * GIADR,
		t_SD_BAS_DataThread *ctx
			)
/* ..FA 162*/
{
  /* nom de la fonction */
  static const char tcProcName_F[] = "SD_BAS_EcrireGIADRN1";
  /*retour de la fonction */
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  /* buffer d' ecriture du giadr*/
  char * bloc;
  /* buffer d' ecriture du grh*/
  char * bloc_grh;
  /* retour de fonction */
  int ret;
  /* indice de boucle */
  int i;
  /* taille du buffer a ecrire */
  int taille_rec;
  /* subclass a ecrire dans le grh */
  int subclass;
  /* longueur des donnees ecrites */
  int lg = 0;
  /* retour des fonctions de commutations */
  t_SD_BAS_status_d status_d;
  /* liste du grh ecrit */
  t_SD_BAS_Liste_Var grh;
  /* tableau des elements a ajouter aux listevars */
  DECOM__T_val_var   valeur[SD_BAS_NB_GRH_FIELD];
  /* message d'erreur pour le contexte d'erreur */
  char *msg_err;
  /* numero de ligne pour le contexte d'erreur */
  int num_lig;
  /* retour de fonction */
  int nb_element;
  int giadrversion;

  //@ on verifie que l'etat est a INIT ou ENCOURS 
  //@ et que le mode est ecriture ou en append
  if ( (Descripteur->etat == INIT || Descripteur->etat == ENCOURS)
       &&( Descripteur->mode == ECRITURE || Descripteur->mode == APPEND || Descripteur->mode == APPEND_INIT))
    {
      



//@ on initialise la version du record avec SD_BAS_GIADR_VERSION_N1
//@ le start et le stop time sont consideres renseignes
//@ selon le type de giadr


      switch(TypeRec)
        {


//@ GIADR_QUAL:
//@ 	on appelle la couche de decodage afin de commuter le contenu du GIADR 
//@ 	DECOM__Commuter ( fic SD_BAS_NOM_FIC_PROD1 bloc SD_BAS_BLOC_GIADR_QUAL)
        case GIADR_QUA:
          

          status_d=DECOM__Recommuter (SD_BAS_BLOC_GIADR_QUAL,
                                      *GIADR,
                                      &bloc,
                                      &lg);
          SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_RECOMMUTER,__LINE__);
         
          taille_rec=SD_BAS_TAILLE_MAX_GIADRQUAL;
	  subclass = SD_BAS_GIADR_QUA_SUBCLASS;
	  giadrversion = SD_BAS_GIADRQUA_VERSION_N1;
          break;

//@ GIADR_SCA: idem
        case GIADR_SCA:
          status_d=DECOM__Recommuter (SD_BAS_BLOC_GIADR_SCA,
                                      *GIADR,
                                      &bloc,
                                      &lg);
          SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_RECOMMUTER,__LINE__);
      

          taille_rec=SD_BAS_TAILLE_GIADR_SCA;
	  subclass = SD_BAS_GIADR_SCA_SUBCLASS;
	  giadrversion = SD_BAS_GIADRSCA_VERSION_N1;
          break;

//@ GIADR_ENG: idem
        case GIADR_ENG:
          status_d=DECOM__Recommuter (SD_BAS_BLOC_GIADR_ENG,
                                      *GIADR,
                                      &bloc,
                                      &lg);
          SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_RECOMMUTER,__LINE__);
          
          taille_rec=SD_BAS_TAILLE_MAX_GIADR_ENG;
	  subclass = SD_BAS_GIADR_ENG_SUBCLASS;
	  giadrversion = SD_BAS_GIADRENG_VERSION_N1;
          break;

	default:
	  cr_op = SD_BAS_ERR_NATURE;
	  msg_err = SD_BAS_MSG_NATURE;
	  num_lig = __LINE__;
	  goto fin;
        }



//@on ecrit un GIADR
//@ on se positionne a la position offsetGAD
      ret = fseeko (Descripteur->fd, Descripteur->offsetGADSuivant, SEEK_SET);
      if(ret == SD_BAS_ECHEC)
        {
          cr_op = SD_BAS_ERR_BAS_NIVEAU;
          msg_err = SD_BAS_MSG_SEEK;
          num_lig = __LINE__;       
          goto fin;
        }
      

 //@ on ecrit dans le fichier le buffer de taille
      nb_element = 1;
      ret = fwrite (bloc, taille_rec, nb_element, Descripteur->fd);
      if(ret != nb_element)
        {
          cr_op = SD_BAS_ERR_BAS_NIVEAU;
          msg_err = SD_BAS_MSG_ALLOC;
          num_lig = __LINE__;
          goto fin;
        }


//@ on remplit les champ du GRH manquant (
//@ on commute le GRH contenu dans le produit (fonction interne)
//@ apres init des champs internes
 for(i=0;i<SD_BAS_NB_GRH_FIELD;i++)
    {
      if(SD_BAS_MacMALLOC(valeur[i].pui4,unsigned int,1)==FALSE)
        {
          cr_op = SD_BAS_ERR_BAS_NIVEAU;
          msg_err = SD_BAS_MSG_ALLOC;
          num_lig = __LINE__;
          goto fin;
        }
    }

 grh.nb_var=0;
 grh.tab_var=NULL;


 *(valeur[0].pui4)=TR_GIADR;
 status_d=DECOM__Ajouter_variable (&grh,"","GRH_RECORD_CLASS",
				   DECOM__C_uint4,1,valeur[0]);
 SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);


//@ on initialise l'instrument dans le GRH(IN_IASI)  
 * (valeur[1].pui4)=IN_IASI;
 status_d=DECOM__Ajouter_variable (&grh,"","GRH_INSTRUMENT_GROUP",
				   DECOM__C_uint4,1,valeur[1]);
 SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);


 //@ on initialise la sous classe du record 
 *(valeur[2].pui4) = subclass; 
 status_d=DECOM__Ajouter_variable (&grh,"","GRH_RECORD_SUBCLASS",
				   DECOM__C_uint4,1,valeur[2]);
 SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);
 
 //@ on initialise la version
 *(valeur[3].pui4)=giadrversion;
 status_d=DECOM__Ajouter_variable (&grh,"","GRH_RECORD_SUBCLASS_VERSION",
				   DECOM__C_uint4,1,valeur[3]);
 SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);

 
 //@ on initialise la taille du record dans le GRH (SD_BAS_TAILLE_GIADR)
 *(valeur[4].pui4)=taille_rec; 
 status_d=DECOM__Ajouter_variable (&grh,"","GRH_RECORD_SIZE",
				   DECOM__C_uint4,1,valeur[4]); 
 SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);


 
 //@on commute le GRH
  status_d = SD_BAS_CommuteGRH(grh,&bloc_grh);
  SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_DECOMMUTER,__LINE__);   
  
  //@ on libere le tableau de valeur ajoute
  
  for(i=0; i<SD_BAS_NB_GRH_FIELD; i++)
    {    
      SD_BAS_MacFREE(valeur[i].pui4);
    }

  /* on libere la listevar */
  //SD_BAS_LibereListeVar(ECRITURE, &grh);

 //@ on se positionne en debut du GIADR
        ret = fseeko (Descripteur->fd, Descripteur->offsetGADSuivant, SEEK_SET);
          if(ret == SD_BAS_ECHEC)
            {
              cr_op = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_SEEK;
              num_lig = __LINE__;   
              goto fin;
            }
      

 //@ on ecrit dans le GRH
	  nb_element = 1;
          ret = fwrite (bloc_grh, SD_BAS_TAILLE_GRH_SANS_DATE, nb_element, Descripteur->fd);
          if(ret != nb_element)
            {
              cr_op = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_ALLOC;
              num_lig = __LINE__;
              goto fin;
            }


          SD_BAS_MacFREE(bloc_grh);



/* FA 162 */
   if ((mode_traitement == GRANULE) || (Descripteur->etat == INIT))	 
   {  
      //@ on incremente offsetGADsuivant
      Descripteur->offsetGADSuivant =
        Descripteur->offsetGADSuivant + taille_rec;

      //@ on incremente offsetVIADRsuivant
      Descripteur->offsetVIADRSuivant =
        Descripteur->offsetVIADRSuivant + taille_rec;

      //@ on incremente offsetVIADR
      Descripteur->offsetVIADR =
        Descripteur->offsetVIADR + taille_rec;

      //@on incremente offsetMDR
      Descripteur->offsetMDR =
        Descripteur->offsetMDR + taille_rec;
      
      //@ si mode different de APPEND
      //@ on incremente offsetMDRsuivant
      if( Descripteur->mode != APPEND && Descripteur->mode != APPEND_INIT )
        Descripteur->offsetMDRSuivant =
          Descripteur->offsetMDRSuivant + taille_rec;
  }
/* ..FA 162 */


       SD_BAS_MacFREE(bloc);
   
   }

fin:
 /* si une erreur est detectee */
 if ( cr_op != CMN__STATUT_OK)
   {
     /* mise a jour de la variable ctx->cr.errinterne */
     SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                         SD_BAS_ERR_SET_Niveau1,
                         SD_BAS_ERR_NUM_JDB,
                         tcProcName_F,
                         num_lig,
                         msg_err);

    /* on imprime le message d'erreur sur la sortie standard */
   }
/* on retourne le status */
return(cr_op); 

}
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_EcrireMDRN1
//@
//@ Description : fonction d'ecriture du MDR des produits IASI L1
//@  cette operation generique s'applique aux produits IASI de N1 
//@ cette operation doit etre appelee apres SD_BAS_EcrireMPHRSPHRN1
//@
//@
//@ Parameters :
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces
//@			(SORTIE)  mdr  : liste des variables lues dans le MDR
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_EcrireMDRN1(	
    t_SD_BAS_Fd * Descripteur,
    t_SD_BAS_LigneN1 * mdr,
    t_SD_BAS_DataThread *ctx
			)
{
  /* nom de la fonction */
  static const char tcProcName_F[] = "SD_BAS_EcrireMDRN1";
  /*retour de la fonction */
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  /* buffer d' ecriture du mdr*/
  char * bloc;
    /* buffer d' ecriture du mdr*/
  char * bloc_tmp;
  /* buffer d' ecriture du grh*/
  char *bloc_grh;
  /* retour de fonction */
  int ret;
  /* indice de boucle */
  int i;
  /* taille du buffer a ecrire */
  unsigned int taille_rec;
  /* type d'instrument a ecrire */
  unsigned int instrument;
  /* subclass a ecrire dans le grh */
  unsigned int record_subclass;
  /* descripteur du fichier temporaire en mode APPEND */
  FILE* fd_mdr; 
  /* longueur des donnees ecrites */
  int lg = 0;
  /* liste du grh ecrit */
  t_SD_BAS_Liste_Var grh;
  /* liste d'un mdr dummy*/
  t_SD_BAS_Liste_Var dummy;
  /* tableau des elements a ajouter aux listevars */
  DECOM__T_val_var   valeur[SD_BAS_NB_GRH_FIELD];
  /* retour des fonctions de commutations */
  t_SD_BAS_status_d status_d;
   /* message d'erreur pour le contexte d'erreur */
  char *msg_err;
  /* numero de ligne pour le contexte d'erreur */
  int num_lig;
  /* retour de fonction */
  int nb_element;
  int versionmdr;


//@ on verifie que l'etat est a INIT ou ENCOURS 
//@ et que le mode est ecriture ou en append

  if ( (Descripteur->etat == INIT || Descripteur->etat == ENCOURS)
       &&( Descripteur->mode == ECRITURE || Descripteur->mode == APPEND || Descripteur->mode == APPEND_INIT))

    {


//@ si mode APPEND on ecrit les MDR dans le fichier intermediaire
      if(  Descripteur->mode == APPEND || Descripteur->mode == APPEND_INIT)
        fd_mdr = Descripteur->fd_sec;
//@ sinon on les ecrit dans le fichier en fin du fichier principal
      else
        fd_mdr = Descripteur->fd;

//@initialisation des GRH
//@ on initialise la version du record avec SD_BAS_MDR_VERSION_N1
//@ le start et le stop time sont consideres renseignes

 
//@ si type different de dummy
      if(mdr->TypeRec == MDR_1A ||
         mdr->TypeRec == MDR_1B ||
         mdr->TypeRec == MDR_1C ||
         mdr->TypeRec == MDR_VER ||
         mdr->TypeRec == MDR_ENG ||
         mdr->TypeRec == MDR_DUMMY) 
      {
        //@ recommuter les valeurs selon le type du MDR
        cr_op = SD_BAS_RecommuterTypeRecord (
          ctx, 
          mdr, 
          &bloc, 
          &instrument, 
          &taille_rec, 
          &record_subclass, 
          &versionmdr);
          
          if (cr_op != CMN__STATUT_OK)
          {
            cr_op   = SD_BAS_ERR_BAS_NIVEAU;
            msg_err = SD_BAS_MSG_RECOMMUTERTYPERECORD;
            num_lig = __LINE__;
            goto fin;
          }
      
//@  on remplit les champ du GRH manquant (
//@  on commute le GRH contenu dans le produit (fonction interne)
//@  apres init des champs internes ( dates record class et subclasse)
//@  on se positionne a la position offsetMDRSuivant
  
          ret = fseeko (fd_mdr, Descripteur->offsetMDRSuivant, SEEK_SET);
          if(ret == SD_BAS_ECHEC)
            {
              cr_op = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_SEEK;
              num_lig = __LINE__;
              goto fin;
            }
      

 //@ on ecrit dans le fichier le buffer de taille
	  nb_element = 1;
          ret = fwrite (bloc, taille_rec, nb_element, fd_mdr);
          if(ret != nb_element)
            {
              cr_op = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_WRITE;
              num_lig = __LINE__;
              goto fin;
            }

          SD_BAS_MacFREE(bloc);


//@	recopie des images et du spectre 1A datasp[0] a partir de infocod 
//@                                   1B datasp[1]
//@                                   1C datasp[2]


          if(mdr->TypeRec == MDR_1A||
             mdr->TypeRec == MDR_1B||
             mdr->TypeRec == MDR_1C)
            {
          //@on se positionne a l'offset des spectres
              ret = fseeko (fd_mdr,
                           Descripteur->offsetMDRSuivant + SD_BAS_OFFSET_SPECTRE, 
                           SEEK_SET);
              if(ret == SD_BAS_ECHEC)
                {
                  cr_op = SD_BAS_ERR_BAS_NIVEAU;
                  msg_err = SD_BAS_MSG_SEEK;
                  num_lig = __LINE__;
                  goto fin;
                }
              
          //@ on ecrit le spectre voulut
	      nb_element = 1;
              ret = fwrite (mdr->InfoCod->datasp[mdr->TypeRec],
                            SD_BAS_SS * SD_BAS_PN * SD_BAS_SNOT *SD_BAS_NB_OCTET_DATA,
                            nb_element, 
                            fd_mdr);
              if(ret != nb_element)
                {
                  cr_op = SD_BAS_ERR_BAS_NIVEAU;
                  msg_err = SD_BAS_MSG_WRITE;
                  num_lig = __LINE__;
                  goto fin;
               }
          

          //@on se positionne a l'offset des images
              ret = fseeko (fd_mdr,
                           Descripteur->offsetMDRSuivant + SD_BAS_OFFSET_IMAGE, 
                           SEEK_SET);
              if(ret == SD_BAS_ECHEC)
                {
                  cr_op = SD_BAS_ERR_BAS_NIVEAU;
                  msg_err = SD_BAS_MSG_SEEK;
                  num_lig = __LINE__;
                  goto fin;
                }
                  
          //@ on ecrit l'image
	      nb_element = 1;
              ret = fwrite (mdr->InfoCod->dataim,
                            SD_BAS_IMCO * SD_BAS_IMLI * SD_BAS_SNOT * SD_BAS_NB_OCTET_DATA,
                            nb_element, 
                            fd_mdr);
              if(ret != nb_element)
                {
                  cr_op = SD_BAS_ERR_BAS_NIVEAU;
                  msg_err = SD_BAS_MSG_WRITE;
                  num_lig = __LINE__;
                  goto fin;
               }
          
            

              
            } // MDR_1C
        } // MDR_DUMMY
       
  
     
//@ sinon

      else
        {
	  cr_op = SD_BAS_ERR_MDR;
	  msg_err = SD_BAS_MSG_MDR;
	  num_lig = __LINE__;
	  goto fin;
	}
//@

 for(i=0;i<SD_BAS_NB_GRH_FIELD;i++)
    {
      if(SD_BAS_MacMALLOC(valeur[i].pui4,unsigned int,1)==FALSE)
        {
             cr_op = SD_BAS_ERR_BAS_NIVEAU;
             msg_err = SD_BAS_MSG_ALLOC;
             num_lig = __LINE__;
             goto fin;
        }
    }


 grh.nb_var=0;
 grh.tab_var=NULL;

 //@ on initialise la classe du record (TR_MDR) 
 

 *(valeur[0].pui4)=TR_MDR;
 status_d=DECOM__Ajouter_variable (&grh,"","GRH_RECORD_CLASS",
                                   DECOM__C_uint4,1,valeur[0]);
 SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);


//@ on initialise l'instrument dans le GRH(IN_IASI)  
 * (valeur[1].pui4)=instrument;
 status_d=DECOM__Ajouter_variable (&grh,"","GRH_INSTRUMENT_GROUP",
				   DECOM__C_uint4,1,valeur[1]);
 SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);


 //@ on initialise la sous classe du record 
 *(valeur[2].pui4)=record_subclass;
 status_d=DECOM__Ajouter_variable (&grh,"","GRH_RECORD_SUBCLASS",
				   DECOM__C_uint4,1,valeur[2]);
 SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);
 
 //@ on initialise la version
 *(valeur[3].pui4)=versionmdr;
 status_d=DECOM__Ajouter_variable (&grh,"","GRH_RECORD_SUBCLASS_VERSION",
				   DECOM__C_uint4,1,valeur[3]);
 SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);

 
 //@ on initialise la taille du record dans le GRH (SD_BAS_TAILLE_MPHR)
 *(valeur[4].pui4)=taille_rec; 
 status_d=DECOM__Ajouter_variable (&grh,"","GRH_RECORD_SIZE",
				   DECOM__C_uint4,1,valeur[4]); 
 SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);


 
 //@on commute le GRH
  status_d = SD_BAS_CommuteGRH(grh,&bloc_grh);
  SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_DECOMMUTER,__LINE__);   


  /* on libere la listevar */
  // FT-2512
  SD_BAS_LibereListeVar(ECRITURE, &grh);
  // ..FT-2512

 //@ on se positionne en debut du MDR
  ret = fseeko (fd_mdr, Descripteur->offsetMDRSuivant, SEEK_SET);
  if(ret == SD_BAS_ECHEC)
    {
      cr_op = SD_BAS_ERR_BAS_NIVEAU;
      msg_err = SD_BAS_MSG_SEEK;
      num_lig = __LINE__;
      goto fin;
    }
      

 //@ on ecrit dans le GRH
  nb_element = 1;
  ret = fwrite (bloc_grh, SD_BAS_TAILLE_GRH_SANS_DATE, nb_element, fd_mdr);
  if(ret != nb_element)
    {
      cr_op = SD_BAS_ERR_BAS_NIVEAU;
      msg_err = SD_BAS_MSG_ALLOC;
      num_lig = __LINE__;
      goto fin;
    }

  //@on libere le buffer du GRH
  SD_BAS_MacFREE(bloc_grh);
  
  
  //@  on incremente  offsetMDRsuivant 
  Descripteur->offsetMDRSuivant =
    Descripteur->offsetMDRSuivant + taille_rec;
  
  
    }

fin:
 /* si une erreur est detectee */
 if ( cr_op != CMN__STATUT_OK)
   {
     /* mise a jour de la variable ctx->cr.errinterne */
     SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                         SD_BAS_ERR_SET_Niveau1,
                         SD_BAS_ERR_NUM_JDB,
                         tcProcName_F,
                         num_lig,
                         msg_err);

    /* on imprime le message d'erreur sur la sortie standard */

   }
/* on retourne le status */
return(cr_op); 

}
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_EcrireVIADRN1
//@
//@ Description : fonction d'ecriture du VIADR des produits IASI L1 ENG
//@  cette operation generique s'applique aux produits IASI de N1 
//@ cette operation doit etre appelee apres SD_BAS_EcrireMDRN1
//@
//@ Parameters :
//@			(ENTREE)  descripteur  : descripteur du produit
//@				  utilise par les fonctions d'acces<
//@			(SORTIE)  mdr  : liste des variables lues dans le MDR
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
/* FA 162 */
t_CMN__Statut SD_BAS_EcrireVIADRN1(
		t_SD_BAS_Fd * Descripteur,
		t_SD_BAS_LigneN1 * mdr,
		t_SD_BAS_DataThread *ctx,
		const e_BAS_ModeTrt modeTraitement
			)
/* ..FA 162 */
{
  /* nom de la fonction */
  static const char tcProcName_F[] = "SD_BAS_EcrireVIADRN1";
  /*retour de la fonction */
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  /* buffer d' ecriture du giadr*/
  char *bloc;
  /* buffer d' ecriture du grh*/
  char *bloc_grh;
  /* retour de fonction */
  int ret;
  /* indice de boucle */
  int i;
  /* longueur des donnees ecrites */
  int lg = 0;
  /* tableau des elements a ajouter aux listevars */
  DECOM__T_val_var   valeur[SD_BAS_NB_GRH_FIELD];
  /* retour des fonctions de commutations */
  t_SD_BAS_status_d status_d;
  /* liste du grh ecrit */
  t_SD_BAS_Liste_Var grh;
  /* message d'erreur pour le contexte d'erreur */
  char *msg_err;
  /* numero de ligne pour le contexte d'erreur */
  int num_lig;
  /* retour de fonction */
  int nb_element;
  /* DUMMY ou IASI */
  unsigned int instrument;
  int versionviadr;

/* FA 162 */
  FILE * fd_viadr ; 		 // file descripteur du fichier
  static unsigned int NbViadr = 0;
/* ..FA 162 */


  //@ on verifie que l'etat est a INIT ou ENCOURS 
  //@ et que le mode est ecriture ou en append

  if ( (Descripteur->etat == INIT || Descripteur->etat == ENCOURS)
       && ( Descripteur->mode == ECRITURE || Descripteur->mode == APPEND || Descripteur->mode == APPEND_INIT))
    {     

/* FA 162 */
//@ si mode APPEND on ecrit les VIADR dans le fichier temporaire
      if( (DUMP == modeTraitement) &&
          (Descripteur->mode == APPEND || Descripteur->mode == APPEND_INIT) )
        fd_viadr = Descripteur->fd_viadr_tmp;
//@ sinon on les ecrit dans le fichier en fin du fichier principal
      else
        fd_viadr = Descripteur->fd;
/* ..FA 162 */

      //@ selon le type de VIADR (champ TypeRec)
      switch(mdr->TypeRec)
	{
        
          //@ VIADR_ENG: 
	case VIADR_ENG:
	  instrument = IN_IASI;
	  versionviadr = SD_BAS_VIADRENG_VERSION_N1;
	  break;

          //@ VIADR_DUMMY
	case VIADR_DUMMY:
	/* FA 1769*/
	  instrument = IN_IASI;
	/* ... FA 1769*/
	  versionviadr = SD_BAS_MDRDUM_VERSION_N1;
	  break;

	default:
	  cr_op = SD_BAS_ERR_NATURE;
	  msg_err = SD_BAS_MSG_NATURE;
	  num_lig = __LINE__;
	  goto fin;
	}


      //@ 	on appelle la couche de decodage afin de commuter le contenu du VIADR 
      //@ 	DECOM__Commuter ( fic SD_BAS_NOM_FIC_PROD1 bloc VIADR_ENG)
      status_d=DECOM__Recommuter (SD_BAS_BLOC_VIADR_ENG,
                                  mdr->InfoDet,
                                  &bloc,
                                  &lg);
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_RECOMMUTER,__LINE__);

      //@ on se positionne a la position offsetVIADRSuivant

/* FA 162 */
      if(DUMP == modeTraitement)      
         ret = fseeko (fd_viadr, NbViadr*SD_BAS_TAILLE_MAX_VIADRENG, SEEK_SET);
      else
         ret = fseeko (Descripteur->fd, Descripteur->offsetVIADRSuivant, SEEK_SET);
/* ..FA 162 */
      if(ret == SD_BAS_ECHEC)
        {
          cr_op = SD_BAS_ERR_BAS_NIVEAU;
          msg_err = SD_BAS_MSG_SEEK;
          num_lig = __LINE__;
          goto fin;
        }
      
      //@  on ecrit dans le fichier le buffer de taille
      nb_element=1;
/* FA 162 */
      if(DUMP == modeTraitement) 
      {     
         ret = fwrite (bloc, SD_BAS_TAILLE_MAX_VIADRENG, nb_element, fd_viadr);
         NbViadr ++;
      }
      else
         ret = fwrite (bloc, SD_BAS_TAILLE_MAX_VIADRENG, nb_element, Descripteur->fd);
/* ..FA 162 */
      if(ret != nb_element)
        {
          cr_op = SD_BAS_ERR_BAS_NIVEAU;
          msg_err = SD_BAS_MSG_ALLOC;
          num_lig = __LINE__;
          goto fin;
        }

      //@ liberation du buffer
      SD_BAS_MacFREE(bloc);

      //@ on remplit les champ du GRH manquant (
      //@ apres init des champs internes ( dates record class et subclasse)

      for(i=0;i<SD_BAS_NB_GRH_FIELD;i++)
        {
          if(SD_BAS_MacMALLOC(valeur[i].pui4,unsigned int,1)==FALSE)
            {
              cr_op = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_ALLOC;
              num_lig = __LINE__;
              goto fin;
            }
        }


      //@ on initialise la version du record avec SD_BAS_MDR_VERSION_N1
      //@ le start et le stop time sont consideres renseignes

      grh.nb_var=0;
      grh.tab_var=NULL;


      *(valeur[0].pui4)=TR_VIADR;
      status_d=DECOM__Ajouter_variable (&grh,"","GRH_RECORD_CLASS",
                                        DECOM__C_uint4,1,valeur[0]);
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);


      //@ on initialise l'instrument dans le GRH(IN_IASI)  
      * (valeur[1].pui4)=instrument;
      status_d=DECOM__Ajouter_variable (&grh,"","GRH_INSTRUMENT_GROUP",
                                        DECOM__C_uint4,1,valeur[1]);
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);


      //@ on initialise la sous classe du record 
      *(valeur[2].pui4)=SD_BAS_VIADR_ENG_SUBCLASS;
      status_d=DECOM__Ajouter_variable (&grh,"","GRH_RECORD_SUBCLASS",
                                        DECOM__C_uint4,1,valeur[2]);
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);
 
      //@ on initialise la version
      *(valeur[3].pui4)=versionviadr;
      status_d=DECOM__Ajouter_variable (&grh,"","GRH_RECORD_SUBCLASS_VERSION",
                                        DECOM__C_uint4,1,valeur[3]);
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);

 
      //@ on initialise la taille du record dans le GRH (SD_BAS_TAILLE_MPHR)
      *(valeur[4].pui4)=SD_BAS_TAILLE_MAX_VIADRENG; 
      status_d=DECOM__Ajouter_variable (&grh,"","GRH_RECORD_SIZE",
                                        DECOM__C_uint4,1,valeur[4]); 
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);
 
      //@ on commute le GRH contenu dans le produit (fonction interne)
      status_d = SD_BAS_CommuteGRH(grh,&bloc_grh);
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_DECOMMUTER,__LINE__);   



      //@ on libere le tableau de valeur ajoute
  
      for(i=0; i<SD_BAS_NB_GRH_FIELD; i++)
        {
          SD_BAS_MacFREE(valeur[i].pui4);
        }

      /* on libere la listevar */
      //SD_BAS_LibereListeVar(ECRITURE, &grh);


      //@ on se positionne en debut du VIADR
/* FA 162 */
      if(DUMP == modeTraitement) 
        ret = fseeko (fd_viadr, (NbViadr-1)*SD_BAS_TAILLE_MAX_VIADRENG, SEEK_SET);
      else
        ret = fseeko (Descripteur->fd, Descripteur->offsetVIADRSuivant, SEEK_SET);
/* ..FA 162 */
      if(ret == SD_BAS_ECHEC)
        {
          cr_op = SD_BAS_ERR_BAS_NIVEAU;
          msg_err = SD_BAS_MSG_SEEK;
          num_lig = __LINE__;
          goto fin;
        }
      

      //@ on ecrit dans le GRH
      nb_element = 1;
/* FA 162 */
      if(DUMP == modeTraitement) 
         ret = fwrite (bloc_grh, SD_BAS_TAILLE_GRH_SANS_DATE, nb_element, fd_viadr);
      else
         ret = fwrite (bloc_grh, SD_BAS_TAILLE_GRH_SANS_DATE, nb_element, Descripteur->fd);
/* ..FA 162 */
      if(ret != nb_element)
        {
          cr_op = SD_BAS_ERR_BAS_NIVEAU;
          msg_err = SD_BAS_MSG_ALLOC;
          num_lig = __LINE__;
          goto fin;
        }

      //@on libere le buffer
      SD_BAS_MacFREE(bloc_grh);


      //@ on incremente offsetVIADRSuivant
      Descripteur->offsetVIADRSuivant =
        Descripteur->offsetVIADRSuivant + SD_BAS_TAILLE_MAX_VIADRENG;
          
      Descripteur->offsetMDR = 
        Descripteur->offsetMDR + SD_BAS_TAILLE_MAX_VIADRENG;

      //@ si mode different de APPEND
      //@ on incremente offsetMDRsuivant
      if( (Descripteur->mode != APPEND) && (Descripteur->mode != APPEND_INIT) )
        {
          Descripteur->offsetMDRSuivant =
            Descripteur->offsetMDRSuivant + SD_BAS_TAILLE_MAX_VIADRENG ;
        }
    }


 fin:

  /* si une erreur est detectee */
  if ( cr_op != CMN__STATUT_OK)
    {
      /* mise a jour de la variable ctx->cr.errinterne */
      SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                          SD_BAS_ERR_SET_Niveau1,
                          SD_BAS_ERR_NUM_JDB,
                          tcProcName_F,
                          num_lig,
                          msg_err);
    }

  /* on retourne le status */
  return(cr_op); 
}


//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_InitEcritureMDRN1
//@
//@ Description : fonction d'initialisation d'une liste de variable 
//@ correspondant a un MDR 
//@ Parameters :
//@			(ENTREE)  TypeRec  : type de record initialise
//@					par la fonction de niveau superieur
//@			(ENTREE/sortie)  mdr  : MDR a initialiser
//@                     (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
t_CMN__Statut SD_BAS_InitEcritureMDRN1(
				       t_SD_BAS_Fd * Descripteur,
				       e_BAS_TypeRecN1 TypeRec,
				       t_SD_BAS_LigneN1 * mdr,
				       t_SD_BAS_DataThread *ctx)
		
{
  /* nom de la fonction */
  static const char tcProcName_F[] = "SD_BAS_InitEcritureMDRN1";
  /*retour de la fonction */
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  /* retour de fonction */
  int ret;
  /* message d'erreur pour le contexte d'erreur */
  char *msg_err;
  /* numero de ligne pour le contexte d'erreur */
  int num_lig; 
  /* indice de boucle */
  int ispect;

//@ on verifie que l'etat est a INIT ou ENCOURS 
//@ et que le mode est ecriture ou en append
 if ( (Descripteur->etat == INIT || Descripteur->etat == ENCOURS)
       &&( Descripteur->mode == ECRITURE || Descripteur->mode == APPEND|| Descripteur->mode == APPEND_INIT))
    {
      mdr->TypeRec = TypeRec;

      switch(TypeRec)
        {
//@ si MDR_1ABC :
        case MDR_1A:
        case MDR_1B:
        case MDR_1C:

//@   on s'alloue le champ InfoDet2 en fonction du type de record


//@   pour chaque variable de InfoDet2
//@   on recopie chaque pointeur en ajoutant une variable via AjouterVariable ( superficiel)
//@   ( fonction interne)
//@   fin pour
          

	  cr_op = SD_BAS_InitMdr1C(&mdr->InfoDet,ctx);
          if (cr_op != CMN__STATUT_OK)
            {
              cr_op   = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_LIREIPRN1;
              num_lig = __LINE__;
              goto fin;
            }
	             

//@   on s'alloue alors la structure et le contenu InfoCalc
          ret = SD_BAS_MacMALLOC(mdr->InfoCalc, t_SD_BAS_DataThreadProduit, 1);
          if(ret == FALSE)
            {
              cr_op   = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_INITMDR1C;
              num_lig = __LINE__;
              goto fin;     
            }


//@   on s'alloue alors la structure Infocod et le contenu
          ret = SD_BAS_MacMALLOC(mdr->InfoCod, t_SD_BAS_DonCodN1, 1);
          if(ret == FALSE)
            {
              cr_op = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_ALLOC;
              num_lig = __LINE__;
              goto fin;
            }
	  //@ on alloue les images
	  ret = SD_BAS_MacMALLOC(mdr->InfoCod->dataim, char, SD_BAS_IMCO * SD_BAS_IMLI * SD_BAS_SNOT * SD_BAS_NB_OCTET_DATA);
          if(ret == FALSE)
            {
              cr_op = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_ALLOC;
              num_lig = __LINE__;
              goto fin;
            }


	  //@ on alloue les spectres 
	  for(ispect=0; ispect<MDR_1C+1 ; ispect++)
	    {
	      ret = SD_BAS_MacMALLOC(mdr->InfoCod->datasp[ispect], char, SD_BAS_SS * SD_BAS_PN * SD_BAS_SNOT *SD_BAS_NB_OCTET_DATA);
	      if(ret == FALSE)
		{
		  cr_op = SD_BAS_ERR_BAS_NIVEAU;
		  msg_err = SD_BAS_MSG_ALLOC;
		  num_lig = __LINE__;
		  goto fin;
		}
	    }
          break;

	case MDR_DUMMY:
	  cr_op = SD_BAS_InitMdrDummy(&mdr->InfoDet,ctx);
          if (cr_op != CMN__STATUT_OK)
            {
              cr_op   = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_INITMDRDUMMY;
              num_lig = __LINE__;
              goto fin;
            }
	  break;

//@ si MDR_ENG :
        case MDR_ENG:
//@   on s'alloue le champ InfoDet2 en fonction du type de record

//@   pour chaque variable de InfoDet2
//@   on recopie chaque pointeur en ajoutant une variable via AjouterVariable ( superficiel)
//@   fin pour   (fonction interne)
      
          cr_op = SD_BAS_InitMdrEng(&mdr->InfoDet,ctx);
          if (cr_op != CMN__STATUT_OK)
            {
              cr_op   = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_INITMDRENG;
              num_lig = __LINE__;
              goto fin;
            }            
          break;


//@ si MDR_ENG :
        case MDR_VER:
//@   on s'alloue le champ InfoDet2 avec une taillz max
	  ret = SD_BAS_MacMALLOC(mdr->InfoDet2, char*, SD_BAS_TAILLE_MAX_MDRVER);
       
//@   pour chaque variable de InfoDet2
//@   on recopie chaque pointeur en ajoutant une variable via AjouterVariable ( superficiel)
//@   fin pour   (fonction interne)
      
          cr_op = SD_BAS_InitMdrN1Ver(&mdr->InfoDet,ctx);
          if (cr_op != CMN__STATUT_OK)
            {
              cr_op   = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_INITMDRVER;
              num_lig = __LINE__;
              goto fin;
            }            
	  
	  /* on initialise la taille avec la taille max */
	  *(mdr->InfoDet.tab_var[VER_SIZE_OF_VERIFICATION_DATA].val.pui4) = SD_BAS_TAILLE_MAX_MDRVER;
	  
          break;



          
//@ si VIADR_ENG:
        case  VIADR_ENG:
//@   on s'alloue le champ InfoDet2 en fonction du type de record

//@   pour chaque variable de InfoDet2
//@   on recopie chaque pointeur en ajoutant une variable via AjouterVariable ( superficiel)
//@   fin pour  ( fonction interne)

          cr_op = SD_BAS_InitViadrN1Eng(&mdr->InfoDet,ctx);
          if (cr_op != CMN__STATUT_OK)
            {
              cr_op   = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_INITVIADRENG;
              num_lig = __LINE__;
              goto fin;
            }            
          break;

/* FA143 */
//@ si VIADR_DUMMY:
        case  VIADR_DUMMY:
//@   on s'alloue le champ InfoDet2 en fonction du type de record

//@   pour chaque variable de InfoDet2
//@   on recopie chaque pointeur en ajoutant une variable via AjouterVariable ( superficiel)
//@   fin pour  ( fonction interne)

          cr_op = SD_BAS_InitViadrN1Eng(&mdr->InfoDet,ctx);
          if (cr_op != CMN__STATUT_OK)
            {
              cr_op   = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_INITVIADRENG;
              num_lig = __LINE__;
              goto fin;
            }            
          break;
/* FIN FA143 */
          
//@ si GIADR_ENG:
        case  GIADR_ENG:
//@   on s'alloue le champ InfoDet2 en fonction du type de record

//@   pour chaque variable de InfoDet2
//@   on recopie chaque pointeur en ajoutant une variable via AjouterVariable ( superficiel)
//@   fin pour  ( fonction interne)

          cr_op = SD_BAS_InitGiadrEng(&mdr->InfoDet,ctx);
          if (cr_op != CMN__STATUT_OK)
            {
              cr_op   = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_INITGIADRENG;
              num_lig = __LINE__;
              goto fin;
            }            
          break;

//@ si GIADR_SCA:
        case  GIADR_SCA:
//@   on s'alloue le champ InfoDet2 en fonction du type de record

//@   pour chaque variable de InfoDet2
//@   on recopie chaque pointeur en ajoutant une variable via AjouterVariable ( superficiel)
//@   fin pour  ( fonction interne)

          cr_op = SD_BAS_InitGiadrSca(&mdr->InfoDet,ctx);
          if (cr_op != CMN__STATUT_OK)
            {
              cr_op   = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_INITGIADRSCA;
              num_lig = __LINE__;
              goto fin;
            }            
          break;


//@ si GIADR_QUA:
        case  GIADR_QUA:
//@   on s'alloue le champ InfoDet2 en fonction du type de record

//@   pour chaque variable de InfoDet2
//@   on recopie chaque pointeur en ajoutant une variable via AjouterVariable ( superficiel)
//@   fin pour  ( fonction interne)

          cr_op = SD_BAS_InitGiadrQual(&mdr->InfoDet,ctx);
          if (cr_op != CMN__STATUT_OK)
            {
              cr_op   = SD_BAS_ERR_BAS_NIVEAU;
              msg_err = SD_BAS_MSG_INITGIADRQUAL;
              num_lig = __LINE__;
              goto fin;
            }            
            
          break;


//@ defaut erreur:
          
        }
    }

fin:
 /* si une erreur est detectee */
 if ( cr_op != CMN__STATUT_OK)
   {
     /* mise a jour de la variable ctx->cr.errinterne */
     SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                         SD_BAS_ERR_SET_Niveau1,
                         SD_BAS_ERR_NUM_JDB,
                         tcProcName_F,
                         num_lig,
                         msg_err);


   }
/* on retourne le status */
return(cr_op); 

}



//======================================================================
//					FONCTIONS INTERNES  
//======================================================================
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_InitViadrVer
//@
//@ Description : fonction d'allocation memoire pour un VIADR engineering
//@ Parameters :
//@			(ENTREE)  VIADR  : liste de variable a allouee

//@			(sortie)  ctx  : ctx d'erreur
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
static t_CMN__Statut SD_BAS_InitMdrN1Ver(t_SD_BAS_Liste_Var *VIADR,
                                  t_SD_BAS_DataThread *ctx)
{
  /* nom de la fonction */
  static const char tcProcName_F[] = "SD_BAS_InitViadrVer";
  /*retour de la fonction */
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  /* element a ajouter a la listevar */
  DECOM__T_val_var   valeur;
  /* retour des fonctions de commutations */
  t_SD_BAS_status_d status_d;
  /* indice de boucle */
  int i;
  /* retour de fonction */
  int ret;
  /* message d'erreur pour le contexte d'erreur */
  char *msg_err;
  /* numero de ligne pour le contexte d'erreur */
  int num_lig;

  /* tableau decrivant les elements d'un VIADR ENG */
  const SD_BAS_Record viadr_eng [] ={
    {"VER_DATEDEB",
     DECOM__C_date,        1},
    {"VER_DATEFIN",
     DECOM__C_date,        1},
    {"VER_SIZE_OF_VERIFICATION_DATA",
     DECOM__C_uint4,       1},
    {"",0,0}};

 /* initialisation  de la listevar */
  VIADR->nb_var=0;
  VIADR->tab_var=NULL;

 /* on initialise l'indice de boucle */
  i=0;
  
  //pour tous les elements du tableau viade_sca
  while(strcmp(viadr_eng[i].nom_variable, ""))
    {
     
      //@ on alloue un element dans la liste de variable
      status_d = DECOM__Ajouter_variable (VIADR,"",
                                          viadr_eng[i].nom_variable,
                                          viadr_eng[i].type,
                                          viadr_eng[i].dim,
                                          valeur);
     /* si l'ajout est un echec on emet une erreur */
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);


      /* suivant le type de la donnee */
      switch(viadr_eng[i].type)
        {
	  /* on alloue le pointeur */
        case DECOM__C_int4:
          ret = SD_BAS_MacMALLOC(VIADR->tab_var[i].val.pi4, 
                                 int , viadr_eng[i].dim + SD_BAS_MARGE);
          break;

        case DECOM__C_string:
          ret = SD_BAS_MacMALLOC(VIADR->tab_var[i].val.s, 
                                 char , SD_BAS_DATA_STRING);
          break;
          
        case DECOM__C_uint4:
          ret = SD_BAS_MacMALLOC(VIADR->tab_var[i].val.pui4, 
                                 unsigned int , viadr_eng[i].dim + SD_BAS_MARGE);
          break;
          
        case DECOM__C_real8:
          ret = SD_BAS_MacMALLOC(VIADR->tab_var[i].val.pr8, 
                                double , viadr_eng[i].dim + SD_BAS_MARGE);
         break;
          
        case DECOM__C_date:
          ret = SD_BAS_MacMALLOC(VIADR->tab_var[i].val.pdate, 
                                 t_SD_BAS_SCDSTime , viadr_eng[i].dim + SD_BAS_MARGE);
          break;

	  /* si le type est inconnu on emet une erreur */
	default:
	  cr_op = SD_BAS_ERR_NATURE;
	  msg_err = SD_BAS_MSG_NATURE;
	  num_lig = __LINE__;
	  goto fin;

         
        } // fin switch 

      //@ on teste le retour de l'allocation
      if(ret == FALSE)
	{
	  cr_op = SD_BAS_ERR_BAS_NIVEAU;
	  msg_err = SD_BAS_MSG_ALLOC;
	  num_lig = __LINE__;
	  goto fin;
	}
      
      //on incremente le numero du champ 
      i++;

    } //fin while

 fin:
 /* si une erreur est detectee */
 if ( cr_op != CMN__STATUT_OK)
   {
     /* mise a jour de la variable ctx->cr.errinterne */
     SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                         SD_BAS_ERR_SET_Niveau1,
                         SD_BAS_ERR_NUM_JDB,
                         tcProcName_F,
                         num_lig,
                         msg_err);

   }

 /* on retourne le status */
  return(cr_op); 


}

//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_InitViadrEng
//@
//@ Description : fonction d'allocation memoire pour un VIADR engineering
//@ Parameters :
//@			(ENTREE)  VIADR  : liste de variable a allouee

//@			(sortie)  ctx  : ctx d'erreur
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
static t_CMN__Statut SD_BAS_InitViadrN1Eng(t_SD_BAS_Liste_Var *VIADR,
                                  t_SD_BAS_DataThread *ctx)
{
  /* nom de la fonction */
  static const char tcProcName_F[] = "SD_BAS_InitViadrEng";
  /*retour de la fonction */
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  /* element a ajouter a la listevar */
  DECOM__T_val_var   valeur;
  /* retour des fonctions de commutations */
  t_SD_BAS_status_d status_d;
  /* indice de boucle */
  int i;
  /* retour de fonction */
  int ret;
  /* message d'erreur pour le contexte d'erreur */
  char *msg_err;
  /* numero de ligne pour le contexte d'erreur */
  int num_lig;
//FA158 dans le cas EXS j'alloue 10 lignes pour le multithreading //
  char *pointer;

  /* tableau decrivant les elements d'un VIADR ENG */
  const SD_BAS_Record viadr_eng [] ={
    {"VIADRENG_DATEDEB",
     DECOM__C_date,        1},
    {"VIADRENG_DATEFIN",
     DECOM__C_date,        1},
    {"VIADRENG_MEXSSMIN",
     DECOM__C_uint4,        SD_BAS_SPCT_COD},
    {"VIADRENG_MEXSSMAX",
     DECOM__C_uint4,        SD_BAS_SPCT_COD},
    {"VIADRENG_MDPTIISBADHEALTHPIX",
     DECOM__C_uint4,        SD_BAS_IMCO * SD_BAS_IMLI},
    {"VIADRENG_MDPTIISINHOMPIX",
     DECOM__C_uint4,        SD_BAS_IMCO * SD_BAS_IMLI},
    {"",0,0}};

 /* initialisation  de la listevar */
  VIADR->nb_var=0;
  VIADR->tab_var=NULL;

 /* on initialise l'indice de boucle */
  i=0;
  
  //pour tous les elements du tableau viade_sca
  while(strcmp(viadr_eng[i].nom_variable, ""))
    {
     
      //@ on alloue un element dans la liste de variable
      status_d = DECOM__Ajouter_variable (VIADR,"",
                                          viadr_eng[i].nom_variable,
                                          viadr_eng[i].type,
                                          viadr_eng[i].dim,
                                          valeur);
     /* si l'ajout est un echec on emet une erreur */
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);


      /* suivant le type de la donnee */
      switch(viadr_eng[i].type)
        {
	  /* on alloue le pointeur */
        case DECOM__C_int4:
          ret = SD_BAS_MacMALLOC(VIADR->tab_var[i].val.pi4, 
                                 int , viadr_eng[i].dim + SD_BAS_MARGE);
          break;

        case DECOM__C_string:
          ret = SD_BAS_MacMALLOC(VIADR->tab_var[i].val.s, 
                                 char , SD_BAS_DATA_STRING);
          break;
          
        case DECOM__C_uint4:
	//FA158 dans le cas EXS j'alloue 10 lignes pour le multithreading //
	  if (strstr(viadr_eng[i].nom_variable,"EXS")==NULL) 
          ret = SD_BAS_MacMALLOC(VIADR->tab_var[i].val.pui4, 
                                 unsigned int , viadr_eng[i].dim + SD_BAS_MARGE);
	  else  
          ret = SD_BAS_MacMALLOC(VIADR->tab_var[i].val.pui4, 
                                 unsigned int , viadr_eng[i].dim*PERIODE_VIADR + SD_BAS_MARGE);
          break;
          
        case DECOM__C_real8:
          ret = SD_BAS_MacMALLOC(VIADR->tab_var[i].val.pr8, 
                                double , viadr_eng[i].dim + SD_BAS_MARGE);
         break;
          
        case DECOM__C_date:
          ret = SD_BAS_MacMALLOC(VIADR->tab_var[i].val.pdate, 
                                 t_SD_BAS_SCDSTime , viadr_eng[i].dim + SD_BAS_MARGE);
          break;

	  /* si le type est inconnu on emet une erreur */
	default:
	  cr_op = SD_BAS_ERR_NATURE;
	  msg_err = SD_BAS_MSG_NATURE;
	  num_lig = __LINE__;
	  goto fin;

         
        } // fin switch 

      //@ on teste le retour de l'allocation
      if(ret == FALSE)
	{
	  cr_op = SD_BAS_ERR_BAS_NIVEAU;
	  msg_err = SD_BAS_MSG_ALLOC;
	  num_lig = __LINE__;
	  goto fin;
	}
      
      //on incremente le numero du champ 
      i++;

    } //fin while

 fin:
 /* si une erreur est detectee */
 if ( cr_op != CMN__STATUT_OK)
   {
     /* mise a jour de la variable ctx->cr.errinterne */
     SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                         SD_BAS_ERR_SET_Niveau1,
                         SD_BAS_ERR_NUM_JDB,
                         tcProcName_F,
                         num_lig,
                         msg_err);


   }

 /* on retourne le status */
  return(cr_op); 


}

//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_InitGiadrSca
//@
//@ Description : fonction d'allocation memoire pour un GIADR Scale Factor

//@ Parameters :
//@			(ENTREE)  GIADR  : liste de variable a allouee

//@			(sortie)  ctx  : ctx d'erreur
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
static t_CMN__Statut SD_BAS_InitGiadrSca(t_SD_BAS_Liste_Var *GIADR,
                                  t_SD_BAS_DataThread *ctx)

{
  /* nom de la fonction */
  static const char tcProcName_F[] = "SD_BAS_InitGiadrSca";
  /*retour de la fonction */
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  /* element a ajouter a la listevar */
  DECOM__T_val_var   valeur;
  /* retour des fonctions de commutations */
  t_SD_BAS_status_d status_d;
  /* indice de boucle */
  int i;
  /* retour de fonction */
  int ret;
  /* message d'erreur pour le contexte d'erreur */
  char *msg_err;
  /* numero de ligne pour le contexte d'erreur */
  int num_lig;

  /* tableau decrivant les elements d'un GIADR SCA */
  SD_BAS_Record giadr_sca [] ={
    {"GIADRSCA_DATEDEB",
     DECOM__C_date,        1},
    {"GIADRSCA_DATEFIN",
     DECOM__C_date,        1},
    {"GIADRSCA_IDEFSCALESONDNBSCALE",
     DECOM__C_int4,        1},
    {"GIADRSCA_IDEFSCALESONDNSFIRST",
     DECOM__C_int4,        SD_BAS_TAILLE_NB_SI_B},
    {"GIADRSCA_IDEFSCALESONDNSLAST",
     DECOM__C_int4,        SD_BAS_TAILLE_NB_SI_B},
    {"GIADRSCA_IDEFSCALESONDSCALEFACTOR",
     DECOM__C_int4,        SD_BAS_TAILLE_NB_SI_B},
    {"GIADRSCA_IDEFSCALEIISSCALEFACTOR",
     DECOM__C_int4,        1},
// version 1.6 du conf autre
    {"GIADRSCA_IDEFSCALESONDNBSCALE1A",
     DECOM__C_int4,        1},
    {"GIADRSCA_IDEFSCALESONDNSFIRST1A",
     DECOM__C_int4,        SD_BAS_TAILLE_NB_SI_B},
    {"GIADRSCA_IDEFSCALESONDNSLAST1A",
     DECOM__C_int4,        SD_BAS_TAILLE_NB_SI_B},
    {"GIADRSCA_IDEFSCALESONDSCALEFACTOR1A",
     DECOM__C_int4,        SD_BAS_TAILLE_NB_SI_B},
    {"",0,0}};

   /* initialisation  de la listevar */
  GIADR->nb_var=0;
  GIADR->tab_var=NULL;

  /* on initialise l'indice de boucle */
  i=0;
  
  //pour tous les elements du tableau viade_sca
  while(strcmp(giadr_sca[i].nom_variable, ""))
    {
     
      //@ on alloue un element dans la liste de variable
      status_d = DECOM__Ajouter_variable (GIADR,"",
                                          giadr_sca[i].nom_variable,
                                          giadr_sca[i].type,
                                          giadr_sca[i].dim,
                                          valeur);
     /* si l'ajout est un echec on emet une erreur */
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);

      /* suivant le type de la donnee */
      switch(giadr_sca[i].type)
        {
	  /* on alloue le pointeur */
        case DECOM__C_int4:
          ret = SD_BAS_MacMALLOC(GIADR->tab_var[i].val.pi4, 
                                 int , giadr_sca[i].dim + SD_BAS_MARGE);
          break;

        case DECOM__C_string:
          ret = SD_BAS_MacMALLOC(GIADR->tab_var[i].val.s, 
                                 char , SD_BAS_DATA_STRING);
          break;
          
        case DECOM__C_uint4:
          ret = SD_BAS_MacMALLOC(GIADR->tab_var[i].val.pui4, 
                                 unsigned int , giadr_sca[i].dim + SD_BAS_MARGE);
          break;
          
        case DECOM__C_real8:
          ret = SD_BAS_MacMALLOC(GIADR->tab_var[i].val.pr8, 
                                double , giadr_sca[i].dim + SD_BAS_MARGE);
         break;
          
        case DECOM__C_date:
          ret = SD_BAS_MacMALLOC(GIADR->tab_var[i].val.pdate, 
                                 t_SD_BAS_SCDSTime , giadr_sca[i].dim + SD_BAS_MARGE);
          break;
	  
	  /* si le type est inconnu on emet une erreur */
    	default:
	  cr_op = SD_BAS_ERR_NATURE;
	  msg_err = SD_BAS_MSG_NATURE;
	  num_lig = __LINE__;
	  goto fin;

	} 
      // fin switch 

          //@ on teste le retour de l'allocation
      if(ret == FALSE)
	{
	  cr_op = SD_BAS_ERR_BAS_NIVEAU;
	  msg_err = SD_BAS_MSG_ALLOC;
	  num_lig = __LINE__;
	  goto fin;
	}


      
      //on incremente le numero du champ 
      i++;

    } //fin while

 fin:
 /* si une erreur est detectee */
 if ( cr_op != CMN__STATUT_OK)
   {
     /* mise a jour de la variable ctx->cr.errinterne */
     SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                         SD_BAS_ERR_SET_Niveau1,
                         SD_BAS_ERR_NUM_JDB,
                         tcProcName_F,
                         num_lig,
                         msg_err);

   }
 /* on retourne le status */
  return(cr_op); 
} 





//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_InitGiadrQual
//@
//@ Description : fonction d'allocation memoire pour un GIADR QUAl

//@ Parameters :
//@			(ENTREE)  GIADR  : liste de variable a allouee

//@			(sortie)  ctx  : ctx d'erreur
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
static t_CMN__Statut SD_BAS_InitGiadrQual(t_SD_BAS_Liste_Var *GIADR,
                                     t_SD_BAS_DataThread *ctx)
{
  /* nom de la fonction */
  static const char tcProcName_F[] = "SD_BAS_InitGiadrQual";
  /*retour de la fonction */
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  /* element a ajouter a la listevar */
  DECOM__T_val_var   valeur;
  /* retour des fonctions de commutations */
  t_SD_BAS_status_d status_d;
  /* indice de boucle */
  int i;
  /* retour de fonction */
  int ret;
  /* message d'erreur pour le contexte d'erreur */
  char *msg_err;
  /* numero de ligne pour le contexte d'erreur */
  int num_lig;

  // definition des varibles a alloue
  //nom  : correspodant au fichier .env 
  //type : (int4, uint,4 real8, string, date)
  //dimension : s'il s'agit de tableaux

  /* tableau decrivant les elements d'un QIADR QUA */
  SD_BAS_Record giadr_qual [] ={
    {"GIADRQUA_DATEDEB", 
     DECOM__C_date,        1},
    {"GIADRQUA_DATEFIN", 
     DECOM__C_date,        1},
    {"GIADRQUA_IDEFPSFSONDNBLIN",
     DECOM__C_int4,        SD_BAS_PN},
    {"GIADRQUA_IDEFPSFSONDNBCOL", 
     DECOM__C_int4,        SD_BAS_PN},
    {"GIADRQUA_IDEFPSFSONDOVERSAMPFACTOR", 
     DECOM__C_real8,       1},
    {"GIADRQUA_IDEFPSFSONDY", 
     DECOM__C_real8,       SD_BAS_NB_LIN_SOND * SD_BAS_PN},
    {"GIADRQUA_IDEFPSFSONDZ", 
     DECOM__C_real8,       SD_BAS_NB_COL_SOND * SD_BAS_PN},
    {"GIADRQUA_IDEFPSFSONDWGT",
     DECOM__C_real8,       SD_BAS_NB_COL_SOND * SD_BAS_NB_LIN_SOND * SD_BAS_PN},
    {"GIADRQUA_IDEFIISSRFNSFIRST", 
     DECOM__C_int4,        1},
    {"GIADRQUA_IDEFIISSRFNSLAST", 
     DECOM__C_int4,        1},
    {"GIADRQUA_IDEFIISSRF", 
     DECOM__C_real8,        SD_BAS_NB_COL_SOND},
    {"GIADRQUA_IDEFIISSRFDWN", 
     DECOM__C_real8,        1},
    {"GIADRQUA_IDEFIISNEDT",
     DECOM__C_real8,       SD_BAS_IMCO * SD_BAS_IMLI},
    {"GIADRQUA_IDEFDPTIISDEADPIX",
     DECOM__C_uint4,       SD_BAS_IMCO * SD_BAS_IMLI},
    {"",0,0}};
  


  /* initialisation  de la listevar */
  GIADR->nb_var=0;
  GIADR->tab_var=NULL;

 /* on initialise l'indice de boucle */
  i=0;
  
  //pour tous les elements du tableau viade_qual
  while(strcmp(giadr_qual[i].nom_variable, ""))
    {

      /* on alloue un element dans la liste de variable */
      status_d = DECOM__Ajouter_variable (GIADR,"",
                                          giadr_qual[i].nom_variable,
                                          giadr_qual[i].type,
                                          giadr_qual[i].dim,
                                          valeur);
     /* si l'ajout est un echec on emet une erreur */
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);


      /* suivant le type de la donnee */
      switch(giadr_qual[i].type)
        {
	  /* on alloue le pointeur */
        case DECOM__C_int4:
          ret = SD_BAS_MacMALLOC(GIADR->tab_var[i].val.pi4, 
                                 int , giadr_qual[i].dim + SD_BAS_MARGE);
          break;

        case DECOM__C_string:
          ret = SD_BAS_MacMALLOC(GIADR->tab_var[i].val.s, 
                                 char , SD_BAS_DATA_STRING );
          break;
          
        case DECOM__C_uint4:
          ret = SD_BAS_MacMALLOC(GIADR->tab_var[i].val.pui4, 
                                 unsigned int , giadr_qual[i].dim + SD_BAS_MARGE);
          break;
          
        case DECOM__C_real8:
          ret = SD_BAS_MacMALLOC(GIADR->tab_var[i].val.pr8, 
                                double , giadr_qual[i].dim + SD_BAS_MARGE);
         break;
          
        case DECOM__C_date:
          ret = SD_BAS_MacMALLOC(GIADR->tab_var[i].val.pdate, 
                                 t_SD_BAS_SCDSTime , giadr_qual[i].dim + SD_BAS_MARGE);
          break;
	  
	  /* si le type est inconnu on emet une erreur */
    	default:
	  cr_op = SD_BAS_ERR_NATURE;
	  msg_err = SD_BAS_MSG_NATURE;
	  num_lig = __LINE__;
	  goto fin;

	} // fin switch     

          // on teste le retour de l'allocation
      if(ret == FALSE)
	{
	  cr_op = SD_BAS_ERR_BAS_NIVEAU;
	  msg_err = SD_BAS_MSG_ALLOC;
	  num_lig = __LINE__;
	  goto fin;             
	}


       
      //on incremente le numero du champ 
      i++;

    } //fin while

 fin:
 /* si une erreur est detectee */
 if ( cr_op != CMN__STATUT_OK)
   {
     /* mise a jour de la variable ctx->cr.errinterne */
     SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                         SD_BAS_ERR_SET_Niveau1,
                         SD_BAS_ERR_NUM_JDB,
                         tcProcName_F,
                         num_lig,
                         msg_err);

   }
 /* on retourne le status */
  return(cr_op); 
}
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_InitGiadrEng
//@
//@ Description : fonction d'allocation memoire pour un GIADR ENG

//@ Parameters :
//@			(ENTREE)  GIADR  : liste de variable a allouee

//@			(sortie)  ctx  : ctx d'erreur
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
static t_CMN__Statut SD_BAS_InitGiadrEng(t_SD_BAS_Liste_Var *GIADR,
                                     t_SD_BAS_DataThread *ctx)
{
  /* nom de la fonction */
  static const char tcProcName_F[] = "SD_BAS_InitGiadrEng";
  /*retour de la fonction */
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  /* element a ajouter a la listevar */
  DECOM__T_val_var   valeur;
  /* retour des fonctions de commutations */
  t_SD_BAS_status_d status_d;
  /* indice de boucle */
  int i;
  /* retour de fonction */
  int ret;
  /* message d'erreur pour le contexte d'erreur */
  char *msg_err;
  /* numero de ligne pour le contexte d'erreur */
  int num_lig;


  // definition des varibles a alloue
  //nom  : correspodant au fichier .env 
  //type : (int4, uint,4 real8, string, date, date)
  //dimension : s'il s'agit de tableaux
//CR277 GEPSCCUOBTCORREL est stocke non signe
  /* tableau decrivant les elements d'un GIADR ENG */
  SD_BAS_Record giadr_eng [] ={
    {"GIADRENG_DATEDEB",
     DECOM__C_date,        1},
    {"GIADRENG_DATEFIN",
     DECOM__C_date,        1},
    {"GIADRENG_GEPSDATPROCESSING",
     DECOM__C_date,        1},
    {"GIADRENG_GEPSUTCLEAPSECOND",
     DECOM__C_int4,        3},
    {"GIADRENG_GEPSCCUOBTCORREL",
     DECOM__C_uint4,        1},
    {"GIADRENG_GEPSUTCCORREL",
     DECOM__C_int4,        3},
    {"GIADRENG_GEPSASTEPCORREL",
     DECOM__C_real8,       1},
    {"GIADRENG_GEPSBSTEPCORREL",
     DECOM__C_real8,       1},
    {"",0,0}};



  /* initialisation  de la listevar */
  GIADR->nb_var=0;
  GIADR->tab_var=NULL;

 /* on initialise l'indice de boucle */
  i=0;
  
  //pour tous les elements du tableau viade_qual
  while(strcmp(giadr_eng[i].nom_variable, ""))
    {
      
      // on alloue un element dans la liste de variable
      status_d = DECOM__Ajouter_variable (GIADR,"",
                                          giadr_eng[i].nom_variable,
                                          giadr_eng[i].type,
                                          giadr_eng[i].dim,
                                          valeur);
      /* si l'ajout est un echec on emet une erreur */
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);

      /* suivant le type de la donnee */
      switch(giadr_eng[i].type)
        {
	  /* on alloue le pointeur */
        case DECOM__C_int4:
          ret = SD_BAS_MacMALLOC(GIADR->tab_var[i].val.pi4, 
                                 int , giadr_eng[i].dim + SD_BAS_MARGE);
          break;

        case DECOM__C_string:
          ret = SD_BAS_MacMALLOC(GIADR->tab_var[i].val.s, 
                                 char , SD_BAS_DATA_STRING );
          break;
          
        case DECOM__C_uint4:
          ret = SD_BAS_MacMALLOC(GIADR->tab_var[i].val.pui4, 
                                 unsigned int , giadr_eng[i].dim + SD_BAS_MARGE);
          break;
          
        case DECOM__C_real8:
          ret = SD_BAS_MacMALLOC(GIADR->tab_var[i].val.pr8, 
                                double , giadr_eng[i].dim + SD_BAS_MARGE);
         break;
          
        case DECOM__C_date:
          ret = SD_BAS_MacMALLOC(GIADR->tab_var[i].val.pdate, 
                                 t_SD_BAS_SCDSTime , giadr_eng[i].dim + SD_BAS_MARGE);
          break;
    
	  /* si le type est inconnu on emet une erreur */
    	default:
	  cr_op = SD_BAS_ERR_NATURE;
	  msg_err = SD_BAS_MSG_NATURE;
	  num_lig = __LINE__;
	  goto fin;

	} // fin switch 

          // on teste le retour de l'allocation
      if(ret == FALSE)
	{
	  cr_op = SD_BAS_ERR_BAS_NIVEAU;
	  msg_err = SD_BAS_MSG_ALLOC;
	  num_lig = __LINE__;
	  goto fin;                            
	}


      //on incremente le numero du champ 
      i++;

    } //fin while

 fin:
 /* si une erreur est detectee */
 if ( cr_op != CMN__STATUT_OK)
   {
     /* mise a jour de la variable ctx->cr.errinterne */
     SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                         SD_BAS_ERR_SET_Niveau1,
                         SD_BAS_ERR_NUM_JDB,
                         tcProcName_F,
                         num_lig,
                         msg_err);

   }
 /* on retourne le status */
  return(cr_op); 
}



//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_InitMdrDummy
//@
//@ Description : fonction d'allocation memoire pour un MDR DUMMY
//@ Parameters :
//@			(ENTREE)  MDR  : liste de variable a allouee

//@			(sortie)  ctx  : ctx d'erreur
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
static t_CMN__Statut SD_BAS_InitMdrDummy(t_SD_BAS_Liste_Var *MDR,
                                   t_SD_BAS_DataThread *ctx)
{
  /* nom de la fonction */
  static const char tcProcName_F[] = "SD_BAS_InitMdrDummy";
/*retour de la fonction */
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  /* element a ajouter a la listevar */
  DECOM__T_val_var   valeur;
  /* retour des fonctions de commutations */
  t_SD_BAS_status_d status_d;
  /* indice de boucle */
  int i;
  /* retour de fonction */
  int ret;
  /* message d'erreur pour le contexte d'erreur */
  char *msg_err;
  /* numero de ligne pour le contexte d'erreur */
  int num_lig;

  // definition des varibles a alloue
  //nom  : correspodant au fichier .env 
  //type : (int4, uint,4 real8, string, date)
  //dimension : s'il s'agit de tableaux

  /* tableau decrivant les elements d'un MDR 1C */
  SD_BAS_Record mdr_data [] ={
    {"DMDR_DATEDEB", 
     DECOM__C_date,        1},
    {"DMDR_DATEFIN", 
     DECOM__C_date,        1},
    {"DMDR_LOST_DATA_FLAG", 
     DECOM__C_uint4,        1},
    {"",0,0}};

  /* initialisation  de la listevar */
  MDR->nb_var=0;
  MDR->tab_var=NULL;

  /* on initialise l'indice de boucle */
  i=0;
  
  //pour tous les elements du tableau viade_qual
  while(strcmp(mdr_data[i].nom_variable, ""))
    {

      // on alloue un element dans la liste de variable
      status_d = DECOM__Ajouter_variable (MDR,"",
                               mdr_data[i].nom_variable,
                               mdr_data[i].type,
                               mdr_data[i].dim,
                               valeur);
     /* si l'ajout est un echec on emet une erreur */
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);

      /* suivant le type de la donnee */
      switch(mdr_data[i].type)
        {
	  /* on alloue le pointeur */
        case DECOM__C_int4:
          ret = SD_BAS_MacMALLOC(MDR->tab_var[i].val.pi4, 
                                 int , mdr_data[i].dim + SD_BAS_MARGE);
          break;

        case DECOM__C_string:
          ret = SD_BAS_MacMALLOC(MDR->tab_var[i].val.s, 
                                 char , SD_BAS_DATA_STRING);
          break;
          
        case DECOM__C_uint4:
          ret = SD_BAS_MacMALLOC(MDR->tab_var[i].val.pui4, 
                                 unsigned int , mdr_data[i].dim + SD_BAS_MARGE);
          break;
          
        case DECOM__C_real8:
          ret = SD_BAS_MacMALLOC(MDR->tab_var[i].val.pr8, 
                                double , mdr_data[i].dim + SD_BAS_MARGE);
         break;
          
        case DECOM__C_date:
          ret = SD_BAS_MacMALLOC(MDR->tab_var[i].val.pdate, 
                                 t_SD_BAS_SCDSTime , mdr_data[i].dim + SD_BAS_MARGE);
          break;
    

	  /* si le type est inconnu on emet une erreur */
    	default:
	  cr_op = SD_BAS_ERR_NATURE;
	  msg_err = SD_BAS_MSG_NATURE;
	  num_lig = __LINE__;
	  goto fin;

	} // fin switch 
      
          // on teste le retour de l'allocation
      if(ret == FALSE)
	{
	  cr_op = SD_BAS_ERR_BAS_NIVEAU;
	  msg_err = SD_BAS_MSG_ALLOC;
	  num_lig = __LINE__;
	  goto fin;
	}


      //on incremente le numero du champ 
      i++;

    } //fin while

 fin:
 /* si une erreur est detectee */
 if ( cr_op != CMN__STATUT_OK)
      {
     /* mise a jour de la variable ctx->cr.errinterne */
     SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                         SD_BAS_ERR_SET_Niveau1,
                         SD_BAS_ERR_NUM_JDB,
                         tcProcName_F,
                         num_lig,
                         msg_err);

   }
 /* on retourne le status */
  return(cr_op); 
}
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_InitMdr1C
//@
//@ Description : fonction d'allocation memoire pour un MDR

//@ Parameters :
//@			(ENTREE)  MDR  : liste de variable a allouee

//@			(sortie)  ctx  : ctx d'erreur
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
static t_CMN__Statut SD_BAS_InitMdr1C(t_SD_BAS_Liste_Var *MDR,
                                   t_SD_BAS_DataThread *ctx)
{
  /* nom de la fonction */
  static const char tcProcName_F[] = "SD_BAS_InitMdr1C";
/*retour de la fonction */
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  /* element a ajouter a la listevar */
  DECOM__T_val_var   valeur;
  /* retour des fonctions de commutations */
  t_SD_BAS_status_d status_d;
  /* indice de boucle */
  int i;
  /* retour de fonction */
  int ret;
  /* message d'erreur pour le contexte d'erreur */
  char *msg_err;
  /* numero de ligne pour le contexte d'erreur */
  int num_lig;

  /* ..FT-2521,FT-2522,FT-2523,FT-2524,FT-2525,FT-2526,FT-2528 */
  int index = -1;
  /* ..FT-2521,FT-2522,FT-2523,FT-2524,FT-2525,FT-2526,FT-2528 */
  

  // definition des varibles a alloue
  //nom  : correspodant au fichier .env 
  //type : (int4, uint,4 real8, string, date)
  //dimension : s'il s'agit de tableaux


  /* tableau decrivant les elements d'un MDR 1C */
  /* CR246 : ajout de N1C_ONBOARD_SOFTWARE_VERSION */
  SD_BAS_Record mdr_data [] ={
    {"N1C_DATEDEB", 
     DECOM__C_date,        1},
    {"N1C_DATEFIN", 
     DECOM__C_date,        1},
    {"N1C_DEGRADED_INST_MDR",
     DECOM__C_uint4,       1},
    {"N1C_DEGRADED_PROC_MDR",
     DECOM__C_uint4,       1},
    {"N1C_INSTRUMENT_MODE",
     DECOM__C_uint4,       1},
    {"N1C_SCAN_POSITION",
     DECOM__C_uint4,       1},
    {"N1C_LEVEL",
     DECOM__C_uint4,       1},
    {"N1C_MODE",
     DECOM__C_uint4,       1},
    {"N1C_DEBUG_MODE",
     DECOM__C_uint4,       1},
    {"N1C_INTERFACE_MODE",
     DECOM__C_uint4,       1},
    {"N1C_TARGET",
     DECOM__C_uint4,       1},
    {"N1C_PTSI",
     DECOM__C_uint4,       1},
// FA 196 et 198: suppresion de N1_ONBOARD_SOFTWARE_VERSION (contenu dans PTSI)
    {"N1C_IDEFIDCONF",
     DECOM__C_uint4,       1},
    {"N1C_NORMAL_PROCESSING_MODE",
     DECOM__C_uint4,       1},
    {"N1C_BACKLOG_PROCESSING_MODE",
     DECOM__C_uint4,       1},
    {"N1C_REPROCESSING_MODE",
     DECOM__C_uint4,       1},
    {"N1C_PARALLEL_VALIDATION",
     DECOM__C_uint4,       1},
    {"N1C_MANOEUVRE",
     DECOM__C_uint4,       1},
    {"N1C_DEGRADED_CASES",
     DECOM__C_uint4,       1},
    {"N1C_GEPSLOCIASIAVHRR_IASI",
     DECOM__C_real8,       SD_BAS_DEUX * SD_BAS_PN * SD_BAS_SNOT},
    {"N1C_GEPSLOCIASIAVHRR_IIS",
     DECOM__C_real8,      SD_BAS_DEUX * SD_BAS_SGI * SD_BAS_SNOT},
    {"N1C_OBT",
     DECOM__C_uint4,    SD_BAS_SNOT},//OBT
    {"N1C_ONBOARD_UTC",
     DECOM__C_date,        SD_BAS_SNOT},
    {"N1C_GEPSDATIASI",
     DECOM__C_date,        SD_BAS_SNOT},
    {"N1C_GISFLINORIGIN",
     DECOM__C_int4,        SD_BAS_CCD},
    {"N1C_GISFCOLORIGIN",
     DECOM__C_int4,        SD_BAS_CCD},
    {"N1C_GISFPDS1",
     DECOM__C_real8,        SD_BAS_CCD},
    {"N1C_GISFPDS2",
     DECOM__C_real8,        SD_BAS_CCD},
    {"N1C_GISFPDS3",
     DECOM__C_real8,        SD_BAS_CCD},
    {"N1C_GISFPDS4",
     DECOM__C_real8,        SD_BAS_CCD},
    {"N1C_GEPS_CCD",
     DECOM__C_uint4,       SD_BAS_SNOT},
    {"N1C_GEPS_SP",
     DECOM__C_int4,        SD_BAS_SNOT},
    {"N1C_GQISFLAGQUAL",
     DECOM__C_uint4,       SD_BAS_SB * SD_BAS_PN * SD_BAS_SNOT}, /* FT-2525 */
    {"N1C_GQISFLAGQUALDETAILED",
     DECOM__C_uint4,       SD_BAS_PN * SD_BAS_SNOT}, /* FT-2525 */
    {"N1C_GQISQUALINDEX",
     DECOM__C_real8,       1},
    {"N1C_GQISQUALINDEXIIS",
     DECOM__C_real8,       1},
    {"N1C_GQISQUALINDEXLOC",
     DECOM__C_real8,       1},
    {"N1C_GQISQUALINDEXRAD",
     DECOM__C_real8,       1},
    {"N1C_GQISQUALINDEXSPECT",
     DECOM__C_real8,       1},
    {"N1C_GQISSYSTECIISQUAL",
     DECOM__C_uint4,       1},
    {"N1C_GQISSYSTECSONDQUAL",
     DECOM__C_uint4,       1},
    {"N1C_GGEOSONDLOC",
     DECOM__C_real8,       SD_BAS_DEUX * SD_BAS_PN * SD_BAS_SNOT},
    {"N1C_GGEOSONDANGLESMETOP",
     DECOM__C_real8,       SD_BAS_DEUX * SD_BAS_PN * SD_BAS_SNOT},
    {"N1C_GGEOIISANGLESMETOP",
     DECOM__C_real8,       SD_BAS_DEUX * SD_BAS_SGI * SD_BAS_SNOT},
    {"N1C_GGEOSONDANGLESSUN",
     DECOM__C_real8,       SD_BAS_DEUX * SD_BAS_PN * SD_BAS_SNOT},
    {"N1C_GGEOIISANGLESSUN",
     DECOM__C_real8,       SD_BAS_DEUX * SD_BAS_SGI * SD_BAS_SNOT},
    {"N1C_GGEOIISLOC",
     DECOM__C_real8,       SD_BAS_DEUX * SD_BAS_SGI * SD_BAS_SNOT},
    {"N1C_EARTH_SATELLITE_DISTANCE",
     DECOM__C_uint4,       1},
    {"N1C_IDEFSPECTDWN1B",
     DECOM__C_real8,       1},
    {"N1C_IDEFNSFIRST1B",
     DECOM__C_int4,        1},
    {"N1C_IDEFNSLAST1B",
     DECOM__C_int4,        1},
    {"N1C_IDEFCOVARMATEIGENVAL1C",
     DECOM__C_real8,       SD_BAS_CCD * SD_BAS_COVAR_DIM },
    {"N1C_IDEFCCSCHANNELID",
     DECOM__C_int4,       SD_BAS_NBK},
    {"N1C_GCCSRADANALNBCLASS",
     DECOM__C_int4,       SD_BAS_PN * SD_BAS_SNOT},
    {"N1C_GCCSRADANALWGT",
     DECOM__C_real8,      SD_BAS_NCL * SD_BAS_PN * SD_BAS_SNOT },
    {"N1C_GCCSRADANALY",
     DECOM__C_real8,      SD_BAS_NCL * SD_BAS_PN * SD_BAS_SNOT },
    {"N1C_GCCSRADANALZ",
     DECOM__C_real8,      SD_BAS_NCL * SD_BAS_PN * SD_BAS_SNOT },
    {"N1C_GCCSRADANALMEAN",
     DECOM__C_real8,      SD_BAS_NBK * SD_BAS_NCL * SD_BAS_PN * SD_BAS_SNOT},
    {"N1C_GCCSRADANALSTD",
     DECOM__C_real8,      SD_BAS_NBK * SD_BAS_NCL * SD_BAS_PN * SD_BAS_SNOT},
    {"N1C_GCCSIMAGECLASSIFIED",
     DECOM__C_int4,      SD_BAS_AMCO * SD_BAS_AMLI * SD_BAS_SNOT},
    {"N1C_IDEFCCSMODE",
     DECOM__C_uint4,       1},     
    {"N1C_GCCSIMAGECLASSIFIEDNBLIN",
     DECOM__C_int4,      SD_BAS_SNOT},
    {"N1C_GCCSIMAGECLASSIFIEDNBCOL",
     DECOM__C_int4,      SD_BAS_SNOT},
    {"N1C_GCCSIMAGECLASSIFIEDFIRSTLIN",
     DECOM__C_real8,      SD_BAS_SNOT},
    {"N1C_GCCSIMAGECLASSIFIEDFIRSTCOL",
     DECOM__C_real8,      SD_BAS_SNOT},
    {"N1C_GCCSRADANALTYPE",
     DECOM__C_uint4,      SD_BAS_NCL * SD_BAS_SNOT},
    {"N1C_GIACVARIMAGIIS",                /* FT-2522 */
     DECOM__C_real8,      SD_BAS_SNOT },
    {"N1C_GIACAVGIMAGIIS",                /* FT-2522 */
     DECOM__C_real8,      SD_BAS_SNOT },
    {"N1C_GEUMAVHRR1BCLDFRAC",
     DECOM__C_uint4,      SD_BAS_PN * SD_BAS_SNOT}, /* FT-2528 */
    {"N1C_GEUMAVHRR1BLANDFRAC",
     DECOM__C_uint4,      SD_BAS_PN * SD_BAS_SNOT}, /* FT-2528 */
    {"N1C_GEUMAVHRR1BQUAL",
     DECOM__C_uint4,      SD_BAS_PN * SD_BAS_SNOT}, /* FT-2528 */
    {"N1A_IDEFSPECTDWN",
     DECOM__C_real8,       1},
    {"N1A_IDEFNSFIRST",
     DECOM__C_int4,        1},
    {"N1A_IDEFNSLAST",
     DECOM__C_int4,        1},
    {"N1B_IDEFCOVARMATEIGENVAL1B",
     DECOM__C_real8,       SD_BAS_CCD * SD_BAS_COVAR_DIM },
    
    {"",0,0}};

  /* initialisation  de la listevar */
  MDR->nb_var=0;
  MDR->tab_var=NULL;

 /* valeur.s = NULL;
  valeur.pi4 = NULL;
  valeur.pui4 = NULL;
  valeur.pr8 = NULL;
  valeur.pdate = NULL;
  valeur.pgentime = NULL;*/

  /* on initialise l'indice de boucle */
  i=0;
  
  //pour tous les elements du tableau viade_qual
  while(strcmp(mdr_data[i].nom_variable, ""))
    {

#ifdef COMPIL_INSURE
      /* suivant le type de la donnee */
      switch(mdr_data[i].type)
        {
	  /* on alloue le pointeur */
        case DECOM__C_int4:
          valeur.pi4 = NULL;
          break;
        case DECOM__C_string:
          valeur.s = NULL;
          break;        
        case DECOM__C_uint4:
          valeur.pui4 = NULL;
          break;
        case DECOM__C_real8:
          valeur.pr8 = NULL;
          break;
        case DECOM__C_date:
          valeur.pdate = NULL;
          break;
	  /* si le type est inconnu on emet une erreur */
    	default:
	  cr_op = SD_BAS_ERR_NATURE;
	  msg_err = SD_BAS_MSG_NATURE;
	  num_lig = __LINE__;
	  goto fin;

	} // fin switch 
#endif

      // on alloue un element dans la liste de variable
      status_d = DECOM__Ajouter_variable (MDR,"",
                               mdr_data[i].nom_variable,
                               mdr_data[i].type,
                               mdr_data[i].dim,
                               valeur);
     /* si l'ajout est un echec on emet une erreur */
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);

      /* suivant le type de la donnee */
      switch(mdr_data[i].type)
        {
	  /* on alloue le pointeur */
        case DECOM__C_int4:
          ret = SD_BAS_MacMALLOC(MDR->tab_var[i].val.pi4, 
                                 int , mdr_data[i].dim + SD_BAS_MARGE);
          break;

        case DECOM__C_string:
          ret = SD_BAS_MacMALLOC(MDR->tab_var[i].val.s, 
                                 char , SD_BAS_DATA_STRING);
          break;
          
        case DECOM__C_uint4:
          ret = SD_BAS_MacMALLOC(MDR->tab_var[i].val.pui4, 
                                 unsigned int , mdr_data[i].dim + SD_BAS_MARGE);
          // CR-1777 
          if (!strcmp(mdr_data[i].nom_variable, "N1C_EARTH_SATELLITE_DISTANCE")) 
          {
            *(MDR->tab_var[i].val.pui4) = UINT_MAX;
          }
          // GQISFLAGQUAL
          if (!strcmp(mdr_data[i].nom_variable, "N1C_GQISFLAGQUAL")) 
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE; index++)
            {
              MDR->tab_var[i].val.pui4[index] = CMN__OUI;
            }
          }
          // ...CR-1777 
          // FT-2525
          // GQISFLAGQUALDETAILED
          if (!strcmp(mdr_data[i].nom_variable, "N1C_GQISFLAGQUALDETAILED"))
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE;  index++) 
            {
              // FT-2574
              // Tous les flags en erreur par defaut sauf bits 13,14,15 = 0
              MDR->tab_var[i].val.pui4[index] = 0x1FFF;
              // ...FT-2574
            }
          }
          // ...FT-2525
          // FT-2528
          // GEUMAVHRR1BCLDFRAC
          if (!strcmp(mdr_data[i].nom_variable, "N1C_GEUMAVHRR1BCLDFRAC"))
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE;  index++) 
            {
              MDR->tab_var[i].val.pui4[index] = 0xFF;
            }
          }
          // GEUMAVHRR1BLANDFRAC
          if (!strcmp(mdr_data[i].nom_variable, "N1C_GEUMAVHRR1BLANDFRAC"))
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE;  index++) 
            {
              MDR->tab_var[i].val.pui4[index] = 0xFF;
            }
          }
          // GEUMAVHRR1BQUAL
          if (!strcmp(mdr_data[i].nom_variable, "N1C_GEUMAVHRR1BQUAL"))
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE;  index++) 
            {
              MDR->tab_var[i].val.pui4[index] = 0xFF;
            }
          }
          // ...FT-2528
          break;
          
        case DECOM__C_real8:
          ret = SD_BAS_MacMALLOC(MDR->tab_var[i].val.pr8, 
                                double , mdr_data[i].dim + SD_BAS_MARGE);
                                
          /* FT-2521,FT-2522,FT-2523,FT-2524,FT-2525,FT-2526,FT-2528 */
          /*
           Attention : Code provisoire d'initialisation aux "dummy values"
           des donnees ajoutees aux produits
          */
          
          // GIACVARIMAGIIS
          if (!strcmp(mdr_data[i].nom_variable, "N1C_GIACVARIMAGIIS"))
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE;  index++) 
            {
              MDR->tab_var[i].val.pr8[index] = 0;
            }
          }
          // GIACAVGIMAGIIS
          if (!strcmp(mdr_data[i].nom_variable, "N1C_GIACAVGIMAGIIS"))
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE;  index++) 
            {
              MDR->tab_var[i].val.pr8[index] = 0;
            }
          }
          /* ..FT-2521,FT-2522,FT-2523,FT-2524,FT-2525,FT-2526,FT-2528 */
          // FT-2562
          // Default value for Geo-Location (compliant with GPFS)
          if (!strcmp(mdr_data[i].nom_variable, "N1C_GGEOSONDLOC"))
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE;  index++) 
            {
              MDR->tab_var[i].val.pr8[index] = SD_BAS_MAXNEG_INT4_SF6;
            }
          }
          if (!strcmp(mdr_data[i].nom_variable, "N1C_GGEOSONDANGLESMETOP"))
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE;  index++) 
            {
              MDR->tab_var[i].val.pr8[index] = SD_BAS_MAXNEG_INT4_SF6;
            }
          }
          if (!strcmp(mdr_data[i].nom_variable, "N1C_GGEOIISANGLESMETOP"))
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE;  index++) 
            {
              MDR->tab_var[i].val.pr8[index] = SD_BAS_MAXNEG_INT4_SF6;
            }
          }
          if (!strcmp(mdr_data[i].nom_variable, "N1C_GGEOSONDANGLESSUN"))
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE;  index++) 
            {
              MDR->tab_var[i].val.pr8[index] = SD_BAS_MAXNEG_INT4_SF6;
            }
          }
          if (!strcmp(mdr_data[i].nom_variable, "N1C_GGEOIISANGLESSUN"))
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE;  index++) 
            {
              MDR->tab_var[i].val.pr8[index] = SD_BAS_MAXNEG_INT4_SF6;
            }
          }
          if (!strcmp(mdr_data[i].nom_variable, "N1C_GGEOIISLOC"))
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE;  index++) 
            {
              MDR->tab_var[i].val.pr8[index] = SD_BAS_MAXNEG_INT4_SF6;
            }
          }
          // ...FT-2562
          break;
          
        case DECOM__C_date:
          ret = SD_BAS_MacMALLOC(MDR->tab_var[i].val.pdate, 
                                 t_SD_BAS_SCDSTime , mdr_data[i].dim + SD_BAS_MARGE);
          break;
    

	  /* si le type est inconnu on emet une erreur */
    	default:
	  cr_op = SD_BAS_ERR_NATURE;
	  msg_err = SD_BAS_MSG_NATURE;
	  num_lig = __LINE__;
	  goto fin;

	} // fin switch 
      
          // on teste le retour de l'allocation
      if(ret == FALSE)
	{
	  cr_op = SD_BAS_ERR_BAS_NIVEAU;
	  msg_err = SD_BAS_MSG_ALLOC;
	  num_lig = __LINE__;
	  goto fin;
	}


      //on incremente le numero du champ 
      i++;

    } //fin while

 fin:
 /* si une erreur est detectee */
 if ( cr_op != CMN__STATUT_OK)
      {
     /* mise a jour de la variable ctx->cr.errinterne */
     SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                         SD_BAS_ERR_SET_Niveau1,
                         SD_BAS_ERR_NUM_JDB,
                         tcProcName_F,
                         num_lig,
                         msg_err);

   }
 /* on retourne le status */
  return(cr_op); 
}
//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_InitMdrEng
//@
//@ Description : fonction d'allocation memoire pour un MDR
//@
//@ Parameters :
//@			(ENTREE)  MDR  : liste de variable a allouee
//@
//@			(sortie)  ctx  : ctx d'erreur
//@
//@ Return Status : 
//@			t_CMN__Statut 
//@			CMN__STATUT_OK si la fonction a reussi
//@			CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
static t_CMN__Statut SD_BAS_InitMdrEng(t_SD_BAS_Liste_Var  *MDR,
                                   t_SD_BAS_DataThread *ctx)
{
  /* nom de la fonction */
  static const char tcProcName_F[] = "SD_BAS_InitMdrEng";
   /*retour de la fonction */
  t_CMN__Statut cr_op=CMN__STATUT_OK;
  /* element a ajouter a la listevar */
  DECOM__T_val_var   valeur;
  /* retour des fonctions de commutations */
  t_SD_BAS_status_d status_d;
  /* indice de boucle */
  int i;
  /* retour de fonction */
  int ret;
  /* message d'erreur pour le contexte d'erreur */
  char *msg_err;
  /* numero de ligne pour le contexte d'erreur */
  int num_lig;

    
	/* FT-2521,FT-2522,FT-2523,FT-2524,FT-2525,FT-2526,FT-2528 */
	int index = -1;
    /* ..FT-2521,FT-2522,FT-2523,FT-2524,FT-2525,FT-2526,FT-2528 */

  // definition des varibles a alloue
  //nom  : correspodant au fichier .env 
  //type : (int4, uint,4 real8, string, date)
  //dimension : s'il s'agit de tableaux 

  /* tableau decrivant les elements d'un MDR ENG */
  /* CR246 : ajout de N1C_ONBOARD_SOFTWARE_VERSION */
 
  SD_BAS_Record mdr_data [] ={ 
    {"ENG_DATEDEB",
     DECOM__C_date,        1},
    {"ENG_DATEFIN",
     DECOM__C_date,        1}, 
    {"ENG_BIMSBBT",
     DECOM__C_real8,       1},
    {"ENG_GFTBFILTEREDBBT",
     DECOM__C_real8,       1},
    {"ENG_PTSI",
     DECOM__C_uint4,       1},
// FA 196 et 198: suppresion de N1_ONBOARD_SOFTWARE_VERSION (contenu dans PTSI)
    {"ENG_IDEFIDCONF",
     DECOM__C_uint4,       1},
    {"ENG_NORMAL_PROCESSING_MODE",
     DECOM__C_uint4,       1},
    {"ENG_BACKLOG_PROCESSING_MODE",
     DECOM__C_uint4,       1},
    {"ENG_REPROCESSING_MODE",
     DECOM__C_uint4,       1},
    {"ENG_PARALLEL_VALIDATION",
     DECOM__C_uint4,       1},
    {"ENG_MANOEUVRE",
     DECOM__C_uint4,       1},
    {"ENG_DEGRADED_CASES",
     DECOM__C_uint4,       1},
    {"ENG_INSTRUMENT_MODE",
     DECOM__C_uint4,       1},
    {"ENG_SCAN_POSITION",
     DECOM__C_uint4,       1},
    {"ENG_GCCSCONFAVHRRCHANNEL",
     DECOM__C_uint4,       SD_BAS_NBK * SD_BAS_SNOT},
    {"ENG_GEPSGRANULNUMBER",
     DECOM__C_int4,        1},
    {"ENG_GEPSDATIASI",
     DECOM__C_date,        SD_BAS_SNOT},
    {"ENG_LEVEL",
     DECOM__C_uint4,       1},
    {"ENG_MODE",
     DECOM__C_uint4,       1},
    {"ENG_DEBUG_MODE",
     DECOM__C_uint4,       1},
    {"ENG_INTERFACE_MODE",
     DECOM__C_uint4,       1},
    {"ENG_TARGET",
     DECOM__C_uint4,       1},
    {"ENG_GEPS_SP",
     DECOM__C_int4,        SD_BAS_SNOT},
    {"ENG_GEPS_CCD",
     DECOM__C_uint4,       SD_BAS_SNOT},
    {"ENG_CGEOSUBSATELLITEPOSITION",
     DECOM__C_real8,       SD_BAS_DEUX},
    {"ENG_GEPSOPSFLAGNAN",
     DECOM__C_uint4,       1},
    {"ENG_GEPSENDECLIPSETIME",
     DECOM__C_date,        1},
    {"ENG_GSMETSCAN",
     DECOM__C_real8,       1},
    {"ENG_GSMEFLAGDATENOK",
     DECOM__C_uint4,       1},
    {"ENG_GFTBBBTRES",
     DECOM__C_real8,       1},
    {"ENG_GFTBFLAGBBTNONQUAL",
     DECOM__C_uint4,       1},
    {"ENG_GEPS_LN",
     DECOM__C_int4,        1},
    {"ENG_GDOCFLAGUNDEROVERFLOW",
     DECOM__C_uint4,       SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_GDOCNBUNDERFLOW",
     DECOM__C_int4,        SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_GDOCNBOVERFLOW",
     DECOM__C_int4,        SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_GDOCPOSUNDERFLOW",
     DECOM__C_int4,        SD_BAS_NBPOSUNDERFLOWMAX * SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_GDOCPOSOVERFLOW",
     DECOM__C_int4,        SD_BAS_NBPOSOVERFLOWMAX * SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_BCODSPECVERIFF",
     DECOM__C_int4,        SD_BAS_VERIF},
    {"ENG_GIACOFFSETIISAVHRR",
     DECOM__C_real8,       SD_BAS_DEUX * SD_BAS_SNOT},
    {"ENG_GIACCORRELQUAL",
     DECOM__C_real8,       SD_BAS_SNOT },
    {"ENG_GIACPOSMAXQUAL",
     DECOM__C_real8,       SD_BAS_SNOT },
    {"ENG_GIACFLAGCOREGNONVALID",
     DECOM__C_uint4,       SD_BAS_SNOT },
    {"ENG_GIACFLAGCOREGNONQUAL",
     DECOM__C_uint4,       SD_BAS_SNOT },
    {"ENG_GIACVARIMAGIIS",
     DECOM__C_real8,       SD_BAS_SNOT },
    {"ENG_GIACAVGIMAGIIS",                /* FT-2522 */
     DECOM__C_real8,       SD_BAS_SNOT },
    {"ENG_GEUMAVHRR1BCLDFRAC",
     DECOM__C_uint4,       SD_BAS_PN * SD_BAS_SNOT}, /* FT-2528 */
    {"ENG_GEUMAVHRR1BLANDFRAC", 
     DECOM__C_uint4,       SD_BAS_PN * SD_BAS_SNOT}, /* FT-2528 */
    {"ENG_GEUMAVHRR1BQUAL",     
     DECOM__C_uint4,       SD_BAS_PN * SD_BAS_SNOT}, /* FT-2528 */
    {"ENG_GCCSOFFSETSONDAVHRR",
     DECOM__C_real8,       SD_BAS_DEUX * SD_BAS_PN * SD_BAS_SNOT },
    {"ENG_GCCSOFFSETSONDIIS",
     DECOM__C_real8,       SD_BAS_DEUX * SD_BAS_PN * SD_BAS_SNOT },
    {"ENG_GCCSQUALINDEX", 
     DECOM__C_real8,       SD_BAS_SNOT},
    {"ENG_GCCSFLAGDATENOK",
     DECOM__C_uint4,       1},
    {"ENG_GPCHAVHRRPSEUDOCHN",
     DECOM__C_real8,       4 * SD_BAS_PN * SD_BAS_SNOT}, /* FT-2521 */
    {"ENG_CGCCSRADANALNBCLASS",
     DECOM__C_int4,        SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_GCCSFLAGPOSTPROCESSING",
     DECOM__C_int4,       SD_BAS_SNOT },
    {"ENG_GCCSNONCLASSIFRATE",
     DECOM__C_real8,       SD_BAS_SNOT},
    {"ENG_GCCSVARIANCERATE",
     DECOM__C_real8,       SD_BAS_SNOT},
    {"ENG_GSSDCONVERFLAG",
     DECOM__C_uint4,       SD_BAS_PN * SD_BAS_SNOT}, /* FT-2524 */
    {"ENG_GSSDWNSHIFT",
     DECOM__C_real8,       SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_GSSDWNSHIFTQUAL",
     DECOM__C_real8,       SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_GSSDFLAGSPECTRALSHIFTNONQUAL",
     DECOM__C_uint4,       SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_GSSSWNSHIFTMEAN", 
     DECOM__C_real8,       SD_BAS_PN * SD_BAS_CCD},
    {"ENG_GSSSWNSHIFTMEANQUAL",
     DECOM__C_real8,       SD_BAS_PN * SD_BAS_CCD},
    {"ENG_GSSSFLAGNONSELPIX",
     DECOM__C_uint4,       SD_BAS_PN * SD_BAS_CCD},
    {"ENG_GSSSFLAGDATENOK",
     DECOM__C_uint4,       1},
    {"ENG_GIAXAXEY",
     DECOM__C_real8,       SD_BAS_CCD},
    {"ENG_GIAXAXEZ",
     DECOM__C_real8,       SD_BAS_CCD},
    {"ENG_GIAXFLAGAXENONQUAL",
     DECOM__C_uint4,       SD_BAS_CCD},
    {"ENG_GIAXAXEQUAL",
     DECOM__C_real8,       SD_BAS_CCD},
    {"ENG_GIAXAXERES",
     DECOM__C_real8,       SD_BAS_CCD},
    {"ENG_GFAXAXEY",
     DECOM__C_real8,       SD_BAS_CCD},
    {"ENG_GFAXAXEZ",
     DECOM__C_real8,       SD_BAS_CCD},
    {"ENG_GFAXFLAGAXENONQUAL",
     DECOM__C_uint4,       SD_BAS_CCD},
    {"ENG_GFAXAXERES",
     DECOM__C_real8,       SD_BAS_CCD},
    {"ENG_GISFFLAGPDSNONVALID",
     DECOM__C_uint4,       SD_BAS_CCD},
    {"ENG_GICCRADCALOFFSETIMAG",
     DECOM__C_real8,       SD_BAS_IMCO *  SD_BAS_IMLI},
    {"ENG_GICCRADCALSLOPEIMAG",
     DECOM__C_real8,        SD_BAS_IMCO *  SD_BAS_IMLI},
    {"ENG_GICCFLAGINIT",
     DECOM__C_uint4,       1},
    {"ENG_GQISFLAGQUAL",
     DECOM__C_uint4,       SD_BAS_SB * SD_BAS_PN * SD_BAS_SNOT}, /* FT-2525 */
    {"ENG_GQISFLAGQUALDETAILED",
     DECOM__C_uint4,       SD_BAS_PN * SD_BAS_SNOT}, /* FT-2525 */
    {"ENG_GQISQUALINDEX",
     DECOM__C_real8,       SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_GQISQUALINDEXIIS",
     DECOM__C_real8,       SD_BAS_SNOT},
    {"ENG_GQISQUALINDEXLOC",
     DECOM__C_real8,       SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_GQISQUALINDEXRAD",
     DECOM__C_real8,       SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_GQISQUALINDEXSPECT",
     DECOM__C_real8,       SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_MHIPNZPDINTERPIXEL",
     DECOM__C_int4,        SD_BAS_PN * SD_BAS_SNOT_BIS}, /* FT-2526 */
    {"ENG_MHIPFLAGINTERPIXNZPDNONQUAL",
     DECOM__C_int4,        SD_BAS_PN * SD_BAS_SNOT_BIS}, /* FT-2526 */
    {"ENG_MMCXNOISECALRAD",
     DECOM__C_real8,       SD_BAS_NIM * SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_MMCXBIASCALRAD",
     DECOM__C_real8,       SD_BAS_NIM * SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_MMCXFLAGNOISECALRAD",
     DECOM__C_uint4,       SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_MMCXFLAGBIASCALRAD",
     DECOM__C_uint4,       SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_MMCXCOEFFCALRAD",
     DECOM__C_real8,       SD_BAS_SB * SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_MDPTVARIMAGMAX", 
     DECOM__C_real8,       1},
    {"ENG_MDPTVARIMAGMEAN",
     DECOM__C_real8,       1},
    {"ENG_MDPTPIXQUAL",
     DECOM__C_real8,       1},
    {"ENG_GHECFLAGDATENOK",
     DECOM__C_uint4,       1},
    {"ENG_DATA_PX",
     DECOM__C_int4,        SD_BAS_PN * SD_BAS_SNOT * SD_BAS_DATA_PX}, /* FT-2523 */
    {"ENG_DATA_IP",
     DECOM__C_int4,        SD_BAS_PN * SD_BAS_SNOT_BIS * SD_BAS_DATA_IP},
    {"ENG_EQUALIZATION_COUNTER",
     DECOM__C_int4,        SD_BAS_PN * SD_BAS_SNOT_BIS},
    {"ENG_GOPSFLAPIXMISS",
     DECOM__C_uint4,        SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_GOPSFLADATAGAP",
     DECOM__C_uint4,       1},
    {"ENG_GOPSFLTISRFEMOFF",
     DECOM__C_uint4,       SD_BAS_SNOT}, /* PM4 CR177 */
    {"ENG_GOPSDATISRFEMOFF",
     DECOM__C_date,        1},
    {"ENG_GOPSFLTBANDMISS",
     DECOM__C_uint4,        SD_BAS_SNOT},
    {"ENG_GOPSDATBANDMISS",
     DECOM__C_date,        1},
    {"ENG_GOPSFLTBBTMISS",
     DECOM__C_uint4,       1},
    {"ENG_GOPSDATBBTMISS",
     DECOM__C_date,        1},
    {"ENG_GOPSFLTIMGEWMISS",
     DECOM__C_uint4,        SD_BAS_SNOT},
    {"ENG_GOPSDATIMGEWMISS",
     DECOM__C_date,        1},
    {"ENG_GOPSFLTIMGBBMISS",
     DECOM__C_uint4,       1},
    {"ENG_GOPSDATIMGBBMISS",
     DECOM__C_date,        1},
    {"ENG_GOPSFLTIMGCSMISS",
     DECOM__C_uint4,       1},
    {"ENG_GOPSDATIMGCSMISS",
     DECOM__C_date,        1},
    {"ENG_GOPSFLAIISCALIBMISS",
     DECOM__C_uint4,       SD_BAS_QUATRE},
    {"ENG_GOPSFLTRADAVHRRMISS",
     DECOM__C_uint4,       SD_BAS_SNOT},
    {"ENG_GOPSDATRADAVHRRMISS",
     DECOM__C_date,        1},
    {"ENG_GOPSFLAGPACKETVPMISS",
     DECOM__C_uint4,       SD_BAS_CINQ},
    {"ENG_GOPSFLAGPACKETAPMISS",
     DECOM__C_uint4,       1},
    {"ENG_GOPSFLAGPACKETPXMISS",
      DECOM__C_uint4,       SD_BAS_PN * SD_BAS_SNOT},
    {"ENG_GOPSFLAGPACKETIPMISS",
     DECOM__C_uint4,        SD_BAS_SNOT+4},
    {"ENG_GOPSFLAGEOAVHRRMISS", 
     DECOM__C_uint4,        SD_BAS_SNOT}, /* PM4 CR177 */
    {"",0,0}};



  /* initialisation  de la listevar */
  MDR->nb_var=0;
  MDR->tab_var=NULL;
  
  /* on initialise l'indice de boucle */
   i=0;
  
  //pour tous les elements du tableau viade_qual
  while(strcmp(mdr_data[i].nom_variable, ""))
    {

      // on alloue un element dans la liste de variable
      status_d = DECOM__Ajouter_variable (MDR,"",
                               mdr_data[i].nom_variable,
                               mdr_data[i].type,
                               mdr_data[i].dim,
                               valeur);
     /* si l'ajout est un echec on emet une erreur */
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_AJOUTER,__LINE__);

      /* suivant le type de la donnee */
      switch(mdr_data[i].type)
        {
	  /* on alloue le pointeur */
        case DECOM__C_int4:
          ret = SD_BAS_MacMALLOC(MDR->tab_var[i].val.pi4, 
                                 int , mdr_data[i].dim + SD_BAS_MARGE);
          
          // FT-2526
          // MHIPNZPDINTERPIXEL
          if (!strcmp(mdr_data[i].nom_variable, "ENG_MHIPNZPDINTERPIXEL")) 
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE; index++)
            {
              // FT-2573
              MDR->tab_var[i].val.pi4[index] = SD_BAS_MAX_NFLOAT; 
              // ...FT-2573
            }
          }
          // MHIPFLAGINTERPIXNZPDNONQUAL
          if (!strcmp(mdr_data[i].nom_variable, "ENG_MHIPFLAGINTERPIXNZPDNONQUAL")) 
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE; index++)
            {
              // FT-2941
              MDR->tab_var[i].val.pi4[index] = CMN__OUI;
              // ..FT-2941
            }
          }
          // ...FT-2526
          break;

        case DECOM__C_string:
          ret = SD_BAS_MacMALLOC(MDR->tab_var[i].val.s, 
                                 char , SD_BAS_DATA_STRING);
          break;
          
        case DECOM__C_uint4:
          ret = SD_BAS_MacMALLOC(MDR->tab_var[i].val.pui4, 
                                 unsigned int , mdr_data[i].dim + SD_BAS_MARGE);
          
          // GQISFLAGQUAL
          // CR-1777 
          if (!strcmp(mdr_data[i].nom_variable, "ENG_GQISFLAGQUAL")) 
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE; index++)
            {
              MDR->tab_var[i].val.pui4[index] = CMN__OUI;
            }
          }
          // ...CR-1777 
          // FT-2525
          // GQISFLAGQUALDETAILED
          if (!strcmp(mdr_data[i].nom_variable, "ENG_GQISFLAGQUALDETAILED"))
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE;  index++) 
            {
              // FT-2574 
              // Tous les flags en erreur par defaut sauf bits 13,14,15 = 0
              MDR->tab_var[i].val.pui4[index] = 0x1FFF; 
              // ...FT-2574
            }
          }
          // ...FT-2525
          // FT-2528
          // GEUMAVHRR1BCLDFRAC
          if (!strcmp(mdr_data[i].nom_variable, "ENG_GEUMAVHRR1BCLDFRAC"))
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE;  index++) 
            {
              MDR->tab_var[i].val.pui4[index] = 0xFF;
            }
          }
          // GEUMAVHRR1BLANDFRAC
          if (!strcmp(mdr_data[i].nom_variable, "ENG_GEUMAVHRR1BLANDFRAC"))
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE;  index++) 
            {
              MDR->tab_var[i].val.pui4[index] = 0xFF;
            }
          }
          // GEUMAVHRR1BQUAL
          if (!strcmp(mdr_data[i].nom_variable, "ENG_GEUMAVHRR1BQUAL"))
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE;  index++) 
            {
              MDR->tab_var[i].val.pui4[index] = 0xFF;
            }
          }
          // ...FT-2528

          /* FT-2521,FT-2522,FT-2523,FT-2524,FT-2525,FT-2526,FT-2528 *//*
           Attention : Code provisoire d'initialisation aux "dummy values"
           des donnees ajoutees aux produits
          */

          // GSSDCONVERFLAG
          if (!strcmp(mdr_data[i].nom_variable, "ENG_GSSDCONVERFLAG"))
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE;  index++) 
            {
              MDR->tab_var[i].val.pui4[index] = CMN__NON;
            }
          }
          /* ..FT-2521,FT-2522,FT-2523,FT-2524,FT-2525,FT-2526,FT-2528 */
          break;
          
        case DECOM__C_real8:
          ret = SD_BAS_MacMALLOC(MDR->tab_var[i].val.pr8, 
                                double , mdr_data[i].dim + SD_BAS_MARGE);
                                
          /* FT-2521,FT-2522,FT-2523,FT-2524,FT-2525,FT-2526,FT-2528 */
          /*
           Attention : Code provisoire d'initialisation aux "dummy values"
           des donnees ajoutees aux produits
          */ 

          // GIACAVGIMAGIIS
          if (!strcmp(mdr_data[i].nom_variable, "ENG_GIACAVGIMAGIIS"))
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE;  index++) 
            {
              MDR->tab_var[i].val.pr8[index] = 0;
            }
          }
          // GPCHAVHRRPSEUDOCHN
          if (!strcmp(mdr_data[i].nom_variable, "ENG_GPCHAVHRRPSEUDOCHN"))
          {
            for ( index = 0; index < mdr_data[i].dim + SD_BAS_MARGE;  index++) 
            {
              MDR->tab_var[i].val.pr8[index] = 0;
            }
          }
         /* ..FT-2521,FT-2522,FT-2523,FT-2524,FT-2525,FT-2526,FT-2528 */
         break;
          
        case DECOM__C_date:
          ret = SD_BAS_MacMALLOC(MDR->tab_var[i].val.pdate, 
                                 t_SD_BAS_SCDSTime , mdr_data[i].dim + SD_BAS_MARGE);
          break;
    

	  /* si le type est inconnu on emet une erreur */
    	default:
	  cr_op = SD_BAS_ERR_NATURE;
	  msg_err = SD_BAS_MSG_NATURE;
	  num_lig = __LINE__;
	  goto fin;

	} // fin switch 

          // on teste le retour de l'allocation
      if(ret == FALSE)
	{
	  cr_op = SD_BAS_ERR_BAS_NIVEAU;
	  msg_err = SD_BAS_MSG_ALLOC;
	  num_lig = __LINE__;
	  goto fin;              
	}


      //on incremente le numero du champ 
      i++;

    } //fin while

 fin:
  /* si une erreur est detectee */
  if ( cr_op != CMN__STATUT_OK )
   {
     /* mise a jour de la variable ctx->cr.errinterne */
     SD_BAS_TEST_ERR_INT(ctx->cr.errinterne,
                         SD_BAS_ERR_SET_Niveau1,
                         SD_BAS_ERR_NUM_JDB,
                         tcProcName_F,
                         num_lig,
                         msg_err);

   }

/* on retourne le status */
  return(cr_op); 
}

//@ ------------------------------------------------------------------*/
//@ Procedure : SD_BAS_RecommuterTypeRecord
//@
//@ Description : commutation du MDR et initialisation du GRH 
//@ Parameters :
//@  (ENTREE/SORTIE) ctx   : contexte de gestion des erreurs
//@  (ENTREE)        mdr   : liste des variables lues dans le MDR
//@  (SORTIE)        bloc  : buffer d'ecriture du mdr
//@  (SORTIE)        instr : type d'instrument a ecrire
//@  (SORTIE)        taille_record : taille du buffer a ecrire
//@  (SORTIE)        rec_subclass  : subclass a ecrire dans le grh
//@  (SORTIE)        version_mdr   : version du mdr a ecrire dans le grh
//@
//@ Return Status : 
//@  t_CMN__Statut 
//@    CMN__STATUT_OK si la fonction a reussi
//@    CMN__STATUT_NOK si la fonction a echoue
//@
//@ ------------------------------------------------------------------*/
static t_CMN__Statut SD_BAS_RecommuterTypeRecord(
  t_SD_BAS_DataThread * ctx, 
  t_SD_BAS_LigneN1 *    mdr, 
  char **               bloc, 
  unsigned int *        instr, 
  unsigned int *        taille_record, 
  unsigned int *        rec_subclass, 
  int *                 version_mdr)

{
  /* nom de la fonction */
  static const char tcProcName_F[] = "SD_BAS_RecommuterTypeRecord";
  
  /*retour de la fonction */
  t_CMN__Statut cr_op = CMN__STATUT_OK;
  
  /* buffer temporaire d'ecriture du mdr */
  char * bloc_tmp;
  char * bloc_tmp2;
  
  /* taille du buffer a ecrire */
  unsigned int taille_rec;
  
  /* type d'instrument a ecrire */
  unsigned int instrument;
  
  /* longueur des donnees ecrites */
  int lg = 0;
  
  /* retour des fonctions de commutations */
  t_SD_BAS_status_d status_d;
  
  /* subclass a ecrire dans le grh */
  unsigned int record_subclass;
  
  /* version du mdr a ecrire dans le grh */
  int versionmdr;
  
  /* liste d'un mdr dummy*/
  t_SD_BAS_Liste_Var dummy;
  
  /* message d'erreur pour le contexte d'erreur */
  char *msg_err;
  
  /* numero de ligne pour le contexte d'erreur */
  int num_lig;
  
  /* retour de fonction */
  int ret;
  
  //@ selon le type de mdr (champ TypeRec)
  switch(mdr->TypeRec)
  {
    //@ MDR_1A:
    //@  allocation d'un buffer de taille SD_BAS_TAILLE_MAX_MDR_1A
    //@  on appelle la couche de decodage afin de commuter le contenu du MDR 
    //@  DECOM__Commuter ( fic SD_BAS_NOM_FIC_PROD1 bloc MDR_1A)
    case MDR_1A:
    {
      status_d=DECOM__Recommuter (
        SD_BAS_BLOC_MDR_1A, 
        mdr->InfoDet, 
        bloc, 
        &lg);
      
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_RECOMMUTER,__LINE__);
      
      //@on initialise lees champs du GRH
      instrument = IN_IASI;
      taille_rec = SD_BAS_TAILLE_MAX_MDR_1AB;
      record_subclass = SD_BAS_MDR_A_SUBCLASS;
      versionmdr=SD_BAS_MDR1A_VERSION_N1;
    }
    break;
    
    //@  MDR_1B:
    //@ 	allocation d'un buffer de taille SD_BAS_TAILLE_MAX_MDR_1B
    //@ 	on appelle la couche de decodage afin de commuter le contenu du MDR 
    //@ 	DECOM__Commuter ( fic SD_BAS_NOM_FIC_PROD1 bloc MDR_1B)
    //@	recopie des images et du spectre 1B datasp[1] a partir de infocod
    case MDR_1B:
    {
      status_d=DECOM__Recommuter (
        SD_BAS_BLOC_MDR_1B, 
        mdr->InfoDet, 
        bloc, 
        &lg);
      
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_RECOMMUTER,__LINE__);
      
      //@on initialise lees champs du GRH
      instrument = IN_IASI;
      taille_rec = SD_BAS_TAILLE_MAX_MDR_1AB;
      record_subclass = SD_BAS_MDR_B_SUBCLASS;
      versionmdr=SD_BAS_MDR1B_VERSION_N1;
    }
    break;
    
    //@  MDR_1C:
    //@ 	allocation d'un buffer de taille SD_BAS_TAILLE_MAX_MDR_1C
    //@ 	on appelle la couche de decodage afin de commuter le contenu du MDR 
    //@ 	DECOM__Commuter ( fic SD_BAS_NOM_FIC_PROD1 bloc MDR_1C)
    //@	recopie des images et du spectre 1A datasp[2] a partir de infocod
    case MDR_1C:
    {
      status_d=DECOM__Recommuter (
        SD_BAS_BLOC_MDR_1C, 
        mdr->InfoDet, 
        bloc, 
        &lg);
      
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_RECOMMUTER,__LINE__);
      
      //@on initialise lees champs du GRH
      instrument = IN_IASI;
      taille_rec = SD_BAS_TAILLE_MAX_MDR_1C;
      record_subclass = SD_BAS_MDR_C_SUBCLASS;
      versionmdr=SD_BAS_MDR1C_VERSION_N1;
    }
    break;
    
    //@  MDR_VER: 
    //@ 	allocation d'un buffer de taille SD_BAS_TAILLE_MAX_MDRVER
    //@ 	on appelle la couche de decodage afin de commuter le contenu du MDR 
    //@ 	DECOM__Commuter ( fic SD_BAS_NOM_FIC_PROD1 bloc MDR_1C)
    case MDR_VER:
    {
      //@on alloue un buffer de la taille d'un MDR VER
      status_d=DECOM__Recommuter (
        SD_BAS_BLOC_MDR_VER, 
        mdr->InfoDet, 
        &bloc_tmp, 
        &lg);
      
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_RECOMMUTER,__LINE__);
      
      //@on initialise lees champs du GRH
      instrument = IN_IASI;
      taille_rec = 4+SD_BAS_TAILLE_GRH+ *(mdr->InfoDet.tab_var[VER_SIZE_OF_VERIFICATION_DATA].val.pui4);
      record_subclass = SD_BAS_MDR_VER_SUBCLASS;
      versionmdr=SD_BAS_MDRVER_VERSION_N1;
      
      ret = SD_BAS_MacMALLOC(bloc_tmp2, char, taille_rec);
      if (ret == FALSE)
      {
        cr_op = SD_BAS_ERR_BAS_NIVEAU;
        msg_err = SD_BAS_MSG_ALLOC;
        num_lig = __LINE__;
        goto fin;
      }
      
      memcpy(bloc_tmp2, bloc_tmp, 4+SD_BAS_TAILLE_GRH); 
      memcpy(
        &bloc_tmp2[4+SD_BAS_TAILLE_GRH], 
        mdr->InfoDet2, 
        *(mdr->InfoDet.tab_var[VER_SIZE_OF_VERIFICATION_DATA].val.pui4));
      
      SD_BAS_MacFREE(bloc_tmp);
      *bloc = bloc_tmp2;
    }
    break;
    
    //@  MDR_ENG:
    //@ 	allocation d'un buffer de taille SD_BAS_TAILLE_MAX_MDRENG
    //@ 	on appelle la couche de decodage afin de commuter le contenu du MDR 
    //@ 	DECOM__Commuter ( fic SD_BAS_NOM_FIC_PROD1 bloc MDR_ENG)
    case MDR_ENG:
    {
      status_d=DECOM__Recommuter (
        SD_BAS_BLOC_MDR_ENG, 
        mdr->InfoDet, 
        bloc, 
        &lg);
      
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_RECOMMUTER,__LINE__);
      
      //@on initialise lees champs du GRH
      instrument = IN_IASI;
      taille_rec = SD_BAS_TAILLE_MAX_MDRENG;
      record_subclass = SD_BAS_MDR_ENG_SUBCLASS;
      versionmdr=SD_BAS_MDRENG_VERSION_N1;
    }
    break;
    
    case MDR_DUMMY:
    {
      /* on initialise le MDR */
      cr_op = SD_BAS_InitMdrDummy(&dummy,ctx);
      if (cr_op != CMN__STATUT_OK)
      {
        cr_op   = SD_BAS_ERR_BAS_NIVEAU;
        msg_err = SD_BAS_MSG_INITMDRDUMMY;
        num_lig = __LINE__;
        goto fin;
      }
      
      //@  on remplit les champ du GRH manquant ( dans une liste temporaire)
      //@	  SPARE_FLAGS = 0 
      dummy.tab_var[DMDR_DATEDEB].val.pdate->day = 
        mdr->InfoDet.tab_var[DMDR_DATEDEB].val.pdate->day;
      dummy.tab_var[DMDR_DATEDEB].val.pdate->millis = 
        mdr->InfoDet.tab_var[DMDR_DATEDEB].val.pdate->millis;
      dummy.tab_var[DMDR_DATEFIN].val.pdate->day = 
        mdr->InfoDet.tab_var[DMDR_DATEFIN].val.pdate->day;
      dummy.tab_var[DMDR_DATEFIN].val.pdate->millis = 
        mdr->InfoDet.tab_var[DMDR_DATEFIN].val.pdate->millis;
      *(dummy.tab_var[DMDR_LOST_DATA_FLAG].val.pui4) = 0;
      
      //@ 	on appelle la couche de decodage afin de commuter le contenu du DMDR 
      //@ 	DECOM__Commuter ( fic SD_BAS_NOM_FIC_PROD1 bloc DUMMY)
      //@	dans une buffer de taille SD_BAS_TAILLE_DUMMY
      status_d=DECOM__Recommuter (
        SD_BAS_BLOC_DUMMY, 
        dummy, 
        bloc, 
        &lg);
      
      SD_BAS_TEST_DECOM(status_d,SD_BAS_ERR_RECOMMUTER,__LINE__);
      
      taille_rec= SD_BAS_TAILLE_DUMMY;   
      versionmdr=SD_BAS_MDRDUM_VERSION_N1;
      
      //@	 INSTRUMENT_GROUP = DUMMY
      instrument = IN_DUMMY;
      
      //@	  RECORD_SUBCLASS = 1
      record_subclass = SD_BAS_MDR_DUMMY_SUBCLASS;
      
      /* on libere la liste_var */
      SD_BAS_LibereListeVar(ECRITURE, &dummy);
    }
    break;
    
    default:
    {
      cr_op = SD_BAS_ERR_NATURE;
      msg_err = SD_BAS_MSG_NATURE;
      num_lig = __LINE__;
      goto fin;
    }
  } //@fin switch
  
  /* Definition des sorties */
  *instr = instrument;
  *taille_record = taille_rec;
  *rec_subclass = record_subclass;
  *version_mdr = versionmdr;
  
fin:
  /* si une erreur est detectee */
  if ( cr_op != CMN__STATUT_OK)
  {
    /* mise a jour de la variable ctx->cr.errinterne */
    SD_BAS_TEST_ERR_INT(
      ctx->cr.errinterne, 
      SD_BAS_ERR_SET_Niveau1, 
      SD_BAS_ERR_NUM_JDB, 
      tcProcName_F, 
      num_lig, 
      msg_err);
    
  }

  /* on retourne le status */
  return(cr_op); 
  
} /* fin SD_BAS_RecommuterTypeRecord */
