static char rcs[]="$Header: /root/indusdrci/artf84050/IASI_OPS/OPS/SD/DON/src/SD_DON_GranuleN1.cc,v 1.4 2014/05/14 15:41:10 lcaspar Exp $";
//@ --------------------------------------------------------------------
//@ Composant : SD
//@ Sous-composant : SD_DON
//@ CLASSE : SD_DON_GranuleN1
//@
//@ Commentaire :
//@    Ce module gere la classe SD_DON_GranuleN1, qui contient les
//@    informations relatives a un granule de donnees de niveau 1
//@
//@ --------------------------------------------------------------------
//@ HISTORIQUE
//@ --------------------------------------------------------------------
//@ VERSION : 06/01/2003 : P. CABANE
//@ Creation du fichier
//@ --------------------------------------------------------------------
//@ VERSION : 04/09/2003 : [reference :] Benjamin MASSART
//@ cette version prend en compte les evolutions du code pour une gestion
//@ dynamique de l'ecriture des IPR dans les produits de niveau 1 suite
//@ aux modifications apparues dans la version 6.4 du GPFS et la version
//@ 6.5 du IASI Level 1 Product Format Specification
//@ --------------------------------------------------------------------
//@ DM-ID : PM-3 : 04/09/2003 :
//@ -definition de DecrireIPR()
//@ -appel a la mpethode DecrireIPR() dans EcrireProduit()
//@ --------------------------------------------------------------------
//@ DM-ID :IA-CR-2100-246-CNE : 06/07/2004 : B. MASSART
//@ word # 16 in level 0 PX packets is no more read as part of PTSI number
//@ Variable ONBOARD_SOFTWARE_VERSION added in ENG, 1A, 1B and 1C products
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-136-CN : 01/09/2004 : P.CABANE
//@ Initialization of fields <GIADRENG_GEPSUTCLEAPSECOND> and <GIADRENG_GEPSBSTEPCORREL> has been updated
//@ fiche de correction correspondante : IA-2100-FC-136-THA
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-146-CN : 10/11/2004 : B.MASSART
//@ Mauvaise orthographe de quelques champs du MPHR. Voir IA-2100-FC-146-THA.
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-152-CN : 01/01/2005 : JL.PASCAL
//@ la date de processing dans le nom du produit est la date de debut.
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-153-CN : 29/01/2005 : JL. PASCAL
//@ calcul du champ SUBSAT_LAT et SUBSAT_LON du MPHR
//@ fiche de correction correspondante : IA-2100-FC-153-THA
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-155-CN : 1/03/2005 : JL.PASCAL
//@ Les IPR sont systematiquement ajoutes pour ENG meme si ils n'existent pas
//@ Voir IA-2100-FC-155-THA.
//@ --------------------------------------------------------------------
//@ DM-ID :IA-CR-2100-277-CNE : 07/06/2005 :  JL PASCAL
//@ ecriture du champ GIADRENG_GEPSUTCCORREL comme un entier non signe
//@ Voir IA-2100-CR-277-THA.
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-CR-271-CN : 22/06/2005 : JL.PASCAL
//@ prise en compte du mode transition
//@ fiche de correction correspondante : IA-2100-CR-271-THA
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-170-CN : 07/03/2006 : B.GUENDE
//@ Correction of TARGET_RECORD_SUBCLASS for ENG and VER products in IPR.
//@ See IA-2100-FA-170-THA.
//@ --------------------------------------------------------------------
//@ DM-ID : IA-2100-CR-292-CNE : 10/03/2006 : B.MASSART
//@ Function SD_ALG_AVHRR_GetSubSatLatLon is added to set up 
//@ MPHR_SUBSAT_LATITUDE/LONGITUDE_START/END fields in Level1 products.
//@ See IA-2100-CR-292-THA.
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-180-CN : 30/08/2006 : C.MERIGUET
//@ Mise a jour de l'entete MPHR en mode DUMP
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-162-CN : 09/2006 : C.MERIGUET
//@ Gestion des IPR en mode DUMP
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-185-CN : 09/2006 : C.MERIGUET
//@ Gestion des IPR en mode Granule pour un petit granule
//@ --------------------------------------------------------------------
//@ FA-ID :IA-2100-FA-191-CN : 18/10/2006 : C.MERIGUET
//@ Recopie du spectre L0 dans les produits ENG (champ BCODSPECVERIFF)
//@ --------------------------------------------------------------------
//@ FA-ID : IA-2100-FA-196-CN : 15/01/2007 : C.MERIGUET
//@ FA-ID : IA-2100-FA-198-CN : 15/01/2007 : C.MERIGUET
//@ Ces 2 FA sont traitees conjointement. Recuperation du PTSI lu dans 
//@ le mot 17 (2 octets) mais ecriture dans le champ PTSI des N1 des mots 
//@ 16 (version logiciel bord) et 17 (ptsi) (4 octets).
//@ --------------------------------------------------------------------
//@ FA-ID :IA-FT-2466(FA-2100-OPS) : 30/05/2008 : S. BRUNEL
//@ Probleme de reproductibilite: SUBSAT_LATITUDE_START et
//@ SUBSAT_LONGITUDE_START
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2512 (FA-2100-OPS) : 17/11/2008 : S. BRUNEL
//@ Fuites memoires signalees par EUMETSAT (EUM.EPS.NCR.3627.1)
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2751(FA-2100-OPS) : 06/04/2010 : S.BRUNEL
//@ Probleme de reproductibilite sur les variables 
//@ SUBSAT_XXXX_START et SUBSAT_XXXX_END
//@ --------------------------------------------------------------------
//@ FA-ID : IA-FT-2364(FA-2100-OPS) : 20/09/2010 : S. BRUNEL
//@ Product without  manoeuvre flag raised 
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-2765(DM-2100-OPS) : 21/03/2011 : S. BRUNEL
//@ PORTAGE OPS SOUS LINUX 32 BITS
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-3150(DM-2100-OPS) : 25/04/2014 : M. PENZES
//@ Modification de la MaJ du count_degraded_proc_inst (concaténation de valeur)
//@ --------------------------------------------------------------------
//@ DM-ID : IA-FT-3358(DM-2100-OPS) : 13/04/2017 : MLA
//@ Pour produits > 2Go, il faut utiliser des long long pour stocker la position du curseur 
//@ et les fonctions fseeko et ftello
//@ --------------------------------------------------------------------
//@ FIN-HISTORIQUE
//@ --------------------------------------------------------------------

//
// Fichiers include
//
#include <math.h>
// FT-2765
#include <errno.h>
// ...FT-2765

// STL
#include <cstdio>

// Standard

// Projet
#include "CMN__Commun.h"
#include "CMN__Date.h"
#include "CMN__OPSFile.h"
#include "CMN__Version.h"
#include "CFG__Configuration.h"

#include "SD_DON_GranuleN1.h"


//
// Definition des constantes
//
const t_Chaine SD_DON_GranuleN1::DIR_DATA_TMP           = "DATA_TMP_DIR";
const t_Chaine SD_DON_GranuleN1::JDB_PARAM_1            = "$PRM1";
const t_Chaine SD_DON_GranuleN1::JDB_PARAM_2            = "$PRM2";
const t_Chaine SD_DON_GranuleN1::EXCEPTION_SEPARATEUR   = ": ";
const t_Chaine SD_DON_GranuleN1::ERROR_INIT_READING     = "Error while attempting to read product ";
const t_Chaine SD_DON_GranuleN1::ERROR_INIT_WRITING     = "Error while starting writing product ";
const t_Chaine SD_DON_GranuleN1::ERROR_END_WRITING      = "Error while initialising output product ";
const t_Chaine SD_DON_GranuleN1::NO_LINE_IN_PRODUCT     = "Product does not contain any line ";
const t_Chaine SD_DON_GranuleN1::ERROR_DUMP_FILENAME    = "Error while retrieving dump filename";

const t_Chaine SD_DON_GranuleN1::ASCII_PM_BACKLOG       = "B";
const t_Chaine SD_DON_GranuleN1::ASCII_PM_REPROCESSING  = "R";
const t_Chaine SD_DON_GranuleN1::ASCII_DM_OPERATIONNAL  = "O";
const t_Chaine SD_DON_GranuleN1::ASCII_DM_COMMISSIONING = "C";

const t_Chaine SD_DON_GranuleN1::PROC_LEVEL_1A          = "1A";
const t_Chaine SD_DON_GranuleN1::PROC_LEVEL_1B          = "1B";

const int      SD_DON_GranuleN1::NB_MAX_PRODUIT         = 3;
const int      SD_DON_GranuleN1::TAILLE_FICHIER_PRODUIT = 67;


/* FA 162*/
unsigned int SD_DON_GranuleN1::m_NbIPR1A = 0;
unsigned int SD_DON_GranuleN1::m_NbIPR1B = 0;
unsigned int SD_DON_GranuleN1::m_NbIPR1C = 0;
unsigned int SD_DON_GranuleN1::m_NbIPRENG = 0;
unsigned int SD_DON_GranuleN1::m_NbIPRVER = 0;
e_BAS_TypeRecN1 SD_DON_GranuleN1::m_TypeLastRecord_1A = MDR_DUMMY;
e_BAS_TypeRecN1 SD_DON_GranuleN1::m_TypeLastRecord_1B = MDR_DUMMY;
e_BAS_TypeRecN1 SD_DON_GranuleN1::m_TypeLastRecord_1C = MDR_DUMMY;
e_BAS_TypeRecN1 SD_DON_GranuleN1::m_TypeLastRecENG = MDR_DUMMY;
e_BAS_TypeRecN1 SD_DON_GranuleN1::m_TypeLastRecVER = MDR_DUMMY;
/* ..FA 162*/


//======================================================================
//                                      METHODES PUBLIQUES
//======================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : SD_DON_GranuleN1
//@
//@ Description : Constructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_DON_GranuleN1::SD_DON_GranuleN1()
  : m_NomOrigine(""), m_NbLigneAbsolu(0), 
    m_NatureGranule(SD_DON_GRANULE_N1_DATA),
    m_ModeTraitement(GRANULE), m_PositionTraitement(FIRST),
    m_TypeProduit(SD_DON_PRODUIT_N1_1A1B1C), m_TypeAcces(LECTURE)
{
  //@ Mise a jour du type du granule
  m_TypeGran = SD_DON_Granule::IASIN1;

  //@ Initialisation des GIADR
  m_GIADRENG.TypeRec        = GIADR_ENG;
  m_GIADRENG.InfoDet.nb_var = 0;
  m_GIADRQUA.TypeRec        = GIADR_QUA;
  m_GIADRQUA.InfoDet.nb_var = 0;
  m_GIADRSCA.TypeRec        = GIADR_SCA;
  m_GIADRSCA.InfoDet.nb_var = 0;
}


//@ ------------------------------------------------------------------*/
//@ Methode : ~SD_DON_GranuleN1
//@
//@ Description : Destructeur
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
SD_DON_GranuleN1::~SD_DON_GranuleN1()
{
  //@ On libere ici les listes eventuellement remplies
  m_ListeLigneMDR.clear();
  m_ListeLigneVIADR.clear();
}


//@ ------------------------------------------------------------------*/
//@ Methode : Liberer
//@
//@ Description : Liberation memoire des donnees de l'objet
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::Liberer()
{
  //@ On libere les GIADR eventuellement remplis
  //@ SELON la nature du granule
  switch (m_NatureGranule)
    {
      //@ SI donnees:
    case SD_DON_GRANULE_N1_DATA:

      //@ Liberation GIADR ScaleFactor
      SD_BAS_LibereListeVar(m_TypeAcces, &m_GIADRQUA.InfoDet);

      //@ Liberation GIADR Quality
      SD_BAS_LibereListeVar(m_TypeAcces, &m_GIADRSCA.InfoDet);
      break;
      
      //@ SI ENG:
    case SD_DON_GRANULE_N1_ENG:

      //@ Liberation GIADR Eng
      SD_BAS_LibereListeVar(m_TypeAcces, &m_GIADRENG.InfoDet);
      break;
      
      //@ SI VER:
    case SD_DON_GRANULE_N1_VER:
      //@ Rien a faire
      break;
      
      //@ Defaut:
    default:
      //@ Rien a faire
      break;
    }
  //@ FIN SELON la nature du granule

  //@ POUR toutes les lignes MDR du granule
  for (int i=0; i<m_ListeLigneMDR.size(); i++)
    {
      //@ Liberation memoire des donnees
      m_ListeLigneMDR[i].Liberer();
    }
  //@ FIN POUR toutes les lignes VIADR du granule
  
  //@ POUR toutes les lignes MDR du granule
  for (int i=0; i<m_ListeLigneVIADR.size(); i++)
    {
      //@ Liberation memoire des donnees
      m_ListeLigneVIADR[i].Liberer();
    }
  //@ FIN POUR toutes les lignes VIADR du granule
  
  //@ RAZ des listes
  m_ListeLigneMDR.clear();
  m_ListeLigneVIADR.clear();

  // FT-2512
  SD_BAS_LibereListeVar(ECRITURE, &m_MPHR.listevar);
  SD_BAS_LibereListeVar(ECRITURE, &m_MPHR.grh);
  // ..FT-2512
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetNatureGranule
//@
//@ Description : Recupere la nature du granule: DATA, ENG ou VER
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Nature du granule
//@
//@ ------------------------------------------------------------------*/
SD_DON_GranuleN1::e_SD_DON_GranuleN1 SD_DON_GranuleN1::GetNatureGranule()
  const
{
  //@ Renvoie de la nature du granule
  return (m_NatureGranule);
}


//@ ------------------------------------------------------------------*/
//@ Methode : SetNatureGranule
//@
//@ Description : Met a jour la nature du granule: DATA, ENG ou VER
//@
//@ Parametres :
//@               (ENTREE) nature : Nature du granule
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::SetNatureGranule(SD_DON_GranuleN1::
                                       e_SD_DON_GranuleN1 nature)
{
  //@ Met a jour la nature et le type du granule
 m_NatureGranule = nature;
 m_TypeGran      = SD_DON_Granule::IASIN1;
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetTypeProduit
//@
//@ Description : Recupere le type du produit contenu dans la ligne
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Type du produit contenu dans la ligne
//@
//@ ------------------------------------------------------------------*/
e_SD_DON_ProduitN1 SD_DON_GranuleN1::GetTypeProduit() const
{
  //@ Renvoie du type du produit contenu dans la ligne
  return (m_TypeProduit);
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetNbLigneVIADR
//@
//@ Description : Recupere le nombre de lignes VIADR du granule
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Nombre de lignes VIADR du granule
//@
//@ ------------------------------------------------------------------*/
int SD_DON_GranuleN1::GetNbLigneVIADR() const
{
  //@ Renvoie du nombre de lignes VIADR du granule
  return (m_ListeLigneVIADR.size());
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetDataGenLigne
//@
//@ Description : Recupere la liste des donnees generales pour une 
//@               ligne
//@
//@ Parametres :
//@               (ENTREE) numLigne : Numero de la ligne demandee
//@               (SORTIE) dataGenLigne : Donnees generales ligne
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::GetDataGenLigne(const int numLigne,
                                       t_InfoGenLigne& dataGenLigne)
{
  //@ Recuperation de la ligne MDR
  SD_DON_LigneN1 ligneN1 = GetLigneMDR(numLigne);
  
  //@ Recuperation des donnees generales de la ligne via la
  //@ methode SD_DON_LigneN1::GetDataGen()
  dataGenLigne = ligneN1.GetDataGen();
}

//CR271
//@ ------------------------------------------------------------------*/
//@ Methode : EstTransitionLigne
//@
//@ Description : Recupere la validite d'une ligne
//@
//@ Parametres :
//@               (ENTREE) numLigne : Numero de la ligne demandee
//@
//@ Valeur de retour : 
//@               CMN__VRAI : Ligne valide
//@               CMN__FAUX : Ligne invalide
//@
//@ ------------------------------------------------------------------*/
t_CMN__Booleen SD_DON_GranuleN1::EstTransitionLigne(const int numLigne)
{
  //@ Recuperation de la ligne MDR
  SD_DON_LigneN1 ligneN1 = GetLigneMDR(numLigne);
  
  //@ Recuperation de la validite de la ligne
  return (ligneN1.EstTransition());
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetDataLigne
//@
//@ Description : Recupere les donnees detaillees contenues dans une
//@               ligne
//@
//@ Parametres :
//@               (ENTREE) numLigne : Numero de la ligne demandee
//@               (SORTIE) ligneMDR : Ligne MDR retournee
//@                     (allouee par l'appelant)
//@               (SORTIE) ligneVIADR : Ligne VIADR retournee
//@                     (allouee par l'appelant)
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::GetDataLigne(const int numLigne,
                                    t_SD_BAS_LigneN1& ligneMDR,
                                    t_SD_BAS_LigneN1& ligneVIADR)
{
  //@ Recuperation de la ligne MDR
  SD_DON_LigneN1 ligneN1 = GetLigneMDR(numLigne);
  
  //@ Recuperation des donnees MDR
  ligneN1.GetData(ligneMDR);
 
  //@ SI le produit est un produit ENG
  if (m_NatureGranule == SD_DON_GRANULE_N1_ENG)
    {

      //@ Calcul du numero de la ligne VIADR
      int numLigneVIADR = ((m_NbLigneAbsolu+numLigne)/PERIODE_VIADR)
        - ((m_NbLigneAbsolu)/PERIODE_VIADR);

#ifdef OPS_DEBUG
      cout << "SD_DON_GranuleN1::GetDataLigne: granule ENG: "
           << endl;
      cout << "\tENG_DATEDEB       : " 
           << ligneMDR.InfoDet.tab_var[ENG_DATEDEB].val.pdate->day 
           << " - "
           << ligneMDR.InfoDet.tab_var[ENG_DATEDEB].val.pdate->millis 
           << endl;
      cout << "\tENG_DATEFIN: " 
           << ligneMDR.InfoDet.tab_var[ENG_DATEFIN].val.pdate->day
           << " - "
           << ligneMDR.InfoDet.tab_var[ENG_DATEFIN].val.pdate->millis 
           << endl;
      cout << "\tnumero ligne MDR  : " << numLigne << endl;
      cout << "\tnumero ligne VIADR: " << numLigneVIADR << endl;
      cout << "\tnombre ligne VIADR: " << m_ListeLigneVIADR.size() 
           << endl;
#endif
      
      //@ SI la ligne VIADR est definie
      if (numLigneVIADR < m_ListeLigneVIADR.size())
        {
          //@ Recuperation de la ligne VIADR
          GetDataLigneVIADR(numLigneVIADR, ligneVIADR);
        }
      //@ FIN SI la ligne VIADR est definie
    }
  //@ FIN SI le produit est un produit ENG
}


//@ ------------------------------------------------------------------*/
//@ Methode : InitLecture
//@
//@ Description : Initialise l'acces au granule de niveau 1 en lecture
//@
//@ Parametres :
//@               (ENTREE) nomProduit : Nom du produit a lire
//@               (ENTREE) natureProduit : Nature du produit a lire
//@               (ENTREE) t0 : Date de debut issue du Work Order
//@               (ENTREE) t1 : Date de fin issue du Work Order
//@               (ENTREE) nbLigneAbsolu : Nombre de ligne depuis le
//@                                        debut du dump
//@               (ENTREE/SORTIE) gestionCasDegrade : Gestionnaire de
//@                                                   cas degrade
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::InitLecture(const t_Chaine& nomProduit,
                                   const e_BAS_Nature natureProduit,
                                   const t_Date& t0,
                                   const t_Date& t1,
                                   const int nbLigneAbsolu,
                                   SD_DON_GestCasDeg& gestionCasDegrade)
  throw (ERR__Exception)
{
  // Donnees de contexte
  t_SD_BAS_DataThread *ctx           = NULL;

  // Descripteur de fichier
  t_SD_BAS_Fd         ficDesc;
  t_CMN__Booleen      ficOuvert      = CMN__FAUX;

  // Nom de fichier
  t_SD_BAS_NomProduit nomFichier;

  // Code retour des fonctions utilisees
  t_CMN__Statut       statut         = CMN__STATUT_OK;

#ifdef OPS_DEBUG
  // Nom de la methode
  static const char   tcProcName_F[] = "SD_DON_GranuleN1::InitLecture";
#endif
  

  //@ En captant les exceptions  
  try
    {
      //@ Allocation memoire pour les donnees de contexte
      ctx = new t_SD_BAS_DataThread;
      InitialiserCompteRendu(&(ctx->cr));

      //@ m_NomGranule    = nomProduit
      m_NomGranule    = nomProduit;
      strcpy(nomFichier, m_NomGranule.c_str());

      //@ m_NbLigneAbsolu = nbLigneAbsolu
      m_NbLigneAbsolu = nbLigneAbsolu;

      //@ m_TypeAcces     = LECTURE
      m_TypeAcces     = LECTURE;


      //@ 1. Lecture du fichier en entree
            
      //@ Ouverture du produit N1
/* FA 162 */
      statut = SD_BAS_OuvrirProduit(m_TypeAcces, 
                                    natureProduit, 
                                    nomFichier, 
                                    &ficDesc, 
                                    ctx,
				    m_ModeTraitement);
/* ..FA 162 */

      //@ SI l'ouverture du produit N1 a genere une erreur
      if (statut != CMN__STATUT_OK)
        {
#ifdef OPS_DEBUG
          cerr << tcProcName_F << ": Erreur OuvrirProduit: " << 
            nomFichier << " (" << statut << ")" << endl;
#endif
      
          //@ Traiter l'erreur en provenance des couches basses
          TraiterErreurBAS(ctx, 
                           ERR__Exception::SD_DON_FILE_OPEN, 
                           m_NomGranule);
        }
      //@ FIN SI l'ouverture du produit N1 a genere une erreur
      

#ifdef OPS_DEBUG
      cout << tcProcName_F << ": OuvrirProduit: " << 
        nomFichier << "(" << statut << ")" << endl;
#endif
     
      //@ Le fichier est ouvert
      ficOuvert = CMN__VRAI;
     
      //@ Lecture et initialisation du MPHR du granule m_MPHR
      //@ Lecture du GIADR ScaleFactor
      statut = SD_BAS_LireMPHRGIADRN1(&ficDesc, 
                                      &m_MPHR, 
                                      &m_GIADRSCA.InfoGen, 
                                      ctx);

      //@ SI la lecture du MPHR a genere une erreur
      if (statut != CMN__STATUT_OK)
        {

#ifdef OPS_DEBUG
          cerr << tcProcName_F << ": Erreur LireMPHRGIADRN1: " << 
            nomFichier << " (" << statut << ")" << endl;
#endif
          
      
          //@ Traiter l'erreur en provenance des couches basses
          TraiterErreurBAS(ctx, 
                           ERR__Exception::SD_DON_FILE_READ, 
                           m_NomGranule);
        }
      //@ FIN SI la lecture du MPHR a genere une erreur
      
#ifdef DEBUG
      cout << tcProcName_F << ": LireMPHRGIADRN1: " << 
        nomFichier << "(" << statut << ")" << endl;
      
      // Affichage MPHR
      AfficherMPHR(CMN__VRAI);
      
      cout << "1er offset MDR: " << ficDesc.offsetMDR << endl;
      cout << "Offset suivant: " << ficDesc.offsetMDRSuivant << endl;
#endif
      
      //@ SI le produit en entree est de type ENG
      if (natureProduit == NA_IASIL1ENG)
        {
          //@ Lecture du GIADR ENG
          statut = SD_BAS_LireGIADRN1(&ficDesc, 
                                      &m_GIADRENG, 
                                      ctx);

          //@ SI la lecture du GIADR a genere une erreur
          if (statut != CMN__STATUT_OK)
            {
              
#ifdef OPS_DEBUG
              cerr << tcProcName_F << ": Erreur LireGIADRN1: " << 
                nomFichier << " (" << statut << ")" << endl;
#endif
              
              
              //@ Traiter l'erreur en provenance des couches basses
              TraiterErreurBAS(ctx, 
                               ERR__Exception::SD_DON_FILE_READ, 
                               m_NomGranule);
            }
          //@ FIN SI la lecture du GIADR a genere une erreur
	         
          //@ Mise a jour du type de produit
          m_TypeProduit = SD_DON_PRODUIT_N1_ENG;
        }
      //@ SI le produit en entree est de type ENG


      //@ 2. Gestion de l'overlap (pour determiner le debut
      //@    et la fin du produit a traiter)
      //@ Ici c'est tres simple, il suffit de lire chaque ligne a la
      //@ suite et de remplir le tableau 
      GestionOverlap(t0, t1, ficDesc, ctx);
  
        
      //@ 3. Lecture des donnees MDR
      //@ On se deplace jusqu'a la ligne numero m_IndiceDebut
      
      //@ POUR chaque ligne du tableau m_ListeInfoGenLigne (on 
      //@ commence a m_IndiceDebut)
      for (int i=m_IndiceDebut; i<m_ListeInfoGenLigne.size(); i++)
        {
          
#ifdef OPS_DEBUG
          cout << "Ligne GRANULE: " << i+1 << endl;
#endif
          
          //@ Creation d'une ligne de niveau 1 (SD_DON_LigneN1)
          SD_DON_LigneN1 nouvelleLigneN1;
          
          //@ Mise a jour de l'offset de lecture
          ficDesc.offsetMDRSuivant = m_ListeInfoGenLigne[i].GetOffset();

          //@ Lire les donnees de la ligne via la methode
          //@ SD_DON_LigneN1::InitLecture()
          nouvelleLigneN1.InitLecture(i-m_IndiceDebut, 
                                      m_ListeInfoGenLigne[i], 
                                      m_TypeProduit, 
                                      TR_MDR,
                                      gestionCasDegrade,
                                      ficDesc);

          //@ Ajouter la ligne dans la liste des lignes du granule
          m_ListeLigneMDR.push_back(nouvelleLigneN1);

          //@ SI la ligne est DUMMY
          if (m_ListeInfoGenLigne[i].GetValidite() != VALIDE)
            {
              //@ Referencer le trou de donnees
              m_NbDataGap++;
            }
        }
      //@ FIN POUR chaque ligne du tableau m_ListeInfoGenLigne

      //@ SI granule ENG
      if (m_NatureGranule == SD_DON_GRANULE_N1_ENG)
        {
          // Numero de la ligne VIADR
          int numLigneVIADR = 0;

          // Indice de la premiere ligne MDR attachee a la ligne VIADR
          int premierMDR    = 0;


          //@ 4. Lecture des donnees VIADR
          //@ On se deplace jusqu'a la ligne numero m_IndiceDebut
      
          //@ POUR chaque ligne du tableau m_ListeInfoGenLigne (on 
          //@ commence a m_IndiceDebut)
          for (int i=m_IndiceDebut; i<m_ListeInfoGenLigne.size(); i++)
            {

#ifdef OPS_DEBUG
              cout << endl 
                   << "Ligne GRANULE  : " << i << endl;
              cout << "No ligne VIADR : " << (i/PERIODE_VIADR) << endl;
#endif

              //@ SI (nbLigneAbsolu+i-1)%PERIODE_VIADR = 0
              if ( ((nbLigneAbsolu+i+1)%PERIODE_VIADR) == 0)
                {
                  //@ Creation d'une ligne VIADR
                  SD_DON_LigneN1 nouvelleLigneVIADR;
                  t_InfoGenLigne infoGen = m_ListeInfoGenLigne[i];

                  premierMDR = i - PERIODE_VIADR + 1;

                  //@ SI la premiere ligne fait partie des 
                  //@ lignes MDR lues
                  if (premierMDR >= 0)
                    {
                      infoGen.SetDateDebut(m_ListeInfoGenLigne[premierMDR]
                                           .GetDateDebut());
                    }
                  //@ SINON
                  else
                    {
                      //@ Ligne VIADR inter-granule
                      //@ Elle sera completee par les infos du contexte
                      double ecartDebutVIADR = 
                        (PERIODE_VIADR-1)*SD_BAS_DUREE_LGN;
                      
                      infoGen.SetDateDebut(infoGen.GetDateDebut() - 
                                           ecartDebutVIADR);
                    }
                  //@ FIN SI

                  //@ Lire les donnees de la ligne via la methode
                  //@ SD_DON_LigneN1::InitLecture()
                  nouvelleLigneVIADR.InitLecture(numLigneVIADR++, 
                                                 infoGen,
                                                 m_TypeProduit, 
                                                 TR_VIADR,
                                                 gestionCasDegrade,
                                                 ficDesc);

                  //@ Ajouter la ligne dans la liste des lignes 
                  //@ VIADR du granule
                  m_ListeLigneVIADR.push_back(nouvelleLigneVIADR);
                }
              //@ FIN SI (nbLigneAbsolu+i-1)%PERIODE_VIADR = 0
            }
          //@ FIN POUR chaque ligne du tableau m_ListeInfoGenLigne
        }
      //@ FIN SI granule ENG
      
      //@ Fermeture du fichier de N1
/* FA 162 */
      SD_BAS_FermerProduit(m_TypeAcces, &ficDesc, ctx,m_ModeTraitement);
/* ..FA 162 */
  
      //@ Liberation memoire pour les donnees de contexte
      LibererCompteRendu(&(ctx->cr.msgJDB));
      delete ctx;
    }

  //@ Traiter les exceptions
  catch(ERR__Exception& exception)
    {

#ifdef OPS_DEBUG
      //@ Impression des exceptions
      cout << "Exception in " << tcProcName_F << endl;
      cout << "\tFile : " << exception.GetFile() << endl;
      cout << "\tLine : " << exception.GetLine() << endl;
      cout << "\tError: " << exception.GetErrorCode() << endl;
      for (int i=0; i<exception.GetNbParametre(); i++)
        {
          cout << "\tInfo : " << exception.GetParametre(i) << endl;
        }
#endif

      //@ SI le fichier est ouvert
      if (ficOuvert == CMN__VRAI)
        {
          //@ Fermeture du fichier de N1
/* FA 162 */
          SD_BAS_FermerProduit(m_TypeAcces, &ficDesc, ctx,m_ModeTraitement);
/* ..FA 162 */
        }
      //@ FIN SI le fichier est ouvert

      //@ Envoi des messages generes au JDB
      EnvoyerMessagesStockes(&(ctx->cr.msgJDB));
      
      //@ Liberation memoire pour les donnees de contexte
      LibererCompteRendu(&(ctx->cr.msgJDB));
      delete ctx;
      
      //@ Emission d'un message de type JDB MSG_SD_FILE_READ_ERROR
      JDB__Client messageJDB;
      messageJDB.SetParametre(JDB_PARAM_1, m_NomGranule);
      messageJDB.EcrireMessage(SD_SET, 
                               SD__Message::MSG_SD_FILE_READ_ERROR);
      messageJDB.Liberer();

      //@ Re-emission de l'exception
      exception.SetDebParametre(ERROR_INIT_READING + m_NomGranule);
      THROW(exception);
    }
}


//@ ------------------------------------------------------------------*/
//@ Methode : InitEcritureN0N1
//@
//@ Description : Initialise l'acces au granule de niveau 1 en
//@               ecriture a partir du granule de N0
//@
//@ Parametres :
//@               (ENTREE/SORTIE) gestionCasDegrade : Gestionnaire de
//@                                                   cas degrade
//@               (ENTREE) nomModele : Nom du fichier modele
//@               (ENTREE) modeTraitement : Mode de traitement (dump
//@                                         ou granule)
//@               (ENTREE) positionTraitement : Position du traitement
//@                                             (FRIST, MIDDLE ou LAST)
//@               (ENTREE) typeProduit : Type de produit
//@               (ENTREE) objetOSV : Objet OSV pour le mode plateforme
//@               (ENTREE) OBTUTC : Objet pour la correction temps UTC
//@               (ENTREE) granuleN0 : Granule N0 pour initialisation
//@               (ENTREE) nbLigneAbsolu : Nombre de lignes absolues
//@                                        depuis le debut du dump
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::InitEcritureN0N1(SD_DON_GestCasDeg& 
                                        gestionCasDegrade,
                                        const t_Chaine& nomModele,
                                        const e_BAS_ModeTrt 
                                        modeTraitement,
                                        const e_BAS_PositionTrt
                                        positionTraitement,
                                        const e_SD_DON_ProduitN1 
                                        typeProduit,
                                        SD_DON_OSV& objetOSV,
                                        SD_DON_OBTUTC& OBTUTC,
                                        SD_DON_GranuleN0& granuleN0,
                                        const int nbLigneAbsolu,
					t_SD_BAS_MPHR& mphr)
{
  // Donnees lues dans le MPHR
  e_BAS_PROCMODE       processingMode  = PM_NRT; 
  e_BAS_DISPMODE       dispositionMode = VALIDATION;


  //@ m_NomGranule         = NomCourt(nomModele)
  m_NomGranule         = NomCourt(nomModele);
  
  //@ m_NbLigne            = SD_DON_Granule::GetNbLigne()
  m_NbLigne            = granuleN0.GetNbLigne();

  //@ m_NomOrigine         = SD_DON_Granule::GetNomGranule()
  m_NomOrigine         = NomCourt(granuleN0.GetNomGranule());

  //@ m_TypeProduit        = typeProduit
  m_TypeProduit        = typeProduit;
  
  //@ m_ModeTraitement     = modeTraitement
  m_ModeTraitement     = modeTraitement;
  
  //@ m_PositionTraitement = positionTraitement
  m_PositionTraitement = positionTraitement;
  
  //@ m_NbLigneAbsolu      = nbLigneAbsolu
  m_NbLigneAbsolu      = nbLigneAbsolu;
  
  //@ m_TypeAcces          = ECRITURE
  m_TypeAcces          = ECRITURE;
  
  //@ Recuperer la date de debut et de fin du granule
  //@ et initialiser les attributs
  m_TP0                = granuleN0.GetDateDebut();
  m_TP1                = granuleN0.GetDateFin();
      
  //@ Mise a jour des dates de debut, de fin de processing pour le MPHR
   m_Tdeb.DateCourante();
   m_Tfin.DateCourante();

  //@ 1. Lecture du product model
  LireProductModel(nomModele,mphr);

  //@ 2. Recuperer les infos processingMode et dispositionMode
  processingMode  = GetProcessingMode();
  dispositionMode = GetDispositionMode();

  //@ Le granule peut etre de nature: DATA/ENG/VER

  //@ 3. Initialiser les GIADR
  InitGIADR();

  //@ 4. Initialiser les MDR
  //@ POUR chaque ligne MDR du granule a initialiser
  for (int i=0; i<m_NbLigne; i++)
    {
      //@ Appel de la methode InitLigne()
      InitLigne(i, 
                objetOSV,
                granuleN0,
                gestionCasDegrade,
                processingMode,
                dispositionMode,
                nbLigneAbsolu,
                OBTUTC);
    } 
  //@ FIN POUR chaque ligne du granule a initialiser

  //@ 5. Initialiser les VIADR
  //@ SI le produit est un produit ENG
  if (m_NatureGranule == SD_DON_GRANULE_N1_ENG)
    {
      // Numero de la ligne VIADR
      int numLigneVIADR = 0;
      
      //@ POUR chaque ligne MDR du granule a initialiser
      for (int i=0; i<m_NbLigne; i++)
        {        
          //@ SI (i+1+m_NbLigneAbsolu)%PERIODE_VIADR = 0
          if ( ((i+1+m_NbLigneAbsolu)%PERIODE_VIADR) == 0)
            {

#ifdef OPS_DEBUG
              cout << "GranuleN1::Init: ligne VIADR cree: " 
                   << numLigneVIADR << " (MDR=" << i 
                   << "; nbLigneAbsolu=" << nbLigneAbsolu 
                   << ")" << endl;
#endif
              
              //@ Appel de la methode InitLigneVIADR()
              InitLigneVIADR(numLigneVIADR++,
                             i, 
                             objetOSV,
                             granuleN0,
                             gestionCasDegrade,
                             processingMode,
                             dispositionMode,
                             nbLigneAbsolu,
                             OBTUTC);
            }
          //@ FIN SI (i+1)%PERIODE_VIADR = 0
        }
      //@ FIN POUR chaque ligne MDR du granule a initialiser
    }
  //@ FIN SI le produit est un produit ENG      
}


//@ ------------------------------------------------------------------*/
//@ Methode : InitEcritureN1N1
//@
//@ Description : Initialise l'acces au granule de niveau 1 en
//@               ecriture a partir du granule de N1
//@
//@ Parametres :
//@               (ENTREE/SORTIE) gestionCasDegrade : Gestionnaire de 
//@                                                   cas degrade
//@               (ENTREE) nomModele : Nom du fichier modele
//@               (ENTREE) modeTraitement : Mode de traitement (dump
//@                                         ou granule)
//@               (ENTREE) typeLigne : Type de la ligne
//@               (ENTREE) granule : Granule de N0 pour initialisation
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::InitEcritureN1N1(SD_DON_GestCasDeg& 
                                        gestionCasDegrade,
                                        const t_Chaine& nomModele,
                                        const e_BAS_ModeTrt 
                                        modeTraitement,
                                        const e_BAS_PositionTrt
                                        positionTraitement,
                                        const e_SD_DON_ProduitN1 
                                        typeProduit,
                                        SD_DON_GranuleN1& granuleN1,
					t_SD_BAS_MPHR& mphr)
{
  //@ m_NomGranule         = NomCourt(nomModele)
  m_NomGranule         = NomCourt(nomModele);

  //@ m_NomOrigine         = SD_DON_Granule::GetNomGranule()
  m_NomOrigine         = granuleN1.GetNomGranule();
  
  //@ m_NbLigne            = SD_DON_Granule::GetNbLigne()
  m_NbLigne            = granuleN1.GetNbLigne();
  
  //@ m_TypeProduit        = typeProduit
  m_TypeProduit        = typeProduit;
  
  //@ m_ModeTraitement     = modeTraitement
  m_ModeTraitement     = modeTraitement;
  
  //@ m_PositionTraitement = positionTraitement
  m_PositionTraitement = positionTraitement;
  
  //@ m_TypeAcces          = ECRITURE
  m_TypeAcces          = ECRITURE;
  
  //@ Recuperer la date de debut et de fin du granule
  //@ et initialiser les attributs
  m_TP0                = granuleN1.GetDateDebut();
  m_TP1                = granuleN1.GetDateFin();
  
  //@ Mise a jour des dates de debut, de fin de processing pour le MPHR
   m_Tdeb.DateCourante();
   m_Tfin.DateCourante();

  //@ 1. Lecture du product model
  LireProductModel(nomModele,mphr);

  //@ 2. Initialiser les GIADR
  if (m_NatureGranule == SD_DON_GRANULE_N1_ENG)
    {
      RecupererGIADR(granuleN1);
    }
  else
    {
      InitGIADR();
    }

  //@ 3. Initialisation des MDR
  //@ POUR chaque ligne du granule
  for (int i=0; i<m_NbLigne; i++)
    {
      //@ Creation d'une ligne de niveau 1
      SD_DON_LigneN1      nouvelleLigneN1;
      t_InfoGenLigne      dataGenLigne;
      SD_DON_CasDegLigne* casDegLigne = 0;
      t_SD_BAS_LigneN1    ligneMDR;

      //@ Recuperation des donnees generales a la ligne 0 via
      //@ la methode SD_DON_Granule::GetDataGenLigne()
      granuleN1.GetDataGenLigne(i, dataGenLigne);
      
      //@ Lecture des donnees de la ligne via la methode
      //@ SD_DON_GranuleN1::GetDataLigne()
      granuleN1.GetDataLigneMDR(i, ligneMDR);
      
      //@ Recuperation du cas degrade associe a la ligne via
      //@ la methode SD_DON_GestCasDeg::GetCasDegLigne()
      casDegLigne = gestionCasDegrade.GetCasDegLigne(i+1);
      
      //@ Initialisation des donnees de la ligne N1 via
      //@ la methode SD_DON_LigneN1::InitEcritureN1()
      nouvelleLigneN1.InitEcritureN1(i,
                                     m_TypeProduit,
                                     TR_MDR,
                                     modeTraitement,
                                     dataGenLigne, 
                                     ligneMDR,
                                     *casDegLigne);
      
      //@ Remarque : si un DMDR est detecte en entree, un DMDR
      //@ est initialise
      //@ i.e.: (N1::m_EstValide) -> (N1::m_EstValide)
      
      //@ Ajouter la ligne dans la liste des lignes MDR du granule
      m_ListeLigneMDR.push_back(nouvelleLigneN1);
    }
  //@ FIN POUR chaque ligne du granule a initialiser
  
  //@ SI le produit est un produit ENG
  if (m_NatureGranule == SD_DON_GRANULE_N1_ENG)
    {
      //@ Nombre de lignes VIADR
      int nbLigneVIADR = granuleN1.GetNbLigneVIADR();

      //@ Initialisation des VIADR
      //@ POUR chaque ligne VIADR du granule
      for (int i=0; i<nbLigneVIADR; i++)
        {
          //@ Creation d'une ligne de type VIADR
          SD_DON_LigneN1      nouvelleLigneVIADR;
          t_InfoGenLigne      dataGenLigne;
          t_SCDSTime          valDate;
          t_Date              dateTmp;
          SD_DON_CasDegLigne* casDegLigne = 0;
          t_SD_BAS_LigneN1    ligneVIADR;
          
          //@ Lecture des donnees de la ligne via la methode
          //@ SD_DON_GranuleN1::GetDataLigneVIADR()
          granuleN1.GetDataLigneVIADR(i, ligneVIADR);

          valDate.day    = ligneVIADR.InfoDet.tab_var[VIADRENG_DATEDEB].
            val.pdate->day;
          valDate.millis = ligneVIADR.InfoDet.tab_var[VIADRENG_DATEDEB].
            val.pdate->millis;
          dateTmp.SCDSTime(valDate);
          dataGenLigne.SetDateDebut(dateTmp);
          valDate.day    = ligneVIADR.InfoDet.tab_var[VIADRENG_DATEFIN].
            val.pdate->day;
          valDate.millis = ligneVIADR.InfoDet.tab_var[VIADRENG_DATEFIN].
            val.pdate->millis;
          dateTmp.SCDSTime(valDate);
          dataGenLigne.SetDateFin(dateTmp);
          dataGenLigne.SetValidite(VALIDE);

          nouvelleLigneVIADR.InitEcritureN1(i,
                                            m_TypeProduit,
                                            TR_VIADR,
                                            modeTraitement,
                                            dataGenLigne, 
                                            ligneVIADR,
                                            *casDegLigne);
          
          //@ Ajouter la ligne dans la liste des lignes 
          //@ VIADR du granule
          m_ListeLigneVIADR.push_back(nouvelleLigneVIADR);
        }
      //@ FIN POUR chaque ligne VIADR du granule
    }
  //@ FIN SI le produit est un produit ENG
}


//@ ------------------------------------------------------------------*/
//@ Methode : SetEntete
//@
//@ Description : Met a jour le MPHR et les GIADR en fin de traitement
//@
//@ Parametres :
//@               (ENTREE) statMPHR : Infos generales pour le MPHR
//@               (ENTREE) paramConfStable : Parametres de qualite
//@                                          pour le GIADR
//@               (ENTREE) OBTUTC : Donnees OBTUTC
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
// FT-2466
void SD_DON_GranuleN1::SetEntete(const t_SD_BAS_StatMphr* statMPHR,
                                 const t_SD_BAS_ConfStable* 
                                 paramConfStable,
                                 const SD_DON_OBTUTC& OBTUTC,
                                 int numeroLigne)
// ..FT-2466
{
  // Structure CDS
  t_SCDSTime tempsDebut    = m_TP0.SCDSTime();
  t_SCDSTime tempsFin      = m_TP1.SCDSTime();
  t_Chaine   strTempsDebut = m_TP0.DateUTC(CMN__FAUX, CMN__FAUX);
  t_Chaine   strTempsFin   = m_TP1.DateUTC(CMN__FAUX, CMN__FAUX);

  //@ MPHR_PROCESSOR_MAJOR_VERSION
   int version_majeur=CMN__Version_Majeur();
    *(m_MPHR.listevar.tab_var[MPHR_PROCESSOR_MAJOR_VERSION].val.pui4)=  version_majeur;
  //@ MPHR_PROCESSOR_MINOR_VERSION
   int version_mineur=CMN__Version_Mineur();
    *(m_MPHR.listevar.tab_var[MPHR_PROCESSOR_MINOR_VERSION].val.pui4)=  version_mineur;
   
#ifdef OPS_DEBUG
      cout << "MPHR_PROCESSOR_MAJOR_VERSION "
           << version_majeur
           << endl;
      cout << "MPHR_PROCESSOR_MINOR_VERSION "
           << version_mineur
           << endl;
#endif
   
  
  //@ MPHR_SENSING_START
  strcpy(m_MPHR.listevar.tab_var[MPHR_SENSING_START].val.s, 
         strTempsDebut.c_str());
 
  //@ MPHR_SENSING_END
  strcpy(m_MPHR.listevar.tab_var[MPHR_SENSING_END].val.s, 
         strTempsFin.c_str());


  //@ MPHR_DURATION_OF_PRODUCT
  m_MPHR.listevar.tab_var[MPHR_DURATION_OF_PRODUCT].val.pui4[0] = 
    (unsigned int) ((m_TP1 - m_TP0) * 1000);
 
  //@ MPHR_MILLISECONDS_OF_DATA_MISSING
  m_MPHR.listevar.tab_var[MPHR_MILLISECONDS_OF_DATA_MISSING].val.
    pui4[0] = 0;
  
  //@ MPHR_MILLISECONDS_OF_DATA_PRESENT
  m_MPHR.listevar.tab_var[MPHR_MILLISECONDS_OF_DATA_PRESENT].val.
    pui4[0] = 
    m_MPHR.listevar.tab_var[MPHR_DURATION_OF_PRODUCT].val.pui4[0] - 
    m_MPHR.listevar.tab_var[MPHR_MILLISECONDS_OF_DATA_MISSING].val.
    pui4[0];

  //@ Mise a jour de m_MPHR avec statMPHR (nombre de record degrades)
  m_MPHR.listevar.tab_var[MPHR_COUNT_DEGRADED_INST_MDR].val.pui4[0] += 
    statMPHR->count_degraded_inst_mdr;
  
  // DM-3150 : Modification de la MaJ du count_degraded_proc
  // La valeur est ajouté entièrement
  m_MPHR.listevar.tab_var[MPHR_COUNT_DEGRADED_PROC_MDR].val.pui4[0] +=  statMPHR->count_degraded_proc_mdr;
  // Obselete 
  /*if (statMPHR->count_degraded_proc_mdr > 0)
    {
      m_MPHR.listevar.tab_var[MPHR_COUNT_DEGRADED_PROC_MDR].val.pui4[0]
        = m_MPHR.listevar.tab_var[MPHR_COUNT_DEGRADED_PROC_MDR].val.
        pui4[0] + 1;
    }*/
  // ... DM-3150
  m_MPHR.listevar.tab_var[MPHR_COUNT_DEGRADED_INST_MDR_BLOCKS].val.
    pui4[0] += statMPHR->count_degraded_inst_mdr_blocks;
  m_MPHR.listevar.tab_var[MPHR_COUNT_DEGRADED_PROC_MDR_BLOCKS].val.
    pui4[0] += statMPHR->count_degraded_proc_mdr_blocks;

  //@ Mise a jour de m_MPHR avec statMPHR (infos subsat)
  //FA153 mise a jour pour la premiere ligne
// attention suite a discussion tel richard Moreno du 29 / 01 /05
// la solution retenue consiste a laisser l'information a l'initiative du CGS
// (product model) car des pb se posent :
// cas normal : il faut faire une "moyenne" entre SN 14 et 15
// cas calibration visee terre : il faut faire un calcul specifique
// si l'on souhaite revenir a un calcul "standard" SN = 15 , il faut enlever les 
// commentaires ci-desous

/* CR292 */
  // FT-2466
  if (SD_BAS_MacEGAUX_D(m_MPHR.listevar.tab_var[MPHR_SUBSAT_LATITUDE_START].val.pr8[0],0.0) 
  	&& (numeroLigne == 1))
  // ..FT-2466
  {

    m_MPHR.listevar.tab_var[MPHR_SUBSAT_LATITUDE_START].val.pr8[0] = 
      statMPHR->subsat_latitude_start;
    m_MPHR.listevar.tab_var[MPHR_SUBSAT_LONGITUDE_START].val.pr8[0] = 
      statMPHR->subsat_longitude_start;
  }
  // FT-2751
  if (SD_BAS_MacEGAUX_D(m_MPHR.listevar.tab_var[MPHR_SUBSAT_LATITUDE_END].val.pr8[0],0.0) 
  	&& (numeroLigne == -1))
  {
    m_MPHR.listevar.tab_var[MPHR_SUBSAT_LATITUDE_END].val.pr8[0] = 
      statMPHR->subsat_latitude_end;
    m_MPHR.listevar.tab_var[MPHR_SUBSAT_LONGITUDE_END].val.pr8[0] = 
      statMPHR->subsat_longitude_end;
  }
  // ...FT-2751


#ifdef OPS_DEBUG
  cout << endl << "MPHR_SUBSAT_LATITUDE_START = " << 
    m_MPHR.listevar.tab_var[MPHR_SUBSAT_LATITUDE_START].val.pr8[0] << endl;
  cout << endl << "MPHR_SUBSAT_LATITUDE_END = " << 
    m_MPHR.listevar.tab_var[MPHR_SUBSAT_LATITUDE_END].val.pr8[0] << endl;
  cout << endl << "MPHR_SUBSAT_LONGITUDE_START = " << 
    m_MPHR.listevar.tab_var[MPHR_SUBSAT_LONGITUDE_START].val.pr8[0] << endl;
  cout << endl << "MPHR_SUBSAT_LONGITUDE_END = " << 
    m_MPHR.listevar.tab_var[MPHR_SUBSAT_LONGITUDE_END].val.pr8[0] << endl;
#endif
/* FIN CR292 */
 
  //@ SELON la nature du granule
  switch (m_NatureGranule)
    {
      //@ SI donnees:
    case SD_DON_GRANULE_N1_DATA:

      //@ Initialisation du m_GIADRScaleFactor avec paramConfStable
      m_GIADRSCA.InfoDet.tab_var[GIADRSCA_DATEDEB].val.pdate->day = 
        tempsDebut.day;
      m_GIADRSCA.InfoDet.tab_var[GIADRSCA_DATEDEB].val.pdate->millis = 
        tempsDebut.millis;
      m_GIADRSCA.InfoDet.tab_var[GIADRSCA_DATEFIN].val.pdate->day = 
        tempsFin.day;
      m_GIADRSCA.InfoDet.tab_var[GIADRSCA_DATEFIN].val.pdate->millis = 
        tempsFin.millis;
      m_GIADRSCA.InfoDet.tab_var[GIADRSCA_IDEFSCALESONDNBSCALE].val.
        pi4[0] = paramConfStable->IDefScaleSondNbScale;
      

      // short int -> int
      for (int i=0; i<SD_BAS_TAILLE_NB_SI_B; i++)
        {
          m_GIADRSCA.InfoDet.tab_var[GIADRSCA_IDEFSCALESONDNSFIRST].
            val.pi4[i] = (int) paramConfStable->IDefScaleSondNsfirst[i];
          m_GIADRSCA.InfoDet.tab_var[GIADRSCA_IDEFSCALESONDNSLAST].
            val.pi4[i] = (int) paramConfStable->IDefScaleSondNslast[i];
          m_GIADRSCA.InfoDet.tab_var[GIADRSCA_IDEFSCALESONDSCALEFACTOR].
            val.pi4[i] = 
            (int) paramConfStable->IDefScaleSondScaleFactor[i];
        }

      m_GIADRSCA.InfoDet.tab_var[GIADRSCA_IDEFSCALEIISSSCALEFACTOR].val.
        pi4[0] = paramConfStable->IDefScaleIISScaleFactor;
// version 1.6 du conf autre

      m_GIADRSCA.InfoDet.tab_var[GIADRSCA_IDEFSCALESONDNBSCALE1A].val.
        pi4[0] = paramConfStable->IDefScaleSondNbScale1a;
      
      // short int -> int
      for (int i=0; i<SD_BAS_TAILLE_NB_SI_B; i++)
        {
          m_GIADRSCA.InfoDet.tab_var[GIADRSCA_IDEFSCALESONDNSFIRST1A].
            val.pi4[i] = (int) paramConfStable->IDefScaleSondNsfirst1a[i];
          m_GIADRSCA.InfoDet.tab_var[GIADRSCA_IDEFSCALESONDNSLAST1A].
            val.pi4[i] = (int) paramConfStable->IDefScaleSondNslast1a[i];
          m_GIADRSCA.InfoDet.tab_var[GIADRSCA_IDEFSCALESONDSCALEFACTOR1A].
            val.pi4[i] = 
            (int) paramConfStable->IDefScaleSondScaleFactor1a[i];
        }

      //@ Initialisation du m_GIADRN1Quality avec paramConfStable
      m_GIADRQUA.InfoDet.tab_var[GIADRQUA_DATEDEB].val.pdate->day = 
        tempsDebut.day;
      m_GIADRQUA.InfoDet.tab_var[GIADRQUA_DATEDEB].val.pdate->millis = 
        tempsDebut.millis;
      m_GIADRQUA.InfoDet.tab_var[GIADRQUA_DATEFIN].val.pdate->day = 
        tempsFin.day;
      m_GIADRQUA.InfoDet.tab_var[GIADRQUA_DATEFIN].val.pdate->millis = 
        tempsFin.millis;
      
      for (int i=0; i<SD_BAS_PN; i++)
        {
          m_GIADRQUA.InfoDet.tab_var[GIADRQUA_IDEFPSFSONDNBLIN].
            val.pi4[i] = paramConfStable->IDefPsfSondNbLin;
          m_GIADRQUA.InfoDet.tab_var[GIADRQUA_IDEFPSFSONDNBCOL].
            val.pi4[i] = paramConfStable->IDefPsfSondNbCol;
        }
      
      // int -> double
      m_GIADRQUA.InfoDet.tab_var[GIADRQUA_IDEFPSFSONDOVERSAMPFACTOR].
        val.pr8[0] = 
        (double) paramConfStable->IDefPsfSondOverSampFactor;
      
      memcpy(m_GIADRQUA.InfoDet.tab_var[GIADRQUA_IDEFPSFSONDY].val.pr8,
             paramConfStable->IDefPsfSondY,
             sizeof(double)*SD_BAS_NB_LIN_SOND*SD_BAS_PN);
// conversion en degres
      for (int i=0 ; i<SD_BAS_NB_LIN_SOND*SD_BAS_PN;i++)
       {
       m_GIADRQUA.InfoDet.tab_var[GIADRQUA_IDEFPSFSONDY].val.pr8[i] =
       m_GIADRQUA.InfoDet.tab_var[GIADRQUA_IDEFPSFSONDY].val.pr8[i]*180./M_PI;
       }
      memcpy(m_GIADRQUA.InfoDet.tab_var[GIADRQUA_IDEFPSFSONDZ].val.pr8,
             paramConfStable->IDefPsfSondZ,
             sizeof(double)*SD_BAS_NB_COL_SOND*SD_BAS_PN);
// conversion en degres
      for (int i=0 ; i<SD_BAS_NB_COL_SOND*SD_BAS_PN;i++)
       {
       m_GIADRQUA.InfoDet.tab_var[GIADRQUA_IDEFPSFSONDZ].val.pr8[i] =
       m_GIADRQUA.InfoDet.tab_var[GIADRQUA_IDEFPSFSONDZ].val.pr8[i]*180./M_PI;
       }
      memcpy(m_GIADRQUA.InfoDet.tab_var[GIADRQUA_IDEFPSFSONDWGT].val.
             pr8,
             paramConfStable->IDefPsfSondWgt,
             sizeof(double)*SD_BAS_NB_COL_SOND*SD_BAS_NB_LIN_SOND*
             SD_BAS_PN);
      
      m_GIADRQUA.InfoDet.tab_var[GIADRQUA_IDEFIISSRFNSFIRST].val.pi4[0]
        = paramConfStable->IDefIISSrfNsfirst;
      m_GIADRQUA.InfoDet.tab_var[GIADRQUA_IDEFIISSRFNSLAST].val.pi4[0] 
        = paramConfStable->IDefIISSrfNslast;

      memcpy(m_GIADRQUA.InfoDet.tab_var[GIADRQUA_IDEFIISSRF].val.pr8,
             paramConfStable->IDefIISSrf,
             sizeof(double)*SD_BAS_NB_COL_SOND);
      
      m_GIADRQUA.InfoDet.tab_var[GIADRQUA_IDEFIISSRFDWN].val.pr8[0] = 
        paramConfStable->IDefIISSrfDWn;
      
      memcpy(m_GIADRQUA.InfoDet.tab_var[GIADRQUA_IDEFIISNEDT].val.pr8,
             paramConfStable->IDefIISNeDT,
             sizeof(double)*SD_BAS_IMCO*SD_BAS_IMLI);
      memcpy(m_GIADRQUA.InfoDet.tab_var[GIADRQUA_IDEFDPTIISDEADPIX].val.
             pui4,
             paramConfStable->IDefDptIISDeadPix,
             sizeof(unsigned int)*SD_BAS_IMCO*SD_BAS_IMLI);

      break;
      
      //@ SI ENG:
    case SD_DON_GRANULE_N1_ENG:

      //@ Initialisation du m_GIADRENG avec OBTUTC
      m_GIADRENG.InfoDet.tab_var[GIADRENG_DATEDEB].val.pdate->day = 
        tempsDebut.day;
      m_GIADRENG.InfoDet.tab_var[GIADRENG_DATEDEB].val.pdate->millis = 
        tempsDebut.millis;
      m_GIADRENG.InfoDet.tab_var[GIADRENG_DATEFIN].val.pdate->day = 
        tempsFin.day;
      m_GIADRENG.InfoDet.tab_var[GIADRENG_DATEFIN].val.pdate->millis = 
        tempsFin.millis;
      m_GIADRENG.InfoDet.tab_var[GIADRENG_GEPSDATPROCESSING].val.pdate->
        day = m_MPHR.listevar.tab_var[MPHR_PROCESSING_TIME_START].val.
        pdate->day;
      m_GIADRENG.InfoDet.tab_var[GIADRENG_GEPSDATPROCESSING].val.pdate->
        millis = m_MPHR.listevar.tab_var[MPHR_PROCESSING_TIME_START].
        val.pdate->millis;
      
      /* FA136 */
      if (OBTUTC.GetCharge() == CMN__VRAI)
      {
        t_LCDSTime tempsUTCLEAPSECOND = OBTUTC.GetDateUTCLEAPSECOND().LCDSTime();
        t_LCDSTime tempsUTC           = OBTUTC.GetDateUTCREF().LCDSTime();
        
        m_GIADRENG.InfoDet.tab_var[GIADRENG_GEPSUTCLEAPSECOND].val.pi4[0] 
          = (int) tempsUTCLEAPSECOND.day;
        m_GIADRENG.InfoDet.tab_var[GIADRENG_GEPSUTCLEAPSECOND].val.pi4[1] 
          = (int) tempsUTCLEAPSECOND.millis;
        m_GIADRENG.InfoDet.tab_var[GIADRENG_GEPSUTCLEAPSECOND].val.pi4[2] 
          = (int) tempsUTCLEAPSECOND.micros;
//CR277 GEPSCCUOBTCORREL est stocke non signe
        m_GIADRENG.InfoDet.tab_var[GIADRENG_GEPSCCUOBTCORREL].val.pui4[0]
          = (unsigned int) OBTUTC.GetDateOBTREF();
      
        m_GIADRENG.InfoDet.tab_var[GIADRENG_GEPSUTCCORREL].val.pi4[0] 
          = (int) tempsUTC.day;
        m_GIADRENG.InfoDet.tab_var[GIADRENG_GEPSUTCCORREL].val.pi4[1] 
          = (int) tempsUTC.millis;
        m_GIADRENG.InfoDet.tab_var[GIADRENG_GEPSUTCCORREL].val.pi4[2] 
          = (int) tempsUTC.micros;
          
        m_GIADRENG.InfoDet.tab_var[GIADRENG_GEPSASTEPCORREL].val.pr8[0] 
          = OBTUTC.GetAStep();
        m_GIADRENG.InfoDet.tab_var[GIADRENG_GEPSBSTEPCORREL].val.pr8[0] 
          = OBTUTC.GetBOffset();
      }
      /* FIN FA136 */
      
      break;
      
      //@ SI VER:
    case SD_DON_GRANULE_N1_VER:
      //@ Rien a faire
      break;
      
      //@ Defaut:
    default:
      //@ Rien a faire
      break;
    }
  //@ FIN SELON la nature du granule
}


//@ ------------------------------------------------------------------*/
//@ Methode : Ecrire
//@
//@ Description : Ecrit physiquement le contenu du granule de niveau 1
//@               (MPHR + GIADR + VIADR + MDR)
//@
//@ Parametres :
//@               (ENTREE) IdCA : Identifiant fichier de conf autre
//@               (SORTIE) listeFichier : Liste des fichiers ecrits
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::Ecrire(const int idCA,
                              t_ListeChaine& listeFichier)
{
  // Acces au produit (ECRITURE par defaut)
  e_BAS_TypeAcces typeAccesOuverture = ECRITURE;
  e_BAS_TypeAcces typeAccesFermeture = ECRITURE;

  // Nombre de produits a generer
  int             nbProduit          = 0;

  // Nature des produits a generer
  e_BAS_Nature    natureProduit[NB_MAX_PRODUIT];


  //@ Identifier les produits a generer
  IdentifierProduit(nbProduit, natureProduit);

  //@ Dans le cas du mode dump, on travaille en mode append
  //@ SI mode DUMP
  if (m_ModeTraitement == DUMP)
  {
    //@ SI premiere ouverture
    if (m_PositionTraitement == FIRST)
    {
      typeAccesOuverture = APPEND_INIT;
      typeAccesFermeture = APPEND;
    }
    else 
    {
      //@ SINON SI derniere ouverture
      if (m_PositionTraitement == LAST)
      {
        typeAccesOuverture = APPEND;
        typeAccesFermeture = APPEND_CLOSE;
      }
      //@ SINON
      else
      {
        typeAccesOuverture = APPEND;
        typeAccesFermeture = APPEND;
      }
    }
    //@ FIN SI premiere ouverture
  }
  //@ FIN SI mode DUMP
  
  //@ POUR chaque produit a generer
  for (int i=0; i<nbProduit; i++)
    {
      //@ Ecrire le produit
      EcrireProduit(idCA,
                    typeAccesOuverture,
                    typeAccesFermeture,
                    natureProduit[i],
                    listeFichier);
    }
  //@ FIN POUR chaque produit a generer  
}


//@ ------------------------------------------------------------------*/
//@ Methode : EncodeDecodeDataLigne
//@
//@ Description : Decode les donnees detaillees contenues dans une
//@               ligne
//@
//@ Parametres :
//@               (ENTREE) ligne : Ligne issue de l'appel a 
//@                                GetDataLigne
//@               (ENTREE) niveau : Info a traiter (IMAGE/1A/1B/1C)
//@               (ENTREE) paramDecodage : Parametres de decodage
//@               (ENTREE) sens : Sens decodage/encodage
//@               (ENTREE/SORTIE) data : Donnees decodees
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::EncodeDecodeDataLigne(const t_SD_BAS_ORIGINE 
                                             numLignesNPN,
                                             t_SD_BAS_LigneN1* ligne,
                                             const e_SD_BAS_Atraiter 
                                             niveau, 
                                             t_SD_BAS_ConfStable* 
                                             paramDecodage,
                                             const e_SD_BAS_Sens sens,
                                             double* data)
{
  // Objet ligne de niveau 1
  SD_DON_LigneN1 ligneN1;


  //@ Mise a jour des donnees de l'objet ligne de niveau 1
  ligneN1.SetData(*ligne);

  //@ Decodage encodage de la ligne via la methode
  //@ SD_DON_LigneN1::DecodeEncode()
  ligneN1.DecodeEncode(numLignesNPN, niveau, paramDecodage, sens, data);
}


//@ ------------------------------------------------------------------*/
//@ Methode : Afficher
//@
//@ Description : Afficher les infos generales d'une la ligne
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::Afficher()
{
  cout << "------------------------------------------------------------"
       << endl;
  cout << "--------------------- Infos Granule N1 ---------------------"
       << endl;
  SD_DON_Granule::Afficher();

  cout << "Nb ligne absolu       : " << m_NbLigneAbsolu << endl;
  cout << "NatureGranule         : " << m_NatureGranule
       << " (0:DATA 1:ENG 2:VER)" << endl;
  cout << "ModeTraitement        : " << m_ModeTraitement
       << " (0:GRANULE 1:DUMP)" << endl;
  cout << "PositionTraitement    : " << m_PositionTraitement
       << " (1:FIRST 2:MIDDLE 3:LAST)" << endl;
  cout << "TypeAcces             : " << m_TypeAcces
       << " (0:READ 1:WRITE 2,3,4:APPEND)" << endl;
  cout << "TypeProduit (sf READ) : " << m_TypeProduit
       << " (0:1C 1:1A1B 2:1A1B1C 3:VER 4:ENG)" << endl;
  cout << "Nb lignes MDR         : " << m_ListeLigneMDR.size() << endl;
  cout << "Nb lignes VIADR       : " << m_ListeLigneVIADR.size() << endl;
  cout << endl;
  cout << "------------------------------------------------------------"
       << endl << endl;
}


//======================================================================
//                                      METHODES PRIVEES 
//======================================================================

//@ ------------------------------------------------------------------*/
//@ Methode : GetDataLigneMDR
//@
//@ Description : Recupere les donnees detaillees contenues dans une
//@               ligne MDR
//@
//@ Parametres :
//@               (ENTREE) numLigne : Numero de la ligne MDR demandee
//@               (SORTIE) ligneMDR : Ligne MDR retournee
//@                     (allouee par l'appelant)
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::GetDataLigneMDR(const int numLigne,
                                         t_SD_BAS_LigneN1& ligneMDR)
{
  //@ Recuperation de la ligne MDR
  SD_DON_LigneN1 ligneN1 = GetLigneMDR(numLigne);
  
  //@ Recuperation des donnees MDR
  ligneN1.GetData(ligneMDR);
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetDataLigneVIADR
//@
//@ Description : Recupere les donnees detaillees contenues dans une
//@               ligne VIADR
//@
//@ Parametres :
//@               (ENTREE) numLigne : Numero de la ligne VIADR demandee
//@               (SORTIE) ligneVIADR : Ligne VIADR retournee
//@                     (allouee par l'appelant)
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::GetDataLigneVIADR(const int numLigne,
                                         t_SD_BAS_LigneN1& ligneVIADR)
{
  //@ Recuperation de la ligne VIADR
  SD_DON_LigneN1 ligneN1 = GetLigneVIADR(numLigne);
  
  //@ Recuperation des donnees VIADR
  ligneN1.GetData(ligneVIADR);
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetDataGIADR
//@
//@ Description : Recupere les donnees detaillees contenues dans un
//@               GIADR
//@
//@ Parametres :
//@               (ENTREE) typeRecord : Type du GIADR
//@               (SORTIE) dataGIADR : Donnees du GIADR
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::GetDataGIADR(const e_BAS_TypeRecN1 typeRecord,
                                    t_SD_BAS_LigneN1& dataGIADR)
{
  //@ SI le type demande est GIADR ScaleFactor
  if (typeRecord == GIADR_SCA)
    {
      dataGIADR = m_GIADRSCA;
    }
  //@ SINON SI le type demande est GIADR Quality
  else if (typeRecord == GIADR_QUA)
    {
      dataGIADR = m_GIADRQUA;
    }
  //@ SINON SI le type demande est GIADR Eng
  else if (typeRecord == GIADR_ENG)
    {
      dataGIADR = m_GIADRENG;
    }
  //@ FIN SI le type demande est GIADR ScaleFactor
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetLigneMDR
//@
//@ Description : Recupere une ligne MDR du granule
//@
//@ Parametres :
//@               (ENTREE) numLigne : Numero de la ligne MDR demandee
//@
//@ Valeur de retour : 
//@               Ligne MDR demandee
//@
//@ ------------------------------------------------------------------*/
SD_DON_LigneN1& SD_DON_GranuleN1::GetLigneMDR(const int numLigne) 
  throw (ERR__Exception)
{
  // Exception generee
  ERR__Exception           exception;

  // Iterateur pour la liste des lignes
  t_ListeLigneN1::iterator pInfo;

  // Temoin de recherche
  t_CMN__Booleen           trouve         = CMN__FAUX;


  //@ Verification de coherence du numero de la ligne: il doit 
  //@ etre compris dans l'ensemble [0, m_NbLigne-1]

  //@ SI le numero de la ligne n'est pas coherent
  if ( (numLigne < 0) || (numLigne > (m_NbLigne-1)) )
    {
      //@ Emission d'une exception SD_DON_OPER_FAILED
      exception.SetErrorCode(ERR__Exception::SD_DON_OPER_FAILED);
      THROW(exception);
    }
  //@ FIN SI le numero de la ligne n'est pas coherent


  //@ Recherche de la ligne souhaitee
  pInfo = m_ListeLigneMDR.begin();

  //@ TANT QUE il existe des lignes ET QUE la ligne
  //@ souhaitee n'a pas ete trouvee
  while (pInfo != m_ListeLigneMDR.end() && (trouve == CMN__FAUX))
    {
      //@ SI le numero de la ligne correspond a celui de la
      //@ ligne souhaitee
      if (pInfo->GetNumLigne() == numLigne)
        {
          //@ La ligne a ete trouvee
          //@ Mettre a jour le temoin de recherche
          trouve = CMN__VRAI;
        }
      //@ SINON ce n'est pas la ligne souhaitee
      else
        {
          //@ Passer a la ligne suivante
          pInfo++;
        }
      //@ FIN SI
    }
  //@ FIN TANT QUE
  
  //@ SI la ligne n'a pas ete trouvee
  if (trouve != CMN__VRAI)
    {
      //@ Emission d'une exception SD_DON_OPER_FAILED
      exception.SetErrorCode(ERR__Exception::SD_DON_OPER_FAILED);
      THROW(exception);
    }         
  //@ FIN SI la ligne n'a pas ete trouvee

  
  //@ On retourne la ligne trouvee
  return *pInfo;
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetLigneVIADR
//@
//@ Description : Recupere une ligne VIADR du granule
//@
//@ Parametres :
//@               (ENTREE) numLigne : Numero de la ligne VIADR demandee
//@
//@ Valeur de retour : 
//@               Ligne VIADR demandee
//@
//@ ------------------------------------------------------------------*/
SD_DON_LigneN1& SD_DON_GranuleN1::GetLigneVIADR(const int numLigne) 
  throw (ERR__Exception)
{
  // Exception generee
  ERR__Exception           exception;

  // Iterateur pour la liste des lignes
  t_ListeLigneN1::iterator pInfo;

  // Temoin de recherche
  t_CMN__Booleen           trouve         = CMN__FAUX;


  //@ Verification de coherence du numero de la ligne: il doit 
  //@ etre compris dans l'ensemble [0, m_NbLigne-1]

  //@ SI le numero de la ligne n'est pas coherent
  if ( (numLigne < 0) || (numLigne > (m_NbLigne-1)) )
    {
      //@ Emission d'une exception SD_DON_OPER_FAILED
      exception.SetErrorCode(ERR__Exception::SD_DON_OPER_FAILED);
      THROW(exception);
    }
  //@ FIN SI le numero de la ligne n'est pas coherent


  //@ Recherche de la ligne souhaitee
  pInfo = m_ListeLigneVIADR.begin();

  //@ TANT QUE il existe des lignes ET QUE la ligne
  //@ souhaitee n'a pas ete trouvee
  while (pInfo != m_ListeLigneVIADR.end() && (trouve == CMN__FAUX))
    {
      //@ SI le numero de la ligne correspond a celui de la
      //@ ligne souhaitee
      if (pInfo->GetNumLigne() == numLigne)
        {
          //@ La ligne a ete trouvee
          //@ Mettre a jour le temoin de recherche
          trouve = CMN__VRAI;
        }
      //@ SINON ce n'est pas la ligne souhaitee
      else
        {
          //@ Passer a la ligne suivante
          pInfo++;
        }
      //@ FIN SI
    }
  //@ FIN TANT QUE
  
  //@ SI la ligne n'a pas ete trouvee
  if (trouve != CMN__VRAI)
    {
      //@ Emission d'une exception SD_DON_OPER_FAILED
      exception.SetErrorCode(ERR__Exception::SD_DON_OPER_FAILED);
      THROW(exception);
    }         
  //@ FIN SI la ligne n'a pas ete trouvee

  
  //@ On retourne la ligne trouvee
  return *pInfo;
}


//@ ------------------------------------------------------------------*/
//@ Methode : GestionOverlap
//@
//@ Description : Determine les dates de debut et fin des lignes
//@               utilisees dans le traitement de niveau 1. On prend
//@               en compte ici le cas des dumps qui se traduit par
//@               le choix de dates t0 et t1 inclues dans le produit
//@
//@ Parametres :
//@               (ENTREE) t0 : Date de debut issue du Work Order
//@               (ENTREE) t1 : Date de fin issue du Work Order
//@               (ENTREE/SORTIE) ficDesc : Descripteur de fichier
//@               (ENTREE/SORTIE) ctx : Donnees de contexte
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::GestionOverlap(const t_Date& t0,
                                      const t_Date& t1,
                                      t_SD_BAS_Fd& ficDesc,
                                      t_SD_BAS_DataThread* ctx)
{
  // Donnees generales
  t_SD_BAS_Liste_Var donneesGenerales;

  // Indice de parcours
  int                iMDR   = 0;

  // Code retour des fonctions utilisees 
  t_CMN__Statut      statut = CMN__STATUT_OK;

  
  //@ Lecture de toutes les lignes du produit (DUMP ou GRANULE)

  //@ Mise a jour du contexte d'appel: INIT

  //@ TANT QUE il existe des MDR
  while (iMDR < ficDesc.nombreMDR)
    {
      //@ Lire le premier ISP en ne decodant que le type, la date UTC,
      //@ le mode et le type de record (MDR) (SD_BAS_Niveau1)
      //@ On ne stocke pas ici la donnee elle meme
      
      //@ Appel de la fonction de lecture des donnees generales 
      //@ d'un MDR
      statut = SD_BAS_LireMDRGenN1(CTX_NORMAL,
                                   ficDesc.offsetMDRSuivant,
                                   &ficDesc,
                                   &donneesGenerales,
                                   ctx);

#ifdef OPS_DEBUG
      cout << "LireMDRGenN1 MDR# " << iMDR+1 << " - statut: " 
           << statut << endl;
#endif

      //@ SI la lecture du MDR a genere une erreur
      if (statut != CMN__STATUT_OK)
        {

#ifdef OPS_DEBUG
          cerr << "SD_DON_GranuleN1::GestionOverlap: "
               << "erreur LireMDRGenN1 " << m_NomGranule << 
               " (" << statut << ")" << endl;
#endif
          
          //@ Envoi des messages generes au JDB
          EnvoyerMessagesStockes(&(ctx->cr.msgJDB));
          InitialiserListeErreurs(&(ctx->cr.errinterne));

          //@ Referencer le trou de donnees
          m_NbDataGap++;
        }
      //@ SINON 
      else
        {

#ifdef DEBUG
          cout << "Offset MDR    : " << ficDesc.offsetMDR << endl;
          cout << "Offset suivant: " << ficDesc.offsetMDRSuivant 
               << endl;
          cout << "Date debut    : " 
               << donneesGenerales.tab_var[N1_DATEDEB].val.pdate->day 
               << " - " 
               << donneesGenerales.tab_var[N1_DATEDEB].val.pdate->millis
               << endl;
          cout << "Date fin      : " 
               << donneesGenerales.tab_var[N1_DATEFIN].val.pdate->day 
               << " - " 
               << donneesGenerales.tab_var[N1_DATEFIN].val.pdate->millis
               << endl;
          cout << "Mode          : " 
               << donneesGenerales.tab_var[N1_MODE].val.pui4[0] 
               << endl;
          cout << "PTSI          : " 
               << donneesGenerales.tab_var[N1_PTSI].val.pui4[0] 
               << endl;
          cout << "GEPSDATIASI   : " 
               << donneesGenerales.tab_var[N1_GEPSDATIASI].val.pdate->
            day 
               << " - " 
               << donneesGenerales.tab_var[N1_GEPSDATIASI].val.pdate->
            millis 
               << endl;
          cout << "Type rec      : " 
               << donneesGenerales.tab_var[N1_TYPEREC].val.pui4[0] 
               << endl;
          cout << "Longueur rec  : "
               << donneesGenerales.tab_var[N1_LONGUEURREC].val.pui4[0]
               << endl;
          cout << "Offset        : " 
               << donneesGenerales.tab_var[N1_OFFSET].val.pui4[0] 
               << endl;
          cout << "Validite rec  : " 
               << donneesGenerales.tab_var[N1_VALIDREC].val.pui4[0] 
               << endl;
          cout << "Flag          : " 
               << donneesGenerales.tab_var[N1_FLAG].val.pui4[0] 
               << endl;
#endif

          // Nouvelle ligne
          t_InfoGenLigne nouvelleLigne;
          
          // Donnees generales recuperees
          t_SCDSTime     tDebutSCDS;
          t_SCDSTime     tFinSCDS;
          t_Date         dateMDR;
          e_BAS_ModePdv  mode       = (e_BAS_ModePdv)
            donneesGenerales.tab_var[N1_MODE].val.pui4[0];
          unsigned int   valeurPTSI = 
            donneesGenerales.tab_var[N1_PTSI].val.pui4[0];
                  
          unsigned int   offset     = 
            donneesGenerales.tab_var[N1_OFFSET].val.pui4[0];
          e_BAS_ValidRec validite   = (e_BAS_ValidRec)
            donneesGenerales.tab_var[N1_VALIDREC].val.pui4[0];

          tDebutSCDS.day    = donneesGenerales.tab_var[N1_DATEDEB].val.
            pdate->day;
          tDebutSCDS.millis = donneesGenerales.tab_var[N1_DATEDEB].val.
            pdate->millis;
          tFinSCDS.day      = donneesGenerales.tab_var[N1_DATEFIN].val.
            pdate->day;
          tFinSCDS.millis   = donneesGenerales.tab_var[N1_DATEFIN].val.
            pdate->millis;
      
          //@ Creer un nouveau element descripteur de ligne
          //@ Initialiser dateDebut, dateFin, mode, PTSI, 
          //@ offset et validite
          dateMDR.SCDSTime(tDebutSCDS);

          nouvelleLigne.SetDateDebut(dateMDR);

          dateMDR.SCDSTime(tFinSCDS);

          nouvelleLigne.SetDateFin(dateMDR);
          
          nouvelleLigne.SetModePriseDeVue(mode);
          nouvelleLigne.SetPTSI(valeurPTSI);
          
          nouvelleLigne.SetOffset(offset);
          nouvelleLigne.SetValidite(validite);

          //@ Mettre a jour le numero du MDR
          nouvelleLigne.SetNumMDRDebut(iMDR);
          nouvelleLigne.SetNumMDRFin(iMDR);
       
          //@ Ajouter l'element dans le tableau des 
          //@ descripteurs de lignes
          m_ListeInfoGenLigne.push_back(nouvelleLigne);

          //@ Liberation memoire des donnees generales
          //@ via la fonction SD_BAS_LibereListeVar()
          SD_BAS_LibereListeVar(LECTURE, &donneesGenerales);
         }
      //@ FIN SI la lecture du MDR a genere une erreur
         
      iMDR++;
    }
  //@ FIN TANT QUE il existe des MDR

  //@ SI aucune ligne n'a ete identifiee
  if (m_ListeInfoGenLigne.size() == 0)
    {
      // Exception generee
      ERR__Exception exception;
         

#ifdef OPS_DEBUG
      cerr << "SD_DON_GranuleN1::GestionOverlap: "
           << "aucune ligne n'a ete identifiee pour " 
           << m_NomGranule << endl;
#endif

      //@ Le nombre de lignes est egal a 0 
      m_NbLigne = 0;

      //@ Emission d'une exception SD_DON_FILE_READ
      exception.SetErrorCode(ERR__Exception::SD_DON_FILE_READ);
      exception.SetParametre(NO_LINE_IN_PRODUCT+m_NomGranule);
      THROW(exception);
    }
  //@ FIN SI aucune ligne n'a ete identifiee
 
  //@ Determiner les bornes du granule
  DeterminerBornes(t0, t1);
}


//@ ------------------------------------------------------------------*/
//@ Methode : DeterminerBornes
//@
//@ Description : Determine les dates de debut et fin des lignes
//@               utilisees dans le traitement de niveau 1
//@
//@ Parametres :
//@               (ENTREE) t0 : Date de debut issue du Work Order
//@               (ENTREE) t1 : Date de fin issue du Work Order
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::DeterminerBornes(const t_Date& t0,
                                        const t_Date& t1)
{
  // Indicateur d'initialisation d'overlap
  t_CMN__Booleen bInit = CMN__FAUX;


#ifdef OPS_DEBUG
  // Affichage liste des descripteurs de lignes
  cout << endl 
       << "--------------------------------------------------" << endl;
  cout << "- Affichage liste des infos generales des lignes -" << endl;
  cout << "- Nombre de lignes: " << m_ListeInfoGenLigne.size() 
       << endl;
  for (int i=0; i<m_ListeInfoGenLigne.size(); i++)
    {
      cout << "Element: " << i+1 << endl;
      m_ListeInfoGenLigne[i].Afficher();
    }
  cout << "--------------------------------------------------" << endl;
#endif

  m_IndiceDebut = -1;

  //@ POUR toutes les lignes du tableau precedent (on commence a
  //@ m_NbLigneAbsolu)

  //@ POUR toutes les lignes du tableau precedent
  for (int i = 0 ; i < m_ListeInfoGenLigne.size() ; i++)
    {
      if ( (m_ListeInfoGenLigne[i].GetDateDebut() <= t0) &&
           (bInit == CMN__FAUX) )
        {
          //@ m_TP0         = dateDebut
          m_TP0         = m_ListeInfoGenLigne[i].GetDateDebut();
          
          //@ m_IndiceDebut = numLigne
          m_IndiceDebut = i;
        }
      //@ SINON
      else
        {
          //@ bInit = VRAI
          bInit = CMN__VRAI;
        }
      //@ FIN SI dateDebut <= t0 et bInit = faux

      //@ SI dateFin <= t1 
      if (m_ListeInfoGenLigne[i].GetDateFin() <= t1)
        {
          //@ m_TP1       = dateFin
          m_TP1       = m_ListeInfoGenLigne[i].GetDateFin();
          
          //@ m_IndiceFin = numLigne
          m_IndiceFin = i;
        }
      //@ FIN SI dateFin <= t1 
    }
  //@ FIN POUR toutes les lignes du tableau precedent

  //@ SI m_IndiceDebut = -1
  if ( (m_IndiceDebut == -1) && (m_ListeInfoGenLigne.size() > 0) )
    {
      //@ m_TP0 = dateDebut[0]
      m_TP0 = m_ListeInfoGenLigne[0].GetDateDebut();
      
      //@ m_IndiceDebut = 0
      m_IndiceDebut = 0;
      
      //@ Emission d'un message de type JDB MSG_DATA_START_DATE_INFO
      JDB__Client messageJDB;
      messageJDB.SetParametre(JDB_PARAM_1, m_TP0.Chaine());
      messageJDB.SetParametre(JDB_PARAM_2, t_Date(t0).Chaine());
      messageJDB.EcrireMessage(SD_DATA_SET, 
                               SD__Message::MSG_DATA_START_DATE_INFO);
      messageJDB.Liberer();
    }
  //@ FIN SI m_IndiceDebut = -1

  //@ m_NbLigne = m_IndiceFin - m_IndiceDebut + 1
  m_NbLigne = m_IndiceFin - m_IndiceDebut + 1;
}


//@ ------------------------------------------------------------------*/
//@ Methode : LireProductModel
//@
//@ Description : Lit le MPHR d'un product model
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::LireProductModel(const t_Chaine& nomModele,t_SD_BAS_MPHR& mphr) 
  throw (ERR__Exception)
{
  // Donnees de contexte
  t_SD_BAS_DataThread* ctx            = NULL;

  // Descripteur de fichier
  t_SD_BAS_Fd          ficDesc;

  // Nom de fichier
  t_SD_BAS_NomProduit  nomFichier;

  // Code retour des fonctions utilisees
  t_CMN__Statut        statut         = CMN__STATUT_OK;
  
#ifdef OPS_DEBUG
  // Nom de la methode
  static const char    tcProcName_F[] = 
    "SD_DON_GranuleN1::LireProductModel";
#endif


  //@ En captant les exceptions  
  try
    {
      //@ Allocation memoire pour les donnees de contexte
      ctx = new t_SD_BAS_DataThread;
      InitialiserCompteRendu(&(ctx->cr));

      //@ Ouverture du product model
      strcpy(nomFichier, nomModele.c_str());
/* FA 162 */
      statut = SD_BAS_OuvrirProduit(LECTURE, 
                                    NA_PRODMODEL,
                                    nomFichier, 
                                    &ficDesc, 
                                    ctx,
				    m_ModeTraitement);
/* ..FA 162 */
      //@ SI l'ouverture du product model a genere une erreur
      if (statut != CMN__STATUT_OK)
        {

#ifdef OPS_DEBUG
          cerr << tcProcName_F << ": Erreur OuvrirProduit: " << 
            nomModele << " (" << statut << ")" << endl;
#endif
          
          //@ Traiter l'erreur en provenance des couches basses
          TraiterErreurBAS(ctx, 
                           ERR__Exception::SD_DON_FILE_OPEN, 
                           nomModele);
        }
      //@ FIN SI l'ouverture du product model a genere une erreur
      

#ifdef OPS_DEBUG
      cout << tcProcName_F << ": OuvrirProduit: " << 
        nomModele << "(" << statut << ")" << endl;
#endif
     
     
      //@ Lecture et initialisation du MPHR du granule
      //@ a partir du fichier product model via la
      //@ methode SD_BAS_Niveau1::LireMPHR(modele)
      statut = SD_BAS_LireMPHR(&ficDesc, &m_MPHR, ctx);

      //@ SI la lecture du MPHR a genere une erreur
      if (statut != CMN__STATUT_OK)
        {

#ifdef OPS_DEBUG
          cerr << tcProcName_F << ": Erreur LireMPHR: " << 
            nomModele << " (" << statut << ")" << endl;
#endif
          
          //@ Fermeture du fichier product model en lecture
/* FA 162 */
          SD_BAS_FermerProduit(LECTURE, &ficDesc, ctx,m_ModeTraitement);
/* ..FA 162 */
          //@ Traiter l'erreur en provenance des couches basses
          TraiterErreurBAS(ctx, 
                           ERR__Exception::SD_DON_FILE_READ, 
                           nomModele);
        }
      //@ FIN SI la lecture du MPHR a genere une erreur

      //@ Fermeture du fichier product model en lecture
/* FA 162 */
       SD_BAS_FermerProduit(LECTURE, &ficDesc, ctx,m_ModeTraitement);
/* ..FA 162 */
 
      
#ifdef OPS_DEBUG
      cout << tcProcName_F << ": LireMPHR: " << 
        nomModele << "(" << statut << ")" << endl;
      
      // Affichage MPHR
      AfficherMPHR(CMN__VRAI);
      
      cout << "1er offset MDR: " << ficDesc.offsetMDR << endl;
      cout << "Offset suivant: " << ficDesc.offsetMDRSuivant << endl;
#endif

      //@ Liberation memoire pour les donnees de contexte
      LibererCompteRendu(&(ctx->cr.msgJDB));
      delete ctx;
      // initialisation du MPHR a partir de champs issu du MPHR du produit en entree
      (m_MPHR.listevar.tab_var[MPHR_STATE_VECTOR_TIME].val.pgentime)->year =    
        (mphr.listevar.tab_var[MPHR_STATE_VECTOR_TIME].val.pgentime)->year; 
      (m_MPHR.listevar.tab_var[MPHR_STATE_VECTOR_TIME].val.pgentime)->month =    
        (mphr.listevar.tab_var[MPHR_STATE_VECTOR_TIME].val.pgentime)->month; 
      (m_MPHR.listevar.tab_var[MPHR_STATE_VECTOR_TIME].val.pgentime)->day =    
        (mphr.listevar.tab_var[MPHR_STATE_VECTOR_TIME].val.pgentime)->day; 
      (m_MPHR.listevar.tab_var[MPHR_STATE_VECTOR_TIME].val.pgentime)->hour =    
        (mphr.listevar.tab_var[MPHR_STATE_VECTOR_TIME].val.pgentime)->hour; 
      (m_MPHR.listevar.tab_var[MPHR_STATE_VECTOR_TIME].val.pgentime)->min =    
        (mphr.listevar.tab_var[MPHR_STATE_VECTOR_TIME].val.pgentime)->min; 
      (m_MPHR.listevar.tab_var[MPHR_STATE_VECTOR_TIME].val.pgentime)->sec =    
        (mphr.listevar.tab_var[MPHR_STATE_VECTOR_TIME].val.pgentime)->sec; 
      (m_MPHR.listevar.tab_var[MPHR_STATE_VECTOR_TIME].val.pgentime)->millis =    
        (mphr.listevar.tab_var[MPHR_STATE_VECTOR_TIME].val.pgentime)->millis; 
     *(m_MPHR.listevar.tab_var[MPHR_SEMI_MAJOR_AXIS].val.pi4) =    
        *(mphr.listevar.tab_var[MPHR_SEMI_MAJOR_AXIS].val.pi4); 
     *(m_MPHR.listevar.tab_var[MPHR_ECCENTRICITY].val.pui4) =    
        *(mphr.listevar.tab_var[MPHR_ECCENTRICITY].val.pui4); 
     *(m_MPHR.listevar.tab_var[MPHR_INCLINATION].val.pr8) =    
        *(mphr.listevar.tab_var[MPHR_INCLINATION].val.pr8); 
     *(m_MPHR.listevar.tab_var[MPHR_PERIGEE_ARGUMENT].val.pr8) =    
        *(mphr.listevar.tab_var[MPHR_PERIGEE_ARGUMENT].val.pr8); 
     *(m_MPHR.listevar.tab_var[MPHR_RIGHT_ASCENSION].val.pr8) =    
        *(mphr.listevar.tab_var[MPHR_RIGHT_ASCENSION].val.pr8); 
     *(m_MPHR.listevar.tab_var[MPHR_MEAN_ANOMALY].val.pr8) =    
        *(mphr.listevar.tab_var[MPHR_MEAN_ANOMALY].val.pr8); 
     *(m_MPHR.listevar.tab_var[MPHR_X_POSITION].val.pr8) =    
        *(mphr.listevar.tab_var[MPHR_X_POSITION].val.pr8); 
     *(m_MPHR.listevar.tab_var[MPHR_Y_POSITION].val.pr8) =    
        *(mphr.listevar.tab_var[MPHR_Y_POSITION].val.pr8); 
     *(m_MPHR.listevar.tab_var[MPHR_Z_POSITION].val.pr8) =    
        *(mphr.listevar.tab_var[MPHR_Z_POSITION].val.pr8); 
     *(m_MPHR.listevar.tab_var[MPHR_X_VELOCITY].val.pr8) =    
        *(mphr.listevar.tab_var[MPHR_X_VELOCITY].val.pr8); 
     *(m_MPHR.listevar.tab_var[MPHR_Y_VELOCITY].val.pr8) =    
        *(mphr.listevar.tab_var[MPHR_Y_VELOCITY].val.pr8); 
     *(m_MPHR.listevar.tab_var[MPHR_Z_VELOCITY].val.pr8) =    
        *(mphr.listevar.tab_var[MPHR_Z_VELOCITY].val.pr8); 
/* FA 180 */
     *(m_MPHR.listevar.tab_var[MPHR_ORBIT_START].val.pui4) =    
        *(mphr.listevar.tab_var[MPHR_ORBIT_START].val.pui4); 
     *(m_MPHR.listevar.tab_var[MPHR_ORBIT_END].val.pui4) =    
        *(mphr.listevar.tab_var[MPHR_ORBIT_END].val.pui4); 
	
     strcpy(m_MPHR.listevar.tab_var[MPHR_RECEIVING_GROUND_STATION].val.s,   
        mphr.listevar.tab_var[MPHR_RECEIVING_GROUND_STATION].val.s ); 
	
     strcpy(m_MPHR.listevar.tab_var[MPHR_SPACECRAFT_ID].val.s,    
        mphr.listevar.tab_var[MPHR_SPACECRAFT_ID].val.s); 

     strcpy(m_MPHR.listevar.tab_var[MPHR_PROCESSING_CENTRE].val.s,    
        mphr.listevar.tab_var[MPHR_PROCESSING_CENTRE].val.s);

/* ..FA 180 */

    }
  
  //@ Traiter les exceptions
  catch(ERR__Exception& exception)
    {
      //@ Envoi des messages generes au JDB
      EnvoyerMessagesStockes(&(ctx->cr.msgJDB));
      
      //@ Liberation memoire pour les donnees de contexte
      LibererCompteRendu(&(ctx->cr.msgJDB));
      delete ctx;
      
      //@ Emission d'un message de type JDB MSG_SD_FILE_WRITE_ERROR
      JDB__Client messageJDB;
      messageJDB.SetParametre(JDB_PARAM_1, m_NomGranule);
      messageJDB.EcrireMessage(SD_SET, 
                               SD__Message::MSG_SD_FILE_WRITE_ERROR);
      messageJDB.Liberer();

      //@ Re-emission de l'exception
      exception.SetDebParametre(ERROR_INIT_WRITING + m_NomGranule);
      throw(exception);
    }
}


//@ ------------------------------------------------------------------*/
//@ Methode : InitGIADR
//@
//@ Description : Initialise les GIADR du granule
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::InitGIADR() throw (ERR__Exception)
{
  // Exception generee
  ERR__Exception       exception;

  // Message pour l'exception
  t_ChaineFixe         message;
  t_Chaine             messageException("");

  // Donnees de contexte
  t_SD_BAS_DataThread* ctx    = NULL;

  // Descripteur de fichier
  t_SD_BAS_Fd          ficDesc;

  // Code retour des fonctions utilisees
  t_CMN__Statut        statut = CMN__STATUT_OK;


  //@ Lecture et initialisation du ou des GIADR du
  //@ granule: 
  //@    1A1B1C: 2 GIADR
  //@    ENG   : 1 GIADR
  //@    VER   : aucun

  //@ Les GIADR peuvent etre alloues statiquement
  //@ Dans le cas du mode DUMP, on initialise la 
  //@ premiere fois un entete global en fonction 
  //@ du MPH initial mais le nombre de lignes est
  //@ limite
  //@ L'initialisation du MPH peut etre mise dans
  //@ une methode privee
 
  //@ SELON la nature du granule
  switch (m_NatureGranule)
    {
      //@ SI donnees:
    case SD_DON_GRANULE_N1_DATA:

      //@ Allocation memoire pour les donnees de contexte
      ctx = new t_SD_BAS_DataThread;
      InitialiserCompteRendu(&(ctx->cr));

      //@ Initialisation du GIADR ScaleFactor
      ficDesc.etat = ENCOURS;
      ficDesc.mode = ECRITURE;
      statut = SD_BAS_InitEcritureMDRN1(&ficDesc,
                                        m_GIADRSCA.TypeRec,
                                        &m_GIADRSCA,
                                        ctx);

      //@ SI l'initialisation du GIADR a genere une erreur
      if (statut != CMN__STATUT_OK)
        {

#ifdef OPS_DEBUG
          cerr << "SD_DON_GranuleN1::InitGIADR: " 
               << "Erreur initialisation du GIADR SCA ("
               << statut << ")" << endl;
#endif

          //@ Recuperation du message d'erreur genere par 
          //@ les couches basses
          RecupererDernierMessageStocke(&(ctx->cr.msgJDB), message);
          messageException = t_Chaine(message) + EXCEPTION_SEPARATEUR +
            m_NomGranule;

          //@ Envoi des messages generes au JDB
          EnvoyerMessagesStockes(&(ctx->cr.msgJDB));
          
          //@ Liberation memoire pour les donnees de contexte
          LibererCompteRendu(&(ctx->cr.msgJDB));
          delete ctx;

          //@ Emission d'une exception SD_DON_OPER_FAILED
          exception.SetErrorCode(ERR__Exception::SD_DON_OPER_FAILED);
          exception.SetParametre(messageException);
          THROW(exception);
        }
      //@ FIN SI l'initialisation du GIADR a genere une erreur

      //@ Initialisation du GIADR Quality
      statut = SD_BAS_InitEcritureMDRN1(&ficDesc,
                                        m_GIADRQUA.TypeRec,
                                        &m_GIADRQUA,
                                        ctx);

      //@ SI l'initialisation du GIADR a genere une erreur
      if (statut != CMN__STATUT_OK)
        {

#ifdef OPS_DEBUG
          cerr << "SD_DON_GranuleN1::InitGIADR: " 
               << "Erreur initialisation du GIADR QUA (" 
               << statut << ")" << endl;
#endif

          //@ Recuperation du message d'erreur genere par 
          //@ les couches basses
          RecupererDernierMessageStocke(&(ctx->cr.msgJDB), message);
          messageException = t_Chaine(message) + EXCEPTION_SEPARATEUR +
            m_NomGranule;

          //@ Envoi des messages generes au JDB
          EnvoyerMessagesStockes(&(ctx->cr.msgJDB));

          //@ Liberation memoire pour les donnees de contexte
          LibererCompteRendu(&(ctx->cr.msgJDB));
          delete ctx;

          //@ Emission d'une exception SD_DON_OPER_FAILED
          exception.SetErrorCode(ERR__Exception::SD_DON_OPER_FAILED);
          exception.SetParametre(messageException);
          THROW(exception);
        }
      //@ FIN SI l'initialisation du GIADR a genere une erreur

      //@ Liberation memoire pour les donnees de contexte
      LibererCompteRendu(&(ctx->cr.msgJDB));
      delete ctx;

      break;

      //@ SI ENG:
    case SD_DON_GRANULE_N1_ENG:

      //@ Allocation memoire pour les donnees de contexte
      ctx = new t_SD_BAS_DataThread;
      InitialiserCompteRendu(&(ctx->cr));

      //@ Initialisation du GIADR ENG
      ficDesc.etat = ENCOURS;
      ficDesc.mode = ECRITURE;
      statut = SD_BAS_InitEcritureMDRN1(&ficDesc,
                                        m_GIADRENG.TypeRec,
                                        &m_GIADRENG,
                                        ctx);

      //@ SI l'initialisation du GIADR a genere une erreur
      if (statut != CMN__STATUT_OK)
        {

#ifdef OPS_DEBUG
          cerr << "SD_DON_GranuleN1::InitGIADR: " 
               << "Erreur initialisation du GIADR ENG ("
               << statut << ")" << endl;
#endif

          //@ Recuperation du message d'erreur genere par 
          //@ les couches basses
          RecupererDernierMessageStocke(&(ctx->cr.msgJDB), message);
          messageException = t_Chaine(message) + EXCEPTION_SEPARATEUR +
            m_NomGranule;

          //@ Envoi des messages generes au JDB
          EnvoyerMessagesStockes(&(ctx->cr.msgJDB));

          //@ Liberation memoire pour les donnees de contexte
          LibererCompteRendu(&(ctx->cr.msgJDB));
          delete ctx;

          //@ Emission d'une exception SD_DON_OPER_FAILED
          exception.SetErrorCode(ERR__Exception::SD_DON_OPER_FAILED);
          exception.SetParametre(messageException);
          THROW(exception);
        }
      //@ FIN SI l'initialisation du GIADR a genere une erreur

      //@ Liberation memoire pour les donnees de contexte
      LibererCompteRendu(&(ctx->cr.msgJDB));
      delete ctx;

      break;

      //@ SI VER:
    case SD_DON_GRANULE_N1_VER:
      //@ Rien a faire
      break;

      //@ Defaut:
    default:
      //@ Rien a faire
      break;
    }
  //@ FIN SELON la nature du granule
}


//@ ------------------------------------------------------------------*/
//@ Methode : EcrireGIADR
//@
//@ Description : Ecrit les GIADR du granule
//@
//@ Parametres :
//@               (ENTREE/SORTIE) ficDesc : Descripteur de fichier
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::EcrireGIADR(t_SD_BAS_Fd& ficDesc,
                                     const e_BAS_Nature natureProduit) 
  throw (ERR__Exception)
{
  // Exception generee
  ERR__Exception       exception;

  // Message pour l'exception
  t_ChaineFixe         message;
  t_Chaine             messageException("");

  // Donnees de contexte
  t_SD_BAS_DataThread* ctx    = NULL;

  // Code retour des fonctions utilisees
  t_CMN__Statut        statut = CMN__STATUT_OK;


  //@ Ecriture du ou des GIADR du granule: 
  //@    1A1B1C: 2 GIADR
  //@    ENG   : 1 GIADR
  //@    VER   : aucun
 
  //@ SELON la nature du granule
  switch (m_NatureGranule)
    {
      //@ SI donnees:
    case SD_DON_GRANULE_N1_DATA:

      //@ Allocation memoire pour les donnees de contexte
      ctx = new t_SD_BAS_DataThread;
      InitialiserCompteRendu(&(ctx->cr));
      if (natureProduit == NA_IASIL1A)
        {
      //@ Mise a jour des scale factor 1A ( sans auvegarde car c'est le dernie ecrit )
     m_GIADRSCA.InfoDet.tab_var[GIADRSCA_IDEFSCALESONDNBSCALE].val.pi4[0] =
     m_GIADRSCA.InfoDet.tab_var[GIADRSCA_IDEFSCALESONDNBSCALE1A].val.pi4[0];
      

      // short int -> int
      for (int i=0; i<SD_BAS_TAILLE_NB_SI_B; i++)
        {
          m_GIADRSCA.InfoDet.tab_var[GIADRSCA_IDEFSCALESONDNSFIRST].val.pi4[i] = 
          m_GIADRSCA.InfoDet.tab_var[GIADRSCA_IDEFSCALESONDNSFIRST1A].val.pi4[i] ;

          m_GIADRSCA.InfoDet.tab_var[GIADRSCA_IDEFSCALESONDNSLAST].val.pi4[i] = 
          m_GIADRSCA.InfoDet.tab_var[GIADRSCA_IDEFSCALESONDNSLAST1A].val.pi4[i]; 

          m_GIADRSCA.InfoDet.tab_var[GIADRSCA_IDEFSCALESONDSCALEFACTOR].val.pi4[i] = 
          m_GIADRSCA.InfoDet.tab_var[GIADRSCA_IDEFSCALESONDSCALEFACTOR1A].val.pi4[i]; 
        }
       }
      //@ Ecriture du GIADR Quality
/* FA 162*/
      statut = SD_BAS_EcrireGIADRN1(m_ModeTraitement,
      				    m_PositionTraitement,
				    &ficDesc,
                                    GIADR_QUA,
                                    &m_GIADRQUA.InfoDet,
                                    ctx);
/* ..FA 162*/
      //@ SI l'ecriture du GIADR a genere une erreur
      if (statut != CMN__STATUT_OK)
        {

#ifdef OPS_DEBUG
          cerr << "SD_DON_GranuleN1::EcrireGIADR: " 
               << "Erreur ecriture du GIADR QUA (" 
               << statut << ")" << endl;
#endif

          //@ Recuperation du message d'erreur genere par 
          //@ les couches basses
          RecupererDernierMessageStocke(&(ctx->cr.msgJDB), message);
          messageException = t_Chaine(message) + EXCEPTION_SEPARATEUR +
            m_NomGranule;

          //@ Envoi des messages generes au JDB
          EnvoyerMessagesStockes(&(ctx->cr.msgJDB));

          //@ Liberation memoire pour les donnees de contexte
          LibererCompteRendu(&(ctx->cr.msgJDB));
          delete ctx;

          //@ Emission d'une exception SD_DON_FILE_WRITE
          exception.SetErrorCode(ERR__Exception::SD_DON_FILE_WRITE);
          exception.SetParametre(messageException);
          THROW(exception);
        }
      //@ FIN SI l'ecriture du GIADR a genere une erreur

      //@ Ecriture du GIADR ScaleFactor
/* FA 162*/
      statut = SD_BAS_EcrireGIADRN1(m_ModeTraitement,
      				    m_PositionTraitement,
      				    &ficDesc,
                                    GIADR_SCA,
                                    &m_GIADRSCA.InfoDet,
                                    ctx);
/* ..FA 162*/
      //@ SI l'ecriture du GIADR a genere une erreur
      if (statut != CMN__STATUT_OK)
        {

#ifdef OPS_DEBUG
          cerr << "SD_DON_GranuleN1::EcrireGIADR: " 
               << "Erreur ecriture du GIADR SCA ("
               << statut << ")" << endl;
#endif

          //@ Recuperation du message d'erreur genere par 
          //@ les couches basses
          RecupererDernierMessageStocke(&(ctx->cr.msgJDB), message);
          messageException = t_Chaine(message) + EXCEPTION_SEPARATEUR +
            t_Chaine(ficDesc.nom);

          //@ Envoi des messages generes au JDB
          EnvoyerMessagesStockes(&(ctx->cr.msgJDB));
          
          //@ Liberation memoire pour les donnees de contexte
          LibererCompteRendu(&(ctx->cr.msgJDB));
          delete ctx;

          //@ Emission d'une exception SD_DON_FILE_WRITE
          exception.SetErrorCode(ERR__Exception::SD_DON_FILE_WRITE);
          exception.SetParametre(messageException);
          THROW(exception);
        }
      //@ FIN SI l'ecriture du GIADR ScaleFactor a genere une erreur

      //@ Liberation memoire pour les donnees de contexte
      LibererCompteRendu(&(ctx->cr.msgJDB));
      delete ctx;

      break;

      //@ SI ENG:
    case SD_DON_GRANULE_N1_ENG:

      //@ Allocation memoire pour les donnees de contexte
      ctx = new t_SD_BAS_DataThread;
      InitialiserCompteRendu(&(ctx->cr));

      //@ Ecriture du GIADR ENG
/* FA 162*/
      statut = SD_BAS_EcrireGIADRN1(m_ModeTraitement,
      				    m_PositionTraitement,
				    &ficDesc,
                                    GIADR_ENG,
                                    &m_GIADRENG.InfoDet,
                                    ctx);
/* ..FA 162*/

      //@ SI l'ecriture du GIADR a genere une erreur
      if (statut != CMN__STATUT_OK)
        {

#ifdef OPS_DEBUG
          cerr << "SD_DON_GranuleN1::EcrireGIADR: " 
               << "Erreur ecriture du GIADR ENG ("
               << statut << ")" << endl;
#endif

          //@ Recuperation du message d'erreur genere par 
          //@ les couches basses
          RecupererDernierMessageStocke(&(ctx->cr.msgJDB), message);
          messageException = t_Chaine(message) + EXCEPTION_SEPARATEUR +
            m_NomGranule;

          //@ Envoi des messages generes au JDB
          EnvoyerMessagesStockes(&(ctx->cr.msgJDB));

          //@ Liberation memoire pour les donnees de contexte
          LibererCompteRendu(&(ctx->cr.msgJDB));
          delete ctx;

          //@ Emission d'une exception SD_DON_FILE_WRITE
          exception.SetErrorCode(ERR__Exception::SD_DON_FILE_WRITE);
          exception.SetParametre(messageException);
          THROW(exception);
        }
      //@ FIN SI l'ecriture du GIADR a genere une erreur

      //@ Liberation memoire pour les donnees de contexte
      LibererCompteRendu(&(ctx->cr.msgJDB));
      delete ctx;

      break;

      //@ SI VER:
    case SD_DON_GRANULE_N1_VER:
      //@ Rien a faire
      break;

      //@ Defaut:
    default:
      //@ Rien a faire
      break;
    }
  //@ FIN SELON la nature du granule
}


//@ ------------------------------------------------------------------*/
//@ Methode : RecupererGIADR
//@
//@ Description : Recupere le ou les GIADR d'un granule N1
//@
//@ Parametres :
//@               (ENTREE) granuleN1 : Granule d'origine
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::RecupererGIADR(SD_DON_GranuleN1& granuleN1) 
  throw (ERR__Exception)
{
  //@ Recuperation du ou des GIADR du granule: 
  //@    1A1B1C: 2 GIADR
  //@    ENG   : 1 GIADR
  //@    VER   : aucun

  //@ SI le granule d'origine n'est pas du meme type que
  //@ le granule courant
  if (granuleN1.GetNatureGranule() != m_NatureGranule)
    {
      // Exception generee
      ERR__Exception exception;

      //@ Emission d'une exception SD_DON_OPER_FAILED
      exception.SetErrorCode(ERR__Exception::SD_DON_OPER_FAILED);
      THROW(exception);
    }
  //@ FIN SI

  //@ SELON la nature du granule
  switch (m_NatureGranule)
    {
      //@ SI donnees:
    case SD_DON_GRANULE_N1_DATA:

      //@ Recuperation du GIADR ScaleFactor
      granuleN1.GetDataGIADR(GIADR_SCA, m_GIADRSCA);

      //@ Recuperation du GIADR Quality
      granuleN1.GetDataGIADR(GIADR_QUA, m_GIADRQUA);

      break;

      //@ SI ENG:
    case SD_DON_GRANULE_N1_ENG:

      //@ Recuperation du GIADR ENG
      granuleN1.GetDataGIADR(GIADR_ENG, m_GIADRENG);

      break;

      //@ SI VER:
    case SD_DON_GRANULE_N1_VER:
      //@ Rien a faire
      break;

      //@ Defaut:
    default:
      //@ Rien a faire
      break;
    }
  //@ FIN SELON la nature du granule
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetProcessingMode
//@
//@ Description : Recupere le processing mode du MPHR
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Processing mode
//@
//@ ------------------------------------------------------------------*/
e_BAS_PROCMODE SD_DON_GranuleN1::GetProcessingMode()
{
  //@ Recuperation de la valeur lue dans le MPHR
  t_Chaine valeur(m_MPHR.listevar.tab_var[MPHR_PROCESSING_MODE].val.s);

  // Processing mode correspondant
  e_BAS_PROCMODE processingMode = PM_NRT; 


  //@ Par defaut, la valeur est Nominal (NRT processing)

  //@ SI la valeur lue est differente
  if (valeur == ASCII_PM_BACKLOG)
    {
      //@ Mettre a jour le processing mode
      processingMode = PM_BACKLOG;
    }
  else if (valeur == ASCII_PM_REPROCESSING)
    {
      processingMode = PM_REPROCESSING;
    }
  //@ FIN SI la valeur lue est differente


  //@ Retourner le processing mode
  return processingMode;
}


//@ ------------------------------------------------------------------*/
//@ Methode : GetDispositionMode
//@
//@ Description : Recupere le disposition mode du MPHR
//@
//@ Parametres :
//@               Aucun
//@
//@ Valeur de retour : 
//@               Disposition mode
//@
//@ ------------------------------------------------------------------*/
e_BAS_DISPMODE SD_DON_GranuleN1::GetDispositionMode()
{
  //@ Recuperation de la valeur lue dans le MPHR
  t_Chaine valeur(m_MPHR.listevar.tab_var[MPHR_DISPOSITION_MODE].val.s);

  // Disposition mode correspondant
  e_BAS_DISPMODE dispositionMode = VALIDATION; 


  //@ Par defaut, la valeur est VALIDATION

  //@ SI la valeur lue est differente
  if (valeur == ASCII_DM_OPERATIONNAL)
    {
      //@ Mettre a jour le disposition mode
      dispositionMode = OPERATIONNAL;
    }
  else if (valeur == ASCII_DM_COMMISSIONING)
    {
      dispositionMode = COMMISSIONING;
    }
  //@ FIN SI la valeur lue est differente


  //@ Retourner le disposition mode
  return dispositionMode;
}


//@ ------------------------------------------------------------------*/
//@ Methode : InitLigne
//@
//@ Description : Initialise une ligne du granule
//@
//@ Parametres :
//@               (ENTREE) numLigne : Numero de la ligne dans le granule
//@               (ENTREE) objetOSV : Objet OSV pour le mode plateforme
//@               (ENTREE) granuleN0 : Granule N0 pour initialisation
//@               (ENTREE/SORTIE) gestionCasDegrade : Gestionnaire de
//@                                                   cas degrade
//@               (ENTREE) processingMode : NRT, Backlog ou reprocessing
//@               (ENTREE) dispositionMode : Operationnal, Validation
//@                                          ou Commissioning
//@               (ENTREE) nbLigneAbsolu : Nombre de lignes absolues
//@                                        depuis le debut du dump
//@               (ENTREE) OBTUTC : Objet pour la correction temps UTC
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::InitLigne(const int numLigne,
                                 SD_DON_OSV& objetOSV,
                                 SD_DON_GranuleN0& granuleN0,
                                 SD_DON_GestCasDeg& gestionCasDegrade,
                                 const e_BAS_PROCMODE processingMode,
                                 const e_BAS_DISPMODE dispositionMode,
                                 const int nbLigneAbsolu,
                                 SD_DON_OBTUTC& OBTUTC)
{
  //@ Creation d'une ligne de niveau 1
  SD_DON_LigneN1       nouvelleLigneN1;
  t_InfoGenLigne       dataGenLigne;
  SD_DON_CasDegLigne*  casDegLigne = 0;
  t_SD_BAS_PaquetN0**  listePaquet1;
  t_SD_BAS_PaquetN0**  listePaquet2;
  int                  nbPaquet1   = 0;
  int                  nbPaquet2   = 0;
  e_SD_BAS_TypeN0      type1       = PX;
  e_SD_BAS_TypeN0      type2       = IP;
  
/* FA 191*/
  int                  nbPaquet3   = 0;
  e_SD_BAS_TypeN0      type3       = AP;
  t_SD_BAS_PaquetN0**  listePaquet3;
  short int	       InfosVDS = 0;
/* ..FA 191*/

  // Mode plateforme
  e_BAS_ModePlateforme modePTF     = PTF_NORMAL;
  // FT-2364
  bool flagManoeuvre;
  // ...FT-2364
  
  //@ Remarque : si un DMDR est detecte en entree, un DMDR
  //@ est initialise
  //@ i.e.: (N0::m_EstValide) -> (N1::m_EstValide)

  //@ Recuperation des donnees generales de la ligne 0 via
  //@ la methode SD_DON_GranuleN0::GetDataGenLigne()
  granuleN0.GetDataGenLigne(numLigne, dataGenLigne);
      
  //@ Recuperation du cas degrade associe a la ligne via
  //@ la methode SD_DON_GestCasDeg::GetCasDegLigne()
  casDegLigne = gestionCasDegrade.GetCasDegLigne(numLigne+1);
  

  //@ SI la ligne est INVALIDE
  //CR271
  if (dataGenLigne.GetValidite() != VALIDE && dataGenLigne.GetValidite() != TRANSITION)
    {
      //@ Initialisation des donnees de la ligne N1 via
      //@ la methode SD_DON_LigneN1::InitEcritureDummy()
/* FA 191*/
      // FT-2364
      nouvelleLigneN1.InitEcritureN0(numLigne,
                                     m_TypeProduit,
                                     TR_MDR,
                                     processingMode,
                                     dispositionMode,
                                     modePTF,
                                     m_ModeTraitement,
                                     dataGenLigne, 
                                     nbLigneAbsolu,
                                     0,
                                     0,
                                     0,
                                     0,
                                     *casDegLigne,
                                     OBTUTC,
                                     0,
                                     false);
      // ....FT-2364
/* ..FA 191*/ 
    }
  //@ SINON
  else
    {
      //@ Calcul du mode plateforme
      // FT-2364
      flagManoeuvre =  false;
      t_Date dateDebut = dataGenLigne.GetDateDebut();
      t_Date dateFin = dataGenLigne.GetDateFin();
      objetOSV.GetModePlateforme(dateDebut, dateFin, modePTF, flagManoeuvre);
      // ...FT-2364
      
      //@ Recuperation des donnees detaillees de la ligne 0
      
      //@ SI le granule est de type DATA ou ENG
      //@     Recuperation des donnees de type PX et IP
      //@ FIN SI le granule est de type DATA
      
      //@ SI le granule est de type VER
      if (m_NatureGranule == SD_DON_GRANULE_N1_VER)
        {
          //@ Recuperation des donnees de type VP et AP
          type1 = VP;
          type2 = AP;
        }
      //@ FIN SI le granule est de type VER
      
      //@ Recuperation des donnees via la methode
      //@ SD_DON_GranuleN0::GetDataLigne()
      nbPaquet1 = granuleN0.GetNbPaquetN0(numLigne, type1);
      if (nbPaquet1 > 0)
        {
          listePaquet1 = new t_SD_BAS_PaquetN0*[nbPaquet1]; 
          granuleN0.GetDataLigne(numLigne, 
                                 type1, 
                                 nbPaquet1, 
                                 listePaquet1);
        }
      nbPaquet2 = granuleN0.GetNbPaquetN0(numLigne, type2);
      if (nbPaquet2 > 0)
        {
          listePaquet2 = new t_SD_BAS_PaquetN0*[nbPaquet2]; 
          granuleN0.GetDataLigne(numLigne, 
                                 type2, 
                                 nbPaquet2, 
                                 listePaquet2);
        }
/* FA 191*/
      //@ SI le granule est de type ENG
      if (m_NatureGranule == SD_DON_GRANULE_N1_ENG)
      {
         //@ recuperation des infos paquets AP pour VDS
	 nbPaquet3 = granuleN0.GetNbPaquetN0(numLigne, type3);
         if (nbPaquet3 > 0)
         {
           listePaquet3 = new t_SD_BAS_PaquetN0*[nbPaquet3]; 
           granuleN0.GetDataLigne(numLigne, 
                                 type3, 
                                 nbPaquet3, 
                                 listePaquet3);
	   //@ recuperation des infos VDS: c la meme pour tous les paquets  
	   InfosVDS = listePaquet3[0]->InfoDet.tab_var[AP_BCODSPECTVERIF].val.
                pi4[0];
           
	   //@ Liberation memoire des paquets N0
           delete [] listePaquet3;
         }	 

      }//@ FIN SI le granule est de type ENG
      
      //@ Initialisation des donnees de la ligne N1 via
      //@ la methode SD_DON_LigneN1::InitEcritureN0()
      // FT-2364
      nouvelleLigneN1.InitEcritureN0(numLigne,
                                     m_TypeProduit,
                                     TR_MDR,
                                     processingMode,
                                     dispositionMode,
                                     modePTF,
                                     m_ModeTraitement,
                                     dataGenLigne, 
                                     nbLigneAbsolu,
                                     nbPaquet1,
                                     nbPaquet2,
                                     listePaquet1,
                                     listePaquet2,
                                     *casDegLigne,
                                     OBTUTC,
                                     InfosVDS,
                                     flagManoeuvre);
      // ...FT-2364
/* ..FA 191*/
      
      //@ Liberation memoire des paquets N0
      if (nbPaquet1 > 0)
        {
          delete [] listePaquet1;
        }
      if (nbPaquet2 > 0)
        {
          delete [] listePaquet2;
        }    
    }
  //@ FIN SI la ligne est INVALIDE
      
  //@ Ajouter la ligne dans la liste des lignes MDR du granule
  m_ListeLigneMDR.push_back(nouvelleLigneN1);
}


//@ ------------------------------------------------------------------*/
//@ Methode : InitLigneVIADR
//@
//@ Description : Initialise une ligne VIADR du granule ENG
//@
//@ Parametres :
//@               (ENTREE) numLigneVIADR : Numero de la ligne VIADR
//@               (ENTREE) numLigneMDR : Numero de la ligne MDR
//@               (ENTREE) objetOSV : Objet OSV pour le mode plateforme
//@               (ENTREE) granuleN0 : Granule N0 pour initialisation
//@               (ENTREE/SORTIE) gestionCasDegrade : Gestionnaire de
//@                                                   cas degrade
//@               (ENTREE) processingMode : NRT, Backlog ou reprocessing
//@               (ENTREE) dispositionMode : Operationnal, Validation
//@                                          ou Commissioning
//@               (ENTREE) nbLigneAbsolu : Nombre de lignes absolues
//@                                        depuis le debut du dump
//@               (ENTREE) OBTUTC : Objet pour la correction temps UTC
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::InitLigneVIADR(const int numLigneVIADR,
                                      const int numLigneMDR,
                                      SD_DON_OSV& objetOSV,
                                      SD_DON_GranuleN0& granuleN0,
                                      SD_DON_GestCasDeg& 
                                      gestionCasDegrade,
                                      const e_BAS_PROCMODE 
                                      processingMode,
                                      const e_BAS_DISPMODE 
                                      dispositionMode,
                                      const int nbLigneAbsolu,
                                      SD_DON_OBTUTC& OBTUTC)
{
  //@ Creation d'une ligne de type VIADR apres
  //@ PERIODE_VIADR lignes MDR
  SD_DON_LigneN1       nouvelleLigneVIADR;
  t_InfoGenLigne       dataGenLigneFin;
  t_InfoGenLigne       dataGenLigneVIADR;
  SD_DON_CasDegLigne*  casDegLigne = 0;
              
  // Mode plateforme
  e_BAS_ModePlateforme modePTF     = PTF_NORMAL;
  // FT-2364
  bool flagManoeuvre;
  // ...FT-2364

  //@ Recuperation des donnees generales de la ligne MDR via
  //@ la methode SD_DON_GranuleN0::GetDataGenLigne()
  granuleN0.GetDataGenLigne(numLigneMDR, dataGenLigneFin);
  dataGenLigneVIADR = dataGenLigneFin;
  
  //@ Calcul du mode plateforme
  // FT-2364
  flagManoeuvre = false;
  t_Date dateDebutTmp = dataGenLigneVIADR.GetDateDebut();
  t_Date dateFinTmp = dataGenLigneVIADR.GetDateFin();
  objetOSV.GetModePlateforme(dateDebutTmp, dateFinTmp, modePTF, flagManoeuvre);
  // ...FT-2364

  //@ Recuperation du cas degrade associe a la ligne via
  //@ la methode SD_DON_GestCasDeg::GetCasDegLigne()
  casDegLigne = gestionCasDegrade.GetCasDegLigne(numLigneMDR+1);
  
  //@ SI le numero de ligne MDR < (PERIODE_VIADR-1)
  if (numLigneMDR < (PERIODE_VIADR-1))
    {
      //@ Ligne VIADR inter-granule
      //@ Elle sera completee par les infos du contexte
      double ecartDebutVIADR = (PERIODE_VIADR-1)*SD_BAS_DUREE_LGN;
      
      dataGenLigneVIADR.SetDateDebut(dataGenLigneVIADR.GetDateDebut() - 
                                     ecartDebutVIADR);
    }
  //@ SINON
  else
    {
      //@ Ligne VIADR complete dans le granule
      t_InfoGenLigne dataGenLigneDebut;
      
      granuleN0.GetDataGenLigne(numLigneMDR-PERIODE_VIADR+1, 
                                dataGenLigneDebut);
      dataGenLigneVIADR.SetDateDebut(dataGenLigneDebut.
                                     GetDateDebut());
    }
  //@ FIN SI
  
  //@ Initialisation des donnees de la ligne N1 via
  //@ la methode SD_DON_LigneN1::InitEcritureN0()
/* FA 191*/
  // FT-2364
  nouvelleLigneVIADR.InitEcritureN0(numLigneVIADR,
                                    m_TypeProduit,
                                    TR_VIADR,
                                    processingMode,
                                    dispositionMode,
                                    modePTF,
                                    m_ModeTraitement,
                                    dataGenLigneVIADR, 
                                    nbLigneAbsolu,
                                    0,
                                    0,
                                    NULL,
                                    NULL,
                                    *casDegLigne,
                                    OBTUTC,
                                    0,
                                    flagManoeuvre);
  // ...FT-2364
/*..FA 191*/  
  //@ Ajouter la ligne dans la liste des lignes 
  //@ VIADR du granule
  m_ListeLigneVIADR.push_back(nouvelleLigneVIADR);
}


//@ ------------------------------------------------------------------*/
//@ Methode : IdentifierProduit
//@
//@ Description : Identifie les produits a generer pour le granule
//@
//@ Parametres :
//@               (SORTIE) nbProduit : Nombre de produits a generer
//@               (SORTIE) natureProduit : Nature des produits a generer
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::IdentifierProduit(int& nbProduit, 
                                         e_BAS_Nature natureProduit[])
{
  //@ SELON le type de produit (1A/1B/1C, 1B/1C, 1C, VER ou ENG)
  switch (m_TypeProduit)
    {
      //@ SI 1C, alors il faut generer 1 produit
    case SD_DON_PRODUIT_N1_1C: 
      nbProduit        = 1;
      natureProduit[0] = NA_IASIL1C;
      break;
      
      //@ SI 1B/1C, alors il faut generer 2 produits
      //@ differents a partir du meme granule
    case SD_DON_PRODUIT_N1_1B1C: 
      nbProduit        = 2;
      natureProduit[0] = NA_IASIL1B;
      natureProduit[1] = NA_IASIL1C;
      break;
      
      //@ SI 1A/1B/1C, alors il faut generer 3 produits
      //@ differents a partir du meme granule
    case SD_DON_PRODUIT_N1_1A1B1C: 
      nbProduit        = 3;
      natureProduit[0] = NA_IASIL1B;
      natureProduit[1] = NA_IASIL1C;
// en dernier pour mise a jour des scale factors
      natureProduit[2] = NA_IASIL1A;
      break;
      
      //@ SI ENG, alors il faut generer 1 produit
    case SD_DON_PRODUIT_N1_ENG: 
      nbProduit        = 1;
      natureProduit[0] = NA_IASIL1ENG;
      break;
      
      //@ SI VER, alors il faut generer 1 produit
    case SD_DON_PRODUIT_N1_VER: 
      nbProduit        = 1;
      natureProduit[0] = NA_IASIL1VER;
      break;
      
      //@ Defaut:
    default:
      //@ Par defaut, aucun produit a generer
      nbProduit = 0;
      break;
    }
  //@ FIN SELON le type de produit 
}


//@ ------------------------------------------------------------------*/
//@ Methode : ModifierNomProduit
//@
//@ Description : Modifie le nom d'un produit en fonction de son niveau
//@               et des dates de debut et de fin
//@
//@ Parametres :
//@               (ENTREE) natureProduit : Nature du produit
//@               (ENTREE/SORTIE) nomProduit : Nom du produit
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::ModifierNomProduit(const e_BAS_Nature natureProduit,
                                          t_Chaine& nomProduit)
  throw (ERR__Exception)
{

#ifdef OPS_DEBUG
  cout << "Avant SD_DON_GranuleN1::ModifierNomProduit: " << nomProduit 
       << endl;
#endif

  //@ On construit un objet t_OPSFile
  t_OPSFile fichierOPS(nomProduit);

  //@ SI produit de nature 1A
  if (natureProduit == NA_IASIL1A)
    {
      //@ Mise a jour du niveau
      fichierOPS.SetProcLevel(PROC_LEVEL_1A);
    }
  //@ SINON SI produit de nature 1B
  else if (natureProduit == NA_IASIL1B)
    {
      //@ Mise a jour du niveau
      fichierOPS.SetProcLevel(PROC_LEVEL_1B);
    }
  //@ FIN SELON la nature du produit


  //@ SI mode GRANULE ou DUMP, First
  if ( (m_ModeTraitement == GRANULE) ||
       ((m_ModeTraitement == DUMP) && (m_PositionTraitement == FIRST)) )
    {
      // Date courante pour le processing time

//FA152
      t_Date dateCourante=m_Tdeb;
      //@ Mise a jour des dates de debut, de fin et processing
//      dateCourante.DateCourante();
      fichierOPS.RemplacerValidityStartDate(m_TP0);
      fichierOPS.RemplacerValidityEndDate(m_TP1);
      fichierOPS.RemplacerProcDate(dateCourante);
     
      //@ Recuperation du nom
      nomProduit = fichierOPS.GetNom();
    }
  //@ SINON
  else
    {
      // Exception generee
      ERR__Exception exception;

      // Variables pour la recherche du fichier DUMP
      t_ListeChaine  listeFichier;
      t_Chaine       nomFichier("");


      //@ On positionne des patterns de recherche pour 
      //@ les dates
      fichierOPS.ResetValidityStartDate();
      fichierOPS.ResetValidityEndDate();
      fichierOPS.ResetProcDate();

      //@ Recuperation du nom complet du fichier avec 
      //@ des patterns de recherche
      nomFichier = NomComplet(fichierOPS.GetNom());

      //@ Rechercher le fichier physique
      if (CMN__RechercherFichier(nomFichier, 
                                 CMN__VRAI, 
                                 listeFichier) == CMN__FAUX)
        {
          //@ Emission d'une exception SD_DON_OPER_FAILED
          exception.SetErrorCode(ERR__Exception::SD_DON_OPER_FAILED);
          exception.SetParametre(ERROR_DUMP_FILENAME);
          THROW(exception);
        }


      //@ SI pas dernier traitement du DUMP
      if (m_PositionTraitement != LAST)
        {
          //@ Mise a jour du nom du produit
          nomProduit = NomCourt(listeFichier.back());
        }
      //@ SINON
      else
        {
          //@ On reconstruit un objet t_OPSFile
          t_Chaine  nomInitial(NomCourt(listeFichier.back()));
          t_OPSFile fichierDUMP(nomInitial);
          
          //@ Mise a jour de la date de fin
          fichierDUMP.RemplacerValidityEndDate(m_TP1);
          
          //@ Recuperation du nom
          nomProduit = fichierDUMP.GetNom();
          
          //@ Renommer le fichier physique
         
          //@ SI le deplacement du fichier physique a genere
          //@ une erreur
          if (rename(listeFichier.back().c_str(), 
                     NomComplet(nomProduit).c_str()) != 0)
            {
              //@ Emission exception WOM_FILE_WRITE_ERROR
              exception.SetErrorCode(ERR__Exception::SD_DON_OPER_FAILED);
              exception.SetErrno(errno);
              exception.SetParametre(ERROR_DUMP_FILENAME);
              THROW(exception);
            }
          //@ FIN SI
        }
      //@ FIN SI pas dernier traitement du DUMP
    }
  //@ FIN SI mode GRANULE ou DUMP, First


#ifdef OPS_DEBUG
  cout << "Apres SD_DON_GranuleN1::ModifierNomProduit: " << nomProduit 
       << endl;
#endif

}


//@ ------------------------------------------------------------------*/
//@ Methode : EcrireProduit
//@
//@ Description : Ecrit physiquement le contenu d'un produit de niveau 1
//@               (MPHR + GIADR + VIADR + MDR)
//@
//@ Parametres :
//@               (ENTREE) IdCA : Identifiant fichier de conf autre
//@               (ENTREE) typeAccesOuverture : Mode d'acces ouverture
//@               (ENTREE) typeAccesFermeture : Mode d'acces fermeture
//@               (ENTREE) natureProduit : Nature du produit a ecrire
//@               (SORTIE) listeFichier : Liste des fichiers ecrits
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::EcrireProduit(const int idCA,
                                     const e_BAS_TypeAcces 
                                     typeAccesOuverture,
                                     const e_BAS_TypeAcces 
                                     typeAccesFermeture,
                                     const e_BAS_Nature natureProduit,
                                     t_ListeChaine& listeFichier)
  throw (ERR__Exception)
{
  // Dates de debut et de fin
/* FA 180 */
  t_Date	       dateDebLue;
  t_SCDSTime           dateDebut;
  t_SCDSTime           dateFin            = m_TP1.SCDSTime();

/* ..FA 180 */
  // Donnees de contexte
  t_SD_BAS_DataThread* ctx                = NULL;

  // Descripteur de fichier
  t_SD_BAS_Fd          ficDesc;
  t_CMN__Booleen       ficOuvert          = CMN__FAUX;

  // Nom du produit
  t_Chaine             nomProduit(m_NomGranule);

  // Nom de fichier
  t_SD_BAS_NomProduit  nomFichier;

  // Code retour des fonctions utilisees
  t_CMN__Statut        statut             = CMN__STATUT_OK;

#ifdef OPS_DEBUG
  // Nom de la methode
  static const char    tcProcName_F[] = 
    "SD_DON_GranuleN1::EcrireProduit";
#endif


  //@ En captant les exceptions  
  try
    {
      //@ Allocation memoire pour les donnees de contexte
      ctx = new t_SD_BAS_DataThread;
      InitialiserCompteRendu(&(ctx->cr));

      //@ Modifier eventuellement le niveau 1A, 1B ou 1C
      //@ dans le nom du produit et dans le product model
      //@ (date de debut et de fin)
      ModifierNomProduit(natureProduit, nomProduit);

      //@ Le MPHR a deja ete mis a jour en fin de
      //@ traitement via SetEntete()
      
      //@ On le complete ici avec la taille, le nombre 
      //@ d'enregistrement et la date de fin de traitement
      FinaliserMPHR(m_NomOrigine, nomProduit);

      //@ Le GIADR a egalement ete mis en jour en fin de 
      //@ traitement (donnees de conf) via SetEntete()
       
      
      //@ Ouverture du fichier de N1 en ecriture (SD_BAS_Niveau1)
      strcpy(nomFichier, NomComplet(nomProduit).c_str());
      
#ifdef OPS_DEBUG
      cout << tcProcName_F << ": typeAccesOuverture = " 
           << typeAccesOuverture 
           << " (ECRITURE= " << ECRITURE << ")" << endl;
      cout << "\tnatureProduit = " << natureProduit 
           << " (NA_IASIL1A= " << NA_IASIL1A << ")" << endl;
#endif

/* FA 162 */
      statut = SD_BAS_OuvrirProduit(typeAccesOuverture, 
                                    natureProduit, 
                                    nomFichier, 
                                    &ficDesc, 
                                    ctx,
				    m_ModeTraitement);
/* ..FA 162 */ 

      //@ SI l'ouverture du produit a genere une erreur
      if (statut != CMN__STATUT_OK)
        {
          
#ifdef OPS_DEBUG
          cerr << tcProcName_F << ": Erreur OuvrirProduit: " << 
            nomProduit << " (" << statut << ")" << endl;
#endif
          
          //@ Traiter l'erreur en provenance des couches basses
          TraiterErreurBAS(ctx, 
                           ERR__Exception::SD_DON_FILE_OPEN, 
                           nomProduit);
        }
      //@ FIN SI l'ouverture du produit a genere une erreur
      
      
#ifdef OPS_DEBUG
      cout << tcProcName_F << ": OuvrirProduit: " << 
        nomProduit << "(" << statut << ")" << endl;
#endif
     
      //@ Ajout du fichier dans la liste des fichiers ecrits
      listeFichier.push_back(nomProduit);

      //@ Le fichier est ouvert
      ficOuvert = CMN__VRAI;

      
/* FA 180 + 162 */
      if ( (m_ModeTraitement == GRANULE) ||
           (m_ModeTraitement == DUMP) && (m_PositionTraitement == FIRST) )
      {
          dateDebut = m_TP0.SCDSTime();
          
	  //@ Decrire les IPR dynamiquement */
          DecrireIPR(&ficDesc);
      }
      else
      {
          t_SD_BAS_MPHR  * mphrPrec;
 
          mphrPrec = new t_SD_BAS_MPHR;
         
	  //@ relire le MPHR du premier granule pour recuperer la date de debut
          statut = SD_BAS_LireMPHR( &ficDesc,
				  mphrPrec,
				  ctx);
          if (statut != CMN__STATUT_OK)
          {
             TraiterErreurBAS(
                              ctx, 
                              ERR__Exception::SD_DON_FILE_WRITE, 
                              nomProduit);
          }
		  //@ recuperation de la date
		  dateDebLue.TransformeDate(mphrPrec->listevar.tab_var[MPHR_SENSING_START].val.s);
		  dateDebut = dateDebLue.SCDSTime();

		  delete (mphrPrec);
		  
                  //@ Decrire les IPR dynamiquement */
          if( m_GIADRSCA.InfoDet.nb_var > 0 ) 
            if( m_GIADRSCA.InfoDet.tab_var[GIADRSCA_IDEFSCALESONDNBSCALE1A].val.pi4[0] > 0 ) 
                  DecrireIPRDump(&ficDesc,ctx);
      }

/* ..FA 180 + 162 */
      //@ SI premiere ecriture du fichier
      if ( (typeAccesOuverture == APPEND_INIT) || 
           (typeAccesOuverture == ECRITURE) )
        {
          //@ Ecriture du MPHR+GIADR (selon le type de produit) 
          //@ via la methode SD_BAS_LigneN1::EcrireEntete()
/* FA 180 */
          statut = SD_BAS_EcrireMPHRSPHRN1(m_ModeTraitement,
	  				   m_PositionTraitement, 
	                                   &ficDesc, 
                                           CMN__FAUX, 
                                           &m_MPHR, 
                                           dateDebut,
                                           dateFin,
                                           ctx);
/* ..FA 180 */
          //@ SI l'ecriture du MPHR a genere une erreur
          if (statut != CMN__STATUT_OK)
            {
              
#ifdef OPS_DEBUG
              cerr << tcProcName_F << ": Erreur EcrireMPHRSPHRN1: " << 
                nomProduit << " (" << statut << ")" << endl;
#endif
              
              //@ Traiter l'erreur en provenance des couches basses
              TraiterErreurBAS(ctx, 
                               ERR__Exception::SD_DON_FILE_WRITE, 
                               nomProduit);
            }
          //@ FIN SI l'ecriture du MPHR a genere une erreur
     
#ifdef OPS_DEBUG
          cout << tcProcName_F << ": EcrireMPHRSPHRN1: " << 
            nomProduit << "(" << statut << ")" << endl;
#endif

          //@ Ecriture du ou des GIADR
          EcrireGIADR(ficDesc,natureProduit);
        }
      //@ FIN SI premiere ecriture du fichier

      //@ Ecriture des donnees
      EcrireDonnees(ficDesc, idCA, natureProduit);

      //@ Finalisation de l'ecriture du MPHR via la methode
      //@ SD_BAS_LigneN1::EcrireMPHRSPHRN1()
      //@ On met a jour ici les offsets VIADR et MDR utilises
      //@ pour les IPR
/* FA 180 */
      statut = SD_BAS_EcrireMPHRSPHRN1(
        m_ModeTraitement, 
        m_PositionTraitement, 
	&ficDesc, 
        CMN__VRAI, 
        &m_MPHR, 
        dateDebut, 
        dateFin, 
        ctx);
/* ..FA 180 */
      //@ SI la finalisation du MPHR a genere une erreur
      if (statut != CMN__STATUT_OK)
      {              
#ifdef OPS_DEBUG
  cerr << tcProcName_F << ": Erreur EcrireMPHRSPHRN1: " 
       << nomProduit << " (" << statut << ")" << endl;
#endif
              
        //@ Traiter l'erreur en provenance des couches basses
        TraiterErreurBAS(
          ctx, 
          ERR__Exception::SD_DON_FILE_WRITE, 
          nomProduit);
      }
      //@ FIN SI la finalisation du MPHR a genere une erreur

/* FA 162*/
      if ((m_ModeTraitement == DUMP) && (m_PositionTraitement != FIRST))
      {
          //@ re ecriture des giadr (a cause du decalage provoque par les ipr )
          if( m_GIADRSCA.InfoDet.nb_var > 0 )
            if( m_GIADRSCA.InfoDet.tab_var[GIADRSCA_IDEFSCALESONDNBSCALE1A].val.pi4[0] > 0 ) 
              EcrireGIADR(ficDesc,natureProduit);
      }

/* ..FA 162*/

      //@ Le fichier est ferme
      ficOuvert = CMN__FAUX;
      
      //@ Fermeture du fichier de N1
/* FA 162 */
      statut = SD_BAS_FermerProduit(typeAccesFermeture, 
                                    &ficDesc, 
                                    ctx,
				    m_ModeTraitement);
/* ..FA 162 */      
      //@ SI la fermeture du produit N1 a genere une erreur
      if (statut != CMN__STATUT_OK)
        {
          
#ifdef OPS_DEBUG
          cerr << tcProcName_F << ": Erreur FermerProduit: " << 
            nomProduit << " (" << statut << ")" << endl;
#endif

          //@ Traiter l'erreur en provenance des couches basses
          TraiterErreurBAS(ctx, 
                           ERR__Exception::SD_DON_FILE_WRITE, 
                           nomProduit);
        }
      //@ FIN SI la fermeture du produit N1 a genere une erreur

      //@ Liberation memoire pour les donnees de contexte
      LibererCompteRendu(&(ctx->cr.msgJDB));
      delete ctx;
    }
  
  //@ Traiter les exceptions
  catch(ERR__Exception& exception)
    {

#ifdef OPS_DEBUG
      //@ Impression des exceptions
      cout << "Exception in " << tcProcName_F << endl;
      cout << "\tFile : " << exception.GetFile() << endl;
      cout << "\tLine : " << exception.GetLine() << endl;
      cout << "\tError: " << exception.GetErrorCode() << endl;
      for (int i=0; i<exception.GetNbParametre(); i++)
        {
          cout << "\tInfo : " << exception.GetParametre(i) << endl;
        }
#endif

      //@ SI le fichier est ouvert
      if (ficOuvert == CMN__VRAI)
        {
          //@ Fermeture du fichier de N1
/* FA 162 */
          SD_BAS_FermerProduit(typeAccesFermeture, &ficDesc, ctx,m_ModeTraitement);
/* ..FA 162 */
        }
      //@ FIN SI le fichier est ouvert

      //@ Envoi des messages generes au JDB
      EnvoyerMessagesStockes(&(ctx->cr.msgJDB));
      
      //@ Liberation memoire pour les donnees de contexte
      LibererCompteRendu(&(ctx->cr.msgJDB));
      delete ctx;
      
      //@ Emission d'un message de type JDB MSG_SD_FILE_WRITE_ERROR
      JDB__Client messageJDB;
      messageJDB.SetParametre(JDB_PARAM_1, nomProduit);
      messageJDB.EcrireMessage(SD_SET, 
                               SD__Message::MSG_SD_FILE_WRITE_ERROR);
      messageJDB.Liberer();

      //@ Re-emission de l'exception
      exception.SetDebParametre(ERROR_END_WRITING + nomProduit);
      throw(exception);
    }
}


//@ ------------------------------------------------------------------*/
//@ Methode : EcrireDonnees
//@
//@ Description : Ecrit les donnees d'un produit de niveau 1
//@               (GIADR + VIADR + MDR)
//@
//@ Parametres :
//@               (ENTREE/SORTIE) ficDesc : Descripteur de fichier
//@               (ENTREE) IdCA : Identifiant fichier de conf autre
//@               (ENTREE) natureProduit : Nature du produit a ecrire
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::EcrireDonnees(t_SD_BAS_Fd& ficDesc, 
                                     const int idCA, 
                                     const e_BAS_Nature natureProduit)
{
  //@ SI produit ENG
  if (m_TypeProduit == SD_DON_PRODUIT_N1_ENG)
    {
      //@ POUR chaque ligne VIADR du granule a ecrire 
      for (int i=0; i<m_ListeLigneVIADR.size(); i++)
        {
          //@ Ecriture du record via la methode
          //@ SD_DON_LigneN1::Ecrire()
/* FA 162 */
          m_ListeLigneVIADR[i].Ecrire(ficDesc, 
                                      idCA, 
                                      natureProduit,
				      m_ModeTraitement);
/* ..FA 162*/
        }
      //@ FIN POUR chaque ligne VIADR du granule a ecrire
    }
  //@ FIN SI produit ENG
  
  //@ POUR chaque ligne MDR du granule a ecrire
  for (int i=0; i<m_ListeLigneMDR.size(); i++)
    {
      //@ Ecriture du record via la methode
      //@ SD_DON_LigneN1::Ecrire()
/* FA 162 */
      m_ListeLigneMDR[i].Ecrire(ficDesc, 
                                idCA, 
                                natureProduit,
				m_ModeTraitement);
/* FA 162*/
    }


  //@ FIN POUR chaque ligne MDR du granule a ecrire
}


//@ ------------------------------------------------------------------*/
//@ Methode : FinaliserMPHR
//@
//@ Description : Finalise le renseignement du MPHR
//@
//@ Parametres :
//@               (ENTREE) nomProduitEntree : Fichier d'entree
//@               (ENTREE) nomProduitSortie : Fichier a generer
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::FinaliserMPHR(const t_Chaine& nomProduitEntree,
                                     const t_Chaine& nomProduitSortie)
{
  
  //@ MPHR_PARENT_PRODUCT_NAME
  strncpy(m_MPHR.listevar.tab_var[MPHR_PRODUCT_NAME].val.s, 
          nomProduitSortie.c_str(),
          TAILLE_FICHIER_PRODUIT);
  m_MPHR.listevar.tab_var[MPHR_PRODUCT_NAME].val.
    s[TAILLE_FICHIER_PRODUIT] = '\0';

  //@ MPHR_PARENT_PRODUCT_NAME_1
  strncpy(m_MPHR.listevar.tab_var[MPHR_PARENT_PRODUCT_NAME_1].val.s, 
          nomProduitEntree.c_str(),
          TAILLE_FICHIER_PRODUIT);
  m_MPHR.listevar.tab_var[MPHR_PARENT_PRODUCT_NAME_1].val.
    s[TAILLE_FICHIER_PRODUIT] = '\0';

  //@ MPHR_PARENT_PRODUCT_NAME_2
  strncpy(
    m_MPHR.listevar.tab_var[MPHR_PARENT_PRODUCT_NAME_2].val.s,
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\0", 
    TAILLE_FICHIER_PRODUIT);

  //@ MPHR_PARENT_PRODUCT_NAME_3
  strncpy(
    m_MPHR.listevar.tab_var[MPHR_PARENT_PRODUCT_NAME_3].val.s,
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\0", 
    TAILLE_FICHIER_PRODUIT);

  //@ MPHR_PARENT_PRODUCT_NAME_4
  strncpy(
    m_MPHR.listevar.tab_var[MPHR_PARENT_PRODUCT_NAME_4].val.s,
    "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\0", 
    TAILLE_FICHIER_PRODUIT);


  //@ Mise a jour des dates de fin de processing pour le MPHR
  m_Tfin.DateCourante();
  t_Chaine   strTempsDebut = m_Tdeb.DateUTC(CMN__FAUX, CMN__FAUX);
  t_Chaine   strTempsFin   = m_Tfin.DateUTC(CMN__FAUX, CMN__FAUX);

  //@ MPHR_PROCESSING_TIME_START
  strcpy(m_MPHR.listevar.tab_var[MPHR_PROCESSING_TIME_START].val.s, 
         strTempsDebut.c_str());

  //@ MPHR_PROCESSING_TIME_END
  strcpy(m_MPHR.listevar.tab_var[MPHR_PROCESSING_TIME_END].val.s, 
         strTempsFin.c_str());

  //@ On construit un objet t_OPSFile
  t_OPSFile fichierOPS(nomProduitSortie);

  //@ MPHR_PRODUCT_TYPE
  strcpy(m_MPHR.listevar.tab_var[MPHR_PRODUCT_TYPE].val.s, 
         fichierOPS.GetProdType().c_str());
  
  //@ MPHR_PROCESSING_LEVEL
  strcpy(m_MPHR.listevar.tab_var[MPHR_PROCESSING_LEVEL].val.s, 
         fichierOPS.GetProcLevel().c_str());

  //@ MPHR_ACTUAL_PRODUCT_SIZE (renseigne dans 
  //@ SD_BAS_EcrireMPHRSPHRN1)
  
  //@ MPHR_TOTAL_MPHR
  m_MPHR.listevar.tab_var[MPHR_TOTAL_MPHR].val.pui4[0] = 1;

  //@ MPHR_TOTAL_SPHR
  m_MPHR.listevar.tab_var[MPHR_TOTAL_SPHR].val.pui4[0] = 0;

  //@ MPHR_TOTAL_IPR (renseigne dans SD_BAS_EcrireMPHRSPHRN1)
  
  //@ MPHR_TOTAL_GEADR
  m_MPHR.listevar.tab_var[MPHR_TOTAL_GEADR].val.pui4[0] = 0;

  //@ MPHR_TOTAL_GIADR
  //@ SELON la nature du granule
  switch (m_NatureGranule)
    {
      //@ SI donnees: 2 GIADR
    case SD_DON_GRANULE_N1_DATA:
      m_MPHR.listevar.tab_var[MPHR_TOTAL_GIADR].val.pui4[0] = 2;
      break;
      
      //@ SI ENG: 1 GIADR
    case SD_DON_GRANULE_N1_ENG:
      m_MPHR.listevar.tab_var[MPHR_TOTAL_GIADR].val.pui4[0] = 1;
      break;

      //@ Defaut: 0 GIADR
    default:
      break;
    }
  
  //@ MPHR_TOTAL_VEADR
  m_MPHR.listevar.tab_var[MPHR_TOTAL_VEADR].val.pui4[0] = 0;
  
  //@ MPHR_TOTAL_VIADR
  m_MPHR.listevar.tab_var[MPHR_TOTAL_VIADR].val.pui4[0] = 
    m_ListeLigneVIADR.size();
  
  //@ MPHR_TOTAL_MDR
  // SI le traitement se fait en mode DUMP ALORS
/* FA 180 - MPHR*/
    // Comptabiliser seulement les MDR du granule courant
    m_MPHR.listevar.tab_var[MPHR_TOTAL_MDR].val.pui4[0] = 
      m_ListeLigneMDR.size();
/* ..FA 180 - MPHR*/
}


//@ ------------------------------------------------------------------*/
//@ Methode : NomComplet
//@
//@ Description : Transforme le nom d'un fichier en chemin complet
//@
//@ Parametres :
//@               (ENTREE) nomFichier : Nom du fichier
//@
//@ Valeur de retour :
//@               Nom complet du fichier
//@
//@ ------------------------------------------------------------------*/
t_Chaine SD_DON_GranuleN1::NomComplet(const t_Chaine& nomFichier)
  throw (ERR__Exception)
{
  // Nom complet
  t_Chaine nomComplet("");

  //@ Recuperation de la variable d'environnement REP_DATA_TMP
  t_Chaine dirTmp = CFG__Configuration::GetRepertoire(DIR_DATA_TMP);

  //@ SI la variable d'environnement REP_DATA_TMP n'est pas definie
  if (dirTmp.empty())
    {
      // Exception generee
      ERR__Exception exception;

      //@ Emission d'une exception SD_ENV_UNDEFINED
      exception.SetErrorCode(ERR__Exception::SD_ENV_UNDEFINED);
      exception.SetParametre(DIR_DATA_TMP);
      THROW(exception);
    }
  //@ FIN SI

  nomComplet = dirTmp + CMN__SEP_REPERTOIRE + nomFichier;


  //@ Retourner le nom complet du fichier granule
  return nomComplet;
}


//@ ------------------------------------------------------------------*/
//@ Methode : NomCourt
//@
//@ Description : Recupere le nom court d'un fichier
//@
//@ Parametres :
//@               (ENTREE) nomFichier : Nom du fichier
//@
//@ Valeur de retour :
//@               Nom court du fichier
//@
//@ ------------------------------------------------------------------*/
t_Chaine SD_DON_GranuleN1::NomCourt(const t_Chaine& nomFichier)
{
  //@ Affecter le nom de fichier a la variable du nom court
  t_Chaine            nomCourt(nomFichier);
  t_Chaine::size_type posDebut = t_Chaine::npos;
  int                 longueur = 0;


  //@ Rechercher le caractere separateur de repertoire
  posDebut = nomFichier.rfind(CMN__SEP_REPERTOIRE);

  //@ SI le caractere a ete trouve
  if (posDebut != t_Chaine::npos)
    {
      posDebut += strlen(CMN__SEP_REPERTOIRE);
      longueur = nomFichier.length() - posDebut;

      //@ Affecter le nom court avec les caracteres suivants
      nomCourt = nomFichier.substr(posDebut, longueur);
    }
  //@ FIN SI


  //@ Retourner le nom court du fichier
  return nomCourt;
}


//@ ------------------------------------------------------------------*/
//@ Methode : TraiterErreurBAS
//@
//@ Description : Traite une erreur en provenance des couches basses
//@
//@ Parametres :
//@               (ENTREE) ctx : Donnees de contexte
//@               (ENTREE) codeException : Code de l'exception a generer
//@               (ENTREE) paramMessage : Parametre pour le message 
//@                                       d'erreur
//@
//@ Valeur de retour :
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::TraiterErreurBAS(t_SD_BAS_DataThread* ctx,
                                        const ERR__Exception::e_Code 
                                        codeException,
                                        const t_Chaine paramMessage) 
  throw (ERR__Exception)
{
  // Exception generee
  ERR__Exception exception;
  
  // Message pour l'exception
  t_ChaineFixe   message;
  t_Chaine       messageException("");
  
  
  //@ Recuperation du message d'erreur genere par 
  //@ les couches basses
  RecupererDernierMessageStocke(&(ctx->cr.msgJDB), message);
  messageException = t_Chaine(message) + EXCEPTION_SEPARATEUR + 
    paramMessage;
          
  //@ Emission d'une exception
  exception.SetErrorCode(codeException);
  exception.SetParametre(messageException);
  THROW(exception);
}

//@ ------------------------------------------------------------------*/
//@ Methode : DecrireIPR
//@
//@ Description : cette methode permet de decrire les champs 
//@ TARGET_RECORD_CLASS, TARGET_INSTRUMENT_GROUP, TARGET_RECORD_SUBCLASS et
//@ TARGET_RECORD_OFFSET des IPR
//@
//@ Parametres :
//@   (ENTREE/SORTIE) descripteur_fichier : descripteur du fichier associe 
//@                   au produit
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::DecrireIPR(
  t_SD_BAS_Fd * descripteur_fichier)

{
  /* Variables locales */
  /*-------------------*/
  /* Structure de ligne courante contenue dans la liste des MDR ou des VIADR */
  t_SD_BAS_LigneN1 LigneCourante;
  /* champ TARGET_RECORD_OFFSET    */
  off_t     Offset;
  /* Nombre d'IPR identifies */
  int              NbIPR;
  /* champs Instrument Group des GRH des IPR */
  e_BAS_INSTRUMENT InstrumentGroup;
  /* buffer pour le type de 2 record consecutifs */
  e_BAS_TypeRecN1  TypeRecordCourant;
  e_BAS_TypeRecN1  TypeRecordPrecedent;
  /* taille d'un record dans le produit */
  int              TailleRecordPrecedent;
  /* compteurs */
  int              i,j;
  
  /* Initialiser les variables locales */
  /*-----------------------------------*/
  for (i = 0 ; i < SD_BAS_NB_MAX_IPR ; i++)
  {
    descripteur_fichier->descripteurIPR[i].Rec = TR_UNDEFINED;
    descripteur_fichier->descripteurIPR[i].Instrument = IN_DUMMY;
    descripteur_fichier->descripteurIPR[i].subclass = 0;
    descripteur_fichier->descripteurIPR[i].Offset = 0;
  }
  InstrumentGroup = IN_IASI;
  Offset = 0;
  NbIPR = 0;
  TypeRecordCourant = MDR_DUMMY;
  TypeRecordPrecedent = TypeRecordCourant;
  TailleRecordPrecedent = 0;
  j = 0;
  
  /* Corps de l'operation */
  /*----------------------*/
  /* mettre a jour le champ TypeRec des MDR ou des VIADR */
  for (i = 0 ; i < m_ListeLigneMDR.size() ; i++)
  {
    if (descripteur_fichier->nature == NA_IASIL1ENG && i < m_ListeLigneVIADR.size()) 
    //protection contre les debordements
    {
      m_ListeLigneVIADR[i].MettreAJourTypeRecord(descripteur_fichier->nature);
    }
    
    m_ListeLigneMDR[i].MettreAJourTypeRecord(descripteur_fichier->nature);
  }
  
/* FA 162 */
  /* On compte le nombre d'IPR a ecrire */
  if (descripteur_fichier->nature == NA_IASIL1A) 
  {
    NbIPR = 3; /* GIADR_QUA, GIADR_SCA et 1er MDR */
    
    m_ListeLigneMDR[0].GetData(LigneCourante);
    TypeRecordCourant = LigneCourante.TypeRec;
    TypeRecordPrecedent = TypeRecordCourant;
    
    if ((m_ModeTraitement == DUMP) && (m_PositionTraitement != FIRST))
    {

       /* si 1er record different du dernier record granule precedent 
        on ajoute un IPR */
	if(TypeRecordCourant != m_TypeLastRecord_1A)
	       NbIPR ++;
    }

    for (i = 1 ; i < m_ListeLigneMDR.size() ; i++)
    {
      m_ListeLigneMDR[i].GetData(LigneCourante);
      TypeRecordCourant = LigneCourante.TypeRec;

      if (TypeRecordCourant != TypeRecordPrecedent)
      {
        NbIPR++;
      } /* fin if (TypeRecordCourant != TypeRecordPrecedent) */
      TypeRecordPrecedent = TypeRecordCourant;
    } /* fin for (i = 1 ; i < m_ListeLigneMDR.size() ; i++) */
    m_NbIPR1A = NbIPR;
  }

  if (descripteur_fichier->nature == NA_IASIL1B) 
  {
    NbIPR = 3; /* GIADR_QUA, GIADR_SCA et 1er MDR */
    
    m_ListeLigneMDR[0].GetData(LigneCourante);
    TypeRecordCourant = LigneCourante.TypeRec;
    TypeRecordPrecedent = TypeRecordCourant;

    if ((m_ModeTraitement == DUMP) && (m_PositionTraitement != FIRST))
    {
       /* si 1er record different du dernier record granule precedent 
        on ajoute un IPR */
	if(TypeRecordCourant != m_TypeLastRecord_1B)
	       NbIPR ++;

    }
    
    for (i = 1 ; i < m_ListeLigneMDR.size() ; i++)
    {
      m_ListeLigneMDR[i].GetData(LigneCourante);
      TypeRecordCourant = LigneCourante.TypeRec;

      if (TypeRecordCourant != TypeRecordPrecedent)
      {
        NbIPR++;
      } /* fin if (TypeRecordCourant != TypeRecordPrecedent) */
      TypeRecordPrecedent = TypeRecordCourant;
    } /* fin for (i = 1 ; i < m_ListeLigneMDR.size() ; i++) */
    m_NbIPR1B = NbIPR;
  }


  if (descripteur_fichier->nature == NA_IASIL1C) 
  {
    NbIPR = 3; /* GIADR_QUA, GIADR_SCA et 1er MDR */
    
     m_ListeLigneMDR[0].GetData(LigneCourante);
     TypeRecordCourant = LigneCourante.TypeRec;
     TypeRecordPrecedent = TypeRecordCourant;

    if ((m_ModeTraitement == DUMP) && (m_PositionTraitement != FIRST))
    {
       /* si 1er record different du dernier record granule precedent 
        on ajoute un IPR */
	if(TypeRecordCourant != m_TypeLastRecord_1C)
	       NbIPR ++;
    }

    for (i = 1 ; i < m_ListeLigneMDR.size() ; i++)
    {
      m_ListeLigneMDR[i].GetData(LigneCourante);
      TypeRecordCourant = LigneCourante.TypeRec;

      if (TypeRecordCourant != TypeRecordPrecedent)
      {
        NbIPR++;
      } /* fin if (TypeRecordCourant != TypeRecordPrecedent) */
      TypeRecordPrecedent = TypeRecordCourant;
    } /* fin for (i = 1 ; i < m_ListeLigneMDR.size() ; i++) */
    m_NbIPR1C = NbIPR;
  }
/* ..FA 162 */
  
  if (descripteur_fichier->nature == NA_IASIL1ENG)
  {
  // correction FA 155  nombre IPR produit ENG
    NbIPR = 2; /* GIADR_ENG,et 1er MDR */
    if ( m_ListeLigneVIADR.size()> 0) 
    {
      NbIPR++;
      m_ListeLigneVIADR[0].GetData(LigneCourante);
      TypeRecordCourant = LigneCourante.TypeRec;
      TypeRecordPrecedent = TypeRecordCourant;
    
      for (i = 1 ; i < m_ListeLigneVIADR.size() ; i++)
      {
        m_ListeLigneVIADR[i].GetData(LigneCourante);
        TypeRecordCourant = LigneCourante.TypeRec;
        if (TypeRecordCourant != TypeRecordPrecedent)
        {
          NbIPR++;
        }
        TypeRecordPrecedent = TypeRecordCourant;
      }

      m_ListeLigneMDR[0].GetData(LigneCourante);
      TypeRecordCourant = LigneCourante.TypeRec;
      TypeRecordPrecedent = TypeRecordCourant;
    }
  //fin  correction IPR 155 nombre IPR produit ENG
/* FA 185 */
    else
    {
      /* si on  n'a pas de VIADR les types record ne sont pas mis a jour!
      => mise a jour ici */
      m_ListeLigneMDR[0].GetData(LigneCourante);
      TypeRecordCourant = LigneCourante.TypeRec;
      TypeRecordPrecedent = TypeRecordCourant;
    }
/* ..FA 185 */

/* FA 162 */
    if ((m_ModeTraitement == DUMP) && (m_PositionTraitement != FIRST))
    {
        /* si 1er record different du dernier record granule precedent 
	   on ajoute un IPR */
	if (TypeRecordCourant != m_TypeLastRecENG)
	   NbIPR ++;
    }
/* ..FA 162 */

    for (j = 1 ; j < m_ListeLigneMDR.size() ; j++)
    {
      m_ListeLigneMDR[j].GetData(LigneCourante);
      TypeRecordCourant = LigneCourante.TypeRec;
      if (TypeRecordCourant != TypeRecordPrecedent)
      {
        NbIPR++;
      } /* fin if (TypeRecordCourant != TypeRecordPrecedent) */
      TypeRecordPrecedent = TypeRecordCourant;
    } /* fin for (i = 1 ; i < m_ListeLigneMDR.size() ; i++) */
/* FA 162 + 180*/
   /* recuperation du nombre d'ipr trouves */
   m_NbIPRENG = NbIPR;
/* ..FA 162 + 180 */
  } /* fin if (descripteur_fichier->nature == NA_IASIL1ENG) */


  if (descripteur_fichier->nature == NA_IASIL1VER)
  {
    NbIPR = 1; /* 1er MDR */
    
    if (m_ListeLigneMDR.size() != 0)
    {
      m_ListeLigneMDR[0].GetData(LigneCourante);
      TypeRecordCourant = LigneCourante.TypeRec;
    }
    TypeRecordPrecedent = TypeRecordCourant;
/* FA 162 */
    if ((m_ModeTraitement == DUMP) && (m_PositionTraitement != FIRST))
    {
        /* si 1er record different du dernier record granule precedent 
	   on ajoute un IPR */
	if (TypeRecordCourant != m_TypeLastRecVER)
	   NbIPR ++;
    }
/* ..FA 162 */
    
    for (i = 1 ; i < m_ListeLigneMDR.size() ; i++)
    {
      m_ListeLigneMDR[i].GetData(LigneCourante);
      TypeRecordCourant = LigneCourante.TypeRec;
      if (TypeRecordCourant != TypeRecordPrecedent)
      {
        NbIPR++;
      } /* fin if (TypeRecordCourant != TypeRecordPrecedent) */
      TypeRecordPrecedent = TypeRecordCourant;
    } /* fin for(i = 1 ; i < m_ListeLigneMDR.size() ; i++) */
/* FA 162 + 180*/
   /* recuperation du nombre d'ipr trouves */
   m_NbIPRVER = NbIPR;
/* ..FA 162 + 180*/
  } /* fin if (nature_produit == NA_IASIL1VER) */

  /* on definit les champs des IPR */
  if (descripteur_fichier->nature == NA_IASIL1A)
  {
    j = 0;
    Offset = SD_BAS_OFFSET_IPR_N1 + NbIPR * SD_BAS_TAILLE_IPR;
    descripteur_fichier->descripteurIPR[j].Rec = TR_GIADR;
    descripteur_fichier->descripteurIPR[j].Instrument = IN_IASI;
    descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_GIADR_QUA_SUBCLASS;
    descripteur_fichier->descripteurIPR[j].Offset = Offset;
    j++;

    Offset = Offset + SD_BAS_TAILLE_MAX_GIADRQUAL;    
    descripteur_fichier->descripteurIPR[j].Rec = TR_GIADR;
    descripteur_fichier->descripteurIPR[j].Instrument = IN_IASI;
    descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_GIADR_SCA_SUBCLASS;
    descripteur_fichier->descripteurIPR[j].Offset = Offset;
    j++;
    
    m_ListeLigneMDR[0].GetData(LigneCourante);
    TypeRecordCourant = LigneCourante.TypeRec;
    TypeRecordPrecedent = TypeRecordCourant;
  
    Offset = Offset + SD_BAS_TAILLE_GIADR_SCA;

/* FA 162 */
    if (TypeRecordCourant == MDR_DUMMY)
    {
      InstrumentGroup = IN_DUMMY;
      /* on adapte la valeur de SUBCLASS comme dans SD_BAS_EcrireMDRN1() */
      descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_DUMMY_SUBCLASS;
    }
    else
    {
      InstrumentGroup = IN_IASI;
      descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_A_SUBCLASS;
    }
    
    descripteur_fichier->descripteurIPR[j].Rec = TR_MDR;
    descripteur_fichier->descripteurIPR[j].Instrument = InstrumentGroup;
    descripteur_fichier->descripteurIPR[j].Offset = Offset;
    j++;
    
    if ((m_ModeTraitement == DUMP) && (m_PositionTraitement != FIRST))
    {
        /* si 1er record different du dernier record granule precedent 
	   on ajoute un IPR , decrire cet ipr (en fait on recopie fois
	   le meme pour qu'il soit recupere dans decrireIPRDump) */
	if (TypeRecordCourant != m_TypeLastRecord_1A)
	{
            if (TypeRecordCourant == MDR_DUMMY)
            {
               InstrumentGroup = IN_DUMMY;
               /* on adapte la valeur de SUBCLASS comme dans SD_BAS_EcrireMDRN1() */
               descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_DUMMY_SUBCLASS;
            }
            else
            {
               InstrumentGroup = IN_IASI;
               descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_A_SUBCLASS;
            }
    
            descripteur_fichier->descripteurIPR[j].Rec = TR_MDR;
            descripteur_fichier->descripteurIPR[j].Instrument = InstrumentGroup;
            descripteur_fichier->descripteurIPR[j].Offset = Offset;
            j++;
	    
	}
    }
        
/* ..FA 162 */
    
    for (i = 1 ; i < m_ListeLigneMDR.size() ; i++)
    {
      m_ListeLigneMDR[i].GetData(LigneCourante);
      TypeRecordCourant = LigneCourante.TypeRec;
      
      if (TypeRecordCourant != TypeRecordPrecedent)
      {
        if (TypeRecordCourant == MDR_DUMMY)
        {
          InstrumentGroup = IN_DUMMY;
          Offset = Offset + SD_BAS_TAILLE_MAX_MDR_1AB;
          /* on adapte la valeur de SUBCLASS comme dans SD_BAS_EcrireMDRN1() */
	  descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_DUMMY_SUBCLASS;
        }
        else
        {
          InstrumentGroup = IN_IASI;
          Offset = Offset + SD_BAS_TAILLE_DUMMY;
	  descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_A_SUBCLASS;
        }
	
        descripteur_fichier->descripteurIPR[j].Rec = TR_MDR;
	descripteur_fichier->descripteurIPR[j].Instrument = InstrumentGroup;
	descripteur_fichier->descripteurIPR[j].Offset = Offset;
	j++;
      }
      else
      {
        if (TypeRecordPrecedent == MDR_DUMMY)
	{
	  Offset = Offset + SD_BAS_TAILLE_DUMMY;
	}
	else
	{
	  Offset = Offset + SD_BAS_TAILLE_MAX_MDR_1AB;
	}
      }
      TypeRecordPrecedent = TypeRecordCourant;
    }
/* FA 162 */
     /* recuperation du type du dernier record du granule courant */
    if (m_ListeLigneMDR.size() > 0)
     m_TypeLastRecord_1A = TypeRecordCourant;
    else
     m_TypeLastRecord_1A = MDR_DUMMY;
/* ..FA 162 */
  }
   
  if (descripteur_fichier->nature == NA_IASIL1B)
  {
    j = 0;
    Offset = SD_BAS_OFFSET_IPR_N1 + NbIPR * SD_BAS_TAILLE_IPR;    
    descripteur_fichier->descripteurIPR[j].Rec = TR_GIADR;
    descripteur_fichier->descripteurIPR[j].Instrument = IN_IASI;
    descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_GIADR_QUA_SUBCLASS;
    descripteur_fichier->descripteurIPR[j].Offset = Offset;
    j++;
    
    Offset = Offset + SD_BAS_TAILLE_MAX_GIADRQUAL;
    descripteur_fichier->descripteurIPR[j].Rec = TR_GIADR;
    descripteur_fichier->descripteurIPR[j].Instrument = IN_IASI;
    descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_GIADR_SCA_SUBCLASS;
    descripteur_fichier->descripteurIPR[j].Offset = Offset;
    j++;
    
    m_ListeLigneMDR[0].GetData(LigneCourante);
    TypeRecordCourant = LigneCourante.TypeRec;
    TypeRecordPrecedent = TypeRecordCourant;
    
    Offset = Offset + SD_BAS_TAILLE_GIADR_SCA;
    
/* FA 162 */
    if (TypeRecordCourant == MDR_DUMMY)
    {
      InstrumentGroup = IN_DUMMY;
      /* on adapte la valeur de SUBCLASS comme dans SD_BAS_EcrireMDRN1() */
      descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_DUMMY_SUBCLASS;
    }
    else
    {
      InstrumentGroup = IN_IASI;
      descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_B_SUBCLASS;
    }
    
    descripteur_fichier->descripteurIPR[j].Rec = TR_MDR;
    descripteur_fichier->descripteurIPR[j].Instrument = InstrumentGroup;
    descripteur_fichier->descripteurIPR[j].Offset = Offset;
    j++;

    if ( (m_ModeTraitement == DUMP) && (m_PositionTraitement != FIRST) )
    {
       /* si 1er record different du dernier record granule precedent 
	   on ajoute un IPR , decrire cet ipr (en fait on recopie fois
	   le meme pour qu'il soit recupere dans decrireIPRDump) */
	if ( (TypeRecordCourant != m_TypeLastRecord_1B) )
	{
             if (TypeRecordCourant == MDR_DUMMY)
            {
               InstrumentGroup = IN_DUMMY;
               /* on adapte la valeur de SUBCLASS comme dans SD_BAS_EcrireMDRN1() */
               descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_DUMMY_SUBCLASS;
            }
            else
            {
               InstrumentGroup = IN_IASI;
               descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_B_SUBCLASS;
            }
    
            descripteur_fichier->descripteurIPR[j].Rec = TR_MDR;
            descripteur_fichier->descripteurIPR[j].Instrument = InstrumentGroup;
            descripteur_fichier->descripteurIPR[j].Offset = Offset;
            j++;
	
	}/* fin recopie */
    }
        
/* ..FA 162 */
    
    for (i = 1 ; i < m_ListeLigneMDR.size() ; i++)
    {
      m_ListeLigneMDR[i].GetData(LigneCourante);
      TypeRecordCourant = LigneCourante.TypeRec;
      
      if (TypeRecordCourant != TypeRecordPrecedent)
      {
        if (TypeRecordCourant == MDR_DUMMY)
        {
          InstrumentGroup = IN_DUMMY;
          Offset = Offset + SD_BAS_TAILLE_MAX_MDR_1AB;
          /* on adapte la valeur de SUBCLASS comme dans SD_BAS_EcrireMDRN1() */
	  descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_DUMMY_SUBCLASS;
        }
        else
        {
          InstrumentGroup = IN_IASI;
          Offset = Offset + SD_BAS_TAILLE_DUMMY;
	  descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_B_SUBCLASS;
        }
    
        descripteur_fichier->descripteurIPR[j].Rec = TR_MDR;
	descripteur_fichier->descripteurIPR[j].Instrument = InstrumentGroup;
	descripteur_fichier->descripteurIPR[j].Offset = Offset;
	j++;
      }
      else
      {
        if (TypeRecordPrecedent == MDR_DUMMY)
	{
	  Offset = Offset + SD_BAS_TAILLE_DUMMY;
	}
	else
	{
	  Offset = Offset + SD_BAS_TAILLE_MAX_MDR_1AB;
	}
      }
      TypeRecordPrecedent = TypeRecordCourant;
    }
/* FA 162 */
     /* recuperation du type du dernier record du granule courant */
    if (m_ListeLigneMDR.size() > 0)
      m_TypeLastRecord_1B = TypeRecordCourant;
    else
      m_TypeLastRecord_1B = MDR_DUMMY;
/* ..FA 162 */
  }
  
  if (descripteur_fichier->nature == NA_IASIL1C)
  {
    j = 0;
    Offset = SD_BAS_OFFSET_IPR_N1 + NbIPR * SD_BAS_TAILLE_IPR;
    descripteur_fichier->descripteurIPR[j].Rec = TR_GIADR;
    descripteur_fichier->descripteurIPR[j].Instrument = IN_IASI;
    descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_GIADR_QUA_SUBCLASS;
    descripteur_fichier->descripteurIPR[j].Offset = Offset;
    j++;
    
    Offset = Offset + SD_BAS_TAILLE_MAX_GIADRQUAL;
    descripteur_fichier->descripteurIPR[j].Rec = TR_GIADR;
    descripteur_fichier->descripteurIPR[j].Instrument = IN_IASI;
    descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_GIADR_SCA_SUBCLASS;
    descripteur_fichier->descripteurIPR[j].Offset = Offset;
    j++;
    
    m_ListeLigneMDR[0].GetData(LigneCourante);
    TypeRecordCourant = LigneCourante.TypeRec;
    TypeRecordPrecedent = TypeRecordCourant;
    
    Offset = Offset + SD_BAS_TAILLE_GIADR_SCA;
    
/* FA 162 */
    if (TypeRecordCourant == MDR_DUMMY)
    {
      InstrumentGroup = IN_DUMMY;
      /* on adapte la valeur de SUBCLASS comme dans SD_BAS_EcrireMDRN1() */
      descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_DUMMY_SUBCLASS;
    }
    else
    {
      InstrumentGroup = IN_IASI;
      descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_C_SUBCLASS;
    }
    
    descripteur_fichier->descripteurIPR[j].Rec = TR_MDR;
    descripteur_fichier->descripteurIPR[j].Instrument = InstrumentGroup;
    descripteur_fichier->descripteurIPR[j].Offset = Offset;
    j++; 
       
    if ((m_ModeTraitement == DUMP) && (m_PositionTraitement != FIRST))
    {
        /* si 1er record different du dernier record granule precedent 
	   on ajoute un IPR , decrire cet ipr (en fait on recopie fois
	   le meme pour qu'il soit recupere dans decrireIPRDump) */
	if (TypeRecordCourant != m_TypeLastRecord_1C)
	{
            if (TypeRecordCourant == MDR_DUMMY)
            {
               InstrumentGroup = IN_DUMMY;
               /* on adapte la valeur de SUBCLASS comme dans SD_BAS_EcrireMDRN1() */
               descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_DUMMY_SUBCLASS;
            }
            else
            {
               InstrumentGroup = IN_IASI;
               descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_C_SUBCLASS;
            }
    
            descripteur_fichier->descripteurIPR[j].Rec = TR_MDR;
            descripteur_fichier->descripteurIPR[j].Instrument = InstrumentGroup;
            descripteur_fichier->descripteurIPR[j].Offset = Offset;
            j++;
	
	}
    }
        
/* ..FA 162 */

    for (i = 1 ; i < m_ListeLigneMDR.size() ; i++)
    {
      m_ListeLigneMDR[i].GetData(LigneCourante);
      TypeRecordCourant = LigneCourante.TypeRec;
      
      if (TypeRecordCourant != TypeRecordPrecedent)
      {
        if (TypeRecordCourant == MDR_DUMMY)
        {
          InstrumentGroup = IN_DUMMY;
          Offset = Offset + SD_BAS_TAILLE_MAX_MDR_1C;
          /* on adapte la valeur de SUBCLASS comme dans SD_BAS_EcrireMDRN1() */
	  descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_DUMMY_SUBCLASS;
        }
        else
        {
          InstrumentGroup = IN_IASI;
          Offset = Offset + SD_BAS_TAILLE_DUMMY;
	  descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_C_SUBCLASS;
        }
	
        descripteur_fichier->descripteurIPR[j].Rec = TR_MDR;
	descripteur_fichier->descripteurIPR[j].Instrument = InstrumentGroup;
	descripteur_fichier->descripteurIPR[j].Offset = Offset;
	j++;
      }
      else
      {
        if (TypeRecordPrecedent == MDR_DUMMY)
	{
	  Offset = Offset + SD_BAS_TAILLE_DUMMY;
	}
	else
	{
	  Offset = Offset + SD_BAS_TAILLE_MAX_MDR_1C;
	}
      }
      TypeRecordPrecedent = TypeRecordCourant;
    }
 /* FA 162 */
     /* recuperation du type du dernier record du granule courant */
    if (m_ListeLigneMDR.size() > 0)
     m_TypeLastRecord_1C = TypeRecordCourant;
    else
     m_TypeLastRecord_1C = MDR_DUMMY;
/* ..FA 162 */
  }
 
  if (descripteur_fichier->nature == NA_IASIL1ENG)
  {
    j = 0;
    Offset = SD_BAS_OFFSET_IPR_N1 + NbIPR * SD_BAS_TAILLE_IPR;
    descripteur_fichier->descripteurIPR[j].Rec = TR_GIADR;
    descripteur_fichier->descripteurIPR[j].Instrument = IN_IASI;
    descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_GIADR_ENG_SUBCLASS;
    descripteur_fichier->descripteurIPR[j].Offset = Offset;
    j++;
    // correction FA 155 nb IPR produit ENG
    if ( m_ListeLigneVIADR.size()> 0) 
    {
    
      m_ListeLigneVIADR[0].GetData(LigneCourante);
      TypeRecordCourant = LigneCourante.TypeRec;
      TypeRecordPrecedent = TypeRecordCourant;
    
      Offset = Offset + SD_BAS_TAILLE_MAX_GIADR_ENG;
    
      if (TypeRecordCourant == VIADR_DUMMY)
      {
        InstrumentGroup = IN_DUMMY;
      /* on ne change pas la valeur de SUBCLASS cf SD_BAS_EcrireVIADRN1() */
      }
      else
      {
        InstrumentGroup = IN_IASI;
      }
    
      descripteur_fichier->descripteurIPR[j].Rec = TR_VIADR;
      descripteur_fichier->descripteurIPR[j].Instrument = InstrumentGroup;
      descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_VIADR_ENG_SUBCLASS;
      descripteur_fichier->descripteurIPR[j].Offset = Offset;
      j++;
    
      for (i = 1 ; i < m_ListeLigneVIADR.size() ; i++)
      {
        m_ListeLigneVIADR[i].GetData(LigneCourante);
        TypeRecordCourant = LigneCourante.TypeRec;
      
/* FA 162 */
	  Offset = Offset + SD_BAS_TAILLE_MAX_VIADRENG;
/* ..FA 162 */
        TypeRecordPrecedent = TypeRecordCourant;
      }
    }
   // fin correction FA 155 nb IPR produit ENG


    m_ListeLigneMDR[0].GetData(LigneCourante);
    TypeRecordCourant = LigneCourante.TypeRec;

/* FA 185*/
if (m_ListeLigneVIADR.size() > 0)
{
    Offset = Offset + SD_BAS_TAILLE_MAX_VIADRENG;
}/* fin si il y a des VIADR */
else
{
   Offset = Offset + SD_BAS_TAILLE_MAX_GIADR_ENG;
}
/* ..FA 185 */ 
    
    TypeRecordPrecedent = TypeRecordCourant;
    
/* FA 162 */
    if (TypeRecordCourant == MDR_DUMMY)
    {
      InstrumentGroup = IN_DUMMY;
      /* on adapte la valeur de SUBCLASS comme dans SD_BAS_EcrireMDRN1() */
      descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_DUMMY_SUBCLASS;
    }
    else
    {
      InstrumentGroup = IN_IASI;
      descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_ENG_SUBCLASS;
    }
    
    descripteur_fichier->descripteurIPR[j].Rec = TR_MDR;
    descripteur_fichier->descripteurIPR[j].Instrument = InstrumentGroup;
    descripteur_fichier->descripteurIPR[j].Offset = Offset;
    j++;
    
    if ((m_ModeTraitement == DUMP) && (m_PositionTraitement != FIRST))
    {
        /* si 1er record different du dernier record granule precedent 
	   on ajoute un IPR , decrire cet ipr (en fait on recopie fois
	   le meme pour qu'il soit recupere dans decrireIPRDump) */
	if ( TypeRecordCourant != m_TypeLastRecENG )
	{
            if (TypeRecordCourant == MDR_DUMMY)
            {
               InstrumentGroup = IN_DUMMY;
               /* on adapte la valeur de SUBCLASS comme dans SD_BAS_EcrireMDRN1() */
               descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_DUMMY_SUBCLASS;
            }
            else
            {
               InstrumentGroup = IN_IASI;
               descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_ENG_SUBCLASS;
            }
    
            descripteur_fichier->descripteurIPR[j].Rec = TR_MDR;
            descripteur_fichier->descripteurIPR[j].Instrument = InstrumentGroup;
            descripteur_fichier->descripteurIPR[j].Offset = Offset;
            j++;
	    
	}
    }
/* ..FA 162 */
    
    for (i = 1 ; i < m_ListeLigneMDR.size() ; i++)
    {
      m_ListeLigneMDR[i].GetData(LigneCourante);
      TypeRecordCourant = LigneCourante.TypeRec;
      
      if (TypeRecordCourant != TypeRecordPrecedent)
      {
        if (TypeRecordCourant == MDR_DUMMY)
        {
          InstrumentGroup = IN_DUMMY;
          Offset = Offset + SD_BAS_TAILLE_MAX_MDRENG;
          /* on adapte la valeur de SUBCLASS comme dans SD_BAS_EcrireMDRN1() */
	  descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_DUMMY_SUBCLASS;
        }
        else
        {
          InstrumentGroup = IN_IASI;
          Offset = Offset + SD_BAS_TAILLE_DUMMY;
	  descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_ENG_SUBCLASS;
        }
	
        descripteur_fichier->descripteurIPR[j].Rec = TR_MDR;
	descripteur_fichier->descripteurIPR[j].Instrument = InstrumentGroup;
	descripteur_fichier->descripteurIPR[j].Offset = Offset;
	j++;
      }
      else
      {
        if (TypeRecordPrecedent == MDR_DUMMY)
	{
	  Offset = Offset + SD_BAS_TAILLE_DUMMY;
	}
	else
	{
	  Offset = Offset + SD_BAS_TAILLE_MAX_MDRENG;
	}
      }
      TypeRecordPrecedent = TypeRecordCourant;
    }
/* FA 162 */
     /* recuperation du type du dernier record du granule courant */
    if (m_ListeLigneMDR.size() > 0)
     m_TypeLastRecENG= TypeRecordCourant;
    else
     m_TypeLastRecENG= MDR_DUMMY;
/* ..FA 162 */
  }

  if (descripteur_fichier->nature == NA_IASIL1VER)
  {
    j = 0;
    m_ListeLigneMDR[0].GetData(LigneCourante);
    TypeRecordCourant = LigneCourante.TypeRec;
    TypeRecordPrecedent = TypeRecordCourant;
    
    Offset = SD_BAS_OFFSET_IPR_N1 + NbIPR * SD_BAS_TAILLE_IPR;
    
/* FA 162 */
    if (TypeRecordCourant == MDR_DUMMY)
    {
      InstrumentGroup = IN_DUMMY;
      /* on adapte la valeur de SUBCLASS comme dans SD_BAS_EcrireMDRN1() */
      descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_DUMMY_SUBCLASS;
    }
    else
    {
      InstrumentGroup = IN_IASI;
      
      /* FA170 */
      descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_VER_SUBCLASS;
    }
    
    descripteur_fichier->descripteurIPR[j].Rec = TR_MDR;
    descripteur_fichier->descripteurIPR[j].Instrument = InstrumentGroup;
    descripteur_fichier->descripteurIPR[j].Offset = Offset;
    j++;
    
    if ((m_ModeTraitement == DUMP) && (m_PositionTraitement != FIRST))
    {
        /* si 1er record different du dernier record granule precedent 
	   on ajoute un IPR , decrire cet ipr (en fait on recopie fois
	   le meme pour qu'il soit recupere dans decrireIPRDump) */
	if (TypeRecordCourant != m_TypeLastRecVER)
	{
            if (TypeRecordCourant == MDR_DUMMY)
            {
               InstrumentGroup = IN_DUMMY;
               /* on adapte la valeur de SUBCLASS comme dans SD_BAS_EcrireMDRN1() */
               descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_DUMMY_SUBCLASS;
            }
            else
            {
               InstrumentGroup = IN_IASI;
               descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_VER_SUBCLASS;
            }
    
            descripteur_fichier->descripteurIPR[j].Rec = TR_MDR;
            descripteur_fichier->descripteurIPR[j].Instrument = InstrumentGroup;
            descripteur_fichier->descripteurIPR[j].Offset = Offset;
            j++;
	    
	}
    }
        
/* ..FA 162 */
    TailleRecordPrecedent = 
      4 + 
      SD_BAS_TAILLE_GRH + 
      *(LigneCourante.InfoDet.tab_var[VER_SIZE_OF_VERIFICATION_DATA].val.pui4);
    
    for (i = 1 ; i < m_ListeLigneMDR.size() ; i++)
    {
      m_ListeLigneMDR[i].GetData(LigneCourante);
      TypeRecordCourant = LigneCourante.TypeRec;
      
      if (TypeRecordCourant != TypeRecordPrecedent)
      {
        if (TypeRecordCourant == MDR_DUMMY)
        {
          InstrumentGroup = IN_DUMMY;
          Offset = Offset + TailleRecordPrecedent;
          /* on adapte la valeur de SUBCLASS comme dans SD_BAS_EcrireMDRN1() */
	  descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_DUMMY_SUBCLASS;
        }
        else
        {
          InstrumentGroup = IN_IASI;
	  Offset = Offset + SD_BAS_TAILLE_DUMMY;
	  descripteur_fichier->descripteurIPR[j].subclass = SD_BAS_MDR_VER_SUBCLASS;
        }
	
        descripteur_fichier->descripteurIPR[j].Rec = TR_MDR;
	descripteur_fichier->descripteurIPR[j].Instrument = InstrumentGroup;
	descripteur_fichier->descripteurIPR[j].Offset = Offset;
	j++;
      }
      else
      {
        if (TypeRecordPrecedent == MDR_DUMMY)
	{
	  Offset = Offset + SD_BAS_TAILLE_DUMMY;
	}
	else
	{
	  Offset = Offset + TailleRecordPrecedent;
	}
      }
      TypeRecordPrecedent = TypeRecordCourant;
      TailleRecordPrecedent = 
        4 + 
        SD_BAS_TAILLE_GRH + 
        *(LigneCourante.InfoDet.tab_var[VER_SIZE_OF_VERIFICATION_DATA].val.pui4);
    } /* fin for(i = 1 ; i < m_ListeLigneMDR.size() ; i++) */
/* FA 162 */
     /* recuperation du type du dernier record du granule courant */
    if (m_ListeLigneMDR.size() > 0)
     m_TypeLastRecVER = TypeRecordCourant;
    else
     m_TypeLastRecVER = MDR_DUMMY;
/* ..FA 162 */
  } /* fin if (nature_produit == NA_IASIL1VER) */


#ifdef OPS_DEBUG
  cout << " descripteur_fichier->nature = " 
       << descripteur_fichier->nature << endl
       << " NbIPR = " << NbIPR << endl
       << " SD_BAS_OFFSET_IPR_N1 = " << SD_BAS_OFFSET_IPR_N1 << endl
       << " SD_BAS_TAILLE_IPR    = " << SD_BAS_TAILLE_IPR << endl
       << " types descripteurIPR.Rec:" << endl
       << "  TR_UNDEFINED = " << TR_UNDEFINED << endl
       << "  TR_MPHR      = " << TR_MPHR << endl
       << "  TR_SPHR      = " << TR_SPHR << endl
       << "  TR_IPR       = " << TR_IPR << endl
       << "  TR_GEADR     = " << TR_GEADR << endl
       << "  TR_GIADR     = " << TR_GIADR << endl
       << "  TR_VEADR     = " << TR_VEADR << endl
       << "  TR_VIADR     = " << TR_VIADR << endl
       << "  TR_MDR       = " << TR_MDR << endl
       << " types descripteurIPR.Instrument:" << endl
       << "  IN_IASI  = " << IN_IASI << endl
       << "  IN_AVHRR = " << IN_AVHRR << endl
       << "  IN_DUMMY = " << IN_DUMMY << endl
       << " types descripteurIPR.subclass:" << endl
       << "  SD_BAS_MDR_A_SUBCLASS     = " << SD_BAS_MDR_A_SUBCLASS << endl
       << "  SD_BAS_MDR_B_SUBCLASS     = " << SD_BAS_MDR_B_SUBCLASS << endl
       << "  SD_BAS_MDR_C_SUBCLASS     = " << SD_BAS_MDR_C_SUBCLASS << endl
       << "  SD_BAS_MDR_ENG_SUBCLASS   = " << SD_BAS_MDR_ENG_SUBCLASS << endl
       << "  SD_BAS_MDR_VER_SUBCLASS   = " << SD_BAS_MDR_VER_SUBCLASS << endl
       << "  SD_BAS_MDR_DUMMY_SUBCLASS = " << SD_BAS_MDR_DUMMY_SUBCLASS << endl
       << "  SD_BAS_GIADR_SCA_SUBCLASS = " << SD_BAS_GIADR_SCA_SUBCLASS << endl
       << "  SD_BAS_GIADR_QUA_SUBCLASS = " << SD_BAS_GIADR_QUA_SUBCLASS << endl
       << "  SD_BAS_GIADR_ENG_SUBCLASS = " << SD_BAS_GIADR_ENG_SUBCLASS << endl
       << "  SD_BAS_VIADR_ENG_SUBCLASS = " << SD_BAS_VIADR_ENG_SUBCLASS << endl;
  
  for (j = 0 ; j < NbIPR ; j++)
  {
    cout << " descripteurIPR[" << j << "].Rec = " 
         << descripteur_fichier->descripteurIPR[j].Rec << endl
	 << " descripteurIPR[" << j << "].Instrument = " 
	 << descripteur_fichier->descripteurIPR[j].Instrument << endl
	 << " descripteurIPR[" << j << "].subclass = " 
	 << descripteur_fichier->descripteurIPR[j].subclass << endl
	 << " descripteurIPR[" << j << "].Offset = " 
	 << descripteur_fichier->descripteurIPR[j].Offset << endl
	 << "" << endl;
  }
#endif

}/* fin de SD_DON_GranuleN1::DecrireIPR */

/* FA 162*/
//@ ------------------------------------------------------------------*/
//@ Methode : DecrireIPRDump
//@
//@ Description : cette methode permet de decrire les champs 
//@ TARGET_RECORD_CLASS, TARGET_INSTRUMENT_GROUP, TARGET_RECORD_SUBCLASS et
//@ TARGET_RECORD_OFFSET des IPR
//@
//@ Parametres :
//@   (ENTREE/SORTIE) descripteur_fichier : descripteur du fichier associe 
//@                   au produit
//@
//@ Valeur de retour : 
//@               Aucune
//@
//@ ------------------------------------------------------------------*/
void SD_DON_GranuleN1::DecrireIPRDump(
  t_SD_BAS_Fd * descripteur_fichier,
  t_SD_BAS_DataThread *ctx)

{
    t_CMN__Statut    cr_op = CMN__STATUT_OK;
    unsigned int     NbIPRTotal;
    unsigned int     nvxNbIpr;
    unsigned int     NbIprMin;
    unsigned int     NbIprSuppl;
    t_SD_BAS_Produit descripteurIPRGlobal[SD_BAS_NB_MAX_IPR];
    int		     i,j;
    unsigned int     NewOffset;
    off_t            taille_mdr = 0;
    off_t            PositionCourante;
    t_CMN__Booleen   bPresenceViadrCourant = CMN__FAUX;
    t_CMN__Booleen   bPresenceViadrGlobal = CMN__FAUX;
    
   /* Init NbIprMin NbIprTotal*/
   if ( descripteur_fichier->nature == NA_IASIL1A )
   {
        NbIprMin =3;  
       /* recuperer nb IPR deja ecrits */
        NbIPRTotal = m_NbIPR1A;
   }
   else if ( descripteur_fichier->nature == NA_IASIL1B )
   {
        NbIprMin =3;  
       /* recuperer nb IPR deja ecrits */
        NbIPRTotal = m_NbIPR1B;
   }
   else if ( descripteur_fichier->nature == NA_IASIL1C )
   {
        NbIprMin =3;  
       /* recuperer nb IPR deja ecrits */
        NbIPRTotal = m_NbIPR1C;
   }
   else if (descripteur_fichier->nature == NA_IASIL1VER)
   {
        NbIprMin =1;  
       /* recuperer nb IPR deja ecrits */
        NbIPRTotal = m_NbIPRVER;
   }
   else if (descripteur_fichier->nature == NA_IASIL1ENG)/* fichier ENG */
   {
        NbIprMin =2;  
       /* recuperer nb IPR deja ecrits */
        NbIPRTotal = m_NbIPRENG;
   }
   else /* erreur  a MAJ !!!*/
   {
            TraiterErreurBAS(ctx, 
                           ERR__Exception::SD_DON_FILE_OPEN, 
                           m_NomGranule);
 
   }

cout << "DecrireIPRDump :: NbIPRTotal = " << NbIPRTotal <<endl; 
   

   /* Lire les ipr deja ecrits */
   cr_op = SD_BAS_LireIPRDump(descripteur_fichier, ctx); 
   if(cr_op != CMN__STATUT_OK) 
   {
          TraiterErreurBAS(ctx, 
                           ERR__Exception::SD_DON_FILE_OPEN, 
                           m_NomGranule);
   }
   
   
   /* sauvegarder les IPR precedemment ecrits dans une structure tempo car descripteur_fichier->descripteurIPR
   sera ecrasee a l'appel de decrireIPR pour le granule courant */
  for (i = 0 ; i < NbIPRTotal ; i++)
  {
    descripteurIPRGlobal[i].Rec = descripteur_fichier->descripteurIPR[i].Rec;
    descripteurIPRGlobal[i].Instrument = descripteur_fichier->descripteurIPR[i].Instrument;
    descripteurIPRGlobal[i].subclass = descripteur_fichier->descripteurIPR[i].subclass;
    descripteurIPRGlobal[i].Offset = descripteur_fichier->descripteurIPR[i].Offset;      
  }
   
   /** initialisation des booleens **/
   if (m_ListeLigneVIADR.size()!=0)
       bPresenceViadrCourant = CMN__VRAI;
   if (descripteurIPRGlobal[1].Rec == TR_VIADR)
       bPresenceViadrGlobal = CMN__VRAI;
   
   /** taille du fichier secondaire MDR **/
   /* on memorise la position courante du descripteur du fichier secondaire*/
   PositionCourante = ftello(descripteur_fichier->fd_sec);
   /* on se place en fin de fichier secondaire */
   cr_op = fseeko(descripteur_fichier->fd_sec, 0, SEEK_END);
   if(cr_op != CMN__STATUT_OK) 
   {
          TraiterErreurBAS(ctx, 
                           ERR__Exception::SD_DON_FILE_OPEN, 
                           m_NomGranule);
   }
   /* on recupere la taille du fichier */
   taille_mdr = ftello(descripteur_fichier->fd_sec);
   /* on se replace en position initiale */
   cr_op = fseeko(descripteur_fichier->fd_sec, PositionCourante, SEEK_SET);
   if(cr_op != CMN__STATUT_OK) 
   {
          TraiterErreurBAS(ctx, 
                           ERR__Exception::SD_DON_FILE_OPEN, 
                           m_NomGranule);
   }
   
   /** decrire les IPR du granule courant **/
   DecrireIPR(descripteur_fichier);
  
   /** mettre a jour la structure avec les ipr sauvegardes et les ipr courants **/
   /** fichier 1A **/
   /*-------------------------------------------------------------------------*/
   if ( descripteur_fichier->nature == NA_IASIL1A )
   {
     
     if (m_NbIPR1A == NbIprMin)
     {
        /* on conserve le nb d'ipr global  */
	nvxNbIpr = NbIPRTotal;
	/* on recupere les IPR precedemment ecrits */
	for (i = 0 ; i < NbIPRTotal; i++)
	{
	   descripteur_fichier->descripteurIPR[i].Rec = descripteurIPRGlobal[i].Rec;
	   descripteur_fichier->descripteurIPR[i].Instrument = descripteurIPRGlobal[i].Instrument;
	   descripteur_fichier->descripteurIPR[i].subclass = descripteurIPRGlobal[i].subclass;
	   descripteur_fichier->descripteurIPR[i].Offset = descripteurIPRGlobal[i].Offset;	
	}
     }
     
     if (m_NbIPR1A > NbIprMin) /* il y a des DMDR */
     {
	/* mise a jour du nb total d'ipr et du nb d'ipr supplementaires */
	nvxNbIpr = NbIPRTotal + m_NbIPR1A - NbIprMin;
	NbIprSuppl =  m_NbIPR1A - NbIprMin;
	
	/** mise a jour de la structure **/
	/* Tous les ipr precedents sont decales de n IPR suppl.*/
	for (i = 0 ; i < NbIPRTotal; i++)
	{
	   descripteurIPRGlobal[i].Offset = descripteurIPRGlobal[i].Offset + 
	   					NbIprSuppl*SD_BAS_TAILLE_IPR;	    
	}
	/* mise a jour des ipr suppl.*/
	NewOffset = descripteurIPRGlobal[NbIprMin-1].Offset + taille_mdr;
	j = 3;
	for (i = NbIPRTotal ; i < nvxNbIpr; i++)
	{
	   descripteurIPRGlobal[i].Rec = descripteur_fichier->descripteurIPR[j].Rec;
	   descripteurIPRGlobal[i].Instrument = descripteur_fichier->descripteurIPR[j].Instrument;
	   descripteurIPRGlobal[i].subclass = descripteur_fichier->descripteurIPR[j].subclass;
	   descripteurIPRGlobal[i].Offset = NewOffset +
	                                    descripteur_fichier->descripteurIPR[j].Offset - 
					    descripteur_fichier->descripteurIPR[NbIprMin-1].Offset;
	   j ++;
	}
	  
	  
	/* on conserve la nouvelle structure mise a jour */
	for (i = 0 ; i < nvxNbIpr; i++)
	{
	   descripteur_fichier->descripteurIPR[i].Rec = descripteurIPRGlobal[i].Rec;
	   descripteur_fichier->descripteurIPR[i].Instrument = descripteurIPRGlobal[i].Instrument;
	   descripteur_fichier->descripteurIPR[i].subclass = descripteurIPRGlobal[i].subclass;
	   descripteur_fichier->descripteurIPR[i].Offset = descripteurIPRGlobal[i].Offset;
	}
	  
     }/* fin si il y a des DMDR */
     /* on conserve le nouveaux nb d'ipr a ecrire */
     m_NbIPR1A = nvxNbIpr ;
     
   }/* fin si fichier 1A  */

   /** fichier 1B **/
   /*-------------------------------------------------------------------------*/
   if ( descripteur_fichier->nature == NA_IASIL1B )
   {
     
     if (m_NbIPR1B == NbIprMin)
     {
        nvxNbIpr = NbIPRTotal;
	/* on recupere les IPR precedemment ecrits */
	for (i = 0 ; i < NbIPRTotal; i++)
	{
	   descripteur_fichier->descripteurIPR[i].Rec = descripteurIPRGlobal[i].Rec;
	   descripteur_fichier->descripteurIPR[i].Instrument = descripteurIPRGlobal[i].Instrument;
	   descripteur_fichier->descripteurIPR[i].subclass = descripteurIPRGlobal[i].subclass;
	   descripteur_fichier->descripteurIPR[i].Offset = descripteurIPRGlobal[i].Offset;	
	}
     }
     
     if (m_NbIPR1B > NbIprMin) /* il y a des DMDR */
     {
	/* mise a jour du nb total d'ipr et du nb d'ipr supplementaires */
	nvxNbIpr = NbIPRTotal + m_NbIPR1B -NbIprMin;
	NbIprSuppl =  m_NbIPR1B - NbIprMin;
        
        /* mise a jour de la structure */
	/* Tous les ipr precedents sont decales de n IPR suppl.*/
	for (i = 0 ; i < NbIPRTotal; i++)
	{
	   descripteurIPRGlobal[i].Offset = descripteurIPRGlobal[i].Offset + 
	   					NbIprSuppl*SD_BAS_TAILLE_IPR;	    
	}
	/* mise a jour des ipr suppl.*/
	NewOffset = descripteurIPRGlobal[NbIprMin-1].Offset + taille_mdr;
	j = 3;
	for (i = NbIPRTotal ; i < nvxNbIpr; i++)
	{
	   descripteurIPRGlobal[i].Rec = descripteur_fichier->descripteurIPR[j].Rec;
	   descripteurIPRGlobal[i].Instrument = descripteur_fichier->descripteurIPR[j].Instrument;
	   descripteurIPRGlobal[i].subclass = descripteur_fichier->descripteurIPR[j].subclass;
	   descripteurIPRGlobal[i].Offset = NewOffset +
	                                    descripteur_fichier->descripteurIPR[j].Offset - 
					    descripteur_fichier->descripteurIPR[NbIprMin-1].Offset;
	   j ++;
	}
	  
	/* on conserve la nouvelle structure mise a jour */
	for (i = 0 ; i < nvxNbIpr; i++)
	{
	   descripteur_fichier->descripteurIPR[i].Rec = descripteurIPRGlobal[i].Rec;
	   descripteur_fichier->descripteurIPR[i].Instrument = descripteurIPRGlobal[i].Instrument;
	   descripteur_fichier->descripteurIPR[i].subclass = descripteurIPRGlobal[i].subclass;
	   descripteur_fichier->descripteurIPR[i].Offset = descripteurIPRGlobal[i].Offset;
	}
	  
     }/* fin si il y a des DMDR */
	/* on conserve le nouveaux nb d'ipr a ecrire */
         m_NbIPR1B = nvxNbIpr ;
	  
   }/* fin si fichier 1B  */


   /** fichier 1C **/
   /*-------------------------------------------------------------------------*/
   if ( descripteur_fichier->nature == NA_IASIL1C )
   {
     
     if (m_NbIPR1C == NbIprMin)
     {
        nvxNbIpr = NbIPRTotal;
	/* on recupere les IPR precedemment ecrits */
	for (i = 0 ; i < NbIPRTotal; i++)
	{
	   descripteur_fichier->descripteurIPR[i].Rec = descripteurIPRGlobal[i].Rec;
	   descripteur_fichier->descripteurIPR[i].Instrument = descripteurIPRGlobal[i].Instrument;
	   descripteur_fichier->descripteurIPR[i].subclass = descripteurIPRGlobal[i].subclass;
	   descripteur_fichier->descripteurIPR[i].Offset = descripteurIPRGlobal[i].Offset;	
	}
     }
     
     if (m_NbIPR1C > NbIprMin) /* il y a des DMDR */
     {
	/* mise a jour du nb total d'ipr et du nb d'ipr supplementaires */
	nvxNbIpr = NbIPRTotal + m_NbIPR1C -NbIprMin;
	NbIprSuppl = m_NbIPR1C - NbIprMin;

        /* mise a jour de la structure */
	/* Tous les ipr precedents sont decales de n IPR suppl.*/
	for (i = 0 ; i < NbIPRTotal; i++)
	{
	   descripteurIPRGlobal[i].Offset = descripteurIPRGlobal[i].Offset + 
	   					NbIprSuppl*SD_BAS_TAILLE_IPR;	    
	}
	/* mise a jour des ipr suppl.*/
	NewOffset = descripteurIPRGlobal[NbIprMin-1].Offset + taille_mdr;
	j = 3;
	for (i = NbIPRTotal ; i < nvxNbIpr; i++)
	{
	   descripteurIPRGlobal[i].Rec = descripteur_fichier->descripteurIPR[j].Rec;
	   descripteurIPRGlobal[i].Instrument = descripteur_fichier->descripteurIPR[j].Instrument;
	   descripteurIPRGlobal[i].subclass = descripteur_fichier->descripteurIPR[j].subclass;
	   descripteurIPRGlobal[i].Offset = NewOffset +
	                                    descripteur_fichier->descripteurIPR[j].Offset - 
					    descripteur_fichier->descripteurIPR[NbIprMin-1].Offset;
	   j ++;
	}
	  
	/* on conserve la nouvelle structure mise a jour */
	for (i = 0 ; i < nvxNbIpr; i++)
	{
	   descripteur_fichier->descripteurIPR[i].Rec = descripteurIPRGlobal[i].Rec;
	   descripteur_fichier->descripteurIPR[i].Instrument = descripteurIPRGlobal[i].Instrument;
	   descripteur_fichier->descripteurIPR[i].subclass = descripteurIPRGlobal[i].subclass;
	   descripteur_fichier->descripteurIPR[i].Offset = descripteurIPRGlobal[i].Offset;
	}
	  
     }/* fin si il y a des DMDR */
	  
	/* on conserve le nouveaux nb d'ipr a ecrire */
         m_NbIPR1C = nvxNbIpr ;
	 
   }/* fin si fichier 1C  */

      
   /** Fichier VER **/
   /*-------------------------------------------------------------------------*/
   if (descripteur_fichier->nature == NA_IASIL1VER)
   {
     
     if (m_NbIPRVER == NbIprMin)
     {
        nvxNbIpr = NbIPRTotal;
	/* on recupere les IPR precedemment ecrits */
	for (i = 0 ; i < NbIPRTotal; i++)
	{
	   descripteur_fichier->descripteurIPR[i].Rec = descripteurIPRGlobal[i].Rec;
	   descripteur_fichier->descripteurIPR[i].Instrument = descripteurIPRGlobal[i].Instrument;
	   descripteur_fichier->descripteurIPR[i].subclass = descripteurIPRGlobal[i].subclass;
	   descripteur_fichier->descripteurIPR[i].Offset = descripteurIPRGlobal[i].Offset;	
	}
     }
     
     if (m_NbIPRVER > NbIprMin) /* il y a des DMDR */
     {
	/* mise a jour du nb total d'ipr */
	nvxNbIpr = NbIPRTotal + m_NbIPRVER - NbIprMin;
	NbIprSuppl = m_NbIPRVER - NbIprMin;

        /* mise a jour de la structure */
	/* Tous les ipr precedents sont decales de n IPR suppl.*/
	for (i = 0 ; i < NbIPRTotal; i++)
	{
	   descripteurIPRGlobal[i].Offset = descripteurIPRGlobal[i].Offset + 
	   					NbIprSuppl*SD_BAS_TAILLE_IPR;	    
	}
	/* mise a jour des ipr suppl.*/
	NewOffset = descripteurIPRGlobal[NbIprMin-1].Offset + taille_mdr;
	j = 1;
	for (i = NbIPRTotal ; i < nvxNbIpr; i++)
	{
	   descripteurIPRGlobal[i].Rec = descripteur_fichier->descripteurIPR[j].Rec;
	   descripteurIPRGlobal[i].Instrument = descripteur_fichier->descripteurIPR[j].Instrument;
	   descripteurIPRGlobal[i].subclass = descripteur_fichier->descripteurIPR[j].subclass;
	   descripteurIPRGlobal[i].Offset = NewOffset +
	                                    descripteur_fichier->descripteurIPR[j].Offset - 
					    descripteur_fichier->descripteurIPR[NbIprMin-1].Offset;
	   j ++;
	}

	/* on conserve la nouvelle structure mise a jour */
	/* memcpy ?*/
	for (i = 0 ; i < nvxNbIpr; i++)
	{
	   descripteur_fichier->descripteurIPR[i].Rec = descripteurIPRGlobal[i].Rec;
	   descripteur_fichier->descripteurIPR[i].Instrument = descripteurIPRGlobal[i].Instrument;
	   descripteur_fichier->descripteurIPR[i].subclass = descripteurIPRGlobal[i].subclass;
	   descripteur_fichier->descripteurIPR[i].Offset = descripteurIPRGlobal[i].Offset;
	}
	  
     }/* fin si il y a des DMDR */   
	/* on conserve le nouveaux nb d'ipr a ecrire */
        m_NbIPRVER = nvxNbIpr;
	  
   }/* fin si Fichier VER */

   /** Fichier ENG **/
   /*-------------------------------------------------------------------------*/
   if (descripteur_fichier->nature == NA_IASIL1ENG)
   {
    
     if (m_NbIPRENG == NbIprMin)
     {

cout << "CAS 1" << endl;
        /* Pas de changement, on recupere les IPR precedemment ecrits */
	for (i = 0 ; i < NbIPRTotal; i++)
	{
	   descripteur_fichier->descripteurIPR[i].Rec = descripteurIPRGlobal[i].Rec;
	   descripteur_fichier->descripteurIPR[i].Instrument = descripteurIPRGlobal[i].Instrument;
	   descripteur_fichier->descripteurIPR[i].subclass = descripteurIPRGlobal[i].subclass;
	   descripteur_fichier->descripteurIPR[i].Offset = descripteurIPRGlobal[i].Offset;	
	}
	
	/* maj du nb d'ipr */
	nvxNbIpr = NbIPRTotal;
     } /* fin CAS 1 */
     
     else if (NbIPRTotal == NbIprMin)
     {
cout << "CAS 2" << endl;
        /* on conserve les ipr qui viennent d'etre decrits = rien a faire si il n'y a pas de doublons*/
        /* maj du nb d'ipr */
        nvxNbIpr = m_NbIPRENG;
	NbIprSuppl = m_NbIPRENG - NbIprMin;
	
	if ( (CMN__FAUX == bPresenceViadrCourant) && (m_NbIPRENG >= (NbIprMin+1)) )
	{
cout << "CAS 2.1" << endl;
	   /* on decale de n ipr suppl */
	   for (i = 0; i < NbIprMin; i++ )
	   {
	      descripteurIPRGlobal[i].Offset = descripteurIPRGlobal[i].Offset + 
	                                            NbIprSuppl*SD_BAS_TAILLE_IPR;
	   }
	   
	   /* mise a jour des IPR */
	   NewOffset = descripteurIPRGlobal[NbIprMin-1].Offset + taille_mdr;
	   j = 2;
	   for (i = NbIprMin; i < nvxNbIpr; i++ )
	   {
	      descripteurIPRGlobal[i].Offset = NewOffset + 
	                                       descripteur_fichier->descripteurIPR[j].Offset -
					       descripteur_fichier->descripteurIPR[NbIprMin -1].Offset;
	      descripteurIPRGlobal[i].Rec = descripteur_fichier->descripteurIPR[j].Rec;
	      descripteurIPRGlobal[i].Instrument = descripteur_fichier->descripteurIPR[j].Instrument;
	      descripteurIPRGlobal[i].subclass = descripteur_fichier->descripteurIPR[j].subclass;
	      j++;
	   }
	   
	   /* on conserve la nouvelle structure mise a jour */
	   for (i = 0 ; i < nvxNbIpr; i++)
	   {
              descripteur_fichier->descripteurIPR[i].Rec = descripteurIPRGlobal[i].Rec;
              descripteur_fichier->descripteurIPR[i].Instrument = descripteurIPRGlobal[i].Instrument;
              descripteur_fichier->descripteurIPR[i].subclass = descripteurIPRGlobal[i].subclass;
              descripteur_fichier->descripteurIPR[i].Offset = descripteurIPRGlobal[i].Offset;
	   }
	}/* fin cas 2.1*/
	/* else correspond au cas ou on recupere les ipr tels quels */
	
     } /* fin CAS 2 */
     
     else /* il y a des VIADR et/ou transitions MDR/DMDR dans le granule courant 
             et dans le dump */
     {
cout << "CAS 3" << endl;
        /* CAS 3.1 */
	if (CMN__FAUX == bPresenceViadrCourant)
	{
cout << "CAS 3.1" << endl;
           /* maj du nb d'ipr et d'ipr supplementaires */
	   nvxNbIpr = NbIPRTotal + m_NbIPRENG - NbIprMin;
	   NbIprSuppl = m_NbIPRENG - NbIprMin;
	  
	   /* mise a jour des offsets incrementes de NbIprSuppl */
	   for (i = 0; i < NbIPRTotal; i++ )
	   {
	      descripteurIPRGlobal[i].Offset = descripteurIPRGlobal[i].Offset + 
	                                            NbIprSuppl*SD_BAS_TAILLE_IPR;
	   }

	   /* mise a jour des ipr supplementaires */
	   if (CMN__VRAI == bPresenceViadrGlobal)
	     NewOffset = descripteurIPRGlobal[NbIprMin].Offset + taille_mdr;
	   else
	     NewOffset = descripteurIPRGlobal[NbIprMin - 1].Offset + taille_mdr;
	   
	   j = 2;
	   for (i = NbIPRTotal; i < nvxNbIpr; i++ )
	   {
	      descripteurIPRGlobal[i].Offset = NewOffset + 
	                                       descripteur_fichier->descripteurIPR[j].Offset -
					       descripteur_fichier->descripteurIPR[NbIprMin -1].Offset;
	      descripteurIPRGlobal[i].Rec = descripteur_fichier->descripteurIPR[j].Rec;
	      descripteurIPRGlobal[i].Instrument = descripteur_fichier->descripteurIPR[j].Instrument;
	      descripteurIPRGlobal[i].subclass = descripteur_fichier->descripteurIPR[j].subclass;
	      j++;
	   }
	
	} /* fin si (CMN__FAUX == bPresenceViadrCourant)*/
	
	else /* if (CMN__VRAI == bPresenceViadrCourant) */
	{
cout << "CAS 3.2" << endl;
           if (CMN__VRAI == bPresenceViadrGlobal)
	   {
cout << "CAS 3.2.1" << endl;
             /* maj du nb d'ipr et d'ipr supplementaires */
	     nvxNbIpr = NbIPRTotal + m_NbIPRENG - (NbIprMin + 1);
	     NbIprSuppl = m_NbIPRENG - (NbIprMin + 1);
             
	     /* mise a jour des offsets incrementes de NbIprSuppl */
	     for (i = 0; i <NbIprMin ; i++ )
	     {
	         descripteurIPRGlobal[i].Offset = descripteurIPRGlobal[i].Offset + 
	                                            NbIprSuppl*SD_BAS_TAILLE_IPR;
	     }
	     
	     /* mise a jour des ipr precedents */
	     for (i = NbIprMin; i < NbIPRTotal; i++)
	     {
	        descripteurIPRGlobal[i].Offset = descripteurIPRGlobal[i].Offset +
	                                         descripteur_fichier->descripteurIPR[NbIprMin].Offset -
					         descripteur_fichier->descripteurIPR[NbIprMin -1].Offset +
						 NbIprSuppl*SD_BAS_TAILLE_IPR;
	     }
	     
	     /* mise a jour des ipr supplementaires */
	     NewOffset = descripteurIPRGlobal[NbIprMin].Offset + taille_mdr;
	     j = 3;
	     for (i = NbIPRTotal; i < nvxNbIpr; i++)
	     {
	        descripteurIPRGlobal[i].Offset = NewOffset + 
	                                         descripteur_fichier->descripteurIPR[j].Offset -
					         descripteur_fichier->descripteurIPR[NbIprMin].Offset;
	        descripteurIPRGlobal[i].Rec = descripteur_fichier->descripteurIPR[j].Rec;
	        descripteurIPRGlobal[i].Instrument = descripteur_fichier->descripteurIPR[j].Instrument;
	        descripteurIPRGlobal[i].subclass = descripteur_fichier->descripteurIPR[j].subclass;
	        j++;
	        
	     }
	      
	   } /* fin  if (CMN__VRAI == bPresenceViadrGlobal) */
	   
	   else /*if (CMN__FAUX == bPresenceViadrGlobal) */
	   {
cout << "CAS 3.2.2" << endl;
             /* maj du nb d'ipr et d'ipr supplementaires */
	     nvxNbIpr = NbIPRTotal + m_NbIPRENG - NbIprMin ;
	     NbIprSuppl = m_NbIPRENG - NbIprMin ;
	     
	     /* mise a jour des offsets incrementes de NbIprSuppl */
	     for (i = 0; i <(NbIprMin+1) ; i++ )
	     {
	         descripteurIPRGlobal[i].Offset = descripteurIPRGlobal[i].Offset + 
	                                            NbIprSuppl*SD_BAS_TAILLE_IPR;
	     }
	     
	     /* mise a jour des ipr precedents */
	     for (i = NbIPRTotal-1; i > 0; i--)
	     {
	        descripteurIPRGlobal[i+1].Offset = descripteurIPRGlobal[i].Offset +
						   descripteur_fichier->descripteurIPR[NbIprMin].Offset - 
						   descripteur_fichier->descripteurIPR[NbIprMin-1].Offset;
	        descripteurIPRGlobal[i+1].Rec = descripteurIPRGlobal[i].Rec;
	        descripteurIPRGlobal[i+1].Instrument = descripteurIPRGlobal[i].Instrument;
	        descripteurIPRGlobal[i+1].subclass = descripteurIPRGlobal[i].subclass;     
	     }
	     
	     /* mise a jour des caracteristiques de l'ipr qui pointe le 
	       1er VIADR */
	     descripteurIPRGlobal[NbIprMin-1].Rec = descripteur_fichier->descripteurIPR[NbIprMin-1].Rec;
	     descripteurIPRGlobal[NbIprMin-1].Instrument = descripteur_fichier->descripteurIPR[NbIprMin-1].Instrument;
	     descripteurIPRGlobal[NbIprMin-1].subclass = descripteur_fichier->descripteurIPR[NbIprMin-1].subclass;
	     
	     /* mise a jour des ipr supplementaires */
	     NewOffset = descripteurIPRGlobal[NbIprMin].Offset + taille_mdr;
	     j = 3;
	     for (i = NbIPRTotal+1; i < nvxNbIpr; i++)
	     {
	        descripteurIPRGlobal[i].Offset = NewOffset + 
	                                         descripteur_fichier->descripteurIPR[j].Offset -
					         descripteur_fichier->descripteurIPR[NbIprMin].Offset;
	        descripteurIPRGlobal[i].Rec = descripteur_fichier->descripteurIPR[j].Rec;
	        descripteurIPRGlobal[i].Instrument = descripteur_fichier->descripteurIPR[j].Instrument;
	        descripteurIPRGlobal[i].subclass = descripteur_fichier->descripteurIPR[j].subclass;
	        j++;	     
	     }/* fin for */
	   
	   }/* fin else if (CMN__FAUX == bPresenceViadrGlobal)*/
	
	} /* fin else - (CMN__VRAI == bPresenceViadrCourant) */
     
       /* on conserve la nouvelle structure mise a jour */
       for (i = 0 ; i < nvxNbIpr; i++)
       {
          descripteur_fichier->descripteurIPR[i].Rec = descripteurIPRGlobal[i].Rec;
          descripteur_fichier->descripteurIPR[i].Instrument = descripteurIPRGlobal[i].Instrument;
          descripteur_fichier->descripteurIPR[i].subclass = descripteurIPRGlobal[i].subclass;
          descripteur_fichier->descripteurIPR[i].Offset = descripteurIPRGlobal[i].Offset;
       }
	  
     } /* fin CAS 3 */
        
     /* on conserve le nouveaux nb d'ipr a ecrire */
     m_NbIPRENG = nvxNbIpr;

   } /* fin si fichier ENG*/

  /* mise a jour du nombre d'ipr dans l'entete MPHR */
  *(m_MPHR.listevar.tab_var[MPHR_TOTAL_IPR].val.pui4) = nvxNbIpr;
   
#ifdef OPS_DEBUG
  cout << "### IPR Recalcules ###" << endl;
  cout << " descripteur_fichier->nature = " 
       << descripteur_fichier->nature << endl
       << " NbIPR = " << nvxNbIpr << endl;
  for (i = 0 ; i < nvxNbIpr ; i++)
  {
    cout << " descripteurIPR[" << i << "].Rec = " 
         << descripteur_fichier->descripteurIPR[i].Rec << endl
	 << " descripteurIPR[" << i << "].Instrument = " 
	 << descripteur_fichier->descripteurIPR[i].Instrument << endl
	 << " descripteurIPR[" << i << "].subclass = " 
	 << descripteur_fichier->descripteurIPR[i].subclass << endl
	 << " descripteurIPR[" << i << "].Offset = " 
	 << descripteur_fichier->descripteurIPR[i].Offset << endl
	 << "" << endl;
  }
#endif


}/* fin de SD_DON_GranuleN1::DecrireIPRDump */
